
/*
 * FILE:  dis204_entities.h 
 *
 * Created on Thu May  2 20:02:24 1996 
 * Compiled by DRN compiler, version 6.2.d
 * 
 */

#ifndef _dis204_entities_included
#define _dis204_entities_included

 /* File:     dis204_entities.drn */
 /* Contents: enumerations and values for DIS 2.0.3 */
 /* System:   BDS-D BIP development. */
 /* Created:  11-Oct-93 */
 /* Author:   cchiang/ckuczaj */
 /*           Picot Chappell  */

 /* Remarks: */
 /* 	These are the enumerations defined in "Enumeration and Bit Encoded */
 /*      Values for Use with Protocols for Distributed Interactive Simulation */
 /* 	Applications" dated November 25, 1997 for use with version 2 protocols */

 /*     This document was modified for DIS 2.0.4 standards on 4/3/98 by
        E-OIR Measurements, Inc.  */

 /* History: */
 /*     */
 /* $RCSfile: dis204_entities.h,v $ */
 /* $Revision: 1.1.1.1 $ */
 /* $State: Exp $ */
 /*     */
 /* COPYRIGHT 1993 Loral Advanced Distributed Simulation */
 /* 50 Moulton Street */
 /* Cambridge, Ma. 02138 */
 /* 617-873-3600 */

 /* Section 6 Specifics -- 4.2.3.1.1  page 24 */
#define DIS204_ENTITY_CATEGORY_OTHER                          0 /* Land Domain -- */
#define DIS204_ENTITY_CATEGORY_TANK                           1 /* U.S.A. -- */
#define DIS204_ENTITY_SUBCATEGORY_M1_ABRAMS                   1
#define DIS204_ENTITY_SPECIFIC_M1A1                           2
#define DIS204_ENTITY_SPECIFIC_M1A2                           3
#define DIS204_ENTITY_SPECIFIC_M1A1_WITH_MINE_ROLLERS         4
#define DIS204_ENTITY_SPECIFIC_M1A1_WITH_MINE_PLOWS           5
#define DIS204_ENTITY_SUBCATEGORY_M60_MBT                     2  /* Main Battle Tank  */
#define DIS204_ENTITY_SPECIFIC_M60A3_MBT                      1
#define DIS204_ENTITY_SUBCATEGORY_M551_SHERIDAN_LIGHT_TANK    3
#define DIS204_ENTITY_SUBCATEGORY_M48_MEDIUM_TANK             4
#define DIS204_ENTITY_SUBCATEGORY_VIRTUAL_PROTOTYPE_TANK      11 /* guessing?!? */  
     /* U.S.S.R. -- now this is C.I.S  4.2.3.1.2  page 71 */
#define DIS204_ENTITY_SUBCATEGORY_T80_MBT           1
#define DIS204_ENTITY_SUBCATEGORY_T72_MBT           2
#define DIS204_ENTITY_SPECIFIC_T72                  1
#define DIS204_ENTITY_SPECIFIC_T72M                 2
#define DIS204_ENTITY_SUBCATEGORY_T64_MBT           3
#define DIS204_ENTITY_SUBCATEGORY_T62_MBT           4
#define DIS204_ENTITY_SUBCATEGORY_T54_MBT           5
#define DIS204_ENTITY_SUBCATEGORY_T55_MBT           6
/* #define DIS204_ENTITY_SUBCATEGORY_T10            7  this doesn't seem exist anymore */
#define DIS204_ENTITY_SUBCATEGORY_PT76              8 
     /* U.K. -- 4.2.3.1.3  page 125 */
#define DIS204_ENTITY_SUBCATEGORY_CHIEFTAIN_MBT           1
/* #define DIS204_ENTITY_SUBCATEGORY_CENTURION_MBT        2  doesn't exist anymore */
#define DIS204_ENTITY_SUBCATEGORY_CHALLENGER_MBT          2
/* #define DIS204_ENTITY_SUBCATEGORY_MK7_MBT              4  doesn't exist anymore */
/* #define DIS204_ENTITY_SUBCATEGORY_FV100                5  doesn't exist anymore */
     /* France -- 4.2.3.1.4  page 144 */
#define DIS204_ENTITY_SUBCATEGORY_AMX30                   1
#define DIS204_ENTITY_SPECIFIC_AMX30B2                    1
#define DIS204_ENTITY_SUBCATEGORY_AMX13_LIGHT_TANK        2 
     /* Germany -- 4.2.3.1.5  page 160 */
#define DIS204_ENTITY_SUBCATEGORY_LEOPARD_1_MBT                   1
#define DIS204_ENTITY_SPECIFIC_LEOPARD_1_MBT_A5                   5
#define DIS204_ENTITY_SUBCATEGORY_LEOPARD_2_MBT                   2
#define DIS204_ENTITY_SUBCATEGORY_LEOPARD_2_IMPROVED_MBT          3
     /*  Armored Fighting Vehicles  */
#define DIS204_ENTITY_CATEGORY_ARMORED_FIGHTING_VEHICLE           2 
     /* U.S.A. -- */
#define DIS204_ENTITY_SUBCATEGORY_IFV           1
#define DIS204_ENTITY_SUBCATEGORY_CFV           2
#define DIS204_ENTITY_SUBCATEGORY_M2_BRADLEY           1
#define DIS204_ENTITY_SPECIFIC_LOSAT           1
#define DIS204_ENTITY_SUBCATEGORY_M3_BRADLEY           1
#define DIS204_ENTITY_SUBCATEGORY_M113           5
#define DIS204_ENTITY_SPECIFIC_M113A2           1
#define DIS204_ENTITY_SPECIFIC_M113A3           2
#define DIS204_ENTITY_SPECIFIC_M113A3_WITH_M105_TRAILER           3
#define DIS204_ENTITY_SPECIFIC_M981_FIST_V           4
#define DIS204_ENTITY_SPECIFIC_M106A1           5
#define DIS204_ENTITY_SUBCATEGORY_LAV_25           6
#define DIS204_ENTITY_SUBCATEGORY_LAV_TOW           7
#define DIS204_ENTITY_SUBCATEGORY_M901A1_ITV           8
#define DIS204_ENTITY_SUBCATEGORY_M106A1_MORTAR_CARRIER           9
#define DIS204_ENTITY_SUBCATEGORY_V_600_ARMORED_CAR           10 
     /* U.S.S.R. -- 4.2.3.1.2  page 73*/
#define DIS204_ENTITY_SUBCATEGORY_BMP1               1
#define DIS204_ENTITY_SPECIFIC_BMP1K                 3
#define DIS204_ENTITY_SUBCATEGORY_BMP2               2
/* #define DIS204_ENTITY_SUBCATEGORY_BRDM1              3  now this is 15 */
#define DIS204_ENTITY_SUBCATEGORY_BMP3               3
#define DIS204_ENTITY_SUBCATEGORY_BRDM2              4
/* #define DIS204_ENTITY_SPECIFIC_ATGM_WITH_AT4         1  doesn't exist */
#define DIS204_ENTITY_SPECIFIC_ATGM_WITH_AT5         3
#define DIS204_ENTITY_SUBCATEGORY_BTR40              5
#define DIS204_ENTITY_SUBCATEGORY_BTR152             6
#define DIS204_ENTITY_SUBCATEGORY_MT_LB              7
/* #define DIS204_ENTIRY_SPECIFIC_MT_LBU_TRACKED_VEH    17  doesn't exist */
#define DIS204_ENTITY_SUBCATEGORY_BTR60              8
#define DIS204_ENTITY_SUBCATEGORY_BTR50              9
/* #define DIS204_ENTITY_SUBCATEGORY_ACRV2              10  doesn't exist */
#define DIS204_ENTITY_SUBCATEGORY_BMD                11
#define DIS204_ENTITY_SUBCATEGORY_BMD2               3
#define DIS204_ENTITY_SUBCATEGORY_BTR70              12
#define DIS204_ENTITY_SUBCATEGORY_BTR80              13
/* #define DIS204_ENTITY_SUBCATEGORY_BMP3               14  now this is 3 */
#define DIS204_ENTITY_SUBCATEGORY_BRDM1              15
/* #define DIS204_ENTITY_SUBCATEGORY_BMD2               15 this is changed to specific */
     /* U.K. -- 4.2.3.1.3 page 125*/
#define DIS204_ENTITY_SUBCATEGORY_FV432           1
#define DIS204_ENTITY_SUBCATEGORY_FV103           2
#define DIS204_ENTITY_SUBCATEGORY_FV601           3
#define DIS204_ENTITY_SUBCATEGORY_FV107           4
/* #define DIS204_ENTITY_SUBCATEGORY_FV105           5  doesn't exist */
#define DIS204_ENTITY_SUBCATEGORY_FV603           6
/* #define DIS204_ENTITY_SUBCATEGORY_MCV80           7  changed to AT105 Saxon */
     /* France -- 4.2.3.1.4  page 144 */
#define DIS204_ENTITY_SUBCATEGORY_VBC90                      1
#define DIS204_ENTITY_SUBCATEGORY_ERC90                      2
#define DIS204_ENTITY_SUBCATEGORY_AML90                      3
#define DIS204_ENTITY_SUBCATEGORY_AML60                      4
#define DIS204_ENTITY_SUBCATEGORY_VAB_APC                    5
#define DIS204_ENTITY_SUBCATEGORY_AMX10RC                    6
#define DIS204_ENTITY_SUBCATEGORY_AMX13_IFV                  7
#define DIS204_ENTITY_SUBCATEGORY_AMX10_IFV                  8
#define DIS204_ENTITY_SUBCATEGORY_EBR_ARMORED_CAR            9
#define DIS204_ENTITY_SUBCATEGORY_AMX13_VCI_APC              10
#define DIS204_ENTITY_SUBCATEGORY_AMX13_DCA                  11
#define DIS204_ENTITY_SUBCATEGORY_BERLIET_VXB_ARMORED_CAR    12
#define DIS204_ENTITY_SUBCATEGORY_PANHARD_EBR                13 
     /* Germany -- 4.2.3.1.5  page 160 */
#define DIS204_ENTITY_SUBCATEGORY_MARDER_1_A3                1
#define DIS204_ENTITY_SUBCATEGORY_MARDER_2                   2
#define DIS204_ENTITY_SUBCATEGORY_BMP_1                      3
#define DIS204_ENTITY_SUBCATEGORY_JAGUAR_1_TANK_DESTROYER    4
#define DIS204_ENTITY_SUBCATEGORY_JAGUAR_2                   5
#define DIS204_ENTITY_SUBCATEGORY_LUCHS_ARV                  6
#define DIS204_ENTITY_SUBCATEGORY_ZOBEL_ARV                  7
#define DIS204_ENTITY_SUBCATEGORY_ROLAND_ADS                 8
#define DIS204_ENTITY_SUBCATEGORY_GEPARD_AAD                 9
     /* Armored Utility Vehicle */ 
#define DIS204_ENTITY_CATEGORY_ARMORED_UTILITY_VEHICLE       3 
     /* U.S.A. -- 4.2.3.1.1  page 28 */
#define DIS204_ENTITY_SUBCATEGORY_M88                   1
#define DIS204_ENTITY_SPECIFIC_M88A1                    1
#define DIS204_ENTITY_SPECIFIC_M88A2                    2
#define DIS204_ENTITY_SUBCATEGORY_M578                  2
/* #define DIS204_ENTITY_SUBCATEGORY_M901_FIST_V           3  doesn't exist */
#define DIS204_ENTITY_SUBCATEGORY_AVLB                  4
#define DIS204_ENTITY_SUBCATEGORY_M728_CEV              5
#define DIS204_ENTITY_SUBCATEGORY_M9_ACE                6
/* #define DIS204_ENTITY_SUBCATEGORY_V_500_COMMANDO        7 changed to 150 */ 
#define DIS204_ENTITY_SUBCATEGORY_V_150_COMMANDO        7 
     /* U.S.S.R. -- 4.2.3.1.2  page 75 */
#define DIS204_ENTITY_SUBCATEGORY_BTS2          1
#define DIS204_ENTITY_SUBCATEGORY_MTP           2
/* #define DIS204_ENTITY_SUBCATEGORY_IMR2          3 changed */
#define DIS204_ENTITY_SUBCATEGORY_IMR           3
/* #define DIS204_ENTITY_SUBCATEGORY_IPR           4 changed */
#define DIS204_ENTITY_SUBCATEGORY_IRM           4
     /* U.K. -- 4.2.3.1.3  page 125 */
/* #define DIS204_ENTITY_SUBCATEGORY_AT60           1   doesn't exist */
#define DIS204_ENTITY_SUBCATEGORY_FV4204        1
     /* France -- 4.2.3.1.4  page 144 */
#define DIS204_ENTITY_SUBCATEGORY_AMX10_ECH_RECOV_VEH    1 
     /* Germany -- 4.2.3.1.5  page 160 */
#define DIS204_ENTITY_SUBCATEGORY_BIBER_ABL                1
#define DIS204_ENTITY_SUBCATEGORY_DACHS_AET                2
#define DIS204_ENTITY_SUBCATEGORY_KEILER_AMS               3
#define DIS204_ENTITY_SUBCATEGORY_SKORPION_AML             4
#define DIS204_ENTITY_SUBCATEGORY_M113_AAO                 7
#define DIS204_ENTITY_SUBCATEGORY_M113_AMA                 6
     /* Self Propelled Artillery */ 
#define DIS204_ENTITY_CATEGORY_SELF_PROPELLED_ARTILLERY    4
     /* U.S.A. -- 4.2.3.1.1  page 29 */
#define DIS204_ENTITY_SUBCATEGORY_MLRS                  1
#define DIS204_ENTITY_SUBCATEGORY_M110_8_INCH           2
#define DIS204_ENTITY_SUBCATEGORY_M109_155MM_USA        3
#define DIS204_ENTITY_SUBCATEGORY_GLCM_LAUNCHER         4
/* #define DIS204_ENTITY_SUBCATEGORY_PERSHING_LAUNCHER           5 doesn't exist */ 
     /* U.S.S.R. -- 4.2.3.1.2  page 76 */
#define DIS204_ENTITY_SUBCATEGORY_M1973              1
#define DIS204_ENTITY_SUBCATEGORY_M1974              2   
/* #define DIS204_ENTITY_SUBCATEGORY_M1981              3 doesn't exist */ 
/* #define DIS204_ENTITY_SUBCATEGORY_2S7                4 doesn't exist */ 
/* #define DIS204_ENTITY_SUBCATEGORY_ASU85              5 doesn't exist */ 
#define DIS204_ENTITY_SUBCATEGORY_FROG3              6
#define DIS204_ENTITY_SUBCATEGORY_FROG4              7
#define DIS204_ENTITY_SUBCATEGORY_FROG5              8
#define DIS204_ENTITY_SUBCATEGORY_FROG7              9
#define DIS204_ENTITY_SUBCATEGORY_SS1                10
/* #define DIS204_ENTITY_SUBCATEGORY_SS12               11 doesn't exist */ 
#define DIS204_ENTITY_SUBCATEGORY_BM14               12
#define DIS204_ENTITY_SUBCATEGORY_BM21               13
#define DIS204_ENTITY_SUBCATEGORY_M1975              14
#define DIS204_ENTITY_SUBCATEGORY_BM24               15
#define DIS204_ENTITY_SUBCATEGORY_BM25               16
/* #define DIS204_ENTITY_SUBCATEGORY_BM27               17 doesn't exist */ 
#define DIS204_ENTITY_SUBCATEGORY_ZSU234             18
#define DIS204_ENTITY_SUBCATEGORY_SA6                19
#define DIS204_ENTITY_SUBCATEGORY_SA9                20
#define DIS204_ENTITY_SUBCATEGORY_SA13               21
#define DIS204_ENTITY_SUBCATEGORY_2S6                22
/* #define DIS204_ENTITY_SUBCATEGORY_ZSU30              23 doesn't exist */
#define DIS204_ENTITY_SUBCATEGORY_SA8                41
#define DIS204_ENTITY_SPECIFIC_SA8_LAUNCHER_RADER    1  /* this could be just SA8 */
     /* U.K. -- 4.2.3.1.3  page 126 */
#define DIS204_ENTITY_SUBCATEGORY_ABBOT_105MM          1
/* #define DIS204_ENTITY_SUBCATEGORY_M109_155MM_UK        2  doesn't exist */  
/* #define DIS204_ENTITY_SUBCATEGORY_M107_175MM           3  doesn't exist */  
/* #define DIS204_ENTITY_SUBCATEGORY_M110_204MM           4  doesn't exist */  
/* #define DIS204_ENTITY_SUBCATEGORY_AT105_SAXON          5  doesn't exist */  
/* #define DIS204_ENTITY_SUBCATEGORY_SSM_LANCE_LAUNCHER   6  doesn't exist */  
     /* France -- 4.2.3.1.4  page 144 */
#define DIS204_ENTITY_SUBCATEGORY_A_UF1_155MM         1
#define DIS204_ENTITY_SUBCATEGORY_AMX_105MM           2
#define DIS204_ENTITY_SUBCATEGORY_AU50_105MM          3
#define DIS204_ENTITY_SUBCATEGORY_F3_155MM            4
     /* Towed Artillery */
#define DIS204_ENTITY_CATEGORY_TOWED_ARTILLERY        5 
     /* U.S.A. -- 4.2.3.1.1  page 30*/
#define DIS204_ENTITY_SUBCATEGORY_M114_155MM_HOWITZER           1
#define DIS204_ENTITY_SUBCATEGORY_M198_155MM_TOWED_HOWITZER     2
#define DIS204_ENTITY_SUBCATEGORY_M101_105MM_HOWITZER           3
#define DIS204_ENTITY_SUBCATEGORY_M119_105MM_LIGHT_HOWITZER     4
#define DIS204_ENTITY_SUBCATEGORY_PATRIOT_SYSTEM                13
#define DIS204_ENTITY_SUBCATEGORY_THADD_SYSTEM                  16 
#define DIS204_ENTITY_SPECIFIC_THADD_LAUNCHER                   3
     /* U.S.S.R. -- 4.2.3.1.2  page 78 */
#define DIS204_ENTITY_SUBCATEGORY_S23                      1
#define DIS204_ENTITY_SUBCATEGORY_M1976                    2
#define DIS204_ENTITY_SUBCATEGORY_D20                      3
#define DIS204_ENTITY_SUBCATEGORY_D30_122MM                4
#define DIS204_ENTITY_SUBCATEGORY_M46                      5
#define DIS204_ENTITY_SUBCATEGORY_D30_FIELD_HOWITZER       6
/* #define DIS204_ENTITY_SUBCATEGORY_M1955                    7  doesn't exist */
#define DIS204_ENTITY_SUBCATEGORY_SD44                     8
#define DIS204_ENTITY_SUBCATEGORY_M1966                    9
/* #define DIS204_ENTITY_SUBCATEGORY_M1965                    10  doesn't exist */ 
     /* U.K. -- 4.2.3.1.3  page 126 */
#define DIS204_ENTITY_SUBCATEGORY_FH70_155MM_GUN           1 
     /* France -- 4.2.3.1.4  page 145 */
#define DIS204_ENTITY_SUBCATEGORY_TR_155MM_HOWITZER        1
     /* Small wheeled Utility Vehicle */
#define DIS204_ENTITY_CATEGORY_SMALL_WHEELED_UTILITY_VEHICLE           6
     /* U.S.A. -- 4.2.3.1.1  page 31 */
#define DIS204_ENTITY_SUBCATEGORY_HMMWV                  1
#define DIS204_ENTITY_SUBCATEGORY_M577                   2
#define DIS204_ENTITY_SPECIFIC_M577A1           1
#define DIS204_ENTITY_SPECIFIC_M577A2           2
#define DIS204_ENTITY_SUBCATEGORY_FAST_ATTACK_VEHICLE           3
#define DIS204_ENTITY_SUBCATEGORY_M58A3_MCLIC           4
#define DIS204_ENTITY_SUBCATEGORY_CIVILIAN_CAR           6 /* U.S.S.R. -- */
#define DIS204_ENTITY_SUBCATEGORY_GAZ69           1
#define DIS204_ENTITY_SUBCATEGORY_UAZ469           2
#define DIS204_ENTITY_SUBCATEGORY_MAV           3
#define DIS204_ENTITY_SUBCATEGORY_SA2_FAN_SONG_TRAILER           8
#define DIS204_ENTITY_SUBCATEGORY_SA3_LOW_BLOW_TRAILER           9 /* U.K. -- */
#define DIS204_ENTITY_SUBCATEGORY_LWB_LAND_ROVER           1
#define DIS204_ENTITY_SUBCATEGORY_LAND_ROVER_6X6_TRUCK           2
#define DIS204_ENTITY_CATEGORY_LARGE_WHEELED_UTILITY_VEHICLE           7
     /* U.S.A. -- */
#define DIS204_ENTITY_SUBCATEGORY_GENERIC_TRUCK           0
#define DIS204_ENTITY_SUBCATEGORY_M352_2_5_TON           1
#define DIS204_ENTITY_SPECIFIC_M352           1
#define DIS204_ENTITY_SPECIFIC_M352A2           2
#define DIS204_ENTITY_SUBCATEGORY_M977_HEMTT           2
#define DIS204_ENTITY_SUBCATEGORY_M978_HEMTT           3
#define DIS204_ENTITY_SUBCATEGORY_M817           4
#define DIS204_ENTITY_SUBCATEGORY_M939           5
#define DIS204_ENTITY_SUBCATEGORY_M17_HOSTED_VULCANO           6
#define DIS204_ENTITY_SUBCATEGORY_M985_HEMTT           7
#define DIS204_ENTITY_SUBCATEGORY_M915           8
#define DIS204_ENTITY_SPECIFIC_M915_CARGO           1
#define DIS204_ENTITY_SPECIFIC_M915_WITH_PS_PODS           2
#define DIS204_ENTITY_SPECIFIC_M915_WITH_SHELTER           3
#define DIS204_ENTITY_SUBCATEGORY_M1038           9
#define DIS204_ENTITY_SUBCATEGORY_M1039           10
#define DIS204_ENTITY_SUBCATEGORY_M35           11
#define DIS204_ENTITY_SUBCATEGORY_PATRIOT_RADAR_TRAILER           12
#define DIS204_ENTITY_SUBCATEGORY_BUS           14 /* U.S.S.R. -- */
#define DIS204_ENTITY_SUBCATEGORY_PZM2           1
#define DIS204_ENTITY_SUBCATEGORY_BAV           2
#define DIS204_ENTITY_SUBCATEGORY_KRAZ255B           3
#define DIS204_ENTITY_SUBCATEGORY_ZIL131           4
#define DIS204_ENTITY_SUBCATEGORY_ZIL151           5
#define DIS204_ENTITY_SUBCATEGORY_ZIL157           6
#define DIS204_ENTITY_SUBCATEGORY_GAZ63           7
#define DIS204_ENTITY_SUBCATEGORY_GAZ66           8
#define DIS204_ENTITY_SUBCATEGORY_URAL375           9
#define DIS204_ENTITY_SUBCATEGORY_KAMAZ4310           10
#define DIS204_ENTITY_SUBCATEGORY_URAL4320           11
#define DIS204_ENTITY_SUBCATEGORY_UAZ3151           12
#define DIS204_ENTITY_SUBCATEGORY_SA10           38
#define DIS204_ENTITY_SPECIFIC_SA10_FLAP_LID_RADAR           1 /* Common -- */
#define DIS204_ENTITY_CATEGORY_SMALL_TRACKED_UTILITY_VEHICLE           8
     /* U.S.S.R. -- */
#define DIS204_ENTITY_SUBCATEGORY_SA6_STRIGHT_FLUSH_RADAR           10
#define DIS204_ENTITY_CATEGORY_LARGE_TRACKED_UTILITY_VEHICLE           9
     /* U.S.A. -- */
#define DIS204_ENTITY_SUBCATEGORY_M548           1 /* U.S.S.R. -- */
#define DIS204_ENTITY_SUBCATEGORY_PTS           1
#define DIS204_ENTITY_SUBCATEGORY_ATT           5
#define DIS204_ENTITY_CATEGORY_MORTAR           10 /* U.S.A. -- */
#define DIS204_ENTITY_SUBCATEGORY_M29_81MM_MORTAR           1
#define DIS204_ENTITY_SUBCATEGORY_M224_60MM_MORTAR           2 /* U.S.S.R. -- */
#define DIS204_ENTITY_SUBCATEGORY_M1937           1
#define DIS204_ENTITY_SUBCATEGORY_M1943           2
#define DIS204_ENTITY_SUBCATEGORY_M1953           3
#define DIS204_ENTITY_SUBCATEGORY_M1952           4
#define DIS204_ENTITY_SUBCATEGORY_AM2B9           5
#define DIS204_ENTITY_SUBCATEGORY_2S4SP           6
#define DIS204_ENTITY_CATEGORY_AMPHIBIOUS_ASSAULT_VEHICLE           50
#define DIS204_ENTITY_SUBCATEGORY_LVTP_7           1
#define DIS204_ENTITY_CATEGORY_MISCELLANEOUS_WEAPON_SYSTEM           51
#define DIS204_ENTITY_SUBCATEGORY_M901_40MM_MACHINE_GUN           1
#define DIS204_ENTITY_SUBCATEGORY_MK_19_40MM_GRENADE_LAUNCHER           2
#define DIS204_ENTITY_SUBCATEGORY_20MM_VULCAN           3 /* Germany -- */
#define DIS204_ENTITY_SUBCATEGORY_M113_ARMORED_MORTAR           1
     /* Air Domain -- */
#define DIS204_ENTITY_CATEGORY_FIGHTER           1 /* U.S.A. -- */
#define DIS204_ENTITY_SUBCATEGORY_F117_STEALTH           1
#define DIS204_ENTITY_SPECIFIC_F117A           1
#define DIS204_ENTITY_SUBCATEGORY_F14           2
#define DIS204_ENTITY_SPECIFIC_F14A           1
#define DIS204_ENTITY_SPECIFIC_F14B           2
#define DIS204_ENTITY_SPECIFIC_F14C           3
#define DIS204_ENTITY_SPECIFIC_F14DF           4
#define DIS204_ENTITY_SUBCATEGORY_F16           3
#define DIS204_ENTITY_SPECIFIC_F16A           1
#define DIS204_ENTITY_SPECIFIC_F16B           2
#define DIS204_ENTITY_SPECIFIC_F16C           3
#define DIS204_ENTITY_SPECIFIC_F16D           4
#define DIS204_ENTITY_SPECIFIC_F16E           5
#define DIS204_ENTITY_SUBCATEGORY_FB111           4
#define DIS204_ENTITY_SUBCATEGORY_F4           5
#define DIS204_ENTITY_SUBCATEGORY_F8           6
#define DIS204_ENTITY_SUBCATEGORY_F15           7
#define DIS204_ENTITY_SUBCATEGORY_F22           8
#define DIS204_ENTITY_SUBCATEGORY_F100           9
#define DIS204_ENTITY_SUBCATEGORY_F104           10
#define DIS204_ENTITY_SUBCATEGORY_F102           11
#define DIS204_ENTITY_SUBCATEGORY_F106           12
#define DIS204_ENTITY_SUBCATEGORY_F105           13
#define DIS204_ENTITY_SUBCATEGORY_F111           14
#define DIS204_ENTITY_SUBCATEGORY_FA18           15
#define DIS204_ENTITY_SUBCATEGORY_EF111           16
#define DIS204_ENTITY_SUBCATEGORY_F5           17 /* U.S.S.R. -- */
#define DIS204_ENTITY_SUBCATEGORY_MIG31           1
#define DIS204_ENTITY_SUBCATEGORY_MIG29           2
#define DIS204_ENTITY_SUBCATEGORY_SU27           3
#define DIS204_ENTITY_SUBCATEGORY_MIG25           4
#define DIS204_ENTITY_SUBCATEGORY_MIG23           5
#define DIS204_ENTITY_SUBCATEGORY_MIG21           6
#define DIS204_ENTITY_SUBCATEGORY_MIG19           7
#define DIS204_ENTITY_SUBCATEGORY_MIG17           8
#define DIS204_ENTITY_SUBCATEGORY_SU9           9
#define DIS204_ENTITY_SUBCATEGORY_SU15           10
#define DIS204_ENTITY_SUBCATEGORY_TU128           11
#define DIS204_ENTITY_SUBCATEGORY_YAK25           12
#define DIS204_ENTITY_SUBCATEGORY_YAK28           13
#define DIS204_ENTITY_SUBCATEGORY_MIG27_FIGHTER           14 /* U.K. -- */
#define DIS204_ENTITY_SUBCATEGORY_TORNADO_ADV           1
#define DIS204_ENTITY_SUBCATEGORY_LIGHTNING           2
#define DIS204_ENTITY_SUBCATEGORY_PHANTOM           3 /* France -- */
#define DIS204_ENTITY_SUBCATEGORY_MIRAGE_F1           1
#define DIS204_ENTITY_SUBCATEGORY_MIRAGE_II           2
#define DIS204_ENTITY_SUBCATEGORY_MIRAGE_III           3
#define DIS204_ENTITY_SUBCATEGORY_MIRAGE_IV           4
#define DIS204_ENTITY_SUBCATEGORY_MIRAGE_V           5
#define DIS204_ENTITY_SUBCATEGORY_MIRAGE_2000           6
#define DIS204_ENTITY_SUBCATEGORY_GARDIAN           7
#define DIS204_ENTITY_SUBCATEGORY_MIRAGE_5000           8 /* Germany -- */
#define DIS204_ENTITY_SUBCATEGORY_MRCA_TORNADO           1
#define DIS204_ENTITY_CATEGORY_ATTACK           2 /* U.S.A. -- */
#define DIS204_ENTITY_SUBCATEGORY_A4           1
#define DIS204_ENTITY_SUBCATEGORY_A6           2
#define DIS204_ENTITY_SUBCATEGORY_A7           3
#define DIS204_ENTITY_SUBCATEGORY_A10           4
#define DIS204_ENTITY_SUBCATEGORY_A37           5
#define DIS204_ENTITY_SUBCATEGORY_EA6           6
#define DIS204_ENTITY_SPECIFIC_EA6A           1
#define DIS204_ENTITY_SPECIFIC_EA6B           2
#define DIS204_ENTITY_SUBCATEGORY_KA6           7
#define DIS204_ENTITY_SUBCATEGORY_AV8           8
#define DIS204_ENTITY_SPECIFIC_AV8A           1
#define DIS204_ENTITY_SPECIFIC_AV8B           2
#define DIS204_ENTITY_SUBCATEGORY_A3           9 /* U.S.S.R. -- */
#define DIS204_ENTITY_SUBCATEGORY_MIG27_ATTACK           1
#define DIS204_ENTITY_SUBCATEGORY_SU7           2
#define DIS204_ENTITY_SUBCATEGORY_SU11           3
#define DIS204_ENTITY_SUBCATEGORY_SU17           4
#define DIS204_ENTITY_SUBCATEGORY_SU20           5
#define DIS204_ENTITY_SUBCATEGORY_SU22           6
#define DIS204_ENTITY_SUBCATEGORY_SU24           7
#define DIS204_ENTITY_SUBCATEGORY_SU25           8
#define DIS204_ENTITY_SUBCATEGORY_YAK27R           9
#define DIS204_ENTITY_SUBCATEGORY_YAK36           10
#define DIS204_ENTITY_SUBCATEGORY_YAK38           11 /* U.K. -- */
#define DIS204_ENTITY_SUBCATEGORY_SEA_HARRIER           1
#define DIS204_ENTITY_SUBCATEGORY_HARRIER           2
#define DIS204_ENTITY_SUBCATEGORY_BUCCANEER           3
#define DIS204_ENTITY_SUBCATEGORY_TORNADO_GR1           4
#define DIS204_ENTITY_SUBCATEGORY_JAGUAR_UK           5
#define DIS204_ENTITY_SUBCATEGORY_HAWK           6 /* France -- */
#define DIS204_ENTITY_SUBCATEGORY_JAGUAR_FRANCE           1
#define DIS204_ENTITY_SUBCATEGORY_ETENDARD_IVP           2
#define DIS204_ENTITY_SUBCATEGORY_SUPER_ETENDARD           3
#define DIS204_ENTITY_SUBCATEGORY_ALPHA_JET_2           4
#define DIS204_ENTITY_CATEGORY_BOMBER           3 /* U.S.A. -- */
#define DIS204_ENTITY_SUBCATEGORY_B1           1
#define DIS204_ENTITY_SPECIFIC_B1A           1
#define DIS204_ENTITY_SPECIFIC_B1B           2
#define DIS204_ENTITY_SUBCATEGORY_B2           2
#define DIS204_ENTITY_SPECIFIC_B2A           1
#define DIS204_ENTITY_SUBCATEGORY_B52           3 /* U.S.S.R. -- */
#define DIS204_ENTITY_SUBCATEGORY_TU160           1
#define DIS204_ENTITY_SUBCATEGORY_TU16           2
#define DIS204_ENTITY_SUBCATEGORY_TU26           3
#define DIS204_ENTITY_SUBCATEGORY_TU22           4
#define DIS204_ENTITY_SUBCATEGORY_TU95           5
#define DIS204_ENTITY_SUBCATEGORY_M4           6
#define DIS204_ENTITY_CATEGORY_CARGO           4 /* U.S.A. -- */
#define DIS204_ENTITY_SUBCATEGORY_C130           1
#define DIS204_ENTITY_SUBCATEGORY_C5           2
#define DIS204_ENTITY_SPECIFIC_C5A           1
#define DIS204_ENTITY_SUBCATEGORY_C141           3
#define DIS204_ENTITY_SUBCATEGORY_C135           4
#define DIS204_ENTITY_SUBCATEGORY_KC135           5
#define DIS204_ENTITY_SUBCATEGORY_KC10           6
#define DIS204_ENTITY_SUBCATEGORY_KC130           7
#define DIS204_ENTITY_SUBCATEGORY_V22           8 /* U.S.S.R. -- */
#define DIS204_ENTITY_SUBCATEGORY_AN124           1
#define DIS204_ENTITY_SUBCATEGORY_AN22           2
#define DIS204_ENTITY_SUBCATEGORY_II76           3
#define DIS204_ENTITY_SUBCATEGORY_AN12           4
#define DIS204_ENTITY_SUBCATEGORY_AN24           5
#define DIS204_ENTITY_SUBCATEGORY_AN26           6
#define DIS204_ENTITY_SUBCATEGORY_AN32           7
#define DIS204_ENTITY_SUBCATEGORY_AN72           8
#define DIS204_ENTITY_SUBCATEGORY_AN225           9
#define DIS204_ENTITY_SUBCATEGORY_M12           10 /* U.K. -- */
#define DIS204_ENTITY_SUBCATEGORY_K2_VICTOR           1 /* France -- */
#define DIS204_ENTITY_SUBCATEGORY_TRANSALL           1
#define DIS204_ENTITY_CATEGORY_ANTI_SUBMARINE_PATROL           5 /* U.S.A. -- */
#define DIS204_ENTITY_SUBCATEGORY_P3           1
#define DIS204_ENTITY_SUBCATEGORY_S3           2
#define DIS204_ENTITY_SUBCATEGORY_OV10           3 /* U.S.S.R. -- */
#define DIS204_ENTITY_SUBCATEGORY_II38           1
#define DIS204_ENTITY_SUBCATEGORY_BE12           2
#define DIS204_ENTITY_SUBCATEGORY_TU126           3 /* U.K. -- */
#define DIS204_ENTITY_SUBCATEGORY_NIMROD_MK_R1           1 /* France -- */
#define DIS204_ENTITY_SUBCATEGORY_ATLANTIQUE           1
#define DIS204_ENTITY_SUBCATEGORY_ALIZE           2
#define DIS204_ENTITY_CATEGORY_ATTACK_HELICOPTER           6 /* U.S.A. -- */
#define DIS204_ENTITY_SUBCATEGORY_AH64_APACHE           1
#define DIS204_ENTITY_SUBCATEGORY_AH64_APACHE_D           1
#define DIS204_ENTITY_SUBCATEGORY_AH1           2
#define DIS204_ENTITY_SPECIFIC_AH1G           1
#define DIS204_ENTITY_SPECIFIC_AH1S           2
#define DIS204_ENTITY_SPECIFIC_AH1W           3
#define DIS204_ENTITY_SPECIFIC_AH1_VENOM           4
#define DIS204_ENTITY_SUBCATEGORY_RAH66           3
#define DIS204_ENTITY_SUBCATEGORY_RAH66_LONGBOW           3 /* U.S.S.R. -- */
#define DIS204_ENTITY_SUBCATEGORY_MI28           1
#define DIS204_ENTITY_SUBCATEGORY_MI24           2
#define DIS204_ENTITY_SPECIFIC_MI24D           1
#define DIS204_ENTITY_SPECIFIC_MI24F           2
#define DIS204_ENTITY_SPECIFIC_MI24E           3
#define DIS204_ENTITY_SUBCATEGORY_KA50           3 /* Germany -- */
#define DIS204_ENTITY_SUBCATEGORY_PAH_1           1
#define DIS204_ENTITY_SUBCATEGORY_PAH_2           2
#define DIS204_ENTITY_CATEGORY_UTILITY_HELICOPTER           7 /* U.S.A. -- */
#define DIS204_ENTITY_SUBCATEGORY_UH1           1
#define DIS204_ENTITY_SUBCATEGORY_UH60           2
#define DIS204_ENTITY_SPECIFIC_UH60A           1
#define DIS204_ENTITY_SPECIFIC_UH60L           2
#define DIS204_ENTITY_SUBCATEGORY_H46           3
#define DIS204_ENTITY_SUBCATEGORY_S70           4 /* U.S.S.R. -- */
#define DIS204_ENTITY_SUBCATEGORY_MI8           1
#define DIS204_ENTITY_SUBCATEGORY_MI14           2
#define DIS204_ENTITY_SUBCATEGORY_MI26           3
#define DIS204_ENTITY_SUBCATEGORY_MI6           4
#define DIS204_ENTITY_SUBCATEGORY_MI2           5
#define DIS204_ENTITY_SUBCATEGORY_MI4           6
#define DIS204_ENTITY_SUBCATEGORY_MI10           7
#define DIS204_ENTITY_SUBCATEGORY_KA25           8
#define DIS204_ENTITY_SUBCATEGORY_KA27           9 /* U.K. -- */
#define DIS204_ENTITY_SUBCATEGORY_EH101_MERLIN           1
#define DIS204_ENTITY_SUBCATEGORY_LYNX_HAS_2_3           2
#define DIS204_ENTITY_SUBCATEGORY_SEA_KING_AEW_2           3
#define DIS204_ENTITY_SUBCATEGORY_SEA_KING_HAS_5_6           4
#define DIS204_ENTITY_SUBCATEGORY_GAZELLE_UK           5
#define DIS204_ENTITY_SUBCATEGORY_PUMA_SUPER_PUMA           6
#define DIS204_ENTITY_SUBCATEGORY_JET_PROVOST           7
#define DIS204_ENTITY_SUBCATEGORY_WESSEX           8
#define DIS204_ENTITY_SUBCATEGORY_SCOUT           9
#define DIS204_ENTITY_SUBCATEGORY_WASP           10
#define DIS204_ENTITY_SUBCATEGORY_BEAVER           11
#define DIS204_ENTITY_SUBCATEGORY_CHIPMUNK           12
#define DIS204_ENTITY_SUBCATEGORY_AUSTER           13
#define DIS204_ENTITY_SUBCATEGORY_ALOUETTE_II           14
#define DIS204_ENTITY_SUBCATEGORY_JET_STREAM           15
#define DIS204_ENTITY_SUBCATEGORY_BULL_DOG           16 /* France -- */
#define DIS204_ENTITY_SUBCATEGORY_ALOUETTE_II_III           1
#define DIS204_ENTITY_SUBCATEGORY_SUPER_PUMA_PUMA           2
#define DIS204_ENTITY_SUBCATEGORY_GAZELLE_FRANCE           3
#define DIS204_ENTITY_SUBCATEGORY_LYNX           4
#define DIS204_ENTITY_SUBCATEGORY_PANTHER           5
#define DIS204_ENTITY_SUBCATEGORY_SUPER_FRELON           6
#define DIS204_ENTITY_CATEGORY_SURVEILLANCE_COMMAND_CONTROL           9
#define DIS204_ENTITY_SUBCATEGORY_A50           1
#define DIS204_ENTITY_SPECIFIC_A50_AEW_C           1
#define DIS204_ENTITY_CATEGORY_UNDEFINED           30
#define DIS204_ENTITY_SUBCATEGORY_X31           0
#define DIS204_ENTITY_CATEGORY_CARGO_HELICOPTER           50
#define DIS204_ENTITY_SUBCATEGORY_CH47           1
#define DIS204_ENTITY_SPECIFIC_CH47C           1
#define DIS204_ENTITY_SPECIFIC_CH47D           2
#define DIS204_ENTITY_SUBCATEGORY_CH53           2
#define DIS204_ENTITY_CATEGORY_OBSERVATION_HELICOPTER           51
#define DIS204_ENTITY_SUBCATEGORY_OH58           1
#define DIS204_ENTITY_SPECIFIC_OH58C           1
#define DIS204_ENTITY_SPECIFIC_OH58D           2
#define DIS204_ENTITY_CATEGORY_SEA_GOING_HELICOPTER           52
#define DIS204_ENTITY_SUBCATEGORY_SH2           1
#define DIS204_ENTITY_SUBCATEGORY_SH3           2
#define DIS204_ENTITY_SUBCATEGORY_SH60           3
#define DIS204_ENTITY_SPECIFIC_SH60B           1
#define DIS204_ENTITY_SPECIFIC_SH60F           2
#define DIS204_ENTITY_CATEGORY_ELECTRONIC_WARFARE           53
#define DIS204_ENTITY_SUBCATEGORY_E2           1
#define DIS204_ENTITY_SUBCATEGORY_EA3           2
#define DIS204_ENTITY_SPECIFIC_EA3A           1
#define DIS204_ENTITY_SPECIFIC_EA3B           2
#define DIS204_ENTITY_SUBCATEGORY_E6           3
#define DIS204_ENTITY_SPECIFIC_E6A           1
#define DIS204_ENTITY_SUBCATEGORY_E3           4
#define DIS204_ENTITY_SPECIFIC_E3A           1
#define DIS204_ENTITY_SUBCATEGORY_E4           5
#define DIS204_ENTITY_SPECIFIC_E4A           1
#define DIS204_ENTITY_SPECIFIC_E4B           2
#define DIS204_ENTITY_SUBCATEGORY_JSTARS           6
#define DIS204_ENTITY_CATEGORY_UNMANNED_AIR_VEHICLE           54
#define DIS204_ENTITY_SUBCATEGORY_UAV           0
#define DIS204_ENTITY_CATEGORY_SPY_PLANES           55
#define DIS204_ENTITY_SUBCATEGORY_SR71           1
#define DIS204_ENTITY_SUBCATEGORY_TR1           2
#define DIS204_ENTITY_SUBCATEGORY_U2           3
#define DIS204_ENTITY_SUBCATEGORY_BIPLANE           5
#define DIS204_ENTITY_CATEGORY_SPECIAL_OPERATIONS           56
#define DIS204_ENTITY_SUBCATEGORY_MH60           1
#define DIS204_ENTITY_SPECIFIC_MH60G           1
#define DIS204_ENTITY_SPECIFIC_MH60K           2
#define DIS204_ENTITY_SUBCATEGORY_MH47           2
#define DIS204_ENTITY_SPECIFIC_MH47E           1
#define DIS204_ENTITY_SUBCATEGORY_MH53           3
#define DIS204_ENTITY_SPECIFIC_MH53J           1
#define DIS204_ENTITY_SUBCATEGORY_MH6           4 /* Surface Domain -- */
 /* U.K. -- */
#define DIS204_ENTITY_SUBCATEGORY_LIGHT_AIRCRAFT_CARRIERS           1
#define DIS204_ENTITY_SUBCATEGORY_TYPE_82           2
#define DIS204_ENTITY_SUBCATEGORY_TYPE_42           3
#define DIS204_ENTITY_SUBCATEGORY_AMAZON_CLASS           4
#define DIS204_ENTITY_SUBCATEGORY_BROADSWORD_CLASS           5
#define DIS204_ENTITY_SUBCATEGORY_DUKE_CLASS           6
#define DIS204_ENTITY_SUBCATEGORY_LEANDER_CLASS           7
#define DIS204_ENTITY_SUBCATEGORY_HUNT_CLASS           8
#define DIS204_ENTITY_SUBCATEGORY_RIVER_CLASS           9
#define DIS204_ENTITY_SUBCATEGORY_TON_CLASS           10
#define DIS204_ENTITY_SUBCATEGORY_SANDOWN_CLASS           11 /* France -- */
#define DIS204_ENTITY_SUBCATEGORY_CLEMENCEAU_CLASS           1
#define DIS204_ENTITY_SUBCATEGORY_TYPE_F70_DESTROYER           2
#define DIS204_ENTITY_SUBCATEGORY_TYPE_F70_A_A           3
#define DIS204_ENTITY_SUBCATEGORY_SUFFREN_CLASS           4
#define DIS204_ENTITY_SUBCATEGORY_TYPE_F67           5
#define DIS204_ENTITY_SUBCATEGORY_TYPE_T56           6
#define DIS204_ENTITY_SUBCATEGORY_TYPE_T53           7
#define DIS204_ENTITY_SUBCATEGORY_TYPE_47           8
#define DIS204_ENTITY_SUBCATEGORY_TYPE_F65           9
#define DIS204_ENTITY_SUBCATEGORY_FL_3000_CLASS_FRIGATE           10
#define DIS204_ENTITY_SUBCATEGORY_SURVEILLANCE_TYPE           11
#define DIS204_ENTITY_SUBCATEGORY_COMMANANT_RIVIERE_CLASS           12
#define DIS204_ENTITY_SUBCATEGORY_D_ESTIENNE_DORVES_CLASS           13
#define DIS204_ENTITY_CATEGORY_CARRIER           1 /* U.S.A. -- */
#define DIS204_ENTITY_SUBCATEGORY_NIMITZ_CLASS           1
#define DIS204_ENTITY_SPECIFIC_CVN_68           1
#define DIS204_ENTITY_SPECIFIC_CVN_69           2
#define DIS204_ENTITY_SPECIFIC_CVN_70           3
#define DIS204_ENTITY_SPECIFIC_CVN_71           4
#define DIS204_ENTITY_SPECIFIC_CVN_72           5
#define DIS204_ENTITY_SPECIFIC_CVN_73           6
#define DIS204_ENTITY_SUBCATEGORY_ENTERPRISE_CLASS           2
#define DIS204_ENTITY_SPECIFIC_CVN_65           1
#define DIS204_ENTITY_SUBCATEGORY_KITTY_HAWK_JFK_CLASS           3
#define DIS204_ENTITY_SPECIFIC_CV_63           1
#define DIS204_ENTITY_SPECIFIC_CV_64           2
#define DIS204_ENTITY_SPECIFIC_CV_66           3
#define DIS204_ENTITY_SPECIFIC_CV_67           4
#define DIS204_ENTITY_SUBCATEGORY_FORRESTAL_CLASS           4
#define DIS204_ENTITY_SPECIFIC_CV_59           1
#define DIS204_ENTITY_SPECIFIC_CV_60           2
#define DIS204_ENTITY_SPECIFIC_CV_61           3
#define DIS204_ENTITY_SPECIFIC_CV_62           4
#define DIS204_ENTITY_SUBCATEGORY_MIDWAY_CLASS           5
#define DIS204_ENTITY_SPECIFIC_CV_41           1
#define DIS204_ENTITY_SPECIFIC_CV_43           2 /* U.S.S.R. -- */
#define DIS204_ENTITY_SUBCATEGORY_KIEV_CLASS           1
#define DIS204_ENTITY_SPECIFIC_KIEV           1
#define DIS204_ENTITY_SPECIFIC_MINSK           2
#define DIS204_ENTITY_SPECIFIC_NOVOROSSIYSK           3
#define DIS204_ENTITY_SPECIFIC_KHARKOV           4
#define DIS204_ENTITY_SUBCATEGORY_MOSKVA_CLASS           2
#define DIS204_ENTITY_SPECIFIC_MOSKVA           1
#define DIS204_ENTITY_SPECIFIC_LENINGRAD           2 /* France -- */
#define DIS204_ENTITY_SUBCATEGORY_NUCLEAR_PROPELLED           1
#define DIS204_ENTITY_SUBCATEGORY_HELICOPTER_CARRIER           1
#define DIS204_ENTITY_CATEGORY_COMMAND_SHIP_CRUISER           2 /* U.S.A. -- */
#define DIS204_ENTITY_SUBCATEGORY_BLUE_RIDGE_CLASS           1
#define DIS204_ENTITY_SPECIFIC_LCC_19           1
#define DIS204_ENTITY_SPECIFIC_LLC_20           2
#define DIS204_ENTITY_SUBCATEGORY_MISC_COMMAND_SHIPS           2
#define DIS204_ENTITY_SPECIFIC_AGF_11           1
#define DIS204_ENTITY_SPECIFIC_AGF_3           2 /* U.S.S.R. -- */
#define DIS204_ENTITY_SUBCATEGORY_CONVERTED_SVERDLOV_CLASS           1
#define DIS204_ENTITY_SPECIFIC_ADMIRAL_SENYAVIN           1
#define DIS204_ENTITY_SPECIFIC_ZHDANOV           2
#define DIS204_ENTITY_CATEGORY_GUIDED_MISSILE_CRUISER           3 /* U.S.A. -- */
#define DIS204_ENTITY_SUBCATEGORY_TICONDEROGA_CLASS           1
#define DIS204_ENTITY_SPECIFIC_CG_47           1
#define DIS204_ENTITY_SPECIFIC_CG_48           2
#define DIS204_ENTITY_SPECIFIC_CG_49           3
#define DIS204_ENTITY_SPECIFIC_CG_50           4
#define DIS204_ENTITY_SPECIFIC_CG_51           5
#define DIS204_ENTITY_SUBCATEGORY_VIRGINIA_CLASS           2
#define DIS204_ENTITY_SPECIFIC_CGN_38           1
#define DIS204_ENTITY_SPECIFIC_CGN_39           2
#define DIS204_ENTITY_SPECIFIC_CGN_40           3
#define DIS204_ENTITY_SPECIFIC_CGN_41           4
#define DIS204_ENTITY_SUBCATEGORY_CALIFORNIA_CLASS           3
#define DIS204_ENTITY_SPECIFIC_CGN_36           1
#define DIS204_ENTITY_SPECIFIC_CGN_37           2
#define DIS204_ENTITY_SUBCATEGORY_TRUXTUN_CLASS           4
#define DIS204_ENTITY_SPECIFIC_CGN_35           1
#define DIS204_ENTITY_SUBCATEGORY_BELKNAP_CLASS           5
#define DIS204_ENTITY_SPECIFIC_CG_26           1
#define DIS204_ENTITY_SPECIFIC_CG_27           2
#define DIS204_ENTITY_SPECIFIC_CG_28           3
#define DIS204_ENTITY_SPECIFIC_CG_29           4
#define DIS204_ENTITY_SPECIFIC_CG_30           5
#define DIS204_ENTITY_SPECIFIC_CG_31           6
#define DIS204_ENTITY_SPECIFIC_CG_32           7
#define DIS204_ENTITY_SPECIFIC_CG_33           8
#define DIS204_ENTITY_SPECIFIC_CG_34           9
#define DIS204_ENTITY_SUBCATEGORY_BAINBRIDGE_CLASS           6
#define DIS204_ENTITY_SPECIFIC_CGN_25           1
#define DIS204_ENTITY_SUBCATEGORY_LEAHY_CLASS           7
#define DIS204_ENTITY_SPECIFIC_CG_16           1
#define DIS204_ENTITY_SPECIFIC_CG_17           2
#define DIS204_ENTITY_SPECIFIC_CG_18           3
#define DIS204_ENTITY_SPECIFIC_CG_19           4
#define DIS204_ENTITY_SPECIFIC_CG_20           5
#define DIS204_ENTITY_SPECIFIC_CG_21           6
#define DIS204_ENTITY_SPECIFIC_CG_22           7
#define DIS204_ENTITY_SPECIFIC_CG_23           8
#define DIS204_ENTITY_SPECIFIC_CG_24           9
#define DIS204_ENTITY_SUBCATEGORY_ALBANY_CLASS           8
#define DIS204_ENTITY_SPECIFIC_CG_10           1
#define DIS204_ENTITY_SUBCATEGORY_LONG_BEACH_CLASS           9
#define DIS204_ENTITY_SPECIFIC_CGN_9           1 /* U.S.S.R. -- */
#define DIS204_ENTITY_SUBCATEGORY_KRASINA_CLASS           1
#define DIS204_ENTITY_SUBCATEGORY_KIROV_CLASS           2
#define DIS204_ENTITY_SUBCATEGORY_KARA_CLASS           3
#define DIS204_ENTITY_SPECIFIC_NIKOLAYEV           1
#define DIS204_ENTITY_SPECIFIC_OCHAKOV           2
#define DIS204_ENTITY_SPECIFIC_KERCH           3
#define DIS204_ENTITY_SPECIFIC_AZOV           4
#define DIS204_ENTITY_SPECIFIC_PETROPAVLOVSK           5
#define DIS204_ENTITY_SPECIFIC_TASHKENT           6
#define DIS204_ENTITY_SPECIFIC_TALLINN           7
#define DIS204_ENTITY_SUBCATEGORY_KRESTA_II_CLASS           4
#define DIS204_ENTITY_SPECIFIC_KRONSHTADT           1
#define DIS204_ENTITY_SPECIFIC_ADMIRAL_ISAKOV           2
#define DIS204_ENTITY_SPECIFIC_ADMIRAL_NAKIHIMOV           3
#define DIS204_ENTITY_SPECIFIC_MARSHAL_VOROSHILOV           4
#define DIS204_ENTITY_SPECIFIC_ADMIRAL_OKTYABRSKIY           5
#define DIS204_ENTITY_SPECIFIC_ADMIRAL_ISACHENKOV           6
#define DIS204_ENTITY_SPECIFIC_MARSHAL_TIMOSHENKO           7
#define DIS204_ENTITY_SPECIFIC_VASILIY_CHAPAYEV           8
#define DIS204_ENTITY_SPECIFIC_ADMIRAL_YUMASHEV           9
#define DIS204_ENTITY_SUBCATEGORY_KRESTA_I_CLASS           5
#define DIS204_ENTITY_SPECIFIC_ADMIRAL_ZOZULYA           1
#define DIS204_ENTITY_SPECIFIC_VLADIVOSTOK           2
#define DIS204_ENTITY_SPECIFIC_VITSE_ADMIRAL_DROZD           3
#define DIS204_ENTITY_SPECIFIC_SEVASTOPOL           4
#define DIS204_ENTITY_SUBCATEGORY_KYNDA_CLASS           6
#define DIS204_ENTITY_SPECIFIC_GROZNYY           1
#define DIS204_ENTITY_SPECIFIC_ADMIRAL_FOKIN           2
#define DIS204_ENTITY_SPECIFIC_ADMIRAL_GOLOVKO           3
#define DIS204_ENTITY_SPECIFIC_VARYAG           4
#define DIS204_ENTITY_SUBCATEGORY_SVERDLOV_CLASS_GMC           7
#define DIS204_ENTITY_SPECIFIC_DZERZHINSKIY           1
#define DIS204_ENTITY_CATEGORY_GUIDED_MISSILE_DESTROYER           4 /* U.S.A. -- */
#define DIS204_ENTITY_SUBCATEGORY_ARLEIGH_BURKE_CLASS           1
#define DIS204_ENTITY_SPECIFIC_DDG_51           1
#define DIS204_ENTITY_SUBCATEGORY_KIDD_CLASS           2
#define DIS204_ENTITY_SPECIFIC_DDG_993           1
#define DIS204_ENTITY_SPECIFIC_DDG_994           2
#define DIS204_ENTITY_SPECIFIC_DDG_995           3
#define DIS204_ENTITY_SPECIFIC_DDG_996           4
#define DIS204_ENTITY_SUBCATEGORY_FARRAGUT_CLASS           3
#define DIS204_ENTITY_SPECIFIC_DDG_37           1
#define DIS204_ENTITY_SPECIFIC_DDG_38           2
#define DIS204_ENTITY_SPECIFIC_DDG_39           3
#define DIS204_ENTITY_SPECIFIC_DDG_40           4
#define DIS204_ENTITY_SPECIFIC_DDG_41           5
#define DIS204_ENTITY_SPECIFIC_DDG_42           6
#define DIS204_ENTITY_SPECIFIC_DDG_43           7
#define DIS204_ENTITY_SPECIFIC_DDG_44           8
#define DIS204_ENTITY_SPECIFIC_DDG_45           9
#define DIS204_ENTITY_SUBCATEGORY_CHARLES_F_ADAMS_CLASS           4
#define DIS204_ENTITY_SPECIFIC_DDG_2           1
#define DIS204_ENTITY_SPECIFIC_DDG_3           2
#define DIS204_ENTITY_SPECIFIC_DDG_4           3
#define DIS204_ENTITY_SPECIFIC_DDG_5           4
#define DIS204_ENTITY_SPECIFIC_DDG_6           5
#define DIS204_ENTITY_SPECIFIC_DDG_7           6
#define DIS204_ENTITY_SPECIFIC_DDG_8           7
#define DIS204_ENTITY_SPECIFIC_DDG_9           8
#define DIS204_ENTITY_SPECIFIC_DDG_10           9
#define DIS204_ENTITY_SPECIFIC_DDG_11           10
#define DIS204_ENTITY_SPECIFIC_DDG_12           11
#define DIS204_ENTITY_SPECIFIC_DDG_13           12
#define DIS204_ENTITY_SPECIFIC_DDG_14           13
#define DIS204_ENTITY_SPECIFIC_DDG_15           14
#define DIS204_ENTITY_SPECIFIC_DDG_16           15
#define DIS204_ENTITY_SPECIFIC_DDG_17           16
#define DIS204_ENTITY_SPECIFIC_DDG_18           17
#define DIS204_ENTITY_SPECIFIC_DDG_19           18
#define DIS204_ENTITY_SPECIFIC_DDG_20           19
#define DIS204_ENTITY_SPECIFIC_DDG_21           20
#define DIS204_ENTITY_SPECIFIC_DDG_22           21
#define DIS204_ENTITY_SPECIFIC_DDG_23           22
#define DIS204_ENTITY_SPECIFIC_DDG_24           23 /* U.S.S.R. -- */
#define DIS204_ENTITY_SUBCATEGORY_UDALOY_CLASS           1
#define DIS204_ENTITY_SPECIFIC_UDALOY           1
#define DIS204_ENTITY_SPECIFIC_VITSE_ADMIRAL_KULAKOV           2
#define DIS204_ENTITY_SUBCATEGORY_SOVREMENNYY_CLASS           2
#define DIS204_ENTITY_SPECIFIC_SOVREMENNYY           1
#define DIS204_ENTITY_SPECIFIC_OTCHAYANNYY           2
#define DIS204_ENTITY_SUBCATEGORY_MODIFIED_KASHIN_CLASS           3
#define DIS204_ENTITY_SPECIFIC_OGNEVOY           1
#define DIS204_ENTITY_SPECIFIC_SLAVNYY           2
#define DIS204_ENTITY_SPECIFIC_SDERZHANDOYY           3
#define DIS204_ENTITY_SPECIFIC_SMELYY           4
#define DIS204_ENTITY_SPECIFIC_SMYSHLENNYY           5
#define DIS204_ENTITY_SPECIFIC_STROYNYY           6
#define DIS204_ENTITY_SUBCATEGORY_KASHIN_CLASS           4
#define DIS204_ENTITY_SPECIFIC_KOMSOMOLETS_UKRAINYY           1
#define DIS204_ENTITY_SPECIFIC_KRASNYY_KAVKAZ           2
#define DIS204_ENTITY_SPECIFIC_KRASNYY_KRYM           3
#define DIS204_ENTITY_SPECIFIC_OBRAZTSOVYY           4
#define DIS204_ENTITY_SPECIFIC_ODARENNYY           5
#define DIS204_ENTITY_SPECIFIC_PROVORNYY           6
#define DIS204_ENTITY_SPECIFIC_RESHITELNYY           7
#define DIS204_ENTITY_SPECIFIC_SKORYY           8
#define DIS204_ENTITY_SPECIFIC_SMETLIVVY           9
#define DIS204_ENTITY_SPECIFIC_SOOBRAZITELNYY           10
#define DIS204_ENTITY_SPECIFIC_SPOSOBNYY           11
#define DIS204_ENTITY_SPECIFIC_STEREGUSHCHIY           12
#define DIS204_ENTITY_SPECIFIC_STROGIY           13
#define DIS204_ENTITY_SUBCATEGORY_KANIN_CLASS           5
#define DIS204_ENTITY_SPECIFIC_BOIKIY           1
#define DIS204_ENTITY_SPECIFIC_DERZKIY           2
#define DIS204_ENTITY_SPECIFIC_GNEVNYY           3
#define DIS204_ENTITY_SPECIFIC_GORDYY           4
#define DIS204_ENTITY_SPECIFIC_GREMYASHCHIY           5
#define DIS204_ENTITY_SPECIFIC_UPORNYY           6
#define DIS204_ENTITY_SPECIFIC_ZHGUCHIY           7
#define DIS204_ENTITY_SPECIFIC_ZORKIY           8
#define DIS204_ENTITY_SUBCATEGORY_MODIFIED_KILDIN_CLASS           6
#define DIS204_ENTITY_SPECIFIC_BEDOVYY           1
#define DIS204_ENTITY_SPECIFIC_NEULOVIMYY           2
#define DIS204_ENTITY_SPECIFIC_PROZORLIVYY           3
#define DIS204_ENTITY_SUBCATEGORY_KILDIN_CLASS           7
#define DIS204_ENTITY_SPECIFIC_NEUDERZHIMYY           1
#define DIS204_ENTITY_SUBCATEGORY_SAM_KOTLIN_CLASS           8
#define DIS204_ENTITY_SPECIFIC_BRAVYY           1
#define DIS204_ENTITY_SPECIFIC_NAKHODCHIVYY           2
#define DIS204_ENTITY_SPECIFIC_NASTOCHIVYY           3
#define DIS204_ENTITY_SPECIFIC_NESOKRUSHIMYY           4
#define DIS204_ENTITY_SPECIFIC_SKROMNYY           5
#define DIS204_ENTITY_SPECIFIC_SKRYTNYY           6
#define DIS204_ENTITY_SPECIFIC_SOZNATELNYY           7
#define DIS204_ENTITY_SPECIFIC_VOZBUZHDENNYY           8
#define DIS204_ENTITY_CATEGORY_DESTROYER           5 /* U.S.A. -- */
#define DIS204_ENTITY_SUBCATEGORY_SPRUANCE_CLASS           1
#define DIS204_ENTITY_SPECIFIC_DD_963           1
#define DIS204_ENTITY_SPECIFIC_DD_964           2
#define DIS204_ENTITY_SPECIFIC_DD_965           3
#define DIS204_ENTITY_SPECIFIC_DD_966           4
#define DIS204_ENTITY_SPECIFIC_DD_967           5
#define DIS204_ENTITY_SPECIFIC_DD_968           6
#define DIS204_ENTITY_SPECIFIC_DD_969           7
#define DIS204_ENTITY_SPECIFIC_DD_970           8
#define DIS204_ENTITY_SPECIFIC_DD_971           9
#define DIS204_ENTITY_SPECIFIC_DD_972           10
#define DIS204_ENTITY_SPECIFIC_DD_973           11
#define DIS204_ENTITY_SPECIFIC_DD_974           12
#define DIS204_ENTITY_SPECIFIC_DD_975           13
#define DIS204_ENTITY_SPECIFIC_DD_976           14
#define DIS204_ENTITY_SPECIFIC_DD_977           15
#define DIS204_ENTITY_SPECIFIC_DD_978           16
#define DIS204_ENTITY_SPECIFIC_DD_979           17
#define DIS204_ENTITY_SPECIFIC_DD_980           18
#define DIS204_ENTITY_SPECIFIC_DD_981           19
#define DIS204_ENTITY_SPECIFIC_DD_982           20
#define DIS204_ENTITY_SPECIFIC_DD_983           21
#define DIS204_ENTITY_SPECIFIC_DD_984           22
#define DIS204_ENTITY_SPECIFIC_DD_985           23
#define DIS204_ENTITY_SPECIFIC_DD_986           24
#define DIS204_ENTITY_SPECIFIC_DD_987           25
#define DIS204_ENTITY_SPECIFIC_DD_988           26
#define DIS204_ENTITY_SPECIFIC_DD_989           27
#define DIS204_ENTITY_SPECIFIC_DD_990           28
#define DIS204_ENTITY_SPECIFIC_DD_991           29
#define DIS204_ENTITY_SPECIFIC_DD_992           30
#define DIS204_ENTITY_SPECIFIC_DD_993           31 /* U.S.S.R. -- */
#define DIS204_ENTITY_SUBCATEGORY_KOTLIN_CLASS           1
#define DIS204_ENTITY_SPECIFIC_BESSLEDNYY           1
#define DIS204_ENTITY_SPECIFIC_BLAGORODNYY           2
#define DIS204_ENTITY_SPECIFIC_BLESTYASHCHIY           3
#define DIS204_ENTITY_SPECIFIC_BURLIVYY           4
#define DIS204_ENTITY_SPECIFIC_BYVALYY           5
#define DIS204_ENTITY_SPECIFIC_DALNEVOTOCHNYY           6
#define DIS204_ENTITY_SPECIFIC_KOMSOMOLETS1           7
#define DIS204_ENTITY_SPECIFIC_MOSKOVSKIY           8
#define DIS204_ENTITY_SPECIFIC_KOMSOMOLETS2           9
#define DIS204_ENTITY_SPECIFIC_NAPORISTIY           10
#define DIS204_ENTITY_SPECIFIC_PLAMENNYY           11
#define DIS204_ENTITY_SPECIFIC_SPESHNYY           12
#define DIS204_ENTITY_SPECIFIC_SPOKOYNYY           13
#define DIS204_ENTITY_SPECIFIC_SVEDUSHCHIY           14
#define DIS204_ENTITY_SPECIFIC_SVETLYY           15
#define DIS204_ENTITY_SPECIFIC_VESKIY           16
#define DIS204_ENTITY_SPECIFIC_VDOKHNOVENNY           17
#define DIS204_ENTITY_SPECIFIC_VOZMUSHCHYENNYY           18
#define DIS204_ENTITY_SPECIFIC_VYDERZHANNYY           19
#define DIS204_ENTITY_SPECIFIC_VYZYVAYUSHCHIY           20
#define DIS204_ENTITY_SUBCATEGORY_SKORY_CLASS           2
#define DIS204_ENTITY_SPECIFIC_BEZUDERZHNYY           1
#define DIS204_ENTITY_SPECIFIC_OGNENNYY           2
#define DIS204_ENTITY_SPECIFIC_OSTOROZHNY           3
#define DIS204_ENTITY_SPECIFIC_OZHESTOCHENNYY           4
#define DIS204_ENTITY_SPECIFIC_OZHIVLENNY           5
#define DIS204_ENTITY_SPECIFIC_SERDITY           6
#define DIS204_ENTITY_SPECIFIC_SMOTRYASHY           7
#define DIS204_ENTITY_SPECIFIC_SOLIDNY           8
#define DIS204_ENTITY_SPECIFIC_SOKRUSHITELNYY           9
#define DIS204_ENTITY_SPECIFIC_SOVERSHENNYY           10
#define DIS204_ENTITY_SPECIFIC_STATNY           11
#define DIS204_ENTITY_SPECIFIC_STEPENNY           12
#define DIS204_ENTITY_SPECIFIC_STOYKY           13
#define DIS204_ENTITY_SPECIFIC_STREMITELNY           14
#define DIS204_ENTITY_SPECIFIC_SUROVY           15
#define DIS204_ENTITY_SPECIFIC_SVOBODNY           16
#define DIS204_ENTITY_SPECIFIC_VDUMCHIVY           17
#define DIS204_ENTITY_SPECIFIC_VNIMATELNY           18
#define DIS204_ENTITY_SPECIFIC_VRAZUMITELNY           19
#define DIS204_ENTITY_CATEGORY_GUIDED_MISSILE_FRIGATE           6 /* U.S.A. -- */
#define DIS204_ENTITY_SUBCATEGORY_OLIVER_PERRY_CLASS           1
#define DIS204_ENTITY_SPECIFIC_FFG_7           1
#define DIS204_ENTITY_SPECIFIC_FFG_8           2
#define DIS204_ENTITY_SPECIFIC_FFG_9           3
#define DIS204_ENTITY_SPECIFIC_FFG_10           4
#define DIS204_ENTITY_SPECIFIC_FFG_11           5
#define DIS204_ENTITY_SPECIFIC_FFG_12           6
#define DIS204_ENTITY_SPECIFIC_FFG_13           7
#define DIS204_ENTITY_SPECIFIC_FFG_14           8
#define DIS204_ENTITY_SPECIFIC_FFG_15           9
#define DIS204_ENTITY_SPECIFIC_FFG_16           10
#define DIS204_ENTITY_SPECIFIC_FFG_19           11
#define DIS204_ENTITY_SPECIFIC_FFG_20           12
#define DIS204_ENTITY_SPECIFIC_FFG_21           13
#define DIS204_ENTITY_SPECIFIC_FFG_22           14
#define DIS204_ENTITY_SPECIFIC_FFG_23           15
#define DIS204_ENTITY_SPECIFIC_FFG_24           16
#define DIS204_ENTITY_SPECIFIC_FFG_25           17
#define DIS204_ENTITY_SPECIFIC_FFG_26           18
#define DIS204_ENTITY_SPECIFIC_FFG_27           19
#define DIS204_ENTITY_SPECIFIC_FFG_28           20
#define DIS204_ENTITY_SPECIFIC_FFG_29           21
#define DIS204_ENTITY_SPECIFIC_FFG_30           22
#define DIS204_ENTITY_SPECIFIC_FFG_31           23
#define DIS204_ENTITY_SPECIFIC_FFG_32           24
#define DIS204_ENTITY_SPECIFIC_FFG_33           25
#define DIS204_ENTITY_SPECIFIC_FFG_34           26
#define DIS204_ENTITY_SPECIFIC_FFG_36           27
#define DIS204_ENTITY_SPECIFIC_FFG_37           28
#define DIS204_ENTITY_SPECIFIC_FFG_38           29
#define DIS204_ENTITY_SPECIFIC_FFG_39           30
#define DIS204_ENTITY_SPECIFIC_FFG_40           31
#define DIS204_ENTITY_SPECIFIC_FFG_41           32
#define DIS204_ENTITY_SPECIFIC_FFG_42           33
#define DIS204_ENTITY_SPECIFIC_FFG_43           34
#define DIS204_ENTITY_SPECIFIC_FFG_45           35
#define DIS204_ENTITY_SPECIFIC_FFG_46           36
#define DIS204_ENTITY_SPECIFIC_FFG_47           37
#define DIS204_ENTITY_SPECIFIC_FFG_48           38
#define DIS204_ENTITY_SPECIFIC_FFG_49           39
#define DIS204_ENTITY_SPECIFIC_FFG_50           40
#define DIS204_ENTITY_SPECIFIC_FFG_51           41
#define DIS204_ENTITY_SPECIFIC_FFG_52           42
#define DIS204_ENTITY_SPECIFIC_FFG_53           43
#define DIS204_ENTITY_SPECIFIC_FFG_54           44
#define DIS204_ENTITY_SPECIFIC_FFG_55           45
#define DIS204_ENTITY_SPECIFIC_FFG_56           46
#define DIS204_ENTITY_SPECIFIC_FFG_57           47
#define DIS204_ENTITY_SPECIFIC_FFG_58           48
#define DIS204_ENTITY_SUBCATEGORY_BROOKE_CLASS           2
#define DIS204_ENTITY_SPECIFIC_FFG_1           1
#define DIS204_ENTITY_SPECIFIC_FFG_2           2
#define DIS204_ENTITY_SPECIFIC_FFG_3           3
#define DIS204_ENTITY_SPECIFIC_FFG_4           4
#define DIS204_ENTITY_SPECIFIC_FFG_5           5
#define DIS204_ENTITY_SPECIFIC_FFG_6           6 /* U.S.S.R. -- */
#define DIS204_ENTITY_SUBCATEGORY_KRIVAK_I_CLASS           1
#define DIS204_ENTITY_SPECIFIC_BDITELNYY           1
#define DIS204_ENTITY_SPECIFIC_BEZUKORIZNENNYY           2
#define DIS204_ENTITY_SPECIFIC_BEZZEVETNIY           3
#define DIS204_ENTITY_SPECIFIC_BODRYY           4
#define DIS204_ENTITY_SPECIFIC_DEYATELNYY           5
#define DIS204_ENTITY_SPECIFIC_DOBLESTNYY           6
#define DIS204_ENTITY_SPECIFIC_DOSTOYNYY           7
#define DIS204_ENTITY_SPECIFIC_DRUZHNYY           8
#define DIS204_ENTITY_SPECIFIC_LADNYY           9
#define DIS204_ENTITY_SPECIFIC_LENINGRADSKIY           10
#define DIS204_ENTITY_SPECIFIC_KOMSOMOLETS           11
#define DIS204_ENTITY_SPECIFIC_LETUCHIY           12
#define DIS204_ENTITY_SPECIFIC_PYTLIVYY           13
#define DIS204_ENTITY_SPECIFIC_RAZUMNYY           14
#define DIS204_ENTITY_SPECIFIC_RAZYASHCHIY           15
#define DIS204_ENTITY_SPECIFIC_RETIVYY           16
#define DIS204_ENTITY_SPECIFIC_SILNYY           17
#define DIS204_ENTITY_SPECIFIC_STOROZHEVOY           18
#define DIS204_ENTITY_SPECIFIC_SVIREPYY           19
#define DIS204_ENTITY_SPECIFIC_ZADORNYY           20
#define DIS204_ENTITY_SPECIFIC_ZHARKYY           21
#define DIS204_ENTITY_SUBCATEGORY_KRIVAK_II_CLASS           2
#define DIS204_ENTITY_SPECIFIC_BESSMENYY           1
#define DIS204_ENTITY_SPECIFIC_GORDELIVYY           2
#define DIS204_ENTITY_SPECIFIC_GROMKIY           3
#define DIS204_ENTITY_SPECIFIC_GROZYASHCHIY           4
#define DIS204_ENTITY_SPECIFIC_NEUKROTIMYY           5
#define DIS204_ENTITY_SPECIFIC_PITLIVYY           6
#define DIS204_ENTITY_SPECIFIC_RAZITELNYY           7
#define DIS204_ENTITY_SPECIFIC_REVNOSTTNYY           8
#define DIS204_ENTITY_SPECIFIC_REZKIY           9
#define DIS204_ENTITY_SPECIFIC_REZVYY           10
#define DIS204_ENTITY_SPECIFIC_RYANYY           11
#define DIS204_ENTITY_CATEGORY_PATROL_CRAFT           7 /* U.S.A. -- */
#define DIS204_ENTITY_SUBCATEGORY_PEGASUS_CLASS           1
#define DIS204_ENTITY_SPECIFIC_PHM_1           1
#define DIS204_ENTITY_SPECIFIC_PHM_2           2
#define DIS204_ENTITY_SPECIFIC_PHM_3           3
#define DIS204_ENTITY_SPECIFIC_PHM_4           4
#define DIS204_ENTITY_SPECIFIC_PHM_5           5
#define DIS204_ENTITY_SPECIFIC_PHM_6           6
#define DIS204_ENTITY_SUBCATEGORY_HIGHPOINT_CLASS           2
#define DIS204_ENTITY_SPECIFIC_PCH_1           1
#define DIS204_ENTITY_SUBCATEGORY_MULTI_MISSION           3
#define DIS204_ENTITY_SPECIFIC_PBM_1           1 /* U.S.S.R. -- */
#define DIS204_ENTITY_SUBCATEGORY_MATKA_CLASS           1
#define DIS204_ENTITY_SUBCATEGORY_SARANCHA_CLASS           2
#define DIS204_ENTITY_SUBCATEGORY_OSA_I_CLASS           3
#define DIS204_ENTITY_SUBCATEGORY_OSA_II_CLASS           4
#define DIS204_ENTITY_SUBCATEGORY_TURYA_CLASS           5
#define DIS204_ENTITY_SUBCATEGORY_SHERSHEN_CLASS           6
#define DIS204_ENTITY_SUBCATEGORY_BABOCHKA_CLASS           7
#define DIS204_ENTITY_SUBCATEGORY_ZHUK_CLASS           8
#define DIS204_ENTITY_SUBCATEGORY_SLEPEN_CLASS           9
#define DIS204_ENTITY_SUBCATEGORY_STENKA_CLASS           10
#define DIS204_ENTITY_SUBCATEGORY_PCHELA_CLASS           11
#define DIS204_ENTITY_SUBCATEGORY_S_O_1_CLASS           12
#define DIS204_ENTITY_CATEGORY_MINE_COUNTERMEASURE_SHIP_CRAFT           8
     /* U.S.A. -- */
#define DIS204_ENTITY_SUBCATEGORY_MSH_TYPE           1
#define DIS204_ENTITY_SPECIFIC_MSH_1           1
#define DIS204_ENTITY_SUBCATEGORY_AVENGER_CLASS           2
#define DIS204_ENTITY_SPECIFIC_MCM_1           1
#define DIS204_ENTITY_SPECIFIC_MCM_2           2
#define DIS204_ENTITY_SPECIFIC_MCM_3           3
#define DIS204_ENTITY_SPECIFIC_MCM_4           4
#define DIS204_ENTITY_SPECIFIC_MCM_5           5
#define DIS204_ENTITY_SUBCATEGORY_ACME_CLASS           3
#define DIS204_ENTITY_SPECIFIC_MSO_509           1
#define DIS204_ENTITY_SPECIFIC_MSO_511           2
#define DIS204_ENTITY_SUBCATEGORY_AGILE_AGGRESSIVE_CLASS           4
#define DIS204_ENTITY_SPECIFIC_MSO_427           1
#define DIS204_ENTITY_SPECIFIC_MSO_433           2
#define DIS204_ENTITY_SPECIFIC_MSO_437           3
#define DIS204_ENTITY_SPECIFIC_MSO_438           4
#define DIS204_ENTITY_SPECIFIC_MSO_439           5
#define DIS204_ENTITY_SPECIFIC_MSO_440           6
#define DIS204_ENTITY_SPECIFIC_MSO_441           7
#define DIS204_ENTITY_SPECIFIC_MSO_442           8
#define DIS204_ENTITY_SPECIFIC_MSO_443           9
#define DIS204_ENTITY_SPECIFIC_MSO_446           10
#define DIS204_ENTITY_SPECIFIC_MSO_448           11
#define DIS204_ENTITY_SPECIFIC_MSO_449           12
#define DIS204_ENTITY_SPECIFIC_MSO_455           13
#define DIS204_ENTITY_SPECIFIC_MSO_456           14
#define DIS204_ENTITY_SPECIFIC_MSO_464           15
#define DIS204_ENTITY_SPECIFIC_MSO_488           16
#define DIS204_ENTITY_SPECIFIC_MSO_489           17
#define DIS204_ENTITY_SPECIFIC_MSO_490           18
#define DIS204_ENTITY_SPECIFIC_MSO_492           19 /* U.S.S.R. -- */
#define DIS204_ENTITY_SUBCATEGORY_ALESHA_CLASS           1
#define DIS204_ENTITY_SUBCATEGORY_NATYA_I_CLASS           2
#define DIS204_ENTITY_SUBCATEGORY_NATYA_II_CLASS           3
#define DIS204_ENTITY_SUBCATEGORY_YURKA_CLASS           4
#define DIS204_ENTITY_SUBCATEGORY_T43_CLASS           5
#define DIS204_ENTITY_SUBCATEGORY_SONYA_CLASS           6
#define DIS204_ENTITY_SUBCATEGORY_ZHENYA_CLASS           7
#define DIS204_ENTITY_SUBCATEGORY_VANYA_I_CLASS           8
#define DIS204_ENTITY_SUBCATEGORY_VANYA_II_CLASS           9
#define DIS204_ENTITY_SUBCATEGORY_SASHA_CLASS           10
#define DIS204_ENTITY_SUBCATEGORY_YEVGENYA_CLASS           11
#define DIS204_ENTITY_CATEGORY_DOCK_LANDING_SHIP           9 /* U.S.A. -- */
#define DIS204_ENTITY_SUBCATEGORY_WHIDBEY_ISLAND_CLASS           1
#define DIS204_ENTITY_SPECIFIC_LSD_1           1
#define DIS204_ENTITY_SPECIFIC_LSD_2           2
#define DIS204_ENTITY_SUBCATEGORY_ANCHORAGE_CLASS           2
#define DIS204_ENTITY_SPECIFIC_LSD_36           1
#define DIS204_ENTITY_SPECIFIC_LSD_37           2
#define DIS204_ENTITY_SPECIFIC_LSD_38           3
#define DIS204_ENTITY_SPECIFIC_LSD_39           4
#define DIS204_ENTITY_SPECIFIC_LSD_40           5
#define DIS204_ENTITY_SUBCATEGORY_THOMASTON_CLASS           3
#define DIS204_ENTITY_SPECIFIC_LSD_28           1
#define DIS204_ENTITY_SPECIFIC_LSD_29           2
#define DIS204_ENTITY_SPECIFIC_LSD_30           3
#define DIS204_ENTITY_SPECIFIC_LSD_31           4
#define DIS204_ENTITY_SPECIFIC_LSD_32           5
#define DIS204_ENTITY_SPECIFIC_LSD_33           6
#define DIS204_ENTITY_SPECIFIC_LSD_34           7
#define DIS204_ENTITY_SPECIFIC_LSD_35           8 /* U.S.S.R. -- */
#define DIS204_ENTITY_SUBCATEGORY_IVAN_ROGOV_CLASS           1
#define DIS204_ENTITY_SPECIFIC_IVAN_ROGOV           1
#define DIS204_ENTITY_SPECIFIC_ALEKSANDR_NIKOLAY           2
#define DIS204_ENTITY_CATEGORY_TANK_LANDING_SHIP           10 /* U.S.A. -- */
#define DIS204_ENTITY_SUBCATEGORY_NEWPORT_CLASS           1
#define DIS204_ENTITY_SPECIFIC_LST_1179           1
#define DIS204_ENTITY_SPECIFIC_LST_1180           2
#define DIS204_ENTITY_SPECIFIC_LST_1181           3
#define DIS204_ENTITY_SPECIFIC_LST_1182           4
#define DIS204_ENTITY_SPECIFIC_LST_1183           5
#define DIS204_ENTITY_SPECIFIC_LST_1184           6
#define DIS204_ENTITY_SPECIFIC_LST_1185           7
#define DIS204_ENTITY_SPECIFIC_LST_1186           8
#define DIS204_ENTITY_SPECIFIC_LST_1187           9
#define DIS204_ENTITY_SPECIFIC_LST_1188           10
#define DIS204_ENTITY_SPECIFIC_LST_1189           11
#define DIS204_ENTITY_SPECIFIC_LST_1190           12
#define DIS204_ENTITY_SPECIFIC_LST_1191           13
#define DIS204_ENTITY_SPECIFIC_LST_1192           14
#define DIS204_ENTITY_SPECIFIC_LST_1193           15
#define DIS204_ENTITY_SPECIFIC_LST_1194           16
#define DIS204_ENTITY_SPECIFIC_LST_1195           17
#define DIS204_ENTITY_SPECIFIC_LST_1196           18
#define DIS204_ENTITY_SPECIFIC_LST_1197           19
#define DIS204_ENTITY_SPECIFIC_LST_1198           20
#define DIS204_ENTITY_SUBCATEGORY_DE_SOTO_COUNTY_CLASS           2
#define DIS204_ENTITY_SPECIFIC_LST_1173           1
#define DIS204_ENTITY_SPECIFIC_LST_1177           2
#define DIS204_ENTITY_SPECIFIC_LST_1178           3
#define DIS204_ENTITY_SUBCATEGORY_TERREBONNE_PARISH_CLASS           3
#define DIS204_ENTITY_SPECIFIC_LST_1158           1
#define DIS204_ENTITY_SPECIFIC_LST_1160           2
#define DIS204_ENTITY_SPECIFIC_LST_1162           3
#define DIS204_ENTITY_SPECIFIC_LST_1163           4
#define DIS204_ENTITY_SPECIFIC_LST_1164           5
#define DIS204_ENTITY_SPECIFIC_LST_1165           6 /* U.S.S.R. -- */
#define DIS204_ENTITY_SUBCATEGORY_ROPUCHA_CLASS           1
#define DIS204_ENTITY_SUBCATEGORY_ALLIGATOR_CLASS           2
#define DIS204_ENTITY_SPECIFIC_ALEKSANDR_TORTSEV           1
#define DIS204_ENTITY_SPECIFIC_DONETSKIY_SHAKHTER           2
#define DIS204_ENTITY_SPECIFIC_KRASNAYA_PRESNYA           3
#define DIS204_ENTITY_SPECIFIC_KRYMSKIY_KOM           4
#define DIS204_ENTITY_SPECIFIC_NIKOLAY_FILCHENKOV           5
#define DIS204_ENTITY_SPECIFIC_NIKOLAY_VILKOV           6
#define DIS204_ENTITY_SPECIFIC_NIKOLAY_OBYEKOV           7
#define DIS204_ENTITY_SPECIFIC_PETR_ILICHYEV           8
#define DIS204_ENTITY_SPECIFIC_SERGEI_LAZO           9
#define DIS204_ENTITY_SPECIFIC_TOMSKIY_KOM           10
#define DIS204_ENTITY_SPECIFIC_VORONEZHKIY_KOM           11
#define DIS204_ENTITY_SUBCATEGORY_POLNOCNY_CLASS           3
#define DIS204_ENTITY_CATEGORY_LANDING_CRAFT           11 /* U.S.A. -- */
#define DIS204_ENTITY_SUBCATEGORY_LCAC_TYPE           1
#define DIS204_ENTITY_SPECIFIC_LCAC           1
#define DIS204_ENTITY_SUBCATEGORY_LCU_1610_CLASS           2
#define DIS204_ENTITY_SPECIFIC_LCU_1616_1679           1 /* U.S.S.R. -- */
#define DIS204_ENTITY_SUBCATEGORY_LEBED_CLASS           1
#define DIS204_ENTITY_SUBCATEGORY_AIST_CLASS           2
#define DIS204_ENTITY_SUBCATEGORY_GUS_CLASS           3
#define DIS204_ENTITY_SUBCATEGORY_VYDRA_CLASS           4
#define DIS204_ENTITY_SUBCATEGORY_ONDATRA_CLASS           5
#define DIS204_ENTITY_SUBCATEGORY_T4_CLASS           6
#define DIS204_ENTITY_CATEGORY_FRIGATE           50
#define DIS204_ENTITY_SUBCATEGORY_KNOX_CLASS           1
#define DIS204_ENTITY_SPECIFIC_FF_1052           1
#define DIS204_ENTITY_SPECIFIC_FF_1053           2
#define DIS204_ENTITY_SPECIFIC_FF_1054           3
#define DIS204_ENTITY_SPECIFIC_FF_1055           4
#define DIS204_ENTITY_SPECIFIC_FF_1056           5
#define DIS204_ENTITY_SPECIFIC_FF_1057           6
#define DIS204_ENTITY_SPECIFIC_FF_1058           7
#define DIS204_ENTITY_SPECIFIC_FF_1059           8
#define DIS204_ENTITY_SPECIFIC_FF_1060           9
#define DIS204_ENTITY_SPECIFIC_FF_1061           10
#define DIS204_ENTITY_SPECIFIC_FF_1062           11
#define DIS204_ENTITY_SPECIFIC_FF_1063           12
#define DIS204_ENTITY_SPECIFIC_FF_1064           13
#define DIS204_ENTITY_SPECIFIC_FF_1065           14
#define DIS204_ENTITY_SPECIFIC_FF_1066           15
#define DIS204_ENTITY_SPECIFIC_FF_1067           16
#define DIS204_ENTITY_SPECIFIC_FF_1068           17
#define DIS204_ENTITY_SPECIFIC_FF_1069           18
#define DIS204_ENTITY_SPECIFIC_FF_1070           19
#define DIS204_ENTITY_SPECIFIC_FF_1071           20
#define DIS204_ENTITY_SPECIFIC_FF_1072           21
#define DIS204_ENTITY_SPECIFIC_FF_1073           22
#define DIS204_ENTITY_SPECIFIC_FF_1074           23
#define DIS204_ENTITY_SPECIFIC_FF_1075           24
#define DIS204_ENTITY_SPECIFIC_FF_1076           25
#define DIS204_ENTITY_SPECIFIC_FF_1077           26
#define DIS204_ENTITY_SPECIFIC_FF_1078           27
#define DIS204_ENTITY_SPECIFIC_FF_1079           28
#define DIS204_ENTITY_SPECIFIC_FF_1080           29
#define DIS204_ENTITY_SPECIFIC_FF_1081           30
#define DIS204_ENTITY_SPECIFIC_FF_1082           31
#define DIS204_ENTITY_SPECIFIC_FF_1083           32
#define DIS204_ENTITY_SPECIFIC_FF_1084           33
#define DIS204_ENTITY_SPECIFIC_FF_1085           34
#define DIS204_ENTITY_SPECIFIC_FF_1086           35
#define DIS204_ENTITY_SPECIFIC_FF_1087           36
#define DIS204_ENTITY_SPECIFIC_FF_1088           37
#define DIS204_ENTITY_SPECIFIC_FF_1089           38
#define DIS204_ENTITY_SPECIFIC_FF_1090           39
#define DIS204_ENTITY_SPECIFIC_FF_1091           40
#define DIS204_ENTITY_SPECIFIC_FF_1092           41
#define DIS204_ENTITY_SPECIFIC_FF_1093           42
#define DIS204_ENTITY_SPECIFIC_FF_1094           43
#define DIS204_ENTITY_SPECIFIC_FF_1095           44
#define DIS204_ENTITY_SPECIFIC_FF_1096           45
#define DIS204_ENTITY_SPECIFIC_FF_1097           46
#define DIS204_ENTITY_SUBCATEGORY_GARCIA_CLASS           2
#define DIS204_ENTITY_SPECIFIC_FF_1040           1
#define DIS204_ENTITY_SPECIFIC_FF_1041           2
#define DIS204_ENTITY_SPECIFIC_FF_1043           3
#define DIS204_ENTITY_SPECIFIC_FF_1044           4
#define DIS204_ENTITY_SPECIFIC_FF_1045           5
#define DIS204_ENTITY_SPECIFIC_FF_1047           6
#define DIS204_ENTITY_SPECIFIC_FF_1048           7
#define DIS204_ENTITY_SPECIFIC_FF_1049           8
#define DIS204_ENTITY_SPECIFIC_FF_1050           9
#define DIS204_ENTITY_SPECIFIC_FF_1051           10
#define DIS204_ENTITY_SUBCATEGORY_BRONSTEIN_CLASS           3
#define DIS204_ENTITY_SPECIFIC_FF_1037           1
#define DIS204_ENTITY_SPECIFIC_FF_1038           2 /* Next parameter:  USSR -- */
#define DIS204_ENTITY_CATEGORY_ANTI_SUBMARINE_FRIGATE           50
#define DIS204_ENTITY_SUBCATEGORY_GRISHA_I_CLASS           1
#define DIS204_ENTITY_SUBCATEGORY_GRISHA_II_CLASS           2
#define DIS204_ENTITY_SUBCATEGORY_GRISHA_III_CLASS           3
#define DIS204_ENTITY_SUBCATEGORY_MIRKA_I_CLASS           4
#define DIS204_ENTITY_SUBCATEGORY_MIRKA_II_CLASS           5
#define DIS204_ENTITY_SUBCATEGORY_PETYA_I_CLASS           6
#define DIS204_ENTITY_SUBCATEGORY_PETYA_II_CLASS           7
#define DIS204_ENTITY_SUBCATEGORY_RIGA_CLASS           8
#define DIS204_ENTITY_SPECIFIC_ASTRAKHANSKIY_KOM           1
#define DIS204_ENTITY_SPECIFIC_ARKHANGELSKIY_KOM           2
#define DIS204_ENTITY_SPECIFIC_BARS           3
#define DIS204_ENTITY_SPECIFIC_BARSUK           4
#define DIS204_ENTITY_SPECIFIC_BOBR           5
#define DIS204_ENTITY_SPECIFIC_BUYVOL           6
#define DIS204_ENTITY_SPECIFIC_BYK           7
#define DIS204_ENTITY_SPECIFIC_GEPARD           8
#define DIS204_ENTITY_SPECIFIC_GIENA           9
#define DIS204_ENTITY_SPECIFIC_KOBCHIK           10
#define DIS204_ENTITY_SPECIFIC_KOMSOMOLETS_GRUZIY           11
#define DIS204_ENTITY_SPECIFIC_KOMSOMOLETS_LITVIY           12
#define DIS204_ENTITY_SPECIFIC_KRASNODARSKIY_KOM           13
#define DIS204_ENTITY_SPECIFIC_KUNITSA           14
#define DIS204_ENTITY_SPECIFIC_LEOPARD           15
#define DIS204_ENTITY_SPECIFIC_LEV           16
#define DIS204_ENTITY_SPECIFIC_LISA           17
#define DIS204_ENTITY_SPECIFIC_MEDVED           18
#define DIS204_ENTITY_SPECIFIC_PANTERA           19
#define DIS204_ENTITY_SPECIFIC_RYS_ROSOMAKHA           20
#define DIS204_ENTITY_SPECIFIC_SHAKAL           21
#define DIS204_ENTITY_SPECIFIC_TIGR           22
#define DIS204_ENTITY_SPECIFIC_TURMAN           23
#define DIS204_ENTITY_SPECIFIC_VOLK           24
#define DIS204_ENTITY_SPECIFIC_VORON           25
#define DIS204_ENTITY_SPECIFIC_YAGUAR           26
#define DIS204_ENTITY_SUBCATEGORY_KONI_CLASS           9
#define DIS204_ENTITY_SPECIFIC_TIMOFEY_ULYANTSEV           1
     /* Next parameter:  France -- */
#define DIS204_ENTITY_CATEGORY_CRUISER           50
#define DIS204_ENTITY_CATEGORY_BATTLESHIP           51
#define DIS204_ENTITY_SUBCATEGORY_IOWA_CLASS           1
#define DIS204_ENTITY_SPECIFIC_BB_61           1
#define DIS204_ENTITY_SPECIFIC_BB_62           2
#define DIS204_ENTITY_SPECIFIC_BB_63           3 /* Next parameter:  USSR -- */
#define DIS204_ENTITY_CATEGORY_GUIDED_MISSILE_CORVETTE           51
#define DIS204_ENTITY_SUBCATEGORY_TARANTUL_I_CLASS           1
#define DIS204_ENTITY_SUBCATEGORY_TARANTUL_II_CLASS           2
#define DIS204_ENTITY_SUBCATEGORY_NANUCHKA_I_CLASS           3
#define DIS204_ENTITY_SUBCATEGORY_NANUCHKA_III_CLASS           4
#define DIS204_ENTITY_CATEGORY_HEAVY_CRUISER           52
#define DIS204_ENTITY_SUBCATEGORY_DES_MOINES_CLASS           1
#define DIS204_ENTITY_SPECIFIC_CA_134           1
#define DIS204_ENTITY_SPECIFIC_CA_139           2 /* Next parameter:  USSR -- */
#define DIS204_ENTITY_CATEGORY_ANTI_SUBMARINE_CORVETTE           52
#define DIS204_ENTITY_SUBCATEGORY_PAUK_CLASS           1
#define DIS204_ENTITY_SUBCATEGORY_POTI_CLASS           2
#define DIS204_ENTITY_SUBCATEGORY_T58_CLASS           3
     /* DZERZHINSKIY is already defined as 1 at this point */
 /* drn will not allow the same constant twice */
 /* constant           DIS204_ENTITY_SPECIFIC_DZERZHINSKIY                  1 */
#define DIS204_ENTITY_SPECIFIC_KALININGRAD_KOMSOMOLETS           2
#define DIS204_ENTITY_SPECIFIC_KOMSOMOLETS_LATVIY           3
#define DIS204_ENTITY_SPECIFIC_MALAKHIT           4
#define DIS204_ENTITY_SPECIFIC_SOVIETSKIY_POGRANICHINIK           5
#define DIS204_ENTITY_CATEGORY_DESTROYER_TENDER           53
#define DIS204_ENTITY_SUBCATEGORY_SAM_GOMPERS_CLASS           1
#define DIS204_ENTITY_SPECIFIC_AD_37           1
#define DIS204_ENTITY_SPECIFIC_AD_38           2
#define DIS204_ENTITY_SPECIFIC_AD_41           3
#define DIS204_ENTITY_SPECIFIC_AD_42           4
#define DIS204_ENTITY_SPECIFIC_AD_43           5
#define DIS204_ENTITY_SPECIFIC_AD_44           6
#define DIS204_ENTITY_SUBCATEGORY_DIXIE_CLASS           2
#define DIS204_ENTITY_SPECIFIC_AD_15           1
#define DIS204_ENTITY_SPECIFIC_AD_18           2
#define DIS204_ENTITY_SPECIFIC_AD_19           3 /* Next parameter:  USSR -- */
#define DIS204_ENTITY_CATEGORY_LIGHT_CRUISER           53
#define DIS204_ENTITY_SUBCATEGORY_SVERDLOV_CLASS_LC           1
#define DIS204_ENTITY_SPECIFIC_ADMIRAL_LAZAREV           1
#define DIS204_ENTITY_SPECIFIC_ADMIRAL_USHAKOV           2
#define DIS204_ENTITY_SPECIFIC_ALEKSANDR_NEVSKIY           3
#define DIS204_ENTITY_SPECIFIC_ALEKSANDR_SUVOROV           4
#define DIS204_ENTITY_SPECIFIC_DMITRIY_POZHARSKIY           5
#define DIS204_ENTITY_SPECIFIC_MIKHAIL_KUTUZOV           6
#define DIS204_ENTITY_SPECIFIC_MURMANSK           7
#define DIS204_ENTITY_SPECIFIC_OKTYABRSKYAYA_REVOLUTSIYA           8
#define DIS204_ENTITY_SPECIFIC_SVERDLOV           9
#define DIS204_ENTITY_CATEGORY_AMPHIBIOUS_ASSAULT_SHIP           54
#define DIS204_ENTITY_SUBCATEGORY_TARAWA_CLASS           1
#define DIS204_ENTITY_SPECIFIC_LHA_1           1
#define DIS204_ENTITY_SPECIFIC_LHA_2           2
#define DIS204_ENTITY_SPECIFIC_LHA_3           3
#define DIS204_ENTITY_SPECIFIC_LHA_4           4
#define DIS204_ENTITY_SPECIFIC_LHA_5           5
#define DIS204_ENTITY_SUBCATEGORY_IWO_JIMA_CLASS           2
#define DIS204_ENTITY_SPECIFIC_LPH_2           1
#define DIS204_ENTITY_SPECIFIC_LPH_3           2
#define DIS204_ENTITY_SPECIFIC_LPH_7           3
#define DIS204_ENTITY_SPECIFIC_LPH_9           4
#define DIS204_ENTITY_SPECIFIC_LPH_10           5
#define DIS204_ENTITY_SPECIFIC_LPH_11           6
#define DIS204_ENTITY_SPECIFIC_LPH_12           7
#define DIS204_ENTITY_SUBCATEGORY_WACLASS           3
#define DIS204_ENTITY_SPECIFIC_LHD_1           1
#define DIS204_ENTITY_CATEGORY_AMPHIBIOUS_CARGO_SHIP           55
#define DIS204_ENTITY_SUBCATEGORY_CHARLESTON_CLASS           1
#define DIS204_ENTITY_SPECIFIC_LKA_113           1
#define DIS204_ENTITY_SPECIFIC_LKA_114           2
#define DIS204_ENTITY_SPECIFIC_LKA_115           3
#define DIS204_ENTITY_SPECIFIC_LKA_116           4
#define DIS204_ENTITY_SPECIFIC_LKA_117           5
#define DIS204_ENTITY_CATEGORY_AMPHIBIOUS_TRANSPORT_DOCK           56
#define DIS204_ENTITY_SUBCATEGORY_AUSTIN_CLASS           1
#define DIS204_ENTITY_SPECIFIC_LPD_4           1
#define DIS204_ENTITY_SPECIFIC_LPD_5           2
#define DIS204_ENTITY_SPECIFIC_LPD_6           3
#define DIS204_ENTITY_SPECIFIC_LPD_7           4
#define DIS204_ENTITY_SPECIFIC_LPD_8           5
#define DIS204_ENTITY_SPECIFIC_LPD_9           6
#define DIS204_ENTITY_SPECIFIC_LPD_10           7
#define DIS204_ENTITY_SPECIFIC_LPD_12           8
#define DIS204_ENTITY_SPECIFIC_LPD_13           9
#define DIS204_ENTITY_SPECIFIC_LPD_14           10
#define DIS204_ENTITY_SPECIFIC_LPD_15           11
#define DIS204_ENTITY_SUBCATEGORY_RALEIGH_CLASS           2
#define DIS204_ENTITY_SPECIFIC_LPD_1           1
#define DIS204_ENTITY_SPECIFIC_LPD_2           2
#define DIS204_ENTITY_CATEGORY_AMMUNITION_SHIP           57
#define DIS204_ENTITY_SUBCATEGORY_KILAUEA_CLASS           1
#define DIS204_ENTITY_SPECIFIC_T_AE_26           1
#define DIS204_ENTITY_SPECIFIC_AE_27           2
#define DIS204_ENTITY_SPECIFIC_AE_28           3
#define DIS204_ENTITY_SPECIFIC_AE_29           4
#define DIS204_ENTITY_SPECIFIC_AE_32           5
#define DIS204_ENTITY_SPECIFIC_AE_33           6
#define DIS204_ENTITY_SPECIFIC_AE_34           7
#define DIS204_ENTITY_SPECIFIC_AE_35           8
#define DIS204_ENTITY_SUBCATEGORY_SURIBACHI_CLASS           2
#define DIS204_ENTITY_SPECIFIC_AE_21           1
#define DIS204_ENTITY_SPECIFIC_AE_22           2
#define DIS204_ENTITY_SPECIFIC_AE_23           3
#define DIS204_ENTITY_SPECIFIC_AE_24           4
#define DIS204_ENTITY_SPECIFIC_AE_25           5
#define DIS204_ENTITY_CATEGORY_COMBAT_STORES_SHIP           58
#define DIS204_ENTITY_SUBCATEGORY_EX_BRITISH_CLASS           1
#define DIS204_ENTITY_SPECIFIC_T_AFS_8           1
#define DIS204_ENTITY_SPECIFIC_T_AFS_9           2
#define DIS204_ENTITY_SPECIFIC_T_AFS_10           3
#define DIS204_ENTITY_SUBCATEGORY_MARS_CLASS           2
#define DIS204_ENTITY_SPECIFIC_AFS_1           1
#define DIS204_ENTITY_SPECIFIC_AFS_2           2
#define DIS204_ENTITY_SPECIFIC_AFS_3           3
#define DIS204_ENTITY_SPECIFIC_AFS_4           4
#define DIS204_ENTITY_SPECIFIC_AFS_5           5
#define DIS204_ENTITY_SPECIFIC_AFS_6           6
#define DIS204_ENTITY_SPECIFIC_AFS_7           7
#define DIS204_ENTITY_CATEGORY_SURTASS           59
#define DIS204_ENTITY_SUBCATEGORY_STALWARD_CLASS           1
#define DIS204_ENTITY_SPECIFIC_T_AGOS_1           1
#define DIS204_ENTITY_SPECIFIC_T_AGOS_2           2
#define DIS204_ENTITY_SPECIFIC_T_AGOS_3           3
#define DIS204_ENTITY_SPECIFIC_T_AGOS_4           4
#define DIS204_ENTITY_SPECIFIC_T_AGOS_5           5
#define DIS204_ENTITY_SPECIFIC_T_AGOS_6           6
#define DIS204_ENTITY_SPECIFIC_T_AGOS_7           7
#define DIS204_ENTITY_SPECIFIC_T_AGOS_8           8
#define DIS204_ENTITY_SPECIFIC_T_AGOS_9           9
#define DIS204_ENTITY_SPECIFIC_T_AGOS_10           10
#define DIS204_ENTITY_SPECIFIC_T_AGOS_11           11
#define DIS204_ENTITY_SPECIFIC_T_AGOS_12           12
#define DIS204_ENTITY_SPECIFIC_T_AGOS_13           13
#define DIS204_ENTITY_SPECIFIC_T_AGOS_14           14
#define DIS204_ENTITY_SPECIFIC_T_AGOS_15           15
#define DIS204_ENTITY_SPECIFIC_T_AGOS_16           16
#define DIS204_ENTITY_SPECIFIC_T_AGOS_17           17
#define DIS204_ENTITY_SPECIFIC_T_AGOS_18           18
#define DIS204_ENTITY_SUBCATEGORY_SWATH_S_CLASS           2
#define DIS204_ENTITY_SPECIFIC_T_AGOS_19           1
#define DIS204_ENTITY_SPECIFIC_T_AGOS_20           2
#define DIS204_ENTITY_SPECIFIC_T_AGOS_21           3
#define DIS204_ENTITY_SPECIFIC_T_AGOS_22           4
#define DIS204_ENTITY_SUBCATEGORY_SWATH_L_CLASS           3
#define DIS204_ENTITY_SPECIFIC_T_AGOS_23           1
#define DIS204_ENTITY_CATEGORY_FAST_COMBAT_SUPPORT_SHIP           60
#define DIS204_ENTITY_SUBCATEGORY_SACRAMENTO_CLASS           1
#define DIS204_ENTITY_SPECIFIC_AOE1           1
#define DIS204_ENTITY_SPECIFIC_AOE2           2
#define DIS204_ENTITY_SPECIFIC_AOE3           3
#define DIS204_ENTITY_SPECIFIC_AOE4           4
#define DIS204_ENTITY_SUBCATEGORY_SUPPLY_CLASS           2
#define DIS204_ENTITY_SPECIFIC_AOE6           1
#define DIS204_ENTITY_SPECIFIC_AOE7           2
#define DIS204_ENTITY_SPECIFIC_AOE8           3 /* Subsurface Domain -- */
 /* U.K. -- */
#define DIS204_ENTITY_SUBCATEGORY_VANGUARD_CLASS           1
#define DIS204_ENTITY_SUBCATEGORY_RESOLUTION_CLASS           2
#define DIS204_ENTITY_SUBCATEGORY_W_CLASS           3
#define DIS204_ENTITY_SUBCATEGORY_TRAFALGAR_CLASS           4
#define DIS204_ENTITY_SUBCATEGORY_SWIFTSURE_CLASS           5
#define DIS204_ENTITY_SUBCATEGORY_VALIANT_CLASS           6
#define DIS204_ENTITY_SUBCATEGORY_CHURCHILL_CLASS           7
#define DIS204_ENTITY_SUBCATEGORY_UPHOLDER_CLASS           8
#define DIS204_ENTITY_SUBCATEGORY_OBERON_CLASS           9 /* France -- */
#define DIS204_ENTITY_SUBCATEGORY_LE_TRIOMPHANT_CLASS           1
#define DIS204_ENTITY_SUBCATEGORY_L_INFLEXIBLE_CLASS           2
#define DIS204_ENTITY_SUBCATEGORY_LE_REDOUBTABLE_CLASS           3
#define DIS204_ENTITY_SUBCATEGORY_RUBIS_CLASS           4
#define DIS204_ENTITY_SUBCATEGORY_AGOSTA_CLASS           5
#define DIS204_ENTITY_SUBCATEGORY_DAPHNE_CLASS           6
#define DIS204_ENTITY_SUBCATEGORY_NARVAL_CLASS           7
#define DIS204_ENTITY_CATEGORY_STRATEGIC_MISSILE_SUBMARINE           1
     /* U.S.A. -- */
#define DIS204_ENTITY_SUBCATEGORY_OHIO_CLASS           1
#define DIS204_ENTITY_SPECIFIC_SSBN_726           1
#define DIS204_ENTITY_SPECIFIC_SSBN_727           2
#define DIS204_ENTITY_SPECIFIC_SSBN_728           3
#define DIS204_ENTITY_SPECIFIC_SSBN_729           4
#define DIS204_ENTITY_SPECIFIC_SSBN_730           5
#define DIS204_ENTITY_SPECIFIC_SSBN_731           6
#define DIS204_ENTITY_SPECIFIC_SSBN_732           7
#define DIS204_ENTITY_SPECIFIC_SSBN_733           8
#define DIS204_ENTITY_SUBCATEGORY_LAFAYETTE_CLASS           2
#define DIS204_ENTITY_SPECIFIC_SSBN_616           1
#define DIS204_ENTITY_SPECIFIC_SSBN_617           2
#define DIS204_ENTITY_SPECIFIC_SSBN_619           3
#define DIS204_ENTITY_SPECIFIC_SSBN_620           4
#define DIS204_ENTITY_SPECIFIC_SSBN_622           5
#define DIS204_ENTITY_SPECIFIC_SSBN_623           6
#define DIS204_ENTITY_SPECIFIC_SSBN_624           7
#define DIS204_ENTITY_SPECIFIC_SSBN_625           8
#define DIS204_ENTITY_SPECIFIC_SSBN_626           9
#define DIS204_ENTITY_SPECIFIC_SSBN_627           10
#define DIS204_ENTITY_SPECIFIC_SSBN_628           11
#define DIS204_ENTITY_SPECIFIC_SSBN_629           12
#define DIS204_ENTITY_SPECIFIC_SSBN_630           13
#define DIS204_ENTITY_SPECIFIC_SSBN_631           14
#define DIS204_ENTITY_SPECIFIC_SSBN_632           15
#define DIS204_ENTITY_SPECIFIC_SSBN_633           16
#define DIS204_ENTITY_SPECIFIC_SSBN_634           17
#define DIS204_ENTITY_SPECIFIC_SSBN_635           18
#define DIS204_ENTITY_SPECIFIC_SSBN_636           19
#define DIS204_ENTITY_SPECIFIC_SSBN_640           20
#define DIS204_ENTITY_SPECIFIC_SSBN_641           21
#define DIS204_ENTITY_SPECIFIC_SSBN_642           22
#define DIS204_ENTITY_SPECIFIC_SSBN_643           23
#define DIS204_ENTITY_SPECIFIC_SSBN_644           24
#define DIS204_ENTITY_SPECIFIC_SSBN_645           25
#define DIS204_ENTITY_SPECIFIC_SSBN_654           26
#define DIS204_ENTITY_SPECIFIC_SSBN_655           27
#define DIS204_ENTITY_SPECIFIC_SSBN_656           28
#define DIS204_ENTITY_SPECIFIC_SSBN_657           29
#define DIS204_ENTITY_SPECIFIC_SSBN_658           30
#define DIS204_ENTITY_SPECIFIC_SSBN_659           31 /* U.S.S.R. -- */
#define DIS204_ENTITY_SUBCATEGORY_TYPHOON_CLASS           1
#define DIS204_ENTITY_SUBCATEGORY_DELTA_IV_CLASS           2
#define DIS204_ENTITY_SUBCATEGORY_DELTA_III_CLASS           3
#define DIS204_ENTITY_SUBCATEGORY_DELTA_II_CLASS           4
#define DIS204_ENTITY_SUBCATEGORY_DELTA_I_CLASS           5
#define DIS204_ENTITY_SUBCATEGORY_YANKEE_II_CLASS           6
#define DIS204_ENTITY_SUBCATEGORY_YANKEE_I_CLASS           7
#define DIS204_ENTITY_SUBCATEGORY_HOTEL_III_CLASS           8
#define DIS204_ENTITY_SUBCATEGORY_HOTEL_II_CLASS           9
#define DIS204_ENTITY_SUBCATEGORY_GOLF_V_CLASS           10
#define DIS204_ENTITY_SUBCATEGORY_GOLF_II_CLASS           11
#define DIS204_ENTITY_CATEGORY_ATTACK_SUBMARINE           2 /* U.S.A. -- */
#define DIS204_ENTITY_SUBCATEGORY_LOS_ANGELES_CLASS           1
#define DIS204_ENTITY_SPECIFIC_SSN_688           1
#define DIS204_ENTITY_SPECIFIC_SSN_689           2
#define DIS204_ENTITY_SPECIFIC_SSN_690           3
#define DIS204_ENTITY_SPECIFIC_SSN_691           4
#define DIS204_ENTITY_SPECIFIC_SSN_692           5
#define DIS204_ENTITY_SPECIFIC_SSN_693           6
#define DIS204_ENTITY_SPECIFIC_SSN_694           7
#define DIS204_ENTITY_SPECIFIC_SSN_695           8
#define DIS204_ENTITY_SPECIFIC_SSN_696           9
#define DIS204_ENTITY_SPECIFIC_SSN_697           10
#define DIS204_ENTITY_SPECIFIC_SSN_698           11
#define DIS204_ENTITY_SPECIFIC_SSN_699           12
#define DIS204_ENTITY_SPECIFIC_SSN_700           13
#define DIS204_ENTITY_SPECIFIC_SSN_701           14
#define DIS204_ENTITY_SPECIFIC_SSN_702           15
#define DIS204_ENTITY_SPECIFIC_SSN_703           16
#define DIS204_ENTITY_SPECIFIC_SSN_704           17
#define DIS204_ENTITY_SPECIFIC_SSN_705           18
#define DIS204_ENTITY_SPECIFIC_SSN_706           19
#define DIS204_ENTITY_SPECIFIC_SSN_707           20
#define DIS204_ENTITY_SPECIFIC_SSN_708           21
#define DIS204_ENTITY_SPECIFIC_SSN_709           22
#define DIS204_ENTITY_SPECIFIC_SSN_710           23
#define DIS204_ENTITY_SPECIFIC_SSN_711           24
#define DIS204_ENTITY_SPECIFIC_SSN_712           25
#define DIS204_ENTITY_SPECIFIC_SSN_713           26
#define DIS204_ENTITY_SPECIFIC_SSN_714           27
#define DIS204_ENTITY_SPECIFIC_SSN_715           28
#define DIS204_ENTITY_SPECIFIC_SSN_716           29
#define DIS204_ENTITY_SPECIFIC_SSN_717           30
#define DIS204_ENTITY_SPECIFIC_SSN_718           31
#define DIS204_ENTITY_SPECIFIC_SSN_719           32
#define DIS204_ENTITY_SPECIFIC_SSN_720           33
#define DIS204_ENTITY_SPECIFIC_SSN_750           34
#define DIS204_ENTITY_SUBCATEGORY_GLEN_P_LIPSCOMB_CLASS           2
#define DIS204_ENTITY_SPECIFIC_SSN_685           1
#define DIS204_ENTITY_SUBCATEGORY_NARWHAL_CLASS           3
#define DIS204_ENTITY_SPECIFIC_SSN_671           1
#define DIS204_ENTITY_SUBCATEGORY_STURGEON_CLASS           4
#define DIS204_ENTITY_SPECIFIC_SSN_637           1
#define DIS204_ENTITY_SPECIFIC_SSN_638           2
#define DIS204_ENTITY_SPECIFIC_SSN_639           3
#define DIS204_ENTITY_SPECIFIC_SSN_646           4
#define DIS204_ENTITY_SPECIFIC_SSN_647           5
#define DIS204_ENTITY_SPECIFIC_SSN_648           6
#define DIS204_ENTITY_SPECIFIC_SSN_649           7
#define DIS204_ENTITY_SPECIFIC_SSN_650           8
#define DIS204_ENTITY_SPECIFIC_SSN_651           9
#define DIS204_ENTITY_SPECIFIC_SSN_652           10
#define DIS204_ENTITY_SPECIFIC_SSN_653           11
#define DIS204_ENTITY_SPECIFIC_SSN_660           12
#define DIS204_ENTITY_SPECIFIC_SSN_661           13
#define DIS204_ENTITY_SPECIFIC_SSN_662           14
#define DIS204_ENTITY_SPECIFIC_SSN_663           15
#define DIS204_ENTITY_SPECIFIC_SSN_664           16
#define DIS204_ENTITY_SPECIFIC_SSN_665           17
#define DIS204_ENTITY_SPECIFIC_SSN_666           18
#define DIS204_ENTITY_SPECIFIC_SSN_667           19
#define DIS204_ENTITY_SPECIFIC_SSN_668           20
#define DIS204_ENTITY_SPECIFIC_SSN_669           21
#define DIS204_ENTITY_SPECIFIC_SSN_670           22
#define DIS204_ENTITY_SPECIFIC_SSN_672           23
#define DIS204_ENTITY_SPECIFIC_SSN_673           24
#define DIS204_ENTITY_SPECIFIC_SSN_674           25
#define DIS204_ENTITY_SPECIFIC_SSN_675           26
#define DIS204_ENTITY_SPECIFIC_SSN_676           27
#define DIS204_ENTITY_SPECIFIC_SSN_677           28
#define DIS204_ENTITY_SPECIFIC_SSN_678           29
#define DIS204_ENTITY_SPECIFIC_SSN_679           30
#define DIS204_ENTITY_SPECIFIC_SSN_680           31
#define DIS204_ENTITY_SPECIFIC_SSN_681           32
#define DIS204_ENTITY_SPECIFIC_SSN_682           33
#define DIS204_ENTITY_SPECIFIC_SSN_683           34
#define DIS204_ENTITY_SPECIFIC_SSN_684           35
#define DIS204_ENTITY_SPECIFIC_SSN_686           36
#define DIS204_ENTITY_SPECIFIC_SSN_687           37
#define DIS204_ENTITY_SUBCATEGORY_PERMIT_CLASS           5
#define DIS204_ENTITY_SPECIFIC_SSN_594           1
#define DIS204_ENTITY_SPECIFIC_SSN_595           2
#define DIS204_ENTITY_SPECIFIC_SSN_596           3
#define DIS204_ENTITY_SPECIFIC_SSN_603           4
#define DIS204_ENTITY_SPECIFIC_SSN_604           5
#define DIS204_ENTITY_SPECIFIC_SSN_605           6
#define DIS204_ENTITY_SPECIFIC_SSN_606           7
#define DIS204_ENTITY_SPECIFIC_SSN_607           8
#define DIS204_ENTITY_SPECIFIC_SSN_612           9
#define DIS204_ENTITY_SPECIFIC_SSN_613           10
#define DIS204_ENTITY_SPECIFIC_SSN_614           11
#define DIS204_ENTITY_SPECIFIC_SSN_615           12
#define DIS204_ENTITY_SPECIFIC_SSN_621           13
#define DIS204_ENTITY_SUBCATEGORY_ETHAN_ALLEN_CLASS           6
#define DIS204_ENTITY_SPECIFIC_SSN_609           1
#define DIS204_ENTITY_SPECIFIC_SSN_610           2
#define DIS204_ENTITY_SPECIFIC_SSN_611           3
#define DIS204_ENTITY_SPECIFIC_SSN_618           4
#define DIS204_ENTITY_SUBCATEGORY_SKIPJACK_CLASS           7
#define DIS204_ENTITY_SPECIFIC_SSN_585           1
#define DIS204_ENTITY_SPECIFIC_SSN_588           2
#define DIS204_ENTITY_SPECIFIC_SSN_590           3
#define DIS204_ENTITY_SPECIFIC_SSN_591           4
#define DIS204_ENTITY_SPECIFIC_SSN_592           5
#define DIS204_ENTITY_SUBCATEGORY_BARBEL_CLASS           8
#define DIS204_ENTITY_SPECIFIC_SSN_580           1
#define DIS204_ENTITY_SPECIFIC_SSN_581           2
#define DIS204_ENTITY_SPECIFIC_SSN_582           3
#define DIS204_ENTITY_SUBCATEGORY_GEORGE_WASHINGTON_CLASS           9
#define DIS204_ENTITY_SPECIFIC_SSN_598           1
#define DIS204_ENTITY_SPECIFIC_SSN_599           2
#define DIS204_ENTITY_SPECIFIC_SSN_601           3
#define DIS204_ENTITY_SUBCATEGORY_TULLIBEE_CLASS           10
#define DIS204_ENTITY_SPECIFIC_SSN_597           1
#define DIS204_ENTITY_SUBCATEGORY_TRITON_CLASS           11
#define DIS204_ENTITY_SPECIFIC_SSN_586           1
#define DIS204_ENTITY_SUBCATEGORY_SKATE_CLASS           12
#define DIS204_ENTITY_SPECIFIC_SSN_578           1
#define DIS204_ENTITY_SPECIFIC_SSN_579           2
#define DIS204_ENTITY_SPECIFIC_SSN_583           3
#define DIS204_ENTITY_SPECIFIC_SSN_584           4
#define DIS204_ENTITY_SUBCATEGORY_SEAWOLF_CLASS           13
#define DIS204_ENTITY_SPECIFIC_SSN_575           1 /* U.S.S.R. -- */
#define DIS204_ENTITY_SUBCATEGORY_OSCAR_II_CLASS           1
#define DIS204_ENTITY_SUBCATEGORY_OSCAR_I_CLASS           2
#define DIS204_ENTITY_SUBCATEGORY_PAPA_CLASS           3
#define DIS204_ENTITY_SUBCATEGORY_CHARLIE_II_CLASS           4
#define DIS204_ENTITY_SUBCATEGORY_CHARLIE_I_CLASS           5
#define DIS204_ENTITY_SUBCATEGORY_ECHO_II_CLASS           6
#define DIS204_ENTITY_SUBCATEGORY_ECHO_I_CLASS           7
#define DIS204_ENTITY_SUBCATEGORY_VICTOR_II_CLASS           8
#define DIS204_ENTITY_SUBCATEGORY_YANKEE_CONVERSION_CLASS           9
#define DIS204_ENTITY_SUBCATEGORY_YANKEE_NOTCH_CLASS           10
#define DIS204_ENTITY_SUBCATEGORY_WHISKEY_LONG_BIN_CLASS           11
#define DIS204_ENTITY_SUBCATEGORY_JULIETT_CLASS           12
#define DIS204_ENTITY_SUBCATEGORY_SIERRA_CLASS           13
#define DIS204_ENTITY_SUBCATEGORY_ALFA_CLASS           14
#define DIS204_ENTITY_SUBCATEGORY_IMPROVED_ALFA_CLASS           15
#define DIS204_ENTITY_SUBCATEGORY_VICTOR_III_CLASS           16
#define DIS204_ENTITY_SUBCATEGORY_VICTOR_I_CLASS           17
#define DIS204_ENTITY_SUBCATEGORY_NOVEMBER_CLASS           18
#define DIS204_ENTITY_SUBCATEGORY_KILO_CLASS           19
#define DIS204_ENTITY_SUBCATEGORY_TANGO_CLASS           20
#define DIS204_ENTITY_SUBCATEGORY_FOXTROT_CLASS           21
#define DIS204_ENTITY_SUBCATEGORY_ROMEO_CLASS           22
#define DIS204_ENTITY_SUBCATEGORY_WHISKEY_CLASS           23
#define DIS204_ENTITY_SUBCATEGORY_AKULA_CLASS           24
#define DIS204_ENTITY_SUBCATEGORY_MIKE_CLASS           25
#define DIS204_ENTITY_SUBCATEGORY_ZULU_IV_CLASS           26
#define DIS204_ENTITY_CATEGORY_RESEARCH_MISC_SUBMARINE           3
#define DIS204_ENTITY_SUBCATEGORY_DARTER_CLASS           1
#define DIS204_ENTITY_SPECIFIC_SS_576           1
#define DIS204_ENTITY_SUBCATEGORY_DOLPHIN_CLASS           2
#define DIS204_ENTITY_SPECIFIC_AGSS_555           1
#define DIS204_ENTITY_CATEGORY_UNMANNED_UNDERWATER_VEHICLE           4
#define DIS204_ENTITY_SUBCATEGORY_MINE_SEARCH           1
#define DIS204_ENTITY_SPECIFIC_C_S_DRAPER_LAB_UUV           1 /* Space Domain -- */
#define DIS204_ENTITY_CATEGORY_MANNED_PLATFORM           1
#define DIS204_ENTITY_SUBCATEGORY_SPACE_SHUTTLE           1 /* U.S.A. -- */
#define DIS204_ENTITY_SPECIFIC_ATLANTIS           1
#define DIS204_ENTITY_SPECIFIC_DISCOVERY           2
#define DIS204_ENTITY_SPECIFIC_COLUMBIA           3
#define DIS204_ENTITY_SPECIFIC_ENDEAVOR           4 /* U.S.S.R. -- */
#define DIS204_ENTITY_SPECIFIC_BURAN           1
#define DIS204_ENTITY_SUBCATEGORY_SPACE_STATION           1 /* U.S.A. -- */
#define DIS204_ENTITY_SPECIFIC_FREEDOM           1 /* U.S.S.R. -- */
#define DIS204_ENTITY_SPECIFIC_MIR           1
#define DIS204_ENTITY_CATEGORY_UNMANNED_PLATFORM           2
#define DIS204_ENTITY_SUBCATEGORY_SATELLITE           1
     /* Section 6 Munitions Specifics-- */
#define DIS204_MUNITION_CATEGORY_OTHER           0
#define DIS204_MUNITION_CATEGORY_GUIDED           1
#define DIS204_MUNITION_CATEGORY_BALLISTIC           2
#define DIS204_MUNITION_CATEGORY_FIXED           3 /* Other Domain -- */
 /* U.S.A. -- */
#define DIS204_MUNITION_SUBCATEGORY_FRAGMENTS           1 /* Anti-Air Domain -- */
 /* U.S.A. -- */
#define DIS204_MUNITION_SUBCATEGORY_SIDEWINDER           1
#define DIS204_MUNITION_SPECIFIC_AIM_9M_SIDEWINDER           1
#define DIS204_MUNITION_SUBCATEGORY_AMRAAM           2
#define DIS204_MUNITION_SUBCATEGORY_ADSM           3
#define DIS204_MUNITION_SUBCATEGORY_FALCON           4
#define DIS204_MUNITION_SUBCATEGORY_CHAPARRAL           5
#define DIS204_MUNITION_SUBCATEGORY_HAWK_MIM_23B           6
#define DIS204_MUNITION_SUBCATEGORY_MLMS           7
#define DIS204_MUNITION_SUBCATEGORY_PHOENIX           8
#define DIS204_MUNITION_SUBCATEGORY_RAPIER_UK           9
#define DIS204_MUNITION_SUBCATEGORY_REDEYE           10
#define DIS204_MUNITION_SUBCATEGORY_ROLAND_USA           11
#define DIS204_MUNITION_SUBCATEGORY_SEA_SPARROW           12
#define DIS204_MUNITION_SUBCATEGORY_SPARROW           13
#define DIS204_MUNITION_SUBCATEGORY_RIM_66_67           14
#define DIS204_MUNITION_SUBCATEGORY_STINGER           15
#define DIS204_MUNITION_SUBCATEGORY_PATRIOT_MIM_104           16
#define DIS204_MUNITION_SUBCATEGORY_TARTAR           17
#define DIS204_MUNITION_SUBCATEGORY_TERRIER           18
#define DIS204_MUNITION_SUBCATEGORY_ADATS           19
#define DIS204_MUNITION_SUBCATEGORY_THADD           20 /* U.S.S.R. -- */
#define DIS204_MUNITION_SUBCATEGORY_AA_1_ALKALI           1
#define DIS204_MUNITION_SUBCATEGORY_AA_2_ATOLL           2
#define DIS204_MUNITION_SUBCATEGORY_AA_3_ANAB           3
#define DIS204_MUNITION_SUBCATEGORY_AA_4_AWL           4
#define DIS204_MUNITION_SUBCATEGORY_AA_5_ASH           5
#define DIS204_MUNITION_SUBCATEGORY_AA_6_ACRID           6
#define DIS204_MUNITION_SUBCATEGORY_AA_7_APEX           7
#define DIS204_MUNITION_SUBCATEGORY_AA_8_APHID           8
#define DIS204_MUNITION_SUBCATEGORY_AA_9_AMOS           9
#define DIS204_MUNITION_SUBCATEGORY_AA_10_ALAMO           10
#define DIS204_MUNITION_SUBCATEGORY_AA_11_ARCHER           11
#define DIS204_MUNITION_SUBCATEGORY_SA_1_GUILD           12
#define DIS204_MUNITION_SUBCATEGORY_SA_2_GUIDELINE           13
#define DIS204_MUNITION_SUBCATEGORY_SA_3_GOA           14
#define DIS204_MUNITION_SUBCATEGORY_SA_4_GANEF           15
#define DIS204_MUNITION_SUBCATEGORY_SA_5_GAMMON           16
#define DIS204_MUNITION_SUBCATEGORY_SA_6_GAINFUL           17
#define DIS204_MUNITION_SUBCATEGORY_SA_7_GRAIL           18
#define DIS204_MUNITION_SUBCATEGORY_SA_8_GECKO           19
#define DIS204_MUNITION_SUBCATEGORY_SA_9_GASKIN           20
#define DIS204_MUNITION_SUBCATEGORY_SA_10_GRUMBLE           21
#define DIS204_MUNITION_SUBCATEGORY_SA_11_GADFLY           22
#define DIS204_MUNITION_SUBCATEGORY_SA_12_GLADIATOR           23
#define DIS204_MUNITION_SUBCATEGORY_SA_13_GOPHER           24
#define DIS204_MUNITION_SUBCATEGORY_SA_14_GREMLIN           25
#define DIS204_MUNITION_SUBCATEGORY_SA_15           26
#define DIS204_MUNITION_SUBCATEGORY_SA_16_MAN_PORTABLE_SAM           27
#define DIS204_MUNITION_SUBCATEGORY_SA_N_1_GOA           28
#define DIS204_MUNITION_SUBCATEGORY_SA_N_2_GUIDELINE           29
#define DIS204_MUNITION_SUBCATEGORY_SA_N_3_GOBLET           30
#define DIS204_MUNITION_SUBCATEGORY_SA_N_4           31
#define DIS204_MUNITION_SUBCATEGORY_SA_N_5           32
#define DIS204_MUNITION_SUBCATEGORY_SA_N_6           33
#define DIS204_MUNITION_SUBCATEGORY_SA_N_7           34
#define DIS204_MUNITION_SUBCATEGORY_SA_N_9           35
#define DIS204_MUNITION_SUBCATEGORY_ZSU_30_AAA           2 /* U.K. -- */
#define DIS204_MUNITION_SUBCATEGORY_BLOODHOUND_MK2           1
#define DIS204_MUNITION_SUBCATEGORY_RAPIER           2
#define DIS204_MUNITION_SUBCATEGORY_SEACAT_TIGERCAT           3
#define DIS204_MUNITION_SUBCATEGORY_BLOWPIPE           4
#define DIS204_MUNITION_SUBCATEGORY_JAVELIN           5
#define DIS204_MUNITION_SUBCATEGORY_STAR_STREAK           6
#define DIS204_MUNITION_SUBCATEGORY_SEA_DART           7
#define DIS204_MUNITION_SUBCATEGORY_SEA_WOLF           8
#define DIS204_MUNITION_SUBCATEGORY_SKY_FLASH           9
#define DIS204_MUNITION_SUBCATEGORY_FIRE_STREAK           10
#define DIS204_MUNITION_SUBCATEGORY_RED_TOP           11 /* France -- */
#define DIS204_MUNITION_SUBCATEGORY_ASTER_15           1
#define DIS204_MUNITION_SUBCATEGORY_ASTER_30           2
#define DIS204_MUNITION_SUBCATEGORY_CROTALE           3
#define DIS204_MUNITION_SUBCATEGORY_ROLAND_FRANCE           4
#define DIS204_MUNITION_SUBCATEGORY_MISTRAL           5
#define DIS204_MUNITION_SUBCATEGORY_MASURCA           6
#define DIS204_MUNITION_SUBCATEGORY_MICA_MISSILE           7
#define DIS204_MUNITION_SUBCATEGORY_R_530_SIDEWINDER           8
#define DIS204_MUNITION_SUBCATEGORY_R_550_MAGIC           9
#define DIS204_MUNITION_SUBCATEGORY_SUPER_530           10 /* Germany -- */
#define DIS204_MUNITION_SUBCATEGORY_ROLAND_GERMANY           1
     /* Anti-armor Domain -- */
 /* U.S.A. -- */
#define DIS204_MUNITION_SUBCATEGORY_TOW           1
#define DIS204_MUNITION_SUBCATEGORY_M47_DRAGON           2
#define DIS204_MUNITION_SUBCATEGORY_HELLFIRE           3
#define DIS204_MUNITION_SUBCATEGORY_MAVERICK           4
#define DIS204_MUNITION_SPECIFIC_MAVERICK_AGM_65D           1
#define DIS204_MUNITION_SUBCATEGORY_COPPERHEAD           5
#define DIS204_MUNITION_SUBCATEGORY_AAWS_M           6
#define DIS204_MUNITION_SUBCATEGORY_LOSAT           7
#define DIS204_MUNITION_SUBCATEGORY_FOGM           8
#define DIS204_MUNITION_SUBCATEGORY_25MM_US           1
#define DIS204_MUNITION_SUBCATEGORY_84MM           2
#define DIS204_MUNITION_SUBCATEGORY_105MM_ANTI_ARMOR           3
#define DIS204_MUNITION_SUBCATEGORY_120MM_ANTI_ARMOR           4
#define DIS204_MUNITION_SUBCATEGORY_155MM_ANTI_ARMOR           5
#define DIS204_MUNITION_SUBCATEGORY_227MM_ROCKET_ANTI_ARMOR           6
     /* U.S.S.R. -- */
#define DIS204_MUNITION_SUBCATEGORY_RPG_7VAT_ROCKET_LAUNCHER           1
#define DIS204_MUNITION_SUBCATEGORY_AS_8           2
#define DIS204_MUNITION_SUBCATEGORY_AT_1_SNAPPER           3
#define DIS204_MUNITION_SUBCATEGORY_AT_2_SWATTER           4
#define DIS204_MUNITION_SUBCATEGORY_AT_3_SAGGER           5
#define DIS204_MUNITION_SUBCATEGORY_AT_4_SPIGOT           6
#define DIS204_MUNITION_SUBCATEGORY_AT_5_SPANDREL           7
#define DIS204_MUNITION_SUBCATEGORY_AT_6_SPIRAL           8
#define DIS204_MUNITION_SUBCATEGORY_AT_7_SAXHORN           9
#define DIS204_MUNITION_SUBCATEGORY_AT_8_SONGSTER           10
#define DIS204_MUNITION_SUBCATEGORY_RPG_16           11
#define DIS204_MUNITION_SUBCATEGORY_23MM           1
#define DIS204_MUNITION_SUBCATEGORY_30MM_USSR           2
#define DIS204_MUNITION_SUBCATEGORY_73MM           3
#define DIS204_MUNITION_SUBCATEGORY_76MM_USSR           4
#define DIS204_MUNITION_SUBCATEGORY_85MM           5
#define DIS204_MUNITION_SUBCATEGORY_115MM           6
#define DIS204_MUNITION_SUBCATEGORY_125MM_ANTI_ARMOR           7
#define DIS204_MUNITION_SUBCATEGORY_135MM           8 /* U.K. -- */
#define DIS204_MUNITION_SUBCATEGORY_MILAN_MISSILE_UK           1
#define DIS204_MUNITION_SUBCATEGORY_SWINGFIRE_MISSILE           2
#define DIS204_MUNITION_SUBCATEGORY_MERLIN           3
#define DIS204_MUNITION_SUBCATEGORY_FI_TOW           4
#define DIS204_MUNITION_SUBCATEGORY_VIGILANT_MISSILE           5
#define DIS204_MUNITION_SUBCATEGORY_HOT_MISSILE_UK           6 /* France -- */
#define DIS204_MUNITION_SUBCATEGORY_SS_11_FRANCE           1
#define DIS204_MUNITION_SUBCATEGORY_ERYX_MISSILE           2
#define DIS204_MUNITION_SUBCATEGORY_HOT_MISSILE_FRANCE           3
#define DIS204_MUNITION_SUBCATEGORY_MILAN_MISSILE_FRANCE           4
#define DIS204_MUNITION_SUBCATEGORY_ACL_STRIM           5
#define DIS204_MUNITION_SUBCATEGORY_ENTAC           6 /* Germany -- */
#define DIS204_MUNITION_SUBCATEGORY_MILAN_MISSILE_GERMANY           1
#define DIS204_MUNITION_SUBCATEGORY_HOT_MISSILE_GERMANY           2
#define DIS204_MUNITION_SUBCATEGORY_TOW_MISSILE           3
#define DIS204_MUNITION_SUBCATEGORY_PARS_3_MISSILE           4
#define DIS204_MUNITION_SUBCATEGORY_110MM_ROCKET           1
#define DIS204_MUNITION_SUBCATEGORY_MIFF_ANTI_TANK_MINE           1
#define DIS204_MUNITION_SUBCATEGORY_KB44_ANTI_TANK_MINE           2
#define DIS204_MUNITION_SUBCATEGORY_ANTI_TANK_MINE           3
     /* Anti-Guided Munition Domain -- */
 /* U.S.A. -- */
#define DIS204_MUNITION_SUBCATEGORY_DECOYS           1
#define DIS204_MUNITION_SPECIFIC_ADC_MK_1           2
#define DIS204_MUNITION_SPECIFIC_ADC_MK_2           3
#define DIS204_MUNITION_SPECIFIC_NAE           4 /* U.S.S.R. -- */
#define DIS204_MUNITION_SUBCATEGORY_ABM_1B           1
#define DIS204_MUNITION_SUBCATEGORY_SH_08           2
#define DIS204_MUNITION_SUBCATEGORY_DECOYS_TBD           3
#define DIS204_MUNITION_SPECIFIC_UC_1S           1
#define DIS204_MUNITION_SPECIFIC_UC_2S           2
#define DIS204_MUNITION_SPECIFIC_UC_P_1S           3 /* Anti-Radar Domain -- */
 /* U.S.A. -- */
#define DIS204_MUNITION_SUBCATEGORY_HARM_AGM_88A           1
#define DIS204_MUNITION_SUBCATEGORY_SHRIKE_AGM_45           2
#define DIS204_MUNITION_SUBCATEGORY_STANDARD_AGM_78           3
#define DIS204_MUNITION_SUBCATEGORY_SIDEARM_AGM_122           4
#define DIS204_MUNITION_SUBCATEGORY_TACIT_RAINBOW           5 /* U.S.S.R. -- */
#define DIS204_MUNITION_SUBCATEGORY_AS_4_KITCHEN_ANTI_RADAR           1
#define DIS204_MUNITION_SUBCATEGORY_AS_9           2
#define DIS204_MUNITION_SUBCATEGORY_AS_12_KEGLER           3 /* U.K. -- */
#define DIS204_MUNITION_SUBCATEGORY_ALARM           1 /* France -- */
#define DIS204_MUNITION_SUBCATEGORY_ARMAT           1 /* Anti-Satellite Domain -- */
#define DIS204_MUNITION_SUBCATEGORY_ASAT           1 /* Anti-Ship Domain -- */
 /* U.S.A. -- */
#define DIS204_MUNITION_SUBCATEGORY_HARPOON_ARM_RGM_84A           1
#define DIS204_MUNITION_SUBCATEGORY_HARPOON_ARM_RGM_84B           2
#define DIS204_MUNITION_SUBCATEGORY_HARPOON_ARM_RGM_84C           3
#define DIS204_MUNITION_SUBCATEGORY_HARPOON_ARM_RGM_84D           4
#define DIS204_MUNITION_SUBCATEGORY_MK37E_TORPEDO_ANTI_SHIP           5
#define DIS204_MUNITION_SUBCATEGORY_MK48_TORPEDO_ANTI_SHIP           6
#define DIS204_MUNITION_SUBCATEGORY_MK50_TORPEDO           7
#define DIS204_MUNITION_SUBCATEGORY_DEADEYE           8
#define DIS204_MUNITION_SUBCATEGORY_PENGUIN           9 /* U.S.S.R. -- */
#define DIS204_MUNITION_SUBCATEGORY_AS_2_KIPPER           1
#define DIS204_MUNITION_SUBCATEGORY_AS_4_KITCHEN_AS           2
#define DIS204_MUNITION_SUBCATEGORY_AS_5_KITCHEN           3
#define DIS204_MUNITION_SUBCATEGORY_AS_6_KINGFISH           4
#define DIS204_MUNITION_SUBCATEGORY_AS_13           5
#define DIS204_MUNITION_SUBCATEGORY_AS_14_KEDGE_ANTI_SHIP           6
#define DIS204_MUNITION_SUBCATEGORY_AS_15_USSR_AS           7
#define DIS204_MUNITION_SUBCATEGORY_SS_N_2_STYX           8
#define DIS204_MUNITION_SUBCATEGORY_SS_N_7_STARBRIGHT           9
#define DIS204_MUNITION_SUBCATEGORY_SS_N_9_SIREN           10
#define DIS204_MUNITION_SUBCATEGORY_SS_N_12_SANDBOX           11
#define DIS204_MUNITION_SUBCATEGORY_SS_N_19_SHIPWRECK           12
#define DIS204_MUNITION_SUBCATEGORY_SS_N_22_SUNBURN           13
#define DIS204_MUNITION_SUBCATEGORY_SS_N_3_SHADDOCK           14
#define DIS204_MUNITION_SUBCATEGORY_SSC_2B_SAMLET_CRUISE           15
#define DIS204_MUNITION_SUBCATEGORY_SSC_1B_SEPAL           16
#define DIS204_MUNITION_SUBCATEGORY_553MM_TORPEDO           17
#define DIS204_MUNITION_SUBCATEGORY_406MM_TORPEDO_ANTI_SHIP           18
#define DIS204_MUNITION_SUBCATEGORY_660MM_TORPEDO_ANTI_SHIP           19
     /* U.K. -- */
#define DIS204_MUNITION_SUBCATEGORY_EXCALIBUR           1
#define DIS204_MUNITION_SUBCATEGORY_SEA_EAGLE           2
#define DIS204_MUNITION_SUBCATEGORY_SEA_SKUA           3
#define DIS204_MUNITION_SUBCATEGORY_MARTEL           4
#define DIS204_MUNITION_SUBCATEGORY_SPEAR_FISH_TORPEDO_ANTI_SHIP           5
     /* France -- */
#define DIS204_MUNITION_SUBCATEGORY_EXOCET           1
#define DIS204_MUNITION_SUBCATEGORY_AS_11           2
#define DIS204_MUNITION_SUBCATEGORY_AS_12           3
#define DIS204_MUNITION_SUBCATEGORY_AS_15_FRANCE_AS           4
#define DIS204_MUNITION_SUBCATEGORY_AS_30           5
#define DIS204_MUNITION_SUBCATEGORY_AS_37_MARTEL           6
#define DIS204_MUNITION_SUBCATEGORY_ASMP           7
#define DIS204_MUNITION_SUBCATEGORY_OTOMAT           8
#define DIS204_MUNITION_SUBCATEGORY_E14_TORPEDO           9
#define DIS204_MUNITION_SUBCATEGORY_E15_TORPEDO           10
#define DIS204_MUNITION_SUBCATEGORY_F17_TORPEDO           11
#define DIS204_MUNITION_SUBCATEGORY_L_5_TORPEDO_ANTI_SHIP           12
#define DIS204_MUNITION_SUBCATEGORY_Z_16_TORPEDO           13 /* Italy -- */
#define DIS204_MUNITION_SUBCATEGORY_MANTA           1
#define DIS204_MUNITION_SPECIFIC_BOTTOM           1 /* Anti-Submarine Domain -- */
 /* U.S.A. -- */
#define DIS204_MUNITION_SUBCATEGORY_MK46_TORPEDO           1
#define DIS204_MUNITION_SUBCATEGORY_MK48_TORPEDO_ANTI_SUBMARINE           2
#define DIS204_MUNITION_SUBCATEGORY_M50_TORPEDO           3
#define DIS204_MUNITION_SUBCATEGORY_MK37E_TORPEDO_ANTI_SUBMARINE           4
#define DIS204_MUNITION_SUBCATEGORY_ASROC_RUR_5A           5
#define DIS204_MUNITION_SUBCATEGORY_CASW_SOW           6
#define DIS204_MUNITION_SUBCATEGORY_SUBROC_UUM_44A           7 /* U.S.S.R. -- */
#define DIS204_MUNITION_SUBCATEGORY_FRAS_1           1
#define DIS204_MUNITION_SUBCATEGORY_SSN_14_SILEX           2
#define DIS204_MUNITION_SUBCATEGORY_SSN_15_STARFISH           3
#define DIS204_MUNITION_SUBCATEGORY_SSN_16_STALLION           4
#define DIS204_MUNITION_SUBCATEGORY_533MM_TORPEDO           5
#define DIS204_MUNITION_SPECIFIC_ET_80A           1
#define DIS204_MUNITION_SPECIFIC_E_53_83           2
#define DIS204_MUNITION_SPECIFIC_E_53_71           3
#define DIS204_MUNITION_SUBCATEGORY_406MM_TORPEDO_ANTI_SUBMARINE           6
#define DIS204_MUNITION_SUBCATEGORY_660MM_TORPEDO_ANTI_SUBMARINE           7
     /* U.K. -- */
#define DIS204_MUNITION_SUBCATEGORY_TIGERFISH_TORPEDO           1
#define DIS204_MUNITION_SUBCATEGORY_SPEAR_FISH_TORPEDO_ANTI_SUBMARINE           2
#define DIS204_MUNITION_SUBCATEGORY_STING_RAY_TORPEDO           3
#define DIS204_MUNITION_SUBCATEGORY_MK_24_TORPEDO           4 /* France -- */
#define DIS204_MUNITION_SUBCATEGORY_MALAFON           1
#define DIS204_MUNITION_SUBCATEGORY_E_14_TORPEDO           2
#define DIS204_MUNITION_SUBCATEGORY_E_15_TORPEDO           3
#define DIS204_MUNITION_SUBCATEGORY_F_17_TORPEDO           4
#define DIS204_MUNITION_SUBCATEGORY_L_3_TORPEDO           5
#define DIS204_MUNITION_SUBCATEGORY_L_4_TORPEDO           6
#define DIS204_MUNITION_SUBCATEGORY_L_5_TORPEDO_ANTI_SUBMARINE           7
#define DIS204_MUNITION_SUBCATEGORY_MURENE_TORPEDO           8
     /* Anti-Personnel Domain -- */
 /* U.S.A. -- */
#define DIS204_MUNITION_SUBCATEGORY_5_56MM           1
#define DIS204_MUNITION_SUBCATEGORY_7_62MM_USA           2
#define DIS204_MUNITION_SUBCATEGORY_9_0MM_USA           3
#define DIS204_MUNITION_SUBCATEGORY_11_43MM           4
#define DIS204_MUNITION_SUBCATEGORY_12_7MM_USA           5
#define DIS204_MUNITION_SUBCATEGORY_M16_MINE           1
#define DIS204_MUNITION_SUBCATEGORY_CLAYMORE_MINE           2
#define DIS204_MUNITION_SUBCATEGORY_HEAVY_M15_AT_MINE           3
#define DIS204_MUNITION_SUBCATEGORY_NONMETALLIC_M19_AT_MINE           4
#define DIS204_MUNITION_SUBCATEGORY_HEAVY_M21_AT_MINE           5
#define DIS204_MUNITION_SUBCATEGORY_SCATTERABLE_M741_AT_MINE           6
#define DIS204_MUNITION_SUBCATEGORY_SCATTERABLE_M718_AT_MINE           7
#define DIS204_MUNITION_SUBCATEGORY_SCATTERABLE_M75_AT_MINE           8
#define DIS204_MUNITION_SUBCATEGORY_SCATTERABLE_M14_TOE_POPPER_AP_MINE           9
#define DIS204_MUNITION_SUBCATEGORY_SCATTERABLE_M731_AP_MINE           10
#define DIS204_MUNITION_SUBCATEGORY_SCATTERABLE_M692_AP_MINE           11
#define DIS204_MUNITION_SUBCATEGORY_SCATTERABLE_M74_AP_MINE           12
     /* U.S.S.R. -- */
#define DIS204_MUNITION_SUBCATEGORY_5_45MM           1
#define DIS204_MUNITION_SUBCATEGORY_7_62MM_USSR           2
#define DIS204_MUNITION_SUBCATEGORY_12_7MM_USSR           3
#define DIS204_MUNITION_SUBCATEGORY_14_5MM_ANTI_PERSONNEL           4
#define DIS204_MUNITION_SUBCATEGORY_WOODEN_TMD_B_AT_MINE           1
#define DIS204_MUNITION_SUBCATEGORY_WOODEN_YAM_5_AT_MINE           2
#define DIS204_MUNITION_SUBCATEGORY_TM_38_AT_MINE           3
#define DIS204_MUNITION_SUBCATEGORY_TM_44_AT_MINE           4
#define DIS204_MUNITION_SUBCATEGORY_TM_46_AT_BLAST_MINE           5
#define DIS204_MUNITION_SUBCATEGORY_TMN_46_AT_BLAST_MINE           6
#define DIS204_MUNITION_SUBCATEGORY_TM_57_AT_MINE           7
#define DIS204_MUNITION_SUBCATEGORY_TM_62M_MINE           8
#define DIS204_MUNITION_SUBCATEGORY_TMK_2_AT_SHAPED_CHARGE_MINE           9
#define DIS204_MUNITION_SUBCATEGORY_AREA_TYPE_POMZ_2_AP_FRAG_MINE           10
#define DIS204_MUNITION_SUBCATEGORY_OMZ_3_AP_FRAG_MINE           11
#define DIS204_MUNITION_SUBCATEGORY_MON_SERIES_AP_MINE           12
#define DIS204_MUNITION_SUBCATEGORY_PMN_AP_BLAST_MINE           13
#define DIS204_MUNITION_SUBCATEGORY_PMK_40_AP_BLAST_MINE           14 /* U.K. -- */
#define DIS204_MUNITION_SUBCATEGORY_7_62MM_UK           1
#define DIS204_MUNITION_SUBCATEGORY_9_0MM_UK           2 /* Germany -- */
 /* 5_56MM is already defined under U.S.A */
 /* drn won't allow same define twice */
 /* constant DIS204_MUNITION_SUBCATEGORY_5_56MM              1 */
#define DIS204_MUNITION_SUBCATEGORY_7_62MM_GERMANY           2
#define DIS204_MUNITION_SUBCATEGORY_9MM           3
#define DIS204_MUNITION_SUBCATEGORY_ANTI_PERSONNEL_MINE           1
     /* Battlefield Support Domain -- */
 /* U.S.A. -- */
#define DIS204_MUNITION_SUBCATEGORY_ALCM_AGM_86B_BATTLEFIELD_SUPPORT           1
#define DIS204_MUNITION_SUBCATEGORY_BULLPUP           2
#define DIS204_MUNITION_SUBCATEGORY_LANCE_MGM_52C           3
#define DIS204_MUNITION_SUBCATEGORY_PERSHING_MGM_31           4
#define DIS204_MUNITION_SUBCATEGORY_TOMAHAWK_AGM_109_BATTLEFIELD_SUPPORT           5
#define DIS204_MUNITION_SUBCATEGORY_TOMAHAWK_BGM_109G_BATTLEFIELD_SUPPORT           6
#define DIS204_MUNITION_SPECIFIC_TOMAHAWK_BGM109_BOOSTER           1
#define DIS204_MUNITION_SPECIFIC_TOMAHAWK_BGM109_WINGS           2
#define DIS204_MUNITION_SUBCATEGORY_WALLEYE_AGM_62           7
#define DIS204_MUNITION_SUBCATEGORY_SRAM_AGM_69           8
#define DIS204_MUNITION_SUBCATEGORY_20MM           1
#define DIS204_MUNITION_SUBCATEGORY_30MM_USA           3
#define DIS204_MUNITION_SUBCATEGORY_40MM           4
#define DIS204_MUNITION_SUBCATEGORY_60MM           5
#define DIS204_MUNITION_SUBCATEGORY_66MM_ROCKET           6
#define DIS204_MUNITION_SUBCATEGORY_76MM_USA           7
#define DIS204_MUNITION_SUBCATEGORY_81MM           8
#define DIS204_MUNITION_SUBCATEGORY_90MM           9
#define DIS204_MUNITION_SUBCATEGORY_105MM_USA           10
#define DIS204_MUNITION_SUBCATEGORY_120MM_USA           11
#define DIS204_MUNITION_SUBCATEGORY_127MM           12
#define DIS204_MUNITION_SUBCATEGORY_152MM_USA           13
#define DIS204_MUNITION_SUBCATEGORY_155MM_USA           14
#define DIS204_MUNITION_SUBCATEGORY_204MM           15
#define DIS204_MUNITION_SUBCATEGORY_227MM_ROCKET_BATTLEFIELD_SUPPORT           16
#define DIS204_MUNITION_SUBCATEGORY_406MM           17
#define DIS204_MUNITION_SUBCATEGORY_107MM           18
#define DIS204_MUNITION_SUBCATEGORY_2_75INCH_ROCKET           19 /* U.S.S.R. -- */
#define DIS204_MUNITION_SUBCATEGORY_AS_3_KANGAROO           1
#define DIS204_MUNITION_SUBCATEGORY_AS_4_KITCHEN_BATTLEFIELD_SUPPORT           2
#define DIS204_MUNITION_SUBCATEGORY_AS_5_KELT           3
#define DIS204_MUNITION_SUBCATEGORY_AS_7_KERRY           4
#define DIS204_MUNITION_SUBCATEGORY_AS_10_KAREN           5
#define DIS204_MUNITION_SUBCATEGORY_AS_11_KILTER           6
#define DIS204_MUNITION_SUBCATEGORY_AS_14_KEDGE_BATTLEFIELD_SUPPORT           7
#define DIS204_MUNITION_SUBCATEGORY_AS_15_KENT           8
#define DIS204_MUNITION_SUBCATEGORY_AS_X_10           9
#define DIS204_MUNITION_SUBCATEGORY_SS_1           10
#define DIS204_MUNITION_SUBCATEGORY_SS_12           11
#define DIS204_MUNITION_SUBCATEGORY_SS_21           12
#define DIS204_MUNITION_SUBCATEGORY_SS_22           13
#define DIS204_MUNITION_SUBCATEGORY_SS_23           14
#define DIS204_MUNITION_SUBCATEGORY_14_5MM_BATTLEFIELD_SUPPORT           1
#define DIS204_MUNITION_SUBCATEGORY_25MM_USSR           3
#define DIS204_MUNITION_SUBCATEGORY_37MM           5
#define DIS204_MUNITION_SUBCATEGORY_40MM_ROCKET           6
#define DIS204_MUNITION_SUBCATEGORY_45MM           7
#define DIS204_MUNITION_SUBCATEGORY_57MM           8
#define DIS204_MUNITION_SUBCATEGORY_82MM           11
#define DIS204_MUNITION_SUBCATEGORY_100MM           13
#define DIS204_MUNITION_SUBCATEGORY_120MM_USSR           15
#define DIS204_MUNITION_SUBCATEGORY_122MM           16
#define DIS204_MUNITION_SUBCATEGORY_122MM_ROCKET           17
#define DIS204_MUNITION_SUBCATEGORY_125MM_BATTLEFIELD_SUPPORT           18
#define DIS204_MUNITION_SUBCATEGORY_130MM           19
#define DIS204_MUNITION_SUBCATEGORY_152MM_USSR           20
#define DIS204_MUNITION_SUBCATEGORY_160MM           21
#define DIS204_MUNITION_SUBCATEGORY_180MM           22
#define DIS204_MUNITION_SUBCATEGORY_240MM           23
#define DIS204_MUNITION_SUBCATEGORY_240MM_ROCKET           24
#define DIS204_MUNITION_SUBCATEGORY_250MM_ROCKET           25
#define DIS204_MUNITION_SUBCATEGORY_400MM_ROCKET           26
#define DIS204_MUNITION_SUBCATEGORY_550MM_ROCKET           27
#define DIS204_MUNITION_SUBCATEGORY_600MM_ROCKET           28
#define DIS204_MUNITION_SUBCATEGORY_850MM_MISSILE           29
#define DIS204_MUNITION_SUBCATEGORY_1100MM_MISSILE           30
#define DIS204_MUNITION_SUBCATEGORY_204MM_HOWITZER           31
#define DIS204_MUNITION_SUBCATEGORY_220MM_ROCKET           32 /* U.K. -- */
#define DIS204_MUNITION_SUBCATEGORY_LANCE           1
#define DIS204_MUNITION_SUBCATEGORY_51MM           1
#define DIS204_MUNITION_SUBCATEGORY_89MM           2
#define DIS204_MUNITION_SUBCATEGORY_105MM_UK           3
#define DIS204_MUNITION_SUBCATEGORY_155MM_UK           4
#define DIS204_MUNITION_SUBCATEGORY_175MM           5 /* France -- */
#define DIS204_MUNITION_SUBCATEGORY_HADES_MISSILE           1
#define DIS204_MUNITION_SUBCATEGORY_PLUTON_MISSILE           2
#define DIS204_MUNITION_SUBCATEGORY_58MM           1
#define DIS204_MUNITION_SUBCATEGORY_105MM_FRANCE           2
#define DIS204_MUNITION_SUBCATEGORY_155MM_FRANCE           3 /* Germany -- */
#define DIS204_MUNITION_SUBCATEGORY_PARACHUTE_SIGNAL           1
     /* 20MM is already defined as 1 under U.S.A */
 /* drn won't allow the same constant twice */
 /* constant DIS204_MUNITION_SUBCATEGORY_20MM                1 */
#define DIS204_MUNITION_SUBCATEGORY_35MM           2
     /* 73MM is already defined as 1 under U.S.S.R */
 /* drn won't allow the same constant twice */
 /* constant DIS204_MUNITION_SUBCATEGORY_73MM                3 */
#define DIS204_MUNITION_SUBCATEGORY_105MM_GERMANY           4
#define DIS204_MUNITION_SUBCATEGORY_120MM_GERMANY           5
     /* Strategic Domain -- */
 /* U.S.A. -- */
#define DIS204_MUNITION_SUBCATEGORY_MINUTEMAN_II_LGM_30           1
#define DIS204_MUNITION_SUBCATEGORY_MINUTEMAN_III           2
#define DIS204_MUNITION_SUBCATEGORY_POSEIDON_UGM_73           3
#define DIS204_MUNITION_SUBCATEGORY_TITAN_II_LGM_25C           4
#define DIS204_MUNITION_SUBCATEGORY_TRIDENT_II_UGM_93A           5
#define DIS204_MUNITION_SUBCATEGORY_TOMAHAWK_AGM_109_STRATEGIC           7
#define DIS204_MUNITION_SUBCATEGORY_TOMAHAWK_BGM_109G_STRATEGIC           8
#define DIS204_MUNITION_SUBCATEGORY_ALCM_AGM_86B_STRATEGIC           9
#define DIS204_MUNITION_SUBCATEGORY_PEACE_KEEPER_MGM_118           10
     /* U.S.S.R. -- */
#define DIS204_MUNITION_SUBCATEGORY_SS_N_5           1
#define DIS204_MUNITION_SUBCATEGORY_SS_N_6           2
#define DIS204_MUNITION_SUBCATEGORY_SS_N_8           3
#define DIS204_MUNITION_SUBCATEGORY_SS_N_17           4
#define DIS204_MUNITION_SUBCATEGORY_SS_N_18           5
#define DIS204_MUNITION_SUBCATEGORY_SS_N_20           6
#define DIS204_MUNITION_SUBCATEGORY_SS_N_23           7
#define DIS204_MUNITION_SUBCATEGORY_SS_N_21           8
#define DIS204_MUNITION_SUBCATEGORY_SS_NX_24           9
#define DIS204_MUNITION_SUBCATEGORY_SSC_X_4           10
#define DIS204_MUNITION_SUBCATEGORY_AS_15_USSR_STRATEGIC           11
#define DIS204_MUNITION_SUBCATEGORY_AS_16           12
#define DIS204_MUNITION_SUBCATEGORY_SS_4           13
#define DIS204_MUNITION_SUBCATEGORY_SS_11_USSR           14
#define DIS204_MUNITION_SUBCATEGORY_SS_13           15
#define DIS204_MUNITION_SUBCATEGORY_SS_16           16
#define DIS204_MUNITION_SUBCATEGORY_SS_17           17
#define DIS204_MUNITION_SUBCATEGORY_SS_18           18
#define DIS204_MUNITION_SUBCATEGORY_SS_19           19
#define DIS204_MUNITION_SUBCATEGORY_SS_20           20
#define DIS204_MUNITION_SUBCATEGORY_SS_24           21
#define DIS204_MUNITION_SUBCATEGORY_SS_25           22 /* France -- */
#define DIS204_MUNITION_SUBCATEGORY_SSBS_TYPE_S_30D_TN_61           1
#define DIS204_MUNITION_SUBCATEGORY_SSBS_TYPE_S_4           2
#define DIS204_MUNITION_SUBCATEGORY_SLBM_M_20           3
#define DIS204_MUNITION_SUBCATEGORY_SLBM_M_4           4
     /* Miscellaneous Domain -- */
#define DIS204_MUNITION_SUBCATEGORY_DEADEYE_5_IN_PROJECTILE           1
     /* Bomb Domain --  U.S.A */
#define DIS204_MUNITION_SUBCATEGORY_MK_82_GUIDED           1
#define DIS204_MUNITION_SUBCATEGORY_MK_84_GUIDED           2
#define DIS204_MUNITION_SUBCATEGORY_CBU_15           1
#define DIS204_MUNITION_SUBCATEGORY_CBU_52           2
#define DIS204_MUNITION_SUBCATEGORY_CBU_58           3
#define DIS204_MUNITION_SUBCATEGORY_CBU_71           4

/*
 * for now, make it CBU1 so they are not the same
 */

#define DIS204_MUNITION_SUBCATEGORY_CBU1_71           5
#define DIS204_MUNITION_SUBCATEGORY_CBU_87           6
#define DIS204_MUNITION_SUBCATEGORY_CBU_89           7
#define DIS204_MUNITION_SUBCATEGORY_MK_81           8
#define DIS204_MUNITION_SUBCATEGORY_MK_82_BALLISTIC           9
#define DIS204_MUNITION_SUBCATEGORY_MK_83           10
#define DIS204_MUNITION_SUBCATEGORY_MK_84_BALLISTIC           11
#define DIS204_MUNITION_SUBCATEGORY_BLU           12
#define DIS204_MUNITION_SUBCATEGORY_MK_20           13
#define DIS204_MUNITION_SUBCATEGORY_DURANDAL           14
     /* Weapons for Life Forms -- */
 /* U.S. Life Form Weapons -- */
#define DIS204_LIFE_FORM_WEAPON_REDEYE_FIM_43A           1
#define DIS204_LIFE_FORM_WEAPON_DRAGON_M47_FGM_77A           2
#define DIS204_LIFE_FORM_WEAPON_STINGER_FIM_92A           3
#define DIS204_LIFE_FORM_WEAPON_M72_LIGHT_ANTI_TANK_WEAPON           4
#define DIS204_LIFE_FORM_WEAPON_MK_193_83MM_SMAW           5
#define DIS204_LIFE_FORM_WEAPON_M60_GENERAL_PURPOSE_MACHINE_GUN           6
#define DIS204_LIFE_FORM_WEAPON_M2_HB_HEAVY_MACHINE_GUN           7
#define DIS204_LIFE_FORM_WEAPON_M67_RECOILLESS_RIFLE           8
#define DIS204_LIFE_FORM_WEAPON_M_204_GRENADE_LAUNCHER           9
#define DIS204_LIFE_FORM_WEAPON_M16A1_RIFLE           10
#define DIS204_LIFE_FORM_WEAPON_M9_PISTOL           11
#define DIS204_LIFE_FORM_WEAPON_M1911A1_PISTOL           12
#define DIS204_LIFE_FORM_WEAPON_M249_SAW           13
     /* Soviet Life Form Weapons -- */
#define DIS204_LIFE_FORM_WEAPON_SA_7_GRAIL_MISSILE           1
#define DIS204_LIFE_FORM_WEAPON_RPG_7_VAT_ROCKER_LAUNCHER           2
#define DIS204_LIFE_FORM_WEAPON_RPG_18           3
#define DIS204_LIFE_FORM_WEAPON_AT_4_SPIGOT_MISSILE           4
#define DIS204_LIFE_FORM_WEAPON_AT_3_SAGGER_MISSILE           5
#define DIS204_LIFE_FORM_WEAPON_AT_7_SAXHORN_MISSILE           6
#define DIS204_LIFE_FORM_WEAPON_7_62MM_PK_GPMG           7
#define DIS204_LIFE_FORM_WEAPON_7_62MM_RPK_LMG           8
#define DIS204_LIFE_FORM_WEAPON_7_62MM_AK_AND_AKM_ASSAULT_RIFLES           9
#define DIS204_LIFE_FORM_WEAPON_5_45MM_AKS_74_ASSAULT_RIFLE           10
#define DIS204_LIFE_FORM_WEAPON_7_62MM_SVD_SNIPER_RIFLE           11
#define DIS204_LIFE_FORM_WEAPON_RKG_3M_AT_HAND_GRENADE           12
#define DIS204_LIFE_FORM_WEAPON_RGD_5_HAND_GRENADE           13
#define DIS204_LIFE_FORM_WEAPON_AGS_17_PLAMYA_GRENADE_LAUNCHER           14
     /* British Life Form Weapons -- */
#define DIS204_LIFE_FORM_WEAPON_LAW_80           1
#define DIS204_LIFE_FORM_WEAPON_BLOWPIPE           2
#define DIS204_LIFE_FORM_WEAPON_JAVELIN           3
#define DIS204_LIFE_FORM_WEAPON_51MM_MORTAR           4
#define DIS204_LIFE_FORM_WEAPON_SLR_7_62MM_RIFLE           5
#define DIS204_LIFE_FORM_WEAPON_STERLING_9MM_SMG           6
#define DIS204_LIFE_FORM_WEAPON_L7A2_GENERAL_PURPOSE_MACHINE_GUN           7
#define DIS204_LIFE_FORM_WEAPON_L6_WOMBAT_RECOILLESS_RIFLE           8
#define DIS204_LIFE_FORM_WEAPON_CARL_GUSTAV_89MM_RECOILLESS_RIFLE           9
#define DIS204_LIFE_FORM_WEAPON_SA80_INDIV_WPN_LIGHT_SUPPORT_WPN           10
#define DIS204_LIFE_FORM_WEAPON_TRIGAT           11
#define DIS204_LIFE_FORM_WEAPON_MILAT_AT_MISSILE           12
     /* French Life Form Weapons -- */
#define DIS204_LIFE_FORM_WEAPON_ACL_STRIM           1
#define DIS204_LIFE_FORM_WEAPON_MISTRAL_MISSILE           2
#define DIS204_LIFE_FORM_WEAPON_MILAN_AT_MISSILE           3
#define DIS204_LIFE_FORM_WEAPON_LRAC_F1_89MM_AT_ROCKET_LAUNCHER           4
#define DIS204_LIFE_FORM_WEAPON_FA_MAS_RIFLE           5
#define DIS204_LIFE_FORM_WEAPON_AA_52_MACHINE_GUN           6
#define DIS204_LIFE_FORM_WEAPON_58MM_RIFLE_GRENADE           7
#define DIS204_LIFE_FORM_WEAPON_FR_F1_SNIPER_RIFLE           8
     /* German Life Form Weapons -- */
#define DIS204_LIFE_FORM_WEAPON_G3_RIFLE           1
#define DIS204_LIFE_FORM_WEAPON_G11_RIFLE           2
#define DIS204_LIFE_FORM_WEAPON_P1_PISTOL           3
#define DIS204_LIFE_FORM_WEAPON_MG3_MACHINE_GUN           4
#define DIS204_LIFE_FORM_WEAPON_MILAN_MISSILE           5
#define DIS204_LIFE_FORM_WEAPON_MP1_UZI_SUBMARINE_GUN           6
#define DIS204_LIFE_FORM_WEAPON_PANZERFAUST3_LIGHT_ANTI_TANK_WEAPON_SYSTEM           7
#define DIS204_LIFE_FORM_WEAPON_DM19_HAND_GRENADE           8
#define DIS204_LIFE_FORM_WEAPON_DM29_HAND_GRENADE           9 /* Life Form -- */
 /* Land -- */
#define DIS204_LIFE_FORM_LAND_CATEGORY_OTHER           0
#define DIS204_LIFE_FORM_LAND_CATEGORY_DISMOUNTED_INFANTRY           1
#define DIS204_LIFE_FORM_LAND_SUBCATEGORY_           0
#define DIS204_LIFE_FORM_LAND_SUBCATEGORY_OTHER           0
#define DIS204_LIFE_FORM_LAND_SUBCATEGORY_1           1
#define DIS204_LIFE_FORM_LAND_SUBCATEGORY_2           2
#define DIS204_LIFE_FORM_LAND_SUBCATEGORY_3           3
#define DIS204_LIFE_FORM_LAND_SUBCATEGORY_4           4
#define DIS204_LIFE_FORM_LAND_SUBCATEGORY_5           5
#define DIS204_LIFE_FORM_LAND_SUBCATEGORY_6           6
#define DIS204_LIFE_FORM_LAND_SUBCATEGORY_7           7
#define DIS204_LIFE_FORM_LAND_SUBCATEGORY_8           8
#define DIS204_LIFE_FORM_LAND_SUBCATEGORY_9           9
#define DIS204_LIFE_FORM_LAND_SUBCATEGORY_10           10
#define DIS204_LIFE_FORM_LAND_SUBCATEGORY_11           11
#define DIS204_LIFE_FORM_LAND_SUBCATEGORY_12           12
#define DIS204_LIFE_FORM_LAND_SUBCATEGORY_13           13 /* Air -- */
#define DIS204_LIFE_FORM_AIR_CATEGORY_OTHER           0
#define DIS204_LIFE_FORM_AIR_CATEGORY_PARACHUTIST           1
#define DIS204_LIFE_FORM_AIR_CATEGORY_A_BIRD           2
#define DIS204_LIFE_FORM_AIR_CATEGORY_FLOCK_OF_BIRDS           3
#define DIS204_LIFE_FORM_AIR_SUBCATEGORY_OTHER           0 /* Surface -- */
#define DIS204_LIFE_FORM_SURFACE_CATEGORY_OTHER           0
#define DIS204_LIFE_FORM_SURFACE_CATEGORY_SWIMMER           1
#define DIS204_LIFE_FORM_SURFACE_CATEGORY_OCCUPIED_LIFE_RAFT           2
#define DIS204_LIFE_FORM_SURFACE_SUBCATEGORY_OTHER           0 /* Subsurface -- */
#define DIS204_LIFE_FORM_SUBSURFACE_CATEGORY_OTHER           0
#define DIS204_LIFE_FORM_SUBSURFACE_CATEGORY_DIVER           1
#define DIS204_LIFE_FORM_SUBSURFACE_CATEGORY_SCHOOL_OF_FISH           2
#define DIS204_LIFE_FORM_SUBSURFACE_CATEGORY_SCHOOL_OF_SHRIMP           3
#define DIS204_LIFE_FORM_SUBSURFACE_CATEGORY_WHALE           4
#define DIS204_LIFE_FORM_SUBSURFACE_SUBCATEGORY_OTHER           0 /* Space -- */
#define DIS204_LIFE_FORM_SPACE_CATEGORY_OTHER           0
#define DIS204_LIFE_FORM_SPACE_CATEGORY_ASTRONAUT           1
#define DIS204_LIFE_FORM_SPACE_SUBCATEGORY_OTHER           0
     /* Number of Life Forms -- */
#define DIS204_LIFE_FORM_FIRE_TEAM           101
#define DIS204_LIFE_FORM_SQUAD  102
#define DIS204_LIFE_FORM_PLATOON 103
#define DIS204_LIFE_FORM_COMPANY 104
#define DIS204_LIFE_FORM_BATALLION           105
#define DIS204_LIFE_FORM_REGIMENT           106
#define DIS204_LIFE_FORM_DIVISION           107
#define DIS204_LIFE_FORM_CORPS  108
#define DIS204_LIFE_FORM_ARMY   109 /* Environmental -- */
 /* Land -- */
#define DIS204_ENVIRONMENTAL_LAND_CATEGORY_OTHER           0 /* Air -- */
#define DIS204_ENVIRONMENTAL_AIR_CATEGORY_OTHER           0
#define DIS204_ENVIRONMENTAL_AIR_CATEGORY_SMOKE           1
#define DIS204_ENVIRONMENTAL_AIR_CATEGORY_FOG           2
#define DIS204_ENVIRONMENTAL_AIR_CATEGORY_CLOUD           3
#define DIS204_ENVIRONMENTAL_AIR_CATEGORY_CLOUD_WITH_RAIN_FALLING           4
#define DIS204_ENVIRONMENTAL_AIR_CATEGORY_CLOUD_WITH_SNOW_FALLING           5
     /* Surface -- */
 /* None -- */
 /* Subsurface -- */
#define DIS204_ENVIRONMENTAL_SUBSURFACE_CATEGORY_OTHER           0
#define DIS204_ENVIRONMENTAL_SUBSURFACE_CATEGORY_THERMOCLINE           1
#define DIS204_ENVIRONMENTAL_SUBSURFACE_CATEGORY_KNOT           2 /* Space -- */
 /* None -- */
 /* Environmental Size -- */
#define DIS204_ENVIRONMENTAL_SIZE_OTHER           0
#define DIS204_ENVIRONMENTAL_SIZE_VERY_SMALL           20
#define DIS204_ENVIRONMENTAL_SIZE_SMALL           40
#define DIS204_ENVIRONMENTAL_SIZE_MEDIUM           60
#define DIS204_ENVIRONMENTAL_SIZE_LARGE           80
#define DIS204_ENVIRONMENTAL_SIZE_VERY_LARGE           100 /* Cultural Feature -- */
 /* Land -- */
#define DIS204_CULTURAL_FEATURE_LAND_CATEGORY_OTHER           0
#define DIS204_CULTURAL_FEATURE_LAND_CATEGORY_BRIDGE_CONCRETE_TWO_LANE           1
#define DIS204_CULTURAL_FEATURE_LAND_CATEGORY_BRIDGE_CONCRETE_FOUR_LANE           2
#define DIS204_CULTURAL_FEATURE_LAND_CATEGORY_BRIDGE_TRUSS_TWO_LANE           3
#define DIS204_CULTURAL_FEATURE_LAND_CATEGORY_BRIDGE_TRUSS_FOUR_LANE           4
#define DIS204_CULTURAL_FEATURE_LAND_CATEGORY_BRIDGE_SUSPENSION_TWO_LANE           5
#define DIS204_CULTURAL_FEATURE_LAND_CATEGORY_BRIDGE_SUSPENSION_FOUR_LANE           6
#define DIS204_CULTURAL_FEATURE_LAND_CATEGORY_BUILDING_ONE_STORY           7
#define DIS204_CULTURAL_FEATURE_LAND_CATEGORY_BUILDING_TWO_STORY           8
#define DIS204_CULTURAL_FEATURE_LAND_CATEGORY_BUILDING_THREE_STORY           9
#define DIS204_CULTURAL_FEATURE_LAND_CATEGORY_BUILDING_FOUR_STORY           10
#define DIS204_CULTURAL_FEATURE_LAND_CATEGORY_TRACKS_TANK           11
#define DIS204_CULTURAL_FEATURE_LAND_CATEGORY_CRATER           15
#define DIS204_CULTURAL_FEATURE_LAND_CATEGORY_DITCH           16
#define DIS204_CULTURAL_FEATURE_LAND_CATEGORY_MINEFIELD_MARKERS           17
#define DIS204_CULTURAL_FEATURE_LAND_CATEGORY_BREACHED_LANE_FLAGS           18
#define DIS204_CULTURAL_FEATURE_LAND_CATEGORY_BARBED_WIRE           19
#define DIS204_CULTURAL_FEATURE_LAND_CATEGORY_DRAGONS_TEETH           20
     /* Air -- */
 /* None -- */
 /* Surface -- */
#define DIS204_CULTURAL_FEATURE_SURFACE_CATEGORY_OTHER           0
#define DIS204_CULTURAL_FEATURE_SURFACE_CATEGORY_OIL_DERRICK           1
#define DIS204_CULTURAL_FEATURE_SURFACE_CATEGORY_BUOY           2
#define DIS204_CULTURAL_FEATURE_SURFACE_CATEGORY_PIER           3
     /* Subsurface -- */
#define DIS204_CULTURAL_FEATURE_SUBSURFACE_CATEGORY_OTHER           0
#define DIS204_CULTURAL_FEATURE_SUBSURFACE_CATEGORY_OIL_DERRICK           1
#define DIS204_CULTURAL_FEATURE_SUBSURFACE_CATEGORY_BUOY           2
#define DIS204_CULTURAL_FEATURE_SUBSURFACE_CATEGORY_SUNKEN_SHIP           3
     /* Space -- */
 /* None -- */
 /* Supply Types -- */
#define DIS204_SUPPLY_CATEGORY_OTHER           0
#define DIS204_SUPPLY_CATEGORY_FUELS           1
#define DIS204_SUPPLY_SUBCATEGORY_FUELS_OTHER           0
#define DIS204_SUPPLY_SUBCATEGORY_FUELS_GASOLINE           1
#define DIS204_SUPPLY_SUBCATEGORY_FUELS_DIESEL_FUEL           2
#define DIS204_SUPPLY_SUBCATEGORY_FUELS_JP4           3
#define DIS204_SUPPLY_SUBCATEGORY_FUELS_FUEL_OIL           4
#define DIS204_SUPPLY_CATEGORY_OILS           2
#define DIS204_SUPPLY_CATEGORY_LUBRICANTS           3
#define DIS204_SUPPLY_CATEGORY_FOOD           4
#define DIS204_SUPPLY_CATEGORY_SPARE_PARTS           5
#define DIS204_SUPPLY_CATEGORY_PERSONNEL           6
#define DIS204_SUPPLY_SUBCATEGORY_PERSONNEL_OTHER           0
#define DIS204_SUPPLY_SUBCATEGORY_PERSONNEL_DISMOUNTED_INFANTRY           1


#endif
