
/*
 * FILE:  dis204exp_types.h 
 *
 * Created on Wed May  8 13:25:47 1996 
 * Compiled by DRN compiler, version 6.2.d
 * 
 */

#ifndef _dis204exp_types_included
#define _dis204exp_types_included



/*
 * File:     dis204exp_types.drn
 * Contents: 
 * System:   BDS-D BIP development.
 * Created:  16-Dec-1993
 * Author:   llovero
 *
 * Remarks:
 *
 * History:
 * 16-Dec-93	new file
 *		Contains types for the experimental PDU's defined in
 *              p_dis204exp.drn.    
 *
 * $RCSfile: dis204exp_types.h,v $
 * $Revision: 1.1.1.1 $
 * $State: Exp $
 *
 * COPYRIGHT 1993 Loral Advanced Distributed Simulation
 * 50 Moulton Street
 * Cambridge, Ma. 02138
 * 617-873-3600
 *
 *
 * Please note!  All hard-coded values that are found in the appendices
 * of the DIS document "Military Standard (Final Draft) Protocol Data
 * Units for Entity Information and Entity Interaction in a Distributed
 * Interactive Simulation" are defined in "dis204_values.drn".
 *
 * Also note that commonly used types and headers which are part of the
 * official DIS standard are defined in "dis204_types.drn".
 */

#include <stdtypes.h>
#include <dis204_types.h> 
#include <dis204exp_values.h> 
#include <basic.h> 
     /* The following is obsoleted by the new environmental pdu */
 /* BEGIN OBSOLETE */
 /* AE types and constants are from IRS DIS-Interface to  */
 /* SAFSim BL 5121 T058 document. */

 /* AE Precipitation Type. (section 3.3.1.1.4, pages 31-32) */

/*typedef uint8    DIS204EXP_PRECIPITATION_TYPE;   same as 203 */


/*
 * AE Precipitation Level. (section 3.3.1.1.4, pages 31-32)
 *
 */

/*typedef uint8    DIS204EXP_PRECIPITATION_LEVEL_TYPE;    same as 203 */


/*
 * AE Temperature. (section 3.3.1.1.4, pages 31-32)
 *
 */

/*typedef char             DIS204EXP_TEMPERATURE_TYPE;    same as 203 */


/*
 * AE Humidity. (section 3.3.1.1.4, pages 31-32)
 *
 */

/*typedef uint8    DIS204EXP_HUMIDITY_TYPE;   same as 203 */


/*
 * AE Air Pressure. (section 3.3.1.1.4, pages 31-32)
 *
 */

/*typedef float32            DIS204EXP_AIR_PRESSURE_TYPE;   same as 203 */


/*
 * AE Luminosity. (section 3.3.1.1.4, pages 31-32)
 *
 */

/*typedef float32            DIS204EXP_LUMINOSITY_TYPE;   same as 203 */


/*
 * AE Precipitation Record. (section 3.3.1.1.4, pages 31-32)
 *
 */
/*
typedef struct {
    DIS204EXP_PRECIPITATION_TYPE       precip_type; 
    DIS204EXP_PRECIPITATION_LEVEL_TYPE precip_level; 
} DIS204EXP_PRECIPITATION_RECORD;  same as 203 */


/*
 * AE Weather Record. (section 3.3.1.1.4, pages 31-32)
 *
 */
/*
typedef struct {
    DIS204EXP_PRECIPITATION_RECORD       precipitation; 
    uint16                          _unused_9; */ /* padding */
/*    DIS204_LENGTH_TYPE                   visual_range; 
    DIS204EXP_TEMPERATURE_TYPE           temperature; 
    DIS204EXP_HUMIDITY_TYPE              humidity; 
    DIS204EXP_AIR_PRESSURE_TYPE          air_pressure; 
    DIS204EXP_LUMINOSITY_TYPE            luminosity; 
    DIS204_LINEAR_VELOCITY_VECTOR_RECORD wind_velocity; 
} DIS204EXP_WEATHER_RECORD;   same as 203 */ 


/*
 * AE Dynamic Terrain Object ID. (section 3.3.1.1.5, page 30)
 *
 */

/*typedef uint32 DIS204EXP_DYNAMIC_TERRAIN_OBJECT_ID_TYPE;    same as 203 */


/*
 * AE Dynamic Terrain Object Type. (section 3.3.1.1.5, page 30)
 *
 */

/*typedef uint16 DIS204EXP_DYNAMIC_TERRAIN_OBJECT_TYPE;    same as 203 */


/*
 * AE Dynamic Terrain Object State Type. (section 3.3.1.1.5, page 30)
 *
 */

/*typedef uint16 DIS204EXP_DYNAMIC_TERRAIN_OBJECT_STATE_TYPE;     same as 203 */


/*
 * AE Dynamic Terrain Object Appearance Type. (section 3.3.1.1.5, page 30)
 *
 */

/*typedef uint16 DIS204EXP_DYNAMIC_TERRAIN_OBJECT_APPEARANCE_TYPE;     same as 203 */


/*
 * LOSAT Smoke description
 *
 * 
 *   Scaling factor used to determine intervisibility through smoke
 *
 */

/*typedef float32 DIS204EXP_SCALING_FACTOR;     same as 203 */

/*typedef struct {
    DIS204EXP_SCALING_FACTOR sigma_x; 
    DIS204EXP_SCALING_FACTOR sigma_y; 
    DIS204EXP_SCALING_FACTOR sigma_z; 
    uint16              simulated_time; 
} DIS204EXP_INTERVIS_RECORD;     same as 203 */


/*
 * Volumetric Dead Reckoning Algorithm
 *
 */

/*typedef uint8 DIS204EXP_DEAD_RECKONING_ALGORITHM_TYPE;     same as 203 */


/*
 * Volumetric Dead Reckoning Parameters
 *
 */

/*typedef struct {
    DIS204EXP_DEAD_RECKONING_ALGORITHM_TYPE dead_reckoning_algorithm; 
    unsigned                                   _unused_10                : 24;  */
     /* padding */
   /*  DIS204EXP_SCALING_FACTOR                dsigma_x_dt; 
    DIS204EXP_SCALING_FACTOR                dsigma_y_dt; 
    DIS204EXP_SCALING_FACTOR                dsigma_z_dt; 
} DIS204EXP_SMOKE_DEAD_RECKONING_RECORD;      same as 203 */

/*typedef struct {
    DIS204EXP_INTERVIS_RECORD             intervis_factors; 
    uint16                           _unused_11;*/  /* padding */
  /*   DIS204EXP_SMOKE_DEAD_RECKONING_RECORD dead_reckoning; 
} DIS204EXP_SMOKE_RECORD;       same as 203 */
 /* END OBSOLETE */

 /* New proposed environmental pdu information */

 /* Number of records in packet */
/*typedef uint32 DIS204_ENV_NUMBER_OF_RECORDS_TYPE;       same as 203 */
 /* Relative distances */
/*typedef float32 DIS204_ENV_DISTANCE_TYPE;       same as 203 */
 /* Velocity */
/*typedef float32 DIS204_ENV_VELOCITY_TYPE;       same as 203 */

/*typedef float32 DIS204_ENV_VELOCITY_VECTOR[3];       same as 203 */
 /* Acceleration */
/*typedef float32 DIS204_ENV_ACCELERATION_TYPE;       same as 203 */
 /* Density */
/*typedef float32 DIS204_ENV_DENSITY_TYPE;       same as 203 */
 /* Index in a state record used to find associated geometry record */
/*typedef uint16 DIS204_ENV_GEOMETRY_INDEX_TYPE;       same as 203 */
 /* Number of vertices stored in record */
/*typedef int32 DIS204_ENV_NUMBER_OF_VERTICES_TYPE;       same as 203 */
 /* Paddng to fill out max record size */
/*typedef struct {*/
//    uint32 _unused_12_13;         /* padding */
//    uint32 _unused_12_14;         /* padding */
//    uint32 _unused_12_15;         /* padding */
//    uint32 _unused_12_16;         /* padding */
//    uint32 _unused_12_17;         /* padding */
//    uint32 _unused_12_18;         /* padding */
//    uint32 _unused_12_19;         /* padding */
//    uint32 _unused_12_20;         /* padding */
//    uint32 _unused_12_21;         /* padding */
//    uint32 _unused_12_22;         /* padding */
//    uint32 _unused_12_23;         /* padding */
//    uint32 _unused_12_24;         /* padding */
//    uint32 _unused_12_25;         /* padding */
//    uint32 _unused_12_26;         /* padding */
//    uint32 _unused_12_27;         /* padding */
//    uint32 _unused_12_28;         /* padding */
//    uint32 _unused_12_29;         /* padding */
//    uint32 _unused_12_30;         /* padding */
//    uint32 _unused_12_31;         /* padding */
//    uint32 _unused_12_32;         /* padding */
//    uint32 _unused_12_33;         /* padding */
//    uint32 _unused_12_34;         /* padding */
//    uint32 _unused_12_35;         /* padding */
//    uint32 _unused_12_36;         /* padding */
//    uint32 _unused_12_37;         /* padding */
//    uint32 _unused_12_38;         /* padding */
//    uint32 _unused_12_39;         /* padding */
//    uint32 _unused_12_40;         /* padding */
//    uint32 _unused_12_41;         /* padding */
//    uint32 _unused_12_42;         /* padding */
//    uint32 _unused_12_43;         /* padding */
//    uint32 _unused_12;            /* padding */
/*} DIS204_ENV_PADDING_VARIANT;        same as 203 */

/*typedef int32 DIS204_ENV_NUMBER_OF_SOURCES_TYPE;      same as 203 */

 /* type DIS204_ENV_STATE_OBSCURANT_VARIANT sequence { */
 /* 	time_since_creation		DIS204_TIME_TYPE, */
 /* 	density				DIS204_ENV_DENSITY_TYPE, */
 /* 	geometry_index			DIS204_ENV_GEOMETRY_INDEX_TYPE, */
 /* 	obscurant_type			DIS204_ENV_OBSCURANT_TYPE, */
 /* 					unused(8) */
 /* } */
//typedef struct {
//    DIS204_TIME_TYPE                  time_since_detonation; 
//    DIS204_ENTITY_TYPE_RECORD         source; 
//    DIS204_ENV_NUMBER_OF_SOURCES_TYPE number_of_sources; 
//    DIS204_ENV_GEOMETRY_INDEX_TYPE    geometry_index; 
//    uint16                       _unused_44;  /* padding */
//    DIS204_ENV_SOURCE_TYPE            source_type; 
//    float32                                barrage_rate;  /* only valid if source_type */
//
//    float32                                barrage_duration;  /* is barrage. */
//
//    float32                                crosswind_length;  /* dimensions of */
//
//    float32                                downwind_length;  /* impact region. */
//
//    DIS204_ENV_VELOCITY_VECTOR        detonate_velocity;  /* angle from which  */
         /* detonation occurred, */
     /* currently used */
     /* with barrages */

//} DIS204_ENV_STATE_COMBIC_VARIANT;   same as 203

/*typedef struct {
    DIS204_TIME_TYPE                  time_since_detonation; 
    DIS204_ENTITY_TYPE_RECORD         source; 
    float32                                source_intensity; 
    DIS204_ENV_NUMBER_OF_SOURCES_TYPE number_of_sources; 
    DIS204_ENV_GEOMETRY_INDEX_TYPE    geometry_index; 
} DIS204_ENV_STATE_FLARE_VARIANT;    same as 203*/
 /* a little wierd, but might be useful for small databases */
/*typedef struct {
    DIS204_ENV_GEOMETRY_INDEX_TYPE sun_geometry_index; 
    DIS204_ENV_GEOMETRY_INDEX_TYPE moon_geometry_index; 
    float32                             moon_phase; 
} DIS204_ENV_STATE_EPHEMERIS_VARIANT;    same as 203*/

/*typedef struct {
    DIS204_ENV_WAVEBAND_TYPE waveband; 
    float32         coeff;                
} DIS204_ENV_EXTINCTION_RECORD;    same as 203*/

/*typedef struct {
    uint32                            simulation_time; */ /* Enumeration */

//    DIS204_ENV_WEATHER_PRECIPITATION_TYPE precipitation_type; 
//      /* precipitation rate (mm/hr) */

//     float32                           precipitation_rate;  /* Enumeration */

//     DIS204_ENV_WEATHER_EXTINCTION_TYPE extinction_type; 
//      /* Visibility, basically, in km. */

//     float32                           extinction_amount;  /* deg C */

//     float32                           temperature;  /* deg C */

//     float32                           dewpoint;  /* relative humidity percent */

//     float32                           relative_humidity; 
//      /* barometric pressure in N/m2 (aka Pascal == 7.501E-4 cm Hg) */

//     float32                           barometric_pressure; 
//      /* illumination level in ft-candles, abstraction of tod/cloud cover */

//     float32                           ambient_light;  /* wind velocity in m/s */

//     DIS204_ENV_VELOCITY_VECTOR        wind; 
//      /* 0.0 is no clouds, 1.0 is complete cloud cover */

 //    float32                           cloud_cover;  /* altitude ASL */

//     float32                           cloud_top;  /* altitude ASL */

//     float32                           cloud_base; 
     /* extinction coefficients(3) and the wavebands they appy to */

//     DIS204_ENV_EXTINCTION_RECORD      extinctionRecord[3]; 
     /* where does this weather apply? */

//     uint16                            geometry_index; 
//     uint16                            _unused_45;  /* padding */
//     uint32                            cloud_type; 
//     float32                           total_precip_last_hr; 
//     uint32                            last_rain_time; 
//     uint32                            sub_soil_saturation; 
// } DIS204_ENV_STATE_SIMPLE_WEATHER_VARIANT;    same as 203*/

/*#define DIS204_ENV_MAX_SITE_NAME_LEN           32   same as 203*/
/*typedef struct {*/

     /* Name of observation site (used in ModSAF PVD label) */

//    uint8                   name[DIS204_ENV_MAX_SITE_NAME_LEN]; 
         /* (Unix std.) time observation was made. Do *NOT* set sim time  */
     /* from this!  */


//    uint32                   observation_time;  /* Enumeration */

//    DIS204_ENV_WEATHER_PRECIPITATION_TYPE precipitation_type; 
     /* precipitation rate (mm/hr) */

//    float32                           precipitation_rate;  /* Enumeration */
//
//    DIS204_ENV_WEATHER_EXTINCTION_TYPE extinction_type; 
     /* Visibility, basically, in km. */

//    float32                           extinction_amount;  /* deg C */

//    float32                           temperature;  /* deg C */

//    float32                           dewpoint;  /* relative humidity percent */

//    float32                           relative_humidity; 
     /* barometric pressure in N/m2 (aka Pascal == 7.501E-4 cm Hg) */
         /* (millibar * 100) */

//    float32                           barometric_pressure; 
     /* illumination level in ft-candles, abstraction of tod/cloud cover */

//    float32                           ambient_light;  /* wind velocity in m/s */

//    DIS204_ENV_VELOCITY_VECTOR   wind; 
     /* 0.0 is no clouds, 1.0 is complete cloud cover */

//    float32                           cloud_cover;  /* altitude ASL */

//    float32                           cloud_top;  /* altitude ASL */

//    float32                           cloud_base; 
     /* extinction coefficients(3) and the wavebands they apply to */

//    DIS204_ENV_EXTINCTION_RECORD extinctionRecord[3]; 
     /* index to record which shows where this observation is from */

//    uint16                  geometry_index; 
/*} DIS204_ENV_STATE_OBSERVED_WEATHER_VARIANT;    same as 203*/

/*typedef float32 DIS204_ENV_COMPONENT_OFFSET_TYPE;    same as 203*/

/*typedef struct {
    DIS204_ENV_COMPONENT_OFFSET_TYPE x_offset; 
    DIS204_ENV_COMPONENT_OFFSET_TYPE y_offset; 
    DIS204_ENV_COMPONENT_OFFSET_TYPE z_offset; 
} DIS204_ENV_LOCATION_OFFSET_RECORD;    same as 203*/

/*typedef struct {
    uint32                        time_since_creation; 
    DIS204_ENTITY_ID_RECORD           attached_vehicle_ID; 
    uint16                       geometry_index; 
    DIS204_ENV_VELOCITY_VECTOR        vehicle_velocity; 
    DIS204_WORLD_COORDINATES_RECORD   location; 
    DIS204_ENV_LOCATION_OFFSET_RECORD bounding_sphere_center; 
    DIS204_ENV_DISTANCE_TYPE          bounding_sphere_radius; 
    DIS204_ENV_DISTANCE_TYPE          plume_length; 
    DIS204_ENV_DISTANCE_TYPE          sigma_y; 
    DIS204_ENV_DISTANCE_TYPE          sigma_z; 
    DIS204_ENV_VELOCITY_TYPE          horz_velocity; 
    DIS204_ENV_VELOCITY_TYPE          vert_velocity; 
    DIS204_ENV_VELOCITY_TYPE          d_sigma_y_dt; 
    DIS204_ENV_VELOCITY_TYPE          d_sigma_z_dt; 
    DIS204_ENV_VEHICLE_TYPE           vehicle_type; 
    uint16                       _unused_45_46; */ /* padding */
/*    uint32                        _unused_45; */  /* padding */
/*} DIS204_ENV_STATE_VEH_DUST_VARIANT;    same as 203*/


/*
 * Used for padding out to max size
 *
 */

//typedef struct {
//    uint32 _unused_47_48;         /* padding */
//    uint32 _unused_47_49;         /* padding */
//    uint32 _unused_47_50;         /* padding */
//    uint32 _unused_47_51;         /* padding */
//    uint32 _unused_47_52;         /* padding */
//    uint32 _unused_47_53;         /* padding */
//    uint32 _unused_47_54;         /* padding */
//    uint32 _unused_47_55;         /* padding */
//    uint32 _unused_47_56;         /* padding */
//    uint32 _unused_47_57;         /* padding */
//    uint32 _unused_47_58;         /* padding */
//    uint32 _unused_47_59;         /* padding */
//    uint32 _unused_47_60;         /* padding */
//    uint32 _unused_47_61;         /* padding */
//    uint32 _unused_47_62;         /* padding */
//    uint32 _unused_47_63;         /* padding */
//    uint32 _unused_47_64;         /* padding */
//    uint32 _unused_47_65;         /* padding */
//    uint32 _unused_47_66;         /* padding */
//    uint32 _unused_47_67;         /* padding */
//    uint32 _unused_47_68;         /* padding */
//    uint32 _unused_47_69;         /* padding */
//    uint32 _unused_47_70;         /* padding */
//    uint32 _unused_47_71;         /* padding */
//    uint32 _unused_47_72;         /* padding */
//    uint32 _unused_47_73;         /* padding */
//    uint32 _unused_47_74;         /* padding */
//    uint32 _unused_47_75;         /* padding */
//    uint32 _unused_47_76;         /* padding */
//    uint32 _unused_47_77;         /* padding */
//    uint32 _unused_47_78;         /* padding */
//    uint32 _unused_47;            /* padding */
//} DIS204_ENV_GEOMETRY_UNIFORM_VARIANT; 

//typedef struct {
//    DIS204_WORLD_COORDINATES_COMPONENT_TYPE x; 
//    DIS204_WORLD_COORDINATES_COMPONENT_TYPE y; 
//} DIS204_ENV_HORZ_WORLD_COORDINATES_RECORD; 

//typedef struct {
//    DIS204_WORLD_COORDINATES_COMPONENT_TYPE x; 
//    DIS204_WORLD_COORDINATES_COMPONENT_TYPE y; 
//    DIS204_WORLD_COORDINATES_COMPONENT_TYPE z; 
//} DIS204_ENV_WORLD_COORDINATES_RECORD; 

//typedef struct {
//    DIS204_ENV_WORLD_COORDINATES_RECORD location; 
//} DIS204_ENV_GEOMETRY_POINT_VARIANT; 

//typedef struct {
//    DIS204_WORLD_COORDINATES_COMPONENT_TYPE  z0; 
//    DIS204_WORLD_COORDINATES_COMPONENT_TYPE  z1; 
 //   DIS204_ENV_NUMBER_OF_VERTICES_TYPE       number_of_vertices; 
//    uint32                               _unused_79_80;  /* padding */
//    uint32                               _unused_79_81;  /* padding */
//    uint32                               _unused_79;  /* padding */
//    DIS204_ENV_HORZ_WORLD_COORDINATES_RECORD vertex[1]; 
//} DIS204_ENV_GEOMETRY_POLYGON_VARIANT; 

//typedef struct {
//    DIS204_ENV_WORLD_COORDINATES_RECORD location; 
//    DIS204_ENV_DISTANCE_TYPE            distance; 
//    DIS204_ANGLE_TYPE                   azimuth;  /* downwind direction */

//    DIS204_ENV_DISTANCE_TYPE            sigma_y; 
//    DIS204_ENV_DISTANCE_TYPE            sigma_z; 
//    DIS204_ENV_DISTANCE_TYPE            height; 
//    DIS204_ENV_VELOCITY_TYPE            horz_velocity; 
//    DIS204_ENV_VELOCITY_TYPE            vert_velocity; 
//    DIS204_ENV_VELOCITY_TYPE            d_sigma_y_dt; 
//    DIS204_ENV_VELOCITY_TYPE            d_sigma_z_dt; 
//} DIS204_ENV_GEOMETRY_GAUSSIAN_PLUME_VARIANT; 

//typedef struct {
//    DIS204_ENV_WORLD_COORDINATES_RECORD location; 
//    DIS204_ENV_DISTANCE_TYPE            distance; 
//    DIS204_ANGLE_TYPE                   azimuth; 
//    DIS204_ENV_DISTANCE_TYPE            sigma_x; 
//    DIS204_ENV_DISTANCE_TYPE            sigma_y; 
//    DIS204_ENV_DISTANCE_TYPE            sigma_z; 
//    DIS204_ENV_DISTANCE_TYPE            height; 
//    DIS204_ENV_VELOCITY_TYPE            horz_velocity; 
//    DIS204_ENV_VELOCITY_TYPE            vert_velocity; 
//    DIS204_ENV_VELOCITY_TYPE            d_sigma_x_dt; 
//    DIS204_ENV_VELOCITY_TYPE            d_sigma_y_dt; 
//    DIS204_ENV_VELOCITY_TYPE            d_sigma_z_dt; 
//} DIS204_ENV_GEOMETRY_GAUSSIAN_PUFF_VARIANT; 

//typedef struct {
//    DIS204_ENV_WORLD_COORDINATES_RECORD location; 
//    DIS204_ENV_DISTANCE_TYPE            radius; 
//    DIS204_VECTOR_RECORD                acceleration; 
//    DIS204_VECTOR_RECORD                velocity; 
//    DIS204_ENV_VELOCITY_TYPE            d_radius_dt; 
//} DIS204_ENV_GEOMETRY_SPHEROID_VARIANT; 

//typedef struct {
//    DIS204_ENV_WORLD_COORDINATES_RECORD location; 
 //   DIS204_ANGLE_TYPE                   peak_angle; 
 //   DIS204_ENV_VELOCITY_VECTOR          horz_velocity; 
 //   DIS204_ENV_VELOCITY_TYPE            vert_velocity; 
//} DIS204_ENV_GEOMETRY_CONE_VARIANT; 

//typedef struct {
//    DIS204_ENV_WORLD_COORDINATES_RECORD origin; 
//    DIS204_ENV_WORLD_COORDINATES_RECORD extent; 
//} DIS204_ENV_GEOMETRY_EXTENTS_VARIANT; 

//typedef struct {
//    DIS204_ANGLE_TYPE        azimuth; 
//    DIS204_ANGLE_TYPE        elevation; 
//    DIS204_ENV_DISTANCE_TYPE range;  
//} DIS204_ENV_GEOMETRY_SPHERICAL_COORDS_VARIANT; 

//typedef uint32 DIS204_ENV_STATE_SIMULATION_DATE_VARIANT; 

//typedef float32 DIS204_ENV_TIME_OFFSET_TYPE; 

//typedef struct {
//    DIS204_ENV_LOCATION_OFFSET_RECORD node_location; 
//    DIS204_ENV_DISTANCE_TYPE          node_dsigma_y_dt; 
//    DIS204_ENV_DISTANCE_TYPE          node_dsigme_z_dt; 
//    float32                                node_mass; 
//    uint16                       node_time_since_creation; 
//    uint16                       node_soil_type; 
//    float32                                node_d_sigma_info; 
//} DIS204_ENV_DUST_NODE_RECORD; 

//typedef struct {
//    DIS204_ENV_DUST_NODE_RECORD dust_nodes[4]; 
//} DIS204_ENV_GEOMETRY_FLEX_PLUME_VARIANT; 

//typedef struct {
//    DIS204_ENV_RECORD_KIND_TYPE record_kind; 
//    uint32 _unused_82;            /* padding */
//    union {
//        DIS204_ENV_PADDING_VARIANT                 padding;
//        DIS204_ENV_STATE_COMBIC_VARIANT            combic_plume;
//        DIS204_ENV_STATE_COMBIC_VARIANT            combic_puff;
//        DIS204_ENV_STATE_FLARE_VARIANT             flare;
//        DIS204_ENV_STATE_EPHEMERIS_VARIANT         ephemeris;
//        DIS204_ENV_STATE_SIMPLE_WEATHER_VARIANT    simple_weather;
//        DIS204_ENV_STATE_OBSERVED_WEATHER_VARIANT  observed_weather;
//        DIS204_ENV_STATE_SIMULATION_DATE_VARIANT   simulation_date;
//        DIS204_ENV_GEOMETRY_UNIFORM_VARIANT        uniform;
//        DIS204_ENV_GEOMETRY_POINT_VARIANT          point;
//        DIS204_ENV_GEOMETRY_SPHEROID_VARIANT       spheroid;
////        DIS204_ENV_GEOMETRY_GAUSSIAN_PLUME_VARIANT gaussian_plume;
//        DIS204_ENV_GEOMETRY_CONE_VARIANT           cone;
//        DIS204_ENV_GEOMETRY_GAUSSIAN_PUFF_VARIANT  gaussian_puff;
//        DIS204_ENV_GEOMETRY_POLYGON_VARIANT        polygon;
//        DIS204_ENV_GEOMETRY_EXTENTS_VARIANT        extents;
//        DIS204_ENV_STATE_VEH_DUST_VARIANT          vehicle_dust;
//        DIS204_ENV_GEOMETRY_FLEX_PLUME_VARIANT     flex_plume;
//    } variant;                          
//} DIS204_ENV_RECORD; 



#endif
