
/*
 * FILE:  dis204exp_values.h 
 *
 * Created on Wed Apr 17 10:52:41 1996 
 * Compiled by DRN compiler, version 6.2.d
 * 
 */

#ifndef _dis204exp_values_included
#define _dis204exp_values_included



/*
 * File:     dis204exp_values.drn
 * Contents: 
 * System:   BDS-D BIP development.
 * Created:  16-Dec-1993
 * Author:   llovero
 *
 * Remarks:
 *
 * History:
 * 16-Dec-93	new file
 *		Contains values for the experimental PDU's defined in
 *              p_dis204exp.drn.    
 *
 * $RCSfile: dis204exp_values.h,v $
 * $Revision: 1.1.1.1 $
 * $State: Exp $
 *
 * COPYRIGHT 1993 Loral Advanced Distributed Simulation
 * 50 Moulton Street
 * Cambridge, Ma. 02138
 * 617-873-3600
 *
 * 
 * NOTE: There are currently some temporary PDU Kinds defined in
 *       dis_values.drn that we do not want to conflict with. We
 *       will start with 140 to completely avoid this conflict.
 *
 * DIS204EXP_ENVIRONMENT_PDU_KIND is used for the Atlas environment code
 *
 * DIS204_ENVIRONMENTAL_PDU_KIND is used by the Phenomenology ModSAF extension
 *
 * LOSAT Smoke type 142 is obsolete
 */

#include <stdtypes.h>

#define DIS204EXP_ENVIRONMENT_PDU_KIND 140
#define DIS204EXP_DYNAMIC_TERRAIN_ENTITY_PDU_KIND 141
#define DIS204EXP_SMOKE_PDU_KIND 142 
#define DIS204_MARKER_PDU_KIND  150  
#define DIS204_ENVIRONMENTAL_PDU_KIND 154

typedef uint8    DIS_EXP_PDU_KIND; 


/*
 * AE types and constants are from IRS DIS-Interface to 
 * SAFSim BL 5121 T058 document.
 *
 * AE Enum, Type, and Record definitions for the Environment PDU.
 * (section 3.3.1.1.4, pages 31-32)
 *
 *
 *
 * AE Precipitation Type Enum. (section 3.3.1.1.5)
 *
 */

#define DIS204EXP_PRECIPITATION_TYPE_NONE           0
#define DIS204EXP_PRECIPITATION_TYPE_CLOUDS           1
#define DIS204EXP_PRECIPITATION_TYPE_FOG           2
#define DIS204EXP_PRECIPITATION_TYPE_RAIN           3
#define DIS204EXP_PRECIPITATION_TYPE_SNOW           4
#define DIS204EXP_PRECIPITATION_TYPE_HAIL           5

/*
 * AE Dynamic Terrain Object State Enum. (section 3.3.1.1.3)
 *
 * Atlas-specific dynamic terrain extensions
 */

#define DIS204AE_DYNAMIC_TERRAIN_ENTITY_STATE_MASK           0x7000000
#define DIS204AE_DYNAMIC_TERRAIN_ENTITY_APPEARANCE_MASK           0x18000000

/*
 * Atlas-specific dynamic terrain appearance enums
 *
 */

#define DIS204AE_DYNAMIC_TERRAIN_ENTITY_STATE_DAMAGE_NONE 0x1000000
#define DIS204AE_DYNAMIC_TERRAIN_ENTITY_STATE_DAMAGE_MODERATE 0x2000000
#define DIS204AE_DYNAMIC_TERRAIN_ENTITY_STATE_DAMAGE_HEAVY 0x3000000
#define DIS204AE_DYNAMIC_TERRAIN_ENTITY_STATE_DAMAGE_COMPLETE 0x4000000
#define DIS204AE_DYNAMIC_TERRAIN_ENTITY_APPEARANCE_SMOKING 0x8000000
#define DIS204AE_DYNAMIC_TERRAIN_ENTITY_APPEARANCE_FLAMING 0x10000000

typedef uint32    DIS204AE_DYNAMIC_TERRAIN_ENTITY_APPEARANCE_LIFE; 
 /* These need to be defined as constants instead of being in the */
 /* enumerated section above since they overload the value 0x00000000. */
#define DIS204AE_DYNAMIC_TERRAIN_ENTITY_STATE_NOT_PRESENT           0x0
#define DIS204AE_DYNAMIC_TERRAIN_ENTITY_APPEARANCE_NORMAL           0x0
     /* BEGIN OBSOLETE */

 /* Smoke values developed for LOSAT */

 /*  Use constant DIS204_ENVIRONMENTAL_AIR_CATEGORY_SMOKE for category */

#define DIS204EXP_ENV_AIR_SUBCAT_SMOKE_RED_PHOSPHORUS           1
#define DIS204EXP_ENV_AIR_SUBCAT_SMOKE_WHITE_PHOSPHORUS           2
#define DIS204EXP_ENV_AIR_SPEC_RED_PHOSPHORUS_181MM           1
#define DIS204EXP_ENV_AIR_SPEC_WP_M110E2           2
#define DIS204EXP_ENV_AIR_SPEC_WP_M328A1           3
#define DIS204EXP_ENV_AIR_SPEC_WP_M825           4
#define DIS204EXP_ENV_AIR_SPEC_WP_ZUNI_MK4           5
     /* These constants are for LOSAT munition types */
 /* For example, use DIS204_ENTITY_KIND_MUNITION, */
 /*                  DIS204_MUNITION_DOMAIN_BATTLEFIELD_SUPPORT, */
 /*                  DIS204EXP_MUNITION_CATEGORY_SMOKE, */
 /*                  DIS204EXP_MUNITION_SUBCAT_SMOKE_M110E2 */
#define DIS204EXP_MUNITION_CATEGORY_SMOKE           4
#define DIS204EXP_MUNITION_SUBCAT_SMOKE_RED_PHOSPH           1
#define DIS204EXP_MUNITION_SUBCAT_SMOKE_M110E2           2
#define DIS204EXP_MUNITION_SUBCAT_SMOKE_M328A1           3
#define DIS204EXP_MUNITION_SUBCAT_SMOKE_M825           4
#define DIS204EXP_MUNITION_SUBCAT_SMOKE_ZUNI_MK4           5

/*
 * Different dead reckoning algorithms
 *
 */

#define DIS204EXP_DEAD_RECKONING_ALGORITHM_OTHER           0
#define DIS204EXP_DEAD_RECKONING_ALGORITHM_STATIC           1
#define DIS204EXP_DEAD_RECKONING_ALGORITHM_DRM_3D           2 /* END OBSOLETE */

 /* Experimental Environment PDU enums */

 /* Constants should match their SIMNET counterparts */

#define DIS204_ENV_WAVEBAND_UNKNOWN 0
#define DIS204_ENV_WAVEBAND_47MM 1   
#define DIS204_ENV_WAVEBAND_49MM 2   
#define DIS204_ENV_WAVEBAND_712 3    
#define DIS204_ENV_WAVEBAND_106 4    
#define DIS204_ENV_WAVEBAND_35  5    
#define DIS204_ENV_WAVEBAND_812 6    
#define DIS204_ENV_WAVEBAND_1060 7   

typedef uint32    DIS204_ENV_WAVEBAND_TYPE; 

#define DIS204_ENV_WEATHER_PRECIPITATION_NONE 0
#define DIS204_ENV_WEATHER_PRECIPITATION_OTHER 1
#define DIS204_ENV_WEATHER_PRECIPITATION_RAIN 2
#define DIS204_ENV_WEATHER_PRECIPITATION_SLEET 3
#define DIS204_ENV_WEATHER_PRECIPITATION_HAIL 4
#define DIS204_ENV_WEATHER_PRECIPITATION_SNOW 5

typedef uint32    DIS204_ENV_WEATHER_PRECIPITATION_TYPE; 

#define DIS204_ENV_WEATHER_EXTINCTION_NONE 0
#define DIS204_ENV_WEATHER_EXTINCTION_OTHER 1
#define DIS204_ENV_WEATHER_EXTINCTION_RURAL 2
#define DIS204_ENV_WEATHER_EXTINCTION_MARITIME 3
#define DIS204_ENV_WEATHER_EXTINCTION_URBAN 4
#define DIS204_ENV_WEATHER_EXTINCTION_TROPOSPHERIC 5
#define DIS204_ENV_WEATHER_EXTINCTION_ADVECTIVEFOG 6
#define DIS204_ENV_WEATHER_EXTINCTION_RADIATIVEFOG 7
#define DIS204_ENV_WEATHER_EXTINCTION_DESERT 8

typedef uint32    DIS204_ENV_WEATHER_EXTINCTION_TYPE; 

#define DIS204_ENV_STATUS_OFF   0    
#define DIS204_ENV_STATUS_ON    1    

typedef uint16    DIS204_ENV_STATUS_TYPE; 

#define DIS204_ENV_VEHICLE_TRACKED 0 
#define DIS204_ENV_VEHICLE_WHEELED 1 

typedef uint16   DIS204_ENV_VEHICLE_TYPE; 

#define DIS204_ENV_NODE_OFF     0    
#define DIS204_ENV_NODE_ON      1    

typedef uint16   DIS204_ENV_NODE_FLAG_TYPE; 

#define DIS204_ENV_SOIL_ROCK    0    
#define DIS204_ENV_SOIL_DRY_SOIL 1   
#define DIS204_ENV_SOIL_DRY_SAND 2   
#define DIS204_ENV_SOIL_MEDIUM_SAND 3
#define DIS204_ENV_SOIL_WET_SAND 4   
#define DIS204_ENV_SOIL_WET_SOIL 5   

typedef uint16   DIS204_ENV_SOIL_TYPE; 

#define DIS204_ENV_WEATHER_MODEL_SIMPLE 0x1
#define DIS204_ENV_WEATHER_MODEL_OBSERVED 0x2
#define DIS204_ENV_SEA_STATE_MODEL_SIMPLE 0x3
#define DIS204_ENV_EPHEMERIS_MODEL_SIMPLE 0x5
#define DIS204_ENV_SMOKE_MODEL_OTHER 0x10
#define DIS204_ENV_SMOKE_MODEL_SIMPLE 0x11
#define DIS204_ENV_SMOKE_MODEL_ATLAS 0x12
#define DIS204_ENV_SMOKE_MODEL_COMBIC 0x13
#define DIS204_ENV_FLARE_MODEL_FLARE 0x14
#define DIS204_ENV_VEHICLE_DUST_MODEL_COMBIC 0x15
#define DIS204_ENV_OBSCURANT_MODEL_OTHER 0x16
#define DIS204_ENV_OBSCURANT_MODEL_SIMPLE 0x17

typedef uint8   DIS204_ENV_MODEL_TYPE; 

#define DIS204_ENV_PADDING_KIND 0x0   /* State Records */
#define DIS204_ENV_STATE_SIMPLE_ILLUMINATION_KIND 0x1
#define DIS204_ENV_STATE_SIMPLE_SOUND_KIND 0x2
#define DIS204_ENV_STATE_SIMPLE_OBSCURANT_KIND 0x3
#define DIS204_ENV_STATE_SIMPLE_WEATHER_KIND 0x4
#define DIS204_ENV_STATE_OBSERVED_WEATHER_KIND 0x5
#define DIS204_ENV_STATE_COMBIC_PLUME_KIND 0x100
#define DIS204_ENV_STATE_COMBIC_PUFF_KIND 0x101
#define DIS204_ENV_STATE_EPHEMERIS_KIND 0x102
#define DIS204_ENV_STATE_FLARE_KIND 0x103
#define DIS204_ENV_STATE_NET_SEA_KIND 0x104
#define DIS204_ENV_STATE_VEH_DUST_KIND 0x502
#define DIS204_ENV_STATE_SIMULATION_DATE_KIND 0x500 /* Geometry Records */
#define DIS204_ENV_GEOMETRY_UNIFORM_KIND 0x50000
#define DIS204_ENV_GEOMETRY_POINT_KIND 0xa0000
#define DIS204_ENV_GEOMETRY_SPHEROID_KIND 0xd0000
#define DIS204_ENV_GEOMETRY_POLYGON_KIND 0x10000003
#define DIS204_ENV_GEOMETRY_EXTENTS_KIND 0x10000004
#define DIS204_ENV_GEOMETRY_SPHERICAL_COORDS_KIND 0x10000005
#define DIS204_ENV_GEOMETRY_GAUSSIAN_PLUME_KIND 0x60000000
#define DIS204_ENV_GEOMETRY_GAUSSIAN_PUFF_KIND 0x70000000
#define DIS204_ENV_GEOMETRY_CONE_KIND 0x30000000
#define DIS204_ENV_GEOMETRY_FLEX_PLUME_KIND 0x10000400

typedef uint32    DIS204_ENV_RECORD_KIND_TYPE; 

#define DIS204_ENV_SOURCE_POINT_DETONATION 0
#define DIS204_ENV_SOURCE_BARRAGE 1  

typedef uint32    DIS204_ENV_SOURCE_TYPE; 



#endif
