
/*
 * FILE:  p_dis204exp.h 
 *
 * Created on Wed Apr 17 10:52:44 1996 
 * Compiled by DRN compiler, version 6.2.d
 * 
 */

#ifndef _p_dis204exp_included
#define _p_dis204exp_included



/*
 * File:     p_dis204exp.drn
 * Contents: 
 * System:   BDS-D BIP development.
 * Created:  16-Dec-93
 * Author:   llovero
 *
 * Remarks:
 *
 * History:
 * 16-Dec-1993  Combined experimental AE PDU's with the experimental
 *              LOSAT PDU's to create this file.
 * 2-Dec-1993	Data entered in DRN format by mgreess from
 *		IRS DIS-Interface to SAFSim BL 5121 T058 document.
 *    
 *
 * $RCSfile: p_dis204exp.h,v $
 * $Revision: 1.1.1.1 $
 * $State: Exp $
 *
 * COPYRIGHT 1993 Loral Advanced Distributed Simulation
 * 50 Moulton Street
 * Cambridge, Ma. 02138
 * 617-873-3600
 *
 */

#include <stdtypes.h>
#include <p_dis203.h> 
#include <p_dis204.h> 
#include <dis203_types.h> 
#include <dis203exp_types.h> 
#include <dis203exp_values.h> 
#include <dis204_types.h> 

/*
 * Please note!  All hard-coded values that are found in the appendices
 * of the DIS document "Military Standard (Final Draft) Protocol Data
 * Units for Entity Information and Entity Interaction in a Distributed
 * Interactive Simulation" are defined in "dis204_values.drn".
 *
 * Also note that commonly used types and headers which are part of the
 * official DIS standard are defined in "dis204_types.drn".
 *
 * Atlas Environment PDU. (section 3.3.1.1.4, pages 31-32) (OBSOLETE)
 *
 */

typedef struct {
    DIS204_PDU_HEADER_RECORD pdu_header; 
    DIS203_ENTITY_ID_RECORD  entity_id; 
    DIS203_EVENT_ID_RECORD   event_id; 
    DIS203_CLOCK_TIME_RECORD time_of_day; 
    DIS203EXP_WEATHER_RECORD weather; 
} DIS204EXP_ENVIRONMENT_PDU; 


/*
 * Dynamic Terrain PDU.
 *
 */

typedef DIS204_ENTITY_STATE_PDU DIS204EXP_DYNAMIC_TERRAIN_ENTITY_PDU; 


/*
 * LOSAT Smoke PDU. Based on the Entity State PDU.  (OBSOLETE)
 *
 */

typedef struct {
    DIS204_PDU_HEADER_RECORD             pdu_header; 
    DIS203_ENTITY_ID_RECORD              smoke_id; 
    DIS203_FORCE_ID_TYPE                 force_id; 
     /*  data_valid is true if the smoke_parameters, downwind_distance, */
         /*  centroid_height, linear velocity and fill_weight are all valid. */

    uint8                           data_valid; 
    DIS203_ENTITY_TYPE_RECORD            smoke_type; 
    DIS203_LINEAR_VELOCITY_VECTOR_RECORD linear_velocity; 
    DIS203_WORLD_COORDINATES_RECORD      location; 
    DIS203_ENTITY_APPEARANCE_TYPE        appearance; 
    DIS203_VECTOR_RECORD                 wind_velocity; 
    float32                                   downwind_distance; 
    float32                                   centroid_height; 
    float32                                   num_sources; 
    float32                                   fill_weight; 
    DIS203EXP_SMOKE_RECORD               smoke_parameters; 
    DIS203_ENTITY_TYPE_RECORD            munition_type; 
} DIS204EXP_SMOKE_PDU; 


/*
 * New experimental environmental PDU.  Based loosely on Entity State PDU.
 * Follows some recommendations of DIS Environmental Subgroup, expands
 * upon others.
 *
 */

typedef struct {
    DIS204_PDU_HEADER_RECORD          pdu_header; 
    DIS203_ENTITY_ID_RECORD           env_id; 
    DIS203_ENTITY_TYPE_RECORD         env_type; 
    unsigned                             _unused_61         : 32;  /* padding */
    DIS203_ENV_MODEL_TYPE             env_model; 
    DIS203_ENV_STATUS_TYPE            env_status; 
    DIS203_ENV_NUMBER_OF_RECORDS_TYPE number_of_records; 
    DIS203_ENV_RECORD                 env_record[1]; 
} DIS204_ENVIRONMENTAL_PDU; 



#endif
