#ifndef lint
static char rcsid [] = "$RCSfile: bgrdb_init.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif
/****************************************************************************
*   File: bgrdb_init.c
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*	This software was developed by Loral under U. S. Government contracts *
*	and may be reproduced by or for the U. S. Government pursuant to    *
*	the copyright license under the clause at DFARS 252.227-7013        *
*	(OCT 1988).                                                         *
*                                                                           *
*       Contents: Code to initialize libbgrdb
*       Created: Wed Jul  7 12:39:13 EDT 1993
*       Author: ajc
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/

#ifdef USE_X

#include "libbgrdb_local.h"
#include <stdext.h> /*common/include/global*/
#include <libotmatch.h>

READER_UNION *bgrdb_size_table;
READER_UNION *bgrdb_role_table;
int32 bgrdb_db_key = -1;

/*
 * Initialize the library by loading up the data file.
 */
int32 bgrdb_init(directory, flags)
    char  *directory;
    uint32 flags;
{
    READER_UNION bgrdb_data;
    READER_UNION *mapping_table;

    int32 ret = reader_read("bgrdb.rdr", directory, &bgrdb_data,
			    flags & ~READER_TYPING);

    if (ret != 0)
      return ret;

    bgrdb_size_table = reader_find_tag(reader_get_symbol("sizes"),
				       bgrdb_data.array,
				       FALSE,
				       READER_ERRORS_WITH_CONTEXT);
    bgrdb_role_table = reader_find_tag(reader_get_symbol("roles"),
				       bgrdb_data.array,
				       FALSE,
				       READER_ERRORS_WITH_CONTEXT);
    
    mapping_table = reader_find_tag(reader_get_symbol("mappings"),
				    bgrdb_data.array,
				    FALSE,
				    READER_ERRORS_WITH_CONTEXT);

    bgrdb_db_key = 
      otm_incorporate_db((OTM_DB *)(mapping_table[2].array), TRUE, NULL);

    /* Initialze the new symbols we are added to BGR 
     * (from bgrdb_newelts.sym)
     */
    bgrdb_InstallBgrSymbols();

    return ret;
}

#else

int bgrdb_dummy_archive_variable;

#endif /*  USE_X */
