/*
 * $RCSfile: libbgrdb.h,v $ $Revision: 1.1.1.1 $ $State: Exp $
 */
/****************************************************************************
*   File: libbgrdb.h
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*	This software was developed by Loral under U. S. Government contracts *
*	and may be reproduced by or for the U. S. Government pursuant to    *
*	the copyright license under the clause at DFARS 252.227-7013        *
*	(OCT 1988).                                                         *
*                                                                           *
*       Contents: Public header file for libbgrdb
*       Created: Wed Jul  7 12:39:13 EDT 1993
*       Author: ajc
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/

#ifndef _LIBBGRDB_H_INCLUDED
#define _LIBBGRDB_H_INCLUDED

#ifdef __cplusplus
extern "C" {
#endif

#ifdef USE_X

#include <stdtypes.h> /*common/include/global*/
#include <basic.h>
#undef Time
#undef Boolean
#include <X11/Xlib.h>

#include <libbgr.h>

#include <libreader.h>

typedef struct bgrdb_pixmap_pool_element
{
    Pixmap                         pixmap;
    struct bgrdb_pixmap_pool_data *data;
} BGRDB_PIXMAP_POOL_ELEMENT;

/* bgrdb_init:
 *
 * Initializes libbgrdb.  Call this before calling any other libbgrdb
 * functions.
 */
extern int32
  bgrdb_init(/* char  *directory, 
		uint32 flags */);


/*
 * Allocate a pixmap from the pool or make a new one if needed.
 */
extern BGRDB_PIXMAP_POOL_ELEMENT *
  bgrdb_allocate_pixmap(/* Display    *display,
			   Drawable    window,
			   int32       depth,
			   int32       width,
			   int32       height */);

/*
 * Return a pooled pixmap back into the free pool
 */
extern void 
  bgrdb_deallocate_pixmap(/* BGRDB_PIXMAP_POOL_ELEMENT *pixmap */);

/*
 * Print statistics about the pixmap pool.
 */
extern void
  bgrdb_print_pixmap_pool_statistics();

extern void
  bgrdb_calculate_elements_and_extents(/* BgrSymbolElt  elts[],
					  int32        *nelts,
					  int32         max_desc_elts,
					  int32        *width,
					  int32        *height,
					  int32        *cx,
					  int32        *cy,
					  Display      *display,
					  GC            draw_gc,
					  int32         size,
					  int32         line_thickness,
					  float64       rotation,
					  int32         dashed,
					  char         *call_sign,
					  ObjectType    object_type,
					  READER_UNION *dfn */);

extern void
  bgrdb_draw_elements_to_pixmap(/* BgrSymbolElt elts[],
				   int32        nelts,
				   int32        cx,
				   int32        cy,
				   Display     *display,
				   GC           draw_gc,
				   Pixmap       pix */);

#endif /* USE_X */

#ifdef __cplusplus
}
#endif /*__cplusplus */

#endif /*_LIBBGRDB_H_INCLUDED*/
