#ifndef lint
static char rcsid [] = "$RCSfile: cb_create.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif
/****************************************************************************
*   File: cb_create.c                                                       *
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*       This software was developed by Loral under U. S. Government contracts *
*       and may be reproduced by or for the U. S. Government pursuant to    *
*       the copyright license under the clause at DFARS 252.227-7013        *
*       (OCT 1988).                                                         *
*                                                                           *
*       Contents: Creates an event so handlers can be registered for it     *
*       Created: Wed Feb 26 1990                                            *
*       Author: jesmith                                                     *
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/

#include "libcb_local.h"
#include <stdext.h> /*common/include/global*/
#include <stdalloc.h> /*common/include/global*/
#include <stdarg.h>

/*VARARGS*/
CALLBACK_EVENT_PTR callback_define_event(int32 arg, ...)
{
    CB_EVENT *ev;
    int32 i;
    va_list ap;

    ev = (CB_EVENT *)STDALLOC(sizeof(CB_EVENT));

    va_start(ap, arg);
    for (i=0;i<CALLBACK_MAX_ARGS;i++)
    {
	ev->arg_types[i] = arg;
	if (ev->arg_types[i] == A_END)
	  break;
	arg = va_arg(ap, int);
    }
    va_end(args);

    ev->nargs = i;
    ev->nhandlers = 0;
    ev->nacthandlers = 0;
    ev->handlers = (CB_HANDLER *)0;

    return ev;
}

void callback_destroy_event(CALLBACK_EVENT_PTR ev)
{
    if (ev->nhandlers > 0)
      STDDEALLOC(ev->handlers);

    /* In case someone accidently uses this later */
    ev->nhandlers = -1;
    ev->nacthandlers = -1;
    ev->handlers = (CB_HANDLER *)0;

    /* This check of executing flag is required, since its possible that
     * the cb_invoke() may still be checking the contents of ev
     * after this returns, but a malloc on the deallocated pointer
     * could have blown away the -l in the nhandlers.  Therefore,
     * the dealloc will be deferred.
     */
    if (!ev->executing)
      STDDEALLOC(ev);
}
