/*
 * $RCSfile: libclass_local.h,v $ $Revision: 1.1.1.1 $ $State: Exp $
 */
/****************************************************************************
*   File: libclass_local.h                                                  *
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*       This software was developed by Loral under U. S. Government contracts *
*       and may be reproduced by or for the U. S. Government pursuant to    *
*       the copyright license under the clause at DFARS 252.227-7013        *
*       (OCT 1988).                                                         *
*                                                                           *
*       Contents: Private header file for libclass                          *
*       Created: Tue Mar 24 1990                                            *
*       Author: jesmith                                                     *
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/

#include "libclass.h"

#define MAX_SLOT_NAME_LEN 128

/* We create one of these for each class */
typedef struct class_info
{
    int32 number;
    int32 num_slots;
    struct class_slot_info *slots;
    struct class_info *next;
    char *debug_flags;
} CLASS_INFO;

/* And we create one of these for each slot in a class */
typedef struct class_slot_info
{
    int32 number;
    char name[MAX_SLOT_NAME_LEN];
    CLASS_PRINTER printer;
    struct class_slot_info *next;
} CLASS_SLOT_INFO;

/* This is stored in the 0'th slot of each instance */
typedef struct class_special_info
{
    CLASS_INFO *class;
    char *debug_flags;
    CLASS_USER_DATA_TYPE global_data;
} CLASS_SPECIAL_INFO;

/* class_alloc_debug_flags: PRIVATE FUNCTION
 *
 * Allocates a block of memory large enough to hold a debug bit for each
 * slot.
 */
extern char *class_alloc_debug_flags(int32 num_slots);

/* class_classes: VERY PRIVATE FUNCTION
 *
 * Returns the head of the global class list.
 */
extern CLASS_INFO *class_classes(void);
