#ifndef lint
static char rcsid [] = "$RCSfile: test.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif
/****************************************************************************
*   File: test.c                                                            *
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*       This software was developed by Loral under U. S. Government contracts *
*       and may be reproduced by or for the U. S. Government pursuant to    *
*       the copyright license under the clause at DFARS 252.227-7013        *
*       (OCT 1988).                                                         *
*                                                                           *
*       Contents: Simple little class test program                          *
*       Created: Tue Mar 24 1990                                            *
*       Author: jesmith                                                     *
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/

#include "libclass.h"

#include <stdio.h>

CLASS_PTR class_a_handle;
CLASS_PTR class_b_handle;

int32 a_part_0;
int32 a_part_1;
int32 a_part_2;

int32 b_part_0;
int32 b_part_1;
int32 b_part_2;

void a0_print(data)
    char *data;
{
    printf("a0: %s\n", data);
}

void a1_print(data)
    char *data;
{
    printf("a1: %s\n", data);
}

void a2_print(data)
    char *data;
{
    printf("a2: %s\n", data);
}

main()
{
    int32 a[2];
    int32 b;

    /* Create a couple classes */
    class_a_handle = class_declare_class();
    class_b_handle = class_declare_class();

    /* Define the parts of class a */
    a_part_0 = class_reserve_user_data(class_a_handle, "a0", a0_print);
    a_part_1 = class_reserve_user_data(class_a_handle, "a1", a1_print);
    a_part_2 = class_reserve_user_data(class_a_handle, "a2", a2_print);

    /* Define the parts of class b, and be lazy about the names and
     * printers.
     */
    b_part_0 = class_reserve_user_data(class_b_handle, 0, 0);
    b_part_1 = class_reserve_user_data(class_b_handle, 0, 0);
    b_part_2 = class_reserve_user_data(class_b_handle, 0, 0);

    /* Make an instance of an 'a' */
    a[0] = (int32)class_alloc_user_data(class_a_handle);
    
    /* Fill in the parts */
    class_set_user_data(a[0], a_part_0, "Instance 1: part 0");
    class_set_user_data(a[0], a_part_1, "Instance 1: part 1");
    class_set_user_data(a[0], a_part_2, "Instance 1: part 2");

    /* Make another instance of an 'a' */
    a[1] = (int32)class_alloc_user_data(class_a_handle);
    
    /* Fill in the parts (leave part 1 empty) */
    class_set_user_data(a[1], a_part_0, "Instance 2: part 0");
    class_set_user_data(a[1], a_part_2, "Instance 2: part 2");

    /* Make an instance of a 'b' */
    b = (int32)class_alloc_user_data(class_b_handle);

    /* Fill in the parts */
    class_set_user_data(b, b_part_0, 1);
    class_set_user_data(b, b_part_1, 2);
    class_set_user_data(b, b_part_2, 3);

    printf ("class slot names:\n");
    class_show_names();

    /* Get the b data */
    printf("b data:  %d %d %d\n",
	   (int32)class_get_user_data(b, b_part_0),
	   (int32)class_get_user_data(b, b_part_1),
	   (int32)class_get_user_data(b, b_part_2));

    /* Show all the a[0] data */
    class_show(a[0], "all");

    /* Show some of the a[1] data */
    class_show(a[1], "a0 a2");

    /* Test the debug flags */
    while(1)
    {
	char s[80];
	int32 block, bit;
	int32 i;

	printf("[12]? "); fflush(stdout);
	gets(s);
	switch(s[0])
	{
	  case '1': block = a[0]; break;
	  case '2': block = a[1]; break;
	  case 'q': exit(0);
	  default: block = 0;
	}
	printf("[+-]? "); fflush(stdout);
	gets(s);
	switch(s[0])
	{
	  case '+': bit = 1; break;
	  case '-': bit = 0; break;
	  default: printf("?"); fflush(stdout); continue;
	}
	printf("<name>? "); fflush(stdout);
	gets(s);

	class_debug_byname(block, s, bit);

	for (i=0;i<2;i++)
	{
	    CLASS_DEBUG(a[i], a_part_0, ("%d: Part 0\n", i+1));
	    CLASS_DEBUG(a[i], a_part_1, ("%d: Part 1\n", i+1));
	    CLASS_DEBUG(a[i], a_part_2, ("%d: Part 2\n", i+1));
	}
    }

}
