#ifndef lint
static char rcsid [] = "$RCSfile: test.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif
/****************************************************************************
*   File: test.c                                                            *
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*       This software was developed by Loral under U. S. Government contracts*
*       and may be reproduced by or for the U. S. Government pursuant to    *
*       the copyright license under the clause at DFARS 252.227-7013        *
*       (OCT 1988).                                                         *
*                                                                           *
*       Contents: Simple test program                                       *
*       Created: Wed Mar 20 1996                                            *
*       Author: jesmith                                                     *
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/

#include "libconstants.h"
#include <libreader.h>
#include <stdext.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdstring.h>

static char *datafn = "common/data/constants";

int main(int argc, char *argv[])
{
    int32 value, v2;
    char *name;
    char commondir[256];
    char *commonptr, *nextcommon;
    char datadir[256];

    if (argc < 2)
    {
	printf("Usage: %s [dump | <name> | <namespace> <value> | <from ns> <to ns> <value>]\n", argv[0]);
	exit(0);
    }

    /* Figure out where we are compared to common */
    if (!getcwd(commondir, 255))
      exit(0);

    /* Find the first occurence of "common" */
    if(!(commonptr = strstr(commondir, "common")))
    {
        printf("\n%s: must be run in the common tree.\n", argv[0]);
        exit(0);
    }
    
    /* Make sure it's the last common */
    while (nextcommon = strstr(commonptr+1, "common"))
      commonptr = nextcommon;

    bcopy(commondir, datadir, commonptr - commondir);
    bcopy(datafn, datadir + (commonptr - commondir), strlen(datafn) + 1);


    reader_init(FALSE);
    const_init(datadir);

    if (!strcmp(argv[1], "dump"))
    {
	const_dump();
    }
    else if (argc == 2)
    {
	value = const_name_to_value(name = reader_get_symbol(argv[1]));
	printf("%s = %d (%x)\n", name, value, value);
    }
    else if (argc == 3)
    {
	value = atoi(argv[2]);
	name = const_value_to_name(reader_get_symbol(argv[1]), value);
	printf("%s = %d (%x)\n", name, value, value);
    }
    else if (argc == 4)
    {
	value = atoi(argv[3]);
	v2 = const_convert_namespace(value,
				     reader_get_symbol(argv[1]),
				     reader_get_symbol(argv[2]));
	printf("%d (%x) in %s -> %d (%x) in %s\n",
	       value, value, argv[1],
	       v2, v2, argv[2]);
    }
    return(0);
}
