#ifndef lint
static char rcsid [] = "$RCSfile: geo2utm.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif
/****************************************************************************
*   File: geo2utm.c                                                         *
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*       This software was developed by Loral under U. S. Government contracts *
*       and may be reproduced by or for the U. S. Government pursuant to    *
*       the copyright license under the clause at DFARS 252.227-7013        *
*       (OCT 1988).                                                         *
*                                                                           *
*       Contents: Converts command line latitude/longitude to UTM           *
*       Created: Thu Sep 10 1992                                            *
*       Author: jesmith                                                     *
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/

#include "libcoord_local.h"

main(argc,argv)
    int32 argc;
    char *argv[];
{
    float64 northing, easting;
    int32 datum, zone;
    float64 latitude, longitude;
    extern float64 atof();

    if (argc != 5)
    {
	printf("usage: %s zone (+N/-S)latitude (+E/-W)longitude datum\n(run 'datums' for list of datums)\n", argv[0]);
	exit(0);
    }

    if (coord_init(".", 0) != 0)
      exit(0);

    zone = atoi(argv[1]);
    latitude = atof(argv[2]);
    longitude = atof(argv[3]);
    datum = atoi(argv[4]);

    coord_ll_to_utm(datum, latitude, longitude, &zone, &northing, &easting);

    printf("%d %d\n",(int32)(northing+0.5),(int32)(easting+0.5));
}
