#ifndef lint
static char rcsid [] = "$RCSfile: utm2geo.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif
/****************************************************************************
*   File: utm2geo.c                                                         *
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*       This software was developed by Loral under U. S. Government contracts *
*       and may be reproduced by or for the U. S. Government pursuant to    *
*       the copyright license under the clause at DFARS 252.227-7013        *
*       (OCT 1988).                                                         *
*                                                                           *
*       Contents: Converts command line UTM to latitude/longitude           *
*       Created: Thu Sep 10 1992                                            *
*       Author: jesmith                                                     *
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/

#include "libcoord_local.h"

main(argc,argv)
    int32 argc;
    char *argv[];
{
    float64 northing, easting;
    int32 datum, zone;
    float64 latitude, longitude;

    if (argc != 5)
    {
	printf("usage: %s zone northing easting datum\n(run 'datums' for list of datums)\n", argv[0]);
	exit(0);
    }

    if (coord_init(".", 0) != 0)
      exit(0);

    zone = atoi(argv[1]);
    northing = atoi(argv[2]);
    easting = atoi(argv[3]);
    datum = atoi(argv[4]);

    coord_utm_to_ll(datum, northing, easting, zone, &latitude, &longitude);

    printf("%f %f\n", latitude, longitude);
}

    

