/*
 * $RCSfile: ct_coalesce.h,v $ $Revision: 1.1.1.1 $ $State: Exp $
 */
/****************************************************************************
*   File: ct_coalesce.h                                                     *
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*       This software was developed by Loral under U. S. Government contracts *
*       and may be reproduced by or for the U. S. Government pursuant to    *
*       the copyright license under the clause at DFARS 252.227-7013        *
*       (OCT 1988).                                                         *
*                                                                           *
*       Contents: CTDB polygon coalesce interface structures                *
*       Created: Thu Feb  8 1996                                            *
*       Author: mlongtin                                                    *
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/

#ifndef _CT_COALESCE_H_INCLUDED
#define _CT_COALESCE_H_INCLUDED

#include <stdtypes.h>

typedef struct polygon
{
    float32 vertex[2];
    struct polygon *next;
} CTDB_COALESCE_POLYGON;

typedef struct src_poly
{
    /* The source polygon is either a 3-sided or a 4-sided polygon. */
    float32 verts[4][3];
    int32   is_3_sided;
} CTDB_COALESCE_SRC_POLY;

void ctdb_coalesce_deallocate_polygon(
				      CTDB_COALESCE_POLYGON *output_polys[],
				      int32                  polygon_number);

void ctdb_coalesce_store_polygon(
				 CTDB_COALESCE_POLYGON *output_polys[],
				 int32                  slot,
				 float64                poly[],
				 int32                  n_verts);

void ctdb_coalesce_polygons(
			    CTDB_COALESCE_SRC_POLY src_polys[],
			    int32                  n_src_polys,
			    CTDB_COALESCE_POLYGON *output_polys[],
			    int32                 *n_output_polys);

#endif /*_CT_COALESCE_H_INCLUDED*/
