#ifndef lint
static char rcsid [] = "$RCSfile: ct_route.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif
/****************************************************************************
*   File: ct_route.c                                                        *
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*       This software was developed by Loral under U. S. Government contracts*
*       and may be reproduced by or for the U. S. Government pursuant to    *
*       the copyright license under the clause at DFARS 252.227-7013        *
*       (OCT 1988).                                                         *
*                                                                           *
*       Contents: Generates a contour route between two points              *
*       Created: Sun Aug 22 1993                                            *
*       Author: jesmith                                                     *
*       Remarks: This was an experimental algorithm which, it turns out,    *
*                didn't work very well.  We've left the rigging in place    *
*                in case anyone comes up with a better algorithm.           *
****************************************************************************/

#include "libctdb_local.h"

void ctdb_contour_route(CTDB *ctdb, 
			float64 x0, 
			float64 y0,
			float64 x1, 
			float64 y1, 
			float64 max_deviation, 
			int32 direction, 
			float64 sin_slope, 
			int32 *n_route,
			ROUTE_POINT *route)
{
    float64 lat, lng, h;
    
    if (!ctdb)
    {
	*n_route = 0;
	return;
    }
    /* Make sure we have enough room */
    if (*n_route < 2)
    {
	*n_route = 0;
	return;
    }

    /* Store the first point */
    route[0].point[X] = x0;
    route[0].point[Y] = y0;
    route[0].point[Z] = ctdb_lookup_elevation_amsl(ctdb,x0,y0);
    /* Store the last point */
    route[1].point[X] = x1;
    route[1].point[Y] = y1;
    route[1].point[Z] = ctdb_lookup_elevation_amsl(ctdb,x1,y1); 
    *n_route = 2;
}






