#ifndef lint
static char rcsid [] = "$RCSfile: ascii.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif
/****************************************************************************
*   File: ascii.c                                                          *
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*       This software was developed by Loral under U. S. Government contracts*
*       and may be reproduced by or for the U. S. Government pursuant to    *
*       the copyright license under the clause at DFARS 252.227-7013        *
*       (OCT 1988).                                                         *
*                                                                           *
*       Contents: Prints database in ASCII format                           *
*       Created: Thu Jul 29 EDT 1993                                        *
*       Author: ajc                                                         *
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/

#include <stdio.h>
#include "../libctdb_local.h"

main(
    int32 argc,
    argv_t argv)
{
    CTDB ctdb;
    int32 i, j;
    CTDB_POST_STAT stat;
    char *filename;
    
    bzero((void*)&stat,sizeof(stat));

    if (argc != 3)
    {
	printf("Usage: %s <s1000 identifier> <path>\n", argv[0]);
	exit(0);
    }

    filename=ctdb_generate_tdb_filename(CTDB_MODE_SIMNET, argv[2],
					argv[1], CTDB_FILE_FORMAT, 0, FALSE);
    
    ctdb_read(filename,&ctdb,0);

    ctdb_print_description(&ctdb);

    for (j = 0; j < ctdb.patches_high; j++)
      for (i = 0; i < ctdb.patches_wide; i++)
      {
	  ctdb_print_features(&ctdb, i, j);
	  ctdb_print_posts(&ctdb, i, j, &stat);
      }

    printf("\n\n----Grid Post analysis:\n");

    printf("  %d posts, of which\n   %d have features, %d have buildings, %d have trees, %d have micro\n",
	   stat.posts, stat.features, stat.buildings, stat.trees, stat.micro);
    printf(" % microterrain = %.4f %%\n",
	   (((float64) stat.micro) * 100.0) / (float64) stat.posts);

}
