#ifndef lint
static char rcsid [] = "$RCSfile: header.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif
/****************************************************************************
*   File: header.c                                                          *
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*       This software was developed by Loral under U. S. Government contracts*
*       and may be reproduced by or for the U. S. Government pursuant to    *
*       the copyright license under the clause at DFARS 252.227-7013        *
*       (OCT 1988).                                                         *
*                                                                           *
*       Contents: Program to print the database header                      *
*       Created: Tue Jul 13 1993                                            *
*       Author: aevans                                                      *
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/

#include <stdio.h>
#include "libctdb.h"


CTDB ctdb;

main (argc,argv)
    int32 argc;
    char *argv[];

{
    CTDB_FILE_HEADER hdr;
    CTDB_AUX_FILE_HEADER aux;
    FILE *fin;
    int32 i;
    
    if (!(fin = fopen(argv[1], "r")))
    {
	perror("Unable to open input file");
	exit(-1);
    }

    /* Read the header */
    if (fread(&hdr, sizeof(hdr), 1, fin) != 1)
    {
	perror("Unable to read header");
	exit(-1);
    }    

    /* Read the aux header */
    if (fread(&aux, sizeof(aux), 1, fin) != 1)
    {
	perror("Unable to read aux header");
	exit(-1);
    }    

#define SHOWARRAY(src,var,index)	      	       \
    printf(#var "[%d]:\t%d\n ",index,src.var[index]);  \
    fflush(stdout);				       \

#define SHOWINT(src,var)				\
    printf(#var ":\t%d\n", src.var);			\
    fflush(stdout);					\

#define SHOWCHAR(src,var)				\
    printf(#var ":\t%c\n", src.var);			\
    fflush(stdout);					\

#define SHOWFLOAT(src,var)				\
    printf(#var ":\t%f\n", src.var);			\
    fflush(stdout);					\

#define SHOWSTRING(src, var, len)			\
    printf(#var ":\t%s\n", src.var);			\
    fflush(stdout);					\

    if (argc != 2)
    {
	printf("Usage: %s <fn.ctb>\n", argv[0]);
	exit(0);
    }

    SHOWINT(hdr, format);
    SHOWINT(hdr, is_curved);
    SHOWINT(hdr, pad0);
    SHOWINT(hdr, is_gridded);
    SHOWINT(hdr, is_tinned);
    SHOWINT(hdr, pad1);
    SHOWFLOAT(hdr, fixed_point_basis);
    for (i=0;i<CTDB_HEADER_RESERVED;i++)
    {
	SHOWARRAY(hdr, reserved1,i);
    }
    SHOWINT(hdr, post_increment);
    SHOWINT(hdr, posts_per_patch_side);
    SHOWINT(hdr, pages_wide);
    SHOWINT(hdr, pages_high);
    SHOWINT(hdr, min_x);
    SHOWINT(hdr, max_x);
    SHOWINT(hdr, min_y);
    SHOWINT(hdr, max_y);
    SHOWINT(hdr, num_features);
    for(i=0;i<CTDB_PATCH_CACHES;i++)
    {
	SHOWARRAY(hdr, patch_cache_size_map, i);
    }
    SHOWINT(hdr, pad2);
    SHOWFLOAT(hdr, origin_northing);
    SHOWFLOAT(hdr, origin_easting);
    SHOWINT(hdr, origin_zone_number);
    SHOWCHAR(hdr, origin_zone_letter);
    SHOWINT(hdr, datum);
    SHOWSTRING(hdr, name, CTDB_NAME_LENGTH);
    SHOWINT(hdr, version);
    SHOWSTRING(hdr, date, CTDB_DATE_LENGTH);
    SHOWINT(hdr, num_nodes);
    SHOWINT(hdr, node_size);
    SHOWINT(hdr, num_edges);
    SHOWINT(hdr, edge_size);
    SHOWINT(hdr, num_quad_data);
    SHOWINT(hdr, n_patch_bytes);
    SHOWINT(hdr, num_linear_models);
    SHOWINT(hdr, num_volume_models);
    SHOWINT(hdr, aux_hdr_bytes);
    SHOWINT(hdr, num_soil_tables);
    SHOWINT(hdr, soil_table_size);
    SHOWINT(hdr, num_water_chars);
    SHOWINT(hdr, num_tidal_zones);
    SHOWINT(hdr, num_aggregate_models);
    SHOWINT(hdr, num_mes_volumes);
    SHOWINT(hdr, num_mes_templates);
    
    printf("\n--AUX HEADER--\n");
    
    printf("\n gcs_mode values:\n");
    printf("0.\tSIMNET mode\n");
    printf("1.\tGCS single-cell mode\n");
    printf("2.\tGCS multi-cell mode\n");
    
    SHOWINT(aux, gcs_mode);
    SHOWINT(aux, pad1);
    SHOWINT(aux, cell_id);
    SHOWINT(aux, origin_x);
    SHOWINT(aux, origin_y);
    SHOWFLOAT(aux, west_long);
    SHOWFLOAT(aux, east_long);
    SHOWFLOAT(aux, south_lat);
    SHOWFLOAT(aux, north_lat);
    
}
