#ifndef lint
static char rcsid [] = "$RCSfile: post_test.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif
/****************************************************************************
*   File: post_test.c
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*       This software was developed by Loral under U. S. Government contracts *
*       and may be reproduced by or for the U. S. Government pursuant to    *
*       the copyright license under the clause at DFARS 252.227-7013        *
*       (OCT 1988).                                                         *
*                                                                           *
*       Contents: Xwindows test program for libctdb                         *
*       Created: Mon Apr 15 1990                                            *
*       Author: jesmith                                                     *
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/

#undef PARANOID

#include <stdio.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <Xm/Xm.h>
#include <Xm/Form.h>
#include <Xm/Scale.h>
#include <Xm/DrawingA.h>
#include <Xm/Text.h>
#include <X11/cursorfont.h>
#include <libctdb.h>
#include "../libctdb_local.h"

#define SIZE 10
#define INIT_WIDTH 500
#define INIT_HEIGHT 500

#define BUTTON 1
int32 dragging;
int32 ix0=0, ix1=0, iy0=0, iy1=0;
Dimension width=INIT_WIDTH;
Dimension height=INIT_HEIGHT;

CTDB ctdb;

#define SX(x) (int32)((x) + (ctdb.incr)/2)
#define SY(y) (int32)(INIT_HEIGHT + (ctdb.incr)/2 - (y))
#define PX(x) (float64)((x) - (ctdb.incr)/2)
#define PY(y) (float64)(INIT_HEIGHT  + (ctdb.incr)/2 - (y))

XtAppContext g_app_context = NULL;
Widget toplevel = NULL;
Widget g_dialog_shell;
Widget area;
GC line_gc, post_gc;

int32 inters[1000][4];
int32 inters_count;

int32 serial;

always_fv()
{
    return VIS_KEEP_GOING;
}

start_line()
{
    serial = 0;
    inters_count = 0;
}

draw_intersect(ign,x,y,z1,z2,ign2)
    CTDB  *ign;
    float64 x,y,z1,z2;
    float64 ign2;
{
    int32 dx,dy;
    char buf[10];

    x *= ctdb.incr;
    y *= ctdb.incr;

    if (z1 != z2)
      printf("%f != %f\n",z1,z2);

    /* Draw the little X at the intersection */
    XDrawLine(XtDisplay(area), XtWindow(area), line_gc,
	      SX(x)-SIZE/2, SY(y)-SIZE/2, SX(x)+SIZE/2, SY(y)+SIZE/2);
    XDrawLine(XtDisplay(area), XtWindow(area), line_gc,
	      SX(x)-SIZE/2, SY(y)+SIZE/2, SX(x)+SIZE/2, SY(y)-SIZE/2);

    /* Label the Z value */
/*
    sprintf(buf,"%3.2f",z1);
    XDrawString(XtDisplay(area), XtWindow(area),
		line_gc, SX(x)+SIZE/2, SY(y), buf, strlen(buf));
*/

#ifdef PARANOID
    inters[inters_count][0] = PX(x0);
    inters[inters_count][1] = PY(y0);
    inters[inters_count][2] = PX(x1);
    inters[inters_count][3] = PY(y1);

    inters_count++;
#endif

    /* Keep going */
    return TRUE;
}

end_line()
{
    int32 i,j;

    for(i=0;i<inters_count;i++)
      for(j=i+1;j<inters_count;j++)
      {
	  if (((inters[i][0] == inters[j][0]) &&
	       (inters[i][1] == inters[j][1]) &&
	       (inters[i][2] == inters[j][2]) &&
	       (inters[i][3] == inters[j][3])) ||
	      ((inters[i][0] == inters[j][2]) &&
	       (inters[i][1] == inters[j][3]) &&
	       (inters[i][2] == inters[j][0]) &&
	       (inters[i][3] == inters[j][1])))
	    printf("%d=%d: %d %d %d %d\n",
		   i,j,inters[i][0],inters[i][1],inters[i][2],inters[i][3]);
      }
}

erase_line()
{
    int32 x,y,w,h;

    if (ix0>ix1)
      x = ix1, w = ix0-ix1;
    else
      x = ix0, w = ix1-ix0;
    if (iy0>iy1)
      y = iy1, h = iy0-iy1;
    else
      y = iy0, h = iy1-iy0;

#define BUF (2*(ctdb.incr)+SIZE)

    XClearArea(XtDisplay(area), XtWindow(area),
	       x-BUF,y-BUF,w+2*BUF,h+2*BUF,
	       FALSE);
}

lookup() { return 0; }

draw_line()
{
    float64 start[3];
    float64 end[4];

#ifdef PARANOID
    /* Sanity check: start_line, draw_intersect, and end_line make sure
     * we NEVER draw the same line twice.  The whole point of this routine
     * is to generate each test only once, and in the right order.
     */
    start_line();
#endif

    start[0] = ctdb.inv_incr * PX(ix0);
    start[1] = ctdb.inv_incr * PY(iy0);
    start[2] = 0.0;
    end[0] = ctdb.inv_incr * PX(ix1);
    end[1] = ctdb.inv_incr * PY(iy1);
    end[2] = end[3] = 100.0;
    ctdb_intervis(&ctdb,
		  start, end,
		  lookup,draw_intersect,always_fv,0);

#ifdef PARANOID
    end_line();
#endif

    XDrawLine(XtDisplay(area), XtWindow(area), line_gc,
	      ix0, iy0, ix1, iy1);
}

do_intervis(w,ignored,event)
    Widget  w;
    int32     ignored;
    XEvent *event;
{
    if (event->xbutton.button != BUTTON)
      return;

    erase_line();

    dragging = TRUE;

    ix0 = ix1 = event->xbutton.x;
    iy0 = iy1 = event->xbutton.y;

    draw_line();
}

drag_intervis(map_area, ignored, event)
    Widget  map_area;
    int32     ignored;
    XEvent *event;
{
    if (!dragging)
      return;

    erase_line();

    ix1 = event->xbutton.x;
    iy1 = event->xbutton.y;

    draw_line();
}

release_intervis(w,ignored,event)
    Widget  w;
    int32     ignored;
    XEvent *event;
{
    if (event->xbutton.button != BUTTON)
      return;

    dragging = FALSE;
}

resize_area(w,ignored,call_data)
    Widget                       w;
    int32                          ignored;
    XmDrawingAreaCallbackStruct *call_data;
{
    int32 x,y;
    Arg args[2];

    XtSetArg(args[0], XmNwidth, &width);
    XtSetArg(args[1], XmNheight, &height);
    XtGetValues(w, args, XtNumber(args));
}

expose_area()
{
    draw_line();
}

circle_post() {};
draw_micro_poly() {};

fill_post(x,y)
    int32 x,y;
{
    x *= ctdb.incr;
    y *= ctdb.incr;

    /* Draw the crossed line */
    XDrawArc(XtDisplay(area), XtWindow(area), post_gc,
	      SX(x)-5, SY(y)-5, 10,10, 0,64*360);
}

static Arg form_args[] = { { XmNresizePolicy , XmRESIZE_NONE } ,
			   { XmNwidth , INIT_WIDTH } ,
			   { XmNheight , INIT_HEIGHT } ,
			 };

init_x(argc,argv)
    int32   argc;
    char *argv[];
{
    int32 copy_argc = argc;
    int32 i;
    char buf[20];
    Widget form;
    XGCValues gcv;
    GC back_gc;
    Pixmap pix;
    Arg pix_arg;

    toplevel = XtInitialize(argv[0],"POTest", NULL, 0,
			    &copy_argc,argv);
    g_dialog_shell = toplevel;

    g_app_context = XtWidgetToApplicationContext(toplevel);

    area = XtCreateManagedWidget("area", xmDrawingAreaWidgetClass,
				 toplevel, NULL, 0);

    XtAddCallback(area, XmNresizeCallback, resize_area, NULL);
    XtAddCallback(area, XmNexposeCallback, expose_area, NULL);

    XtRealizeWidget(toplevel);

    gcv.foreground = BlackPixelOfScreen(XtScreen(area));
    line_gc = XCreateGC(XtDisplay(area), XtWindow(area),
			GCForeground , &gcv);

    gcv.foreground = WhitePixelOfScreen(XtScreen(area));
    gcv.line_width = 2;
    post_gc = XCreateGC(XtDisplay(area), XtWindow(area),
			GCForeground | GCLineWidth , &gcv);

    pix = XCreatePixmap(XtDisplay(area), XtWindow(area), (ctdb.incr), (ctdb.incr),
			DefaultDepthOfScreen(XtScreen(area)));

    /* Clear out the pixmap */
    XtSetArg(pix_arg, XmNbackground, &gcv.foreground);
    XtGetValues(area, &pix_arg, 1);
    back_gc = XCreateGC(XtDisplay(area), XtWindow(area),
			GCForeground , &gcv);
    XFillRectangle(XtDisplay(area), pix, back_gc, 0, 0, (ctdb.incr), (ctdb.incr));

    /* Draw post pattern */
    XtSetArg(pix_arg, XmNforeground, &gcv.foreground);
    XtGetValues(area, &pix_arg, 1);
    XChangeGC(XtDisplay(area), back_gc,
	      GCForeground , &gcv);
    XDrawArc(XtDisplay(toplevel), pix, back_gc,
	     (ctdb.incr)/2-SIZE/2, (ctdb.incr)/2-SIZE/2, SIZE, SIZE,
	     0, 64*360);
    XDrawLine(XtDisplay(toplevel), pix, back_gc,
	      0, (ctdb.incr)/2, (ctdb.incr), (ctdb.incr)/2);
    XDrawLine(XtDisplay(toplevel), pix, back_gc,
	      (ctdb.incr)/2, 0, (ctdb.incr)/2, (ctdb.incr));
    if (ctdb.is_sw_ne)
      XDrawLine(XtDisplay(toplevel), pix, back_gc,
		0, (ctdb.incr)-1, (ctdb.incr)-1, 0);
    else
      XDrawLine(XtDisplay(toplevel), pix, back_gc,
		0, 0, (ctdb.incr)-1, (ctdb.incr)-1);

    XtSetArg(pix_arg, XmNbackgroundPixmap, pix);
    XtSetValues(area, &pix_arg, 1);

    XtAddEventHandler(area, ButtonPressMask, FALSE,
		      do_intervis, NULL);
    XtAddEventHandler(area, ButtonMotionMask, FALSE,
		      drag_intervis, NULL);
    XtAddEventHandler(area, ButtonReleaseMask, FALSE,
		      release_intervis, NULL);

    XGrabButton(XtDisplay(area), Button1, AnyModifier, XtWindow(area), TRUE,
		ButtonPressMask | ButtonMotionMask | ButtonReleaseMask,
		GrabModeAsync, GrabModeAsync, XtWindow(area),
		XCreateFontCursor(XtDisplay(area), XC_crosshair));
}

main(argc,argv)
    int32   argc;
    char *argv[];
{
    int32 copy_argc = argc;

    if (copy_argc != 2)
    {
	printf("Usage: %s <database.ctdb>\n", argv[0]);
	exit(0);
    }

    ctdb_read(argv[1],&ctdb,0);

    ctdb_print_description(&ctdb);

    init_x(argc,argv);

    XtAppMainLoop(g_app_context);
}
