#ifndef lint
static char rcsid [] = "$RCSfile: profile_tdb.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif
/****************************************************************************
*   File: profile_tdb.c                                                     *
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*       This software was developed by Loral under U. S. Government contracts *
*       and may be reproduced by or for the U. S. Government pursuant to    *
*       the copyright license under the clause at DFARS 252.227-7013        *
*       (OCT 1988).                                                         *
*                                                                           *
*       Contents: Test program which uses old tdb format                    *
*       Created: Thu May 23 1990                                            *
*       Author: jesmith                                                     *
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/

#include <tdb.h>
#include <pvis_call.h>
#include <sys/types.h>
#include <sys/timeb.h>

PATCH_GUARD *g_patch_guard;

/* !STRESS_MICRO ~600us
 *  STRESS_MICRO ~460us
 */

/*#define STRESS_MICRO*/

pv_intervis(x0,y0,x1,y1,doit)
    float64 x0,y0,x1,y1;
{
    PV_PARAMS vis_params;

    vis_params.eye_pt[0] = x0;
    vis_params.eye_pt[1] = y0;
    tdb_get_z(vis_params.eye_pt);
    vis_params.eye_pt[3] = vis_params.eye_pt[2]+2.0;

    vis_params.targ_pt[0] = x1;
    vis_params.targ_pt[1] = y1;
    tdb_get_z(vis_params.targ_pt);
    vis_params.targ_pt[2] += 0.5;
    vis_params.targ_pt[3] = vis_params.targ_pt[2]+1.5;

    vis_params.guardp = g_patch_guard;

    vis_params.vis_tests = PV_PT_TO_PT;

    if (doit)
      return(pve_checkvis(&vis_params));
    else
      return 0;
}

#ifdef STRESS_MICRO
#define CX 42493.0
#define CY 37501.0
#else
#define CX 31252.0
#define CY 35733.0
#endif

#define SIZE 1500.0
/*
#define STEP 10.0
*/
#define STEP 249

main (argc, argv)
    int32 argc;
    char *argv[];
{
    int32 i,j;
    float64 x,y;
    struct timeb tloc;
    uint32 start, middle, end;
    int32 v;
    float64 dx, dy;

    if (tdb_init_memory("/saf/terrain/knox-0311/Knox.0400") == -1)
    {
	printf("Unable to init terrain: %s\n",
	       tdb_error());
	exit(1);
    }

    g_patch_guard = (PATCH_GUARD *)tdb_init_patch_guards();

    ftime(&tloc);
    start = tloc.time * 1000 + tloc.millitm;

    i = 0;
    srand(0);
    for (x=3500;x<tdb_info.db_header.db_info.max_x-3500;x+=STEP)
      for (y=3500;y<tdb_info.db_header.db_info.max_y-3500;y+=STEP,i++)
      {
	  dx = 1500.0-3000.0*(rand()&0xFFFF)/0xFFFF;
	  dy = 1500.0-3000.0*(rand()&0xFFFF)/0xFFFF;
	  v = pv_intervis(x,y,x+dx,y+dy, 0);
      }

    ftime(&tloc);
    middle = tloc.time * 1000 + tloc.millitm;

    i = 0;
    srand(0);
    for (x=3500;x<tdb_info.db_header.db_info.max_x-3500;x+=STEP)
      for (y=3500;y<tdb_info.db_header.db_info.max_y-3500;y+=STEP,i++)
      {
	  dx = 1500.0-3000.0*(rand()&0xFFFF)/0xFFFF;
	  dy = 1500.0-3000.0*(rand()&0xFFFF)/0xFFFF;
	  v = pv_intervis(x,y,x+dx,y+dy, 1);
      }
/*
    i = 0;
    for (x= -SIZE;x<SIZE;x+=STEP)
      for (y= -SIZE;y<SIZE;y+=STEP,i++)
	v = pv_intervis(CX,CY,CX+x,CY+y);
*/
    ftime(&tloc);
    end = tloc.time * 1000 + tloc.millitm;

    printf("%f usec (%0.0f ops / second)\n",
	   1000.0*(end-middle - (middle-start))/i,
	   1000.0*i/(end-middle - (middle-start)));
}

