#ifndef lint
static char rcsid [] = "$RCSfile: dt_bitmap.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif
/****************************************************************************
*   File: dt_bitmap.c                                                       *
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*       This software was developed by Loral under U. S. Government contracts *
*       and may be reproduced by or for the U. S. Government pursuant to    *
*       the copyright license under the clause at DFARS 252.227-7013        *
*       (OCT 1988).                                                         *
*                                                                           *
*       Contents: Code to make a dither bitmaps from a dither matrix        *
*       Created: Fri Nov  8 1990                                            *
*       Author: jesmith                                                     *
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/

#include <stdext.h>  /*common/include/global*/
#include "libdither.h"

void dither_bitmaps(size, mat_2D, bit_array_3D)
    int32    size;
    int32  **mat_2D; /* Dimensions vary */
    char  ***bit_array_3D; /* Dimensions vary */
{
    int32  b, i, x, y;
    int32  width;
    int32 *mat = (int32 *)mat_2D;
    char  *bits = (char *)bit_array_3D;

    /* This code generates 2*size+1 [size x size] bitmaps from the
     * dither matrix (created with a call to dither_matrix()).  See
     * dither matrix for an explanation.
     */

    width = DITHER_WIDTH(size);

    /* Set entry 0 to all zeros */
    bzero(bits, (int)(width*size));

    for (b=0;b<size*size;b++)
    {
	/* bitmap[n] = bitmap[n-1]
	 */
	bcopy(bits+b*width*size, bits+(b+1)*width*size, (int)(width*size));

	/* bitmap[n] |= bit x,y; where mat[x][y] == n-1
	 */

	/* 1. Find x, y */
	for(i=0;i<size*size;i++)
	  if (mat[i] == b)
	    break;
	x = i % size;
	y = i / size;

	/* 2. Set bit x,y */
	bits[(b+1)*width*size + y*width + (x>>3)] |= 1 << (x&7);
    }
}
