#ifndef lint
static char rcsid [] = "$RCSfile: env_scenarios.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif
/****************************************************************************
*   File: env_scenarios.c                                                        *
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*	This software was developed by Loral under US Government contracts  * 
*	and may be reproduced by or for the U. S. Government pursuant to    *
*	the copyright license under the clause at DFARS 252.227-7013        *
*	(OCT 1988).                                                         *
*                                                                           *
*       Contents: Interface to scenario load and saves of environmental     *
*		  models  			                            *
*       Created: Sat Aug 31 10:05:09 EDT 1996                               *
*       Author: shaque                                                      *
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/

#include "libenv_local.h"
#include <stdtypes.h>
#include <string.h>
#include <libpo.h>

int32 env_errno = 0;

char * env_errlist[] = 
{
    "No Error",
    "Memory Allocation Failed",
    "Invalid Model Number",
    "Error saving state for client entity. Must be a master to save state",
    "Error opening file",
    "Error writing into file",
    "Error reading from file",
    "Error closing file",
    "No entity to save",
    "Client cannot load scenario. Must be master to load.",
};

int32 env_save_all(char *fname)
{
    int32	m, num_models;
    char 	saved_fname[256];
    
    env_errno = 0;
    num_models = env_find_num_models();
    
    strcpy(saved_fname, fname);
    strcat(saved_fname, ".env");
    
    for (m = 0; m < num_models; m++)
      if (env_models[m].savefcn)
      {
	  if( env_errno = (*(env_models[m].savefcn))(saved_fname))
	    return(env_errno);
      }
    return(env_errno);
}


int32 env_load_all(char *fname)
{
    int32	m, num_models;
    char	saved_fname[256];

    env_errno = 0;
    num_models = env_find_num_models();
    
    strcpy(saved_fname, fname);
    strcat(saved_fname, ".env");
    
    for (m = 0; m < num_models; m++)
      if (env_models[m].loadfcn)
      {
	  if( env_errno = (*(env_models[m].loadfcn))(saved_fname))
	    return (env_errno);
      }
    
    return(env_errno);
    
}
