#ifndef lint
static char rcsid [] = "$RCSfile: test.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif
/****************************************************************************
*   File: test.c                                                            *
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*       This software was developed by Loral under U. S. Government contracts *
*       and may be reproduced by or for the U. S. Government pursuant to    *
*       the copyright license under the clause at DFARS 252.227-7013        *
*       (OCT 1988).                                                         *
*                                                                           *
*       Contents: environment user interface test program
*       Created: Mon Aug 16 13:52:58 EDT 1993                               *
*       Author: krobasky
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/


#include <stdext.h>
#include <libtty.h>
#include "libeui_local.h"
#include <libreader.h>

static testflag = 0;

/*ARGSUSED*/
void setflag(argc, argv)
    int32 argc;
    int32 argv[];
{
    int32 flag = argv[0];

    testflag = flag;
}

/*ARGSUSED*/
void showflag(argc, argv)
    int32 argc;
    int32 argv[];
{
    printf("Flag currently set to: %d\n", testflag);
}

DEFINE_TABLE(model_options_table)

  KEYWORD_SELECT("     FakeModel options (libwhatever)")

    KEYWORD("setflag", "-Sets the flag")
      GET_ON_OR_OFF
      CALL(setflag)
    END_KEYWORD

    KEYWORD("showflag", "-Prints the flag")
      CALL(showflag)
    END_KEYWORD

  END_KEYWORD_SELECT

END_DEFINE_TABLE


/* This is an example of how a model might register a table: (Note,
 * this is a top level table, which will be folded into another top
 * level table, so don't inlcude "KEYWORD_SELECT" in the definition)
 */
DEFINE_TABLE(model_command_table)

   KEYWORD("FakeModel", "-This could be something like, SMOKE")
     DO_KEYWORD_TABLE(model_options_table)
   END_KEYWORD

END_DEFINE_TABLE

/* This is an example of what an application table might look like: */

static int32 done;

void test_done()
{
    done = 1;
}

DEFINE_TABLE(top_command_table)

    KEYWORD_SELECT("    Test Commands:")

	KEYWORD("quit", "-exit")
	    CALL(test_done)
	END_KEYWORD

	KEYWORD("exit", "-quit")
	    CALL(test_done)
	END_KEYWORD

        KEYWORD ("environment", "- environment operations")
            DO_KEYWORD_TABLE(eui_table)
        END_KEYWORD

    END_KEYWORD_SELECT

END_DEFINE_TABLE

main()
{

    /* Initialize libraries */
    except_init(TRUE, FALSE);
    sched_init(0);
    time_init(0);
    reader_init(0);
    env_init("../../data", READER_OVERRIDE);
    eui_init();

#ifdef USE_PARSER
    /* Typically, each individual model would add there own interface, like so: */
    ParseAddTable(eui_models_table, model_command_table);
    /* Note that you're adding it to the models table, not the  eui_table */
#endif


    tty_parser_init(top_command_table, "test> ");

    while(!done) {
	tty_tick();
    }

    tty_exit();
    
}

