#ifndef lint
static char rcsid [] = "$RCSfile: test.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif
/****************************************************************************
*   File: test.c                                                            *
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*       This software was developed by Loral under U. S. Government contracts *
*       and may be reproduced by or for the U. S. Government pursuant to    *
*       the copyright license under the clause at DFARS 252.227-7013        *
*       (OCT 1988).                                                         *
*                                                                           *
*       Contents: Simple test program for liblock                           *
*       Created: Thu Jan 20 10:44:36 EST 1994                               *
*       Author: jtan                                                        *
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/

#include <stdio.h>
#include "libgeometry.h"
#include <libvecmat.h>
#include <stdext.h>
#include <stdalloc.h> /*common/include/global*/
#include <stdstring.h> /*common/include/global*/
typedef struct polygon
{
    float64 poly[50][2];
    int32   n;
    struct polygon *next;
} POLYGON;

void test_merge_poly();

static print_help()
{
    printf("\t(h)elp\n");
    printf("\t(t)angential_points_on_circle()\n");
    printf("\t(r)egular_polygon()\n");
    printf("\t(d)distance_sq_2_objects()\n");
    printf("\t(i)ntersection_2_objects()\n");
    printf("\t(c)lip_2_objects()\n");
    printf("\tis_(p)oint_in_polygon()\n");
    printf("\t(P)oint_to_point()\n");
    printf("\t(m)erge_polygons()\n");
    printf("\t(g)et_polygons()\n");
    printf("\tis_polygon_clock(w)ise()\n");
    printf("\tc(l)one_object()\n");
    printf("\t(q)uit\n\n");
}

static int32 get_vertices(v, filename)
    float64 v[100][2];
    char * filename;
{
    int32 n;
    float64 x,y;
    int32 num=0;
    int32 closed;
    FILE *fp = fopen(filename, "r");
    
    if (!fp)
    {
	printf("Open %s failed.\n", filename);
	return(0);
    }
    
    while(1)
    {
	n = fscanf(fp, "%lf %lf", &x,&y);
	if (n == 2)
	{
	    v[num][0] = x;
	    v[num++][1] = y;
	}
	else
	  break;
    }
    fclose(fp);
    return(num);
}


    
main()
{
    char test_type[20];
    int32 num1=0;
    int32 num2=0;
    float64 point1[100][2];
    float64 point2[100][2];
    float64 clipped[100][2];
    int32 i; 
    float64 center[2], r, point[2], direction[2];
    float64 tang1[2], tang2[2];
    float64 angle;
    float64 x, y;
    int32 n=2;
    float64 r1[2];
    float64 r2[2];
    int32 index1, index2;
    int32 n_ints=0;
    GEO_POINT v1[10];
    GEO_POINT v2[10];
    int32 ret;
    float64 dist;
    GEO_POLYGONS polys, *poly_ptr;
    int32 dir;
    
    POLYGON *feat = (POLYGON *) STDALLOC(sizeof(POLYGON));
    POLYGON *merged = (POLYGON *)0;
    POLYGON *tmp_polygon;
    int32 n_read;
    char line[80];
    char *lptr = line;
    
    printf("You may select one of the following choices:\n");
    print_help();
    while (test_type[0] != 'q')
    {
	FILE *fin = fopen("test.dat", "r");
	FILE *fout = fopen("out.dat", "w");
	printf("test > ");
	scanf("%s", test_type);
	switch (test_type[0])
	{
	  case 'h':
	    print_help();
	    break;
	  case 't':
	    printf("Given a circle defined by the 'circle_center' and\n");
	    printf("the 'circle_radius' and a 'point', \n");
	    printf("geo_tangential_points_on_circle() calculates the\n");
	    printf("two tangential points on the circle. Looking at \n");
	    printf("the circle from the point, 'tang_point1' is the \n");
	    printf("tangential point on the left side of the circle,\n");
	    printf("and 'tang_point2' is the one on the right side.\n\n");
	    
	    printf("Enter circle center x => ");
	    scanf("%lf", &center[0]);
	    printf("Enter circle center y => ");
	    scanf("%lf", &center[1]);
	    printf("Enter circle center radius => ");
	    scanf("%lf", &r);
	    printf("Enter outside circle point x => ");
	    scanf("%lf",&point[0]);
	    printf("Enter outside circle point y => ");
	    scanf("%lf",&point[1]);
	    if (geo_tangential_points_on_circle(center, r, point, 
						tang1, tang2))
	    {
		printf("tang_point1: (%f, %f)\n", tang1[0], tang1[1]);
		printf("tang_point2: (%f, %f)\n", tang2[0], tang2[1]);
	    }
	    else
	      printf("No tangential points\n");
	    break;

	  case 'r':
	    printf("geo_regular_polygon() returns the positions of the\n");
	    printf("vertices of an 'num1' regular polygon at 'center'.\n");
	    printf("The size of the polygon is specified by the `radius',\n");
	    printf("the distance between a vertex and the polygon center.\n");
	    printf("The first vertex is at the input 'direction', and the \n");
	    printf("others are in the clockwise order.\n\n");
	    
	    printf("Enter polygon center x => ");
	    scanf("%lf", &center[0]);
	    printf("Enter polygon center y => ");
	    scanf("%lf", &center[1]);
	    printf("Enter polygon radius => ");
	    scanf("%lf", &r);
	    printf("Enter angle (in degree) between the direction and the y-axis => ");
	    scanf("%lf", &angle);
	    angle *= 3.1415927 / ((float64) 180);
	    direction[0] = sin(angle);
	    direction[1] = cos(angle);
	    printf("Enter number of vertices => ");
	    scanf("%d", &num1);
	    geo_regular_polygon(center, r, direction, num1, point1);
	    printf("Center=(%f,%f), dir=(%f,%f), radius=%f, num1=%d\n",
		   center[0], center[1], direction[0], direction[1],
		   r, num1);
	    for (i = 0; i < num1; i++)
	      printf("Vertex[%d]=(%f, %f)\n", i, point1[i][0], point1[i][1]); 
	    break;
	    
	  case 'd':
	    printf("Reading first geometry object points\n");
	    num1 = get_vertices(point1, "array1.dat");
	    printf("Reading second geometry object points\n");
	    num2 = get_vertices(point2, "array2.dat");
	    printf("The dist is %lf\n", 
		   sqrt(geo_distance_sq_2_objects(point1, num1, point2, num2, 
						  &v1[0], &v2[0])));
	    printf("Point on object one: (%lf, %lf), index=%d, t=%lf\n",
		   v1[0].point[0], v1[0].point[1], v1[0].vertex, v1[0].t);
	    printf("Point on object two: (%lf, %lf), index=%d, t=%lf\n",
		   v2[0].point[0], v2[0].point[1], v2[0].vertex, v2[0].t);
	    break;

	  case 'i':
	    printf("Reading first geometry object points\n");
	    num1 = get_vertices(point1, "array1.dat");
	    printf("Reading second geometry object points\n");
	    num2 = get_vertices(point2, "array2.dat");
	    printf("Enter number of intersections needed: ");
	    scanf("%d", &n_ints);
	    printf("The two objects intersect at the following %d points:\n", 
		   (n_ints=geo_intersection_2_objects(point1, num1, 
						      point2, num2,
						      n_ints, v1, v2)));
	    if (n_ints)
	    {
		for (n=0; n<n_ints; n++)
		{
		    printf("obj1: (%lf,%lf) at vertex: %d, t=%lf\n",
			   v1[n].point[0], v1[n].point[1], 
			   v1[n].vertex, v1[n].t);
		    printf("obj2: (%lf,%lf) at vertex %d, t=%lf\n",
			   v2[n].point[0], v2[n].point[1], 
			   v2[n].vertex, v2[n].t);
		}
	    }
	    break;

	  case 'c':
	    printf("Reading first geometry object points\n");
	    num1 = get_vertices(point1, "array1.dat");
	    printf("Reading second geometry object points\n");
	    num2 = get_vertices(point2, "array2.dat");
	    
	    printf("The clipped object has %d points:\n", 
		   (n_ints=geo_clip_2_objects(point1, num1, 
					      point2, num2,
					      clipped)));
	    printf("object1:\n");
	    for (n=0; n<num1; n++)
	      printf("%lf %lf\n", point1[n][0], point1[n][1]);
	    printf("object2:\n");
	    for (n=0; n<num2; n++)
	      printf("%lf %lf\n", point2[n][0], point2[n][1]);
	    printf("clipped:\n");
	    for (n=0; n<n_ints; n++)
	      printf("%lf %lf\n", clipped[n][0], clipped[n][1]);
	    break;
	    
	  case 'p':
	    printf("Reading polygon vertices\n");
	    num1 = get_vertices(point1, "array1.dat");
	    printf("Enter test point x,y => ");
	    scanf("%lf,%lf", &point[0], &point[1]);
	    
	    ret = geo_is_point_in_polygon(point, point1, num1);
	    printf("The point is ");
	    if (ret == GEO_PT_INSIDE)
	      printf("GEO_PT_INSIDE\n");
	    else if (ret == GEO_PT_OUTSIDE)
	      printf("GEO_PT_OUTSIDE\n");
	    else
	      printf("GEO_PT_ON_VERTEX or GEO_PT_ON_LINE\n");
	    
	    break;
	    
	  case 'P':
	    printf("Reading object vertices\n");
	    num1 = get_vertices(point1, "array1.dat");
	    printf("Enter test point vertex, t => ");
	    scanf("%d,%lf", &v1[0].vertex, &v1[0].t);
	    printf("Enter distance => ");
	    scanf("%lf", &dist);
	    
	    v1[0].point[X] = point1[v1[0].vertex][X] + 
	      v1[0].t * (point1[v1[0].vertex+1][X] - point1[v1[0].vertex][X]);
	    v1[0].point[Y] = point1[v1[0].vertex][Y] + 
	      v1[0].t * (point1[v1[0].vertex+1][Y] - point1[v1[0].vertex][Y]);
	    
	    ret = geo_point_to_point(point1, num1, &v1[0], dist, &v1[1]);
	    printf("The input point is (%lf, %lf)\n", v1[0].point[X], 
		   v1[0].point[Y]);
	    printf("The output point is (%lf, %lf)\n", v1[1].point[X], 
		   v1[1].point[Y]);

	    break;
	    
	  case 'm':
	    printf("Reading first geometry object points\n");
	    num1 = get_vertices(point1, "array1.dat");
	    printf("Reading second geometry object points\n");
	    num2 = get_vertices(point2, "array2.dat");
	    
	    printf("The merged object has %d points:\n", 
		   (n_ints=geo_merge_polygons(point1, num1, 
					      point2, num2,
					      clipped)));
	    printf("object1:\n");
	    for (n=0; n<num1; n++)
	      printf("%lf %lf\n", point1[n][0], point1[n][1]);
	    printf("object2:\n");
	    for (n=0; n<num2; n++)
	      printf("%lf %lf\n", point2[n][0], point2[n][1]);
	    printf("clipped:\n");
	    for (n=0; n<n_ints; n++)
	      printf("%lf %lf\n", clipped[n][0], clipped[n][1]);
	    break;

	  case 'g':
	    printf("Reading first geometry object points\n");
	    polys.n_pts = get_vertices(point1, "array1.dat");
	    polys.points = point1;
	    printf("get %d polygons\n", geo_get_polygons(&polys));
	    for (poly_ptr = &polys; poly_ptr; poly_ptr=poly_ptr->next)
	    {
		printf("getting new polygon...:\n");
		for (n=0; n<poly_ptr->n_pts; n++)
		  printf("%lf %lf\n", poly_ptr->points[n][0], 
			 poly_ptr->points[n][1]);
	    }
	    
	    break;

	  case 'w':
	    printf("Reading first geometry object points\n");
	    num1 = get_vertices(point1, "array1.dat");
	    printf("polygon clockwise: %d\n", 
		   geo_is_polygon_clockwise(point1, num1));
	    break;

	  case 'l':
	    printf("Reading first geometry object points\n");
	    num1 = get_vertices(point1, "array1.dat");
	    printf("Enter direction(1=right, -1=left, 2=expend, -2=shrink): ");
	    scanf("%d", &dir);
	    printf("Enter distance: ");
	    scanf("%lf", &dist);

	    num2 = geo_clone_object(point1, num1, dist, dir, point2);
	    for (i=0; i<num2; i++)
	      fprintf(fout, "%lf %lf\n", point2[i][0], point2[i][1]);
	    fclose(fout);
	    fout = fopen("gnuplot.cmd", "w");
	    fprintf(fout, "plot 'array1.dat' w l, 'out.dat' w l\n");
	    fprintf(fout, "pause -1\n");
	    fclose(fout);
	    system("gnuplot -geometry 600x400+0+0 gnuplot.cmd");
	    break;

	  case 'M':
	    bzero(feat, sizeof(POLYGON));
	    n = 0;
	    while(lptr)
	    {
		feat->n = 0;
		while (lptr = fgets(line, 80, fin))
		{
		    if (strlen(line) < 3)
		    {
			n++;
			break;
		    }
		    else if (line[0] == '#')
		    {
			printf("%s\n", line);
			n = 0;
			while(test_merge_merged(merged));
			while(merged)
			{
			    for (i=0; i<merged->n; i++)
			      fprintf(fout, "%lf %lf\n", merged->poly[i][0],
				      merged->poly[i][1]);
			    fprintf(fout, "\n");
			    tmp_polygon = merged;
			    merged=merged->next;
			    STDDEALLOC(tmp_polygon);
			}
			merged = NULL;
			fprintf(fout, "%s\n", line);
			continue;
		    }
		    
		    sscanf(line, "%lf %lf", 
			   &feat->poly[feat->n][0], &feat->poly[feat->n][1]);
		    feat->n++;
		}
		
		if (feat->n > 2)
		{
		    printf("%d ", n);
		    if (!merged)
		    {
			printf("create first polygon\n");
			merged = (POLYGON *) STDALLOC(sizeof(POLYGON));
			bcopy((char *)feat, (char *)merged, sizeof(POLYGON));
			continue;
		    }
		    test_merge_poly(feat, merged);
		}
	    }
	    
	    break;
				  
	  case 'q':
	    printf("Bye\n");
	    break;

	  default:
	    printf("Illegal command. Type 'h' for help.\n");
	    break;
	}
    }
}

void test_merge_poly(feat, first_merged)
    POLYGON *feat;
    POLYGON *first_merged;
{
    POLYGON *merged, *prev;
    float64 test_poly[50][2], cnvx_poly[50][2];
    int32   n_test, n_cnvx;
    
    n_cnvx = geo_make_polygon_convex(feat->poly, feat->n, cnvx_poly);
    bcopy((char *)cnvx_poly, (char *)feat->poly, 
	  n_cnvx * 2 * sizeof(float64));
    feat->n = n_cnvx;
    
    for (merged = first_merged; merged; prev=merged, merged=merged->next)
    {
	if ((n_test = geo_merge_polygons(feat->poly, feat->n, 
					 merged->poly, merged->n, test_poly))
	    &&
	    (n_cnvx = geo_make_polygon_convex(test_poly, n_test, cnvx_poly)))
	{
	    merged->n = n_cnvx;
	    bcopy((char *)cnvx_poly, (char *)merged->poly, 
		  n_cnvx * 2 * sizeof(float64));
	    return;
	}
    }
    
    prev->next = (POLYGON *)STDALLOC(sizeof(POLYGON));
    bcopy((char *)feat, (char *)prev->next, sizeof(POLYGON));
    printf("created a new polygon\n");
    return;
}


int32 test_merge_merged(first_merged)
    POLYGON *first_merged;
{
    POLYGON *merged, *next, *prev;
    float64 test_poly[50][2], cnvx_poly[50][2];
    int32   n_test, n_cnvx;
    int32   n_merged = 0;

    if (!first_merged)
      return(0);
    
    for (merged = first_merged ; merged && merged->next; merged=merged->next)
    {
	for (prev=merged, next = merged->next; next; 
	     prev = next, next=next->next)
	{
	    if ((n_test = geo_merge_polygons(merged->poly, merged->n, 
					     next->poly, next->n, test_poly))
		&&
		(n_cnvx = geo_make_polygon_convex(test_poly, n_test, 
						  cnvx_poly)))
	    {
		merged->n = n_cnvx;
		bcopy((char *)cnvx_poly, (char *)merged->poly, 
		      n_cnvx * 2 * sizeof(float64));
		prev->next = next->next;
		STDDEALLOC(next);
		next = prev;
		n_merged++;
	    }
	}
    }
    
    printf("merged %d merged polygons\n", n_merged);
    return(n_merged);
}
