#ifndef lint
static char rcsid [] = "$RCSfile: test_perim.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif
/****************************************************************************
*   File: test_perim.c
*                                                                           *
*       Copyright 1993 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               10 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-873-3660                                                *
*                                                                           *
*	This software was developed by Loral under U. S. Government contracts *
*	and may be reproduced by or for the U. S. Government pursuant to    *
*	the copyright license under the clause at DFARS 252.227-7013        *
*	(OCT 1988).                                                         *
*                                                                           *
*       Contents: perimeter finder test program
*       Created: Thu Jan 20 10:44:36 EST 1994
*       Author: wrichard
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/

/* Perimeter Test Program:
 *  
 * Compile perim, and use gnuplot to see the graph of points and the
 * perimeter line drawn around the set of points.
 *  
 * gnuplot> set term iris4d
 * gnuplot> plot '< test_perim 10000' with lines, '<test_perim 10000'
 *
 */

#include "libgeometry.h"
#include <librandom.h>
#include <stdext.h>
#include <stdalloc.h>

main(int argc, char *argv[])
{
#define MAX_PT 10000
    int32 points[MAX_PT][2];
    uint16 perimeter_index[MAX_PT];
    int32 num_points = 0;
    int32 count;
    int32 i;
    float64 x, y;

    if (argc)
      num_points = atoi(argv[1]);
    if ((num_points > MAX_PT) || (num_points < 1))
      printf("Usage: %s <points>\n", argv[0]), exit(0);

    for (i=0;i<num_points;i++)
    {
	rnd_bivariant_normal_distribution(10.0, &x, &y);
	points[i][X] = x;
	points[i][Y] = y;
    }

    count = geo_find_perimeter(num_points, points, perimeter_index);

    /* Print the points */
    for (i=0;i<num_points;i++)
      printf("%d %d\n\n", points[i][X], points[i][Y]);

    /* Print the perimeter */
    for (i=0;i<count;i++)
      printf("%d %d\n",
	     points[perimeter_index[i]][X],
	     points[perimeter_index[i]][Y]);
    printf("%d %d\n",
	   points[perimeter_index[0]][X],
	   points[perimeter_index[0]][Y]);
}
