/*
 * $RCSfile: compat.h,v $ $Revision: 1.1.1.1 $ $State: Exp $
 */
/*
 * File:	compat.h
 *
 * Contains macros for compatibility across various platforms.
 *
 */

#ifndef COMPAT_H_INCLUDED

#define COMPAT_H_INCLUDED

#ifdef _GT_

#define L_SWAP(x)	x
#define W_SWAP(x)	x
#define F_REFLECT(x)	x
#define L_REFLECT(x)	x

#endif

#ifdef MASSCOMP_MACHINE

#define L_SWAP(x)	x
#define W_SWAP(x)	x
#define F_REFLECT(x)	x
#define L_REFLECT(x)	x

#endif

#ifdef LYNX

#define L_SWAP(x)	x
#define W_SWAP(x)	x
#define F_REFLECT(x)	x
#define L_REFLECT(x)	x

#endif

#ifdef SIMBFLY

#define L_SWAP(x)	x
#define W_SWAP(x)	x
#define F_REFLECT(x)	x
#define L_REFLECT(x)	x

#endif

#ifdef CMU

#define L_SWAP(x)	x
#define W_SWAP(x)	x
#define F_REFLECT(x)	x
#define L_REFLECT(x)	x

#endif

#ifdef mips

#define L_SWAP(x)	x
#define W_SWAP(x)	x
#define F_REFLECT(x)	x
#define L_REFLECT(x)	x

#endif

#ifdef SUN

#define L_SWAP(x)	x
#define W_SWAP(x)	x
#define F_REFLECT(x)	x
#define L_REFLECT(x)	x

#endif

#ifdef hpux

#define L_SWAP(x)	x
#define W_SWAP(x)	x
#define F_REFLECT(x)	x
#define L_REFLECT(x)	x

#endif

#ifdef MSC

extern float	fixfloat();
extern long	fixlong();

#define L_SWAP(x)	((unsigned long)x >> 16 | (unsigned long)x << 16)
#define W_SWAP(x)	((unsigned short)x >> 8 | (unsigned short)x << 8)
#define F_REFLECT(x)	fixfloat(x)
#define L_REFLECT(x)	fixlong(x)

#endif

#endif

