#ifndef lint
static char rcsid [] = "$RCSfile: net_acce.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif

/*
 * File:	net_access.c
 *
 * Copyright 1995 Loral Advanced Distributed Simulation
 * Cambridge, MA  02138.
 * All Rights Reserved.
 *
 * Functions:
 *		net_access
 */

/*LINTLIBRARY*/

#ifndef NO_ASSOC
#ifndef SOCKET_NETIF
#ifndef STREAMS_NETIF

#include "libnet.h"


/*
 *	net_access
 *
 *	Common access routine to the network server.
 *	Arguments are access handle and the command code to execute.
 *	The command specific arguments are assumed to be set up by
 *	the caller.  The handle is assumed to be valid.
 */

int net_access(h, command)
int h;
int command;
{
    register struct netlib_pb *np = &npb[h];
    int ret;

#ifdef SIMBFLY
    catch

	Reset_Event(np->net_event);

    onthrow

	when(TRUE)
	    ;

    endcatch

    np->net_req->req_code = command;
    np->net_req->device = np->net_device;
    np->net_req->ret_event = np->net_event;

    Enq_DualQ(np->net_queue, np->net_reqoid, FALSE);

    MWait(np->net_event, 0L);
    return(np->net_req->ret_code);

#else

    switch(np->type) {
	case NIF_TYPE_CMC:
	    ret = access_cmc(np, command);
	    break;
	case NIF_TYPE_147:
	    ret = access_147(np, command);
	    break;
	case NIF_TYPE_SIMLE:
	    ret = access_simle(np, command);
	    break;
	default:
	    printf("net_access: unknown NIF type!!!\n");
	    ret = -1;
	    break;
    }

    return(ret);

#endif
}

#ifndef SIMBFLY

access_cmc(np, command)
int command;
register struct netlib_pb *np;
{
#ifdef _GT_

    if(np->fd < 0) {
	if(errno = ifx_open(np->dev_name, IFXMPUBLIC | IFXMRDWR, &np->fd))
	    return(errno);
    }
	
    if(errno = ifx_ioctl(np->fd, command, np->params))
	return errno;

    return (0);

#else

    if(np->fd < 0) {
	if((np->fd = XXX_OPEN(np->dev_name, 2)) < 0)
	    return(errno);
    }
	
    if (XXX_IOCTL(np->fd, (unsigned long)command, np->params) < 0)
	return errno;

    return (0);

#endif

}

/*ARGSUSED*/
access_147(np, command)
int command;
register struct netlib_pb *np;
{
#ifdef _GT_
    errno = (*np->ioctl) (np->ccb, command, np->params);
    return errno;
#else
    printf("access_147: not supported\n");
	return 0;
#endif
}

/*ARGSUSED*/
access_simle(np, command)
int command;
register struct netlib_pb *np;
{
    errno = ioctl (np->fd, (unsigned long)command, np->params);
    return errno;
}

#endif

#endif /* STREAMS_NETIF */
#endif /* SOCKET_NETIF */
#endif /* NO_ASSOC */
