#ifndef lint
static char rcsid [] = "$RCSfile: net_clos.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif

/*
 * File:	net_clos.c
 *
 * Copyright 1995 Loral Advanced Distributed Simulation
 * Cambridge, MA  02138.
 * All Rights Reserved.
 *
 * Functions:
 *		net_close
 */

/*LINTLIBRARY*/

#ifndef NO_ASSOC
#ifndef SOCKET_NETIF
#ifndef STREAMS_NETIF

#include "libnet.h"


int net_close(h)

    int h;

{
    register struct netlib_pb *np;
    int ret = 0;

    CHECK_HANDLE(h, -1);

    np = &npb[h];

#ifdef SIMBFLY
    Del_Obj(np->net_event);
    Unmap_Obj(np->net_reqoid, (char *)np->net_req);
    Unmap_Obj(np->inringoid, (char *)(np->inbuffers - 1));
    Unmap_Obj(np->outringoid, (char *)(np->outbuffers - 1));
#endif

#ifdef MASSCOMP
    XXX_CLOSE(np->fd);
    (void)detachshm ((char *)(np->inbuffers-1));
    (void)detachshm ((char *)(np->outbuffers-1));
    (void)detachshm ((char *)np->share_ptr);
#endif

#ifdef SUN
	unmap_buffers (np);
    XXX_CLOSE(np->fd);
#endif

#ifdef mips
    XXX_CLOSE(np->fd);
#endif

#ifdef _GT_
    switch(np->type) {
	case NIF_TYPE_CMC:
	    break;
	case NIF_TYPE_147:
	    ifx_close(np->fd);
	    break;
	default:
	    printf("net_close: unknown NIF type!!!\n");
	    ret = -1;
    }
#endif

    np->used = FALSE;

    return(ret);
}

#endif /* STREAMS_NETIF */
#endif /* SOCKET_NETIF */
#endif /* NO_ASSOC */
