#ifndef lint
static char rcsid [] = "$RCSfile: net_flus.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif

/*
 * File:	net_flush.c
 *
 * Copyright 1995 Loral Advanced Distributed Simulation
 * Cambridge, MA  02138.
 * All Rights Reserved.
 *
 * This file contains routines used to perform control functions.
 *
 * Functions:
 *		net_flush
 */

/*LINTLIBRARY*/

#ifndef NO_ASSOC
#ifndef SOCKET_NETIF
#ifndef STREAMS_NETIF

#include "libnet.h"


int net_flush(h, flags)
int h;
int flags;
{
    register struct netlib_pb *np;

    CHECK_HANDLE(h, -1);

    np = &npb[h];

    if(flags & NETFLUSHRCV) {
#ifdef SIMBFLY
        Wait_DualQ(np->net_rcvlock, FALSE);
#endif

	if(errno = net_access(h, ENPFLUSHRCV))
	    goto error1;

	if(np->type == NIF_TYPE_CMC)
	    SETLONG(np->currentinbuf, 0);

#ifdef SIMBFLY
        Unlock_DualQ(np->net_rcvlock);
#endif
    }

    if(flags & NETFLUSHXMT) {
#ifdef SIMBFLY
        Wait_DualQ(np->net_xmtlock, FALSE);
#endif
	if(np->type == NIF_TYPE_SIMLE)
	    return 0;

        if(errno = net_access(h, ENPFLUSHXMT))
	    goto error2;

	if(np->type == NIF_TYPE_CMC)
	    SETLONG(np->currentoutbuf, 0);
	
#ifdef SIMBFLY
        Unlock_DualQ(np->net_xmtlock);
#endif
    }

    return(0);

error2:

#ifdef SIMBFLY
    Unlock_DualQ(np->net_xmtlock);
#endif

error1:

#ifdef SIMBFLY
    Unlock_DualQ(np->net_rcvlock);
#endif

    return(-1);
}

#endif /* STREAMS_NETIF */
#endif /* SOCKET_NETIF */
#endif /* NO_ASSOC */
