#ifndef lint
static char rcsid [] = "$RCSfile: net_load.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif

/*
 *	File:	net_load.c
 *
 *	Functions:
 *		net_load
 *		net_unload
 *
 */

/*LINTLIBRARY*/

#ifndef NO_ASSOC
#ifndef SOCKET_NETIF
#ifndef STREAMS_NETIF

#include <stdext.h>  /*common/include/global*/
#include "libnet.h"

#ifdef mips
#include <sys/file.h>
#endif

/*
 *	net_load
 *
 *	Load memory on enp.
 */

int net_load(h, buffer, count, offset)
int h;
char *buffer;
long count;
long offset;

#ifdef SIMBFLY

{
    register struct netlib_pb *np;
    char *localbuf;
    OID localbufoid;

    CHECK_HANDLE(h, -1);

    np = npb + h;

    localbufoid = Make_Obj((char)0, -1, count, RW_rw_);
    localbuf = Map_Obj(localbufoid, 0, RW_rw_);

    Do_bt(buffer, localbuf, count);

    np->net_req->a.write_req.count = count;
    np->net_req->a.write_req.offset = offset;
    np->net_req->a.write_req.bufoid = localbufoid;

    if(errno = net_access(h, ENPLOAD))
	goto error1;

    Del_Obj(localbufoid);

    return(0);

error1:
    Del_Obj(localbufoid);
    
    return(-1);
}

#endif

#ifdef MASSCOMP

{
    register struct netlib_pb *np;
    int nloaded = 0;
    int werr;

    CHECK_HANDLE(h, -1);

    np = npb + h;
    if (XXX_LSEEK(np->fd, (long)offset, 0) != offset)
	return (-1);
    
    while (nloaded < count) {
	errno = 0;
	nloaded +=
	    (werr = XXX_WRITE(np->fd, buffer + nloaded, (int) (count - nloaded)));
	if (werr < 0)
	    return (-1);
    }
    return (0);
}

#endif

#ifdef MSC

{
    CHECK_HANDLE(h, -1);
    
    bcopy(buffer, npb[h].enp_base + offset, (int)count);
    
    return(0);
}

#endif

#if defined(SUN) || defined (hpux) || defined(__alpha)

{
    CHECK_HANDLE(h, -1);
    
    if(npb[h].type == NIF_TYPE_CMC)
        movebytes(buffer, npb[h].enp_base + offset, (int)count);
    else {
	printf("net_load: unknown NIF type!!!\n");
	return(-1);
    }
    
    return(0);
}

#endif

#ifdef _GT_

{
    CHECK_HANDLE(h, -1);
    
    /* Must be in chunks no larger than a word for enp10. */
    if(npb[h].type == NIF_TYPE_CMC)
        movebytes(buffer, npb[h].enp_base + offset, (int)count);
    else {
	printf("net_load: unknown NIF type!!!\n");
	return(-1);
    }
    
    return(0);
}

#endif
 
#ifdef mips
  
{
    register struct netlib_pb *np;
    int cc;

    CHECK_HANDLE(h, -1);

    np = npb + h;
    if (XXX_LSEEK(np->fd, (off_t)offset, 0) != -1)
        return (-1);

    cc = XXX_WRITE(np->fd, buffer, (int)count);
    if (cc = -1)
        return (-1);
    else if (cc < count) {
	fprintf(stderr, "Short write to ENP.\n");
	return (-1);
    }
    else
        return (0);
}

#endif

/*
 *	net_unload
 *
 *	Read from enp memory.
 */

int net_unload(h, buffer, count, offset)
int h;
char *buffer;
int count;
int offset;

#ifdef SIMBFLY

{
    register struct netlib_pb *np;
    char *localbuf;
    OID localbufoid;

    CHECK_HANDLE(h,  -1);

    np = &npb[h];

    localbufoid = Make_Obj((char)0, -1, count, RW_rw_);
    localbuf = Map_Obj(localbufoid, 0, RW_rw_);

    np->net_req->a.read_req.count = count;
    np->net_req->a.read_req.offset = offset;
    np->net_req->a.read_req.bufoid = localbufoid;

    if(errno = net_access(h, ENPUNLOAD))
	goto error1;

    Do_bt(localbuf, buffer, count);

    Del_Obj(localbufoid);

    return(0);

error1:
    Del_Obj(localbufoid);

    return(-1);
}

#endif

#ifdef MASSCOMP

{
    register struct netlib_pb *np;
    int nunloaded = 0;
    int rerr;


    CHECK_HANDLE(h, -1);

    np = npb + h;
    if (XXX_LSEEK(np->fd, (long)offset, 0) != offset)
	return (-1);
    
    while (nunloaded < count) {
	errno = 0;
	nunloaded +=
	    (rerr = XXX_READ(np->fd, buffer + nunloaded, (int) (count - nunloaded)));
	if (rerr < 0)
	    return (-1);
	
    }
    return (0);
}

#endif

#if defined(SUN) || defined (hpux) || defined(__alpha)

{
    register struct netlib_pb *np;
    int nunloaded = 0;
    int rerr;

    CHECK_HANDLE(h, -1);

    np = npb + h;
    if (XXX_LSEEK(np->fd, (long)offset, 0) != offset)
	return (-1);
    
    while (nunloaded < count) {
	nunloaded +=
	    (rerr = XXX_READ(np->fd, buffer + nunloaded, count - nunloaded));
	if (rerr < 0)
	    return (-1);
    }

    return (0);
}

#endif
 
#ifdef MSC

{
    CHECK_HANDLE(h, -1);
    
    bcopy(npb[h].enp_base + offset, buffer, count);
    
    return(0);
}

#endif

#ifdef _GT_

{
    CHECK_HANDLE(h, -1);
    
    /*
     * Must be in chunks no larger than a word for enp10
     */
    if(npb[h].type == NIF_TYPE_CMC)
        movebytes(npb[h].enp_base + offset, buffer, count);
    else {
	printf("net_unload: unknown NIF type!!!\n");
	return(-1);
    }
    
    return(0);
}

#endif

#ifdef mips

{
    register struct netlib_pb *np;
    int cc;

    CHECK_HANDLE(h, -1);

    np = npb + h;
    if (XXX_LSEEK(np->fd, (off_t)offset, 0) != -1)
	return (-1);

    cc = XXX_READ(np->fd, buffer, (int)count);

    if (cc = -1)
	return (-1);
    else if (cc < count) {
	fprintf(stderr, "Short read to ENP.\n");
	return (-1);
    }
    else
        return (0);
}

#endif

#endif /* STREAMS_NETIF */
#endif /* SOCKET_NETIF */
#endif /* NO_ASSOC */
