#ifndef lint
static char rcsid [] = "$RCSfile: net_mca.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif

/*
 * File:	net_mca.c
 *
 * Copyright (c) 1988 by BBN Laboratories.
 * Cambridge, MA  02138.
 * All Rights Reserved.
 *
 * This file contains routines used to control multicast addressing.
 *
 * Functions:
 *		net_add_mca
 *		net_del_mca
 *		net_init_mca
 */

/*LINTLIBRARY*/

#ifndef NO_ASSOC
#ifndef SOCKET_NETIF
#ifndef STREAMS_NETIF

#include <stdext.h>  /*common/include/global*/
#include "libnet.h"


/*
	net_add_mca - add multicast address to list
*/

int net_add_mca(h, pna)
int h;
NetworkAddress *pna;
{
    CHECK_HANDLE (h, -1);

#ifndef SIMBFLY
    npb[h].params = pna->addr;
#else
    bcopy(pna->addr, npb[h].net_req->a.mca_req.eaddr, ENETADDRSZ);
#endif

    if(errno = net_access(h, ENPADDMCA))
	return(-1);

    return(0);
}

/*
	net_del_mca - delete multicast address from list
*/

int net_del_mca(h, pna)
int h;
NetworkAddress *pna;
{
    CHECK_HANDLE (h, -1);

#ifndef SIMBFLY
    npb[h].params = pna->addr;
#else
    bcopy(pna->addr, npb[h].net_req->a.mca_req.eaddr, ENETADDRSZ);
#endif

    if(errno = net_access(h, ENPDELMCA))
	return(-1);

    return(0);
}

/*
	net_init_mca - initialize multicast list; delete all addresses on list
*/

int net_init_mca(h)
int h;
{
    CHECK_HANDLE (h, -1);

    if(errno = net_access(h, ENPINITMCA))
	return(-1);

    return(0);
}

#endif /* STREAMS_NETIF */
#endif /* SOCKET_NETIF */
#endif /* NO_ASSOC */
