#ifndef lint
static char rcsid [] = "$RCSfile: net_reg.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif

/*
 * File:	net_reg.c
 *
 * Copyright (c) 1988 by BBN Laboratories.
 * Cambridge, MA  02138.
 * All Rights Reserved.
 *
 * This file contains routines used to access the network interface registers.
 *
 * Functions:
 *		net_reg_read
 *		net_reg_write
 */

/*LINTLIBRARY*/

#ifndef NO_ASSOC
#ifndef SOCKET_NETIF
#ifndef STREAMS_NETIF

#include "libnet.h"


/*
	net_reg_read - read from register 

	returns 0 if successful, -1 if fails
*/

int net_reg_read(h, regnum, pval)
int h;
int regnum;
long *pval;
{
    CHECK_HANDLE (h, -1);

    if(regnum > NUMBER_OF_REGISTERS) {
	errno = E2BIG;
	return(-1);
    }
    else if(npb[h].base_ptr == NULL) {
	errno = EINVAL;
	return(-1);
    }

    *pval = GETLONG(npb[h].reg_ptr + regnum);

    return(0);
}

/*
	net_reg_write - write to register 

	returns 0 if successful, -1 if fails
*/

int net_reg_write(h, regnum, val)
int h;
int regnum;
long val;
{
    CHECK_HANDLE (h, -1);

    if(regnum > NUMBER_OF_REGISTERS) {
	errno = E2BIG;
	return(-1);
    }
    else if(npb[h].base_ptr == NULL) {
	errno = EINVAL;
	return(-1);
    }

    SETLONG(npb[h].reg_ptr + regnum, val);

    return(0);
}

#endif /* STREAMS_NETIF */
#endif /* SOCKET_NETIF */
#endif /* NO_ASSOC */
