#ifndef lint
static char rcsid [] = "$RCSfile: net_run.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif

/*
 * File:	net_run.c
 *
 * Copyright 1995 Loral Advanced Distributed Simulation
 * Cambridge, MA  02138.
 * All Rights Reserved.
 *
 * This file contains routines used to perform control functions.
 *
 * Functions:
 *		net_run
 *		net_stop
 */

/*LINTLIBRARY*/

#ifndef NO_ASSOC
#ifndef SOCKET_NETIF
#ifndef STREAMS_NETIF

#include "libnet.h"


/*
 *	net_run
 *
 *	Begin running down loaded code.
 *
 */

int net_run(h)
int h;
{
    CHECK_HANDLE(h, -1);

    if(errno = net_access(h, ENPRUN))
	return(-1);

    return(0);
}

/*
 *	net_stop
 *
 *	Stop running.  Control returns to idle loop.
 */

int net_stop(h)
int h;
{
    CHECK_HANDLE(h, -1);

    if(errno = net_access(h, ENPSTOP))
	return(-1);

    return(0);
}

#endif /* STREAMS_NETIF */
#endif /* SOCKET_NETIF */
#endif /* NO_ASSOC */
