#ifndef lint
static char rcsid [] = "$RCSfile: net_stam.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif

/*
 * Functions:
 *		net_get_timestamp
 *		net_put_timestamp
 *		net_stamp_disable
 *		net_stamp_enable
 */

/*LINTLIBRARY*/

#ifndef NO_ASSOC
#ifndef SOCKET_NETIF
#ifndef STREAMS_NETIF

#include "libnet.h"


/*
 *	net_get_timestamp
 */

long net_get_timestamp(h)
int h;
{
    CHECK_HANDLE(h, -1L);

    return(npb[h].timestamp);
}


/*
 *	net_put_timestamp
 */

int net_put_timestamp(h, time)
int h;
long time;
{
    CHECK_HANDLE(h, -1);

    npb[h].timestamp = time;

    return(0);
}

/*
 * net_stamp_disable - disable timestamp
 *
 * This routine disables the timestamp function of the network
 * controller.  Packets are transmitted as soon as possible.
 */

int net_stamp_disable(h)
int h;
{
    CHECK_HANDLE(h, -1);
    
    if(errno = net_access(h, ENPDISTIMESTAMP))
	return(-1);

    return(0);
}

/*
 * net_stamp_enable - enable timestamping
 *
 * This routine is called to enable the timestamping function
 * of the network controller.  Packets are transmitted when
 * their timestamp is less than the current value of the timer.
 */

int net_stamp_enable(h)
int h;
{
    CHECK_HANDLE(h, -1);

    if(errno = net_access(h, ENPENBTIMESTAMP))
	return(-1);

    return(0);
}

#endif /* STREAMS_NETIF */
#endif /* SOCKET_NETIF */
#endif /* NO_ASSOC */
