#ifndef lint
static char rcsid [] = "$RCSfile: net_stat.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif

/*
 * File:	net_stat.c
 *
 * Copyright (c) 1987 by BBN Laboratories.
 * Cambridge, MA  02138.
 * All Rights Reserved.
 *
 * This file contains routines used to perform control functions.
 *
 * Functions:
 *		net_get_statistics
 *		net_zero_statistics
 *		net_stat_string
 *		net_print_statistics
 */

/*LINTLIBRARY*/

#ifndef NO_ASSOC
#ifndef SOCKET_NETIF
#ifndef STREAMS_NETIF

#include <stdext.h>  /*common/include/global*/
#include <stdstring.h>
#include "libnet.h"


int net_get_statistics(h, stats)
int h;
long *stats;
#ifdef mips
{
    struct enpaccess_arg arg;
	 
    CHECK_HANDLE(h, -1);
      
    arg.command = GETSTAT;
    arg.buffer_to_enp = NULL;
    arg.bytes_to_enp = 0;
    arg.buffer_to_host = (char *)stats;
    arg.bytes_to_host = N_STATS*sizeof(int);

    npb[h].params = (char *)&arg;

    if(errno = net_access(h, ENPACCESS))
	return(-1);

    return (0);
}
#else
{
#ifndef SIMBFLY
    npb[h].params = (char *)stats;
#endif

    CHECK_HANDLE(h, -1);

    if(errno = net_access(h, ENPGETSTATS))
	return(-1);

#ifdef SIMBFLY
    bcopy(npb[h].net_req->a.getstats_req.stats, stats, N_STATS * sizeof(long));
#endif

    return(0);
}
#endif

int net_zero_statistics(h)

    int h;

{
    CHECK_HANDLE(h, -1);

    if(errno = net_access(h, ENPZEROSTATS))
	return(-1);

    return(0);
}


/*
 *	net_stat_string
 *
 *	Returns a string for specified statistic.  The maximum
 *	string length is 40 chars, not including the null terminator.
 *	A null string is returned if there is no string for
 *	the statistic.
 */

void net_stat_string(stat, buf)

    int stat;
    char *buf;

{
    if(stat >= max_statistics_string)
	buf[0] = '\0';
    else
        strcpy(buf, &statistics_strings[stat][0]);
}

/*
 *	net_print_stats
 *
 *	Prints out the statistics from the CMC card.
 *
 */

int net_print_statistics (h)
int h;
{
    long stats[N_STATS];
    char str[60];
    register int i;

    CHECK_HANDLE (h, -1);

    if (net_get_statistics (h, stats) == -1)
	return (-1);

    for (i = 0; i < N_STATS; i++) {
	net_stat_string (i, str);
	if (str[0] != '\0')
	    printf ("%s%ld\n", str, stats[i]);
    }
    return (0);
}

#endif /* STREAMS_NETIF */
#endif /* SOCKET_NETIF */
#endif /* NO_ASSOC */
