#ifndef lint
static char rcsid [] = "$RCSfile: net_stuf.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif

/*
 *
 *	File	: net_stuff.c
 *
 */

/*LINTLIBRARY*/

#ifndef NO_ASSOC
#ifndef SOCKET_NETIF
#ifndef STREAMS_NETIF

#include <stdext.h>  /*common/include/global*/
#include "sys/types.h"
#include "libnet.h"


int force_some_compilation;
#ifndef SIMBFLY

#ifdef mips
#include </usr/include/sys/mman.h>
#include <sys/types.h>
#include </usr/include/sys/immu.h>
#ifndef sgi
#include <mips/cachectl.h>
#endif
#include <fcntl.h>
#endif


/********************************************
 *
 *	get_locks
 *
 *	This routine gets the locks for the rings.
 *
 ********************************************/
 
get_locks (np)
struct netlib_pb *np;
{
#ifndef SUN
#ifndef CMU
#ifndef mips
#ifndef MSC
#ifndef _GT_
    np->net_xmtlock = semget((key_t) np->nib.xmtsemkey, 1, 0666);

    if(np->net_xmtlock < 0 && errno == ENOENT) {
	np->net_xmtlock = semget((key_t) np->nib.xmtsemkey, 1, IPC_CREAT | 0666);
	(void)semctl(np->net_xmtlock, 0, SETVAL, 1);
    }
    if (np->net_xmtlock < 0)
	return -1;

    np->net_rcvlock = semget((key_t) np->nib.rcvsemkey, 1, 0666);

    if(np->net_rcvlock < 0 && errno == ENOENT) {
	np->net_rcvlock = semget((key_t) np->nib.rcvsemkey, 1, IPC_CREAT | 0666);
	(void)semctl(np->net_rcvlock, 0, SETVAL, 1);
    }

    if (np->net_rcvlock < 0)
	return -1;
#endif
#endif
#endif
#endif
#endif

    return (0);
}

/***************************************
 *
 *	map_buffers
 *
 *	This routine maps in the buffers.  On the MASSCOMP
 * attaches the buffers.  On the sun4, it just maps them in.
 *
 **************************************/

map_buffers (np, flags)
struct netlib_pb *np;
int flags;
{
    char *ptr;
	extern char * attachshm();

    if(np->type != NIF_TYPE_SIMLE)
    {
	np->inringnum = np->nib.inringsize;
	np->outringnum = np->nib.outringsize;
	np->share_size = np->nib.sharesize;
    }

#ifdef MASSCOMP
    ptr = attachshm ((key_t) np->nib.inringkey,
		  (int) Ringsize_in_chars(np->inringnum), TRUE);
    if (ptr == NULL)
	return (-1);
    np->inbuffers = (RingElement *)(ptr + sizeof (RingElement));
    np->currentinbuf = (int *)ptr;
    if (flags & NETINIT)
	(void)bzero (ptr, (int) Ringsize_in_chars(np->inringnum));

    ptr = attachshm((key_t) np->nib.outringkey,
		  (int) Ringsize_in_chars(np->outringnum), TRUE);
    if (ptr == NULL)
	return (-1);
    np->outbuffers = (RingElement *)(ptr + sizeof (RingElement));
    np->currentoutbuf = (int *)ptr;
    if (flags & NETINIT)
	(void)bzero (ptr, (int) Ringsize_in_chars(np->outringnum));

    if ((np->share_ptr = attachshm ((key_t) np->nib.sharekey,
		  np->nib.sharesize, TRUE)) == NULL)
    return (-1);

#endif

#ifdef mips
    
    if ((ptr = (char *)malloc(ENP_MAPSIZE)) == NULL)
    {
	char error_buf[128];

	sprintf(error_buf,
		"Couldn't get %d bytes of malloc'ed memory",
		ENP_MAPSIZE); 
	perror(error_buf);
	return(-1);
    }
#ifndef sgi
    if (mmap(ptr,
	     ENP_MAPSIZE,
	     PROT_READ | PROT_WRITE,
	     MAP_SHARED,
	     np->fd,
	     0) == -1) {
	perror("mmap() in map_buffers() failed");
	return(-1);
    }

    if (cachectl(ptr, ENP_MAPSIZE, UNCACHEABLE) == -1) {
	perror("cachctl() in map_buffers() failed");
	return(-1);
    }
#endif

    np->enp_base = ptr;

    np->currentinbuf = (int *)ptr;
    np->inbuffers = (RingElement *)(ptr + sizeof(RingElement));
    if (flags & NETINIT)
      (void)bzero (ptr, (int) Ringsize_in_chars(np->inringnum));
    ptr += Ringsize_in_chars(np->inringnum);

    np->currentoutbuf = (int *)ptr;
    np->outbuffers = (RingElement *)(ptr + sizeof(RingElement));
    if (flags & NETINIT)
      (void)bzero (ptr, (int) Ringsize_in_chars(np->outringnum));
    ptr += Ringsize_in_chars(np->outringnum);

    np->share_ptr = (char *)ptr;
#endif

#ifdef sun4
    /* On the Sun4, the new OS makes mmap a little different */
    if (np->type == NIF_TYPE_CMC)
    {
	if ((np->enp_base = mmap(0, ENP_MAPSIZE, PROT_READ|PROT_WRITE,
			     MAP_SHARED, np->fd, 0)) == (caddr_t) -1)
	    return (-1);
    }
    else if(np->type == NIF_TYPE_SIMLE)
    {
	if (((char *)np->inbuffers = mmap(0, np->inbuffers_map_size,
		PROT_READ|PROT_WRITE, MAP_SHARED, np->fd, 0)) == (caddr_t) -1)
	    return (-1);

	mlock ((char *)np->inbuffers, np->inbuffers_map_size);

	return 0;
    }
    else
	return (-1);
/* 
For sunos 3.5 only  
    if ((np->enp_base = (char *)valloc (ENP_MAPSIZE)) == NULL)
	return (-1);
    if (mmap (np->enp_base, ENP_MAPSIZE, 0666, MAP_SHARED, np->fd, 0) < 0)
	return (-1);
*/
    np->currentinbuf = (int *)(np->enp_base + np->nib.inringoff);
    np->currentoutbuf = (int *)(np->enp_base + np->nib.outringoff);
    np->inbuffers = (RingElement *)np->currentinbuf + 1;
    np->outbuffers = (RingElement *)np->currentoutbuf + 1;
    np->share_ptr = (char *)(np->enp_base + np->nib.shareoff);
#endif

#ifdef MSC

    np->currentinbuf = (int *)(np->enp_base + np->nib.inringoff);
    np->currentoutbuf = (int *)(np->enp_base + np->nib.outringoff);
    np->nettab = (struct nettab *)(np->enp_base + np->nib.nettaboff);
    np->inbuffers = (RingElement *)np->currentinbuf + 1;
    np->outbuffers = (RingElement *)np->currentoutbuf + 1;

#endif

#ifdef _GT_

    np->currentinbuf = (int *)(np->nib.inringoff);
    np->currentoutbuf = (int *)(np->nib.outringoff);
    np->inbuffers = (RingElement *)np->currentinbuf + 1;
    np->outbuffers = (RingElement *)np->currentoutbuf + 1;
    np->share_ptr = (char *)np->nib.shareoff;

#endif

    return (0);
}

#ifdef sun4
/*
 *
 *
 *	net_resize_inq
 *	
 *	Resize the inqueue used with the simle driver.
 *
 */

net_resize_inq(h, count)
int h;
int count;
{
struct netlib_pb *np;

    np = &npb[h];
    if (net_access (h, SIMLEDELINQ) != -1)  
    {
	net_create_inq(h, count);
	return 0;
    }

    return -1;
}

/*
 *
 *
 *	net_create_inq
 *	
 *	Create the inqueue used with the simle driver.
 *
 */

net_create_inq(h, count)
int h;
int count;
{
struct netlib_pb *np;

    np = &npb[h];
    (int *)np->params = &count;
    np->inringnum = count;

    if (net_access (h, SIMLECREATEINQ) != -1)  
    {
	np->inbuffers_map_size = *(int *)np->params;

	if (map_buffers (np, 0) != -1)
	{
	    np->net_list = &(((NetList *) np->inbuffers)[np->micro]);
	    return 0;
	}
	else
	    net_access (h, SIMLEDELINQ);
    }

    return -1;

}

#endif /* sun4 */

/****************************************
 *
 *	map_enp
 *
 *	This routine maps in the CMC card.
 *
 ****************************************/
map_enp (np)
struct netlib_pb *np;
{

#ifdef MASSCOMP
    char *enp_base = np->enp_base;
    char *ptr;

    extern char *sbrk ();

    if (enp_base != NULL) {	/* if memory can be mapped in */
	enp_base += 0x1000;	/* offset of real memory from enp_base */
	enp_base = (char *)((long)enp_base & 0xfffffff);

	if ((int)(ptr = sbrk (0)) == -1)
	    return (-1);
	ptr = (char *)((long)(ptr + 0xfff) & ~(0xfff));

	if (brk (ptr + _enpmapsize) == -1)
	    return (-1);

	if (pmapm ((unsigned)ptr, (int)_enpmapsize, (unsigned)enp_base) == -1)
	    return (-1);
    
	np->base_ptr = ptr - 0x1000;
	np->reg_ptr = (long *)((char *)np->base_ptr + REG_REG_OFS);
	np->enp_ptr = (struct enp_registers*)((char *)np->base_ptr+ENP_REG_OFS);
    }
    else	/* indicate multibus memory cannot be mapped in */
	np->base_ptr = NULL;

#endif

#ifdef	sun4
    np->base_ptr = np->enp_base;
    np->reg_ptr = (long *)((char *)np->base_ptr + REG_REG_OFS);
    np->enp_ptr = (struct enp_registers *)((char *)np->base_ptr + ENP_REG_OFS); 
#endif

#ifdef mips
    /* On mips, the enp_device is CMC_BUFFER_SIZE offset from the enp_base */
    np->base_ptr = np->enp_base + CMC_BUFFER_SIZE;
    np->reg_ptr = (long *)((char *)np->base_ptr + REG_REG_OFS);
    np->enp_ptr = (struct enp_registers *)((char *)np->base_ptr + ENP_REG_OFS); 
#endif

#ifdef MSC
    np->base_ptr = np->enp_base;
    np->reg_ptr = (long *)((char *)np->base_ptr + REG_REG_OFS);
    np->enp_ptr = (struct enp_registers *)((char *)np->base_ptr + ENP_REG_OFS); 
#endif

#ifdef _GT_
    np->base_ptr = np->enp_base;
    np->reg_ptr = (long *)((char *)np->base_ptr + REG_REG_OFS);
    np->enp_ptr = (struct enp_registers *)((char *)np->base_ptr + ENP_REG_OFS); 
#endif

    return (0);
}


/*******************************************
 *
 *	unmap_enp
 *
 *	This routine frees up the memory allocated to map the timer.
 *
 ******************************************/

unmap_enp (np)
struct netlib_pb *np;
{
#ifdef MASSCOMP
    (void)punmap ((unsigned)np->base_ptr, 0x1000);
#endif

    return (0);
}

/*******************************************
 *
 *	unmap_buffers
 *
 *	This routine undoes the action of map_buffers.  For the sun, this
 * means using munmap to release the memory.
 *
 *******************************************/

unmap_buffers (np)
struct netlib_pb *np;
{
#ifdef MASSCOMP
    (void)detachshm ((char *)(np->outbuffers - 1));
    (void)detachshm ((char *)(np->inbuffers - 1));
    (void)detachshm ((char *)(np->share_ptr));
#endif

#ifdef sun4
    if (np->type == NIF_TYPE_CMC)
	if (munmap (np->enp_base, ENP_MAPSIZE) == -1) 
	{
	    perror("munmap() in umap_buffers() failed");
	    return(-1);
	}
    else if(np->type == NIF_TYPE_SIMLE)
	if (munmap (np->inbuffers, np->inbuffers_map_size) == -1) 
	{
	    perror("munmap() in umap_buffers() failed");
	    return(-1);
	}
#endif

#ifdef mips
    if (munmap(np->enp_base, ENP_MAPSIZE) == -1) {
	perror("munmap() in umap_buffers() failed");
	return(-1);
    }
#endif

    return (0);
}

/*******************************************
 *
 *	unget_locks
 *
 *	On the Masscomp and Sun, this is a null call.
 *
 *******************************************/
unget_locks (np)
struct netlib_pb *np;
{
    return (0);
}

#endif

#endif /* STREAMS_NETIF */
#endif /* SOCKET_NETIF */
#endif /* NO_ASSOC */
