/*
 * $RCSfile: netlock.h,v $ $Revision: 1.1.1.1 $ $State: Exp $
 */

#ifndef NETLOCK_INCLUDED

#define NETLOCK_INCLUDED



#ifdef SIMBFLY
static long private_garbage;
#define POLL_LOCK(lock) Poll_DualQ(lock, &private_garbage, FALSE)
#define WAIT_FOR_LOCK(lock)	Wait_DualQ (lock, FALSE)
#define REMOVE_LOCK(lock)	Unlock_DualQ (lock)
#endif

#ifdef MASSCOMP_MACHINE
extern struct sembuf sem_lock_wait, sem_unlock, sem_lock_nowait;
#define POLL_LOCK(lock) ((semop(lock, &sem_lock_nowait, 1) >= 0) ? TRUE : FALSE)
#define WAIT_FOR_LOCK(lock) (void)semop(lock, &sem_lock_wait, 1)
#define REMOVE_LOCK(lock)	(void)semop(lock, &sem_unlock, 1)
#endif

#ifdef _GT_
#define POLL_LOCK(lock) 	(TRUE)
#define WAIT_FOR_LOCK(lock) 	;
#define REMOVE_LOCK(lock)	;
#endif

#ifdef mips
#define POLL_LOCK(lock) 	(TRUE)
#define WAIT_FOR_LOCK(lock) 	;
#define REMOVE_LOCK(lock)	;
#endif

#ifdef SUN
#define POLL_LOCK(lock) 	(TRUE)
#define WAIT_FOR_LOCK(lock) 	;
#define REMOVE_LOCK(lock)	;
#endif

#ifdef hpux
#define POLL_LOCK(lock) 	(TRUE)
#define WAIT_FOR_LOCK(lock) 	;
#define REMOVE_LOCK(lock)	;
#endif


#endif

