#ifndef lint
static char rcsid [] = "$RCSfile: test.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif
/****************************************************************************
*   File: test.c                                                            *
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*       This software was developed by Loral under U. S. Government contracts *
*       and may be reproduced by or for the U. S. Government pursuant to    *
*       the copyright license under the clause at DFARS 252.227-7013        *
*       (OCT 1988).                                                         *
*                                                                           *
*       Contents: Libotmatch test program                                   *
*       Created: Wed Jul  1 1992                                            *
*       Author: jesmith                                                     *
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/

#include <libreader.h>
#include <librdrconst.h>
#include "libotmatch.h"
#include <obj_type.h>
#include <veh_type.h>
#include <mun_type.h>
#include <ech_type.h>

uint32 tank = (objectDomainVehicle | vehicleEnvironmentGround |
	       vehicleClassSPArmoredTracked | vehicleCountryUSSR |
	       1 << vehicleSeriesShift | 0 << vehicleModelShift |
	       vehicleFunctionMainBattleTank);
uint32 missile = (objectDomainMunition | munitionClassMissile |
		  missileTargetSurface | missileWarheadShapedCharge |
		  ammunitionCountryUS | 1 << ammunitionSeriesShift |
		  1 << ammunitionModelShift);
uint32 projectile = (objectDomainMunition | munitionClassProjectile |
		     11 << ammunitionCaliberShift |
		     ammunitionSubclassShapedCharge |
		     ammunitionCountryUS |
		     1 << ammunitionSeriesShift |
		     2 << ammunitionModelShift);
uint32 smoke = (objectDomainDiffuseMatter |
		diffuseMatterConcentrationModerate |
		diffuseMatterClassDust | diffuseMatterFunctionSmoke |
		1 << diffuseMatterMajorShift |
		2 << diffuseMatterMinorShift);

main()
{
    READER_UNION data;
    int32 key;

    /* Initialize libreader */
    reader_init(0);

    /* Initialize librdrconst */
    if (rdc_init("../../data", 0))
      exit(0);

    /* Initialize libotmatch */
    if (otm_init("", 0))
      exit(0);

    /* Describe some things we know */
#define DESCRIBE(x) printf("x is a %s\n", otm_describe(x))

#if 0
    DESCRIBE(vehicle_US_F16B);
    DESCRIBE(vehicle_USSR_SU_refueler);
    DESCRIBE(vehicle_USSR_T72M);
    DESCRIBE(echelon_US_ScoutRWAPlatoon);
    DESCRIBE(munition_US_Hellfire);
    DESCRIBE(diffuseMatter_MediumFlame);

    /* Describe some we don't */
    DESCRIBE(tank);
    DESCRIBE(missile);
    DESCRIBE(projectile);
    DESCRIBE(smoke);
#endif

    /* Load our test database */
    reader_read("test.rdr", "", &data, 0);
    key = otm_incorporate_db((OTM_DB *)(data.array), 0, (ADDRESS)"default");

    /* Do some lookups (no defaulting) */
#define LOOKUP(x) printf("x yields %s\n", otm_query(key, x))
    printf("Defaulting disabled\n");
    LOOKUP(vehicle_US_M1);
    LOOKUP(vehicle_USSR_BMP1);    
    LOOKUP(vehicle_USSR_BMP2);    
#if 0
    LOOKUP(vehicle_US_A10);
    LOOKUP(munition_US_M739);
    LOOKUP(echelon_US_ScoutRWAPlatoon);
    LOOKUP(vehicle_US_F16B);
    LOOKUP(vehicle_US_AH64);
    LOOKUP(diffuseMatter_MediumFlame);
#endif

    /* Load our test database */
    reader_read("test.rdr", "", &data, 0);
    key = otm_incorporate_db((OTM_DB *)(data.array), 1, (ADDRESS)"default");

    /* Do some lookups (with defaulting) */
    printf("Defaulting enabled\n");
    LOOKUP(vehicle_US_M1);
/*    LOOKUP(vehicle_US_A10); */
    LOOKUP(vehicle_USSR_BMP1);    
    LOOKUP(vehicle_USSR_BMP2);    
#if 0
    LOOKUP(munition_US_M739);
    LOOKUP(echelon_US_ScoutRWAPlatoon);
    LOOKUP(vehicle_US_F16B);
    LOOKUP(vehicle_US_AH64);
    LOOKUP(diffuseMatter_MediumFlame);
    LOOKUP(tank);
    LOOKUP(missile);
    LOOKUP(projectile);
    LOOKUP(smoke);
#endif
}
