#ifndef lint
static char rcsid [] = "$RCSfile: physdb_util.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif
/****************************************************************************
*   File: physdb_util.c                                                     *
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*       This software was developed by Loral under U. S. Government contracts *
*       and may be reproduced by or for the U. S. Government pursuant to    *
*       the copyright license under the clause at DFARS 252.227-7013        *
*       (OCT 1988).                                                         *
*                                                                           *
*       Contents: Physdb utility routines                                   *
*       Created: Wed Aug 19 1992                                            *
*       Author: jesmith                                                     *
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/

#include <stdext.h>
#include "libphysdb.h"

/* Return an angle that fits within limits imposed by physdb config
 * information.
 */

float64 physdb_nearest_angle(ccw, cw, desired)
    float64 ccw;
    float64 cw;
    float64 desired;
{
    float64 adjusted_ccw;
    float64 adjusted_desired;
    float64 ccd, cd;

    /* Is the range unlimited? */
    if (ccw >= TWO_PI)
      return desired;

    /* Is the range fixed? */
    if (ccw == cw)
      return ccw;

    /* Make the ccw larger than the cw */
    if (ccw < cw)
      adjusted_ccw = ccw + TWO_PI;
    else
      adjusted_ccw = ccw;

    /* Make the desired larger than the cw */
    if (desired < cw)
      adjusted_desired = desired + TWO_PI;
    else
      adjusted_desired = desired;

    /* Is the desired between cw & ccw? */
    if ((cw <= adjusted_desired) && (adjusted_desired <= adjusted_ccw))
      return desired;

    /* It is out of range.  Find the distance between it and the ccw limit */
    ccd = ccw - desired;
    if (ccd < -PI)      ccd += TWO_PI;
    else if (ccd >= PI) ccd -= TWO_PI;
    if (ccd < 0)        ccd  = -ccd;

    /* Now the cw limit */
    cd = cw - desired;
    if (cd < -PI)      cd += TWO_PI;
    else if (cd >= PI) cd -= TWO_PI;
    if (cd < 0)        cd  = -cd;

    /* Return the one which is nearer */
    if (cd < ccd)
      return cw;
    else
      return ccw;
}
