#ifndef lint
static char rcsid [] = "$RCSfile: test.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif
/****************************************************************************
*   File: test.c                                                            *
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*       This software was developed by Loral under U. S. Government contracts *
*       and may be reproduced by or for the U. S. Government pursuant to    *
*       the copyright license under the clause at DFARS 252.227-7013        *
*       (OCT 1988).                                                         *
*                                                                           *
*       Contents: Libphysdb test program                                    *
*       Created: Mon Jul  6 1992                                            *
*       Author: jesmith                                                     *
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/

#include <libreader.h>
#include <librdrconst.h>
#include <libotmatch.h>
#include "libphysdb.h"
#include <stdext.h> /*common/include/global*/

main(argc, argv)
    int argc;
    char *argv[];
{
    int32 ot;
    PHYSDB_DATA *data;

    if (argc != 2)
    {
	printf("Usage: %s <object_type>\n", argv[0]);
	exit(0);
    }


    /* Initialize libreader */
    reader_init(0);

    /* Initialize librdrconst */
    if (rdc_init("../../data", 0))
      exit(0);

    /* Initialize libotmatch */
    if (otm_init("../../data", 0))
      exit(0);

    /* Initialize libphysdb */
    if (physdb_init("", 0))
      exit(0);

    if ((sscanf(argv[1], "0x%x", &ot) != 1) &&
	!(ot = rdc_translate_name(argv[1])))
    {
	printf("Cannot understand object type %s\n", argv[1]);
	exit(0);
    }

    data = otm_query(physdb_key, ot);

    printf("0x%x (%s):\n", ot, rdc_translate_number(ot));
    physdb_print(data);
}
