#
# $RCSfile: find_proto.awk,v $ $Revision: 1.1.1.1 $ $State: Exp $
#
# AWK script to find DRN code in the texinfo file.

BEGIN {
  printheader = 1;
  output = 0;
}

(printheader == 1) {
  printheader = 0;

# Put header on .h file

  print "/* THIS FILE IS GENERATED FROM libpo.texinfo  */" > hfile;
  print "/* DO NOT EDIT.                               */" > hfile;
  print "" > hfile;
  print "/*" > hfile;
  print " * FILE:  p_po.h " > hfile;
  print " *" > hfile;
  print " * Created on Mon Jun 17 19:33:06 1996 " > hfile;
  print " * Compiled by DRN compiler, version 6.2.d, one last time " > hfile;
  print " * " > hfile;
  print " */" > hfile;
  print "" > hfile;
  print "#ifndef _p_po_included" > hfile;
  print "#define _p_po_included" > hfile;
  print "" > hfile;
  print "/* File:     p_po.drn */" > hfile;
  print "/* Contents: The persistent object protocol data units */" > hfile;
  print "/* System:   simnet development. */" > hfile;
  print "/* Created:  07-Jun-1991 */" > hfile;
  print "/* Author:   jesmith */" > hfile;
  print "/* $RCSfile: find_proto.awk,v $ */" > hfile;
  print "/* $Revision: 1.1.1.1 $ */" > hfile;
  print "/* $State: Exp $ */" > hfile;
  print "/* COPYRIGHT 1993 Loral Advanced Distributed Simulation */" > hfile;
  print "/* 50 Moulton Street */" > hfile;
  print "/* Cambridge, Ma. 02138 */" > hfile;
  print "/* 617-873-1850 */" > hfile;
  print "" > hfile;
  print "#include <stdtypes.h>" > hfile;
  print "#include <basic.h> " > hfile;
  print "#include <po_const.h>" > hfile;
  print "" > hfile;

# Put header on .cdf file

  print "# THIS FILE IS GENERATED FROM libpo.texinfo " > cfile;
  print "# DO NOT EDIT." > cfile;
  print "" > cfile;
  print "# File:     po_const.cdf" > cfile;
  print "# Contents: The persistent object protocol constants" > cfile;
  print "# System:   simnet development. " > cfile;
  print "# Created:  07-Jun-1991 " > cfile;
  print "# Author:   jesmith " > cfile;
  print "# $RCSfile: find_proto.awk,v $ " > cfile;
  print "# $Revision: 1.1.1.1 $ " > cfile;
  print "# $State: Exp $ " > cfile;
  print "# COPYRIGHT 1993 Loral Advanced Distributed Simulation " > cfile;
  print "# 50 Moulton Street " > cfile;
  print "# Cambridge, Ma. 02138 " > cfile;
  print "# 617-873-1850 " > cfile;
  print "" > cfile;
  print "hfile:" > cfile;
  print "#include <stdtypes.h>" > cfile;
  print "endhfile:" > cfile;
  print "" > cfile;
}

($$0 ~ /comment H START/) {
  output = 1;
  next;
}

($$0 ~ /comment CDF START/) {
  output = 2;
  next;
}

($$0 ~ /comment END/) {
  output = 0;
  next;
}

{
  if (output == 0)
    next;

# Remove @ signs from output

  line = $0;
  while (i = index(line, "@}"))
    line = substr(line,1,i-1) substr(line, i+1);
  while (i = index(line, "@{"))
    line = substr(line,1,i-1) substr(line, i+1);

  if (output == 1) 
    print line > hfile;
  if (output == 2)
    print line > cfile;
}

END {
# Put trailing endif on header file

  print "" > hfile;
  print "#endif" > hfile;
}
