#ifndef lint
static char rcsid [] = "$RCSfile: po_del_pdu.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif
/****************************************************************************
*   File: po_del_pdu.c                                                      *
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*       This software was developed by Loral under U. S. Government contracts *
*       and may be reproduced by or for the U. S. Government pursuant to    *
*       the copyright license under the clause at DFARS 252.227-7013        *
*       (OCT 1988).                                                         *
*                                                                           *
*       Contents: Code to send delete object PDUs                           *
*       Created: Thu Apr 11 1990                                            *
*       Author: jesmith                                                     *
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/

#include "libpo.h"
#include "libpo_local.h"
#include <libnetif.h>
#include <po_size.h>
#include <stdext.h> /* common/include/global */

void po_send_delete_objects_pdu(
    PO_DATABASE  *db,
    int32         n_entries,
    PO_DB_ENTRY **entries)
{
    char buf[NETWORK_BUFFER_SIZE];
    PersistentObjectPDU *pdu = (PersistentObjectPDU *)buf;
    int32 pdu_size;
    int32 i, count;

    pdu->version = persistentObjectProtocolVersionCurrent;
    pdu->kind = deleteObjectsPDUKind;
    pdu->exercise = db->exercise_id;
    pdu->database = db->database_id;
    pdu->variant.deleteObjects.deletingSimulator = db->sim_addr;
    count = 0;

    for (i=0;i<n_entries;i++)
    {
	/* Some objects cannot be deleted */
	if (!PO_UNDELETABLE(entries[i]->pdu))
	{
	    pdu->variant.deleteObjects.objects[count].objectID =
	      entries[i]->pdu->variant.describeObject.objectID;
	    pdu->variant.deleteObjects.objects[count].worldStateID =
	      entries[i]->pdu->variant.describeObject.worldStateID;
	    count++;
	}

	/* If this is full or we're done, send it out */
	if ((count == maxDeleteObjectsCount) ||
	    (i == n_entries-1))
	{
	    pdu->variant.deleteObjects.objectCount = count;

	    pdu_size = PRO_PO_DELETE_OBJS_SIZE(pdu, count);

	    pdu->length = NS_HTON16(pdu_size);
	    db->send_handler(pdu, pdu_size, db->send_user_data);
	    db->packets_sent++;

	    /* Set the counter back to zero for the next packet, if any */
	    count = 0;
	}
    }
}
