#ifndef lint
static char rcsid [] = "$RCSfile: po_nom_pdu.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif
/****************************************************************************
*   File: po_nom_pdu.c                                                      *
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*       This software was developed by Loral under U. S. Government contracts *
*       and may be reproduced by or for the U. S. Government pursuant to    *
*       the copyright license under the clause at DFARS 252.227-7013        *
*       (OCT 1988).                                                         *
*                                                                           *
*       Contents: Code to send a nomination pdu                             *
*       Created: Tue Apr  9 1990                                            *
*       Author: jesmith                                                     *
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/

#include "libpo.h"
#include "libpo_local.h"
#include <libnetif.h>
#include <po_size.h>
#include <stdext.h> /* common/include/global */

void po_send_nominate_pdus(
    PO_DATABASE       *db,
    SimulationAddress *nominated_addr,
    int32              n_missing,
    SimulationAddress *missing_addrs)
{
    char buf[NETWORK_BUFFER_SIZE];
    PersistentObjectPDU *pdu = (PersistentObjectPDU *)buf;
    int32 i, pdu_size;

    pdu->version = persistentObjectProtocolVersionCurrent;
    pdu->kind = nominationPDUKind;
    pdu->exercise = db->exercise_id;
    pdu->database = db->database_id;
    pdu->variant.nomination.nominatedSimulator = *nominated_addr;
    pdu->variant.nomination.nominatingSimulator = db->sim_addr;

    for (i=0;i<n_missing;i++)
    {
	pdu->variant.nomination.missingSimulator = missing_addrs[i];

	pdu_size = PRO_PO_NOMINATE_SIZE(pdu);
	pdu->length =  NS_HTON16(pdu_size);
	db->send_handler(pdu, pdu_size, db->send_user_data);
	db->packets_sent++;
    }
}
