#ifndef lint
static char rcsid [] = "$RCSfile: po_or_pdu.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif
/****************************************************************************
*   File: po_or_pdu.c                                                       *
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*       This software was developed by Loral under U. S. Government contracts *
*       and may be reproduced by or for the U. S. Government pursuant to    *
*       the copyright license under the clause at DFARS 252.227-7013        *
*       (OCT 1988).                                                         *
*                                                                           *
*       Contents: Code to send the object request PDU                       *
*       Created: Thu May 16 1990                                            *
*       Author: jesmith                                                     *
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/

#include <stdext.h>  /*common/include/global*/
#include "libpo.h"
#include "libpo_local.h"
#include <libnetif.h>
#include <po_size.h>

void po_send_object_request_pdu(
    PO_DATABASE       *db,
    SimulationAddress *owner,
    ObjectID          *world_state,
    int32              n_ids,
    ObjectID          *obj_ids)
{
    char buf[NETWORK_BUFFER_SIZE];
    PersistentObjectPDU *pdu = (PersistentObjectPDU *)buf;
    int32 pdu_size;

    pdu->version = persistentObjectProtocolVersionCurrent;
    pdu->kind = objectRequestPDUKind;
    pdu->exercise = db->exercise_id;
    pdu->database = db->database_id;
    pdu->variant.objectRequest.requestingSimulator = db->sim_addr;
    pdu->variant.objectRequest.objectOwner = *owner;
    pdu->variant.objectRequest.worldStateID = *world_state;
    pdu->variant.objectRequest.objectCount = n_ids;
    bcopy((char *)obj_ids,
	  (char *)pdu->variant.objectRequest.objects,
	  (unsigned int) (n_ids * sizeof(ObjectID)));

    pdu_size = PRO_PO_OBJ_REQ_SIZE(pdu, n_ids);
    pdu->length =  NS_HTON16(pdu_size);

    db->send_handler(pdu, pdu_size, db->send_user_data);
    db->packets_sent++;
}

