#ifndef _LIBPQ_LOCAL_H_INCLUDED
#define _LIBPQ_LOCAL_H_INCLUDED

/*
 * $RCSfile: libpq_local.h,v $ $Revision: 1.1.1.1 $ $State: Exp $
 */
/****************************************************************************
*   File: libpq_local.h                                                     *
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*       This software was developed by Loral under U. S. Government contracts*
*       and may be reproduced by or for the U. S. Government pursuant to    *
*       the copyright license under the clause at DFARS 252.227-7013        *
*       (OCT 1988).                                                         *
*                                                                           *
*       Contents: Private header file for libpriqueue.
*       Created: June 27 1994                                               *
*       Author: swarts                                                      *
*                                                                           *
****************************************************************************/

#include <stdext.h>

typedef struct pq_elem
{
    uint32 priority;
    ADDRESS data;
} PQ_ELEM;

struct pq_opaque 
{
    int32 max_size;
    int32 expand_chunk;
    int32 size;
    PQ_ELEM *array;		/* Variable_length_array */
};

#include "libpriqueue.h"

/*
 * The priority queue is kept as a heap.  The tree is embedded in an array.
 * The following macros are used to traverse the tree.  Note:  all of this
 * works better with 1 based indexing, so we just don't use the 0 element.
 */

#define PQ_ROOT 1
#define PQ_LEFT(i) ((i)<<1)
#define PQ_RIGHT(i) (((i)<<1)+1)
#define PQ_PARENT(i) ((i)>>1)

#endif /*_LIBPQ_LOCAL_H_INCLUDED*/


