#  File:     dis203_values.cdf
#  Contents: enumerations and values for DIS 2.0.3 and DIS 2.0.4
#  System:   BDS-D BIP development.
#  Created:  11-Oct-93
#  Author:   cchiang/ckuczaj
# 
#  Remarks:
# 	These are the enumerations defined in "Enumeration and Bit Encoded
#       Values for Use with Protocols for Distributed Interactive Simulation
# 	Applications" dated June 15, 1993 for use with Version 2 protocols
# 
#  History:
#     
#  $RCSfile: dis204_values.cdf,v $
#  $Revision: 1.1.1.1 $
#  $State: Exp $
#     
#  COPYRIGHT 1993 Loral Advanced Distributed Simulation
#  50 Moulton Street
#  Cambridge, Ma. 02138
#  617-873-3600
# 

hfile:
#include <stdtypes.h>
endhfile:

#  1.3.1 Fuze 
namespace_def: DIS204_FUZE uint16
  value: OTHER       0    
  value: CONTACT     1000 
  value: CONTACT_INSTANT 1100
  value: CONTACT_DELAYED 1200
  value: TIMED       2000 
  value: PROXIMITY   3000 
  value: COMMAND     4000 
  value: ALTITUDE    5000 
  value: DEPTH       6000 
  value: ACOUSTIC    7000 

hfile:
#define DIS204_FUZE_TYPE DIS204_FUZE
endhfile:


# 1.3.1 Warhead  
namespace_def: DIS204_WARHEAD uint16
  value: OTHER    0    
  value: HIGH_EXPLOSIVE 1000
  value: HIGH_EXPLOSIVE_PLASTIC 1100
  value: HIGH_EXPLOSIVE_INCENDIARY 1200
  value: HIGH_EXPLOSIVE_FRAGMENTATION 1300
  value: HIGH_EXPLOSIVE_ANTI_TANK 1400
  value: HIGH_EXPLOSIVE_BOMBLETS 1500
  value: HIGH_EXPLOSIVE_SHAPED_CHARGE 1600
  value: SMOKE    2000 
  value: ILLUMINATION 3000
  value: PRACTICE 4000 
  value: KINETIC  5000 
  value: MINES    6000 
  value: NUCLEAR  7000 
  value: CHEMICAL_GENERAL 8000
  value: CHEMICAL_BLISTER_AGENT 8100
  value: CHEMICAL_BLOOD_AGENT 8200
  value: CHEMICAL_NERVE_AGENT 8300
  value: BIOLOGICAL_GENERAL 9000

hfile:
#define DIS204_WARHEAD_TYPE DIS204_WARHEAD
endhfile:

# 2.3.1 General Repair Codes  
namespace_def: DIS204_REPAIR_CODE uint16
  value: NO_REPAIRS_PERFORMED 0
  value: REPAIR_EVERYTHING 1

# 2.3.2.1 Propulsion systems  
namespace_def: DIS204_REPAIR_SYSTEM uint16
  value: MOTOR 10
  value: STARTER 20
  value: ALTERNATOR 30
  value: GENERATOR 40
  value: BATTERY 50
  value: ENGINE_COOLANT_LEAK 60
  value: FUEL_FILTER 70
  value: TRANSMISSION_OIL_LEAK 80
  value: ENGINE_OIL_LEAK 90
  value: PUMPS 100
  value: PROPULSION_SYSTEM_FILTERS 110
  value: TRANSMISSION 120
  value: BRAKES 130
  value: SUSPENSION_SYSTEM 140
  value: OIL_FILTER 150
# 2.3.2.2 Hull, Airframe, Body  
  value: HULL 1000
  value: AIRFRAME 1010
  value: TRUCK_BODY 1020
  value: TANK_BODY 1030
  value: TRAILER_BODY 1040
  value: TURRET 1050
# 2.3.2.3 Interface to environment systems  
  value: PROPELLER 1500
  value: TRANSMISSION_ENV 1510
  value: ENVIRONMENTAL_FILTERS 1520
  value: BRAKES_ENV 1530
  value: WHEELS 1540
  value: TIRE 1550
  value: TRACK 1560
# 2.3.2.4 Weapon systems  
  value: GUN_ELEVATION_DRIVE 2000
  value: GUN_STABILIZATION_SYSTEM 2010
  value: GUNNERS_PRIMARY_SIGHT 2020
  value: COMMANDERS_EXTENSION_TO_THE_GPS 2030
  value: LOADING_MECHANISM 2040
  value: GUNNERS_AUXILIARY_SIGHT 2050
  value: GUNNERS_CONTROL_PANEL 2060
  value: GUNNERS_CONTROL_HANDLES 2070
  value: COMMANDERS_CONTROL_HANDLES 2090
  value: COMMANDERS_WEAPON_STATION 2100
  value: COMMANDERS_INDEPENDENT_THERMAL_VIEWER 2110
  value: GENERAL_WEAPONS 2120
# 2.3.2.5 Fuel systems  
  value: FUEL_TRANSFER_PUMP 4000
  value: FUEL_LINES 4010
  value: GAUGES 4020
  value: GENERAL_FUEL_STATION 4030
# 2.3.2.6 Electronic and communications systems  
  value: ELECTRONIC_COUNTER_MEASURE_SYSTEMS 4500
  value: ELECTRONIC_WARFARE_SYSTEMS 4600
  value: DETECTION_RADIO_FREQUENCY 4610
  value: MICROWAVE_DETECTOR 4620
  value: INFRARED_DETECTOR 4630
  value: LASER_DETECTOR 4640
  value: RANGE_FINDERS 4700
  value: RANGE_ONLY_RADAR 4710
  value: LASER_RANGE_FINDER 4720
  value: ELECTRONIC_SYSTEMS 4800
  value: RADIO_FREQUENCY 4810
  value: MICROWAVE 4820
  value: INFRARED 4830
  value: LASER 4840
  value: RADIOS 5000
  value: COMMUNICATION_SYSTEMS 5010
  value: INTERCOMS 5100
  value: ENCODERS 5200
  value: ENCRYPTION_DEVICES 5250
  value: DECODERS 5300
  value: DECRYPTION_DEVICES 5350
  value: EMITTERS 5400
  value: COMPUTERS 5500
  value: DETECTION_SYSTEMS 5600
  value: NAVIGATION_AND_CONTROL_SYSTEMS 6000
  value: FIRE_CONTROL_SYSTEMS 6500
# 2.3.2.7 Life support systems  
  value: AIR_SUPPLY 8000
  value: LIFE_SUPPORT_FILTERS 8010
  value: LIFE_SUPPORT_WATER_SUPPLY 8020
  value: REFRIDGERATION_SYSTEM 8030
  value: CHEMICAL_BIOLOGICAL_RADIOLOGIC_PROTECTION 8040
  value: WATER_WASH_DOWN_SYSTEMS 8050
  value: DECONTAMINATION_SYSTEMS 8060
# 2.3.2.8 Hydraulics systems and actuators  
  value: HYDRAULICS_WATER_SUPPLY 9000
  value: COOLING_SYSTEM 9010
  value: WINCHES 9020
  value: CATAPULTS 9030
  value: CRANES 9040
  value: LAUNCHERS 9050
# 2.3.2.9 Auxiliary craft  
  value: LIFE_BOATS 10000
  value: LANDING_CRAFT 10010
  value: EJECTION_SEATS 10020


# 3.3.1 General  
namespace_def: DIS204_ENTITY_APPEARANCE_GENERAL uint32
  value: STANDARD_APPEARANCE 0x0
  value: PAINT_SCHEME_CAMOUFLAGE 0x1
  value: MOBILITY_KILL_YES 0x2
  value: FIRE_POWER_KILL_YES 0x4
  value: DAMAGE_SLIGHT_DAMAGE 0x8
  value: DAMAGE_MODERATE_DAMAGE 0x10
  value: DAMAGE_DESTROYED 0x18
  value: SMOKE_PLUME 0x20
  value: SMOKE_ENGINE 0x40
  value: SMOKE_ENGINE_AND_PLUME 0x60
  value: TRAILING_EFFECTS_SMALL 0x80
  value: TRAILING_EFFECTS_MEDIUM 0x100
  value: TRAILING_EFFECTS_LARGE 0x180
  value: HATCH_CLOSED 0x200
  value: HATCH_POPPED 0x400
  value: HATCH_POPPED_AND_PERSON 0x600
  value: HATCH_OPEN 0x800
  value: HATCH_OPEN_AND_PERSON 0xa00
  value: HATCH_UNUSED_NUMBER_6 0xc00
  value: HATCH_UNUSED_NUMBER_7 0xe00
  value: LIGHTS_RUNNING 0x1000
  value: LIGHTS_NAVIGATION 0x2000
  value: LIGHTS_FORMATION 0x3000
  value: LIGHTS_UNUSED_NUMBER_4 0x4000
  value: LIGHTS_UNUSED_NUMBER_5 0x5000
  value: LIGHTS_UNUSED_NUMBER_6 0x6000
  value: LIGHTS_UNUSED_NUMBER_7 0x7000
  value: FLAMING_FLAMES_PRESENT 0x8000

# These need to be defined as constants instead of being in the 
# enumerated section above since they overload the value 0x0000. 
  value: PAINT_SCHEME_UNIFORM_COLOR           0x0
  value: MOBILITY_KILL_NO           0x0
  value: FIRE_POWER_KILL_NO           0x0
  value: DAMAGE_NO_DAMAGE           0x0
  value: TRAILING_EFFECTS_NONE           0x0
  value: SMOKE_NOT_SMOKING           0x0
  value: HATCH_NOT_APPLICABLE           0x0
  value: LIGHTS_NONE           0x0
  value: FLAMING_NONE           0x0


# 3.3.2.1.1 Platforms of the Land Domain  
namespace_def: DIS204_ENTITY_APPEARANCE_LAND uint32
  value: STANDARD_APPEARANCE 0x0
  value: LAUNCHER_RAISED 0x10000
  value: CAMOUFLAGE_TYPE_WINTER 0x20000
  value: CAMOUFLAGE_TYPE_FOREST 0x40000
  value: CAMOUFLAGE_TYPE_UNUSED 0x60000
  value: CONCEALED_YES 0x80000
  value: UNUSED_BIT_20 0x100000
  value: UNUSED_BIT_21 0x200000
  value: UNUSED_BIT_22 0x400000
  value: UNUSED_BIT_23 0x800000
  value: ENTITY_SPECIFIC_BIT_24 0x1000000
  value: ENTITY_SPECIFIC_BIT_25 0x2000000
  value: ENTITY_SPECIFIC_BIT_26 0x4000000
  value: ENTITY_SPECIFIC_BIT_27 0x8000000
  value: ENTITY_SPECIFIC_BIT_28 0x10000000
  value: ENTITY_SPECIFIC_BIT_29 0x20000000
  value: ENTITY_SPECIFIC_BIT_30 0x40000000
  value: ENTITY_SPECIFIC_BIT_31 0x80000000

# These need to be defined as constants instead of being in the 
# enumerated section above since they overload the value 0x00000000. 
  value: LAUNCHER_NOT_RAISED           0x0
  value: CONCEALED_NO           0x0
  value: CAMOUFLAGE_TYPE_DESERT           0x0
  value: BRIDGE_DISABLED_NO           0x0
# These are entity specific values, and so overload the above 
  value: BRIDGE_DISABLED_YES           0x1000000
  value: SHOVEL_DISABLED_YES           0x2000000
  value: PRIMARY_ROCKET_DISABLED_YES           0x4000000
  value: SECONDARY_ROCKET_DISABLED_YES           0x8000000
  value: SPOIL_DISPLAYED           0x10000000
  value: PRIMARY_ROCKET_PRESENT           0x2000000
  value: SECONDARY_ROCKET_PRESENT           0x20000000



# 3.3.2.1.2 Platforms of the Air Domain  
namespace_def: DIS204_ENTITY_APPEARANCE_AIR uint32
  value: AFTER_BURNER_OFF 0x0
  value: AFTER_BURNER_ON 0x10000
  value: UNUSED_BIT_17 0x20000
  value: UNUSED_BIT_18 0x40000
  value: UNUSED_BIT_19 0x80000
  value: UNUSED_BIT_20 0x100000
  value: UNUSED_BIT_21 0x200000
  value: UNUSED_BIT_22 0x400000
  value: UNUSED_BIT_23 0x800000
  value: ENTITY_SPECIFIC_BIT_24 0x1000000
  value: ENTITY_SPECIFIC_BIT_25 0x2000000
  value: ENTITY_SPECIFIC_BIT_26 0x4000000
  value: ENTITY_SPECIFIC_BIT_27 0x8000000
  value: ENTITY_SPECIFIC_BIT_28 0x10000000
  value: ENTITY_SPECIFIC_BIT_29 0x20000000
  value: ENTITY_SPECIFIC_BIT_30 0x40000000
  value: ENTITY_SPECIFIC_BIT_31 0x80000000


# 3.3.2.1.3 Platforms of the Surface Domain  
namespace_def: DIS204_ENTITY_APPEARANCE_SURFACE uint32 
  value: UNUSED_BIT_16 0x10000
  value: UNUSED_BIT_17 0x20000
  value: UNUSED_BIT_18 0x40000
  value: UNUSED_BIT_19 0x80000
  value: UNUSED_BIT_20 0x100000
  value: UNUSED_BIT_21 0x200000
  value: UNUSED_BIT_22 0x400000
  value: UNUSED_BIT_23 0x800000
  value: ENTITY_SPECIFIC_BIT_24 0x1000000
  value: ENTITY_SPECIFIC_BIT_25 0x2000000
  value: ENTITY_SPECIFIC_BIT_26 0x4000000
  value: ENTITY_SPECIFIC_BIT_27 0x8000000
  value: ENTITY_SPECIFIC_BIT_28 0x10000000
  value: ENTITY_SPECIFIC_BIT_29 0x20000000
  value: ENTITY_SPECIFIC_BIT_30 0x40000000
  value: ENTITY_SPECIFIC_BIT_31 0x80000000


# 3.3.2.1.4 Platforms of the Subsurface Domain  
namespace_def: DIS204_ENTITY_APPEARANCE_SUB_SURFACE uint32
  value: UNUSED_BIT_16 0x10000
  value: UNUSED_BIT_17 0x20000
  value: UNUSED_BIT_18 0x40000
  value: UNUSED_BIT_19 0x80000
  value: UNUSED_BIT_20 0x100000
  value: UNUSED_BIT_21 0x200000
  value: UNUSED_BIT_22 0x400000
  value: UNUSED_BIT_23 0x800000
  value: ENTITY_SPECIFIC_BIT_24 0x1000000
  value: ENTITY_SPECIFIC_BIT_25 0x2000000
  value: ENTITY_SPECIFIC_BIT_26 0x4000000
  value: ENTITY_SPECIFIC_BIT_27 0x8000000
  value: ENTITY_SPECIFIC_BIT_28 0x10000000
  value: ENTITY_SPECIFIC_BIT_29 0x20000000
  value: ENTITY_SPECIFIC_BIT_30 0x40000000
  value: ENTITY_SPECIFIC_BIT_31 0x80000000


# 3.3.2.1.5 Platforms of the Space Domain  
namespace_def: DIS204_ENTITY_APPEARANCE_SPACE uint32
  value: UNUSED_BIT_16 0x10000
  value: UNUSED_BIT_17 0x20000
  value: UNUSED_BIT_18 0x40000
  value: UNUSED_BIT_19 0x80000
  value: UNUSED_BIT_20 0x100000
  value: UNUSED_BIT_21 0x200000
  value: UNUSED_BIT_22 0x400000
  value: UNUSED_BIT_23 0x800000
  value: ENTITY_SPECIFIC_BIT_24 0x1000000
  value: ENTITY_SPECIFIC_BIT_25 0x2000000
  value: ENTITY_SPECIFIC_BIT_26 0x4000000
  value: ENTITY_SPECIFIC_BIT_27 0x8000000
  value: ENTITY_SPECIFIC_BIT_28 0x10000000
  value: ENTITY_SPECIFIC_BIT_29 0x20000000
  value: ENTITY_SPECIFIC_BIT_30 0x40000000
  value: ENTITY_SPECIFIC_BIT_31 0x80000000


# 3.3.2.2.1 Guided Munitions  
namespace_def: DIS204_ENTITY_APPEARANCE_MUNITION uint32 
  value: LAUNCH_FLASH_NO 0x0
  value: LAUNCH_FLASH_YES 0x10000
  value: UNUSED_BIT_17 0x20000
  value: UNUSED_BIT_18 0x40000
  value: UNUSED_BIT_19 0x80000
  value: UNUSED_BIT_20 0x100000
  value: UNUSED_BIT_21 0x200000
  value: UNUSED_BIT_22 0x400000
  value: UNUSED_BIT_23 0x800000
  value: ENTITY_SPECIFIC_BIT_24 0x1000000
  value: ENTITY_SPECIFIC_BIT_25 0x2000000
  value: ENTITY_SPECIFIC_BIT_26 0x4000000
  value: ENTITY_SPECIFIC_BIT_27 0x8000000
  value: ENTITY_SPECIFIC_BIT_28 0x10000000
  value: ENTITY_SPECIFIC_BIT_29 0x20000000
  value: ENTITY_SPECIFIC_BIT_30 0x40000000
  value: ENTITY_SPECIFIC_BIT_31 0x80000000
# This is an entity specific value, and therefore can't be in the above 
  value: CHARGE_ATTACHED           0x20000000

# 3.3.2.3.1 Life Forms  
namespace_def: DIS204_ENTITY_APPEARANCE_LIFE uint32
  value: LIFE_FORM_STATE_DESTROYED 0x0
  value: LIFE_FORM_STATE_CAMOUFLAGE 0x1
  value: LIFE_FORM_STATE_UPRIGHT 0x10000
  value: LIFE_FORM_STATE_KNEELING 0x20000
  value: LIFE_FORM_STATE_PRONE 0x30000
  value: WEAPON_1_DEPLOYED 0x40000
  value: WEAPON_1_SHOOTING_STANDING 0x50000
  value: WEAPON_1_SHOOTING_KNEELING 0x60000
  value: WEAPON_2_DEPLOYED 0x80000
  value: UNUSED_BIT_20 0x100000
  value: UNUSED_BIT_21 0x200000
  value: UNUSED_BIT_22 0x400000
  value: UNUSED_BIT_23 0x800000
  value: ENTITY_SPECIFIC_BIT_24 0x1000000
  value: ENTITY_SPECIFIC_BIT_25 0x2000000
  value: ENTITY_SPECIFIC_BIT_26 0x4000000
  value: ENTITY_SPECIFIC_BIT_27 0x8000000
  value: ENTITY_SPECIFIC_BIT_28 0x10000000
  value: ENTITY_SPECIFIC_BIT_29 0x20000000
  value: ENTITY_SPECIFIC_BIT_30 0x40000000
  value: ENTITY_SPECIFIC_BIT_31 0x80000000
# These need to be defined as constants instead of being in the 
# enumerated section above since they overload the value 0x00000000. 
  value: WEAPON_1_STOWED           0x0
  value: WEAPON_2_STOWED           0x0

# Multi-Stage "articulated" Dismounted Infantry (Experimental) 
namespace_def: DIS204EXP_ENTITY_APPEARANCE_LIFE uint32
  value: RUNNING_POSTURE_1 0x10010000
  value: RUNNING_POSTURE_2 0x20010000
  value: RUNNING_POSTURE_3 0x30010000
  value: RUNNING_POSTURE_4 0x40010000
  value: RUNNING_POSTURE_5 0x50010000
  value: RUNNING_POSTURE_6 0x60010000
  value: RUNNING_POSTURE_7 0x70010000
  value: RUNNING_POSTURE_8 0x80010000
  value: RUNNING_POSTURE_9 0x90010000
  value: RUNNING_POSTURE_10 0xa0010000
  value: RUNNING_POSTURE_11 0xb0010000
  value: RUNNING_POSTURE_12 0xc0010000
  value: RUNNING_TO_PRONE_1 0x1030000
  value: RUNNING_TO_PRONE_2 0x2030000
  value: RUNNING_TO_PRONE_3 0x3030000
  value: RUNNING_TO_PRONE_4 0x4030000
  value: CRAWLING_1 0x130000
  value: CRAWLING_2 0x230000
  value: CRAWLING_3 0x330000
  value: CRAWLING_4 0x430000
  value: CRAWLING_5 0x530000
  value: CRAWLING_6 0x630000
  value: CRAWLING_7 0x730000
  value: CRAWLING_8 0x830000

# Atlas-specific Lifeform (DI) extensions: 
namespace_def: DIS204AE_ENTITY_APPEARANCE_LIFE uint32 
  value: DEACTIVATE_MASK           0x800000
  value: MOUNT_MASK           0x3000000
  value: FORMATION_MASK           0xc000000
  value: ACTIVATED 0x0
  value: DEACTIVATED 0x800000
  value: MOUNT_DISMOUNTING 0x1000000
  value: MOUNT_MOUNTING 0x2000000
  value: MOUNT_MOUNTED 0x3000000
  value: FORMATION_REIHE 0x4000000
  value: FORMATION_RUDEL 0x8000000
  value: FORMATION_DEFENSE 0xc000000

# These need to be defined as constants instead of being in the 
# enumerated section above since they overload the value 0x00000000. 
  value: MOUNT_INVALID           0x0
  value: FORMATION_OTHER           0x0


# 3.3.2.4.1 Environmentals  
namespace_def: DIS204_ENTITY_APPEARANCE_ENVIRONMENTAL uint32
  value: DENSITY_CLEAR 0x0
  value: DENSITY_HAZY 0x10000
  value: DENSITY_DENSE 0x20000
  value: DENSITY_VERY_DENSE 0x30000
  value: DENSITY_OPAQUE 0x40000
  value: DENSITY_UNUSED_5 0x50000
  value: DENSITY_UNUSED_6 0x60000
  value: DENSITY_UNUSED_7 0x70000
  value: UNUSED_BIT_19 0x80000
  value: UNUSED_BIT_20 0x100000
  value: UNUSED_BIT_21 0x200000
  value: UNUSED_BIT_22 0x400000
  value: UNUSED_BIT_23 0x800000
  value: SPECIFIC_BIT_24 0x1000000
  value: SPECIFIC_BIT_25 0x2000000
  value: SPECIFIC_BIT_26 0x4000000
  value: SPECIFIC_BIT_27 0x8000000
  value: SPECIFIC_BIT_28 0x10000000
  value: SPECIFIC_BIT_29 0x20000000
  value: SPECIFIC_BIT_30 0x40000000
  value: SPECIFIC_BIT_31 0x80000000

# 3.3.2.5.1 Cultural Features  
namespace_def: DIS204_ENTITY_APPEARANCE_CULTURAL uint32
  value: UNUSED_BIT_16 0x10000
  value: UNUSED_BIT_17 0x20000
  value: UNUSED_BIT_18 0x40000
  value: UNUSED_BIT_19 0x80000
  value: UNUSED_BIT_20 0x100000
  value: UNUSED_BIT_21 0x200000
  value: UNUSED_BIT_22 0x400000
  value: UNUSED_BIT_23 0x800000
  value: SPECIFIC_BIT_24 0x1000000
  value: SPECIFIC_BIT_25 0x2000000
  value: SPECIFIC_BIT_26 0x4000000
  value: SPECIFIC_BIT_27 0x8000000
  value: SPECIFIC_BIT_28 0x10000000
  value: SPECIFIC_BIT_29 0x20000000
  value: SPECIFIC_BIT_30 0x40000000
  value: SPECIFIC_BIT_31 0x80000000

hfile:
#define DIS204_ENTITY_APPEARANCE_CULTURAL_FEATURE DIS204_ENTITY_APPEARANCE_CULTURAL
endhfile:

# 3.3.2.6.1 Supplies  
namespace_def: DIS204_ENTITY_APPEARANCE_SUPPLIES uint32
  value: UNUSED_BIT_16 0x10000
  value: UNUSED_BIT_17 0x20000
  value: UNUSED_BIT_18 0x40000
  value: UNUSED_BIT_19 0x80000
  value: UNUSED_BIT_20 0x100000
  value: UNUSED_BIT_21 0x200000
  value: UNUSED_BIT_22 0x400000
  value: UNUSED_BIT_23 0x800000
  value: SPECIFIC_BIT_24 0x1000000
  value: SPECIFIC_BIT_25 0x2000000
  value: SPECIFIC_BIT_26 0x4000000
  value: SPECIFIC_BIT_27 0x8000000
  value: SPECIFIC_BIT_28 0x10000000
  value: SPECIFIC_BIT_29 0x20000000
  value: SPECIFIC_BIT_30 0x40000000
  value: SPECIFIC_BIT_31 0x80000000

# 4.3.1.2 Country ID  
namespace_def: DIS204_COUNTRY uint8
  value: OTHER    0    
  value: AFGHANISTAN 1 
  value: ALBANIA  2    
  value: ALGERIA  3    
  value: AMERICAN_SAMOA 4
  value: ANDORRA  5    
  value: ANGOLA   6    
  value: ANGUILLA 7    
  value: ANTARCTICA 8  
  value: ANTIGUA_AND_BARBUDA 9
  value: ARGENTINA 10  
  value: ARUBA    11   
  value: ASHMORE_AND_CARTIER_ISLANDS 12
  value: AUSTRALIA 13  
  value: AUSTRIA  14   
  value: BAHAMAS  15   
  value: BAHRAIN  16   
  value: BAKER_ISLAND 17
  value: BANGLADESH 18 
  value: BARBADOS 19   
  value: BASSAS_DA_INDIA 20
  value: BELGIUM  21   
  value: BELIZE   22   
  value: BENIN    23   
  value: BERMUDA  24   
  value: BHUTAN   25   
  value: BOLIVIA  26   
  value: BOTSWANA 27   
  value: BOUVET_ISLAND 28
  value: BRAZIL   29   
  value: BRITISH_INDIAN_OCEAN_TERRITORY 30
  value: BRITISH_VIRGIN_ISLANDS 31
  value: BRUNEI   32   
  value: BULGARIA 33   
  value: BURKINA_FASO 34
  value: BURMA    35   
  value: BURUNDI  36   
  value: CAMBODIA 37   
  value: CAMEROON 38   
  value: CANADA   39   
  value: CAPE_VERDE 40 
  value: CAYMAN_ISLANDS 41
  value: CENTRAL_AFRICAN_REPUBLIC 42
  value: CHAD     43   
  value: CHILE    44   
  value: CHINA    45   
  value: CHRISTMAS_ISLAND 46
  value: COCOS_ISLANDS 47
  value: COLOMBIA 48   
  value: COMOROS  49   
  value: CONGO    50   
  value: COOK_ISLANDS 51
  value: CORAL_SEA_ISLANDS 52
  value: COSTA_RICA 53 
  value: CUBA     54   
  value: CYPRUS   55   
  value: CZECHOSLOVAKIA 56
  value: DENMARK  57   
  value: DJIBOUTI 58   
  value: DOMINICA 59   
  value: DOMINICAN_REPUBLIC 60
  value: ECUADOR  61   
  value: EGYPT    62   
  value: EL_SALVADOR 63
  value: EQUATORIAL_GUINEA 64
  value: ETHIOPIA 65   
  value: EUROPA_ISLANDS 66
  value: FALKLAND_ISLANDS 67
  value: FAROE_ISLAND 68
  value: FIJI     69   
  value: FINLAND  70   
  value: FRANCE   71   
  value: FRENCH_GUIANA 72
  value: FRENCH_POLYNESIA 73
  value: FRENCH_SOUTHERN_AND_ANTARCTIC_ISLANDS 74
  value: GABON    75   
  value: GAMBIA   76   
  value: GAZA_STRIP 77 
  value: GERMANY  78   
  value: GHANA    79   
  value: GIBRALTAR 80  
  value: GLORIOSO_ISLAND 81
  value: GREECE   82   
  value: GREENLAND 83  
  value: GRENADA  84   
  value: GUADALOUPE 85 
  value: GUAM     86   
  value: GUATEMALA 87  
  value: GUERNSEY 88   
  value: GUINEA   89   
  value: GUINEA_BISSUA 90
  value: GUYANA   91   
  value: HAITI    92   
  value: HEARD_ISLAND_AND_MCDONALD_ISLANDS 93
  value: HONDURAS 94   
  value: HONG_KONG 95  
  value: HOWLAND_ISLAND 96
  value: HUNGARY  97   
  value: ICELAND  98   
  value: INDIA    99   
  value: INDONESIA 100 
  value: IRAN     101  
  value: IRAQ     102  
  value: IRAQ_SAUDI_ARABIA_NEUTRAL_ZONE 103
  value: IRELAND  104  
  value: ISRAEL   105  
  value: ITALY    106  
  value: IVORY_COAST 107
  value: JAMAICA  108  
  value: JAN_MAYEN 109 
  value: JAPAN    110  
  value: JARVIS_ISLAND 111
  value: JERSEY   112  
  value: JOHNSTON_ATOLL 113
  value: JORDAN   114  
  value: JUAN_DE_NOVA_ISLAND 115
  value: KENYA    116  
  value: KINGMAN_REEF 117
  value: KIRIBATI 118  
  value: KOREA    119  
  value: REPUBLIC_OF_KOREA 120
  value: KUWAIT   121  
  value: LAOS     122  
  value: LEBANON  123  
  value: LESOTHO  124  
  value: LIBERIA  125  
  value: LIBYA    126  
  value: LIECHTENSTEIN 127
  value: LUXEMBOURG 128
  value: MACAO    129  
  value: MADAGASCAR 130
  value: MALAWI   131  
  value: MALAYSIA 132  
  value: MALDIVES 133  
  value: MALI     134  
  value: MALTA    135  
  value: MAN_ISLE_OF 136
  value: MARSHALL_ISLANDS 137
  value: MARTINIQUE 138
  value: MAURITANIA 139
  value: MAURITIUS 140 
  value: MAYOTTE  141  
  value: MEXICO   142  
  value: MICRONESIA 143
  value: MONACO   144  
  value: MONGOLIA 145  
  value: MONTSERRAT 146
  value: MOROCCO  147  
  value: MOSAMBIQUE 148
  value: NAMIBIA  149  
  value: NAURU    150  
  value: NAVASSA_ISLAND 151
  value: NEPAL    152  
  value: NETHERLANDS 153
  value: NETHERLANDS_ANTILLES 154
  value: NEW_CALEDONIA 155
  value: NEW_ZEALAND 156
  value: NICARAGUA 157 
  value: NIGER    158  
  value: NIGERIA  159  
  value: NIUE     160  
  value: NORFOLK_ISLAND 161
  value: NORTHERN_MARIANA_ISLANDS 162
  value: NORWAY   163  
  value: OMAN     164  
  value: PAKISTAN 165  
  value: PALMYRA_ATOLL 166
  value: PALAU    167  
  value: PANAMA   168  
  value: PAPUA_NEW_GUINEA 169
  value: PARACEL_ISLANDS 170
  value: PARAGUAY 171  
  value: PERU     172  
  value: PHILIPPINES 173
  value: PITCAIM_ISLANDS 174
  value: POLAND   175  
  value: PORTUGAL 176  
  value: PUERTO_RICO 177
  value: QATAR    178  
  value: REUNION  179  
  value: ROMANIA  180  
  value: RWANDA   181  
  value: ST_KITTS_AND_NEVIS 182
  value: ST_HELENA 183 
  value: ST_LUCIA 184  
  value: ST_PIERRE_AND_MIGUELON 185
  value: ST_VINCENT_AND_THE_GRENADINES 186
  value: SAN_MARINO 187
  value: SAO_TOME_AND_PRINCIPE 188
  value: SAUDI_ARABIA 189
  value: SENEGAL  190  
  value: SEYCHELLES 191
  value: SIERRA_LEONE 192
  value: SINGAPORE 193 
  value: SOLOMON_ISLANDS 194
  value: SOMALIA  195  
  value: SOUTH_GEORGIA_AND_SOUTH_SANDWICH_ISLANDS 196
  value: SOUTH_AFRICA 197
  value: SPAIN    198  
  value: SPRATLY_ISLANDS 199
  value: SRI_LANKA 200 
  value: SUDAN    201  
  value: SURINAME 202  
  value: SVALBARD 203  
  value: SWAZILAND 204 
  value: SWEDEN   205  
  value: SWITZERLAND 206
  value: SYRIA    207  
  value: TAIWAN   208  
  value: TANZANIA 209  
  value: THAILAND 210  
  value: TOGO     211  
  value: TOKELAU  212  
  value: TONGA    213  
  value: TRINIDAD_AND_TOBAGO 214
  value: TROMELIN_ISLAND 215
  value: TRUST_TERRITORY_OF_THE_PACIFIC_ISLANDS 216
  value: TUNISIA  217  
  value: TURKEY   218  
  value: TURKS_AND_CAICOS_ISLAND 219
  value: TUVALU   220  
  value: UGANDA   221  
  value: UNION_OF_SOVIET_SOCIALIST_REPUBLICS 222
  value: UNITED_ARAB_EMIRATES 223
  value: UNITED_KINGDOM 224
  value: UNITED_STATES 225
  value: URUGUAY  226  
  value: VANUATU  227  
  value: VATICAN_CITY 228
  value: VENEZUELA 229 
  value: VIETNAM  230  
  value: VIRGIN_ISLANDS 231
  value: WAKE_ISLAND 232
  value: WALLIS_AND_FUTUNA 233
  value: WESTERN_SAHARA 234
  value: WEST_BANKS 235
  value: WESTERN_SAMOA 236
  value: YEMEN    237  
  value: YEMEN_ADEN 238
  value: YEMEN_SANAA 239
  value: YUGOSLAVIA 240
  value: ZAIRE    241  
  value: ZAMBIA   242  
  value: ZIMBABWE 243  


# 4.3.1.3 Detonation result  
namespace_def: DIS204_DETONATION_RESULT uint8
  value: OTHER 0
  value: ENTITY_IMPACT 1
  value: ENTITY_PROXIMATE_DETONATION 2
  value: GROUND_IMPACT 3
  value: GROUND_PROXIMATE_DETONATION 4
  value: DETONATION 5
  value: NONE 6
  value: MICLIC 21     # really 2.0.4


# 4.3.1.4 Entity marking  
namespace_def: DIS204_ENTITY_MARKING_CHAR_SET uint8
  value: MAX_LENGTH           11
  value: UNUSED 0
  value: ASCII 1


# 4.3.1.5 Force ID  
namespace_def: DIS204_FORCE uint8
  value: OTHER      0    
  value: FRIENDLY   1    
  value: OPPOSING   2    
  value: NEUTRAL    3    

# 4.3.1.6 PDU kinds  
defs: DIS204_PDU_KIND uint8
  value: DIS204_OTHER_PDU_KIND   0    
  value: DIS204_ENTITY_STATE_PDU_KIND 1
  value: DIS204_FIRE_PDU_KIND    2    
  value: DIS204_DETONATION_PDU_KIND 3 
  value: DIS204_COLLISION_PDU_KIND 4  
  value: DIS204_SERVICE_REQUEST_PDU_KIND 5
  value: DIS204_RESUPPLY_OFFER_PDU_KIND 6
  value: DIS204_RESUPPLY_RECEIVED_PDU_KIND 7
  value: DIS204_RESUPPLY_CANCEL_PDU_KIND 8
  value: DIS204_REPAIR_COMPLETE_PDU_KIND 9
  value: DIS204_REPAIR_RESPONSE_PDU_KIND 10
  value: DIS204_CREATE_ENTITY_PDU_KIND 11
  value: DIS204_REMOVE_ENTITY_PDU_KIND 12
  value: DIS204_START_RESUME_PDU_KIND 13
  value: DIS204_STOP_FREEZE_PDU_KIND 14
  value: DIS204_ACKNOWLEDGE_PDU_KIND 15
  value: DIS204_ACTION_REQUEST_PDU_KIND 16
  value: DIS204_ACTION_RESPONSE_PDU_KIND 17
  value: DIS204_DATA_QUERY_PDU_KIND 18
  value: DIS204_SET_DATA_PDU_KIND 19  
  value: DIS204_DATA_PDU_KIND    20   
  value: DIS204_EVENT_REPORT_PDU_KIND 21
  value: DIS204_MESSAGE_PDU_KIND 22   
  value: DIS204_EMISSION_PDU_KIND 23  
  value: DIS204_LASER_PDU_KIND   24   
  value: DIS204_TRANSMITTER_PDU_KIND 25
  value: DIS204_SIGNAL_PDU_KIND  26   
  value: DIS204_RECEIVER_PDU_KIND 27  
  value: DIS204_AGGREGATE_PDU_KIND 134


# 4.3.1.8 Result of Repair  
namespace_def: DIS204_REPAIR_RESULT uint8
  value: OTHER 0 
  value: REPAIR_ENDED 1
  value: INVALID_REPAIR 2
  value: REPAIR_INTERRUPTED 3
  value: SERVICE_CANCELLED_BY_THE_SUPPLIER 4


# 4.3.1.9 Service type  
namespace_def: DIS204_SERVICE_TYPE uint8
  value: OTHER 0  
  value: RESUPPLY 1
  value: REPAIR 2 


# 4.3.1.10 Reasons to stop  
namespace_def: DIS204_REASONS_TO_STOP uint8
  value: OTHER 0
  value: RECESS 1
  value: TERMINATION 2
  value: SYSTEM_FAILURE 3
  value: SECURITY_VIOLATION 4
  value: ENTITY_RECONSTITUTION 5


# 4.3.1.11 Acknowledgement Flags  
namespace_def: DIS204_ACKNOWLEDGEMENT_FLAGS uint8
  value: OTHER 0
  value: CREATE_ENTITY 1
  value: REMOVE_ENTITY 2
  value: START_RESUME 3
  value: STOP_FREEZE 4


# 4.3.1.12 Action ID  
namespace_def: DIS204_ACTION_ID uint8
  value: OTHER  0    
  value: OTHER_LOCAL_STORAGE 1
  value: OTHER_INFORM_SM_RAN_OUT_OF_AMMUNITION 2
  value: OTHER_INFORM_SM_KILLED_IN_ACTION 3
  value: OTHER_INFORM_SM_DAMAGE 4
  value: OTHER_INFORM_SM_MOBILITY_DISABLED 5
  value: OTHER_INFORM_SM_FIRE_DISABLED 6


# 4.3.1.13 Request Status  
namespace_def: DIS204_REQUEST_STATUS uint8
  value: OTHER 0
  value: PENDING 1
  value: EXECUTING 2
  value: PARTIALLY_COMPLETE 3
  value: COMPLETE 4


# 4.3.1.14 Event Type  
namespace_def: DIS204_EVENT_TYPE uint8
  value: OTHER 0    
  value: RAN_OUT_OF_FUEL 1
  value: RAN_OUT_OF_AMMUNITION 2
  value: KILLED_IN_ACTION 3
  value: DAMAGE 4   


# 4.3.1.15 Datum Parameters  
namespace_def: DIS204_DATUM_PARAMETER uint8
  value: MASS 1
  value: FORCE_ID 2
  value: ENTITY_TYPE_KIND 3
  value: ENTITY_TYPE_DOMAIN 4
  value: ENTITY_TYPE_COUNTRY 5
  value: ENTITY_TYPE_SUB_CATEGORY 6
  value: ENTITY_TYPE_SPECIFIC 7
  value: ENTITY_TYPE_EXTRA 8
  value: ALTERNATIVE_ENTITY_TYPE_KIND 9
  value: ALTERNATIVE_ENTITY_TYPE_DOMAIN 10
  value: ALTERNATIVE_ENTITY_TYPE_COUNTRY 11
  value: ALTERNATIVE_ENTITY_TYPE_SUB_CATEGORY 12
  value: ALTERNATIVE_ENTITY_TYPE_SPECIFIC 13
  value: ALTERNATIVE_ENTITY_TYPE_EXTRA 14
  value: ENTITY_LOCATION_X 15
  value: ENTITY_LOCATION_Y 16
  value: ENTITY_LOCATION_Z 17
  value: ENTITY_LINEAR_VELOCITY_X 18
  value: ENTITY_LINEAR_VELOCITY_Y 19
  value: ENTITY_LINEAR_VELOCITY_Z 20
  value: ENTITY_ORIENTATION_X 21
  value: ENTITY_ORIENTATION_Y 22
  value: ENTITY_ORIENTATION_Z 23
  value: DEAD_RECKONING_ALGORITHM 24
  value: DEAD_RECKONING_LINEAR_ACCELERATION_X 25
  value: DEAD_RECKONING_LINEAR_ACCELERATION_Y 26
  value: DEAD_RECKONING_LINEAR_ACCELERATION_Z 27
  value: DEAD_RECKONING_ANGULAR_VELOCITY_X 28
  value: DEAD_RECKONING_ANGULAR_VELOCITY_Y 29
  value: DEAD_RECKONING_ANGULAR_VELOCITY_Z 30
  value: ENTITY_APPEARANCE 31
  value: ENTITY_MARKING_CHARACTER_SET 32
  value: ENTITY_MARKING_11_BYTES 33
  value: ENTITY_CAPABILITY 34
  value: NUMBER_ARTICULATION_PARAMETERS 35
  value: ARTICULATION_PARAMETER_ID 36
  value: ARTICULATION_PARAMETER_PARAMETER_TYPE 37
  value: ARTICULATION_PARAMETER_PARAMETER_VALUE 38
  value: AMOUNT_OF_AMMUNITION_SUPPLIES 39
  value: AMMUNITION_QUANTITY 40
  value: FUEL_QUANTITY 41
  value: RADAR_SYSTEM_STATUS 42
  value: RADIO_COMMUNICATION_SYSTEM_STATUS 43
  value: DEFAULT_TIME_FOR_STATIONARY_RADIO_TRANSMISSION 44
  value: DEFAULT_TIME_FOR_MOVING_RADIO_TRANSMISSION 45
  value: BODY_PART_DAMAGED_RATIO 46
  value: NAME_OF_THE_TERRAIN_DATABASE_FILE 47
  value: NAME_OF_THE_LOCAL_LOGGER_FILE 48


# 4.3.1.16 Emitter System  
namespace_def: DIS204_EMITTER_SYSTEM uint8
  value: OTHER 0
  value: TBD 1  
  value: ORSMC 2
  value: MMCM 3

# 4.3.1.17 Emission Function  
namespace_def: DIS204_EMISSION_FUNCTION uint8
  value: OTHER 0
  value: TBD 1
  value: ORSMC 2


# 4.3.1.18 Laser Code Name  
namespace_def: DIS204_LASER_CODE_NAME uint8
  value: OTHER 0
  value: TBD 1 


# 4.3.1.19 Laser Code  
namespace_def: DIS204_LASER_CODE uint8
  value: OTHER 0    
  value: TBD   1    


# 4.3.1.20 Radio Transmit State  
namespace_def: DIS204_RADIO_TRANSMIT_STATE uint8
  value: OFF 0
  value: ON_BUT_NOT_TRANSMITTING 1
  value: ON_AND_TRANSMITTING 2


# 4.3.1.21 Radio Input Source  
namespace_def: DIS204_RADIO_INPUT_SOURCE uint8
  value: OTHER 0
  value: PILOT 1
  value: CO_PILOT 2
  value: FIRST_OFFICER 3


# 4.3.1.22 Radio Spread Spectrum  
namespace_def: DIS204_RADIO_SPREAD_SPECTRUM uint8
  value: FREQUENCY_HOPPING 0
  value: PSEUDO_NOISE 1
  value: TIME_HOPPING 2


# 4.3.1.23 Radio Major Modulation  
namespace_def: DIS204_RADIO_MAJOR_MODULATION uint8
  value: OTHER 0
  value: AMPLITUDE 1
  value: AMPLITUDE_AND_ANGLE 2
  value: COMBINATION 3
  value: PULSE 4
  value: UNMODULATED 5


# 4.3.1.24.1 Detailed Modulation for Amplitude Modulation  
namespace_def: DIS204_DETAILED_MODULATION_FOR_AMPLITUDE_MODULATION uint8
  value: OTHER 0
  value: AFSK 1
  value: AM 2
  value: CW 3
  value: DSB 4
  value: ISB 5
  value: LSB 6
  value: SSB_FULL 7
  value: SSB_REDEC 8
  value: USB 9
  value: VSB 10


# 4.3.1.24.2 Detailed Modulation for Amplitude and Angle Modulation  
namespace_def: DIS204_DETAILED_MODULATION_FOR_AMPLITUDE_AND_ANGLE_MODULATION uint8
  value: OTHER 0
  value: AMPLITUDE_AND_ANGLE 1


# 4.3.1.24.3 Detailed Modulation for Angle Modulation  
namespace_def: DIS204_DETAILED_MODULATION_FOR_ANGLE_MODULATION uint8
  value: OTHER 0
  value: FM 1
  value: FSK 2
  value: PM 3


# 4.3.1.24.4 Detailed Modulation for Combination Modulation  
namespace_def: DIS204_DETAILED_MODULATION_FOR_COMBINATION_MODULATION uint8
  value: OTHER 0
  value: AMPLITUDE_ANGLE_PULSE 1


# 4.3.1.24.5 Detailed Modulation for Unmodulated Modulation  
namespace_def: DIS204_DETAILED_MODULATION_FOR_UNMODULATED_MODULATION uint8
  value: OTHER 0
  value: CONTINUOUS_WAVE 1


# 4.3.1.25 Radio System  
namespace_def: DIS204_RADIO_SYSTEM uint8
  value: OTHER 0  
  value: GENERIC 1
  value: HQ  2    
  value: HQII 3   
  value: HQIIA 4  
  value: SINCGARS 5


# 4.3.1.26 Radio Crypto System  
namespace_def: DIS204_RADIO_CRYPTO uint16
  value: SYSTEM_OTHER 0
  value: SYSTEM_KY_28 1
  value: SYSTEM_KY_58 2


# 4.3.1.27.1 Radio Signal Encoding Class  
namespace_def: DIS204_RADIO_SIGNAL_ENCODING_CLASS uint16
  value: ENCODED_VOICE 0x0
  value: RAW_BINARY_DATA 0x4000
  value: APPLICATION_SPECIFIC_DATA 0x8000
  value: PRE_RECORDED_VOICE_POINTER 0xc000


# 4.3.1.28 Radio Signal Encoding Type  
namespace_def: DIS204_RADIO_SIGNAL_ENCODING_TYPE uint16
  value: 8_BIT_MU_LAW 0x1
  value: CVSD_PER_MIL_STD_188_113 0x2
  value: ADPCM_PER_CCITT_G_721 0x3
  value: 16_BIT_LINEAR_PCM 0x4


# 4.3.1.29 Radio Receiver State  
namespace_def: DIS204_RADIO_RECEIVER_STATE uint8
  value: OFF 0
  value: ON_BUT_NOT_RECEIVING 1
  value: ON_AND_RECEIVING 2


# 4.3.1.30 Protocol Version  
namespace_def: DIS204_PROTOCOL_VERSION uint8
  value: 1_0 1
  value: IEEE_1278_1993 2
  value: 2_0 3

  value: CURRENT           DIS204_PROTOCOL_VERSION_2_0

# 5.0 Articulated Parameters  

# An articulated parameter is described in two parts - the type of motion 
# of the appendage, and what the appendage is.  The types of motion are 
# defined by constants.  The appendages are defined by multiples of 20. 
# An articulation parameter describes one 
# aspect of an appendage.  This is defined by adding the motion type to 
# the appendage type.  There are certain appendages that don't have any 
# motions or positions associated with them; these are included in the 
# articulated parts (appendages) enumeration, but should not have any 
# articulated part types (motions) added to them. 

# The following 2 definitions are defined as a result of the 
# description of articulation and attached types in Annex 
# A of the 2.0.3 spec.  
namespace_def: DIS204_PART_TYPE uint8
  value: DIS204_PART_TYPE_ARTICULATED 0
  value: DIS204_PART_TYPE_ATTACHED 1  
  value: DIS204_PART_TYPE_WHOLE  2     /* dummy constant to fool drn (?) 


# The following definition must be set to the maximum number 
#   of attached and articulated parts  
defs: DIS204_MAXIMUM_INDICES
  value: DIS204_ATTACHED_PART_INDEX_MAX           1024
  value: DIS204_ARTICULATED_PART_INDEX_MAX           7808

# 5.3 Table 5-1 Attached Part Stations  
defs: DIS204_ARTICULATED_PART_STATIONS uint8
  value: DIS204_ARTICULATED_PART_EMPTY 0
  value: DIS204_ARTICULATED_PART_MODEL_SPECIFIC_STATIONS 1
  value: DIS204_ARTICULATED_PART_FUSELAGE_STATIONS 512
  value: DIS204_ARTICULATED_PART_LEFT_WING_STATIONS 640
  value: DIS204_ARTICULATED_PART_RIGHT_WING_STATIONS 768
  value: DIS204_ARTICULATED_PART_OTHER_ATTACHED_PARTS 896


# 5.3 Table 5-2 Parameter Types  
namespace_def: DIS204_ARTICULATED_PARAMETER_TYPE uint8
  value: POSITION 1
  value: POSITION_RATE 2
  value: EXTENSION 3
  value: EXTENSION_RATE 4
  value: X 5
  value: X_RATE 6
  value: Y 7
  value: Y_RATE 8
  value: Z 9
  value: Z_RATE 10
  value: AZIMUTH 11
  value: AZIMUTH_RATE 12
  value: ELEVATION 13
  value: ELEVATION_RATE 14
  value: ROTATION 15
  value: ROTATION_RATE 16


# 5.3 Table 5-3 Articulating Parts  
namespace_def: DIS204_ARTICULATED_PART uint16
  value: OFFSET           32
  value: RUDDER 1024
  value: LEFT_FLAP 1056
  value: RIGHT_FLAP 1088
  value: LEFT_AILERON 1120
  value: RIGHT_AILERON 1152
  value: OTHER_AIRCRAFT_SURFACES 1184
  value: PERISCOPE 2048
  value: GENERIC_ANTENNA 2080
  value: SNORKEL 2112
  value: OTHER_EXTENDABLE_PARTS 2144
  value: LANDING_GEAR 3072
  value: TAIL_HOOK 3104
  value: SPEED_BRAKE 3136
  value: LEFT_WEAPON_BAY_DOOR 3168
  value: RIGHT_WEAPON_BAY_DOOR 3200
  value: TANK_OR_APC_HATCH 3232
  value: WINGSWEEP 3264
  value: OTHER_FIXED_PARTS 3296
  value: PRIMARY_TURRET_NUMBER_1 4096
  value: PRIMARY_TURRET_NUMBER_2 4128
  value: PRIMARY_TURRET_NUMBER_3 4160
  value: PRIMARY_TURRET_NUMBER_4 4200
  value: PRIMARY_TURRET_NUMBER_5 4224
  value: PRIMARY_TURRET_NUMBER_6 4256
  value: PRIMARY_TURRET_NUMBER_7 4288
  value: PRIMARY_TURRET_NUMBER_8 4320
  value: PRIMARY_TURRET_NUMBER_9 4352
  value: PRIMARY_TURRET_NUMBER_10 4384
  value: PRIMARY_GUN_NUMBER_1 4416
  value: PRIMARY_GUN_NUMBER_2 4448
  value: PRIMARY_GUN_NUMBER_3 4480
  value: PRIMARY_GUN_NUMBER_4 4512
  value: PRIMARY_GUN_NUMBER_5 4544
  value: PRIMARY_GUN_NUMBER_6 4576
  value: PRIMARY_GUN_NUMBER_7 4608
  value: PRIMARY_GUN_NUMBER_8 4640
  value: PRIMARY_GUN_NUMBER_9 4672
  value: PRIMARY_GUN_NUMBER_10 4704
  value: PRIMARY_LAUNCHER_1 4736
  value: PRIMARY_LAUNCHER_2 4768
  value: PRIMARY_LAUNCHER_3 4800
  value: PRIMARY_LAUNCHER_4 4832
  value: PRIMARY_LAUNCHER_5 4864
  value: PRIMARY_LAUNCHER_6 4896
  value: PRIMARY_LAUNCHER_7 4928
  value: PRIMARY_LAUNCHER_8 4960
  value: PRIMARY_LAUNCHER_9 4992
  value: PRIMARY_LAUNCHER_10 5024
  value: PRIMARY_DEFENSE_SYSTEMS_1 5056
  value: PRIMARY_DEFENSE_SYSTEMS_2 5088
  value: PRIMARY_DEFENSE_SYSTEMS_3 5120
  value: PRIMARY_DEFENSE_SYSTEMS_4 5152
  value: PRIMARY_DEFENSE_SYSTEMS_5 5184
  value: PRIMARY_DEFENSE_SYSTEMS_6 5216
  value: PRIMARY_DEFENSE_SYSTEMS_7 5348
  value: PRIMARY_DEFENSE_SYSTEMS_8 5280
  value: PRIMARY_DEFENSE_SYSTEMS_9 5312
  value: PRIMARY_DEFENSE_SYSTEMS_10 5344
  value: PRIMARY_RADAR_1 5376
  value: PRIMARY_RADAR_2 5408
  value: PRIMARY_RADAR_3 5440
  value: PRIMARY_RADAR_4 5472
  value: PRIMARY_RADAR_5 5504
  value: PRIMARY_RADAR_6 5536
  value: PRIMARY_RADAR_7 5568
  value: PRIMARY_RADAR_8 5600
  value: PRIMARY_RADAR_9 5632
  value: PRIMARY_RADAR_10 5664
  value: SECONDARY_TURRET_NUMBER_1 5696
  value: SECONDARY_TURRET_NUMBER_2 5728
  value: SECONDARY_TURRET_NUMBER_3 5760
  value: SECONDARY_TURRET_NUMBER_4 5792
  value: SECONDARY_TURRET_NUMBER_5 5824
  value: SECONDARY_TURRET_NUMBER_6 5856
  value: SECONDARY_TURRET_NUMBER_7 5888
  value: SECONDARY_TURRET_NUMBER_8 5920
  value: SECONDARY_TURRET_NUMBER_9 5952
  value: SECONDARY_TURRET_NUMBER_10 5984
  value: SECONDARY_GUN_NUMBER_1 6016
  value: SECONDARY_GUN_NUMBER_2 6048
  value: SECONDARY_GUN_NUMBER_3 6080
  value: SECONDARY_GUN_NUMBER_4 6112
  value: SECONDARY_GUN_NUMBER_5 6144
  value: SECONDARY_GUN_NUMBER_6 6176
  value: SECONDARY_GUN_NUMBER_7 6208
  value: SECONDARY_GUN_NUMBER_8 6340
  value: SECONDARY_GUN_NUMBER_9 6272
  value: SECONDARY_GUN_NUMBER_10 6304
  value: SECONDARY_LAUNCHER_1 6336
  value: SECONDARY_LAUNCHER_2 6368
  value: SECONDARY_LAUNCHER_3 6400
  value: SECONDARY_LAUNCHER_4 6432
  value: SECONDARY_LAUNCHER_5 6464
  value: SECONDARY_LAUNCHER_6 6496
  value: SECONDARY_LAUNCHER_7 6528
  value: SECONDARY_LAUNCHER_8 6560
  value: SECONDARY_LAUNCHER_9 6592
  value: SECONDARY_LAUNCHER_10 6624
  value: SECONDARY_DEFENSE_SYSTEMS_1 6656
  value: SECONDARY_DEFENSE_SYSTEMS_2 6688
  value: SECONDARY_DEFENSE_SYSTEMS_3 6720
  value: SECONDARY_DEFENSE_SYSTEMS_4 6752
  value: SECONDARY_DEFENSE_SYSTEMS_5 6784
  value: SECONDARY_DEFENSE_SYSTEMS_6 6816
  value: SECONDARY_DEFENSE_SYSTEMS_7 6848
  value: SECONDARY_DEFENSE_SYSTEMS_8 6880
  value: SECONDARY_DEFENSE_SYSTEMS_9 6912
  value: SECONDARY_DEFENSE_SYSTEMS_10 6944
  value: SECONDARY_RADAR_1 6976
  value: SECONDARY_RADAR_2 7008
  value: SECONDARY_RADAR_3 7040
  value: SECONDARY_RADAR_4 7072
  value: SECONDARY_RADAR_5 7104
  value: SECONDARY_RADAR_6 7136
  value: SECONDARY_RADAR_7 7168
  value: SECONDARY_RADAR_8 7200
  value: SECONDARY_RADAR_9 7232
  value: SECONDARY_RADAR_10 7264
  value: AVLB1 7296
  value: AVLB2 7328
  value: AVLB 7360
  value: AVLB4 7392
  value: FWMP 7424
  value: FWMR 7456
  value: TWMP 7488
  value: TWMR 7520
  value: moldboard 7552
  value: dogbone 7584
  value: shovel_base 7616
  value: shovel_arm 7648
  value: shovel 7680
  value: prim_miclic 7712
  value: sec_miclic 7744
  value: dozerblade 7776
  value: suspension 7808


# 6.3.1 Entity Kind  
namespace_def: DIS204_ENTITY_KIND uint8
  value: OTHER 0   
  value: PLATFORM 1
  value: MUNITION 2
  value: LIFE_FORM 3
  value: ENVIRONMENTAL 4
  value: CULTURAL_FEATURE 5
  value: SUPPLY 6  
  value: RADIO 7   


# 6.3.1.1.1 Domain  
namespace_def: DIS204_ENTITY_DOMAIN uint8
  value: OTHER 0 
  value: LAND 1  
  value: AIR 2   
  value: SURFACE 3
  value: SUBSURFACE 4
  value: SPACE 5 


# 6.3.1.2.1 Domain  
namespace_def: DIS204_MUNITION_DOMAIN uint8
  value: OTHER 0
  value: ANTI_AIR 1
  value: ANTI_ARMOR 2
  value: ANTI_GUIDED_MUNITION 3
  value: ANTI_RADAR 4
  value: ANTI_SATELLITE 5
  value: ANTI_SHIP 6
  value: ANTI_SUBMARINE 7
  value: ANTI_PERSONNEL 8
  value: BATTLEFIELD_SUPPORT 9
  value: STRATEGIC 10
  value: MISCELLANEOUS 11


# 6.3.1.3.1, 6.3.1.4.1, 6.3.1.5.1 Domain  
# Same as 6.3.1.1.1 Domain  

# The different dead reckoning algorithms 
namespace_def: DIS204_DEAD_RECKONING_ALGORITHM uint8
  value: OTHER 0
  value: STATIC 1
  value: DRM_F_P_W 2
  value: DRM_R_P_W 3
  value: DRM_R_V_W 4
  value: DRM_F_V_W 5
  value: DRM_F_P_B 6
  value: DRM_R_P_B 7
  value: DRM_R_V_B 8
  value: DRM_F_V_B 9

