#
# File:     ech_type.cdf
# Contents: 
# System:   simnet development.
# Created:  8-Oct-1991
# Author:   jslee
#
# Remarks:
#
# History:
#    11/08/91	JSLee		Converted from ech_type.h

# $RCSfile: ech_type.cdf,v $
# $Revision: 1.1.1.1 $
# $State: Exp $

# COPYRIGHT 1990 BBN Systems and Technologies Corporation
# 10 Moulton Street
# Cambridge, Ma. 02138
# 617-873-3000

needs: obj_type.cdf

namespace_def: echelon

#
# SINGLES
 
#
# A single US Tank 
  value: US_TankSingle (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS | 	
	 echelonKindSingle | echelonFunctionMainBattleTank)

# A single US Mech Inf 
  value: US_MechanizedInfantrySingle (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS | 	
	 echelonKindSingle | echelonFunctionPersonnelCarrier)

# A single US Air Defense Vehicle 
  value: US_ADASingle (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS | 	
	 echelonKindSingle | echelonFunctionAntiAircraft)

# A single Losat Vehicle 
  value: US_LosatSingle (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS | 	
	 echelonKindSingle | echelonFunctionTankDestroyer)

# A single US Armored Cavalry Vehicle 
  value: US_ArmoredCavalrySingle (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS | 	
	 echelonKindSingle | echelonFunctionArmoredCavalry)

#
# Squad
 
  value: US_DISquad (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassTowed | echelonCountryUS | 	        
	 echelonKindSquad | echelonFunctionInfantry)

#
# Section
 
  value: US_DISection (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassTowed | echelonCountryUS | 	        
	 echelonKindSection | echelonFunctionInfantry)

# A section of m2/m3 Bradleys 
  value: US_ScoutSection (objectDomainEchelon | echelonEnvironmentGround |   
	 echelonClassSPArmoredTracked | echelonCountryUS |  
	 echelonKindSection | echelonFunctionPersonnelCarrier)

#
# SORTIES
 
#
# A single US Fixed Wing 
  value: US_FWASortie (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUS | 		
	 echelonKindSortie | echelonFunctionAirCombat)

# A single US Attack RWA 
  value: US_AttackRWASortie (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassRotaryWing | echelonCountryUS |
	 echelonKindSortie | echelonFunctionAirCombat)

# A single US Scout RWA 
  value: US_ScoutRWASortie (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassRotaryWing | echelonCountryUS | 	
	 echelonKindSortie | echelonFunctionAirRecon)

#
# PLATOONS
 
#
# A platoon of US Tanks 
  value: US_TankPlatoon (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS | 	
	 echelonKindPlatoon | echelonFunctionMainBattleTank)

# A platoon of US Mech Infs 
  value: US_MechanizedInfantryPlatoon (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS | 	
	 echelonKindPlatoon | echelonFunctionPersonnelCarrier)

# A platoon of US Air Defense Vehicles 
  value: US_ADAPlatoon (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS | 	
	 echelonKindPlatoon | echelonFunctionAntiAircraft)

# A platoon of US Armored Cavalry Vehicles 
  value: US_ArmoredCavalryPlatoon (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS | 	
	 echelonKindPlatoon | echelonFunctionArmoredCavalry)

# A platoon of Losat Vehicles 
  value: US_LosatPlatoon (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS | 	
	 echelonKindPlatoon | echelonFunctionTankDestroyer)

# A platoon of US Scout RWA 
  value: US_ScoutRWAPlatoon (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassRotaryWing | echelonCountryUS | 	
	 echelonKindAirPlatoon | echelonFunctionAirRecon)

# A platoon of US Attack RWA 
  value: US_AttackRWAPlatoon (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassRotaryWing | echelonCountryUS | 	
	 echelonKindAirPlatoon | echelonFunctionAirCombat)

  value: US_CombatAviationPlatoon (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUS |		
	 echelonKindAirPlatoon | echelonFunctionCombatAviation)

  value: US_CombatEngineerPlatoon (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPUnarmoredTracked | echelonCountryUS |
	 echelonKindPlatoon | echelonFunctionCombatEngineer)

  value: US_AirCavalryPlatoon (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassRotaryWing | echelonCountryUS |
	 echelonKindAirPlatoon | echelonFunctionAirCavalry)

# A platoon of US Self Propelled Howitzers 
  value: US_HowitzerSPPlatoon (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS | 	
	 echelonKindPlatoon | echelonFunctionHowitzer)

# A platoon of US Mortars (towed) 
  value: US_MortarPlatoon (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassTowed | echelonCountryUS | 	
	 echelonKindPlatoon | echelonFunctionMortar)

# A platoon of supply vehicles 
  value: US_SupplyPlatoon (objectDomainEchelon | echelonEnvironmentGround |   
	 echelonClassSPArmoredWheeled | echelonCountryUS |  
	 echelonKindPlatoon | echelonFunctionSupplyTruck)

# A platoon of command post vehicles 
  value: US_CPPlatoon (objectDomainEchelon | echelonEnvironmentGround |   
	 echelonClassSPArmoredWheeled | echelonCountryUS |  
	 echelonKindPlatoon | echelonFunctionCommandPost)

# A platoon of m2 Bradleys 
  value: US_ScoutPlatoon (objectDomainEchelon | echelonEnvironmentGround |   
	 echelonClassSPArmoredWheeled | echelonCountryUS |  
	 echelonKindPlatoon | echelonFunctionPersonnelCarrier)

# A platoon of DI 
  value: US_DIPlatoon (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassTowed | echelonCountryUS | 	        
	 echelonKindPlatoon | echelonFunctionInfantry)

  value: US_G1Platoon (objectDomainEchelon | echelonEnvironmentGround |   
	 echelonClassSPUnarmoredTracked | echelonCountryUS |
	 echelonKindPlatoon | echelonFunctionSupplyTruck)

  value: US_G2Platoon (objectDomainEchelon | echelonEnvironmentGround |   
	 echelonClassSPUnarmoredTracked | echelonCountryUS |
	 echelonKindPlatoon | echelonFunctionMortar)

  value: US_Eagle1Platoon (objectDomainEchelon | echelonEnvironmentGround |   
	 echelonClassSPUnarmoredWheeled | echelonCountryUS |
	 echelonKindPlatoon | echelonFunctionSupplyTruck)

  value: US_Eagle2Platoon (objectDomainEchelon | echelonEnvironmentGround |   
	 echelonClassSPArmoredWheeled | echelonCountryUS |  
	 echelonKindPlatoon | echelonFunctionMortar)

  value: US_Iron1Platoon (objectDomainEchelon | echelonEnvironmentGround |   
	 echelonClassSPArmoredTracked | echelonCountryUS |  
	 echelonKindPlatoon | echelonFunctionSupplyTruck)

  value: US_Iron2Platoon (objectDomainEchelon | echelonEnvironmentGround |   
	 echelonClassSPArmoredTracked | echelonCountryUS |  
	 echelonKindPlatoon | echelonFunctionMortar)

#
# FLIGHT OF TWO
 
#
# A flight of two US FWAs 
  value: US_FWAFlightOfTwo (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUS | 	
	 echelonKindFlightOfTwo | echelonFunctionAirCombat)

# A flight of two US A10s 
  value: US_A10FlightOfTwo (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUS | 	
	 echelonKindFlightOfTwo | echelonFunctionAirAttack)

# A flight of two US F14Ds 
  value: US_F14DFlightOfTwo (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUS | 	
	 echelonKindFlightOfTwo | echelonFunctionAirToAirAttack)

# A flight of two US FA18s 
  value: US_FA18FlightOfTwo (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUS | 	
	 echelonKindFlightOfTwo | echelonFunctionAirAndGround)

# A flight of two US B52s 
  value: US_B52FlightOfTwo (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUS | 	
	 echelonKindFlightOfTwo | echelonFunctionBomber)

# A flight of two US A6s
  value: US_A6FlightOfTwo (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUS | 	
	 echelonKindFlightOfTwo | echelonFunctionGroundAttack)

# A flight of two US Attack RWAs 
  value: US_AttackRWAFlightOfTwo (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassRotaryWing | echelonCountryUS |
	 echelonKindFlightOfTwo | echelonFunctionAirCombat)

# A flight of two US Scout RWAs 
  value: US_ScoutRWAFlightOfTwo (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassRotaryWing | echelonCountryUS | 		
	 echelonKindFlightOfTwo | echelonFunctionAirRecon)

#
# FLIGHT OF THREE
 
#
# A flight of three US FWAs 
  value: US_FWAFlightOfThree (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUS | 	
	 echelonKindFlightOfThree | echelonFunctionAirCombat)

# A flight of three US Attack RWAs 
  value: US_AttackRWAFlightOfThree (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassRotaryWing | echelonCountryUS |
	 echelonKindFlightOfThree | echelonFunctionAirCombat)

# A flight of three US Scout RWAs 
  value: US_ScoutRWAFlightOfThree (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassRotaryWing | echelonCountryUS | 		
	 echelonKindFlightOfThree | echelonFunctionAirRecon)

# A flight of three US A10s 
  value: US_A10FlightOfThree (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUS | 	
	 echelonKindFlightOfThree | echelonFunctionAirAttack)

# A flight of three US F14Ds 
  value: US_F14DFlightOfThree (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUS | 	
	 echelonKindFlightOfThree | echelonFunctionAirToAirAttack)

# A flight of three US FA18s 
  value: US_FA18FlightOfThree (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUS | 	
	 echelonKindFlightOfThree | echelonFunctionAirAndGround)

# A flight of three US B52s 
  value: US_B52FlightOfThree (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUS | 	
	 echelonKindFlightOfThree | echelonFunctionBomber)

# A flight of three US A6s
  value: US_A6FlightOfThree (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUS | 	
	 echelonKindFlightOfThree | echelonFunctionGroundAttack)

#
# FLIGHT OF FOUR
 
#
# A flight of four US FWAs 
  value: US_FWAFlightOfFour (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUS | 	
	 echelonKindFlightOfFour | echelonFunctionAirCombat)

# A flight of four US Attack RWAs 
  value: US_AttackRWAFlightOfFour (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassRotaryWing | echelonCountryUS | 	
	 echelonKindFlightOfFour | echelonFunctionAirCombat)

# A flight of four US Scout RWAs 
  value: US_ScoutRWAFlightOfFour (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassRotaryWing | echelonCountryUS | 	
	 echelonKindFlightOfFour | echelonFunctionAirRecon)

# A flight of Four US A10s 
  value: US_A10FlightOfFour (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUS | 	
	 echelonKindFlightOfFour | echelonFunctionAirAttack)

# A flight of four US F14Ds 
  value: US_F14DFlightOfFour (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUS | 	
	 echelonKindFlightOfFour | echelonFunctionAirToAirAttack)

# A flight of four US FA18s 
  value: US_FA18FlightOfFour (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUS | 	
	 echelonKindFlightOfFour | echelonFunctionAirAndGround)

# A flight of four US B52s 
  value: US_B52FlightOfFour (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUS | 	
	 echelonKindFlightOfFour | echelonFunctionBomber)

# A flight of four US A6s
  value: US_A6FlightOfFour (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUS | 	
	 echelonKindFlightOfFour | echelonFunctionGroundAttack)


#
# BATTERIES
 
#
# A battery of Self Propelled Howitzers 
  value: US_HowitzerSPBattery (objectDomainEchelon | echelonEnvironmentGround |   
         echelonClassSPArmoredTracked| echelonCountryUS |   
         echelonKindBattery | echelonFunctionHowitzer)

#
# A Patriot missile battery
  value: US_PatriotBattery (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassTowed | echelonCountryUS |
	 echelonKindBattery | echelonFunctionAntiAircraft)

#
# COMPANIES
 
#
# A company of Tanks 
  value: US_TankCompany (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS |
	 echelonKindCompany | echelonFunctionMainBattleTank)

# A company of Mechanized Infantry 
  value: US_MechanizedInfantryCompany (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS |
	 echelonKindCompany | echelonFunctionPersonnelCarrier)

# A mixed company of US RWAs 
  value: US_RWACompany (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassRotaryWing | echelonCountryUS |
	 echelonKindAirCompany | echelonFunctionAirCombat)

#
# TEAMS
 
#
# A task organized company of Tanks 
  value: US_TankTeam (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS |
	 echelonKindTeam | echelonFunctionMainBattleTank)

# A task organized company of Mechanized Infantry 
  value: US_MechanizedInfantryTeam (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS |
	 echelonKindTeam | echelonFunctionPersonnelCarrier)

#
# TROOPS
 
#
# A company of Armored Cavalry 
  value: US_ArmoredCavalryTroop (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS |
	 echelonKindTroop | echelonFunctionArmoredCavalry)

#
# TRAINS
 
#
# A company of support vehicles 
  value: US_Train (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS |
	 echelonKindTrain | echelonFunctionCombatServiceSupport)

#
# BATTALIONS
 
#
# A battalion of Tanks 
  value: US_TankBattalion (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS |
	 echelonKindBattalion | echelonFunctionMainBattleTank)

# A battalion of Mechanized Infantry 
  value: US_MechanizedInfantryBattalion (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS |
	 echelonKindBattalion | echelonFunctionPersonnelCarrier)

# A battalion of Howitzers 
  value: US_HowitzerBattalion (objectDomainEchelon | echelonEnvironmentGround |   
         echelonClassTowed | echelonCountryUS |         
         echelonKindBattalion | echelonFunctionHowitzer)

# A battalion of Self Propelled Howitzers 
  value: US_HowitzerSPBattalion (objectDomainEchelon | echelonEnvironmentGround |   
         echelonClassSPArmoredTracked| echelonCountryUS |   
         echelonKindBattalion | echelonFunctionHowitzer)

# A battalion of Mortars 
  value: US_MortarBattalion (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassTowed | echelonCountryUS |
	 echelonKindBattalion | echelonFunctionMortar)

# 
# SQUADRON
 
  value: US_ArmoredCavalrySquadron (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS |
	 echelonKindSquadron | echelonFunctionArmoredCavalry)


# 
# SQUADRON HQS
 

  value: US_ArmoredCavalrySquadronHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS |
	 echelonKindSquadronHQ | echelonFunctionArmoredCavalry)
  value: US_AirCavalrySquadronHQ (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassRotaryWing | echelonCountryUS |
	 echelonKindAirSquadronHQ | echelonFunctionAirCavalry)


# 
# BATTALION HQS
 

  value: US_TankBattalionHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS |
	 echelonKindBattalionHQ | echelonFunctionMainBattleTank)
  value: US_MechanizedInfantryBattalionHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS |
	 echelonKindBattalionHQ | echelonFunctionPersonnelCarrier)
  value: US_InfantryBattalionHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS |
	 echelonKindBattalionHQ | echelonFunctionInfantry)
  value: US_AirInfantryBattalionHQ (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUS |
	 echelonKindAirBattalionHQ | echelonFunctionAirInfantry)
  value: US_AirAssaultInfantryBattalionHQ (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassRotaryWing | echelonCountryUS |
	 echelonKindAirBattalionHQ | echelonFunctionAirAssaultInfantry)
  value: US_HowitzerBattalionHQ (objectDomainEchelon | echelonEnvironmentGround |   
         echelonClassTowed | echelonCountryUS |         
         echelonKindBattalionHQ | echelonFunctionHowitzer)
  value: US_HowitzerSPBattalionHQ (objectDomainEchelon | echelonEnvironmentGround |   
         echelonClassSPArmoredTracked| echelonCountryUS |   
         echelonKindBattalionHQ | echelonFunctionHowitzer)
  value: US_MortarBattalionHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassTowed | echelonCountryUS |
	 echelonKindBattalionHQ | echelonFunctionMortar)
  value: US_CombatEngineerBattalionHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPUnarmoredTracked | echelonCountryUS |
	 echelonKindBattalionHQ | echelonFunctionCombatEngineer)
  value: US_CombatServiceSupportBattalionHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPUnarmoredTracked | echelonCountryUS |
	 echelonKindBattalionHQ | echelonFunctionCombatServiceSupport)
  value: US_CombatAviationBattalionHQ (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUS |		
	 echelonKindAirBattalionHQ | echelonFunctionCombatAviation)
  value: US_ADABattalionHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPUnarmoredTracked | echelonCountryUS |
	 echelonKindBattalionHQ | echelonFunctionAntiAircraft)

# 
# REGIMENT HQS
 

  value: US_TankRegimentHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS |
	 echelonKindRegimentHQ | echelonFunctionMainBattleTank )
  value: US_MechanizedInfantryRegimentHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS |
	 echelonKindRegimentHQ | echelonFunctionPersonnelCarrier )
  value: US_InfantryRegimentHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS |
	 echelonKindRegimentHQ | echelonFunctionInfantry )
  value: US_ArmoredCavalryRegimentHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS |
	 echelonKindRegimentHQ | echelonFunctionArmoredCavalry )
  value: US_AirInfantryRegimentHQ (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUS |
	 echelonKindAirRegimentHQ | echelonFunctionAirInfantry )
  value: US_AirAssaultInfantryRegimentHQ (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassRotaryWing | echelonCountryUS |
	 echelonKindAirRegimentHQ | echelonFunctionAirAssaultInfantry )

#
# BRIGADE HQS
 

  value: US_TankBrigadeHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS |
	 echelonKindBrigadeHQ | echelonFunctionMainBattleTank )
  value: US_MechanizedInfantryBrigadeHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS |
	 echelonKindBrigadeHQ | echelonFunctionPersonnelCarrier )
  value: US_InfantryBrigadeHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS |
	 echelonKindBrigadeHQ | echelonFunctionInfantry )
  value: US_ArmoredCavalryBrigadeHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS |
	 echelonKindBrigadeHQ | echelonFunctionArmoredCavalry )
  value: US_AirInfantryBrigadeHQ (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUS |
	 echelonKindAirBrigadeHQ | echelonFunctionAirInfantry)
  value: US_AirAssaultInfantryBrigadeHQ (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassRotaryWing | echelonCountryUS |
	 echelonKindAirBrigadeHQ | echelonFunctionAirAssaultInfantry )
  value: US_HowitzerBrigadeHQ (objectDomainEchelon | echelonEnvironmentGround |   
         echelonClassTowed | echelonCountryUS |         
         echelonKindBrigadeHQ | echelonFunctionHowitzer)
  value: US_HowitzerSPBrigadeHQ (objectDomainEchelon | echelonEnvironmentGround |   
         echelonClassSPArmoredTracked| echelonCountryUS |   
         echelonKindBrigadeHQ | echelonFunctionHowitzer)
  value: US_MortarBrigadeHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassTowed | echelonCountryUS |
	 echelonKindBrigadeHQ | echelonFunctionMortar)
  value: US_CombatEngineerBrigadeHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPUnarmoredTracked | echelonCountryUS |
	 echelonKindBrigadeHQ | echelonFunctionCombatEngineer)
  value: US_CombatServiceSupportBrigadeHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPUnarmoredTracked | echelonCountryUS |
	 echelonKindBrigadeHQ | echelonFunctionCombatServiceSupport)
  value: US_CombatAviationBrigadeHQ (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUS |		
	 echelonKindAirBrigadeHQ | echelonFunctionCombatAviation)

#
# DIVISION HQS
 

  value: US_TankDivisionHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS |
	 echelonKindDivisionHQ | echelonFunctionMainBattleTank )
  value: US_MechanizedInfantryDivisionHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS |
	 echelonKindDivisionHQ | echelonFunctionPersonnelCarrier )
  value: US_InfantryDivisionHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS |
	 echelonKindDivisionHQ | echelonFunctionInfantry )
  value: US_ArmoredCavalryDivisionHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS |
	 echelonKindDivisionHQ | echelonFunctionArmoredCavalry )
  value: US_AirInfantryDivisionHQ (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUS |
	 echelonKindAirDivisionHQ | echelonFunctionAirInfantry )
  value: US_AirAssaultInfantryDivisionHQ (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassRotaryWing | echelonCountryUS |
	 echelonKindAirDivisionHQ | echelonFunctionAirAssaultInfantry )
  value: US_HowitzerDivisionHQ (objectDomainEchelon | echelonEnvironmentGround |   
         echelonClassTowed | echelonCountryUS |         
         echelonKindDivisionHQ | echelonFunctionHowitzer)
  value: US_HowitzerSPDivisionHQ (objectDomainEchelon | echelonEnvironmentGround |   
         echelonClassSPArmoredTracked| echelonCountryUS |   
         echelonKindDivisionHQ | echelonFunctionHowitzer)
  value: US_MortarDivisionHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassTowed | echelonCountryUS |
	 echelonKindDivisionHQ | echelonFunctionMortar)
  value: US_CombatEngineerDivisionHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPUnarmoredTracked | echelonCountryUS |
	 echelonKindDivisionHQ | echelonFunctionCombatEngineer)

#
# CORPS HQS
 

  value: US_TankCorpsHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS |
	 echelonKindCorpsHQ | echelonFunctionMainBattleTank )
  value: US_MechanizedInfantryCorpsHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS |
	 echelonKindCorpsHQ | echelonFunctionPersonnelCarrier )
  value: US_InfantryCorpsHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS |
	 echelonKindCorpsHQ | echelonFunctionInfantry )
  value: US_ArmoredCavalryCorpsHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUS |
	 echelonKindCorpsHQ | echelonFunctionArmoredCavalry )
  value: US_AirInfantryCorpsHQ (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUS |
	 echelonKindAirCorpsHQ | echelonFunctionAirInfantry )
  value: US_AirAssaultInfantryCorpsHQ (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassRotaryWing | echelonCountryUS |
	 echelonKindAirCorpsHQ | echelonFunctionAirAssaultInfantry )

#
# "UNKNOWN" ECHELON TYPES
 

  value: US_GroundVehicle (objectDomainEchelon | echelonEnvironmentGround |
	 echelonCountryUS | echelonKindSingle)
  value: US_GroundSquad (objectDomainEchelon | echelonEnvironmentGround |
	 echelonCountryUS | echelonKindSquad)
  value: US_GroundSection (objectDomainEchelon | echelonEnvironmentGround |
	 echelonCountryUS | echelonKindSection)
  value: US_GroundPlatoon (objectDomainEchelon | echelonEnvironmentGround |
	 echelonCountryUS | echelonKindPlatoon)
  value: US_GroundCompany (objectDomainEchelon | echelonEnvironmentGround |
	 echelonCountryUS | echelonKindCompany)
  value: US_GroundBattalion (objectDomainEchelon | echelonEnvironmentGround |
	 echelonCountryUS | echelonKindBattalion)
  value: US_GroundRegiment (objectDomainEchelon | echelonEnvironmentGround |
	 echelonCountryUS | echelonKindRegiment)
  value: US_GroundBrigade (objectDomainEchelon | echelonEnvironmentGround |
	 echelonCountryUS | echelonKindBrigade)
  value: US_GroundDivision (objectDomainEchelon | echelonEnvironmentGround |
	 echelonCountryUS | echelonKindDivision)
  value: US_GroundCorps (objectDomainEchelon | echelonEnvironmentGround |
	 echelonCountryUS | echelonKindCorps)
  value: US_GroundArmy (objectDomainEchelon | echelonEnvironmentGround |
	 echelonCountryUS | echelonKindArmy)
  value: US_GroundArmyGroup (objectDomainEchelon | echelonEnvironmentGround |
	 echelonCountryUS | echelonKindArmyGroup)
  value: US_GroundBattalionHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonCountryUS | echelonKindBattalionHQ)
  value: US_GroundRegimentHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonCountryUS | echelonKindRegimentHQ)
  value: US_GroundBrigadeHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonCountryUS | echelonKindBrigadeHQ)
  value: US_GroundDivisionHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonCountryUS | echelonKindDivisionHQ)
  value: US_GroundCorpsHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonCountryUS | echelonKindCorpsHQ)
  value: US_GroundArmyHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonCountryUS | echelonKindArmyHQ)
  value: US_GroundArmyGroupHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonCountryUS | echelonKindArmyGroupHQ)
  value: US_AirSortie (objectDomainEchelon | echelonEnvironmentAir |
	 echelonCountryUS | echelonKindSortie)
  value: US_AirFlightOfTwo (objectDomainEchelon | echelonEnvironmentAir |
	 echelonCountryUS | echelonKindFlightOfTwo)
  value: US_AirFlightOfThree (objectDomainEchelon | echelonEnvironmentAir |
	 echelonCountryUS | echelonKindFlightOfThree)
  value: US_AirFlightOfFour (objectDomainEchelon | echelonEnvironmentAir |
	 echelonCountryUS | echelonKindFlightOfFour)
  value: US_AirPlatoon (objectDomainEchelon | echelonEnvironmentAir |
	 echelonCountryUS | echelonKindAirPlatoon)
  value: US_AirCorpsHQ (objectDomainEchelon | echelonEnvironmentAir |
	 echelonCountryUS | echelonKindAirCorpsHQ)

#
# Soviet echelons
 

#
# SINGLES
 
#
# A single USSR Tank 
  value: USSR_TankSingle (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUSSR | 	
	 echelonKindSingle | echelonFunctionMainBattleTank)

# A single USSR Howitzer (towed) 
  value: USSR_HowitzerSingle (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassTowed | echelonCountryUSSR |
	 echelonKindSingle | echelonFunctionHowitzer)

# A single USSR Self Propelled Howitzer 
  value: USSR_HowitzerSPSingle (objectDomainEchelon | echelonEnvironmentGround |
         echelonClassSPArmoredTracked | echelonCountryUSSR |
         echelonKindSingle | echelonFunctionHowitzer)

# A single USSR Mortar (towed) 
  value: USSR_MortarSingle (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassTowed | echelonCountryUSSR |
	 echelonKindSingle | echelonFunctionMortar)

# A single USSR Mech Inf 
  value: USSR_MotorizedRifleSingle (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUSSR | 	
	 echelonKindSingle | echelonFunctionPersonnelCarrier)

# A single USSR Air Defense Vehicle 
  value: USSR_ADASingle (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUSSR | 	
	 echelonKindSingle | echelonFunctionAntiAircraft)

#
# Squad
 
  value: USSR_DISquad (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassTowed | echelonCountryUSSR | 	        
	 echelonKindSquad | echelonFunctionInfantry)

#
# Section
 
  value: USSR_DISection (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassTowed | echelonCountryUSSR | 	        
	 echelonKindSection | echelonFunctionInfantry)


#
# SORTIES
 
#
# A single USSR Fixed Wing 
  value: USSR_FWASortie (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUSSR | 		
	 echelonKindSortie | echelonFunctionAirCombat)

# A single USSR Attack RWA 
  value: USSR_AttackRWASortie (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassRotaryWing | echelonCountryUSSR | 	
	 echelonKindSortie | echelonFunctionAirCombat)

# A single USSR Scout RWA 
  value: USSR_ScoutRWASortie (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassRotaryWing | echelonCountryUSSR | 	
	 echelonKindSortie | echelonFunctionAirRecon)

#
# PLATOONS
 
#
# A platoon of USSR Tanks 
  value: USSR_TankPlatoon (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUSSR | 	
	 echelonKindPlatoon | echelonFunctionMainBattleTank)

# A platoon of USSR Howitzers 
  value: USSR_HowitzerPlatoon (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassTowed | echelonCountryUSSR | 	
	 echelonKindPlatoon | echelonFunctionHowitzer)

# A platoon of USSR Self Propelled Howitzers 
  value: USSR_HowitzerSPPlatoon (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUSSR | 	
	 echelonKindPlatoon | echelonFunctionHowitzer)

# A platoon of USSR Mortars (towed) 
  value: USSR_MortarPlatoon (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassTowed | echelonCountryUSSR | 	
	 echelonKindPlatoon | echelonFunctionMortar)

# A platoon of USSR Mech Infs 
  value: USSR_MotorizedRiflePlatoon (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUSSR | 	
	 echelonKindPlatoon | echelonFunctionPersonnelCarrier)

# A platoon of USSR Air Defense Vehicles 
  value: USSR_ADAPlatoon (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUSSR | 	
	 echelonKindPlatoon | echelonFunctionAntiAircraft)

# A platoon of USSR Scout RWA 
  value: USSR_ScoutRWAPlatoon (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassRotaryWing | echelonCountryUSSR | 	
	 echelonKindAirPlatoon | echelonFunctionAirRecon)

# A platoon of USSR Attack RWA 
  value: USSR_AttackRWAPlatoon (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassRotaryWing | echelonCountryUSSR | 	
	 echelonKindAirPlatoon | echelonFunctionAirCombat)

  value: USSR_CombatAviationPlatoon (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUSSR |  		
	 echelonKindAirPlatoon | echelonFunctionCombatAviation)

  value: USSR_CombatEngineerPlatoon (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPUnarmoredTracked | echelonCountryUSSR |  
	 echelonKindPlatoon | echelonFunctionCombatEngineer)

  value: USSR_AirCavalryPlatoon (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassRotaryWing | echelonCountryUSSR |
	 echelonKindAirPlatoon | echelonFunctionAirCavalry)

# A platoon of DI 
  value: USSR_DIPlatoon (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassTowed | echelonCountryUSSR | 	        
	 echelonKindPlatoon | echelonFunctionInfantry)

# A platoon of assorted traffic vehicles
  value: USSR_TrafficPlatoon (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPUnarmoredWheeled | echelonCountryUSSR |
	 echelonKindPlatoon | echelonFunctionTrafficVehicles)

# A SCUD launcher platoon
  value: USSR_ScudPlatoon (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPUnarmoredWheeled | echelonCountryUSSR |
	 echelonKindPlatoon | echelonFunctionSSMissileLauncher)

#
# FLIGHT OF TWO

# 
# A flight of two USSR FWAs 
  value: USSR_FWAFlightOfTwo (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUSSR | 	
	 echelonKindFlightOfTwo | echelonFunctionAirCombat)

# A flight of two USSR Attack RWAs 
  value: USSR_AttackRWAFlightOfTwo (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassRotaryWing | echelonCountryUSSR | 	
	 echelonKindFlightOfTwo | echelonFunctionAirCombat)

# A flight of two USSR Scout RWAs 
  value: USSR_ScoutRWAFlightOfTwo (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassRotaryWing | echelonCountryUSSR | 	
	 echelonKindFlightOfTwo | echelonFunctionAirRecon)

#
# FLIGHT OF THREE
 
#
# A flight of three USSR FWAs 
  value: USSR_FWAFlightOfThree (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUSSR | 	
	 echelonKindFlightOfThree | echelonFunctionAirCombat)

# A flight of three USSR Attack RWAs 
  value: USSR_AttackRWAFlightOfThree (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassRotaryWing | echelonCountryUSSR | 	
	 echelonKindFlightOfThree | echelonFunctionAirCombat)

# A flight of three USSR Scout RWAs 
  value: USSR_ScoutRWAFlightOfThree (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassRotaryWing | echelonCountryUSSR | 	
	 echelonKindFlightOfThree | echelonFunctionAirRecon)

#
# FLIGHT OF FOUR
 
#
# A flight of four USSR FWAs 
  value: USSR_FWAFlightOfFour (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUSSR | 	
	 echelonKindFlightOfFour | echelonFunctionAirCombat)

# A flight of four USSR Attack RWAs 
  value: USSR_AttackRWAFlightOfFour (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassRotaryWing | echelonCountryUSSR | 	
	 echelonKindFlightOfFour | echelonFunctionAirCombat)

# A flight of four USSR Scout RWAs 
  value: USSR_ScoutRWAFlightOfFour (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassRotaryWing | echelonCountryUSSR | 	
	 echelonKindFlightOfFour | echelonFunctionAirRecon)

#
# BATTERIES
 
#
# A battery of Howitzers 
  value: USSR_HowitzerBattery (objectDomainEchelon | echelonEnvironmentGround |   
         echelonClassTowed | echelonCountryUSSR |       
         echelonKindBattery | echelonFunctionHowitzer)

# A battery of Self Propelled Howitzers 
  value: USSR_HowitzerSPBattery (objectDomainEchelon | echelonEnvironmentGround |   
         echelonClassSPArmoredTracked| echelonCountryUSSR | 
         echelonKindBattery | echelonFunctionHowitzer)

# A battery of Mortars 
  value: USSR_MortarBattery (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassTowed | echelonCountryUSSR |
	 echelonKindBattery | echelonFunctionMortar)

#
# COMPANIES
 
#
# A company of Tanks 
  value: USSR_TankCompany (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUSSR |
	 echelonKindCompany | echelonFunctionMainBattleTank)

# A company of Mechanized Infantry 
  value: USSR_MotorizedRifleCompany (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUSSR |
	 echelonKindCompany | echelonFunctionPersonnelCarrier)

# A mixed company of USSR RWAs 
  value: USSR_RWACompany (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassRotaryWing | echelonCountryUSSR |
	 echelonKindAirCompany | echelonFunctionAirCombat)

# A FUEL supply company 
  value: USSR_FuelCompany (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPUnarmoredWheeled | echelonCountryUSSR |
	 echelonKindCompany | echelonFunctionSupplyTruck)

# A supply company 
  value: USSR_SupplyCompany (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredWheeled | echelonCountryUSSR |
	 echelonKindCompany | echelonFunctionSupplyTruck)

# A company of assorted traffic vehicles
  value: USSR_TrafficCompany (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPUnarmoredWheeled | echelonCountryUSSR |
	 echelonKindCompany | echelonFunctionTrafficVehicles)

#
# TEAMS
 
#
# A task organized company of Tanks 
  value: USSR_TankTeam (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUSSR |
	 echelonKindTeam | echelonFunctionMainBattleTank)

# A task organized company of Mechanized Infantry 
  value: USSR_MotorizedRifleTeam (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUSSR |
	 echelonKindTeam | echelonFunctionPersonnelCarrier)

#
# TROOPS
 

# A company of Armored Cavalry 
  value: USSR_ArmoredCavalryTroop (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUSSR |
	 echelonKindTroop | echelonFunctionArmoredCavalry)

#
# BATTALIONS
 
#
# A battalion of Tanks 
  value: USSR_TankBattalion (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUSSR |
	 echelonKindBattalion | echelonFunctionMainBattleTank)

# A battalion of Mechanized Infantry 
  value: USSR_MotorizedRifleBattalion (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUSSR |
	 echelonKindBattalion | echelonFunctionPersonnelCarrier)

# A battalion of Howitzers 
  value: USSR_HowitzerBattalion (objectDomainEchelon | echelonEnvironmentGround |   
         echelonClassTowed | echelonCountryUSSR |       
         echelonKindBattalion | echelonFunctionHowitzer)

# A battalion of Self Propelled Howitzers 
  value: USSR_HowitzerSPBattalion (objectDomainEchelon | echelonEnvironmentGround |   
         echelonClassSPArmoredTracked| echelonCountryUSSR | 
         echelonKindBattalion | echelonFunctionHowitzer)

# A battalion of Mortars 
  value: USSR_MortarBattalion (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassTowed | echelonCountryUSSR |
	 echelonKindBattalion | echelonFunctionMortar)


# 
# SQUADRON
 
  value: USSR_ArmoredCavalrySquadron (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUSSR |
	 echelonKindSquadron | echelonFunctionArmoredCavalry)

# 
# SQUADRON HQS
 

  value: USSR_ArmoredCavalrySquadronHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUSSR |
	 echelonKindSquadronHQ | echelonFunctionArmoredCavalry)
  value: USSR_AirCavalrySquadronHQ (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassRotaryWing | echelonCountryUSSR |
	 echelonKindAirSquadronHQ | echelonFunctionAirCavalry)

# 
# BATTALION HQS
 

  value: USSR_TankBattalionHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUSSR |
	 echelonKindBattalionHQ | echelonFunctionMainBattleTank )
  value: USSR_MotorizedRifleBattalionHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUSSR |
	 echelonKindBattalionHQ | echelonFunctionPersonnelCarrier )
  value: USSR_InfantryBattalionHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUSSR |
	 echelonKindBattalionHQ | echelonFunctionInfantry )
  value: USSR_AirInfantryBattalionHQ (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUSSR |
	 echelonKindAirBattalionHQ | echelonFunctionAirInfantry )
  value: USSR_AirAssaultInfantryBattalionHQ (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassRotaryWing | echelonCountryUSSR |
	 echelonKindAirBattalionHQ | echelonFunctionAirAssaultInfantry )
  value: USSR_HowitzerBattalionHQ (objectDomainEchelon | echelonEnvironmentGround |   
         echelonClassTowed | echelonCountryUSSR |       
         echelonKindBattalionHQ | echelonFunctionHowitzer)
  value: USSR_HowitzerSPBattalionHQ (objectDomainEchelon | echelonEnvironmentGround |   
         echelonClassSPArmoredTracked| echelonCountryUSSR | 
         echelonKindBattalionHQ | echelonFunctionHowitzer)
  value: USSR_MortarBattalionHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassTowed | echelonCountryUSSR |
	 echelonKindBattalionHQ | echelonFunctionMortar)
  value: USSR_CombatEngineerBattalionHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPUnarmoredTracked | echelonCountryUSSR |  
	 echelonKindBattalionHQ | echelonFunctionCombatEngineer)
  value: USSR_CombatServiceSupportBattalionHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPUnarmoredTracked | echelonCountryUSSR |  
	 echelonKindBattalionHQ | echelonFunctionCombatServiceSupport)
  value: USSR_ADABattalionHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPUnarmoredTracked | echelonCountryUSSR |
	 echelonKindBattalionHQ | echelonFunctionAntiAircraft)
  value: USSR_CombatAviationBattalionHQ (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUSSR |  		
	 echelonKindAirBattalionHQ | echelonFunctionCombatAviation)


#
# REGIMENT HQS
 

  value: USSR_TankRegimentHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUSSR |
	 echelonKindRegimentHQ | echelonFunctionMainBattleTank)
  value: USSR_MotorizedRifleRegimentHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUSSR |
	 echelonKindRegimentHQ | echelonFunctionPersonnelCarrier)
  value: USSR_InfantryRegimentHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUSSR |
	 echelonKindRegimentHQ | echelonFunctionInfantry)
  value: USSR_ArmoredCavalryRegimentHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUSSR |
	 echelonKindRegimentHQ | echelonFunctionArmoredCavalry)
  value: USSR_AirInfantryRegimentHQ (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUSSR |
	 echelonKindAirRegimentHQ | echelonFunctionAirInfantry)
  value: USSR_AirAssaultInfantryRegimentHQ (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassRotaryWing | echelonCountryUSSR |
	 echelonKindAirRegimentHQ | echelonFunctionAirAssaultInfantry)

#
# BRIGADE HQS
 

  value: USSR_TankBrigadeHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUSSR |
	 echelonKindBrigadeHQ | echelonFunctionMainBattleTank)
  value: USSR_MotorizedRifleBrigadeHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUSSR |
	 echelonKindBrigadeHQ | echelonFunctionPersonnelCarrier)
  value: USSR_InfantryBrigadeHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUSSR |
	 echelonKindBrigadeHQ | echelonFunctionInfantry)
  value: USSR_ArmoredCavalryBrigadeHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUSSR |
	 echelonKindBrigadeHQ | echelonFunctionArmoredCavalry)
  value: USSR_AirInfantryBrigadeHQ (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUSSR |
	 echelonKindAirBrigadeHQ | echelonFunctionAirInfantry)
  value: USSR_AirAssaultInfantryBrigadeHQ (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassRotaryWing | echelonCountryUSSR |
	 echelonKindAirBrigadeHQ | echelonFunctionAirAssaultInfantry)
  value: USSR_HowitzerBrigadeHQ (objectDomainEchelon | echelonEnvironmentGround |   
         echelonClassTowed | echelonCountryUSSR |       
         echelonKindBrigadeHQ | echelonFunctionHowitzer)
  value: USSR_HowitzerSPBrigadeHQ (objectDomainEchelon | echelonEnvironmentGround |   
         echelonClassSPArmoredTracked| echelonCountryUSSR | 
         echelonKindBrigadeHQ | echelonFunctionHowitzer)
  value: USSR_MortarBrigadeHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassTowed | echelonCountryUSSR |
	 echelonKindBrigadeHQ | echelonFunctionMortar)
  value: USSR_CombatEngineerBrigadeHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPUnarmoredTracked | echelonCountryUSSR |  
	 echelonKindBrigadeHQ | echelonFunctionCombatEngineer)
  value: USSR_CombatServiceSupportBrigadeHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPUnarmoredTracked | echelonCountryUSSR |  
	 echelonKindBrigadeHQ | echelonFunctionCombatServiceSupport)
  value: USSR_CombatAviationBrigadeHQ (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUSSR |  		
	 echelonKindAirBrigadeHQ | echelonFunctionCombatAviation)

#
# DIVISION HQS
 

  value: USSR_TankDivisionHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUSSR |
	 echelonKindDivisionHQ | echelonFunctionMainBattleTank)
  value: USSR_MotorizedRifleDivisionHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUSSR |
	 echelonKindDivisionHQ | echelonFunctionPersonnelCarrier)
  value: USSR_InfantryDivisionHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUSSR |
	 echelonKindDivisionHQ | echelonFunctionInfantry)
  value: USSR_ArmoredCavalryDivisionHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUSSR |
	 echelonKindDivisionHQ | echelonFunctionArmoredCavalry)
  value: USSR_AirInfantryDivisionHQ (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUSSR |
	 echelonKindAirDivisionHQ | echelonFunctionAirInfantry)
  value: USSR_AirAssaultInfantryDivisionHQ (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassRotaryWing | echelonCountryUSSR |
	 echelonKindAirDivisionHQ | echelonFunctionAirAssaultInfantry)
  value: USSR_HowitzerDivisionHQ (objectDomainEchelon | echelonEnvironmentGround |   
         echelonClassTowed | echelonCountryUSSR |       
         echelonKindDivisionHQ | echelonFunctionHowitzer)
  value: USSR_HowitzerSPDivisionHQ (objectDomainEchelon | echelonEnvironmentGround |   
         echelonClassSPArmoredTracked| echelonCountryUSSR | 
         echelonKindDivisionHQ | echelonFunctionHowitzer)
  value: USSR_MortarDivisionHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassTowed | echelonCountryUSSR |
	 echelonKindDivisionHQ | echelonFunctionMortar)
  value: USSR_CombatEngineerDivisionHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPUnarmoredTracked | echelonCountryUSSR |  
	 echelonKindDivisionHQ | echelonFunctionCombatEngineer)

#
# CORPS HQS
 

  value: USSR_TankCorpsHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUSSR |
	 echelonKindCorpsHQ | echelonFunctionMainBattleTank )
  value: USSR_MotorizedRifleCorpsHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUSSR |
	 echelonKindCorpsHQ | echelonFunctionPersonnelCarrier )
  value: USSR_InfantryCorpsHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUSSR |
	 echelonKindCorpsHQ | echelonFunctionInfantry )
  value: USSR_ArmoredCavalryCorpsHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryUSSR |
	 echelonKindCorpsHQ | echelonFunctionArmoredCavalry )
  value: USSR_AirInfantryCorpsHQ (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassFixedWing | echelonCountryUSSR |
	 echelonKindAirCorpsHQ | echelonFunctionAirInfantry )
  value: USSR_AirAssaultInfantryCorpsHQ (objectDomainEchelon | echelonEnvironmentAir |
	 echelonClassRotaryWing | echelonCountryUSSR |
	 echelonKindAirCorpsHQ | echelonFunctionAirAssaultInfantry )

#
# "UNKNOWN" ECHELON TYPES
 

  value: USSR_GroundVehicle (objectDomainEchelon | echelonEnvironmentGround |
	 echelonCountryUSSR | echelonKindSingle)
  value: USSR_GroundSquad (objectDomainEchelon | echelonEnvironmentGround |
	 echelonCountryUSSR | echelonKindSquad)
  value: USSR_GroundSection (objectDomainEchelon | echelonEnvironmentGround |
	 echelonCountryUSSR | echelonKindSection)
  value: USSR_GroundPlatoon (objectDomainEchelon | echelonEnvironmentGround |
	 echelonCountryUSSR | echelonKindPlatoon)
  value: USSR_GroundCompany (objectDomainEchelon | echelonEnvironmentGround |
	 echelonCountryUSSR | echelonKindCompany)
  value: USSR_GroundBattalion (objectDomainEchelon | echelonEnvironmentGround |
	 echelonCountryUSSR | echelonKindBattalion)
  value: USSR_GroundRegiment (objectDomainEchelon | echelonEnvironmentGround |
	 echelonCountryUSSR | echelonKindRegiment)
  value: USSR_GroundBrigade (objectDomainEchelon | echelonEnvironmentGround |
	 echelonCountryUSSR | echelonKindBrigade)
  value: USSR_GroundDivision (objectDomainEchelon | echelonEnvironmentGround |
	 echelonCountryUSSR | echelonKindDivision)
  value: USSR_GroundCorps (objectDomainEchelon | echelonEnvironmentGround |
	 echelonCountryUSSR | echelonKindCorps)
  value: USSR_GroundArmy (objectDomainEchelon | echelonEnvironmentGround |
	 echelonCountryUSSR | echelonKindArmy)
  value: USSR_GroundArmyGroup (objectDomainEchelon | echelonEnvironmentGround |
	 echelonCountryUSSR | echelonKindArmyGroup)
  value: USSR_GroundBattalionHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonCountryUSSR | echelonKindBattalionHQ)
  value: USSR_GroundRegimentHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonCountryUSSR | echelonKindRegimentHQ)
  value: USSR_GroundBrigadeHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonCountryUSSR | echelonKindBrigadeHQ)
  value: USSR_GroundDivisionHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonCountryUSSR | echelonKindDivisionHQ)
  value: USSR_GroundCorpsHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonCountryUSSR | echelonKindCorpsHQ)
  value: USSR_GroundArmyHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonCountryUSSR | echelonKindArmyHQ)
  value: USSR_GroundArmyGroupHQ (objectDomainEchelon | echelonEnvironmentGround |
	 echelonCountryUSSR | echelonKindArmyGroupHQ)
  value: USSR_AirSortie (objectDomainEchelon | echelonEnvironmentAir |
	 echelonCountryUSSR | echelonKindSortie)
  value: USSR_AirFlightOfTwo (objectDomainEchelon | echelonEnvironmentAir |
	 echelonCountryUSSR | echelonKindFlightOfTwo)
  value: USSR_AirFlightOfThree (objectDomainEchelon | echelonEnvironmentAir |
	 echelonCountryUSSR | echelonKindFlightOfThree)
  value: USSR_AirFlightOfFour (objectDomainEchelon | echelonEnvironmentAir |
	 echelonCountryUSSR | echelonKindFlightOfFour)
  value: USSR_AirPlatoon (objectDomainEchelon | echelonEnvironmentAir |
	 echelonCountryUSSR | echelonKindAirPlatoon)
  value: USSR_AirCorpsHQ (objectDomainEchelon | echelonEnvironmentAir |
	 echelonCountryUSSR | echelonKindAirCorpsHQ)

#
# German echelons

#
# SINGLES
 
#
# A single German Tank 
  value: German_TankSingle (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryGermany |
	 echelonKindSingle | echelonFunctionMainBattleTank)

# A single German Mech Inf 
  value: German_MechanizedInfantrySingle (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryGermany |
	 echelonKindSingle | echelonFunctionPersonnelCarrier)
#
# SQUAD
 
  value: German_DISquad (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassTowed | echelonCountryGermany |
	 echelonKindSquad | echelonFunctionInfantry)

#
# SECTION
 
  value: German_DISection (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassTowed | echelonCountryGermany |
	 echelonKindSection | echelonFunctionInfantry)

#
# PLATOONS
 
#
# A platoon of German Tanks 
  value: German_TankPlatoon (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryGermany |
	 echelonKindPlatoon | echelonFunctionMainBattleTank)

# A platoon of German Mech Infs 
  value: German_MechanizedInfantryPlatoon (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryGermany |
	 echelonKindPlatoon | echelonFunctionPersonnelCarrier)

# A platoon of DI 
  value: German_DIPlatoon (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassTowed | echelonCountryGermany |
	 echelonKindPlatoon | echelonFunctionInfantry)

#
# COMPANIES
 
#
# A company of Tanks 
  value: German_TankCompany (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryGermany |
	 echelonKindCompany | echelonFunctionMainBattleTank)

# A company of Mechanized Infantry 
  value: German_MechanizedInfantryCompany (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryGermany |
	 echelonKindCompany | echelonFunctionPersonnelCarrier)

#
# TEAMS
 
#
# A task organized company of Tanks 
  value: German_TankTeam (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryGermany |
	 echelonKindTeam | echelonFunctionMainBattleTank)

# A task organized company of Mechanized Infantry 
  value: German_MechanizedInfantryTeam (objectDomainEchelon | echelonEnvironmentGround |
	 echelonClassSPArmoredTracked | echelonCountryGermany |
	 echelonKindTeam | echelonFunctionPersonnelCarrier)
