
/*
 * FILE:  failure.h 
 *
 * Created on Wed Apr 17 10:53:10 1996 
 * Compiled by DRN compiler, version 6.2.d
 * 
 */

#ifndef _failure_included
#define _failure_included



/*
 * File:     failure.drn
 * Contents: 
 * System:   simnet development.
 * Created:  8-Oct-1991
 * Author:   jslee
 *
 * Remarks:
 *
 * History:
 *    11/08/91	JSLee		Converted from failure.h
 * $RCSfile: failure.h,v $
 * $Revision: 1.1.1.1 $
 * $State: Exp $
 * COPYRIGHT 1990 BBN Systems and Technologies Corporation
 * 10 Moulton Street
 * Cambridge, Ma. 02138
 * 617-873-3000
 *
 */

/*
 * ElectronicSubsystems 
 */

#define electronicCommunicationMajor      0
#define electronicRadioAntenna            1
#define electronicIntercom                2
#define electronicRadio                   3
#define electronicLaserRangefinder        16
#define electronicElectroOpticalMajor     17
#define electronicEoFLIR                  18
#define electronicEoDATV                  19
#define electronicEoCtlHandle             20
#define electronicRadarMajor              21
#define electronicRadarTransceiver        22
#define electronicRadarTracking           23
#define electronicRadarNetwork            24
#define electronicNavigationMajor         25

/*
 * MotiveSubsystems 
 */

#define motiveEngineMajor                 32
#define motivePilotRelay                  33
#define motiveStarter                     34
#define motiveOilFilter                   35
#define motiveOilLeak                     36
#define motiveAirCleaner                  37
#define motiveCoolantLeak                 38
#define motiveFuelFilter                  39
#define motiveFuelXferPump                40
#define motiveTransmissionMajor           48
#define motiveTransFluidFilter            49
#define motiveTransFluidLeak              50
#define motiveLeftGearbox                 51
#define motiveRightGearbox                52
#define motiveUniversalJoint              53

/*
 *PowerSubsystems 
 */

#define powerPriElectrical                64
#define powerPriDistributionBox           65
#define powerSecElectrical                66
#define powerSecDistributionBox           67
#define powerAlternator                   68
#define powerGenerator                    69
#define powerPriHydraulic                 80

/*
 * WeaponSubsystems 
 */

#define weaponPriGunMajor                 96
#define weaponPriGunMount                 97
#define weaponPriGunElevation             98
#define weaponPriGunTraverse              99
#define weaponPriGunMisfire               100
#define weaponSecGunMajor                 101
#define weaponSecGunMount                 102
#define weaponSecGunElevation             103
#define weaponSecGunTraverse              104
#define weaponSecGunMisfire               105
#define weaponMissileMajor                106
#define weaponLauncher1                   107
#define weaponLauncher2                   108

/*
 * ChassisSubsystems (specific to ground vehicles) 
 */

#define chassisFinalDriveMajor            128
#define chassisLeftTrack                  129
#define chassisRightTrack                 130
#define chassisLeftFrontWheel             131
#define chassisRightFrontWheel            132
#define chassisLeftRearWheel              133
#define chassisRightRearWheel             134
#define chassisServiceBrake               135
#define chassisParkingBrake               136
#define chassisHullMajor                  144
#define chassisDriversVisionBlocks        152

/*
 * TurretSubsystems (specific to ground vehicles) 
 */

#define turretTurretMajor                 160
#define turretTurretTraverse              161
#define turretStabilization               162
#define turretGunnersCtlHandle            163
#define turretCmdrsCtlHandle              164
#define turretTurretPositionInd           165
#define turretTurretSlopeInd              166
#define turretGunnersPrimarySight         167
#define turretGunnersSecondarySight       168
#define turretGpsExtension                169
#define turretGunnersVisionBlocks         170
#define turretCmdrsVisionBlocks           171
#define turretLoadersPeriscope            172

/*
 * AirframeSubsystems (specific to air vehicles) 
 */

#define airframeAirframeMajor             128
#define airframeLeftWing                  129
#define airframeRightWing                 130
#define airframePitchControl              136
#define airframeRollControl               137
#define airframeYawControl                138
#define airframeFlaps                     139
#define airframeAirBrakes                 140
#define airframeLandingGearMajor          144
#define airframeNoseWheel                 145
#define airframeLeftWheel                 146
#define airframeRightWheel                147

/*
 * CockpitSubsystems (specific to air vehicles) 
 */

#define cockpitCockpitMajor               160


#endif
