#
# File:     mun_type.cdf
# Contents: 
# System:   simnet development.
# Created:  8-Oct-1991
# Author:   jslee
#
# Remarks:
#
# History:
#    11/08/91	JSLee		Converted from mun_type.h

# $RCSfile: mun_type.cdf,v $
# $Revision: 1.1.1.1 $
# $State: Exp $

# COPYRIGHT 1990 BBN Systems and Technologies Corporation
# 10 Moulton Street
# Cambridge, Ma. 02138
# 617-873-3000
 

needs: obj_type.cdf

namespace_def: munition

#
# File is organized as follows:
# 
# Fuel Munitions
# US Munitions
#   Detonators
#   Projectiles (by caliber shift and the subclass)
#   Bombs (by weight)
#   Missiles (by target type)
#   Mines (by domain and then target type)
# Yugoslav Mines
# Egyptian Mines
# Italian Mines
# British Mines
# USSR Munitions
#   Projectiles (by caliber shift and the subclass)
#   Bombs (by weight)
#   Missiles (by target type)
#   Mines (by domain and then target type)
# German Munitions
#   Projectiles (by caliber shift and the subclass)
#   Missiles (by target type)
# Other Country Munitions
#   Mines
# Temp Munitions
#
 
 

#
#  Petroleum, oil, and lubricant munitions.

# Presently one munition type code for fuel: 
  value: Fuel (objectDomainMunition | munitionClassPOL)

# Liquid Prop for Crusader System:  
  value: LiqProp (objectDomainMunition | munitionClassPropellent |
     ammunitionSubclassLiquid)

#
#  U.S. MUNITIONS.
 

# DETONATORS 

# M904 impact detonator for general purpose bombs: 
  value: US_M904 (objectDomainMunition | munitionClassDetonator |
     0 << ammunitionCaliberShift |
     ammunitionSubclassPercussion | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Bridge Demolition detonator, an M904 
  value: US_BridgeDetonator (objectDomainMunition | munitionClassDetonator |
     0 << ammunitionCaliberShift |
     ammunitionSubclassPercussion | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

  value: US_M935 (objectDomainMunition | munitionClassDetonator |
     0 << ammunitionCaliberShift |
     ammunitionSubclassPercussion | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     2 << ammunitionModelShift)

# M745 percussion detonator for mortars:  
  value: US_M745 (objectDomainMunition | munitionClassDetonator |
     0 << ammunitionCaliberShift |
     ammunitionSubclassPercussion | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     3 << ammunitionModelShift)

# M734 proximity detonator for mortars:  
  value: US_M734 (objectDomainMunition | munitionClassDetonator |
     0 << ammunitionCaliberShift |
     ammunitionSubclassProximity | ammunitionCountryUS |
     2 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# M776 proximity detonator for mortars: 
  value: US_M776 (objectDomainMunition | munitionClassDetonator |
     0 << ammunitionCaliberShift |
     ammunitionSubclassProximity | ammunitionCountryUS |
     2 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# M772 proximity detonator for mortars:  
  value: US_M772 (objectDomainMunition | munitionClassDetonator |
     0 << ammunitionCaliberShift |
     ammunitionSubclassProximity | ammunitionCountryUS |
     2 << ammunitionSeriesShift |
     2 << ammunitionModelShift)

# M603 pressure-activated AT conventional mine fuze  
  value: US_M603 (objectDomainMunition | munitionClassDetonator |
     1 << ammunitionCaliberShift |
     ammunitionSubclassProximity | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# M603 tiltrod-activated AT conventional mine fuze  
  value: US_M603T (objectDomainMunition | munitionClassDetonator |
     1 << ammunitionCaliberShift |
     ammunitionSubclassProximity | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# M606 pressure fuze--integral fuze in M19 
  value: US_M606 (objectDomainMunition | munitionClassDetonator |
     1 << ammunitionCaliberShift |
     ammunitionSubclassProximity | ammunitionCountryUS |
     2 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# M607 pressure AT conventional mine fuze  
  value: US_M607 (objectDomainMunition | munitionClassDetonator |
     1 << ammunitionCaliberShift |
     ammunitionSubclassProximity | ammunitionCountryUS |
     3 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# M607 tiltrod AT conventional mine fuze  
  value: US_M607T (objectDomainMunition | munitionClassDetonator |
     1 << ammunitionCaliberShift |
     ammunitionSubclassProximity | ammunitionCountryUS |
     3 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# M608 AT mine fuze 
  value: US_M608 (objectDomainMunition | munitionClassDetonator |
     1 << ammunitionCaliberShift |
     ammunitionSubclassProximity | ammunitionCountryUS |
     4 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# M624 tiltrod AT conventional mine fuze  
  value: US_M624 (objectDomainMunition | munitionClassDetonator |
     1 << ammunitionCaliberShift |
     ammunitionSubclassProximity | ammunitionCountryUS |
     5 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Generic magnetic fuze 
  value: Fuze_Magnetic (objectDomainMunition | munitionClassDetonator |
     1 << ammunitionCaliberShift |
     ammunitionSubclassProximity | ammunitionCountryUS |
     6 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Generic tiltrod fuze 
  value: Fuze_Tiltrod (objectDomainMunition | munitionClassDetonator |
     1 << ammunitionCaliberShift |
     ammunitionSubclassProximity | ammunitionCountryUS |
     7 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Generic pressure fuze 
  value: Fuze_Pressure (objectDomainMunition | munitionClassDetonator |
     1 << ammunitionCaliberShift |
     ammunitionSubclassProximity | ammunitionCountryUS |
     8 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Generic multisensor fuze 
  value: Fuze_MultiSensor (objectDomainMunition | munitionClassDetonator |
     1 << ammunitionCaliberShift |
     ammunitionSubclassProximity | ammunitionCountryUS |
     9 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Generic siesmic fuze 
  value: Fuze_Siesmic (objectDomainMunition | munitionClassDetonator |
     1 << ammunitionCaliberShift |
     ammunitionSubclassProximity | ammunitionCountryUS |
     10 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Generic tripwire fuze 
  value: Fuze_TripWire (objectDomainMunition | munitionClassDetonator |
     1 << ammunitionCaliberShift |
     ammunitionSubclassProximity | ammunitionCountryUS |
     11 << ammunitionSeriesShift |
     0 << ammunitionModelShift)
 
# Generic CDet fuze 
  value: Fuze_CDet (objectDomainMunition | munitionClassDetonator |
     1 << ammunitionCaliberShift |
     ammunitionSubclassProximity | ammunitionCountryUS |
     12 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Generic infrared fuze 
  value: Fuze_InfraRed (objectDomainMunition | munitionClassDetonator |
     1 << ammunitionCaliberShift |
     ammunitionSubclassProximity | ammunitionCountryUS |
     13 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Generic acoustic/pressure fuze 
  value: Fuze_AcouPress (objectDomainMunition | munitionClassDetonator |
     1 << ammunitionCaliberShift |
     ammunitionSubclassProximity | ammunitionCountryUS |
     14 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Generic magnetic/acoustic fuze 
  value: Fuze_MagAcou (objectDomainMunition | munitionClassDetonator |
     1 << ammunitionCaliberShift |
     ammunitionSubclassProximity | ammunitionCountryUS |
     15 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Generic magnetic/pressure fuze 
  value: Fuze_MagPress (objectDomainMunition | munitionClassDetonator |
     1 << ammunitionCaliberShift |
     ammunitionSubclassProximity | ammunitionCountryUS |
     16 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Generic magnetic/acoustic/pressur fuze 
  value: Fuze_MagAcouPress (objectDomainMunition | munitionClassDetonator |
     1 << ammunitionCaliberShift |
     ammunitionSubclassProximity | ammunitionCountryUS |
     17 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Generic acoustic fuze 
  value: Fuze_Acoustic (objectDomainMunition | munitionClassDetonator |
     1 << ammunitionCaliberShift |
     ammunitionSubclassProximity | ammunitionCountryUS |
     18 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Generic chemical contact fuze 
  value: Fuze_ContactChem (objectDomainMunition | munitionClassDetonator |
     1 << ammunitionCaliberShift |
     ammunitionSubclassProximity | ammunitionCountryUS |
     19 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# The M433 is a point detonating, nose mounted fuze.  
  value: US_M433 (objectDomainMunition | munitionClassDetonator |
     6 << ammunitionCaliberShift |
     ammunitionSubclassPercussion | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# The M439 is a time-delayed (RC time constant) fuze.  
  value: US_M439 (objectDomainMunition | munitionClassDetonator |
     6 << ammunitionCaliberShift | ammunitionSubclassTime |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# M557 107mm percussion detonator:  
  value: US_M557 (objectDomainMunition | munitionClassDetonator |
     11 << ammunitionCaliberShift |
     ammunitionSubclassPercussion | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# M513 107mm proximity detonator:  
  value: US_M513 (objectDomainMunition | munitionClassDetonator |
     11 << ammunitionCaliberShift |
     ammunitionSubclassProximity | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# M739 155mm percussion detonator:  
  value: US_M739 (objectDomainMunition | munitionClassDetonator |
     16 << ammunitionCaliberShift |
     ammunitionSubclassPercussion | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# M728 155mm timed detonator:  
  value: US_M728 (objectDomainMunition | munitionClassDetonator |
     16 << ammunitionCaliberShift | ammunitionSubclassTime |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# PROJECTILES 

# CALIBER SHIFT 0 

# SMOKE 

# Generator, ABC M3A3 (Smoke generator)  $$$ Should this *really* be a munition???? 
  value: US_M3A3 (objectDomainMunition | munitionClassProjectile |
     0 << ammunitionCaliberShift | ammunitionSubclassSmoke |
     ammunitionCountryUS | 0 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Generator, VEESS (Smoke generator)  $$$ Should this *really* be a munition???? 
  value: US_VEESS (objectDomainMunition | munitionClassProjectile |
     0 << ammunitionCaliberShift | ammunitionSubclassSmoke |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Smoke pot, HC M4A2  $$$ Should this *really* be a munition???? 
  value: US_M4A2 (objectDomainMunition | munitionClassProjectile |
     0 << ammunitionCaliberShift | ammunitionSubclassSmoke |
     ammunitionCountryUS | 2 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Smoke pot, HC M5   $$$ Should this *really* be a munition???? 
  value: US_M5 (objectDomainMunition | munitionClassProjectile |
     0 << ammunitionCaliberShift | ammunitionSubclassSmoke |
     ammunitionCountryUS | 3 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

  value: US_M7A1 (objectDomainMunition | munitionClassProjectile |
     0 << ammunitionCaliberShift | ammunitionSubclassSmoke |
     ammunitionCountryUS | 4 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# 10-lb C4 
  value: US_C4_10LB (objectDomainMunition | munitionClassProjectile |
     0 << ammunitionCaliberShift | ammunitionSubclassSmoke |
     ammunitionCountryUS | 5 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# CALIBER SHIFT 1 

# SHAPED CHARGE 

# M77 bomblets are packed into the warhead of the XR_M77 and the M77_M26 
  value: US_M77_bomblets (objectDomainMunition | munitionClassProjectile |
     1 << ammunitionCaliberShift |
     ammunitionSubclassShapedCharge | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# KINETIC 

# M855 5.56mm projectile  
  value: US_M855 (objectDomainMunition | munitionClassProjectile |
     1 << ammunitionCaliberShift |
     ammunitionSubclassKinetic | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# M856 5.56mm projectile 
  value: US_M856 (objectDomainMunition | munitionClassProjectile |
     1 << ammunitionCaliberShift |
     ammunitionSubclassKinetic | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     2 << ammunitionModelShift)

# M9X19 9 mm NATO projectile 
  value: US_M9X19 (objectDomainMunition | munitionClassProjectile |
     1 << ammunitionCaliberShift |
     ammunitionSubclassKinetic | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     3 << ammunitionModelShift)

# a 60 grain flechette (dart) carried by the Hydra70 M255 rocket   
  value: US_Flechette_60 (objectDomainMunition | munitionClassProjectile |
     1 << ammunitionCaliberShift |
     ammunitionSubclassKinetic | ammunitionCountryUS |
     2 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# M59 7.62 mm NATO Ball 
  value: US_M59 (objectDomainMunition | munitionClassProjectile |
     1 << ammunitionCaliberShift |
     ammunitionSubclassKinetic | ammunitionCountryUS |
     2 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# M27 7.62 mm NATO Tracer 
  value: US_M27 (objectDomainMunition | munitionClassProjectile |
     1 << ammunitionCaliberShift |
     ammunitionSubclassKinetic | ammunitionCountryUS |
     2 << ammunitionSeriesShift |
     2 << ammunitionModelShift)

  value: US_M240 (objectDomainMunition | munitionClassProjectile |
     1 << ammunitionCaliberShift |
     ammunitionSubclassKinetic | ammunitionCountryUS |
     2 << ammunitionSeriesShift |
     3 << ammunitionModelShift)

# M80 7.62 mm NATO Ball 
  value: US_M80 (objectDomainMunition | munitionClassProjectile |
     1 << ammunitionCaliberShift |
     ammunitionSubclassKinetic | ammunitionCountryUS |
     2 << ammunitionSeriesShift |
     4 << ammunitionModelShift)

# SMOKE 

# Red Phosphorus Smoke grenades. 181mm cartridges 
  value: US_RedPhosphorus_181mm (objectDomainMunition | munitionClassProjectile |
     1 << ammunitionCaliberShift | ammunitionSubclassSmoke |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# 4.2in White Phosphorus M328A1 Cartridge Smoke grenades 
  value: US_M328A1 (objectDomainMunition | munitionClassProjectile |
     1 << ammunitionCaliberShift | ammunitionSubclassSmoke |
     ammunitionCountryUS | 3 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# ZUNI-Mk4 White Phosphorous Smoke Grenades 
  value: US_ZUNI_MK4 (objectDomainMunition | munitionClassProjectile |
     1 << ammunitionCaliberShift | ammunitionSubclassSmoke |
     ammunitionCountryUS | 5 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# 66mm InfraRed M76 Projectile Smoke grenades 
  value: US_M76 (objectDomainMunition | munitionClassProjectile |
     1 << ammunitionCaliberShift | ammunitionSubclassSmoke |
     ammunitionCountryUS | 6 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# CALIBER SHIFT 2 

# KINETIC 

# 50 caliber (12.7mm) round fired from the Browning M2 gun  
  value: US_M33 (objectDomainMunition | munitionClassProjectile |
     2 << ammunitionCaliberShift |
     ammunitionSubclassKinetic | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# .50 caliber Sabot Light Armor Penetrator (SLAP) M903  
  value: US_M903 (objectDomainMunition | munitionClassProjectile |
     2 << ammunitionCaliberShift |
     ammunitionSubclassKinetic | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# HIGH EXPLOSIVE 

# 20mm round fired from the GE M197 gun  
  value: US_M50 (objectDomainMunition | munitionClassProjectile |
     2 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# M940 20mm PIE 
  value: US_M940 (objectDomainMunition | munitionClassProjectile |
     2 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# CALIBER SHIFT 3 

# KINETIC 

# M791 25mm kinetic projectile:  
  value: US_M791 (objectDomainMunition | munitionClassProjectile |
     3 << ammunitionCaliberShift |
     ammunitionSubclassKinetic | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# HIGH EXPLOSIVE 

# M792 25mm HEI projectile:  
  value: US_M792 (objectDomainMunition | munitionClassProjectile |
     3 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# M919 25mm armor piercing 
  value: US_M919 (objectDomainMunition | munitionClassProjectile |
     3 << ammunitionCaliberShift |
     ammunitionSubclassKinetic | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

#  M789 30mm HEDP projectile  
  value: US_M789 (objectDomainMunition | munitionClassProjectile |
     3 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUS | 2 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

#  23mm HEI projectile  
  value: US_23HEI (objectDomainMunition | munitionClassProjectile |
     3 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUS | 3 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# CALIBER SHIFT 4 

# SHAPED CHARGE 

# a bomblet carried by the Hydra70 M261 (MPSM) rocket 
# The M73 is a fragmenting shape charge used for target saturation. It is 
# a high drag, point detonating device. 
  value: US_M73 (objectDomainMunition | munitionClassProjectile |
     4 << ammunitionCaliberShift |
     ammunitionSubclassShapedCharge | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# HIGH EXPLOSIVE 

# 40 mm HEDP round fired from the MK19 heavy machine gun  
  value: US_M430 (objectDomainMunition | munitionClassProjectile |
     4 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# 40 mm HE round fired from the MK19 heavy machine gun  
  value: US_M383 (objectDomainMunition | munitionClassProjectile |
     4 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# CALIBER SHIFT 5 

# ILLUMINATION 

#
# DVW smoke & flare munitions
# IMPORTANT:
# Neither Thiokol nor Jane's provide formal designation, so we're
# mixing physical data from the manufacturer with designations from
# taking these from BMH Associates.
 

# 41mm expendable signal rocket, parachute, RED. 
  value: US_M126A1 (objectDomainMunition | munitionClassProjectile |
     5 << ammunitionCaliberShift |
     ammunitionSubclassIllumination | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# 41mm expendable signal rocket, parachute, WHITE.   
  value: US_M127A1 (objectDomainMunition | munitionClassProjectile |
     5 << ammunitionCaliberShift |
     ammunitionSubclassIllumination | ammunitionCountryUS |
     2 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# 41mm expendable signal rocket, parachute, GREEN. 
  value: US_M195 (objectDomainMunition | munitionClassProjectile |
     5 << ammunitionCaliberShift |
     ammunitionSubclassIllumination | ammunitionCountryUS |
     3 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# 41mm expendable signal rocket, star cluster, GREEN. 
  value: US_M125 (objectDomainMunition | munitionClassProjectile |
     5 << ammunitionCaliberShift |
     ammunitionSubclassIllumination | ammunitionCountryUS |
     4 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# 41mm expendable signal rocket, star cluster, GREEN. 
  value: US_M125A1 (objectDomainMunition | munitionClassProjectile |
     5 << ammunitionCaliberShift |
     ammunitionSubclassIllumination | ammunitionCountryUS |
     4 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# 41mm expendable signal rocket, star cluster, RED. 
  value: US_M158 (objectDomainMunition | munitionClassProjectile |
     5 << ammunitionCaliberShift |
     ammunitionSubclassIllumination | ammunitionCountryUS |
     5 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# 41mm expendable signal rocket, star cluster, WHITE. 
  value: US_M159 (objectDomainMunition | munitionClassProjectile |
     5 << ammunitionCaliberShift |
     ammunitionSubclassIllumination | ammunitionCountryUS |
     6 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# SMOKE 

# 41mm expendable smoke rocket.  Neither Thiokol nor Jane's provide 
# formal designation. 
  value: US_HandFiredSmoke (objectDomainMunition | munitionClassProjectile |
     5 << ammunitionCaliberShift | ammunitionSubclassSmoke |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# CALIBER SHIFT 6 

# ILLUMINATION 

# 60mm (mortar) illumination.  For ("old") mortar. 
  value: US_M83A2 (objectDomainMunition | munitionClassProjectile |
     6 << ammunitionCaliberShift |
     ammunitionSubclassIllumination | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     2 << ammunitionModelShift)

# 60mm (mortar) illumination.  For M224 ("new") mortar. 
  value: US_M721 (objectDomainMunition | munitionClassProjectile |
     6 << ammunitionCaliberShift |
     ammunitionSubclassIllumination | ammunitionCountryUS |
     2 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# SMOKE 

# Hand-launched signal smoke grenade.  "Caliber" is arbitrary. 
  value: US_M18 (objectDomainMunition | munitionClassProjectile |
     6 << ammunitionCaliberShift | ammunitionSubclassSmoke |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Hand-launched signal smoke grenade.  "Caliber" is arbitrary. 
  value: US_M18_RED (objectDomainMunition | munitionClassProjectile |
     6 << ammunitionCaliberShift | ammunitionSubclassSmoke |
     ammunitionCountryUS | 2 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Hand-launched signal smoke grenade.  "Caliber" is arbitrary. 
  value: US_M18_GREEN (objectDomainMunition | munitionClassProjectile |
     6 << ammunitionCaliberShift | ammunitionSubclassSmoke |
     ammunitionCountryUS | 3 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Hand-launched signal smoke grenade.  "Caliber" is arbitrary. 
  value: US_M18_YELLOW (objectDomainMunition | munitionClassProjectile |
     6 << ammunitionCaliberShift | ammunitionSubclassSmoke |
     ammunitionCountryUS | 4 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Hand-launched signal smoke grenade.  "Caliber" is arbitrary. 
  value: US_M18_VIOLET (objectDomainMunition | munitionClassProjectile |
     6 << ammunitionCaliberShift | ammunitionSubclassSmoke |
     ammunitionCountryUS | 5 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# 60-mm WP M302A1 cartridge 
  value: US_M302A1 (objectDomainMunition | munitionClassProjectile |
     6 << ammunitionCaliberShift | ammunitionSubclassSmoke |
     ammunitionCountryUS | 6 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# M722 60mm smoke projectile: 
  value: US_M722 (objectDomainMunition | munitionClassProjectile |
     6 << ammunitionCaliberShift | ammunitionSubclassSmoke |
     ammunitionCountryUS | 7 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# HIGH EXPLOSIVE 

# M888 60mm HE projectile: 
  value: US_M888 (objectDomainMunition | munitionClassProjectile |
     6 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# M720 60mm HE projectile: 
  value: US_M720 (objectDomainMunition | munitionClassProjectile |
     6 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# M49A4 60mm HE projectile:  
  value: US_M49A4 (objectDomainMunition | munitionClassProjectile |
     6 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     2 << ammunitionModelShift)

# CALIBER SHIFT 7 

# SHAPED CHARGE 

# TOW2B submunition (EFP) 
  value: US_TOW2B_EFP (objectDomainMunition | munitionClassProjectile |
     7 << ammunitionCaliberShift |
     ammunitionSubclassShapedCharge | ammunitionCountryUS |
     0 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# ILLUMINATION 

# 2.75-inch rocket (TOW) illumination. 
  value: US_M257 (objectDomainMunition | munitionClassProjectile |
     7 << ammunitionCaliberShift |
     ammunitionSubclassIllumination | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# SMOKE 

# 2.75-inch White Phosphorous M156 Rocket 
  value: US_M156 (objectDomainMunition | munitionClassProjectile |
     7 << ammunitionCaliberShift | ammunitionSubclassSmoke |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# 2.75" White Phosphorous Wedge 
  value: US_WEDGE_WP (objectDomainMunition | munitionClassProjectile |
     7 << ammunitionCaliberShift | ammunitionSubclassSmoke |
     ammunitionCountryUS | 2 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# 66mm Optical White Phosphorous L8A1 Projectile Smoke grenades  
  value: US_L8A1 (objectDomainMunition | munitionClassProjectile |
     7 << ammunitionCaliberShift | ammunitionSubclassSmoke |
     ammunitionCountryUS | 2 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# 2.75" White Phosphorous M259 Rocket 
  value: US_M259 (objectDomainMunition | munitionClassProjectile |
     7 << ammunitionCaliberShift | ammunitionSubclassSmoke |
     ammunitionCountryUS | 3 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# 81mm Red Phosphorous Wedge 
  value: US_WEDGE_RP (objectDomainMunition | munitionClassProjectile |
     9 << ammunitionCaliberShift | ammunitionSubclassSmoke |
     ammunitionCountryUS | 3 << ammunitionSeriesShift |
     2 << ammunitionModelShift)

# CALIBER SHIFT 8 

# SHAPED CHARGE 

# Generic US Explosively Formed Penetrator (EFP) 
# This is fired from the SADARM submunition cannister. 
  value: US_EFP (objectDomainMunition | munitionClassProjectile |
     8 << ammunitionCaliberShift |
     ammunitionSubclassShapedCharge | ammunitionCountryUS |
     0 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# SMOKE 

# 3" White Phosphorous Wick 
  value: US_WICK_76 (objectDomainMunition | munitionClassProjectile |
     8 << ammunitionCaliberShift | ammunitionSubclassSmoke |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# CALIBER SHIFT 9 

# ILLUMINATION 

# 81mm (mortar) illumination.  For M29 ("old") mortar. 
  value: US_M301A3 (objectDomainMunition | munitionClassProjectile |
     9 << ammunitionCaliberShift |
     ammunitionSubclassIllumination | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     3 << ammunitionModelShift)

# 81mm (mortar) illumination.  For M252 ("new") mortar. 
  value: US_M853A1 (objectDomainMunition | munitionClassProjectile |
     9 << ammunitionCaliberShift |
     ammunitionSubclassIllumination | ammunitionCountryUS |
     2 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# SMOKE 

# 81mm (mortar) smoke.  For M29 ("old") mortar. 
  value: US_M375A2 (objectDomainMunition | munitionClassProjectile |
     9 << ammunitionCaliberShift | ammunitionSubclassSmoke |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     2 << ammunitionModelShift)

# M819A1 81mm (mortar) smoke: 
  value: US_M819A1 (objectDomainMunition | munitionClassProjectile |
     9 << ammunitionCaliberShift | ammunitionSubclassSmoke |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     3 << ammunitionModelShift)

# 81mm (mortar) smoke.  For M252 (UK L16) ("new") mortar. 
# need US designation for this, here and in disconst.rdr 
  value: US_L40A2 (objectDomainMunition | munitionClassProjectile |
     9 << ammunitionCaliberShift | ammunitionSubclassSmoke |
     ammunitionCountryUS | 2 << ammunitionSeriesShift |
     2 << ammunitionModelShift)

# HIGH EXPLOSIVE 
	
# M889A1 81mm HE projectile: 
  value: US_M889A1 (objectDomainMunition | munitionClassProjectile |
     9 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# M821A1 81mm HE projectile: 
  value: US_M821A1 (objectDomainMunition | munitionClassProjectile |
     9 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# CALIBER SHIFT 10 

# SHAPED CHARGE 

# MX943_submunition, the STAFF round is not designed to hit a target 
# directly, but to fly over a target and fire an explosively formed 
# penetrator.   This is that submunition, best as can be figured. 
  value: US_MX943_submun (objectDomainMunition | munitionClassProjectile |
     10 << ammunitionCaliberShift |
     ammunitionSubclassShapedCharge | ammunitionCountryUS |
     0 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# CALIBER SHIFT 11 

# KINETIC 

# M392A2 105mm kinetic projectile:  
  value: US_M392A2 (objectDomainMunition | munitionClassProjectile |
     11 << ammunitionCaliberShift |
     ammunitionSubclassKinetic | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# SHAPED CHARGE 

# M456A1 105mm shaped charge projectile:  
  value: US_M456A1 (objectDomainMunition | munitionClassProjectile |
     11 << ammunitionCaliberShift |
     ammunitionSubclassShapedCharge | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# HIGH EXPLOSIVE 

# M329 107mm HE projectile:  
  value: US_M329 (objectDomainMunition | munitionClassProjectile |
     11 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# M329A1 107mm HE projectile: 
  value: US_M329A1 (objectDomainMunition | munitionClassProjectile |
     11 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# M329A2 107mm HE projectile: 
  value: US_M329A2 (objectDomainMunition | munitionClassProjectile |
     11 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     2 << ammunitionModelShift)

# M1 105mm HE projectile: 
  value: US_M1 (objectDomainMunition | munitionClassProjectile |
     11 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     3 << ammunitionModelShift)

# M548 105mm HE RAP projectile: 
  value: US_M548 (objectDomainMunition | munitionClassProjectile |
     11 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     4 << ammunitionModelShift)

# M933/934 107mm HE projectile: 
  value: US_M933_934 (objectDomainMunition | munitionClassProjectile |
     11 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     5 << ammunitionModelShift)

# ILLUMINATION 

# 4.2-inch (mortar) illumination. 
  value: US_M335A2 (objectDomainMunition | munitionClassProjectile |
     11 << ammunitionCaliberShift |
     ammunitionSubclassIllumination | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     2 << ammunitionModelShift)

# 105mm (howitzer) illumination. 
  value: US_M314A3 (objectDomainMunition | munitionClassProjectile |
     11 << ammunitionCaliberShift |
     ammunitionSubclassIllumination | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     3 << ammunitionModelShift)

# SMOKE 

# 105mm HC M2 canister 
  value: US_CAN (objectDomainMunition | munitionClassProjectile |
     11 << ammunitionCaliberShift |
     ammunitionSubclassSmoke | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# 105mm HC M84A1 projectile 
  value: US_M84A1 (objectDomainMunition | munitionClassProjectile |
     11 << ammunitionCaliberShift |
     ammunitionSubclassSmoke | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# 105mm White Phosphorous M60A2 Cartridge 
  value: US_M60A2 (objectDomainMunition | munitionClassProjectile |
     11 << ammunitionCaliberShift |
     ammunitionSubclassSmoke | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     2 << ammunitionModelShift)

# 4.2in Plasticized White Phosphorus M328A1 
  value: US_M328A1_PWP (objectDomainMunition | munitionClassProjectile |
     11 << ammunitionCaliberShift |
     ammunitionSubclassSmoke | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     3 << ammunitionModelShift)

# CALIBER SHIFT 12 

# HIGH EXPLOSIVE 

# MX943 120mm smart target aquisition fire and forget (STAFF) round 
# Due to compatability requirements with the AAMSA manned simulator  
# the STAFF, projectile and submunition are all defined separately.   
# This is the combined hull and submunition of the STAFF. 
  value: US_MX943 (objectDomainMunition | munitionClassProjectile |
     12 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# MX943 120mm projectile.  This is the projectile  
# w/out the submunition. 
  value: US_MX943_hull (objectDomainMunition | munitionClassProjectile |
     12 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# KINETIC 

# M829A2 120mm kinetic projectile:  
  value: US_M829A2 (objectDomainMunition | munitionClassProjectile |
     12 << ammunitionCaliberShift |
     ammunitionSubclassKinetic | ammunitionCountryUS |
     0 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# SHAPED CHARGE 

# M830A1 120mm shaped charge projectile:  
  value: US_M830A1 (objectDomainMunition | munitionClassProjectile |
     12 << ammunitionCaliberShift |
     ammunitionSubclassShapedCharge | ammunitionCountryUS |
     0 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# US 120mm SMART Munition for PGM Mortar 
  value: US_PGMM (objectDomainMunition | munitionClassProjectile |
     12 << ammunitionCaliberShift |
     ammunitionSubclassShapedCharge | ammunitionCountryUS |
     2 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# ILLUMINATION 

# 120mm (mortar) illumination. 
  value: US_M930 (objectDomainMunition | munitionClassProjectile |
     12 << ammunitionCaliberShift |
     ammunitionSubclassIllumination | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# SMOKE 

  value: US_M929 (objectDomainMunition | munitionClassProjectile |
     12 << ammunitionCaliberShift |
     ammunitionSubclassSmoke | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# CALIBER SHIFT 14 

# SHAPED CHARGE 

# US-SADARM submunition 
  value: US_SADARM (objectDomainMunition | munitionClassProjectile |
     14 << ammunitionCaliberShift |
     ammunitionSubclassShapedCharge | ammunitionCountryUS |
     2 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# CALIBER SHIFT 16 

# HIGH EXPLOSIVE 

# M107 155mm HE projectile:  
  value: US_M107 (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# M712 155mm Laser guided HE projectile:  
  value: US_M712 (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# 155mm artillery projectile M804 HEA projectile  
  value: US_M804 (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     3 << ammunitionModelShift)

# 155mm artillery projectile M795 HEF projectile  
  value: US_M795 (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     4 << ammunitionModelShift)

# Shipboard 5inch/54cal HEPD projectile with point detonating fuze
  value: US_5_54_HEPD (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUS | 2 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Shipboard 5inch/54cal VTIR projectile with VT (proximity)/IR fuze
  value: US_5_54_VTIR (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUS | 2 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# Shipboard 5inch/54cal High Capacity projectile 
  value: US_5_54_HICAP (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUS | 2 << ammunitionSeriesShift |
     2 << ammunitionModelShift)

# Shipboard 5inch/54cal MTPD projectile with mechanical-time/
# point-detonating fuze 
  value: US_5_54_MTPD (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUS | 2 << ammunitionSeriesShift |
     3 << ammunitionModelShift)

# BOMBLETS 

# XM898 155mm SADARM carrier 
  value: US_XM898 (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift |
     ammunitionSubclassBomblets | ammunitionCountryUS |
     2 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# M483A1 155mm DPICM projectile:  
  value: US_M483A1 (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift |
     ammunitionSubclassBomblets | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# M864 155mm DPICM projectile: 
  value: US_M864 (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift |
     ammunitionSubclassBomblets | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     3 << ammunitionModelShift)

# M449A1 155mm ICM projectile:  
  value: US_M449A1 (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift |
     ammunitionSubclassBomblets | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# M549A1 155mm HE RAP projectile:  
  value: US_M549A1 (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift |
     ammunitionSubclassBomblets | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     2 << ammunitionModelShift)

# 155mm artillery projectile XM971 ER SADARM  
  value: US_XM971 (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift |
     ammunitionSubclassBomblets | ammunitionCountryUS |
     2 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# 155mm artillery projectile XM982 ERA  
  value: US_XM982 (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift |
     ammunitionSubclassBomblets | ammunitionCountryUS |
     2 << ammunitionSeriesShift |
     2 << ammunitionModelShift)

# SCATTER MINES 

# 155mm artillery projectile M731 (contains 36 M72 AP mines) 
  value: US_M731 (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift |
     ammunitionSubclassScatterMines | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# 155mm artillery projectile M692 (contains 36 M67 AP mines) 
  value: US_M692 (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift |
     ammunitionSubclassScatterMines | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# 155mm artillery projectile M718 (contains 9 M73 AT mines) 
  value: US_M718 (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift |
     ammunitionSubclassScatterMines | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     2 << ammunitionModelShift)

# 155mm artillery projectile M741 (contains 9 M70 AP mines) 
  value: US_M741 (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift |
     ammunitionSubclassScatterMines | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     3 << ammunitionModelShift)

# ILLUMINATION 

# 155mm (howitzer) illumination. 
  value: US_M485A2 (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift |
     ammunitionSubclassIllumination | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     2 << ammunitionModelShift)

# SMOKE 

# 155mm HC M1 Canister 
  value: US_M1_CAN (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift |
     ammunitionSubclassSmoke | ammunitionCountryUS |
     0 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# 155mm HC M2 Canister 
  value: US_M2_CAN (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift |
     ammunitionSubclassSmoke | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# 6" White Phosphorous Wick 
  value: US_WICK_152 (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift |
     ammunitionSubclassSmoke | ammunitionCountryUS |
     2 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# 155mm White Phosphorus M110E2 Projectile Smoke grenades  
  value: US_M110E2 (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift |
     ammunitionSubclassSmoke | ammunitionCountryUS |
     2 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# 155mm artillery projectile M116A1 Projectile Smoke grenades  
  value: US_M116A1 (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift |
     ammunitionSubclassSmoke | ammunitionCountryUS |
     2 << ammunitionSeriesShift |
     2 << ammunitionModelShift)

# 155mm HC M116B1 Projectile 
  value: US_M116B1 (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift |
     ammunitionSubclassSmoke | ammunitionCountryUS |
     3 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# 155mm White Phosphorus M825 Projectile Smoke grenades  
  value: US_M825 (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift |
     ammunitionSubclassSmoke | ammunitionCountryUS |
     4 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# Shipboard 5inch/54cal White Phosphorous projectile 
  value: US_5_54_WP (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift | ammunitionSubclassSmoke |
     ammunitionCountryUS | 5 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Chemical 

# 155mm artillery projectile M121A1 Chem Round  
  value: US_M121A1 (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift |
     ammunitionSubclassChemical | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# 155mm artillery projectile M687 Chem Round  
  value: US_M687 (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift |
     ammunitionSubclassChemical | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# PRACTICE 

# 155mm artillery projectile XM867 Ex-JAM  
  value: US_XM867 (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift |
     ammunitionSubclassPractice | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# 155mm artillery projectile XM951 Leaflet  
  value: US_XM951 (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift |
     ammunitionSubclassPractice | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# CALIBER SHIFT 17 

# HIGH EXPLOSIVE PLASTIC 

# 165mm HEP round fired from CEV's M135 Demolition Gun.	 
  value: US_HEP (objectDomainMunition | munitionClassProjectile |
     17 << ammunitionCaliberShift |
     ammunitionSubclassHEPlastic | ammunitionCountryUS |
     0 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# CALIBER SHIFT 19 

# SMOKE 

# 181mm Red Phosphorous XM819 Cartridge 
  value: US_XM819 (objectDomainMunition | munitionClassProjectile |
     19 << ammunitionCaliberShift |
     ammunitionSubclassSmoke | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# CALIBER SHIFT 23 

# BOMBLETS 

# M77 227mm Extended Range ICM projectile:  
  value: US_XR_M77 (objectDomainMunition | munitionClassProjectile |
     23 << ammunitionCaliberShift |
     ammunitionSubclassBomblets | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     3 << ammunitionModelShift)

# M77 227mm MLRS projectile with M26 warhead 
  value: US_M77_M26 (objectDomainMunition | munitionClassProjectile |
     23 << ammunitionCaliberShift |
     ammunitionSubclassBomblets | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     4 << ammunitionModelShift)

# BOMBS 

# WEIGHT SHIFT 1 

# MICLIC charge: 1/10th of M58 $$$ temporary definition 
  value: US_M58_chargelet (objectDomainMunition | munitionClassBomb |
     1 << bombWeightClassShift |
     bombSubclassGeneralPurpose | ammunitionCountryUS |
     10 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# ESMB charge: $$$ temporary definition
  value: US_ESMB_chargelet (objectDomainMunition | munitionClassBomb |
     (1 << bombWeightClassShift) | bombSubclassGeneralPurpose |
     ammunitionCountryUS | (11 << ammunitionSeriesShift) |
     (0 << ammunitionModelShift))

# WEIGHT SHIFT 2 

# 250 lb cratering charge containing 10lb of TNT and 
#   40 lbs of M39, used for hasty cratering times 5 boreholes 
  value: US_M39_Hasty (objectDomainMunition | munitionClassBomb |
     2 << bombWeightClassShift |
     bombSubclassGeneralPurpose | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     2 << ammunitionModelShift)

# WEIGHT SHIFT 3 

# 330 lb cratering charge containing 10lb of TNT and 
#   40 lbs of M39, used for deliberate cratering times 5 boreholes 
#   plus 80 lbs of M39 and 10lbs of TNT times 2 boreholes = 330 lbs 
  value: US_M39_Delib (objectDomainMunition | munitionClassBomb |
     3 << bombWeightClassShift |
     bombSubclassGeneralPurpose | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     3 << ammunitionModelShift)

# CALIBER SHIFT 5 

# Mk82 500lb general purpose bomb:  
  value: US_Mk82 (objectDomainMunition | munitionClassBomb |
     5 << bombWeightClassShift |
     bombSubclassGeneralPurpose | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Mk84 ?lb general purpose bomb:  
  value: US_Mk84 (objectDomainMunition | munitionClassBomb |
     5 << bombWeightClassShift |
     bombSubclassGeneralPurpose | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# GBU-12 500lb LGB general purpose bomb:  
  value: US_GBU12 (objectDomainMunition | munitionClassBomb |
     5 << bombWeightClassShift | bombSubclassGuided |
     bombSubclassGeneralPurpose | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# CALIBER SHIFT 10 

# GBU-16 1000lb LGB general purpose bomb:  
  value: US_GBU16 (objectDomainMunition | munitionClassBomb |
     10 << bombWeightClassShift | bombSubclassGuided |
     bombSubclassGeneralPurpose | ammunitionCountryUS |
     2 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# CALIBER SHIFT 11 

# 1100lb general purpose bomb  
  value: US_GPBomb (objectDomainMunition | munitionClassBomb |
     11 << bombWeightClassShift |
     bombSubclassGeneralPurpose | ammunitionCountryUS |
     1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# CALIBER SHIFT 20 

# PavewayII Laser Guided Bombs (LGB) 
# GBU-10 2000lb LGB general purpose bomb:  
  value: US_GBU10 (objectDomainMunition | munitionClassBomb |
     20 << bombWeightClassShift | bombSubclassGuided |
     bombSubclassGeneralPurpose | ammunitionCountryUS |
     0 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# CALIBER SHIFT 27 

# GBU-15 2617lb general purpose electro-optical guided bombs (EOGB) 
# also known as the  cruciform-wing weapon (CWW) : 
# -- 
# GBU-15 (V)1/B (TV seeker) 
  value: US_GBU15_1B (objectDomainMunition | munitionClassBomb |
     27 << bombWeightClassShift | bombSubclassGuided |
     bombSubclassGeneralPurpose | ammunitionCountryUS |
     3 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# GBU-15 (V)2/B (Imaging Infrared  seeker) 
  value: US_GBU15_2B (objectDomainMunition | munitionClassBomb |
     27 << bombWeightClassShift | bombSubclassGuided |
     bombSubclassGeneralPurpose | ammunitionCountryUS |
     3 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# MISSILES 

# ANTI-TANK 

# SHAPED CHARGE 

# TOW anti-tank missile: 
  value: US_TOW (objectDomainMunition | munitionClassMissile |
     missileTargetArmor | missileWarheadShapedCharge |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# TOW2B anti-tank missile:  
  value: US_TOW2B (objectDomainMunition | munitionClassMissile |
     missileTargetArmor | missileWarheadShapedCharge |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# M47 (Dragon) anti-tank missile:  
  value: US_Dragon (objectDomainMunition | munitionClassMissile |
     missileTargetArmor | missileWarheadShapedCharge |
     ammunitionCountryUS | 2 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Hellfire anti-tank missile:  
  value: US_Hellfire (objectDomainMunition | munitionClassMissile |
     missileTargetArmor | missileWarheadShapedCharge |
     ammunitionCountryUS | 3 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# RF Hellfire anti-tank missile:  
  value: US_Hellfire_RF (objectDomainMunition | munitionClassMissile |
     missileTargetArmor | missileWarheadShapedCharge |
     ammunitionCountryUS | 3 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# Maverick anti-tank missile:  
  value: US_Maverick (objectDomainMunition | munitionClassMissile |
     missileTargetArmor | missileWarheadShapedCharge |
     ammunitionCountryUS | 4 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Javelin anti-tank missile:  
  value: US_Javelin (objectDomainMunition | munitionClassMissile |
     missileTargetArmor | missileWarheadShapedCharge |
     ammunitionCountryUS | 5 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# TACAWS anti-tank missile  
# $$$ 
  value: US_TACAWS (objectDomainMunition | munitionClassMissile |
     missileTargetArmor | missileWarheadShapedCharge |
     ammunitionCountryUS | 5 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# LOSAT KEM anti-tank missile: 
# KEM is not really a shape charge warhead but there is no 
# missileWareheadKE defined. This field is not currently used 
# and does not impact LOSAT performance 
  value: US_LOSAT (objectDomainMunition | munitionClassMissile |
     missileTargetArmor | missileWarheadShapedCharge |
     ammunitionCountryUS | 6 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# NLOS-IR missile, with IR seeker: 
  value: US_NLOS_IR (objectDomainMunition | munitionClassMissile |
     missileTargetArmor | missileWarheadShapedCharge |
     ammunitionCountryUS | 7 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# NLOS-TV missle, with TV seeker: 
  value: US_NLOS_TV (objectDomainMunition | munitionClassMissile |
     missileTargetArmor | missileWarheadShapedCharge |
     ammunitionCountryUS | 7 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# HIGH EXPLOSIVE 

# US Rockets (modeled as missiles) fired by AH-64 helo.
# Hydra70 FFAR (Folding Fin Aerial Rocket) with Mk66 motor, 
# M433 fuze.  The M433 is a point detonating, nose mounted 
# fuze; in this series, the warhead consists of a ten pound, 
# high explosive device.  
  value: US_Hydra70_M151 (objectDomainMunition | munitionClassMissile |
     missileTargetArmor | missileWarheadHE |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

#
# Following are definitions relating to the SMAW (Shoulder-Launched
# Multi-Purpose Assault Weapon) used by the USMC Assault Team.
    

# The SmawHEAA (High Explosive Anti-Armor warhead) is a rocket/warhead
# assembly designed for penetration of armor targets.  
  value: US_SmawHEAA (objectDomainMunition | munitionClassMissile |
     missileTargetArmor | missileWarheadHE |
     ammunitionCountryUS | 2 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# The SmawDualMode is a rocket/warhead assembly designed to
# engage bunkers and other reinforced structures.      
  value: US_SmawDualMode (objectDomainMunition | munitionClassMissile |
     missileTargetArmor | missileWarheadHE |
     ammunitionCountryUS | 2 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# BOMBLETS 

# Hydra70 FFAR (Folding Fin Aerial Rocket) with Mk66 motor, 
# M439 RC fuze.  This model is equipped to carry MultiPurpose 
# SubMunitions; in this series the MPSM consists of 9 M73 
# bomblets. 
  value: US_Hydra70_M261 (objectDomainMunition | munitionClassMissile |
     missileTargetArmor | missileWarheadBomblets |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# ANTI-AIRCRAFT 

# HIGH EXPLOSIVE 

# IHAWK anti-aircraft missile:  
  value: US_IHAWK (objectDomainMunition | munitionClassMissile |
     missileTargetAircraft | missileWarheadHE |
     ammunitionCountryUS | 0 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# Sidewinder anti-aircraft missile:  
  value: US_Sidewinder (objectDomainMunition | munitionClassMissile |
     missileTargetAircraft | missileWarheadHE |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# ADATS anti-aircraft missile:  
  value: US_ADATS (objectDomainMunition | munitionClassMissile |
     missileTargetAircraft | missileWarheadHE |
     ammunitionCountryUS | 2 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Stinger anti-aircraft missile:  
  value: US_Stinger (objectDomainMunition | munitionClassMissile |
     missileTargetAircraft | missileWarheadHE |
     ammunitionCountryUS | 3 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Sparrow anti-aircraft missile:  
  value: US_Sparrow (objectDomainMunition | munitionClassMissile |
     missileTargetAircraft | missileWarheadHE |
     ammunitionCountryUS | 4 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# AMRAAM anti-aircraft missile:  
  value: US_AMRAAM (objectDomainMunition | munitionClassMissile |
     missileTargetAircraft | missileWarheadHE |
     ammunitionCountryUS | 5 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Phoenix anti-aircraft missile:  
  value: US_Phoenix (objectDomainMunition | munitionClassMissile |
     missileTargetAircraft | missileWarheadHE |
     ammunitionCountryUS | 6 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Magic anti-aircraft missile: (this is really French) 
  value: US_Magic (objectDomainMunition | munitionClassMissile |
     missileTargetAircraft | missileWarheadHE |
     ammunitionCountryUS | 7 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# SM1 Shipboard Surface-to-Air missile 
  value: US_SM1 (objectDomainMunition | munitionClassMissile |
     missileTargetAircraft | missileWarheadHE |
     ammunitionCountryUS | 8 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# SM2 Shipboard Surface-to-Air missile 
  value: US_SM2 (objectDomainMunition | munitionClassMissile |
     missileTargetAircraft | missileWarheadHE |
     ammunitionCountryUS | 8 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# SM2 Block 4 Shipboard Surface-to-Air missile (extended range) 
  value: US_SM2_BLK4 (objectDomainMunition | munitionClassMissile |
     missileTargetAircraft | missileWarheadHE |
     ammunitionCountryUS | 8 << ammunitionSeriesShift |
     2 << ammunitionModelShift)

# Sea Sparrow anti-aircraft missile:  
  value: US_Sea_Sparrow (objectDomainMunition | munitionClassMissile |
     missileTargetAircraft | missileWarheadHE |
     ammunitionCountryUS | 9 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Sea Stinger anti-aircraft missile:  
  value: US_Sea_Stinger (objectDomainMunition | munitionClassMissile |
     missileTargetAircraft | missileWarheadHE |
     ammunitionCountryUS | 10 << ammunitionSeriesShift |
     0 << ammunitionModelShift)


# BOMBLETS 

# Hydra70 FFAR (Folding Fin Aerial Rocket) with Mk66 motor, 
# M439 RC fuze.  This model is equipped to carry flechette 
# munitions; in this series the munitions consist of 1200 
# 60 grain flechettes (lead darts about 2" long).
# NOTE:  The M255 warhead contains 2500 28 grain flechettes, 
# but at the time of this release, the designation for the 
# 1200 60 grain flechette warhead was unknown. 
  value: US_Hydra70_M255 (objectDomainMunition | munitionClassMissile |
     missileTargetAircraft | missileWarheadBomblets |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# LAND ATTACK 

# Tomahawk anti-ground missile:  
  value: US_Tomahawk (objectDomainMunition | munitionClassMissile |
     missileTargetSurface | missileWarheadShapedCharge |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# MICLIC rocket 
  value: US_Mk22 (objectDomainMunition | munitionClassMissile |
     missileTargetSurface | missileWarheadKinetic |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# ESMB rocket
  value: US_Mk104 (objectDomainMunition | munitionClassMissile |
        missileTargetSurface | missileWarheadKinetic |
        ammunitionCountryUS | (2 << ammunitionSeriesShift) |
        (0 << ammunitionModelShift))


# ANTI-MISSILE 

# Patriot anti-missile missile (PAC2 MIM-104): 
  value: US_PAC2 (objectDomainMunition | munitionClassMissile |
     missileTargetMissile | missileWarheadHE |
     ammunitionCountryUS | 2 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# ANTI-RADAR 

# HARM anit-radar missile (AMG-88A) 
  value: US_HARM (objectDomainMunition | munitionClassMissile |
     missileTargetRadar | missileWarheadHE |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# ANTI-SHIP 

# Penguin anit-ship missile 
  value: US_Penguin (objectDomainMunition | munitionClassMissile |
     missileTargetShip | missileWarheadHE |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Harpoon anti-ship missile 
  value: US_Harpoon (objectDomainMunition | munitionClassMissile |
     missileTargetShip | missileWarheadHE |
     ammunitionCountryUS | 2 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Tomahawk Anti-Ship Missile 
  value: US_TASM (objectDomainMunition | munitionClassMissile |
     missileTargetShip | missileWarheadShapedCharge |
     ammunitionCountryUS | 3 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# TARGET MISC 

# Grenades, (modeled as missiles) (this is a poor definition) 
  value: US_M203 (objectDomainMunition | munitionClassMissile |
     missileTargetMiscellaneous | missileWarheadHE |
     ammunitionCountryUS | 3 << ammunitionSeriesShift |
     0 << ammunitionModelShift)


# MINES 
 
# LAND 

# ANTI-TANK 

# Heavy AT Mine M15 
  value: US_M15 (objectDomainMunition | munitionClassMine |
     mineTargetTank | mineEnvironmentLand |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# Nonmetallic AT Mine M19  
  value: US_M19 (objectDomainMunition | munitionClassMine |
     mineTargetTank | mineEnvironmentLand |
     ammunitionCountryUS | 2 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# Heavy AT Mine M21  
  value: US_M21 (objectDomainMunition | munitionClassMine |
     mineTargetTank | mineEnvironmentLand |
     ammunitionCountryUS | 3 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# AT Scatterable Mine M75  
  value: US_M75 (objectDomainMunition | munitionClassMine |
     mineTargetTank | mineEnvironmentLand |
     ammunitionCountryUS | 6 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# AT Scatterable Mine M70 
  value: US_M70 (objectDomainMunition | munitionClassMine |
     mineTargetTank | mineEnvironmentLand |
     ammunitionCountryUS | 7 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# AT Scatterable Mine M73   ***conflict*** 
  value: US_M73_mine (objectDomainMunition | munitionClassMine |
     mineTargetTank | mineEnvironmentLand |
     ammunitionCountryUS | 8 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# AT Scatterable Mine M76    ***conflict*** 
  value: US_M76_mine (objectDomainMunition | munitionClassMine |
     mineTargetTank | mineEnvironmentLand |
     ammunitionCountryUS | 9 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# AT Scatterable Mine BLU91B 
  value: US_BLU91B (objectDomainMunition | munitionClassMine |
     mineTargetTank | mineEnvironmentLand |
     ammunitionCountryUS | 10 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# AT Volcano Scatterable Mine  
  value: US_VOLCANO_AT (objectDomainMunition | munitionClassMine |
     mineTargetTank | mineEnvironmentLand |
     ammunitionCountryUS | 11 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# AT SLAM mine 
  value: US_SLAM (objectDomainMunition | munitionClassMine |
     mineTargetTank | mineEnvironmentLand |
     ammunitionCountryUS | 12 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# AT HORNET mine 
  value: US_HORNET (objectDomainMunition | munitionClassMine |
     mineTargetTank | mineEnvironmentLand |
     ammunitionCountryUS | 13 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# ANTI-PERSONNEL 

# AP Mine M14  
  value: US_M14 (objectDomainMunition | munitionClassMine |
     mineTargetPerson | mineEnvironmentLand |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# Claymore Mine M18A1  
  value: US_M18A1 (objectDomainMunition | munitionClassMine |
     mineTargetPerson | mineEnvironmentLand |
     ammunitionCountryUS | 2 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# AP Mine M16A2  
  value: US_M16A2 (objectDomainMunition | munitionClassMine |
     mineTargetPerson | mineEnvironmentLand |
     ammunitionCountryUS | 3 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# AP Scatterable Mine M74  
  value: US_M74 (objectDomainMunition | munitionClassMine |
     mineTargetPerson | mineEnvironmentLand |
     ammunitionCountryUS | 6 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# AP Scatterable Mine M67  
  value: US_M67 (objectDomainMunition | munitionClassMine |
     mineTargetPerson | mineEnvironmentLand |
     ammunitionCountryUS | 7 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# AP Scatterable Mine M72 
  value: US_M72 (objectDomainMunition | munitionClassMine |
     mineTargetPerson | mineEnvironmentLand |
     ammunitionCountryUS | 8 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# AP Scatterable Mine M77    ***conflict*** 
  value: US_M77_mine (objectDomainMunition | munitionClassMine |
     mineTargetPerson | mineEnvironmentLand |
     ammunitionCountryUS | 9 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# AP Scatterable Mine BLU92B 
  value: US_BLU92B (objectDomainMunition | munitionClassMine |
     mineTargetPerson | mineEnvironmentLand |
     ammunitionCountryUS | 10 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# AP Volcano Scatterable Mine  
  value: US_VOLCANO_AP (objectDomainMunition | munitionClassMine |
     mineTargetPerson | mineEnvironmentLand |
     ammunitionCountryUS | 11 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# SEA 

# ANTI-SHIP 

# MK56 aircraft-laid, moored US mine 
  value: US_MK56 (objectDomainMunition | munitionClassMine |
     mineTargetShip | mineEnvironmentWater |
     ammunitionCountryUS | 1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

  value: false_contact (objectDomainMunition | munitionClassMine  |
     mineTargetShip | mineEnvironmentWater |
     ammunitionCountryUS | 2 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

  value: neut_mine_charge (objectDomainMunition | munitionClassMine  |
     mineTargetShip | mineEnvironmentWater |
     ammunitionCountryUS | 3 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

#
# Yugoslav mines
# IU AT mine
 

  value: YUGO_IU (objectDomainMunition | munitionClassMine |
     mineTargetTank | mineEnvironmentLand |
     ammunitionCountryYugoslavia |
     1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# TMRP6 mine, Yugoslav version 
  value: YUGO_TMRP6 (objectDomainMunition | munitionClassMine |
     mineTargetTank | mineEnvironmentLand |
     ammunitionCountryYugoslavia |
     2 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

#
# Egyptian mines
# M80 AT mine
 

  value: EGYPT_M80 (objectDomainMunition | munitionClassMine |
     mineTargetTank | mineEnvironmentLand |
     ammunitionCountryEgypt | 1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

#
# Italian mines
# TC24 AT mine
 

# LAND 

  value: ITALY_TC24 (objectDomainMunition | munitionClassMine |
     mineTargetTank | mineEnvironmentLand |
     ammunitionCountryItaly | 1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# SB81 AT mine 
  value: ITALY_SB81 (objectDomainMunition | munitionClassMine |
     mineTargetTank | mineEnvironmentLand |
     ammunitionCountryItaly | 2 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# VS16 AT mine 
  value: ITALY_VS16 (objectDomainMunition | munitionClassMine |
     mineTargetTank | mineEnvironmentLand |
     ammunitionCountryItaly | 3 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# SBMV AT mine 
  value: ITALY_SBMV (objectDomainMunition | munitionClassMine |
     mineTargetTank | mineEnvironmentLand |
     ammunitionCountryItaly | 4 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# SH55 AT mine 
  value: ITALY_SH55 (objectDomainMunition | munitionClassMine |
     mineTargetTank | mineEnvironmentLand |
     ammunitionCountryItaly | 5 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# TC6 AT mine 
  value: ITALY_TC6 (objectDomainMunition | munitionClassMine |
     mineTargetTank | mineEnvironmentLand |
     ammunitionCountryItaly | 6 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# TCE6 AT mine 
  value: ITALY_TCE6 (objectDomainMunition | munitionClassMine |
     mineTargetTank | mineEnvironmentLand |
     ammunitionCountryItaly | 7 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# VSHCT AT mine 
  value: ITALY_VSHCT (objectDomainMunition | munitionClassMine |
     mineTargetTank | mineEnvironmentLand |
     ammunitionCountryItaly | 8 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# SEA 

# MR-80 Influence mine 
  value: ITALY_MR80 (objectDomainMunition | munitionClassMine |
     mineTargetShip | mineEnvironmentWater |
     ammunitionCountryItaly | 1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)
	 
# MANTA Influence mine 
  value: ITALY_MANTA (objectDomainMunition | munitionClassMine |
     mineTargetShip | mineEnvironmentWater |
     ammunitionCountryItaly | 2 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

#
# British Mines
# Mk.7 AT mine
 

  value: UK_MK7 (objectDomainMunition | munitionClassMine |
     mineTargetTank | mineEnvironmentLand |
     ammunitionCountryUK | 1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# L14A1 AT mine 
  value: UK_L14A1 (objectDomainMunition | munitionClassMine |
     mineTargetTank | mineEnvironmentLand |
     ammunitionCountryUK | 2 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

#
#  U.S.S.R. MUNITIONS.
 

# PROJECTILES 

# CALIBER SHIFT 1 

# KINETIC 

# Soviet PS - 7.62x39mm (AK-47 rifle) Ball 
  value: USSR_PS (objectDomainMunition | munitionClassProjectile |
     1 << ammunitionCaliberShift |
     ammunitionSubclassKinetic | ammunitionCountryUSSR |
     0 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# Soviet T45 - 7.62x39mm (AK-47 rifle) Tracer 
  value: USSR_T45 (objectDomainMunition | munitionClassProjectile |
     1 << ammunitionCaliberShift |
     ammunitionSubclassKinetic | ammunitionCountryUSSR |
     0 << ammunitionSeriesShift |
     2 << ammunitionModelShift)

# Soviet D - 7.62x54R (PK machine gun) Ball 
  value: USSR_D (objectDomainMunition | munitionClassProjectile |
     1 << ammunitionCaliberShift |
     ammunitionSubclassKinetic | ammunitionCountryUSSR |
     1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# Soviet BZT - 7.62x54R (PK machine gun) Tracer 
  value: USSR_BZT (objectDomainMunition | munitionClassProjectile |
     1 << ammunitionCaliberShift |
     ammunitionSubclassKinetic | ammunitionCountryUSSR |
     1 << ammunitionSeriesShift |
     2 << ammunitionModelShift)

# SHAPED CHARGE 

#
# Fake munitions that are used to trigger shrinking smoke effects for
#  73 Easting.  Big kludge.
#
 
  value: USSR_VehicleShrinkingSmoke (objectDomainMunition | munitionClassProjectile |
     1 << ammunitionCaliberShift |
     ammunitionSubclassShapedCharge |
     ammunitionCountryUSSR | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)
  value: USSR_FuelSiteShrinkingSmoke (objectDomainMunition | munitionClassProjectile |
     1 << ammunitionCaliberShift |
     ammunitionSubclassShapedCharge |
     ammunitionCountryUSSR | 1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)
  value: USSR_AmmoSiteShrinkingSmoke (objectDomainMunition | munitionClassProjectile |
     1 << ammunitionCaliberShift |
     ammunitionSubclassShapedCharge |
     ammunitionCountryUSSR | 1 << ammunitionSeriesShift |
     2 << ammunitionModelShift)

# CALIBER SHIFT 2 

# KINETIC 

# Soviet (French, I think) 20mm round fired from the M621 gun  
  value: USSR_20AP (objectDomainMunition | munitionClassProjectile |
     2 << ammunitionCaliberShift |
     ammunitionSubclassKinetic | ammunitionCountryUSSR |
     4 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Soviet 23mm round fired from the Gsh23L gun  
  value: USSR_23AP (objectDomainMunition | munitionClassProjectile |
     2 << ammunitionCaliberShift |
     ammunitionSubclassKinetic | ammunitionCountryUSSR |
     5 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Soviet 14.5mm machine gun round  
  value: USSR_145MG (objectDomainMunition | munitionClassProjectile |
     2 << ammunitionCaliberShift |
     ammunitionSubclassKinetic | ammunitionCountryUSSR |
     1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Soviet 12.7mm anti-aircraft round  
  value: USSR_127AA (objectDomainMunition | munitionClassProjectile |
     2 << ammunitionCaliberShift |
     ammunitionSubclassKinetic | ammunitionCountryUSSR |
     2 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Soviet 12.7mm gatling machine gun round  
  value: USSR_127MG (objectDomainMunition | munitionClassProjectile |
     2 << ammunitionCaliberShift |
     ammunitionSubclassKinetic | ammunitionCountryUSSR |
     3 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# CALIBER SHIFT 3 

# KINETIC 

# Soviet 30 mm sabot  
  value: USSR_30SABOT (objectDomainMunition | munitionClassProjectile |
     3 << ammunitionCaliberShift |
     ammunitionSubclassKinetic | ammunitionCountryUSSR |
     1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Soviet 30 mm sabot fired by BMP2 
  value: USSR_30SABOT_BMP2 (objectDomainMunition | munitionClassProjectile |
     3 << ammunitionCaliberShift |
     ammunitionSubclassKinetic | ammunitionCountryUSSR |
     1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# Soviet 30 mm sabot fired by Ka50 HOKUM 
  value: USSR_30SABOT_Ka50 (objectDomainMunition | munitionClassProjectile |
     3 << ammunitionCaliberShift |
     ammunitionSubclassKinetic | ammunitionCountryUSSR |
     1 << ammunitionSeriesShift |
     2 << ammunitionModelShift)

# HIGH EXPLOSIVE 

# Soviet 30mm HE round fired from the 2A42 gun  
  value: USSR_30HE (objectDomainMunition | munitionClassProjectile |
     3 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUSSR | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Soviet 30mm HE round fired from the BMP2 
  value: USSR_30HE_BMP2 (objectDomainMunition | munitionClassProjectile |
     3 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUSSR | 1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# Soviet 30mm HE round fired from the 2S6 
  value: USSR_30HE_2S6 (objectDomainMunition | munitionClassProjectile |
     3 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUSSR | 1 << ammunitionSeriesShift |
     2 << ammunitionModelShift)

# MICLIC water detonation: 10m in length 
  value: US_Water_MICLIC (objectDomainMunition | munitionClassBomb |
     1 << bombWeightClassShift |
     bombSubclassGeneralPurpose | ammunitionCountryUS |
     11 << ammunitionSeriesShift |
     0 << ammunitionModelShift)
# Shallow water mine detonation 
  value: US_Water_Mine_Shallow (objectDomainMunition | munitionClassBomb |
     1 << bombWeightClassShift |
     bombSubclassGeneralPurpose | ammunitionCountryUS |
     12 << ammunitionSeriesShift |
     0 << ammunitionModelShift)
# Deep water mine detonation (Quickstrike)
  value: US_Water_Mine_Deep (objectDomainMunition | munitionClassBomb |
     1 << bombWeightClassShift |
     bombSubclassGeneralPurpose | ammunitionCountryUS |
     13 << ammunitionSeriesShift |
     0 << ammunitionModelShift)
# Soviet 30mm HE round fired from the Ka50 HOKUM 
  value: USSR_30HE_Ka50 (objectDomainMunition | munitionClassProjectile |
     3 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUSSR | 1 << ammunitionSeriesShift |
     3 << ammunitionModelShift)

# CALIBER SHIFT 6 

# HIGH EXPLOSIVE 

# S-5 57mm rocket:  
  value: USSR_S5 (objectDomainMunition | munitionClassProjectile |
     6 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUSSR | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# CALIBER SHIFT 8 

# SHAPED CHARGE 

# Generic USSR Explosively Formed Penetrator (EFP) 
# This projectile is fired by the MCS-E submunition. 
  value: USSR_EFP (objectDomainMunition | munitionClassProjectile |
     8 << ammunitionCaliberShift |
     ammunitionSubclassShapedCharge |
     ammunitionCountryUSSR | 2 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Soviet 73 mm high explosive heat  
  value: USSR_73HEAT (objectDomainMunition | munitionClassProjectile |
     8 << ammunitionCaliberShift |
     ammunitionSubclassShapedCharge |
     ammunitionCountryUSSR | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# CALIBER SHIFT 10 

# SHAPED CHARGE 

# MCS-E Postulated Soviet SADARM-like submunition 
  value: USSR_MCS_E (objectDomainMunition | munitionClassProjectile |
     10 << ammunitionCaliberShift |
     ammunitionSubclassShapedCharge |
     ammunitionCountryUSSR | 2 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# CALIBER SHIFT 12 

# SHAPED CHARGE 

# Soviet 120mm SMART Munition Mortar Body artillery round  
  value: USSR_MMB_120_SMART (objectDomainMunition | munitionClassProjectile |
     12 << ammunitionCaliberShift |
     ammunitionSubclassShapedCharge |
     ammunitionCountryUSSR | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# HIGH EXPLOSIVE 

# OF843B 120mm HE mortar projectile:  
  value: USSR_OF843B (objectDomainMunition | munitionClassProjectile |
     12 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUSSR | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# HR843A 120mm HE mortar projectile: 
  value: USSR_HR843A (objectDomainMunition | munitionClassProjectile |
     12 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUSSR | 2 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# BOMBLETS 

# 120MM MCS-E Postulated Soviet SADARM-like carrier 
# This Mortar launched projectile carries 2 MCS-E submunitions. 
  value: USSR_120MM_MCS_E (objectDomainMunition | munitionClassProjectile |
     12 << ammunitionCaliberShift |
     ammunitionSubclassBomblets | ammunitionCountryUSSR |
     2 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# CALIBER SHIFT 13 

# KINETIC 

# Soviet 125 mm sabot  
  value: USSR_125SABOT (objectDomainMunition | munitionClassProjectile |
     13 << ammunitionCaliberShift |
     ammunitionSubclassKinetic | ammunitionCountryUSSR |
     1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# SHAPED CHARGE 

# Soviet 125 mm high explosive heat  
  value: USSR_125HEAT (objectDomainMunition | munitionClassProjectile |
     13 << ammunitionCaliberShift |
     ammunitionSubclassShapedCharge |
     ammunitionCountryUSSR | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Soviet 125 mm high explosive / fragmentation 
  value: USSR_125HE_Frag (objectDomainMunition | munitionClassProjectile |
     13 << ammunitionCaliberShift |
     ammunitionSubclassShapedCharge |
     ammunitionCountryUSSR | 1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# Soviet BK-6M, 122 mm HEAT-FS  
  value: USSR_BK_6M (objectDomainMunition | munitionClassProjectile |
     13 << ammunitionCaliberShift |
     ammunitionSubclassShapedCharge |
     ammunitionCountryUSSR | 2 << ammunitionSeriesShift |
     2 << ammunitionModelShift)

# HIGH EXPLOSIVE 

# Soviet M-21-OF, 122 mm rocket HE  
  value: USSR_M_21_OF (objectDomainMunition | munitionClassProjectile |
     13 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUSSR | 2 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Soviet OF-462, 122 mm HE  
  value: USSR_OF_462 (objectDomainMunition | munitionClassProjectile |
     13 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUSSR | 2 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# SMOKE 

# Soviet D-462, 122 mm smoke 
  value: USSR_D_462 (objectDomainMunition | munitionClassProjectile |
     13 << ammunitionCaliberShift |
     ammunitionSubclassSmoke | ammunitionCountryUSSR |
     2 << ammunitionSeriesShift |
     3 << ammunitionModelShift)

# CALIBER SHIFT 14 

# SHAPED CHARGE 

  value: US_MLRS_SAD (objectDomainMunition | munitionClassProjectile |
     14 << ammunitionCaliberShift |
     ammunitionSubclassShapedCharge | ammunitionCountryUS |
     2 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

  value: US_MLRS_SAD_ER (objectDomainMunition | munitionClassProjectile |
     14 << ammunitionCaliberShift |
     ammunitionSubclassShapedCharge | ammunitionCountryUS |
     2 << ammunitionSeriesShift |
     2 << ammunitionModelShift)

  value: US_MLRS_MSTAR (objectDomainMunition | munitionClassProjectile |
     14 << ammunitionCaliberShift |
     ammunitionSubclassShapedCharge | ammunitionCountryUS |
     2 << ammunitionSeriesShift |
     3 << ammunitionModelShift)

# CALIBER SHIFT 16 

# SHAPED CHARGE 

# 152mm MCS Postulated Soviet SADARM-like carrier. 
# This 152mm howitzer launched projectile carries 2 MCS_E submunitions. 
  value: USSR_MCS_SMART (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift |
     ammunitionSubclassShapedCharge |
     ammunitionCountryUSSR | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# HIGH EXPLOSIVE 

# Soviet OF-540, 152 mm HE  
  value: USSR_OF_540 (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUSSR | 2 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# Soviet OF-45, 152 mm HE  
  value: USSR_OF_45 (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUSSR | 2 << ammunitionSeriesShift |
     2 << ammunitionModelShift)

# Soviet OF-61, 152 mm HE BB 
  value: USSR_OF_61 (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUSSR | 2 << ammunitionSeriesShift |
     3 << ammunitionModelShift)

# Soviet 9K25, 152 mm CLGP 
  value: USSR_9K25 (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUSSR | 2 << ammunitionSeriesShift |
     5 << ammunitionModelShift)

# Soviet ER-540 FRAG/HE 
  value: USSR_ER540 (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift | ammunitionSubclassHE |
     ammunitionCountryUSSR | 3 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# BOMBLETS 

# Larger version of US-SADARM 
  value: US_155_SADARM (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift |
     ammunitionSubclassBomblets | ammunitionCountryUS |
     2 << ammunitionSeriesShift |
     3 << ammunitionModelShift)

# Soviet 3O23, 152 mm DPICM 
  value: USSR_3O23 (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift |
     ammunitionSubclassBomblets | ammunitionCountryUSSR |
     2 << ammunitionSeriesShift |
     4 << ammunitionModelShift)

# Soviet MAS-D, 152mm DPICM 
  value: USSR_MASD (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift |
     ammunitionSubclassBomblets | ammunitionCountryUSSR |
     3 << ammunitionSeriesShift |
     4 << ammunitionModelShift)

# SMOKE 

# Soviet D-540, 152 mm Smoke 
  value: USSR_D_540 (objectDomainMunition | munitionClassProjectile |
     16 << ammunitionCaliberShift |
     ammunitionSubclassSmoke | ammunitionCountryUSSR |
     2 << ammunitionSeriesShift |
     6 << ammunitionModelShift)

# BOMBS 

# BOMB WEIGHT SHIFT 2 

# KhAB-100 100 kg chemical bomb, HL filled 
  value: USSR_KhAB_100_HL (objectDomainMunition | munitionClassBomb |
     2 << bombWeightClassShift | bombSubclassChemical |
     ammunitionCountryUSSR | 0 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# KhAB-100 100 kg chemical bomb, GB filled 
  value: USSR_KhAB_100_GB (objectDomainMunition | munitionClassBomb |
     2 << bombWeightClassShift | bombSubclassChemical |
     ammunitionCountryUSSR | 0 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# KhAB-100 100 kg chemical bomb, GD filled  
  value: USSR_KhAB_100_GD (objectDomainMunition | munitionClassBomb |
     2 << bombWeightClassShift | bombSubclassChemical |
     ammunitionCountryUSSR | 0 << ammunitionSeriesShift |
     2 << ammunitionModelShift)

# BOMB WEIGHT SHIFT 5 

# KhAB-250 250 kg chemical bomb, HL filled 
  value: USSR_KhAB_250_HL (objectDomainMunition | munitionClassBomb |
     5 << bombWeightClassShift | bombSubclassChemical |
     ammunitionCountryUSSR | 0 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# KhAB-250 250 kg chemical bomb, GB filled  
  value: USSR_KhAB_250_GB (objectDomainMunition | munitionClassBomb |
     5 << bombWeightClassShift | bombSubclassChemical |
     ammunitionCountryUSSR | 0 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# KhAB-250 250 kg chemical bomb, GD filled 
  value: USSR_KhAB_250_GD (objectDomainMunition | munitionClassBomb |
     5 << bombWeightClassShift | bombSubclassChemical |
     ammunitionCountryUSSR | 0 << ammunitionSeriesShift |
     2 << ammunitionModelShift)

# FAB 250 kg (550 lb) general purpose bomb  
  value: USSR_FAB250 (objectDomainMunition | munitionClassBomb |
     5 << bombWeightClassShift |
     bombSubclassGeneralPurpose | ammunitionCountryUSSR |
     1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# BOMB WEIGHT SHIFT 11 

# FAB 500 kg (1100 lb) general purpose bomb  
  value: USSR_FAB500 (objectDomainMunition | munitionClassBomb |
     11 << bombWeightClassShift |
     bombSubclassGeneralPurpose | ammunitionCountryUSSR |
     1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Internal combustion "munitions" for secondary explosions 
# Internal bomb caused by the burning contents of a Soviet tank 
  value: USSR_TankInternalExplosion (objectDomainMunition | munitionClassBomb |
     11 << bombWeightClassShift |
     bombSubclassGeneralPurpose | ammunitionCountryUSSR |
     2 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Internal bomb caused by the burning contents of a Soviet PC 
  value: USSR_PCInternalExplosion (objectDomainMunition | munitionClassBomb |
     11 << bombWeightClassShift |
     bombSubclassGeneralPurpose | ammunitionCountryUSSR |
     2 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# Internal bomb caused by the burning contents of a Soviet Missile Carrier 
  value: USSR_MissileCarrierInternalExplosion (objectDomainMunition | munitionClassBomb |
     11 << bombWeightClassShift |
     bombSubclassGeneralPurpose | ammunitionCountryUSSR |
     2 << ammunitionSeriesShift |
     2 << ammunitionModelShift)

# Internal bomb caused by the burning contents of a Soviet Fuel Truck 
  value: USSR_FuelTruckInternalExplosion (objectDomainMunition | munitionClassBomb |
     11 << bombWeightClassShift |
     bombSubclassGeneralPurpose | ammunitionCountryUSSR |
     2 << ammunitionSeriesShift |
     3 << ammunitionModelShift)

# Internal bomb caused by the burning contents of a Soviet Ammo Truck 
  value: USSR_AmmoTruckInternalExplosion (objectDomainMunition | munitionClassBomb |
     11 << bombWeightClassShift |
     bombSubclassGeneralPurpose | ammunitionCountryUSSR |
     2 << ammunitionSeriesShift |
     4 << ammunitionModelShift)

# Internal bomb caused by the burning contents of a Soviet Ammo Crate 
  value: USSR_AmmoCrateInternalExplosion (objectDomainMunition | munitionClassBomb |
     11 << bombWeightClassShift |
     bombSubclassGeneralPurpose | ammunitionCountryUSSR |
     2 << ammunitionSeriesShift |
     5 << ammunitionModelShift)

# MISSILES 

# ANTI-TANK 

# HIGH EXPLOSIVE 

# Soviet 57mm rocket, UV-32 rocket pod  
  value: USSR_UV32_57 (objectDomainMunition | munitionClassMissile |
     missileTargetArmor | missileWarheadHE |
     ammunitionCountryUSSR | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Matra (French???) SNEB 68mm rocket  
  value: USSR_SNEB_68 (objectDomainMunition | munitionClassMissile |
     missileTargetArmor | missileWarheadHE |
     ammunitionCountryUSSR | 2 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Soviet 80mm rocket, UV-20 rocket pod  
  value: USSR_UV20_80 (objectDomainMunition | munitionClassMissile |
     missileTargetArmor | missileWarheadHE |
     ammunitionCountryUSSR | 3 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Soviet 64mm rocket, as launched by an RPG-18 
  value: USSR_ROCKET_64 (objectDomainMunition | munitionClassMissile |
     missileTargetArmor | missileWarheadHE |
     ammunitionCountryUSSR | 4 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# SHAPED CHARGE 

# Soviet Songster Anti-tank missile  
  value: USSR_Songster (objectDomainMunition | munitionClassMissile |
     missileTargetArmor | missileWarheadShapedCharge |
     ammunitionCountryUSSR | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Soviet Spandrel Anti-tank missile  
  value: USSR_Spandrel (objectDomainMunition | munitionClassMissile |
     missileTargetArmor | missileWarheadShapedCharge |
     ammunitionCountryUSSR | 2 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Soviet Sagger (AT-3) Anti-tank missile  
  value: USSR_Sagger (objectDomainMunition | munitionClassMissile |
     missileTargetArmor | missileWarheadShapedCharge |
     ammunitionCountryUSSR | 6 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Soviet Spigot (AT-4) Anti-tank missile  
  value: USSR_Spigot (objectDomainMunition | munitionClassMissile |
     missileTargetArmor | missileWarheadShapedCharge |
     ammunitionCountryUSSR | 7 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Soviet Spiral Anti-tank missile  
  value: USSR_Spiral (objectDomainMunition | munitionClassMissile |
     missileTargetArmor | missileWarheadShapedCharge |
     ammunitionCountryUSSR | 3 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

  value: USSR_AT6       USSR_Spiral

# Soviet AT/2C Swatter Anti-tank missile  
  value: USSR_SwatterC (objectDomainMunition | munitionClassMissile |
     missileTargetArmor | missileWarheadShapedCharge |
     ammunitionCountryUSSR | 4 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

  value: muniton_USSR_AT2C       USSR_SwatterC

# Soviet (Franco-German actually) HOT Anti-tank missile  
  value: USSR_HOT (objectDomainMunition | munitionClassMissile |
     missileTargetArmor | missileWarheadShapedCharge |
     ammunitionCountryUSSR | 5 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Soviet AT-P-H2 Anti-tank missile  
  value: USSR_ATP_H2 (objectDomainMunition | munitionClassMissile |
     missileTargetArmor | missileWarheadShapedCharge |
     ammunitionCountryUSSR | 8 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# ANTI-AIRCRAFT 

# Soviet (French actually) Mistral anti-aircraft missile:  
  value: USSR_Mistral (objectDomainMunition | munitionClassMissile |
     missileTargetAircraft | missileWarheadHE |
     ammunitionCountryUSSR | 0 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Soviet SA-14 Gremlin anti-aircraft missile:  
  value: USSR_Gremlin (objectDomainMunition | munitionClassMissile |
     missileTargetAircraft | missileWarheadHE |
     ammunitionCountryUSSR | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

  value: USSR_SA14      USSR_Gremlin

# Soviet SA-7 Grail anti-aircraft missile:  
  value: USSR_Grail (objectDomainMunition | munitionClassMissile |
     missileTargetAircraft | missileWarheadHE |
     ammunitionCountryUSSR | 2 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Soviet SA-9 Gaskin anti-aircraft missile:  
  value: USSR_Gaskin (objectDomainMunition | munitionClassMissile |
     missileTargetAircraft | missileWarheadHE |
     ammunitionCountryUSSR | 3 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Soviet AA-10 Alamo anit-aircraft missile: 
  value: USSR_Alamo (objectDomainMunition | munitionClassMissile |
     missileTargetAircraft | missileWarheadHE |
     ammunitionCountryUSSR | 4 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Soviet AA-11 Archer anit-aircraft missile: 
  value: USSR_Archer (objectDomainMunition | munitionClassMissile |
     missileTargetAircraft | missileWarheadHE |
     ammunitionCountryUSSR | 5 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Soviet SA-19 anti-aircraft missile:  
  value: USSR_SA_19 (objectDomainMunition | munitionClassMissile |
     missileTargetAircraft | missileWarheadHE |
     ammunitionCountryUSSR | 6 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Soviet SA-16 anti-aircraft missile:  
  value: USSR_SA_16 (objectDomainMunition | munitionClassMissile |
     missileTargetAircraft | missileWarheadHE |
     ammunitionCountryUSSR | 7 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

  value: USSR_Gauntlet (objectDomainMunition | munitionClassMissile |
     missileTargetAircraft | missileWarheadHE |
     ammunitionCountryUSSR | 8 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Soviet SA-15 Gauntlet anti-aircraft missile:  
  value: USSR_SA15      USSR_Gauntlet

# Soviet SA-18 Gimlet anti-aircraft missile 
# $$$ Changed to be series 9, since the Gauntlet above 
# $$$ was series 8. 
  value: USSR_Gimlet (objectDomainMunition | munitionClassMissile |
     missileTargetAircraft | missileWarheadHE |
     ammunitionCountryUSSR | 9 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Soviet SA_6 TEL anti-aircraft missile: 
  value: USSR_SA_6 (objectDomainMunition | munitionClassMissile |
     missileTargetAircraft | missileWarheadHE |
     ammunitionCountryUSSR | 10 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

  value: USSR_Aspide (objectDomainMunition | munitionClassMissile |
     missileTargetAircraft | missileWarheadHE |
     ammunitionCountryUSSR | 11 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# LAND ATTACK 

# Soviet FROG-7 B  600mm missile 
  value: USSR_FROG_7 (objectDomainMunition | munitionClassMissile |
     missileTargetSurface | missileWarheadHE |
     ammunitionCountryUSSR | 0 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Soviet (actually Iraqi) Al Husayn missile (longer than a Scud) 
  value: USSR_ALHUSAYN (objectDomainMunition | munitionClassMissile |
     missileTargetSurface | missileWarheadHE |
     ammunitionCountryUSSR | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Soviet SCUD A (SS-1B) 850mm ballistic missile 
  value: USSR_SCUD_A (objectDomainMunition | munitionClassMissile |
     missileTargetSurface | missileWarheadHE |
     ammunitionCountryUSSR | 2 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Soviet SCUD B (SS-1C) 850mm ballistic missile 
  value: USSR_SCUD_B (objectDomainMunition | munitionClassMissile |
     missileTargetSurface | missileWarheadHE |
     ammunitionCountryUSSR | 2 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# ANTI-SHIP 

# SSN 2 STYX_c surface-to-surface anti-ship missile  
  value: USSR_STYX_C (objectDomainMunition | munitionClassMissile |
     missileTargetShip | missileWarheadHE |
     ammunitionCountryUSSR | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# CSSC_W silkworm surface-to-surface anti-ship missile  
  value: USSR_Silkworm (objectDomainMunition | munitionClassMissile |
     missileTargetShip | missileWarheadHE |
     ammunitionCountryUSSR | 2 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

#EXOCET MM 38/SM 39/ MM 40 (GWS 50)
  value: FRANCE_Exocet (objectDomainMunition | munitionClassMissile |
     missileTargetShip | missileWarheadHE |
     ammunitionCountryFrance | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

  value: USSR_Otomat (objectDomainMunition | munitionClassMissile |
     missileTargetShip | missileWarheadHE |
     ammunitionCountryUSSR | 3 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# TARGET MISCELLANEOUS 

# Grenades, (modeled as missiles) (this is a poor definition) 
  value: USSR_RPG16 (objectDomainMunition | munitionClassMissile |
     missileTargetMiscellaneous | missileWarheadHE |
     ammunitionCountryUSSR | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# Soviet 30mm grenade, as launched by an AGS-17 
  value: USSR_VOG_17M (objectDomainMunition | munitionClassMissile |
     missileTargetMiscellaneous | missileWarheadHE |
     ammunitionCountryUSSR | 2 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# MINES 

# LAND 

# ANTI-TANK 

# TMD-B wooden antitank mine used for mobility kills using blasts.  This 
# mine contains between 11 and 15 lbs of TNT for its main charge and 
# is activated by a pressure fuzing system that requires a force of 440 lbs. 
# This mine is obsolete, but still in the Soviet inventory  
  value: USSR_TMD_B (objectDomainMunition | munitionClassMine |
     mineTargetTank | mineEnvironmentLand |
     ammunitionCountryUSSR | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# YAM-5 is similar to the TMD-B wooden antitank mine  
  value: USSR_YAM5 (objectDomainMunition | munitionClassMine |
     mineTargetTank | mineEnvironmentLand |
     ammunitionCountryUSSR | 2 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# TM-46 anti-tank blast mine  
  value: USSR_TM46 (objectDomainMunition | munitionClassMine |
     mineTargetTank | mineEnvironmentLand |
     ammunitionCountryUSSR | 3 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# TMN-46 anti-tank blast mine, is similar to TM-46, but with 
#   a secondary fuzewell for antihandling devices  
  value: USSR_TMN46 (objectDomainMunition | munitionClassMine |
     mineTargetTank | mineEnvironmentLand |
     ammunitionCountryUSSR | 4 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# TM-57 anti-tank mine, a little larger than TMN-46  
  value: USSR_TM57 (objectDomainMunition | munitionClassMine |
     mineTargetTank | mineEnvironmentLand |
     ammunitionCountryUSSR | 5 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# TM-62M, the current standard AT mine.  
#   Contains MVZ-62 time delay fuze  
  value: USSR_TM62 (objectDomainMunition | munitionClassMine |
     mineTargetTank | mineEnvironmentLand |
     ammunitionCountryUSSR | 6 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# TMK-2 is a shaped charge AT mine, consisting of HEAT round similar 
# to those fired from tanks.  This is one of the few Soviet mines designed 
#   for catastophic kills.  
  value: USSR_TMK2 (objectDomainMunition | munitionClassMine |
     mineTargetTank | mineEnvironmentLand |
     ammunitionCountryUSSR | 7 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# PGMDM AT mine 
  value: USSR_PGMDM (objectDomainMunition | munitionClassMine |
     mineTargetTank | mineEnvironmentLand |
     ammunitionCountryUSSR | 8 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# PT-MI-K AT mine 
  value: USSR_PTMIK (objectDomainMunition | munitionClassMine |
     mineTargetTank | mineEnvironmentLand |
     ammunitionCountryUSSR | 9 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# TMRP-6 AT mine 
  value: USSR_TMRP6 (objectDomainMunition | munitionClassMine |
     mineTargetTank | mineEnvironmentLand |
     ammunitionCountryUSSR | 10 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# ANTI-PERSONNEL 

# POMZ-2 AP-frag mine, area type mine, causes causalities in a 4m radius, 
#   normally laid in clusters of four and often found in bushy areas  
  value: USSR_POMZ2 (objectDomainMunition | munitionClassMine |
     mineTargetPerson | mineEnvironmentLand |
     ammunitionCountryUSSR | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# OMZ-3 AP-frag, actually blast, since it propells upward to a height 
#   of 1.5-2 m before exploding  
  value: USSR_OMZ3 (objectDomainMunition | munitionClassMine |
     mineTargetPerson | mineEnvironmentLand |
     ammunitionCountryUSSR | 2 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# MON series.  The number afterwards is the lethal range in meters.  
#  The MON50 is similar to the Claymore M18A1.   
#   All are frag simes, command detonated  
  value: USSR_MON50 (objectDomainMunition | munitionClassMine |
     mineTargetPerson | mineEnvironmentLand |
     ammunitionCountryUSSR | 3 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

  value: USSR_MON100 (objectDomainMunition | munitionClassMine |
     mineTargetPerson | mineEnvironmentLand |
     ammunitionCountryUSSR | 3 << ammunitionSeriesShift |
     2 << ammunitionModelShift)

  value: USSR_MON200 (objectDomainMunition | munitionClassMine |
     mineTargetPerson | mineEnvironmentLand |
     ammunitionCountryUSSR | 3 << ammunitionSeriesShift |
     3 << ammunitionModelShift)

# The PMN AP blast, contains 8.5oz of TNT, contains 20 minute delay fuze  
  value: USSR_PMN (objectDomainMunition | munitionClassMine |
     mineTargetPerson | mineEnvironmentLand |
     ammunitionCountryUSSR | 4 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# The PMK-40 AP blast, contains 2oz of TNT  
  value: USSR_PMK40 (objectDomainMunition | munitionClassMine |
     mineTargetPerson | mineEnvironmentLand |
     ammunitionCountryUSSR | 5 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# SEA 

# ANTI-SHIP 

  value: USSR_PDM1 (objectDomainMunition | munitionClassMine |
     mineTargetShip | mineEnvironmentWater |
     ammunitionCountryUSSR | 1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

  value: USSR_M26 (objectDomainMunition | munitionClassMine |
     mineTargetShip | mineEnvironmentWater |
     ammunitionCountryUSSR | 2 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

  value: USSR_MKB1 (objectDomainMunition | munitionClassMine |
     mineTargetShip | mineEnvironmentWater |
     ammunitionCountryUSSR | 3 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

  value: USSR_MYaM (objectDomainMunition | munitionClassMine |
     mineTargetShip | mineEnvironmentWater |
     ammunitionCountryUSSR | 4 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

  value: USSR_MZ26 (objectDomainMunition | munitionClassMine |
     mineTargetShip | mineEnvironmentWater |
     ammunitionCountryUSSR | 5 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

  value: USSR_AMDKMD (objectDomainMunition | munitionClassMine |
     mineTargetShip | mineEnvironmentWater |
     ammunitionCountryUSSR | 6 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# ANTI-SUB 

  value: USSR_MAG (objectDomainMunition | munitionClassMine |
     mineTargetSub | mineEnvironmentWater |
     ammunitionCountryUSSR | 1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

#
# GERMAN MUNITIONS 
 

# PROJECTILES 

# CALIBER SHIFT 2 

# German 20mm round  
  value: German_20SABOT (objectDomainMunition | munitionClassProjectile |
     2 << ammunitionCaliberShift |
     ammunitionSubclassKinetic | ammunitionCountryGermany |
     1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# German DM63, 20mm APDS  
  value: German_DM63 (objectDomainMunition | munitionClassProjectile |
     2 << ammunitionCaliberShift |
     ammunitionSubclassKinetic | ammunitionCountryGermany |
     2 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# German DM81, 20mm HEI-T  
  value: German_DM81 (objectDomainMunition | munitionClassProjectile |
     2 << ammunitionCaliberShift |
     ammunitionSubclassHEIncendiary |
     ammunitionCountryGermany | 2 << ammunitionSeriesShift |
     2 << ammunitionModelShift)

# German Flare 
  value: German_Flare (objectDomainMunition | munitionClassProjectile |
     2 << ammunitionCaliberShift |
     ammunitionSubclassIllumination |
     ammunitionCountryGermany | 0 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# CALIBER SHIFT 4 

# German 35mm Oerlikon KDA, HEI  
  value: German_35HEI (objectDomainMunition | munitionClassProjectile |
     4 << ammunitionCaliberShift |
     ammunitionSubclassHEIncendiary |
     ammunitionCountryGermany | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# German 35mm Oerlikon KDA, APDS-T  
  value: German_35AP (objectDomainMunition | munitionClassProjectile |
     4 << ammunitionCaliberShift |
     ammunitionSubclassKinetic | ammunitionCountryGermany |
     1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

# CALIBER SHIFT 12 

# German 120mm heat 
  value: German_120HEAT (objectDomainMunition | munitionClassProjectile |
     12 << ammunitionCaliberShift |
     ammunitionSubclassShapedCharge |
     ammunitionCountryGermany | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# German 120mm sabot  
  value: German_120SABOT (objectDomainMunition | munitionClassProjectile |
     12 << ammunitionCaliberShift |
     ammunitionSubclassKinetic | ammunitionCountryGermany |
     1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# CALIBER SHIFT 23 

# German Mines -  AT2 227mm AT2 Anti-Tank Mine projectile:  
  value: GERMAN_AT2 (objectDomainMunition | munitionClassProjectile |
     23 << ammunitionCaliberShift |
     ammunitionSubclassScatterMines |
     ammunitionCountryGermany | 1 << ammunitionSeriesShift |
     1 << ammunitionModelShift)

  value: German_AT2     GERMAN_AT2# Soviet Mines  

# MISSILES 

# German Milan missile  
  value: Germany_Milan (objectDomainMunition | munitionClassMissile |
     missileTargetArmor | missileWarheadShapedCharge |
     ammunitionCountryGermany | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

  value: German_Milan   Germany_Milan

# Franco-German HOT Anti-tank missile  
  value: German_HOT (objectDomainMunition | munitionClassMissile |
     missileTargetArmor | missileWarheadShapedCharge |
     ammunitionCountryGermany | 2 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# German 66mm rocket, as launched by an M72 bazooka 
  value: German_Panzerfaust (objectDomainMunition | munitionClassMissile |
     missileTargetArmor | missileWarheadHE |
     ammunitionCountryGermany | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

#
# OTHER COUNTRY MUNITIONS
 

# MINES 

# P2-Mk3 AT mine 
  value: OTHER_P2MK3 (objectDomainMunition | munitionClassMine |
     mineTargetTank | mineEnvironmentLand |
     ammunitionCountryOther | 1 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# PT-MI-BA-III AT mine 
  value: OTHER_PTMIBAIII (objectDomainMunition | munitionClassMine |
     mineTargetTank | mineEnvironmentLand |
     ammunitionCountryOther | 2 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

# MIACAH AT mine 
  value: OTHER_MIACAH (objectDomainMunition | munitionClassMine |
     mineTargetTank | mineEnvironmentLand |
     ammunitionCountryOther | 3 << ammunitionSeriesShift |
     0 << ammunitionModelShift)

##************************************************************************* 
# temp munitions 
##************************************************************************* 

  value: EO_1 (objectDomainMunition | munitionClassEO | 1)
  value: EO_2 (objectDomainMunition | munitionClassEO | 2)
  value: EO_3 (objectDomainMunition | munitionClassEO | 3)
  value: EO_4 (objectDomainMunition | munitionClassEO | 4)
  value: EO_5 (objectDomainMunition | munitionClassEO | 5)
  value: US_Hell_Laser (objectDomainMunition | munitionClassLaser | 1)

