#
# File:     obj_type.cdf
# Contents: 
# System:   simnet development.
# Created:  8-Oct-1991
# Author:   jslee
#
# Remarks:
#
# History:
#    11/08/91	JSLee		Converted from obj_type.h

# $RCSfile: obj_type.cdf,v $
# $Revision: 1.1.1.1 $
# $State: Exp $

# COPYRIGHT 1990 BBN Systems and Technologies Corporation
# 10 Moulton Street
# Cambridge, Ma. 02138
# 617-873-3000
#

##
#  Country codes.

defs: Country
  value: countryOther			0		# other 
  value: countryUS			1		# U.S.A. 
  value: countryUSSR			2		# U.S.S.R. 
  value: countryGermany                 3               # Germany 
  value: countryFrance			4		# France
  value: countryYugoslavia		5		# Yugoslavia
  value: countryEgypt			6		# Egypt
  value: countryItaly			7		# Italy
  value: countryUK			8		# U.K.


# The high-order three bits identify an object type's domain: 
defs: ObjectDomain
  value: objectDomainMask		0xE0000000
  value: objectDomainShift		29
  value: objectDomainOther		(0 << objectDomainShift)
  value: objectDomainVehicle		(1 << objectDomainShift)
  value: objectDomainMunition		(2 << objectDomainShift)
  value: objectDomainStructure		(3 << objectDomainShift)
  value: objectDomainLifeForm		(4 << objectDomainShift)
  value: objectDomainEchelon		(5 << objectDomainShift)
  value: objectDomainEnvironmental      (6 << objectDomainShift)
  value: objectDomainUnit               (7 << objectDomainShift)

#
#  Numbering scheme for domain type "Other".
##  

# The next four bits of the domain Other identifies class
defs: OtherClass
  value: otherClassMask			0x1E000000
  value: otherClassShift		25
  value: otherClassAccessory		(1 << otherClassShift)
  value: otherClassObstacle             (2 << otherClassShift)
  value: otherClassComponent		(3 << otherClassShift)
  value: otherClassSubComponent         (4 << otherClassShift)


# The next three bits of the domain Other identifies subclass
defs: OtherSubclass
  value: otherSubclassMask		0x1F80000
  value: otherSubclassShift		19

#     Subclasses of Accessories                              
defs: OtherSubclassAccessory
  value: otherSubclassResupply		(1 << otherSubclassShift)
  value: otherSubclassRadio		(2 << otherSubclassShift)
  value: otherSubclassParts             (3 << otherSubclassShift)

#     Subclasses of Obstacles
defs: OtherSubclassObstacle
  value: otherSubclassMinefield		(1 << otherSubclassShift)
  value: otherSubclassMineSet		(2 << otherSubclassShift)

#     Subclasses of Components                               
defs: OtherSubclassComponent
  value: otherSubclassHull		(1 << otherSubclassShift)
  value: otherSubclassTurret            (2 << otherSubclassShift)
  value: otherSubclassChassis           (3 << otherSubclassShift)
  value: otherSubclassSuspension        (4 << otherSubclassShift)
  value: otherSubclassEngineComponent   (5 << otherSubclassShift)
  value: otherSubclassElect_Sights      (6 << otherSubclassShift)
  value: otherSubclassCommo             (7 << otherSubclassShift)
  value: otherSubclassWeapon            (8 << otherSubclassShift)

#     Subclasses of SubComponents                           
defs: OtherSubclassSubcomponent
  value: otherSubclassEngine            (1 << otherSubclassShift)
  value: otherSubclassTransmission      (2 << otherSubclassShift)
  value: otherSubclassGun               (3 << otherSubclassShift)
  value: otherSubclassTurretParts       (4 << otherSubclassShift)
  value: otherSubclassCommunications    (5 << otherSubclassShift)
  value: otherSubclassWheel             (6 << otherSubclassShift)
  value: otherSubclassAssembly          (7 << otherSubclassShift)
  value: otherSubclassDriver            (8 << otherSubclassShift)
  value: otherSubclassBrake             (9 << otherSubclassShift)
  value: otherSubclassFuel              (10 << otherSubclassShift)
  value: otherSubclassVision            (11 << otherSubclassShift)
  value: otherSubclassNetwork           (12 << otherSubclassShift)
  value: otherSubclassExhaust           (13 << otherSubclassShift)
  value: otherSubclass14                (14 << otherSubclassShift)
  value: otherSubclass15                (15 << otherSubclassShift)
  value: otherSubclass16                (16 << otherSubclassShift)
  value: otherSubclass17                (17 << otherSubclassShift)
  value: otherSubclass18                (18 << otherSubclassShift)
  value: otherSubclass19                (19 << otherSubclassShift)
  value: otherSubclass20                (20 << otherSubclassShift)
  value: otherSubclass21                (21 << otherSubclassShift)
  value: otherSubclass22                (22 << otherSubclassShift)
  value: otherSubclass23                (23 << otherSubclassShift)
  value: otherSubclass24                (24 << otherSubclassShift)
  value: otherSubclass25                (25 << otherSubclassShift)
  value: otherSubclass26                (26 << otherSubclassShift)
  value: otherSubclass27                (27 << otherSubclassShift)
  value: otherSubclass28                (28 << otherSubclassShift)
  value: otherSubclass29                (29 << otherSubclassShift)
  value: otherSubclass30                (30 << otherSubclassShift)
  value: otherSubclass31                (31 << otherSubclassShift)
  value: otherSubclass32                (32 << otherSubclassShift)
  value: otherSubclass33                (33 << otherSubclassShift)
  value: otherSubclass34                (34 << otherSubclassShift)
  value: otherSubclass35                (35 << otherSubclassShift)
  value: otherSubclass36                (36 << otherSubclassShift)
  value: otherSubclass37                (37 << otherSubclassShift)
  value: otherSubclass38                (38 << otherSubclassShift)
  value: otherSubclass39                (39 << otherSubclassShift)


# The next three bits of the domain Other identifies type
defs: OtherType
  value: otherTypeMask			0x70000
  value: otherTypeShift			16

#     Types of Resupply Accessories                 
defs: OtherTypeResupply
  value: otherTypeFuelDrum		(1 << otherTypeShift)
  value: otherTypeFARE			(2 << otherTypeShift)

#     Types of Radio Accessories                 
defs: OtherTypeRadio
  value: otherTypeRadioGeneric		(1 << otherTypeShift)

#     Types of Minefields
defs: OtherTypeMinefield
  value: otherTypeGenericMinefield	(1 << otherTypeShift)

#     Types of Mine Sets
defs: OtherTypeMineSet
  value: otherTypeGenericMineSet	(1 << otherTypeShift)

#     Types of attachable parts
defs: OtherTypeParts
  value: otherTypeGenericPart		(1 << otherTypeShift)

#     Types of Hull Components                       
defs: OtherTypeHull
  value: otherTypeGenericHull              (1 << otherTypeShift)

#     Types of Turret Components                     
defs: OtherTypeTurret
  value: otherTypeGenericTurret            (1 << otherTypeShift)

#     Types of Engine Subomponents                   
defs: OtherTypeEngine
  value: otherTypeGenericEngine            (1 << otherTypeShift)

#     Types of Transmission Subomponents             
defs: OtherTypeTransmission
  value: otherTypeGenericTransmission      (1 << otherTypeShift)

# The next six bits of a Radio type identify its country of origin: 
defs: RadioCountry
  value: RadioCountryMask	0x0FC000
  value: RadioCountryShift	10
  value: RadioCountryOther	(countryOther	<< RadioCountryShift)
  value: RadioCountryUS		(countryUS	<< RadioCountryShift)
  value: RadioCountryUSSR	(countryUSSR	<< RadioCountryShift)

#
#  Vehicle type scheme.
 
##
# The next three bits of a vehicle type identify its environment: 
defs: VehicleEnvironment
  value: vehicleEnvironmentMask		0x1C000000
  value: vehicleEnvironmentShift	26
  value: vehicleEnvironmentAir		(1 << vehicleEnvironmentShift)
  value: vehicleEnvironmentGround	(2 << vehicleEnvironmentShift)
  value: vehicleEnvironmentSpace	(3 << vehicleEnvironmentShift)
  value: vehicleEnvironmentWater	(4 << vehicleEnvironmentShift)

# The next three bits of a vehicle type identify its class: 
defs: VehicleClass
  value: vehicleClassMask		0x03800000
  value: vehicleClassShift		23
  value: vehicleClassNonMilitary	(0 << vehicleClassShift)

# Classes of air vehicles: 
defs: VehicleClassAir
  value: vehicleClassFixedWing		(1 << vehicleClassShift)
  value: vehicleClassLighterThanAir	(2 << vehicleClassShift)
  value: vehicleClassRotaryWing		(3 << vehicleClassShift)

# Classes of ground vehicles: 
defs: VehicleClassGround
  value: vehicleClassSPArmoredTracked	(1 << vehicleClassShift)
  value: vehicleClassSPArmoredWheeled	(2 << vehicleClassShift)
  value: vehicleClassSPUnarmoredTracked	(3 << vehicleClassShift)
  value: vehicleClassSPUnarmoredWheeled	(4 << vehicleClassShift)
  value: vehicleClassTowed		(5 << vehicleClassShift)
  value: vehicleClassCarried            (6 << vehicleClassShift)


# Classes of water vehicles 
defs: VehicleClassSea
  value: vehicleClassAmphibWarfare      (1 << vehicleClassShift)
  value: vehicleClassAuxilliary		(2 << vehicleClassShift)
  value: vehicleClassMaterialSupport	(3 << vehicleClassShift)
  value: vehicleClassMineWarfare	(4 << vehicleClassShift)
  value: vehicleClassSubmarine		(5 << vehicleClassShift)
  value: vehicleClassSurfaceCombat	(6 << vehicleClassShift)
  value: vehicleClassMineSweepGear      (7 << vehicleClassShift)

# The next six bits of a vehicle type identify its country of origin: 
defs: VehicleCountry
  value: vehicleCountryMask		0x007E0000
  value: vehicleCountryShift		17
  value: vehicleCountryOther		(countryOther << vehicleCountryShift)
  value: vehicleCountryUS		(countryUS << vehicleCountryShift)
  value: vehicleCountryUSSR		(countryUSSR << vehicleCountryShift)
  value: vehicleCountryGermany          (countryGermany << vehicleCountryShift)
  value: vehicleCountryFrance           (countryFrance << vehicleCountryShift)
  value: vehicleCountryYugoslavia       (countryYugoslavia << vehicleCountryShift)
  value: vehicleCountryEgypt            (countryEgypt << vehicleCountryShift)
  value: vehicleCountryItaly            (countryItaly << vehicleCountryShift)
  value: vehicleCountryUK               (countryUK << vehicleCountryShift)

# The next six bits of a vehicle type identify its chassis series: 
defs: VehicleSeries
  value: vehicleSeriesMask		0x0001F800
  value: vehicleSeriesShift		11

# The next six bits of a vehicle type identify its model: 
defs: VehicleModel
  value: vehicleModelMask		0x000007E0
  value: vehicleModelShift		5

# The last five bits of a vehicle type identify its function: 
defs: VehicleFunction
  value: vehicleFunctionMask		0x0000001F
  value: vehicleFunctionShift		0
  value: vehicleFunctionMiscellaneous	0		# miscellaneous 


# Functions of air vehicles: 
defs: VehicleFunctionAir
  value: vehicleFunctionAirCombat	1		# air combat 
  value: vehicleFunctionGroundAttack	2		# ground attack 
  value: vehicleFunctionAirRecon	3		# air reconnaissance 
  value: vehicleFunctionBomber		4		# bomber 
  value: vehicleFunctionAirUtility      5               # utility 
  value: vehicleFunctionAirCargo        6               # cargo 
  value: vehicleFunctionAirTanker       7               # tanker 
  value: vehicleFunctionAWACS           8	        # airborne warning and control system
  value: vehicleFunctionElectronicWarfare       9       # electronic warfare
  value: vehicleFunctionMineCtrMes         10           # mine counter measures

# Functions of ground vehicles: 
defs: VehicleFunctionGround
  value: vehicleFunctionAntiAircraft		1	# AA-gun or SAM 
  value: vehicleFunctionPersonnelCarrier	2	# armored PC 
  value: vehicleFunctionCommandPost		3	# command post 
  value: vehicleFunctionHowitzer		4	# howitzer 
  value: vehicleFunctionMortar			5	# mortar 
  value: vehicleFunctionRocketLauncher		6	# mult. launcher 
  value: vehicleFunctionGroundRecon		7	# reconnaissance 
  value: vehicleFunctionRecovery		8	# recovery 
  value: vehicleFunctionSupplyTruck		9	# supply truck 
  value: vehicleFunctionTankDestroyer		10	# tank destroyer 
  value: vehicleFunctionLightTank		11	# tank, light 
  value: vehicleFunctionMainBattleTank		12	# tank, main battle 
  value: vehicleFunctionCombatEngineer    	13	# combat eng 
  value: vehicleFunctionSSMissileLauncher    	14      # Surface to Sur. 
  value: vehicleFunctionGroundUtility       	15      # utility 
  value: vehicleFunctionRadar			16      # Radar
  value: vehicleFunctionAT			17	# Anti-Tank(KE)
  value: vehicleFunctionAirControl              18      # Forward Air Control
  value: vehicleFunctionNBCRecon                19      # Chemical Recon
  value: vehicleFunctionBunker                  20

# Functions of sea vehicles
defs: VehicleFunctionSea 
  value: vehicleFunctionAmmunition 		1
  value: vehicleFunctionAmphibAssault		2
  value: vehicleFunctionAmphibCargo		3
  value: vehicleFunctionAmphibCommand		4
  value: vehicleFunctionAmphibTransport		5
  value: vehicleFunctionAttackSub		6
  value: vehicleFunctionBallisticMissileSub 	7
  value: vehicleFunctionBattleship		8
  value: vehicleFunctionCarrier			9
  value: vehicleFunctionCombatStores		10
  value: vehicleFunctionCruiser			11
  value: vehicleFunctionDestroyerTender		12
  value: vehicleFunctionDestroyer		13
  value: vehicleFunctionDockLanding		14
  value: vehicleFunctionFastCombatSupport	15
  value: vehicleFunctionFleetOiler		16
  value: vehicleFunctionFrigate			17
  value: vehicleFunctionHydrofoil		18
  value: vehicleFunctionMineCM			19
  value: vehicleFunctionOceanMinesweep		20
  value: vehicleFunctionRepair			21
  value: vehicleFunctionReplenishment		22
  value: vehicleFunctionSalvage			23
  value: vehicleFunctionSeaMisc			24
  value: vehicleFunctionSubTender		25
  value: vehicleFunctionTankLanding		26
  value: vehicleFunctionLanding                 27
  value: vehicleFunctionCorvette                28



#
#  LifeForm type scheme.

# The next four bits of a lifeform type identify its class: 
defs: LifeformClass
  value: lifeformClassMask                 0x1e000000
  value: lifeformClassShift                25
  value: lifeformClassPistol               (1 << lifeformClassShift)
  value: lifeformClassRifle                (2 << lifeformClassShift)
  value: lifeformClassSaw                  (3 << lifeformClassShift)
  value: lifeformClassMGun                 (4 << lifeformClassShift)
  value: lifeformClassHvyMGun              (5 << lifeformClassShift)
  value: lifeformClassSmaw                 (6 << lifeformClassShift)
  value: lifeformClassDragon               (7 << lifeformClassShift)
  value: lifeformClassTow                  (8 << lifeformClassShift)




#
#  Munition type scheme.
 
##
# The next four bits of a munition type identify its class: 
defs: MunitionClass
  value: munitionClassMask		0x1E000000
  value: munitionClassShift		25
  value: munitionClassMiscellaneous	(0 << munitionClassShift)   # misc 
  value: munitionClassDetonator		(1 << munitionClassShift)
  value: munitionClassMissile		(2 << munitionClassShift)
  value: munitionClassPOL		(3 << munitionClassShift)
  value: munitionClassProjectile	(4 << munitionClassShift)
  value: munitionClassPropellent	(5 << munitionClassShift)
  value: munitionClassBomb		(6 << munitionClassShift)
  value: munitionClassMine              (7 << munitionClassShift)
  value: munitionClassEO		(8 << munitionClassShift)
  value: munitionClassLaser             (9 << munitionClassShift)

#
#  Ammunition type scheme.
 
##
# The next five bits of an ammunition type identify its caliber: 
defs: AmmunitionCaliber
  value: ammunitionCaliberMask		0x01F00000
  value: ammunitionCaliberShift		20

# The next four bits of an ammunition type identify its subclass: 
defs: AmmunitionSubclass
  value: ammunitionSubclassMask		0x000F0000
  value: ammunitionSubclassShift		16

# Subclasses of detonators: 
defs: AmmunitionSubclass
  value: ammunitionSubclassPercussion	(1 << ammunitionSubclassShift)
  value: ammunitionSubclassProximity	(2 << ammunitionSubclassShift)
  value: ammunitionSubclassTime		(3 << ammunitionSubclassShift)

# Subclasses of projectiles: 
defs: AmmunitionSubclassProjectile
  value: ammunitionSubclassBiological	(1 << ammunitionSubclassShift)	
  value: ammunitionSubclassBomblets	(2 << ammunitionSubclassShift)	
  value: ammunitionSubclassChemical	(3 << ammunitionSubclassShift)	
  value: ammunitionSubclassHE		(4 << ammunitionSubclassShift)	
  value: ammunitionSubclassHEPlastic	(5 << ammunitionSubclassShift)	
  value: ammunitionSubclassHEIncendiary	(6 << ammunitionSubclassShift)	
  value: ammunitionSubclassIllumination	(7 << ammunitionSubclassShift)	
  value: ammunitionSubclassKinetic	(8 << ammunitionSubclassShift)	
  value: ammunitionSubclassNuclear	(9 << ammunitionSubclassShift)	
  value: ammunitionSubclassPractice	(10 << ammunitionSubclassShift)
  value: ammunitionSubclassShapedCharge	(11 << ammunitionSubclassShift)
  value: ammunitionSubclassSmoke	(12 << ammunitionSubclassShift)
  value: ammunitionSubclassScatterMines (13 << ammunitionSubclassShift)

# Subclasses of propellents: 
defs: AmmunitionSubclassPropellent
  value: ammunitionSubclassBagged	(1 << ammunitionSubclassShift)
  value: ammunitionSubclassCanistered	(2 << ammunitionSubclassShift)
  value: ammunitionSubclassLiquid	(3 << ammunitionSubclassShift)

# The next six bits of an ammunition type identify its country of origin: 
defs: AmmunitionCountry
  value: ammunitionCountryMask	 0x0000FC00
  value: ammunitionCountryShift	 10
  value: ammunitionCountryOther	  (countryOther << ammunitionCountryShift)
  value: ammunitionCountryUS	  (countryUS << ammunitionCountryShift)
  value: ammunitionCountryUSSR	  (countryUSSR << ammunitionCountryShift)
  value: ammunitionCountryGermany (countryGermany << ammunitionCountryShift)
  value: ammunitionCountryFrance  (countryFrance << ammunitionCountryShift)
  value: ammunitionCountryYugoslavia (countryYugoslavia << ammunitionCountryShift)
  value: ammunitionCountryEgypt   (countryEgypt << ammunitionCountryShift)
  value: ammunitionCountryItaly   (countryItaly << ammunitionCountryShift)
  value: ammunitionCountryUK      (countryUK << ammunitionCountryShift)

# The next five bits of an ammunition type identify its manufacture series: 
defs: AmmunitionSeries
  value: ammunitionSeriesMask		0x000003E0
  value: ammunitionSeriesShift		5

# The last five bits of an ammunition type identify its model: 
defs: AmmunitionModel
  value: ammunitionModelMask		0x0000001F
  value: ammunitionModelShift		0

#
#  Missile type scheme.
 
##
# The next five bits of a missile type identify its intended target 
defs: MissileTarget
  value: missileTargetMask		0x01F00000
  value: missileTargetShift		20
  value: missileTargetMiscellaneous (0 << missileTargetShift) # misc 
  value: missileTargetAircraft	(1 << missileTargetShift) # anti-aircraft 
  value: missileTargetArmor	(2 << missileTargetShift) # anti-armor 
  value: missileTargetMissile	(3 << missileTargetShift) # anti-missile 
  value: missileTargetRadar	(4 << missileTargetShift) # anti-radar 
  value: missileTargetSatellite	(5 << missileTargetShift) # anti-satellite 
  value: missileTargetShip	(6 << missileTargetShift) # anti-ship 
  value: missileTargetSubmarine	(7 << missileTargetShift) # anti-submarine 
  value: missileTargetSurface    (8 << missileTargetShift) # anti-surface 

# The next four bits of a missile type identify its warhead: 
defs: MissileWarhead
  value: missileWarheadMask		0x000F0000
  value: missileWarheadShift		16
  value: missileWarheadMiscellaneous	(0 << missileWarheadShift)	
  value: missileWarheadBiological	(1 << missileWarheadShift)	
  value: missileWarheadBomblets		(2 << missileWarheadShift)	
  value: missileWarheadChemical		(3 << missileWarheadShift)	
  value: missileWarheadHE		(4 << missileWarheadShift)	
  value: missileWarheadHEPlastic	(5 << missileWarheadShift)	
  value: missileWarheadKinetic		(8 << missileWarheadShift)	
  value: missileWarheadNuclear		(9 << missileWarheadShift)	
  value: missileWarheadShapedCharge	(11 << missileWarheadShift)

# The remaining fields of the missile type code are defined identically to
#   those of the ammunition types.  Use ammunitionCountryMask,
#   ammunitionSeriesMask, and ammunitionModelMask for these fields. 
##

#
#  Bomb type scheme.
##

# The next five bits of a bomb type identify its weight class: 
defs: BombWeightClass
  value: bombWeightClassMask		0x01F00000
  value: bombWeightClassShift		20

# The next four bits of a bomb type identify its subclass: 
defs: BombSubclass
  value: bombSubclassMask		0x000F0000
  value: bombSubclassShift		16

# Subclasses of bombs: 
  value: bombSubclassGeneralPurpose	(1 << bombSubclassShift)
  value: bombSubclassChemical           (2 << bombSubclassShift)
# The first bit of the field "subclass" is the "Guided" flag
  value: bombSubclassGuided             (8 << bombSubclassShift)

# mine class 
##
# The next five bits of a mine type identify its target: 
defs: MineTarget
  value: mineTargetMask		0x01F00000
  value: mineTargetShift	20
  value: mineTargetTank         (1 << 20)
  value: mineTargetPerson       (2 << 20)
  value: mineTargetShip         (3 << 20)
  value: mineTargetSub          (4 << 20)

# The next four bits of a mine type identify its environment: 
defs: MineEnvironment
  value: mineEnvironmentMask	0x000F0000
  value: mineEnvironmentShift	16

# Environments of mines: 
  value: mineEnvironmentLand	(1 << 16)	#  
  value: mineEnvironmentWater	(2 << 16)	#  



# The remaining fields of the bomb type code are defined identically to
# those of the ammunition types.  Use ammunitionCountryMask,
# ammunitionSeriesMask, and ammunitionModelMask for these fields. 
##

#   Structure scheme
 
# The next three bits of a structure type identify its class: 
defs: StructureClass
  value: structureClassMask            0x1C000000
  value: structureClassShift           26
  value: structureClassOther           (0 << structureClassShift)
  value: structureClassPallet          (1 << structureClassShift)


# The next four bits of an pallet type identify its class: 
defs: PalletClass
  value: palletClassMask       0x03C00000
  value: palletClassShift      22
  value: palletClassOther      (0 << palletClassShift)
  value: palletClassI          (1 << palletClassShift)
  value: palletClassII         (2 << palletClassShift)
  value: palletClassIII        (3 << palletClassShift)
  value: palletClassIV         (4 << palletClassShift)
  value: palletClassV          (5 << palletClassShift)
  value: palletClassVI         (6 << palletClassShift)
  value: palletClassVII        (7 << palletClassShift)
  value: palletClassVIII       (8 << palletClassShift)
  value: palletClassIX         (9 << palletClassShift)
  value: palletClassX          (10 << palletClassShift)


# The next six bits of a pallet type identify its country of origin: 
defs: PalletCountry
  value: palletCountryMask       0x3f0000
  value: palletCountryShift      16
  value: palletCountryOther      (countryOther << palletCountryShift)
  value: palletCountryUS         (countryUS << palletCountryShift)
  value: palletCountryUSSR       (countryUSSR << palletCountryShift)
  value: palletCountryGermany    (countryGermany << palletCountryShift)
  value: palletCountryFrance     (countryFrance << palletCountryShift)
  value: palletCountryYugoslavia (countryYugoslavia << palletCountryShift)
  value: palletCountryEgypt      (countryEgypt << palletCountryShift)
  value: palletCountryItaly      (countryItaly << palletCountryShift)
  value: palletCountryUK         (countryUK << vehicleCountryShift)


#   Echelon scheme
 
# The next three bits of a echelon type identify its environment: 
defs: EchelonEnvironment
  value: echelonEnvironmentMask		0x1C000000
  value: echelonEnvironmentShift	26
  value: echelonEnvironmentAir		(1 << echelonEnvironmentShift)
  value: echelonEnvironmentGround	(2 << echelonEnvironmentShift)
  value: echelonEnvironmentSpace	(3 << echelonEnvironmentShift)
  value: echelonEnvironmentWater	(4 << echelonEnvironmentShift)

# The next three bits of an echelon type identify its class: 
defs: EchelonClass
  value: echelonClassMask		0x03800000
  value: echelonClassShift		23
  value: echelonClassOther		(0 << echelonClassShift)

# Classes of air echelons: 
defs: EchelonClassAir
  value: echelonClassFixedWing		(1 << echelonClassShift)	
  value: echelonClassLighterThanAir	(2 << echelonClassShift)	
  value: echelonClassRotaryWing		(3 << echelonClassShift)	

# Classes of ground echelons: 
defs: EchelonClassGround
  value: echelonClassSPArmoredTracked	(1 << echelonClassShift)	
  value: echelonClassSPArmoredWheeled	(2 << echelonClassShift)	
  value: echelonClassSPUnarmoredTracked	(3 << echelonClassShift)	
  value: echelonClassSPUnarmoredWheeled	(4 << echelonClassShift) 
  value: echelonClassTowed		(5 << echelonClassShift) 

# The next six bits of a echelon type identify its country of origin: 
defs: EchelonCountry
  value: echelonCountryMask		0x007E0000
  value: echelonCountryShift		17
  value: echelonCountryOther		(countryOther << echelonCountryShift)
  value: echelonCountryUS		(countryUS << echelonCountryShift)
  value: echelonCountryUSSR		(countryUSSR << echelonCountryShift)
  value: echelonCountryGermany          (countryGermany << echelonCountryShift)
  value: echelonCountryFrance           (countryFrance << echelonCountryShift)
  value: echelonCountryYugoslavia       (countryYugoslavia << echelonCountryShift)
  value: echelonCountryEgypt            (countryEgypt << echelonCountryShift)
  value: echelonCountryItaly            (countryItaly << echelonCountryShift)
  value: echelonCountryUK               (countryUK << echelonCountryShift)

# The next five bits of an echelon type identify the type of echelon: 
defs: EchelonKind
  value: echelonKindMask			0x0001F800
  value: echelonKindShift		11
  value: echelonKindOther		(0 << echelonKindShift)

#
# There is a convention maintained for people who have to deal with
#  veh_map  files that the air, ground and sea kinds match up
#  where the unit size is the "same".
##

# The kinds of land echelons: 
defs: EchelonKindGround
  value: echelonKindSingle       	(1 << echelonKindShift)
  value: echelonKindSquad        	(2 << echelonKindShift)
  value: echelonKindSection      	(3 << echelonKindShift)

  value: echelonKindPlatoon      	(5 << echelonKindShift)
  value: echelonKindBattery		(6 << echelonKindShift)
  value: echelonKindCompany      	(7 << echelonKindShift)
  value: echelonKindBattalion    	(8 << echelonKindShift)
  value: echelonKindRegiment     	(9 << echelonKindShift)
  value: echelonKindBrigade      	(10 << echelonKindShift)
  value: echelonKindDivision     	(11 << echelonKindShift)
  value: echelonKindCorps        	(12 << echelonKindShift)
  value: echelonKindNewArmyCorps        (13 << echelonKindShift)
  value: echelonKindArmy         	(14 << echelonKindShift)
  value: echelonKindArmyGroup    	(15 << echelonKindShift)
  value: echelonKindFront	    	(16 << echelonKindShift)
  value: echelonKindBattalionHQ    	(17 << echelonKindShift)
  value: echelonKindRegimentHQ     	(18 << echelonKindShift)
  value: echelonKindBrigadeHQ      	(19 << echelonKindShift)
  value: echelonKindDivisionHQ     	(20 << echelonKindShift)
  value: echelonKindCorpsHQ        	(21 << echelonKindShift)
  value: echelonKindNewArmyCorpsHQ      (22 << echelonKindShift)
  value: echelonKindArmyHQ         	(23 << echelonKindShift)
  value: echelonKindArmyGroupHQ    	(24 << echelonKindShift)
  value: echelonKindFrontHQ	    	(25 << echelonKindShift)
  value: echelonKindSquadron            (26 << echelonKindShift)
  value: echelonKindSquadronHQ          (27 << echelonKindShift)
  value: echelonKindTeam                (28 << echelonKindShift)
  value: echelonKindTroop               (29 << echelonKindShift)
  value: echelonKindTrain               (30 << echelonKindShift)

# The kinds of air echelons: 
defs: EchelonKindAir
  value: echelonKindSortie		(1 << echelonKindShift)
  value: echelonKindFlightOfTwo		(2 << echelonKindShift)
  value: echelonKindFlightOfThree	(3 << echelonKindShift)
  value: echelonKindFlightOfFour	(4 << echelonKindShift)
  value: echelonKindAirPlatoon		(5 << echelonKindShift)

  value: echelonKindAirCompany		(7 << echelonKindShift)
  value: echelonKindAirBattalion    	(8 << echelonKindShift)
  value: echelonKindAirRegiment     	(9 << echelonKindShift)
  value: echelonKindAirBrigade      	(10 << echelonKindShift)
  value: echelonKindAirDivision     	(11 << echelonKindShift)
  value: echelonKindAirCorps        	(12 << echelonKindShift)
  value: echelonKindAirNewArmyCorps     (13 << echelonKindShift)
  value: echelonKindAirArmy         	(14 << echelonKindShift)
  value: echelonKindAirArmyGroup    	(15 << echelonKindShift)
  value: echelonKindAirFront	    	(16 << echelonKindShift)
  value: echelonKindAirBattalionHQ    	(17 << echelonKindShift)
  value: echelonKindAirRegimentHQ     	(18 << echelonKindShift)
  value: echelonKindAirBrigadeHQ      	(19 << echelonKindShift)
  value: echelonKindAirDivisionHQ     	(20 << echelonKindShift)
  value: echelonKindAirCorpsHQ        	(21 << echelonKindShift)

  value: echelonKindAirSquadron         (26 << echelonKindShift)
  value: echelonKindAirSquadronHQ       (27 << echelonKindShift)

# The last five bits of a echelon type identify its function: 
defs: EchelonFunction
  value: echelonFunctionMask		0x0000001F
  value: echelonFunctionShift		0
  value: echelonFunctionMiscellaneous	0		# miscellaneous 

# Functions of air echelons: 
defs: EchelonFunctionAir
  value: echelonFunctionAirCombat	1		# air combat 
  value: echelonFunctionGroundAttack	2		# ground attack 
  value: echelonFunctionAirRecon	3		# reconnaissance 
  value: echelonFunctionAirInfantry      4
  value: echelonFunctionAirAssaultInfantry 5
  value: echelonFunctionAirCavalry       6
  value: echelonFunctionCombatAviation   7
  value: echelonFunctionAirToAirAttack   8
  value: echelonFunctionAirAttack	 9
  value: echelonFunctionAirAndGround	 10
  value: echelonFunctionBomber		 11

# Functions of ground echelons: 
defs: EchelonFunctionGround
  value: echelonFunctionAntiAircraft	1		# AA-gun or SAM 
  value: echelonFunctionPersonnelCarrier 2		# armored PC 
  value: echelonFunctionCommandPost	3		# command post 
  value: echelonFunctionHowitzer	4		# howitzer 
  value: echelonFunctionMortar		5		# mortar 
  value: echelonFunctionRocketLauncher	6		# mult. launcher 
  value: echelonFunctionGroundRecon	7		# reconnaissance 
  value: echelonFunctionRecovery	8		# recovery 
  value: echelonFunctionSupplyTruck	9		# supply truck 
  value: echelonFunctionTankDestroyer	10		# tank destroyer 
  value: echelonFunctionLightTank	11		# tank, light 
  value: echelonFunctionMainBattleTank	12		# tank, main battle 
  value: echelonFunctionInfantry         13
  value: echelonFunctionArmoredCavalry   14
  value: echelonFunctionCombatEngineer   15		# combat eng 
  value: echelonFunctionCombatServiceSupport 16
  value: echelonFunctionSSMissileLauncher 17            # surf-surf launcher
  value: echelonFunctionTrafficVehicles   18            # assorted traffic vehs

# Functions of sea echelons 
defs: EchelonFunctionSea
  value: echelonFunctionAmmunition 		1
  value: echelonFunctionAmphibAssault		2
  value: echelonFunctionAmphibCargo		3
  value: echelonFunctionAmphibCommand		4
  value: echelonFunctionAmphibTransport		5
  value: echelonFunctionAttackSub		6
  value: echelonFunctionBallisticMissileSub 	7
  value: echelonFunctionBattleship		8
  value: echelonFunctionCarrier			9
  value: echelonFunctionCombatStores		10
  value: echelonFunctionCruiser			11
  value: echelonFunctionDestroyerTender		12
  value: echelonFunctionDestroyer		13
  value: echelonFunctionDockLanding		14
  value: echelonFunctionFastCombatSupport	15
  value: echelonFunctionFleetOiler		16
  value: echelonFunctionFrigate			17
  value: echelonFunctionHydrofoil		18
  value: echelonFunctionMineCM			19
  value: echelonFunctionOceanMinesweep		20
  value: echelonFunctionRepair			21
  value: echelonFunctionReplenishment		22
  value: echelonFunctionSalvage			23
  value: echelonFunctionSeaMisc			24
  value: echelonFunctionSubTender		25
  value: echelonFunctionTankLanding		26
  value: echelonFunctionLanding                 27

#
# Environmental type scheme

##
# The next three bits define the category of environmental information
defs: EnvironmentalCategory
  value: environmentalCategoryMask		0x1C000000
  value: environmentalCategoryShift		26


  value: environmentalCategoryEmbeddedProcess	(1 << environmentalCategoryShift)
  value: environmentalCategoryFeatureModel	(2 << environmentalCategoryShift)
  value: environmentalCategoryOther		(3 << environmentalCategoryShift)


# The next eight bits define the environmental phenomena
defs: EnvironmentalPhenomena
  value: environmentalPhenomenaMask		0x03FC0000
  value: environmentalPhenomenaShift		18
  value: environmentalPhenomenaSmoke		(1 << environmentalPhenomenaShift)
  value: environmentalPhenomenaHaze		(2 << environmentalPhenomenaShift)
  value: environmentalPhenomenaSound		(3 << environmentalPhenomenaShift)
  value: environmentalPhenomenaFlame		(4 << environmentalPhenomenaShift)
  value: environmentalPhenomenaLight		(5 << environmentalPhenomenaShift)
  value: environmentalPhenomenaEphemeris	(6 << environmentalPhenomenaShift)
  value: environmentalPhenomenaWeather		(7 << environmentalPhenomenaShift)
  value: environmentalPhenomenaFlare		(8 << environmentalPhenomenaShift)
  value: environmentalPhenomenaWater            (9 << environmentalPhenomenaShift)

# The next six bits define the type of the phenomena
defs: EnvironmentalType
  value: environmentalTypeMask			0x0003F000
  value: environmentalTypeShift			12

# Smoke types
defs: EnvironmentalTypeSmoke
  value: environmentalPhenomenaSmokeOther	(0 << environmentalTypeShift)
#   White Phosphorous
  value: environmentalPhenomenaSmokeWP		(1 << environmentalTypeShift)
#   Plasticized White Phosphorous
  value: environmentalPhenomenaSmokePWP		(2 << environmentalTypeShift)
#   Red Phosphorous
  value: environmentalPhenomenaSmokeRP		(3 << environmentalTypeShift)
#   Hexachloroethane
  value: environmentalPhenomenaSmokeHC		(4 << environmentalTypeShift)
#   Fog Oil
  value: environmentalPhenomenaSmokeFO		(5 << environmentalTypeShift)
#   Kerosene/Fog Oil
  value: environmentalPhenomenaSmokeKFO		(6 << environmentalTypeShift)
#   Infra Red
  value: environmentalPhenomenaSmokeIR		(7 << environmentalTypeShift)
#   Diesel Fuel
  value: environmentalPhenomenaSmokeDF		(8 << environmentalTypeShift)
#   Diesel Fuel/Rubber
  value: environmentalPhenomenaSmokeDFR		(9 << environmentalTypeShift)
#   High Explosive Debris (Dust)
  value: environmentalPhenomenaSmokeHE		(10 << environmentalTypeShift)
#   High Explosive Debris (Carbon)
  value: environmentalPhenomenaSmokeC		(11 << environmentalTypeShift)
#   Polyethylene Glycol
  value: environmentalPhenomenaSmokePEG		(12 << environmentalTypeShift)
#   Anthracene
  value: environmentalPhenomenaSmokeANTH	(13 << environmentalTypeShift)
#   Chlorosulfonic Acid
  value: environmentalPhenomenaSmokeFS		(14 << environmentalTypeShift)
#   Titanium Tetrachloride
  value: environmentalPhenomenaSmokeFM		(15 << environmentalTypeShift)

#
defs: EnvironmentalTypeHaze
  value: environmentalPhenomenaHazeDust		(0 << environmentalTypeShift)

#
defs: EnvironmentalTypeEphemeris
  value: environmentalPhenomenaEphemerisLocal	(0 << environmentalTypeShift)

#
defs: EnvironmentalTypeWeather
  value: environmentalPhenomenaWeatherParameterized		(0 << environmentalTypeShift)

#
defs: EnvironmentalTypeFlare
  value: environmentalPhenomenaFlareIllum	(0 << environmentalTypeShift)
  value: environmentalPhenomenaFlareSigSolGrn	(1 << environmentalTypeShift)
  value: environmentalPhenomenaFlareSigSolRed	(2 << environmentalTypeShift)
  value: environmentalPhenomenaFlareSigSolWht	(3 << environmentalTypeShift)
  value: environmentalPhenomenaFlareSigStarGrn	(4 << environmentalTypeShift)
  value: environmentalPhenomenaFlareSigStarRed	(5 << environmentalTypeShift)
  value: environmentalPhenomenaFlareSigStarWht	(6 << environmentalTypeShift)

defs: EnvironmentalTypeWater
  value: environmentalPhenomenaWaterOther       (0 << environmentalTypeShift)
  value: environmentalPhenomenaWaterSpray       (1 << environmentalTypeShift)


# The last twelve bits define the specific type of phenomena
defs: EnvironmentalInstance
  value: environmentalInstanceMask		0x00000FFF
  value: environmentalInstanceShift		0

## Unit object scheme
 
# The next three bits of a unit type identify its environment: 
defs: UnitEnvironment
  value: unitEnvironmentMask		0x1C000000
  value: unitEnvironmentShift		26
  value: unitEnvironmentAir		(1 << unitEnvironmentShift)
  value: unitEnvironmentGround		(2 << unitEnvironmentShift)
  value: unitEnvironmentSpace		(3 << unitEnvironmentShift)
  value: unitEnvironmentWater		(4 << unitEnvironmentShift)

# The next six bits of a unit type identify its country of origin: 
defs: UnitCountry
  value: unitCountryMask		0x03F00000
  value: unitCountryShift		20
  value: unitCountryOther		(countryOther   << unitCountryShift)
  value: unitCountryUS			(countryUS      << unitCountryShift)
  value: unitCountryUSSR		(countryUSSR    << unitCountryShift)
  value: unitCountryGermany		(countryGermany << unitCountryShift)
  value: unitCountryFrance  	        (countryFrance << unitCountryShift)
  value: unitCountryYugoslavia  	(countryYugoslavia << unitCountryShift)
  value: unitCountryEgypt            	(countryEgypt << unitCountryShift)
  value: unitCountryItaly            	(countryItaly << unitCountryShift)
  value: unitCountryUK               	(countryUK << unitCountryShift)

# The next four bits of a unit type identify its size:
defs: UnitSize
  value: unitSizeMask			0x000F0000
  value: unitSizeShift			16
  value: unitSizeSquad			(0  << unitSizeShift)
  value: unitSizeSection		(1  << unitSizeShift)
  value: unitSizePlatoon		(2  << unitSizeShift)
  value: unitSizeCompany		(3  << unitSizeShift)
  value: unitSizeBattalion		(4  << unitSizeShift)
  value: unitSizeRegiment		(5  << unitSizeShift)
  value: unitSizeBrigade		(6  << unitSizeShift)
  value: unitSizeDivision		(7  << unitSizeShift)
  value: unitSizeCorps			(8  << unitSizeShift)
  value: unitSizeArmy			(9  << unitSizeShift)
  value: unitSizeArmyGroup		(10 << unitSizeShift)

# The next bit of a unit type identifies it as a headquarters
defs: UnitHQ
  value: unitHQMask			0x00008000
  value: unitHQShift			15
  value: unitHQ				(1 << unitHQShift)

# The next bit of a unit type identifies it as being task organized
defs: UnitTaskOrganized
  value: unitTaskOrganizedMask		0x00004000
  value: unitTaskOrganizedShift		14
  value: unitTaskOrganized		(1 << unitTaskOrganizedShift)

# The next two bits of a unit type identifies as being light or heavy
defs: UnitModifier
  value: unitModifierMask		0x00003000
  value: unitModifierShift		12
  value: unitModifierHeavy		(1 << unitModifierShift)
  value: unitModifierLight		(2 << unitModifierShift)

# The next six bits of a unit type identifies its role
defs: UnitRole
  value: unitRoleMask			0x00000FC0
  value: unitRoleShift			6
# The following encoding is temporary
  value: unitRoleArmor			(1 << unitRoleShift)
  value: unitRoleAPC			(2 << unitRoleShift)
  value: unitRoleMixedAPCDI		(3 << unitRoleShift)
  value: unitRoleInfantry		(4 << unitRoleShift)
  value: unitRoleScout                  (5 << unitRoleShift)
  value: unitRoleAirDefense             (6 << unitRoleShift)
  value: unitRoleFWA			(7 << unitRoleShift)
  value: unitRoleRWA			(8 << unitRoleShift)
  value: unitRoleArtillery		(9 << unitRoleShift)
  value: unitRoleRWAFARRP		(10 << unitRoleShift)
  value: unitRoleAT			(11 << unitRoleShift)
  value: unitRoleMaintenance		(12 << unitRoleShift)
  value: unitRoleSPArty		        (13 << unitRoleShift)
  value: unitRoleDigitalArty		(14 << unitRoleShift)
  value: unitRoleSupply		        (15 << unitRoleShift)
  value: unitRoleChemical               (16 << unitRoleShift)
  value: unitRoleNBCRecon               (17 << unitRoleShift)
  value: unitRoleEngineer               (18 << unitRoleShift)
  value: unitRoleCavalry                (19 << unitRoleShift)
  value: unitRoleMP                     (20 << unitRoleShift)
  value: unitRoleAttackRWA              (21 << unitRoleShift)
  value: unitRoleMedical                (22 << unitRoleShift)
  value: unitRoleTransport              (23 << unitRoleShift)
  value: unitRoleSignal                 (24 << unitRoleShift)
  value: unitRoleArmoredCavalry         (25 << unitRoleShift)
  value: unitRoleMechEngineer           (26 << unitRoleShift)
  value: unitRoleC2                     (27 << unitRoleShift)
  value: unitRoleMINE                   (28 << unitRoleShift)
  value: unitRoleAmphibious             (29 << unitRoleShift)

defs: UnitDepth
# ModSAF has the problem that it uses 'unitSize' when echelon
# depth should be used
  value: unitDepthMask                     0x20
  value: unitDepthShift                    5
  value: unitDepthShallow                  (0 << unitDepthShift)
  value: unitDepthDeep                     (1 << unitDepthShift)


# The next six bits of a unit type are for "specialized" variants
defs: UnitSpecial
  value: unitSpecialMask		0x1f
  value: unitSpecialShift		0
  value: unitSpecialRifle               (0 << unitSpecialShift)
  value: unitSpecialAssault             (4 << unitSpecialShift)
  value: unitSpecial240MG               (5 << unitSpecialShift)
  value: unitSpecialDragon              (6 << unitSpecialShift)
  value: unitSpecialHeavyMG             (7 << unitSpecialShift)
  value: unitSpecialATTOW               (8 << unitSpecialShift)
  value: unitSpecial60mmMortar          (9 << unitSpecialShift)
  value: unitSpecial81mmMortar          (10 << unitSpecialShift)
  value: unitSpecialWeapons             (11 << unitSpecialShift)
