
/*
 * FILE:  p_assoc.h 
 *
 * Created on Wed Apr 17 10:52:50 1996 
 * Compiled by DRN compiler, version 6.2.d
 * 
 */

#ifndef _p_assoc_included
#define _p_assoc_included

 /* File:     pro_assoc.drn */
 /* Contents: The association protocol data units */
 /* System:   simnet development. */
 /* Created:  10-Oct-1989 */
 /* Author:   apope */
 /* Remarks: */
 /* History: */
 /*    13 Dec 89 kanarick	added apduDataLengthMultiplier */
 /*    21 Dec 89 kanarick	changed elements in data array */
 /* $RCSfile: p_assoc.h,v $ */
 /* $Revision: 1.1.1.1 $ */
 /* $State: Exp $ */
 /* COPYRIGHT 1989 BBN Systems and Technologies Corporation */
 /* 10 Moulton Street */
 /* Cambridge, Ma. 02138 */
 /* 617-873-3000 */
#include <stdtypes.h>
#include <address.h> 

/*
 * Versions of the association protocol:
 */

#define protocolVersionAug89    1    
#define protocolVersionJan90    2    

typedef unsigned         AssociationProtocolVersion; 

#define protocolVersionCurrent  2

/*
 * Various kinds of Association PDUs:
 */

#define datagramAPDUKind        1    
#define requestAPDUKind         2    
#define replyAPDUKind           3    
#define paddingAPDUKind         4    

typedef unsigned         AssociationPDUKind; 


/*
 * Representation of various Association PDU fields:
 */

typedef uint8    AssociationUserProtocol; 

typedef uint8    MulticastGroupID; 

typedef uint16   TransactionIdentifier; 


/*
 * The amount by which to multiply the dataLength field
 * of the AssociationPDU value to obtain the length of the data field
 * in octets.
 */

#define apduDataLengthMultiplier 8 /* The data elements in the data arrays */
typedef uint8    AssociationDataUnit[8]; 


/*
 * Definition of an Association Protocol Data Unit:
 */

typedef struct {
    unsigned                      version : 4; /* AssociationProtocolVersion */
    unsigned                      kind    : 4; /* AssociationPDUKind */
    uint8                         dataLength; 
    MulticastGroupID              group; 
    AssociationUserProtocol       userProtocol; 
    SimulationAddress             originator; 
    union {
        struct {
            AssociationDataUnit   data[1]; 
        } datagram;
        struct {
            SimulationAddress     respondent; 
            TransactionIdentifier transactionID; 
            uint16                _unused_1;   /* padding */
            AssociationDataUnit   data[1]; 
        } request;
        struct {
            SimulationAddress     respondent; 
            TransactionIdentifier transactionID; 
            uint16                _unused_2;   /* padding */
            AssociationDataUnit   data[1]; 
        } response;
        struct {
            AssociationDataUnit   data[1]; 
        } padding;
    } variant;                          
} AssociationPDU; 



#endif
