
/*
 * FILE:  p_dis203eh.h 
 *
 * Created on Wed Apr 17 10:52:43 1996 
 * Compiled by DRN compiler, version 6.2.d
 * 
 */

#ifndef _p_dis203eh_included
#define _p_dis203eh_included



/*
 * File:     p_dis203eh.drn
 * Contents: 
 * System:   Experimental DIS Entity Handover Protocol
 * Created:  15-Aug-94
 * Author:   Hiroshi Kawai
 *
 * Remarks:
 *
 * History:
 * 
 * $RCSfile: p_dis203eh.h,v $
 * $Revision: 1.1.1.1 $
 * $State: Exp $
 *
 * COPYRIGHT 1993 Loral Advanced Distributed Simulation
 * 50 Moulton Street
 * Cambridge, Ma. 02138
 * 617-873-3600
 *
 */

#include <stdtypes.h>
#include <p_dis203.h> 
#include <dis203_types.h> 
#include <dis203eh_types.h> 
#include <dis203eh_values.h> 

/*
 * Please note!  All hard-coded values that are found in the appendices
 * of the DIS document "Military Standard (Final Draft) Protocol Data
 * Units for Entity Information and Entity Interaction in a Distributed
 * Interactive Simulation" are defined in "dis203_values.drn".
 *
 * Also note that commonly used types and headers which are part of the
 * official DIS standard are defined in "dis203_types.drn".
 *
 * Transfer Control Request PDU.
 *
 */

typedef struct {
    DIS203_PDU_HEADER_RECORD pdu_header; 
     /*  entity_id			DIS203_ENTITY_ID_RECORD, */

    DIS203_ENTITY_ID_RECORD  requesting_entity_id; 
     /*  requesting_application	DIS203_SIMULATION_ADDRESS_RECORD */

    DIS203_ENTITY_ID_RECORD  providing_entity_id; 
} DIS203EH_TRANSFER_CONTROL_REQUEST_PDU; 


/*
 * Transfer Control PDU.
 *
 */

typedef struct {
    DIS203_PDU_HEADER_RECORD                      pdu_header; 
    DIS203_ENTITY_ID_RECORD                       handover_entity_id; 
     /*  requesting_application	DIS203_SIMULATION_ADDRESS_RECORD, */

    DIS203_ENTITY_ID_RECORD                       requesting_entity_id; 
    DIS203_FORCE_ID_TYPE                          force_id; 
    DIS203_NUMBER_OF_ARTICULATION_PARAMETERS_TYPE number_of_articulation_parameters; 
    uint16                                   _unused_52;  /* padding */
    DIS203_ENTITY_TYPE_RECORD                     entity_type; 
    DIS203_ENTITY_TYPE_RECORD                     alternative_entity_type; 
    DIS203_LINEAR_VELOCITY_VECTOR_RECORD          entity_linear_velocity; 
    DIS203_WORLD_COORDINATES_RECORD               entity_location; 
    DIS203_EULER_ANGLES_RECORD                    entity_orientation; 
    DIS203_ENTITY_APPEARANCE_TYPE                 entity_appearance; 
    DIS203_DEAD_RECKONING_PARAMETERS_RECORD       dead_reckoning_parameters; 
    DIS203_ENTITY_MARKING_RECORD                  entity_marking; 
    DIS203_ENTITY_CAPABILITIES_RECORD             capabilities; 
    DIS203_ARTICULATION_PARAMETER_RECORD          articulation_parameters[1]; 
} DIS203EH_TRANSFER_CONTROL_PDU; 


/*
 * Transfer Control Acknowledge PDU.
 *
 */

typedef struct {
    DIS203_PDU_HEADER_RECORD pdu_header; 
     /*  old_entity_id		DIS203_ENTITY_ID_RECORD, */

    DIS203_ENTITY_ID_RECORD  handover_entity_id; 
     /*  new_entity_id		DIS203_ENTITY_ID_RECORD */

    DIS203_ENTITY_ID_RECORD  providing_entity_id; 
} DIS203EH_TRANSFER_CONTROL_ACKNOWLEDGE_PDU; 



#endif
