#
# File:     p_safmodels.cdf
# Contents: 
# System:   simnet development.
# Created:  5-Jun-1992
# Author:   jesmith
#
# Remarks:
#
# History:
#    

# $RCSfile: p_safmodels.cdf,v $
# $Revision: 1.1.1.1 $
# $State: Exp $

# COPYRIGHT 1990 BBN Systems and Technologies Corporation
# 10 Moulton Street
# Cambridge, Ma. 02138
# 617-873-3000
#

namespace_def: SM

##
# Each SAF model is made up of three parts.  The high order 20 bits
# indicate the class of the model, the next 7 bits indicate the
# instance of that class, and the low order 5 bits indicate the
# instantiation of that instance.  Many models support only one
# instantiation.

     value: classMask         0xFFFFF000
     value: classShift        12
     value: instanceMask      0x00000FE0
     value: instanceShift     5
     value: instantiationMask 0x0000001F

##
# Classes.

     value: classArchitectural (0 << SM_classShift)
     value: classHull          (1 << SM_classShift)
     value: classTurret        (2 << SM_classShift)
     value: classGun           (3 << SM_classShift)
     value: classSensor        (4 << SM_classShift)
     value: classTask          (5 << SM_classShift)
     value: classDeployable    (6 << SM_classShift)
     value: classComm          (7 << SM_classShift)
     value: classESensor       (8 << SM_classShift)
     value: classAirframe      (9 << SM_classShift)
     value: classDsgDetector   (10 << SM_classShift)
     value: classMineDetector  (11 << SM_classShift)

##
# Model Numbers.  Add one for each SAF vehicle sub-class

# Architectural sub-classes
     value: Entity	    (SM_classArchitectural | (0 << SM_instanceShift))
     value: PBTab	    (SM_classArchitectural | (1 << SM_instanceShift))
     value: Designator  (SM_classArchitectural | (2 << SM_instanceShift))
     value: Components  (SM_classArchitectural | (3 << SM_instanceShift))
     value: Supplies    (SM_classArchitectural | (4 << SM_instanceShift))
     value: Preview     (SM_classArchitectural | (5 << SM_instanceShift))
     value: Collision   (SM_classArchitectural | (6 << SM_instanceShift))
     value: TaskManager (SM_classArchitectural | (7 << SM_instanceShift))
     value: DFDamage    (SM_classArchitectural | (8 << SM_instanceShift))
     value: IFDamage    (SM_classArchitectural | (9 << SM_instanceShift))
     value: PVD         (SM_classArchitectural | (10 << SM_instanceShift))
     value: Detonation  (SM_classArchitectural | (11 << SM_instanceShift))
     value: FireControl (SM_classArchitectural | (12 << SM_instanceShift))
     value: Stealth     (SM_classArchitectural | (13 << SM_instanceShift))
     value: SAFSOAR     (SM_classArchitectural | (14 << SM_instanceShift))
     value: LocalMap    (SM_classArchitectural | (15 << SM_instanceShift))
     value: RouteMap    (SM_classArchitectural | (16 << SM_instanceShift))
     value: TaskPriority (SM_classArchitectural | (17 << SM_instanceShift))
     value: EnvEntity    (SM_classArchitectural | (18 << SM_instanceShift))
     value: SAFSAM       (SM_classArchitectural | (19 << SM_instanceShift))
     value: SmokeModel   (SM_classArchitectural | (20 << SM_instanceShift))
     value: SRDetect     (SM_classArchitectural | (21 << SM_instanceShift))
     value: CombatServiceSupport (SM_classArchitectural | (22 << SM_instanceShift))
     value: PolyTask     (SM_classArchitectural | (23 << SM_instanceShift))
     value: CollPred	(SM_classArchitectural | (25 << SM_instanceShift))
     value: CvccIvis	(SM_classArchitectural | (26 << SM_instanceShift))
     value: EH	        (SM_classArchitectural | (27 << SM_instanceShift))
     value: RadarWarnReceiver   (SM_classArchitectural | (28 << SM_instanceShift))
     value: MarkerEntity (SM_classArchitectural | (30 << SM_instanceShift))
     value: SignalDetect (SM_classArchitectural | (31 << SM_instanceShift))
     value: Transmitter  (SM_classArchitectural | (32 << SM_instanceShift))
     value: StealthSim   (SM_classArchitectural | (33 << SM_instanceShift))
     value: RFPI         (SM_classArchitectural | (34 << SM_instanceShift))
     value: MineManager  (SM_classArchitectural | (35 << SM_instanceShift))
     value: EnvAssess    (SM_classArchitectural | (36 << SM_instanceShift))
     value: EnvReason    (SM_classArchitectural | (37 << SM_instanceShift))
     value: HandOff      (SM_classArchitectural | (38 << SM_instanceShift))
     value: Element      (SM_classArchitectural | (39 << SM_instanceShift))
     value: SubComp	 (SM_classArchitectural | (40 << SM_instanceShift))
     value: ChemicalDamage	(SM_classArchitectural | (41 << SM_instanceShift))
     value: AGGposition  (SM_classArchitectural | (42 << SM_instanceShift))
     value: LRDetect     (SM_classArchitectural | (43 << SM_instanceShift))
     value: SimpleIFF    (SM_classArchitectural | (44 << SM_instanceShift))
     value: LaneEntity   (SM_classArchitectural | (45 << SM_instanceShift))
     value: POHandOff    (SM_classArchitectural | (46 << SM_instanceShift))


# Hulls
     value: TrackedHull         (SM_classHull | (0 << SM_instanceShift))
     value: WheeledHull         (SM_classHull | (1 << SM_instanceShift))
     value: FWAHull             (SM_classHull | (2 << SM_instanceShift))
     value: RWAHull             (SM_classHull | (3 << SM_instanceShift))
     value: DIHull              (SM_classHull | (4 << SM_instanceShift))
     value: MissileHull         (SM_classHull | (5 << SM_instanceShift))
     value: StaffHull           (SM_classHull | (6 << SM_instanceShift))
     value: MoveMapDynamicsHull (SM_classHull | (7 << SM_instanceShift))
     value: HODynamics          (SM_classHull | (8 << SM_instanceShift))
     value: AirframeHull        (SM_classHull | (9 << SM_instanceShift))

# Turrets
     value: GenericTurret (SM_classTurret | (0 << SM_instanceShift))

# Guns
     value: BallisticGun    (SM_classGun | (0 << SM_instanceShift))
     value: MissileLauncher (SM_classGun | (1 << SM_instanceShift))
     value: RocketLauncher  (SM_classGun | (2 << SM_instanceShift))
     value: IFBallisticGun  (SM_classGun | (3 << SM_instanceShift))
     value: BombRack        (SM_classGun | (4 << SM_instanceShift))
     value: LaserDesignator (SM_classGun | (5 << SM_instanceShift))
     value: Stingray        (SM_classGun | (6 << SM_instanceShift))
     value: MICLIC	    (SM_classGun | (7 << SM_instanceShift))
     value: AirBallistics   (SM_classGun | (8 << SM_instanceShift))
     value: Remote_MICLIC   (SM_classGun | (9 << SM_instanceShift))

# Sensors
     value: FWARadar     (SM_classSensor | (0 << SM_instanceShift))
     value: Visual       (SM_classSensor | (1 << SM_instanceShift))
     value: CBRadar      (SM_classSensor | (2 << SM_instanceShift))
     value: GenericRadar (SM_classSensor | (3 << SM_instanceShift))
     value: Sight        (SM_classSensor | (4 << SM_instanceShift))

# ESensors
     value: ChemSensor   (SM_classESensor | (0 << SM_instanceShift))

# Deployables 
     value: Plow          (SM_classDeployable | (0 << SM_instanceShift))
     value: ScissorBridge (SM_classDeployable | (1 << SM_instanceShift))
     value: Shovel        (SM_classDeployable | (2 << SM_instanceShift))
     value: ORSMC         (SM_classDeployable | (3 << SM_instanceShift))
     value: SlidingBridge (SM_classDeployable | (4 << SM_instanceShift))

# Comm Devices
     value: GenRadio          (SM_classComm | (0 << SM_instanceShift))
     value: IvisI             (SM_classComm | (2 << SM_instanceShift))
     value: Ivis              (SM_classComm | (3 << SM_instanceShift))
     value: Comm              (SM_classComm | (4 << SM_instanceShift))
     value: Link              (SM_classComm | (5 << SM_instanceShift))
     value: C3Util            (SM_classComm | (6 << SM_instanceShift))

# Airframes
     value: FWAAirframe       (SM_classAirframe | (0 << SM_instanceShift))

# Designation detectors
     value: LDsgDetector      (SM_classDsgDetector | (0 << SM_instanceShift))

# Mine Detectors
     value: STAMIDS           (SM_classMineDetector | (0 << SM_instanceShift))


# Tasks
     value: Spotter             (SM_classTask |  0)
     value: VSpotter            (SM_classTask |  1)
     value: VAssess             (SM_classTask |  2)
     value: VTargeter           (SM_classTask |  3)
     value: UTargeter           (SM_classTask |  4)
     value: ArbMove             (SM_classTask |  5)
     value: ArbTarg             (SM_classTask |  6)
     value: ArbSensor           (SM_classTask |  7)
     value: VFlwRte             (SM_classTask |  8)
     value: UFlwRte             (SM_classTask |  9)
     value: VTakeOff            (SM_classTask | 10)
     value: VOrbit              (SM_classTask | 11)
     value: VLand               (SM_classTask | 12)
     value: VATAInt             (SM_classTask | 13)
     value: UATAInt             (SM_classTask | 14)
     value: URTB                (SM_classTask | 15)
     value: UBingoFuel          (SM_classTask | 16)
     value: UCommit             (SM_classTask | 17)
     value: UReset              (SM_classTask | 18)
     value: MedArbMove          (SM_classTask | 19)
     value: VFlyContour         (SM_classTask | 20)
     value: VFlyGrndAvoid       (SM_classTask | 21)
     value: VSearch             (SM_classTask | 22)
     value: VCAP                (SM_classTask | 23)
     value: UCAP                (SM_classTask | 24)
     value: ETCM                (SM_classTask | 25)
     value: UHalt               (SM_classTask | 26)
     value: UTravel             (SM_classTask | 27)
     value: VMove               (SM_classTask | 28)
     value: VTerrain            (SM_classTask | 29)
     value: VEnemy              (SM_classTask | 30)
     value: VAltFirePos         (SM_classTask | 31)
     value: UActionDrill        (SM_classTask | 32)
     value: UAssault            (SM_classTask | 33)
     value: UAtkFire            (SM_classTask | 34)
     value: UOverWatchMove      (SM_classTask | 35)
     value: UDefendPos          (SM_classTask | 36)
     value: UEnemy              (SM_classTask | 37)
     value: UMove               (SM_classTask | 38)
     value: UOcpyPos            (SM_classTask | 39)
     value: UPrepAtkFire        (SM_classTask | 41)
     value: UPrepOcpyPos        (SM_classTask | 42)
     value: URIFDrill           (SM_classTask | 43)
     value: EInPhase            (SM_classTask | 45)
     value: EOnOrder            (SM_classTask | 46)
     value: UActionOnContact    (SM_classTask | 47)
     value: UFarAway            (SM_classTask | 48)
     value: UReactIF            (SM_classTask | 49)
     value: UReactNoMission     (SM_classTask | 50)
     value: VCollide            (SM_classTask | 51)
     value: UDsmnt	        (SM_classTask | 52)
     value: UMount	        (SM_classTask | 53)
     value: VATGrndTgt          (SM_classTask | 54)
     value: UATGrndTgt          (SM_classTask | 55)
     value: VMount	        (SM_classTask | 56)
     value: UFlyRte             (SM_classTask | 57)
     value: UMixedMount	        (SM_classTask | 58)
     value: UMixedTravel        (SM_classTask | 59)
     value: UMixedPrepOcpyPos   (SM_classTask | 60)
     value: UMixedDsmnt	        (SM_classTask | 61)
     value: UMixedHalt          (SM_classTask | 62)
     value: UMixedTargeter      (SM_classTask | 63)
     value: UPickUp             (SM_classTask | 64)
     value: UFollowUnit         (SM_classTask | 65)
     value: UMixedOverWatchMove (SM_classTask | 66)
     value: UDIHalt		(SM_classTask | 67)
     value: UDITravel		(SM_classTask | 68)
     value: UDIMount		(SM_classTask | 69)
     value: UDIDsmnt		(SM_classTask | 70)
     value: UDITargeter		(SM_classTask | 72)
     value: UDIPrepOcpyPos	(SM_classTask | 73)
     value: VSRReact          	(SM_classTask | 74)
     value: UWithdraw         	(SM_classTask | 75)
     value: UMixedWithdraw    	(SM_classTask | 76)
     value: UMixedConcealment 	(SM_classTask | 77)
     value: UCompanyHalt      	(SM_classTask | 78)
     value: UCompanyMarch     	(SM_classTask | 79)
     value: UCompanyReactAir    (SM_classTask | 80)
     value: UCompanyOcpyPos     (SM_classTask | 81)
     value: UCompanyOcpyAArea   (SM_classTask | 82)
     value: UCompanyPrepOcpyDef (SM_classTask | 83)
     value: UMixedDelay         (SM_classTask | 84)
     value: UMixedMineWithdraw  (SM_classTask | 85)
     value: UDelay              (SM_classTask | 86)
     value: UMineWithdraw       (SM_classTask | 87)
     value: UBreach             (SM_classTask | 88)
     value: UReactAir           (SM_classTask | 89)
     value: VBacktrack          (SM_classTask | 90)
     value: VFWAGrndAtk         (SM_classTask | 91)
     value: UFWAGrndAtk         (SM_classTask | 92)
     value: UFWAGACoord         (SM_classTask | 93)
     value: UTgtOppty           (SM_classTask | 94)
     value: VFWAFormKeep        (SM_classTask | 95)
     value: VFWACollAvoid       (SM_classTask | 96)
     value: VIFMission          (SM_classTask | 97)
     value: VFDC                (SM_classTask | 98)
     value: VFlyRte             (SM_classTask | 99)
     value: VStop               (SM_classTask | 100)
     value: UMixedBreach        (SM_classTask | 101)
     value: UCompanyWithdraw    (SM_classTask | 102)
     value: UPolyMove           (SM_classTask | 103)
     value: UPolyWithdraw       (SM_classTask | 104)
     value: UPolyDelay          (SM_classTask | 105)
     value: UPolyBreach         (SM_classTask | 106)
     value: UPolyPrepOcpyPos	(SM_classTask | 107)
     value: UPolyTargeter       (SM_classTask | 108)
     value: UPolyHalt           (SM_classTask | 109)
     value: EDuration           (SM_classTask | 110)
     value: EHHour              (SM_classTask | 111)
     value: UCompanyTargeter    (SM_classTask | 112)
     value: UFWAFlyRte		(SM_classTask | 113)
     value: UADAPrepOcpyPos     (SM_classTask | 114)
     value: URWAHover           (SM_classTask | 115)
     value: URWAPopUp           (SM_classTask | 116)
     value: URWAOrbit           (SM_classTask | 117)
     value: URWAPrepOcpyPos     (SM_classTask | 118)
     value: URWAAssemble        (SM_classTask | 119)
     value: URWAAttack          (SM_classTask | 120)
     value: UCompanyAttack      (SM_classTask | 121)
     value: VSmoke		(SM_classTask | 122)
     value: VRWALand		(SM_classTask | 123)
     value: VRWAHover		(SM_classTask | 124)
     value: VRWAOrbit		(SM_classTask | 125)
     value: VRWAPopUp		(SM_classTask | 126)
     value: VRWARun		(SM_classTask | 127)
     value: VRWARunningFire	(SM_classTask | 128)
     value: VRWAMove            (SM_classTask | 129)
     value: URWALand            (SM_classTask | 130)
     value: URWAReactContact    (SM_classTask | 131)
     value: UMLRS               (SM_classTask | 132)
     value: VMLRS               (SM_classTask | 133)
     value: VSupply            	(SM_classTask | 134)
     value: USupply            	(SM_classTask | 135)
     value: VReceive		(SM_classTask | 136)
     value: UFWAHold		(SM_classTask | 137)
     value: URWARunningFire	(SM_classTask | 138)
     value: USUT		(SM_classTask | 139)
     value: UFWABingoFuel    	(SM_classTask | 140)
     value: VFWABingoFuel    	(SM_classTask | 141)
     value: UFWAAirAtk       	(SM_classTask | 142)
     value: VFWAAirAtk       	(SM_classTask | 143)
     value: URWAGroundDrill     (SM_classTask | 144)
     value: URWAAirDrill        (SM_classTask | 145)
     value: VCntrBattery        (SM_classTask | 146)
     value: URWABoundingOW      (SM_classTask | 147)
     value: UFWACAS             (SM_classTask | 148)
     value: UXlevel		(SM_classTask | 154)
     value: VTransfer		(SM_classTask | 155)
     value: VXreceive		(SM_classTask | 156)
     value: VXsupply		(SM_classTask | 157)
     value: VAlternate		(SM_classTask | 158)
     value: VGBSensor           (SM_classTask | 159)
     value: VRadarWarnRecvr     (SM_classTask | 160)
     value: URWARadarWarnRecvr  (SM_classTask | 161)
     value: VRWAFARRP		(SM_classTask | 162)
     value: URWAFARRP		(SM_classTask | 163)
     value: VRWAFARRPF          (SM_classTask | 164)
     value: USupplyRWA          (SM_classTask | 165)
     value: UTravelingOverwatch (SM_classTask | 166)
     value: VNLOSTarg           (SM_classTask | 167)
     value: VTow                (SM_classTask | 168)
     value: UTow                (SM_classTask | 169)
     value: VRepair             (SM_classTask | 170)
     value: URepair             (SM_classTask | 171)
     value: VReceiveRepair      (SM_classTask | 172)
     value: UServiceStation     (SM_classTask | 173)
     value: URWALaserDesignator (SM_classTask | 174)
     value: VDependentFire      (SM_classTask | 175)
     value: VLaserDesignator    (SM_classTask | 176)
     value: UFollowSimulator    (SM_classTask | 177)
     value: VAttach             (SM_classTask | 178)
     value: UAttach             (SM_classTask | 179)
     value: VPosDeploy          (SM_classTask | 180)
     value: UPosDeploy          (SM_classTask | 181)
     value: UPlowBrch           (SM_classTask | 182)
     value: UChangeFormation    (SM_classTask | 183)
     value: UMixedChangeForm    (SM_classTask | 184)
     value: VSignal		(SM_classTask | 185)
     value: ESignal		(SM_classTask | 186)
     value: USignal		(SM_classTask | 187)
     value: UBrdgBrch           (SM_classTask | 188)
     value: VHellfire           (SM_classTask | 189)
     value: URWAHellfire        (SM_classTask | 190)
     value: URWAGNDLaserDsg     (SM_classTask | 191)
     value: VRWADamageCheck     (SM_classTask | 192)
     value: VRWAMissionAbort    (SM_classTask | 193)
     value: VRWAForcedLand      (SM_classTask | 194)
     value: UBattalionHalt      (SM_classTask | 195)
     value: UBattalionMarch     (SM_classTask | 196)
     value: UCompanyActContact  (SM_classTask | 197)
     value: VBridge             (SM_classTask | 198)
     value: UBrdgRtrve          (SM_classTask | 199)
     value: VFWASpotReport      (SM_classTask | 200)
     value: URWAFollowSim       (SM_classTask | 201)
     value: VRWADigCom          (SM_classTask | 202)
     value: VRWADigComMov       (SM_classTask | 203)
     value: VRendv              (SM_classTask | 204)
     value: URendv              (SM_classTask | 205)
     value: VPOC                (SM_classTask | 206)
     value: UPOC                (SM_classTask | 207)
     value: VTacIntel           (SM_classTask | 208)
     value: VRWALaserDsg        (SM_classTask | 209)
     value: UFWACASMission	(SM_classTask | 210)
     value: VFAC		(SM_classTask | 211)
     value: UFACSetup		(SM_classTask | 212)
     value: UFACAssign		(SM_classTask | 213)
     value: UFWAInterdiction    (SM_classTask | 214)
     value: USmoke              (SM_classTask | 215)
     value: UReactSmoke         (SM_classTask | 216)
     value: VC3AssetComm        (SM_classTask | 217)
     value: VC3NodeComm         (SM_classTask | 218)
     value: VC3Engage           (SM_classTask | 219)
     value: VManualSearch       (SM_classTask | 220)
     value: UTrenchBreach       (SM_classTask | 221)
     value: VPushDirt           (SM_classTask | 222)
     value: VShovelBreach       (SM_classTask | 223)
     value: VC3RadarComm        (SM_classTask | 224)
     value: VCCFDC        	(SM_classTask | 225)
     value: VForwardObs         (SM_classTask | 226)
     value: VHighlightTgt       (SM_classTask | 227)
     value: VMICLIC             (SM_classTask | 228)
     value: UMICLIC             (SM_classTask | 229)
     value: UGunBreach          (SM_classTask | 230)
     value: VGunBreach        	(SM_classTask | 231)
     value: VChemSurvey		(SM_classTask | 232)
     value: UWireBreach         (SM_classTask | 233)
     value: VWireBreach         (SM_classTask | 234)
     value: UReactObst          (SM_classTask | 235)
     value: UORSMC              (SM_classTask | 236)
     value: VReactLR            (SM_classTask | 237)
     value: VFSO                (SM_classTask | 238)
     value: UReportTo           (SM_classTask | 239)
     value: UUnAssignUnit       (SM_classTask | 240)
     value: UAcceptUnit         (SM_classTask | 241)
     value: EMessage            (SM_classTask | 242)
     value: UHookUp             (SM_classTask | 243)
     value: URelease            (SM_classTask | 244)
     value: ULoad               (SM_classTask | 245)
     value: UUnload             (SM_classTask | 246)
     value: VTransRec           (SM_classTask | 247)
     value: UTailgate           (SM_classTask | 248)
     value: VTailgate           (SM_classTask | 249)
     value: USplyServiceSt      (SM_classTask | 250)
     value: VMineDtct           (SM_classTask | 251)
     value: UASTAMIDS           (SM_classTask | 252)
     value: VASTAMIDS           (SM_classTask | 253)
     value: UVMMD               (SM_classTask | 254)
     value: VVMMD               (SM_classTask | 255)
     value: VDetectedMinefield  (SM_classTask | 256)
     value: UDigInVehicle       (SM_classTask | 257)
     value: UMoveToken          (SM_classTask | 258)
     value: UAssistedRecov      (SM_classTask | 259)
     value: VStochastic         (SM_classTask | 260)
