
/*
 * FILE:  p_stngry.h 
 *
 * Created on Wed Apr 17 10:53:01 1996 
 * Compiled by DRN compiler, version 6.2.d
 * 
 */

#ifndef _p_stngry_included
#define _p_stngry_included



/*
 * File:     p_stngry.drn
 * Contents: The Stingray Procotol Data Units
 * System:   simnet development.
 * Created:  25-Feb-1993
 * Author:   llovero
 *
 * $RCSfile: p_stngry.h,v $
 * $Revision: 1.1.1.1 $
 * $State: Exp $
 * COPYRIGHT 1993 BBN Systems and Technologies Corporation
 * 10 Moulton Street
 * Cambridge, Ma. 02138
 * 617-873-3000
 */

#include <stdtypes.h>
#include <basic.h> 

/*
 * Versions of the Stingray protocol
 *
 */

#define stingrayProtocolVersionFeb93 1

typedef uint8    StingrayProtocolVersion; 


/*
 * The current version
 *
 */

#define stingrayProtocolVersionCurrent           1
#define SRDetectionRequestPDUKind 1  
#define SRDetectionResponsePDUKind 2 

typedef uint8    StingrayPDUKind; 

typedef struct {
    EventID            detectionEventID; 
    VehicleID          stingrayVehicleID; 
    VehicleID          targetVehicleID; 
    uint16             _unused_3;     /* padding */
    VehicleCoordinates searchOrigin; 
} SRDetectionRequestVariant; 

typedef struct {
    EventID            detectionEventID; 
    SightID            detectedSightID; 
    VehicleID          stingrayVehicleID; 
    VehicleID          targetVehicleID; 
    SP_Time            simulatedTime; 
    float32            range;        
    VehicleCoordinates location;     
    unsigned           detectionResult    : 1;  /* Boolean */
    unsigned           _unused_4          : 15;  /* padding */
} SRDetectionResponseVariant; 

typedef struct {
    StingrayProtocolVersion version; 
    StingrayPDUKind         kind;            
    ExerciseID              exercise;             
    uint8                   _unused_5_6;           /* padding */
    uint32                  _unused_5;             /* padding */
    union {
        SRDetectionRequestVariant  srDetectionRequest;
        SRDetectionResponseVariant srDetectionResponse;
    } variant;                          
} StingrayPDU; 



#endif
