
/*
 * FILE:  p_terra.h 
 *
 * Created on Fri Apr 26 13:42:20 1996 
 * Compiled by DRN compiler, version 6.2.d
 * 
 */

#ifndef _p_terra_included
#define _p_terra_included



/*
 * File:     pro_terra.drn
 * Contents: The terrain protocol
 * System:   simnet development.
 * Created:  20-Feb-1990
 * Author:   kanarick
 * Remarks:
 * $RCSfile: p_terra.h,v $
 * $Revision: 1.1.1.1 $
 * $State: Exp $
 * COPYRIGHT 1990 BBN Systems and Technologies Corporation
 * 10 Moulton Street
 * Cambridge, Ma. 02138
 * 617-873-3000
 */

#include <stdtypes.h>
#include <basic.h> 
#define elevationRequestPDUKind 1    
#define elevationResponsePDUKind 2   

typedef uint8    TerrainPDUKind; 

#define terrainProtocolVersionJan90 1

typedef uint8    TerrainProtocolVersion; 

#define terrainProtocolVersionCurrent           1

/*
 * This PDU requests an array of elevations
 */

typedef struct {
    VehicleID               vehicle;  /* vehicle making request */
    EventID                 event;   
    SIMNET_WorldCoordinates start;   
    SIMNET_WorldCoordinates end;     
} ElevationRequestVariant; 

#define maxElevations           25

/*
 * The response is merely an array of heights
 */

typedef struct {
    VehicleID vehicle;                /* vehicle making request */
    EventID   event;                 
    float64   elevations[maxElevations]; 
} ElevationResponseVariant; 


/*
 * The terrain PDU
 */

typedef struct {
    TerrainProtocolVersion version;  
    TerrainPDUKind kind;             
    ExerciseID exercise;             
    uint8 _unused_3_4;           /* padding */
    uint32 _unused_3;             /* padding */
    union {
        ElevationRequestVariant  elevationRequest;
        ElevationResponseVariant elevationResponse;
    } variant;                          
} TerrainPDU; 



#endif
