
/*
 * FILE:  p_ulf.h 
 *
 * Created on Wed Apr 17 10:53:02 1996 
 * Compiled by DRN compiler, version 6.2.d
 * 
 */

#ifndef _p_ulf_included
#define _p_ulf_included

 /* File:     pro_ulf.drn */
 /* Contents: This file contains the ULF protocol */
 /* System:   simnet development. */
 /* Created:  1-Sept-90 */
 /* Author:   ajc */
 /* Remarks: */
 /* $RCSfile: p_ulf.h,v $ */
 /* $Revision: 1.1.1.1 $ */
 /* $State: Exp $ */
 /* COPYRIGHT 1990 Bolt Beranek and Newman Inc. */
 /* 10 Moulton Street */
 /* Cambridge, Ma. 02138 */
 /* 617-873-3000 */
#include <stdtypes.h>
#include <basic.h> 

/*
 * the different versions of the protocol
 */

#define ulfProtocolVersionJan90Corrected 1

typedef uint8    UlfProtocolVersion; 


/*
 * The current protocol version
 */

#define ulfProtocolVersionCurrent           1

/*
 * different kinds of Ulf PDUs:
 */

#define ulfViewPDUKind          1    

typedef uint8    UlfPDUKind; 


/*
 * Contents of a View PDU:
 */

typedef struct {
     /* Identity of the vehicle */
    VehicleID vehicleID;             
    uint16    _unused_3;            /* padding */
     /* Rotations of the sights of the vehicle: */

    float32   periToTurretRotation[3][3]; 
    float32   emesToTurretRotation[3][3]; 
} UlfViewVariant; 


/*
 * An Ulf PDU:
 */

typedef struct {
    UlfProtocolVersion version;      
    UlfPDUKind kind;                 
    uint16 _unused_4_5;          /* padding */
    uint32 _unused_4;             /* padding */
    union {
        UlfViewVariant ulfView;
    } variant;                          
} UlfPDU; 



#endif
