#ifndef lint
static char rcsid [] = "$RCSfile: protocol_init.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif
/****************************************************************************
*   File: protocol_init.c
*                                                                           *
*      Copyright 1996 by Lockheed Martin Federal Systems, Inc.              *
*                                                                           *
*               Lockheed Martin Federal Systems                             *
*               Advanced Distributed Simulation                             *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*      This software was developed by LMFS under U. S. Government contracts *
*      and may be reproduced by or for the U. S. Government pursuant to     *
*      the copyright license under the clause at DFARS 252.227-7013         *
*      (OCT 1988).                                                          *
*                                                                           *
*      Contents: Code to initialize libprotocol
*      Created: Mon Jun 24 14:40:42 EDT 1996
*      Author: bhelf
*      Remarks:                                                             *
*                                                                           *
****************************************************************************/

#include "libprotocol.h"
#include <libreader.h>
#include <libconstants.h>
#include <stdtypes.h>

#define NUM_NAMESPACES 11

static char names[NUM_NAMESPACES][20] = 
{ 
    "vehicle",
    "munition",
    "structure",
    "lifeForm",
    "environmental",
    "unit",
    "other",
    "part",
    "component",
    "subcomponent",
    "echelon"
};

static char *syms[NUM_NAMESPACES];
			    
void protocol_init(void)
{
    int32 i;

    for(i=0;i<NUM_NAMESPACES;i++)
      syms[i] = reader_get_symbol(names[i]);
}


/* If you have no idea what namespace this ObjectType is, this will check them
 * all.  If you know what namespace it is, then call libconstants directly.
 */
char *protocol_find_name(
    ObjectType ot)
{
    int32 i;
    char *res = const_error;

    for(i=0; (i<NUM_NAMESPACES) && (res == const_error); i++)
      res = const_value_to_name(syms[i], ot);

    return res;
}
