
/*
 * FILE:  st_leo2.h 
 *
 * Created on Wed Apr 17 10:53:03 1996 
 * Compiled by DRN compiler, version 6.2.d
 * 
 */

#ifndef _st_leo2_included
#define _st_leo2_included

 /* File:     st_leo2.drn */
 /* Contents: This file contains the Leo2 specific status */
 /* System:   simnet development. */
 /* Created:  1-Sept-90 */
 /* Author:   ajc */
 /* Remarks: */
 /* $RCSfile: st_leo2.h,v $ */
 /* $Revision: 1.1.1.1 $ */
 /* $State: Exp $ */
 /* COPYRIGHT 1990 Bolt Beranek and Newman Inc. */
 /* 10 Moulton Street */
 /* Cambridge, Ma. 02138 */
 /* 617-873-3000 */
#include <stdtypes.h>
#include <basic.h> 
#define germanAmmoNone          0    
#define germanAmmoKE            1    
#define germanAmmoMG            2    
#define germanAmmoMZ            3    

typedef uint8    GermanAmmo; 

#define rangeSourceUnknown      0    
#define rangeSourceKDT          1    
#define rangeSourceLaser        2    
#define rangeSourceE1000        3    
#define rangeSourceManual       4    

typedef uint8    RangeSource; 

#define germanTurretModeUnknown 0    
#define germanTurretModeKW      1    
#define germanTurretModeKH      2    
#define germanTurretRHKP        3    
#define germanTurretRHZU        4    
#define germanTurretRWKP        5    
#define germanTurretRWZO        6    

typedef uint8    GermanTurretMode; 

#define germanComputerDisplayBlank 0 
#define germanComputerDisplayEMES_LASER 1
#define germanComputerDisplayEMES_STAB 2
#define germanComputerDisplayWBG 3   
#define germanComputerDisplayPERI 4  
#define germanComputerDisplayEMES_UEST 5
#define germanComputerDisplayBORD_NETZ 6

typedef uint8    GermanComputerDisplay; 


/*
 * vehicle specific status:
 */

typedef struct {
    float32          fuel;                 /* Liters */

    float32          targetRange;          /* Meters */

    Angle       dynamicLeadAngle;    
    uint8  keReadyAmmo;         
    uint8  keResdistributionAmmo; 
    uint8  mzReadyAmmo;         
    uint8  mzRedistributeAmmo;  
    GermanAmmo  loadedAmmo;          
    GermanAmmo  firedAmmo;           
    RangeSource rangeSource;         
    GermanTurretMode turretMode;     
    GermanComputerDisplay computerDisplay; 
    unsigned       dynamicLeadButton      : 1;  /* Boolean */ /* is it pressed? */

    unsigned       float64Echo             : 1;  /* Boolean */
    unsigned       cmdrsPeriscope         : 1;  /* Boolean */
    unsigned       _unused_3_4            : 21;  /* padding */
    uint32  _unused_3_5;          /* padding */
    uint32  _unused_3_6;          /* padding */
    uint32  _unused_3_7;          /* padding */
    uint32  _unused_3_8;          /* padding */
    uint32  _unused_3_9;          /* padding */
    uint32  _unused_3_10;         /* padding */
    uint32  _unused_3;            /* padding */
} AGPT_Leo2_Status; 



#endif
