
/*
 * FILE:  st_rwa.h 
 *
 * Created on Wed Apr 17 10:53:04 1996 
 * Compiled by DRN compiler, version 6.2.d
 * 
 */

#ifndef _st_rwa_included
#define _st_rwa_included

 /* FILE:    st_rwa.h  */
 /* AUTHOR:  Paul J Metzger */
 /* CREATED: 23-Mar-1991 */
 /* $RCSfile: st_rwa.h,v $ */
 /* $Revision: 1.1.1.1 $ */
 /* $State: Exp $ */
 /* COPYRIGHT 1991 BBN Systems and Technologies Corporation */
 /* 10 Moulton Street */
 /* Cambridge, Ma. 02138 */
 /* 617-873-3000 */
#include <stdtypes.h>
#include <basic.h> 
     /* The SIMNET generic RWA has 4 weapon selection posibilities */
 /* (Weapons Action Switch 12:00, WAS 3:00, WAS 6:00, and WAS 9:00) */
 /* which results in the fact that no more than 4 different munitions */
 /* may be carried at any one time. */
#define maxRWAStores            4
typedef struct {
    ObjectType  munition;             /* Type of munition: */

    unsigned       leftwing            : 1;  /* Boolean */
    unsigned       quantity_leftwing   : 15;  /* quantity */

    unsigned       rightwing           : 1;  /* Boolean */
    unsigned       quantity_rightwing  : 15;  /* quantity */

    unsigned       turret              : 1;  /* Boolean */
    unsigned       quantity_turret     : 15;  /* quantity */

    uint16 _unused_3;            /* padding */
} RWAMunitionStores; 

typedef struct {
    float32                fuel;          
    RWAMunitionStores stores[maxRWAStores]; 
} Generic_RWA_Status; 



#endif
