
/*
 * FILE:  stat_m2.h 
 *
 * Created on Wed Apr 17 10:53:04 1996 
 * Compiled by DRN compiler, version 6.2.d
 * 
 */

#ifndef _stat_m2_included
#define _stat_m2_included

 /* File:     status_m2.drn */
 /* Contents: Vehicle status information specific to the m2 */
 /* System:   simnet development. */
 /* Created:  10-Oct-1989 */
 /* Author:   apope */
 /* Remarks: */
 /*  History: */
 /*    10/10/89	Pope	created */

 /* $RCSfile: stat_m2.h,v $ */
 /* $Revision: 1.1.1.1 $ */
 /* $State: Exp $ */
 /* COPYRIGHT 1990 BBN Systems and Technologies Corporation */
 /* 10 Moulton Street */
 /* Cambridge, Ma. 02138 */
 /* 617-873-3000 */

#include <stdtypes.h>

 /* Vehicle-specific status: */
typedef struct {
    float32          enginePower;         
    float32          hullBattery;         
    float32          turretEmergencyBattery; 
    float32          topFuel;             
    float32          bottomFuel;          
    uint8  apCanAmmo;           
    uint8  apCanAmmoType;       
    uint8  heCanAmmo;           
    uint8  heCanAmmoType;       
    uint16 apStowedAmmo;        
    uint16 heiStowedAmmo;       
    unsigned       towStowedAmmo           : 4; 
    unsigned       dragonStowedAmmo        : 4; 
    unsigned       tow1Loaded              : 1; 
    unsigned       tow2Loaded              : 1; 
    unsigned       towLauncherUp           : 1; 
    unsigned       m3Configuration         : 1; 
    unsigned       rampDown                : 1; 
    unsigned       _unused_1_2             : 19;  /* padding */
    uint32  _unused_1_3;          /* padding */
    uint32  _unused_1_4;          /* padding */
    uint32  _unused_1_5;          /* padding */
    uint32  _unused_1_6;          /* padding */
    uint32  _unused_1;            /* padding */
} SIMNET_M2_Status; 



#endif
