#ifndef lint
static char rcsid [] = "$RCSfile: test.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif
/****************************************************************************
*   File: test.c                                                            *
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*       This software was developed by Loral under U. S. Government contracts*
*       and may be reproduced by or for the U. S. Government pursuant to    *
*       the copyright license under the clause at DFARS 252.227-7013        *
*       (OCT 1988).                                                         *
*                                                                           *
*       Contents: Simple test program                                       *
*       Created: Wed Mar 20 1996                                            *
*       Author: bhelf                                                       *
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/

#include "libprotocol.h"
#include <libconstants.h>
#include <libreader.h>
#include <stdext.h>
#include <stdlib.h>
#include <stdstring.h>
#include <stdalloc.h>
#include <unistd.h>

static int compare_entry(
    const void *a,
    const void *b)
{
    READER_UNION *p = (READER_UNION *)a;
    READER_UNION *q = (READER_UNION *)b;

    return (p->array[1].integer - q->array[1].integer);
}


static char *datafn = "common/data/constants";

int main(
    int argc,
    char *argv[])
{
    int i,j,k,n;
    int ret;
    char *name;
    char commondir[256];
    char *commonptr, *nextcommon;
    char datadir[256];
    READER_UNION  ru;
    READER_UNION *nsp[1000];
    READER_UNION *all;

    if (argc < 3)
    {
	printf("Usage: %s macro_filename filename <filename> ...\n", argv[0]);
	exit(0);
    }

    /* Figure out where we are compared to common */
    if (!getcwd(commondir, 255))
      exit(0);

    /* Find the first occurence of "common" */
    if(!(commonptr = strstr(commondir, "common")))
    {
        printf("\n%s: must be run in the common tree.\n", argv[0]);
        exit(0);
    }
    
    /* Make sure it's the last common */
    while (nextcommon = strstr(commonptr+1, "common"))
      commonptr = nextcommon;

    strcpy(datadir, ".:");
    bcopy(commondir, datadir + 2, commonptr - commondir);
    bcopy(datafn, datadir + (commonptr - commondir) + 2, strlen(datafn) + 1);


    reader_init(FALSE);

    if (reader_read(argv[1], datadir, &ru, 0))
      exit(-1);

    n = 0;
    for (i=2; i<argc; i++)
    {
	if (reader_read(argv[i], datadir, &ru, 0))
	  exit(-1);
    
	for (j=2;j<ru.array[0].integer;j++)
        {
          nsp[n] = (READER_UNION*)STDALLOC(sizeof(READER_UNION) *
                                           ru.array[j].array[0].integer - 1);
          nsp[n][0].integer = ru.array[j].array[0].integer - 1;
          for (k=1;k<nsp[n][0].integer;k++)
            nsp[n][k].array = ru.array[j].array[k+1].array;
          n++;
        }
    }

    all = reader_combine_arrays(nsp, n);

    qsort(all+1, all[0].integer-1, sizeof(READER_UNION), compare_entry);

    ret = 0;

    for (i=2;i<all[0].integer;i++)
      if(all[i].array[1].integer == all[i-1].array[1].integer)
      {
	  printf("Conflict in constants files: %s and %s\n", 
		 all[i].array[2].charptr,
		 all[i-1].array[2].charptr);
	  ret++;
      }

    return(ret);
}
