
/*
 * FILE:  toc_bridge.h 
 *
 * Created on Wed Apr 17 10:53:04 1996 
 * Compiled by DRN compiler, version 6.2.d
 * 
 */

#ifndef _toc_bridge_included
#define _toc_bridge_included

 /* $RCSfile: toc_bridge.h,v $ */
 /* $Revision: 1.1.1.1 $ */
 /* $State: Exp $ */
#include <stdtypes.h>
#include <p_ivis.h> 

/*
 * TCP sockets need a port number for connections.  I have arbitrarily
 * picked a number for this purpose.
 */

#define tbr_TocBridgePortNumber 1313

/*
 * Different types of packets between bntoc and the bridge.
 */

#define tbr_Message             0     /* a cvcc_Msg */
#define tbr_BnRole              1     /* message to identify the role of the ws */
#define tbr_Instrumentation     2     /* bntoc instrumentation */
#define tbr_ExecutionControl    3     /* execution control commands */
typedef uint16   tbr_PacketType; 


/*
 * The toc bridge packet
 */

typedef struct {
    tbr_PacketType ptype;             /* the type of packet */

    bntoc_MessageDestination recipients;  /* who gets it */

    union {
        cvcc_Msg                     msg;
        cvcc_Role                    role;
        bntoc_InstrumentationVariant inst;
        cvcc_ExecutionControl        exe;
    } u;                                
} tbr_Packet; 



#endif
