#
# File:     unit_type.cdf
# Contents: 
# System:   ModSAF
# Created:  6/17/93
# Author:   ajc
#
# $RCSfile: unit_type.cdf,v $
# $Revision: 1.1.1.1 $
# $State: Exp $

# COPYRIGHT 1993 Loral Advanced Distributed Simulation
# 50 Moulton Street
# Cambridge, Ma. 02138
# 617-873-1850

needs: obj_type.cdf

namespace_def: unit

## Generic units

  value: Generic_Company (objectDomainUnit | unitEnvironmentGround | 
	unitCountryOther | unitSizeCompany | unitRoleArmor)

## US units

# M1 units

  value: US_M1_Section (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeSection | unitRoleArmor)
  value: US_M1_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizePlatoon | unitRoleArmor)
  value: US_M1_Company (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeCompany | unitRoleArmor)
  value: US_M1_BattalionHQ (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeBattalion | unitRoleArmor | unitHQ)
  value: US_M1_Battalion (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeBattalion | unitRoleArmor)

# M1A1 units

  value: US_M1A1_Section (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeSection | unitRoleArmor | 8)
  value: US_M1A1_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizePlatoon | unitRoleArmor | 8)
  value: US_M1A1_Company (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeCompany | unitRoleArmor | 8)
  value: US_M1A1_BattalionHQ (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeBattalion | unitRoleArmor | unitHQ | 8)
  value: US_M1A1_Battalion (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeBattalion | unitRoleArmor | 8)

# M1A2 units

  value: US_M1A2_Section (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeSection | unitRoleArmor | 3)
  value: US_M1A2_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizePlatoon | unitRoleArmor | 3)
  value: US_M1A2_Company (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeCompany | unitRoleArmor | 3)
  value: US_M1A2_BattalionHQ (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeBattalion | unitRoleArmor | unitHQ | 3)
  value: US_M1A2_Battalion (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeBattalion | unitRoleArmor | 3)

# M2 units

  value: US_M2_Section (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeSection | unitRoleAPC)
  value: US_M2_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizePlatoon | unitRoleAPC)
  value: US_M2_Company (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeCompany | unitRoleAPC)
  value: US_M2_Reinforced_Company (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeCompany | unitRoleAPC | unitTaskOrganized)
  value: US_M2_BattalionHQ (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeBattalion | unitRoleAPC | unitHQ)
  value: US_M2_Battalion (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeBattalion | unitRoleAPC)

 
# MCSAF import, for SE amphib. demo

  value: USMC_AAV_Team (objectDomainUnit | unitEnvironmentGround |
	unitCountryUS | unitSizeSection | unitRoleAPC | 1 )
  value: USMC_AAV_Cmd_Team (objectDomainUnit | unitEnvironmentGround |
	unitCountryUS | unitSizePlatoon | unitRoleAPC | 3 )
  value: USMC_AAV_Section (objectDomainUnit | unitEnvironmentGround |
	unitCountryUS | unitSizePlatoon | unitRoleAPC | 4 )
  value: USMC_AAV_Platoon (objectDomainUnit | unitEnvironmentGround |
	unitCountryUS | unitSizePlatoon | unitRoleAPC | 5 )
  value: USMC_AAV_Company (objectDomainUnit | unitEnvironmentGround |
	unitCountryUS | unitSizeCompany | unitRoleAPC | 3 )


# M3 units
  value: US_M3_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizePlatoon | unitRoleAPC | 1)

  value: US_M3A3_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizePlatoon | unitRoleAPC | 2)

  value: US_M3_Scout_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizePlatoon | unitRoleScout)

# Mixed M1/M2 Units

  value: US_2M2_1M1_Company (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeCompany | unitRoleAPC | unitTaskOrganized | 2)

  value: US_2M1_1M2_Company (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeCompany | unitRoleArmor | unitTaskOrganized | 2)

#  LOSAT units
  value: US_LOSAT_Section (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeSection | unitRoleAT)
# LOSAT_S_Platoon is intended to represent a platoon comprised of two
# sections.  The ModSAF taskframes mgr does not currently accept this
# level of abstraction in unit hierarchies.  If and when it is fixed,
# uncomment the following define.  Also, remember
# to change libunits/units.rdr and libechelondb/echelondb.rdr
#
#   value: US_LOSAT_S_Platoon (objectDomainUnit | unitEnvironmentGround | 
#	unitCountryUS | unitSizePlatoon | unitRoleAT)
#
  value: US_LOSAT_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizePlatoon | unitRoleAT | 0 )

  value: US_LOSAT_Reinforced_M2_Company (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeCompany | unitRoleAPC | unitTaskOrganized | 1)

# Armored Cavalry Troops

  value: US_ArmoredCavalry_CompanyHQ (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizePlatoon | unitRoleArmor | unitHQ)

  value: US_ArmoredCavalry_Maintenance (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizePlatoon | unitRoleMaintenance | 4)

  value: US_ArmoredCavalry_Company (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeCompany | unitRoleArmor | 4)

# Fox NBC Recon units
  value: US_M93_Fox_Squad (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeSection | unitRoleNBCRecon)


# CSS Units  

  value: US_M105_Squad_of_4 (objectDomainUnit | unitEnvironmentGround |
	 unitCountryUS | unitSizeSquad | unitRoleSupply | 13)

  value: US_M105_Squad_of_5 (objectDomainUnit | unitEnvironmentGround |
	 unitCountryUS | unitSizeSquad | unitRoleSupply | 14)

  value: US_M923_Squad_of_4
       (objectDomainUnit | unitEnvironmentGround | unitCountryUS |
         unitSizeSquad | unitRoleSupply | 12)

  value: US_M923_Squad_of_5 (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeSquad | unitRoleSupply | 2)

  value: US_M923_Squad_of_6 (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeSquad | unitRoleSupply | 5)

  value: US_M977_Squad_of_2 (objectDomainUnit | unitEnvironmentGround |
	 unitCountryUS | unitSizeSquad | unitRoleSupply | 10)

  value: US_M977_Squad_of_3 (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeSquad | unitRoleSupply | 3)

  value: US_M977_Squad_of_4 (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeSquad | unitRoleSupply | 9)

  value: US_M978_Squad_of_2 (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeSquad | unitRoleSupply | 4)

  value: US_M978_Squad_of_3 (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeSquad | unitRoleSupply | 8)

  value: US_M978_Squad_of_4 (objectDomainUnit | unitEnvironmentGround |
	 unitCountryUS | unitSizeSquad | unitRoleSupply | 11)

  value: US_M113A2_Squad_of_3 (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeSquad | unitRoleAPC | 4)

  value: US_M88A1_Squad_of_3 (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeSquad | unitRoleMaintenance | 5)

  value: US_M88A1_Squad_of_4 (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeSquad | unitRoleMaintenance | 6)

  value: US_ORSMC (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeSquad | unitRoleEngineer | 0)

  value: US_M113_MICLIC (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeSquad | unitRoleEngineer | 1)

  value: US_M113_ESMB (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeSquad | unitRoleEngineer | 2)

  value: US_HMMWV_Squad_of_3 (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeSquad | unitRoleSupply | 6)

  value: US_M984A1_Squad_of_2 (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeSquad | unitRoleSupply | 7)

  value: US_Maintenance_Company_Team (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizePlatoon | unitRoleMaintenance | 5 )

  value: US_Mech_Company_Team (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizePlatoon | unitRoleInfantry | 6 )

  value: US_Armor_Company_Team (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeCompany | unitRoleArmor | 7)

  value: US_Armor_Battalion_Team (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeCompany | unitRoleArmor | 10 )

  value: US_Maintenance_Spt_Team ( objectDomainUnit | unitEnvironmentGround |
	 unitCountryUS | unitSizeCompany | unitRoleMaintenance | 4 )

  value: US_Maintenance_Battalion_Team (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeCompany | unitRoleMaintenance | 3)

  value: US_Mech_Battalion_Team (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeCompany | unitRoleMaintenance | 2)


# M106A1 Section 

  value: US_M106A1_Section (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeSection | unitRoleSPArty | 1)

# M109 and  M106A1 Platoons


  value: US_M109_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizePlatoon | unitRoleSPArty | 1)

  value: US_M109A1_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizePlatoon | unitRoleSPArty | 2)

  value: US_M109A3_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizePlatoon | unitRoleSPArty | 3)

  value: US_M109A5_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizePlatoon | unitRoleSPArty | 4)

  value: US_M109A6_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizePlatoon | unitRoleSPArty | 5)

  value: US_M106A1_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizePlatoon | unitRoleSPArty | 6)

# M109 and M106A1 Batteries

  value: US_M109_Battery (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeCompany | unitRoleSPArty | 7 )

  value: US_M109A1_Battery (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeCompany | unitRoleSPArty | 8 )

  value: US_M109A3_Battery (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeCompany | unitRoleSPArty | 9 )

  value: US_M109A5_Battery (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeCompany | unitRoleSPArty | 10 )

  value: US_M109A6_Battery (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeCompany | unitRoleSPArty | 11 )

  value: US_M106A1_Battery (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeCompany | unitRoleSPArty | 12 )

# Crusader Units

  value: US_Crusader_Section (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeSection | unitRoleDigitalArty)

  value: US_Crusader_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizePlatoon | unitRoleDigitalArty)

  value: US_Crusader_Battery (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeCompany | unitRoleDigitalArty)

  value: US_Crusader_LRP (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizePlatoon | unitRoleSupply)

# M1064 units

  value: US_M1064_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizePlatoon | unitRoleSPArty | 13 )

  value: US_MPL_Battery (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeCompany | unitRoleSPArty | 14 )

  value: US_M120_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizePlatoon | unitRoleSPArty | 15 )

# M102 units

  value: US_M102_Battery (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeCompany | unitRoleArtillery | 1 )

# M198 units

  value: US_M198_Battery (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeCompany | unitRoleArtillery | 2 )

  value: US_LAH_SADARM_Battery (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeCompany | unitRoleArtillery | 3 )

  value: US_PGMM_Battery (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeCompany | unitRoleArtillery | 4 )

  value: US_M252_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizePlatoon | unitRoleArtillery | 5 )

  value: US_M224_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizePlatoon | unitRoleArtillery | 6 )

# XM8 units

  value: US_XM8_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizePlatoon | unitRoleArmor | 1)

# ADA units

  value: US_M2_Stinger_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizePlatoon | unitRoleAirDefense)

  value: US_Avenger_Squad (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeSquad | unitRoleAirDefense | 1)

  value: US_Avenger_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizePlatoon | unitRoleAirDefense | 1)


# FARRP units

  value: US_M978_M979_FARRP (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeSquad | unitRoleRWAFARRP)


## USSR units

# T72 units

  value: USSR_T72M_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizePlatoon | unitRoleArmor)
  value: USSR_T72M_Company (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizeCompany | unitRoleArmor)
  value: USSR_T72M_BattalionHQ (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizeBattalion | unitRoleArmor | unitHQ)
  value: USSR_T72M_Battalion (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizeBattalion | unitRoleArmor)

# T80 units

  value: USSR_T80_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizePlatoon | unitRoleArmor | 1)
  value: USSR_T80_Company (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizeCompany | unitRoleArmor | 1)
  value: USSR_T80_BattalionHQ (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizeBattalion | unitRoleArmor | unitHQ | 1)
  value: USSR_T80_Battalion (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizeBattalion | unitRoleArmor | 1)

# BMP1 units

  value: USSR_BMP1_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizePlatoon | unitRoleAPC)
  value: USSR_BMP1_Company (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizeCompany | unitRoleAPC)
  value: USSR_BMP1_BattalionHQ (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizeBattalion | unitRoleAPC | unitHQ)
  value: USSR_BMP1_Battalion (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizeBattalion | unitRoleAPC)

# BMP2 units

  value: USSR_BMP2_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizePlatoon | unitRoleAPC | 1)
  value: USSR_BMP2_Company (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizeCompany | unitRoleAPC | 1)
  value: USSR_BMP2_Reinforced_Company (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizeCompany | unitRoleAPC | 1 |  unitTaskOrganized)
  value: USSR_BMP2_BattalionHQ (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizeBattalion | unitRoleAPC | unitHQ | 1)
  value: USSR_BMP2_Battalion (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizeBattalion | unitRoleAPC | 1)

# BTR80 units

  value: USSR_BTR80_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizePlatoon | unitRoleAPC | 2)
  value: USSR_BTR80_Company (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizeCompany | unitRoleAPC | 2)
  value: USSR_BTR80_BattalionHQ (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizeBattalion | unitRoleAPC | unitHQ | 2)
  value: USSR_BTR80_Battalion (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizeBattalion | unitRoleAPC | 2)

# BRDM2 units

  value: USSR_BRDM2_Section (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizeSection | unitRoleAPC | 3)
  value: USSR_BRDM2_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizePlatoon | unitRoleAPC | 3)

# USSR Artillery Units

  value: USSR_2S1_Battery (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizeCompany | unitRoleSPArty | 1 )

  value: USSR_2S19_Battery (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizeCompany | unitRoleSPArty | 2 )

  value: USSR_2B11_Battery (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizeCompany | unitRoleArtillery | 1 )

  value: USSR_2S12_Battery (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizeCompany | unitRoleArtillery | 2 )

  value: USSR_BM21_Battery (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizeCompany | unitRoleArtillery | 3 )


# Mixed USSR APC units

  value: USSR_1BRDM2_1BTR80_Section (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizeSection | unitRoleAPC | 4)
  value: USSR_1BRDM2_1BTR80_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizePlatoon | unitRoleAPC | 7)

  value: USSR_2BMP1_1BRDM2_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizePlatoon | unitRoleAPC | 4)

  value: USSR_2BMP2_1BRDM2_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizePlatoon | unitRoleAPC | 5)

# Mixed USSR Armor/APC units

  value: USSR_1T80_3BTR80_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizePlatoon | unitRoleArmor | 3)

  value: USSR_2T80_1BRDM2_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizePlatoon | unitRoleAPC | 6)

# ADA units

  value: USSR_ZSU23_4M_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizePlatoon | unitRoleAirDefense)

  value: USSR_SA9_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizePlatoon | unitRoleAirDefense | 1)

  value: USSR_2S6_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizePlatoon | unitRoleAirDefense | 2)

  value: USSR_SA_15_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizePlatoon | unitRoleAirDefense | 3)

  value: USSR_SCV_FCR_TEL_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizePlatoon | unitRoleAirDefense | 4)

  value: USSR_C3ADA_Company (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizeCompany | unitRoleAirDefense | 1)

## German units

# Leo1A5 units

  value: German_Leo1A5_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryGermany | unitSizePlatoon | unitRoleArmor)
  value: German_Leo1A5_Company (objectDomainUnit | unitEnvironmentGround | 
	unitCountryGermany | unitSizeCompany | unitRoleArmor)
  value: German_Leo1A5_BattalionHQ (objectDomainUnit | unitEnvironmentGround | 
	unitCountryGermany | unitSizeBattalion | unitRoleArmor | unitHQ)
  value: German_Leo1A5_Battalion (objectDomainUnit | unitEnvironmentGround | 
	unitCountryGermany | unitSizeBattalion | unitRoleArmor)

# Leo2 units

  value: German_Leo2_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryGermany | unitSizePlatoon | unitRoleArmor | 1)
  value: German_Leo2_Company (objectDomainUnit | unitEnvironmentGround | 
	unitCountryGermany | unitSizeCompany | unitRoleArmor | 1)
  value: German_Leo2_BattalionHQ (objectDomainUnit | unitEnvironmentGround | 
	unitCountryGermany | unitSizeBattalion | unitRoleArmor | unitHQ | 1)
  value: German_Leo2_Battalion (objectDomainUnit | unitEnvironmentGround | 
	unitCountryGermany | unitSizeBattalion | unitRoleArmor | 1)

# Jaguar1 units

  value: German_Jaguar1_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryGermany | unitSizePlatoon | unitRoleArmor | 2)
  value: German_Jaguar1_Company (objectDomainUnit | unitEnvironmentGround | 
	unitCountryGermany | unitSizeCompany | unitRoleArmor | 2)
  value: German_Jaguar1_BattalionHQ (objectDomainUnit | unitEnvironmentGround | 
	unitCountryGermany | unitSizeBattalion | unitRoleArmor | unitHQ | 2)
  value: German_Jaguar1_Battalion (objectDomainUnit | unitEnvironmentGround | 
	unitCountryGermany | unitSizeBattalion | unitRoleArmor | 2)

# Marder1A3 units

  value: German_Marder1A3_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryGermany | unitSizePlatoon | unitRoleAPC)
  value: German_Marder1A3_Company (objectDomainUnit | unitEnvironmentGround | 
	unitCountryGermany | unitSizeCompany | unitRoleAPC)
  value: German_Marder1A3_BattalionHQ (objectDomainUnit | unitEnvironmentGround | 
	unitCountryGermany | unitSizeBattalion | unitRoleAPC | unitHQ)
  value: German_Marder1A3_Battalion (objectDomainUnit | unitEnvironmentGround | 
	unitCountryGermany | unitSizeBattalion | unitRoleAPC)

# Luchs units

  value: German_Luchs_Section (objectDomainUnit | unitEnvironmentGround | 
	unitCountryGermany | unitSizeSection | unitRoleAPC | 1)
  value: German_Luchs_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryGermany | unitSizePlatoon | unitRoleAPC | 1)

# Mixed Leo/Marder1A3 units

  value: German_3Leo1A5_1Marder1A3_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryGermany | unitSizePlatoon | unitRoleArmor | 3)
  value: German_3Leo2_1Marder1A3_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryGermany | unitSizePlatoon | unitRoleArmor | 4)
  value: German_1Leo2_3Marder1A3_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryGermany | unitSizePlatoon | unitRoleAPC | 2)

#
# DI Units
#

# Individual DI Squads
  value: US_Dragon_Team (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeSquad | unitRoleInfantry | 1)
  value: US_Javelin_Team (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeSquad | unitRoleInfantry | 2)
  value: US_Stinger_Team (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeSquad | unitRoleInfantry | 3)
  value: USSR_SA_16_Team (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizeSquad | unitRoleInfantry | 1)

# Individual DI Sections
  value: US_DI_Section (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizeSection | unitRoleInfantry)
  value: USSR_DI_Section (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizeSection | unitRoleInfantry)
  value: German_DI_Section (objectDomainUnit | unitEnvironmentGround | 
	unitCountryGermany | unitSizeSection  | unitRoleInfantry)

# Individual DI Platoons
  value: US_DI_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizePlatoon | unitRoleInfantry | 1)
  value: USSR_DI_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizePlatoon | unitRoleInfantry | 1)
  value: German_DI_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryGermany | unitSizePlatoon  | unitRoleInfantry | 1)

# Group DI Platoons
  value: US_DIGroup_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizePlatoon | unitRoleInfantry | 2)
  value: USSR_DIGroup_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizePlatoon | unitRoleInfantry | 2)
  value: German_DIGroup_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryGermany | unitSizePlatoon  | unitRoleInfantry | 2)


#
# APCDI Units with Individual DI Platoons
#
  value: US_M2_DI_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizePlatoon | unitRoleMixedAPCDI | 1)
  value: German_MARDERA3_DI_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryGermany | unitSizePlatoon | unitRoleMixedAPCDI | 2)
  value: German_MARDERA3_DI_LEO_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryGermany | unitSizePlatoon | unitRoleMixedAPCDI | 3)
  value: USSR_BMP1_DI_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizePlatoon | unitRoleMixedAPCDI | 4)
  value: USSR_BMP2_DI_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizePlatoon | unitRoleMixedAPCDI | 5)
  value: USSR_BTR80_DI_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizePlatoon | unitRoleMixedAPCDI | 6)

#
# APCDI Units with Individual DI Platoons
#
  value: US_M2_DIGroup_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUS | unitSizePlatoon | unitRoleMixedAPCDI | 7)
  value: German_MARDERA3_DIGroup_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryGermany | unitSizePlatoon | unitRoleMixedAPCDI | 8)
  value: German_MARDERA3_DIGroup_LEO_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryGermany | unitSizePlatoon | unitRoleMixedAPCDI | 9)
  value: USSR_BMP1_DIGroup_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizePlatoon | unitRoleMixedAPCDI | 10)
  value: USSR_BMP2_DIGroup_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizePlatoon | unitRoleMixedAPCDI | 11)
  value: USSR_BTR80_DIGroup_Platoon (objectDomainUnit | unitEnvironmentGround | 
	unitCountryUSSR | unitSizePlatoon | unitRoleMixedAPCDI | 12)

#
#FWA Units
#

#   A10 units
  value: US_A10_Flight_of_2 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUS | unitSizeSquad | unitRoleFWA )
  value: US_A10_Flight_of_3 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUS | unitSizeSection | unitRoleFWA )
  value: US_A10_Flight_of_4 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUS | unitSizePlatoon | unitRoleFWA )

#   F16C units 
  value: US_F16C_Flight_of_2 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUS | unitSizeSquad | unitRoleFWA | 2)
  value: US_F16C_Flight_of_3 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUS | unitSizeSection | unitRoleFWA | 2)
  value: US_F16C_Flight_of_4 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUS | unitSizePlatoon | unitRoleFWA | 2)

#   F16D units 
  value: US_F16D_Flight_of_2 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUS | unitSizeSquad | unitRoleFWA | 1)
  value: US_F16D_Flight_of_3 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUS | unitSizeSection | unitRoleFWA | 1)
  value: US_F16D_Flight_of_4 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUS | unitSizePlatoon | unitRoleFWA | 1)

#   Su25 units 
  value: USSR_Su25_Flight_of_2 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUSSR | unitSizeSquad | unitRoleFWA )
  value: USSR_Su25_Flight_of_3 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUSSR | unitSizeSection | unitRoleFWA )
  value: USSR_Su25_Flight_of_4 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUSSR | unitSizePlatoon | unitRoleFWA )

#
# RWA Units
#
  value: US_AH64_Flight_of_2 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUS | unitSizeSquad | unitRoleRWA | 1)

  value: US_AH64_Flight_of_3 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUS | unitSizePlatoon | unitRoleRWA | 1)

  value: US_AH64_Flight_of_4 (objectDomainUnit | unitEnvironmentAir |
	 unitCountryUS | unitSizePlatoon | unitRoleAttackRWA | 4)

  value: US_AH64_Flight_of_5 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUS | unitSizeCompany | unitRoleRWA | 1)

  value: US_AH64_Flight_of_8 (objectDomainUnit | unitEnvironmentAir |
	 unitCountryUS | unitSizeCompany | unitRoleAttackRWA | 4)

  value: US_AH64D_Flight_of_2 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUS | unitSizeSquad | unitRoleRWA | 10)
 
  value: US_AH64D_Flight_of_3 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUS | unitSizePlatoon | unitRoleRWA | 10)
 
  value: US_AH64D_Flight_of_4 (objectDomainUnit | unitEnvironmentAir |
	 unitCountryUS | unitSizePlatoon | unitRoleAttackRWA | 5)
 
  value: US_AH64D_Flight_of_5 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUS | unitSizeCompany | unitRoleRWA | 10)
 
  value: US_AH64D_Flight_of_8 (objectDomainUnit | unitEnvironmentAir |
	 unitCountryUS | unitSizeCompany | unitRoleAttackRWA | 5)
 
  value: US_CH47D_Flight_of_2 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUS | unitSizeSquad | unitRoleRWA | 8)
 
  value: US_CH47D_Flight_of_3 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUS | unitSizePlatoon | unitRoleRWA | 8)
 
  value: US_CH47D_Flight_of_4 (objectDomainUnit | unitEnvironmentAir |
	 unitCountryUS | unitSizePlatoon | unitRoleRWA | 14)
 
  value: US_CH47D_Flight_of_5 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUS | unitSizeCompany | unitRoleRWA | 8)

  value: US_CH47D_Flight_of_8 (objectDomainUnit | unitEnvironmentAir |
	 unitCountryUS | unitSizeCompany | unitRoleRWA | 14)
 
  value: US_RAH66_LONGBOW_Flight_of_2 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUS | unitSizeSquad | unitRoleRWA | 13)
 
  value: US_RAH66_LONGBOW_Flight_of_3 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUS | unitSizePlatoon | unitRoleRWA | 13)
 
  value: US_RAH66_LONGBOW_Flight_of_4 (objectDomainUnit | unitEnvironmentAir |
	 unitCountryUS | unitSizePlatoon | unitRoleAttackRWA | 6)
 
  value: US_RAH66_LONGBOW_Flight_of_5 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUS | unitSizeCompany | unitRoleRWA | 13)
  value: US_RAH66_LONGBOW_Flight_of_8 (objectDomainUnit | unitEnvironmentAir |
	 unitCountryUS | unitSizeCompany | unitRoleAttackRWA | 6)
 
  value: US_OH58D_Flight_of_2 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUS | unitSizeSquad | unitRoleRWA | 2)

  value: US_OH58D_Flight_of_3 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUS | unitSizePlatoon | unitRoleRWA | 2)

  value: US_OH58D_Flight_of_4 (objectDomainUnit | unitEnvironmentAir |
	 unitCountryUS | unitSizePlatoon | unitRoleAttackRWA | 9)

  value: US_OH58D_Flight_of_5 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUS | unitSizeCompany | unitRoleRWA | 2)

  value: US_OH58D_Flight_of_8 (objectDomainUnit | unitEnvironmentAir |
	 unitCountryUS | unitSizeCompany | unitRoleAttackRWA | 9)

  value: US_RAH66_Flight_of_2 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUS | unitSizeSquad | unitRoleRWA | 3)

  value: US_RAH66_Flight_of_3 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUS | unitSizePlatoon | unitRoleRWA | 3)

  value: US_RAH66_Flight_of_4 (objectDomainUnit | unitEnvironmentAir |
	 unitCountryUS | unitSizePlatoon | unitRoleAttackRWA | 11)

  value: US_RAH66_Flight_of_5 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUS | unitSizeCompany | unitRoleRWA | 3)

  value: US_RAH66_Flight_of_8 (objectDomainUnit | unitEnvironmentAir |
	 unitCountryUS | unitSizeCompany | unitRoleAttackRWA | 11)

  value: US_UH60_Flight_of_2 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUS | unitSizeSquad | unitRoleRWA | 7)
 
  value: US_UH60_Flight_of_3 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUS | unitSizePlatoon | unitRoleRWA | 7)
 
  value: US_UH60_Flight_of_4 (objectDomainUnit | unitEnvironmentAir |
	 unitCountryUS | unitSizePlatoon | unitRoleRWA | 15)
 
  value: US_UH60_Flight_of_5 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUS | unitSizeCompany | unitRoleRWA | 7)

  value: US_UH60_Flight_of_8 (objectDomainUnit | unitEnvironmentAir |
	 unitCountryUS | unitSizeCompany | unitRoleRWA | 15)
 
  value: US_AH64_OH58D_Pair (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUS | unitSizeSquad | unitRoleRWA | 4)

  value: US_AH64_DI_Pair (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUS | unitSizeSquad | unitRoleRWA | 5)

  value: US_AH64_HMMWV_Pair (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUS | unitSizeSquad | unitRoleRWA | 6)

  value: USSR_Mi24_Flight_of_2 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUSSR | unitSizeSquad | unitRoleRWA | 1)

  value: USSR_Mi24_Flight_of_3 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUSSR | unitSizePlatoon | unitRoleRWA | 1)

  value: USSR_Mi24_Flight_of_4 (objectDomainUnit | unitEnvironmentAir |
	 unitCountryUSSR | unitSizePlatoon | unitRoleRWA | 5)

  value: USSR_Mi24_Flight_of_5 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUSSR | unitSizeCompany | unitRoleRWA | 1)

  value: USSR_Mi24_Flight_of_8 (objectDomainUnit | unitEnvironmentAir |
	 unitCountryUSSR | unitSizeCompany | unitRoleRWA | 5)
 
  value: USSR_Mi8_Flight_of_2 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUSSR | unitSizeSquad | unitRoleRWA | 2)

  value: USSR_Mi8_Flight_of_3 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUSSR | unitSizeCompany | unitRoleRWA | 2)

  value: USSR_Mi8_Flight_of_4 (objectDomainUnit | unitEnvironmentAir |
	 unitCountryUSSR | unitSizePlatoon | unitRoleRWA | 6)

  value: USSR_Mi8_Flight_of_5 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUSSR | unitSizePlatoon | unitRoleRWA | 2)

  value: USSR_Mi8_Flight_of_8 (objectDomainUnit | unitEnvironmentAir |
	 unitCountryUSSR | unitSizeCompany | unitRoleRWA | 6)
 
  value: USSR_Mi28_Flight_of_2 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUSSR | unitSizeSquad | unitRoleRWA | 3)

  value: USSR_Mi28_Flight_of_3 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUSSR | unitSizePlatoon | unitRoleRWA | 3)

  value: USSR_Mi28_Flight_of_4 (objectDomainUnit | unitEnvironmentAir |
	 unitCountryUSSR | unitSizePlatoon | unitRoleRWA | 7)

  value: USSR_Mi28_Flight_of_5 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUSSR | unitSizeCompany | unitRoleRWA | 3)

  value: USSR_Mi28_Flight_of_8 (objectDomainUnit | unitEnvironmentAir |
	 unitCountryUSSR | unitSizeCompany | unitRoleRWA | 7)
 
  value: USSR_Ka50_Flight_of_2 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUSSR | unitSizeSquad | unitRoleRWA | 4)

  value: USSR_Ka50_Flight_of_3 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUSSR | unitSizePlatoon | unitRoleRWA | 4)

  value: USSR_Ka50_Flight_of_4 (objectDomainUnit | unitEnvironmentAir |
	 unitCountryUSSR | unitSizePlatoon | unitRoleRWA | 8)

  value: USSR_Ka50_Flight_of_5 (objectDomainUnit | unitEnvironmentAir | 
	unitCountryUSSR | unitSizeCompany | unitRoleRWA | 4)

  value: USSR_Ka50_Flight_of_8 (objectDomainUnit | unitEnvironmentAir |
	 unitCountryUSSR | unitSizeCompany | unitRoleRWA | 8)
 


