#
# File:     veh_appear.cdf
# Contents: 
# System:   simnet development.
# Created:  8-Oct-1991
# Author:   jslee
#
# Remarks:
#
# History:
#    11/08/91	JSLee		Converted from veh_appear.drn

# $RCSfile: veh_appear.cdf,v $
# $Revision: 1.1.1.1 $
# $State: Exp $

# COPYRIGHT 1990 BBN Systems and Technologies Corporation
# 10 Moulton Street
# Cambridge, Ma. 02138
# 617-873-3000
#


##
# the first 16 bits pertain to all vehicles, the high order 16 bits
#   are vehicle-specific 

##
# Vehicle appearance modifiers pertaining to most vehicles: 
defs: vehAppear
  value: vehDestroyed		0x0001	# whether vehicle is blowed up 
  value: vehSmokePlume		0x0002	# whether burning with smoke 
  value: vehFlaming		0x0004	# whether burning with flames 
  value: vehMobilityDisabled	0x0020	# whether appears unable to move 
  value: vehFirepowerDisabled	0x0040	# whether appears unable to shoot 
  value: vehCommunicationDisabled 0x0080 # whether appears unable to chat 
  value: vehShaded               0x0100  # whether it is shaded 
  value: vehShredded             0x0200  # whether it is "shredded"  
					# (turret blown off, or     
					# some other dismemberment) 
  value: vehExploding		0x0400  # whether it is exploding 

# Vehicle appearance modifiers pertaining to ground vehicles: 
defs: vehAppearGround
  value: vehDustCloudMask	0x0018	# generation of a dust cloud 
  value: vehDustCloudNone	0x0000
  value: vehDustCloudSmall	0x0008
  value: vehDustCloudMedium	0x0010
  value: vehDustCloudLarge	0x0018

# Vehicle appearance modifiers pertaining to water vehicles: 
defs: vehAppearWater
  value: vehWakeMask		0x0018	# generation of a wake cloud 
  value: vehWakeNone		0x0000
  value: vehWakeSmall		0x0008
  value: vehWakeMedium		0x0010
  value: vehWakeLarge		0x0018

# Vehicle appearance modifiers pertaining to specific types of vehicles: 
defs: vehAppearM2M3
  value: vehTOWLauncherUp	0x40000000 # whether M2/3 launcher raised 

defs: vehAppearTEL
  value: vehLauncherUp          0x40000000 # whether TEL launcher raised 
  value: vehLauncherMissileOn   0x20000000 # whether TEL launcher missile on
# Four transitions for Hot to Cold states of TEL launcher pad
# 	(Hot&&Warm), (Hot), (Warm) and (none[Cold]).
  value: vehLauncherHot		0x10000000 # whether TEL launcher heated 
  value: vehLauncherWarm	0x08000000 # whether TEL launcher warm

defs: vehAppearT72
  value: vehEngineSmoke		0x80000000 # whether T-72 engine smokes

defs: vehAppearMICLIC
  value: munTailLineAttached    0x20000000 # whether tail line is attached to
                                           # a MICLIC rocket
defs: vehAppearRWA
  value: slingLoadStrapsUp	0x40000000 # whether sling load enroute 

defs: vehAppearAPC
  value: vehPrisonersOn		0x20000000 # whether M2 has hitch-hikers
  value: vehRampDown		0x40000000 # whether M106 has ramp down

defs: vehAppearMissile
  value: munIncandescent	0x40000000 # whether a missile is incandescent
					   # (glowing due to hyper velocity)

defs: vehAppearEngineering
  value: vehBridgeDisabled      0x01000000 # whether AVLB bridge appears 
				           # disabled
  value: vehShovelDisabled      0x02000000 # whether the Grizzly shovel 
					   # appears disabled.
  value: vehPrimMiclicDisabled  0x04000000 # whether the primary MICLIC 
					   # appears disabled.
  value: vehSecMiclicDisabled   0x08000000 # whether the secondary MICLIC 
					   # appears disabled.
  value: vehBladeSpoil          0x10000000 # whether bladespoil is displayed
  value: vehESMBpresent         0x00200000 # whether esmb is present.
  value: vehPrimMICLICpresent   0x00400000 # whether primary MICLIC present
  value: vehSecMICLICpresent    0x00800000 # whether secondary MICLIC present

# Echelon appearance modifiers pertaining to specific types of echelon: 
defs: vehAppearEchelon
  value: echIsSubsumed		0x80000000
  value: echSizeMask		0x18000000
  value: echSizeStandard	0x00000000
  value: echSizeHeavy		0x08000000
  value: echSizeUnitLess	0x10000000

# Lifeforms change positions, weapons, and actions 
defs: vehAppearLifeform
# 0111 1111 1111 1000
  value: lfModifierMask		0x7FF80000

# different positions for lifeForms 
# 0001 1000 0000 0000
  value: lfPositionMask	        0x18000000
  value: lfPositionUnknown	0x00000000
  value: lfPositionStanding	0x08000000
  value: lfPositionKneeling	0x10000000
  value: lfPositionProne	0x18000000

# different weapons for lifeForms 
# 0110 0000 0000 0000
  value: lfWeaponMask  		0x60000000
  value: lfWeaponNone		0x00000000
  value: lfWeaponMG		0x20000000
  value: lfWeaponRPG		0x40000000
  value: lfWeaponFlag		0x60000000

# different actions for lifeForms 
# 0000 0110 0000 0000
  value: lfActionMask		0x06000000
  value: lfActionNone		0x00000000
  value: lfActionFiring		0x02000000
  value: lfActionSurrendering   0x04000000

# Running sequence bits for lifeForms

# bit is set if simulator itself is setting the Run Position Sequence bits
# Otherwise, observer sets the bits
# 0000 0001 0000 0000
  value: lfRemoteMotionSimul	0x01000000

# 5 bits to be used by libmotion + veh map to select the desired visual model
# 0000 0000 1111 1000 0000 0000 0000 0000
  value: lfRunSequenceMask      0x00F80000
  value: lfRunSequenceShift	19

##############################
# Atlas-specific DI extensions. These will overlay the bits
# used by the weapons and the Run Sequence information.
##############################

defs: vehAppearLifeformAE
# Whether weapon1 and/or weapon2 are deployed.
# ***Overlays the standard lifeForms weapons specification***
# 0110 0000 0000 0000 0000 0000 0000 0000
  value: lfAEUseWeaponsMask	0x60000000
  value: lfAEUseWeaponsShift    29
  value: lfAEUseNoWeapons	0x00000000
  value: lfAEUseWeapon1		0x20000000
  value: lfAEUseWeapon2		0x40000000
  value: lfAEUseBothWeapons     0x60000000 # May not make sense

# Whether or not the lifeform is deactivated.
# ***Overlays a bit in the Run Sequence***
# 0000 0000 0000 1000 0000 0000 0000 0000
  value: lfAEDeactivateMask	0x00080000
  value: lfAEDeactivateShift    19
  value: lfAEActivated		0x00000000
  value: lfAEDeactivated	0x00080000

# Different position extensions for (un)mounted state of DI
# Should only be non-0  when value of 0 in lfPosition bits.
# ***Overlays bits in the Run Sequence***
# 0000 0000 0011 0000 0000 0000 0000 0000
  value: lfAEMountMask		0x00300000
  value: lfAEMountShift		20
  value: lfAEMountInvalid	0x00000000	 
  value: lfAEMountDismounting	0x00100000
  value: lfAEMountMounting	0x00200000
  value: lfAEMountMounted	0x00300000

# Formations used by the "DI 6-packs"
# ***Overlays bits in the Run Sequence***
# 0000 0000 1100 0000 0000 0000 0000 0000
  value: lfAEFormationMask	0x00C00000
  value: lfAEFormationShift	22
  value: lfAEFormationOther	0x00000000
  value: lfAEFormationReihe	0x00400000  # Staggered-column
  value: lfAEFormationRudel	0x00800000  # Line
  value: lfAEFormationDefense	0x00C00000  # In Defensive Position


# Minefield appearance modifiers pertaining to minefield perimeter: 
defs: vehAppearMinefield
  value: minefieldAP  		0x0001  # minefield is pure AP 
  value: minefieldAT  		0x0002  # minefield is pure AT
  value: minefieldInactive      0x0004  # minefield is pure inactive 
  value: minefieldLane          0x0008  # minefield has inactive lane
  value: minefieldDeactivate    0x2000  # deactivate bit
