#
# File:     veh_type.cdf
# Contents: 
# System:   simnet development.
# Created:  8-Oct-1991
# Author:   jslee
#
# Remarks:
#
# History:
#    11/08/91	JSLee		Converted from veh_type.drn

# $RCSfile: veh_type.cdf,v $
# $Revision: 1.1.1.1 $
# $State: Exp $

# COPYRIGHT 1990 BBN Systems and Technologies Corporation
# 10 Moulton Street
# Cambridge, Ma. 02138
# 617-873-3000
#

needs: obj_type.cdf

namespace_def: vehicle

# Stealth vehicle 
  value: Stealth (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassLighterThanAir | vehicleCountryOther |
     1 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionAirRecon)
# -- 
#  U.S. vehicles. 
# -- 
#  air vehicles  
# -- 
# A-10 fixed-wing aircraft:  
  value: US_A10 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUS |
     1 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionGroundAttack)
  value: US_A10A_AFSAF (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUS |
     1 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionGroundAttack)
# US FWA_RECON fixed-wing aircraft:  
  value: US_FWA_RECON (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUS |
     20 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionAirRecon)
# F16A fixed-wing aircraft:  
  value: US_F16A (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUS |
     2 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionAirCombat)
# F16B fixed-wing aircraft:  
  value: US_F16B (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUS |
     2 << vehicleSeriesShift | 2 << vehicleModelShift |
     vehicleFunctionAirCombat)
# F16C fixed-wing aircraft:  
  value: US_F16C (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUS |
     2 << vehicleSeriesShift | 3 << vehicleModelShift |
     vehicleFunctionAirCombat)
# F16D fixed-wing aircraft:  
  value: US_F16D (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUS |
     2 << vehicleSeriesShift | 4 << vehicleModelShift |
     vehicleFunctionAirCombat)
# F16C fixed-wing aircraft for AFSAF:  
  value: US_F16C_AFSAF (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUS |
     2 << vehicleSeriesShift | 5 << vehicleModelShift |
     vehicleFunctionAirCombat)
# US F-14A Tomcat Fighter Jet  
  value: US_F14A (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUS |
     3 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionAirCombat)
# US F-14D Tomcat Fighter Jet with IR  
  value: US_F14D (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUS |
     3 << vehicleSeriesShift | 2 << vehicleModelShift |
     vehicleFunctionAirCombat)
# US F-15E Eagle Fighter  
  value: US_F15E (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUS |
     4 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionAirCombat)
# US F-20 Tigershark Fighter  
  value: US_F20 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUS |
     5 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionAirCombat)
# US F-4S Phantom Fighter  
  value: US_F4S (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUS |
     6 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionAirCombat)
# US F-5F Tiger II Fighter  
  value: US_F5F (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUS |
     7 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionAirCombat)
# A-7 Fighter  
  value: US_A7 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUS |
     8 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionAirCombat)
# F/A 18 Fighter/Bomber 
  value: US_FA18 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUS |
     9 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionAirCombat)

# Marine fixed wing aircraft 
# Marine AV-8B  
  value: USMC_AV8B (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUS |
     10 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionGroundAttack)
# Marine F/A 18  
  value: USMC_FA18 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUS |
     11 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionAirCombat)

# Pioneer Recon RPV  
  value: US_PioneerRPV (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUS |
     8 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionAirRecon)

# x-ASTAMIDS (mine detection system mounted on a UAV)
  value: US_ASTAMIDS (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUS |                
     (8 << vehicleSeriesShift) | (1 << vehicleModelShift) | 
     vehicleFunctionAirRecon)

# US E-8A JSTARS 
  value: US_E8A (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUS |
     9 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionAirRecon)
# US TR-1A Tactical Reconnaissance  
  value: US_TR1A (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUS |
     10 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionAirRecon)
# US TR-1B Tactical Reconnaissance  
  value: US_TR1B (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUS |
     10 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionAirRecon)
# US KC-10A Extender 
  value: US_KC10A (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUS |
     11 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionAirTanker)
# US E-3 Sentry AWACS 
  value: US_E3 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUS |
     12 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionAWACS)
# US E-2C  
  value: US_E2C (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUS |
     12 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionAWACS)
# US EF-111A  
  value: US_EF111A (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUS |
     13 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionElectronicWarfare)
# US F-4G Advanced Wild Weasle 
  value: US_F4G (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUS |
     14 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionElectronicWarfare)
# B52 fixed-wing aircraft:  
  value: US_B52 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUS |
     15 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionGroundAttack)
# US A6 fixed-wing aircraft:  
  value: US_A6 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUS |
     16 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionAirCombat)
# US V22 Osprey Tilt-Rotor Airplane: 
  value: US_V22 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUS |
     17 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionGroundAttack)
# US C130 Cargo Aircraft: 
  value: US_C130 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUS |
     18 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionAirCargo)
# US X31 Experimental Fighter Aircraft: 
  value: US_X31 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUS |
     19 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionAirCombat)
# AH-64 helicopter:  
  value: US_AH64 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassRotaryWing | vehicleCountryUS |
     1 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionGroundAttack)

# AH-1J helicopter:  
  value: USMC_AH1J (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassRotaryWing | vehicleCountryUS |
     4 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionGroundAttack)

# RAH-66 helicopter (Commanche):  
  value: US_RAH66 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassRotaryWing | vehicleCountryUS |
     2 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionGroundAttack)
# AH-64D  helicopter: 
  value: US_AH64D (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassRotaryWing | vehicleCountryUS |
     1 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionGroundAttack)
# RAH-66 Longbow helicopter (Commanche):  
  value: US_RAH66_LONGBOW (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassRotaryWing | vehicleCountryUS |
     2 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionGroundAttack)
# OH-58 helicopter:  
  value: US_OH58D (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassRotaryWing | vehicleCountryUS |
     2 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionAirRecon)
# OH-58C Kiowa helicopter (no Mast Mounted Sight)  
  value: US_OH58C (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassRotaryWing | vehicleCountryUS |
     2 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionAirRecon)
# UH-1 helicopter:  
  value: USMC_UH1 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassRotaryWing | vehicleCountryUS |
     6 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionAirUtility)
# CH-46E helicopter:  
  value: USMC_CH46E (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassRotaryWing | vehicleCountryUS |
     5 << vehicleSeriesShift | 2 << vehicleModelShift |
     vehicleFunctionAirCargo)
# CH-53D helicopter:  
  value: USMC_CH53D (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassRotaryWing | vehicleCountryUS |
     5 << vehicleSeriesShift | 3 << vehicleModelShift |
     vehicleFunctionAirCargo)
# CH-53E helicopter:  
  value: USMC_CH53E (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassRotaryWing | vehicleCountryUS |
     5 << vehicleSeriesShift | 4 << vehicleModelShift |
     vehicleFunctionAirCargo)
# AH-1 Cobra helicopter:  
  value: US_AH1 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassRotaryWing | vehicleCountryUS |
     3 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionGroundAttack)
# UH-60 Blackhawk helicopter:  
  value: US_UH60 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassRotaryWing | vehicleCountryUS |
     4 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionAirUtility)
# SH-60 Sea Blackhawk helicopter:  
  value: US_SH60 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassRotaryWing | vehicleCountryUS |
     4 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionAirUtility)
# CH-47 Chinook helicopter:  
  value: US_CH47 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassRotaryWing | vehicleCountryUS |
     5 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionAirCargo)
# CH-47D Chinook helicopter: 
  value: US_CH47D (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassRotaryWing | vehicleCountryUS |
     5 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionAirCargo)
# MH-53E Mine Warefare helicopter 
  value: US_MH53E (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassRotaryWing | vehicleCountryUS |
     5 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionMineCtrMes)

# ******Forward Air Controller Vehicles ***** 
# Gunless M2 being a FAC: 
  value: US_FAC_TRACKED (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     1 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionAirControl)
# Gunless BMP2 being a FAC: 
  value: USSR_FAC_TRACKED (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUSSR |
     1 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionAirControl)
# HMMWV being a FAC: 
  value: US_FAC_WHEELED (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUS |
     1 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionAirControl)
# ZIL131 being a FAC: 
  value: USSR_FAC_WHEELED (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUSSR |
     1 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionAirControl)
# **************** Armored Tracked Ground Vehicles ********** 
# M1 (Abrams) main battle tank:  
  value: US_M1 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     1 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionMainBattleTank)
# M1_CPS (M1 with stingray device) 
  value: US_M1_CPS (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     1 << vehicleSeriesShift | 3 << vehicleModelShift |
     vehicleFunctionMainBattleTank)
# XM8 US Armored Gun System (light tank)   
  value: US_XM8 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     1 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionLightTank)
# M1A1 main battle tank:  
  value: US_M1A1 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     1 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionMainBattleTank)
# M1A2 main battle tank:  
  value: US_M1A2 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     1 << vehicleSeriesShift | 2 << vehicleModelShift |
     vehicleFunctionMainBattleTank)
# M-60 main battle tank:  
  value: US_M60 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     2 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionMainBattleTank)
# Armored Gun System, basically M1 turret on M2 chassis 
  value: US_AGS (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     7 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionMainBattleTank)
# AVLB Combat Engineering vehicle 
  value: US_AVLB (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     2 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionCombatEngineer)
# CEV Combat Engineering vehicle M728 
  value: US_CEV (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     3 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionCombatEngineer)
# AVLM Combat Engineering vehicle 
  value: US_AVLM (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     4 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionCombatEngineer)
# ACE Armored Combat Earthmover (M9 ACE)  
  value: US_ACE (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     5 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionCombatEngineer)
# GRIZZLY Combat Engineering vehicle 
  value: US_GRIZZLY (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     1 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionCombatEngineer)
# HAB Combat Engineering vehicle 
  value: US_HAB (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     6 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionCombatEngineer)
# M2 (Bradley) infantry fighting vehicle:  
  value: US_M2 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     2 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionPersonnelCarrier)
# M3 (Bradley) calvary fighting vehicle:  
  value: US_M3 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     2 << vehicleSeriesShift | 2 << vehicleModelShift |
     vehicleFunctionPersonnelCarrier)
# M2 (Bradley) Stinger infantry fighting vehicle:  
  value: US_M2_Stinger (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     2 << vehicleSeriesShift | 3 << vehicleModelShift |
     vehicleFunctionAntiAircraft)
# M3A3 (Bradley) calvary fighting vehicle: 
  value: US_M3A3 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     2 << vehicleSeriesShift | 3 << vehicleModelShift |
     vehicleFunctionPersonnelCarrier)
# M113A2 armored personnel carrier:  
  value: US_M113A2 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     3 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionPersonnelCarrier)
# M113 FIST fire support vehicle:  
  value: US_M113_FIST (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     3 << vehicleSeriesShift | 2 << vehicleModelShift |
     vehicleFunctionPersonnelCarrier)
# M113 ambulance:  
  value: US_M113_ambulance (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     3 << vehicleSeriesShift | 3 << vehicleModelShift |
     vehicleFunctionPersonnelCarrier)
# M113 engineering vehicle:  
  value: US_M113_engineer (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     3 << vehicleSeriesShift | 4 << vehicleModelShift |
     vehicleFunctionPersonnelCarrier)
# M981 FIST-V fire support vehicle:  
  value: US_M981 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     3 << vehicleSeriesShift | 5 << vehicleModelShift |
     vehicleFunctionPersonnelCarrier)
# M992 FAASV Field Artillery Ammunition Supply Vehicle:  
  value: US_M992 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     3 << vehicleSeriesShift | 6 << vehicleModelShift |
     vehicleFunctionPersonnelCarrier)

# Marine ground vehicles 
# Marine AAV Amphibious Armored Vehicle:  
  value: USMC_AAV (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     5 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionPersonnelCarrier)
# Marine C2 AAV (Commander Amphibious Armored Tracked Vehicle):  
  value: USMC_AAV_C2 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     5 << vehicleSeriesShift | 2 << vehicleModelShift |
     vehicleFunctionPersonnelCarrier)
  value: USMC_AAV_MINE (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     5 << vehicleSeriesShift | 3 << vehicleModelShift |
     vehicleFunctionPersonnelCarrier)
# Marine AAV Amphibious Armored Vehicle:  
  value: USMC_AAV_REC (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     5 << vehicleSeriesShift | 4 << vehicleModelShift |
     vehicleFunctionRecovery)
# Marine LAV Light Armored Vehicle:  
  value: USMC_LAV_25 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredWheeled | vehicleCountryUS |
     6 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionPersonnelCarrier)
# Marine C2 LAV (Commander Light Assault Wheeled Vehicle):  
  value: USMC_LAV_C2 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredWheeled | vehicleCountryUS |
     6 << vehicleSeriesShift | 2 << vehicleModelShift |
     vehicleFunctionPersonnelCarrier)
  value: USMC_LAV_AT (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredWheeled | vehicleCountryUS |
     6 << vehicleSeriesShift | 3 << vehicleModelShift |
     vehicleFunctionPersonnelCarrier)
  value: USMC_LAV_Mortar (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredWheeled | vehicleCountryUS |
     6 << vehicleSeriesShift | 4 << vehicleModelShift |
     vehicleFunctionPersonnelCarrier)
# Marine IHAWK Launcher:  
  value: USMC_IHAWK_Lchr (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredWheeled | vehicleCountryUS |
     6 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionAntiAircraft)
# Marine artillery:  
  value: USMC_M198 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassTowed | vehicleCountryUS |
     2 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionHowitzer)


# M577 command post:  
  value: US_M577 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     3 << vehicleSeriesShift | 2 << vehicleModelShift |
     vehicleFunctionCommandPost)
# M577A1 command post:  
  value: US_M577A1 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     3 << vehicleSeriesShift | 3 << vehicleModelShift |
     vehicleFunctionCommandPost)

# HTI - added for MC-SAF 
# M224 60mm mortar 
  value: USMC_M224 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassCarried | vehicleCountryUS |
     1 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionMortar)
# M252 81mm mortar 
  value: USMC_M252 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassCarried | vehicleCountryUS |
     1 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionMortar)
# end HTI 


# Crusader Platoon Operations Center M577A1:  
  value: US_Crusader_M577A1 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     3 << vehicleSeriesShift | 4 << vehicleModelShift |
     vehicleFunctionCommandPost)
# M577A1_FDC:  
  value: US_M577A1_FDC (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     3 << vehicleSeriesShift | 5 << vehicleModelShift |
     vehicleFunctionCommandPost)
# M577A1_CCSIL_FDC:  
  value: US_M577A1_CCSIL_FDC (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     3 << vehicleSeriesShift | 6 << vehicleModelShift |
     vehicleFunctionCommandPost)
# Battalion Fire Support Officer M577A1_FSO:  
  value: US_M577A1_FSO (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     3 << vehicleSeriesShift | 7 << vehicleModelShift |
     vehicleFunctionCommandPost)
# The RFPI Battalion commander 
  value: US_RC2T (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUS |
     3 << vehicleSeriesShift | 7 << vehicleModelShift |
     vehicleFunctionCommandPost)
# M106A1 mortar carrier:  
  value: US_M106A1 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     3 << vehicleSeriesShift | 3 << vehicleModelShift |
     vehicleFunctionMortar)
# M252 81mm mortar, carried on a HMMWV:  
  value: US_M252 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUS |
     3 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionMortar)
# M120 120mm mortar, towed by a HMMWV:  
  value: US_M120 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUS |
     3 << vehicleSeriesShift | 2 << vehicleModelShift |
     vehicleFunctionMortar)
# M1064 mortar carrier with M121 120mm mortar:  
  value: US_M1064 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     3 << vehicleSeriesShift | 4 << vehicleModelShift |
     vehicleFunctionMortar)
# Precision Guided Mortar 
  value: US_PGM_Mortar (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassTowed | vehicleCountryUS |
     3 << vehicleSeriesShift | 5 << vehicleModelShift |
     vehicleFunctionMortar)
# M109 155mm howitzer:  
  value: US_M109 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     4 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionHowitzer)
# M109A1 155mm howitzer:  
  value: US_M109A1 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     4 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionHowitzer)
# M109A3 155mm howitzer:  
  value: US_M109A3 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     4 << vehicleSeriesShift | 3 << vehicleModelShift |
     vehicleFunctionHowitzer)
# M109A5 155mm howitzer:  
  value: US_M109A5 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     4 << vehicleSeriesShift | 5 << vehicleModelShift |
     vehicleFunctionHowitzer)
# M109A6 155mm howitzer: 
  value: US_M109A6 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     4 << vehicleSeriesShift | 6 << vehicleModelShift |
     vehicleFunctionHowitzer)
# M198 155mm howitzer: 
  value: US_M198 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassTowed | vehicleCountryUS |
     1 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionHowitzer)
# Lightweight Automated Howitzer, Howitzer 155 with SADARM 
  value: US_LAH_SADARM (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassTowed | vehicleCountryUS |
     4 << vehicleSeriesShift | 7 << vehicleModelShift |
     vehicleFunctionHowitzer)
# M88A1 recovery vehicle:  
  value: US_M88A1 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     5 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionRecovery)
# ADATS vehicle:  
  value: US_ADATS (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     6 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionAntiAircraft)
# M35A2 FDC truck: 
  value: US_M35A2_FDC (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUS |
     3 << vehicleSeriesShift | 5 << vehicleModelShift |
     vehicleFunctionCommandPost)
# M923 5-ton Cargo truck: 
  value: US_M923 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUS |
     1 << vehicleSeriesShift | 6 << vehicleModelShift |
     vehicleFunctionSupplyTruck)
# M911 heavy equipment transporter : 
  value: US_M911 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUS |
     1 << vehicleSeriesShift | 7 << vehicleModelShift |
     vehicleFunctionSupplyTruck)
# LOSAT vehicle:  
  value: US_LOSAT (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     7 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionAT)
# Stingray vehicle:  
  value: US_Stingray (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     8 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionTankDestroyer)
# ************** Unarmored Wheeled Ground Vehicles ************** 
# LVSFuel fuel carrier:  
  value: USMC_LVSFuel (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUS |
     2 << vehicleSeriesShift | 7 << vehicleModelShift |
     vehicleFunctionSupplyTruck)
# LVSCargo cargo carrier:  
  value: USMC_LVSCargo (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUS |
     2 << vehicleSeriesShift | 6 << vehicleModelShift |
     vehicleFunctionSupplyTruck)
# Crusader 155mm Self Propelled howitzer:  
  value: US_Crusader_SPH (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     9 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionHowitzer)
# Crusader -- resupply vehicle:  
  value: US_Crusader_RSV (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     9 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionSupplyTruck)
# ************** Armored Wheeled Ground Vehicles ************** 
# M93 (Fox NBCRS vehicle) 
  value: US_M93_Fox (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredWheeled | vehicleCountryUS |
     1 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionNBCRecon)
# ************** Unarmored Wheeled Ground Vehicles ************** 
# M35A2 2.5-ton supply truck:  
  value: US_M35A2 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUS |
     1 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionSupplyTruck)
# M984A1 HEMMT Wrecker : 
  value: US_M984A1 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUS |
     2 << vehicleSeriesShift | 5 << vehicleModelShift |
     vehicleFunctionSupplyTruck)
# M977 cargo carrier:  
  value: US_M977 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUS |
     2 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionSupplyTruck)
# Crusader M977 cargo carrier for use at LRP:  
  value: US_Crusader_M977 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUS |
     2 << vehicleSeriesShift | 4 << vehicleModelShift |
     vehicleFunctionSupplyTruck)
# M978 fuel carrier:  
  value: US_M978 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUS |
     2 << vehicleSeriesShift | 2 << vehicleModelShift |
     vehicleFunctionSupplyTruck)
# M979 ammo carrier:  
  value: US_M979 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUS |
     2 << vehicleSeriesShift | 3 << vehicleModelShift |
     vehicleFunctionSupplyTruck)
# HMMWV (the new "Jeep")  
  value: US_HMMWV (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUS |
     3 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionGroundUtility)
# USMC_HMMWV vehicle:  
  value: USMC_HMMWV (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUS |
     3 << vehicleSeriesShift | 10 << vehicleModelShift |
     vehicleFunctionGroundRecon)
# USMC_HMMWV with .50 cal machine gun vehicle:  
  value: USMC_HMMWVTOW (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUS |
     3 << vehicleSeriesShift | 2 << vehicleModelShift |
     vehicleFunctionGroundRecon)
# USMC_HMMWV with .50 cal machine gun vehicle:  
  value: USMC_HMMWV50 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUS |
     3 << vehicleSeriesShift | 7 << vehicleModelShift |
     vehicleFunctionGroundRecon)
# USMC_HMMWV with 40 mm cal machine gun vehicle:  
  value: USMC_HMMWV40 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUS |
     3 << vehicleSeriesShift | 6 << vehicleModelShift |
     vehicleFunctionGroundRecon)
# Outrider (HMMWV with stingray device) 
  value: US_Outrider (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUS |
     3 << vehicleSeriesShift | 6 << vehicleModelShift |
     vehicleFunctionAT)
# HMMWV-LaserDsg (the new "Jeep" with laserdsg) 
  value: US_HMMWV_LaserDsg (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUS |
     3 << vehicleSeriesShift | 5 << vehicleModelShift |
     vehicleFunctionAT)
# HMMWV-FDC 
  value: US_HMMWV_FDC (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUS |
     3 << vehicleSeriesShift | 9 << vehicleModelShift |
     vehicleFunctionCommandPost)
# HMMWV-CCSIL-FO 
  value: US_HMMWV_CCSIL_FO (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUS |
     3 << vehicleSeriesShift | 8 << vehicleModelShift |
     vehicleFunctionCommandPost)
# HMMWV-Ambulance (HMMWV ambulance) M997 
  value: US_HMMWV_AMBUL (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUS |
     3 << vehicleSeriesShift | 7 << vehicleModelShift |
     vehicleFunctionGroundUtility)
# ORSMC (a modified HMMWV)  
  value: US_ORSMC (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUS |
     3 << vehicleSeriesShift | 9 << vehicleModelShift |
     vehicleFunctionCombatEngineer)
# VMMD (a modified HMMWV) 
  value: US_VMMD (objectDomainVehicle | vehicleEnvironmentGround |           
     vehicleClassSPUnarmoredWheeled | vehicleCountryUS |        
     (3 << vehicleSeriesShift) | (10 << vehicleModelShift) |     
     vehicleFunctionCombatEngineer)
# GBS-FAAD   
  value: US_GBSFAAD (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUS |
     3 << vehicleSeriesShift | 4 << vehicleModelShift |
     vehicleFunctionGroundUtility)
# NLOS US Non-Line-of-Sight Vehicle, a HMMWV with NLOS Launcher 
  value: US_NLOS (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUS |
     3 << vehicleSeriesShift | 2 << vehicleModelShift |
     vehicleFunctionTankDestroyer)
# Avenger HMMWV forward area air defense (FAAD)  
  value: US_Avenger (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUS |
     3 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionAntiAircraft)
# Civilian Bus 
  value: US_Bus (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUS |
     4 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionPersonnelCarrier)
# Civilian Car 
  value: US_Car (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUS |
     4 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionPersonnelCarrier)
# Virtual remote sentry for RFPI 
  value: US_VIRT_REMOTE_SENTRY (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUS |
     1 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionGroundRecon)
# Hunter virtual prototype system 
  value: US_HunterVPS (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUS |
     3 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionGroundRecon)
# ************** Towed Ground Entities ************** 
# M57 mine layer:  
  value: US_M57 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassTowed | vehicleCountryUS |
     1 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionCombatEngineer)
# M128 GEMSS mine layer:  
  value: US_M128 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassTowed | vehicleCountryUS |
     2 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionCombatEngineer)
# M58A1 mine clearing line charge:  
  value: US_M58A1 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassTowed | vehicleCountryUS |
     3 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionCombatEngineer)
# M353 Trailer (with MICLIC)
  value: US_M353_MICLIC  (objectDomainVehicle | vehicleEnvironmentGround |
      vehicleClassTowed | vehicleCountryUS |
      (5 << vehicleSeriesShift) | (0 << vehicleModelShift) |
      vehicleFunctionCombatEngineer)
# M1073 Trailer (with ESMB)
  value: US_M1073_ESMB  (objectDomainVehicle | vehicleEnvironmentGround |
      vehicleClassTowed | vehicleCountryUS |
      (6 << vehicleSeriesShift) | (0 << vehicleModelShift) |
      vehicleFunctionCombatEngineer)
# M? towed pallet  
  value: US_PALLET (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassTowed | vehicleCountryUS |
     4 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionSupplyTruck)
# M105 1- 1/2 Ton Cargo Trailer 
  value: US_M105 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassTowed | vehicleCountryUS |
     4 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionSupplyTruck)
# HET_Trailer Semi-Trailer for a HET 
  value: US_HET_Trailer (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassTowed | vehicleCountryUS |
     4 << vehicleSeriesShift | 2 << vehicleModelShift |
     vehicleFunctionSupplyTruck)
# M127 Stake and Platform  Semi-Trailer for a 5-Ton Tractor Truck 
  value: US_M127 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassTowed | vehicleCountryUS |
     4 << vehicleSeriesShift | 3 << vehicleModelShift |
     vehicleFunctionSupplyTruck)
# ************** Towed Air Entities ************** 
# A22 Sling Load  
  value: US_A22 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassTowed | vehicleCountryUS |
     1 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionSupplyTruck)
# ************** US Rocket launchers ***************** 
# M270 MLRS (Multiple Launch Rocket System):  
  value: US_M270 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     1 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionRocketLauncher)
# M270_M26 MLRS (Multiple Launch Rocket System):  
  value: US_M270_M26 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     1 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionRocketLauncher)
# M270_M77 MLRS (Multiple Launch Rocket System):  
  value: US_M270_M77 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     1 << vehicleSeriesShift | 2 << vehicleModelShift |
     vehicleFunctionRocketLauncher)
# M270_GAT2 MLRS (Multiple Launch Rocket System):  
  value: US_M270_GAT2 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUS |
     1 << vehicleSeriesShift | 3 << vehicleModelShift |
     vehicleFunctionRocketLauncher)
# Multiple Platform Launcher 
  value: US_MPL_Launcher (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUS |
     1 << vehicleSeriesShift | 4 << vehicleModelShift |
     vehicleFunctionRocketLauncher)
# US Missile Launchers 
# Patriot Launcher 
  value: US_M901 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassTowed | vehicleCountryUS |
     0 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionAntiAircraft)
# Tow launcher mounted on a HMMWV 
  value: US_TOW_Launcher (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUS |
     1 << vehicleSeriesShift | 2 << vehicleModelShift |
     vehicleFunctionSSMissileLauncher)
# US Missile Radars 
# Patriot Radar 
# phased array - surveillance, IFF, tracking and guidance 
  value: US_MPQ53 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassTowed | vehicleCountryUS |
     0 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionRadar)
# ************** end ground vehicles ************************ 
# ******************** ENV: water *************************** 
# Amphib warfare ships  
  value: USSWaspClass (1 << vehicleSeriesShift)
  value: USSBlueRidgeClass (2 << vehicleSeriesShift)
  value: USSTawaraClass (3 << vehicleSeriesShift)
  value: USSIwoJimaClass (4 << vehicleSeriesShift)
  value: USSCharlestonClass (5 << vehicleSeriesShift)
  value: USSRalieghClass (6 << vehicleSeriesShift)
  value: USSAustinClass (7 << vehicleSeriesShift)
  value: USSThomastonClass (8 << vehicleSeriesShift)
  value: USSAnchorageClass (9 << vehicleSeriesShift)
  value: USSWhidbeyIslandClass (10 << vehicleSeriesShift)
  value: USSNewportClass (11 << vehicleSeriesShift)
  value: USSLPD17Class (12 << vehicleSeriesShift)
  value: USSLCACClass (13 << vehicleSeriesShift)
  value: USSLCUClass (14 << vehicleSeriesShift)
  value: USSAAVClass (15 << vehicleSeriesShift)

# Amphibious Assault 

# LHA 1 - USS Tawara assault  
  value: US_LHA1 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassAmphibWarfare | vehicleCountryUS |
     vehicle_USSTawaraClass | 1 << vehicleModelShift |
     vehicleFunctionAmphibAssault)

# LPH 2 - USS Iwo Jima  
  value: US_LPH2 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassAmphibWarfare | vehicleCountryUS |
     vehicle_USSIwoJimaClass | 1 << vehicleModelShift |
     vehicleFunctionAmphibAssault)

# LHD 1- USS WASP  
  value: US_LHD1 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassAmphibWarfare | vehicleCountryUS |
     vehicle_USSWaspClass | 1 << vehicleModelShift |
     vehicleFunctionAmphibAssault)

# LHD2 - USS Essex  
  value: US_LHD2 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassAmphibWarfare | vehicleCountryUS |
     vehicle_USSWaspClass | 2 << vehicleModelShift |
     vehicleFunctionAmphibAssault)

# Amphibious Command 

# LCC 19 - USS Blue Ridge 
  value: US_LCC19 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassAmphibWarfare | vehicleCountryUS |
     vehicle_USSBlueRidgeClass | 1 << vehicleModelShift |
     vehicleFunctionAmphibCommand)

# Amphibious Cargo 

# LKA 113 - USS Charleston 
  value: US_LKA113 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassAmphibWarfare | vehicleCountryUS |
     vehicle_USSCharlestonClass | 1 << vehicleModelShift |
     vehicleFunctionAmphibCargo)

# Transport Dock 

# LPD 17 - USS ?? Multi-purpose Amphib 
  value: US_LPD17 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassAmphibWarfare | vehicleCountryUS |
     vehicle_USSLPD17Class | 1 << vehicleModelShift |
     vehicleFunctionAmphibTransport)

# Dock Landing 

# LSD 49 - USS Harpers Ferry 
  value: US_LSD49 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassAmphibWarfare | vehicleCountryUS |
     vehicle_USSWhidbeyIslandClass | 1 << vehicleModelShift |
     vehicleFunctionDockLanding)

# Landing Craft 

# LCAC 
  value: US_LCAC (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassAmphibWarfare | vehicleCountryUS |
     vehicle_USSLCACClass | 1 << vehicleModelShift |
     vehicleFunctionLanding)

# LCU 
  value: US_LCU (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassAmphibWarfare | vehicleCountryUS |
     vehicle_USSLCUClass | 1 << vehicleModelShift |
     vehicleFunctionLanding)

# AAV 
  value: US_AAV (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassAmphibWarfare | vehicleCountryUS |
     vehicle_USSAAVClass | 1 << vehicleModelShift |
     vehicleFunctionLanding)


# Surface combatants  
  value: USSSpruanceClass (1 << vehicleSeriesShift)
  value: USSTiconderogaClass (2 << vehicleSeriesShift)
  value: USSNimitzClass (3 << vehicleSeriesShift)
  value: USSIowaClass (4 << vehicleSeriesShift)
  value: USSBelknapClass (5 << vehicleSeriesShift)
  value: USSLeahyClass (6 << vehicleSeriesShift)
  value: USSVirginiaClass (7 << vehicleSeriesShift)
  value: USSCaliforniaClass (8 << vehicleSeriesShift)
  value: USSTruxtunClass (9 << vehicleSeriesShift)
  value: USSBainbridgeClass (10 << vehicleSeriesShift)
  value: USSLongBeachClass (11 << vehicleSeriesShift)
  value: USSKittyHawkClass (12 << vehicleSeriesShift)
  value: USSForrestalClass (13 << vehicleSeriesShift)
  value: USSMidwayClass (14 << vehicleSeriesShift)
  value: USSEnterpriseClass (15 << vehicleSeriesShift)
  value: USSArleighBurkeClass (16 << vehicleSeriesShift)
  value: USSKiddClass (17 << vehicleSeriesShift)
  value: USSCoontzClass (18 << vehicleSeriesShift)
  value: USSCharlesFAdamsClass (19 << vehicleSeriesShift)
  value: USSKnoxClass (20 << vehicleSeriesShift)
  value: USSGarciaClass (21 << vehicleSeriesShift)
  value: USSPegasusClass (22 << vehicleSeriesShift)
  value: USSOliverHazardPerryClass (23 << vehicleSeriesShift)
  value: USSBrookeClass (24 << vehicleSeriesShift)
  value: USSArsenalClass (25 << vehicleSeriesShift)
  value: AssadClass (26 << vehicleSeriesShift)
  value: LupoClass (27 << vehicleSeriesShift)

# Carriers 

# CV41 - USS Midway carrier  
  value: US_CV41 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSMidwayClass | 1 << vehicleModelShift |
     vehicleFunctionCarrier)
# CV42 - USS Coral Sea carrier  
  value: US_CV42 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSMidwayClass | 2 << vehicleModelShift |
     vehicleFunctionCarrier)

# CV59 - USS Forrestal carrier  
  value: US_CV59 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSForrestalClass | 1 << vehicleModelShift |
     vehicleFunctionCarrier)

# CV63 - USS Kitty Hawk carrier 
  value: US_CV63 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSKittyHawkClass | 1 << vehicleModelShift |
     vehicleFunctionCarrier)
# CV64 - USS Constellation carrier  
  value: US_CV64 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSKittyHawkClass | 2 << vehicleModelShift |
     vehicleFunctionCarrier)
# CV66 - USS America carrier  
  value: US_CV66 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSKittyHawkClass | 3 << vehicleModelShift |
     vehicleFunctionCarrier)

# CVN65 - USS Enterprise carrier  
  value: US_CVN65 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSEnterpriseClass | 1 << vehicleModelShift |
     vehicleFunctionCarrier)

# CVN 68 - USS Nimitz carrier  
  value: US_CVN68 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSNimitzClass | 1 << vehicleModelShift |
     vehicleFunctionCarrier)
# CVN 69 - USS Dwight D. Eisenhower carrier  
  value: US_CVN69 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSNimitzClass | 2 << vehicleModelShift |
     vehicleFunctionCarrier)
# CVN 70 - USS Carl Vinson carrier  
  value: US_CVN70 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSNimitzClass | 3 << vehicleModelShift |
     vehicleFunctionCarrier)

# Battleships 

# BB 71 - USS Iowa battleship  
  value: US_BB71 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSIowaClass | 1 << vehicleModelShift |
     vehicleFunctionBattleship)
# BB 72 - USS New Jersey battleship  
  value: US_BB72 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSIowaClass | 2 << vehicleModelShift |
     vehicleFunctionBattleship)
# BB 73 - USS Missouri battleship  
  value: US_BB73 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSIowaClass | 3 << vehicleModelShift |
     vehicleFunctionBattleship)
# BB 74 - USS Wisconsin battleship  
  value: US_BB74 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSIowaClass | 4 << vehicleModelShift |
     vehicleFunctionBattleship)

# Arsenal Ship - Strike Cruiser 

# CSG 1 - Arsenal Ship 
  value: US_CSG1 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSArsenalClass | 1 << vehicleModelShift |
     vehicleFunctionCruiser)

# Cruisers 

# CGN 9 - USS Long Beach nuclear cruiser  
  value: US_CGN9 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSLongBeachClass | 1 << vehicleModelShift |
     vehicleFunctionCruiser)

# CGN 25 - USS Bainbridge nuclear cruiser  
  value: US_CGN25 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSBainbridgeClass | 1 << vehicleModelShift |
     vehicleFunctionCruiser)

# CGN 35 - USS Truxtun nuclear cruiser  
  value: US_CGN35 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSTruxtunClass | 1 << vehicleModelShift |
     vehicleFunctionCruiser)

# CGN 36 - USS California nuclear cruiser  
  value: US_CGN36 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSCaliforniaClass | 1 << vehicleModelShift |
     vehicleFunctionCruiser)
# CGN 37 - USS South Carolina nuclear cruiser  
  value: US_CGN37 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSCaliforniaClass | 2 << vehicleModelShift |
     vehicleFunctionCruiser)

# CGN 38 - USS Virginia nuclear cruiser  
  value: US_CGN38 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSVirginiaClass | 1 << vehicleModelShift |
     vehicleFunctionCruiser)

# CG 16 - USS Leahy cruiser  
  value: US_CG16 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSLeahyClass | 1 << vehicleModelShift |
     vehicleFunctionCruiser)
# CG 17 - USS Harry E. Yarnell cruiser  
  value: US_CG17 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSLeahyClass | 2 << vehicleModelShift |
     vehicleFunctionCruiser)

# CG 26 - USS Belknap cruiser  
  value: US_CG26 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSBelknapClass | 1 << vehicleModelShift |
     vehicleFunctionCruiser)

# CG 59- USS Princeton Aegis cruiser  
  value: US_CG59 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSTiconderogaClass | 2 << vehicleModelShift |
     vehicleFunctionCruiser)

# Destroyers 

# DDG 2 - USS Charles F. Adams destroyer  
  value: US_DDG2 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSCharlesFAdamsClass | 1 << vehicleModelShift |
     vehicleFunctionDestroyer)

# DDG 40 - USS Coontz destroyer  
  value: US_DDG40 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSCoontzClass | 1 << vehicleModelShift |
     vehicleFunctionDestroyer)

# DDG 51 - USS Arleigh Burke destroyer  
  value: US_DDG51 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSArleighBurkeClass | 1 << vehicleModelShift |
     vehicleFunctionDestroyer)
# DDG 52 - USS John Barry destroyer  
  value: US_DDG52 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSArleighBurkeClass | 2 << vehicleModelShift |
     vehicleFunctionDestroyer)

# DDG 993 - USS Kidd destroyer  
  value: US_DDG993 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSKiddClass | 1 << vehicleModelShift |
     vehicleFunctionDestroyer)
# DDG 994 - USS Callaghan destroyer  
  value: US_DDG994 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSKiddClass | 2 << vehicleModelShift |
     vehicleFunctionDestroyer)

# DD 963- USS SPRUANCE destroyer  
  value: US_DD963 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSSpruanceClass | 1 << vehicleModelShift |
     vehicleFunctionDestroyer)
# DD 976- USS Merrill destroyer  
  value: US_DD976 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSSpruanceClass | 2 << vehicleModelShift |
     vehicleFunctionDestroyer)
# DD 964- USS Paul F. Foster destroyer  
  value: US_DD964 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSSpruanceClass | 3 << vehicleModelShift |
     vehicleFunctionDestroyer)

# Frigates 

# FFG 1 - USS Brooke frigate (guided missile)  
  value: US_FFG1 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSBrookeClass | 1 << vehicleModelShift |
     vehicleFunctionFrigate)

# FFG 7 - USS Oliver Hazard Perry frigate  
  value: US_FFG7 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSOliverHazardPerryClass | 1 << vehicleModelShift |
     vehicleFunctionFrigate)

# FF 1040 - USS Garcia frigate  
  value: US_FF1040 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSGarciaClass | 1 << vehicleModelShift |
     vehicleFunctionFrigate)

# FF 1052 - USS Knox frigate  
  value: US_FF1052 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSKnoxClass | 1 << vehicleModelShift |
     vehicleFunctionFrigate)

# USSR LUPO Frigate  
  value: USSR_LUPO (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUSSR |
     vehicle_LupoClass | 1 << vehicleModelShift |
     vehicleFunctionFrigate)

# USSR Heavy Frigate  
  value: USSR_HEAVY (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUSSR |
     vehicle_LupoClass | 2 << vehicleModelShift |
     vehicleFunctionFrigate)


# USSR ASSAD Corvettes  
  value: USSR_F210 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUSSR |
     vehicle_AssadClass | 1 << vehicleModelShift |
     vehicleFunctionCorvette)


# Hydrofoils 

# PHM 1 - USS Pegasus hydrofoil  
  value: US_PHM1 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSPegasusClass | 1 << vehicleModelShift |
     vehicleFunctionHydrofoil)
# PHM 2 - USS Hercules hydrofoil  
  value: US_PHM2 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUS |
     vehicle_USSPegasusClass | 2 << vehicleModelShift |
     vehicleFunctionHydrofoil)


# Subs  
  value: USSOhioClass (1 << vehicleSeriesShift)
  value: USSBenFranklinClass (2 << vehicleSeriesShift)
  value: USSSturgeonClass (3 << vehicleSeriesShift)
  value: USSSkipjackClass (4 << vehicleSeriesShift)
  value: USSLosAngelesClass (5 << vehicleSeriesShift)
  value: USSBarbelClass (6 << vehicleSeriesShift)
  value: USSReconClass (7 << vehicleSeriesShift)
  value: EODClass (8 << vehicleSeriesShift)
  value: DolphinClass (9 << vehicleSeriesShift)

# Boomers 

# SSBN 640 - USS Ben Franklin  
  value: US_SSBN640 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSubmarine | vehicleCountryUS |
     vehicle_USSBenFranklinClass | 1 << vehicleModelShift |
     vehicleFunctionBallisticMissileSub)

# SSBN 726 - USS Ohio  
  value: US_SSBN726 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSubmarine | vehicleCountryUS |
     vehicle_USSOhioClass | 1 << vehicleModelShift |
     vehicleFunctionBallisticMissileSub)
# SSBN 727 - USS Michigan  
  value: US_SSBN727 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSubmarine | vehicleCountryUS |
     vehicle_USSOhioClass | 2 << vehicleModelShift |
     vehicleFunctionBallisticMissileSub)
# SSBN 728 - USS Florida  
  value: US_SSBN728 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSubmarine | vehicleCountryUS |
     vehicle_USSOhioClass | 3 << vehicleModelShift |
     vehicleFunctionBallisticMissileSub)

# Attack 

# SS 580 - USS Barbel  
  value: US_SS580 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSubmarine | vehicleCountryUS |
     vehicle_USSBarbelClass | 1 << vehicleModelShift |
     vehicleFunctionAttackSub)

# SSN 585 - USS Skipjack  
  value: US_SSN585 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSubmarine | vehicleCountryUS |
     vehicle_USSSkipjackClass | 1 << vehicleModelShift |
     vehicleFunctionAttackSub)
# SSN 590 - USS Sculpin  
  value: US_SSN590 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSubmarine | vehicleCountryUS |
     vehicle_USSSkipjackClass | 2 << vehicleModelShift |
     vehicleFunctionAttackSub)

# SSN 637 - USS Sturgeon  
  value: US_SSN637 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSubmarine | vehicleCountryUS |
     vehicle_USSSturgeonClass | 1 << vehicleModelShift |
     vehicleFunctionAttackSub)

# SSN 688 - USS Los Angeles  
  value: US_SSN688 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSubmarine | vehicleCountryUS |
     vehicle_USSLosAngelesClass | 1 << vehicleModelShift |
     vehicleFunctionAttackSub)
# SSN 689 - USS Baton Rouge  
  value: US_SSN689 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSubmarine | vehicleCountryUS |
     vehicle_USSLosAngelesClass | 2 << vehicleModelShift |
     vehicleFunctionAttackSub)
# SSN 753 - USS Albany  
  value: US_SSN753 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSubmarine | vehicleCountryUS |
     vehicle_USSLosAngelesClass | 3 << vehicleModelShift |
     vehicleFunctionAttackSub)
	 
# Reconnaissance subs 
  value: US_UUV (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSubmarine | vehicleCountryUS |
     vehicle_USSReconClass | 1 << vehicleModelShift |
     vehicleFunctionAttackSub)

# 6/27/96 SJI JCOS stuff 
# AQS20 Sonar Sweep Gear:  
  value: US_AQS20 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSubmarine | vehicleCountryUS |
     vehicle_USSReconClass | 2 << vehicleModelShift |
     vehicleFunctionOceanMinesweep)

	 
# DIVERS/MAMMALS  

  value: US_EOD (objectDomainVehicle    | vehicleEnvironmentWater |
     vehicleClassSubmarine | vehicleCountryUS |
     vehicle_EODClass		    | 1 << vehicleModelShift |
     vehicleFunctionAttackSub)
	 
  value: US_MK4 (objectDomainVehicle    | vehicleEnvironmentWater |
     vehicleClassSubmarine | vehicleCountryUS |
     vehicle_DolphinClass          | 1 << vehicleModelShift |
     vehicleFunctionAttackSub)

	
  value: US_MK7 (objectDomainVehicle   | vehicleEnvironmentWater |
     vehicleClassSubmarine | vehicleCountryUS |
     vehicle_DolphinClass          | 2 << vehicleModelShift |
     vehicleFunctionAttackSub)



# Mine Warfare 
  value: AvengerClass (1 << vehicleSeriesShift)
  value: OspreyClass (2 << vehicleSeriesShift)
  value: IwoJimaClass (3 << vehicleSeriesShift)
  value: InflatableBoatClass (4 << vehicleSeriesShift)
  value: SonarReconClass (5 << vehicleSeriesShift)
	
  value: US_RMS (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassMineWarfare | vehicleCountryUS |
     vehicle_SonarReconClass | 1 << vehicleModelShift |
     vehicleFunctionMineCM)

# MCM 1 - USS Avenger  
  value: US_MCM1 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassMineWarfare | vehicleCountryUS |
     vehicle_AvengerClass | 1 << vehicleModelShift |
     vehicleFunctionMineCM)

# MHC 51 - USS Osprey  
  value: US_MHC51 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassMineWarfare | vehicleCountryUS |
     vehicle_OspreyClass | 1 << vehicleModelShift |
     vehicleFunctionMineCM)

# 5/21/96 DAE added for JCOS 
# MCS 12 - USS Inchon  
  value: US_MCS12 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassMineWarfare | vehicleCountryUS |
     vehicle_IwoJimaClass  | 1 << vehicleModelShift |
     vehicleFunctionMineCM)

  value: US_RHIB (objectDomainVehicle | vehicleEnvironmentWater |
      vehicleClassMineWarfare | vehicleCountryUS |
      vehicle_InflatableBoatClass | 1 << vehicleModelShift |
      vehicleFunctionMineCM)

# ************** Towed Water Entities ************** 
     
# ************** Towed MC Sweep Gear ************** 

# Sweep Gear 
  value: CombinationGear (1 << vehicleSeriesShift)
  value: MechanicalGear (2 << vehicleSeriesShift)
  value: MagneticGear (3 << vehicleSeriesShift)
  value: AcousticGear (4 << vehicleSeriesShift)

# 10/10/95 JLK JCOS stuff 
# SLQ-37 influence Magnetic/Acoustic Sweep Gear:  
  value: US_SLQ37 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassMineSweepGear | vehicleCountryUS |
     vehicle_CombinationGear  | 1 << vehicleModelShift |
     vehicleFunctionOceanMinesweep)
	 
# 5/20/96 DAE add for JCOS 
# SLQ-53 influence sweep gear 
  value: US_SLQ53 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassMineSweepGear | vehicleCountryUS |
     vehicle_MechanicalGear | 1 << vehicleModelShift |
     vehicleFunctionOceanMinesweep)

#  JLK 11/02/95 added following sweep gear 
# MK 103 Magnetic Sweep Gear:  
  value: US_MK103 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassMineSweepGear | vehicleCountryUS |
     vehicle_MechanicalGear | 2 << vehicleModelShift |
     vehicleFunctionOceanMinesweep)

# 5/20/96  DAE added for JCOS 
# MK-104 sweep gear 
  value: US_MK104 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassMineSweepGear | vehicleCountryUS |
     vehicle_AcousticGear | 1 << vehicleModelShift |
     vehicleFunctionOceanMinesweep)

# 5/20/96  DAE added for JCOS 
# MK-105 sweep gear 
  value: US_MK105 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassMineSweepGear | vehicleCountryUS |
     vehicle_MagneticGear | 1 << vehicleModelShift |
     vehicleFunctionOceanMinesweep)

# 5/20/96  DAE  added for JCOS 
# MK-106 sweep gear 
  value: US_MK106 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassMineSweepGear | vehicleCountryUS |
     vehicle_CombinationGear | 2 << vehicleModelShift |
     vehicleFunctionOceanMinesweep)

# Material Support  

# Destroyer Tender 

# AD 41 - USS Yellowstone destroyer tender  
  value: US_AD41 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassMaterialSupport | vehicleCountryUS |
     1 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionDestroyerTender)
# AD 42 - USS Acadia  
  value: US_AD42 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassMaterialSupport | vehicleCountryUS |
     1 << vehicleSeriesShift | 2 << vehicleModelShift |
     vehicleFunctionDestroyerTender)


# Underway Replenishment 


# Fast Combat Store 

# AFS 1 - USS Mars  
  value: US_AFS1 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassMaterialSupport | vehicleCountryUS |
     2 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionCombatStores)

# Fast Combat Support 
# AOE 6 - USS Supply  
  value: US_AOE6 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassMaterialSupport | vehicleCountryUS |
     3 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionCombatStores)

# Intelligent Minefields 

# These should be given a function in the future (probably vehicleFunctionAT). 
# These small platforms are being fired upon, when they should in fact  

# go unnoticed. The current vehicleFunction is a temporary solution to this. 
  value: US_IMF_Gateway (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassTowed | vehicleCountryUS |
     1 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionMask)
  value: US_IMF_AOS (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassTowed | vehicleCountryUS |
     1 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionMask)
  value: US_IMF_WAM (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassTowed | vehicleCountryUS |
     1 << vehicleSeriesShift | 2 << vehicleModelShift |
     vehicleFunctionMask)

#
#  U.S.S.R. vehicles.
 
# FWA 
 
# Ground Attack 


# Su-25 fixed-wing aircraft: 
  value: USSR_Su25 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUSSR |
     1 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionGroundAttack)
# Bombers  
# Tu-16 Badger strategic bomber:  
  value: USSR_TU16 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUSSR |
     1 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionBomber)
# Tu-20 Bear strategic bomber:  
  value: USSR_TU20 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUSSR |
     2 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionBomber)
# Tu-22 Blinder strategic bomber:  
  value: USSR_TU22 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUSSR |
     3 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionBomber)
# Air Combat  

# USSR MIG 23 Flogger C  
  value: USSR_MIG23 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUSSR |
     2 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionAirCombat)
# USSR MIG 27 Flogger D  
  value: USSR_MIG27 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUSSR |
     3 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionAirCombat)
# USSR MiG-27D Flogger J-1 
  value: USSR_MiG27D (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUSSR |
     3 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionGroundAttack)
# USSR MIG 21 Fishbed C  
  value: USSR_MIG21 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUSSR |
     4 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionAirCombat)
# USSR MIG 25 Foxbat A  
  value: USSR_MIG25 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUSSR |
     5 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionAirCombat)
# USSR MIG 29 Fulcrum 
  value: USSR_MIG29 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUSSR |
     6 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionAirCombat)
# USSR MIG 31  
  value: USSR_MIG31 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUSSR |
     7 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionAirCombat)
# USSR Mirage F-1 (Really a French Mirage)  
  value: USSR_F1 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUSSR |
     8 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionAirCombat)
# Air Recon  

# USSR IL-76 AWACS (Really Iraqi)  
  value: USSR_IL76 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUSSR |
     1 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionAWACS)
# USSR FWA_RECON fixed-wing aircraft:  
  value: USSR_FWA_RECON (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassFixedWing | vehicleCountryUSSR |
     20 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionAirRecon)
# RWA  

# Mi-24 helicopter:  
  value: USSR_Mi24 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassRotaryWing | vehicleCountryUSSR |
     1 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionGroundAttack)
  value: USSR_Mi24D           vehicle_USSR_Mi24
# Mi-24 helicopter, F Model:  
  value: USSR_Mi24F (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassRotaryWing | vehicleCountryUSSR |
     1 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionGroundAttack)
# Mi-28 helicopter:  
  value: USSR_Mi28 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassRotaryWing | vehicleCountryUSSR |
     2 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionGroundAttack)
# Mi-8 helicopter:  
  value: USSR_Mi8 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassRotaryWing | vehicleCountryUSSR |
     3 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionGroundAttack)
# Mi-17 helicopter:  
  value: USSR_Mi17 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassRotaryWing | vehicleCountryUSSR |
     4 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionGroundAttack)
# SA-342 Gazelle helicopter: (is this really from USSR?)  
  value: USSR_SA342 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassRotaryWing | vehicleCountryUSSR |
     5 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionGroundAttack)
# MBB 150/Hughes 500 helicopter: (is this really from USSR?)  
  value: USSR_MBB150 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassRotaryWing | vehicleCountryUSSR |
     6 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionGroundAttack)
# Mi-6 Hook helicopter (USSR "equivalent" of UH-60)  
  value: USSR_Mi6 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassRotaryWing | vehicleCountryUSSR |
     7 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionAirUtility)
# Mi-26 Halo helicopter (USSR "equivalent" of CH-47)  
  value: USSR_Mi26 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassRotaryWing | vehicleCountryUSSR |
     8 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionAirCargo)
# Ka-50 Hokum helicopter (USSR "equivalent" of AH-64)  
  value: USSR_Ka50 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassRotaryWing | vehicleCountryUSSR |
     9 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionAirCargo)
# Soviet ground vehicles  

# Trucks  
# GAZ-66 supply truck:  
  value: USSR_GAZ66 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUSSR |
     1 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionSupplyTruck)
# Ural-375 cargo carrier:  
  value: USSR_URAL375C (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUSSR |
     2 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionSupplyTruck)
# Ural-375 fuel carrier:  
  value: USSR_URAL375F (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUSSR |
     2 << vehicleSeriesShift | 2 << vehicleModelShift |
     vehicleFunctionSupplyTruck)
# ZIL-131 FDC truck:  
  value: USSR_ZIL131_FDC (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUSSR |
     3 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionCommandPost)
# ZIL-157 2.5 ton supply truck:  
  value: USSR_ZIL157 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUSSR |
     3 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionSupplyTruck)
# 18 wheel fuel truck  
  value: USSR_SU_refueler (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUSSR |
     4 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionSupplyTruck)
# water carrier 
  value: USSR_water_carrier (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUSSR |
     5 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionSupplyTruck)
# UAZ-469 jeep:  
  value: USSR_UAZ469 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUSSR |
     1 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionGroundUtility)
# Soviet combat engineer vehicle  

# PMR3 mine layer  
  value: USSR_PMR3 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassTowed | vehicleCountryUSSR |
     0 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionCombatEngineer)
# Soviet MICLIC line clearing charge  mine clearing line charge:  
  value: USSR_MICLIC (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassTowed | vehicleCountryUSSR |
     1 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionCombatEngineer)
# Soviet version of M128 GEMSS mine layer:  
  value: USSR_GMZ (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUSSR |
     0 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionCombatEngineer)
# Soviet towed pallet  
  value: USSR_PALLET (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassTowed | vehicleCountryUSSR |
     1 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionSupplyTruck)
# Soviet A22 Sling Load  
  value: USSR_A22 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassTowed | vehicleCountryUSSR |
     1 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionSupplyTruck)
# Recovery  

# BREM-1 recovery vehicle:  
  value: USSR_BREM1 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUSSR |
     1 << vehicleSeriesShift | 2 << vehicleModelShift |
     vehicleFunctionRecovery)
# Tanks  

# T80 Battle Tank  
  value: USSR_T80 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUSSR |
     1 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionMainBattleTank)
# T-72 main battle tank:  
  value: USSR_T72M (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUSSR |
     1 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionMainBattleTank)
# T-72S (main battle tank - export model designation:  
  value: USSR_T72S (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUSSR |
     1 << vehicleSeriesShift | 2 << vehicleModelShift |
     vehicleFunctionMainBattleTank)
# T-72SK (MBT Command Vehicle - export model designation:  
  value: USSR_T72SK (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUSSR |
     1 << vehicleSeriesShift | 3 << vehicleModelShift |
     vehicleFunctionMainBattleTank)
# T64 Battle Tank  
  value: USSR_T64 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUSSR |
     9 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionMainBattleTank)
# T62 Battle Tank  
  value: USSR_T62 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUSSR |
     10 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionMainBattleTank)
# T55 Battle Tank  
  value: USSR_T55 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUSSR |
     11 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionMainBattleTank)
# T54 Battle Tank  
  value: USSR_T54 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUSSR |
     12 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionMainBattleTank)
# Chieftain Mk-5 Battle Tank (really from Great Britain)  
  value: USSR_Chieftain (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUSSR |
     13 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionMainBattleTank)
# Personnel Carriers  

# BMP-1 personnel carrier:  
  value: USSR_BMP1 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUSSR |
     2 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionPersonnelCarrier)
# BMP-1K command vehicle:  
  value: USSR_BMP1K (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUSSR |
     2 << vehicleSeriesShift | 2 << vehicleModelShift |
     vehicleFunctionCommandPost)
# BTR 80   
  value: USSR_BTR80 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUSSR |
     3 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionPersonnelCarrier)
# BMP-2 personnel carrier:  
  value: USSR_BMP2 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUSSR |
     4 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionPersonnelCarrier)
# MT-LB personnel carrier/command post  
  value: USSR_MTLB (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUSSR |
     5 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionPersonnelCarrier)
# MT-LB personnel carrier/command post used as ambulance  
  value: USSR_MTLB_ambulance (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUSSR |
     5 << vehicleSeriesShift | 2 << vehicleModelShift |
     vehicleFunctionPersonnelCarrier)
# 1V13 SP Artillery Battery Fire Direction Center 
  value: USSR_1V13 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUSSR |
     5 << vehicleSeriesShift | 3 << vehicleModelShift |
     vehicleFunctionCommandPost)
# 1V14 SP Artillery Battery Commander's Command Observation Post 
  value: USSR_1V14 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUSSR |
     5 << vehicleSeriesShift | 4 << vehicleModelShift |
     vehicleFunctionCommandPost)
# 1V15 SP Artillery Battalion Commander's Command Observation Post 
  value: USSR_1V15 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUSSR |
     5 << vehicleSeriesShift | 5 << vehicleModelShift |
     vehicleFunctionCommandPost)
# 1V16 SP Artillery Battalion Fire Direction Center  
  value: USSR_1V16 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUSSR |
     5 << vehicleSeriesShift | 6 << vehicleModelShift |
     vehicleFunctionCommandPost)
# ACRV recon command post  
  value: USSR_ACRV (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUSSR |
     6 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionCommandPost)
# BTR-60PU Towed Artillery Btry & Bn Cdr's Command Observation Post   
  value: USSR_BTR60PU (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUSSR |
     6 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionCommandPost)

# Brm recon vehicle 
  value: USSR_BRM (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUSSR |
     8 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionGroundRecon)
# BRDM1 recon vehicle 
  value: USSR_BRDM1 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredWheeled | vehicleCountryUSSR |
     1 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionGroundRecon)
# BRDM2 recon vehicle 
  value: USSR_BRDM2 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredWheeled | vehicleCountryUSSR |
     1 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionGroundRecon)

# Soviet Rocket Launchers  

# BM21, a 122mm MLRS (Multiple Launch Rocket System):  
  value: USSR_BM21 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUSSR |
     1 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionRocketLauncher)
# Mortars  

# M-1943 120mm towed mortar:  
  value: USSR_M1943 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassTowed | vehicleCountryUSSR |
     1 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionMortar)
# 2B11 120mm towed mortar:  
  value: USSR_2B11 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassTowed | vehicleCountryUSSR |
     1 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionMortar)
# 2S12 120mm towed mortar: 
  value: USSR_2S12 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassTowed | vehicleCountryUSSR |
     2 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionMortar)
# Howitzers  

# Generic 105mm howitzer, towed:  
  value: USSR_105_HOWITZER (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassTowed | vehicleCountryUSSR |
     1 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionHowitzer)
# M102 105mm towed howitzer: 
  value: US_M102 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassTowed | vehicleCountryUS |
     2 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionHowitzer)
# D20 152mm towed howitzer  
  value: USSR_D20 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassTowed | vehicleCountryUSSR |
     2 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionHowitzer)
# 2S1 122mm howitzer:  
  value: USSR_2S1 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUSSR |
     3 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionHowitzer)
# 2S19 152mm howitzer:  
  value: USSR_2S19 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUSSR |
     3 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionHowitzer)
# Surface to Surface Missiles  

# Scud-B with Armored Wheeled Launcher:  
  value: USSR_SCUD_B (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredWheeled | vehicleCountryUSSR |
     1 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionSSMissileLauncher)
# Frog 7 with Armored Wheeled Launcher:  
  value: USSR_FROG_7 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredWheeled | vehicleCountryUSSR |
     2 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionSSMissileLauncher)
# Soviet MAZ 543 TEL (Transporter/Erector/Launcher) for Scud-type missiles 
  value: USSR_MAZ543 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUSSR |
     3 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionSSMissileLauncher)

  value: USSR_Silkworm_Launcher (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredWheeled | vehicleCountryUSSR |
     4 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionSSMissileLauncher)

# Anti-Aircraft  

# ZSU-23-4M AA gun:  
  value: USSR_ZSU23_4M (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUSSR |
     5 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionAntiAircraft)
# ZSU-57-2 AA gun:  
  value: USSR_ZSU57_2 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUSSR |
     1 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionAntiAircraft)
# 2S6 air defense vehicle:  
  value: USSR_2S6 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUSSR |
     26 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionAntiAircraft)
# SA-2 AA Missile with Unarmored Wheeled Launcher:  
  value: USSR_SA_2 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassTowed | vehicleCountryUSSR |
     2 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionAntiAircraft)
# SA-3 AA Missile with Unarmored Wheeled Launcher:  
  value: USSR_SA_3 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassTowed | vehicleCountryUSSR |
     3 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionAntiAircraft)
# SA-6 AA Missile with Armored Tracked Launcher:  
  value: USSR_SA_6 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUSSR |
     6 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionAntiAircraft)
# SA-8 AA Missile with Armored Wheeled Launcher:  
  value: USSR_SA_8 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredWheeled | vehicleCountryUSSR |
     8 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionAntiAircraft)
# SA-9 AA Missile with Armored Wheeled Launcher:  
  value: USSR_SA_9 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredWheeled | vehicleCountryUSSR |
     9 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionAntiAircraft)
# SA-13 AA Missile with Armored Wheeled Launcher:  
  value: USSR_SA_13 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredWheeled | vehicleCountryUSSR |
     13 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionAntiAircraft)
# SA-15 AA Armored Tracked Launcher: 
  value: USSR_SA_15 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryUSSR |
     15 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionAntiAircraft)
# Roland (actually from Europe) AA Missile with Armored Wheeled Launcher:  
  value: USSR_ROLAND (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredWheeled | vehicleCountryUSSR |
     14 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionAntiAircraft)
# Hawk (actually from where?) AA Missile with Armored Wheeled Launcher:  
  value: USSR_I_HAWK (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassTowed | vehicleCountryUSSR |
     15 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionAntiAircraft)
# S-60 AA Towed AA Gun:  
  value: USSR_S_60 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassTowed | vehicleCountryUSSR |
     1 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionAntiAircraft)
# XM375S command vehicle -- air defense PCV 
  value: USSR_XM375S (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUSSR |
     7 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionCommandPost)
# XMG1S command vehicle -- air defense SCV 
  value: USSR_XMG1S (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUSSR |
     7 << vehicleSeriesShift | 2 << vehicleModelShift |
     vehicleFunctionCommandPost)
# SA_6 fire control radar -- air defense FCR 
  value: USSR_SA_6_FCR (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredTracked | vehicleCountryUSSR |
     1 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionRadar)
# SA_6 missile transporter, erector, launcher -- air defense TEL 
  value: USSR_SA_6_TEL (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredTracked | vehicleCountryUSSR |
     4 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionAntiAircraft)
# XMTSS Aquisition Radar -- air defense ACQ 
  value: USSR_XMTSS (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredTracked | vehicleCountryUSSR |
     1 << vehicleSeriesShift | 2 << vehicleModelShift |
     vehicleFunctionRadar)
# XMLTS Height finding radar -- air defense HFR 
  value: USSR_XMLTS (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPUnarmoredWheeled | vehicleCountryUSSR |
     1 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionRadar)
# Water vehicles  
  value: USSRAlfaClass (1 << vehicleSeriesShift)
  value: USSRRedOctoberClass (2 << vehicleSeriesShift)
  value: USSRKiloClass (3 << vehicleSeriesShift)

# Attack Subs 

  value: USSR_ALFA (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSubmarine | vehicleCountryUSSR |
     vehicle_USSRAlfaClass | 0 << vehicleModelShift |
     vehicleFunctionAttackSub)

  value: USSR_SSK903 (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSubmarine | vehicleCountryUSSR |
     vehicle_USSRKiloClass | 1 << vehicleModelShift |
     vehicleFunctionAttackSub)

# Boomers 

  value: USSR_REDOCTOBER (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSubmarine | vehicleCountryUSSR |
     vehicle_USSRRedOctoberClass | 1 << vehicleModelShift |
     vehicleFunctionBallisticMissileSub)

# Destroyers 

# USSR Destroyer:  
  value: USSR_VYZYVAYUSHCHIY (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassSurfaceCombat | vehicleCountryUSSR |
     1 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionDestroyer)



# German vehicles  

# The Leopard 2 main battle tank  
  value: Germany_LEO2 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryGermany |
     1 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionMainBattleTank)
# The Leopard 1 A5 main battle tank  
  value: Germany_LEO1A5 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryGermany |
     2 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionMainBattleTank)
# The Marder personnel carrier  
  value: Germany_MARDER (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryGermany |
     2 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionPersonnelCarrier)
# The Biber armored bridge layer  
  value: Germany_Biber (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryGermany |
     1 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionGroundUtility)
# The Gepard armored air defense gun   
  value: Germany_Gepard (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryGermany |
     1 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionAntiAircraft)
# The Jaguar 1 tank destroyer   
  value: Germany_JAGUAR1 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryGermany |
     1 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionTankDestroyer)
# The Jaguar 1 as observer 
  value: Germany_Jaguar_Obs (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryGermany |
     1 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionGroundRecon)
# The Luchs armored recon vehicle   
  value: Germany_LUCHS (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryGermany |
     1 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionGroundRecon)
# M113 observer 
  value: Germany_M113_observer (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryGermany |
     3 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionGroundUtility)
# M113 ambulance:  
  value: Germany_M113_ambulance (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryGermany |
     3 << vehicleSeriesShift | 2 << vehicleModelShift |
     vehicleFunctionGroundUtility)
# M113 skorpion mine laying vehicle:  
  value: Germany_M113_Skorpion (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryGermany |
     3 << vehicleSeriesShift | 3 << vehicleModelShift |
     vehicleFunctionGroundUtility)
# PAH-1 attack helicopter:  
  value: Germany_PAH1 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassRotaryWing | vehicleCountryGermany |
     0 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionGroundAttack)
# PAH-2 attack helicopter:  
  value: Germany_PAH2 (objectDomainVehicle | vehicleEnvironmentAir |
     vehicleClassRotaryWing | vehicleCountryGermany |
     0 << vehicleSeriesShift | 1 << vehicleModelShift |
     vehicleFunctionGroundAttack)
# UK vehicles  
# The Challenger Main Battle Tank  
  value: UK_Challenger (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryOther |
     1 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionMainBattleTank)
# The MCV-80 Warrior Armored Fighting Vehicle 
  value: UK_MCV80 (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredTracked | vehicleCountryOther |
     2 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionPersonnelCarrier)
# Dynamic Terrain Barrier "Vehicle" 
  value: Germany_Dynamic_Terrain_Barrier (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassNonMilitary | vehicleCountryOther |
     0 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionMiscellaneous)

# USSR Bunker "Vehicle" 
  value: USSR_Bunker (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassSPArmoredWheeled | vehicleCountryUSSR |
     0 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionBunker)

# Neutral vehicles 

# ENV: water 

# Tanker Ship 
  value: Tanker_Ship (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassNonMilitary | vehicleCountryOther |
     0 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionSeaMisc)

# Merchant Ship 
  value: Merchant_Ship (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassNonMilitary | vehicleCountryOther |
     1 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionSeaMisc)

# Fishing Boat 
  value: Fishing_Boat (objectDomainVehicle | vehicleEnvironmentWater |
     vehicleClassNonMilitary | vehicleCountryOther |
     2 << vehicleSeriesShift | 0 << vehicleModelShift |
     vehicleFunctionSeaMisc)



#
# Hand-held Flare Gun defined by HTI for use by Rifle Squad Leader (RSqLdr)
 
  value: USMC_Flare_Gun (objectDomainVehicle | vehicleEnvironmentGround |
     vehicleClassCarried | vehicleCountryUS |
     1 << vehicleSeriesShift | 2 << vehicleModelShift |
     vehicleFunctionMortar)



# ********** other stuff ********** 

namespace_def: structure

# a building  
  value: BUILDING1 (objectDomainStructure | structureClassOther | 1)
# a minefield marker  
  value: MinefieldMarker (objectDomainStructure | structureClassOther | 2)
# a breached lane marker  
  value: BreachedLaneMarker (objectDomainStructure | structureClassOther | 3)
# a broken stone bridge  
  value: BrokenStoneBridge (objectDomainStructure | structureClassOther | 4)
# a broken steel bridge  
  value: BrokenSteelBridge (objectDomainStructure | structureClassOther | 5)
# a broken low bridge  
  value: BrokenLowBridge (objectDomainStructure | structureClassOther | 6)
# a Long Track Radar  
  value: LongTrackRadar (objectDomainStructure | structureClassOther | 7)
# a Bar Lock Radar  
  value: BarLockRadar (objectDomainStructure | structureClassOther | 8)
# An arrow, sometimes used to display compass direction  
  value: Arrow (objectDomainStructure | structureClassOther | 9)
# Colored cubes  
  value: Cube_Black (objectDomainStructure | structureClassOther | 10)
  value: Cube_White (objectDomainStructure | structureClassOther | 11)
  value: Cube_Red (objectDomainStructure | structureClassOther | 12)
  value: Cube_Orange (objectDomainStructure | structureClassOther | 13)
  value: Cube_Yellow (objectDomainStructure | structureClassOther | 14)
  value: Cube_Green (objectDomainStructure | structureClassOther | 15)
  value: Cube_Blue (objectDomainStructure | structureClassOther | 16)
  value: Cube_Violet (objectDomainStructure | structureClassOther | 17)
# Logistics structures  
  value: AmmoCrate (objectDomainStructure | structureClassOther | 18)
  value: Tent (objectDomainStructure | structureClassOther | 19)
# 73 Easting battle reenactment buildings  
  value: BarracksA (objectDomainStructure | structureClassOther | 21)
  value: BarracksB (objectDomainStructure | structureClassOther | 22)
  value: BarracksC (objectDomainStructure | structureClassOther | 23)
  value: BarracksD (objectDomainStructure | structureClassOther | 24)
  value: BarracksE (objectDomainStructure | structureClassOther | 25)
  value: BarracksF (objectDomainStructure | structureClassOther | 26)
  value: BarracksG (objectDomainStructure | structureClassOther | 27)
  value: BarracksH (objectDomainStructure | structureClassOther | 28)
  value: BarracksI (objectDomainStructure | structureClassOther | 29)
  value: BarracksJ (objectDomainStructure | structureClassOther | 30)
  value: BarracksK (objectDomainStructure | structureClassOther | 31)
  value: LogSite (objectDomainStructure | structureClassOther | 32)

#
# CMT interim destroyable structures
 
 
# Buildings
 

  value: Bld_Cross_T (objectDomainStructure | structureClassOther | 33)
  value: Bld_Large_Residential_A (objectDomainStructure |
	 structureClassOther | 34)
  value: Bld_Large_Commercial_A (objectDomainStructure |
	 structureClassOther | 35)
  value: Bld_Hex_A (objectDomainStructure | structureClassOther | 36)
  value: Bld_Brick_A (objectDomainStructure | structureClassOther | 37)

#
# Misc non-buildings
 

  value: Smoke_Stack_B (objectDomainStructure | structureClassOther | 38)
  value: Minaret_A (objectDomainStructure | structureClassOther | 39)
  value: Corral_C (objectDomainStructure | structureClassOther | 40)
  value: Oil_Tank_A (objectDomainStructure | structureClassOther | 41)

#
# Warehouses
 

  value: Warehouse_A (objectDomainStructure | structureClassOther | 42)
  value: Warehouse_D (objectDomainStructure | structureClassOther | 43)
  value: Warehouse_G (objectDomainStructure | structureClassOther | 44)
  value: Warehouse_W (objectDomainStructure | structureClassOther | 45)
  value: Warehouse_Y (objectDomainStructure | structureClassOther | 46)

#
# Factories
 

  value: Factory_A (objectDomainStructure | structureClassOther | 47)

#
# Garages
 

  value: Garage_Open_W (objectDomainStructure | structureClassOther | 48)
  value: Garage_Open_Y (objectDomainStructure | structureClassOther | 49)
  value: Power_Transformer_Station_A (objectDomainStructure |
	 structureClassOther | 50)

#
# Houses
 

  value: House_R (objectDomainStructure | structureClassOther | 51)
  value: House_S (objectDomainStructure | structureClassOther | 52)
  value: House_T (objectDomainStructure | structureClassOther | 53)

#
# Railroad structures
 

  value: RailRoad_Car_A (objectDomainStructure | structureClassOther | 54)
  value: RailRoad_Car_B (objectDomainStructure | structureClassOther | 55)
  value: RailRoad_Garage_A (objectDomainStructure | structureClassOther | 56)

#
# Water processing structures
 

  value: Water_Pump_Station_A (objectDomainStructure |
	 structureClassOther | 57)
  value: Water_Pump_Station_B (objectDomainStructure |
	 structureClassOther | 58)
  value: Water_Plant (objectDomainStructure | structureClassOther | 59)
  value: Water_Tower_S (objectDomainStructure | structureClassOther | 60)

#
# Highway structures
 

  value: Highway_Deck_100M (objectDomainStructure | structureClassOther | 61)
  value: Highway_Deck_25M (objectDomainStructure | structureClassOther | 62)
  value: Highway_Deck_10M (objectDomainStructure | structureClassOther | 63)

#
# Railroad Deck structures
 

  value: Railroad_Deck_100M (objectDomainStructure | structureClassOther | 64)
  value: Railroad_Deck_50M (objectDomainStructure | structureClassOther | 65)
  value: Railroad_Deck_10M (objectDomainStructure | structureClassOther | 66)

#
# AE Dynamic Terrain structures
 

  value: Dynamic_Terrain_Barrier (objectDomainStructure |
	 structureClassOther | 67)
  value: AE_Destroyable_Bridge (objectDomainStructure |
	 structureClassOther | 68)
  value: AE_Destroyable_Bridge_Barrier (objectDomainStructure |
	 structureClassOther | 69)
  value: AE_Biber_Bridge (objectDomainStructure | structureClassOther | 70)
  value: AE_Biber_Bridge_Barrier (objectDomainStructure |
	 structureClassOther | 71)
  value: AE_Barrier (objectDomainStructure | structureClassOther | 72)
  value: AE_Crater (objectDomainStructure | structureClassOther | 73)

# Line-Pair-Board (for visual testing purposes) 
  value: LINE_PAIR_BOARD (objectDomainStructure | structureClassOther | 74)


# Ditch   
  value: Ditch (objectDomainStructure | structureClassOther | 75)
# AVLB Bridge   
  value: AVLB_Bridge (objectDomainStructure | structureClassOther | 76)
# HAB Bridge 
  value: HAB_Bridge (objectDomainStructure | 80)
# a breached lane
  value: BreachedLane (objectDomainStructure | 81)


# PALLETS
# Other

# Ammo Pallet (supply class V) 
  value: AMMO_PALLET (objectDomainStructure |
	 structureClassPallet | palletCountryOther | palletClassV | 1)
# Mine Pallet OTHER_MIACAH  (supply class V)
  value: MINE_PALLET_munition_OTHER_MIACAH (objectDomainStructure |
	 structureClassPallet | palletCountryOther | palletClassV | 2 )
# Mine Pallet OTHER_P2MK3  (supply class V)
  value: MINE_PALLET_munition_OTHER_P2MK3 (objectDomainStructure |
	 structureClassPallet | palletCountryOther | palletClassV | 3 )
# Mine Pallet OTHER_PTMIBAIII  (supply class V)
  value: MINE_PALLET_munition_OTHER_PTMIBAIII (objectDomainStructure |
	 structureClassPallet | palletCountryOther | palletClassV | 4 )
# Repair Parts Pallet (supply class IX) 
  value: RPARTS_PALLET (objectDomainStructure |
	 structureClassPallet | palletCountryOther | palletClassIX | 1)
# Construction Materials Pallet (supply class IV) 
  value: CONST_MATL_PALLET (objectDomainStructure |
	 structureClassPallet | palletCountryOther | palletClassIV | 1)


#  US

# Ammo Pallet US_155_SADARM  (supply class V)
  value: AMMO_PALLET_US_155_SADARM (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 2 )
 
# Ammo Pallet US_Dragon  (supply class V)
  value: AMMO_PALLET_US_DRAGON (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 3 )
 
# Ammo Pallet GERMAN_AT2  (supply class V)
  value: AMMO_PALLET_GERMAN_AT2 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 4 )
 
# Ammo Pallet US_Hellfire  (supply class V)
  value: AMMO_PALLET_US_HELLFIRE (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 5 )
 
# Ammo Pallet US_Hellfire_RF  (supply class V)
  value: AMMO_PALLET_US_HELLFIRE_RF (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 6 )
 
# Ammo Pallet US_Hydra70M151  (supply class V)
  value: AMMO_PALLET_US_HYDRA70M151 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 7 )
 
# Ammo Pallet US_Hydra70M261  (supply class V)
  value: AMMO_PALLET_US_HYDRA70M261 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 8 )
 
# Ammo Pallet US_Javelin  (supply class V)
  value: AMMO_PALLET_US_JAVELIN (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 9 )
 
# Ammo Pallet US_L8A1  (supply class V)
  value: AMMO_PALLET_US_L8A1 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 10 )
 
# Ammo Pallet US_LOSAT_Missile  (supply class V)
  value: AMMO_PALLET_US_LOSAT_Missile (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 11 )
 
# Ammo Pallet US_M1  (supply class V)
  value: AMMO_PALLET_US_M1 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 12 )
 
# Ammo Pallet US_M107  (supply class V)
  value: AMMO_PALLET_US_M107 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 13 )
 
# Ammo Pallet US_M110E2  (supply class V)
  value: AMMO_PALLET_US_M110E2 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 14 )
 
# Ammo Pallet US_M116A1  (supply class V)
  value: AMMO_PALLET_US_M116A1 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 15 )
 
# Ammo Pallet US_M121A1  (supply class V)
  value: AMMO_PALLET_US_M121A1 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 16 )
 
# Ammo Pallet US_M135  (supply class V)
  value: AMMO_PALLET_US_M135 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 17 )
 
# Ammo Pallet US_M240  (supply class V)
  value: AMMO_PALLET_US_M240 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 18 )
 
# Ammo Pallet US_M329A1  (supply class V)
  value: AMMO_PALLET_US_M329A1 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 19 )
 
# Ammo Pallet US_M329A2  (supply class V)
  value: AMMO_PALLET_US_M329A2 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 20 )
 
# Ammo Pallet US_M33  (supply class V)
  value: AMMO_PALLET_US_M33 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 21 )
 
# Ammo Pallet US_M392A2  (supply class V)
  value: AMMO_PALLET_US_M392A2 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 22 )
 
# Ammo Pallet US_M449A1  (supply class V)
  value: AMMO_PALLET_US_M449A1 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 23 )
 
# Ammo Pallet US_M456A1  (supply class V)
  value: AMMO_PALLET_US_M456A1 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 24 )
 
# Ammo Pallet US_M483A1  (supply class V)
  value: AMMO_PALLET_US_M483A1 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 25 )
 
# Ammo Pallet US_M485A2  (supply class V)
  value: AMMO_PALLET_US_M485A2 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 26 )
 
# Ammo Pallet US_M548  (supply class V)
  value: AMMO_PALLET_US_M548 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 27 )
 
# Ammo Pallet US_M549A1  (supply class V)
  value: AMMO_PALLET_US_M549A1 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 28 )
 
# Ammo Pallet US_M58_chargelet  (supply class V)
  value: AMMO_PALLET_US_M58_chargelet (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 29 )
 
# Ammo Pallet US_M59  (supply class V)
  value: AMMO_PALLET_US_M59 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 30 )
 
# Ammo Pallet US_M687  (supply class V)
  value: AMMO_PALLET_US_M687 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 31 )
 
# Ammo Pallet US_M692  (supply class V)
  value: AMMO_PALLET_US_M692 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 32 )
 
# Ammo Pallet US_M712  (supply class V)
  value: AMMO_PALLET_US_M712 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 33 )
 
# Ammo Pallet US_M718  (supply class V)
  value: AMMO_PALLET_US_M718 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 34 )
 
# Ammo Pallet US_M731  (supply class V)
  value: AMMO_PALLET_US_M731 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 35 )
 
# Ammo Pallet US_M741  (supply class V)
  value: AMMO_PALLET_US_M741 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 36 )
 
# Ammo Pallet US_M76  (supply class V)
  value: AMMO_PALLET_US_M76 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 37 )
 
# Ammo Pallet US_M77_M26  (supply class V)
  value: AMMO_PALLET_US_M77_M26 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 38 )
 
# Ammo Pallet US_M789  (supply class V)
  value: AMMO_PALLET_US_M789 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 39 )
 
# Ammo Pallet US_M792  (supply class V)
  value: AMMO_PALLET_US_M792 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 40 )
 
# Ammo Pallet US_M795  (supply class V)
  value: AMMO_PALLET_US_M795 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 41 )
 
# Ammo Pallet US_M804  (supply class V)
  value: AMMO_PALLET_US_M804 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 42 )
 
# Ammo Pallet US_M819A1  (supply class V)
  value: AMMO_PALLET_US_M819A1 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 43 )
 
# Ammo Pallet US_M821A1  (supply class V)
  value: AMMO_PALLET_US_M821A1 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 44 )
 
# Ammo Pallet US_M825  (supply class V)
  value: AMMO_PALLET_US_M825 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 45 )
 
# Ammo Pallet US_M829A2  (supply class V)
  value: AMMO_PALLET_US_M829A2 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 46 )
 
# Ammo Pallet US_M830A1  (supply class V)
  value: AMMO_PALLET_US_M830A1 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 47 )
 
# Ammo Pallet US_M853A1  (supply class V)
  value: AMMO_PALLET_US_M853A1 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 48 )
 
# Ammo Pallet US_M855  (supply class V)
  value: AMMO_PALLET_US_M855 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 49 )
 
# Ammo Pallet US_M864  (supply class V)
  value: AMMO_PALLET_US_M864 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 50 )
 
# Ammo Pallet US_M889A1  (supply class V)
  value: AMMO_PALLET_US_M889A1 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 51 )
 
# Ammo Pallet US_M919  (supply class V)
  value: AMMO_PALLET_US_M919 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 52 )
 
# Ammo Pallet US_M933_934  (supply class V)
  value: AMMO_PALLET_US_M933_934 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 53 )
 
# Ammo Pallet US_M940  (supply class V)
  value: AMMO_PALLET_US_M940 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 54 )
 
# Ammo Pallet US_Mk22  (supply class V)
  value: AMMO_PALLET_US_MK22 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 55 )
 
# Ammo Pallet US_MLRS_MSTAR  (supply class V)
  value: AMMO_PALLET_US_MLRS_MSTAR (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 56 )
 
# Ammo Pallet US_MLRS_SAD  (supply class V)
  value: AMMO_PALLET_US_MLRS_SAD (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 57 )
 
# Ammo Pallet US_MLRS_SAD_ER  (supply class V)
  value: AMMO_PALLET_US_MLRS_SAD_ER (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 58 )
 
# Ammo Pallet US_MX943  (supply class V)
  value: AMMO_PALLET_US_MX943 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 59 )
 
# Ammo Pallet US_NLOS  (supply class V)
  value: AMMO_PALLET_US_NLOS (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 60 )
 
# Ammo Pallet US_PGMM  (supply class V)
  value: AMMO_PALLET_US_PGMM (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 61 )
 
# Ammo Pallet US_Stinger  (supply class V)
  value: AMMO_PALLET_US_STINGER (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 62 )
 
# Ammo Pallet US_TOW  (supply class V)
  value: AMMO_PALLET_US_TOW (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 63 )
  
# Ammo Pallet US_XM867  (supply class V)
  value: AMMO_PALLET_US_XM867 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 64 )
 
# Ammo Pallet US_XM898  (supply class V)
  value: AMMO_PALLET_US_XM898 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 65 )
 
# Ammo Pallet US_XM951  (supply class V)
  value: AMMO_PALLET_US_XM951 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 66 )
 
# Ammo Pallet US_M971  (supply class V)
  value: AMMO_PALLET_US_M971 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 67 )
 
# Ammo Pallet US_XM982  (supply class V)
  value: AMMO_PALLET_US_XM982 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 68 )
 
# Ammo Pallet US_XR_M77  (supply class V)
  value: AMMO_PALLET_US_XR_M77 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 69 )

#  US MINE PALLETS
# Mine Pallet US_BLU91B  (supply class V)
  value: MINE_PALLET_munition_US_BLU91B (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 70 )
 
# Mine Pallet US_BLU92B  (supply class V)
  value: MINE_PALLET_munition_US_BLU92B (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 71 )
 
# Mine Pallet US_HORNET  (supply class V)
  value: MINE_PALLET_munition_US_HORNET (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 72 )
 
# Mine Pallet US_M14  (supply class V)
  value: MINE_PALLET_munition_US_M14 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 73 )
 
# Mine Pallet US_M15  (supply class V)
  value: MINE_PALLET_munition_US_M15 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 74 )
 
# Mine Pallet US_M16A2  (supply class V)
  value: MINE_PALLET_munition_US_M16A2 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 75 )
 
# Mine Pallet US_M18A1  (supply class V)
  value: MINE_PALLET_munition_US_M18A1 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 76 )
 
# Mine Pallet US_M19  (supply class V)
  value: MINE_PALLET_munition_US_M19 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 77 )
 
# Mine Pallet US_M21  (supply class V)
  value: MINE_PALLET_munition_US_M21 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 78 )
 
# Mine Pallet US_M67  (supply class V)
  value: MINE_PALLET_munition_US_M67 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 79 )
 
# Mine Pallet US_M70  (supply class V)
  value: MINE_PALLET_munition_US_M70 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 80 )
 
# Mine Pallet US_M72  (supply class V)
  value: MINE_PALLET_munition_US_M72 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 81 )
 
# Mine Pallet US_M73_mine  (supply class V)
  value: MINE_PALLET_munition_US_M73_mine (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 82 )
 
# Mine Pallet US_M74  (supply class V)
  value: MINE_PALLET_munition_US_M74 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 83 )
 
# Mine Pallet US_M75  (supply class V)
  value: MINE_PALLET_munition_US_M75 (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 84 )
 
# Mine Pallet US_M76_mine  (supply class V)
  value: MINE_PALLET_munition_US_M76_mine (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 85 )
 
# Mine Pallet US_M77_mine  (supply class V)
  value: MINE_PALLET_munition_US_M77_mine (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 86 )
 
# Mine Pallet US_SLAM  (supply class V)
  value: MINE_PALLET_munition_US_SLAM (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 87 )
 
# Mine Pallet US_VOLCANO_AP  (supply class V)
  value: MINE_PALLET_munition_US_VOLCANO_AP (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 88 )
 
# Mine Pallet US_VOLCANO_AT  (supply class V)
  value: MINE_PALLET_munition_US_VOLCANO_AT (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 89 )
 
# Mine Pallet MECH_Volcano  (supply class V)
  value: MINE_PALLET_MECH_Volcano (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 90 )
 
# Mine Pallet MOPMS  (supply class V)
  value: MINE_PALLET_MOPMS (objectDomainStructure | 
	 structureClassPallet | palletCountryUS | palletClassV | 91 )
 

# USSR AMMO PALLETS

# Ammo Pallet USSR_120MM_MCS_E  (supply class V)
  value: AMMO_PALLET_USSR_120MM_MCS_E (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 1 )
 
# Ammo Pallet USSR_125HE_Frag  (supply class V)
  value: AMMO_PALLET_USSR_125HE_Frag (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 2 )
 
# Ammo Pallet USSR_125HEAT  (supply class V)
  value: AMMO_PALLET_USSR_125HEAT (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 3 )
 
# Ammo Pallet USSR_125SABOT  (supply class V)
  value: AMMO_PALLET_USSR_125SABOT (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 4 )
 
# Ammo Pallet USSR_127AA  (supply class V)
  value: AMMO_PALLET_USSR_127AA (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 5 )
 
# Ammo Pallet USSR_127MG  (supply class V)
  value: AMMO_PALLET_USSR_127MG (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 6 )
 
# Ammo Pallet USSR_145MG  (supply class V)
  value: AMMO_PALLET_USSR_145MG (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 7 )
 
# Ammo Pallet USSR_23AP  (supply class V)
  value: AMMO_PALLET_USSR_23AP (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 8 )
 
# Ammo Pallet USSR_3023_DPICM  (supply class V)
  value: AMMO_PALLET_USSR_3023_DPICM (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 9 )
 
# Ammo Pallet USSR_30HE  (supply class V)
  value: AMMO_PALLET_USSR_30HE (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 10 )
 
# Ammo Pallet USSR_30HE_2S6  (supply class V)
  value: AMMO_PALLET_USSR_30HE_2S6 (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 11 )
 
# Ammo Pallet USSR_30HE_BMP2  (supply class V)
  value: AMMO_PALLET_USSR_30HE_BMP2 (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 12 )
 
# Ammo Pallet USSR_30HE_Ka50  (supply class V)
  value: AMMO_PALLET_USSR_30HE_Ka50 (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 13 )
 
# Ammo Pallet USSR_30SABOT_BMP2  (supply class V)
  value: AMMO_PALLET_USSR_30SABOT_BMP2 (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 14 )
 
# Ammo Pallet USSR_30SABOT_Ka50  (supply class V)
  value: AMMO_PALLET_USSR_30SABOT_Ka50 (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 15 )
 
# Ammo Pallet USSR_73HEAT  (supply class V)
  value: AMMO_PALLET_USSR_73HEAT (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 16 )
 
# Ammo Pallet USSR_9K25  (supply class V)
  value: AMMO_PALLET_USSR_9K25 (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 17 )
 
# Ammo Pallet USSR_ATP_H2  (supply class V)
  value: AMMO_PALLET_USSR_ATP_H2 (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 18 )
 
# Ammo Pallet USSR_BK_M_HEAT_FS  (supply class V)
  value: AMMO_PALLET_USSR_BK_M_HEAT_FS (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 19 )
 
# Ammo Pallet USSR_D  (supply class V)
  value: AMMO_PALLET_USSR_D (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 20 )
 
# Ammo Pallet USSR_D_462  (supply class V)
  value: AMMO_PALLET_USSR_D_462 (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 21 )
 
# Ammo Pallet USSR_D_540  (supply class V)
  value: AMMO_PALLET_USSR_D_540 (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 22 )
 
# Ammo Pallet USSR_ER540  (supply class V)
  value: AMMO_PALLET_USSR_ER540 (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 23 )
 
# Ammo Pallet USSR_Gaskin  (supply class V)
  value: AMMO_PALLET_USSR_GASKIN (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 24 )
 
# Ammo Pallet USSR_Gauntlet  (supply class V)
  value: AMMO_PALLET_USSR_GAUNTLET (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 25 )
 
# Ammo Pallet USSR_HR843A  (supply class V)
  value: AMMO_PALLET_USSR_HR843A (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 26 )
 
# Ammo Pallet USSR_MASD_DPICM  (supply class V)
  value: AMMO_PALLET_USSR_MASD_DPICM (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 27 )
 
# Ammo Pallet USSR_MCS_SMART  (supply class V)
  value: AMMO_PALLET_USSR_MCS_SMART (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 28 )
 
# Ammo Pallet USSR_MMB_120_SMART  (supply class V)
  value: AMMO_PALLET_USSR_MMB_120_SMART (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 29 )
 
# Ammo Pallet USSR_M_21_OF  (supply class V)
  value: AMMO_PALLET_USSR_M_21_OF (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 30 )
 
# Ammo Pallet USSR_OF843B  (supply class V)
  value: AMMO_PALLET_USSR_OF843B (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 31 )
 
# Ammo Pallet USSR_OF_45  (supply class V)
  value: AMMO_PALLET_USSR_OF_45 (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 32 )
 
# Ammo Pallet USSR_OF_462  (supply class V)
  value: AMMO_PALLET_USSR_OF_462 (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 33 )
 
# Ammo Pallet USSR_OF_540  (supply class V)
  value: AMMO_PALLET_USSR_OF_540 (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 34 )
 
# Ammo Pallet USSR_OF_61  (supply class V)
  value: AMMO_PALLET_USSR_OF_61 (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 35 )
 
# Ammo Pallet USSR_PS  (supply class V)
  value: AMMO_PALLET_USSR_PS (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 36 )
 
# Ammo Pallet USSR_Rocket_64  (supply class V)
  value: AMMO_PALLET_USSR_ROCKET_64 (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 37 )
 
# Ammo Pallet USSR_Sagger  (supply class V)
  value: AMMO_PALLET_USSR_SAGGER (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 38 )
 
# Ammo Pallet USSR_SA_16  (supply class V)
  value: AMMO_PALLET_USSR_SA_16 (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 39 )
 
# Ammo Pallet USSR_SA_19  (supply class V)
  value: AMMO_PALLET_USSR_SA_19 (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 40 )
 
# Ammo Pallet USSR_Songster  (supply class V)
  value: AMMO_PALLET_USSR_SONGSTER (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 41 )
 
# Ammo Pallet USSR_Spandrel  (supply class V)
  value: AMMO_PALLET_USSR_SPANDREL (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 42 )
 
# Ammo Pallet USSR_Spigot  (supply class V)
  value: AMMO_PALLET_USSR_SPIGOT (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 43 )
 
# Ammo Pallet USSR_Spiral  (supply class V)
  value: AMMO_PALLET_USSR_SPIRAL (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 44 )
 
# Ammo Pallet USSR_UV32_57 (supply class V)
  value: AMMO_PALLET_USSR_UV32_57 (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 45 )
 
# Ammo Pallet USSR_VOG_17M  (supply class V)
  value: AMMO_PALLET_USSR_VOG_17M (objectDomainStructure | 
	 structureClassPallet |  palletCountryUSSR | palletClassV | 46 )

#  USSR MINE PALLETS

# Mine Pallet USSR_MON100  (supply class V)
  value: MINE_PALLET_munition_USSR_MON100 (objectDomainStructure | 
	 structureClassPallet | palletCountryUSSR | palletClassV | 47 )
 
# Mine Pallet USSR_MON200  (supply class V)
  value: MINE_PALLET_munition_USSR_MON200 (objectDomainStructure | 
	 structureClassPallet | palletCountryUSSR | palletClassV | 48 )
 
# Mine Pallet USSR_MON50  (supply class V)
  value: MINE_PALLET_munition_USSR_MON50 (objectDomainStructure | 
	 structureClassPallet | palletCountryUSSR | palletClassV | 49 )
 
# Mine Pallet USSR_OMZ3  (supply class V)
  value: MINE_PALLET_munition_USSR_OMZ3 (objectDomainStructure | 
	 structureClassPallet | palletCountryUSSR | palletClassV | 50 )
 
# Mine Pallet USSR_PGMDM  (supply class V)
  value: MINE_PALLET_munition_USSR_PGMDM (objectDomainStructure | 
	 structureClassPallet | palletCountryUSSR | palletClassV | 51 )
 
# Mine Pallet USSR_PMK40  (supply class V)
  value: MINE_PALLET_munition_USSR_PMK40 (objectDomainStructure | 
	 structureClassPallet | palletCountryUSSR | palletClassV | 52 )
 
# Mine Pallet USSR_PMN  (supply class V)
  value: MINE_PALLET_munition_USSR_PMN (objectDomainStructure | 
	 structureClassPallet | palletCountryUSSR | palletClassV | 53 )
 
# Mine Pallet USSR_POMZ2  (supply class V)
  value: MINE_PALLET_munition_USSR_POMZ2 (objectDomainStructure | 
	 structureClassPallet | palletCountryUSSR | palletClassV | 54 )
 
# Mine Pallet USSR_PTMIK  (supply class V)
  value: MINE_PALLET_munition_USSR_PTMIK (objectDomainStructure | 
	 structureClassPallet | palletCountryUSSR | palletClassV | 55 )
 
# Mine Pallet USSR_TM46  (supply class V)
  value: MINE_PALLET_munition_USSR_TM46 (objectDomainStructure | 
	 structureClassPallet | palletCountryUSSR | palletClassV | 56 )
 
# Mine Pallet USSR_TM57  (supply class V)
  value: MINE_PALLET_munition_USSR_TM57 (objectDomainStructure | 
	 structureClassPallet | palletCountryUSSR | palletClassV | 57 )
 
# Mine Pallet USSR_TM62  (supply class V)
  value: MINE_PALLET_munition_USSR_TM62 (objectDomainStructure | 
	 structureClassPallet | palletCountryUSSR | palletClassV | 58 )
 
# Mine Pallet USSR_TMD_B  (supply class V)
  value: MINE_PALLET_munition_USSR_TMD_B (objectDomainStructure | 
	 structureClassPallet | palletCountryUSSR | palletClassV | 59 )
 
# Mine Pallet USSR_TMK2  (supply class V)
  value: MINE_PALLET_munition_USSR_TMK2 (objectDomainStructure | 
	 structureClassPallet | palletCountryUSSR | palletClassV | 60 )
 
# Mine Pallet USSR_TMN46  (supply class V)
  value: MINE_PALLET_munition_USSR_TMN46 (objectDomainStructure | 
	 structureClassPallet | palletCountryUSSR | palletClassV | 61 )
 
# Mine Pallet USSR_TMRP6  (supply class V)
  value: MINE_PALLET_munition_USSR_TMRP6 (objectDomainStructure | 
	 structureClassPallet | palletCountryUSSR | palletClassV | 62 )
 
# Mine Pallet USSR_YAM5  (supply class V)
  value: MINE_PALLET_munition_USSR_YAM5 (objectDomainStructure | 
	 structureClassPallet | palletCountryUSSR | palletClassV | 63 )
 
 
# Germany Pallets

# Ammo Pallet German_120HEAT  (supply class V)
  value: AMMO_PALLET_GERMAN_120HEAT (objectDomainStructure | 
	 structureClassPallet | palletCountryGermany | palletClassV | 1 )
 
# Ammo Pallet German_120SABOT  (supply class V)
  value: AMMO_PALLET_GERMAN_120SABOT (objectDomainStructure | 
	 structureClassPallet | palletCountryGermany | palletClassV | 2 )
 
# Ammo Pallet German_DM63  (supply class V)
  value: AMMO_PALLET_GERMAN_DM63 (objectDomainStructure | 
	 structureClassPallet | palletCountryGermany | palletClassV | 3 )
 
# Ammo Pallet German_DM81  (supply class V)
  value: AMMO_PALLET_GERMAN_DM81 (objectDomainStructure | 
	 structureClassPallet | palletCountryGermany | palletClassV | 4 )
 
# Ammo Pallet German_HOT  (supply class V)
  value: AMMO_PALLET_GERMAN_HOT (objectDomainStructure | 
	 structureClassPallet | palletCountryGermany | palletClassV | 5 )
 
# Ammo Pallet German_Milan  (supply class V)
  value: AMMO_PALLET_GERMAN_MILAN (objectDomainStructure | 
	 structureClassPallet | palletCountryGermany | palletClassV | 6 )
 
# Ammo Pallet German_Panzerfaust  (supply class V)
  value: AMMO_PALLET_GERMAN_PANZERFAUST (objectDomainStructure | 
	 structureClassPallet | palletCountryGermany | palletClassV | 7 )

#  Yugoslavia
 
# Mine Pallet YUGO_IU  (supply class V)
  value: MINE_PALLET_munition_YUGO_IU (objectDomainStructure | 
	 structureClassPallet | palletCountryYugoslavia | palletClassV | 1 )
 
# Mine Pallet YUGO_TMRP6  (supply class V)
  value: MINE_PALLET_munition_YUGO_TMRP6 (objectDomainStructure | 
	 structureClassPallet | palletCountryYugoslavia | palletClassV | 2 )
 
#  Egypt

# Mine Pallet EGYPT_M80  (supply class V)
  value: MINE_PALLET_munition_EGYPT_M80 (objectDomainStructure | 
	 structureClassPallet | palletCountryEgypt | palletClassV | 1 )
 

#  Italy

# Mine Pallet ITALY_SB81  (supply class V)
  value: MINE_PALLET_munition_ITALY_SB81 (objectDomainStructure | 
	 structureClassPallet | palletCountryItaly | palletClassV | 1 )
 
# Mine Pallet ITALY_SBMV  (supply class V)
  value: MINE_PALLET_munition_ITALY_SBMV (objectDomainStructure | 
	 structureClassPallet | palletCountryItaly | palletClassV | 2 )
 
# Mine Pallet ITALY_SH55  (supply class V)
  value: MINE_PALLET_munition_ITALY_SH55 (objectDomainStructure | 
	 structureClassPallet | palletCountryItaly | palletClassV | 3 )
 
# Mine Pallet ITALY_TC24  (supply class V)
  value: MINE_PALLET_munition_ITALY_TC24 (objectDomainStructure | 
	 structureClassPallet | palletCountryItaly | palletClassV | 4 )
 
# Mine Pallet ITALY_TC6  (supply class V)
  value: MINE_PALLET_munition_ITALY_TC6 (objectDomainStructure | 
	 structureClassPallet | palletCountryItaly | palletClassV | 5 )
 
# Mine Pallet ITALY_TCE6  (supply class V)
  value: MINE_PALLET_munition_ITALY_TCE6 (objectDomainStructure | 
	 structureClassPallet | palletCountryItaly | palletClassV | 6 )
 
# Mine Pallet ITALY_VS16  (supply class V)
  value: MINE_PALLET_munition_ITALY_VS16 (objectDomainStructure | 
	 structureClassPallet | palletCountryItaly | palletClassV | 7 )
 
# Mine Pallet ITALY_VSHCT  (supply class V)
  value: MINE_PALLET_munition_ITALY_VSHCT (objectDomainStructure | 
	 structureClassPallet | palletCountryItaly | palletClassV | 8 )
 
#  UK

# Mine Pallet UK_L14A1  (supply class V)
  value: MINE_PALLET_munition_UK_L14A1 (objectDomainStructure | 
	 structureClassPallet | palletCountryUK | palletClassV | 1 )
 
# Mine Pallet UK_MK7  (supply class V)
  value: MINE_PALLET_munition_UK_MK7 (objectDomainStructure | 
	 structureClassPallet | palletCountryUK | palletClassV | 2 )





#
# Life forms.
#
# a friendly (by convention) DI 
 
namespace_def: lifeForm

  value: DI1 (objectDomainLifeForm | 1)
# an enemy (by convention) DI  
  value: DI2 (objectDomainLifeForm | 2)
# A friendly (by convention) group of DI  
  value: DIGroupFriend (objectDomainLifeForm | 3)
# An enemy (by convention) group of DI  
  value: DIGroupFoe (objectDomainLifeForm | 4)
# A friendly (by convention) line of DI  
  value: DILineFriend (objectDomainLifeForm | 5)
# An enemy (by convention) line of DI  
  value: DILineFoe (objectDomainLifeForm | 6)
# A friendly (by convention) column of DI 	 
  value: DIColumnFriend (objectDomainLifeForm | 7)
# An enemy (by convention) column of DI  
  value: DIColumnFoe (objectDomainLifeForm | 8)
# An enemy group of DI with MG  
  value: DIGroupFoeMg (objectDomainLifeForm | 9)
# An enemy group of DI with AGS17 
  value: DIGroupFoeAgs17 (objectDomainLifeForm | 10)
# An enemy group of DI with LFK5 
  value: DIGroupFoeLfk5 (objectDomainLifeForm | 11)
# A friend group of DI with MG 
  value: DIGroupFriendMg (objectDomainLifeForm | 12)
# A friend group of DI with MILAN 
  value: DIGroupFriendMilan (objectDomainLifeForm | 13)

#
# DI Groups
#
# A 6-pack of US DI with a machine gun
 

  value: US_DIGroup6_Mg (objectDomainLifeForm | 14)
# A 6-pack of USSR DI with a machine gun 
  value: USSR_DIGroup6_Mg (objectDomainLifeForm | 15)
# A 3-pack of USSR DI with an AGS17 genade launcher 
  value: USSR_DIGroup3_Ags17 (objectDomainLifeForm | 16)
# A 2-pack of USSR DI with a LFK5 missile launcher 
  value: USSR_DIGroup2_Lfk5 (objectDomainLifeForm | 17)
# A 6-pack of German DI with a machine gun 
  value: Germany_DIGroup6_Mg (objectDomainLifeForm | 18)
# A 2-pack of German DI with a MILAN missile launcher 
  value: Germany_DIGroup2_Milan (objectDomainLifeForm | 19)

#
# DI Individuals
#
# A US DI with a rifle
 

  value: US_DI_Rifle (objectDomainLifeForm | 20)
# A USSR DI with a rifle 
  value: USSR_DI_Rifle (objectDomainLifeForm | 21)
# A German DI with a rifle 
  value: Germany_DI_Rifle (objectDomainLifeForm | 22)
# A US DI with a Dragon 
  value: US_DI_Dragon (objectDomainLifeForm | 23)
# A US DI with a Javelin 
  value: US_DI_Javelin (objectDomainLifeForm | 24)
# A US DI with a Stinger 
  value: US_DI_Stinger (objectDomainLifeForm | 25)
# A USSR DI with a SA-16 
  value: USSR_DI_SA_16 (objectDomainLifeForm | 26)
# A US DI with LaserDsg 
  value: US_DI_LaserDsg (objectDomainLifeForm | 32)
# A US DI Forward Observer/Forward Area Controller 
  value: US_DI_FOFAC (objectDomainLifeForm | 33)
# A US DI with a rifle acting as a FDC 
  value: US_DI_Rifle_FDC (objectDomainLifeForm | 34)
# A US DI with a M224 60mm mortar 
  value: US_DI_M224 (objectDomainLifeForm | 35)

#
# DI Groups in Defense
#
# A 6-pack of USSR DI with a machine gun
 

  value: USSR_DIDefenseGroup6_Mg (objectDomainLifeForm | 27)
# A 3-pack of USSR DI with an AGS17 genade launcher 
  value: USSR_DIDefenseGroup3_Ags17 (objectDomainLifeForm | 28)
# A 2-pack of USSR DI with a LFK5 missile launcher 
  value: USSR_DIDefenseGroup2_Lfk5 (objectDomainLifeForm | 29)
# A 6-pack of German DI with a machine gun 
  value: Germany_DIDefenseGroup6_Mg (objectDomainLifeForm | 30)
# A 2-pack of German DI with a MILAN missile launcher 
  value: Germany_DIDefenseGroup2_Milan (objectDomainLifeForm | 31)




#  Casuality types for Medical Play
  value: US_litter_casualty (objectDomainLifeForm | 36)
  value: US_ambulatory_casualty (objectDomainLifeForm | 37)

#  Repairmen types for Maintenance play
  value: US_org_repairman (objectDomainLifeForm | 38)
  value: US_support_repairman (objectDomainLifeForm | 39)



#
# US ICs for USMC SAF (NOTE that as the above LADS controlled list grows,
#	the numbers keep bumping into the MC SF list.  bump them up a bit here,
#	then as necessary to keep separation)
 
# USMC Rifle Squad Leader 
  value: USMC_DI_RSqLdr (objectDomainLifeForm | lifeformClassRifle | 100) 

# USMC FireTeam Leader 
  value: USMC_DI_FTLdr (objectDomainLifeForm | lifeformClassRifle | 101)

# USMC FireTeam SAW machine gunner 
  value: USMC_DI_FTSAW (objectDomainLifeForm | lifeformClassSaw | 102) 

# USMC FireTeam SAW gunner asst 
  value: USMC_DI_FTSAWA (objectDomainLifeForm | lifeformClassRifle | 103) 

# USMC FireTeam Rifleman 
  value: USMC_DI_FTRifle (objectDomainLifeForm | lifeformClassRifle | 104) 

# USMC AssaultTeam Ldr/SMAW Gunner 
  value: USMC_DI_ATSMAW (objectDomainLifeForm | lifeformClassSmaw | 105) 

# USMC AT SMAW Assistant Gunner 
  value: USMC_DI_ATSMAWA (objectDomainLifeForm | lifeformClassRifle | 106) 


# USMC Assault Section Leader 
  value: USMC_DI_ATSCLdr (objectDomainLifeForm | lifeformClassRifle | 40) 

# USMC 240G MachineGun Team Leader 
  value: USMC_DI_240MGTLdr (objectDomainLifeForm | lifeformClassRifle | 41) 

# USMC 240G MachineGun Gunner 
  value: USMC_DI_240MGun (objectDomainLifeForm | lifeformClassMGun | 42) 

# USMC 240G Ammo Bearer 
  value: USMC_DI_240MGA (objectDomainLifeForm | lifeformClassRifle | 43)

# USMC 240G MachineGun Squad Ldr 
  value: USMC_DI_240MGSQLdr (objectDomainLifeForm | lifeformClassRifle | 44) 

# USMC 240G MachineGun Section Ldr 
  value: USMC_DI_240MGSCLdr (objectDomainLifeForm | lifeformClassRifle | 45) 

# USMC DragonTeam Leader/Gunner 
  value: USMC_DI_Dragon (objectDomainLifeForm | lifeformClassDragon | 46) 

# USMC Assistant Dragon Gunner 
  value: USMC_DI_DragonA (objectDomainLifeForm | lifeformClassRifle | 47) 

# USMC Dragon Section Leader 
  value: USMC_DI_DrSCLdr (objectDomainLifeForm | lifeformClassRifle | 48) 

# USMC HeavyMachineGun Squad Leader 
  value: USMC_DI_HMGSQLdr (objectDomainLifeForm | lifeformClassRifle | 49)

# USMC HeavyMachineGun Gunner 
  value: USMC_DI_HMGun (objectDomainLifeForm | lifeformClassHvyMGun | 50) 

# USMC HeavyMachineGun Gunner Asst 
  value: USMC_DI_HMGA (objectDomainLifeForm | lifeformClassRifle | 51) 

# USMC HeavyMachineGun Ammo Bearer 
  value: USMC_DI_HMGammo (objectDomainLifeForm | lifeformClassRifle | 52) 

# USMC HeavyMachineGun Squad Leader 
  value: USMC_DI_HMGPltCdr (objectDomainLifeForm | lifeformClassRifle | 53) 

# USMC HeavyMachineGun Squad Leader 
  value: USMC_DI_HMGPltSgt (objectDomainLifeForm | lifeformClassRifle | 54) 

# USMC HeavyMachineGun Ammo Bearer 
  value: USMC_DI_HMGPltAmmo (objectDomainLifeForm | lifeformClassRifle | 55) 

# USMC AT TOW Squad Leader 
  value: USMC_DI_TOWSCLdr (objectDomainLifeForm | lifeformClassRifle | 56) 

# USMC AT TOW Squad Leader 
  value: USMC_DI_TOWSCDrv (objectDomainLifeForm | lifeformClassRifle | 57) 

# USMC AT TOW Squad Leader 
  value: USMC_DI_TOWSQLdr (objectDomainLifeForm | lifeformClassRifle | 58)

# USMC AT TOW-1 Gunner 
  value: USMC_DI_TOWGunr1 (objectDomainLifeForm | lifeformClassTow | 59) 

# USMC AT TOW-2 Gunner 
  value: USMC_DI_TOWGunr2 (objectDomainLifeForm | lifeformClassTow | 60) 

# USMC AT TOW-1 Assistant Gunner 
  value: USMC_DI_TOWGunA1 (objectDomainLifeForm | lifeformClassRifle | 61) 

# USMC AT TOW-2 Assistant Gunner 
  value: USMC_DI_TOWGunA2 (objectDomainLifeForm | lifeformClassRifle | 62)

# USMC Rifle Co Commander 
  value: USMC_DI_RCoCdr (objectDomainLifeForm | lifeformClassRifle | 63)

# USMC Rifle Co Exec Officer 
  value: USMC_DI_RCoXO (objectDomainLifeForm | lifeformClassRifle | 64)

# USMC Rifle Co First Sergeant 
  value: USMC_DI_RCo1stSgt (objectDomainLifeForm | lifeformClassRifle | 65)

# USMC Rifle Co Gunnery Sergeant 
  value: USMC_DI_RCoGSgt (objectDomainLifeForm | lifeformClassRifle | 66) 

# USMC Rifle Co Property NCO 
  value: USMC_DI_RCoPropNCO (objectDomainLifeForm | lifeformClassRifle | 67)

# USMC Rifle Co Messenger/Driver 
  value: USMC_DI_RCoMess (objectDomainLifeForm | lifeformClassRifle | 68)

# USMC Rifle Plt Commander 
  value: USMC_DI_RPltCdr (objectDomainLifeForm | lifeformClassRifle | 69) 

# USMC Rifle Plt Sergeant 
  value: USMC_DI_RPltSgt (objectDomainLifeForm | lifeformClassRifle | 70)

# USMC Rifle Plt Guide 
  value: USMC_DI_RPltGuide (objectDomainLifeForm | lifeformClassRifle | 71)

# USMC Rifle Plt Messenger 
  value: USMC_DI_RPltMess (objectDomainLifeForm | lifeformClassRifle | 72)

# USMC Weapons Plt Commander 
  value: USMC_DI_WPltCdr (objectDomainLifeForm | lifeformClassRifle | 73) 

# USMC Weapons Plt Sergeant 
  value: USMC_DI_WPltSgt (objectDomainLifeForm | lifeformClassRifle | 74) 

# HTI 
# USMC 60mm mortar squad leader 
  value: USMC_DI_60mmSqLdr (objectDomainLifeForm | lifeformClassRifle | 75) 

# USMC 60mm mortar squad assistant gunner 
  value: USMC_DI_60mmAGun (objectDomainLifeForm | lifeformClassRifle | 76) 

# USMC 60mm mortar squad ammo bearer 
  value: USMC_DI_60mmAmmo (objectDomainLifeForm | lifeformClassRifle | 77) 

# USMC 60mm mortar section leader 
  value: USMC_DI_60mmSectLdr (objectDomainLifeForm | lifeformClassRifle | 78)

# USMC 81mm mortar squad leader 
  value: USMC_DI_81mmSqLdr (objectDomainLifeForm | lifeformClassRifle | 79)

# USMC 81mm mortar squad gunner 
  value: USMC_DI_81mmGun (objectDomainLifeForm | lifeformClassRifle | 80) 

# USMC 81mm mortar squad assistant gunner 
  value: USMC_DI_81mmAGun (objectDomainLifeForm | lifeformClassRifle | 81) 

# USMC 81mm mortar squad ammo bearer 
  value: USMC_DI_81mmAmmo1 (objectDomainLifeForm | lifeformClassRifle | 82)

# USMC 81mm mortar squad ammo bearer 
  value: USMC_DI_81mmAmmo2 (objectDomainLifeForm | lifeformClassRifle | 83) 

# USMC 81mm mortar section leader 
  value: USMC_DI_81mmSectLdr (objectDomainLifeForm | lifeformClassRifle | 84)

# USMC 81mm mortar section ammo bearer 
  value: USMC_DI_81mmSectAmmo (objectDomainLifeForm | lifeformClassRifle | 85) 

# USMC 81mm mortar section ammo driver 
  value: USMC_DI_81mmSectAD (objectDomainLifeForm | lifeformClassRifle | 86)

# USMC 81mm mortar FDC plotter 
  value: USMC_DI_81mmFDCPlotter (objectDomainLifeForm | lifeformClassRifle | 87) 

# USMC 81mm mortar FDC recorder 
  value: USMC_DI_81mmFDCRecorder (objectDomainLifeForm | lifeformClassRifle | 88) 


