#ifndef lint
static char rcsid [] = "$RCSfile: test.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif
/****************************************************************************
*   File: test.c                                                            *
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*       This software was developed by Loral under U. S. Government contracts *
*       and may be reproduced by or for the U. S. Government pursuant to    *
*       the copyright license under the clause at DFARS 252.227-7013        *
*       (OCT 1988).                                                         *
*                                                                           *
*       Contents: Test program for libreader                                *
*       Created: Thu Jul  2 1992                                            *
*       Author: jesmith                                                     *
*       Remarks: Reads the file listed on the command line and prints what  *
*                it thinks it saw.  First command line arg is whether       *
*                the file is taged with symbols (0) or integers (1).        *
*                The second is the file name.                               *
****************************************************************************/

#include "libreader.h"
#include <string.h>
#include <stdio.h>

#define FALSE 0

main(int argc, char **argv)
{
    READER_UNION ru;
    char        *fname;
    READER_UNION *field;
    int32 	int_tags = 0;	
    char         *string;

    if (argc > 1)
    {
	if (!strcmp(argv[1],"1"))
	  int_tags = 1;

	if (argc == 2)
	  if (int_tags)
	    fname = "test_int.rdr";
	  else
	    fname = "test.rdr";
	else
	  fname = argv[2];
    }
    else
      fname = "test.rdr";

    reader_init(0);

    reader_set_search_paths(".", "/:/common/data:/saf/config");


#ifdef USE_READER_READ_FROM_STRING
    string = "((first (second third) fourth fifth (sixth 1234 3456)) (foo))";
    

    reader_read_from_string(string, &ru, READER_TYPING);

    printf("Pretty printed data from string:\n");
    reader_pretty_print(ru.array, stdout);

#endif /* USE_READER_READ_FROM_STRING */


    if (!reader_read(fname, NULL, &ru, READER_TYPING|READER_DEFAULTS))
    {
	printf("Pretty printed data file:\n");
	reader_pretty_print(ru.array, stdout);
    }

    if (!int_tags)
    {
	printf("foo association:\n");
	field = reader_find_tag(reader_get_symbol("foo"), ru.array, 
				FALSE, READER_NO_ERRORS);
	reader_pretty_print(field, stdout);

	printf("the following should be failed associations at different error levels\n");
    
	printf("NO_ERRORS\n");
	fflush(stdout);
	field = reader_find_tag(reader_get_symbol("not-there"), ru.array, 
			    FALSE, READER_NO_ERRORS);    

	printf("REPORT_ERRORS\n");
	fflush(stdout);
	field = reader_find_tag(reader_get_symbol("not-there"), ru.array, 
			    FALSE, READER_REPORT_ERRORS);    

	printf("ERRORS_WITH_CONTEXT\n");
	fflush(stdout);
	field = reader_find_tag(reader_get_symbol("not-there"), ru.array, 
			    FALSE, READER_ERRORS_WITH_CONTEXT);    

	printf("ERRORS_WITH_DESCRIPTION\n");
	fflush(stdout);
	field = reader_find_tag(reader_get_symbol("not-there"), ru.array, 
				FALSE, READER_ERRORS_WITH_DESCRIPTION,
				"Error from module \"%s\", int %d, float %f:",
				argv[0],
				42,
				43.45);
    } else
    {
	printf("4 association:\n");
	field = reader_find_tag_int(4, ru.array, FALSE, READER_NO_ERRORS);
	reader_pretty_print(field, stdout);

	printf("the following should be failed associations at different error levels\n");

	printf("NO_ERRORS\n");
	fflush(stdout);
	field = reader_find_tag_int(1000, ru.array, FALSE, READER_NO_ERRORS);  

	printf("REPORT_ERRORS\n");
	fflush(stdout);
	field = reader_find_tag_int(1000, ru.array, FALSE,
				    READER_REPORT_ERRORS);

	printf("ERRORS_WITH_CONTEXT\n");
	fflush(stdout);
	field = reader_find_tag_int(1000, ru.array, FALSE, 
				    READER_ERRORS_WITH_CONTEXT); 

	printf("ERRORS_WITH_DESCRIPTION\n");
	fflush(stdout);
	field =
	  reader_find_tag_int(1000, ru.array, FALSE,
			      READER_ERRORS_WITH_DESCRIPTION, 
			      "Error from module \"%s\", int %d, float %f:",
			      argv[0],
			      42,
			      43.45);
    }
}
