#ifndef lint
static char rcsid [] = "$RCSfile: preempt_test.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif
/****************************************************************************
*   File: preempt_test.c
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*	This software was developed by Loral under U. S. Government contracts *
*	and may be reproduced by or for the U. S. Government pursuant to    *
*	the copyright license under the clause at DFARS 252.227-7013        *
*	(OCT 1988).                                                         *
*                                                                           *
*       Contents: 
*       Created: Jul  7 1994
*       Author: swarts
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/

#include "libsched.h"
#include <stdext.h>
#include <librandom.h>
#include <sys/time.h>

static char messages[100][100];
static int next_message;
static int new_message;


static void periodic_func(period)
    int32 period;
{
    sprintf(messages[new_message],
	    "periodic %d\n", period);
    new_message = (new_message+1)%100;
}

static void defered_func()
{
    sprintf(messages[new_message],"defered\n");
    new_message = (new_message+1)%100;
}


int main()
{
    except_init(TRUE, FALSE);
    sched_init(0);
    time_init(0);
    sched_preemptive_periodic_fncl(periodic_func,
				   100,
				   100,
				   0,
				   A_INT, 100,
				   A_END);

    sched_preemptive_periodic_fncl(periodic_func,
				   1000,
				   1000,
				   0,
				   A_INT, 1000,
				   A_END);

    sched_preemptive_periodic_fncl(periodic_func,
				   500,
				   500,
				   0,
				   A_INT, 500,
				   A_END);

    while(1)
    {
	if (next_message != new_message)
	{
	    if (rnd_probability(0.1))
	    {
		uint32 delay = 500*rnd_uniform_dist();
		
		sched_preemptive_deferred_fncl(defered_func,
					       delay,
					       0,
					       A_END);
	    }
	    printf(messages[next_message]);
	    next_message = (next_message+1)%100;
	}
    }
}



