#ifndef lint
static char rcsid [] = "$RCSfile: sched_event.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif
/****************************************************************************
*   File: sched_event.c
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*	This software was developed by Loral under U. S. Government contracts *
*	and may be reproduced by or for the U. S. Government pursuant to    *
*	the copyright license under the clause at DFARS 252.227-7013        *
*	(OCT 1988).                                                         *
*                                                                           *
*       Contents: 
*       Created: Jul  7 1994
*       Author: swarts
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/

#include "libsched_local.h"
#include <stdalloc.h>

#ifdef DEBUG
char event_name[256];
#endif

void sched_event_init(SCHED_EVENT *event, EVENT_OPS *ops, int32 group)
{
    event->ops = ops;
    event->group = group;
    event->cancelled = FALSE;
#ifdef DEBUG
    event->name = strdup(event_name);
#endif
}

void sched_event_cancel(SCHED_EVENT *event)
{
    event->cancelled = TRUE;
}

void sched_event_delete_func(SCHED_EVENT *event)
{
    SCHED_EVENT_DESTROY(event);
    STDDEALLOC(event);
}



int32 sched_event_cancel_match_func(SCHED_EVENT *event,
				    SCHED_EVENT *event_to_match)
{
    return (event == event_to_match);
}




