#ifndef lint
static char rcsid [] = "$RCSfile: sched_init.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif
/****************************************************************************
*   File: sched_init.c
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*	This software was developed by Loral under U. S. Government contracts *
*	and may be reproduced by or for the U. S. Government pursuant to    *
*	the copyright license under the clause at DFARS 252.227-7013        *
*	(OCT 1988).                                                         *
*                                                                           *
*       Contents: 
*       Created: Jul  7 1994
*       Author: swarts
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/

#include "libsched.h"
#include <stdarg.h>
#include "libsched_local.h"

void sched_init(int32 nrings, ...)
{
    int32 i;
    uint32 period;
    static int32 scheduler_initted = 0;
    va_list args;

    if (scheduler_initted)
      return;

    scheduler_initted = 1;

    sched_pq_init(&sched_realtime_queue, SCHED_REAL_TIME);
    sched_pq_init(&sched_simtime_queue, SCHED_SIM_TIME);
    sched_preempt_queue_init(&sched_preempt_queue);
    sched_pq_init(&sched_hipri_queue, SCHED_HIGH_PRIORITY);

    va_start(args, nrings);
    for (i=0; i<nrings; i++)
    {
	period = va_arg(args,unsigned int);
	sched_ring_create(period, SCHED_REAL_TIME, 
			  SCHED_BASE_QUEUE(&sched_realtime_queue));
    }
    va_end(args);

#ifdef PYTHON_PARSER
    sched_init_python();
#endif
}

