#ifndef lint
static char rcsid [] = "$RCSfile: snstve_init.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif
/****************************************************************************
*   File: snstve_init.c                                                     *
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*       This software was developed by Loral under U. S. Government contracts *
*       and may be reproduced by or for the U. S. Government pursuant to    *
*       the copyright license under the clause at DFARS 252.227-7013        *
*       (OCT 1988).                                                         *
*                                                                           *
*       Contents: Code to create sensitive windows                          *
*       Created: Fri Sep 11 1992                                            *
*       Author: jesmith                                                     *
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/

#ifdef USE_X

#include "libsnstve_local.h"
#include <stdalloc.h> /*common/include/global*/
#include <stdext.h> /*common/include/global*/

void snstve_init(void)
{
    /*NOP*/;
}

SNSTVE_WINDOW_PTR snstve_create(Widget widget, GC draw_gc, GC erase_gc)
{
    SNSTVE_WINDOW_PTR result =
      (SNSTVE_WINDOW_PTR)STDALLOC(sizeof(struct snstve_window));

    bzero(result, sizeof(struct snstve_window));

    result->widget = widget;
    result->draw_gc = draw_gc;
    result->erase_gc = erase_gc;
    result->miss_callback = callback_define_event(A_PTR, A_INT, A_PTR, A_END);

    XtAddEventHandler(widget,
		      ButtonPressMask |
		      ButtonReleaseMask |
		      PointerMotionMask,
		      FALSE, snstve_gesture, (XtPointer)result);

    XtAddEventHandler(widget,
		      LeaveWindowMask,
		      FALSE, snstve_leave, (XtPointer)result);

    return result;
}

CALLBACK_EVENT_PTR snstve_miss_callback(SNSTVE_WINDOW_PTR window)
{
    return window->miss_callback;
}

#else

int snstve_dummy_archive_variable;

#endif /*USE_X*/
