#ifndef lint
static char rcsid [] = "$RCSfile: test.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif
/****************************************************************************
*   File: test.c                                                            *
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*       This software was developed by Loral under U. S. Government contracts *
*       and may be reproduced by or for the U. S. Government pursuant to    *
*       the copyright license under the clause at DFARS 252.227-7013        *
*       (OCT 1988).                                                         *
*                                                                           *
*       Contents: Test program for libtactmap                               *
*       Created: Thu Sep 17 1992                                            *
*       Author: jesmith                                                     *
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/
#define USE_PLAYBOX
#define GRIDS
#include "libtmap_local.h"
#include <libctdb.h>
#include <libsensitive.h>
#include <libcoordinates.h>
#include <librandom.h>
#include <libreader.h>
#include <librdrconst.h>
#include <libbgr.h>
#include <unit_type.h>
#include <veh_type.h>
#include <math.h>
#include <X11/Intrinsic.h>
#include <X11/bitmaps/tie_fighter>
#include <stdext.h> /*common/include/global*/
#include <sigfpe.h>
#include <libgcs.h>
#include <libworld.h>
#include <stdalloc.h>
#include <libotmatch.h>
#include <librdrconst.h>
#include <libcmdline.h>
#define CELL 2
#define RANDOM_X()  ( tactmap->playbox.min_x + rnd_uniform_dist()* \
		     (tactmap->playbox.max_x-tactmap->playbox.min_x ))
#define RANDOM_Y()  ( tactmap->playbox.min_y + rnd_uniform_dist()* \
		     (tactmap->playbox.max_y-tactmap->playbox.min_y ))
/* Define this to 1(TACTMAP_PIXMAP), 2(TACTMAP_PICTURE), 3(TACTMAP_DRAWN),
 * 4(TACTMAP_BGR), or 5(TACTMAP_PICTURE, non-libreader) for vehicles
 */
#define VEHSTYLE 1

/* Define this to draw contour lines */
#undef CONTOUR

/* Define this to do hypso coloring */
#undef HYPSO

/* Sets number of vehicles to draw on the screen */
#define NUMVEH 20
#define SHOW_VEHICLES

/* Sets the number of GCs and coordinate systems available for pictures */
#define NUMPICTGCS  4

/* Sets update frequency for vehicles */
#define VEHTICK 500 /*ms*/

/* Sets the number of vertices in the editable line */
#define LINELEN 0

/* Sets the max number of vertices in the contoured route */
#define ROUTELEN 100

/* Indicates what to draw vis-a-vis trees (CANOPIES, LINES, INDIVIDUAL) */
#define TREE_MASK TACTMAP_TREE_CANOPIES | TACTMAP_TREE_LINES ;

static Widget toplevel;
static TACTMAP_PTR tactmap;
static float64 scale;
static TACTMAP_OBJECT_DFN *linedfn;
static TACTMAP_OBJECT_PTR lineobj;
static TACTMAP_OBJECT_DFN *line_intervis_dfn;
static TACTMAP_OBJECT_PTR line_intervis_obj;
static TACTMAP_OBJECT_DFN *area_intervis_dfn;
static TACTMAP_OBJECT_PTR area_intervis_obj;
static TACTMAP_OBJECT_DFN *routedfn;
static TACTMAP_OBJECT_PTR routeobj;

static void
random_pt(int32 *c, float64 *x, float64 *y)
{
    int32 cell[1000];
    int32 n_cell=1000;
    
    wld_lookup_playbox_cells(&n_cell,cell);
    *c = cell[(int32)(rnd_uniform_dist()*n_cell)];
    *x = rnd_uniform_dist()*(tactmap->playbox.max_x-tactmap->playbox.min_x);
    *y = rnd_uniform_dist()*(tactmap->playbox.max_y-tactmap->playbox.min_y);
}


static void 
click(SNSTVE_WINDOW_PTR window, SNSTVE_ACTION action, SNSTVE_CALL_DATA *call_data)
{
    int32   c;
    float64 x, y;
    static wv_state=FALSE;

    if (call_data->button == 1)
    {
	wv_state = !wv_state;
	tactmap_world_view(tactmap, wv_state);
    }
    else if (call_data->button == 2)
    {
	if (wv_state)
	  return;

	tactmap_set_scale(tactmap, scale*=0.5);
    }
    else if (call_data->button == 3)
    {
	float64 map_x,map_y;
	int32 map_c;
	
	if (wv_state)
	{
	    tactmap_screen_to_map(tactmap,call_data->screen_x,
				  call_data->screen_y,&map_x,&map_y,&map_c);
	    tactmap_set_center(tactmap, (int32)map_x, (int32)map_y, 
			       map_c);
	    return;
	}
	else
	  tactmap_set_scale(tactmap, scale*=2.0); 
	
    }
    return;
#ifdef NEVER
      
      
    if (call_data->button == 1)
    {
	tactmap_world_view(tactmap, TRUE);
#ifdef NEVER
	tactmap_screen_to_map(tactmap,call_data->screen_x, 
			      call_data->screen_y,
			      &x, &y, &c);
	
	if (action == SNSTVE_PRESS)
	{
/*	    routedfn->linear.vertices[CELL] = cell;*/
	    routedfn->linear.vertices[X] = x;
	    routedfn->linear.vertices[Y] = y;
	}
#endif
#ifdef NEVER
	else
	{
	    ROUTE_POINT points[ROUTELEN];
	    int32 i, len;

	    len = ROUTELEN;
	    ctdb_contour_route(tactmap->ctdb,
			       routedfn->linear.vertices[X],
			       routedfn->linear.vertices[Y],
			       x, y, 1000.0, CTDB_VALLEY,
			       0.01745240643 /* sin(1 degree) */,
			       &len, points);
	    for (i=1;i<len;i++)
	      routedfn->linear.vertices[i*2] = points[i].point[X],
	      routedfn->linear.vertices[i*2+1] = points[i].point[Y];
	    routedfn->linear.n_vertices = len;
	    tactmap_update_object(tactmap, routeobj, routedfn);
	}
#endif
	return;
    }

    if (action == SNSTVE_PRESS)
    {
	tactmap_screen_to_map(tactmap,call_data->screen_x, 
			      call_data->screen_y,
			      &x, &y, &c);
	tactmap_set_center(tactmap, (int32)x, (int32)y, c);
#define ZOOMING
#ifdef ZOOMING
	if (call_data->button == 2)
	{
	    float64 map_x,map_y;
	    int32 map_c;
	    
	    tactmap_screen_to_map(tactmap,call_data->screen_x,
				    call_data->screen_y,&map_x,&map_y,&map_c);
	    tactmap_set_center(tactmap, (int32)map_x, (int32)map_y, 
			       map_c);
	    /*tactmap_set_scale(tactmap, scale*=0.5);*/
	}
	
	else if (call_data->button == 3)
	  tactmap_world_view(tactmap, TRUE);
/*	  tactmap_set_scale(tactmap, scale*=2.0); */
#endif
    }
#endif
}

static void 
print_gesture(SNSTVE_WINDOW_PTR sensitive, SNSTVE_ACTION action, SNSTVE_CALL_DATA *call_data, char *name)
{
    if (action == SNSTVE_PRESS)
      printf("Press on %s %d\n",
	     name,
	     (!strcmp(name, "vehicle")) ?
	     TACTMAP_INSTANCE_TO_USER_INSTANCE(call_data->instance) :
	     TACTMAP_INSTANCE_TO_INDEX(call_data->instance));
}

static void 
line_gesture(SNSTVE_WINDOW_PTR sensitive, SNSTVE_ACTION action, SNSTVE_CALL_DATA *call_data)
{
    int32 v,c;
    float64 dx, dy;

    if ((action == SNSTVE_PRESS) && (call_data->button == 3))
    {
	linedfn->linear.style += 1;
	if (linedfn->linear.style > LSwire)
	  linedfn->linear.style = LSplain;
	tactmap_update_object(tactmap, lineobj, linedfn);
    }
    else if ((action == SNSTVE_RELEASE) &&
	     (call_data->button == 1))
    {
	float64 offset[XYC];
	
	v = TACTMAP_INDEX(call_data->instance);
	tactmap_pix_to_offvec(tactmap,call_data->xoff,call_data->yoff,offset);
	if (TACTMAP_IS_VERTEX(call_data->instance))
	{ /* $$$ This processing needs to have the vector rotated into the 
	   * proper frame
	   */
	    linedfn->linear.vertices[v*2]   += offset[X];
	    linedfn->linear.vertices[v*2+1] += offset[Y];
	}
	else
	{/* $$$ This processing needs to have the vector rotated into the 
	   * proper frame
	   */
	    for(v=0;v<linedfn->linear.n_vertices;v++)
	    {
		linedfn->linear.vertices[v*2]   += offset[X];
		linedfn->linear.vertices[v*2+1] += offset[Y];
	    }
	}
	tactmap_update_object(tactmap, lineobj, linedfn);
    }
}

static void 
set_hot(SNSTVE_WINDOW_PTR sensitive, TACTMAP_OBJECT_PTR object, TACTMAP_OBJECT_DFN *dfn, int32 hot)
{
    snstve_set_class_buttons(sensitive, dfn->sensitive.class,
			     0, 1 << 1); /* Button 1 */
    snstve_set_class(sensitive, dfn->sensitive.class, hot, hot, 0);
}

#if VEHSTYLE == 3
static void 
draw_vehicle(widget, pixmap, draw_arg, boundary)
    Widget widget;
    Pixmap pixmap;
    ADDRESS draw_arg;
    XRectangle *boundary;
{
    static int32 initted = 0;
    static float64 dir[NUMVEH][2];
    static float64 loc[NUMVEH][XYC];
    static GC gc;
    XGCValues gcv;
    int32 index = (int32)draw_arg;
    int32 i;
    int32 x, y;
    int32 cell=tactmap->cur->cc;
    float64 tmplf;

    if (!initted)
    {
	int32 c;

	initted = 1;
	bzero(dir, sizeof(dir));
	for (i=0;i<NUMVEH;i++)
	  gcs_gcs2e_to_gcs(tactmap->cur->cc,(float64)RANDOM_X(),
			   (float64)RANDOM_Y(),&c,
			   &loc[i][X],&loc[i][Y]),
	  loc[i][CELL2D] = c;


	gcv.foreground = BlackPixelOfScreen(XtScreen(widget));
	gc = XCreateGC(XtDisplay(widget), pixmap, GCForeground, &gcv);
    }

    if (rnd_probability(0.05))
    {
	dir[index][0]    = -20 * rnd_probability(0.5) + 10;
	dir[index][1]    = -20 * rnd_probability(0.5) + 10;
    }

    loc[index][X] += dir[index][X];
    loc[index][Y] += dir[index][Y];

    if (tactmap_map_to_screen(tactmap, loc[index][X], loc[index][Y], cell,
			      &x, &y))
    { 
	XFillArc(XtDisplay(widget), pixmap, gc, x, y, 20, 40, 0, 360*64);
	boundary->x = x;
	boundary->y = y;
	boundary->width = 20;
	boundary->height = 40;
    }
    else
      bzero(boundary, sizeof(XRectangle));
}
#endif

static void 
move_vehicle(TACTMAP_OBJECT_PTR object, TACTMAP_OBJECT_DFN *dfn, int32 index, TACTMAP_OBJECT_PTR *object_ptr)
{
    static int32 dir_initted = 0;
    static float64 dir[NUMVEH][3];
    static float64 turret = 0.0;

    /* Skip deleted vehicles */
    if (!*object_ptr)
      return;
    
#if 0
    if (rnd_probability(0.05))
    {
	printf("Randomly deleting vehicle %d\n", index);
	tactmap_destroy_object(tactmap, object);
	*object_ptr = NULL;
	return;
    }
#endif

#if VEHSTYLE != 3
    if (!dir_initted)
    {
	bzero(dir, sizeof(dir));
	dir_initted = 1;
    }

    if (rnd_probability(0.05) || (dir[index][0] == 0.0))
    {
	dir[index][0] = rnd_uniform_dist() * TWO_PI;
	dir[index][1] = -sin(dir[index][0]);
	dir[index][2] =  cos(dir[index][0]);
    }

#if VEHSTYLE == 1
    dfn->pixmap.x += dir[index][1] * 20;
    dfn->pixmap.y += dir[index][2] * 20;
#elif VEHSTYLE == 4
    if (rnd_probability(0.05))
      dfn->bgr.size = (((float64) dfn->bgr.size) * 1.1);
    dfn->bgr.rotation = 
      floor((dir[index][0] + (PI/8.0))/(PI/4.0)) * (PI/4.0);
    dfn->bgr.x += dir[index][1] * 20;
    dfn->bgr.y += dir[index][2] * 20;
#else
    if (!index)
      turret += 0.1;

    dfn->picture.csystems[0].angle = dir[index][0];
    dfn->picture.csystems[0].origin[X] += dir[index][1] * 20;
    dfn->picture.csystems[0].origin[Y] += dir[index][2] * 20;
    dfn->picture.csystems[1].angle = turret;
#endif

#endif

    tactmap_update_object(tactmap, object, dfn);
}

static void 
tick_X(XtAppContext context)
{
    XEvent event;
    int pend;

    while (pend = XtAppPending(context))
    {
	if (pend & (XtIMXEvent  | XtIMTimer))
	{
	    XtAppProcessEvent(context, pend);
	}
	else
	  break;
    }
}

#define MAX_OT_ARRAY_SIZE 25

static ObjectType ot_array[MAX_OT_ARRAY_SIZE] =
{
    vehicle_USSR_BMP2,

    unit_US_M1_Platoon,
    unit_US_M1_Company,
    unit_US_M1_BattalionHQ,
    unit_US_M1_Battalion,

    vehicle_US_M1,

    unit_US_M2_Platoon,
    unit_US_M2_Company,
    unit_US_M2_BattalionHQ,
    unit_US_M2_Battalion,

    vehicle_US_M2,

    unit_USSR_T72M_Platoon,
    unit_USSR_T72M_Company,
    unit_USSR_T72M_BattalionHQ,
    unit_USSR_T72M_Battalion,

    vehicle_USSR_T72M,

    unit_USSR_BMP1_Platoon,
    unit_USSR_BMP1_Company,
    unit_USSR_BMP1_BattalionHQ,
    unit_USSR_BMP1_Battalion,

    vehicle_USSR_BMP1,

    unit_USSR_BMP2_Platoon,
    unit_USSR_BMP2_Company,
    unit_USSR_BMP2_BattalionHQ,
    unit_USSR_BMP2_Battalion,
};

static struct tactmap_picture_instruction programmed_inst[4];

static void 
init_programmed_inst(void)
{
    programmed_inst[0].interior_gc_index       = 0;
    programmed_inst[0].border_gc_index         = -1;
    programmed_inst[0].coordinate_system_index = 0;
    programmed_inst[0].kind                    = TACTMAP_PICTURE_DISC;
    programmed_inst[0].data.disc.center_x      = 0.0;
    programmed_inst[0].data.disc.center_y      = 0.0;
    programmed_inst[0].data.disc.radius        = 20.0;
    programmed_inst[0].data.disc.unit          = TACTMAP_PICTURE_METERS;
    programmed_inst[1].interior_gc_index       = 1;
    programmed_inst[1].border_gc_index         = -1;
    programmed_inst[1].coordinate_system_index = 1;
    programmed_inst[1].kind                    = TACTMAP_PICTURE_CIRCLE;
    programmed_inst[1].data.circle.width       = 2.0;
    programmed_inst[1].data.circle.center_x    = 5.0;
    programmed_inst[1].data.circle.center_y    = 5.0;
    programmed_inst[1].data.circle.radius      = 1.0;
    programmed_inst[1].data.circle.unit        = TACTMAP_PICTURE_METERS;
    programmed_inst[2]                         = programmed_inst[1];
    programmed_inst[2].data.circle.center_x    = -5.0;
    programmed_inst[3].interior_gc_index       = 1;
    programmed_inst[3].border_gc_index         = -1;
    programmed_inst[3].coordinate_system_index = 1;
    programmed_inst[3].kind                    = TACTMAP_PICTURE_LINE;
    programmed_inst[3].data.line.width         = 4.0;
    programmed_inst[3].data.line.num_xy_pairs  = 3;
    programmed_inst[3].data.line.xy_pairs[0]   = -5.0;
    programmed_inst[3].data.line.xy_pairs[1]   = 0.0;
    programmed_inst[3].data.line.xy_pairs[2]   = 0.0;
    programmed_inst[3].data.line.xy_pairs[3]   = -3.0;
    programmed_inst[3].data.line.xy_pairs[4]   = 5.0;
    programmed_inst[3].data.line.xy_pairs[5]   = 0.0;

}

void
main(int32 argc, char **argv)
{ 
    int32   tmpi;
    float64 tmplf;
    int32 hold_argc = argc;
    COORD_TCC_PTR tcc;
    XGCValues gcv;
    GC draw_gc, erase_gc;
    SNSTVE_WINDOW_PTR sensitive;
    TACTMAP_OBJECT_DFN dfn[NUMVEH+100];
    TACTMAP_OBJECT_PTR feature[NUMVEH+100];
#if LINELEN != 0
    float64 vertex_list[LINELEN*2];
#endif
    float64 route_list[ROUTELEN*2];
    Pixmap tie_fighter;
    GC pictgcs[NUMPICTGCS];
    struct tactmap_csystem csystems[2];
    char buf[NUMVEH][20];
    XColor clr;
    READER_UNION veh_picture;
    READER_UNION veh_icon;
    int32 i;
    SNSTVE_CLASS terrain_classes[20], line_class, vehicle_class, null_class;
    int32 c=0, hypso, buildings, rails, roads, trees, vehicle;

    init_programmed_inst();

    /* reader */
    reader_init(0);

    /* rdrconst */
    if (rdc_init("../../data", 0))
      printf("Error initializing librdrconst\n"), exit(0);

    /* otmatch */
    if (otm_init("../../data", 0))
      printf("Error initializing libotmatch\n"), exit(0);

    /* Initialize libtime */
    time_init(1000);

    /* Initailize libsched */
    sched_init(2, 67, VEHTICK);

    env_init("../../data", 0);
    
    /* Initialize librandom */
    rnd_srandom(0);
    
    /* parse the X-Display command line options first to prevent future 
     * libcmdline gripes.
     */
    toplevel = XtInitialize(argv[0], "TactMap", NULL, 0, &argc, argv);
#if 0
    toplevel = XtVaAppInitialize(argv[0], "Terrain Reasoning Tests",
			    NULL, 0, &argc, argv, NULL,
                            XmNminWidth,  900,
                            XmNminHeight, 700, NULL);
#endif
    	
    /* Initialize the playbox */
    wld_load_playbox(1, 0, argc, argv, "../../data", NULL, NULL, NULL, NULL);

    XtRealizeWidget(toplevel);
    
    /* Initialize libbgr */
    BgrInit(XtDisplay(toplevel));
    
    tie_fighter =
      XCreatePixmapFromBitmapData(XtDisplay(toplevel), XtWindow(toplevel),
				  tie_fighter_bits,
				  tie_fighter_width, tie_fighter_height,
				  WhitePixelOfScreen(XtScreen(toplevel)),
				  BlackPixelOfScreen(XtScreen(toplevel)),
				  DefaultDepthOfScreen(XtScreen(toplevel)));
    
    for (i=0;i<NUMPICTGCS;i++)
    {
	clr.red = clr.green = clr.blue = 0xFFFF * i / NUMPICTGCS;
	XAllocColor(XtDisplay(toplevel),
		    DefaultColormapOfScreen(XtScreen(toplevel)), &clr);
	gcv.foreground = clr.pixel;
	pictgcs[i] = XCreateGC(XtDisplay(toplevel), XtWindow(toplevel),
			       GCForeground, &gcv);
    }
    bzero(csystems, sizeof(csystems));
    csystems[0].dimensions[X] = 3.65;
    csystems[0].dimensions[Y] = 9.00;
    csystems[1].dimensions[X] = 2.0;
    csystems[1].dimensions[Y] = 2.0;
    csystems[1].origin[X]     = 0.0;
    csystems[1].origin[Y]     = 2.0;
    
    reader_read("test.rdr", ".", &veh_picture, 0);
    reader_read("test2.rdr", ".", &veh_icon, 0);
    
    /* Make the sensitivity GCs */
    gcv.foreground = WhitePixelOfScreen(XtScreen(toplevel));
    gcv.line_width = 1;
    draw_gc = XCreateGC(XtDisplay(toplevel), XtWindow(toplevel),
			GCForeground | GCLineWidth, &gcv);
    erase_gc = XCreateGC(XtDisplay(toplevel), XtWindow(toplevel),
			 GCLineWidth, &gcv);
    /* Make the sensitive window */
    snstve_init();
    sensitive = snstve_create(toplevel, draw_gc, erase_gc);
    callback_register_handler(snstve_miss_callback(sensitive), click, NULL);

    /* Make the tactical map */
    tactmap_init();
    tactmap = tactmap_create(toplevel, sensitive, erase_gc, NULL);
    tactmap_set_scale(tactmap, scale=200000.0);

    /* Make some features */
    bzero(dfn, sizeof(dfn));

    SNSTVE_INIT_CLASS(terrain_classes[c]);
    callback_register_handler(terrain_classes[c].gesture, print_gesture,
			      "water");
    dfn[c].sensitive.class = &terrain_classes[c];
    feature[c] = tactmap_create_object(tactmap, TACTMAP_WATER, dfn+c);
    tactmap_add_object(tactmap, feature[c]); c++;

    roads = c;
    SNSTVE_INIT_CLASS(terrain_classes[c]);
    callback_register_handler(terrain_classes[c].gesture, print_gesture,
			      "road");
    dfn[c].sensitive.class = &terrain_classes[c];
    feature[c] = tactmap_create_object(tactmap, TACTMAP_ROADS, dfn+c);
    tactmap_add_object(tactmap, feature[c]); c++;

    buildings = c;
    SNSTVE_INIT_CLASS(terrain_classes[c]);
    callback_register_handler(terrain_classes[c].gesture, print_gesture,
			      "building");
    dfn[c].sensitive.class = &terrain_classes[c];
    feature[c] = tactmap_create_object(tactmap, TACTMAP_BUILDINGS, dfn+c);
    tactmap_add_object(tactmap, feature[c]); c++;

    SNSTVE_INIT_CLASS(terrain_classes[c]);
    callback_register_handler(terrain_classes[c].gesture, print_gesture,
			      "pipeline");
    dfn[c].sensitive.class = &terrain_classes[c];
    feature[c] = tactmap_create_object(tactmap, TACTMAP_PIPELINES, dfn+c);
    tactmap_add_object(tactmap, feature[c]); c++;

    SNSTVE_INIT_CLASS(terrain_classes[c]);
    callback_register_handler(terrain_classes[c].gesture, print_gesture,
			      "political");
    dfn[c].sensitive.class = &terrain_classes[c];
    feature[c] = tactmap_create_object(tactmap, TACTMAP_POLITICAL, dfn+c);
    tactmap_add_object(tactmap, feature[c]); c++;

    rails = c;
    SNSTVE_INIT_CLASS(terrain_classes[c]);
    callback_register_handler(terrain_classes[c].gesture, print_gesture,
			      "railroad");
    dfn[c].sensitive.class = &terrain_classes[c];
    feature[c] = tactmap_create_object(tactmap, TACTMAP_RAILROADS, dfn+c);
    tactmap_add_object(tactmap, feature[c]); c++;

    SNSTVE_INIT_CLASS(terrain_classes[c]);
    callback_register_handler(terrain_classes[c].gesture, print_gesture,
			      "powerline");
    dfn[c].sensitive.class = &terrain_classes[c];
    feature[c] = tactmap_create_object(tactmap, TACTMAP_POWERLINES, dfn+c);
    tactmap_add_object(tactmap, feature[c]); c++;
    
    SNSTVE_INIT_CLASS(terrain_classes[c]);
    callback_register_handler(terrain_classes[c].gesture, print_gesture,
			      "town");
    dfn[c].sensitive.class = &terrain_classes[c];
    feature[c] = tactmap_create_object(tactmap, TACTMAP_TOWNS, dfn+c);
    tactmap_add_object(tactmap, feature[c]); c++;
    
    trees = c;
    dfn[c].trees.mask = TREE_MASK;
    SNSTVE_INIT_CLASS(terrain_classes[c]);
    callback_register_handler(terrain_classes[c].gesture, print_gesture,
			      "tree");
    dfn[c].sensitive.class = &terrain_classes[c];
    feature[c] = tactmap_create_object(tactmap, TACTMAP_TREES, dfn+c);
    tactmap_add_object(tactmap, feature[c]); c++;
    
#ifdef HYPSO
    hypso = c;
    bzero(dfn+c, sizeof(TACTMAP_OBJECT_DFN));
    dfn[c].hypso.kind = TACTMAP_COLOR_HYPSO;
    feature[c] = tactmap_create_object(tactmap, TACTMAP_HYPSO, dfn+c);
    tactmap_add_object(tactmap, feature[c]); c++;
#endif

#ifdef CONTOUR
    bzero(dfn+c, sizeof(TACTMAP_OBJECT_DFN));
    dfn[c].contours.minor_spacing = 10.0;
    dfn[c].contours.major_spacing = 100.0;
    feature[c] = tactmap_create_object(tactmap, TACTMAP_CONTOURS, dfn+c);
    tactmap_add_object(tactmap, feature[c]); c++;
#endif
#ifdef GRIDS
    /* Register the grids object */
    bzero(dfn+c, sizeof(TACTMAP_OBJECT_DFN));
    dfn[c].grids.interval   = 10000;
    dfn[c].grids.label_mask = (COORD_LABEL_BOTTOM | COORD_LABEL_LEFT);
    dfn[c].grids.kind       = TACTMAP_MILGRID; 
    feature[c] = tactmap_create_object(tactmap, TACTMAP_GRIDS, dfn+c);
    tactmap_add_object(tactmap, feature[c]); c++;
#endif
    /* Register the cell object */
    bzero(dfn+c, sizeof(TACTMAP_OBJECT_DFN));
    dfn[c].grids.interval   = 0;
    dfn[c].grids.label_mask = (COORD_LABEL_TOP | COORD_LABEL_RIGHT);
    dfn[c].grids.kind       = TACTMAP_GCS; 
    feature[c] = tactmap_create_object(tactmap, TACTMAP_CELLS, dfn+c);
    tactmap_add_object(tactmap, feature[c]); c++;
    
#if LINELEN != 0
    linedfn = dfn+c;
    bzero(dfn+c, sizeof(TACTMAP_OBJECT_DFN));
    dfn[c].linear.style = LSplain;
    dfn[c].linear.dashed = 0;
    dfn[c].linear.width = 100;
    gcv.foreground = BlackPixelOfScreen(XtScreen(toplevel));
    dfn[c].linear.gc = XCreateGC(XtDisplay(toplevel), XtWindow(toplevel),
				 GCForeground, &gcv);
    dfn[c].linear.n_vertices = LINELEN;
    
    dfn[c].linear.cell = tactmap->cur->cc;
    
    for (i=0;i<LINELEN;i++)
    {
      coord_convert(COORD_GCS,
		    tactmap->cur->cc,
		    (float64)(RANDOM_X()),
		    (float64)(RANDOM_Y()),
		    tmplf=0,
		    COORD_GCSCS,
		    dfn[c].linear.cell,
		    &vertex_list[2*i],
		    &vertex_list[2*i+1],
		    &tmplf);
  }
    
    dfn[c].linear.vertices = vertex_list;
    SNSTVE_INIT_CLASS(line_class);
    callback_register_handler(line_class.gesture, line_gesture);
    line_class.buttons = (1 << 1) | (1 << 3); /* Button 1 & 3*/
    line_class.sensitive = line_class.hot = 1;
    line_class.dragable = 1;
    line_class.drag_thresh = 10;
    dfn[c].sensitive.class = &line_class;
    feature[c] = tactmap_create_object(tactmap, TACTMAP_LINEAR, dfn+c);
    lineobj = feature[c];
    tactmap_add_object(tactmap, feature[c]); c++;
#endif

    routedfn = dfn+c;
    bzero(dfn+c, sizeof(TACTMAP_OBJECT_DFN));
    dfn[c].linear.style = LSplain;
    dfn[c].linear.dashed = 0;
    dfn[c].linear.width = 100;
    gcv.foreground = WhitePixelOfScreen(XtScreen(toplevel));
    dfn[c].linear.gc = XCreateGC(XtDisplay(toplevel), XtWindow(toplevel),
				 GCForeground, &gcv);
    dfn[c].linear.cell = tactmap->cur->cc;
    dfn[c].linear.n_vertices = 0;
    dfn[c].linear.vertices = route_list;
    SNSTVE_INIT_CLASS(null_class);
    dfn[c].sensitive.class = &null_class;
    feature[c] = tactmap_create_object(tactmap, TACTMAP_LINEAR, dfn+c);
    routeobj = feature[c];
    tactmap_add_object(tactmap, feature[c]); c++;
#ifdef DOING_INTERVIS
    line_intervis_dfn = dfn+c;
    bzero(dfn+c, sizeof(TACTMAP_OBJECT_DFN));

    {
	float64 swcorner[XYZ],necorner[XYZ],cntr[XYC];
	
	wld_get_playbox_center(cntr);
	wld_get_playbox_extent((int32)cntr[CELL2D],swcorner,nwcorner);
	dfn[c].line_intervis.cell      = cntr[CELL2D];
	dfn[c].line_intervis.point1[X] = swcorner[X];  
	dfn[c].line_intervis.point1[Y] = swcorner[Y];  
	dfn[c].line_intervis.point2[X] = necorner[X];  
	dfn[c].line_intervis.point2[Y] = necorner[Y];
    }  

    dfn[c].line_intervis.viewer_agl = 2.5;
    dfn[c].line_intervis.target_agl = 0.0;
    dfn[c].line_intervis.target_width = 5.0;
    dfn[c].line_intervis.target_height = 5.0;
    dfn[c].line_intervis.n_veh = 0;
    dfn[c].line_intervis.grid_interval = 10000;
    dfn[c].line_intervis.show_percentages = 1;
    feature[c] = tactmap_create_object(tactmap, TACTMAP_LINE_INTERVIS, dfn+c);
    line_intervis_obj = feature[c];
    tactmap_add_object(tactmap, feature[c]); c++;

    area_intervis_dfn = dfn+c;
    bzero(dfn+c, sizeof(TACTMAP_OBJECT_DFN));

    wld_get_playbox_center(dfn[c].area_intervis.center_point);

    dfn[c].area_intervis.radius = 1000.0;
    dfn[c].area_intervis.viewer_agl = 2.5;
    dfn[c].area_intervis.target_agl = 0.0;
    dfn[c].area_intervis.target_width = 5.0;
    dfn[c].area_intervis.target_height = 5.0;
    feature[c] = tactmap_create_object(tactmap, TACTMAP_AREA_INTERVIS, dfn+c);
    area_intervis_obj = feature[c];
    tactmap_add_object(tactmap, feature[c]); c++;
#endif
    /* Post the map tick */
    sched_periodic_fncl(tactmap_tick, 1000, 67, 0,
			A_PTR, tactmap,
			A_INT, 67,
			A_END);

    /* Post the X tick */
    sched_periodic_fncl(tick_X, 0, 67, 0,
			A_PTR, XtWidgetToApplicationContext(toplevel),
			A_END);

    /* After 10 seconds, make stuff hot */
    sched_deferred_fncl(set_hot, 10000, 0,
			A_PTR, sensitive,
			A_PTR, feature[buildings],
			A_PTR, dfn+buildings,
			A_INT, 1,
			A_END);

    sched_deferred_fncl(set_hot, 10000, 0,
			A_PTR, sensitive,
			A_PTR, feature[rails],
			A_PTR, dfn+rails,
			A_INT, 1,
			A_END);

    sched_deferred_fncl(set_hot, 10000, 0,
			A_PTR, sensitive,
			A_PTR, feature[roads],
			A_PTR, dfn+roads,
			A_INT, 1,
			A_END);

    sched_deferred_fncl(set_hot, 10000, 0,
			A_PTR, sensitive,
			A_PTR, feature[trees],
			A_PTR, dfn+trees,
			A_INT, 1,
			A_END);

#ifdef SHOW_VEHICLES
    vehicle = c;
    SNSTVE_INIT_CLASS(vehicle_class);
    callback_register_handler(vehicle_class.gesture, print_gesture,
			      "vehicle");
    vehicle_class.buttons = 1 << 1; /* Button 1 */
    vehicle_class.sensitive = vehicle_class.hot = 1;

    for (i=0;i<NUMVEH;i++)
    {
	bzero(dfn+c, sizeof(TACTMAP_OBJECT_DFN));
	dfn[c].sensitive.class = &vehicle_class;
	dfn[c].sensitive.instance = i;
#if VEHSTYLE == 1
	coord_convert(COORD_GCS,tactmap->cur->cc,(float64)RANDOM_X(),
		      (float64)RANDOM_Y(),tmplf=0,
		      COORD_GCS,&dfn[c].pixmap.cell,&dfn[c].pixmap.x,
		      &dfn[c].pixmap.y,&tmplf);
	dfn[c].pixmap.width  = tie_fighter_width;
	dfn[c].pixmap.height = tie_fighter_height;
	dfn[c].pixmap.pixmap = tie_fighter;
	feature[c] = tactmap_create_object(tactmap, TACTMAP_PIXMAP, dfn+c);
#elif (VEHSTYLE == 2) || (VEHSTYLE == 5)
#if VEHSTYLE == 2
	dfn[c].picture.dfn = veh_picture.array;
#else
	dfn[c].picture.dfn = NULL;
	dfn[c].picture.num_instructions = ARRAYLENGTH(programmed_inst);
	dfn[c].picture.instructions = programmed_inst;
#endif
	dfn[c].picture.magnification = 50.0;
	dfn[c].picture.highlight = TRUE;
	sprintf(buf[i], "#%d", i);
	dfn[c].picture.string = buf[i];
	dfn[c].picture.num_gcs = NUMPICTGCS;
	bcopy(pictgcs, dfn[c].picture.gcs, sizeof(pictgcs));
	dfn[c].picture.num_csystems = 2;
	bcopy(csystems, dfn[c].picture.csystems, sizeof(csystems));
	dfn[c].picture.csystems[0].parent_system = 0;
	coord_convert(COORD_GCS,tactmap->cur->cc,(float64)RANDOM_X(),
		      (float64)RANDOM_Y(),tmplf=0,
		      COORD_GCS,&dfn[c].picture.csystems[0].cell,
		      &dfn[c].picture.csystems[0].origin[X],
		      &dfn[c].picture.csystems[0].origin[Y],
		      &tmplf);
	dfn[c].picture.csystems[1].parent_system = 0;
	feature[c] = tactmap_create_object(tactmap, TACTMAP_PICTURE, dfn+c);
#elif VEHSTYLE == 3
	dfn[c].drawn.draw = draw_vehicle;
	dfn[c].drawn.draw_arg = (ADDRESS)i;
	dfn[c].drawn.erase_on_delete_only = FALSE;
	feature[c] = tactmap_create_object(tactmap, TACTMAP_DRAWN, dfn+c);
#elif VEHSTYLE == 4
	{
	    int32 cell;
	    random_pt(&cell,&dfn[c].bgr.x,&dfn[c].bgr.y);
	}
	dfn[c].bgr.cell = cell;    
	dfn[c].bgr.rotation = 0.0;
	dfn[c].bgr.size = 40;
	dfn[c].bgr.line_thickness = 3;
	if (c%5 == 0)
	{
	    dfn[c].bgr.override = TRUE;
	    dfn[c].bgr.dfn = veh_icon.array;
	}
	else
	{
	    dfn[c].bgr.override = FALSE;
	    dfn[c].bgr.dfn = NULL;
	}
	dfn[c].bgr.object_type = ot_array[c%MAX_OT_ARRAY_SIZE];
	dfn[c].bgr.dashed = TRUE;
	if (rnd_boolean())
	  sprintf(dfn[c].bgr.call_sign, "A %d", c);
	else
	  dfn[c].bgr.call_sign[0] = '\0';
	dfn[c].bgr.gc = pictgcs[c % NUMPICTGCS];
	feature[c] = tactmap_create_object(tactmap, TACTMAP_BGR, dfn+c);
#endif
	tactmap_add_transient_object(tactmap, feature[c]);

	sched_periodic_fncl(move_vehicle, 10000, VEHTICK, 0,
			    A_PTR, feature[c],
			    A_PTR, dfn+c,
			    A_INT, i,
			    A_PTR, &feature[c],
			    A_END);
	c++;
    }
#endif
    /* Star the scheduler */
    sched_invoke_functions_until(0xFFFFFFFF);
}
