#ifndef lint
static char rcsid [] = "$RCSfile: tmap_contam.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif
/****************************************************************************
*   File: tmap_contam.c                                                  *
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*       This software was developed by Loral under U. S. Government contracts *
*       and may be reproduced by or for the U. S. Government pursuant to    *
*       the copyright license under the clause at DFARS 252.227-7013        *
*       (OCT 1988).                                                         *
*                                                                           *
*       Contents: Code to draw chemical contaminations                      *
*       Created: Tue Jul 24 1990                                            *
*       Author: jesmith                                                     *
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/

#ifdef USE_X

#include "libtmap_local.h"
#include <stdext.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>

/*ARGSUSED*/
void tactmap_draw_contaminant(tactmap, object, use_erase_gc, bounds, space)
    TACTMAP_PTR           tactmap;
    TACTMAP_OBJECT_PTR    object;
    int32                 use_erase_gc;
    TACTMAP_BOUNDS       *bounds;
    CTDB_SEARCH_SPACE_PTR space;
{
    DECLARE_REGS;
    XPoint              pts[CTDB_VERTICES_MAX+1];
    float32            *verts;
    float32             cverts[2*(CTDB_VERTICES_MAX+1)];
    int32               n_vert;
    int32               j;
    int32               xmin,xmax,ymin,ymax;
    GC                  gc;
    SNSTVE_OBJECT       snsobj;
    CTDB_ABSTRACT_DATA *data;

    if (use_erase_gc)
      gc = tactmap->gc.background;
    else
      gc = tactmap->gc.contaminant;

    bzero((char *)&snsobj, sizeof(snsobj));
    snsobj.sensClass = object->dfn.sensitive.sensClass;
    snsobj.user_data = object->dfn.sensitive.user_data;
    snsobj.kind = SNSTVE_RECTANGLE;

    while (n_vert = ctdb_next_abstract(space, CTDB_ABSTRACT_CONTAMINANT, &verts, &data, NULL))
    {
	if (tactmap_off_screen32(n_vert, verts, bounds))
	  continue;

	/* Bundle up the points */
	xmin=ymin = 0x10000;
	xmax=ymax = 0;
	for (j=0;j<n_vert;j++)
	{
	    pts[j].x = tactmap_FX_pixel_number(verts[2*j],cx,hsw,ppm);
	    pts[j].y = tactmap_FY_pixel_number(verts[2*j+1],cy,hsh,ppm);

	    if (pts[j].x < xmin)
	      xmin = pts[j].x;
	    if (pts[j].y < ymin)
	      ymin = pts[j].y;
	    if (pts[j].x > xmax)
	      xmax = pts[j].x;
	    if (pts[j].y > ymax)
	      ymax = pts[j].y;
	}

	XFillPolygon(XtDisplay(tactmap->widget), tactmap->terrain_pix,
		     gc, pts, j, Nonconvex, CoordModeOrigin);

	snsobj.instance = 0;
	snsobj.attr.rect.x = xmin;
	snsobj.attr.rect.y = ymin;
	snsobj.attr.rect.width = xmax-xmin;
	snsobj.attr.rect.height = ymax-ymin;

	snstve_add_object(tactmap->sensitive, &snsobj);
    }
}

#endif /*USE_X*/
