#ifndef lint
static char rcsid [] = "$RCSfile: tmap_roads.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif
/****************************************************************************
*   File: tmap_roads.c                                                      *
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*       This software was developed by Loral under U. S. Government contracts *
*       and may be reproduced by or for the U. S. Government pursuant to    *
*       the copyright license under the clause at DFARS 252.227-7013        *
*       (OCT 1988).                                                         *
*                                                                           *
*       Contents: Code to draw roads                                        *
*       Created: Tue Jul 24 1990                                            *
*       Author: jesmith                                                     *
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/

#ifdef USE_X

#include <stdext.h>  /*common/include/global*/
#include "libtmap_local.h"
#include <X11/Xlib.h>
#include <X11/Xutil.h>

#ifdef AE_FEATURES
void tactmap_draw_offroads(tactmap, object, use_erase_gc, bounds, space)
    TACTMAP_PTR           tactmap;
    TACTMAP_OBJECT_PTR    object;
    int32                 use_erase_gc;
    TACTMAP_BOUNDS       *bounds;
    CTDB_SEARCH_SPACE_PTR space;
{
    DECLARE_REGS;
    int16 segs[10000];
    QUAD_LIST *cons;
    QUAD_FEATURES *feat;
    int32 *ptr, num;
    QUAD_LINE_SEG *seg;
    int32 i, j, width;
    XGCValues gcv;
    GC gc;
    SNSTVE_OBJECT snsobj;

    if (use_erase_gc)
      gc = tactmap->gc.background;
    else
      gc = tactmap->gc.offroads;

    bzero((char *)&snsobj, sizeof(snsobj));
    snsobj.sensClass = object->dfn.sensitive.sensClass;
    snsobj.user_data = object->dfn.sensitive.user_data;
    snsobj.kind = SNSTVE_LINE;

    gcv.line_width = 0;
    XChangeGC(XtDisplay(tactmap->widget), gc, GCLineWidth, &gcv);

    for (cons = space; cons != QUAD_NULL_PTR; cons = cons->cdr)
    {
	feat = (QUAD_FEATURES *) cons->car;
	ptr = feat->offroad_indecies + 1;
	num = *(feat->offroad_indecies);
	for (i=1; i<= num; i++, ptr++)
	{
	    seg = &(tactmap->quad_datap->offroads.segments[*ptr]);
	    if (OFF_SCREEN(seg))
	      continue;

	    /* How wide is this segment? */
	    width = seg->width * ppm;
	    if (width==1) width = 0;
	    if (gcv.line_width != width)
	    {
		gcv.line_width = width;
		XChangeGC(XtDisplay(tactmap->widget), gc, GCLineWidth, &gcv);
	    }

	    /* Bundle up the points */
	    for (j=0;j<seg->num_pts;j+=2)
	    {
		segs[j] = tactmap_X_pixel_number(seg->points[j],cx,hsw,ppm);
		segs[j+1] = tactmap_Y_pixel_number(seg->points[j+1],cy,hsh,ppm);
	    }

	    XDrawLines(XtDisplay(tactmap->widget), tactmap->terrain_pix,
		       gc, (XPoint *)segs, j/2, CoordModeOrigin);

	    for (j=0;j<seg->num_pts-2;j+=2)
	    {
		snsobj.instance = ((*ptr) << 8) + (j>>1);
		snsobj.attr.line.x0 = segs[j];
		snsobj.attr.line.y0 = segs[j+1];
		snsobj.attr.line.x1 = segs[j+2];
		snsobj.attr.line.y1 = segs[j+3];
		snsobj.attr.line.width = width + 10;

		snstve_add_object(tactmap->sensitive, &snsobj);
	    }
	}
    }
}
#endif

#endif /*USE_X*/
