#ifndef lint
static char rcsid [] = "$RCSfile: tmap_towns.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif
/****************************************************************************
*   File: tmap_towns.c                                                      *
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*       This software was developed by Loral under U. S. Government contracts *
*       and may be reproduced by or for the U. S. Government pursuant to    *
*       the copyright license under the clause at DFARS 252.227-7013        *
*       (OCT 1988).                                                         *
*                                                                           *
*       Contents: Code to draw towns                                        *
*       Created: Thu Sep 17 1992                                            *
*       Author: jesmith                                                     *
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/

#ifdef USE_X

#include "libtmap_local.h"
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdstring.h> /*common/include/global*/

/*ARGSUSED*/
void 
tactmap_draw_towns(TACTMAP_PTR tactmap, TACTMAP_OBJECT_PTR object, 
		   int32 use_erase_gc, TACTMAP_BOUNDS *bounds, 
		   CTDB_SEARCH_SPACE_PTR space)
{
    DECLARE_REGS;
    CTDB_ABSTRACT_DATA *data;
    float32 *verts;
    int32 x, y;
    GC gc;

    if (use_erase_gc)
      gc = tactmap->gc.background;
    else
      gc = tactmap->gc.towns;

    while ( ctdb_next_abstract(space, CTDB_ABSTRACT_LABEL,
			      &verts, &data, NULL) )
    {
	if ((verts[X] < bounds->min_x) ||
	    (verts[Y] < bounds->min_y) ||
	    (verts[X] > bounds->max_x) ||
	    (verts[Y] > bounds->max_y))
	  continue;

	x = tactmap_FX_pixel_number(verts[X],cx,hsw,ppm);
	y = tactmap_FY_pixel_number(verts[Y],cy,hsh,ppm);

	XDrawString(XtDisplay(tactmap->widget), tactmap->terrain_pix,
		    gc, x, y, data->label.text, strlen(data->label.text));
    }
}

#endif
