#ifndef lint
static char rcsid [] = "$RCSfile: tmap_viewport.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif
/****************************************************************************
*   File: tmap_viewport.c                                                   *
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*       This software was developed by Loral under U. S. Government contracts *
*       and may be reproduced by or for the U. S. Government pursuant to    *
*       the copyright license under the clause at DFARS 252.227-7013        *
*       (OCT 1988).                                                         *
*                                                                           *
*       Contents: Code to show viewport relative to the world               *
*       Created: Thu Sep 17 1992                                            *
*       Author: jesmith                                                     *
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/

#ifdef USE_X

#include "libtmap_local.h"
#include <libgcs.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>

void 
tactmap_show_viewport(TACTMAP_PTR tactmap, Drawable drawable)
{
    float64 cx,cy;
    
    tactmap->last_viewport.width =
      PIXELS(2 * tactmap->vp.hsw, tactmap->wv.ppm);
    tactmap->last_viewport.height =
      PIXELS(2 * tactmap->vp.hsh, tactmap->wv.ppm);

    if (tactmap->last_viewport.width < 4) 
      tactmap->last_viewport.width = 4;

    if (tactmap->last_viewport.height < 4) 
      tactmap->last_viewport.height = 4;

    gcs_gcs2e_to_gcscs(tactmap->wv.cc,(float64)tactmap->wv.cx,
			 (float64)tactmap->wv.cy,tactmap->vp.cc,
			 &cx,&cy);
    
    tactmap->last_viewport.x = 
      tactmap_X_pixel_number((int32)(tactmap->vp.cx - tactmap->vp.hsw),
			     (int32)cx,
			     (int32)tactmap->wv.hsw, tactmap->wv.ppm);

    tactmap->last_viewport.y = 
      tactmap_Y_pixel_number((int32)(tactmap->vp.cy + tactmap->vp.hsh), 
			     (int32)cy,
			     (int32)tactmap->wv.hsh, tactmap->wv.ppm);

    XDrawRectangles(XtDisplay(tactmap->widget), drawable,
		    tactmap->gc.grids, &tactmap->last_viewport, 1);
}

void tactmap_erase_viewport(TACTMAP_PTR tactmap)
{
    XDrawRectangles(DPYWIN, tactmap->background_gc,
		    &tactmap->last_viewport, 1);
}

#endif /*USE_X*/
