#ifndef lint
static char rcsid [] = "$RCSfile: test.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif
/****************************************************************************
*   File: test.c                                                            *
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*       This software was developed by Loral under U. S. Government contracts*
*       and may be reproduced by or for the U. S. Government pursuant to    *
*       the copyright license under the clause at DFARS 252.227-7013        *
*       (OCT 1988).                                                         *
*                                                                           *
*       Contents: LibTime test program                                      *
*       Created: Tue Aug 30 1994                                            *
*       Author: jesmith                                                     *
*       Remarks: Compare real-time clock results to unix time() command     *
*                                                                           *
****************************************************************************/

#include "libtime.h"

#include <time.h>
extern time_t time();

static void dummy() { ; }

main()
{
    int32 i, j;
    int32 res;
    int32 last;
    int32 hiccup;
    uint32 rt0, ut0, rt1, ut1;

    time_init(0);

    printf("Comparing clocks...\n");

    /* Try reading the clock at a high rate */
    res = 0;
    ut0 = time(0);
    rt0 = time_realtime_clock();
    last = hiccup = 0;
    for (i=0;i<10000000;i++)
    {
	res += time_realtime_clock();

	if (time_last_realtime_clock != last)
	{
	    if (time_last_realtime_clock - last > 1)
	      hiccup++;
	    last = time_last_realtime_clock;
	}	
    }
    ut1 = time(0);
    rt1 = time_realtime_clock();
    printf("Realtime: %d ms\t\tUnix: %d sec\t\t%d >1ms hiccups\n",
	   rt1-rt0, ut1-ut0, hiccup);

    /* Try reading the clock at a low rate */
    res = 0;
    ut0 = time(0);
    rt0 = time_realtime_clock();
    for (i=0;i<100;i++)
    {
	res += time_realtime_clock();
	for (j=0;j<1000000;j++)
	  dummy();
    }
    ut1 = time(0);
    rt1 = time_realtime_clock();
    printf("Realtime: %d ms\t\tUnix: %d sec\n",
	   rt1-rt0, ut1-ut0);
    
}
