/****************************************************************************
*   File: vmat_cross.c                                                        *
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*       This software was developed by Loral under U. S. Government contracts *
*       and may be reproduced by or for the U. S. Government pursuant to    *
*       the copyright license under the clause at DFARS 252.227-7013        *
*       (OCT 1988).                                                         *
*                                                                           *
*       Contents: Code to compute cross products                            *
*       Created: Wed Jul 15 1992                                            *
*       Author: jesmith                                                     *
*      $Revision: 1.1.1.1 $                                                     *
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/

#include "libvecmat.h"
#include <stdext.h> /*common/include/global*/
#include <math.h>

float32 vmat2_cross_prod32(
    float32 w[2],
    float32 v[2])
{   return VMAT2_CROSS_PROD(w, v);  }

void vmat3_cross_prod32(
    float32 w[3],
    float32 v[3],
    float32 r[3])
{   VMAT3_CROSS_PROD(w, v, r);  }

float64 vmat2_cross_prod64(
    float64 w[2],
    float64 v[2])
{   return VMAT2_CROSS_PROD(w, v);  }

void vmat3_cross_prod64(
    float64 w[3],
    float64 v[3],
    float64 r[3])
{   VMAT3_CROSS_PROD(w, v, r);  }

float32 vmat2e_cross_prod32(
    float32 wx,
    float32 wy,
    float32 vx,
    float32 vy)
{   return VMAT2E_CROSS_PROD(wx, wy, vx, vy);  }

void vmat3e_cross_prod32(
    float32 wx,
    float32 wy,
    float32 wz,
    float32 vx,
    float32 vy,
    float32 vz,
    float32 r[3])
{   VMAT3E_CROSS_PROD(wx, wy, wz, vx, vy, vz, r);  }

float64 vmat2e_cross_prod64(
    float64 wx,
    float64 wy,
    float64 vx,
    float64 vy)
{   return VMAT2E_CROSS_PROD(wx, wy, vx, vy);  }

void vmat3e_cross_prod64(
    float64 wx,
    float64 wy,
    float64 wz,
    float64 vx,
    float64 vy,
    float64 vz,
    float64 r[3])
{   VMAT3E_CROSS_PROD(wx, wy, wz, vx, vy, vz, r);  }
