/****************************************************************************
*   File: vmat_matmat.c                                                       *
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*       This software was developed by Loral under U. S. Government contracts *
*       and may be reproduced by or for the U. S. Government pursuant to    *
*       the copyright license under the clause at DFARS 252.227-7013        *
*       (OCT 1988).                                                         *
*                                                                           *
*       Contents: Matrix/Matrix operations                                  *
*       Created: Wed Jul 15 1992                                            *
*       Author: jesmith                                                     *
*      $Revision: 1.1.1.1 $                                                     *
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/

#include "libvecmat.h"
#include "vmat_matmat.h"
#include <stdext.h> /*common/include/global*/

void vmat2_mat_mat_mul32(
    float32 m[2][2],
    float32 n[2][2],
    float32 r[2][2])
VMAT2_MULT(float32, m, n, r)

void vmat3_mat_mat_mul32(
    float32 m[3][3],
    float32 n[3][3],
    float32 r[3][3])
VMAT3_MULT(float32, m, n, r)

void vmat4_mat_mat_mul32(
    float32 m[4][4],
    float32 n[4][4],
    float32 r[4][4])
VMAT4_MULT(float32, m, n, r)

void vmat2_mat_mat_mul64(
    float64 m[2][2],
    float64 n[2][2],
    float64 r[2][2])
VMAT2_MULT(float64, m, n, r)

void vmat3_mat_mat_mul64(
    float64 m[3][3],
    float64 n[3][3],
    float64 r[3][3])
VMAT3_MULT(float64, m, n, r)

void vmat4_mat_mat_mul64(
    float64 m[4][4],
    float64 n[4][4],
    float64 r[4][4])
VMAT4_MULT(float64, m, n, r)

void vmat2_mat_mat_add32(
    float32 m[2][2],
    float32 n[2][2],
    float32 r[2][2])
OP_BY_SIZE(float32, 4, +, m, n, r)

void vmat3_mat_mat_add32(
    float32 m[3][3],
    float32 n[3][3],
    float32 r[3][3])
OP_BY_SIZE(float32, 9, +, m, n, r)

void vmat2_mat_mat_add64(
    float64 m[2][2],
    float64 n[2][2],
    float64 r[2][2])
OP_BY_SIZE(float64, 4, +, m, n, r)

void vmat3_mat_mat_add64(
    float64 m[3][3],
    float64 n[3][3],
    float64 r[3][3])
OP_BY_SIZE(float64, 9, +, m, n, r)

void vmat2_mat_mat_sub32(
    float32 m[2][2],
    float32 n[2][2],
    float32 r[2][2])
OP_BY_SIZE(float32, 4, -, m, n, r)

void vmat3_mat_mat_sub32(
    float32 m[3][3],
    float32 n[3][3],
    float32 r[3][3])
OP_BY_SIZE(float32, 9, -, m, n, r)

void vmat2_mat_mat_sub64(
    float64 m[2][2],
    float64 n[2][2],
    float64 r[2][2])
OP_BY_SIZE(float64, 4, -, m, n, r)

void vmat3_mat_mat_sub64(
    float64 m[3][3],
    float64 n[3][3],
    float64 r[3][3])
OP_BY_SIZE(float64, 9, -, m, n, r)









