/*
 * $RCSfile: vmat_matmat.h,v $ $Revision: 1.1.1.1 $ $State: Exp $
 */
/****************************************************************************
*   File: vmat_matmat.h                                                     *
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*       This software was developed by Loral under U. S. Government contracts *
*       and may be reproduced by or for the U. S. Government pursuant to    *
*       the copyright license under the clause at DFARS 252.227-7013        *
*       (OCT 1988).                                                         *
*                                                                           *
*       Contents: Private header file for vmat_matmat.c                     *
*       Created: Wed May 10 1995                                            *
*       Author:  bkenney                                                    *
*       Remarks:  These macros were lifted from vmat_matmat.c so that       *
*                 other vmat files could easily reference them.             *
*                                                                           *
****************************************************************************/

#include <stdext.h> /*common/include/global*/
#include <math.h>

#define VMAT2_MULT(type, m, n, r)		         	       	     \
{									     \
    type rxx, rxy, ryx, ryy;						     \
									     \
    rxx = m[X][X] * n[X][X] + m[X][Y] * n[Y][X];			     \
    rxy = m[X][X] * n[X][Y] + m[X][Y] * n[Y][Y];			     \
    ryx = m[Y][X] * n[X][X] + m[Y][Y] * n[Y][X];			     \
    ryy = m[Y][X] * n[X][Y] + m[Y][Y] * n[Y][Y];			     \
    r[X][X] = rxx;							     \
    r[X][Y] = rxy;							     \
    r[Y][X] = ryx;							     \
    r[Y][Y] = ryy;						 	     \
}

#define VMAT3_MULT(type, m, n, r)   		         		     \
{									     \
    type s[3][3];							     \
    int32 i,j;								     \
									     \
    if ((m == r) || (n == r))						     \
    {									     \
	for(i=0;i<3;i++)						     \
	  for(j=0;j<3;j++)						     \
	    s[i][j]=(m[i][X]*n[X][j]+m[i][Y]*n[Y][j]+m[i][Z]*n[Z][j]);	     \
	bcopy((char *)s, (char *)r, sizeof(s));				     \
    }									     \
    else								     \
    {									     \
	for(i=0;i<3;i++)						     \
	  for(j=0;j<3;j++)						     \
	    r[i][j]=(m[i][X]*n[X][j]+m[i][Y]*n[Y][j]+m[i][Z]*n[Z][j]);	     \
    }									     \
}

#define VMAT4_MULT(type, m, n, r)					     \
{									     \
    type s[4][4];							     \
    int32 i,j;								     \
									     \
    if ((m == r) || (n == r))						     \
    {									     \
	for(i=0;i<4;i++)						     \
	  for(j=0;j<4;j++)						     \
	    s[i][j]=(m[i][X]*n[X][j]+m[i][Y]*n[Y][j]+			     \
		     m[i][Z]*n[Z][j]+m[i][3]*n[3][j]);	    		     \
	bcopy((char *)s, (char *)r, sizeof(s));				     \
    }									     \
    else								     \
    {									     \
	for(i=0;i<4;i++)						     \
	  for(j=0;j<4;j++)						     \
	    r[i][j]=(m[i][X]*n[X][j]+m[i][Y]*n[Y][j]+			     \
		     m[i][Z]*n[Z][j]+m[i][3]*n[3][j]);			     \
    }									     \
}

#define OP_BY_SIZE(type, count, op, m, n, r)				     \
{									     \
    uint32 i;							     	     \
									     \
    for(i=0;i<count;i++)						     \
      ((type *)r)[i] = ((type *)m)[i] op ((type *)n)[i];		     \
}










