/****************************************************************************
*   File: vmat_negate.c                                                       *
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*       This software was developed by Loral under U. S. Government contracts *
*       and may be reproduced by or for the U. S. Government pursuant to    *
*       the copyright license under the clause at DFARS 252.227-7013        *
*       (OCT 1988).                                                         *
*                                                                           *
*       Contents: Code to negate a vector                                   *
*       Created: Wed Jul 15 1992                                            *
*       Author: jesmith                                                     *
*      $Revision: 1.1.1.1 $                                                     *
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/

#include "libvecmat.h"
#include <stdext.h> /*common/include/global*/
#include <math.h>

void vmat2_negate32(
    float32 v[2],
    float32 r[2])
{   VMAT2_NEGATE(v, r);  }

void vmat3_negate32(
    float32 v[3],
    float32 r[3])
{   VMAT3_NEGATE(v, r);  }

void vmat2_negate64(
    float64 v[2],
    float64 r[2])
{   VMAT2_NEGATE(v, r);  }

void vmat3_negate64(
    float64 v[3],
    float64 r[3])
{   VMAT3_NEGATE(v, r);  }

void vmat2e_negate32(
    float32 vx,
    float32 vy,
    float32 r[2])
{   VMAT2E_NEGATE(vx, vy, r);  }

void vmat3e_negate32(
    float32 vx,
    float32 vy,
    float32 vz,
    float32 r[3])
{   VMAT3E_NEGATE(vx, vy, vz, r);  }

void vmat2e_negate64(
    float64 vx,
    float64 vy,
    float64 r[2])
{   VMAT2E_NEGATE(vx, vy, r);  }

void vmat3e_negate64(
    float64 vx,
    float64 vy,
    float64 vz,
    float64 r[3])
{   VMAT3E_NEGATE(vx, vy, vz, r);  }

