#ifndef lint
static char rcsid [] = "$RCSfile: vt_set.c,v $ $Revision: 1.1.1.1 $ $State: Exp $";
#endif
/****************************************************************************
*   File: vt_set.c                                                          *
*                                                                           *
*       Copyright 1995 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*       This software was developed by Loral under U. S. Government contracts *
*       and may be reproduced by or for the U. S. Government pursuant to    *
*       the copyright license under the clause at DFARS 252.227-7013        *
*       (OCT 1988).                                                         *
*                                                                           *
*       Contents: Set operators for vehicle lists                           *
*       Created: Fri Apr 10 1992                                            *
*       Author: jesmith                                                     *
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/

#include "libvtab_local.h"

void vtab_list_union(
    VTAB_LIST a,
    VTAB_LIST b)
{
    VTAB_USER_DATA_TYPE user_data;
    int32 id;

    for (id=vtab_get_first(b, VTAB_ALL, &user_data); id;
	 id=vtab_get_next(b, VTAB_ALL, &user_data))
      vtab_add_to_list(a, id, user_data);
}

void vtab_list_intersect(
    VTAB_LIST a,
    VTAB_LIST b)
{
    VTAB_USER_DATA_TYPE user_data;
    int32 id;

    for (id=vtab_get_first(a, VTAB_ALL, &user_data); id;
	 id=vtab_get_next(a, VTAB_ALL, &user_data))
    {
	if (!vtab_in_list(b, id))
	  vtab_remove_from_list(a, id);
    }
}

void vtab_list_intersect_not(
    VTAB_LIST a,
    VTAB_LIST b)
{
    VTAB_USER_DATA_TYPE user_data;
    int32 id;

    for (id=vtab_get_first(a, VTAB_ALL, &user_data); id;
	 id=vtab_get_next(a, VTAB_ALL, &user_data))
    {
	if (vtab_in_list(b, id))
	  vtab_remove_from_list(a, id);
    }
}

int32 vtab_lists_equal(
    VTAB_LIST a,
    VTAB_LIST b,
    int32 check_user_data)
{
    int32 ida, idb;
    VTAB_USER_DATA_TYPE uda, udb;

    ida=vtab_get_first(a, VTAB_ALL, &uda);
    idb=vtab_get_first(b, VTAB_ALL, &udb);

    while (ida || idb)
    {
	if (ida != idb)
	  return 0;

	if (check_user_data && (uda != udb))
	  return 0;

	ida=vtab_get_next(a, VTAB_ALL, &uda);
	idb=vtab_get_next(b, VTAB_ALL, &udb);
    }
    return 1;
}
