
#include "CmsControl.h"
#include "NetMgr.h"

unsigned short  cCmsMgr::fsSite = 16;
unsigned short  cCmsMgr::fsApplication = 232;

TStartupParam::TStartupParam()
{
   fExerciseName     = NULL;
   fDisPort          = 3000;
   fMulticastAddr    = NULL;
   fTtl              = 32;
   fSite             = 1;      // set later
   fApplication      = 1;      // set later
   fExerciseId       = 1;
   fbHost            = true;
}

void    cCmsMgr::SetStartupParams( int* pArgc, char* argv[] )
{

   int arg = 1, i, val;
 

   int count = 0;   //this usage is commented out further down
  
      fStartupParam.fExerciseName = NULL;
      fStartupParam.fDisPort          = 3000;
      fStartupParam.fSite             = 1;            
      fStartupParam.fApplication      = 1;      
      fStartupParam.fExerciseId       = 1;
      fStartupParam.fbHost            = true;
   
      while ( arg < *pArgc ){
	 if ( strcmp ( argv[arg], "-help" ) == 0 ) {
	    system ("../../data/CLoptions");                    //print command line options and exit.
	    Shutdown();
	    exit(0);
	 }

         else if ( strcmp ( argv[arg], "-exercise" ) == 0) {
                                                           // exercise id
	    if ( ( ( arg + 1 ) < *pArgc ) && ( argv[arg+1][0] != '-' ) ){
               fStartupParam.fExerciseId = atoi ( argv[arg+1] );  
	       arg++;
	    
	    }

	    else                                           // default id
	       fStartupParam.fExerciseId = 1;

         }  // end else exercise

         else if ( strcmp ( argv[arg], "-disport" ) == 0) {
                                                           // disport
	    if ( ( ( arg + 1 ) < *pArgc ) && ( argv[arg+1][0] != '-' ) ){
               fStartupParam.fDisPort = atoi ( argv[arg+1] );     
	       arg++;
	    }

	    else                                           // default port
	       fStartupParam.fDisPort = 3000;

         }  // end else disport

         else if ( strcmp ( argv[arg], "-ttl" ) == 0) {
                                                           // disport
	    if ( ( ( arg + 1 ) < *pArgc ) && ( argv[arg+1][0] != '-' ) ){
               fStartupParam.fTtl = atoi ( argv[arg+1] );     
	       arg++;
	    }

	    else                                           // default TTL
	       fStartupParam.fTtl = 32;

         }  // end else ttl

         else if ( strcmp ( argv[arg], "-unicast" ) == 0) {
                                                           // unicast address
      	    if  ( ( ( arg + 1 ) < *pArgc ) && ( argv[arg+1][0] != '-' ) ){                 
	       fStartupParam.fMulticastAddr = cppstrdup ( argv [ arg + 1 ] );	 
	       arg++;
	    
	    } 
	    
	    else                                           // default to no multicasting
	       fStartupParam.fMulticastAddr = NULL;
	    
         }  // end else unicast 

         arg++;
   
      } // end while parsing

   fStartupParam.fSite = fsSite;
   fStartupParam.fApplication = fsApplication;

} // end SetStartupParams

void        cCmsMgr::StartSimulation()
{
      //** should we check for acceptable startup values?

   SetSimStartTime();

   gbHost = fStartupParam.fbHost;
      
   gpNetMgr = new cNetMgr(fStartupParam);

   fState = estRun;
}

void        cCmsMgr::Shutdown()
{
   if ( gpNetMgr )
   {
      gpNetMgr->NetShutdown();
      delete gpNetMgr;
   }
}

EBoolean     cCmsMgr::RunSim()
{
      // incoming PDUs
   gpNetMgr->RecvPdu();      // loops internally until all PDUs received
   return true;
}

void        cCmsMgr::Run()
   // the main loop for running the CMS.  Called from main, after initialization
   //  the state gets set in startup, could conceivably be shutdown
{
   TTimeSim   xStart, appStart, dispStart, xEnd;
   
   while (true) {
   //while (fState == estRun) {
      RunSim(); 
   }
}

void        cCmsMgr::Initialize( int* pArgc, char* argv[] )
{   
   fState = estInitialize;
   
   SetStartupParams (pArgc, argv);
      StartSimulation();
}

cCmsMgr::cCmsMgr()
{
   fState = estNull;
}

cCmsMgr::~cCmsMgr()
{
}

