#ifndef _GlobalTypes_
#define _GlobalTypes_

#ifndef NULL
#define NULL 0
#endif

/*#if defined(_WIN32) || defined(_SGI_65)
typedef bool EBoolean;
#else
*/
enum EBoolean {
   false, true
};

//#endif

typedef   unsigned long   TTimeMs;    // SIMNET protocols need milliseconds
typedef   float           TTimeSec;
typedef   unsigned long   TTimeDis;   // second lsb = 1.676.. microseconds
typedef   unsigned long   TTimeSim;   // internal simulator time, ms for now

enum EState          { estNull, estInitialize, estStartup, estRun, estQuit };
enum EProtocol       { eDis203, eDis204, eNonet, eDis213, eDisPP, eHLA };
enum ECpProtocol     { eCpNo, eCp1HeartBeat, eCp1, eCp1Mcast, eCp2HeartBeat, eCp2, eCp2Mcast };

struct TStartupParam {
   EState     fStartResult;
   char*      fSetupFileName;
   char*      fDirStats;
   char*      fExerciseName;
   int        fDisPort;         // DIS protocol, including M/CM
   char*      fMulticastAddr;    //Multicast address
   int        fTtl;             //Multicast time-to-live (must also specify fMulticastAddr)
   int        fSite;
   int        fApplication;
   int        fExerciseId;
   EBoolean   fbHost;
   
   TStartupParam();      // provides defaults
};

struct TKeywordEntry;

class cDisPduType {
public:
   unsigned char pdu[256];

private:

enum { epdukwNone, epdukwEntityState, epdukwFire, epdukwDetonation, epdukwCollision, 
       epdukwServiceRequest, epdukwResupplyOffer, epdukwResupplyReceived, epdukwResupplyCancel,
       epdukwRepairComplete, epdukwRepairResponse, epdukwCreateEntity, epdukwRemoveEntity,
       epdukwStartResume, epdukwStopFreeze, epdukwAcknowledge, epdukwActionRequest, 
       epdukwActionResponse, epdukwDataQuery, epdukwSetData, epdukwData, epdukwEventReport, 
       epdukwMessage, epdukwEmission, epdukwLaser, epdukwTransmitter, epdukwSignal, epdukwReceiver, 
       epdukwCpSequencer, epdukwCpNACK, epdukwExpEnvironment, epdukwCpMinefield, epdukwCpMines, 
       epdukwMinefieldRequest, epdukwMinefieldResponse, epdukwMinefieldState, epdukwMinefieldNACK,
       epdukwViewControl, epdukwSizeTable };

static const TKeywordEntry fKeyPduType[epdukwSizeTable];

public:
   cDisPduType ();

};


#endif
