#ifndef _UGlobals_
#define _UGlobals_


#include <limits.h>
#include "GlobalTypes.h"

#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>

// global constants
extern char Datapath[256]; 
extern char DatapathConst[256];
extern char Const[256];
extern char Setupdir[256];

      //+++++++++error numbers
enum EerrorNumber   {
   kerrNone = 0,
   kerrDebug,
   kerrNoBuff,
   kerrNoPduSend,
   kerrRecvError,
   kerrReadTerrain,
   kerrReadMinefield,
	kerrReadParamfile,
   
         //errors after this lead to shutdown
   kerrLowestFatal = 500,
   kerrMemory = kerrLowestFatal,
   kerrValidityCheck,
   kerrNoRecvBcast,
   kerrBindSocket,
   kerrNoBlock,
   kerrCreateSendSocket,
   kerrNoSendBcast,
   kerrInvalidMcast,
   kerrNoSubscribeMcast,
   kerrNoTtlMcast,
   kerrNoDisableLoop,
   kerrCoordRead,
   kerrProtocolFamily,
   kerrList,
   kerrTypeMatch
   
};

//   Global constants, declared extern here.  Most defined in main.cc

extern   const char*  kpCmsVersion;
extern   const double kSimTimeToSec;
extern   const double kSecToSimTime;
extern   const double kSimTimeToDis;
extern   const double kDisToSimTime;
extern   const double kSimTimeToUsec;
extern   const double kUsecToSimTime;

extern   EBoolean         gbHost;
extern   long             gSimStartTime;      // in seconds, not TTimeSim

#ifdef sgi
typedef  unsigned int     iotimer_t;
extern   unsigned int     gSimStartCycle;        // in cycles
extern   long             gStartTimeMilli;
extern volatile iotimer_t       *gpTimerAddr;
extern   double           gCycleVal;
extern   unsigned int     max_diff;
#define  MAXNUMCYCLES     4294967295.0           // 2^32 - 1
#endif

class   cNetMgr;
class   cCmsMgr;
extern   cNetMgr*         gpNetMgr;
extern   cCmsMgr          gCmsMgr;

extern int         gfPduData;

extern char*    gpRunName;

//   Global functions.  Most defined in main.cc
extern   TTimeSim         GetCurSimTime();
extern   void             SetSimStartTime();
extern   char*            cppstrdup( const char* pStr);

extern   void   NewFailureHandler();         //called if new cannot get memory it needs
extern   void   Assert(int, EerrorNumber, char* fnName = 0, int sysErr = 0);    //condition to test, err num on failure
extern   void   Shutdown(EerrorNumber);       // global, can be called regardless of CMS state

extern "C" int yywrap();

#endif
