/**********************************************************************
 * File: ApNonLethal.h
 *
 * Types defined: 
 *
 * Functions defined: 
 *
 * Description:
 *
 * Author: Keith Snively
 *
 * Company: E-OIR Measurements, Inc.
 *          9241 Courthouse Road
 *          P.O. Box 1240
 *          Spotsylvania, VA 22553
 *
 * Email: ksnively@eoir.com
 *
 * Copyright:
 *   + This software is Copyright (C) E-OIR Measurements, Inc., 1998
 *   + E-OIR Measurements, Inc. has all commercial interest and rights.
 *   + E-OIR Measurements, Inc. grants a royalty-free license and
 *     right to use, free of charge, with the following terms and
 *     conditions:
 *
 *       (1) You can redistribute this software in source form.  If you
 *           redistribute this software in compiled form you will
 *           include the source code.
 *       (2) You own full rights to any output files you generate with
 *           this software.
 *       (3) You can make modifications to this software and use it for
 *           in-house use only.  Under no circumstances can modified
 *           software be redistributed.
 *       (4) E-OIR Measurements, Inc. shall be credited should this
 *           software be used in a product or written about in any
 *           publication.
 *       (5) This software is provided "as is", without warranty by
 *           E-OIR Measurements, Inc. In no event shall E-OIR
 *           Measurements, Inc. be liable for any loss or for any
 *           indirect, special, punitive, exemplary, incidental, or
 *           consequential damages arising from the use, possession or
 *           performance of this software.
 *
 ***********************************************************************
 */

#ifndef _UApNonLethal_
#define _UApNonLethal_

class cDbMine_cApNonLethal : public cDbMine
{

 public:
   
   virtual   cDbMine*     CreateDbMine(EBoolean bWithParams);  // blank copy, doesnot fill fields
   virtual cSimMine*     CreateMine(cPlanMine* pPlan);       // bare mine, of appropriate type

             cDbMine_cApNonLethal();
             cDbMine_cApNonLethal(int fuzeType);
             cDbMine_cApNonLethal(int fuzeType, TEntityType& type, 
         int level, char* pName = NULL, char* altname = NULL);
   virtual  ~cDbMine_cApNonLethal();
};

class cApNonLethal : public cApMine {
private:
   static  TEntityType   fsApNonLethalMineEntityType;
   static  char*         fsApNonLethalMineName;
   static  char*         fsApNonLethalMineAltName;
   static  int           fsApNonLethalDefaultFuzeType;   // for initializing database

   static   cDbMine_cApNonLethal     fsDbApNonLethal;      // the instantiation in mine database
   
public:
   

};

#endif  //ifndef _UNonLethal_
