/*
$RCSfile: CompEditor.cc,v $
$Revision: 1.1.1.1 $
$Author: jchappel $
$Date: 1999/02/16 14:54:29 $
$Log: CompEditor.cc,v $
Revision 1.1.1.1  1999/02/16 14:54:29  jchappel
Comprehensive Mine Simulator

// Revision 2.0  1998/01/26  21:01:35  ksnively
// Baseline CMS before additions for AP mine replacements.
//
// Revision 2.0  1998/01/26  21:01:35  ksnively
// Baseline CMS before additions for AP mine replacements.
//
// Revision 1.1  1997/12/16  13:59:57  ksnively
// Initial revision
//
// Revision 1.3  1997/10/02  17:53:37  austin
// first working port to modsaf3.0
//
// Revision 1.2  1997/10/02  17:50:22  austin
// first working port to modsaf3.0
//
// Revision 1.2  1997/10/02  17:50:22  austin
// first working port to modsaf3.0
//
// Revision 1.1  1996/10/23  13:54:40  nsipes
// Initial revision
//
// Revision 1.1  1996/10/23  13:54:40  nsipes
// Initial revision
//
// Revision 1.2  1996/05/11  21:35:41  mkappel
// Add mine age.
//
// Revision 1.2  1996/05/11  21:35:41  mkappel
// Add mine age.
//
// Revision 1.1  1996/01/23  16:52:30  rcarp
// Initial revision
//
$State: Exp $
*/
 
/*******************************************

   file: CompEditor.cc
   
      Copyright 1995 by the Institute for Defense Analyses
      
         Institute for Defense Analyses
         1801 N. Beauregard Street
         Alexandria, Virginia 22311-1772
         703-845-2000
         
      This software was developed by IDA under U. S. Government
      contract.  For distribution information contact:
      
         U. S. Army Night Vision Directorate
         AMSEL RD NV OD CD
         10221 Burbeck Road, suite 430
         Ft. Belvoir VA 22060-5806
      
*********************************************/

/*******************************************

   CompEditor.cc
   
      The display interface implementation.
      
      
   
   Created by Michael Kappel
   Modification history:
      created   
      
*********************************************/

#include "Display.h"
#include "Minefield.h"

#include <Xm/Form.h>
#include <Xm/LabelG.h>
#include <Xm/List.h>
#include <Xm/PushB.h>
#include <Xm/ScrolledW.h>
#include <Xm/TextF.h>


Widget cCompEditorWindow::CreateActionArea (Widget wParent)
{
   Widget     wActionArea;

   wActionArea = 
     XtVaCreateWidget ("action_area", 
		       xmFormWidgetClass, wParent,
		       XmNfractionBase, 100,
		       XmNbottomAttachment, XmATTACH_FORM,
		       XmNleftAttachment, XmATTACH_FORM,
		       XmNrightAttachment, XmATTACH_FORM,
		       NULL);
   fwDoneButton = 
     XtVaCreateManagedWidget ("Done", 
			      xmPushButtonWidgetClass, wActionArea,
			      XmNtopAttachment, XmATTACH_FORM,
			      XmNbottomAttachment, XmATTACH_FORM,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 25,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 40,
			      NULL);
   fwCancelButton = 
     XtVaCreateManagedWidget ("Cancel", 
			      xmPushButtonWidgetClass, wActionArea,
			      XmNtopAttachment, XmATTACH_FORM,
			      XmNbottomAttachment, XmATTACH_FORM,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 60,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 75,
			      NULL);

   XtManageChild( wActionArea );
   return wActionArea;
}

cCompEditorWindow::cCompEditorWindow (Widget wParent)
{
   Widget     wLabel;


   fwMainWin = 
     XtVaCreateWidget ("comp_form", 
		       xmFormWidgetClass, wParent, 
		       XmNfractionBase, 100,
		       NULL);

   wLabel = 
     XtVaCreateManagedWidget ("Minefield Name", 
			      xmLabelGadgetClass, fwMainWin,
			      XmNtopAttachment, XmATTACH_FORM,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 22,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      NULL);
   fwMinefieldName = 
     XtVaCreateManagedWidget ("textbox", 
			      xmTextFieldWidgetClass, fwMainWin, 
			      XmNtopAttachment, XmATTACH_FORM,
			      XmNleftAttachment, XmATTACH_WIDGET,
			      XmNleftWidget, wLabel,
			      XmNleftOffset, 5,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      XmNcolumns, 20,
			      XmNeditable, FALSE,
			      NULL);

   fwActionArea = CreateActionArea (fwMainWin);
}

cCompEditorWindow::~cCompEditorWindow()
{
}

