/*
$RCSfile: Display.h,v $
$Revision: 1.7 $
$Author: jchappel $
$Date: 1999/05/28 13:49:01 $
$Log: Display.h,v $
Revision 1.7  1999/05/28 13:49:01  jchappel


Coms code that has been combined with cms code for one distribution.  Makefile
distinguishes which executable to create.

Revision 1.6  1999/04/26 13:54:59  ksnively
*** empty log message ***

Revision 1.5  1999/04/01 19:48:11  jchappel
Modified COMS to allow Detonate All Button, Keith added some DetontateAll
code.  Also modified COMS to use its own Window editor, instead of the
pre-existing Minefield editor

Revision 1.4  1999/03/30 13:51:59  ksnively

Added linked list for Comtroller to track mines.  Added menu item to activate communication effects model.

Revision 1.3  1999/03/27 02:20:50  jchappel
Made modifications to change COMS location.  Gui icon moves with mouse click

Revision 1.1.1.1  1999/03/25 13:55:22  jchappel
Communication System from modified CMS

Added radio communication capability for Command Detonated Mines.  Included sending
and receiving transmitter and signal PDUs.  All signals have the option of being
processed by the Communication Effects Federate.

Revision 1.1.1.1  1999/02/16 14:54:48  jchappel
Comprehensive Mine Simulator

 * Revision 2.3  1998/04/20  15:10:36  ksnively
 * *** empty log message ***
 *
 * Revision 2.2  1998/03/04  13:20:11  jchappel
 * added area sensitivity to CD mines
 *
 * Revision 2.1  1998/02/18  17:17:24  ksnively
 * Incorporated AP mine replacement code
 *
 * Revision 2.0  1998/01/26  21:04:20  ksnively
 * Baseline CMS before additions for AP mine replacements.
 *
 * Revision 1.1  1997/12/16  13:59:57  ksnively
 * Initial revision
 *
 * Revision 1.4  1997/10/27  17:07:30  trang
 * BUILD1
 *
 * Revision 1.3  1997/10/02  17:47:47  austin
 * first working port to modsaf3.0
 *
Revision 1.3  1997/10/02 17:47:47  austin
first working port to modsaf3.0

 * Revision 1.2  1997/03/20  19:16:16  ksnively
 * Added emission tracking, updated to CMS2.0B6.
 *
 * Revision 1.1  1996/10/23  13:54:40  nsipes
 * Initial revision
 *
 * Revision 1.27  1996/09/07  16:14:35  mkappel
 * Draw box(es) for MICLIC and ESMB explosions
 *
 * Revision 1.27  1996/09/07  16:14:35  mkappel
 * Draw box(es) for MICLIC and ESMB explosions
 *
 * Revision 1.26  1996/08/20  13:44:41  mkappel
 * Add Detonation Display.
 *
 * Revision 1.25  1996/08/15  19:15:44  mkappel
 * Change perimeter color when minefield state changes.
 *
 * Revision 1.24  1996/08/07  20:31:59  mkappel
 * Startup screen header file.
 *
 * Revision 1.23  1996/08/07  14:19:30  rcarp
 * initial revisions for CP protocol
 *
 * Revision 1.22  1996/07/13  19:04:20  rcarp
 * version 1.5b13, fixes bug dragging with two buttons and displays damamged vehicles
 *
 * Revision 1.21  1996/05/21  12:36:39  mkappel
 * Add exercise name to startup screen.
 *
 * Revision 1.20  1996/05/15  00:11:09  rcarp
 * mostly wam and offroute fixes, also deleting selection
 *
 * Revision 1.19  1996/05/14  16:15:08  rcarp
 * refinements and bug fixes for 1.5 delivery
 *
 * Revision 1.18  1996/05/11  21:35:41  mkappel
 * Add mine age.
 *
 * Revision 1.17  1996/05/11  16:49:17  mkappel
 * New mine type selector and fuze options.
 *
 * Revision 1.16  1996/05/08  00:49:35  rcarp
 * changes for 1.5, incl user mines, mine params, param i/o, selection
 *
 * Revision 1.15  1996/04/04  22:16:03  mkappel
 * Label minefield on PVD.
 *
 * Revision 1.14  1996/04/04  16:25:34  mkappel
 * Improve performance with large mine sets.
 *
 * Revision 1.13  1996/03/28  22:34:41  mkappel
 * Add Mine Display toggle to component editors.
 *
 * Revision 1.12  1996/03/23  14:24:14  rcarp
 * improvements to test mode and selection
 *
 * Revision 1.11  1996/03/16  18:36:36  mkappel
 * Interface for Test Mode files.
 *
 * Revision 1.10  1996/03/15  16:03:02  mkappel
 * Allow repositioning of minefield when loading (standard minefields).
 *
 * Revision 1.9  1996/03/13  01:09:55  mkappel
 * Move CompStatus button.
 *
 * Revision 1.8  1996/03/13  00:12:33  mkappel
 * Create scrolling set of toggles for mines.
 *
 * Revision 1.7  1996/03/07  14:22:46  mkappel
 * Add Output Statistics to main menu.
 *
 * Revision 1.6  1996/03/06  19:45:05  mkappel
 * New Mine Status Window
 *
 * Revision 1.5  1996/02/23  21:16:33  mkappel
 * Use cShellWindow::PopupMessage.
 *
 * Revision 1.4  1996/02/23  18:36:44  mkappel
 * Add Site/Application to Start Up Screen.
 *
 * Revision 1.2  1996/02/16  20:33:22  rcarp
 * revisions associated with 1.1b7
 *
$State: Exp $
*/
 
/*******************************************

   file: Display.h
   
      Copyright 1995 by the Institute for Defense Analyses
      
         Institute for Defense Analyses
         1801 N. Beauregard Street
         Alexandria, Virginia 22311-1772
         703-845-2000
         
      This software was developed by IDA under U. S. Government
      contract.  For distribution information contact:
      
         U. S. Army Night Vision Directorate
         AMSEL RD NV OD CD
         10221 Burbeck Road, suite 430
         Ft. Belvoir VA 22060-5806
      
*********************************************/

/*******************************************

   Display.h
   
      The display header file defines the display interface classes.
      
      
   
   Created by Richard Carpenter
   Modification history:
      created   
      
*********************************************/

#ifndef _UDisplay_
#define _UDisplay_

#include "Globals.h"
#include "Vehicle.h"
#include "Minefield.h"

#ifdef COMS
#include "ComSModel.h"
#endif

#include <libsensitive.h>

#include <Xm/Xm.h>

// ************************************
//   basic types
// ************************************

// ************************************
//   display interface classes
// ************************************
class cDispObj {

friend class cMapControlsWindow;

protected:
   TACTMAP_OBJECT_DFN   fDfn;
   SNSTVE_CLASS         fSensClass;
   TACTMAP_OBJECT_PTR   fpObj;
   
   TACTMAP_OBJECT_DFN   fDfnSelected;
   TACTMAP_OBJECT_PTR   fpObjSelected;
   
   EBoolean             fbVisible;      // currently visible
   EBoolean             fbSelVisible;   // selected dfn visible

public:
   virtual void         SetVisible (EBoolean show);
   EBoolean             IsVisible () {return fbVisible;};

   virtual void         RedrawSelected ();
   int                  IsSelVisible () {return fbSelVisible;};

   virtual   void       DrawObj     ();
   virtual   void       RotateObj   (T2dMove move);
   virtual   void       MoveVertex  (int iPt, TLocation tccPt);

              cDispObj ( EBoolean visible = true);
   virtual   ~cDispObj ();
};

class cMapDisp : public cDispObj {

protected:
   static   void    print_gesture (SNSTVE_WINDOW_PTR sensitive,
				   SNSTVE_ACTION action,
				   SNSTVE_CALL_DATA *call_data,
				   char *name);

public:
              cMapDisp (TACTMAP_OBJECT_CLASS tmClass);
   virtual   ~cMapDisp ();
};

class cMineDisp : public cDispObj {

protected:
   cMine*           fpMine;
   static cMine*    fpCurFireMine;   // only one allowed at a time for firing at location
   int              fMineInstance;
   EBoolean         fbClickCmdFire;  // fires on click on mine itself
   static float     fMineMagnification;  // same magnification for all mines.

   static GC                 fMineGC [];
   static SNSTVE_CLASS       fSensNull;      //mine is not sensitive
   static SNSTVE_CLASS       fSensNullSel;   // selected mine display is not sens
   static SNSTVE_CLASS       fSensMine;      // mine sens, for editing
   static SNSTVE_CLASS       fSensMineSelect;   // used in comp ed win, to select mine
   static SNSTVE_CLASS       fSensMineSelectComp;   // used in mf ed win, to select comp
   static SNSTVE_CLASS       fSensMineFire;   // sens obj added, class cleared, so no null is needed
   static SNSTVE_CLASS       fSensMineSelectFire;// used in mine status win, to select or fire mine
   static SNSTVE_CLASS       fSensMineSelectCompFire;// used in comp status win, to select comp or fire mine

   static int                fSensMineInstanceCounter;

   static   void    CbMove (SNSTVE_WINDOW_PTR sensitive, 
			    SNSTVE_ACTION action,
			    SNSTVE_CALL_DATA *call_data, 
			    char *name);
   static   void    CbClickSelect (SNSTVE_WINDOW_PTR sensitive, 
                            SNSTVE_ACTION action,
                            SNSTVE_CALL_DATA *call_data, 
                            char *name);
   static   void    CbClickSelectFire (SNSTVE_WINDOW_PTR sensitive, 
                            SNSTVE_ACTION action,
                            SNSTVE_CALL_DATA *call_data, 
                            char *name);
   static   void    CbClickSelectComp (SNSTVE_WINDOW_PTR sensitive, 
                            SNSTVE_ACTION action,
                            SNSTVE_CALL_DATA *call_data, 
                            char *name);
   static   void    CbClickFire (SNSTVE_WINDOW_PTR sensitive, 
                            SNSTVE_ACTION action,
                            SNSTVE_CALL_DATA *call_data, 
                            char *name);
   static   void    CbClickSelectCompFire (SNSTVE_WINDOW_PTR sensitive, 
			 SNSTVE_ACTION action,
			 SNSTVE_CALL_DATA * call_data, 
			 char * name);


   static   void    CbDrawSelected (Widget widget, 
				    Pixmap pixmap,
				    ADDRESS draw_arg, 
				    XRectangle *boundary);

public:
   static void  InitGCs      (Widget wShell);
   static   void   ClearFireActive();

   float        GetMineMag()          { return fMineMagnification; }
   void         SetMineMag(float mag) { fMineMagnification = mag; }

   void         SetVisible   (EBoolean show);
   void         RedrawSelected ();
   cMine*       GetMine      ()   {return fpMine;}
   void         SetMine      ( cMine* pMine);/*   { fpMine = pMine;}*/
   void         SetSensitive (EBoolean sens);
   void         SetMineSelectSens   (EBoolean sens);
   void         SetCompSelectSens   (EBoolean sens);
   void         SetFireActiveMine();   // sets this instantiation as current
   void         SetFireActiveSens( int x, int y, int radius );   // sets the sensitive area
   virtual void DrawObj ();

                cMineDisp (cMine* pMine, TLocation , EBoolean bVisible = true);
   virtual     ~cMineDisp    ();
};

#ifdef COMS
class cRemoteDisp : public cDispObj {

protected:

   cRemoteMine*        fpMine;
   static cRemoteMine*  fpCurFireMine;  //only one allowed at a time for firing
   int                 fMineInstance;
   EBoolean            fpClickCmdFire;  //fires on click on mine itself
   static float        fMineMagnification;  //  same magnification for all mines
   static int          fSensMineInstanceCounter;

   static GC                 fMineGC [];
   static SNSTVE_CLASS       fSensNull;      //mine is not sensitive
   static SNSTVE_CLASS       fSensNullSel;   // selected mine display is not sens
   static SNSTVE_CLASS       fSensMine;      // mine sens, for editing
   static SNSTVE_CLASS       fSensMineSelect;   // used in comp ed win, to select mine
   static SNSTVE_CLASS       fSensMineSelectComp;   // used in mf ed win, to select comp
   static SNSTVE_CLASS       fSensMineFire;   // sens obj added, class cleared, so no null is needed
   static SNSTVE_CLASS       fSensMineSelectFire;// used in mine status win, to select or fire mine
   static SNSTVE_CLASS       fSensMineSelectCompFire;// used in comp status win, to select comp or fire mine
 
   static   void    CbMove (SNSTVE_WINDOW_PTR sensitive, 
			    SNSTVE_ACTION action,
			    SNSTVE_CALL_DATA *call_data, 
			      char *name){}
   static   void    CbClickSelect (SNSTVE_WINDOW_PTR sensitive, 
                            SNSTVE_ACTION action,
                            SNSTVE_CALL_DATA *call_data, 
				     char *name){}
   static   void    CbClickSelectFire (SNSTVE_WINDOW_PTR sensitive, 
                            SNSTVE_ACTION action,
                            SNSTVE_CALL_DATA *call_data, 
					 char *name){}
   static   void    CbClickSelectComp (SNSTVE_WINDOW_PTR sensitive, 
                            SNSTVE_ACTION action,
                            SNSTVE_CALL_DATA *call_data, 
					 char *name){}
   static   void    CbClickFire (SNSTVE_WINDOW_PTR sensitive, 
                            SNSTVE_ACTION action,
                            SNSTVE_CALL_DATA *call_data, 
				   char *name);
   static   void    CbClickSelectCompFire (SNSTVE_WINDOW_PTR sensitive, 
			 SNSTVE_ACTION action,
			 SNSTVE_CALL_DATA * call_data, 
					     char * name);


   static   void    CbDrawSelected (Widget widget, 
				    Pixmap pixmap,
				    ADDRESS draw_arg, 
				      XRectangle *boundary){}



public:

   static void  InitGCs      (Widget wShell);
   
   virtual void   DrawObj ();
   void           SetVisible( EBoolean show );
   void           SetSensitive (EBoolean sens);
   void           RedrawSelected();
   
                  cRemoteDisp( cRemoteMine* pMine, TLocation, EBoolean bVisible = true );
    virtual      ~cRemoteDisp ();
};
#endif

class cMineExplosion : public cDispObj {

protected:
   TLocation                 fDetonPt;
   TLocation                 fFirePt;
   float64                   fBlastSize;
   
   static SNSTVE_CLASS       fSensNull;
   static GC                 fExplosionGC [];

   static void               DrawExplosion (Widget widget, 
					    Pixmap pixmap,
					    ADDRESS draw_arg, 
					    XRectangle *boundary);
public:
   static void  InitGCs      (Widget wShell);

                cMineExplosion (TLocation detonPt, TLocation firePt, 
				float64 blast_size, TTimeSim delay);     // blast size in meters
   virtual     ~cMineExplosion ();
};

class cVehDisp : public cDispObj {

protected:
   cVehicle*           fpVeh;
   READER_UNION*       fVeh_pictures;

   static GC                 fBlackGC;
   static GC                 fWhiteGC;
   static GC                 fVehGC [];
   static SNSTVE_CLASS       fSensVeh;
   static int                fSensVehInstanceCounter;

   static float              fVehMagnification; // same magnification for all vehicles

public:
   static void  InitGCs      (Widget wShell);
   static void  InitPictures ();

   float        GetVehMag()          { return fVehMagnification; }
   void         SetVehMag(float mag) { fVehMagnification = mag; }

   virtual void         SetVisible (EBoolean show);

   virtual void         UpdateVehicleDisp ();
   virtual void         SetVehDispState();

                cVehDisp     (cVehicle* pVeh, EBoolean visible = true);
   virtual     ~cVehDisp     ();
};

class cDetonationDisp : public cDispObj {

protected:
   cDetonation*              fDeton;
   
   static SNSTVE_CLASS       fSensNull;
   static GC                 fExplosionGC [];

   static void               DrawExplStar (Widget widget, 
					   Pixmap pixmap,
					   ADDRESS draw_arg, 
					   XRectangle *boundary);
   static void               DrawExplBox  (Widget widget, 
					   Pixmap pixmap,
					   ADDRESS draw_arg, 
					   XRectangle *boundary);

public:
   static void  InitGCs      (Widget wShell);

                cDetonationDisp (cDetonation *pDeton, TTimeSim delay);
   virtual     ~cDetonationDisp();
};

enum EPerimState {epsNotSim, epsOff, epsOn};

class cPerimeter;
class cSegmentDisp;

class cPerimDisp : public cDispObj {

protected:
   cPerimeter*      fpPerim;
   cSegmentDisp*    fpDashed;
   TACTMAP_OBJECT_DFN  fLabelDfn;
   TACTMAP_OBJECT_PTR  fpLabelObj;

   static XFontStruct*       fFontInfo;
   static GC                 fPerimGC [];
   static SNSTVE_CLASS       fSensNull;
   static SNSTVE_CLASS       fSensSelNull;
   static SNSTVE_CLASS       fSensPerim;
   static SNSTVE_CLASS       fSensPerimSelect;   // used in battlefield ed win, to select mf
   static int                fSensPerimInstanceCounter;

   static   void    CbMove (SNSTVE_WINDOW_PTR sensitive, 
                            SNSTVE_ACTION action,
                            SNSTVE_CALL_DATA *call_data, 
                            char *name);
   static   void    CbClickSelect (SNSTVE_WINDOW_PTR sensitive, 
                            SNSTVE_ACTION action,
                            SNSTVE_CALL_DATA *call_data, 
                            char *name);
   static   void    CbDrawSelected (Widget widget, 
				    Pixmap pixmap,
				    ADDRESS draw_arg, 
				    XRectangle *boundary);

public:
   static void  InitGCs         (Widget wShell);

   void         SetVisible      (EBoolean show);
   void         SetStateColor   (EBoolean on);
   void         RedrawSelected  ();
   void         RotateObj       (T2dMove move);
   void         MoveVertex      (int iPt, TLocation tccPt);
   void         AddVertex       (int nvert, TLocation tccPt);
   void         DeleteVertex    (int iPt);
   void         CloseLoop       (int nvert);
   void         SetSensitive    (EBoolean sens);
   void         SetSelectSens   (EBoolean sens);
   void         EditPerim       ();
   void         DrawPerim       (EPerimState eState);
   void         UpdateLabelPos  ();
   void         UpdateLabelName (char *name);
  
                cPerimDisp      (cPerimeter* pPerim);
   virtual     ~cPerimDisp      ();
};


class cSegmentDisp : public cDispObj {

protected:
   static GC                 fSegmentGC [];
   static SNSTVE_CLASS       fSensNull;

   static   void    CbMove (SNSTVE_WINDOW_PTR sensitive, 
                            SNSTVE_ACTION action,
                            SNSTVE_CALL_DATA *call_data, 
                            char *name);

public:
   static void  InitGCs      (Widget wShell);

   void         MoveSegment  (TLocation tccPt1, TLocation tccPt2);
  
                cSegmentDisp (TLocation tccPt1, TLocation tccPt2);
   virtual     ~cSegmentDisp ();
};

class cRowDisp : public cDispObj {

protected:
   cRowComp*        fpRow;

   static GC                 fRowGC [];
   static SNSTVE_CLASS       fSensNull;
   static SNSTVE_CLASS       fSensRow;
   static SNSTVE_CLASS       fSensRowSelect;   // used in mf ed win, to select row comp
   static int                fSensRowInstanceCounter;

   static   void    CbMove (SNSTVE_WINDOW_PTR sensitive, 
                            SNSTVE_ACTION action,
                            SNSTVE_CALL_DATA *call_data, 
                            char *name);
   static   void    CbClickSelect (SNSTVE_WINDOW_PTR sensitive, 
                            SNSTVE_ACTION action,
                            SNSTVE_CALL_DATA *call_data, 
                            char *name);

public:
   static void  InitGCs      (Widget wShell);

   void         RotateObj    (T2dMove move);
   void         MoveVertex   (int iPt, TLocation tccPt);
   void         AddVertex    (int nvert, TLocation tccPt);
   void         DeleteVertex (int iPt);
   void         SetSensitive (EBoolean sens);
   void         SetRowSelectSens   (EBoolean sens);
  
                cRowDisp     (cRowComp* pRow);
   virtual     ~cRowDisp     ();
};

class cWindow {

protected:

   static Widget        fwTopLevelShell;
   static XtAppContext  fApp;
   
   Widget               fwMainWin;

public:
   static       void     InitMotif( int* pArgc, char* argv[] );

   Widget                GetMainWin() { return fwMainWin; }
   static  XtAppContext  GetAppContext() { return fApp; }

   virtual              ~cWindow();
};


// ************************************
//  classes supporting work area, X widgets and such
// ************************************

class cDispMfSummary :  public cWindow {

 protected:
    cMinefield*   fpMinefield;
    Widget        fwMfName;
    Widget        fwSimToggle;
    Widget        fwOnToggle;
    Widget        fwPerimToggle;
    Widget        fwMineToggle;
    Widget        fwFixtToggle;
    Widget        fwTotalMines;
    Widget        fwLiveMines;
    Widget        fwFiredMines;
    Widget        fwOtherMines;
    Widget        fwVehHits;
    Widget        fwVehKills;
    Widget	  fwLabelToggle;
    
    static   void  CbSelect     (Widget w, XtPointer pObj, 
				 XmPushButtonCallbackStruct *cbs);
    static   void  CbSimToggle  (Widget, XtPointer, 
				 XmToggleButtonCallbackStruct*);
    static   void  CbOnToggle   (Widget, XtPointer, 
				 XmToggleButtonCallbackStruct*);
    static   void  CbPerimToggle(Widget, XtPointer, 
				 XmToggleButtonCallbackStruct*);
    static   void  CbMineToggle (Widget, XtPointer, 
				 XmToggleButtonCallbackStruct*);
    static   void  CbFixtToggle (Widget, XtPointer, 
				 XmToggleButtonCallbackStruct*);
    static   void  CbLabelToggle(Widget, XtPointer, 
				 XmToggleButtonCallbackStruct*);


 public:
   void          SwitchHilite();              
   void          ShowInfo();              

                 cDispMfSummary(cMinefield* pMinefield);
   virtual      ~cDispMfSummary();
};

class cCompListArea : public cWindow  {

   friend class cMinefieldEditorWindow;

 private:

   Widget      fwMinefieldName;
   Widget      fwTypeMenu;
   Widget      fwHastyOption;
   Widget      fwDeliberateOption;
   Widget      fwForceMenu;
   Widget      fwFriendlyOption;
   Widget      fwEnemyOption;
   Widget      fwOtherOption;

   static void CbNameChange (Widget w, XtPointer pObj, XmTextVerifyCallbackStruct* cbs);

 public:
   void        ShowInfo();              

               cCompListArea (Widget wParent);
              ~cCompListArea ();
};
  
class cCompSummLine : public cWindow  {

 friend class cMinefieldEditorWindow;

 protected:
    cMfComponent* fpComp;
    Widget        fwTypeText;
    Widget        fwSimToggle;
    Widget        fwOnToggle;
    Widget        fwDomain;
    Widget        fwMineType;
    Widget        fwNumMines;
    Widget        fwMineSpacing;
    Widget        fwMineDepth;
    Widget        fwMineAge;
    
    static  void  CbSelect     (Widget w, XtPointer pObj, 
				XmPushButtonCallbackStruct *cbs);
    static  void  CbSimToggle  (Widget, XtPointer, 
				XmToggleButtonCallbackStruct*);
    static  void  CbOnToggle   (Widget, XtPointer, 
				XmToggleButtonCallbackStruct*);

public:
   void          SwitchHilite();              
   virtual void  ShowInfo();              

                 cCompSummLine (cMfComponent* pComp, Widget wParent);
   virtual      ~cCompSummLine ();
};

class cPerimSummLine : public cCompSummLine {

 protected:

public:
   void          ShowInfo();              

                 cPerimSummLine (cPerimeter* pComp, Widget wParent);
   virtual      ~cPerimSummLine ();
};

class cMineCompSummLine : public cCompSummLine {

 protected:

public:
   void          ShowInfo();              

                 cMineCompSummLine (cMineComp* pComp, Widget wParent);
   virtual      ~cMineCompSummLine ();
};

class cCompStatusArea : public cWindow  {

   friend class cComponentStatusWindow;

 private:

   Widget      fwMinefieldName;
   Widget      fwTypeLabel;
   Widget      fwForceLabel;
   Widget      fwStateLabel;

 public:
   void        ShowInfo();              

               cCompStatusArea (Widget wParent);
              ~cCompStatusArea ();
};
  
class cCompStatusLine : public cWindow  {

 friend class cMinefieldEditorWindow;

 protected:
    cMfComponent* fpComp;
    Widget        fwTypeText;
    Widget        fwSimToggle;
    Widget        fwOnToggle;
    Widget        fwTotalMines;
    Widget        fwLiveMines;
    Widget        fwFiredMines;
    Widget        fwOtherMines;
    Widget        fwVehHits;
    Widget        fwVehKills;
    Widget        fwDomain;
    Widget        fwMineType;
    
    static  void  CbSelect     (Widget w, XtPointer pObj, 
				XmPushButtonCallbackStruct *cbs);
    static  void  CbSimToggle  (Widget, XtPointer, 
				XmToggleButtonCallbackStruct*);
    static  void  CbOnToggle   (Widget, XtPointer, 
				XmToggleButtonCallbackStruct*);

public:
   void          ShowInfo();              
   void          SwitchHilite();              

                 cCompStatusLine (cMfComponent* pComp, Widget wParent);
   virtual      ~cCompStatusLine ();
};

class cCoordList;
class cEntityIdTextEditor;

class cEditorWindow : public cWindow {

protected:
   
public:
   virtual    void         DeleteObjEntry(cMfComponent* pComp, int index);
   virtual    void         ShowEdWindow();
   virtual    void         ClearEdWindow ();
   virtual    void         MapClick(TLocation& loc);
   virtual    void         NewMine(TLocation& loc);
   virtual    void         NewMines(TLocation* tccPts, int nMines);
   virtual    void         SetButtonState ();
   virtual    void         SetWidgetState();
   virtual    cCoordList*  GetMineCoordWidget ();
   virtual    cCoordList*  GetPerimVertexCoordWidget ();
   virtual    cCoordList*  GetRowVertexCoordWidget ();

   virtual   cEntityIdTextEditor* GetControllerIdWidget();
   
                           cEditorWindow();
   virtual                ~cEditorWindow();
};

#ifdef COMS
class cCOMStatusWindow : public cEditorWindow {

private:
  // Widget      fwSummList;
   Widget      fwCOMSButton;
   Widget      fwDetonateAllButton;

   static   void        CbCreateCOMS(Widget, XtPointer, 
				    XmPushButtonCallbackStruct*);
   static   void        CbDetonateAll   (Widget, XtPointer, 
				    XmPushButtonCallbackStruct*);
//   static   void        CbScroll   (Widget, XtPointer, 
//				    XmScrollBarCallbackStruct*);

//   Widget        CreateSummaryArea (Widget wParent);
   Widget        CreateHeadings(Widget wParent);
   Widget        CreateActionArea (Widget wParent);

public:
   static TLocation   TccLoc;
   EBoolean eSetLoc;
   EBoolean eNewLoc;
   static EBoolean eDetAll;

   virtual void       ShowEdWindow();
   virtual void       ClearEdWindow ();
   virtual void       SetButtonState();
   virtual void       MapClick (TLocation& loc);
   
              cCOMStatusWindow (Widget parent);
   virtual   ~cCOMStatusWindow ();
};

#endif
class cMinefieldStatusWindow : public cEditorWindow {

private:
   Widget      fwSummList;
   Widget      fwCreateButton;
   Widget      fwEditButton;
   Widget      fwDuplicateButton;
   Widget      fwDeleteButton;
   Widget      fwZoomButton;
   Widget      fwSendCmdButton;
   Widget      fwSaveMfsButton;
   Widget      fwLoadMfsButton;
   Widget      fwSaveTblButton;
   Widget      fwPrintTblButton;
   
   Widget      fwfs;
   char*       filename;

   static   void        CbCreate   (Widget, XtPointer, 
				    XmPushButtonCallbackStruct*);
   static   void        CbEdit     (Widget, XtPointer, 
				    XmPushButtonCallbackStruct*);
   static   void        CbDuplicate(Widget, XtPointer, 
				    XmPushButtonCallbackStruct*);
   static   void        CbDelete   (Widget, XtPointer, 
				    XmPushButtonCallbackStruct*);
   static   void        CbZoom     (Widget, XtPointer, 
				    XmPushButtonCallbackStruct*);
   static   void        CbSendCmd  (Widget, XtPointer, 
				    XmPushButtonCallbackStruct*);
   static   void        CbSaveMfs  (Widget, XtPointer, 
				    XmPushButtonCallbackStruct*);
   static   void        CbSaveMfsOKYes(Widget, XtPointer data, 
				    XmFileSelectionBoxCallbackStruct*);
   //static   void        CbSaveMfsOKNo(Widget, XtPointer data, 
   //				    XmPushButtonCallbackStruct*)  { ((cMinefieldStatusWindow*) data)->fbSave = false; }
   static   void        CbLoadMfs  (Widget, XtPointer, 
				    XmPushButtonCallbackStruct*);
   static   void        CbSaveTbl  (Widget, XtPointer, 
				    XmPushButtonCallbackStruct*);
   static   void        CbPrintTbl (Widget, XtPointer, 
				    XmPushButtonCallbackStruct*);
   static   void        CbScroll   (Widget, XtPointer, 
				    XmScrollBarCallbackStruct*);

   static   void        CbSaveMfsOK(Widget, XtPointer, 
				    XmFileSelectionBoxCallbackStruct*);
   static   void        CbLoadMfsOK(Widget, XtPointer, 
				    XmFileSelectionBoxCallbackStruct*);
   static   void        CbDeleteOK (Widget, XtPointer, 
				    XmAnyCallbackStruct*);
   static   void        CbCancel   (Widget, XtPointer, 
				    XmFileSelectionBoxCallbackStruct*);

   Widget        CreateSummaryArea (Widget wParent);
   Widget        CreateHeadings(Widget wParent);
   Widget        CreateActionArea (Widget wParent);
   
   static   cMinefield**  MakeSelectionList();
   static   int           SelectionCount();

public:

   virtual void       ShowEdWindow();
   virtual void       ClearEdWindow ();
   virtual void       SetButtonState();
   virtual void       MapClick (TLocation& loc);
   Widget             GetMfSummParent()   { return fwSummList; }
   
              cMinefieldStatusWindow (Widget parent);
   virtual   ~cMinefieldStatusWindow ();
};

class cComponentStatusWindow : public cEditorWindow {

private:
   static Widget      fwCompScrollArea;
   static Widget      fwCompScrollBar;
   static Widget      fwDoneButton;
   static Widget      fwStatusButton;

   static cMinefield* fpMinefield;

   static void        CbDone   (Widget, XtPointer, XmPushButtonCallbackStruct*);
   static void        CbCancel (Widget, XtPointer, XmPushButtonCallbackStruct*);
   static void        CbScroll (Widget, XtPointer, XmScrollBarCallbackStruct*);
   static void        CbEdit   (Widget, XtPointer, XmPushButtonCallbackStruct*);
   static void        CbStatus (Widget, XtPointer, XmPushButtonCallbackStruct*);

   Widget             CreateWorkArea    (Widget wParent);
   Widget             CreateHeadings    (Widget wParent);
   Widget             CreateSummaryArea (Widget wParent);
   Widget             CreateActionArea  (Widget wParent);

public:
//   static  void       SetCmdCompSens(cMinefield* pMf, EBoolean sens);
   virtual void       ShowEdWindow();
   virtual void       ClearEdWindow ();
   cCompStatusArea*   CreateCompStatusArea();

              cComponentStatusWindow (Widget parent);
   virtual   ~cComponentStatusWindow ();
};

class cMineStatusWindow : public cEditorWindow {

private:
   static int         fMaxToggles;
   static int         fListLineSize;

   static Widget      fwStatusArea;
   static Widget      fwMinefieldName;
   static Widget      fwCompType;
   static Widget      fwDomain;
   static Widget      fwMineType;
   static Widget      fwMineDepth;
   static Widget      fwMineAge;
   static Widget      fwMineList;
   static Widget      fwScrollbar;
   static Widget      fwToggle[];

   static Widget      fwDoneButton;

   static cMineComp * fpMineComp;

   static  void       CbOnToggle (Widget, XtPointer, XmToggleButtonCallbackStruct*);
   static void        CbScroll   (Widget, XtPointer, XmScrollBarCallbackStruct*);
   static void        CbResize   (Widget, XtPointer, XEvent*);
   static void        CbDone     (Widget, XtPointer, XmPushButtonCallbackStruct*);
   static void        CbCancel   (Widget, XtPointer, XmPushButtonCallbackStruct*);
   static void        CbMineItem (Widget, XtPointer, XmListCallbackStruct*);

   Widget             CreateHeadings    (Widget wParent);
   Widget             CreateStatusArea  (Widget wParent);
   Widget             CreateActionArea  (Widget wParent);

public:
   virtual void       ShowEdWindow();
   virtual void       ClearEdWindow ();
   virtual void       SetButtonState ();
   void               SetMineToggles ();
   cMineComp*         GetMineComp()   { return fpMineComp; }

              cMineStatusWindow (Widget parent);
   virtual   ~cMineStatusWindow ();
};

class cMinefieldEditorWindow : public cEditorWindow {

private:
   static Widget      fwCreateIndiv;
   static Widget      fwCreateGrid;
   static Widget      fwCreateRow;
   static Widget      fwEditComp;
   static Widget      fwDuplicateComp;
   static Widget      fwDeleteComp;
   static Widget      fwMoveMf;
   static Widget      fwCompScrollArea;
   static Widget      fwCompScrollBar;
   static Widget      fwDoneButton;

   static void        CbCreate        (Widget, XtPointer, XmAnyCallbackStruct*);
   static void        CbEditComp      (Widget, XtPointer, XmAnyCallbackStruct*);
   static void        CbDuplicateComp (Widget, XtPointer, XmAnyCallbackStruct*);
   static void        CbDeleteComp    (Widget, XtPointer, XmAnyCallbackStruct*);
   static void        CbDeleteOK      (Widget, XtPointer, XmAnyCallbackStruct*);
   static void        CbMoveMf        (Widget, XtPointer, XmAnyCallbackStruct*);
   static void        CbDone          (Widget, XtPointer, XmPushButtonCallbackStruct *);
   static void        CbCancel        (Widget, XtPointer, XmPushButtonCallbackStruct *);
   static void        CbScroll        (Widget, XtPointer, XmScrollBarCallbackStruct*);

   Widget             CreateMenuBar     (Widget wParent);
   Widget             CreateWorkArea    (Widget wParent);
   Widget             CreateHeadings    (Widget wParent);
   Widget             CreateSummaryArea (Widget wParent);
   Widget             CreateActionArea  (Widget wParent);
   
   static int               CompSelectionCount();
   static cMfComponent**    MakeCompSelectionList();

   cMinefield*        fpMfCopy;

public:
   virtual void       ShowEdWindow();
   virtual void       SetButtonState();
   cCompListArea*     CreateCompListArea();

                      cMinefieldEditorWindow (Widget wParent);
   virtual           ~cMinefieldEditorWindow ();
};

#ifdef COMS
class cCOMSComponent;
class cCOMSEditorWindow : public cEditorWindow {

private:
   static Widget      fwEditComp;
   static Widget      fwDeleteComp;
   static Widget      fwMoveMf;
   static Widget      fwCompScrollArea;
   static Widget      fwCompScrollBar;
   static Widget      fwDoneButton;

   static void        CbEditComp      (Widget, XtPointer, XmAnyCallbackStruct*);
   static void        CbDeleteComp    (Widget, XtPointer, XmAnyCallbackStruct*);
   static void        CbDeleteOK      (Widget, XtPointer, XmAnyCallbackStruct*);
   static void        CbMoveMf        (Widget, XtPointer, XmAnyCallbackStruct*);
   static void        CbDone          (Widget, XtPointer, XmPushButtonCallbackStruct *);
   static void        CbCancel        (Widget, XtPointer, XmPushButtonCallbackStruct *);
   static void        CbScroll        (Widget, XtPointer, XmScrollBarCallbackStruct*);

   Widget             CreateMenuBar     (Widget wParent);
   Widget             CreateWorkArea    (Widget wParent);
   Widget             CreateHeadings    (Widget wParent);
   Widget             CreateSummaryArea (Widget wParent);
   Widget             CreateActionArea  (Widget wParent);
   
   static int               CompSelectionCount();
   static void   MakeCompSelectionList();

   cCOMSComponent*        fpMfCopy;

public:
   virtual void       ShowEdWindow();
   virtual void       SetButtonState();
   cCompListArea*     CreateCompListArea();

		      cCOMSEditorWindow (Widget wParent);
   virtual	     ~cCOMSEditorWindow ();
};
#endif

enum ECoordListType {ecltPerimVertex, ecltRowVertex, ecltMine};

class cCoordList : public cWindow {

private:
   ECoordListType fType;
   Widget         fwCoordForm;
   Widget         fwNumEntries;
   Widget         fwCoordList;
   Widget         fwScrollbar;
   Widget         fwToggle[50];
   int            fMaxToggles;
   int            fListLineSize;

   static void    CbSelect   (Widget, XtPointer, XmListCallbackStruct*);
   static void    CbOnToggle (Widget, XtPointer, XmToggleButtonCallbackStruct*);
   static void    CbScroll   (Widget, XtPointer, XmScrollBarCallbackStruct*);
   static void    CbResize   (Widget, XtPointer, XEvent*);

public:
   Widget         GetCoordForm ()   { return fwCoordForm; }

   void           DeleteEntries ();
   void           DeleteEntry (int index);
   void           ReplaceEntry (int index, TLocation newPt);
   void           AppendCoordEntry (TLocation tccPt);
   void           AppendCoordEntries (TLocation* tccPts, int nEntries);
   void           AppendCoordEntry ();
   void           UpdateNumEntries ();
   void           SetMineToggles ();

                  cCoordList (Widget wParent, ECoordListType type);
   virtual       ~cCoordList ();
};

class cHelpTextWidget : public cWindow {

private:
   Widget         fwHelpForm;

public:
   Widget         GetHelpForm ()  { return fwHelpForm; }

                  cHelpTextWidget (Widget wParent, char *text);
   virtual       ~cHelpTextWidget ();
};

class cCompEditorWindow : public cEditorWindow {

protected:
   Widget         fwMinefieldName;
   Widget         fwActionArea;
   Widget         fwDoneButton;
   Widget         fwCancelButton;

   Widget         CreateActionArea (Widget wParent);

//   static void    CbDone      (Widget, XtPointer, XmPushButtonCallbackStruct*);
//   static void    CbCancel    (Widget, XtPointer, XmPushButtonCallbackStruct*);

public:
                  cCompEditorWindow (Widget parent);
   virtual       ~cCompEditorWindow ();
};

class cPerimEditorWindow : public cCompEditorWindow {

protected:
   cCoordList*    fpVertexCoord;

   static void    CbDone      (Widget, XtPointer, XmPushButtonCallbackStruct*);
   static void    CbCancel    (Widget, XtPointer, XmPushButtonCallbackStruct*);

   cMinefield*    fpMfCopy;

public:
   cCoordList*    GetPerimVertexCoordWidget ();
   virtual void   ShowEdWindow();
   virtual void   SetButtonState ();
   virtual void   MapClick (TLocation& loc);

                  cPerimEditorWindow (Widget parent);
   virtual       ~cPerimEditorWindow ();
};

class cMineTypeSelector;
class cEntityIdTextEditor;

class cMineCompEditorWindow : public cCompEditorWindow {

protected:
   cMineTypeSelector*   fpMineType;
   cCoordList*          fpMineCoord;
   cEntityIdTextEditor* fpControllerId;

   Widget               fwDepthText;
   Widget               fwAgeText;
   Widget               fwMineDispToggle;

   cMfComponent*        fpCompCopy;

   static void        CbDone     (Widget, XtPointer, XmPushButtonCallbackStruct*);
   static void        CbCancel   (Widget, XtPointer, XmPushButtonCallbackStruct*);
   static void        CbOnToggle (Widget, XtPointer, XmToggleButtonCallbackStruct*);

public:
   cMineTypeSelector* GetMineTypeSelector ()   { return fpMineType; }
   cCoordList*        GetMineCoordWidget ();
   cEntityIdTextEditor* GetControllerIdWidget();
   virtual void       ShowEdWindow();
   virtual void       SetButtonState();
   virtual void       SetWidgetState();
   void               NewMine (TLocation& tccPt);
   void               NewMines (TLocation* tccPts, int nMines);
   virtual    void    DeleteObjEntry(cMfComponent* pComp, int index);

                  cMineCompEditorWindow (Widget parent, EBoolean bController = false);
   virtual       ~cMineCompEditorWindow ();
};

class cIndivEditorWindow : public cMineCompEditorWindow {

public:
   virtual void   ShowEdWindow();
   virtual void   MapClick (TLocation& loc);

                  cIndivEditorWindow (Widget parent, EBoolean bController = false);
   virtual       ~cIndivEditorWindow ();
};

class cGridEditorWindow : public cMineCompEditorWindow {

private:
   Widget         fwSpacingText;
	 
   static int     fNmines;	// estimated number of mines, passed to CbSpacingOK

   static void    CbSpacing  (Widget, XtPointer, XmAnyCallbackStruct*);
   static void    CbSpacingOK(Widget, XtPointer, XmAnyCallbackStruct*);

public:
   virtual void   ShowEdWindow();
   virtual void   MapClick (TLocation& loc);

                  cGridEditorWindow (Widget parent, EBoolean bController);
   virtual       ~cGridEditorWindow ();
};

class cRowEditorWindow : public cMineCompEditorWindow {

private:
   cCoordList*    fpVertexCoord;
   Widget         fwSpacingText;
   Widget         fwOffsetText;
	 
   static int     fNmines;	// estimated number of mines, passed to CbSpacingOK

   static void    CbSpacing     (Widget, XtPointer, XmAnyCallbackStruct*);
   static void    CbSpacingOK   (Widget, XtPointer, XmAnyCallbackStruct*);
   static void    CbOffset      (Widget, XtPointer, XmAnyCallbackStruct*);

public:
   cCoordList*    GetRowVertexCoordWidget ();
   virtual void   ShowEdWindow();
   virtual void   MapClick (TLocation& loc);

                  cRowEditorWindow (Widget parent, EBoolean bController = false);
   virtual       ~cRowEditorWindow ();
};

class cFieldControlWindow : public cEditorWindow {

private:
          Widget      fwMinefieldName;
          Widget      fwActionArea;
          Widget      fwDoneButton;
          Widget      fwFireButton;
          
          Widget      fwFireOnCmd;
          Widget      fwFireWhenTripped;
          Widget      fwAutoFire;
          Widget      fwCmdFireAll;
          Widget      fwTripFireAll;
          
          Pixel       fForeColor;
          Pixel       fBackColor;

   static void        CbDone   (Widget, XtPointer, XmPushButtonCallbackStruct*);
   static void        CbFire   (Widget, XtPointer, XmPushButtonCallbackStruct*);
   static void        CbModeCheck (Widget, XtPointer, XmPushButtonCallbackStruct*);

//   cCoordList*    fpMineCoord;

   static cMinefield* fpMinefield;

   Widget             CreateActionArea (Widget wParent);

public:
//   cCoordList*    GetMineCoordList ();
   virtual void   ShowEdWindow();
           void   FireButtonMsg(cMinefield* pMinefield, EBoolean on);

                  cFieldControlWindow (Widget parent);
   virtual       ~cFieldControlWindow ();
};

class cShellWindow : public cWindow {

protected:
   Widget          fwShell;
   
public:
   enum EDialog  { eDialogError, eDialogInfo, eDialogWarning, eDialogQuestion };

   void                 PopupMessage (Widget wParent,
				      EDialog eDialogType, 
				      char* ok_str,
				      char* cancel_str,
				      XtCallbackProc ok_cb_proc,
				      XtCallbackProc cancel_cb_proc,
				      XtPointer pObj,
				      char *msg);

   virtual             ~cShellWindow();
};

class cMapControlsWindow;
class cTestModeWindow;

class cGuiWindow : public cShellWindow {

public:
   enum EEditor  { eEditNone, eEditMfStatus, eEditMinefield, eEditPerim,
                   eEditIndiv, eEditGrid, eEditRow, eEditCompStatus, 
                   eEditMineStatus, eEditCOMS, eEditMfCommand };

private:
   static   cMinefieldStatusWindow*  fpMinefieldStatusWin;
   static   cMinefieldEditorWindow*  fpMfieldEditorWin;
#ifdef COMS
   static   cCOMStatusWindow*        fpCOMSEditorWin;
#endif
   static   cPerimEditorWindow*      fpPerimEditorWin;
   static   cIndivEditorWindow*      fpIndivEditorWin;
   static   cGridEditorWindow*       fpGridEditorWin;
   static   cRowEditorWindow*        fpRowEditorWin;
   static   cComponentStatusWindow*  fpCompStatusWin;
   static   cMineStatusWindow*       fpMineStatusWin;
   static   cFieldControlWindow*     fpFieldControlWin;
   static   cMapControlsWindow*      fpMapControlsWin;
   static   cTestModeWindow*         fpTestModeWin;

   static   cEditorWindow*           fpCurrentEditor;
   static   EBoolean                 fsUserEnabled;

   static   Widget                   fwOutputButton;
   static   Widget                   fwMineDispButton;
   static   Widget                   fwCommEffectsButton;

   GC                       fgcSensErase;
   GC                       fgcSensDraw;
   int                      fScaleIndex;
   SNSTVE_WINDOW_PTR        fpSensWin;
   
      // callbacks for menu buttons
   static void  CbMap      (Widget, XtPointer, XmPushButtonCallbackStruct *);
   static void  CbTestMode (Widget, XtPointer, XmPushButtonCallbackStruct *);
   static void  CbOutput   (Widget, XtPointer, XmPushButtonCallbackStruct *);
   static void  CbMineStateDisp   (Widget, XtPointer, XmPushButtonCallbackStruct *);
   static void  CbCommEffects     (Widget, XtPointer, XmPushButtonCallbackStruct *);
   static void  CbQuit     (Widget, XtPointer, XmPushButtonCallbackStruct *);
   static void  CbQuitOK   (Widget, XtPointer, XmPushButtonCallbackStruct *);
   static void  CbClick    (SNSTVE_WINDOW_PTR window, 
				  SNSTVE_ACTION action, 
				  SNSTVE_CALL_DATA *call_data);
   static void  CbDisableUser (Widget, XtPointer, XmPushButtonCallbackStruct *);

   Widget               CreateMenuBar (Widget wParent);
   Widget               CreateWorkArea (Widget wParent);

   Widget               wHScrollbar;
   Widget               wVScrollbar;
   void                 InitScrollbar (Widget sb);
   static   void        CbScroll (Widget, XtPointer,
				  XmScrollBarCallbackStruct *);

   T2linkHead           fSelectionList;

public:
   SNSTVE_WINDOW_PTR    GetSensWinPtr() { return fpSensWin; }

   Widget               GetMfSummParent() { return fpMinefieldStatusWin->GetMfSummParent(); }
   cCompListArea*       CreateCompListArea() { return fpMfieldEditorWin->CreateCompListArea(); }
   cCompStatusArea*     CreateCompStatusArea() { return fpCompStatusWin->CreateCompStatusArea(); }
   void                 SetEditorButtonState()  {fpCurrentEditor->SetButtonState(); }

   void                 RedrawAll();
   void                 UpdateTactmap();
   float64              GetMapScale();
   int                  GetMapScaleIndex() {return fScaleIndex;}
   void                 SetMapScale (float64 Scale);
   void                 SetMapScaleIndex (int Scale);
   void                 SetMapCenter (int32 x, int32 y, int32 c);

   void                 EditMinefield (cMinefield* pField);
   void                 ComponentStatus (cMinefield* pField);
   void                 EditComponent (cMfComponent* pComp);
   void                 ShowEditor (EEditor eEditType);
   void                 FieldControl (cMinefield* pField);
   void                 ProcessFireButMsg(cMinefield* pMinefield, EBoolean on);

   void                 SetSelection(EBoolean multiSelect, cMinefield* pMf = NULL,
                                  cMfComponent* pComp = NULL, cMfieldObj* pObj = NULL );
   void									DeleteSelection(cMinefield* pMf = NULL,
                                  cMfComponent* pComp = NULL, cMfieldObj* pObj = NULL);
   void                 NewMine (cMineComp* pComp, TLocation& tccPt);
   void                 NewMines (cMineComp* pComp, TLocation* tccPts, int nMines);
   void                 DialogMessage (EDialog eDialogType, 
                                       XtCallbackProc cb_proc,
                                       char *msg);

   cEditorWindow*       GetCurEditor () {return fpCurrentEditor;};
   cMinefield*          GetCurMinefield();
   cMfComponent*        GetCurComponent();
   cMfieldObj*          GetCurMfObject();

   void                 UpdateScrollbars();
   void                 DisableUser();
   void                 EnableUser();

                        cGuiWindow();
   virtual             ~cGuiWindow ();
};
#endif
