/*
$RCSfile: GridEditorCB.cc,v $
$Revision: 1.1.1.1 $
$Author: jchappel $
$Date: 1999/02/16 14:54:35 $
$Log: GridEditorCB.cc,v $
Revision 1.1.1.1  1999/02/16 14:54:35  jchappel
Comprehensive Mine Simulator

// Revision 2.0  1998/01/26  21:01:35  ksnively
// Baseline CMS before additions for AP mine replacements.
//
// Revision 2.0  1998/01/26  21:01:35  ksnively
// Baseline CMS before additions for AP mine replacements.
//
// Revision 1.2  1997/12/17  14:38:03  ksnively
// Debugged Minefield duplication routine.
// Added input file "netparams" for reading PDU type enumerations.
// Got rid of warning messages during compilation.
//
// Revision 1.1  1997/12/16  13:59:57  ksnively
// Initial revision
//
// Revision 1.3  1997/10/02  17:53:37  austin
// first working port to modsaf3.0
//
// Revision 1.2  1997/10/02  17:50:22  austin
// first working port to modsaf3.0
//
// Revision 1.2  1997/10/02  17:50:22  austin
// first working port to modsaf3.0
//
// Revision 1.1  1996/10/23  13:54:40  nsipes
// Initial revision
//
// Revision 1.1  1996/10/23  13:54:40  nsipes
// Initial revision
//
// Revision 1.4  1996/05/14  16:15:08  rcarp
// refinements and bug fixes for 1.5 delivery
//
// Revision 1.3  1996/04/04  16:25:34  mkappel
// Improve performance with large mine sets.
//
// Revision 1.2  1996/03/23  14:22:31  rcarp
// improvements to test mode and selection
//
$State: Exp $
*/
 
/*******************************************

   file: GridEditorCB.cc
   
      Copyright 1995 by the Institute for Defense Analyses
      
         Institute for Defense Analyses
         1801 N. Beauregard Street
         Alexandria, Virginia 22311-1772
         703-845-2000
         
      This software was developed by IDA under U. S. Government
      contract.  For distribution information contact:
      
         U. S. Army Night Vision Directorate
         AMSEL RD NV OD CD
         10221 Burbeck Road, suite 430
         Ft. Belvoir VA 22060-5806
      
*********************************************/

/*******************************************

   GridEditorCB.cc
   
      The display interface implementation.
      
      
   
   Created by Michael Kappel
   Modification history:
      created   
      
*********************************************/

#include "Display.h"
#include "EntityDB.h"
#include "Message.h"

#include <Xm/List.h>
#include <Xm/Text.h>

void cGridEditorWindow::ShowEdWindow ()
{
   char        str[20];

   cMineCompEditorWindow::ShowEdWindow();

   sprintf (str, "%.2f", ((cGridComp*)gpGuiWin->GetCurComponent())->GetSpacing());
   XtVaSetValues (fwSpacingText,
		  XmNvalue, str,
		  NULL);

   // make a copy in case cancel
/*
   if (((cMineComp*)gpCurComponent)->GetNumMines() > 0)
     fpCompCopy = new cGridComp ((cGridComp*)gpCurComponent, 
				 gpCurComponent->GetMinefield(),
				 false);
   else
     fpCompCopy = NULL;
*/
}

void  cGridEditorWindow::MapClick (TLocation& /*loc*/)
{
}

void cGridEditorWindow::CbSpacing (Widget /*w*/, XtPointer pObj, 
				  XmAnyCallbackStruct */*cbs*/)
{
  cGridEditorWindow*   pWindow = (cGridEditorWindow*)pObj;
  float                spacing;
  char                 msg[200];

  sscanf ((char*)XmTextGetString (pWindow->fwSpacingText), "%f", &spacing);

  if (spacing > 0.) {
    fNmines = gpGuiWin->GetCurComponent()->GetMinefield()->GridMineCount (spacing);
    if (fNmines > kMaxMinesInField) {
      sprintf (msg, "A grid spacing of %.2f meters might\ngenerate more than %d mines.\nPlease increase the Spacing to\nreduce the number of mines.", 
	       spacing, kMaxMinesInField);

      gpGuiWin->DialogMessage (cGuiWindow::eDialogError, NULL, msg);
    }
    else if (fNmines > 100) {
      sprintf (msg, "A grid spacing of %.2f meters\nwill generate about %d mines.\nAre you sure that you want\nto create that many?", 
	       spacing, fNmines);

      gpGuiWin->DialogMessage (cGuiWindow::eDialogWarning, 
			       (XtCallbackProc)CbSpacingOK, msg);
    }
    else {
      ((cGridComp*)(gpGuiWin->GetCurComponent()))->SetSpacing (spacing, fNmines);
      pWindow->SetButtonState();
    }
  }
}

void cGridEditorWindow::CbSpacingOK (Widget w, XtPointer  pObj,
				     XmAnyCallbackStruct */*cbs*/)
{
  cGridEditorWindow*   pWindow = (cGridEditorWindow*)pObj;
  float                spacing;

  sscanf ((char*)XmTextGetString (pWindow->fwSpacingText), "%f", &spacing);
  ((cGridComp*)(gpGuiWin->GetCurComponent()))->SetSpacing (spacing, fNmines);
  pWindow->SetButtonState();
  XtDestroyWidget (w);
}
