/*
$RCSfile: MapGeometry.h,v $
$Revision: 1.1.1.1 $
$Author: jchappel $
$Date: 1999/02/16 14:54:51 $
$Log: MapGeometry.h,v $
Revision 1.1.1.1  1999/02/16 14:54:51  jchappel
Comprehensive Mine Simulator

 * Revision 2.1  1998/11/25  18:39:13  ksnively
 * Update for APLA Exercise
 *
 * Revision 2.0  1998/01/26  21:04:20  ksnively
 * Baseline CMS before additions for AP mine replacements.
 *
 * Revision 1.1  1997/12/16  13:59:57  ksnively
 * Initial revision
 *
 * Revision 1.4  1997/10/27  17:07:30  trang
 * BUILD1
 *
 * Revision 1.3  1997/10/02  17:47:47  austin
 * first working port to modsaf3.0
 *
Revision 1.3  1997/10/02 17:47:47  austin
first working port to modsaf3.0

 * Revision 1.2  1997/09/16  23:26:08  austin
 * last version without libworld
 *
 * Revision 1.1  1996/10/23  13:54:40  nsipes
 * Initial revision
 *
 * Revision 1.5  1996/08/09  14:33:27  rcarp
 * changed to support los check by terrain manager, and its use by offroute mines
 *
 * Revision 1.4  1996/07/03  22:55:15  rcarp
 * enhancements and bug fixes for version 1.5b9
 *
 * Revision 1.3  1996/06/22  13:04:11  rcarp
 * deton vuln bug fixes for 1.5b4
 *
 * Revision 1.2  1996/02/16  20:08:40  rcarp
 * revisions associated with 1.1b7
 *
 * Revision 1.2  1996/02/16  20:08:40  rcarp
 * revisions associated with 1.1b7
 *
$State: Exp $
*/
 
/*******************************************

   file: MapGeometry.h
   
      Copyright 1995 by the Institute for Defense Analyses
      
         Institute for Defense Analyses
         1801 N. Beauregard Street
         Alexandria, Virginia 22311-1772
         703-845-2000
         
      This software was developed by IDA under U. S. Government
      contract.  For distribution information contact:
      
         U. S. Army Night Vision Directorate
         AMSEL RD NV OD CD
         10221 Burbeck Road, suite 430
         Ft. Belvoir VA 22060-5806
      
*********************************************/

/*******************************************

   MapGeometry.h
   
      Terrain and coordinate transformation
   
   Created by Richard Carpenter
   Modification history:
      created   
      
*********************************************/


#ifndef _UMapGeometry_
#define _UMapGeometry_

#include "Globals.h"

#include "libctdb.h"
#include "libcoordinates.h"
#include "libworld.h"
#include "main.h"
class cTerrain {

   CTDB                 fCtdb;
   COORD_TCC_PTR        fpTcc;

public:
   CTDB *            GetCtdbAddr() { return &fCtdb; }
   COORD_TCC_PTR     GetTcc()      { return fpTcc; }

   double         GetMapElev( const double mapX, const double mapY );
   double         GetIntervis( const TLocation& loc1, double height1,
                               const TLocation& loc2, double height2,
                               double minvis = 0.1, double treeOpac = 0.5 );
   void           GetMapRotationGeoPt( TRotation* pRot, const TLocation& geoLoc );
   void           GetMapRotationMapPt( TRotation* pRot, const TLocation& mapLoc );
   
   void           MapToSimLoc( const TLocation& mapLoc, TLocation* pSimLoc );
   void           SimToMapLoc( const TLocation& simLoc, TLocation* pMapLoc );
   void           SimToMapLoc( const TLocation& simLoc, double* pMapx, double* pMapy, double* pMapz );

   int            MapToUtmLoc( const TLocation& mapLoc, int* pZone, double* pNorth, double* pEast, double* pZ );
   int            GeoToUtmLoc( const TLocation& geoLoc, int* pZone, double* pNorth, double* pEast, double* pZ );
   
   EBoolean       InTccArea( TLocation& loc );

   cTerrain( char* dirName, char* terrainName, EBoolean* success );
   ~cTerrain();
};

#endif
