/*
$RCSfile: Message.h,v $
$Revision: 1.4 $
$Author: ksnively $
$Date: 1999/05/18 19:33:21 $
$Log: Message.h,v $
Revision 1.4  1999/05/18 19:33:21  ksnively
Ported CMS to compile under IRIX 6.5
Altered make files to allow cms to be compiled under various OS simulataneously
Removed the Startup GUI

Revision 1.3  1999/04/29 19:34:15  ksnively
Incorporated ARDEC addtions:  Tripwire AP mines and a Control Window.

Revision 1.2  1999/03/26 21:17:39  ksnively

Added radio communication capability for Command Detonated Mines.  Included sending
and receiving transmitter and signal PDUs.  All signals have the option of being
processed by the Communication Effects Federate.

Revision 1.1.1.1  1999/02/16 14:54:51  jchappel
Comprehensive Mine Simulator

 * Revision 2.2  1998/11/25  18:39:13  ksnively
 * Update for APLA Exercise
 *
 * Revision 2.1  1998/02/18  17:17:24  ksnively
 * Incorporated AP mine replacement code
 *
 * Revision 2.0  1998/01/26  21:04:20  ksnively
 * Baseline CMS before additions for AP mine replacements.
 *
 * Revision 1.2  1998/01/09  18:29:24  ksnively
 * Integrated latest SAIC release cms3.0b2
 *
 * Revision 1.1  1997/12/16  13:59:57  ksnively
 * Initial revision
 *
 * Revision 1.4  1997/10/27  17:07:30  trang
 * BUILD1
 *
 * Revision 1.3  1997/10/02  17:47:47  austin
 * first working port to modsaf3.0
 *
Revision 1.3  1997/10/02 17:47:47  austin
first working port to modsaf3.0

 * Revision 1.2  1997/03/20  19:16:16  ksnively
 * Added emission tracking, updated to CMS2.0B6.
 *
 * Revision 1.2  1997/03/20  19:16:16  ksnively
 * Added emission tracking, updated to CMS2.0B6.
 *
 * Revision 1.1  1996/10/23  13:54:40  nsipes
 * Initial revision
 *
 * Revision 1.6  1996/08/20  13:44:41  mkappel
 * Add Detonation Display.
 *
 * Revision 1.5  1996/07/03  22:55:15  rcarp
 * enhancements and bug fixes for version 1.5b9
 *
 * Revision 1.4  1996/05/21  22:12:12  rcarp
 * text and lists from mine db, and activating mine state save cmd
 *
 * Revision 1.3  1996/05/08  00:45:10  rcarp
 * changes for 1.5, incl user mines, mine params, param i/o, selection
 *
 * Revision 1.3  1996/05/08  00:45:10  rcarp
 * changes for 1.5, incl user mines, mine params, param i/o, selection
 *
 * Revision 1.2  1996/03/23  14:22:31  rcarp
 * improvements to test mode and selection
 *
$State: Exp $
*/
 
/*******************************************

   file: Message.h
   
      Copyright 1995 by the Institute for Defense Analyses
      
         Institute for Defense Analyses
         1801 N. Beauregard Street
         Alexandria, Virginia 22311-1772
         703-845-2000
         
      This software was developed by IDA under U. S. Government
      contract.  For distribution information contact:
      
         U. S. Army Night Vision Directorate
         AMSEL RD NV OD CD
         10221 Burbeck Road, suite 430
         Ft. Belvoir VA 22060-5806
      
*********************************************/

/*******************************************

   Message.h
   
      The message header file defines the classes
      of messages between GUI and Simulator.
      
      
   
   Created by Michael Kappel
   Modification history:
      created   
      
*********************************************/

#ifndef __UMessage__
#define __UMessage__

#include "Globals.h"

// ************************************
//   messages
// ************************************
class cMineComp;
class cMinefield;
class cMine;
class cSimMine;
class cMineExplosion;
class cDetonationDisp;
class cMfComponent;
class TDetonationData;
class cGridComp;
class cIndivComp;
class cRowComp;
class cDbMine;
class cOutFileObj;

class cRemoveExplosionMsg : public cMsgLowRateUpdt {

protected:
   cMineExplosion*  fpExplosion;
   
public:
      void        SendMsg();

               cRemoveExplosionMsg(cMineExplosion* pExplosion, TTimeSim wait);
   virtual    ~cRemoveExplosionMsg(); 
};

class cRemoveDetonationMsg : public cMsgLowRateUpdt {

protected:
   cDetonationDisp*  fpDisplay;
   
public:
      void        SendMsg();

               cRemoveDetonationMsg(cDetonationDisp*  pDisplay, TTimeSim wait);
   virtual    ~cRemoveDetonationMsg(); 
};

class cCheckVehDamageMsg : public cMsgLowRateUpdt {

protected:
   cSimMine*         fpMine;
   cVehicle*         fpVehicle;
   
public:
      void        SendMsg();

               cCheckVehDamageMsg(cSimMine* pMine, TTimeSim wait, cVehicle* pVeh = NULL);
   virtual    ~cCheckVehDamageMsg(); 
};

class cSendMfStateMsg : public cMsgLowRateUpdt {

protected:
   cMinefield*         fpMinefield;
   
public:
      void        SendMsg();

               cSendMfStateMsg(cMinefield* pMinefield, TTimeSim wait);
   virtual    ~cSendMfStateMsg(); 
};

class cMineDetonationMsg : public cMsgPrEvent {

protected:
   TDetonationData&      fpDetData;
   float          fBlastSize;
   TTimeSim       fDelay;         // to erase the display
   EBoolean       fbDrawExp;
   
public:
      void        SendMsg();

               cMineDetonationMsg(TDetonationData& detData,  
                           float blastSize = 5.0, TTimeSim delay = 3000, EBoolean bDrawExp = true);
   virtual    ~cMineDetonationMsg(); 
};

class cUpdateComponentMsg : public cMsgUpdt {

protected:
   cMfComponent*     fpComponent;
   
public:
      void        SendMsg();

               cUpdateComponentMsg(cMfComponent* pComponent) { fpComponent = pComponent; }
   virtual    ~cUpdateComponentMsg(); 
};

class cUpdateMineMsg : public cMsgUpdt {

protected:
   cSimMine*     fpMine;
   
public:
      void        SendMsg();

               cUpdateMineMsg(cSimMine* pMine) { fpMine = pMine; }
   virtual    ~cUpdateMineMsg(); 
};

class cUpdateMinePrMsg : public cMsgPrUpdt {

protected:
   cSimMine*     fpMine;
   
public:
      void        SendMsg();

               cUpdateMinePrMsg(TTimeSim wait, cSimMine* pMine) :
                  cMsgPrUpdt(wait)      { fpMine = pMine; }
   virtual    ~cUpdateMinePrMsg(); 
};

class cCreateMinefieldMsg : public cMsgLowPrEvent {

protected:
   
public:
   void        SendMsg();

   virtual    ~cCreateMinefieldMsg(); 
};

class cCreateCompMsg : public cMsgLowPrEvent {

protected:
   cMinefield*       fpMfield;
   ECompType         feCompType;
   EBoolean          feSetCurrent;
   
public:
   void        SendMsg();

               cCreateCompMsg(cMinefield* pMfield, ECompType eCompType, EBoolean eSetCur = false) 
                            {fpMfield = pMfield; feCompType = eCompType; feSetCurrent = eSetCur;}
   virtual    ~cCreateCompMsg(); 
};

class cReadMineFileMsg : public cMsgLowPrEvent {
      // the minefield manager reads an input file
protected:
   cInFileObj*    fpMineFile;
   EBoolean       fbSim;   //used for simultaing minefields from command line
   
   
public:
   void        SendMsg();

               cReadMineFileMsg(cInFileObj* pMineFile, EBoolean sim = false) {fpMineFile = pMineFile; fbSim = sim; }
   virtual    ~cReadMineFileMsg(); 
};

class cSimulateMinefieldMsg : public cMsgEvent {
      // a minefield reads its data and components
protected:
   cMinefield*   fpField;
   
public:
   void        SendMsg();

               cSimulateMinefieldMsg(cMinefield* pField) {fpField = pField;}
   virtual    ~cSimulateMinefieldMsg(); 
};

class cOnOffMinefieldMsg : public cMsgEvent {
      // a minefield reads its data and components
protected:
   cMinefield*   fpField;
   EBoolean      fOn;
   
public:
   void        SendMsg();

               cOnOffMinefieldMsg(cMinefield* pField, EBoolean on)
		 {fpField = pField;
		  fOn = on;}
   virtual    ~cOnOffMinefieldMsg(); 
};

class cReadMinefieldMsg : public cMsgLowPrEvent {
      // a minefield reads its data and components
protected:
   cMinefield*   fpField;
   cInFileObj*   fpMineFile;
   
public:
   void        SendMsg();

               cReadMinefieldMsg(cMinefield* pField, cInFileObj* pMineFile);
   virtual    ~cReadMinefieldMsg(); 
};

class cReadGridMsg : public cMsgLowPrEvent {
       
protected:
   cInFileObj*   fpMineFile;
   cGridComp*    fpGrid;
   
public:
   void        SendMsg();

               cReadGridMsg(cGridComp* pGrid, cInFileObj* pMineFile);
   virtual    ~cReadGridMsg(); 
};

class cReadIndivMsg : public cMsgLowPrEvent {
       
protected:
   cInFileObj*   fpMineFile;
   cIndivComp*   fpIndiv;
   
public:
   void        SendMsg();

               cReadIndivMsg(cIndivComp* pIndiv, cInFileObj* pMineFile);
   virtual    ~cReadIndivMsg(); 
};

class cReadRowMsg : public cMsgLowPrEvent {
       
protected:
   cInFileObj*   fpMineFile;
   cRowComp*     fpRow;
   
public:
   void        SendMsg();

               cReadRowMsg(cRowComp* pRow, cInFileObj* pMineFile);
   virtual    ~cReadRowMsg(); 
};

class cUpdateTactmapMsg : public cMsgDispUpdt {

protected:
   cGuiWindow*     fpGuiWin;
   
public:
      void        SendMsg();

               cUpdateTactmapMsg(cGuiWindow* pWin);
   virtual    ~cUpdateTactmapMsg();
};


//added to speed deton processing
class cUpdateMfCompStatusMsg : public cMsgDispUpdt { 

protected:
   cMineComp*     fpMineComp;
   
public:
      void        SendMsg();

               cUpdateMfCompStatusMsg(cMineComp* pComp);
   virtual    ~cUpdateMfCompStatusMsg();
};

//added to speed deton processing
class cSetMineSummMsg : public cMsgDispUpdt {

protected:
   cMinefield*     fpMinefield;
   
public:
      void        SendMsg();

               cSetMineSummMsg(cMinefield* pMfield);
   virtual    ~cSetMineSummMsg();
};

class cEditMinefieldMsg : public cMsgLowPrEvent {

protected:
   
public:
      void        SendMsg();

               cEditMinefieldMsg() {}
   virtual    ~cEditMinefieldMsg();
};

class cComponentStatusMsg : public cMsgLowPrEvent {

protected:
   cMinefield*     fpField;
   
public:
      void        SendMsg();

               cComponentStatusMsg(cMinefield* pField)   {fpField = pField;}
   virtual    ~cComponentStatusMsg();
};

class cFieldControlMsg : public cMsgEvent {

protected:
   cMinefield*     fpField;
   
public:
      void        SendMsg();

               cFieldControlMsg(cMinefield* pField)   {fpField = pField;}
   virtual    ~cFieldControlMsg();
};

class cEditCompMsg : public cMsgLowPrEvent {

protected:
   cMfComponent*     fpComp;
   
public:
      void        SendMsg();

               cEditCompMsg(cMfComponent* pComp)   {fpComp = pComp;}
   virtual    ~cEditCompMsg();
};

class cSaveMinefieldMsg : public cMsgLowPrEvent {
   
public:
      void        SendMsg();

   virtual    ~cSaveMinefieldMsg();
};

class cSaveCompMsg : public cMsgLowPrEvent {

protected:
   cOutFileObj*      fpOutfile;
   cMinefield*       fpMinefield;
   
public:
      void        SendMsg();

               cSaveCompMsg(cMinefield* pField, cOutFileObj* pFile)   
                           {fpMinefield = pField; fpOutfile = pFile;}
   virtual    ~cSaveCompMsg();
};

class cLoadMinefieldsMsg : public cMsgLowPrEvent {

protected:
   char*           fFilename;
   int             fCount;
   cMinefield**    fppMfList;
   
public:
      void        SendMsg();

               cLoadMinefieldsMsg (char* filename)
		 {fFilename = cppstrdup (filename);}
   virtual    ~cLoadMinefieldsMsg();
};

class cDuplicateMinefieldMsg : public cMsgLowPrEvent {

protected:
   
public:
      void     SendMsg();

   virtual    ~cDuplicateMinefieldMsg();
};

class cDeleteMinefieldMsg : public cMsgLowPrEvent {

protected:
   
public:
      void        SendMsg();

   virtual    ~cDeleteMinefieldMsg();
};

class cSaveMfStateMsg : public cMsgLowPrEvent {

protected:
   
public:
      void        SendMsg();

   virtual    ~cSaveMfStateMsg();
};

class cSimulateComponentMsg : public cMsgEvent {

protected:
   cMineComp*    fpComp;
   EBoolean      fSim;
   
public:
   void        SendMsg();

               cSimulateComponentMsg (cMineComp* pComp, EBoolean sim)
		 {fpComp = pComp;  fSim = sim;}
   virtual    ~cSimulateComponentMsg(); 
};

class cOnOffComponentMsg : public cMsgEvent {

protected:
   cMineComp*    fpComp;
   EBoolean      fOn;
   
public:
   void        SendMsg();

               cOnOffComponentMsg (cMineComp* pComp, EBoolean on)
                                 {fpComp = pComp;  fOn = on;}
   virtual    ~cOnOffComponentMsg(); 
};

class cDeleteComponentMsg : public cMsgLowPrEvent {

protected:
   
public:
      void        SendMsg();

   virtual    ~cDeleteComponentMsg();
};

class cDuplicateComponentMsg : public cMsgLowPrEvent {

protected:
   
public:
      void        SendMsg();

   virtual    ~cDuplicateComponentMsg();
};

class cMoveMinefieldMsg : public cMsgLowPrEvent {

protected:
   
public:
      void        SendMsg();

   virtual    ~cMoveMinefieldMsg();
};

class cOnOffMineMsg : public cMsgEvent {

protected:
   cMine*        fpMine;
   EBoolean      fOn;
   
public:
   void        SendMsg();

               cOnOffMineMsg (cMine* pMine, EBoolean on)
		 {fpMine = pMine;  fOn = on;}
   virtual    ~cOnOffMineMsg(); 
};

class cSimulateMineMsg : public cMsgEvent {

protected:
   cMine*        fpMine;
   EBoolean      fSim;
   
public:
   void        SendMsg();

               cSimulateMineMsg (cMine* pMine, EBoolean sim)
		 {fpMine = pMine;  fSim = sim;}
   virtual    ~cSimulateMineMsg(); 
};

class cSetMineTypeMsg : public cMsgEvent {

protected:
   cMineComp*    fpMineComp;
   cDbMine*      fpDbMine;
   
public:
   void        SendMsg();

               cSetMineTypeMsg (cMineComp* pMineComp, cDbMine* pDbMine)
		 {fpMineComp = pMineComp;  fpDbMine = pDbMine;}
   virtual    ~cSetMineTypeMsg(); 
};

class cSetMineDepthMsg : public cMsgEvent {

protected:
   cMineComp*    fpMineComp;
   float         fDepth;
   
public:
   void        SendMsg();

               cSetMineDepthMsg (cMineComp* pMineComp, float depth)
		 {fpMineComp = pMineComp;  fDepth = depth;}
   virtual    ~cSetMineDepthMsg(); 
};

class cSetMineSpacingMsg : public cMsgEvent {

protected:
   cMineComp*    fpMineComp;
   float         fSpacing;
   
public:
   void        SendMsg();

               cSetMineSpacingMsg (cMineComp* pMineComp, float spacing)
		 {fpMineComp = pMineComp;  fSpacing = spacing;}
   virtual    ~cSetMineSpacingMsg(); 
};

class cDeleteMineMsg : public cMsgLowPrEvent {

protected:
   
public:
      void        SendMsg();

   virtual    ~cDeleteMineMsg();
};

// these two messages are between the minefield operator and the
// command detonated mine, each is subject to communication delays
class cFireButtonActivateMsg : public cMsgPrUpdt {

protected:
   cMinefield*     fpMinefield;
   EBoolean        fbOn;
   
public:
      void        SendMsg();

               cFireButtonActivateMsg(TTimeSim delay, EBoolean on, cMinefield*  pMinefield ) :
                  cMsgPrUpdt(delay)      { fbOn = on; fpMinefield = pMinefield; }
   virtual    ~cFireButtonActivateMsg(); 
};

class cFireMunitionMsg : public cMsgPrUpdt {

protected:
   cMinefield*   fpMinefield;
   
public:
      void        SendMsg();

               cFireMunitionMsg(TTimeSim delay, cMinefield*  pMinefield ) :
                  cMsgPrUpdt(delay)      {  fpMinefield = pMinefield; }
   virtual    ~cFireMunitionMsg(); 
};

#endif
