/*
$RCSfile: MineEditorCreate.cc,v $
$Revision: 1.1.1.1 $
$Author: jchappel $
$Date: 1999/02/16 14:54:39 $
$Log: MineEditorCreate.cc,v $
Revision 1.1.1.1  1999/02/16 14:54:39  jchappel
Comprehensive Mine Simulator

// Revision 2.0  1998/01/26  21:01:35  ksnively
// Baseline CMS before additions for AP mine replacements.
//
// Revision 2.0  1998/01/26  21:01:35  ksnively
// Baseline CMS before additions for AP mine replacements.
//
// Revision 1.1  1997/12/16  13:59:57  ksnively
// Initial revision
//
// Revision 1.3  1997/10/02  17:53:37  austin
// first working port to modsaf3.0
//
// Revision 1.2  1997/10/02  17:50:22  austin
// first working port to modsaf3.0
//
// Revision 1.2  1997/10/02  17:50:22  austin
// first working port to modsaf3.0
//
// Revision 1.1  1996/10/23  13:54:40  nsipes
// Initial revision
//
// Revision 1.1  1996/10/23  13:54:40  nsipes
// Initial revision
//
// Revision 1.5  1996/05/14  16:15:08  rcarp
// refinements and bug fixes for 1.5 delivery
//
// Revision 1.4  1996/05/11  21:35:41  mkappel
// Add mine age.
//
// Revision 1.3  1996/04/04  22:16:03  mkappel
// Label minefield on PVD.
//
// Revision 1.2  1996/03/06  19:47:29  mkappel
// Let parent class do destroy.
//
// Revision 1.1  1996/01/23  16:52:30  rcarp
// Initial revision
//
$State: Exp $
*/
 
/*******************************************

   file: MineEditorCreate.cc
   
      Copyright 1995 by the Institute for Defense Analyses
      
         Institute for Defense Analyses
         1801 N. Beauregard Street
         Alexandria, Virginia 22311-1772
         703-845-2000
         
      This software was developed by IDA under U. S. Government
      contract.  For distribution information contact:
      
         U. S. Army Night Vision Directorate
         AMSEL RD NV OD CD
         10221 Burbeck Road, suite 430
         Ft. Belvoir VA 22060-5806
      
*********************************************/

/*******************************************

   MineEditorCreate.cc
   
      The display interface implementation.
      
      
   
   Created by Michael Kappel
   Modification history:
      created   
      
*********************************************/

#include "Display.h"
#include <Xm/ArrowBG.h>
#include <Xm/CascadeBG.h>
#include <Xm/Form.h>
#include <Xm/Frame.h>
#include <Xm/Label.h>
#include <Xm/LabelG.h>
#include <Xm/List.h>
#include <Xm/MainW.h>
#include <Xm/MenuShell.h>
#include <Xm/PanedW.h>
#include <Xm/PushB.h>
#include <Xm/PushBG.h>
#include <Xm/RowColumn.h>
#include <Xm/ScrollBar.h>
#include <Xm/ScrolledW.h>
#include <Xm/Text.h>
#include <Xm/TextF.h>
#include <Xm/ToggleB.h>
#include <stdio.h>

Widget  cMinefieldEditorWindow::fwEditComp;
Widget  cMinefieldEditorWindow::fwCreateIndiv;
Widget  cMinefieldEditorWindow::fwCreateGrid;
Widget  cMinefieldEditorWindow::fwCreateRow;
Widget  cMinefieldEditorWindow::fwDuplicateComp;
Widget  cMinefieldEditorWindow::fwDeleteComp;
Widget  cMinefieldEditorWindow::fwMoveMf;
Widget  cMinefieldEditorWindow::fwCompScrollArea;
Widget  cMinefieldEditorWindow::fwCompScrollBar;
Widget  cMinefieldEditorWindow::fwDoneButton;

void   cCompSummLine::SwitchHilite()
{
   Pixel   backColor, foreColor;
   
   XtVaGetValues( fwTypeText,
                  XmNbackground, &backColor,
                  XmNforeground, &foreColor, 
                  NULL);
                  
   XtVaSetValues( fwTypeText,
                  XmNbackground, foreColor,
                  XmNforeground, backColor, 
                  NULL);
}

cCompSummLine::cCompSummLine (cMfComponent* pComp, Widget wParent)
{ 
   fpComp = pComp;
   
   fwMainWin = 
     XtVaCreateWidget ("compSumm", 
		       xmFormWidgetClass, wParent, 
		       XmNfractionBase, 80,
		       XmNleftAttachment, XmATTACH_POSITION,
		       XmNleftPosition, 20,
		       XmNrightAttachment, XmATTACH_POSITION,
		       XmNrightPosition, 100,
		       XmNalignment, XmALIGNMENT_BEGINNING,
		       NULL);

   if (pComp->GetPrevComp())
     XtVaSetValues (fwMainWin,
		    XmNtopAttachment, XmATTACH_WIDGET,
		    XmNtopWidget, pComp->GetPrevComp()->GetCompEntry()->GetMainWin(),
		    NULL);
   else
     XtVaSetValues (fwMainWin,
		    XmNtopAttachment, XmATTACH_FORM,
 		    NULL);

   if (pComp->GetNext() && pComp->GetNext()->GetCompEntry())
     XtVaSetValues (pComp->GetNext()->GetCompEntry()->GetMainWin(),
		    XmNtopAttachment, XmATTACH_WIDGET,
		    XmNtopWidget, fwMainWin,
		    NULL);
}

cPerimSummLine::cPerimSummLine (cPerimeter* pComp, Widget wParent) :
   cCompSummLine(pComp, wParent)
{
   XmString   xmsText;
   Dimension  height;
   
      // component type name
   xmsText = XmStringCreate("perimeter", XmFONTLIST_DEFAULT_TAG);
   fwTypeText = 
     XtVaCreateManagedWidget ("compTypeName", 
			      xmPushButtonWidgetClass, fwMainWin, 
			      XmNlabelString, xmsText,
			      XmNshadowThickness, 0,
			      XmNborderWidth, 0,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 1,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 10,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      NULL);
   XmStringFree(xmsText);
   XtAddCallback( fwTypeText, XmNactivateCallback, 
       (XtCallbackProc)CbSelect, (XtPointer)this);
   
   xmsText = XmStringCreateSimple("0");
   fwNumMines = 
     XtVaCreateManagedWidget ("label", 
			      xmLabelWidgetClass, fwMainWin, 
			      XmNlabelString, xmsText,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 19,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 24,
			      XmNalignment, XmALIGNMENT_END,
			      NULL);
   XmStringFree(xmsText);
   
   XtVaGetValues (fwTypeText,
		  XmNheight, &height,
		  NULL);
   XtVaSetValues (fwMainWin,
		  XmNheight, height,
		  NULL);

   XtManageChild(fwMainWin);
}

cPerimSummLine::~cPerimSummLine ()
{
}

cMineCompSummLine::cMineCompSummLine (cMineComp* pComp, Widget wParent) :
				      cCompSummLine(pComp, wParent)
{
   XmString   xmsText;
   Dimension  height;
   
      // component type name
   switch (pComp->GetCompType()) {
   case eCompIndiv:
     xmsText = XmStringCreate("individual", XmFONTLIST_DEFAULT_TAG);
     break;

   case eCompGrid:
     xmsText = XmStringCreate("grid", XmFONTLIST_DEFAULT_TAG);
     break;

   case eCompRow:
     xmsText = XmStringCreate("row", XmFONTLIST_DEFAULT_TAG);
     break;
   }

   fwTypeText = 
     XtVaCreateManagedWidget ("compTypeName", 
			      xmPushButtonWidgetClass, fwMainWin, 
			      XmNlabelString, xmsText,
			      XmNshadowThickness, 0,
			      XmNborderWidth, 0,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 1,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 10,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      NULL);
   XmStringFree(xmsText);
   XtAddCallback( fwTypeText, XmNactivateCallback, 
       (XtCallbackProc)CbSelect, (XtPointer)this);
   
   fwSimToggle =
     XtVaCreateManagedWidget ("",
			      xmToggleButtonWidgetClass, fwMainWin,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 11,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 14,
			      XmNset, TRUE,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      NULL);
   XtAddCallback( fwSimToggle, XmNvalueChangedCallback, 
       (XtCallbackProc)CbSimToggle, (XtPointer)this);

   fwOnToggle =
     XtVaCreateManagedWidget ("",
			      xmToggleButtonWidgetClass, fwMainWin,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 15,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 18,
			      XmNset, TRUE,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      NULL);
   XtAddCallback( fwOnToggle, XmNvalueChangedCallback, 
       (XtCallbackProc)CbOnToggle, (XtPointer)this);

   xmsText = XmStringCreateSimple("0");
   fwNumMines = 
     XtVaCreateManagedWidget ("label", 
			      xmLabelWidgetClass, fwMainWin, 
			      XmNlabelString, xmsText,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 19,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 24,
			      XmNalignment, XmALIGNMENT_END,
			      NULL);
   XmStringFree(xmsText);
   
   if (pComp->GetCompType() == eCompGrid ||
       pComp->GetCompType() == eCompRow) {
     xmsText = XmStringCreateSimple("0");
     fwMineSpacing = 
       XtVaCreateManagedWidget ("label", 
				xmLabelWidgetClass, fwMainWin, 
				XmNlabelString, xmsText,
				XmNleftAttachment, XmATTACH_POSITION,
				XmNleftPosition, 25,
				XmNrightAttachment, XmATTACH_POSITION,
				XmNrightPosition, 30,
				XmNalignment, XmALIGNMENT_END,
				NULL);
     XmStringFree(xmsText);
   }
   else
     fwMineSpacing = NULL;
   
   xmsText = XmStringCreateSimple("0");
   fwMineDepth = 
     XtVaCreateManagedWidget ("label", 
			      xmLabelWidgetClass, fwMainWin, 
			      XmNlabelString, xmsText,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 31,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 36,
			      XmNalignment, XmALIGNMENT_END,
			      NULL);
   XmStringFree(xmsText);
   
   xmsText = XmStringCreateSimple("0");
   fwMineAge = 
     XtVaCreateManagedWidget ("label", 
			      xmLabelWidgetClass, fwMainWin, 
			      XmNlabelString, xmsText,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 37,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 42,
			      XmNalignment, XmALIGNMENT_END,
			      NULL);
   XmStringFree(xmsText);
   
   xmsText = XmStringCreateSimple("Unknown");
   fwDomain = 
     XtVaCreateManagedWidget ("label", 
			      xmLabelWidgetClass, fwMainWin, 
			      XmNlabelString, xmsText,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 43,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 48,
			      XmNalignment, XmALIGNMENT_CENTER,
			      NULL);
   XmStringFree(xmsText);

   xmsText = XmStringCreateSimple("Type not set");
   fwMineType = 
     XtVaCreateManagedWidget ("label", 
			      xmLabelWidgetClass, fwMainWin, 
			      XmNlabelString, xmsText,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 49,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 64,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      NULL);
   XmStringFree(xmsText);

   XtVaGetValues (fwTypeText,
		  XmNheight, &height,
		  NULL);
   XtVaSetValues (fwMainWin,
		  XmNheight, height,
		  NULL);

   XtManageChild(fwMainWin);
}

cCompSummLine::~cCompSummLine() 
{
  if (fpComp->GetNext()) {
    if (fpComp->GetPrevComp())
      XtVaSetValues (fpComp->GetNext()->GetCompEntry()->GetMainWin(),
		     XmNtopAttachment, XmATTACH_WIDGET,
		     XmNtopWidget, fpComp->GetPrevComp()->GetCompEntry()->GetMainWin(),
		     NULL);
    else
      XtVaSetValues (fpComp->GetNext()->GetCompEntry()->GetMainWin(),
		     XmNtopAttachment, XmATTACH_FORM,
		     NULL);
  }
}

cMineCompSummLine::~cMineCompSummLine ()
{
}

Widget        cMinefieldEditorWindow::CreateMenuBar(Widget wParent)
{
   Widget     wMenuBar, wMenu1, wMenu2, wCascade, wItem;
   Dimension  height, h;
	
   wMenuBar = 
     XmCreateMenuBar(wParent, "menu_bar", NULL, 0);
   XtVaSetValues (wMenuBar,
		  XmNtopAttachment, XmATTACH_FORM,
		  XmNleftAttachment, XmATTACH_FORM,
		  XmNrightAttachment, XmATTACH_FORM,
		  NULL);
   
         // Create menu
   wMenu1 = 
     XmCreatePulldownMenu( wMenuBar, "menu", NULL, 0 );
   wCascade = 
     XtVaCreateManagedWidget( "Create", 
			     xmCascadeButtonGadgetClass, wMenuBar,
			     XmNsubMenuId, wMenu1, 
			     NULL);
   wMenu2 = 
     XmCreatePulldownMenu( wMenu1, "menu", NULL, 0 );
   wCascade = 
     XtVaCreateManagedWidget( "Emplacement", 
			     xmCascadeButtonGadgetClass, wMenu1,
			     XmNsubMenuId, wMenu2, 
			     NULL);

   fwCreateIndiv = 
     XtCreateManagedWidget( "Individual", 
			   xmPushButtonWidgetClass, wMenu2,
			   NULL, 0);
   XtAddCallback( fwCreateIndiv, XmNactivateCallback, 
		 (XtCallbackProc)CbCreate, (XtPointer)eCompIndiv);
   fwCreateGrid = 
     XtCreateManagedWidget( "Grid", 
			   xmPushButtonWidgetClass, wMenu2,
			   NULL, 0);
   XtAddCallback( fwCreateGrid, XmNactivateCallback, 
		 (XtCallbackProc)CbCreate, (XtPointer)eCompGrid);
   fwCreateRow = 
     XtCreateManagedWidget( "Row", 
			   xmPushButtonWidgetClass, wMenu2,
			   NULL, 0);
   XtAddCallback( fwCreateRow, XmNactivateCallback, 
		 (XtCallbackProc)CbCreate, (XtPointer)eCompRow);
   wItem = 
     XtCreateManagedWidget( "Road Watch", 
			   xmPushButtonWidgetClass, wMenu2,
			   NULL, 0);
   XtSetSensitive (wItem, FALSE);
   XtAddCallback( wItem, XmNactivateCallback, 
		 (XtCallbackProc)CbCreate, (XtPointer)this);
   wItem = 
     XtCreateManagedWidget( "Dispenser Pattern", 
			   xmPushButtonWidgetClass, wMenu2,
			   NULL, 0);
   XtSetSensitive (wItem, FALSE);
   XtAddCallback( wItem, XmNactivateCallback, 
		 (XtCallbackProc)CbCreate, (XtPointer)this);

   wMenu2 = 
     XmCreatePulldownMenu( wMenu1, "menu", NULL, 0 );
   wCascade = 
     XtVaCreateManagedWidget( "Fixed Objects", 
			     xmCascadeButtonGadgetClass, wMenu1,
			     XmNsubMenuId, wMenu2, 
			     NULL);
   XtSetSensitive (wCascade, FALSE);
   wItem = 
     XtCreateManagedWidget( "Fence", 
			   xmPushButtonWidgetClass, wMenu2,
			   NULL, 0);
   XtAddCallback( wItem, XmNactivateCallback, 
		 (XtCallbackProc)CbCreate, (XtPointer)this);
   wItem = 
     XtCreateManagedWidget( "Obstacle", 
			   xmPushButtonWidgetClass, wMenu2,
			   NULL, 0);
   XtAddCallback( wItem, XmNactivateCallback, 
		 (XtCallbackProc)CbCreate, (XtPointer)this);
   wItem = 
     XtCreateManagedWidget( "Ditch", 
			   xmPushButtonWidgetClass, wMenu2,
			   NULL, 0);
   XtAddCallback( wItem, XmNactivateCallback, 
		 (XtCallbackProc)CbCreate, (XtPointer)this);

   wItem = 
     XtCreateManagedWidget( "Lane", 
			   xmPushButtonWidgetClass, wMenu1,
			   NULL, 0);
   XtSetSensitive (wItem, FALSE);
   XtAddCallback( wItem, XmNactivateCallback, 
		 (XtCallbackProc)CbCreate, (XtPointer)this);

   wMenu1 = 
     XmCreatePulldownMenu( wMenuBar, "menu", NULL, 0 );
   wCascade = 
     XtVaCreateManagedWidget( "Edit", 
			     xmCascadeButtonGadgetClass, wMenuBar,
			     XmNsubMenuId, wMenu1, 
			     NULL);
   fwEditComp = 
     XtCreateManagedWidget( "Edit Component", 
			   xmPushButtonWidgetClass, wMenu1,
			   NULL, 0);
   XtAddCallback( fwEditComp, XmNactivateCallback, 
		 (XtCallbackProc)CbEditComp, NULL);
   fwDuplicateComp = 
     XtCreateManagedWidget( "Duplicate Component", 
			   xmPushButtonWidgetClass, wMenu1,
			   NULL, 0);
   XtSetSensitive (fwDuplicateComp, FALSE);
   XtAddCallback( fwDuplicateComp, XmNactivateCallback, 
		 (XtCallbackProc)CbDuplicateComp, (XtPointer)this);
   fwDeleteComp = 
     XtCreateManagedWidget( "Delete Component", 
			   xmPushButtonWidgetClass, wMenu1,
			   NULL, 0);
   XtAddCallback( fwDeleteComp, XmNactivateCallback, 
		 (XtCallbackProc)CbDeleteComp, (XtPointer)this);
   fwMoveMf = 
     XtCreateManagedWidget( "Move Minefield", 
			   xmPushButtonWidgetClass, wMenu1,
			   NULL, 0);
   XtAddCallback( fwMoveMf, XmNactivateCallback, 
		 (XtCallbackProc)CbMoveMf, (XtPointer)this);

   wMenu1 = 
     XmCreatePulldownMenu( wMenuBar, "menu", NULL, 0 );
   wCascade = 
     XtVaCreateManagedWidget( "Preferences", 
			     xmCascadeButtonGadgetClass, wMenuBar,
			     XmNsubMenuId, wMenu1, 
			     NULL);
   XtSetSensitive (wCascade, FALSE);
   wMenu2 = 
     XmCreatePulldownMenu( wMenu1, "menu", NULL, 0 );
   wCascade = 
     XtVaCreateManagedWidget( "Coordinates", 
			     xmCascadeButtonGadgetClass, wMenu1,
			     XmNsubMenuId, wMenu2, 
			     NULL);
   wItem = 
     XtCreateManagedWidget( "X/Y (TCC)", 
			   xmPushButtonWidgetClass, wMenu2,
			   NULL, 0);
   XtAddCallback( wItem, XmNactivateCallback, 
		 (XtCallbackProc)CbCreate, (XtPointer)this);
   wItem = 
     XtCreateManagedWidget( "UTM", 
			   xmPushButtonWidgetClass, wMenu2,
			   NULL, 0);
   XtAddCallback( wItem, XmNactivateCallback, 
		 (XtCallbackProc)CbCreate, (XtPointer)this);
   wItem = 
     XtCreateManagedWidget( "Lat/Long", 
			   xmPushButtonWidgetClass, wMenu2,
			   NULL, 0);
   XtAddCallback( wItem, XmNactivateCallback, 
		 (XtCallbackProc)CbCreate, (XtPointer)this);

   wMenu2 = 
     XmCreatePulldownMenu( wMenu1, "menu", NULL, 0 );
   wCascade = 
     XtVaCreateManagedWidget( "Length Units", 
			     xmCascadeButtonGadgetClass, wMenu1,
			     XmNsubMenuId, wMenu2, 
			     NULL);
   wItem = 
     XtCreateManagedWidget( "Meters", 
			   xmPushButtonWidgetClass, wMenu2,
			   NULL, 0);
   XtAddCallback( wItem, XmNactivateCallback, 
		 (XtCallbackProc)CbCreate, (XtPointer)this);
   wItem = 
     XtCreateManagedWidget( "Feet", 
			   xmPushButtonWidgetClass, wMenu2,
			   NULL, 0);
   XtAddCallback( wItem, XmNactivateCallback, 
		 (XtCallbackProc)CbCreate, (XtPointer)this);
   wItem = 
     XtCreateManagedWidget( "Kilometers", 
			   xmPushButtonWidgetClass, wMenu2,
			   NULL, 0);
   XtAddCallback( wItem, XmNactivateCallback, 
		 (XtCallbackProc)CbCreate, (XtPointer)this);

   wMenu2 = 
     XmCreatePulldownMenu( wMenu1, "menu", NULL, 0 );
   wCascade = 
     XtVaCreateManagedWidget( "Density Units", 
			     xmCascadeButtonGadgetClass, wMenu1,
			     XmNsubMenuId, wMenu2, 
			     NULL);
   wItem = 
     XtCreateManagedWidget( "Mines/Front Length", 
			   xmPushButtonWidgetClass, wMenu2,
			   NULL, 0);
   XtAddCallback( wItem, XmNactivateCallback, 
		 (XtCallbackProc)CbCreate, (XtPointer)this);
   wItem = 
     XtCreateManagedWidget( "Mines/Area", 
			   xmPushButtonWidgetClass, wMenu2,
			   NULL, 0);
   XtAddCallback( wItem, XmNactivateCallback, 
		 (XtCallbackProc)CbCreate, (XtPointer)this);

   XtVaGetValues (wMenuBar, XmNmarginHeight, &h, NULL);
   XtVaGetValues (wItem, XmNheight, &height, NULL);
   height =  height + 2 * h ;
   XtVaSetValues (wMenuBar,
		  XmNpaneMinimum, height,
		  XmNpaneMaximum, height,
		  NULL);
   
   XtManageChild( wMenuBar );
   return wMenuBar;
}

Widget        cMinefieldEditorWindow::CreateHeadings (Widget wParent)
{
   Widget     wHeadings, wLabel;
   XmString   xmsText;
   Dimension  height, h;
   
   wHeadings = 
     XtVaCreateWidget ("headings", 
		       xmFormWidgetClass, wParent,
		       XmNfractionBase, 100,
		       NULL);

   xmsText = XmStringCreateSimple("Component");
   wLabel = 
     XtVaCreateManagedWidget ("label", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      XmNtopAttachment, XmATTACH_FORM,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 21,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 30,
			      NULL);
   XmStringFree(xmsText);

   xmsText = XmStringCreateSimple("Sim");
   wLabel = 
     XtVaCreateManagedWidget ("label", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNtopAttachment, XmATTACH_FORM,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 31,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 34,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      NULL);
   XmStringFree(xmsText);

   xmsText = XmStringCreateSimple("On");
   wLabel = 
     XtVaCreateManagedWidget ("label", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNtopAttachment, XmATTACH_FORM,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 35,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 38,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      NULL);
   XmStringFree(xmsText);

   xmsText = XmStringCreateSimple("Number");
   wLabel = 
     XtVaCreateManagedWidget ("label", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNtopAttachment, XmATTACH_FORM,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 39,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 44,
			      XmNalignment, XmALIGNMENT_END,
			      NULL);
   XmStringFree(xmsText);

   xmsText = XmStringCreateSimple("Spacing");
   wLabel = 
     XtVaCreateManagedWidget ("label", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNtopAttachment, XmATTACH_FORM,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 45,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 50,
			      XmNalignment, XmALIGNMENT_CENTER,
			      NULL);
   XmStringFree(xmsText);

   xmsText = XmStringCreateSimple("Depth");
   wLabel = 
     XtVaCreateManagedWidget ("label", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNtopAttachment, XmATTACH_FORM,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 51,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 56,
			      XmNalignment, XmALIGNMENT_CENTER,
			      NULL);
   XmStringFree(xmsText);
   
   xmsText = XmStringCreateSimple("Age");
   wLabel = 
     XtVaCreateManagedWidget ("label", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNtopAttachment, XmATTACH_FORM,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 57,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 62,
			      XmNalignment, XmALIGNMENT_CENTER,
			      NULL);
   XmStringFree(xmsText);

   xmsText = XmStringCreateSimple("Domain");
   wLabel = 
     XtVaCreateManagedWidget ("label", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNtopAttachment, XmATTACH_FORM,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 63,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 68,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      NULL);
   XmStringFree(xmsText);

   xmsText = XmStringCreateSimple("Type");
   wLabel = 
     XtVaCreateManagedWidget ("label", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNtopAttachment, XmATTACH_FORM,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 69,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 84,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      NULL);
   XmStringFree(xmsText);

   XtVaGetValues (wHeadings, XmNmarginHeight, &h, NULL);
   XtVaGetValues (wLabel, XmNheight, &height, NULL);
   height =  height + 2 * h ;
   XtVaSetValues (wHeadings,
		  XmNpaneMinimum, height,
		  XmNpaneMaximum, height,
		  NULL);

   XtManageChild (wHeadings);
   return wHeadings;
}

Widget    cMinefieldEditorWindow::CreateSummaryArea (Widget wParent)
{
   int           width = WidthOfScreen(XtScreen(fwTopLevelShell)) - 100;

   fwCompScrollArea = 
     XtVaCreateManagedWidget ("scrollwin", 
			      xmScrolledWindowWidgetClass, wParent,
			      XmNscrollingPolicy, XmAPPLICATION_DEFINED,
			      XmNwidth, width,
			      XmNheight, 200,
			      NULL);

   fwCompScrollBar = XtVaCreateManagedWidget ("scrollbar",
				  xmScrollBarWidgetClass, fwCompScrollArea,
				  XmNorientation, XmVERTICAL,
				  XmNmaximum, 2,
				  NULL);

   return fwCompScrollArea;
}

cCompListArea*    cMinefieldEditorWindow::CreateCompListArea ()
{
   cCompListArea* pCompArea = new cCompListArea (fwCompScrollArea);
   Widget         wMainWin = pCompArea->GetMainWin();

   XmScrolledWindowSetAreas (fwCompScrollArea, NULL, fwCompScrollBar, wMainWin);
   XtAddCallback (fwCompScrollBar, XmNvalueChangedCallback, 
		  (XtCallbackProc)CbScroll, wMainWin);

   return pCompArea;
}

cCompListArea::cCompListArea (Widget wParent)
{
   Widget        wLabel, wMenu;                 
   XmString      str1;
   int           width = WidthOfScreen(XtScreen(fwTopLevelShell)) - 100;
   Arg           args[2];

   fwMainWin = 
     XtVaCreateWidget ("form", 
		       xmFormWidgetClass, wParent, 
		       XmNwidth, width,
		       XmNheight, 200,
		       NULL);

   wLabel = 
     XtVaCreateManagedWidget ("Minefield Name", 
			      xmLabelGadgetClass, fwMainWin,
			      XmNtopAttachment, XmATTACH_FORM,
			      XmNleftAttachment, XmATTACH_FORM,
			      NULL);
   fwMinefieldName = 
     XtVaCreateManagedWidget ("textbox", 
			      xmTextFieldWidgetClass, fwMainWin,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, wLabel,
			      XmNleftAttachment, XmATTACH_FORM,
			      XmNcolumns, 20,
			      NULL);
   XtAddCallback (fwMinefieldName, XmNlosingFocusCallback, 
		  (XtCallbackProc)CbNameChange, NULL);

   wMenu = XmCreatePulldownMenu (fwMainWin, "_pulldown", NULL, 0);
   str1 = XmStringCreateSimple ("Type");
   XtSetArg (args[0], XmNsubMenuId, wMenu);
   XtSetArg (args[1], XmNlabelString, str1);
   fwTypeMenu = XmCreateOptionMenu (fwMainWin, "menu", args, 2);
   XtVaSetValues (fwTypeMenu,
		  XmNtopAttachment, XmATTACH_WIDGET,
		  XmNtopWidget, fwMinefieldName,
		  XmNleftAttachment, XmATTACH_FORM,
		  XmNsensitive, FALSE,
		  NULL);
   fwHastyOption =
     XtVaCreateManagedWidget ("Hasty", 
			      xmPushButtonGadgetClass, wMenu, 
			      NULL);
   fwDeliberateOption =
     XtVaCreateManagedWidget ("Deliberate", 
			      xmPushButtonGadgetClass, wMenu, 
			      NULL);
   XtManageChild (fwTypeMenu);
   XmStringFree (str1);

   wMenu = XmCreatePulldownMenu (fwMainWin, "_pulldown", NULL, 0);
   str1 = XmStringCreateSimple ("Force");
   XtSetArg (args[0], XmNsubMenuId, wMenu);
   XtSetArg (args[1], XmNlabelString, str1);
   fwForceMenu = XmCreateOptionMenu (fwMainWin, "menu", args, 2);
   XtVaSetValues (fwForceMenu,
		  XmNtopAttachment, XmATTACH_WIDGET,
		  XmNtopWidget, fwTypeMenu,
		  XmNleftAttachment, XmATTACH_FORM,
		  NULL);
   fwFriendlyOption =
     XtVaCreateManagedWidget ("Friendly", 
			      xmPushButtonGadgetClass, wMenu, 
			      NULL);
   fwEnemyOption =
     XtVaCreateManagedWidget ("Enemy", 
			      xmPushButtonGadgetClass, wMenu, 
			      NULL);
   fwOtherOption =
     XtVaCreateManagedWidget ("Other", 
			      xmPushButtonGadgetClass, wMenu, 
			      NULL);
   XtManageChild (fwForceMenu);
   XmStringFree (str1);

//   XtManageChild( fwMainWin );
}

cCompListArea::~cCompListArea ()
{
}

Widget cMinefieldEditorWindow::CreateActionArea (Widget wParent)
{
   Widget     wActionArea, wButton;
   Dimension  height, h;

   wActionArea = 
     XtVaCreateWidget ("action_area", 
		       xmFormWidgetClass, wParent,
		       XmNfractionBase, 100,
		       XmNleftAttachment, XmATTACH_FORM,
		       XmNrightAttachment, XmATTACH_FORM,
		       XmNbottomAttachment, XmATTACH_FORM,
		       NULL);
   fwDoneButton = 
     XtVaCreateManagedWidget ("Done", 
			      xmPushButtonWidgetClass, wActionArea,
			      XmNtopAttachment, XmATTACH_FORM,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 25,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 40,
			      NULL);
   XtAddCallback( fwDoneButton, XmNactivateCallback, 
		 (XtCallbackProc)CbDone, (XtPointer) this);
   wButton = 
     XtVaCreateManagedWidget ("Cancel", 
			      xmPushButtonWidgetClass, wActionArea,
			      XmNtopAttachment, XmATTACH_FORM,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 60,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 75,
			      NULL);
   XtAddCallback( wButton, XmNactivateCallback, 
		 (XtCallbackProc)CbCancel, (XtPointer) this);

   XtVaGetValues (wActionArea, XmNmarginHeight, &h, NULL);
   XtVaGetValues (wButton, XmNheight, &height, NULL);
   height =  height + 2 * h ;
   XtVaSetValues (wActionArea,
		  XmNpaneMinimum, height,
		  XmNpaneMaximum, height,
		  NULL);

   XtManageChild( wActionArea );
   return wActionArea;
}

cMinefieldEditorWindow::cMinefieldEditorWindow (Widget wParent)
   // the constructor creates the window and its widgets,
   // initializing with input values
   //** should we take the menu bar out of the scrolled window?
{
   Widget        wMenuBar, wHeadings, wSummary, wActionArea;

   fwMainWin =
     XtVaCreateWidget ("pane",
             xmPanedWindowWidgetClass, wParent,
             XmNtopAttachment, XmATTACH_FORM,
             XmNbottomAttachment, XmATTACH_FORM,
             NULL);
             
   wMenuBar = CreateMenuBar(fwMainWin);
   wHeadings = CreateHeadings (fwMainWin);
   wSummary = CreateSummaryArea (fwMainWin);
   wActionArea = CreateActionArea (fwMainWin);

   fpMfCopy = NULL;
}

cMinefieldEditorWindow::~cMinefieldEditorWindow()
{
}

