/*
$RCSfile: Minefield.h,v $
$Revision: 1.5 $
$Author: ksnively $
$Date: 1999/05/18 19:33:23 $
$Log: Minefield.h,v $
Revision 1.5  1999/05/18 19:33:23  ksnively
Ported CMS to compile under IRIX 6.5
Altered make files to allow cms to be compiled under various OS simulataneously
Removed the Startup GUI

Revision 1.4  1999/04/29 19:34:19  ksnively
Incorporated ARDEC addtions:  Tripwire AP mines and a Control Window.

Revision 1.3  1999/04/22 22:20:05  ksnively
Sreamlined radio communication routines.  Allowed to send to unlimited number of receivers.

Revision 1.2  1999/03/26 21:17:42  ksnively

Added radio communication capability for Command Detonated Mines.  Included sending
and receiving transmitter and signal PDUs.  All signals have the option of being
processed by the Communication Effects Federate.

Revision 1.1.1.1  1999/02/16 14:54:52  jchappel
Comprehensive Mine Simulator

 * Revision 2.8  1998/12/02  16:43:52  jchappel
 * added gui detonator
 *
 * Revision 2.7  1998/11/25  18:39:13  ksnively
 * Update for APLA Exercise
 *
 * Revision 2.6  1998/10/27  19:32:01  jchappel
 * modifications for versioning
 *
 * Revision 2.5  1998/04/20  15:10:36  ksnively
 * *** empty log message ***
 *
 * Revision 2.4  1998/03/16  19:11:06  jchappel
 * Added icon size sliders
 *
 * Revision 2.3  1998/02/26  21:26:56  ksnively
 * Created Mf Camera object to control MAK Stealth view.
 * Created vulnerability tables specific to command detonated mines
 * and the camera object.
 *
 * Revision 2.2  1998/02/18  20:10:33  ksnively
 * Ap mine replacement bug fixes
 *
 * Revision 2.1  1998/02/18  17:17:24  ksnively
 * Incorporated AP mine replacement code
 *
 * Revision 2.0  1998/01/26  21:04:20  ksnively
 * Baseline CMS before additions for AP mine replacements.
 *
 * Revision 1.2  1998/01/09  18:29:24  ksnively
 * Integrated latest SAIC release cms3.0b2
 *
 * Revision 1.1  1997/12/16  13:59:57  ksnively
 * Initial revision
 *
 * Revision 1.9  1997/10/27  17:07:30  trang
 * BUILD1
 *
 * Revision 1.8  1997/05/20  15:37:57  ksnively
 * *** empty log message ***
 *
Revision 1.8  1997/05/20 15:37:57  ksnively
*** empty log message ***

 * Revision 1.7  1997/05/07  12:33:45  ksnively
 * *** empty log message ***
 *
 * Revision 1.6  1997/03/20  19:16:16  ksnively
 * Added emission tracking, updated to CMS2.0B6.
 *
 * Revision 1.5  1997/02/12  17:04:49  ksnively
 * *** empty log message ***
 *
 * Revision 1.4  1997/01/21  15:09:13  nsipes
 * *** empty log message ***
 *
 * Revision 1.3  1997/01/02  19:48:54  nsipes
 * *** empty log message ***
 *
 * Revision 1.2  1996/11/06  15:13:32  nsipes
 * *** empty log message ***
 *
 * Revision 1.1  1996/10/23  13:54:40  nsipes
 * Initial revision
 *
 * Revision 1.24  1996/09/06  18:57:57  rcarp
 * CP bug fixes
 *
 * Revision 1.23  1996/08/21  21:58:20  rcarp
 * CP and QRP file output, other updates
 *
 * Revision 1.22  1996/08/15  19:15:44  mkappel
 * Change perimeter color when minefield state changes.
 *
 * Revision 1.21  1996/08/08  18:10:09  rcarp
 * gui updates and more CP changes
 *
 * Revision 1.20  1996/08/08  14:42:20  mkappel
 * When mine type is set or changed, redraw display object.
 *
 * Revision 1.19  1996/08/07  14:19:30  rcarp
 * initial revisions for CP protocol
 *
 * Revision 1.18  1996/07/03  22:55:15  rcarp
 * enhancements and bug fixes for version 1.5b9
 *
 * Revision 1.17  1996/06/22  13:04:11  rcarp
 * deton vuln bug fixes for 1.5b4
 *
 * Revision 1.16  1996/06/21  17:04:20  rcarp
 * upgrades for release 1.5b3, mostly mine vuln
 *
 * Revision 1.15  1996/06/19  19:08:07  rcarp
 * revisions for mine vulnerability, version 1.5b2
 *
 * Revision 1.14  1996/05/21  22:15:40  rcarp
 * text and lists from mine db, and activating mine state save cmd
 *
 * Revision 1.13  1996/05/15  17:17:31  rcarp
 * refinements and fixes for 1.5 delivery
 *
 * Revision 1.12  1996/05/14  16:15:08  rcarp
 * refinements and bug fixes for 1.5 delivery
 *
 * Revision 1.10  1996/04/04  22:16:03  mkappel
 * Label minefield on PVD.
 *
 * Revision 1.9  1996/04/04  16:25:34  mkappel
 * Improve performance with large mine sets.
 *
 * Revision 1.8  1996/03/28  22:34:41  mkappel
 * Add Mine Display toggle to component editors.
 *
 * Revision 1.7  1996/03/23  14:25:01  rcarp
 * improvements to test mode and selection
 *
 * Revision 1.6  1996/03/15  16:03:02  mkappel
 * Allow repositioning of minefield when loading (standard minefields).
 *
 * Revision 1.5  1996/03/06  22:18:08  rcarp
 * revisions for mine status window
 *
 * Revision 1.4  1996/02/16  21:41:55  rcarp
 * revisions for getting mine wide area and directional range
 *
 * Revision 1.3  1996/02/05  14:32:43  rcarp
 * Updates and bug fixes of release version 1.1b5
 *
$State: Exp $
*/
 
/*******************************************

   file: Minefield.h
   
      Copyright 1995 by the Institute for Defense Analyses
      
         Institute for Defense Analyses
         1801 N. Beauregard Street
         Alexandria, Virginia 22311-1772
         703-845-2000
         
      This software was developed by IDA under U. S. Government
      contract.  For distribution information contact:
      
         U. S. Army Night Vision Directorate
         AMSEL RD NV OD CD
         10221 Burbeck Road, suite 430
         Ft. Belvoir VA 22060-5806
      
*********************************************/

/*******************************************

   Minefield.h
   
      The minefield header file defines the minefield class,
      and and minefield object classes.
      
      
   
   Created by Richard Carpenter
   Modification history:
      created   
      
*********************************************/

#ifndef _UMinefield_
#define _UMinefield_

#include "Globals.h"
#include "Vehicle.h"
#include "FileObj.h"
#include "EntityDB.h"
#include "Sensor.h"
#include "CmsPdu.h"

#include <Xm/Xm.h>

// ************************************
//   basic types
// ************************************

enum   EMineInternalState { emisNone = 0,
                            emisDetonatedMissed,    //exploded, missed target or no target
                            emisDetonatedHit,       //exploded, hit target
                            emisDetonated,    //exploded, indirect fire
                            emisFailed,       //died or neutralized
                               emisLowestUpdate = emisFailed,   // update and track on failed,
                               emisLowestTracker = emisFailed,  // as we can still plow or move
                            emisMoving,         // being plowed
                            emisOff,
                            emisInhibit,      // special state for tracking with munition off
                               emisLowestControl = emisInhibit,
                            emisOn,
                            emisTracking,      //may be active for side attack
                            emisActivating,      //may be active for side attack
                            emisCloseTracking,   // go to priority queue
                                        
                            emisNumStates };

enum   EMineExternalState   { emsAlive, emsFired, emsOther };

           // sensors use mine state enumerations, in order to display colors
           // from the same pallet
enum   ESensInternalState {
                           esisNone      = emisNone,
                           esisFailed    = emisFailed,
                                 esisLowestUpdate    = esisFailed,
                                 esisLowestTracker   = esisFailed,
                           esisOff       = emisOff,
                           esisOn        = emisOn,
                           esisDetecting = emisTracking,
                           esisTracking  = emisCloseTracking
                           
                           };

enum ERefSet { eNullRef, eTccRef, eMfRef, eMfRef3d, eRefComplete };   // valid coord systems

enum EMfAppearance {
   eMfAppearNone = 0,
   eMfAppearOne
};

enum EMfCmdMode { eCmdModeNone, eCmdModeFire, eCmdModeTripped, 
                  eCmdModeAutoFire, eCmdModeCmdFireAll, eCmdModeTripFireAll }; 

struct EMinefieldType
{
	unsigned ATbit : 1;
	unsigned APbit : 1;
	unsigned _unused_ : 14;
};




class cMine;
struct TLinkMine : public T2link {
      // keeps list of mines
   cMine*     fpMine;
   
   cMine*     GetMine()   { return fpMine; }
   
   TLinkMine(cMine* pMine, T2link* pPrev) : T2link(pPrev) {fpMine = pMine;}
   virtual ~TLinkMine();
};

class cSendCpMinesMsg;
struct T2linkMineList : public T2link {
      // keeps a list of mines of a specific type
   T2linkHead      fMineList;
   TEntityType     fType;
   int             fNumMines;
   
   const TEntityType&     GetType()   { return fType; }
         int              GetNumMines() { return fNumMines; }
         cMine*           GetFirstMine();
         cMine*           GetNextMine();
  
         void             AddMine( cMine* pM );
         void             RemoveMine( cMine* pM );
   
   T2linkMineList(TEntityType type, T2link* prev);
   ~T2linkMineList();
};

struct T2linkMineSetList : public T2linkMineList {
   
         // used in consist protocol for component sublists
   cMineComp*        fpComp;
   unsigned short    fChangeNum;
   TEntityID         fMineSetId;
   cSendCpMinesMsg*  fpCpMinesMsg;      // kept, if heartbeat is used

         
         unsigned short   GetChangeNum() { return fChangeNum; }
         TEntityID&       GetSetId() { return  fMineSetId; }
         cSendCpMinesMsg* GetMsg() { return   fpCpMinesMsg; }
         
         void             MineChange( cMine* );
   
   T2linkMineSetList(TEntityType type, cMineComp* pComp, T2link* prev);
   ~T2linkMineSetList();
};

struct TMineSumm {
      // keeps summary info for minefields and components
   int              fTotalMines;
   int              fLiveMines;
   int              fFiredMines;
   int              fOtherDeadMines;
   int              fVehiclesHit;
   int              fVehiclesKilled;
   
   int              GetDetectable() const  { return fLiveMines + fOtherDeadMines; }
   
   void             Clear() { fTotalMines = fLiveMines = fFiredMines = fOtherDeadMines
                              = fVehiclesHit = fVehiclesKilled = 0; }
   void             WriteTotals(ofstream*);
   
   TMineSumm&   operator+=(const TMineSumm&);
   TMineSumm&   operator-=(const TMineSumm&);

   TMineSumm( int tot = 0 ) {fTotalMines = fLiveMines = tot;
                            fFiredMines = fOtherDeadMines =
                            fVehiclesHit = fVehiclesKilled =  0;}
};

struct TMfObjTypeDesc : public T2link {
      // keeps list of mine types and summ info for minefields
   TEntityType     fType;
   TMineSumm       fMineSumm;
   
   const TEntityType&      GetEntityType()   { return fType; }
   
   TMfObjTypeDesc(const TEntityType& type, int numTot, T2link* pPrev);
   TMfObjTypeDesc(const TEntityType& type, const TMineSumm& msumm, T2link* pPrev);

   ~TMfObjTypeDesc();
};

class cObjTypeListHead : public  T2linkHead{
  
 protected:

 public:
      
   TMfObjTypeDesc*   GetObjDesc( const TEntityType& type);
         
              cObjTypeListHead() : T2linkHead() {}
   virtual   ~cObjTypeListHead();
};

// ************************************
//   mine part classes
// ************************************

class cSimMine;
   //+++
   // trackers produce track lists.
   //   Differences between classes include range and entity types
   //   tracked.
   // Specialized trackers for smart mines have other differences
class cTracker {
   // basic tracker tracks all type of entities, ordered by range
   // Descendents filter types of entities tracked, and can also do
   // specialized things like categorize targets and apply errors
protected:
   float     fRange;
   cEntity*  fpRefEnt;         // owning entity, e.g., mine
   EBoolean  fbUseVehCoord;
   
public:
   virtual   float          GetSensRange();

   virtual   int            GetTrackType(const TEntityType& type);
   virtual   EBoolean       IsInRange(const TEntityType& type, double range);
   virtual   void           UpdateTracker(cVehListHead& proxList, 
                                    cVehListHead* pTrkList, TEntCoord entLoc);
   virtual   cLinkVehGeom*  CreateNewTrack(cLinkVehLoc* pProxLink, cLinkVeh* pPrev);
   virtual   cLinkVehGeom*  CreateCopyTrack(cLinkVehGeom* pOldTrkLink, cLinkVeh* pPrev);
   
              cTracker( cEntity*  pRefEnt, float range, EBoolean useVehCoord = true) 
                     { fpRefEnt = pRefEnt; fRange = range; fbUseVehCoord = useVehCoord;}
   virtual   ~cTracker();
};

class cMechanVuln {

protected:
  enum EPlowIntState { episNone, episPlowing, episPlowingRB, 
                       episAstride, episAstrideRB, episBehind };
  
  cSimMine*          fpMine;
  TVulnMechParam     fMechVulnTables;
  EMineInternalState fMineSavedState;   // to restore after plow movement
  EPlowIntState      fPlowIntState;
  
  

  void          ProcessFullPlow(cLinkVehGeom* pVehLink, TTimeSim* pWaitTime);
  void          ProcessTrackPlow(cLinkVehGeom* pVehLink, TTimeSim* pWaitTime);
  void          ProcessFullRake(cLinkVehGeom* pVehLink, TTimeSim* pWaitTime);
  void          ProcessTrackRoller(cLinkVehGeom* pVehLink, TTimeSim* pWaitTime);
  void          ProcessDogbone(cLinkVehGeom* pVehLink, TTimeSim* pWaitTime);
//  void          ProcessMagCm(cMineLinkEmiss* pEmLink, TTimeSim* pWaitTime);
  
  void          PlowMine(cLinkVehGeom* pVehLink, const T2Dsingle& plowOffset);

public:
   virtual void    UpdateMechVuln(cVehListHead* pVehList, TTimeSim* pWaitTime);
  void          ProcessMagCm(cMineLinkEmiss* pEmLink, TTimeSim* pWaitTime);
   
            cMechanVuln(TVulnMechParam* pTables, cSimMine* pMine) : 
                       fMechVulnTables( *pTables ) 
                       {fpMine = pMine; fMineSavedState = emisNone;}
   virtual ~cMechanVuln();
};

class cControl {

protected:
   
public:
   virtual   void      UpdateControl(cVehListHead* pVehList, cEmissListHead* pEmissList, TTimeSim* pWaitTime);

   virtual  ~cControl();
};

/*
class cEmissVuln {

protected:
//  enum EPlowIntState { episNone, episPlowing, episPlowingRB, 
//                       episAstride, episAstrideRB, episBehind };
  
  cEntity*          fpRefEnt;
//  TVulnMechParam     fMechVulnTables;
  //EMineInternalState fMineSavedState;   // to restore after plow movement
//  EPlowIntState      fPlowIntState;
  
  

//  void          ProcessFullPlow(cLinkVehGeom* pVehLink, TTimeSim* pWaitTime);
//  void          ProcessTrackPlow(cLinkVehGeom* pVehLink, TTimeSim* pWaitTime);
//  void          ProcessFullRake(cLinkVehGeom* pVehLink, TTimeSim* pWaitTime);
//  void          ProcessTrackRoller(cLinkVehGeom* pVehLink, TTimeSim* pWaitTime);
//  void          ProcessDogbone(cLinkVehGeom* pVehLink, TTimeSim* pWaitTime);
  void          ProcessMagCm(cLinkEmiss* pEmLink, cSimMine* fpMine,  TTimeSim* pWaitTime);
  
//  void          PlowMine(cLinkVehGeom* pVehLink, const T2Dsingle& plowOffset);

public:
   virtual void    UpdateEmissVuln(cEmissListHead* pEmissList, cSimMine* fpMine,  TTimeSim* pWaitTime);
   
//            cEmissVuln(TVulnMechParam* pTables, cSimMine* pMine) : 
//                       fMechVulnTables( *pTables ) 
//                       {fpMine = pMine; fMineSavedState = emisNone;}
            cEmissVuln(cEntity* pMine) { fpRefEnt = pMine; }


//   virtual ~cMechanVuln() {};
};
*/


struct TAttackGeom {
   EBoolean         fbAttackNow;
   EBoolean         fbLikelyTgt;
   EBoolean         fbApproaching;
   double           fApproachTime;   // in seconds
   TFlatEntCoord    fTgtOffset;      // generally, from attack position
};

class cMineControl : public cControl {
   // the base control class fires on x and y offset to target,
   // and goes to priority on time to reach these offsets
protected:
   cSimMine*         fpMine;
   TFlatEntCoord     fFireOffset;     // fire on tgt when this close, fixed at object creation
   int               fTgtCount;

 
public:
   TFlatEntCoord&   GetFireOffset() { return fFireOffset;}

   virtual void    UpdateControl(cVehListHead* pVehList, cEmissListHead* pEmissList, TTimeSim* pWaitTime);
   
   virtual void	    CalcControl(cLinkVehGeom* pLink, TTimeSim* pWaitTime);
   virtual void	    CalcControl(cMineLinkEmiss* pLink, TTimeSim* pWaitTime);
   
             
   virtual   void      CalcGeom(const cLinkVehGeom* pLink, TAttackGeom* pGeom);
   virtual   void      CalcGeom(const cMineLinkEmiss* pEmLink, TAttackGeom* pGeom);
   

   virtual   EBoolean  FireGeometry(const cLinkVehGeom* pLink, TAttackGeom* pGeom);         // target should be engaged
   virtual   EBoolean  FireGeometry(const cMineLinkEmiss* pLink, TAttackGeom* pGeom);         // target should be engaged

   virtual      EBoolean   NeedsPrUpdate( EMineInternalState minestate);
   virtual      EBoolean   NeedsUpdate( EMineInternalState minestate);
   
             cMineControl(cSimMine* pMine, TFlatEntCoord offset, const TFuzeOpt& fuzeOpt );
   virtual  ~cMineControl();
};

class cDetVulnList;
class cDetonVuln {

 friend class TVulnDetParam;

protected:
   
   cSimMine*      fpMine;
   cDetVulnList*  fpVulnDetList;
   float          fExtraRange;      // used for components virtual mine
   
public:
   TDetVulnTable*   GetVulnDetTable( int detType ) 
                        { return fpVulnDetList->GetVulnDetTable(detType); }
             float  GetDetVulnRange(int detType, float depth);
   
   virtual   void   AssessDeton(cDetonation* pDet, float range);
             void   WriteDetonResult( ofstream* pFile, cDetonation* pDet, 
                                      float range, int result );

            cDetonVuln(cDetVulnList* pVulnDetList, cSimMine* pMine, float extraRange = 0.0);
   virtual ~cDetonVuln();
};


// ************************************
//   minefield objects
// ************************************
class cMfComponent;
class cMineComp;
class cDispObj;

class cMfieldObj : public cEntity {

 private:
   static TEntityType   fsMfobjEntityType;
   static char*         fsMfobjName;

   friend class cMinefield;
   friend class cMineComp;

protected:
   
   ERefSet             fRefSet;
   cDispObj*           fpDispObj;
   
   cMfComponent *      fpMfComponent;
   cMinefield*         fpMinefield;
   
   TEntCoord           fMfLocation;
   float               fDepth;
   double              fHoursInPlace;

   EBoolean            fbSelected;

public:

   

   const   TEntCoord&       GetMfLoc()   { return fMfLocation;}
           cMfComponent*    GetCompParent() { return fpMfComponent;}
           cMinefield*      GetMinefield()  { return fpMinefield;}
           float            GetDepth()      { return fDepth; }

           void             SetMfLoc(float xLoc, float yLoc);
           void             SetDepth(float depth)   { fDepth = depth; }

   virtual void   SetCoordTccRef(TLocation tccLoc, float psi, float theta, float phi);
   virtual void   SetCoordGeoRef(TLocation geoLoc, float psi, float theta, float phi);
   virtual void   SetCoordGeoRef(TLocation geoLoc, TOrient orient);
   virtual void   SetTccOrient(float psi, float theta, float phi);      // existing location
           void   SetMfFromTcc();

   cDispObj*      GetDispObj()     { return fpDispObj; }
   void           TakeDispObj(cDispObj* obj)    { fpDispObj = obj; }
   
   virtual         EBoolean       CompleteMfObj();
   virtual         void           CompleteVisuals();
   virtual         void           CreateDispObj();
   

             // working with gui
          EBoolean         IsSelected()       { return fbSelected; }
   virtual   void          SelectObj();
   virtual   void          DeSelectObj();
   void                    ShowObj (EBoolean show);
//   virtual         void           SimulateMfObj();
             void     ResetTccCoord()   { fRefSet = eTccRef; }

   void   InitMfObj(cMfComponent* pParent);
   void   CopyMfObjParams(cMfieldObj* pOriginal);

              cMfieldObj(cMfieldObj* pOriginal = NULL);
              cMfieldObj(cMineComp* pParent, cMfieldObj* pOriginal); // used when duplicating or backing up
              cMfieldObj(cMfComponent* pParent);
              cMfieldObj(cMfComponent* pParent, TLocation& tccPt);
   virtual   ~cMfieldObj();
};

   // values set for individual objects, at creation time
struct TMfobjPlaceParam {
   float               fDepth;
   TLocation           fLocation;
   float               fHoursInPlace;
   
   TMfobjPlaceParam( TLocation loc, float depth = 0.0, float hours = 0.0 ) 
                   { fLocation = loc;  fDepth = depth;  fHoursInPlace = hours; }
   TMfobjPlaceParam( float depth = 0.0, float hours = 0.0 )
                   { fDepth = depth;  fHoursInPlace = hours; }
};

   // values set for individual mines, at creation time
struct TMinePlaceParam : public TMfobjPlaceParam {
   EMineInternalState  feIntState;
   EBoolean            fbSim;
   
   TMinePlaceParam(EMineInternalState state = emisOn, EBoolean sim = true) 
                  { feIntState = state; fbSim = sim; }
};

struct TDbOptSet {
   int   fMineOpt;
   int   fFuzeOpt;
   int   fVulnDetOpt;
   int   fVulnMechOpt;
   
   TDbOptSet() { fMineOpt = 0; fFuzeOpt = 0;
                 fVulnDetOpt = 0; fVulnMechOpt = 0; }
};

class cDbMine;
class cMineParam;
class cMine : public cMfieldObj {
 
 private:
   static TEntityType   fsMineEntityType;
   static char*         fsMineName;
   static int           fsDefaultFuzeType;   	// for initializing database
   
   static   cDbMine_cMine     fsDbMine;      	// the instantiation in mine database

 public:
      // all mine types use 0 for not tracked, other values for tracked
   enum { etrkNot, etrkYes };
   
   enum   { esymPlanAt,
            esymPlanAp,
            esymPlanDir,
            esymPlanCam,
            esymPlanSens,
            esymAt,
            esymAp,
            esymDir,
            
            esymFalseDet,
            esymCam,
            esymSens,
            
            esymNum   };
            
 
 protected:
   cDbMine*                        fpDbMine;      // points to the mine db object
   TDbOptSet                       fOptSet;
   
   static unsigned long   simObjType[esymNum];   // used as keys to find drawing icons

   EMineInternalState    feIntState;
   static   char*        fsStateText[emisNumStates];
   EBoolean              fbEditOn;      // set during editing, used when
   EBoolean              fbEditSim;     // starting to simulate
   int                   fRoundsLeft;
      
public:
         // database accessor functions
   TMineParam*          GetMineParams();
   TFuzeParam*          GetFuzeParams();
   char*                GetEntName();
   const TEntityType&   GetEntType();
   EBoolean             IsDirectional(TFlatEntCoord* pMinMax = NULL);
   EBoolean             IsWideArea(float* pRange = NULL);
   EBoolean             IsCmdDet();
   EBoolean             IsClickFire();
   
                void    UserSetDirection(float psi, float theta, float phi);

   virtual      void    CmdDet();
   virtual      void    CmdDet(TLocation tccPt);
   virtual      void    CmdFire(EMfCmdMode eMineCmdMode);

   EWarhead             GetWarhead();
   EFuze                GetFuze();
   int 			GetFuzeNameIndex();  // Added by KS
   EYesNoOpt		GetAntiHandling();  // ""
   virtual   unsigned long   GetIconType();

         // calls specific mine type

   //virtual cSensor* 	GetSensor();
   cMine*                  GetNextMine()     { return (cMine*)fpNextEnt; }
   short GetDomain();

   EMineInternalState    GetInternalState()   { return feIntState; }
   virtual   EMineInternalState    GetDisplayState();
   static char*          GetInternalStateText(EMineInternalState state) { return fsStateText[state]; }
   EMineExternalState    GetExternalState();
   EBoolean              IsDetectable()   { if (feIntState >= emisFailed) return true;
                                            else return false; }
   float                 GetMineDepth()   { return fDepth; }

   virtual   void          CreateDispObj();
   EBoolean                MoveMine (TLocation tccPt);   // mine only
   virtual EBoolean   MoveMineWithMf (T2dMove& move);  // mf moves
   virtual EBoolean   MoveMineWithComp (TEntCoord& centerPt, T2dMove& move);  // comp moves
   EBoolean                GetEditOnState() { return fbEditOn;  }
   EBoolean                GetMineToggleState();
   EBoolean                GetEditSimState() { return fbEditSim;  }
   virtual   void          SetMineOn (EBoolean on);      // called from gui
   virtual   void          SetMineSim (EBoolean sim);      // called from gui
   virtual   void          SetMinePvdSelect( EBoolean on );
   virtual   void          SetCompPvdSelect( EBoolean on );
   
   void       InitMine(cMineComp* pParent = NULL);               // used by constructors
   void       CopyMineParams(cMine* pOriginal);
   
   virtual   void			WriteEntSumm(ofstream*);

              cMine( cPlanMine* pPlan = NULL );

      // constructor for duplicating or backing up component
              cMine( cMineComp* pParent, cMine* pOriginal, EBoolean isBackup);

      // constructor for file input
              cMine(cMineComp* pParent);  // input file

      // constructor for newly specified mines, from gui
              cMine(cMineComp* pParent, TLocation& tccPt);  // gui creation

   virtual   ~cMine();
};

enum EDetectSensorType {
   edetsensNone,
   edetsensMag,
   edetsensPassiveIR,
   edetsensGPR,
   edetsensEO,

   eNumdetsens,
};

struct TMineDetectChar {
      // mine characteristics, mostly of interest to detection systems,
      // that are not simulated/listed elsewhere
   float         fSnowDepth;
   float         fWaterDepth;
   float         fThermalContrast;
   float         fDielectricContrast;
   float         fMineAge;
      // for now, color is in database, applies to all instances of type
   float         fDetectCoeff[eNumdetsens];
   
   float	 GetDetectCoeff(TEntityType detSensorType);
   
   TMineDetectChar();
};

class cMineC2Interface;


class cSimMine : public cMine {

 friend class cDbMine;
 
 protected:
   
   static         TTimeSim   fsDamageCheckDelay;
   
   static const   TTimeSim   fsUpdateRate;
   static const   TTimeSim   fsFastUpdateRate;
   cMessage*                 fpUpdateMsg;
   
   TMineDetectChar           fDetectChar;
   unsigned short            fChangeSequence;      // incremented by mine updater
   EBoolean                  fbChangeIndicator;    // set true by any characteristic updater
   T2linkMineSetList*        fpMineSetList;        // if used, in CP
   TTimeSim                  fNextThermalChange;   // for provisional update method
  
   cSensor*		 fpSensor;
   cEmissVuln*		 fpEmissVuln; 
   cTracker*             fpTracker;
   cMechanVuln*          fpMechanVuln;
   cMineControl*         fpControl;
   cDetonVuln*           fpDetonVuln;
   cEntity*              fpController;
      
      // veh list filled in by tracker
   cVehListHead          fTrackVeh;

     // emission list filled by sensor
   cEmissListHead	 fProxEmiss;
   
      // info filled in during simulation, mostly at detonation
   TDetonationData       fDetonationData;
   TFireData             fFireData;      // for those mines that fire projectiles
   int                   fKilledTgts;
   TEntityType           fTargetType;
   cVehicle*             fpTarget;
   EBoolean		 fbKilledTgt;

      // info filled in during simulation, mostly at detonation
   /*
   TVehPart*             fpPartHit;
   TEntityID             fTargetID;
   TLocation             fDetonLoc;      // may not be mine location
   TEntCoord             fLocTargetRef;
   EDetonResult          feDetonResult;
   float                 fFireRange;
   // mines that fire projectiles need these
   TEntityID             fEventID;      // event that launched it
   TEntityID             fProjID;
   TVelocity             fGeoLaunchVel;
   */

 public:
//   EBoolean		 fbHitEmiss;
//   void			 SetEmissVuln(cEmissVuln* pEmissVuln)	{ fpEmissVuln = pEmissVuln; }
   void                  SetTracker( cTracker* pTracker ) { fpTracker = pTracker; }
   void 		 SetSensor( cSensor* pSensor ) { /*cout << "cSimMine::SetSensor()" << endl;*/fpSensor = pSensor; }
   void                  SetMechVuln( cMechanVuln* pMechVuln ) { fpMechanVuln = pMechVuln; }
   cMechanVuln*		 GetMechVuln()	{ return fpMechanVuln; }
   cEntity*              GetController() { return fpController; }

   void                  SetControl( cMineControl* pControl ) { fpControl = pControl; }
   void                  SetDetVuln( cDetonVuln* pDetonVuln ) { fpDetonVuln = pDetonVuln; }
   cDetonVuln*           GetDetVuln( )             { return fpDetonVuln; }
   cVehListHead*         TakeVehList()      { return &fTrackVeh; }
   void                  SetChangeIndicator()  { fbChangeIndicator = true; }
   void                  SetMineSetList(T2linkMineSetList* fpList);
   void                  DoMineChange();

   TDetonationData&      GetDetonationData(); // { return fDetonationData; }
   TFireData&            GetFireData()  { return fFireData; }
   cSensor*		 GetSensor() { return fpSensor; }
   cVehicle*             GetTarget() { return fpTarget; }
   TVehPart&             GetTargetPart() { return fDetonationData.fTgtPart; }
   EBoolean              IsTargetKilled() { return (fKilledTgts >= 1) ? true: false;  }
   TEntityType           GetDetonationType()  { return GetMineParams()->fDetonationType; }
   TEntityType           GetDetectionType()  { return GetMineParams()->fDetectionType; }
   unsigned char         GetPaintScheme()  { return GetMineParams()->fPaintScheme; }
   TEntityType           GetTargetType() { return fTargetType; }
   TEntityID             GetTargetID() { return fDetonationData.fTargetEnt; }
   TEntCoord             GetDetVehCoord() { return fDetonationData.fLocTargetRef; }
   TLocation             GetDetLoc() { return fDetonationData.fDetLocation; }
   EDetonResult          GetDetResult() { return fDetonationData.feDetResult; }
   float                 GetFireRange() { return fFireData.fFireRange; }
   EAppearance           GetMineAppear() { if  ( (feIntState == emisDetonated) ||
                                                 (feIntState == emisDetonatedHit) ||
                                                 (feIntState == emisDetonatedMissed) )
                                                 return eAprDestroyed;
                                           else return eAprStandard;}
   float                 GetSnowDepth() { return fDetectChar.fSnowDepth; }                       
   float                 GetWaterDepth() { return fDetectChar.fWaterDepth; }                       
   float                 GetThermalContrast() { return fDetectChar.fThermalContrast; }                       
   float                 GetDielectricContrast() { return fDetectChar.fDielectricContrast; }                       
   float                 GetMineAge() { return fDetectChar.fMineAge; }
   float		 GetScalerDetCoeff(TEntityType detSensorType) { return fDetectChar.GetDetectCoeff(detSensorType); }                       
                                           
   TEntityID&            GetEventID()         { return fDetonationData.fEventId; }
   TEntityID&            GetProjID()          { return fFireData.fMunitionEnt; }
   TVelocity&            GetGeoLaunchVel()    { return fFireData.fGeoLaunchVel; }

   TTimeSim              GetUpdateRate()  { return fsUpdateRate; }
   TTimeSim              GetFastUpdateRate()  { return fsFastUpdateRate; }
   //virtual   void        SetDetonationResults();
   virtual   void        SetDetonationResults(cLinkVehGeom* pLink, TVehPart* pPart = NULL,
					      EBoolean all = false);
   virtual   void	 SetDetonationResults(cMineLinkEmiss* pEmLink, EBoolean = false);
   void                  SetDetonLoc(const TLocation& loc) {fDetonationData.fDetLocation = loc;}
   void                  SetDetonResult(EDetonResult result) {fDetonationData.feDetResult = result;}
         
   virtual cInteraction* CreateNewInteraction(cLinkVehGeom*);
   virtual void          UpdateInteractions();

   virtual   void          UpdateMine();
   virtual   void          UpdateDetChar();
   virtual   void          SimulateMine();
   virtual   void          OnOffMine( EBoolean on);
   void                    FireMine(EMineInternalState state, EBoolean all = false);
   virtual   void          StateChange(EMineInternalState state);
             void          CheckVehDamage(cVehicle* pVeh = NULL);

   virtual   EBoolean      InMineRange(cVehicle* veh, double range);
   virtual   EBoolean	   InMineRange(cEmission* pEm,  double range);

             float         GetDetVulnRange(int detType);
   virtual   void          InDetMine(cDetonation* pDet);
   virtual   void          InDetTargeted(cDetonation* pDet);

   void                  InitSimMine();
   virtual   void        WriteEntSumm(ofstream*);
   virtual   void        SaveMineState();
   
   virtual   EBoolean    IsFalseAlarm() { return false; }

           // constructor for virtual mine, for component sensor
    cSimMine(cMineComp* pParent, float radius);

           // constructor for creation from gui, planning mine
    cSimMine( cPlanMine* pPlan = NULL );

    // no constructor for duplicating or backing up.  Duplicates are
    // planning mines
    

           // constructor for reading from file, only used when sim host without gui
//    cSimMine(cMineComp* pParent, cDbMine* pDbMine, TMinePlaceParam& emplace, TDbOptSet opt);

   virtual   ~cSimMine();
};

class cPlanMine : public cMine {

 public:
   void                  SetMineDepth( float depth )  { fDepth = depth; }
   void                  SetMineType( cDbMine* pDbMine );
   void                  SetMineHoursInPlace( float hours )  { fHoursInPlace = hours; }
   
   virtual   unsigned long   GetIconType();
      // constructor for duplicating or backing up component
              cPlanMine( cMineComp* pParent, cMine* pOriginal, EBoolean isBackup);
              
              cPlanMine(cMineComp* pParent, TLocation& tccPt);  // gui creation
              
           // constructors for reading from mine file, using minefield coords w/wo elev
              cPlanMine(cMineComp* pParent, TEntCoord* pMfPt);
              cPlanMine(cMineComp* pParent, TFlatEntCoord* pMfPt);
              
   virtual   ~cPlanMine();
};

class cFixObj : public cMfieldObj {

protected:

public:
   virtual   void          SimulateFixObj();

              cFixObj() {}
   virtual   ~cFixObj();
};

struct TPerimPoint : public T2link {

 protected:
   TEntCoord          fMfPoint;    // minefield coords
   TLocation          fTccPoint;   // map coords
   TLocation          fGeoPoint;   // geocentric coords
   
 public:  
   TEntCoord&      GetMfPoint()    { return fMfPoint; }
   TLocation&      GetTccPoint()   { return fTccPoint; }
   TLocation&      GetGeoPoint()   { return fGeoPoint; }

   void       SetMfPoint(const TEntCoord& loc)   { fMfPoint = loc; }
   void       SetTccPoint(const TLocation& loc);
   
              TPerimPoint(const TFlatEntCoord& mfPt, T2link* pPrev);
              TPerimPoint(const TLocation& tccPt, T2link* pPrev);
   virtual   ~TPerimPoint(); 
};

class cPerimDisp;
class cCompSummLine;
class cCompStatusLine;
class cUpdateMfCompStatusMsg;

class cMfComponent {

   friend class cMineComp;
   
protected:
   ECompType          fCompType;
   EBoolean           feSelected;
   EBoolean           feIsEditing;
     
      // set by minefield, on creation
   cMfComponent*      fpNext;
   cMfComponent*      fpPrev;
   cMinefield*        fpParentMf;
   cCompSummLine*     fpCompEntry;      // display line in minefield editor
   cCompStatusLine*   fpCompStatus;      // display line in minefield editor
   cUpdateMfCompStatusMsg* fpUpdateCompStatMsg;
   ERefSet            fRefSet;

   TEntityID          fControllerId;

   cMfComponent*      fpBackup;

public:
   
   virtual   int          GetObjIndex(cMfieldObj* pObj);

         ECompType        GetCompType()   { return fCompType;}
   virtual   EBoolean     IsMineComp();
   cMfComponent*          GetNext()       { return fpNext;}
   cMfComponent*          GetPrevComp()       { return fpPrev;}
   cMinefield*            GetMinefield()  { return fpParentMf;}
   EBoolean               IsSelected()    { return feSelected; }
   cCompSummLine*         GetCompEntry()  { return fpCompEntry;}
   cCompStatusLine*       GetCompStatus() { return fpCompStatus;}
   void                   UpdateStatusInfo(EBoolean bSentCompStatMsg = false);
   void                   ReplaceInList(cMfComponent* pComp);

   const TEntityID&    GetControllerId() const { return fControllerId; }
   void                SetControllerId(const TEntityID& controller) { fControllerId = controller; }

   virtual   void      OnOffComponent (EBoolean on);
   virtual   void      SimulateComponent (EBoolean sim);

   virtual   void      UpdateComponent();
   virtual   EBoolean  CompleteComp();
   virtual   void      RecreateVisuals();
   virtual   void      SaveComponent(cOutFileObj* pOutfile);
   virtual   void      StartEditingComp();
   virtual   void      StopEditingComp();
   virtual   void      MakeBackup();
   virtual   void      RestoreBackup();
             EBoolean  HasCompBackup()  { return (fpBackup == NULL) ? false: true;}
   virtual   void      DeleteBackup();
   virtual   void      ResetTccCoord();
   virtual cMfComponent*    DuplicateComp(T2dMove&, cMinefield*, 
					  EBoolean isBackup = false);
   virtual   EBoolean  MoveCompOnly(T2dMove&);
   virtual   EBoolean  MoveComp (T2dMove&);   // minefield itself moves
   
   virtual   void      InDetComp(cDetonation* pDetonation);

             // working with gui
   virtual   void          SelectComp();
   virtual   void          DeSelectComp();
   virtual   void          SetCompPvdSelect( EBoolean on );
   virtual   EBoolean      AcceptsCommands();
   virtual   void          CmdFire(EMfCmdMode eMineCmdMode);
   
   virtual   void          WriteCompSumm(ofstream*);
             void          WriteCompTypeText(ofstream* pOut);
   virtual   void          SaveCompState();

   void                InitMfComponent(cMinefield* pParentMf, 
				       EBoolean isBackup = false);

                       cMfComponent(cMfComponent* pOriginal, cMinefield* pParent,
				    EBoolean isBackup = false);   // duplicating
                       cMfComponent(cMinefield* pParent);   // duplicating of clusters
                       cMfComponent();
   virtual            ~cMfComponent();
};

class cPerimeter : public cMfComponent {

 protected:

   cPerimDisp*         fpPerimDisp;
   T2linkHead          fPointList;   // list head, not itself the first point
   int                 fNumPoints;      // not handled by T2links
   
 public:        

   cPerimDisp*   GetPerimDisp()  { return fpPerimDisp; }
   int           GetNumPoints()  { return fNumPoints; }
   TPerimPoint*  GetFirstPoint();
   TPerimPoint*  GetNextPoint();
   TPerimPoint*  GetLastPoint();
   TPerimPoint*  GetPointNum  (int iPt);
   
   EBoolean   AddTccPoint (TLocation& tccPt);
   EBoolean   DeletePoint (int iPt);
   EBoolean   MovePoint   (int iPt, TLocation tccPt);
//   EBoolean   MovePerim   (TLocation offset);
   EBoolean   PointInside (TLocation tccPt);
   
   void       ReadMfPerim   ( TItemList* list );
   void       ReadMapPerim  ( TItemList* list );
   void       Read2dMapPerim( TItemList* list );
   void       ComputePerim  ();
   virtual   EBoolean    MoveComp (T2dMove&);   // moves minefield coord system
   virtual   EBoolean    CompleteComp();
   virtual   void        SaveComponent(cOutFileObj* pOutfile);
   virtual   void        RecreateVisuals();
   virtual   void        OnOffComponent (EBoolean on);
   
   EBoolean   GetMfGeoLoc(TLocation* pLoc);
   EBoolean   ValidPerim(TLocation& newPt);

             // working with gui
//   virtual   void          SelectComp();
//   virtual   void          DeSelectComp();
   void                    ShowPerim (EBoolean show);
   void                    SetPerimSelect (EBoolean on);
   virtual   void          StartEditingComp();
   virtual   void          StopEditingComp();
               
   virtual cMfComponent*    DuplicateComp(T2dMove&, cMinefield*, 
					  EBoolean isBackup = false);
   virtual   void      MakeBackup();
   virtual   void      RestoreBackup();

              cPerimeter(cPerimeter* pOriginal, cMinefield* pParent,
			 EBoolean isBackup = false);   // duplicating
              cPerimeter(cMinefield* pParent);
   virtual   ~cPerimeter();
};

class cUpdateComponentMsg;
class cMineComp : public cMfComponent, public cEntity {

   friend class cMine;

     //file stuff
   enum { emcompkwType, emcompkwTypeString, emcompkwDepth, 
          emcompkwAge,  emcompkwFuzeType, emcompkwSelfDestTime,
          emcompkwTgtCount, emcompkwAntiHandle, emcompkwBlastHard, 
          emcompkwLocList, 
          emcompkw3dLocList, emcompkwOrientList, eSizeMCompTable };
   static   const TKeywordEntry  fKeyMCompTable[eSizeMCompTable];

protected:
   EBoolean           fEditOn;
   EBoolean           fEditSim;           // sim when minefield is simulated
   EBoolean           fRealSim;
   EBoolean           fShowMines;
   float              fDepth;
   float              fHoursInPlace;

      // info about the mines, used for both gui and sim
   cDbMine*           fpDbMine;
   TDbOptSet          fDbOpt;            // option settings in database
   TFuzeOpt           fFuzeOpt;          // option settings for the fuze type
   cMine*             fpMineListHead;
   cMine*             fpMineListTail;
   cMine*             fpCurMine;
   T2linkHead         fMineSetList;      // used with consistency protocol, sublists of mine sets
         // location and radius are derived from mines
   TEntCoord          fMfLocation;         // minefield coordinates
   double             fRadius;
   
      // used for display, gui
   TMineSumm          fMineSumm;
   
      //  used for sim
   cUpdateComponentMsg*    fpUpdateCompMsg;
   cSimMine*             fpVirtualMine;      //not simulated, used for veh list
   cVehListHead       fProxVehList;      // keeps proximate veh list in minefield coordinates
   cEmissListHead     fProxEmissList;    // keeps proximate emission list

   static   void      CbOk (Widget w, XtPointer, XmAnyCallbackStruct* );

public:
             cDbMine*     GetDbEntity() { return fpDbMine;}
   TMineParam*            GetCompMineParams();
   TFuzeParam*            GetCompFuzeParams();
   char*                  GetEntName();
   const   TEntityType&   GetEntType();
   const   TEntityType&   GetDetectEntType();

             EBoolean     IsMineDirectional();
   virtual   EBoolean     IsMineComp();
   virtual   void         SetCompMineType(cDbMine* pDbMine, EBoolean bDraw = true);

             void         SetOnState (EBoolean on);
             void         SetSimState (EBoolean sim);
             void         ShowMines (EBoolean show);
             EBoolean     GetOnState()   { return fEditOn; }
             EBoolean     GetSimState()     { return fEditSim; }
             EBoolean     GetShowMines()   { return fShowMines; }
   
   float              GetCompMineDepth ()   { return fDepth; }
   float              GetCompHoursInPlace ()   { return fHoursInPlace; }
   const TDbOptSet&   GetDbOpt() { return fDbOpt; }
   const TFuzeOpt&    GetFuzeOpt() { return fFuzeOpt; }

             int      GetNumMines() { return fMineSumm.fTotalMines; }
             cMine*   GetFirstMine() { return fpMineListHead; }
//             cMine*   GetNextMine()  { if (fpCurMine) fpCurMine = (cMine*)fpCurMine->GetNextMine(); return fpCurMine; }
             cMine*   GetLastMine() { return fpMineListTail; }
   virtual   int      GetObjIndex(cMfieldObj* pObj);
             cMine*   GetMineNum (int iMine);

   cVehListHead&      GetVehList()    { return fProxVehList;}
   cEmissListHead&    GetEmissList()  { return fProxEmissList; }

          TMineSumm&       GetMsgMineSumm()  { return fMineSumm; }
   const  TMineSumm&       GetMineSumm()     { return fMineSumm; }
          int              GetTotalMines()   { return fMineSumm.fTotalMines; }
          int              GetLiveMines()    { return fMineSumm.fLiveMines; }
          int              GetFiredMines()   { return fMineSumm.fFiredMines; }
          int              GetOtherMines()   { return fMineSumm.fOtherDeadMines; }
          int              GetVehHits()      { return fMineSumm.fVehiclesHit; }
          int              GetVehKills()     { return fMineSumm.fVehiclesKilled; }
          void             IncrementLive();
          void             DecrementMine(EMineExternalState oldState);
          void             IncrementFired(EBoolean decLive = true);
          void             IncrementOtherDead();
          void             IncrementVehHit();
          void             IncrementVehKill();
   
             void      SetCompMineDepth(float  depth);
             void      SetCompHoursInPlace(float  hours);
             void      SetDbOpt(const TDbOptSet&  dbOpt) { fDbOpt = dbOpt; }
             void      SetFuzeOpt(const TFuzeOpt&  fuzeOpt) { fFuzeOpt = fuzeOpt; }

   virtual   void     SelectComp();
   virtual   void     DeSelectComp();
   virtual   void     SetCompPvdSelect( EBoolean on );
   virtual   EBoolean AcceptsCommands();
   virtual   void     CmdFire( EMfCmdMode eMineCmdMode );
//   virtual   void     SetMineSelection (cMine* pMine);
   virtual   void     RedrawComp();
   virtual   EBoolean CompleteComp();
   virtual   void     SimulateComponent (EBoolean sim);
             void     ReplaceMine(cMine* pOld, cMine* pNew);

   virtual   void     OnOffComponent (EBoolean on);
   virtual   void     UpdateComponent();
   virtual   void     StartEditingComp();
   virtual   void     StopEditingComp();
   virtual   void     ResetTccCoord();
   virtual   void     RecreateVisuals();
   virtual   EBoolean MoveCompOnly(T2dMove&);   // within static minefield
   virtual   EBoolean MoveComp (T2dMove&);   // minefield itself moves

   virtual   void     InDetComp(cDetonation* pDetonation);
   virtual   EBoolean AddTccMine (TLocation& loc);
   virtual   EBoolean AddTccMines (TLocation* tccPts, int nMines);
 
   virtual   void     SaveComponent(cOutFileObj* pOutfile);
   void               ParseMineItem(cInFileObj* pMineFile);
             void     DeleteMine (cMine* pM);
             void     DeleteMines ();

   void               CopyMineCompParams(cMineComp* pOriginal);
   virtual   void     SaveCompState();
   virtual   void     WriteCompSumm(ofstream*);
             
                      cMineComp(cMineComp* pOriginal, cMinefield* pParent,
				EBoolean isBackup = false);   // duplication
                      cMineComp(cMinefield* pParentMf);
   virtual           ~cMineComp();
};

class cIndivComp : public cMineComp {

   enum { eSizeIndivTable };
   static   const TKeywordEntry  fKeyIndivTable[ 1 /* eSizeIndivTable */];

public:
   
   EBoolean           AddTccMine (TLocation& loc);
   void               ReadIndivMines(cInFileObj* pMineFile);
   virtual   void     SaveComponent(cOutFileObj* pOutfile);
   virtual cMfComponent*    DuplicateComp(T2dMove& move, cMinefield* pParent,
					    EBoolean isBackup = false);
   virtual   void      MakeBackup();
   virtual   void      RestoreBackup();

   void               InitIndivComp(cMinefield* pParentMf, 
				    EBoolean isBackup = false);

                      cIndivComp(cIndivComp* pOriginal, cMinefield* pParentMf,
				 EBoolean isBackup = false);   // duplication

                      cIndivComp(cMinefield* pParentMf);
   virtual           ~cIndivComp();
};

class cGridComp : public cMineComp {

     //file stuff
   enum { egridkwSpacing, eSizeGridTable };
   static   const TKeywordEntry  fKeyGridTable[eSizeGridTable];

protected:

   float              fSpacing;

public:
             void     EmplaceGrid (int nEstMines);
   float              GetSpacing ()   {return fSpacing;}
   void               SetSpacing (float spacing, int nEstMines);
   void               ReadGridMines(cInFileObj* pMineFile);
   virtual   void     SaveComponent(cOutFileObj* pOutfile);
   virtual   void      MakeBackup();
   virtual   void      RestoreBackup();
   virtual cMfComponent*    DuplicateComp(T2dMove& move, cMinefield* pParent,
					  EBoolean isBackup = false);


   void               InitGridComp(cMinefield* pParentMf, 
                              EBoolean isBackup = false);

        cGridComp(cGridComp* pOriginal, cMinefield* pParentMf,
                  EBoolean isBackup = false);   // duplicate, backup
        cGridComp(cMinefield* pParentMf);       // new
   virtual           ~cGridComp();
};

class cRowDisp;

class cRowComp : public cMineComp {

     //file stuff
   enum { erowkwSpacing, erowkwOffset, 
          erowkwMfRowCoords, eSizeRowTable };
   static   const TKeywordEntry  fKeyRowTable[eSizeRowTable];

protected:

   cRowDisp          *fpRowDisp;
   T2linkHead         fPointList;   // list head, not itself the first point
   int                fNumPoints;      // not handled by T2links
   float              fSpacing;
   float              fOffset;

public:

   cRowDisp*          GetRowDisp   ()  { return fpRowDisp; }
   int                GetNumPoints ()  { return fNumPoints; }
   TPerimPoint*       GetFirstPoint();
   TPerimPoint*       GetNextPoint ();
   TPerimPoint*       GetLastPoint ();
   TPerimPoint*       GetPointNum  (int iPt);
   
   float              GetSpacing   ()   {return fSpacing;}
   float              GetOffset    ()   {return fOffset;}
   void               SetSpacing (float spacing, float offset, int nEstMines = 0);
   EBoolean           AddTccPoint  (TLocation& loc);
   EBoolean           DeletePoint  (int iPt);
   EBoolean           MovePoint    (int iPt, TLocation& loc);
   EBoolean           MoveRow      (TLocation offset);
   int                RowMineCount (float spacing);
   void               ReadRowMines (cInFileObj* pMineFile);
   virtual   void     SaveComponent(cOutFileObj* pOutfile);
   virtual   void     RecreateVisuals();
   virtual   void      MakeBackup();
   virtual   void      RestoreBackup();
   virtual cMfComponent*    DuplicateComp(T2dMove& move, cMinefield* pParent,
					  EBoolean isBackup = false);
   virtual   EBoolean MoveCompOnly(T2dMove& move);   // within static minefield
   virtual   EBoolean MoveComp (T2dMove& move);   // minefield itself moves

   virtual   EBoolean CompleteComp();
   void               ComputeCompLoc();

   virtual   void     SetCompPvdSelect( EBoolean on );

   void               InitRowComp(cMinefield* pParentMf, 
				  EBoolean isBackup = false);

                      cRowComp(cRowComp* pOriginal, cMinefield* pParentMf,
			       EBoolean isBackup = false);   // duplication
                      cRowComp(cMinefield* pParentMf);
   virtual           ~cRowComp();
};

class cCompListArea;
class cCompStatusArea;
class cDispMfSummary;
class cSendMfStateMsg;
class cSendCpMfMsg;

enum ESimState { esimGuiInit, esimGuiPerim, esimFileInit, esimFileRead, 
                    esimPduInit, esimPdusRead, esimComplete, esimSimulated };

enum ESimStart { esimstNow, esimstCommand, esimstTimed, esimstSimulating };

struct TSeqNum {
    unsigned	u : 15;
    unsigned    _unused : 1;
};

class cMinefield : public cEntity {
   
   friend class cMfieldMgr;
   friend class cMfComponent;

public:          
         //   minefield types
   enum   EMfType {   eDeliberate = 0, eHasty, eTactical, eNumMfTypes };
   static const char*   fpMfTypeText[eNumMfTypes];
   
         // file stuff
   enum { emfkwType,    emfkwForce,    emfkwMapLoc,     emfkwGeoLoc, emfkwOrient,
          emfkwMfPerim, emfkwMapPerim, emfkw2dMapPerim, emfkwIndiv,  emfkwGrid,   
          emfkwRow,     eSizeMfldTable };
   static   const TKeywordEntry      fKeyMfldTable [eSizeMfldTable];
  
protected:
   static   const  TTimeSim  fsMfStateMsgRate; 
   
   static   TEntityType      fsMinefieldEntType;
   
      // minefield names
   static   int     fNewNameNum;
   enum   { kNameLength = 30 };
   
      // set on construction
   cMinefield*      fpNext;
   cMinefield*      fpPrev;
   cDispMfSummary*  fpMfSumm;      // if running gui, line in status summary
   cCompListArea*   fpCompList;    // if running gui, component part list
   cCompStatusArea* fpCompStatus;    // if running gui, component part list
   
      // current status and summary
   int              fNumMineTypes;
   int              fNumFixtureTypes;
   int              fNumDetectable;
   int              fNumFixtures;
   cObjTypeListHead fMineTypeList;      // detection type of mines
   TMineSumm        fMineSumm;
   T2linkHead       fFixtureTypeList;
   
   cSendMfStateMsg* fpSendMfStateMsg;
   cSendCpMfMsg*    fpCpMfMsg;
   
      // editing, gui related
   EMfType          fMfType;
   char*            fName;
   EForce           fForce;
   EBoolean         fOn;
   EBoolean         fShowMines;
   EBoolean	    fShowLabel;
   ESimStart        feSimStart;      // now, on command, at time
   TTimeSim         fSimTime;
   EBoolean         feSelected;
   EBoolean         feIsEditing;
   cMinefield*      fpMfBackup;
   EBoolean         fbRepos;
   EBoolean         fbSim;            //used for minefields loaded from command line only
   
      // internal stuff
   ESimState        feSimState;         // creation status info, or simulating
   TEntityType      fCmsType;
   TEntityType      fAltType;
   TTimeSim         fEmplacementTime;
   int              fNumComponents;
   cMfComponent*    fpCompHead;
   cMfComponent*    fpCompTail;
   unsigned short   fChangeNum;      // used in consist protocol, after sim and only for perim
   TSeqNum          fCurMfStateSeq;  // used in QRP3 for sequence number
   TSeqNum          fLastMfStateSeq; 
   EMfAppearance    fAppearance;
   EMfCmdMode       feMineCmdMode;    // used for commanding/controlling mines

      // the minefield controls when the operator's fire button goes on and off,
      // since there is one window for all mines in the field
   EBoolean         fbFireButtonOn;
   TTimeSim         fFireBitOffTime;
   TTimeSim         fFireMsgDelay;
   EBoolean         fbMultiShotCmdDet;

   EMinefieldType   fMinefieldType;
   //EMfAppearance_REV fAppearance_REV;
 
      // info when saving
   cMfComponent*    fpNextSaveComp;   // index of next comp to save
   
public:
   EBoolean             GetfbSim()           { return fbSim; }
   char*                GetEntName();
   const TEntityType&   GetEntType();

          void             SetMinefieldType();
	  short	           GetMinefieldType();
          cMinefield*      GetNextMf()       { return fpNext; }
          cMinefield*      GetPrevMf()       { return fpPrev; }
          cDispMfSummary*  GetMfSumm()       { return fpMfSumm; }
          int              GetNumComps()     { return fNumComponents; }
          EForce           GetForce() const      { return fForce; }
          ESimState        GetSimState() const   { return feSimState; }
          ESimStart        GetSimStart()         { return feSimStart; }
          ESimStart        GetSimStart(TTimeSim* pTime)   { *pTime = fSimTime; return feSimStart; }
          EBoolean         GetOnState();
          EBoolean         GetShowMines();
	  EBoolean	   GetShowLabel()        { return fShowLabel; }
	  void		   SetShowLabel(EBoolean show)  { fShowLabel = show; }
          EMfType          GetMfType() const     { return fMfType; }
          cPerimeter*      GetPerimeter()        { return (cPerimeter*)(fpCompHead); }
          cMfComponent*    GetFirstComp()        { return fpCompHead; }
          char*            GetMfName()         { return fName; }
          int              GetNumMineTypes()   { return fNumMineTypes; }
          int              GetNumFixobjTypes() { return fNumFixtureTypes; }
//   const  TEntityType&     GetEntityType()  { return fCmsType;}
   
   EMfAppearance           GetMfAppearance() { return fAppearance; }
   cObjTypeListHead*       GetMineTypeList() { return &fMineTypeList; }
          int              GetChangeNum()    { return fChangeNum; }
   
          EMfCmdMode       GetCmdMode()                   { return feMineCmdMode; }
          void             SetCmdMode(EMfCmdMode mode)    { feMineCmdMode = mode; }
          EBoolean         GetFireButtonState()   { return fbFireButtonOn; }
          TTimeSim         GetMsgDelay()         { return fFireMsgDelay; }
          void             CmdFire();      // called from msg created by GUI
          void             CmdMineDetect(TTimeSim delayOut, 
                                  TTimeSim delayIn, 
                                  TTimeSim timeout  );   // called by mine, when tripped
          void             ProcessFireButMsg(EBoolean on);   // from the message queue
          EBoolean         IsMultishotCmdDet()  { return fbMultiShotCmdDet; }
          void             SetMultishotCmdDet( EBoolean bMshot ) { fbMultiShotCmdDet = bMshot; }
   
   const  TMineSumm&       GetMineSumm()     { return fMineSumm; }
          int              GetTotalMines()   { return fMineSumm.fTotalMines; }
          int              GetLiveMines()    { return fMineSumm.fLiveMines; }
          int              GetFiredMines()   { return fMineSumm.fFiredMines; }
          int              GetOtherMines()   { return fMineSumm.fOtherDeadMines; }
          int              GetVehHits()      { return fMineSumm.fVehiclesHit; }
          int              GetVehKills()     { return fMineSumm.fVehiclesKilled; }
   void                    UpdateStatusInfo();

   // Increment current sequence number only if we need to.
   void			   IncrementSeq()    { if(fCurMfStateSeq.u == fLastMfStateSeq.u) fCurMfStateSeq.u++; }

   void			   UpdateLastSeq()   { fLastMfStateSeq.u = fCurMfStateSeq.u; }
          TSeqNum	   GetCurSeq()	      { return fCurMfStateSeq; }
	  
          cCompListArea*   GetCompList()      { return fpCompList; }
          cCompStatusArea* GetCompStatus()    { return fpCompStatus; }
          EBoolean         IsSelected()       { return feSelected; }
          EBoolean         IsComplete()       { return EBoolean(feSimState >= esimComplete); }
          EBoolean         HasMfCoords();

             //IMPORTANT - conversions assume no rotation, map and mf y is due north
          void             SetMfElevation( TEntCoord* mfLoc );
          void             MapToMfLoc(const TLocation& mapLoc, TEntCoord* pMfLoc);
          void             MapToMfLoc(const TLocation& mapLoc, TFlatEntCoord* pMfLoc);
          void             MfToMapLoc(const TEntCoord& mfLoc, TLocation* pMapLoc);
          void             MfToMapLoc(const TFlatEntCoord& mfLoc, TLocation* pMapLoc);
  
             void          ScheduleNextMfState();
             void          SetCpMfMsg(cSendCpMfMsg* pCpMfMsg) { fpCpMfMsg = pCpMfMsg; }

   virtual   void          ReadMinefield(cInFileObj* pMineFile);
   virtual   void          SaveMinefield(cOutFileObj* pMineFile);
             void          SaveNextComponent(cOutFileObj* pMineFile);
             void          SetMineSumm();
             EBoolean      DoCompleteMf();
             EBoolean      DoMfCoords();
             void          ResetCoords();
             
                   // editing accessors and related functions
             void          StartEditingMf();
             void          StopEditingMf();
             void          SetMfType(EMfType mfType)      { fMfType = mfType; }
             void          SetMfName(char* name);
             void          SetMfForce(EForce force)         { fForce = force; }
             void          SetMfOnState (EBoolean on);
             void          SetSimStart(ESimStart simStart, TTimeSim time = 0);
             void          ShowMines (EBoolean show);
             void          RedrawMines();
             
             cMfComponent* CreateComp(ECompType eCompType);
             void          DeleteComp(cMfComponent* pComp);
             cMinefield*   DuplicateMf(T2dMove& move);
             void          RestoreMfBackup();
             EBoolean      HasMfBackup()         { return (fpMfBackup == NULL) ? false : true; }
             void          MakeMineCompBackups();
             void          RestoreMineCompBackups();
             void          DeleteMineCompBackups();
             void          MoveMinefield(T2dMove& move);
             void          ShowMinefield (EBoolean show);
             void          ResetComponents ();
             void          ResetAllGrids ();
             int           GridMineCount (float spacing);

   virtual   void          SimulateMinefield();
             void          MinefieldChange();
             void          OnOffMinefield(EBoolean on);
	     void          ProcessMfRequest(TEntityID requestor, int reqNum, unsigned short filter,
                                              TEntityType objType, int numPts, TEntCoord* pPerim,
						short numReqSensors, TEntityType* pReqSensorTypes);

             void          ProcessMfRequest1(TEntityID requestor, int reqNum, unsigned short filter,
                                              TEntityType objType, int numPts, TEntCoord* pPerim);
	     void          ProcessMfRequest3(TEntityID requestor, int reqNum, unsigned short filter,
                                              TEntityType objType, int numPts, TEntCoord* pPerim,
						short numReqSensors, TEntityType* pReqSensorTypes);

   void                    InDetMfield(cDetonation* pDetonation);
             
             // working with gui
             void          SetPvdSelect( EBoolean on);
             void          SelectMfield();
             void          DeSelectMfield();
   
             void          ReplaceInList(cMinefield* pMf);
             void          RecreateVisuals();
             EBoolean      AcceptsCommands();
             
             // data files
   void                    WriteMinefieldSumm(ofstream*);
   void                    SaveMfState();
             

private:      // only minefield manager should create and delete
   void       InitMinefield(char* pName, cMinefield* pOldMf = NULL, 
                            EBoolean isBackup = false);
   void       CopyParams( cMinefield* pOldMf);
   
              cMinefield( cMinefield* pOldMf, 
                          EBoolean isBackup = false);    // for duplicating
              cMinefield( char* pName, ESimState startSimState);
   virtual   ~cMinefield();
};

enum EMfMgrState { emgrstIdle, emgrstSaving, emgrstDeleting, emgrstMoving, 
                   emgrstDuplicating, emgrstReading, emgrstSavingState };

class cMfieldMgr {

   friend class cMinefield;      // sets links
   
         // file stuff
   enum {   emmgrkwMinefield, eSizeMmgrTable };
   static   const TKeywordEntry      fKeyMmgrTable [eSizeMmgrTable];
   
protected:
   cMinefield*      fpFirstMf;
   cMinefield*      fpLastMf;
   
      // minefield saving, deleting, etc.
   EMfMgrState      feMfMgrState;
   cMine**          fppMineList;
   cMinefield**     fppMfList;
   cMfComponent**   fppCompList;
   int              fListCount;   // total number in list
   int              fListIndex;   // array index of next to save
   cOutFileObj*     fpMineFile;
   T2dMove          fMove;
   cInFileObj*      fpInFile;
   
      // backups, for canceling editing
   cMinefield*      fpMfBackupCopy;    // before editing starts, not linked or displayed
   cMinefield*      fpMfMainVersion;   // being edited, linked into list

   static void   CbStoredCoordinates (Widget, XtPointer, XmAnyCallbackStruct* cbs);
   static void   CbRepositionNow     (Widget, XtPointer, XmAnyCallbackStruct* cbs);

public:
   cMinefield*   CreateMinefield(char* pName, ESimState startSimState = esimGuiInit);
   void          ReadMinefile( cInFileObj* pFile, EBoolean sim = false);  //sim used for simulating mfs from command line
   EBoolean      ResumeReadMinefile(EBoolean sim = false);   //see above note
   EBoolean      SaveMinefile (char* filename, int count,
				          cMinefield** ppMfList, char** returnMsg);
   void          SaveNextMinefield();
   void          LoadMinefields ();
   void          DuplicateMinefields (int count, cMinefield** ppMfList,
                                      double dx, double dy, float daz);
   void          DuplicateNextMinefield ();
   void          DeleteMinefields (int count, cMinefield** ppMfList);
   void          DeleteNextMinefield ();
   void          SaveMfState (int count, cMinefield** ppMfList);
   void          SaveNextMfState ();
   void          MoveMinefields (int count, cMinefield** ppMfList, 
                                 double dx, double dy, float daz = 0.0);
   void          MoveNextMinefield ();
   void          DeleteComponents (int count, cMfComponent** ppCompList);
   void          DeleteNextComponent ();
   void          DuplicateComponents (int count, cMfComponent** ppCompList,
                                      double dx, double dy, float daz = 0.0);
   void          DuplicateNextComponent ();
   void          DeleteMine (cMine* pMine);
   void          DeleteMines (int count, cMine** ppMineList);
   void          DeleteNextMine ();

/*
   void          SetMineType (cMineComp* pMineComp, TEntityType ent_type);
   void          SetMineDepth (cMineComp* pMineComp, float depth);
   void          SetMineSpacing (cMineComp* pMineComp, float spacing);
*/

   cMinefield*   GetField(int index);               // from 1 to num fields
   cMinefield*   GetFieldByEntId(TEntityID& id);
   
   void          InDetGeneral(cDetonation* pDetonation);
   
   void          MfShutdown();

              cMfieldMgr();
             ~cMfieldMgr();
};



#endif
