/*
$RCSfile: MinefieldStatusCreate.cc,v $
$Revision: 1.1.1.1 $
$Author: jchappel $
$Date: 1999/02/16 14:54:41 $
$Log: MinefieldStatusCreate.cc,v $
Revision 1.1.1.1  1999/02/16 14:54:41  jchappel
Comprehensive Mine Simulator

// Revision 2.1  1998/11/25  18:37:51  ksnively
// Update for APLA Exercise
//
// Revision 2.0  1998/01/26  21:01:35  ksnively
// Baseline CMS before additions for AP mine replacements.
//
// Revision 1.2  1998/01/09  18:21:47  ksnively
// Integrated latest SAIC release cms3.0b2.
//
// Revision 1.1  1997/12/16  13:59:57  ksnively
// Initial revision
//
// Revision 1.4  1997/10/02  17:53:37  austin
// first working port to modsaf3.0
//
// Revision 1.3  1997/10/02  17:50:22  austin
// first working port to modsaf3.0
//
// Revision 1.3  1997/10/02  17:50:22  austin
// first working port to modsaf3.0
//
// Revision 1.2  1997/03/20  19:14:41  ksnively
// added emission tracking, updated to CMS2.0B6
//
// Revision 1.2  1997/03/20  19:14:41  ksnively
// added emission tracking, updated to CMS2.0B6
//
// Revision 1.1  1996/10/23  13:54:40  nsipes
// Initial revision
//
// Revision 1.5  1996/05/15  17:18:44  rcarp
// refinements and fixes for 1.5 delivery
//
// Revision 1.4  1996/05/14  16:15:08  rcarp
// refinements and bug fixes for 1.5 delivery
//
// Revision 1.2  1996/03/06  19:45:05  mkappel
// New Mine Status Window
//
// Revision 1.1  1996/01/23  16:52:30  rcarp
// Initial revision
//
$State: Exp $
*/
 
/*******************************************

   file: MinefieldStatusCreate.cc
   
      Copyright 1995 by the Institute for Defense Analyses
      
         Institute for Defense Analyses
         1801 N. Beauregard Street
         Alexandria, Virginia 22311-1772
         703-845-2000
         
      This software was developed by IDA under U. S. Government
      contract.  For distribution information contact:
      
         U. S. Army Night Vision Directorate
         AMSEL RD NV OD CD
         10221 Burbeck Road, suite 430
         Ft. Belvoir VA 22060-5806
      
*********************************************/

/*******************************************

   MinefieldStatusCreate.cc
   
      The display interface implementation.
      
      
   
   Created by Michael Kappel
   Modification history:
      created   
      
*********************************************/

#include "Display.h"
#include "Minefield.h"
#include "Message.h"
#include "CmsControl.h"

#include <string.h>
#include <unistd.h>

#include <Xm/ArrowBG.h>
#include <Xm/CascadeBG.h>
#include <Xm/Form.h>
#include <Xm/Frame.h>
#include <Xm/Label.h>
#include <Xm/LabelG.h>
#include <Xm/List.h>
#include <Xm/MainW.h>
#include <Xm/MenuShell.h>
#include <Xm/PanedW.h>
#include <Xm/PushB.h>
#include <Xm/RowColumn.h>
#include <Xm/ScrolledW.h>
#include <Xm/ScrollBar.h>
#include <Xm/Text.h>
#include <Xm/TextF.h>
#include <Xm/ToggleB.h>
#include <stdio.h>

void   cDispMfSummary::SwitchHilite()
{
   Pixel   backColor, foreColor;
   
   XtVaGetValues( fwMfName,
                  XmNbackground, &backColor,
                  XmNforeground, &foreColor, 
                  NULL);
                  
   XtVaSetValues( fwMfName,
                  XmNbackground, foreColor,
                  XmNforeground, backColor, 
                  NULL);
}

cDispMfSummary::cDispMfSummary(cMinefield* pMinefield)
{
   XmString   xmsText;
   Dimension  width, height;

   fpMinefield = pMinefield;

   fwMainWin = 
     XtVaCreateWidget ("fieldSumm", 
		       xmFormWidgetClass, gpGuiWin->GetMfSummParent(), 
		       XmNfractionBase, 80,
		       XmNleftAttachment, XmATTACH_FORM,
		       XmNrightAttachment, XmATTACH_FORM,
		       NULL);
   if (pMinefield->GetPrevMf())
     XtVaSetValues (fwMainWin,
		    XmNtopAttachment, XmATTACH_WIDGET,
		    XmNtopWidget, pMinefield->GetPrevMf()->GetMfSumm()->GetMainWin(),
		    NULL);
   else
     XtVaSetValues (fwMainWin,
		    XmNtopAttachment, XmATTACH_FORM,
 		    NULL);

      // minefield name
   xmsText = XmStringCreateSimple(pMinefield->GetMfName());
   fwMfName = 
     XtVaCreateManagedWidget ("fieldName", 
			      xmPushButtonWidgetClass, fwMainWin, 
			      XmNlabelString, xmsText,
			      XmNshadowThickness, 0,
			      XmNborderWidth, 0,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 1,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 15,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      NULL);
   XmStringFree(xmsText);
   XtAddCallback( fwMfName, XmNactivateCallback, 
       (XtCallbackProc)CbSelect, (XtPointer)this);

   fwSimToggle =
     XtVaCreateManagedWidget ("",
			      xmToggleButtonWidgetClass, fwMainWin,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 16,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 18,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      NULL);
   XtAddCallback( fwSimToggle, XmNvalueChangedCallback, 
       (XtCallbackProc)CbSimToggle, (XtPointer)this);

   fwOnToggle =
     XtVaCreateManagedWidget ("",
			      xmToggleButtonWidgetClass, fwMainWin,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 19,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 21,
			      XmNset, TRUE,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      NULL);
   XtAddCallback( fwOnToggle, XmNvalueChangedCallback, 
       (XtCallbackProc)CbOnToggle, (XtPointer)this);

   fwPerimToggle =
     XtVaCreateManagedWidget ("",
			      xmToggleButtonWidgetClass, fwMainWin,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 22,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 24,
			      XmNset, TRUE,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      NULL);
   XtAddCallback( fwPerimToggle, XmNvalueChangedCallback, 
       (XtCallbackProc)CbPerimToggle, (XtPointer)this);

   fwMineToggle =
     XtVaCreateManagedWidget ("",
			      xmToggleButtonWidgetClass, fwMainWin,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 25,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 27,
			      XmNset, TRUE,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      NULL);
   XtAddCallback( fwMineToggle, XmNvalueChangedCallback, 
       (XtCallbackProc)CbMineToggle, (XtPointer)this);

   fwFixtToggle =
     XtVaCreateManagedWidget ("",
			      xmToggleButtonWidgetClass, fwMainWin,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 28,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 30,
			      XmNset, FALSE,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      XmNsensitive, FALSE,
			      NULL);
   XtAddCallback( fwFixtToggle, XmNvalueChangedCallback, 
       (XtCallbackProc)CbFixtToggle, (XtPointer)this);
   
   fwLabelToggle =
     XtVaCreateManagedWidget ("",
			      xmToggleButtonWidgetClass, fwMainWin,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 31,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 33,
			      XmNset, TRUE,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      NULL);
   XtAddCallback( fwLabelToggle, XmNvalueChangedCallback, 
       (XtCallbackProc)CbLabelToggle, (XtPointer)this);

      // minefield values
   xmsText = XmStringCreateSimple("0");
   fwTotalMines = 
     XtVaCreateManagedWidget ("totMines", 
			      xmLabelWidgetClass, fwMainWin, 
			      XmNlabelString, xmsText,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 35,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 40,
			      XmNalignment, XmALIGNMENT_END,
			      NULL);
   XmStringFree(xmsText);
   
   xmsText = XmStringCreateSimple("0");
   fwLiveMines = 
     XtVaCreateManagedWidget ("liveMines", 
			      xmLabelWidgetClass, fwMainWin, 
			      XmNlabelString, xmsText,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 41,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 46,
			      XmNalignment, XmALIGNMENT_END,
			      NULL);
   XmStringFree(xmsText);
   
   xmsText = XmStringCreateSimple("0");
   fwFiredMines = 
     XtVaCreateManagedWidget ("firedMines", 
			      xmLabelWidgetClass, fwMainWin, 
			      XmNlabelString, xmsText,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 47,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 52,
			      XmNalignment, XmALIGNMENT_END,
			      NULL);
   XmStringFree(xmsText);
   
   xmsText = XmStringCreateSimple("0");
   fwOtherMines = 
     XtVaCreateManagedWidget ("otherMines", 
			      xmLabelWidgetClass, fwMainWin, 
			      XmNlabelString, xmsText,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 53,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 58,
			      XmNalignment, XmALIGNMENT_END,	
			      NULL);
   XmStringFree(xmsText);
   
   xmsText = XmStringCreateSimple("0");
   fwVehHits =
     XtVaCreateManagedWidget ("vehHit", 
			      xmLabelWidgetClass, fwMainWin, 
			      XmNlabelString, xmsText,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 60,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 65,
			      XmNalignment, XmALIGNMENT_END,
			      NULL);
   XmStringFree(xmsText);
   
   xmsText = XmStringCreateSimple("0");
   fwVehKills =
     XtVaCreateManagedWidget ("vehKilled", 
			      xmLabelWidgetClass, fwMainWin, 
			      XmNlabelString, xmsText,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 66,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 71,
			      XmNalignment, XmALIGNMENT_END,
			      NULL);
   XmStringFree(xmsText);

   XtVaGetValues (XtParent (fwMainWin),
		  XmNwidth, &width,
		  NULL);
   XtVaGetValues (fwMfName,
		  XmNheight, &height,
		  NULL);
   XtVaSetValues (fwMainWin,
		  XmNheight, height,
		  XmNwidth, width,
		  NULL);
   XtManageChild(fwMainWin);
}

cDispMfSummary::~cDispMfSummary()
{
  if (fpMinefield->GetNextMf()) {
    if (fpMinefield->GetPrevMf())
      XtVaSetValues (fpMinefield->GetNextMf()->GetMfSumm()->GetMainWin(),
		     XmNtopAttachment, XmATTACH_WIDGET,
		     XmNtopWidget, fpMinefield->GetPrevMf()->GetMfSumm()->GetMainWin(),
		     NULL);
    else
      XtVaSetValues (fpMinefield->GetNextMf()->GetMfSumm()->GetMainWin(),
		     XmNtopAttachment, XmATTACH_FORM,
		     NULL);
  }

  XtDestroyWidget (fwMainWin);
}

Widget        cMinefieldStatusWindow::CreateHeadings(Widget wParent)
{
   Widget     wHeadings, wLabel1, wLabel2;
   XmString   xmsText;
   Dimension  height, h;
   
   wHeadings = 
     XtVaCreateWidget ("headings", 
		       xmFormWidgetClass, wParent,
		       XmNfractionBase, 80,
		       NULL);

   xmsText = XmStringCreateSimple("- Control -");
   wLabel1 = 
     XtVaCreateManagedWidget ("simButtonHd", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNalignment, XmALIGNMENT_CENTER,
			      XmNtopAttachment, XmATTACH_FORM,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 16,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 21,
			      NULL);
   XmStringFree(xmsText);

   xmsText = XmStringCreateSimple("Sim");
   wLabel2 = 
     XtVaCreateManagedWidget ("simButtonHd", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, wLabel1,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 16,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 19,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      NULL);
   XmStringFree(xmsText);

   xmsText = XmStringCreateSimple("On");
   wLabel2 = 
     XtVaCreateManagedWidget ("simButtonHd", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, wLabel1,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 19,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 22,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      NULL);
   XmStringFree(xmsText);

      // minefield name
   xmsText = XmStringCreateSimple("Minefield Name");
   wLabel2 = 
     XtVaCreateManagedWidget ("fieldNameHd", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, wLabel1,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 1,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 15,
			      NULL);
   XmStringFree(xmsText);
   
   xmsText = XmStringCreateSimple("----- Display -----");
   wLabel1 = 
     XtVaCreateManagedWidget ("perimButtonHd", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNalignment, XmALIGNMENT_CENTER,
			      XmNtopAttachment, XmATTACH_FORM,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 22,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 33,
			      NULL);
   XmStringFree(xmsText);

   xmsText = XmStringCreateSimple("Peri");
   wLabel2 = 
     XtVaCreateManagedWidget ("perimButtonHd", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, wLabel1,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 22,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 25,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      NULL);
   XmStringFree(xmsText);

   xmsText = XmStringCreateSimple("Mine");
   wLabel2 = 
     XtVaCreateManagedWidget ("perimButtonHd", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, wLabel1,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 25,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 28,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      NULL);
   XmStringFree(xmsText);

   xmsText = XmStringCreateSimple("Fixt");
   wLabel2 = 
     XtVaCreateManagedWidget ("perimButtonHd", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, wLabel1,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 28,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 31,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      NULL);
   XmStringFree(xmsText);

   xmsText = XmStringCreateSimple("Lab");
   wLabel2 = 
     XtVaCreateManagedWidget ("perimButtonHd", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, wLabel1,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 31,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 33,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      NULL);
   XmStringFree(xmsText);

      // mines
   xmsText = XmStringCreateSimple("-------------- Mines ---------------");
   wLabel1 = 
     XtVaCreateManagedWidget ("totMinesHd", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNalignment, XmALIGNMENT_CENTER,
			      XmNtopAttachment, XmATTACH_FORM,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 35,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 58,
			      NULL);
   XmStringFree(xmsText);
   
   xmsText = XmStringCreateSimple("Total");
   wLabel2 = 
     XtVaCreateManagedWidget ("totMinesHd", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNalignment, XmALIGNMENT_END,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, wLabel1,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 35,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 40,
			      NULL);
   XmStringFree(xmsText);
   
   xmsText = XmStringCreateSimple("Live");
   wLabel2 = 
     XtVaCreateManagedWidget ("totMinesHd", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNalignment, XmALIGNMENT_END,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, wLabel1,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 41,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 46,
			      NULL);
   XmStringFree(xmsText);
   
   xmsText = XmStringCreateSimple("Fired");
   wLabel2 = 
     XtVaCreateManagedWidget ("totMinesHd", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNalignment, XmALIGNMENT_END,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, wLabel1,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 47,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 52,
			      NULL);
   XmStringFree(xmsText);
   
   xmsText = XmStringCreateSimple("Other");
   wLabel2 = 
     XtVaCreateManagedWidget ("totMinesHd", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNalignment, XmALIGNMENT_END,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, wLabel1,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 53,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 58,
			      NULL);
   XmStringFree(xmsText);
   
      // vehicles
   xmsText = XmStringCreateSimple("----- Vehicles -----");
   wLabel1 = 
     XtVaCreateManagedWidget ("vehHitHd", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNalignment, XmALIGNMENT_CENTER,
			      XmNtopAttachment, XmATTACH_FORM,
			      XmNleftPosition, 60,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 71,
			      NULL);
   XmStringFree(xmsText);
   
   xmsText = XmStringCreateSimple("Hit");
   wLabel2 = 
     XtVaCreateManagedWidget ("vehHitHd", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNalignment, XmALIGNMENT_END,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, wLabel1,
			      XmNleftPosition, 60,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 65,
			      NULL);
   XmStringFree(xmsText);
   
   xmsText = XmStringCreateSimple("Killed");
   wLabel2 = 
     XtVaCreateManagedWidget ("vehHitHd", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNalignment, XmALIGNMENT_END,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, wLabel1,
			      XmNleftPosition, 66,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 71,
			      NULL);
   XmStringFree(xmsText);

   XtVaGetValues (wHeadings, XmNmarginHeight, &h, NULL);
   XtVaGetValues (wLabel1, XmNheight, &height, NULL);
   height = 2 * height + 3 * h ;
   XtVaSetValues (wHeadings,
		  XmNpaneMinimum, height,
		  XmNpaneMaximum, height,
		  NULL);
   
   XtManageChild (wHeadings);
   return wHeadings;
}

Widget cMinefieldStatusWindow::CreateActionArea(Widget wParent)
{
   Widget     wActionArea;
   Dimension  height, h;

   wActionArea = 
     XtVaCreateWidget ("rowcol", 
             xmRowColumnWidgetClass, wParent, 
             XmNorientation, XmHORIZONTAL,
             XmNleftAttachment, XmATTACH_FORM,
             XmNbottomAttachment, XmATTACH_FORM,
             NULL);

   fwCreateButton = 
     XtVaCreateManagedWidget ("Create", 
               xmPushButtonWidgetClass, wActionArea,
               NULL);
   XtAddCallback( fwCreateButton, XmNactivateCallback, 
       (XtCallbackProc)CbCreate, (XtPointer)this);

   fwEditButton = 
     XtVaCreateManagedWidget ("Edit", 
               xmPushButtonWidgetClass, wActionArea,
               NULL);
   XtAddCallback( fwEditButton, XmNactivateCallback, 
       (XtCallbackProc)CbEdit, (XtPointer)this);

   fwDuplicateButton = 
     XtVaCreateManagedWidget ("Duplicate", 
               xmPushButtonWidgetClass, wActionArea,
               NULL);
   XtAddCallback( fwDuplicateButton, XmNactivateCallback, 
       (XtCallbackProc)CbDuplicate, (XtPointer)this);

   fwDeleteButton = 
     XtVaCreateManagedWidget ("Delete", 
               xmPushButtonWidgetClass, wActionArea,
               NULL);
   XtAddCallback( fwDeleteButton, XmNactivateCallback, 
       (XtCallbackProc)CbDelete, (XtPointer)this);

   fwZoomButton = 
     XtVaCreateManagedWidget ("Zoom", 
               xmPushButtonWidgetClass, wActionArea,
               NULL);
   XtAddCallback( fwZoomButton, XmNactivateCallback, 
       (XtCallbackProc)CbZoom, (XtPointer)this);

   fwSendCmdButton = 
     XtVaCreateManagedWidget ("Send Cmd", 
			      xmPushButtonWidgetClass, wActionArea,
			      XmNsensitive, FALSE,
			      NULL);
   XtAddCallback( fwSendCmdButton, XmNactivateCallback, 
       (XtCallbackProc)CbSendCmd, (XtPointer)this);

   fwSaveMfsButton = 
     XtVaCreateManagedWidget ("Save Mfld(s)", 
               xmPushButtonWidgetClass, wActionArea,
               NULL);
   XtAddCallback( fwSaveMfsButton, XmNactivateCallback, 
       (XtCallbackProc)CbSaveMfs, (XtPointer)this);

   fwLoadMfsButton = 
     XtVaCreateManagedWidget ("Load Mfld(s)", 
               xmPushButtonWidgetClass, wActionArea,
               NULL);
   XtAddCallback( fwLoadMfsButton, XmNactivateCallback, 
       (XtCallbackProc)CbLoadMfs, (XtPointer)this);

   fwSaveTblButton = 
     XtVaCreateManagedWidget ("Save Status", 
			      xmPushButtonWidgetClass, wActionArea,
//			      XmNsensitive, FALSE,
			      NULL);
   XtAddCallback( fwSaveTblButton, XmNactivateCallback, 
       (XtCallbackProc)CbSaveTbl, (XtPointer)this);
   fwPrintTblButton = 
     XtVaCreateManagedWidget ("Print Status", 
			      xmPushButtonWidgetClass, wActionArea,
			      XmNsensitive, FALSE,
			      NULL);
   XtAddCallback( fwPrintTblButton, XmNactivateCallback, 
       (XtCallbackProc)CbPrintTbl, (XtPointer)this);

   XtVaGetValues (wActionArea, XmNmarginHeight, &h, NULL);
   XtVaGetValues (fwCreateButton, XmNheight, &height, NULL);
   height += 2 * h;
   XtVaSetValues (wActionArea,
        XmNpaneMinimum, height,
        XmNpaneMaximum, height,
        NULL);

   XtManageChild (wActionArea);
   return wActionArea;
}

Widget    cMinefieldStatusWindow::CreateSummaryArea (Widget wParent)
{
   Widget        wScrolled, vsb;
   int           width;

   width = WidthOfScreen(XtScreen(fwTopLevelShell)) - 100;
   wScrolled = 
     XtVaCreateManagedWidget ("statusScrolled", 
			      xmScrolledWindowWidgetClass, wParent,
			      XmNscrollingPolicy, XmAPPLICATION_DEFINED,
//			      XmNwidth, width,
//			      XmNheight, 200,
			      NULL);

   vsb = XtVaCreateManagedWidget ("scrollbar",
				  xmScrollBarWidgetClass, wScrolled,
				  XmNorientation, XmVERTICAL,
				  XmNmaximum, 2,
				  NULL);

   fwSummList = 
     XtVaCreateManagedWidget ("statusList", 
			      xmFormWidgetClass, wScrolled, 
			      XmNheight, 200,
			      XmNwidth, width,
			      NULL);

   XmScrolledWindowSetAreas (wScrolled, NULL, vsb, fwSummList);
   XtAddCallback (vsb, XmNvalueChangedCallback, 
		  (XtCallbackProc)CbScroll, fwSummList);

   return fwSummList;
}

cMinefieldStatusWindow::cMinefieldStatusWindow (Widget wParent)
   // the constructor creates the window and its widgets,
   // initializing with input values
{
   Widget        wHeadings, wSummary, wActionArea;
   /*
   char filename,  msg[199];
   char *cwd = NULL;
   char *tmp = NULL;
   char *mfin = NULL;
   cInFileObj* pMineFile;
   int i, sbuff;
   */

   fwMainWin =
     XtVaCreateWidget ("pane",
             xmPanedWindowWidgetClass, wParent,
             XmNtopAttachment, XmATTACH_FORM,
             XmNbottomAttachment, XmATTACH_FORM,
             NULL);
             
   wHeadings = CreateHeadings (fwMainWin);
   
   wSummary = CreateSummaryArea (fwMainWin);
   
   wActionArea = CreateActionArea (fwMainWin);
 
   /*
   // here is where the minefields from the command line are loaded

   if ( gCmsMgr.fStartupParam.fNumMineFiles != 0 ){

      sbuff = 100;

      //Need to get directory for minefield input into cwd.
      //We need only do this once.
      if (gCmsMgr.fStartupParam.fDirMfInput[0] != '/') {
	 //The input directory is relative
	 while((tmp = getcwd(NULL, sbuff)) == NULL){
	    sbuff = sbuff + 50;
	 }
         cwd = new char[strlen(tmp) + strlen(gCmsMgr.fStartupParam.fDirMfInput) + 3];
         strcpy (cwd, tmp);
	 free (tmp);
	 strcat (cwd, "/" );
	 strcat (cwd, gCmsMgr.fStartupParam.fDirMfInput );
	 strcat (cwd, "/" );
      }
      else { // if ( fDirMfInput[0] != '/')
	 //The input directory is an absolute path
	 cwd = new char[strlen(gCmsMgr.fStartupParam.fDirMfInput) + 2];
	 strcpy (cwd, gCmsMgr.fStartupParam.fDirMfInput);
	 if (cwd[strlen(cwd)-1] != '/')
	    strcat(cwd, "/");
      }// end else

      //cout << endl << endl << "dir: " << cwd << endl<< endl;
      //Open and read each input file
      for ( i = 0 ; i < gCmsMgr.fStartupParam.fNumMineFiles ; i++ ){
	 // Build Minefile name(s)
	 if (gCmsMgr.fStartupParam.fMineFilenames[i].ffilename[0] != '.' 
	     && gCmsMgr.fStartupParam.fMineFilenames[i].ffilename[0] != '/') {
	    //Minefield file is in the minefield input directory
	    mfin = new char[strlen(cwd) + strlen (gCmsMgr.fStartupParam.fMineFilenames[i].ffilename) + 1];
	    strcpy (mfin, cwd);
	    strcat (mfin, gCmsMgr.fStartupParam.fMineFilenames[i].ffilename);
	 }
	 else {
	    //Minefile has been specified from current directory
	    mfin = new char[strlen (gCmsMgr.fStartupParam.fMineFilenames[i].ffilename) + 1];
	    strcpy (mfin, gCmsMgr.fStartupParam.fMineFilenames[i].ffilename);
	 }
	 //cout << endl << endl << "mf: " << mfin << endl<< endl;

         pMineFile = new cInFileObj;
         if ( !pMineFile->Open(mfin, gftypeMinefields) ) {
            sprintf (msg, "Cannot open %s for input", cwd);
         }
	 else {
	    //We have a valid file, read in the minefield.
	    new cReadMineFileMsg (pMineFile, gCmsMgr.fStartupParam.fMineFilenames[i].fesim ); 
	 }
	 delete [] mfin;
      } // end for
      delete [] cwd;
 
   } // end if (NumMineFiles != 0)
   */
}

cMinefieldStatusWindow::~cMinefieldStatusWindow()
{
}
