/* main_options:
 *
 * This structure defines the command line options.  To add a new option:
 *
 * 1) Add a member to this structure.
 * 2) Initialize this new member in main.c
 */
extern struct main_options_struct
{
#ifdef USE_MOTIF
    CMD_TOGGLE_OPTION  gui;
    CMD_TOGGLE_OPTION  activate;
#endif
    CMD_TOGGLE_OPTION  simulate;
    CMD_INTEGER_OPTION benchmark;
    CMD_FLOAT_OPTION   competence;
    CMD_FLOAT_OPTION   vul_modifier;
    CMD_INTEGER_OPTION previewers;
#ifdef USE_MCAGENT
    CMD_BOOLEAN_OPTION mcagent;
#endif
#ifdef USE_RITN
    CMD_BOOLEAN_OPTION safritn;
#endif /*USE_RITN*/
    CMD_INTEGER_OPTION absolute_timestamps;
    CMD_INTEGER_OPTION trust_timestamps;
    CMD_FLOAT_OPTION   load;
    CMD_STRING_OPTION  scenarios;
    CMD_STRING_OPTION  profiles;
    CMD_STRING_OPTION  overlays;
    CMD_STRING_OPTION  logs;
    CMD_STRING_OPTION  views;
    CMD_STRING_OPTION  templates;
    CMD_STRING_OPTION  stdloads;
    CMD_STRING_OPTION  data;
    CMD_TOGGLE_OPTION  bigcursor;
    CMD_BOOLEAN_OPTION routemap;
    CMD_TOGGLE_OPTION  memmon;
    CMD_INTEGER_OPTION stealth_site;
    CMD_INTEGER_OPTION stealth_host;
    CMD_BOOLEAN_OPTION safparse;
    CMD_STRING_OPTION  sourcefile;
    CMD_BOOLEAN_OPTION vpdu_stcg;
    CMD_BOOLEAN_OPTION vpdu_tgtacq;
    CMD_BOOLEAN_OPTION vpdu_delacc;
    CMD_BOOLEAN_OPTION vpdu_dfdam;
    CMD_BOOLEAN_OPTION vpdu_ifdam;
    CMD_BOOLEAN_OPTION mkill_cants_vehicle;
    CMD_BOOLEAN_OPTION fkill_droops_gun;
    CMD_BOOLEAN_OPTION best_ammo_match;
    CMD_BOOLEAN_OPTION assert;
    CMD_BOOLEAN_OPTION fpes;
    CMD_TOGGLE_OPTION  relative_battle;
    CMD_BOOLEAN_OPTION modify_competence;
    CMD_BOOLEAN_OPTION envnonconstant;
    CMD_BOOLEAN_OPTION dustbehavior;
    CMD_BOOLEAN_OPTION phen_behavior;
    CMD_BOOLEAN_OPTION envweathersim;
    CMD_BOOLEAN_OPTION envseasim;
    CMD_BOOLEAN_OPTION envstats;
    CMD_BOOLEAN_OPTION modstealth;
    CMD_INTEGER_OPTION smoke_rep;
    CMD_STRING_OPTION  viewfile;
    CMD_STRING_OPTION  tmplfile;
    CMD_BOOLEAN_OPTION send_rfpi;
    CMD_BOOLEAN_OPTION skip_dfdam;
    CMD_TOGGLE_OPTION  ccsil;
    CMD_BOOLEAN_OPTION dtsim;
    CMD_BOOLEAN_OPTION dtscribe;
#ifdef USE_CLCGF
    CMD_TOGGLE_OPTION  aspdu;
#endif /* USE_CLCGF */
    CMD_INTEGER_OPTION network_monitor;
    CMD_STRING_OPTION  network_monitor_address;
    CMD_BOOLEAN_OPTION simple_iff;
    CMD_BOOLEAN_OPTION force_supply_consumption;
    CMD_BOOLEAN_OPTION damage_editor_on;
    CMD_BOOLEAN_OPTION random_failure_on;
#ifdef PERSIM
    CMD_INTEGER_OPTION ig;
#endif 
    CMD_BOOLEAN_OPTION  env_hydro_mode;
    CMD_BOOLEAN_OPTION software_version;
} main_options;



