/*
$RCSfile: ApMine.h,v $
$Revision: 1.3 $
$Author: ksnively $
$Date: 1999/06/04 17:31:54 $
$Log: ApMine.h,v $
Revision 1.3  1999/06/04 17:31:54  ksnively
Revision 4.2.  Compilies under multiple OS.  Single detonation for Cmd Det mines.

Revision 1.2  1999/04/29 19:34:01  ksnively
Incorporated ARDEC addtions:  Tripwire AP mines and a Control Window.

Revision 1.1.1.1  1999/02/16 14:54:46  jchappel
Comprehensive Mine Simulator


 * Revision 2.3  1998/12/02  16:37:32  jchappel
 * added gui detonator
 *
 * Revision 2.2  1998/02/18  20:10:33  ksnively
 * Ap mine replacement bug fixes
 *
 * Revision 2.1  1998/02/18  17:17:24  ksnively
 * Incorporated AP mine replacement code
 *
 * Revision 2.0  1998/01/26  21:04:20  ksnively
 * Baseline CMS before additions for AP mine replacements.
 *
 * Revision 1.1  1997/12/16  13:59:57  ksnively
 * Initial revision
 *
 * Revision 1.3  1997/10/27  17:07:30  trang
 * BUILD1
 *
 * Revision 1.2  1997/10/02  17:47:47  austin
 * first working port to modsaf3.0
 *
Revision 1.2  1997/10/02 17:47:47  austin
first working port to modsaf3.0

 * Revision 1.1  1996/10/23  13:54:40  nsipes
 * Initial revision
 *
 * Revision 1.1  1996/10/23  13:54:40  nsipes
 * Initial revision
 *
 * Revision 1.6  1996/06/19  19:05:45  rcarp
 * revisions for mine vulnerability, version 1.5b2
 *
 * Revision 1.5  1996/05/21  22:12:12  rcarp
 * text and lists from mine db, and activating mine state save cmd
 *
 * Revision 1.4  1996/05/08  00:46:50  rcarp
 * changes for 1.5, incl user mines, mine params, param i/o, selection
 *
 * Revision 1.4  1996/05/08  00:46:50  rcarp
 * changes for 1.5, incl user mines, mine params, param i/o, selection
 *
 * Revision 1.3  1996/02/16  21:41:55  rcarp
 * revisions for getting mine wide area and directional range
 *
 * Revision 1.2  1996/02/05  14:31:34  rcarp
 * Updates and bug fixes of release version 1.1b5
 *
$State: Exp $
*/
 
/*******************************************

   file: ApMine.h
   
      Copyright 1995 by the Institute for Defense Analyses
      
         Institute for Defense Analyses
         1801 N. Beauregard Street
         Alexandria, Virginia 22311-1772
         703-845-2000
         
      This software was developed by IDA under U. S. Government
      contract.  For distribution information contact:
      
         U. S. Army Night Vision Directorate
         AMSEL RD NV OD CD
         10221 Burbeck Road, suite 430
         Ft. Belvoir VA 22060-5806
      
*********************************************/

/*******************************************

   ApMine.h
   
      The AP mine header file defines AP mine classes,
      
      
   
   Created by Richard Carpenter
   Modification history:
      created   
      
*********************************************/

#ifndef _UApMine_
#define _UApMine_

#include "Globals.h"
#include "Minefield.h"
#include "Vehicle.h"
#include "EntityDB.h"
#include "AtMine.h"

// ************************************
//   basic types
// ************************************

// ************************************
//   component classes
// ************************************

/*
class cLifeTracker : public cTracker {
   // tracks land life forms and platforms
protected:

public:
   virtual int    GetTrackType(const TEntityType& type);
   

            cLifeTracker(cEntity* pRefEnt, float range, EBoolean useVelCoord = true) : 
                        cTracker(pRefEnt, range, useVelCoord) {}
   virtual ~cLifeTracker();
};
*/

// ************************************
//   mine classes
// ************************************
struct TLinkDetData : public T2link {
   TDetonationData* fpDetData;
    cVehicle*        fpVehicle;
   
   TDetonationData* GetDetData() { return fpDetData; }
   cVehicle*        GetDetVeh() { return fpVehicle; }
   
   TLinkDetData(TDetonationData* pDetData, cVehicle* pVeh, T2link* pPrev) : T2link(pPrev) 
         {fpDetData = pDetData; fpVehicle = pVeh;}
   virtual ~TLinkDetData();
};

struct TFuzeParamApCmdDet : public TFuzeParam {

   float         fRangeErrMax;
   float         fAzimuthErrMax;
   float         fMaxRange;
   float         fCrossRange;

	enum {
		eapcdfuzekwFuzeTypeName,      // intercept type name, don't' allow unuseable types
      eapcdfuzekwFireOffset,
      eapcdfuzekwRange,
      eapcdfuzekwCrossRange,
		eapcdfuzekwRangeErrMax,
		eapcdfuzekwAzErrMax,

		eapcdfuzeSizeTable
	};
 
   static const TKeywordEntry fKeyApCdFuzeTable[eapcdfuzeSizeTable];

   virtual EBoolean     ParseDbStructItem(cInFileObj& infile);

   virtual   cControl*     CreateControl(cSimMine* pMine, const TFuzeOpt& fuzeOpt );

   virtual EBoolean   IsDirectional(TFlatEntCoord* pMinMax);
   virtual EBoolean   IsWideArea(float* pRange);
   
   virtual   TFuzeParam*   CloneFuzeParam();
   
            TFuzeParamApCmdDet(int type = efuzetypeCommandFire);
   virtual ~TFuzeParamApCmdDet();
};

struct TFuzeParamApTripCmdDet : public TFuzeParam {

      // the tracking range fTrackRange is set 5m beyond the wire length,
      //   and used to key higher update rates
      // the wire length is kept in  fFireOffset.x as well as fWireLength
   int           fNumWires;
   EBoolean      fbMultiShot;
   float         fShotRange;
   float         fWireLength;
   float         fTripProb;
   float         fArmDuration;   // sim time internally, but read in seconds
   T2Dsingle     fMsgDelay;      // sim time internally, but read in seconds
   T2Dsingle     fCmdDelay;      // sim time internally, but read in seconds
   float         fTgtRange;
   EBoolean      fbDirectional;  // for use with mines with two trip wires, primarily
   float         fHalfAngle;     // half angle for opening direction

	enum {
		eaptcdfuzekwFuzeTypeName,      // intercept type name, don't' allow unuseable types
      eaptcdfuzekwNumWires,
      eaptcdfuzekwMultiShot,
      eaptcdfuzekwShotRange,
		eaptcdfuzekwWireLength,
		eaptcdfuzekwTripProb,
		eaptcdfuzekwArmDuration,
		eaptcdfuzekwMsgDelay,
		eaptcdfuzekwCmdDelay,
		eaptcdfuzekwTgtRange,
		eaptcdfuzekwDirectional,
		eaptcdfuzekwHalfAng,

		eaptcdfuzeSizeTable
	};
 
   static const TKeywordEntry fKeyApTripCdFuzeTable[eaptcdfuzeSizeTable];

   virtual EBoolean     ParseDbStructItem(cInFileObj& infile);

   virtual   cControl*     CreateControl(cSimMine* pMine, const TFuzeOpt& fuzeOpt );

   virtual EBoolean   IsDirectional(TFlatEntCoord* pMinMax);
   virtual EBoolean   IsWideArea(float* pRange);
   
   virtual   TFuzeParam*   CloneFuzeParam();
   
            TFuzeParamApTripCmdDet(int type = efuzetypeTripCommandFire);
   virtual ~TFuzeParamApTripCmdDet();
};

class cTripWire {
   public:
      cTripWire*   fpNextWire;   // just a singly linked list, no editing done
      
      EBoolean   fbTripped;
      EBoolean   fbFired;       // used by controller to tell if munition fired
      TTimeSim   fTimeTripped;
      TTimeSim   fTimeout;
      float      fTripProb;
      float      fAzimuth;      // owner must set ref system and pass down
      float      fLength;
            // keep deton data, for multishot mines with deton at different locations
      TDetonationData       fDetonationData;
      
      cTripWire*   GetNextWire()  { return fpNextWire; }
      EBoolean   UpdateTripWire(T2Dpolar loc1, T2Dpolar loc2, EBoolean bCross, TTimeSim timeout);   // returns true if tripped this update
      
      EBoolean   IsTripped()   { return fbTripped; }
      EBoolean   IsFired()     { return fbFired; }
      void       SetFired()    { fbFired = true; }
      TTimeSim   GetTripTime() { return fTimeTripped; }
      TTimeSim   GetTimeout()  { return fTimeout; }
      float      GetAz() { return fAzimuth; }
      TDetonationData&      GetDetonationData()  { return fDetonationData; }
      
      cTripWire(float prob, float az, float len,
                     TDetonationData mineDetData, cTripWire* pPrevWire);
      ~cTripWire();
};

class cTripWireTracker : public cLandTracker {

 public:

   virtual cLinkVehGeom*   CreateNewTrack(cLinkVehLoc* pProxLink, cLinkVeh* pPrev);
   virtual cLinkVehGeom*   CreateCopyTrack(cLinkVehGeom* pOldTrkLink, cLinkVeh* pPrev);

            cTripWireTracker(cEntity* pRefEnt, float range, EBoolean useVelCoord = false, 
			          EBoolean tracksVeh = true, EBoolean tracksPers = true)  : 
                     cLandTracker(pRefEnt, range, useVelCoord, tracksVeh, tracksPers) {}
   virtual ~cTripWireTracker();
};

class cCmdFireControl : public cMineControl {

protected:
   float      fAzimuth;   // fire angle, from centerline
   EBoolean   fbTgtPending;
   TTimeSim   fTripTime;
   TTimeSim   fReactTime;
   static void   CbDetonate (Widget, XtPointer pObj, XmAnyCallbackStruct* cbs);
   static void   CbIgnore (Widget, XtPointer, XmAnyCallbackStruct* cbs);
   
public:
   virtual void    WriteInteraction (int event);

   virtual void    UpdateControl(cVehListHead* pVehList, cEmissListHead* pEmissList, TTimeSim* pWaitTime);
   
           EBoolean   InFootprint(cLinkVehGeom* pTgtLink);

            cCmdFireControl(cSimMine* pMine, TFlatEntCoord fireOffset, const TFuzeOpt& fuzeOpt);

   virtual ~cCmdFireControl();
};

class cTripCmdFireControl : public cMineControl {

protected:
   cTripWire*      fpTripWireList;
   TTimeSim        fFireTimeout;
   EBoolean        fbMultiShot;
   
public:
   
   virtual void    UpdateControl(cVehListHead* pVehList, cEmissListHead* pEmissList, TTimeSim* pWaitTime);
           void    ProcessFireMsg(EMfCmdMode eCurMode);
           
            cTripCmdFireControl(cSimMine* pMine, TFlatEntCoord fireOffset, 
         const TFuzeOpt& fuzeOpt, TFuzeParamApTripCmdDet* pFuzeParam);

   virtual ~cTripCmdFireControl();
};

class cApMine : public cSimMine {

 friend class cDbMine_cApMine;

 private:
   static  TEntityType   fsApMineEntityType;
   static  char*         fsApMineName;
   static  char*         fsApMineAltName;
   static int           fsDefaultFuzeType;   // for initializing database
   
   static   cDbMine_cApMine     fsDbApMine;      // the instantiation in mine database
   
 protected:
         // param input functions

public:
   

           // constructor for virtual mine, for component sensor
    cApMine(cMineComp* pParent, float radius);

           // constructor for creation from gui, planning mine
    cApMine( cPlanMine* pPlan = NULL );

           // constructor for reading from file, only used when sim host without gui
//    cAtMine(cMineComp* pParent, cDbMine* pDbMine, TMinePlaceParam& emplace, TDbOptSet opt);

   virtual   ~cApMine();
};

class cApConv : public cApMine {

 friend class cDbMine_cApConv;

 private:
   static  TEntityType   fsApConvMineEntityType;
   static  char*         fsApConvMineName;
   static  char*         fsApConvMineAltName;
   static int           fsDefaultFuzeType;   // for initializing database
   
   static   cDbMine_cApConv     fsDbApConv;      // the instantiation in mine database
   
 protected:
         // param input functions

public:

           // constructor for virtual mine, for component sensor
   //cApConv(cMineComp* pParent, float radius);

           // constructor for creation from gui, planning mine
    cApConv( cPlanMine* pPlan = NULL );

   virtual   ~cApConv();
};

class cApScatterable : public cApMine {

 friend class cDbMine_cApScatterable;

 private:
   static  TEntityType   fsApScatMineEntityType;
   static  char*         fsApScatMineName;
   static  char*         fsApScatMineAltName;
   static int           fsDefaultFuzeType;   // for initializing database

   static   cDbMine_cApScatterable   fsDbApScatterable;      // the instantiation in mine database
   
 protected:
         // param input functions

public:

           // constructor for virtual mine, for component sensor
    cApScatterable(cMineComp* pParent, float radius);

           // constructor for creation from gui, planning mine
    cApScatterable( cPlanMine* pPlan = NULL );
    
    virtual ~cApScatterable();
};

class cApConvBding : public cApMine {

 friend class cDbMine_cApConvBding;

 private:
   static  TEntityType   fsApConvBdgMineEntityType;
   static  char*         fsApConvBdgMineName;
   static  char*         fsApConvBdgMineAltName;
   static int           fsDefaultFuzeType;   // for initializing database

   static   cDbMine_cApConvBding     fsDbApConvBding;      // the instantiation in mine database
   
 protected:
         // param input functions

public:

           // constructor for virtual mine, for component sensor
    cApConvBding(cMineComp* pParent, float radius);

           // constructor for creation from gui, planning mine
    cApConvBding( cPlanMine* pPlan = NULL );

   virtual   ~cApConvBding();
};

class cApScatBding : public cApMine {

 friend class cDbMine_cApScatBding;

 private:
   static  TEntityType   fsApScatBdgMineEntityType;
   static  char*         fsApScatBdgMineName;
   static  char*         fsApScatBdgMineAltName;
   static int           fsDefaultFuzeType;   // for initializing database

   static   cDbMine_cApScatBding     fsDbApScatBding;      // the instantiation in mine database
   
 protected:
         // param input functions

public:

           // constructor for virtual mine, for component sensor
    cApScatBding(cMineComp* pParent, float radius);

           // constructor for creation from gui, planning mine
    cApScatBding(cPlanMine* pPlan);
    
    virtual ~cApScatBding();
};

class cApCommandDet : public cApMine {

// friend class cDbMine_cApWideArea;
 
 public:
   enum ECmdType { ecmdFire, ecmdLoc, ecmdFireDir};

 private:
   static  TEntityType   fsApCommandDetMineEntityType;
   static  char*         fsApCommandDetMineName;
   static  char*         fsApCommandDetMineAltName;
   static  int           fsApCommandDetDefaultFuzeType;   // for initializing database

   static   cDbMine_cApCommandDet     fsDbApCommandDet;      // the instantiation in mine database
   
 protected:
   T2linkHead         fHitTgtDetList;      // detonations on tgts in range
   ECmdType           fCmdType;

public:
   enum EOpEvent {eopNone, eopIgnore, eopDetonate};
   EOpEvent             feOpEvent;

//   virtual   void          SimulateMine();
   virtual      void    CmdDet();
   virtual      void    CmdDet(TLocation tccPt);
                void    CheckTgts(EBoolean eUseVehLoc, EBoolean eSendDetPdu);
   virtual      void    SelectObj();      // sets for cmd det
   virtual      void    DeSelectObj();
   virtual      void    CheckVehDamage(cVehicle* pVeh);
   virtual      void    UpdateInteractions();

           // constructor for creation from gui, planning mine
    cApCommandDet( cPlanMine* pPlan = NULL ) ;
    
    virtual ~cApCommandDet();
};

class cApTripCommandDet : public cApMine {
 
 public:
   enum ECmdType { ecmdSingleShot, ecmdMultiShot };

 private:
   static  TEntityType   fsApTripCommandDetMineEntityType;
   static  char*         fsApTripCommandDetMineName;
   static  char*         fsApTripCommandDetMineAltName;
   static  int           fsApTripCommandDetDefaultFuzeType;   // for initializing database

   static   cDbMine_cApTripCommandDet     fsDbApTripCommandDet;      // the instantiation in mine database
   
 protected:
   T2linkHead         fHitTgtDetList;      // detonations on tgts in range
   ECmdType           fCmdType;
   TTimeSim           fAutoFireTimeout;

public:
   virtual      void    CmdFire(EMfCmdMode eMfCmdMode);
                void     Detonate( cTripWire* pWire );
                void    TripWireDetect( cTripWire* pW, TTimeSim timeout);

//                void    CheckTgts(EBoolean eSendDetPdu);
//   virtual      void    SelectObj();      // sets for cmd det
//   virtual      void    DeSelectObj();
//   virtual      void    CheckVehDamage(cVehicle* pVeh);
//   virtual      void    UpdateInteractions();

           // constructor for creation from gui, planning mine
    cApTripCommandDet( cPlanMine* pPlan = NULL ) ;
    
    virtual ~cApTripCommandDet();
};

/*
class cApOffRoute : public cApMine {

 friend class cDbMine_cApOffRoute;

 private:
   static  TEntityType   fsApOffRouteMineEntityType;
   static  char*         fsApOffRouteMineName;
   static  char*         fsApOffRouteMineAltName;
   static  int           fsOffRouteDefaultFuzeType;   // for initializing database

   static   cDbMine_cApOffRoute     fsDbApOffRoute;      // the instantiation in mine database
   
 protected:
   T2linkHead         fHitTgtDetList;      // detonations on tgts in range

public:
//   virtual   void          SimulateMine();
   virtual      void    CmdDet();
//   virtual   void          OnOffMine( EBoolean on);   // fires mine

 
           // constructor for creation from gui, planning mine
    cApOffRoute();
    
    virtual ~cApOffRoute();
};
*/

                            
// ************************************
//   messages
// ************************************

#endif
