/*
$RCSfile: CmsControl.cc,v $
$Revision: 1.6 $
$Author: ksnively $
$Date: 1999/06/04 17:31:54 $
$Log: CmsControl.cc,v $
Revision 1.6  1999/06/04 17:31:54  ksnively
Revision 4.2.  Compilies under multiple OS.  Single detonation for Cmd Det mines.

Revision 1.5  1999/05/18 19:33:14  ksnively
Ported CMS to compile under IRIX 6.5
Altered make files to allow cms to be compiled under various OS simulataneously
Removed the Startup GUI

Revision 1.4  1999/05/12 19:36:53  ksnively
Removed unused variable in cCmsMgr::RunSim

Revision 1.3  1999/05/10 20:18:21  ksnively
Added a command line option for enabling Communication Capability.

Revision 1.2  1999/03/26 21:17:25  ksnively

Added radio communication capability for Command Detonated Mines.  Included sending
and receiving transmitter and signal PDUs.  All signals have the option of being
processed by the Communication Effects Federate.

Revision 1.1.1.1  1999/02/16 14:54:28  jchappel
Comprehensive Mine Simulator

// Revision 2.6  1998/11/25  18:37:51  ksnively
// Update for APLA Exercise
//
// Revision 2.5  1998/10/27  19:34:43  jchappel
// modifications for versioning
//
// Revision 2.4  1998/07/27  19:48:30  jchappel
// Made changes for DIS switch to 204.
//
// Revision 2.3  1998/03/31  14:10:25  jchappel
// added network protocol parsing, to allow DIS_204 specification
//
// Revision 2.2  1998/03/31  13:58:13  ksnively
// *** empty log message ***
//
// Revision 2.1  1998/02/18  17:16:10  ksnively
// Incorporated AP mine replacement code.
//
// Revision 2.0  1998/01/26  21:01:35  ksnively
// Baseline CMS before additions for AP mine replacements.
//
// Revision 1.4  1998/01/09  18:23:09  ksnively
// Integrated latest SAIC release cms3.0b2
//
// Revision 1.3  1997/12/22  21:03:59  ksnively
// Altered time routine to read time from clock cycles, faster than using gettimeofday.
//
// Revision 1.2  1997/12/17  14:38:03  ksnively
// Debugged Minefield duplication routine.
// Added input file "netparams" for reading PDU type enumerations.
// Got rid of warning messages during compilation.
//
// Revision 1.1  1997/12/16  13:59:57  ksnively
// Initial revision
//
// Revision 1.6  1997/10/27  17:08:08  trang
// BUILD1
//
Revision 1.5  1997/10/02 17:53:37  austin
first working port to modsaf3.0

// Revision 1.4  1997/10/02  17:50:22  austin
// first working port to modsaf3.0
//
// Revision 1.4  1997/10/02  17:50:22  austin
// first working port to modsaf3.0
//
// Revision 1.3  1997/05/07  12:32:33  ksnively
// *** empty log message ***
//
// Revision 1.3  1997/05/07  12:32:33  ksnively
// *** empty log message ***
//
// Revision 1.2  1997/03/20  19:14:41  ksnively
// added emission tracking, updated to CMS2.0B6
//
// Revision 1.1  1996/10/23  13:54:40  nsipes
// Initial revision
//
// Revision 1.19  1996/09/07  12:46:58  rcarp
// fixes bug in shutdown from startup window
//
// Revision 1.18  1996/08/21  21:58:20  rcarp
// CP and QRP file output, other updates
//
// Revision 1.17  1996/08/08  18:10:09  rcarp
// gui updates and more CP changes
//
// Revision 1.16  1996/08/07  20:31:59  mkappel
// Startup screen header file.
//
// Revision 1.15  1996/08/07  14:19:30  rcarp
// initial revisions for CP protocol
//
// Revision 1.14  1996/07/13  19:04:20  rcarp
// version 1.5b13, fixes bug dragging with two buttons and displays damamged vehicles
//
// Revision 1.13  1996/07/03  22:55:15  rcarp
// enhancements and bug fixes for version 1.5b9
//
// Revision 1.12  1996/06/21  17:04:20  rcarp
// upgrades for release 1.5b3, mostly mine vuln
//
// Revision 1.11  1996/06/19  19:05:45  rcarp
// revisions for mine vulnerability, version 1.5b2
//
// Revision 1.10  1996/05/21  22:15:40  rcarp
// text and lists from mine db, and activating mine state save cmd
//
// Revision 1.9  1996/05/16  00:01:58  rcarp
// miscellaneous bugs
//
// Revision 1.8  1996/05/15  17:17:31  rcarp
// refinements and fixes for 1.5 delivery
//
// Revision 1.7  1996/05/14  16:15:08  rcarp
// refinements and bug fixes for 1.5 delivery
//
// Revision 1.2  1996/02/16  19:33:39  rcarp
// revisions for 1.1b7 version
//
$State: Exp $
*/
 
/*******************************************

   file: CmsControl.cc
   
      Copyright 1995 by the Institute for Defense Analyses
      
         Institute for Defense Analyses
         1801 N. Beauregard Street
         Alexandria, Virginia 22311-1772
         703-845-2000
         
      This software was developed by IDA under U. S. Government
      contract.  For distribution information contact:
      
         U. S. Army Night Vision Directorate
         AMSEL RD NV OD CD
         10221 Burbeck Road, suite 430
         Ft. Belvoir VA 22060-5806
      
*********************************************/

/*******************************************

   CmsControl.cc
   
      The CMS control implementation file defines the top level 
      simulation management and control functions.
      
      Specific message implementations are with the classes they support.
   
   Created by Richard Carpenter
   Modification history:
      created   
      
*********************************************/

#include "CmsControl.h"
#include "NetMgr.h"
#include "MapGeometry.h"
#include "Message.h"
#include "Display.h"
#include "EntityDB.h"
#include "CmsPdu.h"
#include "Vulnerability.h"
#include "Communication.h"

//** minefield include for test only
#include "Minefield.h"
#include "ApMine.h"
#include "AtMine.h"
#include "AtWideArea.h"

// for directory entry stuff
#include <dirent.h>
#include <string.h>

#include "libreader.h"
#include "libcallback.h"

#include <Xm/Xm.h>

// static variables for control classes
TTimeSim   cMsgDispUpdt::fDispUpdtWaitTime  =  1000;
TTimeSim   cMsgUpdt::fUpdtWaitTime          =  1000;
TTimeSim   cMessageList::fDelayAllowed      =    50;

char*           cCmsMgr::fsSiteDefPath = "/etc/assoc.def";
unsigned short  cCmsMgr::fsSite = 16;
unsigned short  cCmsMgr::fsApplication = 232;
TTimeSim        cCmsMgr::fsNextProcSimTime = 0;
XtIntervalId    cCmsMgr::fsIntId = 0;

TTimeSim        cMsgMgr::fsMinTimeStep = 2;

const TKeywordEntry cCmsMgr::fKeyParamTable[eSizeParamTable] = {
	"minetype", ekeyLev1Struct,
	"vehicletype", ekeyLev1Struct,
	"projectiletype", ekeyLev1Struct,
	"newminefrom", ekeyLev1Struct,
	"newvehiclefrom", ekeyLev1Struct,
	"newprojectilefrom", ekeyLev1Struct,
	"sensortype", ekeyLev1Struct,
	"newsensorfrom", ekeyLev1Struct,
	"controllertype", ekeyLev1Struct,
	"newcontrollerfrom", ekeyLev1Struct,
	"areadenialtype", ekeyLev1Struct,
	"newareadenialfrom", ekeyLev1Struct
};

const TKeywordEntry cCmsMgr::fKeyVulnParamTable[eSizeVulnParamTable] = {
	"vulnTable", ekeyLev1Struct,
	"newVulnTable", ekeyLev1Struct,
	"munitionDetTypeMap", ekeyLev2Struct,
	"warheadDetTypeMap", ekeyLev2Struct,
	"cmVulnTable",  ekeyLev1Struct, 
	"cmNewVulnTable",  ekeyLev1Struct 
};

const TKeywordEntry cCmsMgr::fKeyNetParamTable[eSizeNetParamTable] = {
	"pduTypeMap", ekeyLev2Struct
};

cMessage::cMessage(TTimeSim time, EBoolean bAbsTime)
{
   if ( bAbsTime )
      fSendTime = time;
   else
      fSendTime = GetCurSimTime() + time;
   fpNextMsg = NULL;
   fpPrevMsg = NULL;
}

cMessage::~cMessage()
{
}

TTimeSim cMessage::GetSendTime() const
{
	return fSendTime;
}

cMsgPrEvent::cMsgPrEvent() : cMessage(0)
{
   gPrEventList.AddMsgEnd(this);
}

cMsgPrEvent::~cMsgPrEvent()

{
}

cMsgPrUpdt::cMsgPrUpdt(TTimeSim waitTime) : cMessage(waitTime)
{
   gPrUpdtList.AddMsgOrdered(this);
}

cMsgPrUpdt::~cMsgPrUpdt()
{
}

cMsgLowRateUpdt::cMsgLowRateUpdt(TTimeSim time, EBoolean bAbsTime) :
   cMessage(time, bAbsTime)
{
   gLowRateUpdtList.AddMsgOrdered(this);
}

cMsgLowRateUpdt::~cMsgLowRateUpdt()
{
}

cMsgEvent::cMsgEvent() : cMessage(0)
{
   gEventList.AddMsgEnd(this);
}

cMsgEvent::~cMsgEvent()
{
}

cMsgUpdt::cMsgUpdt() : cMessage(fUpdtWaitTime)
{
   gUpdtList.AddMsgEnd(this);
}

cMsgUpdt::~cMsgUpdt()

{
}

cMsgDispUpdt::cMsgDispUpdt() : cMessage(fDispUpdtWaitTime)
{
   gDispUpdtList.AddMsgEnd(this);
}

cMsgDispUpdt::~cMsgDispUpdt()

{
}

cMsgLowPrEvent::cMsgLowPrEvent() : cMessage(0)
{
   gLowPrEventList.AddMsgEnd(this);
}

cMsgLowPrEvent::~cMsgLowPrEvent()

{
}

EBoolean   cMessageList::SendNextMsg(TTimeSim* pNextTime, TTimeSim* pSendTime)
   // the default checks the time, and sends if past the send time
{
   EBoolean sent = false;
   //fLastSendTime = fSendTime;
   //fSendTime  = *pSendTime;
   
   if (fpHead ) {
      if ( *pSendTime >= fpHead->GetSendTime() ) {
         fpHead->SendMsg();
         DeleteMsg(fpHead);
         sent = true;
         *pNextTime = GetCurSimTime();
      }
      else {
         if ( fpHead->GetSendTime() < *pNextTime )
            *pNextTime = fpHead->GetSendTime();
      }
   }
   return sent;
}

void   cMessageList::MsgListShutdown()
{
   while ( fpHead )
      DeleteMsg( fpHead );
}

cMessageList::cMessageList()
{
   fpHead = fpTail = NULL;
   fSendTime = fLastSendTime = GetCurSimTime();
}

cMessageList::~cMessageList()

{
}

void   cMessageList::AddMsgEnd(cMessage* pMsg)
{
   pMsg->fpPrevMsg = fpTail;
   pMsg->fpNextMsg = NULL;
   
   if (!fpHead)
      fpHead = pMsg;
   if (fpTail)
      fpTail->fpNextMsg = pMsg;
   fpTail = pMsg;
}

void  cMessageList::DeleteMsg(cMessage* pMsg)
{
   if (fpHead == pMsg)
      fpHead = pMsg->fpNextMsg;
   if (fpTail == pMsg) 
      fpTail = pMsg->fpPrevMsg;
   if (pMsg->fpPrevMsg)
      pMsg->fpPrevMsg->fpNextMsg = pMsg->fpNextMsg;
   if (pMsg->fpNextMsg)
      pMsg->fpNextMsg->fpPrevMsg = pMsg->fpPrevMsg;
   delete pMsg;
}

cPrEventList::cPrEventList()
{
}

cPrEventList::~cPrEventList()

{
}

void   cPrUpdtList::AddMsgOrdered(cMsgPrUpdt* msg)
      // the send time has already been set in the message constructor
      // we search backward from end of list
{
   cMsgPrUpdt* next = NULL;
   cMsgPrUpdt* prev = (cMsgPrUpdt*)fpTail;
   
   while (prev)
      if ( prev->GetSendTime() > msg->GetSendTime() ) {
         next = prev;
         prev = (cMsgPrUpdt*) (prev->fpPrevMsg);
      }
      else
         break;
         
   msg->fpNextMsg = next;
   msg->fpPrevMsg = prev;
   if (prev)
      prev->fpNextMsg = msg;
   else
      fpHead = msg;
   if (next)
      next->fpPrevMsg = msg;
   else
      fpTail = msg;
}

cPrUpdtList::cPrUpdtList()
{
}

cPrUpdtList::~cPrUpdtList()

{
}

cEventList::cEventList()
{
}

cEventList::~cEventList()

{
}

cUpdtList::cUpdtList()
{
}

cUpdtList::~cUpdtList()

{
}

cDispUpdtList::cDispUpdtList()
{
}

cDispUpdtList::~cDispUpdtList()

{
}

cLowPrEventList::cLowPrEventList()
{
}

cLowPrEventList::~cLowPrEventList()

{
}

void   cLowRateUpdtList::AddMsgOrdered(cMsgLowRateUpdt* msg)
      // the send time has already been set in the message constructor
      // we search backward from end of list
{
   cMsgLowRateUpdt* next = NULL;
   cMsgLowRateUpdt* prev = (cMsgLowRateUpdt*)fpTail;
   
   while (prev)
      if ( prev->GetSendTime() > msg->GetSendTime() ) {
         next = prev;
         prev = (cMsgLowRateUpdt*) (prev->fpPrevMsg);
      }
      else
         break;
         
   msg->fpNextMsg = next;
   msg->fpPrevMsg = prev;
   if (prev)
      prev->fpNextMsg = msg;
   else
      fpHead = msg;
   if (next)
      next->fpPrevMsg = msg;
   else
      fpTail = msg;
}

cLowRateUpdtList::cLowRateUpdtList()
{
}

cLowRateUpdtList::~cLowRateUpdtList()
{
}

void   cMsgMgr::MsgListDepthCheck( int depth)
{
   if ( fMsgListDepth < depth ) {
      fMsgListDepth = depth;
      fDepthTime = GetCurSimTime();
//      cout << "msg list depth " << depth << endl;
   }
   else if ( fMsgListDepth == depth ) {
      fDepthTime = GetCurSimTime();
   }
   else if ( fDepthTime + 100 < GetCurSimTime() ) {
      fMsgListDepth = depth;
      fDepthTime = GetCurSimTime();
//      cout << "msg list depth " << depth << endl;
   }
}

EBoolean   cMsgMgr::ProcessMsgs( TTimeSim* pNextTime )
{
   TTimeSim pSendTime = GetCurSimTime();                  // Used to reduce calls to GetCurSimTime
   *pNextTime = pSendTime + fsMinTimeStep;
   
   if      ( gPrEventList.SendNextMsg(pNextTime, &pSendTime) ) {      // depth 1
      MsgListDepthCheck(1);
      return true;
   }
      
   else if ( gPrUpdtList.SendNextMsg(pNextTime, &pSendTime) ) {      // depth 2
      MsgListDepthCheck(2);
      return true;
   }
      
   else if ( gEventList.SendNextMsg(pNextTime, &pSendTime) ) {      // depth 3
      MsgListDepthCheck(3);
      return true;
   }
      
   else if ( gUpdtList.SendNextMsg(pNextTime, &pSendTime) ) {      // depth 4
      MsgListDepthCheck(4);
      return true;
   }
      
   else if ( gDispUpdtList.SendNextMsg(pNextTime, &pSendTime) ) {      // depth 5
      MsgListDepthCheck(5);
      return true;
   }
      
   else if ( gLowPrEventList.SendNextMsg(pNextTime, &pSendTime) ) {      // depth 6
      MsgListDepthCheck(6);
      return true;
   }
      
   else if ( gLowRateUpdtList.SendNextMsg(pNextTime, &pSendTime) ) {      // depth 7
      MsgListDepthCheck(7);
      return true;
   }
      
   else {
      MsgListDepthCheck(8);
      return false;
   }
}

void   cMsgMgr::MsgShutdown()
{
   gPrEventList.MsgListShutdown();
   gPrUpdtList.MsgListShutdown();
   gEventList.MsgListShutdown();
   gUpdtList.MsgListShutdown();
   gDispUpdtList.MsgListShutdown();
   gLowPrEventList.MsgListShutdown();
   gLowRateUpdtList.MsgListShutdown();
}

cMsgMgr::cMsgMgr()
{
   fMsgListDepth = 0;
   fDepthTime = GetCurSimTime();
}

cMsgMgr::~cMsgMgr()
{
}

TStartupParam::TStartupParam()
{
   fStartResult      = estInitialize;
   feProtocol        = eDis203;
   feQrpProtocol     = eQrp1;
   feCpProtocol      = eCp1;
   fbOrientation     = false;
   fbBurialDepth     = false;
   fbTemperature     = false;
   fSetupFileName    = NULL;
   //fSetupFileName    = cppstrdup(Setupdir);
   fTerrainName      = NULL;
   fDirTerrains      = NULL;
   fDirMineParams    = NULL;
   fDirMfInput       = NULL;
   fDirMfOutput      = NULL;
   fDirStats         = NULL;
   fExerciseName     = NULL;
   fTestFilenames[0] = NULL;
   fMineFilenames[0].ffilename = NULL;
   fMineFilenames[0].fesim = false;
   fNumMineFiles     = 0;
   fOutputFilePrefix = cppstrdup( "ex1" );
   fNumTestFiles     = 0;
   fDisPort          = 3000;
   fCmsPort          = 3010;
   fMulticastAddr    = NULL;
   fTtl              = 32;
   fSite             = 1;      // set later
   fApplication      = 1;      // set later
   fExerciseId       = 1;
   fbGui             = true;
   fbHost            = true;
   fbController      = false;
   fbRandomSeed      = true;
   fbOperatorPriv    = false;
   fRnSeed           = 1;
   fstealthID.site = 
      fstealthID.application = 
      fstealthID.entityNum = (unsigned short) -1;
}

			/******************************************************/
			/*   Command line compile and parsing is done here.   */
			/******************************************************/

void    cCmsMgr::SetDefaultParams()
{
   //  set all defaults first
   
   fStartupParam.fTerrainName = NULL;
   fStartupParam.fDirTerrains = NULL;
   fStartupParam.fDirMineParams = NULL;
   fStartupParam.fDirMfInput = NULL;
   fStartupParam.fDirMfOutput = NULL;
   fStartupParam.fDirStats = NULL;   
   fStartupParam.fExerciseName = NULL;
   //  fStartupParam.fMineFilenames[0].ffilename = new char;
   
   
   fStartupParam.fStartResult      = estStartup;
   fStartupParam.feProtocol        = eDis203;
   fStartupParam.feQrpProtocol     = eQrpNo;
   fStartupParam.feCpProtocol      = eCp1HeartBeat;
   fStartupParam.fbOrientation     = false;
   fStartupParam.fbBurialDepth     = false;
   fStartupParam.fbTemperature     = false;
   fStartupParam.fSetupFileName    = NULL;
   fStartupParam.fTerrainName      = cppstrdup( "knox-0311" );
   fStartupParam.fDirTerrains      = cppstrdup( "../../terrain" );
   fStartupParam.fDirMineParams    = cppstrdup( "mine_params" );
   fStartupParam.fDirMfInput       = cppstrdup( "../../minefields" );
   fStartupParam.fDirMfOutput      = cppstrdup( "../../minefields" );
   fStartupParam.fDirStats         = cppstrdup( "output" );
   fStartupParam.fExerciseName     = cppstrdup( "output" );
   fStartupParam.fTestFilenames[0] = NULL;
   fStartupParam.fMineFilenames[0].ffilename = NULL;
   fStartupParam.fMineFilenames[0].fesim = false;
   fStartupParam.fNumMineFiles     = 0;
   fStartupParam.fOutputFilePrefix = cppstrdup( "ex1" );
   fStartupParam.fNumTestFiles     = 0;
   fStartupParam.fDisPort          = 3000;
   fStartupParam.fCmsPort          = 3010;
   fStartupParam.fSite             = 1;            
   fStartupParam.fApplication      = 1;      
   fStartupParam.fExerciseId       = 1;
   fStartupParam.fbGui             = true;
   fStartupParam.fbHost            = true;
   fStartupParam.fbController      = false;
   fStartupParam.fbRandomSeed      = true;
   fStartupParam.fbOperatorPriv    = false;
   fStartupParam.fRnSeed           = 1;
   fStartupParam.fstealthID.site = 
      fStartupParam.fstealthID.application = 
      fStartupParam.fstealthID.entityNum = (unsigned short) -1;
   
   //     gpDisVersion = &cDisPdu203;                // default for dis version pointer
}
   
void    cCmsMgr::SetStartupParams( int* pArgc, char* argv[] )
{

   int arg = 1, uk_argc = 1, i, val;
   
   int count = 0;   //this usage is commented out further down
  
   /*
   if ( ( *pArgc > 1 ) &&  ( strcmp ( argv[1], "-f" ) == 0 ) ){

      if ((*pArgc > 2) && (argv[2][0] != '-')) {
	 if ( fStartupParam.fSetupFileName ) 
	    delete fStartupParam.fSetupFileName;
	 
	 if ( (argv[2][0] == '.') ||
	      (argv[2][0] == '/') ) 
	    fStartupParam.fSetupFileName = cppstrdup( argv[2] );
	 
	 else {
	    fStartupParam.fSetupFileName = cppstrdup( strcat( "./data/", argv[2] ) );
	 }
      }
      else {
	 fprintf (stderr, "\nIncorrect Usage: '-f' must be followed by filename!  Setting default Parameters.\n\n");
	 SetDefaultParams();
      }
   }

   else if ( ( *pArgc > 1 ) &&  ( strcmp ( argv[1], "-f" ) != 0 ) ){
   */

   // First set the default parameters.
      SetDefaultParams();

   
 			/*********************************************************/
			/*   Command line parser.  Some sections are commented   */
			/*   out because they may not be needed or useful yet.   */
			/*   If user doesn't supply variable with a '-command'   */
			/*   the default value remains set.                      */
			/*********************************************************/

      while ( arg < *pArgc ){
	 if ( strcmp ( argv[arg], "-help" ) == 0 ) {
	    system ("../../data/CLoptions");                    //print command line options and exit.
	    Shutdown();
	    exit(0);
	 }
         /*
	   else if ( strcmp ( argv[arg], "-g" ) == 0) { //use startup gui
	    //Set initialization
	    fStartupParam.fStartResult = estInitialize;
	    if ( ( ( arg + 1 ) < *pArgc ) && ( argv[arg+1][0] != '-' ) ){
	       if (fStartupParam.fSetupFileName) delete [] fStartupParam.fSetupFileName;
	       fStartupParam.fSetupFileName = cppstrdup ( argv[arg+1] );	 
	       arg++;
	    } 
	    
	    else                                           // default to mine_params
	       fStartupParam.fSetupFileName = cppstrdup( "../../data/setup" );

	    
         }  // end else mparam 
	 */
	   
         else if ( strcmp ( argv[arg], "-network" ) == 0)       // network protocol

	    if ( ( ( arg + 1 ) < *pArgc ) && ( argv[arg+1][0] != '-' ) ){

	       if ( atoi(argv[arg+1]) == 204 ){
		 fStartupParam.feProtocol = eDis204;  //should say eDis204
	          arg++;
		  // cout << "here!here!here!" << fStartupParam.feProtocol << endl;

		  //		  gpDisVersion = &DisPdu203;
              }
	    
	    }

	    else {                                          // default
               fStartupParam.feProtocol = eDis203;
	       arg++;

	       //	       gpDisVersion = &DisPdu203;
                }

         else if ( strcmp ( argv[arg], "-nonet" ) == 0)    // nonet
            fStartupParam.feProtocol = eNonet;

         else if ( strcmp ( argv[arg], "-exercise" ) == 0) {
                                                           // exercise id
	    if ( ( ( arg + 1 ) < *pArgc ) && ( argv[arg+1][0] != '-' ) ){
               fStartupParam.fExerciseId = atoi ( argv[arg+1] );  
	       arg++;
	    
	    }

	    else                                           // default id
	       fStartupParam.fExerciseId = 1;

         }  // end else exercise

         //NPAC 
         else if ( strcmp ( argv[arg], "-udpport" ) == 0) {
            if ( ( ( arg + 1 ) < *pArgc ) && ( argv[arg+1][0] != '-' ) ){
               fStartupParam.fUdpPort = atoi ( argv[arg+1] );
               arg++;
            }
            else
               fStartupParam.fUdpPort = 5000;
         }  


         else if ( strcmp ( argv[arg], "-disport" ) == 0) {
                                                           // disport
	    if ( ( ( arg + 1 ) < *pArgc ) && ( argv[arg+1][0] != '-' ) ){
               fStartupParam.fDisPort = atoi ( argv[arg+1] );     
	       arg++;
	    }

	    else                                           // default port
	       fStartupParam.fDisPort = 3000;

         }  // end else disport

         else if  ( strcmp ( argv[arg], "-ttl" ) == 0) {
                                                           // disport
	    if ( ( ( arg + 1 ) < *pArgc ) && ( argv[arg+1][0] != '-' ) ){
               fStartupParam.fTtl = atoi ( argv[arg+1] );     
	       arg++;
	    }

	    else                                           // default TTL
	       fStartupParam.fTtl = 32;

         }  // end else ttl

         else if ( strcmp ( argv[arg], "-unicast" ) == 0) {
                                                           // unicast address
      	    if  ( ( ( arg + 1 ) < *pArgc ) && ( argv[arg+1][0] != '-' ) ){                 
	       fStartupParam.fMulticastAddr = cppstrdup ( argv [ arg + 1 ] );	 
	       arg++;
	    
	    } 
	    
	    else                                           // default to no multicasting
	       fStartupParam.fMulticastAddr = NULL;
	    
         }  // end else unicast 

         //NPAC 
         else if ( strcmp ( argv[arg], "-udpaddr" ) == 0) {
                                                           // unicast address
            if  ( ( ( arg + 1 ) < *pArgc ) && ( argv[arg+1][0] != '-' ) ){
                  fStartupParam.fUdpAddr = cppstrdup ( argv [ arg + 1 ] );
                  arg++;

             }
             else
                fStartupParam.fUdpAddr = NULL;
         }


         else if ( strcmp ( argv[arg], "-minesorient" ) == 0)
            fStartupParam.fbOrientation = true;           // mine orientation

         else if ( strcmp ( argv[arg], "-nominesorient" ) == 0) 
            fStartupParam.fbOrientation = false;          // default no orientation
	 
         else if ( strcmp ( argv[arg], "-minesdepth" ) == 0) 
            fStartupParam.fbBurialDepth = true;           // mine burial
	 
         else if ( strcmp ( argv[arg], "-nominesdepth" ) == 0) 
            fStartupParam.fbBurialDepth = false;          // default no mine burial
	 
         else if ( strcmp ( argv[arg], "-minestemp" ) == 0) 
            fStartupParam.fbTemperature = true;           // mine temp
	 
         else if ( strcmp ( argv[arg], "-nominestemp" ) == 0) 
            fStartupParam.fbTemperature = false;          // default no mine temp
	 
         else if ( strcmp ( argv[arg], "-qrp" ) == 0) 
            fStartupParam.feQrpProtocol = eQrp1;          // default Query Response
	 
         else if ( strcmp ( argv[arg], "-noqrp" ) == 0) 
            fStartupParam.feQrpProtocol = eQrpNo;         // no Query Response
	 
         else if ( strcmp ( argv[arg], "-cp" ) == 0){     // consistency protocol

/*	    if ( ( ( arg + 1 ) < *pArgc ) && ( argv[arg+1][0] != '-' ) ){
	 
	       if ( strcmp ( argv[arg+1],  "m" ) == 0 )    // multicast
                  fStartupParam.feCpProtocol = eCp1Mcast;
	       
	       if ( strcmp ( argv[arg+1],  "n" ) == 0 )    // Quiescent, no multicast
                  fStartupParam.feCpProtocol = eCp1;
     
	       else                                        // default to heartbeat
                  fStartupParam.feCpProtocol = eCp1HeartBeat;

	       arg++;
	    
	    }  // end if -
	 
	    else         */                                // default to heartbeat
                fStartupParam.feCpProtocol = eCp1HeartBeat;

         }  // end else cp
      
         else if ( strcmp ( argv[arg], "-nocp" ) == 0)
            fStartupParam.feCpProtocol = eCpNo;            // no consistency
      
         else if ( strcmp ( argv[arg], "-mf" ) == 0){      // load a minefield with no sim

            if (( fStartupParam.fNumMineFiles != 50 ) && 
               ( ( arg + 1 ) < *pArgc ) && 
               ( argv[arg+1][0] != '-' ) ){

               fStartupParam.fMineFilenames[fStartupParam.fNumMineFiles].ffilename = 
		  cppstrdup ( argv [ arg + 1 ] ); 

               fStartupParam.fMineFilenames[fStartupParam.fNumMineFiles].fesim = false;

               fStartupParam.fNumMineFiles++;

	       arg++;

            }
         } // end else mf

         else if ( strcmp ( argv[arg], "-mfs" ) == 0){      // load a minefield with sim

            if (( fStartupParam.fNumMineFiles != 50 ) &&
               ( ( arg + 1 ) < *pArgc ) && 
               ( argv[arg+1][0] != '-' ) ){

               fStartupParam.fMineFilenames[fStartupParam.fNumMineFiles].ffilename = 
		  cppstrdup ( argv [arg + 1 ]); 

               fStartupParam.fMineFilenames[fStartupParam.fNumMineFiles].fesim = true;

               fStartupParam.fNumMineFiles++;

	       arg++;
   
            }
         } // end else mfs

         else if ( strcmp ( argv[arg], "-tdbpath" ) == 0) {
                                                           // terrain
      	    if  ( ( ( arg + 1 ) < *pArgc ) && ( argv[arg+1][0] != '-' ) ){
	       delete [] fStartupParam.fDirTerrains;
	       fStartupParam.fDirTerrains = cppstrdup( argv[arg+1] );	 
	       arg++;
	    
	    } 
	    
	    else                                           // default to knox terrain
	       fStartupParam.fDirTerrains = cppstrdup ( "../../terrain" );
	    
         }  // end else terrain 

         else if ( strcmp ( argv[arg], "-terrain" ) == 0) {
                                                           // terrain
      	    if  ( ( ( arg + 1 ) < *pArgc ) && ( argv[arg+1][0] != '-' ) ){
	       delete [] fStartupParam.fTerrainName;
	       fStartupParam.fTerrainName = cppstrdup( argv[arg+1] );	 
	       arg++;
	    
	    } 
	    
	    else                                           // default to knox terrain
	       fStartupParam.fTerrainName = cppstrdup ( "knox-0311" );
	    
         }  // end else terrain 

         else if ( strcmp ( argv[arg], "-stealth" ) == 0) {
                                                           // stealth ID
      	    if  ( ( ( arg + 3 ) < *pArgc ) ){
	       i = 1;
	       while (i <= 3 && val != -1 ) {
		  val = 0;
		  while (argv[arg+i][val] != '\0' && val != -1) {
		     if ((argv[arg+i][val]) >= '0' && (argv[arg+i][val]) <= '9')
			val++;
		     else
			val = -1;
		  }
		  i++;
	       }
	       if (val != -1) {
		  fStartupParam.fstealthID.site = (unsigned short) atoi(argv[arg+1]);
		  fStartupParam.fstealthID.application = (unsigned short)atoi(argv[arg+2]);
		  fStartupParam.fstealthID.entityNum = (unsigned short)atoi(argv[arg+3]);
		  arg+=3;
	       }
	       else
		  fprintf(stderr, "Error parsing -stealth option!\n");
	    
	    } 
         }  // end else stealth 

	 /*
         else if ( strcmp ( argv[arg], "-display" ) == 0) {
	    //fprintf(stderr, "Got a -display option!\n");
      	    if ( ( ( arg + 1 ) < *pArgc ) && ( argv[arg+1][0] != '-' ) ){
	       arg++;
	    }
	 }
	 */

         else if ( strcmp ( argv[arg], "-gui" ) == 0)
            fStartupParam.fbGui = true;       // default to Gui      

         else if ( strcmp ( argv[arg], "-nogui" ) == 0)
            fStartupParam.fbGui = false;                  // no Gui      


	 /*
         else if ( strcmp ( argv[arg], "-sim" ) == 0)
            fStartupParam.fbHost = true;                  // default to sim      

         else if ( strcmp ( argv[arg], "-nosim" ) == 0)
            fStartupParam.fbHost = false;                 // no Host    
*/	 
         else if ( strcmp ( argv[arg], "-mparam" ) == 0) { // mine paramater directory
      
      	    if ( ( ( arg + 1 ) < *pArgc ) && ( argv[arg+1][0] != '-' ) ){
	       delete [] fStartupParam.fDirMineParams;
	       fStartupParam.fDirMineParams = cppstrdup ( argv[arg+1] );	 
	       arg++;
	    
	    } 
	    
	    else                                           // default to mine_params
	       fStartupParam.fDirMineParams = cppstrdup ( "mine_params" );
	    
         }  // end else mparam 
	   
         else if ( strcmp ( argv[arg], "-mfin" ) == 0) {  // minefield input directory
      
      	    if ( ( ( arg + 1 ) < *pArgc ) && ( argv[arg+1][0] != '-' ) ){                 
	       delete [] fStartupParam.fDirMfInput;
	       fStartupParam.fDirMfInput = cppstrdup ( argv[arg+1] );	 
	       arg++;
	    
	    } 
	    
	    else                                           // default to minefields
	       fStartupParam.fDirMfInput = cppstrdup ( "minefields" );
	    
         }  // end else mfin 
	   
         else if ( strcmp ( argv[arg], "-mfout" ) == 0){  // minefield output directory
      
      	    if ( ( ( arg + 1 ) < *pArgc ) && ( argv[arg+1][0] != '-' ) ){                  
	       delete [] fStartupParam.fDirMfOutput;
	       fStartupParam.fDirMfOutput = cppstrdup ( argv[arg+1] );	 
	       arg++;
	    
	    } 
	    
	    else                                           // default to minefields
	       fStartupParam.fDirMfOutput = cppstrdup ( "minefields" );
	    
         }  // end else mfout 
	   
         else if ( strcmp ( argv[arg], "-stats" ) == 0){   // directory of output statistics
      
      	    if ( ( ( arg + 1 ) < *pArgc ) && ( argv[arg+1][0] != '-' ) ){                  
	       delete [] fStartupParam.fDirStats;
	       fStartupParam.fDirStats = cppstrdup ( argv[arg+1] );	 
	       arg++;
	    
	    } 
	 	    
	    else                                           // default to output
	       fStartupParam.fDirStats = cppstrdup ( "output" );
	    
         }  // end else stats 
	   
         else if ( strcmp ( argv[arg], "-exname" ) == 0) { //  exercise name
      
      	    if ( ( ( arg + 1 ) < *pArgc ) && ( argv[arg+1][0] != '-' ) ){                  
	       delete [] fStartupParam.fExerciseName;
	       fStartupParam.fExerciseName = cppstrdup ( argv[arg+1] );	
	       arg++;
	    
	    } 
	    
	    else                                           // default to output
	       fStartupParam.fExerciseName = cppstrdup ( "output" );
	    
         }  // end else exname 
	   
/* this is commented out because we may not need it now or ever
 */

         else if ( strcmp ( argv[arg], "-testfiles" ) == 0) {
            count = 0;					   // test file names 
								
      	    while ( ( ( arg + 1 ) < *pArgc ) && ( argv[arg+1][0] != '-' ) && (count < 50)){          
               fStartupParam.fTestFilenames[count] =  cppstrdup (argv[arg+1] );	
	       arg++;
	       count++;
	    
	    } // end while
	 
	    if ( count != 0 )                              // number of test files
	       fStartupParam.fNumTestFiles = count;        // this may need to be count - 1
	  
	    else                                           // default 0 test files
	        fStartupParam.fNumTestFiles = 0;
	    
         }  // end else testfiles 
	   
         else if ( strcmp ( argv[arg], "-use_controller" ) == 0)
            fStartupParam.fbController = true;       // default to Gui      

         else if ( strcmp ( argv[arg], "-no_controller" ) == 0)
            fStartupParam.fbController = false;                  // no Gui      


	 /*
         else if (strcmp ( argv[arg], "-site" ) == 0) {    //  site number
      
      	    if ( ( ( arg + 1 ) < *pArgc ) && ( argv[arg+1][0] != '-' ) ){           
               fStartupParam.fSite = atoi ( argv[arg+1] ); 	
	       arg++;
	    
	    } 
	    
	    else                                           // default to site 188
	       fStartupParam.fSite = 188;
	    
         }  // end else site 
	   
         else if ( strcmp ( argv[arg], "-app" ) == 0){    //  Application number
      
      	    if ( ( ( arg + 1 ) < *pArgc ) && ( argv[arg+1][0] != '-' ) ){                  
               fStartupParam.fApplication = atoi ( argv[arg+1] ); 	
	       arg++;
	    
	    } 
	    -testfiles <string> <string> ... 
               You can enter the names of one or more test files -- up to 50 --
               for CMS.


	    else                                           // default to site 41
	       fStartupParam.fApplication = 41;
	    
         }  // end else app 
	   
         
	 else if ( strcmp ( argv[arg], "-oppriv" ) == 0){
                                                          //  Operator Priveledge
      	    //if ( ( ( arg + 1 ) < *pArgc ) && ( argv[arg+1][0] != '-' ) ){                  
               fStartupParam.fbOperatorPriv = true; 	
	       //arg++;
	       
	       //} 
	    
	       //else                                           // default to no Operator Priveledge
	       //fStartupParam.fbOperatorPriv = false;
	    
         }  // end else oppriv

	 
         else if ( strcmp ( argv[arg], "-cmsport" ) == 0) {
                                                          //  Cms Port
      	    if ( ( ( arg + 1 ) < *pArgc ) && ( argv[arg+1][0] != '-' ) ){                 
               fStartupParam.fCmsPort = atoi ( argv[arg+1] ); 	
	       arg++;
	    
	    } 
            
            else
               fStartupParam.fCmsPort = 3010;
	    
         }  // end else cmsport
	 */
	 else {
	    //Keep this argument.  Simply move unknowns to front of the list.
	    argv[uk_argc] = argv[arg];
	    uk_argc++;
	 }
	 arg++;
      } // end while parsing

      //}  // end else pArgc
      //set the new number of arguements
      *pArgc = uk_argc;


   fStartupParam.fSite = fsSite;
   fStartupParam.fApplication = fsApplication;

   if ( fStartupParam.feProtocol == eDis203 )
      cout<<"DIS version is 2.0.3"<<endl;

   else
      cout<<"DIS version is 2.0.4"<<endl;

   //NPAC 
    if(fStartupParam.fUdpAddr!=NULL)
     monitorPort = new cUdpclient(fStartupParam.fUdpAddr,
                                  fStartupParam.fUdpPort);
    else monitorPort = NULL;


} // end SetStartupParams

void cCmsMgr::PrintUnknownFlags(int* pArgc, char* argv[])
{
   if (*pArgc == 1)
      return;

   fprintf (stderr, "\a\nThe following command line flags are not recognized:\n\n");
   
   for (int i = 1; i < *pArgc; i++) {
      fprintf (stderr, "\t%s\n", argv[i]);
   }

   fprintf (stderr, "\n");
}

void        cCmsMgr::StartSimulation()
{
   EBoolean   bTerrainOK;
   
      //** should we check for acceptable startup values?

   SetSimStartTime();
   OpenOutputFiles();
   cDetonation::InitDetonMap();
//   gMechThreatList.ConstructBasicList();
	ReadParamfile();

   gbGui  = fStartupParam.fbGui;
   gbHost = fStartupParam.fbHost;
      
   gpNetMgr = new cNetMgr(fStartupParam);

   if (gCmsMgr.fStartupParam.fbController) {
      gpRadioNetMgr = new cRadioNetworkMgr();
   }

   gpTerrainMgr = new cTerrain( fStartupParam.fDirTerrains, fStartupParam.fTerrainName, &bTerrainOK );
   Assert (bTerrainOK, kerrReadTerrain, "cCmsMgr::Startup");
   
   if (gbGui) {
      gpGuiWin = new cGuiWindow();
   }
   gMfieldMgr.LoadMinefields();
      
   fState = estRun;
}

void        cCmsMgr::Shutdown()
{
   if (gpGuiWin) 
      gpGuiWin->SetSelection(false);
   if ( gpNetMgr )
      gpNetMgr->NetShutdown();
   if ( gpRadioNetMgr )
      delete gpRadioNetMgr;
   gMfieldMgr.MfShutdown();
   CloseOutputFiles();
   gVehMgr.VehShutdown();
   gEmissionMgr.EmissShutdown();
   gMsgMgr.MsgShutdown();
}

void     cCmsMgr::TimeoutCB( XtPointer, XtIntervalId* )
   // this is a Run() function within an X callback, set up
   // so that X will not hang looking for user action.
   // X is not called: we are already looking for X event
{
   EBoolean bMsgProc = true;
   
   while ( bMsgProc )
      bMsgProc = gCmsMgr.RunSim();      // call until we're out of msgs
      
   fsIntId = XtAppAddTimeOut( cWindow::GetAppContext(), fsNextProcSimTime - GetCurSimTime(), 
                   (XtTimerCallbackProc)cCmsMgr::TimeoutCB, NULL);
}

EBoolean     cCmsMgr::RunSim()
{
      // incoming PDUs
   gpNetMgr->RecvPdu();      // loops internally until all PDUs received
   
      // a message ready to send.  If none, set next processing time
   return gMsgMgr.ProcessMsgs( &fsNextProcSimTime );
}

void        cCmsMgr::Run()
   // the main loop for running the CMS.  Called from main, after initialization
   //  the state gets set in startup, could conceivably be shutdown
{
   XEvent  event;
   TTimeSim   appStart;
   //TTimeSim   xStart, dispStart, xEnd;
   XtInputMask   pendingResult;
   //char* filename;
   //cInFileObj* pMineFile;
   
   if (fState == estRun) 
      cout<<"now running"<<endl;
   
   while (fState == estRun) {
         // process all PDUs, and one message in RunSim()
      if ( ! RunSim() ) {
            // if no msg processed, we can process X event
         /*xStart = */ appStart = GetCurSimTime();
         pendingResult = XtAppPending ( cWindow::GetAppContext() );
         if ( pendingResult ) {
            appStart = GetCurSimTime();
               // don't want to hang waiting for Godot
            if ( pendingResult && XtIMTimer )
               fsIntId = XtAppAddTimeOut( cWindow::GetAppContext(), fsNextProcSimTime - appStart, 
                               (XtTimerCallbackProc)cCmsMgr::TimeoutCB, NULL);
//  cout << "trying to get next event . . . " << endl;
            XtAppNextEvent( cWindow::GetAppContext(), &event );
//  cout << "got next event" << endl;
            if ( fsIntId ) {
               XtRemoveTimeOut( fsIntId );
               fsIntId = 0;
            }
            //dispStart = GetCurSimTime();
            XtDispatchEvent( &event );
            /*
	    xEnd = GetCurSimTime();
	    if ( (xEnd - xStart) > 100 ) cout << "X delay: total, pending call, next evt call, dispatch "
                                                   << xEnd - xStart << " "
                                                   << appStart - xStart << " "
                                                   << dispStart - appStart << " "
                                                   << xEnd - dispStart
                                                   << " msec, evt mask, type "
                                                   << (int) pendingResult << " "
                                                   << event.type <<endl;*/
         }
      }
   }
}

void        cCmsMgr::Initialize( int* pArgc, char* argv[] )
{   
   fState = estInitialize;
   fsIntId = 0;
   fsNextProcSimTime = 0;
   //EBoolean bCommand = true;
   
   cout << "starting cms version " << kpCmsVersion << endl;
 //  cout << endl << endl << "in initialize" << endl << endl;

      // read the assoc.def file
   ReadAssocDef();

   // fill in  startup parameters from command line for CMS and Motif
   SetStartupParams (pArgc, argv);
   cWindow::InitMotif( pArgc, argv );
   PrintUnknownFlags(pArgc, argv);

   /*
   if (fStartupParam.fStartResult == estInitialize) {
      //Use the startup GUI
      fpStartupWin = new cStartupWindow( &fStartupParam );
   
      while (fStartupParam.fStartResult == estInitialize) {
         XEvent  event;
         XtAppNextEvent( cWindow::GetAppContext(), &event );
         XtDispatchEvent( &event );
      }
      
      fpStartupWin->FillParam();
      delete fpStartupWin;
      fpStartupWin = NULL;
   }      
   */

   /*
   if (( *pArgc > 2 ) && ( strcmp ( argv[1], "-f" ) != 0 ) && (argv[2][0] != '-' )) {
      bCommand = false;
   }  // end if pArgc
      
   if (( gbGui ) && ( bCommand )) {
      cWindow::InitMotif( pArgc, argv );
      fpStartupWin = new cStartupWindow( &fStartupParam );
   
      while (fStartupParam.fStartResult == estInitialize) {
         XEvent  event;
         XtAppNextEvent( cWindow::GetAppContext(), &event );
         XtDispatchEvent( &event );
      }
      
      fpStartupWin->FillParam();
      delete fpStartupWin;
      fpStartupWin = NULL;
   }
   */


   if ( (fState = fStartupParam.fStartResult) == estStartup) {
      StartSimulation();
   }

 
}

void        cCmsMgr::ReadParamfile( void )
{
	cout << "Reading parameters from directory'" << fStartupParam.fDirMineParams;
	cout << "': " << endl;

   // get a list of directory entries
	DIR *paramdir = opendir( fStartupParam.fDirMineParams );

	if( !paramdir )   // can't open this directory...
	{
		// do some kind of error checking/handling
		// "errno" indicates what the error was
		// (see 'man errno')
		cout << "warning: can't open directory '";
		cout << fStartupParam.fDirMineParams << "'..." << endl;

		return;        // do some kind of error checking/handling
	}

	struct dirent *paramfileentry;
	cInFileObj* pParam;
	cInFileObj* pMineParam[500];
   int numMineFile = 0;

	// for each file in this directory...
	while( (paramfileentry = readdir(paramdir)) != NULL )
	{
		if ( ( ! strncmp(paramfileentry->d_name, ".", 1) ) ) continue;

		// build a proper filename
		char filename[1024];
		strcpy(filename, fStartupParam.fDirMineParams);
		strcat(filename, "/" );
		strcat(filename, paramfileentry->d_name);

      pParam = new cInFileObj();
		// open it
		if ( pParam->Open(filename, gftypeParam) ) {
         cout << "opening for parameter input, file '" << filename << "'" << endl;
			pMineParam[numMineFile++] = pParam;
      }
      else if (pParam->Open(filename, gftypeNetParam) ) {
	                cout << "opening for network parameters input, file '" << filename << "'" << endl;
	 ReadNetParamFile ( *pParam );
	 delete pParam;
	 pParam = NULL;
      }
      else if ( pParam->Open(filename, gfmechVulnParam) ) {
			cout << "opening for countermine input, file '" << filename << "'" << endl;
         ReadVulnParamFile( *pParam );
         delete pParam;
         pParam = NULL;

      }
      else if ( pParam->Open(filename, gfdetVulnParam) ) {
			cout << "opening for detonation vulnerability input, file '" << filename << "'" << endl;
         ReadVulnParamFile( *pParam );
         delete pParam;
         pParam = NULL;
      } 
		else {
			cout << "warning: can't open '" << filename << "' as a file..." << endl;
			continue;   // can't open this file; ignore (may be directory, etc.)
		}

	}
   
   for ( int i = 0; i < numMineFile; i++) {
      ReadPerfParamFile( *(pMineParam[i]) );
      delete pMineParam[i];
      pMineParam[i] = NULL;
   }

	// clean-up
	closedir( paramdir );
}

void        cCmsMgr::ReadPerfParamFile(cInFileObj& param)
{
		// loop through each mine type listed in it
		EFileReturn  returnCode;
		int          returnIndex;
		char        *entTypeName = NULL;
		EBoolean     done = false;

		while( !done )
		{
			returnCode = param.ReadItem( fKeyParamTable, eSizeParamTable,
				&returnIndex, (void **)&entTypeName );

//			cout << "@@returnCode = " << returnCode << endl;
			switch (returnCode)
			{
				case eNextLevel:
					switch( returnIndex )
					{
						case eparamkwMineType:
                     // standalone sensors et al are internally just mine types.
                     // and use the same subroutine calls
						case eparamkwSensType:
						case eparamkwContrlType:
						case eparamkwAreaDnlType:
							ReadParamMineType( param, entTypeName );
							break;

						case eparamkwVehicleType:
							ReadParamVehicleType( param, entTypeName );
							break;

						case eparamkwProjectileType:
							ReadParamProjType( param, entTypeName );
							break;

						case eparamkwNewMineType:
						case eparamkwNewSensType:
						case eparamkwNewContrlType:
						case eparamkwNewAreaDnlType:
							ReadParamNewMineType( param, entTypeName );
							break;

						case eparamkwNewVehicleType:
							ReadParamNewVehicleType( param, entTypeName );
							break;

						case eparamkwNewProjectileType:
							ReadParamNewProjType( param, entTypeName );
							break;

						default:
							// should not go here
							break;
					}
					break;

				case eEOF:
					done = true;
					break;

				default:  // error return
					Assert(false, kerrReadParamfile, "cCmsControl::ReadPerfParamFile");
					cout << "returnCode = " << (int)returnCode << ", ";
					cout << "kw = [" << param.GetToken() << "]..." << endl;
					break;
			}
//         if (entTypeName)
//            delete entTypeName;
		}

		param.Close();
}

/*
void        cCmsMgr::ReadMechVulnParamFile(cInFileObj& param)
{
}
*/

void        cCmsMgr::ReadNetParamFile(cInFileObj& param)
{
		EFileReturn  returnCode;
		int          returnIndex;
		void*        buf  = NULL;
		EBoolean     done = false;

		while( !done )
		{
			returnCode = param.ReadItem( fKeyNetParamTable, eSizeNetParamTable,
				&returnIndex, &buf );

			switch (returnCode)
			{
				case eNextLevel:
					switch( returnIndex )
					{
						case ekwPduType:
							gPduType.ReadPduType( param );
							break;

						default:
							// should not go here
							break;
					}
					break;

				case eEOF:
					done = true;
					break;

				default:  // error return
					Assert(false, kerrReadParamfile, "cCmsControl::ReadNetParamFile");
					cout << "returnCode = " << (int)returnCode << ", ";
					cout << "kw = [" << param.GetToken() << "]..." << endl;
					break;
			}
		}

		param.Close();
}

void        cCmsMgr::ReadVulnParamFile(cInFileObj& param)
{
		EFileReturn  returnCode;
		int          returnIndex;
		void*        buf  = NULL;
		EBoolean     done = false;

		while( !done )
		{
			returnCode = param.ReadItem( fKeyVulnParamTable, eSizeVulnParamTable,
				&returnIndex, &buf );

			switch (returnCode)
			{
				case eNextLevel:
					switch( returnIndex )
					{
						case ekwVulnTable:
							gDetThreatList.ReadParamVulnTable( param, (char*)buf );
                     delete[] (char*)buf;
                     buf = NULL;
							break;

						case ekwNewVulnTable:
							gDetThreatList.ReadParamNewVulnTable( param, (char*)buf );
                     delete[] (char*)buf;
                     buf = NULL;
							break;

						case ekwMunDetType:
							cDetonation::ReadParamMunDetType( param );
							break;

						case ekwWarheadDetType:
							cDetonation::ReadParamWhDetType( param );
							break;


						case ekwCmVulnTable:
							gMechThreatList.ReadParamVulnTable( param, (char*)buf );
                     delete[] (char*)buf;
                     buf = NULL;
							break;

						case ekwCmNewVulnTable:
							gMechThreatList.ReadParamNewVulnTable( param, (char*)buf );
                     delete[] (char*)buf;
                     buf = NULL;
							break;


						default:
							// should not go here
							break;
					}
					break;

				case eEOF:
					done = true;
					break;

				default:  // error return
					Assert(false, kerrReadParamfile, "cCmsControl::ReadPerfParamFile");
					cout << "returnCode = " << (int)returnCode << ", ";
					cout << "kw = [" << param.GetToken() << "]..." << endl;
					break;
			}
//         if (entTypeName)
//            delete entTypeName;
		}

		param.Close();
}

void cCmsMgr::ReadParamMineType( cInFileObj& paramfile, const char *typeName )
{
	cDbMine* pDbMine = (cDbMine*) (gMineDbMgr.FindByName(typeName));

	if( pDbMine != NULL )
	{
		cout << "Reading parameters for mine type '" << typeName << "'" << endl;
		if ( ! pDbMine->ReadParamSet(paramfile) )
		   cout << "Error in reading mine parameters for type '" << typeName << "'" << endl;
      else if (gfMineInputParams)
         pDbMine->WriteMineParam(gpMineInputParams);
      
	}
	else
	{
      cout << "Warning:  Encountered unknown mine type, '" << typeName << "'" << endl;
	}
}

void cCmsMgr::ReadParamProjType( cInFileObj& paramfile, const char *typeName )
{
	cDbProj* pDbProj = (cDbProj*) (gProjDbMgr.FindByName(typeName));

	if( pDbProj != NULL )
	{
		cout << "Reading parameters for projectile type '" << typeName << "'" << endl;
		if ( ! pDbProj->ReadParamSet(paramfile) )
		   cout << "Error in reading projectile parameters for type '" << typeName << "'" << endl;
      else if (gfMineInputParams)
         pDbProj->WriteProjParam(gpMineInputParams);
      
	}
	else
	{
      cout << "Warning:  Encountered unknown projectile type, '" << typeName;
	}
}

void cCmsMgr::ReadParamVehicleType( cInFileObj& paramfile, const char *typeName )
{
	cDbVeh* pDbVeh = (cDbVeh*) (gVehDbMgr.FindByName(typeName));

	if( pDbVeh != NULL )
	{
		cout << "Reading new parameters for existing vehicle '" << typeName << "'" << endl;
		if ( ! pDbVeh->ReadParamSet( paramfile ) )
         cout << "Error in reading vehicle parameters for type '" << typeName << "'" << endl;
	}
	else
      cout << "Warning:  Encountered unknown vehicle type, '" << typeName;
}

void cCmsMgr::ReadParamNewMineType( cInFileObj& paramfile, const char *typeName )
{
	cDbMine* pDbBaseMine = (cDbMine*) (gMineDbMgr.FindByName(typeName));

	if( pDbBaseMine != NULL )
	{
		cout << "Creating descendent of mine type '" << typeName << "'" << endl;
      cDbMine* pDbNewMine = pDbBaseMine->CloneDbMine();
		if ( pDbNewMine->ReadParamSet(paramfile) ) {
         gMineDbMgr.Register(pDbNewMine, pDbNewMine->GetDbLevel() );
         cout << "Registering new mine type '" << pDbNewMine->GetEntryEntityName() << "'" << endl;
         if (gfMineInputParams)
            pDbNewMine->WriteMineParam(gpMineInputParams);
      }
      else {
         cout << "Error reading new mine type '" << pDbNewMine->GetEntryEntityName() << "'" << endl;
         delete pDbNewMine;
      }
	}
	else
	{
      cout << "Warning:  Encountered unknown parent mine type, '" 
           << typeName << "'" << endl;
	}
}

void cCmsMgr::ReadParamNewProjType( cInFileObj& paramfile, const char *typeName )
{
	cDbProj* pDbBaseProj = (cDbProj*) (gProjDbMgr.FindByName(typeName));
   cDbProj* pDbNewProj = NULL;

	if( pDbBaseProj != NULL )
	{
		cout << "Creating descendent of projectile type '" << typeName << "'" << endl;
      pDbNewProj = pDbBaseProj->CloneDbProj();
		if ( pDbNewProj->ReadParamSet(paramfile) ) {
         gProjDbMgr.Register(pDbNewProj, cProjDBMgr::epjdblevSubcat);
         cout << "Registering new projectile type '" << pDbNewProj->GetEntryEntityName() << "'" << endl;
         if (gfMineInputParams)
            pDbNewProj->WriteProjParam(gpMineInputParams);
      }
      else {
         cout << "Error reading new projectile type '" << pDbNewProj->GetEntryEntityName() << "'" << endl;
         delete pDbNewProj;
      }
	}
	else
	{
      cout << "Warning:  Encountered unknown parent projectile type, '" << typeName;
      pDbNewProj = new cDbProj_cProj(TFuzeParam::efuzetypeTopSublet);
      pDbNewProj->ReadParamSet(paramfile);
      delete pDbNewProj;
	}
}

void cCmsMgr::ReadParamNewVehicleType( cInFileObj& paramfile, const char *typeName )
{
	cDbVeh* pDbBaseVeh = (cDbVeh*) (gVehDbMgr.FindByName(typeName));
   cDbVeh* pDbNewVeh = NULL;

	if( pDbBaseVeh != NULL )
	{
		cout << "Creating child of vehicle type '" << typeName << "'" << endl;
      pDbNewVeh = pDbBaseVeh->CloneDbVeh();
		if ( pDbNewVeh->ReadParamSet(paramfile) ) {
         cout << "Registering new vehicle type '" << pDbNewVeh->GetEntryEntityName() << "'" << endl;
         gVehDbMgr.Register(pDbNewVeh, pDbNewVeh->GetDbLevel());
         if (gfVehicleInputParams)
            pDbNewVeh->WriteVehicleParam(gpVehicleInputParams);
      }
      else
         delete pDbNewVeh;
	}
	else
	{
      cout << "Warning:  Encountered unknown parent vehicle type, '" 
           << typeName << "'" << endl;
	   pDbNewVeh = new cDbVeh;
      pDbNewVeh->ReadParamSet(paramfile);
      delete pDbNewVeh;
   }
}

void    cCmsMgr::ReadAssocDef()
{
   char buf[100];
   ifstream rdAssoc(fsSiteDefPath);
   
   if ( !rdAssoc ) {
      cout<<"Could not open assoc.def file"<<endl;
      cout << "Using defaults site = " << fsSite << " "
           << " application = " << fsApplication << endl;
   }
   
   else {
      do {
         rdAssoc >> buf;
         if ( !strcmp(buf, "site") ) {
            rdAssoc >> fsSite;
            cout<<"site is "<<fsSite<<endl;
         }
         else if ( !strcmp(buf, "host") ) {
            rdAssoc >> fsApplication;
            cout<<"host is "<<fsApplication<<endl;
         }
      } while ( !rdAssoc.eof() );
   }

   fLastEntityId.site = fsSite;
   fLastEntityId.application = fsApplication;
   fLastEventId.site = fsSite;
   fLastEventId.application = fsApplication;
}

void    cCmsMgr::OpenOutputFiles()
{
   if (gfInteract)
      SetInteractionOutput( true );

   if (gfMineStateSumm) 
      SetMineStateOutput( true );

   if (gfMineInputParams)
      SetMineInputReflect( true );

   if (gfVehicleInputParams)
      SetVehicleInputReflect( true );

   if (gfPduData)
      SetMineDetectPduOutput( true );
}

int        cCmsMgr::OpenOutputFile(ofstream** ppFile, char* pName, char* pFileType)
{
   char fileName[1024];
   char errmsgtext[1024];
   
   strcpy(fileName, fStartupParam.fDirStats);
   strcat(fileName, "/" );
   strcat(fileName, fStartupParam.fExerciseName );
   strcat(fileName, "." );
   strcat(fileName, pName );
   *ppFile = new ofstream(fileName, ios::out, gFileProt);
   if ( ( ! (*ppFile) ) || ( (*ppFile)->bad() ) || ( (*ppFile)->fail() )  ) {
      *ppFile = NULL;
      strcpy(errmsgtext, "Unable to open output file: ");
      strcat(errmsgtext, fileName );
      if ( gbGui && gpGuiWin)
         gpGuiWin->PopupMessage (gpGuiWin->GetMainWin(), cGuiWindow::eDialogError,
            "", "", NULL, NULL, NULL, errmsgtext);
      cout<< errmsgtext << endl;
      return 0;
   }
   else
      **ppFile << "CMS file type: " << pFileType << endl;
   return 1;
}

void        cCmsMgr::WriteFileHeader(ofstream* pFile)
{
   *pFile << "Start time of simulation: " << gSimStartTime << endl;
   *pFile << "Terrain: " <<fStartupParam.fTerrainName << endl;
   *pFile << "DIS port: " <<fStartupParam.fDisPort << endl;
   *pFile << "Host ID (site/appl): " <<fStartupParam.fSite
          << " " << fStartupParam.fApplication << endl;
   *pFile << "Exercise number: " <<fStartupParam.fExerciseId << endl;
}

void        cCmsMgr::SetMineStateOutput(EBoolean on)
{
   if ( on ) {
      gfMineStateSumm = 1;
      if ( ! gpMineStateSumm ) {
         if ( gfMineStateSumm = OpenOutputFile( &gpMineStateSumm, 
                     gpMineStateFileName, gftypeMineState ) );
            WriteFileHeader(gpMineStateSumm);
      }
      if ( gfMineStateSumm )
         *gpMineStateSumm << "Start recording mine states at time "
                        << GetCurSimTime() << endl;
   }
   else {
      gfMineStateSumm = 0;
      if ( gpMineStateSumm )
         *gpMineStateSumm << "Stop recording mine states at time "
                        << GetCurSimTime() << endl;
   }
}

void        cCmsMgr::SetInteractionOutput(EBoolean on)
{
   if ( on ) {
      gfInteract = 1;
      if ( ! gpInteract ) {
         if ( gfInteract = OpenOutputFile( &gpInteract, 
                     gpInteractFileName, gftypeInteract ) );
            WriteFileHeader(gpInteract);
      }
      if ( gfInteract )
         *gpInteract << "Start recording interactions at time "
                        << GetCurSimTime() << endl;
   }
   else {
      gfInteract = 0;
      if ( gpInteract )
         *gpInteract << "Stop recording interactions at time "
                        << GetCurSimTime() << endl;
   }
}

void        cCmsMgr::SetMineInputReflect(EBoolean on)
{
   if ( on ) {
      gfMineInputParams = 1;
      if ( ! gpMineInputParams ) {
         if ( gfMineInputParams = OpenOutputFile( &gpMineInputParams, 
                  gpMineInputFileName, gftypeMineInputs ) );
            WriteFileHeader(gpMineInputParams);
      }
   }
   else
      gfMineInputParams = 0;
}

void        cCmsMgr::SetVehicleInputReflect(EBoolean on)
{
   if ( on ) {
      gfVehicleInputParams = 1;
      if ( ! gpVehicleInputParams ) {
         if ( gfVehicleInputParams = OpenOutputFile( &gpVehicleInputParams, 
                        gpVehicleInputFileName, gftypeVehicleInputs ) );
            WriteFileHeader(gpVehicleInputParams);
      }
   }
   else
      gfVehicleInputParams = 0;
}

void        cCmsMgr::SetMineDetectPduOutput(EBoolean on)
{
   if ( on ) {
      gfPduData = 1;
      if ( ! gpPduData ) {
         if ( gfPduData = OpenOutputFile( &gpPduData, 
                        gpPduDataFileName, gftypePduData ) );
            WriteFileHeader(gpPduData);
      }
   }
   else
      gfPduData = 0;
}

void        cCmsMgr::CloseOutputFiles()
{
   if (gpMineStateSumm) gpMineStateSumm->close();
   if (gpInteract) gpInteract->close();
   if (gpMineInputParams) gpMineInputParams->close();
   if (gpVehicleInputParams) gpVehicleInputParams->close();
   if ( gpPduData ) gpPduData->close();
}

void    cCmsMgr::GetNextEntityId(cEntity* pEnt, TEntityID* fId)      
{
      // give the number
   fLastEntityId.entityNum++;
   *fId = fLastEntityId; 
   
      // allocate more room if needed
   if (fLastEntityId.entityNum > fEntArraySize) {
      int oldSize = fEntArraySize;
      fEntArraySize += eentBlkSize;
      cEntity** newList = new cEntity* [fEntArraySize];
      memcpy(newList, fpEntityList,  oldSize * sizeof(cEntity*) );
      delete [] fpEntityList;
      fpEntityList = newList;
   }
   
       // enter in the list
   fpEntityList [ fLastEntityId.entityNum - 1 ] = pEnt;
}

cEntity*    cCmsMgr::GetEntityByIndex(int index) 
{ 
   if (index<1 || index>fLastEntityId.entityNum)
      return NULL;
   else
      return fpEntityList [ index - 1 ];
}

void    cCmsMgr::DeleteEntityIdById(int id) 
{ 
   if ( (id < 1) || ( id > fLastEntityId.entityNum ) )
      return;
   else
      fpEntityList [ id - 1 ] = NULL;
}

 void        cCmsMgr::DeleteEntityId(cEntity* pEnt)
{
   if ( (pEnt->GetEntityID().site != fsSite) || 
        (pEnt->GetEntityID().application != fsApplication)  )
      return;
   
   int index = pEnt->GetEntityID().entityNum;
   Assert ( (index>0) && (index<=fLastEntityId.entityNum), kerrValidityCheck, "cCmsMgr::DeleteEntityId/1");
   Assert ( (fpEntityList[index - 1] == pEnt) || (fpEntityList[index - 1] == NULL), 
         kerrValidityCheck, "cCmsMgr::DeleteEntityId/2");
   fpEntityList[index - 1] = NULL;
}

cCmsMgr::cCmsMgr()
{
   fState = estNull;
   fLastEntityId.site        = fsSite;
   fLastEntityId.application = fsApplication;
   fLastEntityId.entityNum   = 0;
   fLastEventId = fLastEntityId;
   
   fpEntityList = new cEntity* [eentBlkSize];
   fEntArraySize = eentBlkSize;
}

cCmsMgr::~cCmsMgr()
{
}

//NPAC
void cSimulateMsg::SendMsg()
{ //cout <<"void cSimulateMsg::SendMsg()"<<endl;
  cout <<"INITIALIZATION - Please WAIT!!!" << endl;
  gMfieldMgr.Simulate();
}

//NPAC
cSimulateMsg::~cSimulateMsg()
{}

//NPAC
void cUpdateMsg::SendMsg()
{ //cout <<"void cUpdateMsg::SendMsg()"<<endl;
  gMfieldMgr.UpdateGeneral();
}

//NPAC
cUpdateMsg::~cUpdateMsg()
{}


void      cInDetMsg::SendMsg()
{
   if (gbHost) {
         // see if it hits something we're simulating
      cEntity* pEntity;
      if ( fpDetonation->fTargetEntity.site == gCmsMgr.GetSite() &&
           fpDetonation->fTargetEntity.application == gCmsMgr.GetApplication() && 
           (pEntity = gCmsMgr.GetEntityByIndex(fpDetonation->fTargetEntity.entityNum)) ) {
         pEntity->InDetTargeted(fpDetonation);
      }
         // now check for proximity. Note that target 
         // is responsible for avoiding duplicate processing
      gMfieldMgr.InDetGeneral(fpDetonation);
   }
   
      // put it on display
   if (gbGui)
      ;
      
   delete fpDetonation;
   fpDetonation = NULL;
}

cInDetMsg::~cInDetMsg()
{
}

