/*
$RCSfile: CmsControl.h,v $
$Revision: 1.2 $
$Author: ksnively $
$Date: 1999/05/18 19:33:15 $
$Log: CmsControl.h,v $
Revision 1.2  1999/05/18 19:33:15  ksnively
Ported CMS to compile under IRIX 6.5
Altered make files to allow cms to be compiled under various OS simulataneously
Removed the Startup GUI

Revision 1.1.1.1  1999/02/16 14:54:47  jchappel
Comprehensive Mine Simulator

 * Revision 2.3  1998/11/25  18:39:13  ksnively
 * Update for APLA Exercise
 *
 * Revision 2.2  1998/11/16  19:28:21  jchappel
 * *** empty log message ***
 *
 * Revision 2.1  1998/02/18  17:17:24  ksnively
 * Incorporated AP mine replacement code
 *
 * Revision 2.1  1998/02/18  17:17:24  ksnively
 * Incorporated AP mine replacement code
 *
 * Revision 2.0  1998/01/26  21:04:20  ksnively
 * Baseline CMS before additions for AP mine replacements.
 *
 * Revision 1.4  1998/01/09  18:29:24  ksnively
 * Integrated latest SAIC release cms3.0b2
 *
 * Revision 1.3  1998/01/08  13:05:54  ksnively
 * Altered time routine to read clock cycles, faster then using gettimeofday.
 *
 * Revision 1.2  1997/12/17  14:40:21  ksnively
 *  Debugged Minefield duplication routine.
 * Added input file "netparams" for reading PDU type enumerations.
 * Got rid of warning messages during compilation.
 *
 * Revision 1.1  1997/12/16  13:59:57  ksnively
 * Initial revision
 *
 * Revision 1.3  1997/10/27  17:07:30  trang
 * BUILD1
 *
 * Revision 1.2  1997/05/07  12:33:45  ksnively
 * *** empty log message ***
 *
Revision 1.2  1997/05/07 12:33:45  ksnively
*** empty log message ***

 * Revision 1.1  1996/10/23  13:54:40  nsipes
 * Initial revision
 *
 * Revision 1.10  1996/08/21  21:58:20  rcarp
 * CP and QRP file output, other updates
 *
 * Revision 1.9  1996/08/08  18:10:09  rcarp
 * gui updates and more CP changes
 *
 * Revision 1.8  1996/08/07  20:31:59  mkappel
 * Startup screen header file.
 *
 * Revision 1.7  1996/07/03  22:55:15  rcarp
 * enhancements and bug fixes for version 1.5b9
 *
 * Revision 1.6  1996/06/21  17:04:20  rcarp
 * upgrades for release 1.5b3, mostly mine vuln
 *
 * Revision 1.5  1996/05/14  16:15:08  rcarp
 * refinements and bug fixes for 1.5 delivery
 *
 * Revision 1.2  1996/03/16  18:36:36  mkappel
 * Interface for Test Mode files.
 *
 * Revision 1.2  1996/03/16  18:36:36  mkappel
 * Interface for Test Mode files.
 *
 * Revision 1.1  1996/01/23  16:48:05  rcarp
 * Initial revision
 *
$State: Exp $
*/
 
/*******************************************

   file: CmsControl.h
   
      Copyright 1995 by the Institute for Defense Analyses
      
         Institute for Defense Analyses
         1801 N. Beauregard Street
         Alexandria, Virginia 22311-1772
         703-845-2000
         
      This software was developed by IDA under U. S. Government
      contract.  For distribution information contact:
      
         U. S. Army Night Vision Directorate
         AMSEL RD NV OD CD
         10221 Burbeck Road, suite 430
         Ft. Belvoir VA 22060-5806
      
*********************************************/

/********************************************

   CmsControl.h
   
      The CMS control header file defines the simulation management
      and control object types, except that the top level message
      classes are defined in GlobalTypes.h
         
   Created by Richard Carpenter
   Modification history:
      created   
      
*********************************************/

#ifndef _UCmsControl_
#define _UCmsControl_

#include "Globals.h"
//#include "Startup.h"

#include <Xm/Xm.h>

class cUdpclient;
cUdpclient *monitorPort; //NPAC

//   Message lists
class cMessageList {

protected:
   cMessage*         fpHead;
   cMessage*         fpTail;
   
   TTimeSim          fSendTime;
   TTimeSim          fLastSendTime;
   
public:
   static  TTimeSim  fDelayAllowed;
      
   virtual   EBoolean   SendNextMsg(TTimeSim* pNextTime, TTimeSim* pSendTime);      //returns true if sent, false if not
             void       AddMsgEnd(cMessage* pMsg);
             void       DeleteMsg(cMessage* pMsg);
             
             void       MsgListShutdown();
   
                        cMessageList();
   virtual             ~cMessageList();
};

class cPrEventList: public cMessageList {

public:
   
                      cPrEventList();
   virtual           ~cPrEventList();
};

class cPrUpdtList: public cMessageList {

public:
             void       AddMsgOrdered(cMsgPrUpdt* msg);
   
                      cPrUpdtList();
   virtual           ~cPrUpdtList();
};

class cEventList: public cMessageList {

public:
   
                      cEventList();
   virtual           ~cEventList();
};

class cUpdtList: public cMessageList {

public:
   
                      cUpdtList();
   virtual           ~cUpdtList();
};

class cDispUpdtList: public cMessageList {

public:
   
                      cDispUpdtList();
   virtual           ~cDispUpdtList();
};

class cLowPrEventList: public cMessageList {

public:
   
                      cLowPrEventList();
   virtual           ~cLowPrEventList();
};

class cLowRateUpdtList: public cMessageList {

public:
           void       AddMsgOrdered(cMsgLowRateUpdt* msg);
   
                      cLowRateUpdtList();
   virtual           ~cLowRateUpdtList();
};

class cMsgMgr {
 protected:
   int         fMsgListDepth;
   TTimeSim    fDepthTime;
   
   static    TTimeSim   fsMinTimeStep;   // time to wait in X loop, if nothing is happening
   
      void   MsgListDepthCheck( int depth);

public:
     EBoolean           ProcessMsgs( TTimeSim* pNextTime );      //returns true if sent, false if not
     void               MsgShutdown();
   
                        cMsgMgr();
                       ~cMsgMgr();
};

class cCmsMgr {

private:
   enum { eparamkwMineType, eparamkwVehicleType, eparamkwProjectileType, 
          eparamkwNewMineType, eparamkwNewVehicleType, eparamkwNewProjectileType, 
          eparamkwSensType, eparamkwNewSensType,
          eparamkwContrlType, eparamkwNewContrlType,
          eparamkwAreaDnlType, eparamkwNewAreaDnlType,
          eSizeParamTable };
   static const TKeywordEntry  fKeyParamTable[eSizeParamTable];

   enum { ekwPduType, eSizeNetParamTable };
   static const TKeywordEntry  fKeyNetParamTable[eSizeNetParamTable];

   enum { ekwVulnTable, ekwNewVulnTable,
          ekwMunDetType, ekwWarheadDetType, ekwCmVulnTable,  
	  ekwCmNewVulnTable,  eSizeVulnParamTable };
   static const TKeywordEntry  fKeyVulnParamTable[eSizeVulnParamTable];

   static    char*          fsSiteDefPath;
   static    unsigned short fsSite;
   static    unsigned short fsApplication;
   
   static    TTimeSim      fsNextProcSimTime;
   static    XtIntervalId  fsIntId;
   
   enum { eentBlkSize = 500 };

   EState               fState;
   TEntityID            fLastEventId;       // last id assigned for fire events
   TEntityID            fLastEntityId;      // last id assigned, also number of ents in list
   cEntity**            fpEntityList;       // array of pointers to entities we simulate
   int                  fEntArraySize;      // allocated size of list

   //cStartupWindow *     fpStartupWin;
   
            void        SetDefaultParams();
            void        SetStartupParams( int* pArgc, char* argv[] );
            void        PrintUnknownFlags( int* pArgc, char* argv[] );

            void        ReadAssocDef();

            void        ReadParamfile( void );
            void        ReadPerfParamFile(cInFileObj&);
            void        ReadNetParamFile(cInFileObj&);
//            void        ReadMechVulnParamFile(cInFileObj&);
            void        ReadVulnParamFile(cInFileObj&);
            void        ReadParamMineType( cInFileObj&, const char * );
            void        ReadParamVehicleType( cInFileObj&, const char * );
            void        ReadParamProjType( cInFileObj&, const char * );
            void        ReadParamNewMineType( cInFileObj&, const char * );
            void        ReadParamNewVehicleType( cInFileObj&, const char * );
            void        ReadParamNewProjType( cInFileObj&, const char * );

            void        OpenOutputFiles();
            int         OpenOutputFile(ofstream** ppFile, char* pName, char* pFileType);
            void        CloseOutputFiles();
            void        WriteFileHeader(ofstream* pFile);
            
  static    void        TimeoutCB( XtPointer, XtIntervalId*);
            EBoolean    RunSim();
            
public:
   TStartupParam        fStartupParam;
            void        Initialize( int* pArgc, char* argv[] );
            void        StartSimulation();
            void        Run();
            void        Shutdown();

   unsigned short       GetSite() { return fsSite; }
   unsigned short       GetApplication() { return fsApplication; }
            char*       GetDirMfInput() { return fStartupParam.fDirMfInput; }
            char*       GetDirMfOutput() { return fStartupParam.fDirMfOutput; }
            char*       GetDirStats() { return fStartupParam.fDirStats; }
            int         GetNumTestFiles() { return fStartupParam.fNumTestFiles; }
            char*       GetTestFilenames(int i) { return fStartupParam.fTestFilenames[i]; }
            EBoolean    GetOperatorPriv() { return fStartupParam.fbOperatorPriv; }
            EProtocol   GetProtocol() { return fStartupParam.feProtocol; }
           
            void        SetState(EState state) { fState = state; }
            void        GetNextEntityId(cEntity* pEnt, TEntityID* fId);
            void        GetNextEventId(TEntityID* fEvt) {fLastEventId.entityNum++;
                                                         *fEvt = fLastEventId; }
            cEntity*    GetEntityByIndex(int index);
            void        DeleteEntityIdById(int id);
            void        DeleteEntityId(cEntity* pEnt);
   
            void        SetMineStateOutput(EBoolean on);
            void        SetInteractionOutput(EBoolean on);
            void        SetMineInputReflect(EBoolean on);
            void        SetVehicleInputReflect(EBoolean on);
            void        SetMineDetectPduOutput(EBoolean on);
  
                        cCmsMgr();
                       ~cCmsMgr();
};

      // messages
class cInDetMsg : public cMsgPrEvent {
 protected:
   cDetonation*   fpDetonation;
   
 public:
      void        SendMsg();
 
              cInDetMsg( cDetonation* pDet ) { fpDetonation = pDet; }
   virtual   ~cInDetMsg();
};

#endif
