/* $RCSfile: DisPdu203.cc,v $ $Revision: 1.5 $ $Author: ksnively $
$Date: 1999/05/19 20:57:03 $ $Log: DisPdu203.cc,v $
$Date: 1999/05/19 20:57:03 $ Revision 1.5  1999/05/19 20:57:03  ksnively
$Date: 1999/05/19 20:57:03 $ Cycle radio IDs for messages so CEF does not choke.
$Date: 1999/05/19 20:57:03 $
$Date: 1999/05/19 20:57:03 $ Revision 1.4  1999/05/10 19:50:40  ksnively
$Date: 1999/05/19 20:57:03 $ Removed unneeded files from repository.  Corrected bug with CMS crashing when receiving transmitter PDUs with out the Radio Network enabled.
$Date: 1999/05/19 20:57:03 $
$Date: 1999/05/19 20:57:03 $ Revision 1.3  1999/04/22 22:19:55  ksnively
$Date: 1999/05/19 20:57:03 $ Sreamlined radio communication routines.  Allowed to send to unlimited number of receivers.
$Date: 1999/05/19 20:57:03 $
$Date: 1999/05/19 20:57:03 $ Revision 1.2  1999/03/26 21:17:28  ksnively
$Date: 1999/05/19 20:57:03 $
$Date: 1999/05/19 20:57:03 $ Added radio communication capability for Command Detonated Mines.  Included sending
$Date: 1999/05/19 20:57:03 $ and receiving transmitter and signal PDUs.  All signals have the option of being
$Date: 1999/05/19 20:57:03 $ processed by the Communication Effects Federate.
$Date: 1999/05/19 20:57:03 $
$Date: 1999/05/19 20:57:03 $ Revision 1.1.1.1  1999/02/16 14:54:30  jchappel
$Date: 1999/05/19 20:57:03 $ Comprehensive Mine Simulator
$Date: 1999/05/19 20:57:03 $
// Revision 2.5  1998/12/02  16:40:55  jchappel
// commented out sendfirepdu line, so CMS works with AARS
//
// Revision 2.4  1998/10/27  19:29:55  jchappel
// modifications for versioning
// // Revision 2.3
1998/04/01 14:39:52 ksnively // *** empty log message ***
//
// Revision 2.2  1998/02/26  21:24:37  ksnively
// Created Mf Camera object to control MAK Stealth view.
// Created vulnerability tables specific to command detonated mines
// and the camera object.
//
// Revision 2.1  1998/02/18  17:16:10  ksnively
// Incorporated AP mine replacement code.
//
// Revision 2.0  1998/01/26  21:01:35  ksnively
// Baseline CMS before additions for AP mine replacements.
//
// Revision 1.2  1997/12/17  14:38:03  ksnively
// Debugged Minefield duplication routine.
// Added input file "netparams" for reading PDU type enumerations.
// Got rid of warning messages during compilation.
//
// Revision 1.1  1997/12/16  13:59:57  ksnively
// Initial revision
//
// Revision 1.7  1997/10/02  17:51:30  austin
// first working port to modsaf3.0
//
// Revision 1.6  1997/10/02  17:48:55  austin
// first working port to modsaf3.0
//
// Revision 1.6  1997/10/02  17:48:55  austin
// first working port to modsaf3.0
//
// Revision 1.5  1997/05/07  12:32:33  ksnively
// *** empty log message ***
//
// Revision 1.4  1997/03/20  19:14:41  ksnively
// added emission tracking, updated to CMS2.0B6
//
// Revision 1.3  1997/01/21  15:08:14  nsipes
// *** empty log message ***
//
// Revision 1.2  1997/01/02  19:48:54  nsipes
// *** empty log message ***
//
// Revision 1.1  1996/10/23  13:54:40  nsipes
// Initial revision
//
// Revision 1.11  1996/09/06  18:57:57  rcarp
// CP bug fixes
//
// Revision 1.10  1996/08/21  21:58:20  rcarp
// CP and QRP file output, other updates
//
// Revision 1.9  1996/08/07  14:19:30  rcarp
// initial revisions for CP protocol
//
// Revision 1.8  1996/07/18  19:06:38  rcarp
// Processes all ESPDUs, for version 1.5b14
//
// Revision 1.7  1996/07/13  19:04:20  rcarp
// version 1.5b13, fixes bug dragging with two buttons and displays damamged vehicles
//
// Revision 1.6  1996/07/03  22:55:15  rcarp
// enhancements and bug fixes for version 1.5b9
//
// Revision 1.5  1996/06/21  17:04:20  rcarp
// upgrades for release 1.5b3, mostly mine vuln
//
// Revision 1.4  1996/06/19  19:08:07  rcarp
// revisions for mine vulnerability, version 1.5b2
//
// Revision 1.3  1996/05/08  00:45:10  rcarp
// changes for 1.5, incl user mines, mine params, param i/o, selection
//
// Revision 1.3  1996/05/08  00:45:10  rcarp
// changes for 1.5, incl user mines, mine params, param i/o, selection
//
// Revision 1.2  1996/02/05  14:32:43  rcarp
// Updates and bug fixes of release version 1.1b5
//
$State: Exp $ */
 
/*******************************************

   file: DisPdu203.cc
   
      Copyright 1995 by the Institute for Defense Analyses
      
         Institute for Defense Analyses
         1801 N. Beauregard Street
         Alexandria, Virginia 22311-1772
         703-845-2000
         
      This software was developed by IDA under U. S. Government
      contract.  For distribution information contact:
      
         U. S. Army Night Vision Directorate
         AMSEL RD NV OD CD
         10221 Burbeck Road, suite 430
         Ft. Belvoir VA 22060-5806
      
*********************************************/

/*******************************************

   DisPdu203.cc
   
      The DIS 2.03 protocol interface implementation
         
   Created by Richard Carpenter
   Modification history:
      created   
      
*********************************************/

#include "DisPdu203.h"
#include "McmPdu.h"
#include "CmsPdu.h"

#include "dis203_values.h"
#include "dis203_entities.h"

#include "p_dis203.h" 
#include "p_dis203exp.h" 

#include "dis204_values.h"
#include "dis204_entities.h"

#include "p_dis204.h" 
#include "p_dis204exp.h" 

#include "Minefield.h"
#include "AtWideArea.h"
#include "CmsControl.h"
#include "Emission.h"
#include "Communication.h"

#include <math.h>
#include <stdio.h>
#include <iostream.h>
#include <stdlib.h>

// Temporary solution to set fusing field in response pdu Qrp3

const TKeywordEntry cDisPduType::fKeyPduType[epdukwSizeTable] = {
   "None", ekeyInt,
   "EntityState", ekeyInt,
   "Fire", ekeyInt,
   "Detonation", ekeyInt,
   "Collision", ekeyInt,
   "ServiceRequest", ekeyInt,
   "ResupplyOffer", ekeyInt,
   "ResupplyReceived", ekeyInt,
   "ResupplyCancel", ekeyInt,
   "RepairComplete", ekeyInt,
   "RepairResponse", ekeyInt,
   "CreateEntity", ekeyInt,
   "RemoveEntity", ekeyInt,
   "StartResume", ekeyInt,
   "StopFreeze", ekeyInt,
   "Acknowledge", ekeyInt,
   "ActionRequest", ekeyInt,
   "ActionResponse", ekeyInt,
   "DataQuery", ekeyInt,
   "SetData", ekeyInt,
   "Data", ekeyInt,
   "EventReport", ekeyInt,
   "Message", ekeyInt,
   "Emission", ekeyInt,
   "Laser", ekeyInt,
   "Transmitter", ekeyInt,
   "Signal", ekeyInt,
   "Receiver", ekeyInt,
   "CpSequencer", ekeyInt,
   "CpNACK", ekeyInt,
   "ExpEnvironment", ekeyInt,
   "CpMinefield", ekeyInt,
   "CpMines", ekeyInt,
   "MinefieldRequest", ekeyInt,
   "MinefieldResponse", ekeyInt,
   "MinefieldState", ekeyInt,
   "MinefieldNACK", ekeyInt,
   "ViewControl", ekeyInt,
};
const TKeywordEntry cDisPduType::fKeyPduFamily[epdufwSizeTable] = {
   "Other", ekeyInt,
   "EntityInteraction", ekeyInt,
   "Warfare", ekeyInt,
   "Logistics", ekeyInt,
   "RadioCommunication", ekeyInt,
   "SimulationManagement", ekeyInt,
   "DistributedEmission", ekeyInt,
   "EntityManagement", ekeyInt,
   "Minefield", ekeyInt,
   "SyntheticEnvironment", ekeyInt,
   "ReliableSimulation", ekeyInt,
   "LiveEntity", ekeyInt,
   "NonRealTime", ekeyInt,
   "Experimental", ekeyInt,
};

cDisPduType::cDisPduType ()
{
   for (int i=0; i<256; i++) {
      pdu[i] = (uint8) i;
      family[i] = (uint8) i;
   }
}

void  cDisPduType::ReadPduType( cInFileObj& infile )
   // reads one entry in the munition-detonation table
{
   EBoolean done = false;
   EBoolean success = true;
   EFileReturn    returnCode;
   int            returnIndex;
   void*          returnVal = NULL;
    
   
   do {
      returnCode = infile.ReadItem( fKeyPduType, epdukwSizeTable,
            &returnIndex, &returnVal );
      switch( returnCode ) {
         case eLevelDone:      // done with param set
            done = true;
            break;

         case eFileNoErr:
	    switch (returnIndex) {
	        case epdukwEntityState:
		  pdu[epduTypeEntityState] = (uint8)*((int*)returnVal);
                     delete returnVal;
							returnVal = NULL;
	          break;

	        case epdukwFire:
		  pdu[epduTypeFire] = (uint8)*((int*)returnVal);
                     delete returnVal;
							returnVal = NULL;
	          break;

	        case epdukwDetonation:
	          pdu[epduTypeDetonation] = (uint8)*((int*)returnVal);
                     delete returnVal;
							returnVal = NULL;
	          break;

	        case epdukwCollision:
		  pdu[epduTypeCollision] = (uint8)*((int*)returnVal);
                     delete returnVal;
							returnVal = NULL;
	          break;

               case epdukwServiceRequest:
		  pdu[epduTypeServiceRequest] = (uint8)*((int*)returnVal);
                     delete returnVal;
							returnVal = NULL;
                  break;

               case epdukwResupplyOffer:
		  pdu[epduTypeResupplyOffer] = (uint8)*((int*)returnVal);
                     delete returnVal;
							returnVal = NULL;
                  break;

	    case epdukwResupplyReceived:
	       pdu[epduTypeResupplyReceived] = *(uint8*)returnVal;
	             delete returnVal;
	                                                returnVal = NULL;
	       break;

	    case epdukwResupplyCancel:
	       pdu[epduTypeResupplyCancel] = (uint8)*((int*)returnVal);
	             delete returnVal;
	                                                returnVal = NULL;
	       break;

	    case epdukwRepairComplete:
	       pdu[epduTypeRepairComplete] = (uint8)*((int*)returnVal);
	             delete returnVal;
	                                                returnVal = NULL;
	       break;

                case epdukwRepairResponse:
		   pdu[epduTypeRepairResponse] = (uint8)*((int*)returnVal);
		      delete returnVal;
		                                        returnVal = NULL;
		   break;

	    case epdukwCreateEntity:
	       pdu[epduTypeCreateEntity] = (uint8)*((int*)returnVal);
	             delete returnVal;
	                                                returnVal = NULL;
	       break;

	    case epdukwRemoveEntity:
	       pdu[epduTypeRemoveEntity] = (uint8)*((int*)returnVal);
	             delete returnVal;
	                                                returnVal = NULL;
	       break;

	    case epdukwStartResume:
	       pdu[epduTypeStartResume] = (uint8)*((int*)returnVal);
	             delete returnVal;
	                                                returnVal = NULL;
	       break;

	    case epdukwStopFreeze:
	       pdu[epduTypeStopFreeze] = (uint8)*((int*)returnVal);
	             delete returnVal;
	                                                returnVal = NULL;
	       break;

	    case epdukwAcknowledge:
	       pdu[epduTypeAcknowledge] = (uint8)*((int*)returnVal);
	             delete returnVal;
	                                                returnVal = NULL;
	       break;

	    case epdukwActionRequest:
	       pdu[epduTypeActionRequest] = (uint8)*((int*)returnVal);
	             delete returnVal;
	                                                returnVal = NULL;
	       break;

	    case epdukwActionResponse:
	       pdu[epduTypeActionResponse] = (uint8)*((int*)returnVal);
	             delete returnVal;
	                                                returnVal = NULL;
	       break;

	    case epdukwDataQuery:
	       pdu[epduTypeDataQuery] = (uint8)*((int*)returnVal);
	             delete returnVal;
	                                                returnVal = NULL;
	       break;

	    case epdukwSetData:
	       pdu[epduTypeSetData] = (uint8)*((int*)returnVal);
	             delete returnVal;
	                                                returnVal = NULL;
	       break;

	    case epdukwData:
	       pdu[epduTypeData] = (uint8)*((int*)returnVal);
	             delete returnVal;
	                                                returnVal = NULL;
	       break;

	    case epdukwEventReport:
	       pdu[epduTypeEventReport] = (uint8)*((int*)returnVal);
	             delete returnVal;
	                                                returnVal = NULL;
	       break;

	    case epdukwMessage:
	       pdu[epduTypeMessage] = (uint8)*((int*)returnVal);
	             delete returnVal;
	                                                returnVal = NULL;
	       break;

	    case epdukwEmission:
	       pdu[epduTypeEmission] = (uint8)*((int*)returnVal);
	             delete returnVal;
	                                                returnVal = NULL;
	       break;

	    case epdukwLaser:
	       pdu[epduTypeLaser] = (uint8)*((int*)returnVal);
	             delete returnVal;
	                                                returnVal = NULL;
	       break;

	    case epdukwTransmitter:
	       pdu[epduTypeTransmitter] = (uint8)*((int*)returnVal);
	             delete returnVal;
	                                                returnVal = NULL;
	       break;

	    case epdukwSignal:
	       pdu[epduTypeSignal] = (uint8)*((int*)returnVal);
	             delete returnVal;
	                                                returnVal = NULL;
	       break;

	    case epdukwReceiver:
	       pdu[epduTypeReceiver] = (uint8)*((int*)returnVal);
	             delete returnVal;
	                                                returnVal = NULL;
	       break;

                
	    case epdukwExpEnvironment:
	       pdu[epduTypeExpEnvironment] = (uint8)*((int*)returnVal);
	             delete returnVal;
	                                                returnVal = NULL;
	       break;

	    case epdukwCpMinefield:
	       pdu[epduTypeCpMinefield] = (uint8)*((int*)returnVal);
	             delete returnVal;
	                                                returnVal = NULL;
	       break;

	    case epdukwCpMines:
	       pdu[epduTypeCpMines] = (uint8)*((int*)returnVal);
	             delete returnVal;
	                                                returnVal = NULL;
	       break;

                
	    case epdukwMinefieldRequest:
	       pdu[epduTypeMinefieldRequest] = (uint8)*((int*)returnVal);
	             delete returnVal;
	                                                returnVal = NULL;
	       break;

	    case epdukwMinefieldResponse:
	       pdu[epduTypeMinefieldResponse] = (uint8)*((int*)returnVal);
	             delete returnVal;
	                                                returnVal = NULL;
	       break;

	    case epdukwMinefieldState: 
	       pdu[epduTypeMinefieldState] = (uint8)*((int*)returnVal);
	             delete returnVal;
	                                                returnVal = NULL;
	       break;

	    case epdukwViewControl: 
	       pdu[epduTypeViewControl] = (uint8)*((int*)returnVal);
	             delete returnVal;
	                                                returnVal = NULL;
	       break;


               default: // what?
                     success =  false;
                  break;
            }
            break;

         default: // error getting next token
            Assert(false, kerrReadParamfile, "cDetonation::ReadParamMunDetType");
            success =   false;
      }
   } while( !done );
   
}

const  float     cDisPdu::fsDefaultPlowDepth = 12.0 / 39.37;


TTimeSim     cCpManager::fsHeartbeat = 30.0 * kSecToSimTime;


TEntityID        cDisPdu::CmsEntID(const DIS203_ENTITY_ID_RECORD & id)
{
   return TEntityID(id.simulation_address.site_id, id.simulation_address.application_id, id.entity_id);
}

EForce           cDisPdu::CmsForce( void* pForce)
{
    return EForce( *( (DIS203_FORCE_ID_TYPE*)pForce ) );
}

TEntityType      cDisPdu::CmsEntType(const DIS203_ENTITY_TYPE_RECORD & type)
{
   return TEntityType(type.kind, type.domain, type.country, type.category,
                      type.subcategory, type.specific, type.extra);
}

EAppearance      cDisPdu::CmsVehAppear(const DIS203_ENTITY_APPEARANCE_TYPE & appear)
{
  if( gCmsMgr.fStartupParam.feProtocol == eDis203 ){

   if ( (appear & DIS203_ENTITY_APPEARANCE_GENERAL_DAMAGE_DESTROYED)
         == DIS203_ENTITY_APPEARANCE_GENERAL_DAMAGE_DESTROYED )
      return eAprDestroyed;
   else if (appear & DIS203_ENTITY_APPEARANCE_GENERAL_MOBILITY_KILL_YES) {
      if (appear & DIS203_ENTITY_APPEARANCE_GENERAL_FIRE_POWER_KILL_YES)
         return eAprImmobNoFire;
      else
         return eAprImmobile;
   }
   else if (appear & DIS203_ENTITY_APPEARANCE_GENERAL_FIRE_POWER_KILL_YES) {
      return eAprNoFire;
   }
   else
      return eAprStandard;
  }
  else {

   if ( (appear & DIS204_ENTITY_APPEARANCE_GENERAL_DAMAGE_DESTROYED)
         == DIS204_ENTITY_APPEARANCE_GENERAL_DAMAGE_DESTROYED )
      return eAprDestroyed;
   else if (appear & DIS204_ENTITY_APPEARANCE_GENERAL_MOBILITY_KILL_YES) {
      if (appear & DIS204_ENTITY_APPEARANCE_GENERAL_FIRE_POWER_KILL_YES)
         return eAprImmobNoFire;
      else
         return eAprImmobile;
   }
   else if (appear & DIS204_ENTITY_APPEARANCE_GENERAL_FIRE_POWER_KILL_YES) {
      return eAprNoFire;
   }
   else
      return eAprStandard;
  }

}

EDeadReckonAlg   cDisPdu::CmsVehDr(const DIS203_DEAD_RECKONING_ALGORITHM_TYPE & alg)
{
   return EDeadReckonAlg(alg);
}

TLocation          cDisPdu::CmsVehLoc(const DIS203_WORLD_COORDINATES_RECORD & loc)
{
   return TLocation(loc.x, loc.y, loc.z);
}

TEntCoord        cDisPdu::CmsEntLoc(const DIS203_ENTITY_COORDINATE_VECTOR_RECORD & loc)
{
   return TEntCoord(loc.x, loc.y, loc.z);
}

TVelocity         cDisPdu::CmsVehVel(const DIS203_LINEAR_VELOCITY_VECTOR_RECORD & vel)
{
   return TVelocity(vel.x, vel.y, vel.z);
}

TOrient       cDisPdu::CmsVehOrient(const DIS203_EULER_ANGLES_RECORD & orient)
{
   return TOrient(orient.psi, orient.theta, orient.phi);
}

TAccel        cDisPdu::CmsVehAccel(const DIS203_LINEAR_ACCELERATION_VECTOR_RECORD & accel)
{
   return TAccel(accel.x, accel.y, accel.z);
}

TAngVel       cDisPdu::CmsVehAngVel(const DIS203_ANGULAR_VELOCITY_VECTOR_RECORD & angVel)
{
   return TAngVel(angVel.rate_about_x_axis, angVel.rate_about_y_axis, angVel.rate_about_z_axis);
}

EWarhead      cDisPdu::CmsWarhead(const DIS203_WARHEAD_TYPE warhead)
{
   return  (EWarhead)warhead;
}

EFuze         cDisPdu::CmsFuze(const DIS203_FUZE_TYPE fuze)
{
   return  (EFuze)fuze;
}

EDetonResult  cDisPdu::CmsDetResult(const void* pDisResult)
{ 
    return  EDetonResult ( * (const DIS203_DETONATION_RESULT_TYPE*) pDisResult );

}

void  cDisPdu::SetArticPartParams(const DIS203_ARTICULATION_PARAMETER_RECORD& partRec,
                        TVehPart* pPart)
{
   unsigned int artType = partRec.parameter_type.value >> 5;
   
   switch (artType) {
      case ePartNumFwmP:
            pPart->SetPartType(ePrtFullPlow);
            if ( partRec.parameter_value.numeric.value <= 0.0)
               pPart->SetDepth( fsDefaultPlowDepth );
            else
               pPart->SetDepth( - fsDefaultPlowDepth );
         break;
   
      case ePartNumTwmP:
            pPart->SetPartType(ePrtTrackPlow);
            if ( partRec.parameter_value.numeric.value <= 0.0)
               pPart->SetDepth( fsDefaultPlowDepth );
            else
               pPart->SetDepth( - fsDefaultPlowDepth );
         break;
     
      case ePartNumFwmR:
            pPart->SetPartType(ePrtFullRake);
            if ( partRec.parameter_value.numeric.value <= 0.0)
               pPart->SetDepth( fsDefaultPlowDepth );
            else
               pPart->SetDepth( - fsDefaultPlowDepth );
         break;
   
      case ePartNumTwmR:
            pPart->SetPartType(ePrtTrackRoller);
         break;
   
      case ePartNumDb:
            pPart->SetPartType(ePrtDogbone);
         break;
   
      case ePartNumORSMC:
            pPart->SetPartType(ePrtORSMC);
         break;
   
      case ePartNumMagCm:
            pPart->SetPartType(ePrtMagCm);
         break;
   
      case ePartNumPrimTurret1:
      case ePartNumPrimTurret2:
      case ePartNumPrimTurret3:
      case ePartNumPrimTurret4:
      case ePartNumPrimTurret5:
      case ePartNumPrimTurret6:
      case ePartNumPrimTurret7:
      case ePartNumPrimTurret8:
      case ePartNumPrimTurret9:
      case ePartNumPrimTurret10:
            pPart->SetPartType(ePrtTurret);
         break;
         
      default:
            pPart->SetPartType(ePrtOther);
   }
}

EPartParam  cDisPdu::CmsAttachPartType(const DIS203_PARAMETER_TYPE_TYPE type)
{
   unsigned int artType = type & 0x7FFFFFFF ;
   switch (artType) {
      case ePartNumMagCm:
            return ePrtMagCm;
//         break;
   }
   return ePrtOther;
}

void  cDisPdu::SetArticPartParams(const DIS204_ARTICULATION_PARAMETER_RECORD& partRec,
                        TVehPart* pPart)
{
   unsigned int artType = partRec.parameter_type.value >> 5;
   
   switch (artType) {
      case ePartNumFwmP:
            pPart->SetPartType(ePrtFullPlow);
            if ( partRec.parameter_value.numeric.value <= 0.0)
               pPart->SetDepth( fsDefaultPlowDepth );
            else
               pPart->SetDepth( - fsDefaultPlowDepth );
         break;
   
      case ePartNumTwmP:
            pPart->SetPartType(ePrtTrackPlow);
            if ( partRec.parameter_value.numeric.value <= 0.0)
               pPart->SetDepth( fsDefaultPlowDepth );
            else
               pPart->SetDepth( - fsDefaultPlowDepth );
         break;
     
      case ePartNumFwmR:
            pPart->SetPartType(ePrtFullRake);
            if ( partRec.parameter_value.numeric.value <= 0.0)
               pPart->SetDepth( fsDefaultPlowDepth );
            else
               pPart->SetDepth( - fsDefaultPlowDepth );
         break;
   
      case ePartNumTwmR:
            pPart->SetPartType(ePrtTrackRoller);
         break;
   
      case ePartNumDb:
            pPart->SetPartType(ePrtDogbone);
         break;
   
      case ePartNumORSMC:
            pPart->SetPartType(ePrtORSMC);
         break;
   
      case ePartNumMagCm:
            pPart->SetPartType(ePrtMagCm);
         break;
   
      case ePartNumPrimTurret1:
      case ePartNumPrimTurret2:
      case ePartNumPrimTurret3:
      case ePartNumPrimTurret4:
      case ePartNumPrimTurret5:
      case ePartNumPrimTurret6:
      case ePartNumPrimTurret7:
      case ePartNumPrimTurret8:
      case ePartNumPrimTurret9:
      case ePartNumPrimTurret10:
            pPart->SetPartType(ePrtTurret);
         break;
         
      default:
            pPart->SetPartType(ePrtOther);
   }
}


DIS203_ENTITY_ID_RECORD         cDisPduTranslator::DisEntID(const TEntityID & id)
{   
   DIS203_ENTITY_ID_RECORD disID;      // initializer not implemented
   disID.simulation_address.site_id        = id.site;
   disID.simulation_address.application_id = id.application;
   disID.entity_id                         = id.entityNum;
   return disID;
}

DIS203_ENTITY_ID_RECORD         cDisPduTranslator::DisEntID(unsigned short idNum)
{   
   DIS203_ENTITY_ID_RECORD disID;
   disID.entity_id                         = idNum;

   if (idNum) {
      disID.simulation_address.site_id        = gCmsMgr.GetSite();
      disID.simulation_address.application_id = gCmsMgr.GetApplication();
   }
   else {
      disID.simulation_address.site_id        = 0;
      disID.simulation_address.application_id = 0;
   }
   
   return disID;
}


DIS203_EVENT_ID_RECORD         cDisPduTranslator::DisEventID(const TEntityID & id)
{   
   DIS203_EVENT_ID_RECORD disID;      // initializer not implemented
   disID.simulation_address.site_id        = id.site;
   disID.simulation_address.application_id = id.application;
   disID.event_id                          = id.entityNum;
   return disID;
}

DIS203_EVENT_ID_RECORD         cDisPduTranslator::DisEventID(unsigned short idNum)
{   
   DIS203_EVENT_ID_RECORD disID;      // initializer not implemented
   disID.simulation_address.site_id        = gCmsMgr.GetSite();
   disID.simulation_address.application_id = gCmsMgr.GetApplication();
   disID.event_id                          = idNum;
   return disID;
}

void            cDisPduTranslator::DisForce(void* pDisForce, EForce force)
{ 
      * (DIS203_FORCE_ID_TYPE*)pDisForce = force;
}

DIS203_ENTITY_TYPE_RECORD       cDisPduTranslator::DisEntType(const TEntityType & type)
{
   DIS203_ENTITY_TYPE_RECORD disType;
   disType.kind = type.kind;
   disType.domain = type.domain;
   disType.country = type.country;
   disType.category = type.category;
   disType.subcategory = type.subcategory;
   disType.specific = type.specific;
   disType.extra = type.extra;
   return disType;
}

DIS203_ENTITY_APPEARANCE_TYPE   cDisPduTranslator::DisVehAppear(EAppearance appear)
{
   switch (appear) {
      case eAprStandard:
            return DIS203_ENTITY_APPEARANCE_GENERAL_STANDARD_APPEARANCE;
         //break;
   
      case eAprImmobile:
            return DIS203_ENTITY_APPEARANCE_GENERAL_MOBILITY_KILL_YES;
         //break;
   
      case eAprNoFire:
            return DIS203_ENTITY_APPEARANCE_GENERAL_FIRE_POWER_KILL_YES;
         //break;
   
      case eAprImmobNoFire:
            return  ( DIS203_ENTITY_APPEARANCE_GENERAL_MOBILITY_KILL_YES &
                      DIS203_ENTITY_APPEARANCE_GENERAL_FIRE_POWER_KILL_YES );
         //break;
   
      case eAprDestroyed:
            return DIS203_ENTITY_APPEARANCE_GENERAL_DAMAGE_DESTROYED;
         //break;
   
      case eAprDeact:
            return (unsigned long)k204AppearanceDeactivated;
         //break;
         
   }
   return 0;
}


DIS203_DEAD_RECKONING_ALGORITHM_TYPE  cDisPduTranslator::DisVehDr(EDeadReckonAlg alg)
{
   return EDeadReckonAlg(alg);
}

DIS203_PARAMETER_TYPE_TYPE      cDisPduTranslator::DisVehPartParam(EPartParam /*paramType*/, const EPartValueType & /*valType*/)
{
      return DIS203_ARTICULATED_PART_EMPTY;
}


DIS203_WORLD_COORDINATES_RECORD    cDisPduTranslator::DisVehLoc(const TLocation & loc)
{
   DIS203_WORLD_COORDINATES_RECORD   disLoc;
   disLoc.x = loc.x;
   disLoc.y = loc.y;
   disLoc.z = loc.z;
   return disLoc;
}

DIS203_ENTITY_COORDINATE_VECTOR_RECORD    cDisPduTranslator::DisEntLoc(const TEntCoord & loc)
{
   DIS203_ENTITY_COORDINATE_VECTOR_RECORD   disLoc;
   disLoc.x = loc.x;
   disLoc.y = loc.y;
   disLoc.z = loc.z;
   return disLoc;
}

DIS203_ENTITY_COORDINATE_VECTOR_RECORD    cDisPduTranslator::DisEntLoc(const T3Ddouble & loc)
{
   DIS203_ENTITY_COORDINATE_VECTOR_RECORD   disLoc;
   disLoc.x = loc.x;
   disLoc.y = loc.y;
   disLoc.z = loc.z;
   return disLoc;
}

DIS203_LINEAR_VELOCITY_VECTOR_RECORD   cDisPduTranslator::DisVehVel(const TVelocity & vel)
{
   DIS203_LINEAR_VELOCITY_VECTOR_RECORD   disVel;
   disVel.x = vel.x;
   disVel.y = vel.y;
   disVel.z = vel.z;
   return disVel;
}

DIS203_EULER_ANGLES_RECORD      cDisPduTranslator::DisVehOrient(const TOrient & orient)
{
   DIS203_EULER_ANGLES_RECORD   disOrient;
   disOrient.psi   = orient.psi;
   disOrient.theta = orient.theta;
   disOrient.phi   = orient.phi;
   return disOrient;
}

DIS203_LINEAR_ACCELERATION_VECTOR_RECORD   cDisPduTranslator::DisVehAccel(const TAccel & accel)
{
   DIS203_LINEAR_ACCELERATION_VECTOR_RECORD   disAccel;
   disAccel.x = accel.x;
   disAccel.y = accel.y;
   disAccel.z = accel.z;
   return disAccel;
}

DIS203_ANGULAR_VELOCITY_VECTOR_RECORD     cDisPduTranslator::DisVehAngVel(const TAngVel & angVel)
{
   DIS203_ANGULAR_VELOCITY_VECTOR_RECORD   disangVel;
   disangVel.rate_about_x_axis = angVel.x;
   disangVel.rate_about_y_axis = angVel.y;
   disangVel.rate_about_z_axis = angVel.z;
   return disangVel;
}

DIS203_BURST_DESCRIPTOR_RECORD     cDisPduTranslator::DisBurstDesc( 
                                    const TEntityType & type, EWarhead warhead, EFuze fuze)
{
   DIS203_BURST_DESCRIPTOR_RECORD burst;
   burst.munition.kind       = type.kind;
   burst.munition.domain     = type.domain;
   burst.munition.country    = type.country;
   burst.munition.category    = type.category;
   burst.munition.subcategory = type.subcategory;
   burst.munition.specific    = type.specific;
   burst.munition.extra       = type.extra;
   burst.warhead  = (DIS203_WARHEAD_TYPE) warhead;
   burst.fuze     = (DIS203_FUZE_TYPE) fuze;
   burst.quantity = 1;
   burst.rate     = 0;
   
   return burst;
}

DIS203_ENCODING_SCHEME   cDisPduTranslator::DisEncodingScheme(uint16 encodingScheme)
{
   return encodingScheme;
}

DIS203_DETONATION_RESULT_TYPE      cDisPduTranslator::DisDetonResult( EDetonResult result )
{
      return (DIS203_DETONATION_RESULT_TYPE)result;
}


void      cDisPduTranslator::ReceivePdu(void * buf, TTimeSim timeDelta)
{
         // VerifyPdu checks exercise and protocol version, not addressee
   if ( VerifyPdu(buf) ) {
      int   pduType = GetPduType( buf );
         if (pduType == (int)gPduType.pdu[epduTypeEntityState]) {
            //   if ( gfNetif )
                  cout << "ES pdu " << endl;
               RecvESPdu(buf, timeDelta);
	 }
      
         else if (pduType == (int)gPduType.pdu[epduTypeDetonation]) {
             //  if ( gfNetif )
                  cout << "Det pdu " << endl;
               RecvDetonPdu(buf, timeDelta);
	 }

         else if (pduType == (int)gPduType.pdu[epduTypeMinefieldRequest]) {
              // if ( gfNetif )
                  cout << "Mf req pdu " << endl;
               if ( fpQrpMgr )
                  fpQrpMgr->RecvMfReqPdu(buf, timeDelta);
	 }
/*
	 else if (pduType == (int)gPduType.pdu[epduTypeMinefieldNACK]) {
	       if ( gfNetif )
	          cout << "Mf NACK pdu " << endl;
	       if ( fpQrpMgr )
	          fpQrpMgr->RecvMfNACKPdu(buf, timedelta);
	      }
 */
         else if (pduType == (int)gPduType.pdu[epduTypeEmission]) {
	       //if ( gfNetif )
                  cout << "Emission pdu " << endl;
	       RecvEmissionPdu(buf, timeDelta);
	 }

         else if (pduType == (int)gPduType.pdu[epduTypeCpMinefield]) {
               //if ( gfNetif )
                  cout << "CP minefield pdu " << endl;
               if ( fpCpMgr )
                  fpCpMgr->RecvCpMfPdu(buf, timeDelta);
	 }

         else if (pduType == (int)gPduType.pdu[epduTypeCpMines]) {
               //if ( gfNetif )
                  cout << "CP mines pdu " << endl;
               if ( fpCpMgr )
                  fpCpMgr->RecvCpMinesPdu(buf, timeDelta);
	 }
	    
         else if (pduType == (int)gPduType.pdu[epduTypeExpEnvironment]) {
	        //if ( gfNetif )
		   cout << "Environment pdu " << endl;
		RecvEnvironmentPdu(buf, timeDelta);
	 }

	 else if (pduType == (int)gPduType.pdu[epduTypeTransmitter]) {
	 	//if(gfNetif)
		   cout << "Transmitter pdu " << endl;
		RecvTransmitterPdu(buf, timeDelta);
	 }
	 else if (pduType == (int)gPduType.pdu[epduTypeSignal]) {
	 	//if(gfNetif)
		   cout << "Signal pdu " << endl;
		RecvSignalPdu(buf, timeDelta);
	 }
         else {
	        //if ( gfNetif ) {
		   cout << "unprocessed pdu type: " << pduType << endl;
		   cout << "pdu ignored" << endl;
		//}
	 }

   }
   else //if ( gfNetif )
      cout << "pdu type not verified, ignored" << endl;
}

int   cDisPduTranslator::GetPduType( void* buf)
{      
   if( gCmsMgr.fStartupParam.feProtocol == eDis203 )
      return ((DIS203_PDU_HEADER_RECORD*) buf)->pdu_type;
   else
      return ((DIS204_PDU_HEADER_RECORD*) buf)->pdu_type;

}

EBoolean   cDisPduTranslator::VerifyPdu( void* buf)
   // verify incoming DIS PDUs.  We check:
   //   protocol version
   //   pdu type (in acceptable range, no experimental PDUs in this check)
   //   exercise ID
{   
   DIS203_PDU_HEADER_RECORD* pPdu = (DIS203_PDU_HEADER_RECORD*)buf;
   DIS204_PDU_HEADER_RECORD* pPdu204 = (DIS204_PDU_HEADER_RECORD*)buf;

   if( gCmsMgr.fStartupParam.feProtocol == eDis203 ){
      if ( (pPdu->protocol_version == DIS203_PROTOCOL_VERSION_2_0)     &&
        (pPdu->exercise_id      == gpNetMgr->GetExerciseId() ) )
         return true;
   }
   else{
      if ( (pPdu204->protocol_version == DIS204_PROTOCOL_VERSION_2_0)     &&
        (pPdu204->exercise_id      == gpNetMgr->GetExerciseId() ) )
         return true;
   }
 
      return false;
}

short cDisPduTranslator::DisFusing(cMine* pMine)
{
	short pfuze = 0x00, sfuze=0x00, anti_handling = 0x00;
	int FuzeNameIndex = pMine->GetFuzeNameIndex();
	
	switch (FuzeNameIndex) 
	{
	    case TFuzeParam::efuzetypePressure:
	    case TFuzeParam::efuzetypeApPressure:
		pfuze = DisFusingPressure;
		break;
	    case TFuzeParam::efuzetypeTiltrod:
		pfuze = DisFusingTiltrod;
		break;
	    case TFuzeParam::efuzetypeMagnetic:
		pfuze = DisFusingMagnetic;
		break;
	    case TFuzeParam::efuzetypeApTrip:
		pfuze = DisFusingTripwire;
		break;
	    case TFuzeParam::efuzetypeAcousticTracker:
	    case TFuzeParam::efuzetypeAcousticTrigger:
	    case TFuzeParam::efuzetypeTopSublet:
	    case TFuzeParam::efuzetypeOther:
		pfuze = DisFusingOther;
		break;
	    default:
		pfuze = DisFusingNoFuze;
		break;

	 }
	 
         
	 if (pMine->GetAntiHandling()==eYes)
		     anti_handling = 0x01;
	
	 
	 return (pfuze << 9) + (sfuze << 2) + (anti_handling << 1);
}


void    cDisPduTranslator::FillHdr(DIS203_PDU_TYPE_TYPE type, DIS203_PDU_TYPE_TYPE family)
      // length must be determined before filling in the header
{
   DIS204_PDU_HEADER_RECORD* pPduH = (DIS204_PDU_HEADER_RECORD*)fpOutBuf;

   if( gCmsMgr.fStartupParam.feProtocol == eDis203 )
      pPduH->protocol_version = DIS203_PROTOCOL_VERSION_2_0; 
   else
      pPduH->protocol_version = DIS204_PROTOCOL_VERSION_2_0;  


   pPduH->exercise_id      = gpNetMgr->GetExerciseId();
   pPduH->pdu_type         = type;
   pPduH->protocol_family  = family;  //temp fix for minefield family 
   //    pPduH->_unused_3         = 0;
   pPduH->timestamp.value  = (unsigned int)(kSimTimeToDis * GetCurSimTime ()) << 1;
   pPduH->timestamp.reference  = 0;               // relative time
   pPduH->length           = fLength;
   pPduH->_unused_4        = 0;

}

void    cDisPduTranslator::SendVehState(cVehicle* pVeh)
{
   cout<<"sending ES PDU"<< endl;
   DIS203_ENTITY_STATE_PDU* pPdu = (DIS203_ENTITY_STATE_PDU*)fpOutBuf;
   DIS204_ENTITY_STATE_PDU* pPdu204 = (DIS204_ENTITY_STATE_PDU*)fpOutBuf;
      //** size can vary with number of articulated and attached parts

   if( gCmsMgr.fStartupParam.feProtocol == eDis203 ){
      fLength = sizeof(DIS203_ENTITY_STATE_PDU) - sizeof(DIS203_ARTICULATION_PARAMETER_RECORD);


      pPdu->entity_id                 = DisEntID(pVeh->GetEntityID());
      DisForce( &(pPdu->force_id), pVeh->GetVehicleForce());
      pPdu->number_of_articulation_parameters = 0;
      pPdu->entity_type               = DisEntType(pVeh->GetEntType());
      pPdu->alternative_entity_type   = DisEntType(pVeh->GetVehicleAltType());
      pPdu->entity_linear_velocity    = DisVehVel(pVeh->GetVehicleVel());
      pPdu->entity_location           = DisVehLoc(pVeh->GetGeoLoc());
      pPdu->entity_orientation        = DisVehOrient(pVeh->GetGeoOrient());
      pPdu->entity_appearance         = DisVehAppear(pVeh->GetVehicleAppear());
      pPdu->dead_reckoning_parameters.dead_reckoning_algorithm = DisVehDr(pVeh->GetVehicleDrAlg());
      pPdu->dead_reckoning_parameters.entity_linear_accel      = DisVehAccel(pVeh->GetVehicleAccel());
      pPdu->dead_reckoning_parameters.entity_angular_velocity  = DisVehAngVel(pVeh->GetVehicleAngVel());
      pPdu->entity_marking.Character_set       = DIS203_ENTITY_MARKING_CHAR_SET_UNUSED;
      pPdu->entity_marking.Character_string[0] = 0;
      pPdu->capabilities._unused_2                       = 0;
      pPdu->capabilities.repair_capability               = 0;
      pPdu->capabilities.recovery_capability             = 0;
      pPdu->capabilities.fuel_supply_capability          = 0;
      pPdu->capabilities.ammunition_supply_capability    = 0;

      // don't use articulation parameters yet

      FillHdr(DIS203_ENTITY_STATE_PDU_KIND, DIS204_OTHER_PDU_FAMILY );
      gpNetMgr->SendPdu(fpOutBuf, fLength);


   }
   else{
      fLength = sizeof(DIS204_ENTITY_STATE_PDU) - sizeof(DIS204_ARTICULATION_PARAMETER_RECORD);

      pPdu204->entity_id                 = DisEntID(pVeh->GetEntityID());
      DisForce( &(pPdu->force_id), pVeh->GetVehicleForce());
      pPdu204->number_of_articulation_parameters = 0;
      pPdu204->entity_type               = DisEntType(pVeh->GetEntType());
      pPdu204->alternative_entity_type   = DisEntType(pVeh->GetVehicleAltType());
      pPdu204->entity_linear_velocity    = DisVehVel(pVeh->GetVehicleVel());
      pPdu204->entity_location           = DisVehLoc(pVeh->GetGeoLoc());
      pPdu204->entity_orientation        = DisVehOrient(pVeh->GetGeoOrient());
      pPdu204->entity_appearance         = DisVehAppear(pVeh->GetVehicleAppear());
      pPdu204->dead_reckoning_parameters.dead_reckoning_algorithm = DisVehDr(pVeh->GetVehicleDrAlg());
      pPdu204->dead_reckoning_parameters.entity_linear_accel      = DisVehAccel(pVeh->GetVehicleAccel());
      pPdu204->dead_reckoning_parameters.entity_angular_velocity  = DisVehAngVel(pVeh->GetVehicleAngVel());
      pPdu204->entity_marking.Character_set       = DIS204_ENTITY_MARKING_CHAR_SET_UNUSED;
      pPdu204->entity_marking.Character_string[0] = 0;
      pPdu204->capabilities._unused_2                       = 0;
      pPdu204->capabilities.repair_capability               = 0;
      pPdu204->capabilities.recovery_capability             = 0;
      pPdu204->capabilities.fuel_supply_capability          = 0;
      pPdu204->capabilities.ammunition_supply_capability    = 0;

      // don't use articulation parameters yet

      FillHdr(DIS204_ENTITY_STATE_PDU_KIND, DIS204_ENTITY_INTERACTION_PDU_FAMILY);
      gpNetMgr->SendPdu(fpOutBuf, fLength);
   }
}

void    cDisPduTranslator::SendViewControl(cVehicle* pView, TEntityID toID)
{
   cout<<"sending ViewControl PDU"<< endl;
   TViewControlPdu* pPdu = (TViewControlPdu*)fpOutBuf;

   /*
   fLength = sizeof (TViewControlPdu) -  sizeof (UNetViewControlParams);
   printf ("Sizeof TViewControlPdu = %d\n", fLength);
   printf ("Sizeof UNetViewControlParams Param Record = %d\n", sizeof (UNetViewControlParams));
   printf ("Sizeof TAbsoluteParams Param Record = %d\n", sizeof (TAbsoluteParams));
   printf ("Sizeof TTetherParams Param Record = %d\n", sizeof (TTetherParams));
   printf ("Sizeof TCompassParams Param Record = %d\n", sizeof (TCompassParams));
   printf ("Sizeof TMimicParams Param Record = %d\n", sizeof (TMimicParams));
   printf ("Sizeof TOrbitParams Param Record = %d\n", sizeof (TOrbitParams));
   printf ("Sizeof TTrackParams Param Record = %d\n", sizeof (TTrackParams));
   printf ("Sizeof TTetherTrackParams Param Record = %d\n", sizeof (TTetherTrackParams));
   printf ("Sizeof TMimicTrackParams Param Record = %d\n", sizeof (TMimicTrackParams));
   printf ("Sizeof TEntitiesInGroup Param Record = %d\n", sizeof (TEntitiesInGroup));
   printf ("Sizeof TGroupParams Param Record = %d\n", sizeof (TGroupParams));
   printf ("Sizeof TModelessParams Param Record = %d\n", sizeof (TModelessParams));
   */
 
   pPdu->viewerId                 = DisEntID(toID);
   pPdu->senderId                 = DisEntID(pView->GetEntityID());

   pPdu->unused0                  = 0x0000;
   pPdu->unused                   = 0x00000000;
   //Always send view control PDU using absolute mode.

   //Tell MAK Stealth to use absolute mode.
   pPdu->command                  = 0;

   pPdu->params.absolute.ignoreFlags = 0x00000000;
   pPdu->params.absolute.padding     = 0x00000000;
   pPdu->params.absolute.world       = DisVehLoc(pView->GetGeoLoc());

   // Stealth expects orientation in its own local coord system.  For psi, CMS uses 0 radians as East
   // and PI/2 radians as north.  MAK Stealth uses 0 radians as North and 
   // PI/2 radians as East.  We then must convert the psi radian to (PI/2 - cms.psi).
   pPdu->params.absolute.orientation = DisVehOrient(pView->GetTccOrient());
   pPdu->params.absolute.orientation.psi = M_PI/2.00 - pPdu->params.absolute.orientation.psi;
   /*
   printf ("Orientation is psi = %f, theta = %f, phi = %f\n", 
	   pPdu->params.absolute.orientation.psi, pPdu->params.absolute.orientation.theta,  
	   pPdu->params.absolute.orientation.phi);
	   */

   fLength += sizeof(TAbsoluteParams);

   FillHdr((DIS203_PDU_TYPE_TYPE)(gPduType.pdu[epduTypeViewControl]),
                        DIS204_OTHER_PDU_FAMILY);

   gpNetMgr->SendPdu(fpOutBuf, fLength);
}

void    cDisPduTranslator::SendMineDetonation(TDetonationData& detData )
{
  cout <<"Sending MineDetonation" <<endl;
   DIS203_DETONATION_PDU* pPdu = (DIS203_DETONATION_PDU*)fpOutBuf;
   DIS204_DETONATION_PDU* pPdu204 = (DIS204_DETONATION_PDU*)fpOutBuf;

   if( gCmsMgr.fStartupParam.feProtocol == eDis203 ){
     
      fLength = sizeof(DIS203_DETONATION_PDU) - sizeof(DIS203_ARTICULATION_PARAMETER_RECORD);

      pPdu->firing_entity_id                  = DisEntID(detData.fFiringEnt);

      if ( detData.feDetResult <= edetEntityProximate ) {
         pPdu->target_entity_id               = DisEntID(detData.fTargetEnt);
         pPdu->location_in_entity_coordinates = DisEntLoc( detData.fLocTargetRef );
      }
      else {
         pPdu->target_entity_id               = DisEntID(0);
         pPdu->location_in_entity_coordinates = DisEntLoc( T3Ddouble(0.0, 0.0, 0.0) );
      }
   
      pPdu->munition_id                       = DisEntID(detData.fMunitionEnt);
      pPdu->event_id                          = DisEventID(detData.fEventId);
      pPdu->velocity                          = DisVehVel( detData.fVelocity );
      pPdu->location_in_world                 = DisVehLoc( detData.fDetLocation );
      pPdu->burst_descriptor                  = DisBurstDesc( detData.fDetonationType,
                                                           detData.fWarhead,
                                                           detData.fFuze );
      pPdu->detonation_result                 = DisDetonResult( detData.feDetResult );
      pPdu->number_of_articulation_parameters = 0;
      pPdu->_unused_8                         = 0;
   
   
         //*****
         //  special adjustment to ModSAF 2.1 problem with mines
/*
   if ( ( detData.feDetResult == edetEntityImpact) ||
        ( detData.feDetResult == edetEntityProximate) ) {
      pPdu->location_in_entity_coordinates.x = pPdu->location_in_entity_coordinates.y;
      pPdu->location_in_entity_coordinates.y = 0.0;
      pPdu->location_in_entity_coordinates.z = 0.0;
   }
*/
         //*********


     if ( detData.fTgtPart.GetPartType() != ePrtOther ) {
         TVehPart& part = detData.fTgtPart;
         pPdu->number_of_articulation_parameters = 1;
         pPdu->articulation_parameters[0].change_indicator = part.GetPartChange();
         pPdu->articulation_parameters[0].id_part_attached_to = part.GetPartAttachPt();
         pPdu->articulation_parameters[0].parameter_type.value = part.GetPartValueType();
         if ( part.IsAttached() ) {
            pPdu->articulation_parameters[0].parameter_value.entity_type = DisEntType(part.GetEntType());
         }
         else {      // articulated
            pPdu->articulation_parameters[0].parameter_value.numeric.value = part.GetPartValue();
            pPdu->articulation_parameters[0].parameter_value.numeric._unused_5 = 0;
         }
   
         fLength += sizeof(DIS203_ARTICULATION_PARAMETER_RECORD);
      }
      FillHdr(DIS203_DETONATION_PDU_KIND, DIS204_OTHER_PDU_FAMILY );
 
   }

   else{
     
      fLength = sizeof(DIS204_DETONATION_PDU) - sizeof(DIS204_ARTICULATION_PARAMETER_RECORD);

      pPdu204->firing_entity_id                  = DisEntID(detData.fFiringEnt);

      // if ( detData.feDetResult <= edetEntityProximate ) {
         pPdu204->target_entity_id               = DisEntID(detData.fTargetEnt);
         pPdu204->location_in_entity_coordinates = DisEntLoc( detData.fLocTargetRef );
	 // }
	 // else {
	 //    pPdu204->target_entity_id               = DisEntID(0);
	 //   pPdu204->location_in_entity_coordinates = DisEntLoc( T3Ddouble(0.0, 0.0, 0.0) );
	 // }
   
      pPdu204->munition_id                       = DisEntID(detData.fMunitionEnt);
      pPdu204->event_id                          = DisEventID(detData.fEventId);
      pPdu204->velocity                          = DisVehVel( detData.fVelocity );
      pPdu204->location_in_world                 = DisVehLoc( detData.fDetLocation );
      pPdu204->burst_descriptor                  = DisBurstDesc( detData.fDetonationType,
                                                           detData.fWarhead,
                                                           detData.fFuze );
      pPdu204->detonation_result                 = DisDetonResult( detData.feDetResult );
      pPdu204->number_of_articulation_parameters = 0;
      pPdu204->_unused_8                         = 0;
   
   

     if ( detData.fTgtPart.GetPartType() != ePrtOther ) {
         TVehPart& part = detData.fTgtPart;
         pPdu204->number_of_articulation_parameters = 1;

	 /* here the change is going into a 16 bit from a 8 bit, probalby do conversion */
         pPdu204->articulation_parameters[0].change_indicator = part.GetPartChange204();
         pPdu204->articulation_parameters[0].id_part_attached_to = part.GetPartAttachPt();
         pPdu204->articulation_parameters[0].parameter_type.value = part.GetPartValueType();
         if ( part.IsAttached() ) {
            pPdu204->articulation_parameters[0].parameter_value.entity_type = DisEntType(part.GetEntType());
         }
         else {      // articulated
            pPdu204->articulation_parameters[0].parameter_value.numeric.value = part.GetPartValue();
	    pPdu204->articulation_parameters[0].parameter_value.numeric._unused_5 = 0;
         }
   
         fLength += sizeof(DIS204_ARTICULATION_PARAMETER_RECORD);
      }
      FillHdr(DIS204_DETONATION_PDU_KIND, DIS204_WARFARE_PDU_FAMILY);
  
   }


   gpNetMgr->SendPdu(fpOutBuf, fLength);
}

void    cDisPduTranslator::SendMineFire(TFireData& fireData)
   // firing projectiles from mines
{
   cout<<"sending mine fire PDU"<<endl;
   DIS203_FIRE_PDU* pPdu = (DIS203_FIRE_PDU*)fpOutBuf;
   DIS204_FIRE_PDU* pPdu204 = (DIS204_FIRE_PDU*)fpOutBuf;

   if( gCmsMgr.fStartupParam.feProtocol == eDis203 ){

      fLength = sizeof(DIS203_FIRE_PDU);

      pPdu->firing_entity_id                  = DisEntID(fireData.fFiringEnt);
      pPdu->target_entity_id                  = DisEntID(fireData.fTargetEnt);
   
      pPdu->munition_id                       = DisEntID(fireData.fMunitionEnt);
      pPdu->event_id                          = DisEventID(fireData.fEventId);
      pPdu->velocity                          = DisVehVel( fireData.fGeoLaunchVel );
   
      pPdu->_unused_7                         = 0;
      pPdu->location_in_world                 = DisVehLoc( fireData.fLocation );
      pPdu->burst_descriptor                  = DisBurstDesc( fireData.fDetonationType,
                                                           fireData.fWarhead,
                                                           fireData.fFuze );
      pPdu->fire_range                        = DisRange( fireData.fFireRange );
      FillHdr(DIS203_FIRE_PDU_KIND, DIS204_WARFARE_PDU_FAMILY);
   }
   else{
      fLength = sizeof(DIS204_FIRE_PDU);

      pPdu204->firing_entity_id                  = DisEntID(fireData.fFiringEnt);
      pPdu204->target_entity_id                  = DisEntID(fireData.fTargetEnt);
   
      pPdu204->munition_id                       = DisEntID(fireData.fMunitionEnt);
      pPdu204->event_id                          = DisEventID(fireData.fEventId);
      pPdu204->velocity                          = DisVehVel( fireData.fGeoLaunchVel );
   
      pPdu204->_unused_7                         = 0;
      pPdu204->location_in_world                 = DisVehLoc( fireData.fLocation );
      pPdu204->burst_descriptor                  = DisBurstDesc( fireData.fDetonationType,
                                                           fireData.fWarhead,
                                                           fireData.fFuze );
      pPdu204->fire_range                        = DisRange( fireData.fFireRange );
      FillHdr(DIS204_FIRE_PDU_KIND, DIS204_WARFARE_PDU_FAMILY);  
   }


   //   gpNetMgr->SendPdu(fpOutBuf, fLength);
}

void    cDisPduTranslator::SendProjFire(cProjectile* pProjectile)
   // firing penetrators from sublets
{
   cout <<"Sending ProjFire" <<endl;
   DIS203_FIRE_PDU* pPdu = (DIS203_FIRE_PDU*)fpOutBuf;
   DIS204_FIRE_PDU* pPdu204 = (DIS204_FIRE_PDU*)fpOutBuf;

   if( gCmsMgr.fStartupParam.feProtocol == eDis203 ){

      fLength = sizeof(DIS203_FIRE_PDU);

      pPdu->firing_entity_id                  = DisEntID(pProjectile->GetEntityID());
      pPdu->target_entity_id                  = DisEntID(pProjectile->GetTargetID());
      pPdu->munition_id                       = DisEntID(pProjectile->GetEntityID());
      pPdu->event_id                          = DisEventID(pProjectile->GetEventID());
      pPdu->_unused_7                         = 0;
      pPdu->location_in_world                 = DisVehLoc( pProjectile->GetDetLoc() );
      pPdu->burst_descriptor                  = DisBurstDesc( pProjectile->GetDetonationType(),
                                                           pProjectile->GetWarhead(),
                                                           pProjectile->GetFuze() );
      pPdu->velocity                          = DisVehVel( pProjectile->GetVehicleGeoVel() );
      pPdu->fire_range                        = DisRange( pProjectile->GetFireRange() );
      FillHdr(DIS203_FIRE_PDU_KIND, DIS204_WARFARE_PDU_FAMILY);
   }
   else{

      fLength = sizeof(DIS204_FIRE_PDU);

      pPdu204->firing_entity_id                  = DisEntID(pProjectile->GetEntityID());
      pPdu204->target_entity_id                  = DisEntID(pProjectile->GetTargetID());
      pPdu204->munition_id                       = DisEntID(pProjectile->GetEntityID());
      pPdu204->event_id                          = DisEventID(pProjectile->GetEventID());
      pPdu204->_unused_7                         = 0;
      pPdu204->location_in_world                 = DisVehLoc( pProjectile->GetDetLoc() );
      pPdu204->burst_descriptor                  = DisBurstDesc( pProjectile->GetDetonationType(),
                                                           pProjectile->GetWarhead(),
                                                           pProjectile->GetFuze() );
      pPdu204->velocity                          = DisVehVel( pProjectile->GetVehicleGeoVel() );
      pPdu204->fire_range                        = DisRange( pProjectile->GetFireRange() );
      FillHdr(DIS204_FIRE_PDU_KIND, DIS204_WARFARE_PDU_FAMILY);
   }


   gpNetMgr->SendPdu(fpOutBuf, fLength);
}

void    cDisPduTranslator::SendProjDeton(cProjectile* pProjectile)
   // penetrator or projectile warhead detonating on target
{
   cout << "Sending ProjDeton" <<endl;
   DIS203_DETONATION_PDU* pPdu = (DIS203_DETONATION_PDU*)fpOutBuf;
   DIS204_DETONATION_PDU* pPdu204 = (DIS204_DETONATION_PDU*)fpOutBuf;


   if( gCmsMgr.fStartupParam.feProtocol == eDis203 ){

      //** we don't hit articulated parts at this time
      fLength = sizeof(DIS203_DETONATION_PDU) - sizeof(DIS203_ARTICULATION_PARAMETER_RECORD);

      pPdu->firing_entity_id                  = DisEntID(pProjectile->GetEntityID());
      pPdu->target_entity_id                  = DisEntID(pProjectile->GetTargetID());
      pPdu->munition_id                       = DisEntID(0);
      pPdu->event_id                          = DisEventID(0);
      pPdu->velocity                          = DisVehVel( TVelocity(0.0, 0.0, 0.0) );
      pPdu->location_in_world                 = DisVehLoc( pProjectile->GetDetLoc() );
      pPdu->burst_descriptor                  = DisBurstDesc( pProjectile->GetDetonationType(),
                                                           pProjectile->GetWarhead(),
                                                           pProjectile->GetFuze() );
      pPdu->location_in_entity_coordinates    = DisEntLoc( pProjectile->GetDetVehCoord() );
      pPdu->detonation_result                 = DisDetonResult( pProjectile->GetDetResult() );
      pPdu->number_of_articulation_parameters = 0;
      pPdu->_unused_8                         = 0;

      FillHdr(DIS203_DETONATION_PDU_KIND, DIS204_WARFARE_PDU_FAMILY);

//   cout<<"sending mine detonation PDU"<<endl;
      WriteDetonPdu(pPdu);
   }
   else{

      //** we don't hit articulated parts at this time
      fLength = sizeof(DIS204_DETONATION_PDU) - sizeof(DIS204_ARTICULATION_PARAMETER_RECORD);

      pPdu204->firing_entity_id                  = DisEntID(pProjectile->GetEntityID());
      pPdu204->target_entity_id                  = DisEntID(pProjectile->GetTargetID());
      pPdu204->munition_id                       = DisEntID(0);
      pPdu204->event_id                          = DisEventID(0);
      pPdu204->velocity                          = DisVehVel( TVelocity(0.0, 0.0, 0.0) );
      pPdu204->location_in_world                 = DisVehLoc( pProjectile->GetDetLoc() );
      pPdu204->burst_descriptor                  = DisBurstDesc( pProjectile->GetDetonationType(),
                                                           pProjectile->GetWarhead(),
                                                           pProjectile->GetFuze() );
      pPdu204->location_in_entity_coordinates    = DisEntLoc( pProjectile->GetDetVehCoord() );
      pPdu204->detonation_result                 = DisDetonResult( pProjectile->GetDetResult() );
      pPdu204->number_of_articulation_parameters = 0;
      pPdu204->_unused_8                         = 0;

      FillHdr(DIS204_DETONATION_PDU_KIND, DIS204_WARFARE_PDU_FAMILY);

//   cout<<"sending mine detonation PDU"<<endl;
      WriteDetonPdu(pPdu204);
   }

   gpNetMgr->SendPdu(fpOutBuf, fLength);
}
   
void   cDisPduTranslator::SendMinefieldState(cMinefield* pMf)
{
   if ( fpQrpMgr )
      fpQrpMgr->SendMinefieldState(pMf, fpOutBuf);
}

void   cDisPduTranslator::ProcessMineResponse(cMinefield* pMf, T2linkHead* pTypeList,
               TEntityID reqId, int reqNum, short numReqSensors, TEntityType* pReqSensType)
{
   if ( fpQrpMgr )
      fpQrpMgr->ProcessMineResponse(pMf, pTypeList, reqId, reqNum, numReqSensors, pReqSensType);
}

void   cDisPduTranslator::SendMineResponse(cMinefield* pMf, T2linkHead* pMineList, TEntityID reqId,
                     int reqNum, TEntityType& type, int numMines, int msgNum, int msgsTot, short numReqSens,
				TEntityType* pReqSensType)
{
   if ( fpQrpMgr )
      fpQrpMgr->SendMineResponse(pMf, pMineList, reqId, reqNum, type, 
                  numMines, msgNum, msgsTot, fpOutBuf, numReqSens, pReqSensType);
}

void   cDisPduTranslator::SendCpMines(T2linkMineSetList* pMineSet)
{
   if ( fpCpMgr )
      fpCpMgr->SendCpMines(pMineSet, fpOutBuf);
}

void   cDisPduTranslator::SendCpMinefield(cMinefield* pMf)
{
   if ( fpCpMgr )
      fpCpMgr->SendCpMinefield(pMf, fpOutBuf);
}

EBoolean    cDisPduTranslator::UsesCpwQe()
{
   if ( fpCpMgr )
       return fpCpMgr->UsesQe();
   else
      return false;
}

void   cDisPduTranslator::WriteEsPdu(void * buf)
{
   DIS203_ENTITY_STATE_PDU* pdu = (DIS203_ENTITY_STATE_PDU*)buf;
   
   cout<< "pdu and header size "<< sizeof(*this)  << " "
       << sizeof(DIS203_ENTITY_STATE_PDU) << " "
       << sizeof(pdu->pdu_header) << endl;
   
   cout<< "header " 
       << sizeof(pdu->pdu_header) << " "
       << (int)pdu->pdu_header.protocol_version << " "
       << (int)pdu->pdu_header.exercise_id << " "
       << (int)pdu->pdu_header.pdu_type << " "
       << (int)pdu->pdu_header.length
       << endl;
   
   cout<< "entity_id " 
       << sizeof(pdu->entity_id) << " "
       << (int)pdu->entity_id.simulation_address.site_id << " "
       << (int)pdu->entity_id.simulation_address.application_id << " "
       << (int)pdu->entity_id.entity_id
       << endl;
       
   cout<< "force " << sizeof(pdu->force_id) << " " << (int)pdu->force_id << endl;
       
   cout<< "num art params " << sizeof(pdu->number_of_articulation_parameters) << " " << (int)pdu->number_of_articulation_parameters << endl;
   
   cout<< "entity_type " 
       << sizeof(pdu->entity_type) << " "
       << (int)pdu->entity_type.kind << " "
       << (int)pdu->entity_type.domain << " "
       << (int)pdu->entity_type.country << " "
       << (int)pdu->entity_type.category << " "
       << (int)pdu->entity_type.subcategory << " "
       << (int)pdu->entity_type.specific << " "
       << (int)pdu->entity_type.extra
       << endl;
   
   cout<< "alt entity_type " 
       << sizeof(pdu->alternative_entity_type) << " "
       << (int)pdu->alternative_entity_type.kind << " "
       << (int)pdu->alternative_entity_type.domain << " "
       << (int)pdu->alternative_entity_type.country << " "
       << (int)pdu->alternative_entity_type.category << " "
       << (int)pdu->alternative_entity_type.subcategory << " "
       << (int)pdu->alternative_entity_type.specific << " "
       << (int)pdu->alternative_entity_type.extra
       << endl;
   
    cout<< "linear velocity " 
       << sizeof(pdu->entity_linear_velocity) << " "
       << pdu->entity_linear_velocity.x << " "
       << pdu->entity_linear_velocity.y << " "
       << pdu->entity_linear_velocity.z
       << endl;
   
    cout<< "location " 
       << sizeof(pdu->entity_location) << " "
       << pdu->entity_location.x << " "
       << pdu->entity_location.y << " "
       << pdu->entity_location.z
       << endl;
       
    cout<< "artic params " 
       << sizeof(pdu->articulation_parameters) << endl;
  
}

int   cDisPduTranslator::ProcessableEsPdu(void* buf)
{
   DIS203_ENTITY_STATE_PDU* pdu = (DIS203_ENTITY_STATE_PDU*)buf;
   DIS204_ENTITY_STATE_PDU* pdu204 = (DIS204_ENTITY_STATE_PDU*)buf;

   if( gCmsMgr.fStartupParam.feProtocol == eDis203 ){
      if ( (pdu->entity_type.kind == ekindOther) ||
        (pdu->entity_type.kind >= ekindEnvironmental) )
           //** should support platforms, munitions, life forms 
           //** environmental and cultural may also be supported
           //** at some point
      return 0;
   }
   else{
      if ( (pdu204->entity_type.kind == ekindOther) ||
        (pdu204->entity_type.kind >= ekindEnvironmental) )
           //** should support platforms, munitions, life forms 
           //** environmental and cultural may also be supported
           //** at some point
      return 0;
   }
 
   return 1;
}

void   cDisPduTranslator::RecvESPdu(void* buf, TTimeSim timeDelta)
{
   cVehicle*             pVeh;
   cPriorityVehStateMsg* pPmsg;
   cVehStateMsg*         pMsg;
   DIS203_ENTITY_STATE_PDU* pdu = (DIS203_ENTITY_STATE_PDU*)buf;
   DIS204_ENTITY_STATE_PDU* pdu204 = (DIS204_ENTITY_STATE_PDU*)buf;
   
   if ( ! ProcessableEsPdu(buf) ) {
      return;
   }

   pVeh               = new cVehicle;
   pVeh->fTime        = GetCurSimTime () - timeDelta;

   if( gCmsMgr.fStartupParam.feProtocol == eDis203 ) {  

      pVeh->fId          = cDisPdu::CmsEntID(pdu->entity_id);
      pVeh->fForce       = cDisPdu::CmsForce( & pdu->force_id);
      pVeh->fCmsType     = cDisPdu::CmsEntType(pdu->entity_type);
      pVeh->fAltType     = cDisPdu::CmsEntType(pdu->alternative_entity_type);
      pVeh->fVelocity    = cDisPdu::CmsVehVel(pdu->entity_linear_velocity);
   
      pVeh->SetCoordGeoRef( cDisPdu::CmsVehLoc(pdu->entity_location), 
                         cDisPdu::CmsVehOrient(pdu->entity_orientation) );
                         
      pVeh->fAppearance  = cDisPdu::CmsVehAppear(pdu->entity_appearance);
      pVeh->fDrAlg       = cDisPdu::CmsVehDr(pdu->dead_reckoning_parameters.dead_reckoning_algorithm);
      pVeh->fDrAccel     = cDisPdu::CmsVehAccel(pdu->dead_reckoning_parameters.entity_linear_accel);
      pVeh->fDrAngVel    = cDisPdu::CmsVehAngVel(pdu->dead_reckoning_parameters.entity_angular_velocity);
   
      pVeh->fbHasCmPart = false;

      if (pdu->number_of_articulation_parameters > 0) {
         pVeh->fNumParts = pdu->number_of_articulation_parameters;
         TVehPart* pVpList = pVeh->fpVehPartList = new TVehPart[pdu->number_of_articulation_parameters];
         for ( int i = 0; i < pdu->number_of_articulation_parameters; i++) {
            pVpList[i].fChange = pdu->articulation_parameters[i].change_indicator;
            pVpList[i].fAttachPoint = pdu->articulation_parameters[i].id_part_attached_to;
            pVpList[i].fValueType = pdu->articulation_parameters[i].parameter_type.value;
            if (pdu->articulation_parameters[i].parameter_type.value & eprtmskAttached) {
               pVpList[i].fAttached = true;
               pVpList[i].fEntType = cDisPdu::CmsEntType(pdu->articulation_parameters[i].parameter_value.entity_type);
               pVpList[i].fValue = 0.0;
               pVpList[i].fParamType = cDisPdu::CmsAttachPartType(pdu->articulation_parameters[i].parameter_type.value);

               if (pVpList[i].fParamType != ePrtOther)
                  pVeh->fbHasCmPart = true;
            }
            else {
               pVpList[i].fAttached = false;
               pVpList[i].fValue = pdu->articulation_parameters[i].parameter_value.numeric.value;
               cDisPdu::SetArticPartParams(pdu->articulation_parameters[i], &pVpList[i]);
/*
            pVpList[i].fParamType = 
               cDisPdu::CmsArticPartType(pdu->articulation_parameters[i].parameter_type.value);
*/
               if (pVpList[i].IsCmPart())
                  pVeh->fbHasCmPart = true;
               if ( (pVpList[i].IsTurret()) && ( (pVpList[i].fValueType & eprtmskValType) == ePartTypeAzimuth ) ) 
                  pVeh->fTurretAzimuth = pVpList[i].fValue;
            } // end else
         } // end for
      }// end if
   } // end if DIS
   else {

      pVeh->fId          = cDisPdu::CmsEntID(pdu204->entity_id);
      pVeh->fForce       = cDisPdu::CmsForce( & pdu204->force_id);
      pVeh->fCmsType     = cDisPdu::CmsEntType(pdu204->entity_type);
      pVeh->fAltType     = cDisPdu::CmsEntType(pdu204->alternative_entity_type);
      pVeh->fVelocity    = cDisPdu::CmsVehVel(pdu204->entity_linear_velocity);
   
      pVeh->SetCoordGeoRef( cDisPdu::CmsVehLoc(pdu204->entity_location), 
                         cDisPdu::CmsVehOrient(pdu204->entity_orientation) );
                         
      pVeh->fAppearance  = cDisPdu::CmsVehAppear(pdu204->entity_appearance);
      pVeh->fDrAlg       = cDisPdu::CmsVehDr(pdu204->dead_reckoning_parameters.dead_reckoning_algorithm);
      pVeh->fDrAccel     = cDisPdu::CmsVehAccel(pdu204->dead_reckoning_parameters.entity_linear_accel);
      pVeh->fDrAngVel    = cDisPdu::CmsVehAngVel(pdu204->dead_reckoning_parameters.entity_angular_velocity);
   
      pVeh->fbHasCmPart = false;

      if (pdu204->number_of_articulation_parameters > 0) {
         pVeh->fNumParts = pdu204->number_of_articulation_parameters;
         TVehPart* pVpList = pVeh->fpVehPartList = new TVehPart[pdu204->number_of_articulation_parameters];
         for ( int i = 0; i < pdu204->number_of_articulation_parameters; i++) {
	   /* here I think is the problem.  The change indicator is nolonger uint16.  it is now a 2 part type */
            pVpList[i].fChange204 = pdu204->articulation_parameters[i].change_indicator;

            pVpList[i].fAttachPoint = pdu204->articulation_parameters[i].id_part_attached_to;
            pVpList[i].fValueType = pdu204->articulation_parameters[i].parameter_type.value;
            if (pdu204->articulation_parameters[i].parameter_type.value & eprtmskAttached) {
               pVpList[i].fAttached = true;
               pVpList[i].fEntType = cDisPdu::CmsEntType(pdu204->articulation_parameters[i].parameter_value.entity_type);
               pVpList[i].fValue = 0.0;
               pVpList[i].fParamType = cDisPdu::CmsAttachPartType(pdu204->articulation_parameters[i].parameter_type.value);

               if (pVpList[i].fParamType != ePrtOther)
                  pVeh->fbHasCmPart = true;
            }
            else {
               pVpList[i].fAttached = false;
               pVpList[i].fValue = pdu204->articulation_parameters[i].parameter_value.numeric.value;
               cDisPdu::SetArticPartParams(pdu204->articulation_parameters[i], &pVpList[i]);
/*
            pVpList[i].fParamType = 
               cDisPdu::CmsArticPartType(pdu->articulation_parameters[i].parameter_type.value);
*/
               if (pVpList[i].IsCmPart())
                  pVeh->fbHasCmPart = true;
               if ( (pVpList[i].IsTurret()) && ( (pVpList[i].fValueType & eprtmskValType) == ePartTypeAzimuth ) ) 
                  pVeh->fTurretAzimuth = pVpList[i].fValue;
            } // end else
         } // end for
      }// end if
   } // end else DIS

   if ( pVeh->fDrAlg < eDrLowestBody ) {
      pVeh->fGeoVelocity = pVeh->fVelocity;
      pVeh->fEntVelocity = pVeh->fGeoRotation * pVeh->fGeoVelocity;
   }
   else {
      pVeh->fEntVelocity = pVeh->fVelocity;
      pVeh->fGeoRotation.MultTrans(pVeh->fEntVelocity, &pVeh->fGeoVelocity);
   }

   Assert(pVeh->fCmsType.kind != 0, kerrValidityCheck, "cDisPduTranslator::RecvESPdu");

   if ( gVehMgr.IsPriorityVeh(pVeh->fId) )
      pPmsg = new cPriorityVehStateMsg(pVeh, false);
   else
      pMsg = new cVehStateMsg(pVeh, false);
   
//   cout<<"Entity State PDU received, time "<<int(pdu_header.timestamp.value)<<endl;
}


EBoolean   cDisPduTranslator::IsAreaDetonation(void * buf)
{
   DIS203_DETONATION_PDU* pdu = (DIS203_DETONATION_PDU*)buf;
   DIS204_DETONATION_PDU* pdu204 = (DIS204_DETONATION_PDU*)buf;

   if( gCmsMgr.fStartupParam.feProtocol == eDis203 ){
      if ( cDisPdu::CmsEntType(pdu->burst_descriptor.munition) == kEntTypeESMB)
         return true;
   }
   else {
      if ( cDisPdu::CmsEntType(pdu204->burst_descriptor.munition) == kEntTypeESMB)
         return true;
   }

   return false;
}



void   cDisPduTranslator::RecvEmissionPdu(void * buf, TTimeSim /*timeDelta*/)
{
//   cout<< "emission PDU received" << endl;

  
   DIS203_EMISSION_PDU* pdu = (DIS203_EMISSION_PDU*)buf;
   DIS203_FUNDAMENTAL_PARAMETER_DATA_RECORD* param_record;
   DIS204_EMISSION_PDU* pdu204 = (DIS204_EMISSION_PDU*)buf;
   cEmission*  pEmission;

   if( gCmsMgr.fStartupParam.feProtocol == eDis203 )
      param_record = &(pdu->systems->beams->fundamental_parameter_data);
   else
      param_record = &(pdu204->systems->beams->fundamental_parameter_data);

   if( gCmsMgr.fStartupParam.feProtocol == eDis203 ){
      pEmission = new cEmission((int) pdu->number_of_systems, pdu->systems->emitter_system.emitter_name);

      TEntityID entity_id = cDisPdu::CmsEntID(pdu->entity_id);
      //cout << "rel_emitter_loc = (" << rel_emitter_loc.x << ", " << rel_emitter_loc.y << ")" << endl;

      // need to find vehicle with entity_id of entity_id.entityNum
      cVehListHead&  vehMasterList = gVehMgr.GetVehList();
      pEmission->fpVeh = gVehMgr.FindVehicle(entity_id, &vehMasterList);


      if(pEmission->fpVeh != NULL)
      {
         pEmission->fpSystem->fRelEmitterLoc = cDisPdu::CmsEntLoc(pdu->systems->location_with_respect_to_entity);
         pEmission->fpSystem->fERP = param_record->effective_radiated_power;

         pEmission->fpSystem->fEmitterName = pdu->systems->emitter_system.emitter_name;
//      if (pEmission->fpSystem->fEmitterName == DIS203_EMITTER_SYSTEM_ORSMC)  pEmission->radius = 0.0;
//      else pEmission->radius = 20.0;
      
      //fprintf (stderr, "Emitter Name = %u\n",  pEmission->fpSystem->fEmitterName);
         pEmission->fpSystem->fFunction = pdu->systems->emitter_system.function;

      //fprintf(stderr,  "fRelEmitterLoc = (%.8f, %.8f, %.8f)\n", pEmission->GetRelLoc().x, 
      //			pEmission->GetRelLoc().y, pEmission->GetRelLoc().z);

/*      //TOrient emitter_orient = pVehicle->GetGeoOrient();
      //TOrient emitter_orient = pVehicle->GetTccOrient();
      //cout <<  "emitter_orient = (" << emitter_orient.psi << ", " << emitter_orient.theta << ", " << emitter_orient.phi << ")" << endl;
      //TLocation VehLoc = pVehicle->GetGeoLoc();
      //TLocation VehLoc = pVehicle->GetTccLoc();
      fprintf(stderr,  "fRelEmitterLoc = (%.8f, %.8f, %.8f)\n", pEmission->GetRelLoc().x, 
      			pEmission->GetRelLoc().y, pEmission->GetRelLoc().z);


      //TEntCoord emitter_loc;
      //float b = sqrt( (rel_emitter_loc.x*rel_emitter_loc.x) + (rel_emitter_loc.y*rel_emitter_loc.y));
      //emitter_loc.x = VehLoc.x + b*cos(emitter_orient.psi);
      //emitter_loc.y = VehLoc.y + b*sin(emitter_orient.psi);

      //float angle = emitter_orient.psi-atan(rel_emitter_loc.x/rel_emitter_loc.y);
      //float angle = emitter_orient.psi-atan(rel_emitter_loc.y/rel_emitter_loc.x);
      //cout << "b = " << b << " angle = " << angle  << endl;
        //emitter_loc.x = VehLoc.x + (b * cos(angle));
        //emitter_loc.y = VehLoc.y + (b * sin(angle));
	//emitter_loc.z = VehLoc.z;
      //emitter_loc.x = (rel_emitter_loc.x * cos(emitter_orient.psi)) + (float)VehLoc.x;
      //emitter_loc.y = (rel_emitter_loc.y * cos(emitter_orient.psi)) + (float)VehLoc.y;
      //emitter_loc.z = rel_emitter_loc.z + (float)VehLoc.z;
      //cout << "emitter_location = (" << emitter_loc.x << ", " << emitter_loc.y << ", " << emitter_loc.z << ")" << endl;
*/ 
	new cEmissionMsg(pEmission);
	//new cEmissionMsg();
      }
   } //end if DIS
   else {
      pEmission = new cEmission((int) pdu204->number_of_systems, pdu204->systems->emitter_system.emitter_name);

      TEntityID entity_id = cDisPdu::CmsEntID(pdu204->entity_id);
      cVehListHead&  vehMasterList = gVehMgr.GetVehList();
      pEmission->fpVeh = gVehMgr.FindVehicle(entity_id, &vehMasterList);


      if(pEmission->fpVeh != NULL)
      {
         pEmission->fpSystem->fRelEmitterLoc = cDisPdu::CmsEntLoc(pdu204->systems->location_with_respect_to_entity);
         pEmission->fpSystem->fERP = param_record->effective_radiated_power;

         pEmission->fpSystem->fEmitterName = pdu204->systems->emitter_system.emitter_name;
         /* I cut a lot of commented out code here.  It is the same as above */
 
         pEmission->fpSystem->fFunction = pdu204->systems->emitter_system.function;

         /* I cut a lot of commented out code here.  It is the same as above */
         new cEmissionMsg(pEmission);

      }
   }

}


void   cDisPduTranslator::RecvEnvironmentPdu( void * buf, TTimeSim /*timeDelta*/)
{
   void *pCurrentRecStart;
   static int pdunum = 0;

   //We have received an environmental PDU.  Cast the PDU buffer to the PDU type.
   cpduEnvironmental* pdu = (cpduEnvironmental*)buf;
   
   fprintf (stdout, "\nReceived environmental PDU %d.\n", pdunum++);
   fprintf (stdout, "Records = %d\n",  (int) pdu->fNumberRecords); 

   // Using pCurrentStart, cycle through all records in the PDU
   // and extract needed information.

   for (int i=0; i < (int) pdu->fNumberRecords && i < 5; i++)
     {
	//Set pCurrentRecStart to point to the current environment record 
	//in the PDU
	if (i == 0) {
	   // fpEnvRecord already points to first record.
	   pCurrentRecStart = pdu->fpEnvRecord;
	}
	else {
	   // cast pCurrentRecStart to a pointer to a 1 byte object, then increment by fRecordLength bytes.
	   pCurrentRecStart = (uint8 *)pCurrentRecStart + ((TEnvironmentRecord* )pCurrentRecStart)->fRecordLength;
	}

	// Determine the current record type and move to that case.
       switch (((TEnvironmentRecord* )pCurrentRecStart)->fRecordKind) {

       case DIS203_ENV_PADDING_KIND:
	 //       case DIS204_ENV_PADDING_KIND:
	 fprintf(stdout, "fEnvRecord[%d] = env_padding\n", i);
	 // Don't need to do anything here
	 break;

       case DIS203_ENV_STATE_SIMPLE_ILLUMINATION_KIND:
	 //       case DIS204_ENV_STATE_SIMPLE_ILLUMINATION_KIND:
	 fprintf(stdout, "fEnvRecord[%d] = env_state_simple_illum\n", i);
	 break;

       case DIS203_ENV_STATE_SIMPLE_SOUND_KIND:
	 //       case DIS204_ENV_STATE_SIMPLE_SOUND_KIND:
	 fprintf(stdout, "fEnvRecord[%d] = env_state_simple_sound\n", i);
	 break;

       case DIS203_ENV_STATE_SIMPLE_OBSCURANT_KIND:
	 //       case DIS204_ENV_STATE_SIMPLE_OBSCURANT_KIND:
	 fprintf(stdout, "fEnvRecord[%d] = env_state_simple_obscurant\n", i);
	 break;

       case DIS203_ENV_STATE_SIMPLE_WEATHER_KIND:
	 //       case DIS204_ENV_STATE_SIMPLE_WEATHER_KIND:
	 fprintf(stdout, "fEnvRecord[%d] = env_state_simple_weather\n", i);
	 ((cTransEnvRecord*)pCurrentRecStart)->ProcessSimpleWeatherRecord ();
	 break;

       case DIS203_ENV_STATE_OBSERVED_WEATHER_KIND:
	 //       case DIS204_ENV_STATE_OBSERVED_WEATHER_KIND:
	 fprintf(stdout, "fEnvRecord[%d] = env_state_observed_weather\n", i);
	 break;

       case DIS203_ENV_STATE_COMBIC_PLUME_KIND:
	 //       case DIS204_ENV_STATE_COMBIC_PLUME_KIND:
	 fprintf(stdout, "fEnvRecord[%d] = env_state_combic_plume\n", i);
	 break;

       case DIS203_ENV_STATE_COMBIC_PUFF_KIND:
	 //       case DIS204_ENV_STATE_COMBIC_PUFF_KIND:
	 fprintf(stdout, "fEnvRecord[%d] = env_state_combic_puff\n", i);
	 break;

       case DIS203_ENV_STATE_EPHEMERIS_KIND:
	 //       case DIS204_ENV_STATE_EPHEMERIS_KIND:
	 fprintf(stdout, "fEnvRecord[%d] = env_state_ephemeris\n", i);
	 break;

       case DIS203_ENV_STATE_FLARE_KIND:
	 //       case DIS204_ENV_STATE_FLARE_KIND:
	 fprintf(stdout, "fEnvRecord[%d] = env_state_flare\n", i);
	 break;

       case DIS203_ENV_STATE_NET_SEA_KIND:
	 //       case DIS204_ENV_STATE_NET_SEA_KIND:
	 fprintf(stdout, "fEnvRecord[%d] = env_state_net_sea\n", i);
	 break;

       case DIS203_ENV_STATE_VEH_DUST_KIND:
	 //       case DIS204_ENV_STATE_VEH_DUST_KIND:
	 fprintf(stdout, "fEnvRecord[%d] = env_state_veh_dust\n", i);
	 break;

       case DIS203_ENV_STATE_SIMULATION_DATE_KIND:
	 //       case DIS204_ENV_STATE_SIMULATION_DATE_KIND:
	 fprintf(stdout, "fEnvRecord[%d] = env_state_simulation_date\n", i);
	 break;

       case DIS203_ENV_GEOMETRY_UNIFORM_KIND:
	 //       case DIS204_ENV_GEOMETRY_UNIFORM_KIND:
	 fprintf(stdout, "fEnvRecord[%d] = env_geometry_uniform\n", i);
	 break;

       case DIS203_ENV_GEOMETRY_POINT_KIND:
	 //       case DIS204_ENV_GEOMETRY_POINT_KIND:
	 fprintf(stdout, "fEnvRecord[%d] = env_geometry_point\n", i);
	 break;

       case DIS203_ENV_GEOMETRY_SPHEROID_KIND:
	 //       case DIS204_ENV_GEOMETRY_SPHEROID_KIND:
	 fprintf(stdout, "fEnvRecord[%d] = env_geometry_spheroid\n", i);
	 break;

       case DIS203_ENV_GEOMETRY_POLYGON_KIND:
	 //       case DIS204_ENV_GEOMETRY_POLYGON_KIND:
	 fprintf(stdout, "fEnvRecord[%d] = env_geometry_polygon\n", i);
	 break;

       case DIS203_ENV_GEOMETRY_EXTENTS_KIND:
	 //       case DIS204_ENV_GEOMETRY_EXTENTS_KIND:
	 fprintf(stdout, "fEnvRecord[%d] = env_geometry_extents\n", i);
	 break;

       case DIS203_ENV_GEOMETRY_SPHERICAL_COORDS_KIND:
	 //       case DIS204_ENV_GEOMETRY_SPHERICAL_COORDS_KIND:
	 fprintf(stdout, "fEnvRecord[%d] = env_geometry_spherical\n", i);
	 break;

       case DIS203_ENV_GEOMETRY_GAUSSIAN_PLUME_KIND:
	 //       case DIS204_ENV_GEOMETRY_GAUSSIAN_PLUME_KIND:
	 fprintf(stdout, "fEnvRecord[%d] = env_geometry_gaussian_plume\n", i);
	 break;

       case DIS203_ENV_GEOMETRY_GAUSSIAN_PUFF_KIND:
	 //       case DIS204_ENV_GEOMETRY_GAUSSIAN_PUFF_KIND:
	 fprintf(stdout, "fEnvRecord[%d] = env_geometry_gaussian_puff\n", i);
	 break;

       case DIS203_ENV_GEOMETRY_CONE_KIND:
	 //       case DIS204_ENV_GEOMETRY_CONE_KIND:
	 fprintf(stdout, "fEnvRecord[%d] = env_geometry_cone\n", i);
	 break;

       case DIS203_ENV_GEOMETRY_FLEX_PLUME_KIND:
	 //       case DIS204_ENV_GEOMETRY_FLEX_PLUME_KIND:
	 fprintf(stdout, "fEnvRecord[%d] = env_geometry_flex_plume\n", i);
	 break;


       default:
	 fprintf(stdout, "fEnvRecord[%d] = UNRECOGNIZED! \n", i);
	 break;
       }
     }
}


void   cDisPduTranslator::RecvDetonPdu(void * buf, TTimeSim /*timeDelta*/)
{
//   cout<< "detonation PDU received"<endl;
   DIS203_DETONATION_PDU* pdu = (DIS203_DETONATION_PDU*)buf;
   DIS204_DETONATION_PDU* pdu204 = (DIS204_DETONATION_PDU*)buf;

   cDetonation* pDet = new cDetonation;

   if( gCmsMgr.fStartupParam.feProtocol == eDis203 ) {

      pDet->fFiringEntity    = cDisPdu::CmsEntID(pdu->firing_entity_id);
      pDet->fTargetEntity    = cDisPdu::CmsEntID(pdu->target_entity_id);
      pDet->fMunitionEntity  = cDisPdu::CmsEntID(pdu->munition_id);
      pDet->fVelocity        = cDisPdu::CmsVehVel(pdu->velocity);
      pDet->fMunitionType    = cDisPdu::CmsEntType(pdu->burst_descriptor.munition);
      pDet->feWarhead        = cDisPdu::CmsWarhead(pdu->burst_descriptor.warhead);
      pDet->feFuze           = cDisPdu::CmsFuze(pdu->burst_descriptor.fuze);
   
      pDet->fGeoLoc          = cDisPdu::CmsVehLoc(pdu->location_in_world);
      pDet->fEntityLoc       = cDisPdu::CmsEntLoc(pdu->location_in_entity_coordinates);
      pDet->feResult         = cDisPdu::CmsDetResult( & pdu->detonation_result );
   }
   else {

      pDet->fFiringEntity    = cDisPdu::CmsEntID(pdu204->firing_entity_id);
      pDet->fTargetEntity    = cDisPdu::CmsEntID(pdu204->target_entity_id);
      pDet->fMunitionEntity  = cDisPdu::CmsEntID(pdu204->munition_id);
      pDet->fVelocity        = cDisPdu::CmsVehVel(pdu204->velocity);
      pDet->fMunitionType    = cDisPdu::CmsEntType(pdu204->burst_descriptor.munition);
      pDet->feWarhead        = cDisPdu::CmsWarhead(pdu204->burst_descriptor.warhead);
      pDet->feFuze           = cDisPdu::CmsFuze(pdu204->burst_descriptor.fuze);
   
      pDet->fGeoLoc          = cDisPdu::CmsVehLoc(pdu204->location_in_world);
      pDet->fEntityLoc       = cDisPdu::CmsEntLoc(pdu204->location_in_entity_coordinates);
      pDet->feResult         = cDisPdu::CmsDetResult( & pdu204->detonation_result );
   }
 
   pDet->FinishDetInit();
   
   new cInDetMsg(pDet);
}

void   cDisPduTranslator::WriteDetonPdu(void * buf)
{
   DIS203_DETONATION_PDU* pdu = (DIS203_DETONATION_PDU*) buf;
   DIS204_DETONATION_PDU* pdu204 = (DIS204_DETONATION_PDU*) buf;

   if( gCmsMgr.fStartupParam.feProtocol == eDis203 ){

      cout << " target entity id "<<(int)pdu->target_entity_id.simulation_address.site_id << " "
                               <<(int)pdu->target_entity_id.simulation_address.application_id << " "
                               <<(int)pdu->target_entity_id.entity_id << endl;
      cout << " mine entity id "  <<(int)pdu->firing_entity_id.simulation_address.site_id << " "
                               <<(int)pdu->firing_entity_id.simulation_address.application_id << " "
                               <<(int)pdu->firing_entity_id.entity_id << endl;
      cout << " munition entity id "  <<(int)pdu->munition_id.simulation_address.site_id << " "
                               <<(int)pdu->munition_id.simulation_address.application_id << " "
                               <<(int)pdu->munition_id.entity_id << endl;
                            
      cout << " geo location " << pdu->location_in_world.x << " "
                               << pdu->location_in_world.y << " "
                               << pdu->location_in_world.z << endl;
                            
      cout << " ent location " << pdu->location_in_entity_coordinates.x << " "
                               << pdu->location_in_entity_coordinates.y << " "
                               << pdu->location_in_entity_coordinates.z << endl;

      cout << " detonation result " << (int) pdu->detonation_result << endl;
   
      cout << "burst type " 
           << (int)pdu->burst_descriptor.munition.kind << " "
           << (int)pdu->burst_descriptor.munition.domain << " "
           << (int)pdu->burst_descriptor.munition.country << " "
           << (int)pdu->burst_descriptor.munition.category << " "
           << (int)pdu->burst_descriptor.munition.subcategory << " "
           << (int)pdu->burst_descriptor.munition.specific << " "
           << (int)pdu->burst_descriptor.munition.extra
           << endl;
   
      cout << " burst warhead and fuze " << pdu->burst_descriptor.warhead << " "
                                         << pdu->burst_descriptor.fuze << endl;
   }

   else {
      cout << " target entity id "<<(int)pdu204->target_entity_id.simulation_address.site_id << " "
                               <<(int)pdu204->target_entity_id.simulation_address.application_id << " "
                               <<(int)pdu204->target_entity_id.entity_id << endl;
      cout << " mine entity id "  <<(int)pdu204->firing_entity_id.simulation_address.site_id << " "
                               <<(int)pdu204->firing_entity_id.simulation_address.application_id << " "
                               <<(int)pdu204->firing_entity_id.entity_id << endl;
      cout << " munition entity id "  <<(int)pdu204->munition_id.simulation_address.site_id << " "
                               <<(int)pdu204->munition_id.simulation_address.application_id << " "
                               <<(int)pdu204->munition_id.entity_id << endl;
                            
      cout << " geo location " << pdu204->location_in_world.x << " "
                               << pdu204->location_in_world.y << " "
                               << pdu204->location_in_world.z << endl;
                            
      cout << " ent location " << pdu204->location_in_entity_coordinates.x << " "
                               << pdu204->location_in_entity_coordinates.y << " "
                               << pdu204->location_in_entity_coordinates.z << endl;

      cout << " detonation result " << (int) pdu204->detonation_result << endl;
   
      cout << "burst type " 
           << (int)pdu204->burst_descriptor.munition.kind << " "
           << (int)pdu204->burst_descriptor.munition.domain << " "
           << (int)pdu204->burst_descriptor.munition.country << " "
           << (int)pdu204->burst_descriptor.munition.category << " "
           << (int)pdu204->burst_descriptor.munition.subcategory << " "
           << (int)pdu204->burst_descriptor.munition.specific << " "
           << (int)pdu204->burst_descriptor.munition.extra
           << endl;
   
      cout << " burst warhead and fuze " << pdu204->burst_descriptor.warhead << " "
                                         << pdu204->burst_descriptor.fuze << endl;
   }


}

//Added for the Communications Model
//Need to process trnsmitter and signal PDUs to get C2 Signals for APLA mines
void   cDisPduTranslator::RecvTransmitterPdu ( void* buf, TTimeSim timeDelta )
{
   DIS203_TRANSMITTER_PDU* pdu = (DIS203_TRANSMITTER_PDU*)buf;
   DIS204_TRANSMITTER_PDU* pdu204 = (DIS204_TRANSMITTER_PDU*)buf;

   //Create a new transmission structure to pass to the radio net manager
   TTransmission* trans = new TTransmission();

   //Right now we only care about transmitter PDUs which indicate start of a transmission.
   if( gCmsMgr.fStartupParam.feProtocol == eDis203 ){

      trans->fEntityId = cDisPdu::CmsEntID(pdu->entity_id);
      trans->fRadioId = (unsigned int)(pdu->radio_id);
      trans->fTransInfo.fFrequency.fHighOrder = pdu->frequency.high_order;
      trans->fTransInfo.fFrequency.fLowOrder = pdu->frequency.low_order;
      trans->fState = (unsigned int)(pdu->transmit_state);
      
   }
   else if ( gCmsMgr.fStartupParam.feProtocol == eDis204 ) {

      trans->fEntityId = cDisPdu::CmsEntID(pdu204->entity_id);
      trans->fRadioId = (unsigned int)(pdu204->radio_id);
      trans->fTransInfo.fFrequency.fHighOrder = pdu204->frequency.high_order;
      trans->fTransInfo.fFrequency.fLowOrder = pdu204->frequency.low_order;
      trans->fState = (unsigned int)(pdu204->transmit_state);
      
   }

   if (gpRadioNetMgr)
      gpRadioNetMgr->ProcessTransmission(trans);
}

//Added for the Communications Model: ksnively
//Need to sends trnsmitter and signal PDUs for C2 Signals for APLA mines
void   cDisPduTranslator::SendTransmitterPdu ( const TTransmission* pTrans )
{
  cout << "Sending Transmission Pdu" <<endl;
   DIS203_TRANSMITTER_PDU* pPdu = (DIS203_TRANSMITTER_PDU*)fpOutBuf;
   DIS204_TRANSMITTER_PDU* pPdu204 = (DIS204_TRANSMITTER_PDU*)fpOutBuf;

   cEntity*  fpSender = gCmsMgr.GetEntityByIndex(pTrans->fEntityId.entityNum);
   if (!fpSender) {
      cout << "cDisPduTranslator::SendTransmitterPdu: Cannot find entity " << pTrans->fEntityId;
      cout << " to send transmitter PDU." << endl;
      return;
   }
   TLocation simLoc = EntToSimLoc(pTrans->fTransInfo.fAntEntLoc, fpSender->GetGeoLoc(),
				  fpSender->GetGeoOrient());


   if( gCmsMgr.fStartupParam.feProtocol == eDis203 ){
      //There are no variable field we will be using.  
      fLength = sizeof(DIS203_TRANSMITTER_PDU);

      pPdu->entity_id                         = DisEntID(pTrans->fEntityId);
      pPdu->radio_id                          = pTrans->fRadioId;
      pPdu->radio_entity_type                 = DisEntType (pTrans->fTransInfo.fRadioType);
      pPdu->transmit_state                    = DisTransmitterState(pTrans->fState);
      pPdu->input_source                      = pTrans->fTransInfo.fInputSource;
      pPdu->antenna_location                  = DisVehLoc(simLoc);
      pPdu->relative_antenna_location         = DisEntLoc(pTrans->fTransInfo.fAntEntLoc);
      pPdu->antenna_pattern_type              = pTrans->fTransInfo.fAntennaType;
      pPdu->antenna_pattern_length            = pTrans->fTransInfo.fAntennaLength;

      pPdu->frequency.high_order              = pTrans->fTransInfo.fFrequency.fHighOrder;
      pPdu->frequency.low_order               = pTrans->fTransInfo.fFrequency.fLowOrder;

      pPdu->transmit_frequency_bandwidth      = pTrans->fTransInfo.fBandWidth;
      pPdu->power                             = pTrans->fTransInfo.fPower;

      //For now, the following get sent as zeros
      pPdu->modulation_type.spread_spectrum   = 0;
      pPdu->modulation_type.mod_major         = 0;
      pPdu->modulation_type.mod_detail        = 0;
      pPdu->modulation_type.mod_system        = 0;

      pPdu->crypto_system                     = 0;
      pPdu->crypto_key_id                     = 0;
      pPdu->length_of_modulation_parameters   = 0;

      FillHdr(DIS203_TRANSMITTER_PDU_KIND, DIS204_RADIO_COMMUNICATION_PDU_FAMILY);

//   cout<<"sending transmission PDU"<<endl;
      //      WriteTransmitterPdu(pPdu);
   }
   else {
      //There are no variable field we will be using.  
      fLength = sizeof(DIS203_TRANSMITTER_PDU);

      pPdu204->entity_id                         = DisEntID(pTrans->fEntityId);
      pPdu204->radio_id                          = pTrans->fRadioId;
      pPdu204->radio_entity_type                 = DisEntType (pTrans->fTransInfo.fRadioType);
      pPdu204->transmit_state                    = DisTransmitterState(pTrans->fState);
      pPdu204->input_source                      = pTrans->fTransInfo.fInputSource;
      pPdu204->antenna_location                  = DisVehLoc(simLoc);
      pPdu204->relative_antenna_location         = DisEntLoc(pTrans->fTransInfo.fAntEntLoc);
      pPdu204->antenna_pattern_type              = pTrans->fTransInfo.fAntennaType;
      pPdu204->antenna_pattern_length            = pTrans->fTransInfo.fAntennaLength;

      pPdu204->frequency.high_order              = pTrans->fTransInfo.fFrequency.fHighOrder;
      pPdu204->frequency.low_order               = pTrans->fTransInfo.fFrequency.fLowOrder;

      pPdu204->transmit_frequency_bandwidth      = pTrans->fTransInfo.fBandWidth;
      pPdu204->power                             = pTrans->fTransInfo.fPower;

      //For now, the following get sent as zeros
      pPdu204->modulation_type.spread_spectrum   = 0;
      pPdu204->modulation_type.mod_major         = 0;
      pPdu204->modulation_type.mod_detail        = 0;
      pPdu204->modulation_type.mod_system        = 0;

      pPdu204->crypto_system                     = 0;
      pPdu204->crypto_key_id                     = 0;
      pPdu204->length_of_modulation_parameters   = 0;

      FillHdr(DIS203_TRANSMITTER_PDU_KIND, DIS204_RADIO_COMMUNICATION_PDU_FAMILY);

   //cout<<"sending transmission PDU"<<endl;
      //      WriteTransmitterPdu(pPdu);
   }
   gpNetMgr->SendPdu(fpOutBuf, fLength);

}

void   cDisPduTranslator::RecvSignalPdu ( void* buf, TTimeSim timeDelta )
{
   DIS203_SIGNAL_PDU* pdu = (DIS203_SIGNAL_PDU*)buf;
   DIS204_SIGNAL_PDU* pdu204 = (DIS204_SIGNAL_PDU*)buf;
   
   TEntityID entityId;
   unsigned int radioId;
   uint16 encodingScheme;

   if( gCmsMgr.fStartupParam.feProtocol == eDis203 ){
      //Obtain entity and radio Id from PDU
      entityId = cDisPdu::CmsEntID(pdu->entity_id);
      radioId = (unsigned int)(pdu->radio_id);

      encodingScheme = (uint16)(pdu->encoding_scheme);
      //Pass the signal to cRadioNetMgr
      if (gpRadioNetMgr)
	 gpRadioNetMgr->ProcessSignal (entityId, radioId, encodingScheme, 
				    (void*)(pdu->data), (int) (pdu->length));
   }

   else {
      //Obtain entity and radio Id from PDU
      entityId = cDisPdu::CmsEntID(pdu204->entity_id);
      radioId = (unsigned int)(pdu204->radio_id);

      encodingScheme = (uint16)(pdu204->encoding_scheme);
      //Pass the signal to cRadioNetMgr
      if (gpRadioNetMgr)
	 gpRadioNetMgr->ProcessSignal (entityId, radioId, encodingScheme, 
				    (void*)(pdu204->data), (int) (pdu204->length));

   }
}

void cDisPduTranslator::SendSignalPdu(TEntityID entityId, unsigned int radioId, uint8 state,
				      uint16 encodingScheme, void* buf, int len)
{
   cout <<"Sending SignalPdu" <<endl;
   DIS203_SIGNAL_PDU* pPdu = (DIS203_SIGNAL_PDU*)fpOutBuf;
   DIS204_SIGNAL_PDU* pPdu204 = (DIS204_SIGNAL_PDU*)fpOutBuf;

   
   //cout << "cDisPduTranslator::SendSignalPdu: Sending Signal PDU with class " << encodingClass;
   //cout << " and type " << encodingType << endl;
   
   if( gCmsMgr.fStartupParam.feProtocol == eDis203 ){
      //Compute length of PDU minus data portion.  Add that later.
      fLength = sizeof (DIS203_SIGNAL_PDU) - sizeof (unsigned);

      pPdu->entity_id                = DisEntID(entityId);
      pPdu->radio_id                 = radioId;
      pPdu->encoding_scheme          = DisEncodingScheme(encodingScheme);

      // cout << "\tEncoding Scheme " << pPdu->encoding_scheme << endl;

      pPdu->sample_rate              = 0; //pRadio->GetSampleRate();
      pPdu->length                   = (uint16) (8*len);
      pPdu->samples                  = 0;

      bcopy(buf, pPdu->data, len);
      fLength += len;

      //Fill the PDU header
      FillHdr(DIS203_SIGNAL_PDU_KIND, DIS204_RADIO_COMMUNICATION_PDU_FAMILY);

   }
   else{
      //Compute length of PDU minus data portion.  Add that later.
      fLength = sizeof (DIS203_SIGNAL_PDU) - sizeof (unsigned);

      pPdu204->entity_id                = DisEntID(entityId);
      pPdu204->radio_id                 = radioId;
      pPdu204->encoding_scheme          = DisEncodingScheme(encodingScheme);


      pPdu204->sample_rate              = 0; //pRadio->GetSampleRate();
      pPdu204->length                   = (uint16) (8*len);
      pPdu204->samples                  = 0;

      bcopy(buf, pPdu204->data, len);
      fLength += len;

      //Fill the PDU header
      FillHdr(DIS203_SIGNAL_PDU_KIND, DIS204_RADIO_COMMUNICATION_PDU_FAMILY);


   }
   gpNetMgr->SendPdu(fpOutBuf, fLength);
}

void   cDisPduTranslator::TranslatorShutdown()
{
   if ( fpCpMgr )
      fpCpMgr->CpShutdown();
      
   if ( fpQrpMgr )
      fpQrpMgr->QrpShutdown();
}

cDisPduTranslator::cDisPduTranslator( EQrpProtocol qrp, ECpProtocol cp, EBoolean bOrient,
                                      EBoolean bBurial, EBoolean bTemp)
{
   if ( qrp ==  eQrp1 )
      fpQrpMgr = new cQrpManager( qrp, this);
   /*else if(qrp == eQrp3)
      fpQrpMgr = new cQrpManager_REV(qrp,this);*/
   else
      fpQrpMgr = NULL;
      
   if ( (cp == eCp1) ||
        (cp == eCp1HeartBeat) )
      fpCpMgr = new cCpManager( cp, this, bOrient, bBurial, bTemp );
   else
      fpCpMgr = NULL;
      
}
