/*
$RCSfile: DisPdu203.h,v $
$Revision: 1.4 $
$Author: ksnively $
$Date: 1999/05/19 20:57:04 $
$Log: DisPdu203.h,v $
Revision 1.4  1999/05/19 20:57:04  ksnively
Cycle radio IDs for messages so CEF does not choke.

Revision 1.3  1999/04/22 22:19:57  ksnively
Sreamlined radio communication routines.  Allowed to send to unlimited number of receivers.

Revision 1.2  1999/03/26 21:17:30  ksnively

Added radio communication capability for Command Detonated Mines.  Included sending
and receiving transmitter and signal PDUs.  All signals have the option of being
processed by the Communication Effects Federate.

Revision 1.1.1.1  1999/02/16 14:54:47  jchappel
Comprehensive Mine Simulator

 * Revision 2.4  1998/10/27  19:34:43  jchappel
 * modifications for versioning
 *
 * Revision 2.4  1998/10/27  19:34:43  jchappel
 * modifications for versioning
 *
 * Revision 2.3  1998/04/01  14:39:52  ksnively
 * *** empty log message ***
 *
 * Revision 2.2  1998/02/26  21:26:56  ksnively
 * Created Mf Camera object to control MAK Stealth view.
 * Created vulnerability tables specific to command detonated mines
 * and the camera object.
 *
 * Revision 2.1  1998/02/18  17:17:24  ksnively
 * Incorporated AP mine replacement code
 *
 * Revision 2.0  1998/01/26  21:04:20  ksnively
 * Baseline CMS before additions for AP mine replacements.
 *
 * Revision 1.2  1997/12/17  14:40:21  ksnively
 *  Debugged Minefield duplication routine.
 * Added input file "netparams" for reading PDU type enumerations.
 * Got rid of warning messages during compilation.
 *
 * Revision 1.1  1997/12/16  13:59:57  ksnively
 * Initial revision
 *
 * Revision 1.9  1997/10/27  17:07:30  trang
 * BUILD1
 *
 * Revision 1.8  1997/10/02  17:47:47  austin
 * first working port to modsaf3.0
 *
Revision 1.8  1997/10/02 17:47:47  austin
first working port to modsaf3.0

 * Revision 1.7  1997/03/20  19:16:16  ksnively
 * Added emission tracking, updated to CMS2.0B6.
 *
 * Revision 1.6  1997/02/12  17:04:49  ksnively
 * *** empty log message ***
 *
 * Revision 1.5  1997/01/21  15:09:13  nsipes
 * *** empty log message ***
 *
 * Revision 1.4  1997/01/02  19:48:54  nsipes
 * *** empty log message ***
 *
 * Revision 1.3  1996/11/06  15:48:38  nsipes
 * *** empty log message ***
 *
 * Revision 1.2  1996/11/06  15:13:32  nsipes
 * *** empty log message ***
 *
 * Revision 1.1  1996/10/23  13:54:40  nsipes
 * Initial revision
 *
 * Revision 1.9  1996/09/06  18:57:57  rcarp
 * CP bug fixes
 *
 * Revision 1.8  1996/08/21  21:58:20  rcarp
 * CP and QRP file output, other updates
 *
 * Revision 1.7  1996/08/07  14:19:30  rcarp
 * initial revisions for CP protocol
 *
 * Revision 1.6  1996/07/13  19:04:20  rcarp
 * version 1.5b13, fixes bug dragging with two buttons and displays damamged vehicles
 *
 * Revision 1.5  1996/07/03  22:55:15  rcarp
 * enhancements and bug fixes for version 1.5b9
 *
 * Revision 1.4  1996/06/21  17:04:20  rcarp
 * upgrades for release 1.5b3, mostly mine vuln
 *
 * Revision 1.3  1996/06/19  19:05:45  rcarp
 * revisions for mine vulnerability, version 1.5b2
 *
 * Revision 1.2  1996/05/08  00:45:10  rcarp
 * changes for 1.5, incl user mines, mine params, param i/o, selection
 *
 * Revision 1.2  1996/05/08  00:45:10  rcarp
 * changes for 1.5, incl user mines, mine params, param i/o, selection
 *
$State: Exp $
*/
 

/*
 * FILE:  DisPdu203.h 
 *
 *
 * 
 */

#ifndef _DisPdu203_
#define _DisPdu203_


#include "Globals.h"
#include "NetMgr.h"
#include "Vehicle.h"
#include "dis203_types.h" 
#include "dis204_types.h" 


class cProjectile; 
class cSimMine; 
class TDetonationData; 
class TFireData; 
struct TTransmitterInfo;

      // Default PDU types, these are the same list as 2.0.3
      
enum EPduType { epduTypeNone = 0, 
                epduTypeEntityState, 
                epduTypeFire, 
                epduTypeDetonation, 
                epduTypeCollision, 
                epduTypeServiceRequest     = 5, 
                epduTypeResupplyOffer, 
                epduTypeResupplyReceived, 
                epduTypeResupplyCancel, 
                epduTypeRepairComplete, 
                epduTypeRepairResponse     = 10, 
                epduTypeCreateEntity, 
                epduTypeRemoveEntity, 
                epduTypeStartResume, 
                epduTypeStopFreeze, 
                epduTypeAcknowledge        = 15, 
                epduTypeActionRequest, 
                epduTypeActionResponse, 
                epduTypeDataQuery, 
                epduTypeSetData, 
                epduTypeData               = 20, 
                epduTypeEventReport, 
                epduTypeMessage,           // this is Comment in 2.0.4
                epduTypeEmission,          // Electromagnetic Emission in 2.0.4
                epduTypeLaser,             // Designator in 2.0.4
                epduTypeTransmitter        = 25, 
                epduTypeSignal, 
                epduTypeReceiver           = 27, 
                
//                epduTypeCpSequencer        = x, 
//                epduTypeCpNACK             = x, 
       		epduTypeExpEnvironment     = 154, // Experimental environment pdu from ModSAF
                epduTypeCpMinefield        = 175, //Used to be 160 
                epduTypeCpMines            = 176, //Used to be 161 
                 
                epduTypeMinefieldRequest   = 188, 
                epduTypeMinefieldResponse  = 189, 
                epduTypeMinefieldState     = 190 ,  
                epduTypeViewControl        = 202 /*, 
		epduTypeMinefieldNACK	   = x  Must find this */
       };

enum EPduFamily{ epduFamilyOther                    = 0,
                 epduFamilyEntityInteraction,              // entity state
                 epduFamilyWarfare,
                 epduFamilyLogistics,
                 epduFamilyRadioCommunication,
                 epduFamilySimulationManagement     = 5,
                 epduFamilyDistributedEmission,
                 epduFamilyEntityManagement,
                 epduFamilyMinefield,
                 epduFamilySyntheticEnvironment,
                 epduFamilyReliableSimulation       = 10,
                 epduFamilyLiveEntity,
                 epduFamilyNonRealTime              = 12,
                 epduFamilyExperimental             = 129
               };

      // articulated and attached part masks
      
enum EPartMask { eprtmskAttached = 0x8000000,    //high order bit 
                 eprtmskParam = 0x7FFFFFE0,      //middle bits 
                 eprtmskValType = 0x0000001F,    //low 5 bits 
                 eprtmskParamShift = 5      }; 
      
enum EPartTypes { 
   ePartTypePosition = 1, 
   ePartTypePositionRate, 
   ePartTypeExtension, 
   ePartTypeExtensionRate, 
   ePartTypeX, 
   ePartTypeXRate, 
   ePartTypeY, 
   ePartTypeYRate, 
   ePartTypeZ, 
   ePartTypeZRate, 
   ePartTypeAzimuth, 
   ePartTypeAzimuthRate, 
   ePartTypeElevation, 
   ePartTypeElevationRate, 
   ePartTypeRotation, 
   ePartTypeRotationRate, 
}; 
      // part numbers for countermine parts, used in experimental 2.0.3 PDUs
      
enum EDIS203CmParts { 
   ePartNumPrimTurret1 = 128, 
   ePartNumPrimTurret2, 
   ePartNumPrimTurret3, 
   ePartNumPrimTurret4, 
   ePartNumPrimTurret5, 
   ePartNumPrimTurret6, 
   ePartNumPrimTurret7, 
   ePartNumPrimTurret8, 
   ePartNumPrimTurret9, 
   ePartNumPrimTurret10, 
   
   ePartNumFwmP = 232, 
   ePartNumTwmP = 234, 
   ePartNumFwmR = 233, 
   ePartNumTwmR = 235, 
   ePartNumDb   = 237, 
   ePartNumORSMC= 250, 
   ePartNumMagCm = 251  
}; 

       
class cMinefieldStatusWindow; 


class VARPTRS
{
public:
        TEntityType*   pReqSensType;
        char*           pPadding_1; 
        DIS203_ENTITY_COORDINATE_VECTOR_RECORD*      pMineLoc;
//      DIS203_ENTITY_COORDINATE_VECTOR_RECORD*      pMineLoc_204;
	float*          pGroundDepth;
        float*          pWaterDepth; 
        float*          pSnowDepth; 
        DIS203_EULER_ANGLES_RECORD* pMineOrient;
//	DIS203_EULER_ANGLES_RECORD* pMineOrient_204;
	float*          pThermalContrast;
        float*          pDielectricConstant; 
        double*         pMineEmplacementAge; 
        TEntityID*      pMineEntityId; 
        short*          pFusing; 
        uint8*          pScalerDetCoeff; 
//	short*		pPaintScheme;	This is 2 bytes, should be 1 
        unsigned char*  pPaintScheme; 
        char*           pPadding_2; 
        char*           pNumTripWires; 
        char*           pPadding_3; 
        short*          pNumVertices; 
        char*           pPadding_4; 
        TEntCoord*      pVertex; 


        VARPTRS()
        {
                pReqSensType = NULL;
                pPadding_1 = NULL;
                pMineLoc = NULL;
//		                pMineLoc_204 = NULL;
                pGroundDepth = NULL;
                pWaterDepth = NULL;
                pSnowDepth = NULL;
                pMineOrient = NULL;
//		              pMineOrient_204 = NULL;
                pThermalContrast = NULL;
                pDielectricConstant = NULL;
                pMineEmplacementAge = NULL;
                pMineEntityId = NULL;
                pFusing = NULL;
                pScalerDetCoeff = NULL;
                pPaintScheme = NULL;
                pPadding_2 = NULL;
                pNumTripWires = NULL;
                pPadding_3 = NULL;
                pNumVertices = NULL;
                pPadding_4 = NULL;
                pVertex = NULL;
        }
	
};


///////////
//original cQrpManager class definition
/*class cQrpManager
{
protected:

   EQrpProtocol		fcp;
   cDisPduTranslator*	fpDisTrans;
   static unsigned int	fsMinesPerPdu;
   unsigned int		fNumMfMsgs;
   unsigned int		fNumResponseMsgs;
   unsigned int		fNumResponsePdus;
   unsigned int		fLengthMfMsgs;
   unsigned int		fLengthResponseMsgs;
 
public:

   cQrpManager(EQrpProtocol qrp, cDisPduTranslator* pDisTrans);

   void RecvMfReqPdu(void * buf, TTimeSim timeDelta = 0);
   void FillPerimeter(cMinefield* pMf, void* buf, int* pLength);
   void FillMineTypes(cMinefield* pMf, void* buf, int* pLength);

   virtual void ProcessMineResponse(cMinefield* pMf, T2linkHead* pTypeList,
               TEntityID reqId, int reqNum, short numReqSensors, TEntityType* pReqSensType);
   virtual void SendMineResponse(cMinefield* pMf, T2linkHead* pMineList, TEntityID reqId,
                     int reqNum, TEntityType& type, int numMines, int msgNum, int msgsTot, void* buf);
                     
   virtual void SendMinefieldState(cMinefield* pMf, void* buf);

   void QrpShutdown();
};*/

struct TMineDataFlag 
{
   unsigned int orientation_flag  :  1;
   unsigned int burial_depth_flag :  1;
   unsigned int temperature_flag  :  1;
   unsigned int _unused_          : 29;
};

//WARNING:  This structure (TMinefieldRequestFilter) is cast to pdu part.  
//Order and size of variables is extremely important!
struct TMinefieldRequestFilter 
{
        unsigned GroundBurialDepth      : 1;
        unsigned WaterBurialDepth       : 1;
        unsigned SnowBurialDepth         : 1;
        unsigned MineOrientation         : 1;
        unsigned ThermalContrast         : 1;
        unsigned DielectricConstant      : 1;
        unsigned MineEmplacementAge      : 1;
        unsigned TripDetWireLoc          : 1;
        unsigned Fusing                  : 1;
        unsigned ScalerDetCoeff          : 1;
        unsigned PaintScheme             : 1;
        unsigned Reserved                : 21;
};

class T2linkMineSetList;
class cCpManager 
{
protected:

   ECpProtocol		fcp;
   cDisPduTranslator*	fpDisTrans;
//   cDisPdu204*  	fpDisTrans;  /*takeout?*/
   static unsigned int  fsMinesPerPdu;
   static TMineDataFlag	fsBitFlags;
   static TTimeSim	fsHeartbeat;
   unsigned int		fNumMfMsgs;
   unsigned int		fNumMinesetMsgs;
   unsigned int		fLengthMfMsgs;
   unsigned int		fLengthMinesetMsgs;
   
public:

   cCpManager(ECpProtocol cp, cDisPduTranslator* pDisTrans, EBoolean bOrient,
                       EBoolean bBurial, EBoolean bTemp);
 //   cCpManager(ECpProtocol cp, cDisPdu204* pDisTrans, EBoolean bOrient,
 //                      EBoolean bBurial, EBoolean bTemp);

   EBoolean UsesQe();
   static TTimeSim GetHeartbeat() { return fsHeartbeat; }
   static int GetMinesPerPdu()  { return fsMinesPerPdu; }
   void RecvCpMfPdu(void * buf, TTimeSim timeDelta = 0);
   void RecvCpMinesPdu(void * buf, TTimeSim timeDelta = 0);
   virtual void SendCpMines(T2linkMineSetList* pMineSet, void* buf);
   virtual void SendCpMinefield(cMinefield* pMf, void* buf);
   EBoolean IncludeThermal()  { return fsBitFlags.temperature_flag ? true : false; }
   EBoolean IncludeBurial()  { return fsBitFlags.burial_depth_flag ? true : false; }
   EBoolean IncludeOrient()  { return fsBitFlags.orientation_flag ? true : false; }
   void CpShutdown();

};
class cQrpManager // new one
{
protected: 

   EQrpProtocol         fcp;
   cDisPduTranslator*   fpDisTrans;  
//   cDisPdu204*   fpDisTrans; /*takeout?*/
   static unsigned int  fsMinesPerPdu;
   static TMineDataFlag	fsBitFlags;
   unsigned int         fNumMfMsgs;
   unsigned int         fNumResponseMsgs;
   unsigned int         fNumResponsePdus;
   unsigned int         fLengthMfMsgs;
   unsigned int         fLengthResponseMsgs;


public:

   cQrpManager(EQrpProtocol qrp, cDisPduTranslator* pDisTrans);
  // cQrpManager(EQrpProtocol qrp, cDisPdu204* pDisTrans);
   cQrpManager(EQrpProtocol qrp, cDisPduTranslator* pDisTrans,EBoolean bOrient,
                        EBoolean bBurial, EBoolean bTemp); 


   void RecvMfReqPdu(void * buf, TTimeSim timeDelta = 0);
   void RecvMfReqPduQRP1(void * buf, TTimeSim timeDelta = 0);
   void RecvMfReqPduQRP3(void * buf, TTimeSim timeDelta = 0);
   
   void RecvMfNACKPdu(void * buf, TTimeSim timeDelta = 0);
   void RecvMfNACKPduQRP3(void * buf, TTimeSim timeDelta = 0);
   

   void FillPerimeter(cMinefield* pMf, void* buf, int* pLength);
   void FillMineTypes(cMinefield* pMf, void* buf, int* pLength);
   

   virtual void ProcessMineResponse(cMinefield* pMf, T2linkHead* pTypeList,
               TEntityID reqId, int reqNum, short numReqSens,
                                TEntityType* pReqSensType);
   virtual void SendMineResponse(cMinefield* pMf, T2linkHead* pMineList, TEntityID reqId,
                     int reqNum, TEntityType& type, int numMines, int msgNum, int msgsTot, void* buf, short numReqSens,
                                TEntityType* pReqSensType);

   virtual void SendMineResponse1(cMinefield* pMf, T2linkHead* pMineList, TEntityID reqId,
                     int reqNum, TEntityType& type, int numMines, int msgNum, int msgsTot, void* buf);
   virtual void SendMineResponse3(cMinefield* pMf, T2linkHead* pMineList, TEntityID reqId,
                     int reqNum, TEntityType& type, int numMines, int msgNum, int msgsTot, void* buf, short numReqSens,
                                TEntityType* pReqSensType);

   virtual void SendMinefieldState(cMinefield* pMf, void* buf);
   virtual void SendMinefieldStateQRP1(cMinefield* pMf, void* buf);
   virtual void SendMinefieldStateQRP3(cMinefield* pMf, void* buf);

   void GetVarRec(VARPTRS* varRec, short* pLength,TMinefieldRequestFilter filter,short numReqSens,
                                short numMines);

   void QrpShutdown();

   //EBoolean IncludeThermal()  { return fsBitFlags.temperature_flag ? true : false; }
   //EBoolean IncludeBurial()  { return fsBitFlags.burial_depth_flag ? true : false; }
   //EBoolean IncludeOrient()  { return fsBitFlags.orientation_flag ? true : false; }

/////////////////////////////////////////////
  
//   EBoolean UsesQe();   // this should be in heartbeat manager
   /*static TTimeSim GetHeartbeat() { return fsHeartbeat; } // heartbeat mode
   static int GetMinesPerPdu()  { return fsMinesPerPdu; } // why use this?
   virtual void SendCpMines(T2linkMineSetList* pMineSet, void* buf);
   virtual void SendCpMinefield(cMinefield* pMf, void* buf);
   void CpShutdown();*/


};


/*class cHBManager
{
}:
*/
/*
 * DIS PDU.  Parent class, supplies translators to CMS types
 */
class cDisPdu {
 
 public:
 
   static const  float     fsDefaultPlowDepth;
   
         //   data type translators, DIS to CMS
   static TEntityID        CmsEntID(const DIS203_ENTITY_ID_RECORD & id);
   static EForce           CmsForce( void* pForce);
   static TEntityType      CmsEntType(const DIS203_ENTITY_TYPE_RECORD & type);
   static EAppearance      CmsVehAppear(const DIS203_ENTITY_APPEARANCE_TYPE & appear);
   static EDeadReckonAlg   CmsVehDr(const DIS203_DEAD_RECKONING_ALGORITHM_TYPE & alg);
   static TLocation        CmsVehLoc(const DIS203_WORLD_COORDINATES_RECORD & loc);
   static TEntCoord        CmsEntLoc(const DIS203_ENTITY_COORDINATE_VECTOR_RECORD & loc);
   static TVelocity        CmsVehVel(const DIS203_LINEAR_VELOCITY_VECTOR_RECORD & vel);
   static TOrient          CmsVehOrient(const DIS203_EULER_ANGLES_RECORD & orient);
   static TAccel           CmsVehAccel(const DIS203_LINEAR_ACCELERATION_VECTOR_RECORD & accel);
   static TAngVel          CmsVehAngVel(const DIS203_ANGULAR_VELOCITY_VECTOR_RECORD & angVel);

   static EWarhead         CmsWarhead(const DIS203_WARHEAD_TYPE warhead);
   static EFuze            CmsFuze(const DIS203_FUZE_TYPE fuze);
   static EDetonResult     CmsDetResult(const void* pDisResult);
   static void             SetArticPartParams(const DIS203_ARTICULATION_PARAMETER_RECORD& partRec,
                                    TVehPart* pPart);
   static EPartParam       CmsAttachPartType(const DIS203_PARAMETER_TYPE_TYPE type);


/*
 *  Dis 204 
 */


     static void             SetArticPartParams(const DIS204_ARTICULATION_PARAMETER_RECORD& 
                                              partRec, TVehPart* pPart);

};


struct TTransmission;
/*
 * DIS PDU translator, translates from CMS to DIS
 */
class cDisPduTranslator : public cPduTranslator {
 protected:
   
   cQrpManager*         fpQrpMgr;
   cCpManager*          fpCpMgr;


   enum {DisFusingNoFuze = 0,
   	 DisFusingOther,
	 DisFusingPressure,
	 DisFusingMagnetic,
	 DisFusingTiltrod,
	 DisFusingCommand,
	 DisFusingTripwire };
 

 public:
         //   data type translators, CMS to DIS
    virtual DIS203_ENTITY_ID_RECORD                     DisEntID(const TEntityID & id);
    virtual DIS203_ENTITY_ID_RECORD                     DisEntID(unsigned short idNum);   
                         // fills in site and application

   void            DisForce(void* pDisForce, EForce force);

    virtual DIS203_ENTITY_TYPE_RECORD                   DisEntType(const TEntityType & type);

   virtual DIS203_ENTITY_APPEARANCE_TYPE               DisVehAppear(EAppearance appear);

   virtual DIS203_DEAD_RECKONING_ALGORITHM_TYPE        DisVehDr(EDeadReckonAlg alg);

   virtual DIS203_PARAMETER_TYPE_TYPE                  DisVehPartParam(EPartParam paramType, 
                                                    const EPartValueType & valType);

   virtual DIS203_WORLD_COORDINATES_RECORD             DisVehLoc(const TLocation & loc);

   virtual DIS203_LINEAR_VELOCITY_VECTOR_RECORD        DisVehVel(const TVelocity & vel);
   virtual DIS203_EULER_ANGLES_RECORD                  DisVehOrient(const TOrient & orient);

   virtual DIS203_LINEAR_ACCELERATION_VECTOR_RECORD    DisVehAccel(const TAccel & accel);

   virtual DIS203_ANGULAR_VELOCITY_VECTOR_RECORD       DisVehAngVel(const TAngVel & angVel);

   virtual DIS203_EVENT_ID_RECORD                      DisEventID(const TEntityID & id);  
                              // fills in site and application

   virtual DIS203_EVENT_ID_RECORD                      DisEventID(unsigned short idNum);   
                              // fills in site and application

   virtual DIS203_BURST_DESCRIPTOR_RECORD              DisBurstDesc( const TEntityType &, 
                                                                EWarhead, EFuze);

   virtual DIS203_DETONATION_RESULT_TYPE               DisDetonResult( EDetonResult );

   virtual DIS203_ENTITY_COORDINATE_VECTOR_RECORD      DisEntLoc(const TEntCoord & loc);

   virtual DIS203_ENTITY_COORDINATE_VECTOR_RECORD      DisEntLoc(const T3Ddouble & loc);

   virtual DIS203_RANGE_TYPE                           DisRange(float range)   { return range; }

   virtual DIS203_RADIO_TRANSMIT_STATE_TYPE            DisTransmitterState(uint8 state) { return state; }

   virtual DIS203_ENCODING_SCHEME                      DisEncodingScheme(uint16 encodingScheme);

   short					  DisFusing(cMine* pMine);

             void         RecvESPdu(void * buf, TTimeSim timeDelta = 0);

             int          ProcessableEsPdu(void * buf);
   virtual   void         WriteEsPdu(void * buf);
	     void         RecvEmissionPdu(void* buf, TTimeSim timeDelta = 0);
             void         RecvDetonPdu(void * buf, TTimeSim timeDelta = 0);
             void         RecvEnvironmentPdu(void * buf, TTimeSim timeDelta = 0);
             EBoolean     IsAreaDetonation(void * buf);
             void         WriteDetonPdu(void * buf);

   virtual   void         RecvTransmitterPdu(void* buf, TTimeSim timeDelta = 0);
             void         WriteTransmitterPdu(void* buf);
   virtual   void         RecvSignalPdu(void* buf, TTimeSim timeDelta = 0);
             void         WriteSignalPdu(void* buf);

   virtual   void         ReceivePdu(void * buf, TTimeSim timeDelta = 0);
   virtual   EBoolean     VerifyPdu( void* buf);
   virtual   int          GetPduType( void* buf);

             void         FillHdr(DIS203_PDU_TYPE_TYPE type, DIS203_PDU_TYPE_TYPE family);
             
   virtual   void        SendVehState(cVehicle* pVeh);
   virtual   void        SendMineDetonation(TDetonationData& detData );
   virtual   void        SendMineFire(TFireData& fireData);
   virtual   void        SendProjFire(cProjectile* pProjectile);
   virtual   void        SendProjDeton(cProjectile* pProjectile);
   virtual   void        SendViewControl(cVehicle* pView, TEntityID toID);

   virtual   void        SendTransmitterPdu(const TTransmission* pTrans);
   virtual   void        SendSignalPdu(TEntityID entityId, unsigned int radioId, uint8 state,
				       uint16 encodingScheme, void* buf, int len);

   virtual void    ProcessMineResponse(cMinefield* pMf, T2linkHead* pTypeList,
               TEntityID reqId, int reqNum,short fNumReqSensors, TEntityType* pReqSensorTypes);
   virtual void    SendMineResponse(cMinefield* pMf, T2linkHead* pMineList, TEntityID reqId,
                     int reqNum, TEntityType& type, int numMines, int msgNum, int msgsTot, short numReqSens,
                                TEntityType* pReqSensType);
                     
   virtual   void        SendMinefieldState(cMinefield* pMf);
   
             void   SendCpMines(T2linkMineSetList* pMineSet);
             void   SendCpMinefield(cMinefield* pMf);
   
   EBoolean         UsesCp() { return  fpCpMgr ? true : false; }
   EBoolean         UsesCpwQe();
   EBoolean         IncludeThermal()  { return fpCpMgr ? fpCpMgr->IncludeThermal() : false; }
   EBoolean         IncludeBurial()  { return fpCpMgr ? fpCpMgr->IncludeBurial() : false; }
   EBoolean         IncludeOrient()  { return fpCpMgr ? fpCpMgr->IncludeOrient() : false; }
   EBoolean         UsesQrp() { return  fpQrpMgr ? true : false; }
   
   void             TranslatorShutdown();
   
   cDisPduTranslator( EQrpProtocol qrp, ECpProtocol cp, EBoolean bOrient,
                                      EBoolean bBurial, EBoolean bTemp);
   
};

 
#endif
