/*
$RCSfile: DispObj.cc,v $
$Revision: 1.1.1.1 $
$Author: jchappel $
$Date: 1999/02/16 14:54:31 $
$Log: DispObj.cc,v $
Revision 1.1.1.1  1999/02/16 14:54:31  jchappel
Comprehensive Mine Simulator

// Revision 2.6  1998/07/08  18:35:29  jchappel
// reverted last changes
//
// Revision 2.6  1998/07/08  18:35:29  jchappel
// reverted last changes
//
// Revision 2.5  1998/07/07  14:19:34  jchappel
// added DIS 204 versioning to cVehDisp
//
// Revision 2.4  1998/04/20  15:10:36  ksnively
// *** empty log message ***
//
// Revision 2.3  1998/03/02  16:05:46  jchappel
// made cmd area munitions sensitive to detonation at all times.
//
// Revision 2.2  1998/02/24  14:25:03  ksnively
// Commented out printf statements.
//
// Revision 2.1  1998/02/18  17:16:10  ksnively
// Incorporated AP mine replacement code.
//
// Revision 2.0  1998/01/26  21:01:35  ksnively
// Baseline CMS before additions for AP mine replacements.
//
// Revision 1.2  1997/12/17  14:38:03  ksnively
// Debugged Minefield duplication routine.
// Added input file "netparams" for reading PDU type enumerations.
// Got rid of warning messages during compilation.
//
// Revision 1.1  1997/12/16  13:59:57  ksnively
// Initial revision
//
// Revision 1.4  1997/10/27  17:08:08  trang
// BUILD1
//
Revision 1.3  1997/10/02 17:51:30  austin
first working port to modsaf3.0

// Revision 1.2  1997/10/02  17:48:55  austin
// first working port to modsaf3.0
//
// Revision 1.2  1997/10/02  17:48:55  austin
// first working port to modsaf3.0
//
// Revision 1.1  1996/10/23  13:54:40  nsipes
// Initial revision
//
// Revision 1.8  1996/09/07  16:14:35  mkappel
// Draw box(es) for MICLIC and ESMB explosions
//
// Revision 1.7  1996/08/20  13:44:41  mkappel
// Add Detonation Display.
//
// Revision 1.6  1996/07/13  19:04:20  rcarp
// version 1.5b13, fixes bug dragging with two buttons and displays damamged vehicles
//
// Revision 1.5  1996/07/03  22:55:15  rcarp
// enhancements and bug fixes for version 1.5b9
//
// Revision 1.4  1996/05/08  00:50:23  rcarp
// changes for 1.5, incl user mines, mine params, param i/o, selection
//
// Revision 1.4  1996/05/08  00:50:23  rcarp
// changes for 1.5, incl user mines, mine params, param i/o, selection
//
// Revision 1.3  1996/02/21  19:45:02  rcarp
// revisions for map scroll, mine ranges
//
// Revision 1.2  1996/01/26  21:31:23  rcarp
// Revisions and bug fixes of CMS version 1.1b1
//
$State: Exp $
*/
 
/*******************************************

   file: DispObj.cc
   
      Copyright 1995 by the Institute for Defense Analyses
      
         Institute for Defense Analyses
         1801 N. Beauregard Street
         Alexandria, Virginia 22311-1772
         703-845-2000
         
      This software was developed by IDA under U. S. Government
      contract.  For distribution information contact:
      
         U. S. Army Night Vision Directorate
         AMSEL RD NV OD CD
         10221 Burbeck Road, suite 430
         Ft. Belvoir VA 22060-5806
      
*********************************************/

/*******************************************

   DispObj.cc
   
      The display interface implementation.
      
      
   
   Created by Michael Kappel
   Modification history:
      created   
      
*********************************************/

#include "Display.h"
#include "MapGeometry.h"
#include "Message.h"

#include <bstring.h>
#include <libdisconst.h>
#include <libotmatch.h>
#include <libphysdb.h>
#include <math.h>
#include <mun_type.h>
#include <stdext.h>
#include <veh_appear.h>
#include <veh_type.h>

#define MAX_GCS  emisNumStates + 2

static int32         pvd_db_key    = -1;

SNSTVE_CLASS  cMineDisp::fSensNull;
SNSTVE_CLASS  cMineDisp::fSensNullSel;
SNSTVE_CLASS  cMineDisp::fSensMine;
SNSTVE_CLASS  cMineDisp::fSensMineSelect;
SNSTVE_CLASS  cMineDisp::fSensMineSelectFire;
SNSTVE_CLASS  cMineDisp::fSensMineSelectComp;
SNSTVE_CLASS  cMineDisp::fSensMineSelectCompFire;
SNSTVE_CLASS  cMineDisp::fSensMineFire;
GC            cMineDisp::fMineGC[MAX_GCS];
int           cMineDisp::fSensMineInstanceCounter;
cMine*        cMineDisp::fpCurFireMine = NULL;

SNSTVE_CLASS  cVehDisp::fSensVeh;
int           cVehDisp::fSensVehInstanceCounter;
GC            cVehDisp::fVehGC[5];
GC            cVehDisp::fBlackGC;
GC            cVehDisp::fWhiteGC;

SNSTVE_CLASS  cMineExplosion::fSensNull;
GC            cMineExplosion::fExplosionGC[1];

SNSTVE_CLASS  cDetonationDisp::fSensNull;
GC            cDetonationDisp::fExplosionGC[1];

float cMineDisp::fMineMagnification = 0.001;
float cVehDisp::fVehMagnification   = 0.0008;

cDispObj::cDispObj (EBoolean visible)
{
   fbVisible = visible;
   fbSelVisible = false;
   fpObjSelected = NULL;

   bzero(&fDfn, sizeof(TACTMAP_OBJECT_DFN));
}

cDispObj::~cDispObj ()
{
  if ( fpObj) {
     tactmap_destroy_object (gpTactmap, fpObj);
     fpObj = NULL;
  }
  if ( fpObjSelected) {
     tactmap_destroy_object (gpTactmap, fpObjSelected);
     fpObjSelected = NULL;
  }
}

void cDispObj::DrawObj ()
{
}

void cDispObj::RotateObj (T2dMove)
{
}

void cDispObj::MoveVertex (int, TLocation)
{
}

void cDispObj::SetVisible (EBoolean show)
{
  if ( show != fbVisible) {
     fbVisible = show;
     if (show)
       tactmap_add_object (gpTactmap, fpObj);
     else
       tactmap_remove_object (gpTactmap, fpObj);
  }
}

void cDispObj::RedrawSelected ()
{
}

void cMineDisp::SetVisible (EBoolean show)
{
  cDispObj::SetVisible (show);
  RedrawSelected ();
}

void cMineDisp::RedrawSelected ()
{
   //if (fpObjSelected) {
   if ((!fpMine->IsSelected() && !fpMine->GetCompParent()->IsSelected())
       || ! fbVisible) {
      if (fbSelVisible) {
	 tactmap_remove_object (gpTactmap, fpObjSelected);
	 fbSelVisible = false;
      }
   }
   else if (! fbSelVisible && fbVisible) {
      tactmap_add_transient_object (gpTactmap, fpObjSelected);
      fbSelVisible = true;
   }
   else
      tactmap_update_object (gpTactmap, fpObjSelected, &fDfnSelected);
   //}
}

void cMineDisp::InitGCs (Widget wShell)
{
   Window            root;
   XGCValues         gcv;
   Pixmap            stipple;
   static char       stipple_bits[] = {0x5, 0xA},
                     stipple_bits2[] = {0x1, 0x0, 0x8};

   struct mine_disp_resources
     {
       Pixel not_sim;
       Pixel detonated;
       Pixel failed;
       Pixel off;
       Pixel inhibit;
       Pixel on;
       Pixel tracking;
       Pixel activating;
       Pixel close_tracking;
       Pixel selected;
       Pixel comp_selected;
       Font  designations;
     } resources;

   static XtResource res_list[] = {
     { "not_sim" , "Not_Sim" , XmRPixel , sizeof(Pixel) ,
       XtOffset(struct mine_disp_resources *, not_sim) ,
       XmRString , "Black" } ,
     { "detonated" , "Detonated" , XmRPixel , sizeof(Pixel) ,
       XtOffset(struct mine_disp_resources *, detonated) ,
       XmRString , "Gray50" } ,
     { "failed" , "Failed" , XmRPixel , sizeof(Pixel) ,
       XtOffset(struct mine_disp_resources *, failed) ,
       XmRString , "Purple" } ,
     { "off" , "Off" , XmRPixel , sizeof(Pixel) ,
       XtOffset(struct mine_disp_resources *, off) ,
       XmRString , "Yellow" } ,
     { "inhibit" , "Inhibit" , XmRPixel , sizeof(Pixel) ,
       XtOffset(struct mine_disp_resources *, inhibit) ,
       XmRString , "Green" } ,
     { "on" , "On" , XmRPixel , sizeof(Pixel) ,
       XtOffset(struct mine_disp_resources *, on) ,
       XmRString , "Black" } ,
     { "tracking" , "Tracking" , XmRPixel , sizeof(Pixel) ,
       XtOffset(struct mine_disp_resources *, tracking) ,
       XmRString , "Orange" } ,
     { "activating" , "Activating" , XmRPixel , sizeof(Pixel) ,
       XtOffset(struct mine_disp_resources *, activating) ,
       XmRString , "Pink" } ,
     { "close_tracking" , "Close_Tracking" , XmRPixel , sizeof(Pixel) ,
       XtOffset(struct mine_disp_resources *, close_tracking) ,
       XmRString , "DeepPink" } ,
     { "selected" , "Selected" , XmRPixel , sizeof(Pixel) ,
       XtOffset(struct mine_disp_resources *, selected) ,
       XmRString , "Blue" } ,
     { "comp_selected" , "Comp_selected" , XmRPixel , sizeof(Pixel) ,
       XtOffset(struct mine_disp_resources *, comp_selected) ,
       XmRString , "Blue" } ,
     { "designations" , "Designations" , XmRFont , sizeof(Font) ,
       XtOffset(struct mine_disp_resources *, designations) ,
       XmRString , "Fixed" } ,
   };

   root = RootWindowOfScreen(XtScreen(wShell));

   /* Get the colors, and various other resources used */
   XtGetSubresources (wShell, &resources, "mine", "MINE",
		      res_list, XtNumber(res_list), NULL, 0);

   gcv.font = resources.designations;
   gcv.background = 
     tactmap_get_color(gpTactmap,(TACTMAP_OBJECT_CLASS)-1);

   gcv.foreground = resources.not_sim;
   fMineGC [emisNone] = 
     XCreateGC(gpDisplay,root,GCForeground|GCBackground|GCFont,&gcv);
   gcv.foreground = resources.detonated;
   fMineGC [emisDetonatedMissed] = 
     XCreateGC(gpDisplay,root,GCForeground|GCBackground|GCFont,&gcv);
   fMineGC [emisDetonatedHit] = 
     XCreateGC(gpDisplay,root,GCForeground|GCBackground|GCFont,&gcv);
   fMineGC [emisDetonated] = 
     XCreateGC(gpDisplay,root,GCForeground|GCBackground|GCFont,&gcv);
   gcv.foreground = resources.failed;
   fMineGC [emisFailed] = 
     XCreateGC(gpDisplay,root,GCForeground|GCBackground|GCFont,&gcv);
   gcv.foreground = resources.off;
   fMineGC [emisOff] = 
     XCreateGC(gpDisplay,root,GCForeground|GCBackground|GCFont,&gcv);
   gcv.foreground = resources.inhibit;
   fMineGC [emisInhibit] = 
     XCreateGC(gpDisplay,root,GCForeground|GCBackground|GCFont,&gcv);
   gcv.foreground = resources.on;
   fMineGC [emisOn] = 
     XCreateGC(gpDisplay,root,GCForeground|GCBackground|GCFont,&gcv);
   gcv.foreground = resources.tracking;
   fMineGC [emisTracking] = 
     XCreateGC(gpDisplay,root,GCForeground|GCBackground|GCFont,&gcv);
   gcv.foreground = resources.activating;
   fMineGC [emisActivating] = 
     XCreateGC(gpDisplay,root,GCForeground|GCBackground|GCFont,&gcv);
   gcv.foreground = resources.close_tracking;
   fMineGC [emisCloseTracking] = 
     XCreateGC(gpDisplay,root,GCForeground|GCBackground|GCFont,&gcv);

   gcv.foreground = resources.selected;
   fMineGC [MAX_GCS-1] =
     XCreateGC(gpDisplay,root,GCForeground|GCBackground|GCFont,&gcv);
   /* stipple for selected */
   stipple = XCreateBitmapFromData (gpDisplay, root, stipple_bits, 4, 2);
   XSetFillStyle (gpDisplay, fMineGC [MAX_GCS-1], FillStippled);
   XSetStipple (gpDisplay, fMineGC [MAX_GCS-1], stipple);

   gcv.foreground = resources.comp_selected;
   fMineGC [MAX_GCS-2] =
     XCreateGC(gpDisplay,root,GCForeground|GCBackground|GCFont,&gcv);
   /* stipple for comp_selected */
   stipple = XCreateBitmapFromData (gpDisplay, root, stipple_bits2, 4, 3);
   XSetFillStyle (gpDisplay, fMineGC [MAX_GCS-2], FillStippled);
   XSetStipple (gpDisplay, fMineGC [MAX_GCS-2], stipple);

   SNSTVE_INIT_CLASS(fSensNull);
   SNSTVE_INIT_CLASS(fSensNullSel);
   SNSTVE_INIT_CLASS(fSensMine);
   callback_register_handler(fSensMine.gesture, 
			     (CALLBACK_HANDLER)CbMove,
			     "mine");
   fSensMine.buttons = 0x7; /* binary 111, Buttons 1, 2 and 3 */
   fSensMine.sensitive = fSensMine.hot = fSensMine.dragable = 1;

   SNSTVE_INIT_CLASS(fSensMineSelect);
   callback_register_handler(fSensMineSelect.gesture, 
			     (CALLBACK_HANDLER)CbClickSelect,
			     "mineSel");
   fSensMineSelect.buttons = 0x2; /* 1 << 1, Button 1 */
   fSensMineSelect.sensitive = fSensMineSelect.hot = 1;

   SNSTVE_INIT_CLASS(fSensMineSelectFire);
   callback_register_handler(fSensMineSelectFire.gesture, 
			     (CALLBACK_HANDLER)CbClickSelectFire,
			     "mineSelFire");
   fSensMineSelectFire.buttons = 0x6; /* 11 << 1, Buttons 1 and 2 */
   fSensMineSelectFire.sensitive = fSensMineSelectFire.hot = 1;

   SNSTVE_INIT_CLASS(fSensMineSelectComp);
   callback_register_handler(fSensMineSelectComp.gesture, 
			     (CALLBACK_HANDLER)CbClickSelectComp,
			     "mineCompSel");
   fSensMineSelectComp.buttons = 0x2; /* 1 << 1, Button 1 */
   fSensMineSelectComp.sensitive = fSensMineSelectComp.hot = 1;

   SNSTVE_INIT_CLASS(fSensMineSelectCompFire);
   callback_register_handler(fSensMineSelectCompFire.gesture, 
			     (CALLBACK_HANDLER)CbClickSelectCompFire,
			     "mineCompSelFire");
   fSensMineSelectCompFire.buttons = 0x6; /* 11 << 1, Buttons 1 and 2 */
   fSensMineSelectCompFire.sensitive = fSensMineSelectCompFire.hot = 1;

   SNSTVE_INIT_CLASS(fSensMineFire);
   callback_register_handler(fSensMineFire.gesture, 
			     (CALLBACK_HANDLER)CbClickFire,
			     "mineFire");
   fSensMineFire.buttons = 0x4; /* 1 << 2, Button 2 */
   fSensMineFire.sensitive = fSensMineFire.hot = 1;

   fSensMineInstanceCounter = 0;
   fpCurFireMine = NULL;
}

void cMineDisp::DrawObj ()
{
   READER_UNION        *mine_pictures;
   TEntityType          mine_type;
   TLocation            tccPt;
   cCoordList*          pMineCoord = 
     gpGuiWin->GetCurEditor()->GetMineCoordWidget();

   fDfn.picture.magnification = fMineMagnification * gpGuiWin->GetMapScale();
   if (fDfn.picture.magnification >= fMineMagnification*50000.) fDfn.picture.magnification = 0.;
   fDfn.picture.gcs[0] = fDfn.picture.gcs[1] = fDfn.picture.gcs[2] =
     fMineGC [fpMine->GetDisplayState()];

   tccPt = fpMine->GetTccLoc();
   fDfn.picture.csystems[0].origin[X] = tccPt.x;
   fDfn.picture.csystems[0].origin[Y] = tccPt.y;

   mine_pictures = (READER_UNION *) otm_query (pvd_db_key, fpMine->GetIconType());

   fDfn.picture.dfn = mine_pictures[1].array;
   if (fpMine->IsDirectional())
     fDfn.picture.csystems[0].angle = fpMine->GetTccOrient().psi - kHalfPi;
   else
     fDfn.picture.csystems[0].angle = 0.0;

   tactmap_update_object (gpTactmap, fpObj, &fDfn);
}

void cMineDisp::SetSensitive (EBoolean sens)
{
   if (sens) {
      fDfn.sensitive.sensClass = &fSensMine;
      tactmap_update_object (gpTactmap, fpObj, &fDfn);
   }      
   else if (fDfn.sensitive.sensClass == &fSensMine) {
      fDfn.sensitive.sensClass = &fSensNull;
      tactmap_update_object (gpTactmap, fpObj, &fDfn);
   }
}

void cMineDisp::SetMineSelectSens (EBoolean sens)
{
  if (sens) {
    if ( fbClickCmdFire )
       fDfn.sensitive.sensClass = &fSensMineSelectFire;
    else
       fDfn.sensitive.sensClass = &fSensMineSelect;
    tactmap_update_object (gpTactmap, fpObj, &fDfn);
  }
  else if ( (fDfn.sensitive.sensClass == &fSensMineSelect) ||
            (fDfn.sensitive.sensClass == &fSensMineSelectFire)  ) {
    fDfn.sensitive.sensClass = &fSensNull;
    tactmap_update_object (gpTactmap, fpObj, &fDfn);
  }
}

void cMineDisp::SetCompSelectSens (EBoolean sens)
{
//   SetSensitive ( sens);

  if (sens) {
    if ( fbClickCmdFire )
       fDfn.sensitive.sensClass = &fSensMineSelectCompFire;
    else
       fDfn.sensitive.sensClass = &fSensMineSelectComp;
    tactmap_update_object (gpTactmap, fpObj, &fDfn);
  }
  else if ( (fDfn.sensitive.sensClass == &fSensMineSelectComp) ||
            (fDfn.sensitive.sensClass == &fSensMineSelectCompFire)  ) {
    fDfn.sensitive.sensClass = &fSensNull;
    tactmap_update_object (gpTactmap, fpObj, &fDfn);
  }
}

void   cMineDisp::ClearFireActive()
{
   snstve_clear_class(gpGuiWin->GetSensWinPtr(), &fSensMineFire);
   fpCurFireMine = NULL;
}

void   cMineDisp::SetFireActiveMine()
   // justs sets the current mine pointer,
   // the actual sensitive area gets set in call
   // from CbDrawSelected()
{
   if ( fpCurFireMine )
      ClearFireActive();
   fpCurFireMine = fpMine;
}

void   cMineDisp::SetFireActiveSens( int x, int y, int radius )
   // this is called from CbDrawSelected so that the sensitive
   // circle gets adjusted on display updates.
   //  Thus, when initially selecting the mine, CbDrawSelected
   // should be called first to avoid a duplicate call to SetFireActive
{
   if ( fpCurFireMine == fpMine ) { // this instantiation must be set to current fire
      ClearFireActive();
      SNSTVE_OBJECT sensObj;
      sensObj.kind = SNSTVE_CIRCLE;
      sensObj.sensClass = &fSensMineFire;
      sensObj.instance = fMineInstance;
      sensObj.user_data = this;
      sensObj.attr.circle.x = (int16)x;
      sensObj.attr.circle.y = (int16)y;
      sensObj.attr.circle.radius = (int16)radius;
      snstve_add_object(gpGuiWin->GetSensWinPtr(), &sensObj);
      fpCurFireMine = fpMine;
   }
}

void cMineDisp::CbDrawSelected (Widget /*widget*/, Pixmap /*pixmap*/,
				ADDRESS draw_arg, XRectangle *boundary)
{
  cMineDisp*     pDisp = (cMineDisp*)draw_arg; 
  XPoint         xpts[4];
  int32          x, y, min_range, max_range, dummy;
  int            x1, y1, x2, y2;
  float          range, sine, cosine;
  TFlatEntCoord  minmax_range;

  if (pDisp->fpMine->GetCompParent()->IsSelected() || pDisp->fpMine->IsSelected()) {

/*modified parameters to match modsaf3.0 libtactmap.h AUSTIN 5 Aug 97*/
         // draw the selection box indicator
    tactmap_map_to_screen (gpTactmap, (float64)pDisp->fDfn.picture.csystems[0].origin[X],
			   (float64)pDisp->fDfn.picture.csystems[0].origin[Y], (int32)0, &x, &y);
    xpts[0].x = x - 10;
    xpts[0].y = y - 10;
    xpts[1].x = x + 10;
    xpts[1].y = y - 10;
    xpts[2].x = x + 10;
    xpts[2].y = y + 10;
    xpts[3].x = x - 10;
    xpts[3].y = y + 10;

    XFillPolygon (gpDisplay, gMapWindow, 
		  pDisp->fpMine->IsSelected() ? fMineGC [MAX_GCS-1] : fMineGC [MAX_GCS-2], 
		  xpts, 4, Convex, CoordModeOrigin);

    boundary->x      = xpts[0].x;
    boundary->y      = xpts[0].y;
    boundary->width  = 20;
    boundary->height = 20;

    if (pDisp->fpMine->IsDirectional (&minmax_range)) {
/*modified parameters to match modsaf3.0 libtactmap.h AUSTIN 5 Aug 97*/
          // draw arrow for directional mines
      tactmap_map_to_screen (gpTactmap, 
			     (float64)(pDisp->fDfn.picture.csystems[0].origin[X] + minmax_range.x), 
			     (float64)0., (int32)0, &min_range, &dummy);
/*modified parameters to match modsaf3.0 libtactmap.h AUSTIN 5 Aug 97*/
      tactmap_map_to_screen (gpTactmap, 
			     (float64)(pDisp->fDfn.picture.csystems[0].origin[X] + minmax_range.y), 
			     (float64)0., (int32)0, &max_range, &dummy);
      min_range -= x;
      max_range -= x;
      cosine = cos (pDisp->fDfn.picture.csystems[0].angle + kHalfPi);
      sine = sin (pDisp->fDfn.picture.csystems[0].angle + kHalfPi);
      x1 = x + min_range * cosine;
      y1 = y - min_range * sine;
      x2 = x + max_range * cosine;
      y2 = y - max_range * sine;

      XDrawLine (gpDisplay, gMapWindow, 
		 fMineGC [pDisp->fpMine->GetInternalState()],
		 x1, y1, x2, y2);
      if (x1 < x2) {
	if (x1 < boundary->x) boundary->x = x1;
	if (x2 > boundary->x + boundary->width) boundary->width = x2 - boundary->x;
      }
      else {
	if (x2 < boundary->x) boundary->x = x2;
	if (x1 > boundary->x + boundary->width) boundary->width = x1 - boundary->x;
      }
      if (y1 < y2) {
	if (y1 < boundary->y) boundary->y = y1;
	if (y2 > boundary->y + boundary->height) boundary->height = y2 - boundary->y;
      }
      else {
	if (y2 < boundary->y) boundary->y = y2;
	if (y1 > boundary->y + boundary->height) boundary->height = y1 - boundary->y;
      }
    }
    
    else if (pDisp->fpMine->IsWideArea (&range)) {
/*modified parameters to match modsaf3.0 libtactmap.h AUSTIN 5 Aug 97*/
          // draw circle for wide area range
      tactmap_map_to_screen (gpTactmap, 
			     (float64)(pDisp->fDfn.picture.csystems[0].origin[X] + range), 
			     (float64)0., (int32)0, &max_range, &dummy);
      max_range -= x;
      XDrawArc (gpDisplay, gMapWindow, 
		fMineGC [pDisp->fpMine->GetInternalState()], 
		(int)(x - max_range), (int)(y - max_range), 
		(unsigned int)(max_range * 2), (unsigned int)(max_range * 2),
		0, 360 * 64);

      if (max_range > 10.) {
	boundary->x      = x - max_range;
	boundary->y      = y - max_range;
	boundary->width  = max_range * 2;
	boundary->height = boundary->width;
      }
         // make circle sensitive, if mine is selected and set to fire
      if ( (pDisp->fpMine->IsSelected()) && (pDisp->fpMine == fpCurFireMine) )
         pDisp->SetFireActiveSens(x, y, max_range);
    }
  }

  else
    bzero(boundary, sizeof(XRectangle));
}

void cMineDisp::CbMove (SNSTVE_WINDOW_PTR /*sensitive*/, 
			SNSTVE_ACTION action,
			SNSTVE_CALL_DATA *call_data, 
			char * /*name*/)
{
    float64    dx, dy, off_vec[XYC];
    TLocation  tccPt;
    cMineDisp* pMineDisp = (cMineDisp *)call_data->user_data; 
    cMine*     pMine     =  pMineDisp->GetMine();

/*replaced tactmap_pixel_offset with tactmap_pix_to_offvec to match modsaf3.0 libtactmap.h AUSTIN 5 Aug 97*/
    tactmap_pix_to_offvec (gpTactmap,
			  call_data->xoff,
			  call_data->yoff,
			  off_vec);
	dx=off_vec[0];
	dy=off_vec[1];	
	//printf("in CbMove x: %d y: %d \n",(int)dx,(int)dx);		
/*
    tactmap_pixel_offset (gpTactmap,
			  call_data->xoff,
			  call_data->yoff,
			  &dx, &dy);
*/
    if (call_data->button == 2 && action == SNSTVE_MOTION &&
         pMine->IsDirectional()) {

      pMineDisp->fDfn.picture.csystems[0].angle = atan2 (dy, dx) - kHalfPi;
      tactmap_update_object (gpTactmap, pMineDisp->fpObj, &pMineDisp->fDfn);
    }

    else if (action == SNSTVE_PRESS)
       gpGuiWin->SetSelection(false, pMine->GetMinefield(), pMine->GetCompParent(), pMine);
//      ((cMineComp*)pMineDisp->fpMine->GetCompParent())->SetMineSelection 
//	   (pMineDisp->fpMine);

    else if (action == SNSTVE_RELEASE) {

      if (call_data->button == 1) {
	tccPt.x = pMineDisp->fDfn.picture.csystems[0].origin[X] + dx;
	tccPt.y = pMineDisp->fDfn.picture.csystems[0].origin[Y] + dy;
   tccPt.z = gpTerrainMgr->GetMapElev(tccPt.x, tccPt.y);
	pMineDisp->fpMine->MoveMine (tccPt);
	tactmap_update_object (gpTactmap, pMineDisp->fpObjSelected, 
			       &pMineDisp->fDfnSelected);
      }

      else if (call_data->button == 2) {
	if (pMine->IsDirectional()) {
	  pMineDisp->fpMine->SetTccOrient ((float)atan2 (dy, dx), 0., 0.);
	  pMineDisp->RedrawSelected();
	}
	else
	  gpGuiWin->DialogMessage (cGuiWindow::eDialogError, NULL,
				   "This mine is not directional\nso it cannot be re-oriented.");
      }

      else if (call_data->button == 3)
	gMfieldMgr.DeleteMine (pMine);
    }
}

void cMineDisp::CbClickSelect (SNSTVE_WINDOW_PTR /* sensitive */, 
			 SNSTVE_ACTION action,
			 SNSTVE_CALL_DATA *call_data, 
			 char * /* name */)
{
         // comp status is editor, select the indiv mine
   if ( action == SNSTVE_PRESS ) {
      cMineDisp*       pMineDisp = (cMineDisp *)call_data->user_data; 
      cMine*           pMine     = pMineDisp->fpMine;
      cMineComp*       pMineComp = (cMineComp*) (pMine->GetCompParent());
      cMinefield*      pMf       = pMineComp->GetMinefield();
      
      gpGuiWin->SetSelection(false, pMf, pMineComp, pMine);
   }
}

void cMineDisp::CbClickSelectFire (SNSTVE_WINDOW_PTR sensitive, 
			 SNSTVE_ACTION action,
			 SNSTVE_CALL_DATA * call_data, 
			 char * name)
{
   if ( call_data->button == 1 )
      CbClickSelect(sensitive, action, call_data, name);
   else if ( ( call_data->button == 2 ) &&
             ( action == SNSTVE_PRESS ) ) {
      cMineDisp*       pMineDisp = (cMineDisp *)call_data->user_data; 
      cMine*           pMine     = pMineDisp->fpMine;
      pMine->CmdDet();
   }
}

void cMineDisp::CbClickSelectComp (SNSTVE_WINDOW_PTR /* sensitive */, 
			 SNSTVE_ACTION action,
			 SNSTVE_CALL_DATA *call_data, 
			 char * /* name */)
{
         // minefield status is editor, select the comp
   if ( action == SNSTVE_PRESS ) {
      cMineDisp*       pMineDisp = (cMineDisp *)call_data->user_data; 
      cMine*           pMine     = pMineDisp->fpMine;
      cMineComp*       pMineComp = (cMineComp*) (pMine->GetCompParent());
      cMinefield*      pMf       = pMineComp->GetMinefield();
     
      gpGuiWin->SetSelection(false, pMf, pMineComp);
   }
}

void cMineDisp::CbClickSelectCompFire (SNSTVE_WINDOW_PTR sensitive, 
			 SNSTVE_ACTION action,
			 SNSTVE_CALL_DATA * call_data, 
			 char * name)
{
   if ( call_data->button == 1 )
      CbClickSelect(sensitive, action, call_data, name);

   /*  the previous line used to call CbClickSelectComp(,,,) but it 
       was changed to call CbClickSelect(,,,) so that Area CD mines
       would be selectable and detonatable from all levels of the 
       gui window.  This creates a small bug.  When the status window
       for an individual component it opened and the user right clicks
       on ANY mine, then the status line gets highlighted.  This is 
       probably the wrong status line, unless the user specifically
       clicked on the mine they wanted selected.  When the user clicks
       on the line of the mine that they are interested in selecting,
       then that mine gets hightlighted on the screen.  Because this
       was a small problem, and easily circumventable, we decided not
       to fix it at this time */

   else if ( (call_data->button == 2) &&
             ( action == SNSTVE_PRESS ) ) {
      cMineDisp*       pMineDisp = (cMineDisp *)call_data->user_data; 
      cMine*           pMine     = pMineDisp->fpMine;
      pMine->CmdDet();
   }
}

void cMineDisp::CbClickFire (SNSTVE_WINDOW_PTR /* sensitive */, 
			 SNSTVE_ACTION  action,
			 SNSTVE_CALL_DATA *call_data, 
			 char * /* name */)
{
   if ( action == SNSTVE_PRESS ) {
      TLocation tccLoc;
      int32 cell = 0;
      tactmap_screen_to_map(gpTactmap, call_data->screen_x, call_data->screen_y,
                            &tccLoc.x, &tccLoc.y, &cell);
      fpCurFireMine->CmdDet(tccLoc);
   }
}

void    cMineDisp::SetMine( cMine* pMine)
{
   fpMine = pMine;
   if (pMine->IsClickFire())
      fbClickCmdFire = true;
   else
      fbClickCmdFire = false;
}

cMineDisp::cMineDisp (cMine* pMine, TLocation /*tccPt*/, EBoolean bVisible) :
   cDispObj( bVisible )
{
   fMineInstance = ++fSensMineInstanceCounter;
   
   if (pMine->IsClickFire())
      fbClickCmdFire = true;
   else
      fbClickCmdFire = false;

   fpMine = pMine;
   fDfn.sensitive.sensClass = &fSensNull;
   fDfn.sensitive.instance = fMineInstance;
   fDfn.sensitive.user_data = (char*)this;

   fDfn.picture.highlight = FALSE;
   fDfn.picture.num_gcs = 3;
   fDfn.picture.num_csystems = 1;

   /* First coordinate system is compass */
   fDfn.picture.csystems[0].parent_system = 0; /* world */
   fDfn.picture.csystems[0].dimensions[X] = 1.0;
   fDfn.picture.csystems[0].dimensions[Y] = 1.0;

   fpObj = tactmap_create_object (gpTactmap, TACTMAP_PICTURE, &fDfn);
   if ( fbVisible)
      tactmap_add_object (gpTactmap, fpObj);

   DrawObj ();

   /* also create Selected Area dfn*/
   bzero(&fDfnSelected, sizeof(TACTMAP_OBJECT_DFN));
   fDfnSelected.sensitive.sensClass = &fSensNullSel;
   fDfnSelected.sensitive.user_data = (char*)this;
   fDfnSelected.sensitive.instance = fMineInstance;

   fDfnSelected.drawn.draw = (TACTMAP_DRAW_CALLBACK)cMineDisp::CbDrawSelected;
   fDfnSelected.drawn.draw_arg = (ADDRESS)this;
   fpObjSelected = tactmap_create_object (gpTactmap, TACTMAP_DRAWN, &fDfnSelected);
}

cMineDisp::~cMineDisp ()
{
}

void cVehDisp::SetVisible (EBoolean show)
{
  if ( show != fbVisible) {
     fbVisible = show;
     if (show) {
        //cout << "setting veh visible, adding trans obj" << endl;
       tactmap_add_transient_object (gpTactmap, fpObj);
     }
     
     else {
        //cout << "setting veh invisible, removing trans obj" << endl;
       tactmap_remove_object (gpTactmap, fpObj);
     }
  }
}

void    cVehDisp::SetVehDispState()
{
   switch ( fpVeh->GetVehicleAppear() )
      {
      case eAprStandard:      /* Healthy */
         fDfn.picture.dfn = fVeh_pictures[1].array;
         break;
      case eAprImmobile:
         fDfn.picture.dfn = fVeh_pictures[2].array;
         break;
      case eAprNoFire:
         fDfn.picture.dfn = fVeh_pictures[3].array;
         break;
      case eAprImmobNoFire:
         fDfn.picture.dfn = fVeh_pictures[4].array;
         break;
      default:      /* catastrophic */
         fDfn.picture.dfn = fVeh_pictures[5].array;
         break;
      }
}

cVehDisp::cVehDisp (cVehicle* pVeh, EBoolean visible)
{
   char                 buf[10];
   PHYSDB_DATA         *pdb;
   TEntityType          veh_type;
   ObjectType           ot;
   DIS_ENTITY_TYPE      et;

   fpVeh = pVeh;
   fDfn.sensitive.sensClass = &fSensVeh;
   fDfn.sensitive.instance = ++fSensVehInstanceCounter;

   veh_type = pVeh->GetDispVehicleType();
   et.entity_kind  = veh_type.kind;
   et.domain       = veh_type.domain;
   et.country      = veh_type.country; 

   // if( gCmsMgr.fStartupParam.feProtocol == /*EProtocol:: */eDis203 ){
   et.category     = veh_type.category;
   et.sub_category = veh_type.subcategory;
   et.specific     = veh_type.specific;
   et.extra        = veh_type.extra;
      //}
   /*   else {
      et.category     = veh_type.category204; 
      et.sub_category = veh_type.subcategory204; 
      et.specific     = veh_type.specific204; 
      et.extra        = veh_type.extra204; 
   }*/ 


   disconst_guise_dis_to_simnet (&et, NULL, &ot);

   fVeh_pictures = (READER_UNION *) otm_query (pvd_db_key, ot);
   fDfn.picture.magnification = 1. + fVehMagnification * gpGuiWin->GetMapScale();
   fDfn.picture.highlight = FALSE;
   sprintf(buf, "#%d", fDfn.sensitive.instance);
   fDfn.picture.string = buf;
   fDfn.picture.num_gcs = 3;
   fDfn.picture.gcs[0] = fBlackGC;
   fDfn.picture.gcs[1] = fWhiteGC;
   fDfn.picture.gcs[2] = fVehGC[pVeh->GetVehicleForce()];

   /* Choosing the right picture, and setting up picture data */
   SetVehDispState();

   pdb = (PHYSDB_DATA *)otm_query(physdb_key, ot); 

   fDfn.picture.num_csystems = 3;

   /* First coordinate system is compass */
   fDfn.picture.csystems[0].parent_system = 0; /* world */
   fDfn.picture.csystems[0].angle = 0.0;
   fDfn.picture.csystems[0].dimensions[X] = 1.0;
   fDfn.picture.csystems[0].dimensions[Y] = 1.0;
   fDfn.picture.csystems[0].origin[X] = pVeh->GetTccLoc().x;
   fDfn.picture.csystems[0].origin[Y] = pVeh->GetTccLoc().y;

   /* Second coordinate system is hull */
   fDfn.picture.csystems[1].parent_system = 1; /* world */
   fDfn.picture.csystems[1].angle = pVeh->GetTccOrient().psi - kHalfPi;
   fDfn.picture.csystems[1].dimensions[X] = pdb->dimensions[X];
   fDfn.picture.csystems[1].dimensions[Y] = pdb->dimensions[Y];
   fDfn.picture.csystems[1].origin[X] = pVeh->GetTccLoc().x;
   fDfn.picture.csystems[1].origin[Y] = pVeh->GetTccLoc().y;

   /* Third coordinate system is turret */
   fDfn.picture.csystems[2].parent_system = 1; /* hull */
   if (pdb->turrets->count)
      {
	fDfn.picture.csystems[2].angle = - pVeh->GetTurretAz();   // neg since veh z pts down
	fDfn.picture.csystems[2].origin[X] = 
	  pdb->turrets->turret[0]->location[X];
	fDfn.picture.csystems[2].origin[Y] = 
	  pdb->turrets->turret[0]->location[Y];
      }
   else
      {
	fDfn.picture.csystems[2].angle = 0.0;
	fDfn.picture.csystems[2].origin[X] = 0.0;
	fDfn.picture.csystems[2].origin[Y] = 0.0;
      }
   fDfn.picture.csystems[2].dimensions[X] =
      pdb->dimensions[X] * 0.5;
   if (pdb->turrets->count &&
       pdb->turrets->turret[0]->guns->count)
     fDfn.picture.csystems[2].dimensions[Y] = 
       pdb->turrets->turret[0]->guns->gun[0]->length;
   else
      fDfn.picture.csystems[2].dimensions[Y] = 0.0;

   fpObj = tactmap_create_object (gpTactmap, TACTMAP_PICTURE, &fDfn);

   //Set visibility of vehicle.
   fbVisible = visible;

   if ( fbVisible) {
      // Vehicle is visible, create the tactmap icon.
      cout<< "creating visible veh disp, adding trans obj" << endl;
      tactmap_add_transient_object (gpTactmap, fpObj);
   }
   else
      // Vehicle is not visible.
      cout<< "creating invisible veh disp" << endl;
}

void cVehDisp::UpdateVehicleDisp ()
{
      // compass
   fDfn.picture.csystems[0].origin[X] = fpVeh->GetTccLoc().x;
   fDfn.picture.csystems[0].origin[Y] = fpVeh->GetTccLoc().y;
      // hull
      
   fDfn.picture.csystems[1].angle     = fpVeh->GetTccOrient().psi - kHalfPi;
   fDfn.picture.csystems[1].origin[X] = fpVeh->GetTccLoc().x;
   fDfn.picture.csystems[1].origin[Y] = fpVeh->GetTccLoc().y;
      // turret
   fDfn.picture.csystems[2].angle     = - fpVeh->GetTurretAz();   // since veh z pts down
   fDfn.picture.magnification = 1. + fVehMagnification * gpGuiWin->GetMapScale();

   SetVehDispState();

   if ( fbVisible)
      tactmap_update_object (gpTactmap, fpObj, &fDfn);
}

cVehDisp::~cVehDisp()
{
}

void cVehDisp::InitGCs (Widget wShell)
{
   XGCValues         gcv;
   Window            root;

   struct pvd_gui_resources
     {
       Pixel black;
       Pixel white;
       Pixel unkn;
       Pixel dist;
       Pixel othr;
       Pixel obsr;
       Pixel targ;
       Font  designations;
     } resources;

   static XtResource res_list[] = {
     { "black" , "Black" , XmRPixel , sizeof(Pixel) ,
       XtOffset(struct pvd_gui_resources *, black) ,
       XmRString , "Black" } ,
     { "white" , "White" , XmRPixel , sizeof(Pixel) ,
       XtOffset(struct pvd_gui_resources *, white) ,
       XmRString , "White" } ,
     { "unknown" , "Unknown" , XmRPixel , sizeof(Pixel) ,
       XtOffset(struct pvd_gui_resources *, unkn) ,
       XmRString , "Gray50" } ,
     { "distinguished", "Distinguished", XmRPixel , sizeof(Pixel) ,
       XtOffset(struct pvd_gui_resources *, dist) ,
       XmRString , "Blue" } ,
     { "other" , "Other" , XmRPixel , sizeof(Pixel) ,
       XtOffset(struct pvd_gui_resources *, othr) ,
       XmRString , "Red" } ,
     { "observer" , "Observer" , XmRPixel , sizeof(Pixel) ,
       XtOffset(struct pvd_gui_resources *, obsr) ,
       XmRString , "DeepPink" } ,
     { "target" , "Target" , XmRPixel , sizeof(Pixel) ,
       XtOffset(struct pvd_gui_resources *, targ) ,
       XmRString , "Green3" } ,
     { "designations" , "Designations" , XmRFont , sizeof(Font) ,
       XtOffset(struct pvd_gui_resources *, designations) ,
       XmRString , "Fixed" } ,
   };

   root = RootWindowOfScreen(XtScreen(wShell));

   /* Get the colors, and various other resources used */
   XtGetSubresources(wShell, &resources, "veh", "VEH",
		     res_list, XtNumber(res_list), NULL, 0);

   /* Make the vehicle GCs */
   gcv.font = resources.designations;
   gcv.background = 
     tactmap_get_color(gpTactmap,(TACTMAP_OBJECT_CLASS)-1);

   gcv.foreground = resources.black;
   fBlackGC = 
     XCreateGC(gpDisplay,root,GCForeground|GCBackground|GCFont,&gcv);
   gcv.foreground = resources.white;
   fWhiteGC = 
     XCreateGC(gpDisplay,root,GCForeground|GCBackground|GCFont,&gcv);
   gcv.foreground = resources.unkn;
   fVehGC[forceIDIrrelevant] =
     XCreateGC(gpDisplay,root,GCForeground|GCBackground|GCFont,&gcv);
   gcv.foreground = resources.dist;
   fVehGC[distinguishedForceID] =
     XCreateGC(gpDisplay,root,GCForeground|GCBackground|GCFont,&gcv);
   gcv.foreground = resources.othr;
   fVehGC[otherForceID] =
     XCreateGC(gpDisplay,root,GCForeground|GCBackground|GCFont,&gcv);
   gcv.foreground = resources.obsr;
   fVehGC[observerForceID] =
     XCreateGC(gpDisplay,root,GCForeground|GCBackground|GCFont,&gcv);
   gcv.foreground = resources.targ;
   fVehGC[targetForceID] =
     XCreateGC(gpDisplay,root,GCForeground|GCBackground|GCFont,&gcv);

   SNSTVE_INIT_CLASS(fSensVeh);
   fSensVehInstanceCounter = 0;
}

void cVehDisp::InitPictures ()
{
   READER_UNION      veh_pictures;

   int32 ret = reader_read("pvd.rdr", Datapath, &veh_pictures, 0);

   pvd_db_key = 
     otm_incorporate_db((OTM_DB *)(veh_pictures.array), 
			TRUE, NULL);
}

void cMineExplosion::DrawExplosion (Widget /*widget*/, Pixmap pixmap, 
				    ADDRESS draw_arg, XRectangle *boundary)
{
  cMineExplosion* pExpl = (cMineExplosion*)draw_arg;
  int32           x1 = 0, y1 = 0, x2= 0, y2 = 0, size = 0, dummy;

/*modified parameters to match modsaf3.0 libtactmap.h AUSTIN 5 Aug 97*/
  if (tactmap_map_to_screen (gpTactmap, pExpl->fDetonPt.x,
			     pExpl->fDetonPt.y, (int32)0, &x1, &y1)) {

      //** experiment to see if this draws better
/*
    tactmap_map_to_screen (gpTactmap, pExpl->fFirePt.x,
			   pExpl->fFirePt.y, &x2, &y2);
*/
/*modified parameters to match modsaf3.0 libtactmap.h AUSTIN 5 Aug 97*/
    tactmap_map_to_screen (gpTactmap, pExpl->fDetonPt.x + pExpl->fBlastSize, 
			   (float64)0., (int32)0, &size, &dummy);
    size -= x1;
    if (size < 10) size = 10;

    XFillArc (gpDisplay, pixmap, cMineExplosion::fExplosionGC[0],
	      (int)(x1 - .5 * size), (int)(y1 - .5 * size), 
	      (int)size, (int)size, 0, 360*64);
  }

  if (pExpl->fDetonPt.x != pExpl->fFirePt.x ||
      pExpl->fDetonPt.y != pExpl->fFirePt.y) {

/*modified parameters to match modsaf3.0 libtactmap.h AUSTIN 5 Aug 97*/
    tactmap_map_to_screen (gpTactmap, pExpl->fFirePt.x,
			   pExpl->fFirePt.y, (int32)0, &x2, &y2);
    XDrawLine (gpDisplay, pixmap, cMineExplosion::fExplosionGC[0],
	       (int)x1, (int)y1, (int)x2, (int)y2);
  }

  boundary->x      = x1 - .5 * size < x2 ? (short)(x1 - .5 * size) : (short)x2;
  boundary->y      = y1 - .5 * size < y2 ? (short)(y1 - .5 * size) : (short)y2;
  boundary->width  = x1 + .5 * size > x2 ? 
    (short)(x1 + .5 * size - boundary->x) : (short) (x2 - boundary->x);
  boundary->height = y1 + .5 * size > y2 ? 
    (short)(y1 + .5 * size - boundary->y) : (short) (y2 - boundary->y);
}

cMineExplosion::cMineExplosion (TLocation detonPt, TLocation firePt, 
				float64 blast_size, TTimeSim delay)
{
   static int i = 0;

   fDetonPt = detonPt;
   fFirePt = firePt;
   fBlastSize = blast_size;

   fDfn.sensitive.sensClass = &fSensNull;
   fDfn.sensitive.user_data = (char*)this;
   fDfn.sensitive.instance = ++i;

   fDfn.drawn.draw = (TACTMAP_DRAW_CALLBACK)DrawExplosion;
   fDfn.drawn.draw_arg = (char*)this;

   fpObj = tactmap_create_object (gpTactmap, TACTMAP_DRAWN, &fDfn);
   tactmap_add_transient_object (gpTactmap, fpObj);

   new cRemoveExplosionMsg (this, delay);
}

cMineExplosion::~cMineExplosion ()
{
}

void cMineExplosion::InitGCs (Widget wShell)
{
   Window            root;
   XGCValues         gcv;

   struct expl_disp_resources
     {
       Pixel color;
       int   line_width;
       Font  designations;
     } resources;

   static XtResource res_list[] = {
     { "color" , "Color" , XmRPixel , sizeof(Pixel) ,
       XtOffset(struct expl_disp_resources *, color) ,
       XmRString , "Yellow" } ,
     { "line_width" , "Line_width" , XmRInt , sizeof(int) ,
       XtOffset(struct expl_disp_resources *, line_width) ,
       XmRString , "2" } ,
     { "designations" , "Designations" , XmRFont , sizeof(Font) ,
       XtOffset(struct expl_disp_resources *, designations) ,
       XmRString , "Fixed" } ,
   };

   root = RootWindowOfScreen(XtScreen(wShell));

   /* Get the colors, and various other resources used */
   XtGetSubresources (wShell, &resources, "expl", "EXPL",
		      res_list, XtNumber(res_list), NULL, 0);

   gcv.font = resources.designations;
   gcv.background = tactmap_get_color (gpTactmap,(TACTMAP_OBJECT_CLASS)-1);
   gcv.foreground = resources.color;
   gcv.line_width = resources.line_width;

   fExplosionGC [0] = 
     XCreateGC(gpDisplay,root,GCForeground|GCBackground|GCLineWidth|GCFont,&gcv);

   SNSTVE_INIT_CLASS(fSensNull);
}

void cDetonationDisp::DrawExplStar (Widget /*widget*/, Pixmap pixmap, 
				    ADDRESS draw_arg, XRectangle *boundary)
{
  cDetonationDisp* pExpl = (cDetonationDisp*)draw_arg;
  TLocation        DetonPt = pExpl->fDeton->GetTccLoc();
  int32            x1 = 0, y1 = 0, size = 0, dummy;

/*modified parameters to match modsaf3.0 libtactmap.h AUSTIN 5 Aug 97*/
  if (tactmap_map_to_screen (gpTactmap, DetonPt.x, DetonPt.y, (int32)0, &x1, &y1)) {

/*modified parameters to match modsaf3.0 libtactmap.h AUSTIN 5 Aug 97*/
    tactmap_map_to_screen (gpTactmap, DetonPt.x + 40, 
			   (float64)0., (int32)0, &size, &dummy);
    size -= x1;
    if (size < 10) size = 20;

    XDrawLine (gpDisplay, pixmap, cDetonationDisp::fExplosionGC[0],
	       (int)(x1 - size), (int)y1,
	       (int)(x1 + size), (int)y1);
    XDrawLine (gpDisplay, pixmap, cDetonationDisp::fExplosionGC[0],
	       (int)(x1 - size), (int)(y1 - size),
	       (int)(x1 + size), (int)(y1 + size));
    XDrawLine (gpDisplay, pixmap, cDetonationDisp::fExplosionGC[0],
	       (int)(x1 - size), (int)(y1 + size),
	       (int)(x1 + size), (int)(y1 - size));
    XDrawLine (gpDisplay, pixmap, cDetonationDisp::fExplosionGC[0],
	       (int)x1, (int)(y1 - size),
	       (int)x1, (int)(y1 + size));
  }

  boundary->x      = x1 - size;
  boundary->y      = y1 - size;
  boundary->width  = 2. * size + 1;
  boundary->height = 2. * size + 1;
}

void cDetonationDisp::DrawExplBox (Widget /*widget*/, Pixmap pixmap, 
				   ADDRESS draw_arg, XRectangle *boundary)
{
  cDetonationDisp* pExpl = (cDetonationDisp*)draw_arg;
  TLocation        DetonPt = pExpl->fDeton->GetTccLoc();
  TOrient          orient = pExpl->fDeton->GetTccOrient();
  float            dx1, dy1, dx2, dy2, width, length;
  int32            x[4], y[4], xmin, ymin, xmax, ymax;
  int              i;

  if (pExpl->fDeton->GetDetonType() == cDetonation::edetMiclic) {
    width  = 7.;
    length = 5.;
  }
  else { // Esmb
    width  =  2.5;
    length = 72.5;
  }

  dx1 =   width  * sin (-orient.psi);
  dy1 = - width  * cos (-orient.psi);
  dx2 =   length * cos (-orient.psi);
  dy2 =   length * sin (-orient.psi);

/*modified parameters to match modsaf3.0 libtactmap.h AUSTIN 5 Aug 97*/
  if (tactmap_map_to_screen (gpTactmap, DetonPt.x + dx1 + dx2,
			     DetonPt.y + dy1 + dy2, (int32)0, &x[0], &y[0])) {

/*modified parameters to match modsaf3.0 libtactmap.h AUSTIN 5 Aug 97*/
    tactmap_map_to_screen (gpTactmap, DetonPt.x - dx1 + dx2, 
			   DetonPt.y - dy1 + dy2, (int32)0, &x[1], &y[1]);
/*modified parameters to match modsaf3.0 libtactmap.h AUSTIN 5 Aug 97*/
    tactmap_map_to_screen (gpTactmap, DetonPt.x - dx1 - dx2, 
			   DetonPt.y - dy1 - dy2, (int32)0, &x[2], &y[2]);
/*modified parameters to match modsaf3.0 libtactmap.h AUSTIN 5 Aug 97*/
    tactmap_map_to_screen (gpTactmap, DetonPt.x + dx1 - dx2, 
			   DetonPt.y + dy1 - dy2, (int32)0, &x[3], &y[3]);

    XDrawLine (gpDisplay, pixmap, cDetonationDisp::fExplosionGC[0],
	       (int)x[0], (int)y[0], (int)x[1], (int)y[1]);
    XDrawLine (gpDisplay, pixmap, cDetonationDisp::fExplosionGC[0],
	       (int)x[1], (int)y[1], (int)x[2], (int)y[2]);
    XDrawLine (gpDisplay, pixmap, cDetonationDisp::fExplosionGC[0],
	       (int)x[2], (int)y[2], (int)x[3], (int)y[3]);
    XDrawLine (gpDisplay, pixmap, cDetonationDisp::fExplosionGC[0],
	       (int)x[3], (int)y[3], (int)x[0], (int)y[0]);
    
    xmin = ymin = 0;
    xmax = ymax = 9999999;
    for (i = 0; i < 4; i++) {
      if (x[i] < xmin) xmin = x[i];
      if (x[i] > xmax) xmax = x[i];
      if (y[i] < ymin) ymin = y[i];
      if (y[i] > ymax) ymax = y[i];
    }
    boundary->x      = xmin;
    boundary->y      = ymin;
    boundary->width  = xmax - xmin + 1;
    boundary->height = ymax - ymin + 1;
  }
  else
    boundary->x = boundary->y = boundary->width =
      boundary->height = 0;
}

cDetonationDisp::cDetonationDisp (cDetonation *pDeton, TTimeSim delay)
{
   static int i = 0;
   int        detonType = pDeton->GetDetonType();

   fDeton = pDeton;

   fDfn.sensitive.sensClass = &fSensNull;
   fDfn.sensitive.user_data = (char*)this;
   fDfn.sensitive.instance = ++i;

   
   if (detonType == cDetonation::edetMiclic || 
       detonType == cDetonation::edetEsmb)
     fDfn.drawn.draw = (TACTMAP_DRAW_CALLBACK)DrawExplBox;
   else
     fDfn.drawn.draw = (TACTMAP_DRAW_CALLBACK)DrawExplStar;
   fDfn.drawn.draw_arg = (char*)this;

   fpObj = tactmap_create_object (gpTactmap, TACTMAP_DRAWN, &fDfn);
   tactmap_add_transient_object (gpTactmap, fpObj);

   new cRemoveDetonationMsg (this, delay);
}

cDetonationDisp::~cDetonationDisp ()
{
}

void cDetonationDisp::InitGCs (Widget wShell)
{
   Window            root;
   XGCValues         gcv;

   struct expl_disp_resources
     {
       Pixel color;
       int   line_width;
       Font  designations;
     } resources;

   static XtResource res_list[] = {
     { "color" , "Color" , XmRPixel , sizeof(Pixel) ,
       XtOffset(struct expl_disp_resources *, color) ,
       XmRString , "Red" } ,
     { "line_width" , "Line_width" , XmRInt , sizeof(int) ,
       XtOffset(struct expl_disp_resources *, line_width) ,
       XmRString , "2" } ,
     { "designations" , "Designations" , XmRFont , sizeof(Font) ,
       XtOffset(struct expl_disp_resources *, designations) ,
       XmRString , "Fixed" } ,
   };

   root = RootWindowOfScreen(XtScreen(wShell));

   /* Get the colors, and various other resources used */
   XtGetSubresources (wShell, &resources, "deton", "DETON",
		      res_list, XtNumber(res_list), NULL, 0);

   gcv.font = resources.designations;
   gcv.background = tactmap_get_color (gpTactmap,(TACTMAP_OBJECT_CLASS)-1);
   gcv.foreground = resources.color;
   gcv.line_width = resources.line_width;

   fExplosionGC [0] = 
     XCreateGC(gpDisplay,root,GCForeground|GCBackground|GCLineWidth|GCFont,&gcv);

   SNSTVE_INIT_CLASS(fSensNull);
}
