#include "EntityIdEdit.h"
//#include "Globals.h"

#include <Xm/Form.h>
#include <Xm/Text.h>
#include <Xm/TextF.h>
#include <Xm/LabelG.h>
#include <Xm/Frame.h>

#include <stdlib.h>

cEntityIdTextEditor::cEntityIdTextEditor (Widget wParent)
{
   Widget         wLabel, wForm;
   //   XmString       xmstr;

   fEntityId = TEntityID(1, 1, 1);
   char id[25];

   fwIdForm = 
     XtVaCreateManagedWidget ("frame", 
			      xmFrameWidgetClass, wParent,
			      XmNshadowThickness, 4, 
			      NULL);
   wForm = 
     XtVaCreateManagedWidget ("entity_id_form", 
			      xmFormWidgetClass, fwIdForm, 
			      NULL);

   wLabel = 
     XtVaCreateManagedWidget ("Controller Id", 
			      xmLabelGadgetClass, wForm,
			      XmNtopAttachment, XmATTACH_FORM,
			      XmNleftAttachment, XmATTACH_FORM,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      NULL);

   fwSiteText = 
      XtVaCreateManagedWidget ("textbox", 
			       xmTextFieldWidgetClass, wForm, 
			       XmNtopAttachment, XmATTACH_WIDGET,
			       XmNtopWidget, wLabel,
			       XmNrightAttachment, XmATTACH_FORM,
			       XmNcolumns, 5,
			       NULL);


   sprintf (id, "%hu", fEntityId.site);
   XmTextFieldSetString (fwSiteText, id);

   XtAddCallback (fwSiteText, XmNactivateCallback, 
		  (XtCallbackProc)CbEntityId, this);
   
   wLabel = 
      XtVaCreateManagedWidget ("Site", 
			       xmLabelGadgetClass, wForm,
			       XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET,
			       XmNtopWidget, fwSiteText,
			       XmNrightAttachment, XmATTACH_WIDGET,
			       XmNrightWidget, fwSiteText, 
			       XmNalignment, XmALIGNMENT_BEGINNING,
			       NULL);



   fwApplicationText = 
      XtVaCreateManagedWidget ("textbox", 
			       xmTextFieldWidgetClass, wForm, 
			       XmNtopAttachment, XmATTACH_WIDGET,
			       XmNtopWidget, fwSiteText,
			       XmNrightAttachment, XmATTACH_OPPOSITE_WIDGET,
			       XmNrightWidget, fwSiteText,
			       XmNcolumns, 5,
			       NULL);

   sprintf (id, "%hu", fEntityId.application);
   XmTextFieldSetString (fwApplicationText, id);

   XtAddCallback (fwApplicationText, XmNactivateCallback, 
		  (XtCallbackProc)CbEntityId, this);
   
   wLabel = 
      XtVaCreateManagedWidget ("Application", 
			       xmLabelGadgetClass, wForm,
			       XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET,
			       XmNtopWidget, fwApplicationText,
			       XmNrightAttachment, XmATTACH_WIDGET,
			       XmNrightWidget, fwApplicationText, 
			       XmNalignment, XmALIGNMENT_BEGINNING,
			       NULL);



   fwEntityNumText = 
      XtVaCreateManagedWidget ("textbox", 
			       xmTextFieldWidgetClass, wForm, 
			       XmNtopAttachment, XmATTACH_WIDGET,
			       XmNtopWidget, fwApplicationText,
			       XmNrightAttachment, XmATTACH_OPPOSITE_WIDGET,
			       XmNrightWidget, fwApplicationText,
			       XmNcolumns, 5,
			       NULL);

   sprintf (id, "%hu", fEntityId.entityNum);
   XmTextFieldSetString (fwEntityNumText, id);

   XtAddCallback (fwEntityNumText, XmNactivateCallback, 
		  (XtCallbackProc)CbEntityId, this);
   
   wLabel = 
      XtVaCreateManagedWidget ("EntityNum", 
			       xmLabelGadgetClass, wForm,
			       XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET,
			       XmNtopWidget, fwEntityNumText,
			       XmNrightAttachment, XmATTACH_WIDGET,
			       XmNrightWidget, fwEntityNumText, 
			       XmNalignment, XmALIGNMENT_BEGINNING,
			       NULL);


			       
}

void cEntityIdTextEditor::SetSensitive(EBoolean sens)
{
   XtSetSensitive(fwIdForm, sens);
}

void cEntityIdTextEditor::GetInputId()
{
   if (XmTextGetString (fwSiteText)) {
      sscanf ((char*)XmTextGetString (fwSiteText), "%hu", &(fEntityId.site));
   }
   if (XmTextGetString (fwApplicationText)) {
      sscanf ((char*)XmTextGetString (fwApplicationText), "%hu", &(fEntityId.application));
   }
   if (XmTextGetString (fwEntityNumText)) {
      sscanf ((char*)XmTextGetString (fwEntityNumText), "%hu", &(fEntityId.entityNum));
   }

   ((cMfComponent*)(gpGuiWin->GetCurComponent()))->SetControllerId(fEntityId);

   //cout << "cEntityIdTextEditor::CbEntityId: Setting controller Id  " << fEntityId << endl;
}

void cEntityIdTextEditor::CbEntityId   (Widget w, XtPointer pObj, XmPushButtonCallbackStruct*)
{
   cEntityIdTextEditor* pWindow = (cEntityIdTextEditor*) pObj;

   pWindow->GetInputId();

   XmProcessTraversal (w, XmTRAVERSE_NEXT_TAB_GROUP);
}
