/*
$RCSfile: FalseMine.cc,v $
$Revision: 1.1.1.1 $
$Author: jchappel $
$Date: 1999/02/16 14:54:34 $
$Log: FalseMine.cc,v $
Revision 1.1.1.1  1999/02/16 14:54:34  jchappel
Comprehensive Mine Simulator

// Revision 2.1  1998/02/18  17:16:10  ksnively
// Incorporated AP mine replacement code.
//
// Revision 2.0  1998/01/26  21:01:35  ksnively
// Baseline CMS before additions for AP mine replacements.
//
// Revision 1.1  1997/12/16  13:59:57  ksnively
// Initial revision
//
// Revision 1.3  1997/10/02  17:53:37  austin
// first working port to modsaf3.0
//
// Revision 1.2  1997/10/02  17:50:22  austin
// first working port to modsaf3.0
//
// Revision 1.2  1997/10/02  17:50:22  austin
// first working port to modsaf3.0
//
// Revision 1.1  1996/10/23  13:54:40  nsipes
// Initial revision
//
// Revision 1.1  1996/10/23  13:54:40  nsipes
// Initial revision
//
// Revision 1.6  1996/07/03  22:55:15  rcarp
// enhancements and bug fixes for version 1.5b9
//
// Revision 1.5  1996/06/19  19:05:45  rcarp
// revisions for mine vulnerability, version 1.5b2
//
// Revision 1.4  1996/05/08  00:46:50  rcarp
// changes for 1.5, incl user mines, mine params, param i/o, selection
//
// Revision 1.4  1996/05/08  00:46:50  rcarp
// changes for 1.5, incl user mines, mine params, param i/o, selection
//
// Revision 1.3  1996/02/16  21:41:55  rcarp
// revisions for getting mine wide area and directional range
//
// Revision 1.2  1996/02/05  14:31:34  rcarp
// Updates and bug fixes of release version 1.1b5
//
$State: Exp $
*/
 
/*******************************************

   file: FalseMine.cc
   
      Copyright 1996 by the Institute for Defense Analyses
      
         Institute for Defense Analyses
         1801 N. Beauregard Street
         Alexandria, Virginia 22311-1772
         703-845-2000
         
      This software was developed by IDA under U. S. Government
      contract.  For distribution information contact:
      
         U. S. Army Night Vision Directorate
         AMSEL RD NV OD CD
         10221 Burbeck Road, suite 430
         Ft. Belvoir VA 22060-5806
      
*********************************************/

/*******************************************

   FalseMine.cc
   
      The AP mine implementation.
      
      
   
   Created by Richard Carpenter
   Modification history:
      created   
      
*********************************************/

#include "FalseMine.h"
#include "Message.h"
#include "CmsPdu.h"


// ************************************
//   components 
// ************************************

// ************************************
//   mines 
// ************************************

 void      cFalseMine::UpdateMine()
{
   if ( feIntState >= emisLowestUpdate)
      fpUpdateMsg = new cUpdateMineMsg(this);
   else {
      delete fpDetonVuln;
      fpDetonVuln = NULL;
   }
}

cFalseMine::cFalseMine(  cPlanMine* pPlan  ) :
   cSimMine(pPlan)
{
}

cFalseMine::~cFalseMine()
{ }

