/*
$RCSfile: Main.cc,v $
$Revision: 1.7 $
$Author: jchappel $
$Date: 1999/05/28 13:49:04 $
$Log: Main.cc,v $
Revision 1.7  1999/05/28 13:49:04  jchappel


Coms code that has been combined with cms code for one distribution.  Makefile
distinguishes which executable to create.

Revision 1.6  1999/05/18 19:33:19  ksnively
Ported CMS to compile under IRIX 6.5
Altered make files to allow cms to be compiled under various OS simulataneously
Removed the Startup GUI

Revision 1.5  1999/05/13 13:26:18  ksnively
Updated CMS version number.

Revision 1.4  1999/04/29 19:34:12  ksnively
Incorporated ARDEC addtions:  Tripwire AP mines and a Control Window.

Revision 1.3  1999/04/22 22:20:00  ksnively
Sreamlined radio communication routines.  Allowed to send to unlimited number of receivers.

Revision 1.2  1999/03/26 21:17:37  ksnively

Added radio communication capability for Command Detonated Mines.  Included sending
and receiving transmitter and signal PDUs.  All signals have the option of being
processed by the Communication Effects Federate.

Revision 1.1.1.1  1999/02/16 14:54:35  jchappel
Comprehensive Mine Simulator

// Revision 2.3  1998/11/25  18:37:51  ksnively
// Update for APLA Exercise
//
// Revision 2.2  1998/07/27  19:49:16  jchappel
// Made changes for DIS switch to 204.
//
// Revision 2.1  1998/02/18  17:16:10  ksnively
// Incorporated AP mine replacement code.
//
// Revision 2.0  1998/01/26  21:01:35  ksnively
// Baseline CMS before additions for AP mine replacements.
//
// Revision 1.4  1998/01/09  18:24:10  ksnively
// Integrated latest SAIC release cms3.0b2
//
// Revision 1.2  1997/12/17  14:38:03  ksnively
// Debugged Minefield duplication routine.
// Added input file "netparams" for reading PDU type enumerations.
// Got rid of warning messages during compilation.
//
// Revision 1.1  1997/12/16  13:59:57  ksnively
// Initial revision
//
// Revision 1.6  1997/10/27  17:08:08  trang
// BUILD1
//
Revision 1.5  1997/10/02 17:51:30  austin
first working port to modsaf3.0

// Revision 1.4  1997/10/02  17:48:55  austin
// first working port to modsaf3.0
//
// Revision 1.4  1997/10/02  17:48:55  austin
// first working port to modsaf3.0
//
// Revision 1.3  1997/03/20  19:14:41  ksnively
// added emission tracking, updated to CMS2.0B6
//
// Revision 1.2  1997/01/02  19:48:54  nsipes
// *** empty log message ***
//
// Revision 1.1  1996/10/23  13:54:40  nsipes
// Initial revision
//
// Revision 1.23  1996/09/07  16:14:35  mkappel
// Draw box(es) for MICLIC and ESMB explosions
//
// Revision 1.23  1996/09/07  16:14:35  mkappel
// Draw box(es) for MICLIC and ESMB explosions
//
// Revision 1.22  1996/09/06  18:57:57  rcarp
// CP bug fixes
//
// Revision 1.21  1996/08/21  22:10:57  rcarp
// redoing, rcs mixup
//
// Revision 1.20  1996/08/20  13:44:41  mkappel
// Add Detonation Display.
//
// Revision 1.19  1996/08/07  14:19:30  rcarp
// initial revisions for CP protocol
//
// Revision 1.18  1996/07/18  19:06:38  rcarp
// Processes all ESPDUs, for version 1.5b14
//
// Revision 1.17  1996/07/13  19:04:20  rcarp
// version 1.5b13, fixes bug dragging with two buttons and displays damamged vehicles
//
// Revision 1.15  1996/07/03  22:55:15  rcarp
// enhancements and bug fixes for version 1.5b9
//
// Revision 1.14  1996/06/22  13:04:11  rcarp
// deton vuln bug fixes for 1.5b4
//
// Revision 1.13  1996/06/21  17:04:20  rcarp
// upgrades for release 1.5b3, mostly mine vuln
//
// Revision 1.12  1996/06/19  19:05:45  rcarp
// revisions for mine vulnerability, version 1.5b2
//
// Revision 1.11  1996/05/16  00:01:58  rcarp
// miscellaneous bugs
//
// Revision 1.10  1996/05/15  00:11:09  rcarp
// mostly wam and offroute fixes, also deleting selection
//
// Revision 1.9  1996/05/14  16:15:08  rcarp
// refinements and bug fixes for 1.5 delivery
//
// Revision 1.6  1996/03/23  14:22:31  rcarp
// improvements to test mode and selection
//
// Revision 1.4  1996/02/16  19:33:39  rcarp
// revisions for 1.1b7 version
//
// Revision 1.3  1996/02/05  14:33:28  rcarp
// Updates and bug fixes of release version 1.1b5
//
$State: Exp $
*/
 
/*******************************************

   file: Main.cc
   
      Copyright 1995 by the Institute for Defense Analyses
      
         Institute for Defense Analyses
         1801 N. Beauregard Street
         Alexandria, Virginia 22311-1772
         703-845-2000
         
      This software was developed by IDA under U. S. Government
      contract.  For distribution information contact:
      
         U. S. Army Night Vision Directorate
         AMSEL RD NV OD CD
         10221 Burbeck Road, suite 430
         Ft. Belvoir VA 22060-5806
      
*********************************************/

/*******************************************

   Main.cc
   
      defines globals, and the short main routine
   
   Created by Richard Carpenter
   Modification history:
      created   
      
*********************************************/
/*
#include <libbgrdb.h>
*/
#include "Globals.h"
#include "CmsControl.h"
#include "NetMgr.h"
#include "Minefield.h"
/*
#include "EntityDB.h"
*/
#include "FileObj.h"
#include "MapGeometry.h"
#include "Vulnerability.h"
#include "CmsPdu.h"
#include "Communication.h"
#include "Display.h"

#ifdef COMS
#include "ComSModel.h"
#endif

/*
#include <libvecmat.h>
*/
#include <sys/time.h>
#include <math.h>
#include <new.h>

#include <stddef.h>
#include <sys/types.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <sys/syssgi.h>
#include <unistd.h>

char Datapath[256] = "../../data";
char DatapathConst[256];
char Const[256] = "/constants";
char Setupdir[256] = "./setup";
argv_t av;
int ac;

//   global constants, first simple types then objects in order of construction
EBoolean         gbGui  = true;
EBoolean         gbHost = true;

cNetMgr*         gpNetMgr = NULL;
cTerrain*        gpTerrainMgr = NULL;
cGuiWindow *     gpGuiWin = NULL;
cRadioNetworkMgr* gpRadioNetMgr = NULL;

cPrEventList     gPrEventList;
cPrUpdtList      gPrUpdtList;
cEventList       gEventList;
cUpdtList        gUpdtList;
cDispUpdtList    gDispUpdtList;
cLowPrEventList  gLowPrEventList;
cLowRateUpdtList gLowRateUpdtList;
cMsgMgr          gMsgMgr;
cCmsMgr          gCmsMgr;
#ifdef COMS
cCOMSMgr         gCOMSMgr;
#endif
// cMechThreatList  gMechThreatList; temporarily in cVulnerability.cc
// cDetThreatList   gDetThreatList;

cVehicleMgr      gVehMgr;
cEmissionMgr     gEmissionMgr;
cMfieldMgr       gMfieldMgr;

cDisPduType      gPduType;

int      gFileProt         = 0666;      // protection mode for created output files
int      gfInteract        = 1;
int      gfMineStateSumm   = 1;
int      gfMineInputParams = 1;
int      gfVehicleInputParams = 1;
int      gfPduData         = 1;         // summary of QRP and CP PDUs sent

int      gfMineStateDisp    = 1;
int      gfTestRun    = 0;
int      gfVehicle    = 0;
int      gfMinefield  = 0;
int      gfMine       = 0;
int      gfFixObj     = 0;
int      gfSensor     = 0;
int      gfDamage     = 0;
int      gfControl    = 0;
int      gfAttack     = 0;
int      gfNetif      = 0;
int      gfDetectProt      = 0;

//   global constants
const char*   kpCmsVersion = "4.0";
char*         gpRunName = "CMS test run";

const char*   pForceText[eNumForceTypes] = {"Other", "Friendly", "Enemy", "Neutral"};

const int kYesNoPairs = 3;
const TKeyValuePair gpYesNoText[] = {
	"no", eNo,
	"yes", eYes,
	"choice", eBoth
};

const double kSimTimeToSec = 0.001;   // 1/1000 sec
const double kSecToSimTime = 1000.0;

const double kSimTimeToDis = 2147.4836470 / 3.6;   // ~ 596.5
const double kDisToSimTime = 3.6 / 2147.4836470;   // ~ .001676

const double kSimTimeToUsec = 1000.0;
const double kUsecToSimTime = 0.001;
int   kMaxMinesInField = 9999;

const double kPi            = M_PI;
const double kHalfPi        = M_PI_2;
const double kDegToRad      = M_PI / 180.0;
const double kRadToDeg      = 180.0 / M_PI;
const double kHalfGravAccel = 4.90308;
const double kMeterToInch   = 39.37;
const double kInchToMeter   = 1.0 / kMeterToInch;

long   gSimStartTime = 0;      // in seconds, not TTimeSim

#ifdef sgi
volatile iotimer_t *gpTimerAddr = NULL;
double gCycleVal = 0.0;
long   gStartTimeMilli = 0;
unsigned int gSimStartCycle = 0;
static unsigned int max_diff = 0;

#endif

//   global functions

float UniformRand()         // uniform on (0,1)
{
   int temp = rand();
   return (float)temp / (float)RAND_MAX;
}

void   SetRand(unsigned int seed)
{
   srand(seed);
}

int     KeyIndexLookup( const TKeyValuePair *list, int size, const char *str )
{
	int i;

	for( i = 0; i < size; i++ )
	{
		if( strcmp(str, list[i].key) == 0 )
			return i;
	}

	return -1;
}

int StringIndexLookup( const char** strArray, int size, const char* str )
{
	int i;

	for( i = 0; i < size; i++ )
	{
		if( strcmp(str, strArray[i]) == 0 )
			return i;
	}

	return -1;
}

#ifdef sgi
void   SetSimStartTime() {

   unsigned int     tm1, tm2, tm3, cycleval;

   //  Most of the below code can be found by doing a man on syssgi
   //  Don't really understand it all, but it works.
   int              fd, poffmask;
   __psunsigned_t   phys_addr, raddr;
   timeval t;
   int cnt, counter_size;

   poffmask = getpagesize() - 1;
   phys_addr = syssgi(SGI_QUERY_CYCLECNTR, &cycleval);

   // This multiplier converts cycles to milliseconds.
   // cycleval is given in number of picoseconds per counter cycle.
   gCycleVal = ((double)cycleval)/1000000000.00;
   max_diff = (unsigned int)(2000.0/gCycleVal);

   raddr = phys_addr & ~poffmask;
   fd = open("/dev/mmem", O_RDONLY);
   gpTimerAddr = (volatile iotimer_t *)mmap(0, poffmask, PROT_READ,
					     MAP_PRIVATE, fd, (__psint_t)raddr);

   gpTimerAddr = (iotimer_t *)((__psunsigned_t)gpTimerAddr + (phys_addr & poffmask));

   // Now determine how many bits are used for the counter
   tm1 = *gpTimerAddr;
   tm2 = *gpTimerAddr;
   tm3 = *gpTimerAddr;

   if ((tm1 == tm2) || (tm2 == tm3)) {
      fprintf (stdout, "Using 64 bit cycle counter\n");
      gpTimerAddr += 1;
      counter_size = 64;
      gSimStartCycle = *gpTimerAddr;
   }
   else {
      for (cnt=0;cnt<3000000;cnt++)
	 if (*gpTimerAddr & 0xff000000)
	    {
	       fprintf(stderr, "Using 32 bit cycle counter.\n");
	       counter_size = 32;
	       gSimStartCycle = *gpTimerAddr;
	       break;
	    }
      if (counter_size == 0) {
	 fprintf(stderr,
		 "Only 24 bit cycle counter available.  Using gettimeofday.\n");
	 gpTimerAddr = NULL;
	 gSimStartCycle = 0;
      }
   }


   // Set simulation start time.
   // Used for periodic checking that cycle counter is accurate.
   // i.e.  - we haven't missed any rollovers.
   gettimeofday(&t);
   gStartTimeMilli = (t.tv_usec * kUsecToSimTime );
   gSimStartTime = t.tv_sec;
}

TTimeSim   GetCurSimTime() {
      //   returns TTimeSim since start of sim
      //
      // looks at hardware cycle counter and determines sim time,
      // in milliseconds.
   static TTimeSim LastRolloverTime = 0;
   static unsigned int lastcycle = 0;
   unsigned int cycle;
   timeval t;
   //printf ("max_diff = %u, gCycleVal = %lf\n", max_diff, gCycleVal);

   // Check if we can use the cycle counter
   // I would like to not to have to do this every time.
   if (gpTimerAddr != NULL) {
      
      // Get the current cycle count
      cycle = *gpTimerAddr;
 
      // Make sure cycle counter has not rolled over or gone unchecked for 
      // more than 2 seconds.  The latter case should only occur if other processes 
      // are hogging the CPU or are suspending CMS, such as a debugger.  In these cases
      // we play the odds that the current cycle count does not land close to the lastcycle 
      // count too often.
      if ( lastcycle < cycle && cycle - lastcycle < max_diff ) { 

         // reset lastcycle
	 lastcycle = cycle;

	 // Determine time.
	 return LastRolloverTime + (TTimeSim)((double)(cycle - gSimStartCycle)*gCycleVal);
      }
      else { // The counter has rolled over, or gone unchecked for too long.  Use gettimeofday.

	 gettimeofday(&t);
	 // Reset the time of the last rollover
	 // gLastRolloverTime = (TTimeSim)( (MAXNUMCYCLES - ((double)gSimStartCycle))*gCycleVal);
	 LastRolloverTime = ((t.tv_sec - gSimStartTime) * kSecToSimTime + 
			      (TTimeSim)(((double)t.tv_usec - (double)gStartTimeMilli) * (double)kUsecToSimTime ));
         // reset lastcycle
	 lastcycle = cycle;

	 // Cycle when Rollover time was set
	 gSimStartCycle = cycle;

	 // Now return current time.
	 return LastRolloverTime;
      }
   }
   else {
      gettimeofday(&t);
      return ( (t.tv_sec - gSimStartTime) * kSecToSimTime +  
	       (TTimeSim)(((double)t.tv_usec - (double)gStartTimeMilli) * (double)kUsecToSimTime ));
   }   
}

#else

void   SetSimStartTime() {
   timeval t;
   gettimeofday(&t);
   gSimStartTime = t.tv_sec;
}

TTimeSim   GetCurSimTime() {
      //   returns TTimeSim since start of sim
      //
      // system call 
      //   int   gettimeofday(timeval* t)
      // returns 0 for no error, and sets seconds and microseconds in 
      //   t.tv_sec and t.tv_usec (each are longs)
   timeval t;
   gettimeofday(&t);
   
   return ( (t.tv_sec - gSimStartTime) * kSecToSimTime + t.tv_usec * kUsecToSimTime );
}

#endif /*sgi*/

char*     cppstrdup( const char* pStr)
{
   char* pNew = new char[strlen(pStr) + 1];
   strcpy(pNew, pStr);
   return pNew;
}

void PrintErrMessage(EerrorNumber errNum, char* fnName, int sysErr)
{
   if (sysErr != 0)
      perror(fnName);
   cerr<< "error/system error " << (int) errNum << " " << sysErr << " " <<" in function " << fnName << " ";
   switch (errNum)
   {
   
            //--------- non-fatal errors
      case  kerrDebug:
         cerr << "General assertion error for debugging" << endl;
         break;
         
      case  kerrNoBuff:
         cerr << "Unable to allocate larger buffer, using default" << endl;
         break;
         
      case  kerrNoPduSend:
         cerr << "Error in sending PDU" << endl;
         break;
         
      case  kerrRecvError:
         cerr << "Error in receiving PDU" << endl;
         break;
         
      case  kerrReadTerrain:
         cerr << "error reading terrain" << endl;
         break;
         
      case  kerrReadMinefield:
         cerr << "error reading minefield file, minefield(s) possibly not read" << endl;
         break;
         
      case  kerrReadParamfile:
         cerr << "error reading parameter file, mine type(s) possibly not read" << endl;
         break;
         
            //--------- fatal errors from now on
      case  kerrMemory:
         cerr << "Could not allocate needed memory" << endl;
         break;
         
      case  kerrValidityCheck:
         cerr << "Error in validity check of internal data" << endl;
         break;
         
      case  kerrNoRecvBcast:
         cerr << "Failure in setting receive socket to broadcast mode" << endl;
         break;
         
      case  kerrBindSocket:
         cerr << "Could not bind socket" << endl;
         break;
         
      case  kerrNoBlock:
         cerr << "Failure in setting nonblocking receive socket" << endl;
         break;
         
      case  kerrCreateSendSocket:
         cerr << "Failure in creating send socket" << endl;
         break;
         
      case  kerrNoSendBcast:
         cerr << "Failure in setting send socket to broadcast mode" << endl;
         break;
         
      case  kerrInvalidMcast:
         cerr << "invalid multicast address specified" << endl;
	 cerr << "Use address of type 224.x.x.x" << endl;
         break;
         
      case  kerrNoSubscribeMcast:
         cerr << "Failure in subscribing to multicast address" << endl;
         break;
         
      case  kerrNoTtlMcast:
         cerr << "Failure in setting time-to-live for multicast mode" << endl;
         break;
         
      case  kerrNoDisableLoop:
         cerr << "Failure in disabling loopback for multicast mode" << endl;
         break;
         
      case  kerrCoordRead:
         cerr << "Failure in reading coordinate conversion constants file" << endl;
         break;
         
      case  kerrProtocolFamily:
         cerr << "Trying to initialize with unknown protocol family" << endl;
         break;
         
      case  kerrList:
         cerr << "Error in list links, software implementation error" << endl;
         break;
         
      case  kerrTypeMatch:
         cerr << "Cannot simulate mine, cannot find mine of this type" << endl;
         break;
         
         
   }
}

void   Assert(int test, EerrorNumber errNum, char* fnName, int sysErr )
{
   if (!test)
   {
      if (fnName)   PrintErrMessage(errNum, fnName, sysErr);
      else          PrintErrMessage(errNum, "*not specified*", sysErr);
            
      if (errNum >= kerrLowestFatal)
      {
         cerr<<"fatal error, number "<< (int)errNum << endl;
         Shutdown(errNum);
      }
      
      else
      {
         cerr<<"non-fatal error, number "<< (int)errNum << endl;
      }
   }
}

void Shutdown (EerrorNumber errNum)
{ 
  exit(errNum);
}

void   NewFailureHandler()
{
   Assert( false, kerrMemory, "NewFailureHandler" );
}

//   main

void main (int argc, char* argv[])
{
	ac=argc;
	av=argv;
	strcpy(DatapathConst, Datapath);
	strcat(DatapathConst, Const); 

   set_new_handler( &NewFailureHandler );
   
   gCmsMgr.Initialize( &ac, av);
   gCmsMgr.Run();
   gCmsMgr.Shutdown();
}


int   yywrap()
{
//    printf("yywrap\n");
//   cout<<"yywrap"<<endl;
   return 1;
}

/*
T2link::T2link()    // initializes head, to point to self
{
   fpNext = fpPrev = this;
}
*/

T2link::T2link(T2link* pPrev)
{
   fpPrev = pPrev;
   fpNext = NULL;      // stays NULL ONLY for unlinked links!
   
   if ( pPrev ) {
      fpNext = fpPrev->fpNext;   // if pPrev==this, still NULL
      
      fpPrev->fpNext = this;
      fpNext->fpPrev = this;
   }
}

T2link::~T2link()
{
   fpPrev->fpNext = fpNext;
   fpNext->fpPrev = fpPrev;
}

T2link*   T2linkHead::GetFirstLink()
{
   fpCurrent = fpNext;
   return fpCurrent;
}

T2link*   T2linkHead::GetLastLink()
{
   return fpPrev;
}

T2link*   T2linkHead::GetNextLink()
{
   fpCurrent = fpCurrent->fpNext;
   return fpCurrent;
}

T2link*   T2linkHead::GetLinkNum(int iLink)
{
   if ( iLink <= 0 )
      return this;
   
   T2link* pLink = fpNext;
   for ( int i = 1; (i < iLink) && (pLink != this); i++, pLink = pLink->fpNext)
      ;
      
   return pLink;
}
void   T2linkHead::DeleteList()
{
   while (fpNext != this) 
      delete fpNext;
   fpCurrent = this;
}

void   T2linkHead::DeletePoint (int iPt)
{
  T2link* pPt = GetLinkNum(iPt);

  if (fpCurrent == pPt)
    fpCurrent = pPt->fpPrev;
  delete pPt;
}

T2linkHead::T2linkHead(T2linkHead* pOldHead) : T2link( this )
{
   fpCurrent = this;

   if (pOldHead->fpNext != pOldHead) {
      fpNext = pOldHead->fpNext;
      fpNext->fpPrev = this;
      fpPrev = pOldHead->fpPrev;
      fpPrev->fpNext = this;
   }
   
   pOldHead->fpNext = pOldHead;
   pOldHead->fpPrev = pOldHead;
   
}

T2linkHead::~T2linkHead()            
{
}

EBoolean    TSelection::MatchSel(cMinefield* pMf, cMfComponent* pCmp, 
                          cMfieldObj* pObj)
{
   if ( (pMf == fpMinefield) && (pCmp == fpComponent) && (pObj == fpMfieldObj) )
      return true;
   else
      return false;
}
                          
EBoolean    TSelection::IsParentSel(cMinefield* pMf, cMfComponent* pCmp, 
                          cMfieldObj* pObj)
{
   if ( (pMf == fpMinefield) && (NULL == fpComponent) && (NULL != pCmp) )
      return true;
   else if ( (pMf == fpMinefield) && (pCmp == fpComponent) 
          && (NULL == fpMfieldObj) && (NULL != pObj) )
      return true;
   
   return false;
}
                          
EBoolean    TSelection::IsChildSel(cMinefield* pMf, cMfComponent* pCmp, 
                          cMfieldObj* pObj)
{
   if ( (pMf == fpMinefield) && (NULL != fpComponent) && (NULL == pCmp) )
      return true;
   else if ( (pMf == fpMinefield) && (pCmp == fpComponent) 
          && (NULL != fpMfieldObj) && (NULL == pObj) )
      return true;
   
   return false;
}

TSelection::TSelection(TSelection* pPrev, cMinefield* pMf, 
           cMfComponent* pCmp, cMfieldObj* pObj) :
        T2link(pPrev)
{
   fpMinefield = pMf;
   fpComponent = pCmp;
   fpMfieldObj = pObj;
   
   if (fpMfieldObj)
      fpMfieldObj->SelectObj();
   else if (fpComponent)
      fpComponent->SelectComp();
   else if (fpMinefield)
      fpMinefield->SelectMfield();
}

TSelection::~TSelection()
{
   if (fpMfieldObj)
      fpMfieldObj->DeSelectObj();
   else if (fpComponent)
      fpComponent->DeSelectComp();
   else if (fpMinefield)
      fpMinefield->DeSelectMfield();
}

double     T3Ddouble::Distance( const T3Ddouble& pt) const 
{ 
   return sqrt( (pt.x-x)*(pt.x-x) +
                (pt.y-y)*(pt.y-y) +
                (pt.z-z)*(pt.z-z) ); 
}

double     T3Ddouble::HorzDistance( const T3Ddouble& pt) const 
{ 
   return sqrt( (pt.x-x)*(pt.x-x) +
                (pt.y-y)*(pt.y-y) ); 
}

T3Ddouble&   T3Ddouble::operator+=(const T3Dsingle& a)
{
   x += a.x;
   y += a.y;
   z += a.z;
   return *this;
}

T3Ddouble&   T3Ddouble::operator+=(const T3Ddouble& a)
{
   x += a.x;
   y += a.y;
   z += a.z;
   return *this;
}

T3Ddouble    T3Ddouble::operator*(double a)
{
   return T3Ddouble(x*a, y*a, z*a);
}

T3Ddouble    T3Ddouble::operator-(const T3Ddouble& a) const
{
   return T3Ddouble(x-a.x, y-a.y, z-a.z);
}

T3Ddouble    T3Ddouble::operator+(const T3Ddouble& a) const
{
   return T3Ddouble(x+a.x, y+a.y, z+a.z);
}

T3Ddouble    T3Ddouble::operator+(const T3Dsingle& a) const
{
   return T3Ddouble(x+a.x, y+a.y, z+a.z);
}

float     T3Dsingle::Distance( const T3Dsingle& pt) const 
{ 
   return sqrt( (pt.x-x)*(pt.x-x) +
                (pt.y-y)*(pt.y-y) +
                (pt.z-z)*(pt.z-z) ); 
}

float     T3Dsingle::HorzDistance( const T3Dsingle& pt) const 
{ 
   return sqrt( (pt.x-x)*(pt.x-x) +
                (pt.y-y)*(pt.y-y) ); 
}

T3Dsingle T3Dsingle:: unit() const
{
    T3Dsingle r;
    float mag;

    mag = x*x + y*y + z*z;
    if (mag == 0.0)
      r.x = 1.0, r.y = 0.0, r.z = 0.0;
    else
    {
        mag = 1.0/sqrt(mag);
        r.x = x * mag;
        r.y = y * mag;
        r.z = z * mag;
    }

    return r;
}


T3Dsingle    T3Dsingle::operator*(float a)
{
   return T3Dsingle(x*a, y*a, z*a);
}

T3Dsingle    T3Dsingle::operator*(double a)
{
   return T3Dsingle(x*a, y*a, z*a);
}

T3Dsingle    T3Dsingle::operator*(TTimeSim a)
{
   return T3Dsingle(x*a, y*a, z*a);
}

T3Dsingle    T3Dsingle::operator-(const T3Dsingle& a)
{
   return T3Dsingle(x-a.x, y-a.y, z-a.z);
}

T3Dsingle    T3Dsingle::operator+(const T3Dsingle& a)
{
   return T3Dsingle(x+a.x, y+a.y, z+a.z);
}

T3Dsingle&   T3Dsingle::operator+=(const T3Dsingle& a)
{
   x += a.x;
   y += a.y;
   z += a.z;
   return *this;
}

T3Dsingle&   T3Dsingle::operator-=(const T3Dsingle& a)
{
   x -= a.x;
   y -= a.y;
   z -= a.z;
   return *this;
}

T3Dsingle&   T3Dsingle::operator*=(float a)
{
   x *= a;
   y *= a;
   z *= a;
   return *this;
}

TLocation::TLocation(const T3Ddouble& d) : T3Ddouble(d.x, d.y, d.z) 
{}

TEntCoord::TEntCoord(const T3Dsingle& s) : T3Dsingle(s.x, s.y, s.z) 
{}


void   TRotation::Mult( const T3Dsingle& in, T3Dsingle* out) const
      // used to go from geo to entity coords
{
   out->x = x.x*in.x + x.y*in.y + x.z*in.z;
   out->y = y.x*in.x + y.y*in.y + y.z*in.z;
   out->z = z.x*in.x + z.y*in.y + z.z*in.z;
}

void   TRotation::Mult( const T3Ddouble& in, T3Dsingle* out) const
      // used to go from geo to entity coords
{
   out->x = x.x*in.x + x.y*in.y + x.z*in.z;
   out->y = y.x*in.x + y.y*in.y + y.z*in.z;
   out->z = z.x*in.x + z.y*in.y + z.z*in.z;
}

void   TRotation::Mult( const T3Ddouble& in, T3Ddouble* out) const
      // used to go from geo to entity coords
{
   out->x = x.x*in.x + x.y*in.y + x.z*in.z;
   out->y = y.x*in.x + y.y*in.y + y.z*in.z;
   out->z = z.x*in.x + z.y*in.y + z.z*in.z;
}

void   TRotation::MultTrans( const T3Dsingle& in, T3Dsingle* out) const
      // transpose multiply, used to go from entity to geo coords
{
   out->x =  x.x*in.x + y.x*in.y + z.x*in.z;
   out->y =  x.y*in.x + y.y*in.y + z.y*in.z;
   out->z =  x.z*in.x + y.z*in.y + z.z*in.z;
}

void   TRotation::MultTrans( const T3Dsingle& in, T3Ddouble* out) const
      // transpose multiply, used to go from entity to geo coords
{
   out->x =  x.x*in.x + y.x*in.y + z.x*in.z;
   out->y =  x.y*in.x + y.y*in.y + z.y*in.z;
   out->z =  x.z*in.x + y.z*in.y + z.z*in.z;
}

void   TRotation::MultTrans( const TRotation& in, TRotation* out) const
      // transpose multiply, used to go from entity to geo coords
{
   out->x.x = x.x*in.x.x + y.x*in.y.x + z.x*in.z.x;
   out->x.y = x.x*in.x.y + y.x*in.y.y + z.x*in.z.y;
   out->x.z = x.x*in.x.z + y.x*in.y.z + z.x*in.z.z;

   out->y.x = x.y*in.x.x + y.y*in.y.x + z.y*in.z.x;
   out->y.y = x.y*in.x.y + y.y*in.y.y + z.y*in.z.y;
   out->y.z = x.y*in.x.z + y.y*in.y.z + z.y*in.z.z;

   out->z.x = x.z*in.x.x + y.z*in.y.x + z.z*in.z.x;
   out->z.y = x.z*in.x.y + y.z*in.y.y + z.z*in.z.y;
   out->z.z = x.z*in.x.z + y.z*in.y.z + z.z*in.z.z;
}

void   TRotation::MultOtherTrans( const TRotation& other, TRotation* out) const
{
   out->x.x = x.x*other.x.x + x.y*other.x.y + x.z*other.x.z;
   out->x.y = x.x*other.y.x + x.y*other.y.y + x.z*other.y.z;
   out->x.z = x.x*other.z.x + x.y*other.z.y + x.z*other.z.z;

   out->y.x = y.x*other.x.x + y.y*other.x.y + y.z*other.x.z;
   out->y.y = y.x*other.y.x + y.y*other.y.y + y.z*other.y.z;
   out->y.z = y.x*other.z.x + y.y*other.z.y + y.z*other.z.z;

   out->z.x = z.x*other.x.x + z.y*other.x.y + z.z*other.x.z;
   out->z.y = z.x*other.y.x + z.y*other.y.y + z.z*other.y.z;
   out->z.z = z.x*other.z.x + z.y*other.z.y + z.z*other.z.z;
}

TRotation   TRotation::operator*(const TRotation& in) const
{
   TRotation out;
   out.x.x = x.x*in.x.x + x.y*in.y.x + x.z*in.z.x;
   out.x.y = x.x*in.x.y + x.y*in.y.y + x.z*in.z.y;
   out.x.z = x.x*in.x.z + x.y*in.y.z + x.z*in.z.z;

   out.y.x = y.x*in.x.x + y.y*in.y.x + y.z*in.z.x;
   out.y.y = y.x*in.x.y + y.y*in.y.y + y.z*in.z.y;
   out.y.z = y.x*in.x.z + y.y*in.y.z + y.z*in.z.z;

   out.z.x = z.x*in.x.x + z.y*in.y.x + z.z*in.z.x;
   out.z.y = z.x*in.x.y + z.y*in.y.y + z.z*in.z.y;
   out.z.z = z.x*in.x.z + z.y*in.y.z + z.z*in.z.z;
   
   return out;
}

T3Dsingle   TRotation::operator*(const T3Ddouble& a) const
      // used to go from geo to entity coords
{
   return T3Dsingle ( x.x*a.x + x.y*a.y + x.z*a.z,
                      y.x*a.x + y.y*a.y + y.z*a.z,
                      z.x*a.x + z.y*a.y + z.z*a.z );
}

T3Dsingle   TRotation::operator*(const T3Dsingle& a) const
      // used to go from geo to entity coords
{
   return T3Dsingle ( x.x*a.x + x.y*a.y + x.z*a.z,
                      y.x*a.x + y.y*a.y + y.z*a.z,
                      z.x*a.x + z.y*a.y + z.z*a.z );
}

T3Ddouble   TRotation::operator|(const T3Dsingle& a) const
      // transpose multiply, used to go from entity to geo coords
{
   return T3Ddouble ( x.x*a.x + y.x*a.y + z.x*a.z,
                      x.y*a.x + y.y*a.y + z.y*a.z,
                      x.z*a.x + y.z*a.y + z.z*a.z );
}

void    TRotation::SetRotation ( float psi, float theta, float phi )
{
   double sinpsi   = sin(psi);
   double cospsi   = cos(psi);
   double sintheta = sin(theta);
   double costheta = cos(theta);
   double sinphi   = sin(phi);
   double cosphi   = cos(phi);

   x.x   =    costheta * cospsi;
   x.y   =    costheta * sinpsi;
   x.z   =   -sintheta;
   
   y.x   =   -cosphi * sinpsi    + sinphi * sintheta * cospsi;
   y.y   =    cosphi * cospsi    + sinphi * sintheta * sinpsi;
   y.z   =    sinphi * costheta;
   
   z.x   =    sinphi * sinpsi    + cosphi * sintheta * cospsi;
   z.y   =   -sinphi * cospsi    + cosphi * sintheta * sinpsi;
   z.z   =    cosphi * costheta;
}

void   TRotation::SetRotation( const TOrient& orientation )
{
   double sinpsi   = sin(orientation.psi);
   double cospsi   = cos(orientation.psi);
   double sintheta = sin(orientation.theta);
   double costheta = cos(orientation.theta);
   double sinphi   = sin(orientation.phi);
   double cosphi   = cos(orientation.phi);

   x.x   =    costheta * cospsi;
   x.y   =    costheta * sinpsi;
   x.z   =   -sintheta;
   
   y.x   =   -cosphi * sinpsi    + sinphi * sintheta * cospsi;
   y.y   =    cosphi * cospsi    + sinphi * sintheta * sinpsi;
   y.z   =    sinphi * costheta;
   
   z.x   =    sinphi * sinpsi    + cosphi * sintheta * cospsi;
   z.y   =   -sinphi * cospsi    + cosphi * sintheta * sinpsi;
   z.z   =    cosphi * costheta;

}

void    TRotation::SetOrientation( TOrient* orient )
{
//   double costheta = sqrt( 1.0 - x.z * x.z );
   orient->psi     =  atan2( x.y, x.x );
   orient->theta   = - asin( x.z );
   orient->phi     =  atan2( y.z, z.z );

}

TRotation::TRotation()
{
   x.x   =    1.0;
   x.y   =    0.0;
   x.z   =    0.0;
   
   y.x   =    0.0;
   y.y   =    1.0;
   y.z   =    0.0;
   
   z.x   =    0.0;
   z.y   =    0.0;
   z.z   =    1.0;
}

TRotation::TRotation( float psi, float theta, float phi )
{
   TOrient orient(psi, theta, phi);
   SetRotation( orient );
}

TRotation::TRotation( const TOrient& orientation )
{
   SetRotation( orientation );
}

void   T2dMove::SetMove(double dx, double dy, double daz)
{
   fDelX = dx;
   fDelY = dy;
   fDelAzimuth = daz;
   TOrient orient( - daz, 0.0, 0.0);
   fRotMatrix.SetRotation(orient);
}

TLocation     EntToSimLoc( const TEntCoord& entLoc, const TLocation& entOrigin, const TRotation& entRot )
{
   return TLocation ( (entRot | (const T3Dsingle&)entLoc) + (const T3Ddouble&)entOrigin );
}

TEntCoord     SimToEntLoc( const TLocation& simLoc, const TLocation& entOrigin, const TRotation& entRot )
{	
   return TEntCoord  (entRot * ((const T3Ddouble&)simLoc - (const T3Ddouble&)entOrigin) );
}

EBoolean      IsVerySmall( const float x )
{
   if ( fabs(x) > 0.00001 )
      return false;
   else
      return true;
}

EBoolean      IsVerySmall( const double x )
{
   if ( fabs(x) > 0.000000001 )
      return false;
   else
      return true;
}

cMessageList*  cMsgPrEvent::GetMsgList()
{
   return &gPrEventList;
}

cMessageList*  cMsgPrUpdt::GetMsgList()
{
   return &gPrUpdtList;
}

cMessageList*  cMsgEvent::GetMsgList()
{
   return &gEventList;
}

cMessageList*  cMsgUpdt::GetMsgList()
{
   return &gUpdtList;
}

cMessageList*  cMsgDispUpdt::GetMsgList()
{
   return &gDispUpdtList;
}

cMessageList*  cMsgLowPrEvent::GetMsgList()
{
   return &gLowPrEventList;
}

cMessageList*  cMsgLowRateUpdt::GetMsgList()
{
   return &gLowRateUpdtList;
}

            // Entity stuff
TEntityType cEntity::fsEntEntityType(kMatchAllChar,
                                kMatchAllChar,
                                kMatchAllShort,
                                kMatchAllChar,
                                kMatchAllChar,
                                kMatchAllChar,
                              /*kMatchAllChar,
                                kMatchAllChar, 
                                kMatchAllChar, 
                                kMatchAllChar,*/
                                kMatchAllChar);
char*   cEntity::fsEntName = "Entity";

const TKeywordEntry TEntityType::fKeyEntityTable[eSizeEntityTable] = {
	"kindInt", ekeyInt,
	"domainInt", ekeyInt,
	"countryInt", ekeyInt,
	"categoryInt", ekeyInt,
	"categoryInt204", ekeyInt,
	"subcategoryInt", ekeyInt,
	"subcategoryInt204", ekeyInt,
	"specificInt", ekeyInt,
	"specificInt204", ekeyInt,
	"extraInt", ekeyInt,
	"extraInt204", ekeyInt,
	"kind", ekeyString,
	"domain", ekeyString,
	"country", ekeyString,
	"category", ekeyString,
	"subcategory", ekeyString
};


void           cEntity::ReplaceEnt( cEntity* pOld )
{
   fpNextEnt        = pOld->fpNextEnt;
   fpPrevEnt        = pOld->fpPrevEnt;

   if (fpNextEnt) fpNextEnt->fpPrevEnt = this;
   if (fpPrevEnt) fpPrevEnt->fpNextEnt = this;
   
   pOld->fpNextEnt = NULL;
   pOld->fpPrevEnt = NULL;
}

cInteraction*   cEntity::CreateNewInteraction(cLinkVehGeom*)
{
   return NULL;
}

void    cEntity::UpdateInteractions()
{
}

void    cEntity::WriteEntSumm(ofstream*)
{
}

char*          cEntity::GetEntName()
{
   return fsEntName;
}

TLocation    cEntity::GetDrGeoLoc(TTimeSim)
{
   return fGeoLocation;
}

TLocation    cEntity::GetDrTccLoc(TTimeSim)
{
   return fTccLocation;
}

void   cEntity::SetCoordGeoRef(TLocation geoLoc, float psi, float theta, float phi)
{
   fGeoLocation = geoLoc;
   fGeoOrient.SetOrient(psi, theta, phi);
   fGeoRotation.SetRotation(fGeoOrient);
   
   SetTccCoordFromGeo();
}

void   cEntity::SetCoordGeoRef(TLocation geoLoc, TOrient orient)
{
   SetCoordGeoRef(geoLoc, orient.psi, orient.theta, orient.phi);
}

void   cEntity::SetCoordTccRef(TLocation tccLoc, float psi, float theta, float phi)
{
   fTccLocation = tccLoc;
   fTccOrientation.SetOrient(psi, theta, phi);
   fTccRotation.SetRotation(fTccOrientation);
   
   SetGeoCoordFromTcc();
}

void   cEntity::SetTccOrient(float psi, float theta, float phi)
   // existing location
{
   fTccOrientation.SetOrient(psi, theta, phi);
   fTccRotation.SetRotation(fTccOrientation);
   
   TRotation mapRot;
   gpTerrainMgr->GetMapRotationGeoPt(&mapRot, fGeoLocation);
   fGeoRotation = fTccRotation * mapRot;
   fGeoRotation.SetOrientation(&fGeoOrient);
}

void   cEntity::SetTccCoordFromGeo()
{
   gpTerrainMgr->SimToMapLoc(fGeoLocation, &fTccLocation);
   TRotation mapRot;
   gpTerrainMgr->GetMapRotationGeoPt(&mapRot, fGeoLocation);
   fGeoRotation.MultOtherTrans(mapRot, &fTccRotation);
   fTccRotation.SetOrientation(&fTccOrientation);
}

void   cEntity::SetGeoCoordFromTcc()
{
   gpTerrainMgr->MapToSimLoc(fTccLocation, &fGeoLocation);
   TRotation mapRot;
   gpTerrainMgr->GetMapRotationGeoPt(&mapRot, fGeoLocation);
   fGeoRotation = fTccRotation * mapRot;
   fGeoRotation.SetOrientation(&fGeoOrient);
}

void    cEntity::GeoToLocalLoc(const T3Ddouble& geoLoc, T3Dsingle* pLocLoc)
{
   fGeoRotation.Mult( geoLoc - fGeoLocation, pLocLoc);
}

void    cEntity::TccToLocalLoc(const T3Ddouble& tccLoc, T3Dsingle* pLocLoc)
{
   fTccRotation.Mult( tccLoc - fTccLocation, pLocLoc);
}

void    cEntity::GeoToLocalVel(const T3Dsingle& geoVel, T3Dsingle* pLocVel)
{
   fGeoRotation.Mult( geoVel, pLocVel);
}

void    cEntity::LocalToGeoVel(const T3Dsingle& locVel, T3Dsingle* pGeoVel)
{
   fGeoRotation.MultTrans(locVel, pGeoVel);
}

void    cEntity::LocalToGeoLoc(const T3Dsingle& locLoc, T3Ddouble* pGeoLoc)
{
   *pGeoLoc = (fGeoRotation | locLoc) + fGeoLocation;
}


void    cEntity::LocalToTccLoc(const T3Dsingle& locLoc, T3Ddouble* pTccLoc)
{
   *pTccLoc = (fTccRotation | locLoc) + fTccLocation;
}

void    cEntity::InDetTargeted(cDetonation* )
{}

void   cEntity::CopyEntityParams(cEntity* pOriginal)
{
	 // cannot copy entity id, as we may be duplicate
	 // Plan mines do not yet have entity id, and simulated
	 // mines are copied only to duplicate entire minefield
	 // into new editable plan mines

   fGeoLocation     = pOriginal->fGeoLocation;
   fGeoOrient       = pOriginal->fGeoOrient;
   fGeoRotation     = pOriginal->fGeoRotation;
   fTccLocation     = pOriginal->fTccLocation;
   fTccOrientation  = pOriginal->fTccOrientation;
   fTccRotation     = pOriginal->fTccRotation;
}

cEntity::cEntity(cEntity* pOrig) 
{
   fpPrevEnt = NULL;
   fpNextEnt = NULL;
   fbSimulating = false;
   fpRadio = NULL;
   fpC2Interface = NULL;

   if ( pOrig )
      CopyEntityParams(pOrig);
}
  
cEntity::~cEntity() 
{
   if ( fId.entityNum != 0)
      gCmsMgr.DeleteEntityId(this);
      
   if (fpPrevEnt)
      fpPrevEnt->fpNextEnt = fpNextEnt;
   if (fpNextEnt) 
      fpNextEnt->fpPrevEnt = fpPrevEnt;
}

EBoolean     TEntityType::ReadEntityStruct(cInFileObj& infile)
   // reads each parameter into buffer, passes it to parser to 
   // interpret it.
{
	EBoolean    done = false;
   EBoolean    success = true;
	do {
            // NextItem() stores an item for us to look at
		EFileReturn returnCode = infile.NextItem();
		switch( returnCode )
		{
			case eLevelDone:      // done with second level struct
//				cout << "level done!" << endl;
				done = true;
				break;

			case eFileNoErr:
				if( !ParseEntityType(infile) )
				{
//					cout << "error parsing parameter" << endl;
					success = false;
				}
				break;

			default: // error getting next token
				Assert(false, kerrReadParamfile, "cDbStruct::ReadDbStruct");
				success = false;
		}
	} while( !done );

	return success;	
}

EBoolean TEntityType::ParseEntityType( cInFileObj& rParamFile )
{
	EFileReturn   returnCode;
	int           returnIndex;
	void*         returnVal = NULL;
	int           i;
   EBoolean      success = true;

	returnCode = rParamFile.ParseItem( fKeyEntityTable, eSizeEntityTable,
		&returnIndex, &returnVal );

	switch( returnCode )
	{
		case eFileNoErr:
			switch( returnIndex )
			{
				case eentkwKindInt:
   					kind = (unsigned char) *((int *)returnVal);
                  delete returnVal;
									returnVal = NULL;
					break;

				case eentkwDomainInt:
   					domain = (unsigned char) *((int *)returnVal);
                  delete returnVal;
									returnVal = NULL;
					break;

				case eentkwCountryInt:
   					country = (short) *((int *)returnVal);
                  delete returnVal;
									returnVal = NULL;
					break;

				case eentkwCategoryInt:
   					category = (unsigned char) *((int *)returnVal);
                  delete returnVal;
									returnVal = NULL;
					break;

				case eentkwCategoryInt204:
                                        if( gCmsMgr.fStartupParam.feProtocol == /*EProtocol:: */eDis204 ){   				
   					category = (unsigned char) *((int *)returnVal);
                                        delete returnVal;
				        returnVal = NULL;
					}
					break;

				        
   					
				case eentkwSubcategoryInt:
   					subcategory = (unsigned char) *((int *)returnVal);
                  delete returnVal;
									returnVal = NULL;
					break;

				case eentkwSubcategoryInt204:
                                        if( gCmsMgr.fStartupParam.feProtocol == /*EProtocol:: */eDis204 ){   				
                                        subcategory = (unsigned char) *((int *)returnVal);
                                        delete returnVal;
				        returnVal = NULL;
}
					break;

				case eentkwSpecificInt:
   					specific = (unsigned char) *((int *)returnVal);
                  delete returnVal;
									returnVal = NULL;
					break;

				case eentkwSpecificInt204:
                                        if( gCmsMgr.fStartupParam.feProtocol == /*EProtocol:: */eDis204 ){   				
   				        specific = (unsigned char) *((int *)returnVal);
                                        delete returnVal;
				        returnVal = NULL;
					}
					break;


				case eentkwExtraInt:
   					extra = (unsigned char) *((int *)returnVal);
                  delete returnVal;
						returnVal = NULL;
					break;

				case eentkwExtraInt204:
                                        if( gCmsMgr.fStartupParam.feProtocol == /*EProtocol:: */eDis204 ){   				
   					extra = (unsigned char) *((int *)returnVal);
                                        delete returnVal;
					returnVal = NULL;
					}
					break;

				case eentkwKind:
   					i = StringIndexLookup( fsKindText, enumKind,
   						 (char *)returnVal );
   					if( i < 0 )
                     success = false;
   					else
                     kind = i;
                  delete[] returnVal;
						returnVal = NULL;
					break;

				case eentkwDomain:
                  i = StringIndexLookup( fsMunDomText, enumMunDom,
                     (char *)returnVal );
   					if( i < 0 )
                     success = false;
   					else
                     domain = i;
                  delete[] returnVal;
                  returnVal = NULL;
					break;

				case eentkwCategory:
                  i = StringIndexLookup( fsMunCategoryText, enumMunCat,
                     (char *)returnVal );
   					if( i < 0 )
                     success = false;
   					else
                     category = i;
                  delete[] returnVal;
                  returnVal = NULL;
					break;

				case eentkwSubcategory:
                  i = KeyIndexLookup( fsMineSubcatText, enumMineSubcatPairs,
                     (char *)returnVal );
   					if( i < 0 )
                     success = false;
   					else
                     subcategory = (unsigned char)fsMineSubcatText[i].value;
                  delete[] returnVal;
                  returnVal = NULL;
					break;

				case eentkwCountry:
                  i = StringIndexLookup( fsCountryText, enumCountry,
                     (char *)returnVal );
   					if( i < 0 )
                     success = false;
   					else
                     country = i;
                  delete[] returnVal;
                  returnVal = NULL;
					break;
               
				default:
					break;  // should never happen
			}
			break;

		default:
			Assert( false, kerrReadParamfile, "TEntityType::ParseEntityType" );
         success = false;
	}
	return success;
}

EBoolean     TEntityType::ParseList( TItemList* pList)
{
   kind = ((int*)(pList->ptrItems))[0];
   domain = ((int*)(pList->ptrItems))[1];
   country = ((int*)(pList->ptrItems))[2];
   category = ((int*)(pList->ptrItems))[3];
   // category204 = ((int*)(pList->ptrItems))[4];
   subcategory = ((int*)(pList->ptrItems))[4];
   //subcategory204 = ((int*)(pList->ptrItems))[6];
   specific = ((int*)(pList->ptrItems))[5];
   //specific204 = ((int*)(pList->ptrItems))[8];
   extra = ((int*)(pList->ptrItems))[6];
   //extra204 = ((int*)(pList->ptrItems))[10];
   
   return true;
}

void    TEntityType::WriteEntityType(ofstream* file)
{
   *file << "entity type : ( " << (int)kind << " "
                               << (int)domain << " "
                               << country << " "
                               << (int)category << " "
     //  << (int)category204 << " "
                               << (int)subcategory << " "
     //  << (int)subcategory204 << " "
                               << (int)specific << " "
     //   << (int)specific204 << " "
                               << (int)extra << " "
     //  << (int)extra204 << " )" 
	                       << endl;
}

void    TEntityType::SetAllWilds()
{
	kind           = kMatchAllChar;
	domain         = kMatchAllChar;
	country        = kMatchAllShort;
	category       = kMatchAllChar;
	//category204    = kMatchAllChar;
	subcategory    = kMatchAllChar;
	//subcategory204 = kMatchAllChar;
	specific       = kMatchAllChar;
	//specific204    = kMatchAllChar;
	extra          = kMatchAllChar;
	//extra204       = kMatchAllChar;
}

EBoolean     TMunitionMapBlock::AddMunEntry(const TEntityType& entType, int index)
{
   if ( fNumEntries >= eMunMapBlockSize )
      return false;
   else {
      fMunMap[fNumEntries].fMunitionType = entType;
      fMunMap[fNumEntries].fDetonType = index;
      fNumEntries++;
      return true;
   }
}

EBoolean     TMunitionMapBlock::GetDetIndexMun( const TEntityType& entType, int* pIndex )
{
   for ( int i = 0; i < fNumEntries; i++ )
      if (  entType.MatchType(fMunMap[i].fMunitionType) ) {
         *pIndex = fMunMap[i].fDetonType;
         return true;
      }
   return false;
}

TMunitionMapBlock::~TMunitionMapBlock()
{ }

int      cMunMapListHead::GetDetIndexMun(const TEntityType& entType)
{
   int index = 0;
   
   for ( TMunitionMapBlock* pMunBlock = (TMunitionMapBlock*)GetFirstLink();
                          pMunBlock != (TMunitionMapBlock*)GetNULLLink();
                          pMunBlock = (TMunitionMapBlock*)GetNextLink() ) {
      if ( pMunBlock->GetDetIndexMun(entType, & index) )
         break;
   }
   return index;
}

void     cMunMapListHead::AddMunMapEntry(const TEntityType& entType, int index)
{
   if ( fpPrev == GetNULLLink() ) {
      new TMunitionMapBlock(fpPrev);
      ((TMunitionMapBlock*)fpPrev)->AddMunEntry( entType, index);
   }
   else if ( ! ( ((TMunitionMapBlock*)fpPrev)->AddMunEntry( entType, index) ) ) {
      new TMunitionMapBlock(fpPrev);
      ((TMunitionMapBlock*)fpPrev)->AddMunEntry( entType, index);
   }
}

cMunMapListHead::cMunMapListHead() : T2linkHead()
{ }

cMunMapListHead::~cMunMapListHead()
{ }

EBoolean     TWarheadMapBlock::AddWhEntry(int warhead, int index)
{
   if ( fNumEntries >= eWhMapBlockSize )
      return false;
   else {
      fWhMap[fNumEntries].fWarheadType = warhead;
      fWhMap[fNumEntries].fDetonType = index;
      fNumEntries++;
      return true;
   }
}

EBoolean     TWarheadMapBlock::GetDetIndexWh( int warhead, int* pIndex )
{
   for ( int i = 0; i < fNumEntries; i++ )
      if ( fWhMap[i].fWarheadType  == warhead ) {
         *pIndex = fWhMap[i].fDetonType;
         return true;
      }
   return false;
}

TWarheadMapBlock::~TWarheadMapBlock()
{ }

int      cWarheadMapListHead::GetDetIndexWh(int warhead)
{
   int index = 0;
   
   for ( TWarheadMapBlock* pWhBlock = (TWarheadMapBlock*)GetFirstLink();
                          pWhBlock != (TWarheadMapBlock*)GetNULLLink();
                          pWhBlock = (TWarheadMapBlock*)GetNextLink() ) {
      if ( pWhBlock->GetDetIndexWh(warhead, & index) )
         break;
   }
   return index;
}

void     cWarheadMapListHead::AddWhMapEntry(int warhead, int index)
{
   if ( fpPrev == GetNULLLink() ) {
      new TWarheadMapBlock(fpPrev);
      ((TWarheadMapBlock*)fpPrev)->AddWhEntry( warhead, index);
   }
   else if ( !( ((TWarheadMapBlock*)fpPrev)->AddWhEntry( warhead, index) ) ) {
      new TWarheadMapBlock(fpPrev);
      ((TWarheadMapBlock*)fpPrev)->AddWhEntry( warhead, index);
   }
}

cWarheadMapListHead::cWarheadMapListHead() : T2linkHead()
{ }

cWarheadMapListHead::~cWarheadMapListHead()
{ }

EBoolean     TDetonNameBlock::AddDetonName( const char* pName, int* pIndex )
{
   if ( fNumEntries >= eDetNameBlockSize )
      return false;
   else {
      fpName[fNumEntries] = cppstrdup( pName );
      *pIndex = fNumEntries + fBaseIndex;
      fNumEntries++;
      return true;
   }
}

EBoolean     TDetonNameBlock::GetDetIndexName( const char* pName, int* pIndex )
{
   for ( int i = 0; i < fNumEntries; i++ )
      if ( strcmp( fpName[i], pName ) == 0 ) {
         *pIndex = i + fBaseIndex;
         return true;
      }
   return false;
}

TDetonNameBlock::TDetonNameBlock(T2link* pPrev, EBoolean first) : 
      T2link(pPrev) 
{ 
   fNumEntries = 0; 
   if ( first )
      fBaseIndex = 0;
   else
      fBaseIndex = ((TDetonNameBlock*)pPrev)->fBaseIndex + eDetNameBlockSize;
}

TDetonNameBlock::~TDetonNameBlock()
{ }

int      cDetonNameListHead::GetDetIndexName(const char* pName)
{
   int index = 0;
   
   for ( TDetonNameBlock* pNameBlock = (TDetonNameBlock*)GetFirstLink();
                          pNameBlock != (TDetonNameBlock*)GetNULLLink();
                          pNameBlock = (TDetonNameBlock*)GetNextLink() ) {
      if ( pNameBlock->GetDetIndexName(pName, & index) )
         break;
   }
   return index;
}

int     cDetonNameListHead::AddDetonName( char* pName )
{
   int index = 0;
   
   if ( fpPrev == GetNULLLink() ) {
      new TDetonNameBlock(fpPrev, true);
      ((TDetonNameBlock*)fpPrev)->AddDetonName(pName, & index);
   }
   else if ( !((TDetonNameBlock*)fpPrev)->AddDetonName(pName, & index) ) {
      new TDetonNameBlock(fpPrev, false);
      index = ((TDetonNameBlock*)fpPrev)->AddDetonName(pName, & index);
   }
   return index;
}

cDetonNameListHead::cDetonNameListHead() : T2linkHead()
{ }

cDetonNameListHead::~cDetonNameListHead()
{ }

cMunMapListHead       cDetonation::fMunitionMapList;
cWarheadMapListHead   cDetonation::fWarheadMapList;
cDetonNameListHead    cDetonation::fDetonNameList;
char*                 cDetonation::fDetTypeNames[edetNumTypes]  = {
   "detOther",
   "detEsmb",
   "detMiclic",
   "detLargeBlast",
   "detMediumBlast",
   "detSmallBlast",
   "detLargeFrag",
   "detSmallFrag"
};
TKeywordEntry   cDetonation::fKeyMunParamTable[eSizeMunParamTable] = {
   "detType",             ekeyString,
   "munitionType",        ekeyIntList,
   "munitionTypeStruct",  ekeyLev2Struct
};
TKeywordEntry   cDetonation::fKeyWhParamTable[eSizeWhParamTable] = {
   "detType",             ekeyString,
   "warheadType",         ekeyInt
};

void    cDetonation::FinishDetInit()
{
   gpTerrainMgr->SimToMapLoc(fGeoLoc, &fTccLoc);
      // for now anyway, we only need directionality for ESMB and MICLIC
   
      //  check entries for munition types, then warhead types
   fDetonType = fMunitionMapList.GetDetIndexMun(fMunitionType);
   if ( fDetonType == 0 )
      fDetonType = fWarheadMapList.GetDetIndexWh( (int)feWarhead);
   
   if ( (fDetonType == edetEsmb) ||
        (fDetonType == edetMiclic) ) {
      TRotation mapRot;
      gpTerrainMgr->GetMapRotationGeoPt( &mapRot, fGeoLoc );
         // use vel (geo coords) to get detonation rotation matrix
      TVelocity mapVel = mapRot * fVelocity;
      float azRot = atan2(mapVel.y, mapVel.x);
      float elRot = atan2( mapVel.z, sqrt(mapVel.x*mapVel.x + mapVel.y*mapVel.y) );
      fTccOrient.SetOrient( azRot, elRot, 0.0 );
      fTccRot.SetRotation( fTccOrient );   // this leaves z pointing up
   }

   if (gbGui) fpDisplay = new cDetonationDisp (this, 3000);
}

EBoolean   cDetonation::IsAreaType()
{
   if ( (fDetonType == edetEsmb) ||
        (fDetonType == edetMiclic) )
      return true;
   else
      return false;
}

void       cDetonation::WriteDetInfo(ofstream* pFile)
{
   *pFile << "Detonation type: " << fDetonType
          << " ent type enum: ";
          
   fMunitionType.WriteEntityType(pFile);
   
   *pFile << " map location: "
          << fTccLoc.x << " "
          << fTccLoc.y << " "
          << fTccLoc.z
          << endl;
          
   if ( (fDetonType == edetEsmb) ||
        (fDetonType == edetMiclic) ) {
      *pFile << "Area detonation azimuth: " << fTccOrient.psi
             << endl;
   }
}

void  cDetonation::ReadParamMunDetType( cInFileObj& infile )
   // reads one entry in the munition-detonation table
{
	EBoolean done = false;
	EBoolean success = true;
   EFileReturn    returnCode;
   int            returnIndex;
   void*          returnVal = NULL;
   
   int            nameIndex = 0;
   TEntityType    munType;
   
   do {
      returnCode = infile.ReadItem( fKeyMunParamTable, eSizeMunParamTable,
            &returnIndex, &returnVal );
      switch( returnCode ) {
         case eLevelDone:      // done with param set
            done = true;
            break;

         case eFileNoErr:
            switch( returnIndex ) {
               case emundetkwName:
                     nameIndex = fDetonNameList.GetDetIndexName( (char*)returnVal );
                     if ( nameIndex == 0 ) {
                        //nameIndex = fDetonNameList.AddDetonName( (char*)returnVal );
			cerr << "Unrecognized detonation type: " << ((char*)returnVal);
		        cerr << ".  Using default type." << endl;
		     }
                     delete[] returnVal;
							returnVal = NULL;
                  break;
   
               case emundetkwMunTypeList: {
                     TItemList * pList = (TItemList *)returnVal;
                     munType.ParseList(pList);
                     delete[] (int *)(pList->ptrItems);
                     delete pList;
							pList = NULL;
							returnVal = NULL;
                     }
                  break;
   
               default: // what?
                     success =  false;
                  break;
            }
            break;

         case eNextLevel:
            switch( returnIndex ) {
               case emundetkwMunTypeStruct:
                     if( !munType.ReadEntityStruct(infile) )
                        success = false;
                  break;
   
               default: // what?
                     success =  false;
                  break;
            }
            break;

         default: // error getting next token
            Assert(false, kerrReadParamfile, "cDetonation::ReadParamMunDetType");
            success =   false;
      }
   } while( !done );
   
   if ( success && nameIndex && (munType.kind == ekindMunition) ) {
      fMunitionMapList.AddMunMapEntry(munType, nameIndex);
   }
}

void  cDetonation::ReadParamWhDetType( cInFileObj& infile )
{
	EBoolean done = false;
	EBoolean success = true;
   EFileReturn    returnCode;
   int            returnIndex;
   void*          returnVal = NULL;
   
   int            nameIndex = 0;
   int            warhead;
   
   do {
      returnCode = infile.ReadItem( fKeyWhParamTable, eSizeWhParamTable,
            &returnIndex, &returnVal );
      switch( returnCode ) {
         case eLevelDone:      // done with param set
            done = true;
            break;

         case eFileNoErr:
            switch( returnIndex ) {
               case ewhdetkwName:
                     nameIndex = fDetonNameList.GetDetIndexName( (char*)returnVal );
                     if ( nameIndex == 0 )
                        nameIndex = fDetonNameList.AddDetonName( (char*)returnVal );
                     delete[] returnVal;
							returnVal = NULL;
                  break;
   
               case ewhdetkwWarhead: 
                     warhead = *(int*)returnVal;
                     delete returnVal;
							returnVal = NULL;
                  break;
   
               default: // what?
                     success =  false;
                  break;
            }
            break;

         default: // error getting next token
            Assert(false, kerrReadParamfile, "cDetonation::ReadParamWhDetType");
            success =   false;
      }
   } while( !done );
   
   if ( success && nameIndex && warhead ) {
      fWarheadMapList.AddWhMapEntry( warhead, nameIndex );
   }
}

void   cDetonation::InitDetonMap()
{
      // add the names first
   int otherIndex = fDetonNameList.AddDetonName( fDetTypeNames[edetOtherDet] );
   int esmbIndex = fDetonNameList.AddDetonName( fDetTypeNames[edetEsmb] );
   int miclicIndex = fDetonNameList.AddDetonName( fDetTypeNames[edetMiclic] );
   int lgblastIndex = fDetonNameList.AddDetonName( fDetTypeNames[edetLgBlast] );
   int medblastIndex = fDetonNameList.AddDetonName( fDetTypeNames[edetMedBlast] );
   int smblastIndex = fDetonNameList.AddDetonName( fDetTypeNames[edetSmBlast] );
   int lgfragIndex = fDetonNameList.AddDetonName( fDetTypeNames[edetLgFrag] );
   int smfragIndex = fDetonNameList.AddDetonName( fDetTypeNames[edetSmFrag] );

   fMunitionMapList.AddMunMapEntry(kEntTypeESMB, esmbIndex);
   fMunitionMapList.AddMunMapEntry(kEntTypeMICLIC, miclicIndex);
   
   fWarheadMapList.AddWhMapEntry(ewhOther, otherIndex);
   
   fWarheadMapList.AddWhMapEntry(ewhHE, medblastIndex);

}

cDetonation::cDetonation() 
{
   fDetonType = edetOtherDet;
}
    
cDetonation::~cDetonation() 
{}

int   CntrClk(double pt0x, double pt0y, double pt1x, double pt1y, double pt2x, double pt2y)
{
   double dx1 = pt1x - pt0x;
   double dy1 = pt1y - pt0y;
   double dx2 = pt2x - pt0x;
   double dy2 = pt2y - pt0y;

   if((dx1*dy2) > (dy1*dx2)) return  1;
   if((dx1*dy2) < (dy1*dx2)) return -1;

   if((dx1*dx2 < 0) || (dy1*dy2 < 0)) return -1;

   if((dx1*dx1+dy1*dy1) < (dx2*dx2+dy2*dy2)) return  1;

   return 0;
}

int   CntrClk(const T3Dsingle& pt0, const T3Dsingle& pt1, const T3Dsingle& pt2)
{
   return CntrClk(pt0.x, pt0.y, pt1.x, pt1.y, pt2.x, pt2.y );
}

EBoolean   SegIntersect(const T3Dsingle& seg1pt1, const T3Dsingle& seg1pt2, const T3Dsingle& seg2pt1, const T3Dsingle& seg2pt2)
{
   return ((CntrClk (seg1pt1.x, seg1pt1.y, seg1pt2.x, seg1pt2.y, seg2pt1.x, seg2pt1.y) *
            CntrClk (seg1pt1.x, seg1pt1.y, seg1pt2.x, seg1pt2.y, seg2pt2.x, seg2pt2.y)) <= 0)
     &&   ((CntrClk (seg2pt1.x, seg2pt1.y, seg2pt2.x, seg2pt2.y, seg1pt1.x, seg1pt1.y) *
            CntrClk (seg2pt1.x, seg2pt1.y, seg2pt2.x, seg2pt2.y, seg1pt2.x, seg1pt2.y)) <= 0) ? true: false;
}

EBoolean   SegIntersect(const T3Ddouble& seg1pt1, const T3Ddouble& seg1pt2, const T3Ddouble& seg2pt1, const T3Ddouble& seg2pt2)
{
   return ((CntrClk (seg1pt1.x, seg1pt1.y, seg1pt2.x, seg1pt2.y, seg2pt1.x, seg2pt1.y) *
            CntrClk (seg1pt1.x, seg1pt1.y, seg1pt2.x, seg1pt2.y, seg2pt2.x, seg2pt2.y)) <= 0)
     &&   ((CntrClk (seg2pt1.x, seg2pt1.y, seg2pt2.x, seg2pt2.y, seg1pt1.x, seg1pt1.y) *
            CntrClk (seg2pt1.x, seg2pt1.y, seg2pt2.x, seg2pt2.y, seg1pt2.x, seg1pt2.y)) <= 0) ? true: false;
}

EBoolean   PtInPolygon(const T3Dsingle& pt, int numPolyPts, const T3Dsingle* pPolyPts)
{
   int i;
   T3Dsingle largeX(pt.x, pt.y, pt.z);
   for ( i = 0; i < numPolyPts; i++ ) {
      if (pPolyPts[i].x > largeX.x) 
         largeX.x = pPolyPts[i].x;
   }
   largeX.x += 100.0;
   
   int   iPrev = numPolyPts - 1;
   int   numSects = 0;
   for ( i = 0; i < numPolyPts; i++ ) {
      if ( SegIntersect( pPolyPts[iPrev], pPolyPts[i], pt, largeX) )
         ++numSects;
      iPrev = i;
   }
   
   return   (numSects & 1) ? true : false;
}

EBoolean   PtInPolygon(const T3Ddouble& pt, int numPolyPts, const T3Ddouble* pPolyPts)
{
   int i;
   T3Ddouble largeX(pt.x, pt.y, pt.z);
   for ( i = 0; i < numPolyPts; i++ ) {
      if (pPolyPts[i].x > largeX.x) 
         largeX.x = pPolyPts[i].x;
   }
   largeX.x += 100.0;
   
   int   iPrev = numPolyPts - 1;
   int   numSects = 0;
   for ( i = 0; i < numPolyPts; i++ ) {
      if ( SegIntersect( pPolyPts[iPrev], pPolyPts[i], pt, largeX) )
         ++numSects;
      iPrev = i;
   }
   
   return   (numSects & 1) ? true : false;
}

//Text Output Operators

//Print Entity ID to a stream
ostream & operator << (ostream & Out, const TEntityID & id)
{
   Out << id.site << ":" << id.application << ":" << id.entityNum;
   return Out;
}
