/*
$RCSfile: MapGeometry.cc,v $
$Revision: 1.1.1.1 $
$Author: jchappel $
$Date: 1999/02/16 14:54:37 $
$Log: MapGeometry.cc,v $
Revision 1.1.1.1  1999/02/16 14:54:37  jchappel
Comprehensive Mine Simulator

// Revision 2.2  1998/11/25  18:37:51  ksnively
// Update for APLA Exercise
//
// Revision 2.1  1998/06/03  17:18:04  jchappel
// ..
//
// Revision 2.0  1998/01/26  21:01:35  ksnively
// Baseline CMS before additions for AP mine replacements.
//
// Revision 1.2  1997/12/17  14:38:03  ksnively
// Debugged Minefield duplication routine.
// Added input file "netparams" for reading PDU type enumerations.
// Got rid of warning messages during compilation.
//
// Revision 1.1  1997/12/16  13:59:57  ksnively
// Initial revision
//
// Revision 1.5  1997/10/27  17:08:08  trang
// BUILD1
//
Revision 1.4  1997/10/02 17:51:30  austin
first working port to modsaf3.0

// Revision 1.3  1997/10/02  17:48:55  austin
// first working port to modsaf3.0
//
// Revision 1.3  1997/10/02  17:48:55  austin
// first working port to modsaf3.0
//
// Revision 1.2  1997/09/16  22:58:51  austin
// last attempt with old style ctdb_read--no libworld use
//
// Revision 1.1  1996/10/23  13:54:40  nsipes
// Initial revision
//
// Revision 1.5  1996/08/09  14:33:27  rcarp
// changed to support los check by terrain manager, and its use by offroute mines
//
// Revision 1.4  1996/07/03  22:55:15  rcarp
// enhancements and bug fixes for version 1.5b9
//
// Revision 1.3  1996/06/19  19:05:45  rcarp
// revisions for mine vulnerability, version 1.5b2
//
// Revision 1.2  1996/02/16  20:08:40  rcarp
// revisions associated with 1.1b7
//
// Revision 1.2  1996/02/16  20:08:40  rcarp
// revisions associated with 1.1b7
//
$State: Exp $
*/
 
/*******************************************

   file: MapGeometry.cc
   
      Copyright 1995 by the Institute for Defense Analyses
      
         Institute for Defense Analyses
         1801 N. Beauregard Street
         Alexandria, Virginia 22311-1772
         703-845-2000
         
      This software was developed by IDA under U. S. Government
      contract.  For distribution information contact:
      
         U. S. Army Night Vision Directorate
         AMSEL RD NV OD CD
         10221 Burbeck Road, suite 430
         Ft. Belvoir VA 22060-5806
      
*********************************************/

/*******************************************

   MapGeometry.cc
   
      Terrain and coordinate transformation
   
   Created by Richard Carpenter
   Modification history:
      created   
      
*********************************************/

#include "MapGeometry.h"
#include "libworld.h"
#include "libcmdline.h"
#include "libworld.h"
#include "libreader.h"
#include <string.h>
#include <sys/stat.h>
extern int ac;
extern argv_t av;

#ifdef FOO
static int32 is_regular_file (char *name)
{
    struct stat buf;

    if (stat(name, &buf) < 0)
      return false;

    return ((buf.st_mode & S_IFMT) == S_IFREG);
}
#endif

cTerrain::cTerrain( char* dirName, char* terrainName, EBoolean* success ) : fpTcc(NULL)
{
   //char path_name[256], *r, *ext;
   //int32 i;

/*begin new variables*/
int32 leftover_argc, lac = 5;
char ** leftover_argv;
char* lav[5];
CTDB *fCtdb_ptr = gpTerrainMgr->GetCtdbAddr();
float64 cntr[XYC];
int32 tdb_version;
char playboxname[265];
CMD_OPTION *options;
uint32 sizeof_options=0;
CMD_TYPES **map;
/*
int ac=1;
char avv[256];
char *av1[256];
argv_t av;
strcpy (avv,"./cms");
avv[4]=NULL;
av1[0] = avv;
av1[1]=NULL;
*/

/* main_options:
 *
 * This structure defines the command line options.  To add a new option:
 *
 * 1) Add a member to this structure.
 * 2) Initialize this new member in main.c
 */

struct main_options_struct main_options = {
#ifdef USE_MOTIF
    {
	"GUI" , "Selects whether to start Graphical User Interface" ,
	NULL ,
	CMD_TOGGLE ,	"gui" ,		"nogui" ,	TRUE ,
    } ,
    {  "Activate", "Selects Enabling and disabling of Simulator Activation",
        NULL ,
        CMD_TOGGLE ,    "activate" ,    "noactivate" ,  FALSE ,
    },
#endif
    {
	"Simulate" , "Selects whether to accept vehicles for simulation" ,
	NULL ,
	CMD_TOGGLE ,	"simulate" ,	"nosim" ,	TRUE ,
    } ,
    {
	"Benchmark" , "Select benchmark mode and sets number of platoons" ,
	NULL ,
	CMD_INTEGER ,	"benchmark" ,	"nobench" ,	0 ,
    } ,
    {
	"Default Competence" , "Specifies default value for vehicle competence (0-1)" ,
	NULL ,
	CMD_FLOAT ,	"competence" ,	NULL ,	0.5 ,
    } ,
    {
        "Vulnerability Modifier" , "Specifies default value for vul modification (0-)" ,
        NULL ,
        CMD_FLOAT ,     "vul_modifier" ,        NULL ,  1.0 ,
    } ,
    {
	"Stealth Previews" , "Specifies number of stealth preview windows" ,
	NULL ,
	CMD_INTEGER ,	"preview" ,	"nopreview" ,	0 ,
    } ,
#ifdef USE_MCAGENT
    {
	"Multicast Agent" , "Specifies whether to use the mcagent library" ,
	"udp&nosafritn" ,
	CMD_BOOLEAN,	"mcagent" ,		"nomcagent" ,	0 ,
    } ,
#endif /*USE_MCAGENT*/
#ifdef USE_RITN
    {
	"SAF RITN" , "Specifies whether to use the safritn library" ,
	"udp&nomcagent" ,
	CMD_BOOLEAN ,	"safritn" ,		"nosafritn" ,	0 ,
    } ,
#endif /*USE_RITN*/
    {
	"Absolute Timestamps" , "Specifies whether to use absolute timestamps" ,
	NULL ,
	CMD_BOOLEAN ,	"absolute_time" , "relative_time" ,	0 ,
    } ,
    {
	"Trust Timestamps" , "Specifies whether to use trust incoming timestamps" ,
	NULL ,
	CMD_BOOLEAN ,	"trust" ,	"skeptic" ,
	0 , 
    } ,
    {
	"Vehicle Loading Factor" , "Specifies fractional simulation weight of one local vehicle" ,
	NULL ,
	CMD_FLOAT ,	"load" ,	NULL ,	(1.0/60.0) ,
    } ,
    {
	"Scenario Directory" , "Specifies directory where scenarios are stored" ,
	"gui" ,
	CMD_STRING ,	"scenario" ,	NULL ,		"../../scenarios" ,
    } ,
    {
	"Profile Directory" , "Specifies directory where profiles are stored" ,
	"gui" ,
	CMD_STRING ,	"profile" ,	NULL ,		"../../profiles" ,
    } ,
    {
	"Overlay Directory" , "Specifies directory where overlays are stored" ,
	"gui" ,
	CMD_STRING ,	"overlay" ,	NULL ,		"../../overlays" ,
    } ,
    {
	"Logs Directory" , "Specifies directory where message logs are stored" ,
	"gui" ,
	CMD_STRING ,	"log" ,		NULL ,		"../../logs" ,
    } ,
    {
	"Views Directory" , "Specifies directory where stealth view files are stored" ,
	"gui" ,
	CMD_STRING ,	"views" ,	NULL ,		"../../views" ,
    } ,
    {
	"Template Directory" , "Specifies directory where minefield template files are stored" ,
	NULL ,
	CMD_STRING ,	"template" ,	NULL ,		"../../templates" ,
    } ,
    {
	"Standard Load Directory" , "Specifies directory where standard load files are stored" ,
	NULL ,
	CMD_STRING ,	"stdload" ,	NULL ,		"../../stdloads" ,
    } ,
    {
	"Data Directory" , "Specifies directory where data files are stored" ,
	NULL ,
	CMD_STRING ,	"data" ,	NULL ,		"../../data" ,
    } ,
    {
	"Oversize Cursor" , "Selects whether to use a very large mouse pointer" ,
	NULL ,
	CMD_TOGGLE ,	"cursor" ,	"nocursor" ,	TRUE ,
    } ,
    {
	"Use RouteMap" , "Selects whether to attempt platoon-level planning" ,
	NULL ,
	CMD_BOOLEAN ,	"routemap" ,	"noroutemap" ,	TRUE ,
    } ,
    {
	"Memory Monitor" , "Specifies whether to print memory high water point" ,
	NULL ,
	CMD_TOGGLE ,	"memmon",	"nomemmon" ,	FALSE ,
    } ,
    {
	"Preferred Stealth" , "Specifies the address of the only stealth to show" ,
	NULL ,
	CMD_INTEGER ,	"stealth" ,	"anystealth" ,	0 ,
    } ,
    {
	/* stealth takes two arguments */
	NULL, NULL, NULL , CMD_INTEGER , NULL, NULL, 0,
    } ,
    {
	"Use SAFParse" , "Selects whether start-up the SAF parser" ,
	NULL ,
	CMD_BOOLEAN ,	"safparse" ,	"nosafparse" ,	TRUE ,
    } ,
    {
        "Use sourcefile" , "Specifies source file loaded at start" ,
        "safparse" ,
        CMD_STRING ,    "sourcefile" ,  NULL ,  NULL,
    } ,
    {
	"Send StatusChange PDUs" , "Specifies whether to send StatusChange PDUs" ,
	NULL ,
	CMD_BOOLEAN ,	"vpdu_stcg",	"novpdu_stcg" ,	FALSE ,
    } ,
    {
	"Send TgtAcq VVA PDUs" , "Specifies whether to send Tgt Acq VVA PDUs" ,
	NULL ,
	CMD_BOOLEAN ,	"vpdu_tgtacq",	"novpdu_tgtacq" ,	FALSE ,
    } ,
    {
	"Send DelAcc VVA PDUs" , "Specifies whether to send Del Acc VVA PDUs" ,
	NULL ,
	CMD_BOOLEAN ,	"vpdu_delacc",	"novpdu_delacc" ,	FALSE ,
    } ,
    {
	"Send DfDam VVA PDUs" , "Specifies whether to send Df Dam VVA PDUs" ,
	NULL ,
	CMD_BOOLEAN ,	"vpdu_dfdam",	"novpdu_dfdam" ,	FALSE ,
    } ,
    {
	"Send IfDam VVA PDUs" , "Specifies whether to send If Dam VVA PDUs" ,
	NULL ,
	CMD_BOOLEAN ,	"vpdu_ifdam",	"novpdu_ifdam" ,	FALSE ,
    } ,
    {
	"MKill cants vehicle" , "Specifies whether to cant m-killed vehicle" ,
	NULL ,
	CMD_BOOLEAN ,	"mkill_cants_vehicle",	"nomkill_cants_vehicle" , TRUE ,
    } ,
    {
	"FKill droops gun" , "Specifies whether to droop f-killed vehicle's gun" ,
	NULL ,
	CMD_BOOLEAN ,	"fkill_droops_gun",	"nofkill_droops_gun" , TRUE ,
    } ,
    {
	"Best Matching Ammo" , 
	"Specifies whether to use data from best matching ammo in DfDam and IfDam" ,
	NULL ,
	CMD_BOOLEAN ,	"best_ammo_match",	"exact_ammo_match" , TRUE ,
    } ,
    {
	"Abort on false assertions", 
	"Specifies whether to abort on false assertions",
	NULL,
	CMD_BOOLEAN, "asserts", "noasserts", FALSE,
    },
    {
	"Detect floating point exception",
	"Specifies whether to try to detect certain floating point exceptions",
	NULL,
	CMD_BOOLEAN,
	"fpes", "nofpes", FALSE,
    },
    {
	"Relative Battle Scheme" , "Selects whether relative battle scheme should be used" ,
	NULL ,
	CMD_TOGGLE ,	"relative_battle" ,	"norelative_battle" ,	FALSE ,
    } ,
    {
      "Modify Competence" , "Specifies whether user can modify unit competence" ,
      NULL ,
      CMD_BOOLEAN ,   "mod_competence",       "nomod_competence" , TRUE ,
    } ,
    {
      "Force non-constant environment" , 
      "Initialize non-constant environmental models" ,
      "dis",
      CMD_BOOLEAN ,       "allow_env" ,   "constant_env" , FALSE ,
    } ,
    {
      "Disable dust behavior" , 
      "Skip initialization of non-constant environmental dust models" ,
      NULL ,
      CMD_BOOLEAN ,   "ignore_dust_behavior",   "dust_behavior" , TRUE ,
    } ,
    {
      "Enable phenomenology behavior" , 
      "Enable all phenomenology effects" ,
      NULL ,
      CMD_BOOLEAN ,  "phen_behavior",  "no_phen_behavior" ,  TRUE ,
    } ,
    {
      "Environmental Weather Simulator" , "Specifies whether simulator can be a master for weather",
      NULL ,
      CMD_BOOLEAN ,   "envweathersim",       "envweathernosim" , FALSE,
    } ,
    {
      "Environmental Sea State Simulator" , "Specifies whether simulator can be a master for sea conditions",
      NULL ,
      CMD_BOOLEAN ,   "envseasim",       "envseanosim" , FALSE,
    } ,
    {
      "Environmental Statistics" , "Automatically print environmental statistics upon completion",
      NULL ,
      CMD_BOOLEAN ,   "envstats",       "noenvstats" , FALSE ,
    } ,
    {
      "Use ModStealth Protocol" , "Selects whether to use ModStealth or SIMNET stealth protocol" ,
      NULL ,
      CMD_BOOLEAN ,   "modstealth",      "nomodstealth" , TRUE ,
    } ,
    {
      "Smoke Cloud Representation" , "0 = puffs, 1 = plumes, 2 (default) = use greater mass" ,
      NULL ,
      CMD_INTEGER ,   "smoke_cloud_rep",      NULL , 2 ,
    } ,
    {
      "View file", "File to load for saved stealth views",
      NULL, 
      CMD_STRING, "viewfile", NULL, NULL, 
    },
    {
      "Template file", "File to load for saved minefield templates",
      NULL, 
      CMD_STRING, "tmplfile", NULL, NULL, 
    } ,
    {
      "Send RFPI Messages" , "If TRUE sends RFPI C2 messages via Signal PDUs" ,
      NULL ,
      CMD_BOOLEAN ,   "rfpi",      "norfpi", FALSE ,
    } ,
    {
	"Skip DfDam" , 
	"Specifies whether to skip dfdam tables (developer-use only)" ,
	NULL ,
	CMD_BOOLEAN ,	"skip_dfdam",	"no_skip_dfdam" , FALSE ,
    } ,
    {
      /* MITRE BCK */
      "Use CFOR" , "Specifies whether Command Forces Project modifications are used" ,
      NULL ,
      CMD_TOGGLE ,   "ccsil",      "noccsil" , FALSE ,
    },
    {
	"DT Simulator" , 
	"Specifies whether to start a DTO Simulator" ,
	NULL ,
	CMD_BOOLEAN ,	"dtsim",	"no_dtsim" , FALSE ,
    } ,
    {
	"DT Scribe" , 
	"Specifies whether to start a DTO Scribe" ,
	NULL ,
	CMD_BOOLEAN ,	"dtscribe",	"no_dtscribe" , FALSE ,
    } ,
#ifdef USE_CLCGF
    {
	"ASPDU" , "Selects whether to send and receive AGGREGATE STATE PDU's" ,
	NULL ,
	CMD_TOGGLE ,	"aspdu" ,          "noaspdu" ,	TRUE ,
    } ,
#endif
    {
	"Network Monitor Interval" , "Specifies the interval in milliseconds for network monitor broadcasts" ,
	NULL ,
	CMD_INTEGER ,   "network_monitor" , NULL,   -1 ,
    },
    {
        "Network Monitor Address",
        "Specifies the address the network monitor broadcasts will go to",
        NULL, CMD_STRING, "network_monitor_address",
        NULL, "fff.fff.fff.fff",
    },
    {
	"Simple IFF" , 
	"Specifies whether to use simple IFF model" ,
	NULL ,
	CMD_BOOLEAN ,	"simple_iff",	"nosimple_iff" , FALSE ,
    } , 
    {
	"Supply Consumption" , 
	"Specifies whether supply consumption is forced in the obstacle editor",
	NULL ,
	CMD_BOOLEAN ,	"force_supply_consumption",	
	"no_force_supply_consumption" , FALSE ,
    } ,
    {
	"Damage Editor",
	"Specifies whether to display the damage editor",
	NULL,
	CMD_BOOLEAN, "damage_editor_on",
	"damage_editor_off", TRUE,
    },
    {
	"Random Failures",
        "Specifies whether random failures should occur",
	NULL,
	CMD_BOOLEAN, "random_failure_on",
	"random_failure_off", FALSE,
    },
#ifdef PERSIM
    {
      "Image Generator" , "0 = none, 1 = Vistaworks, 2 = Performer" ,
      NULL ,
      CMD_INTEGER,   "ig",   NULL,    1,
    } ,
#endif
    {
        "Environment Demo Mode",
        "Specifies simple weather to be non-realtime",
        NULL ,
        CMD_BOOLEAN , "env_hydro",  "env_nohydro", FALSE,
    },
    {
	"Print Extended Version/Build Info",
	"Print Extended Version/Build Info",
	NULL,
	CMD_BOOLEAN,
	"software_version", "no_software_version", FALSE,
    }
};

#ifdef FOO
    if (name)
    {
      for (i=0;i<2;i++)
      {
          if (!i)
            ext = "ctb";      /* Preferred */
          else
            ext = "ctdb";      /* Old */
ext = "c7b";
          /* style: knox-0311 (in directory) */
          sprintf(path_name, "terrain/%s.%s", name, ext);
          if (!is_regular_file(path_name))
          {
            /* style: knox-0311 (in subdirectory) */
            sprintf(path_name, "terrain/%s/%s.%s", name, name, ext);
            if (!is_regular_file(path_name))
            {
                /* style: /usr/terrain/knox-0311 */
                if (!(r = strrchr/*rindex*/(name, '/')))
                  r = name;
                sprintf(path_name, "%s/%s.%s", name, r, ext);
                if (!is_regular_file(path_name))
                {
                  /* style: /usr/terrain/[knox-0311/]knox-0311.ctb */
                  strcpy(path_name, name);
                  if (!is_regular_file(path_name))
                  {
                      FILE *lspipe;
                      char cmd[256];

                      /* style: knox */
                      sprintf(cmd, "/bin/ls terrain/%s-*.%s",
                            name, ext);
                      if (lspipe = popen(cmd, "r"))
                      {
                        /* Read up to last one.  If not found,
                         * path_name will still hold name, from above.
                         */
                        while (fgets(path_name, sizeof(path_name),
                                   lspipe))
                          path_name[strlen(path_name)-1] = 0;
                        pclose(lspipe);
                      }
                      if (!is_regular_file(path_name))
                      {
                        sprintf(cmd, "/bin/ls terrain/*/%s-*.%s",
                              name, ext);
                        if (lspipe = popen(cmd, "r"))
                        {
                            while (fgets(path_name, sizeof(path_name),
                                     lspipe))
                              path_name[strlen(path_name)-1] = 0;
                            pclose(lspipe);
                        }
                        if (!is_regular_file(path_name))
                          path_name[0] = 0;
                      }
                  }
                }
            }
          }
          if (path_name[0])
            break;
      }
      if (path_name[0]) {
	printf("reading path: %s fCtdb sz: %d mem lmt: %d\n",path_name,sizeof(fCtdb),8*1024*1024);
        ctdb_read(path_name, &fCtdb, 5*1024*1024);
        *success = true;
      }
      else
      {
          printf("Cannot find terrain \"%s\"\n", name);
          ctdb_read(NULL, &fCtdb, 0);
          *success = false;
      }
    }
    else {
      ctdb_read(NULL, &fCtdb, 0);
      *success = false;
    }

    if (fCtdb.input_format /* 0 is nowhere */ &&
      (fCtdb.input_format < 3))
    {
      printf("\n\007\nWarning: This is an old-format CTDB terrain database which does not\n         contain all the information needed by ModSAF.\n         Go to the terrain database directory, and run the `mergedb' program\n         to generate a new-format CTDB terrain database.\n\007\n");
    }

//    Assert ( !coord_init("./data", 0), kerrCoordRead, "cTerrain::cTerrain");
//    gcs_init(coord_get_datum_info);
//if(gcs_init_cell(1234,(GCS_FLAT_EARTH*) NULL)!=1)
//	printf("error initializing gcs\n",);
//else
//	printf("cell id: %d\n",ctdb_get_cell_id(&fCtdb));
#endif

/*begin new code*/
lav[0] = av[0];
lav[1] = "-tdbpath";
lav[2] = dirName;
lav[3] = "-terrain";
lav[4] = terrainName;

*success = true;
wld_tdb_aggregate_options(&options, &sizeof_options, &map);
cmd_aggregate(&options,&sizeof_options,(CMD_OPTION *)&main_options,sizeof(main_options),&map);
cmd_process_aggregate_options(lac,lav,&leftover_argc,&leftover_argv,options,sizeof_options,map,FALSE);

wld_load_playbox(TRUE,TRUE,0,NULL,Datapath,NULL,NULL,&fpTcc,&fCtdb_ptr);

wld_get_playbox_center(cntr);
fCtdb =*((CTDB *)gcs_get_tdb((int32)cntr[CELL2D],FALSE));
wld_get_playbox_id(playboxname,&tdb_version);

/*end new code*/



/*    *curved = fCtdb.is_curved;*/

//printf("is_curved: %d, %d %d %d %c %d\n",\
	fCtdb.is_curved, COORD_GCC, COORD_UTM_NE, fCtdb.origin_northing, (char)(fCtdb.origin_zone_letter),fCtdb.datum);

    fpTcc  = coord_define_tcc(fCtdb.is_curved ? COORD_GCC : COORD_UTM_NE,
                        fCtdb.origin_northing,
                        fCtdb.origin_easting,
                        fCtdb.origin_zone_number,
/*coord_define_tcc requires origin_zone_letter be a char but CTDB furnishes it as an int32*/
                        (char)(fCtdb.origin_zone_letter),
                        fCtdb.datum,
                        fCtdb.max_x, fCtdb.max_y);
                 
/*
    if (main_options.routemap.value)
      *routemapp = routemap_create(ctdb, data_dir, READER_OVERRIDE);
    else
      *routemapp = NULL;

    strncpy(terrain_id->terrainName, fCtdb.name, maxTerrainNameLength);
    terrain_id->terrainName[maxTerrainNameLength-1] = '\0';
    terrain_id->terrainVersion = fCtdb.version;
*/
    ctdb_print_description(&fCtdb);
    cout << " ctdb box, x,y, min, max "
         << fCtdb.min_x << " "
         << fCtdb.max_x << " "
         << fCtdb.min_y << " "
         << fCtdb.max_y << endl;
         
}

cTerrain::~cTerrain()
{
}

double         cTerrain::GetMapElev( const double mapX, const double mapY )
{
   return ctdb_lookup_elevation(&fCtdb, mapX, mapY);
}

double         cTerrain::GetIntervis( const TLocation& loc1, double height1,
                               const TLocation& loc2, double height2,
                               double minvis, double treeOpac )
{
/*modified parameters to match modsaf3.0 libtactmap.h AUSTIN 4 Aug 97*/
   return ctdb_point_to_point( &fCtdb, loc1.x, loc1.y, loc1.z + height1,
                               loc2.x, loc2.y, loc2.z, loc2.z + height2,
                               0.0, NULL, &treeOpac, minvis, 0, NULL, 0, 0 );
}

void         cTerrain::GetMapRotationGeoPt( TRotation* pRot, const TLocation& geoLoc )
{
   TLocation mapIvec, mapJvec, mapKvec, mapOrigin;
   
   TLocation Ivec(geoLoc.x + 1.0, geoLoc.y,       geoLoc.z) ;
   TLocation Jvec(geoLoc.x,       geoLoc.y + 1.0, geoLoc.z) ;
   TLocation Kvec(geoLoc.x,       geoLoc.y,       geoLoc.z + 1.0) ;
   
   SimToMapLoc(geoLoc, &mapOrigin);
   SimToMapLoc(Ivec, &mapIvec);
   SimToMapLoc(Jvec, &mapJvec);
   SimToMapLoc(Kvec, &mapKvec);
   
   pRot->x.x = mapIvec.x - mapOrigin.x;
   pRot->y.x = mapIvec.y - mapOrigin.y;
   pRot->z.x = mapIvec.z - mapOrigin.z;
   
   pRot->x.y = mapJvec.x - mapOrigin.x;
   pRot->y.y = mapJvec.y - mapOrigin.y;
   pRot->z.y = mapJvec.z - mapOrigin.z;
   
   pRot->x.z = mapKvec.x - mapOrigin.x;
   pRot->y.z = mapKvec.y - mapOrigin.y;
   pRot->z.z = mapKvec.z - mapOrigin.z;

/*
   double matrix[3][3];
   int result  = coord_tcc_gcc_rotation(fpTcc, matrix);
   cout << "rotation matrix from ModSAF, result " << result << endl;
   
   cout << "             "<< matrix[0][0] << " " << matrix[0][1] << " " << matrix[0][2] << endl;
   cout << "             "<< matrix[1][0] << " " << matrix[1][1] << " " << matrix[1][2] << endl;
   cout << "             "<< matrix[2][0] << " " << matrix[2][1] << " " << matrix[2][2] << endl;
*/
}

void         cTerrain::GetMapRotationMapPt( TRotation* pRot, const TLocation& mapLoc )
{
   TLocation Ivec, Jvec, Kvec, Origin;
   
   TLocation mapIvec(mapLoc.x + 1.0, mapLoc.y,       mapLoc.z) ;
   TLocation mapJvec(mapLoc.x,       mapLoc.y + 1.0, mapLoc.z) ;
   TLocation mapKvec(mapLoc.x,       mapLoc.y,       mapLoc.z + 1.0) ;
   
   MapToSimLoc(mapLoc, &Origin);
   MapToSimLoc(mapIvec, &Ivec);
   MapToSimLoc(mapJvec, &Jvec);
   MapToSimLoc(mapKvec, &Kvec);
   
   pRot->x.x = Ivec.x - Origin.x;
   pRot->x.y = Ivec.y - Origin.y;
   pRot->x.z = Ivec.z - Origin.z;
   
   pRot->y.x = Jvec.x - Origin.x;
   pRot->y.y = Jvec.y - Origin.y;
   pRot->y.z = Jvec.z - Origin.z;
   
   pRot->z.x = Kvec.x - Origin.x;
   pRot->z.y = Kvec.y - Origin.y;
   pRot->z.z = Kvec.z - Origin.z;
}

void         cTerrain::MapToSimLoc( const TLocation& mapLoc, TLocation* pSimLoc )
{
   coord_convert(COORD_TCC, fpTcc, mapLoc.x, mapLoc.y, mapLoc.z, 
                 COORD_GCC, &(pSimLoc->x), &(pSimLoc->y), &(pSimLoc->z) );
}

void           cTerrain::SimToMapLoc( const TLocation& simLoc, TLocation* pMapLoc )
{
   coord_convert(COORD_GCC, simLoc.x, simLoc.y, simLoc.z, 
                 COORD_TCC, fpTcc, &(pMapLoc->x), &(pMapLoc->y), &(pMapLoc->z) );
}

void           cTerrain::SimToMapLoc( const TLocation& simLoc, double* pMapx, double* pMapy, double* pMapz )
{
   coord_convert(COORD_GCC, simLoc.x, simLoc.y, simLoc.z, 
                 COORD_TCC, fpTcc, pMapx, pMapy, pMapz );
}

int   cTerrain::MapToUtmLoc( const TLocation& mapLoc, int* pZone, 
                              double* pNorth, double* pEast, double* pZ )
{
   return coord_convert( COORD_TCC, fpTcc, mapLoc.x, mapLoc.y, mapLoc.z,
                         COORD_UTM_NE, pZone, pNorth, pEast, pZ);
}

int   cTerrain::GeoToUtmLoc( const TLocation& geoLoc, int* pZone, 
                              double* pNorth, double* pEast, double* pZ )
{
   return coord_convert( COORD_GCC, geoLoc.x, geoLoc.y, geoLoc.z,
                         COORD_UTM_NE, pZone, pNorth, pEast, pZ);
}

EBoolean       cTerrain::InTccArea( TLocation& tccLoc )
{
   if ( (tccLoc.x < fCtdb.min_x) ||
        (tccLoc.x > fCtdb.max_x) )
      return false;
   if ( (tccLoc.y < fCtdb.min_y) ||
        (tccLoc.y > fCtdb.max_y) )
      return false;
   return true;
}
