/*
$RCSfile: MfObject.cc,v $
$Revision: 1.4 $
$Author: ksnively $
$Date: 1999/04/29 19:34:17 $
$Log: MfObject.cc,v $
Revision 1.4  1999/04/29 19:34:17  ksnively
Incorporated ARDEC addtions:  Tripwire AP mines and a Control Window.

Revision 1.3  1999/04/22 22:20:02  ksnively
Sreamlined radio communication routines.  Allowed to send to unlimited number of receivers.

Revision 1.2  1999/03/26 21:17:40  ksnively

Added radio communication capability for Command Detonated Mines.  Included sending
and receiving transmitter and signal PDUs.  All signals have the option of being
processed by the Communication Effects Federate.

Revision 1.1.1.1  1999/02/16 14:54:38  jchappel
Comprehensive Mine Simulator

// Revision 2.10  1998/12/02  16:39:05  jchappel
// added gui detonator
//
// Revision 2.9  1998/11/25  18:37:51  ksnively
// Update for APLA Exercise
//
// Revision 2.8  1998/10/27  19:34:43  jchappel
// modifications for versioning
//
// Revision 2.7  1998/09/09  15:12:52  ksnively
// *** empty log message ***
//
// Revision 2.6  1998/06/03  17:25:10  jchappel
// made changes for dis204
//
// Revision 2.5  1998/04/20  15:10:36  ksnively
// *** empty log message ***
//
// Revision 2.4  1998/03/05  15:56:58  jchappel
// added icons and area click detonation
//
// Revision 2.3  1998/02/26  21:24:37  ksnively
// Created Mf Camera object to control MAK Stealth view.
// Created vulnerability tables specific to command detonated mines
// and the camera object.
//
// Revision 2.2  1998/02/18  20:10:01  ksnively
// Ap mine replacement bug fixes.
//
// Revision 2.1  1998/02/18  17:16:10  ksnively
// Incorporated AP mine replacement code.
//
// Revision 2.0  1998/01/26  21:01:35  ksnively
// Baseline CMS before additions for AP mine replacements.
//
// Revision 1.3  1998/01/08  13:04:51  ksnively
// Altered time routine to read time from clock cycles, faster than using gettimeofday.
//
// Revision 1.2  1997/12/17  14:38:03  ksnively
// Debugged Minefield duplication routine.
// Added input file "netparams" for reading PDU type enumerations.
// Got rid of warning messages during compilation.
//
// Revision 1.1  1997/12/16  13:59:57  ksnively
// Initial revision
//
// Revision 1.8  1997/10/02  17:51:30  austin
// first working port to modsaf3.0
//
// Revision 1.7  1997/10/02  17:48:55  austin
// first working port to modsaf3.0
//
// Revision 1.7  1997/10/02  17:48:55  austin
// first working port to modsaf3.0
//
// Revision 1.6  1997/05/07  19:09:06  ksnively
// *** empty log message ***
//
// Revision 1.5  1997/05/07  12:32:33  ksnively
// ..
//
// Revision 1.4  1997/03/20  19:14:41  ksnively
// added emission tracking, updated to CMS2.0B6
//
Revision 1.3  1997/01/21 15:08:14  nsipes
*** empty log message ***

// Revision 1.2  1997/01/02  19:48:54  nsipes
// *** empty log message ***
//
// Revision 1.1  1996/10/23  13:54:40  nsipes
// Initial revision
//
// Revision 1.22  1996/09/06  18:57:57  rcarp
// CP bug fixes
//
// Revision 1.21  1996/08/21  21:58:20  rcarp
// CP and QRP file output, other updates
//
// Revision 1.20  1996/08/08  18:10:09  rcarp
// gui updates and more CP changes
//
// Revision 1.19  1996/08/08  14:42:20  mkappel
// When mine type is set or changed, redraw display object.
//
// Revision 1.18  1996/08/07  14:19:30  rcarp
// initial revisions for CP protocol
//
// Revision 1.16  1996/07/03  22:55:15  rcarp
// enhancements and bug fixes for version 1.5b9
//
// Revision 1.15  1996/06/22  13:04:11  rcarp
// deton vuln bug fixes for 1.5b4
//
// Revision 1.14  1996/06/21  17:04:20  rcarp
// upgrades for release 1.5b3, mostly mine vuln
//
// Revision 1.13  1996/06/19  19:08:07  rcarp
// revisions for mine vulnerability, version 1.5b2
//
// Revision 1.12  1996/05/21  22:15:40  rcarp
// text and lists from mine db, and activating mine state save cmd
//
// Revision 1.11  1996/05/16  00:01:58  rcarp
// miscellaneous bugs
//
// Revision 1.10  1996/05/15  17:17:31  rcarp
// refinements and fixes for 1.5 delivery
//
// Revision 1.9  1996/05/15  00:11:09  rcarp
// mostly wam and offroute fixes, also deleting selection
//
// Revision 1.8  1996/05/14  16:15:08  rcarp
// refinements and bug fixes for 1.5 delivery
//
// Revision 1.6  1996/04/04  16:25:34  mkappel
// Improve performance with large mine sets.
//
// Revision 1.5  1996/03/23  14:26:12  rcarp
// improvements to test mode and selection
//
// Revision 1.4  1996/02/16  21:41:55  rcarp
// revisions for getting mine wide area and directional range
//
// Revision 1.3  1996/02/05  14:33:28  rcarp
// Updates and bug fixes of release version 1.1b5
//
$State: Exp $
*/
 
/*******************************************

   file: MfObject.cc
   
      Copyright 1995 by the Institute for Defense Analyses
      
         Institute for Defense Analyses
         1801 N. Beauregard Street
         Alexandria, Virginia 22311-1772
         703-845-2000
         
      This software was developed by IDA under U. S. Government
      contract.  For distribution information contact:
      
         U. S. Army Night Vision Directorate
         AMSEL RD NV OD CD
         10221 Burbeck Road, suite 430
         Ft. Belvoir VA 22060-5806
      
*********************************************/

/*******************************************

   MfObject.cc
   
      The minefield implementation.
      
      
   
   Created by Richard Carpenter
   Modification history:
      created   
      
*********************************************/

#include "Minefield.h"
#include "CmsControl.h"
#include "AtMine.h"
#include "ApMine.h"
#include "AtWideArea.h"
#include "FileObj.h"
#include "NetMgr.h"
#include "MapGeometry.h"
#include "Message.h"
#include "CmsPdu.h"
#include "McmPdu.h"
#include "DisPdu203.h"
#include "AnalData.h"
#include "Vulnerability.h"
#include "SaSensor.h"
#include "MfCamera.h"
#include "Communication.h"

//#include "Sensor.h"

#include <mun_type.h>
#include <dis203_values.h>
#include <dis204_values.h>
#include <iostream.h>
#include <stdlib.h>
#include <math.h>

const TKeyValuePair TFuzeParam::fpFuzeTextType[eNumFuzeTypes] = {
	"Other",              efzOther,
	"Pressure",           efzPressure,
	"Tiltrod",            efzTiltrod,
	"Magnetic",           efzProxMag,
	"AcousticTopAttack",  efzAcoustic,
	"AcousticSideAttack", efzAcoustic,
	"TopAttackSublet",    efzProximity,
   
	"ApPressure",         efzPressure,
	"ApTripWire",         efzProximity,

	"CommandFire",        efzCommandFire,
	"CommandLoc",         efzCommandLoc,
	"CommandFireDir",     efzCommandFireDir,
	"CommandTripFire",    efzCommandTripFire,
   
	"CmdCamera",          esensCommandCamDir,
	"AutoCamera",         esensAutoCmdCamDir,
   
	"PeopleDet",          esensPeoDet,
	"VehicleDet",         esensVehDet,
	"PersOrVehDet",       esensPeoVehDet,
	"TripWireDet",        esensTripWire,
        "DirDet",             esensDirDet,
	"PeopleTrk",          esensPeoTrk,
	"VehicleTrk",         esensVehTrk,
	"PersOrVehTrk",       esensPeoVehTrk,
        "DirPersOrVehTrk",    esensDirPVTrk,
	"DirSens",            esensDirSmart,
   
	"AutoControl",        econAuto,
	"RelayControl",       econRelay
   
};

const   TTimeSim   cSimMine::fsUpdateRate       = 1000;      // milliiseconds
const   TTimeSim   cSimMine::fsFastUpdateRate   = 100;      // milliiseconds
        TTimeSim   cSimMine::fsDamageCheckDelay = 500;      // milliiseconds

char*   cMine::fsStateText[emisNumStates] = {
   "None",
   "MissedTarget",
   "HitTarget",
   "Detonated",
   "Failed",
   "Moving",
   "Off",
   "Inhibited",
   "On",
   "Tracking",
   "Activating",
   "CloseTracking"
};

   // arbitrary SIMNET types for indices into our icons
unsigned long   cMine::simObjType[esymNum] = {
   munition_US_M15,               // planning/not simulated AT
   munition_US_M16A2,             // planning/not simulated AP
   munition_US_M75,               // planning/not simulated directional
   munition_US_M67,               // planning/not simulated camera
   munition_US_M70,               // planning/not simulated sensor
   munition_GERMAN_AT2,           // AT
   munition_US_M14,               // AP
   munition_US_M18A1,             // directional
   munition_US_M19,               // false detect mine
   munition_US_M21,               // minefield camera 
   munition_US_BLU91B             // sensor
};   // used as keys to find drawing icons

// ************************************
//   miscellany
// ************************************
void    TFuzeOptionSelector::GetDestTimeOpt( int* num, float** list)
{
   float* pList = new float[fNumDestTimeOpt];
   for ( int i = 0; i <  fNumDestTimeOpt; i++ )
      pList[i] = fpDestTimeOpt[i];

   *num = fNumDestTimeOpt;
   *list = pList;
}

void     TFuzeOptionSelector::SetSelfDestOpts( TItemList* pList )
{
   if ( fpDestTimeOpt )
      delete[] fpDestTimeOpt;
      
   fpDestTimeOpt = new float[ pList->count];
   for ( int i = 0; i <  pList->count; i++ )
      fpDestTimeOpt[i] = ( (float*)(pList->ptrItems) ) [i];
   fNumDestTimeOpt = pList->count;
}

void     TFuzeOptionSelector::SetTgtCntOpt( EYesNoOpt opt )
{
   switch (opt) {
      case eNo:
            fbTgtCountOpt = false;
         break;
   
      case eYes:
      case eBoth:
            fbTgtCountOpt = true;
         break;
   }
}

void     TFuzeOptionSelector::SetAntihanOpt( EYesNoOpt opt )
{
   fAntihandlingOpt = opt;
}

void     TFuzeOptionSelector::SetBlastHardOpt( EYesNoOpt opt )
{
   fBlasthardOpt = opt;
}

TFuzeOptionSelector* TFuzeOptionSelector::CloneFuzeOptionSelector(TFuzeParam* pFuzeSet)
{
   TFuzeOptionSelector* pClone = new TFuzeOptionSelector(pFuzeSet);
   
   pClone->fbTgtCountOpt = fbTgtCountOpt;
   pClone->fAntihandlingOpt = fAntihandlingOpt;
   pClone->fBlasthardOpt = fBlasthardOpt;
   
   pClone->fNumDestTimeOpt = fNumDestTimeOpt;
   pClone->fpDestTimeOpt = new float[fNumDestTimeOpt];
   for ( int i = 0; i < fNumDestTimeOpt; i++ )
      pClone->fpDestTimeOpt[i] = fpDestTimeOpt[i];
      
   return pClone;
}

TFuzeOptionSelector::TFuzeOptionSelector(TFuzeParam* pFuzeParam)
{
   fpFuzeSet = pFuzeParam;
   
   fNumDestTimeOpt  = 0;
   fpDestTimeOpt    = NULL;
   fbTgtCountOpt    = false;
   fAntihandlingOpt = eNo;
   fBlasthardOpt    = eNo;
}

TFuzeOptionSelector::~TFuzeOptionSelector()
{
}

TFuzeParam*   TFuzeParam::CloneFuzeParam()   
{
   TFuzeParam* pClone = new TFuzeParam(*this);
   pClone->fpOptSelector = fpOptSelector->CloneFuzeOptionSelector(pClone);
   
   return pClone;
}

TFuzeParam*   TFuzeParamOffRoute::CloneFuzeParam()   
{
   TFuzeParam* pClone = new TFuzeParamOffRoute(*this);
   pClone->fpOptSelector = fpOptSelector->CloneFuzeOptionSelector(pClone);
   
   return pClone;
}

TFuzeParam*   TFuzeParamWamSublet::CloneFuzeParam()   
{
   TFuzeParam* pClone = new TFuzeParamWamSublet(*this);
   pClone->fpOptSelector = fpOptSelector->CloneFuzeOptionSelector(pClone);
   
   return pClone;
}

TFuzeParam*   TFuzeParamWideArea::CloneFuzeParam()   
{
   TFuzeParam* pClone = new TFuzeParamWideArea(*this);
   pClone->fpOptSelector = fpOptSelector->CloneFuzeOptionSelector(pClone);
   
   return pClone;
}

/*cSensor* TFuzeParam::CreateSensor(cEntity* pMine, const TFuzeOpt& fuzeOpt , float radius)
{
   //cout << "TFuzeParam::CreateSensor()" << endl;
   cSensor* pNewSensor = NULL;
   
   pNewSensor = new cSensor(pMine, fTrackRange + radius);

   return pNewSensor;
}
*/

cSensor* TFuzeParam::CreateSensor(cEntity* pMine, const TFuzeOpt& /*fuzeOpt */, float radius)
{
   //cout << "TFuzeParam::CreateSensor()" << endl;
   cSensor* pNewSensor = NULL;
   
   switch (fTypeNameIndex) {
      case efuzetypeOther:		// used for false alarms
            pNewSensor = new cSensor(pMine, fTrackRange + radius);
         break;
  
      case efuzetypeMagnetic:	  
            pNewSensor = new cSensor(pMine, fTrackRange + radius);
         break;
   
      case efuzetypeAcousticTracker:
            pNewSensor = new cSensor(pMine, fTrackRange + radius);
         break;
   
      case efuzetypeAcousticTrigger:
            pNewSensor = new cSensor(pMine, fTrackRange + radius, false);
         break;
   
      case efuzetypeTopSublet:
            pNewSensor = new cSensor(pMine, fTrackRange + radius, false);
         break;
   
     // default:
     //       Assert( false, kerrValidityCheck, "TFuzeParam::CreateSensor");
   }
   
   return pNewSensor;
}

/*
cEmissVuln* TFuzeParam::CreateEmissVuln(cEntity* pMine)
{
   //cout << "TFuzeParam::CreateSensor()" << endl;
   cEmissVuln* pNewEmissVuln = NULL;
   
   switch (fTypeNameIndex) {
      case efuzetypeOther:		// used for false alarms
      case efuzetypeMagnetic:	  
      case efuzetypeAcousticTracker:
      case efuzetypeAcousticTrigger:
      	  pNewEmissVuln = new cEmissVuln( pMine);
     // default:
     //       Assert( false, kerrValidityCheck, "TFuzeParam::CreateEmissVuln");
   }

   return pNewEmissVuln;
}
*/

cTracker*     TFuzeParam::CreateTracker( cEntity* pMine, const TFuzeOpt& /* fuzeOpt */, float radius )
{
   cTracker* pNewTracker = NULL;

   switch (fTypeNameIndex) {
      case efuzetypeOther:		// used for false alarms
      case efuzetypeCommandLoc:
      case efuzetypeCommandFire:
            pNewTracker = new cTracker(pMine, fTrackRange + radius);
         break;
  
      case efuzetypeCommandFireDir:      // uses mine coord system
      case esenstypeCommandCamDir:
      case esenstypeAutoCmdCamDir:
            pNewTracker = new cTracker(pMine, fTrackRange + radius, false);
         break;
   
      case efuzetypePressure:
      case efuzetypeTiltrod:
      case efuzetypeMagnetic:
            pNewTracker = new cLandTracker(pMine, fTrackRange + radius);
         break;
   
      case efuzetypeAcousticTracker:
            pNewTracker = new cWideAreaTracker(pMine, fTrackRange + radius);
         break;
   
      case efuzetypeAcousticTrigger:
            pNewTracker = new cOffRouteTracker(pMine, fTrackRange + radius, false);
         break;
   
      case efuzetypeTopSublet:
            pNewTracker = new cSubletTracker(pMine, fTrackRange + radius, false);
         break;
   
      case efuzetypeApPressure:
      case efuzetypeApTrip:
            pNewTracker = new cLandTracker(pMine, fTrackRange + radius, true, true, true);
         break;
   
      case efuzetypeTripCommandFire:
            pNewTracker = new cTripWireTracker(pMine, fTrackRange + radius, false, true, true);
         break;
   
      case esenstypeVehDet:
            pNewTracker = new cLandTracker(pMine, fTrackRange + radius);
         break;

      case esenstypePerDet:
            pNewTracker = new cLandTracker(pMine, fTrackRange + radius, true, false, true);
         break;

      case esenstypePerVehDet:
      case esenstypeTripWire:
      case esenstypeDirDet:
            pNewTracker = new cLandTracker(pMine, fTrackRange + radius, true, true, true);
         break;

      case esenstypePerTrack:
            pNewTracker = new cSensTrkTracker(pMine, fTrackRange + radius, true, false, true);
         break;

      case esenstypeVehTrack:
            pNewTracker = new cSensTrkTracker(pMine, fTrackRange + radius, true, true, false);
         break;

      case esenstypePerVehTrack:
      case esenstypeDirPVTrack:
      case esenstypeDirTrack:
            pNewTracker = new cSensTrkTracker(pMine, fTrackRange + radius, true, true, true);
         break;
         
      default:
            Assert( false, kerrValidityCheck, "TFuzeParam::CreateTracker");
   }
   
   return pNewTracker;
}

cControl*     TFuzeParam::CreateControl(cSimMine* pMine, const TFuzeOpt& fuzeOpt )
{
   cControl* pNewControl = NULL;
   
   switch (fTypeNameIndex) {
      case efuzetypeOther:		// used for false alarms
            pNewControl = new cMineControl(pMine, fFireOffset, fuzeOpt);
         break;
   
      case efuzetypeTiltrod:
      case efuzetypeMagnetic:
            pNewControl = new cFullWidthControl(pMine, fFireOffset, fuzeOpt);
         break;
   
      case efuzetypePressure:
            pNewControl = new cTrWidthControl(pMine, fFireOffset, fuzeOpt);
         break;
   
      case efuzetypeApPressure:
      case efuzetypeApTrip:
            pNewControl = new cFullWidthControl(pMine, fFireOffset, fuzeOpt);
         break;
         
      default:
         Assert( false, kerrValidityCheck, "TFuzeParam::CreateControl");
   }
   
   return pNewControl;
}

void TFuzeParam::InitVulnTables (int type)
{
	fVulnMechParam.InitVulnMechParam(type);
	fVulnDetList.InitDetVulnList(type);
	fBhVulnDetList.InitDetVulnList(type,  true);
 
}
 
TFuzeParam::TFuzeParam(int type) 
{

   if (type != -1)  InitVulnTables(type);
   
   fTypeNameIndex = type;
   fFuze          = (EFuze) (fpFuzeTextType[type].value);
      //   fFireOffset has constructor, sets to 0,0
   fProbDud          = 0.0;       // startup in failed state
   fProbDeton        = 1.0;     // given  good encounter
   fArmTimeHrs       = 0.0;       // += cur time when sim start
   fProbEmplaceDet   = 0.0;       // += cur time when sim start
   fTimeEmplaceDet   = 0.1;       // += cur time when sim start
   fTrackRange       = 30.0;
   fDetonResult      = edetEntityProximate;
   
   fpOptSelector = new TFuzeOptionSelector(this);
}

TFuzeParam::~TFuzeParam()
{
   if (fpOptSelector)
      delete fpOptSelector;
}

// ************************************
//   messages
// ************************************

void    cCheckVehDamageMsg::SendMsg()
{
   fpMine->CheckVehDamage(fpVehicle);
}

cCheckVehDamageMsg::cCheckVehDamageMsg(cSimMine* pMine, TTimeSim wait, cVehicle* pVeh) :   
         cMsgLowRateUpdt(wait)
{
   fpMine = pMine;
   fpVehicle = pVeh;
}

cCheckVehDamageMsg::~cCheckVehDamageMsg()
{} 

void    cMineDetonationMsg::SendMsg()
{
//   cout<<"sending mine detonation message"<<endl;
   gpNetMgr->GetPduTrans()->SendMineDetonation(fpDetData);
   
   if ( gbGui && fbDrawExp ) {
      TLocation detLoc;
      gpTerrainMgr->SimToMapLoc( fpDetData.fDetLocation, &detLoc);
      new cMineExplosion( detLoc, fpDetData.fFireTccLocation, 
                          fBlastSize, fDelay );
   }
}

cMineDetonationMsg::cMineDetonationMsg(TDetonationData& detData, 
                           float blastSize, TTimeSim delay, EBoolean bDrawExp ) :
            fpDetData(detData)
{
   fBlastSize = blastSize;
   fDelay = delay;
   fbDrawExp = bDrawExp;
} 

cMineDetonationMsg::~cMineDetonationMsg()
{} 

void    cUpdateMineMsg::SendMsg()
{
   fpMine->UpdateMine();
}

cUpdateMineMsg::~cUpdateMineMsg()
{} 

void    cUpdateMinePrMsg::SendMsg()
{
   fpMine->UpdateMine();
}

cUpdateMinePrMsg::~cUpdateMinePrMsg()
{} 


// ************************************
//   mine parts
// ************************************
float    cTracker::GetSensRange()
{
   return fRange;
}

int    cTracker::GetTrackType(const TEntityType& type)
{
   if ( (type.kind == ekindPlatform) || (type.kind == ekindLifeform) )
      return cMine::etrkYes;
   else
      return cMine::etrkNot;
}

EBoolean    cTracker::IsInRange(const TEntityType& type, double range)
{
   if ( (range <= fRange) && (GetTrackType(type)) )
      return true;
   else
      return false;
}




void        cTracker::UpdateTracker(cVehListHead& proxList, 
            cVehListHead* pTrkList, TEntCoord entLoc)
     // prox list may have tgt loc referenced to different point than
     // the tracker (e.g., minefield ref rather than mine ref,
     // or projectile launch point rather than current location)
     //  Thus the tracker mine/owner must provide its location in the coord
     // system used in the prox list.
{
   cLinkVehLoc*      pProxLink;
   cLinkVehGeom*     pOldTrkLink;
   cLinkVehGeom*     pTrkLink;
   double             range;
   cVehListHead       oldTrkList(pTrkList);

   for (pProxLink  = (cLinkVehLoc*)(proxList.GetFirstLink());
        pProxLink != (cLinkVehLoc*)(proxList.GetNULLLink());
        pProxLink  = (cLinkVehLoc*)(proxList.GetNextLink()) ) {

      range = entLoc.HorzDistance( pProxLink->GetLocation() );
      if ( IsInRange(pProxLink->GetEntityType(), range)  ) {
         if ( oldTrkList.IsInList(pProxLink->GetVehicle(), (cLinkVeh**)&pOldTrkLink) )
            pTrkLink = CreateCopyTrack(pOldTrkLink, (cLinkVeh*)(pTrkList->GetLastLink()));
         else {
            pTrkLink = CreateNewTrack(pProxLink, (cLinkVeh*)(pTrkList->GetLastLink()));
/*
               // possible analyst's output
            if ( gfInteract ) {
               pTrkLink->SetInteraction( fpRefEnt->CreateNewInteraction(pTrkLink) );
            }
*/
         }
         pTrkLink->UpdateTrkRec();
/*
         if ( pTrkLink->GetInteraction() )
            pTrkLink->GetInteraction()->UpdateInteraction(pTrkLink);
*/
      }
   }
   
      // delete old track list
   oldTrkList.DeleteList();
}

cLinkVehGeom*  cTracker::CreateNewTrack(cLinkVehLoc* pProxLink, cLinkVeh* pPrev)
{
   return new cLinkVehGeom(pProxLink, pPrev, fpRefEnt, fbUseVehCoord);
}

cLinkVehGeom*  cTracker::CreateCopyTrack(cLinkVehGeom* pOldTrkLink, cLinkVeh* pPrev)
{
   return new cLinkVehGeom(pOldTrkLink, pPrev);
}

cTracker::~cTracker()
{ }

void    cMechanVuln::PlowMine(cLinkVehGeom* pVehLink, const T2Dsingle& plowOffset)
{
   TEntCoord newLoc = pVehLink->GetLocation();
   float delY = 0.0;
   const TVehDimensions& vehDim = pVehLink->GetVehicle()->GetDimensions();
   
   if  ( (fPlowIntState == episPlowing) ||
         (fPlowIntState == episPlowingRB)) {
//      printf ("X location = %f\n", newLoc.x);
      newLoc.x = - (vehDim.length / 2.0 + plowOffset.x);
//      printf ("new X location = %f\n", newLoc.x);
//      delY = pVehLink->GetVelocity().x * fpMine->GetUpdateRate() * kSimTimeToSec / 2.0;  // don't know why this done
//      delY = (vehDim.width / 2.0 - fabs(newLoc.y)) + plowOffset.y + 1.00;

//      if ( delY > (vehDim.width / 2.0 - fabs(newLoc.y) + plowOffset.y)) {
         delY = vehDim.width / 2.0 - fabs(newLoc.y) + plowOffset.y;
//	printf("Plow Offset = %f\n", plowOffset.y);
         if (fPlowIntState == episPlowing) 
            fPlowIntState = episAstride;
         else
            fPlowIntState = episAstrideRB;
//      }
   }
   else if ( (fPlowIntState == episAstride) ||
             (fPlowIntState == episAstrideRB) ) {
      if (newLoc.x > vehDim.length / 2.0) {  // we're now behind vehicle
         delY = UniformRand() * ( vehDim.trackYmax - vehDim.trackYmin );
//   printf ("delY = %f\n", delY);
         if (fPlowIntState == episAstrideRB)   // rollback
            delY *= -1.0;
         fPlowIntState = episBehind;
         fpMine->StateChange(fMineSavedState);
         fpMine->SetChangeIndicator();
      }
   }
   
//   printf ("delY = %f\n", delY);
//   printf ("Y location = %f\n", newLoc.y);
   if ( newLoc.y > 0.0 )
      newLoc.y += delY;
   else
      newLoc.y -= delY;
      
//   printf ("new Y location = %f\n", newLoc.y);
      // translate back to geo coords.  Note veh loc may not be dead reckoned,
      // must do this ourselves
   T3Dsingle locLoc( -newLoc.x, -newLoc.y, 0.0);
   TLocation vehGeoLoc = pVehLink->GetVehicle()->GetDrGeoLoc(GetCurSimTime());
   TLocation locGeoOffset = pVehLink->GetVehicle()->GetGeoRot() | locLoc;
   TLocation geoLoc = locGeoOffset + vehGeoLoc;
//   pVehLink->GetVehicle()->LocalToGeoLoc( locLoc, &geoLoc );

   fpMine->SetCoordGeoRef( geoLoc, fpMine->GetGeoOrient() );
}

void    cMechanVuln::ProcessFullPlow(cLinkVehGeom* pVehLink, TTimeSim* /* pWaitTime */)
{
   cVehicle* pVeh = pVehLink->GetVehicle();
   EVulnResult eResult;
   TVehPart*  pPart;
   
   if ( pPart = pVeh->GetPartByType(ePrtFullPlow) ) {
      if ( fpMine->GetInternalState() == emisMoving ) {
//         *pWaitTime = fpMine->GetFastUpdateRate();
         PlowMine(pVehLink, fMechVulnTables.fpFwmPTable->GetTableOffset());
      }
      else if ( pVehLink->GetFullPlowResult() == eprNotEngaged ) {
         if ( fMechVulnTables.fpFwmPTable->IsVehicleEncounter(pVehLink->GetLocation(), 
                              pVehLink->GetVehicle()->GetDimensions()) ) {
            eResult = fMechVulnTables.fpFwmPTable->
                  GetRandomResult( fpMine->GetDepth() - pPart->GetDepth(),  pVeh->GetPartExtension(ePrtFullPlow));
//	    printf("Fwmp effectiveness = %f, Result = %d\n",  pVeh->GetPartExtension(ePrtFullPlow), (int)eResult );
            switch (eResult) {
               case evrNone:
                     pVehLink->SetFullPlowResult(eprNoEffect);
                  break;
            
               case evrDet:
                     if ( fpMine->GetInternalState() >= emisOn ) {
                        pVehLink->SetFullPlowResult(eprDetonated);
                        fpMine->SetDetonationResults(pVehLink, pPart, true); //sets state and interact result
                        new cMineDetonationMsg(fpMine->GetDetonationData());
                     }
                  break;
            
               case evrNeut:
                     pVehLink->SetFullPlowResult(eprNeutralized);
                     fpMine->StateChange(emisFailed);
                     pVehLink->SetInteractResult(eMineNeutralized);
                  break;
            
               case evrDisplace:
                     fMineSavedState = fpMine->GetInternalState();
                     fPlowIntState = episPlowing;
                     fpMine->StateChange(emisMoving);
                     pVehLink->SetInteractResult(eMineDisplaced);
                     pVehLink->SetFullPlowResult(eprDisplaced);
//                     *pWaitTime = fpMine->GetFastUpdateRate();
                     PlowMine(pVehLink, fMechVulnTables.fpFwmPTable->GetTableOffset());
                  break;
            
               case evrRollback:
                     fMineSavedState = fpMine->GetInternalState();
                     fPlowIntState = episPlowingRB;
                     fpMine->StateChange(emisMoving);
                     pVehLink->SetFullPlowResult(eprRollback);
                     pVehLink->SetInteractResult(eMineRollback);
//                     *pWaitTime = fpMine->GetFastUpdateRate();
                     PlowMine(pVehLink, fMechVulnTables.fpFwmPTable->GetTableOffset());
                  break;
                  
               default:
                     pVehLink->SetFullPlowResult(eprNoEffect);
                  break;
            }
         }
      }
   }
}

void    cMechanVuln::ProcessTrackPlow(cLinkVehGeom* pVehLink, TTimeSim* /* pWaitTime */)
{
   cVehicle* pVeh = pVehLink->GetVehicle();
   EVulnResult eResult;
   TVehPart*  pPart;
   
   if ( pPart = pVeh->GetPartByType(ePrtTrackPlow) ) {
      if ( fpMine->GetInternalState() == emisMoving ) {
//         *pWaitTime = fpMine->GetFastUpdateRate();
         PlowMine(pVehLink, fMechVulnTables.fpTwmPTable->GetTableOffset());
      }
      else if ( pVehLink->GetTrackPlowResult() == eprNotEngaged ) {
         if ( fMechVulnTables.fpTwmPTable->IsTrackEncounter(pVehLink->GetLocation(), 
                              pVehLink->GetVehicle()->GetDimensions()) ) {
            eResult = fMechVulnTables.fpTwmPTable->
                  GetRandomResult( fpMine->GetDepth() - pPart->GetDepth(), pVeh->GetPartExtension(ePrtTrackPlow) );
//	    printf("Twmp effectiveness = %f\n",  pVeh->GetPartExtension(ePrtTrackPlow));

            switch (eResult) {
               case evrNone:
                     pVehLink->SetTrackPlowResult(eprNoEffect);
                  break;
            
               case evrDet:
                     if ( fpMine->GetInternalState() >= emisOn ) {
                        pVehLink->SetTrackPlowResult(eprDetonated);
                        fpMine->SetDetonationResults(pVehLink, pPart, true); //sets state and interact result
                        new cMineDetonationMsg(fpMine->GetDetonationData());
                     }
                  break;
            
               case evrNeut:
                     pVehLink->SetTrackPlowResult(eprNeutralized);
                     fpMine->StateChange(emisFailed);
                     pVehLink->SetInteractResult(eMineNeutralized);
                  break;
            
               case evrDisplace:
                     fMineSavedState = fpMine->GetInternalState();
                     fPlowIntState = episPlowing;
                     fpMine->StateChange(emisMoving);
                     pVehLink->SetInteractResult(eMineDisplaced);
                     pVehLink->SetTrackPlowResult(eprDisplaced);
//                     *pWaitTime = fpMine->GetFastUpdateRate();
                     PlowMine(pVehLink, fMechVulnTables.fpTwmPTable->GetTableOffset());
                  break;
            
               case evrRollback:
                     fMineSavedState = fpMine->GetInternalState();
                     fPlowIntState = episPlowingRB;
                     fpMine->StateChange(emisMoving);
                     pVehLink->SetTrackPlowResult(eprRollback);
                     pVehLink->SetInteractResult(eMineRollback);
//                     *pWaitTime = fpMine->GetFastUpdateRate();
                     PlowMine(pVehLink, fMechVulnTables.fpTwmPTable->GetTableOffset());
                  break;
                  
               default:
                     pVehLink->SetTrackPlowResult(eprNoEffect);
                  break;
            }
         }
      }
   }
}

void    cMechanVuln::ProcessFullRake(cLinkVehGeom* pVehLink, TTimeSim* /* pWaitTime */)
{
   cVehicle* pVeh = pVehLink->GetVehicle();
   EVulnResult eResult;
   TVehPart*  pPart;
   
   if (pPart = pVeh->GetPartByType(ePrtFullRake) ) {
      if ( pVehLink->GetFullRakeResult() == eprNotEngaged ) {
         if ( fMechVulnTables.fpFwmRTable->IsVehicleEncounter(pVehLink->GetLocation(), 
                              pVehLink->GetVehicle()->GetDimensions()) ) {
            eResult = fMechVulnTables.fpFwmRTable->GetRandomResult(fpMine->GetDepth(), pVeh->GetPartExtension(ePrtFullRake) );
//	    printf("Fwmr effectiveness = %f\n",  pVeh->GetPartExtension(ePrtFullRake));

            switch (eResult) {
               case evrNone:
                     pVehLink->SetFullRakeResult(eprNoEffect);
                  break;
            
               case evrDet:
                     if ( fpMine->GetInternalState() >= emisOn ) {
                        pVehLink->SetFullRakeResult(eprDetonated);
                        fpMine->SetDetonationResults(pVehLink, pPart, true); //sets state and interact result
                        new cMineDetonationMsg(fpMine->GetDetonationData());
                     }
                  break;
            
               case evrNeut:
                     pVehLink->SetFullRakeResult(eprNeutralized);
                     fpMine->StateChange(emisFailed);
                     pVehLink->SetInteractResult(eMineNeutralized);
                  break;
                  
               default:
                     pVehLink->SetFullRakeResult(eprNoEffect);
                  break;
            }
         }
      }
   }
}

void    cMechanVuln::ProcessTrackRoller(cLinkVehGeom* pVehLink, TTimeSim* /* pWaitTime */)
{
   cVehicle* pVeh = pVehLink->GetVehicle();
   EVulnResult eResult;
   TVehPart*  pPart;
   
   if ( pPart = pVeh->GetPartByType(ePrtTrackRoller) ) {
      if ( pVehLink->GetTrackRollerResult() == eprNotEngaged ) {
         if ( fMechVulnTables.fpTwmRTable->IsTrackEncounter(pVehLink->GetLocation(), 
                              pVehLink->GetVehicle()->GetDimensions()) ) {
            eResult = fMechVulnTables.fpTwmRTable->GetRandomResult(fpMine->GetDepth(), pVeh->GetPartExtension(ePrtTrackRoller) );
//	    printf("Twmr effectiveness = %f\n",  pVeh->GetPartExtension(ePrtTrackRoller));
            switch (eResult) {
               case evrNone:
                     pVehLink->SetTrackRollerResult(eprNoEffect);
                  break;
            
               case evrDet:
                     if ( fpMine->GetInternalState() >= emisOn ) {
                        pVehLink->SetTrackRollerResult(eprDetonated);
                        fpMine->SetDetonationResults(pVehLink, pPart, true); //sets state and interact result
                        new cMineDetonationMsg(fpMine->GetDetonationData());
                     }
                  break;
            
               case evrNeut:
                     pVehLink->SetTrackRollerResult(eprNeutralized);
                     fpMine->StateChange(emisFailed);
                     pVehLink->SetInteractResult(eMineNeutralized);
                  break;
                  
               default:
                     pVehLink->SetTrackRollerResult(eprNoEffect);
                  break;
            }
         }
      }
   }
}

void    cMechanVuln::ProcessDogbone(cLinkVehGeom* pVehLink, TTimeSim* /* pWaitTime */)
{
   cVehicle* pVeh = pVehLink->GetVehicle();
   EVulnResult eResult;
   TVehPart*  pPart;
   
   if ( pPart = pVeh->GetPartByType(ePrtDogbone) ) {
      if ( pVehLink->GetDbResult() == eprNotEngaged ) {
         if ( fMechVulnTables.fpTwmrDbTable->IsBellyEncounter(pVehLink->GetLocation(), 
                              pVehLink->GetVehicle()->GetDimensions()) ) {
            eResult = fMechVulnTables.fpTwmrDbTable->GetRandomResult(fpMine->GetDepth(), pVeh->GetPartExtension(ePrtDogbone) );
//	    printf("DB effectiveness = %f\n",  pVeh->GetPartExtension(ePrtDogbone));
            switch (eResult) {
               case evrNone:
                     pVehLink->SetDbResult(eprNoEffect);
                  break;
            
               case evrDet:
                     if ( fpMine->GetInternalState() >= emisOn ) {
                        pVehLink->SetDbResult(eprDetonated);
                        fpMine->SetDetonationResults(pVehLink, pPart, true); //sets state and interact result
                        new cMineDetonationMsg(fpMine->GetDetonationData());
                     }
                  break;
            
               case evrNeut:
                     pVehLink->SetDbResult(eprNeutralized);
                     fpMine->StateChange(emisFailed);
                     pVehLink->SetInteractResult(eMineNeutralized);
                  break;
                  
               default:
                     pVehLink->SetDbResult(eprNoEffect);
                  break;
            }
         }
      }
   }
}

void    cMechanVuln::ProcessMagCm(cMineLinkEmiss* pEmLink, TTimeSim* /* pWaitTime */)
{
   cEmission* pEm = pEmLink->GetEmission();
   EVulnResult eResult;
   float effectiveness;
   
   if ( pEm->GetEmitterName() == DIS203_EMITTER_SYSTEM_MMCM || 
	pEm->GetEmitterName() == DIS203_EMITTER_SYSTEM_OTHER ) {
      if ( pEmLink->GetMagCmResult() == eprNotEngaged ) {
//         if ( fMechVulnTables.fpMagCmTable->IsVehicleEncounter(pVehLink->GetLocation(), 
//                              pVehLink->GetVehicle()->GetDimensions()) ) {
	    effectiveness = (pEm->GetERP() > 1.00) ? 1.00 : pEm->GetERP();
            eResult = fMechVulnTables.fpMagCmTable->GetRandomResult(fpMine->GetDepth(), effectiveness );
//	    printf("Mmcm effectiveness = %f\n",  effectiveness);
            switch (eResult) {
               case evrNone:
                     pEmLink->SetMagCmResult(eprNoEffect);
		     if ( fpMine->GetInternalState() > emisOn ) 
			fpMine->StateChange(emisOn);
		 break;
            
               case evrDet:
                     if ( fpMine->GetInternalState() >= emisOn ) {
                        pEmLink->SetMagCmResult(eprDetonated);
                        fpMine->SetDetonationResults(pEmLink); //sets state and interact result
                        new cMineDetonationMsg(fpMine->GetDetonationData());
                     }
                  break;
            
               case evrNeut:
                     pEmLink->SetMagCmResult(eprNeutralized);
                     fpMine->StateChange(emisFailed);
//                     pEm->GetVehicle()->SetInteractResult(eMineNeutralized);
                  break;
                  
               default:
                     pEmLink->SetMagCmResult(eprNoEffect);
		     if ( fpMine->GetInternalState() > emisOn ) 
			fpMine->StateChange(emisOn);
                  break;
            }
      }   
      
   }
}

void    cMechanVuln::UpdateMechVuln(cVehListHead* pVehList, TTimeSim* pWaitTime)
{
   for ( cLinkVehGeom* pVehLink = (cLinkVehGeom*)(pVehList->GetFirstLink());
                       pVehLink != (cLinkVehGeom*)(pVehList->GetNULLLink());
                       pVehLink = (cLinkVehGeom*)(pVehList->GetNextLink()) ) {
      if ( pVehLink->HasCmPart() ) {
         ProcessFullPlow(pVehLink, pWaitTime);
         ProcessTrackPlow(pVehLink, pWaitTime);
         ProcessFullRake(pVehLink, pWaitTime);
         ProcessTrackRoller(pVehLink, pWaitTime);
         ProcessDogbone(pVehLink, pWaitTime);
//         ProcessMagCm(pVehLink, pWaitTime);
      }
   }
}

cMechanVuln::~cMechanVuln()
{ }

void   cControl::UpdateControl(cVehListHead*, cEmissListHead*, TTimeSim*)
{ }

cControl::~cControl()
{ }


void    cMineControl::UpdateControl(cVehListHead* pVehList, cEmissListHead* pEmissList, TTimeSim* pWaitTime)
        // Default checks closest vehicle, calls virtual Geometry fns to engage
        //   It assumes that tracker has produced track in vehicle oriented
        // coord system.
        //  Horizontal range is used
{  
   cLinkVehGeom* pLink = NULL;
   cMineLinkEmiss*   pEmLink = NULL;
   TAttackGeom   attGeom;
   EMineInternalState state = fpMine->GetInternalState();
   
   float range = FLT_MAX;
   float erange = FLT_MAX;
   
      // default does nothing on state emisInhibit
   if ( state >= emisOn ) {
      
      
         // find the link for closest veh in track list
      for (T2link* pLn  = pVehList->GetFirstLink();
                   pLn != pVehList->GetNULLLink();
                   pLn  = pVehList->GetNextLink() ) {
         if ( ((cLinkVehGeom*)pLn)->GetHorzRange() < range ) {
            pLink = (cLinkVehGeom*)pLn;
            range = pLink->GetHorzRange();
         }
      }


      for (	   pLn  = pEmissList->GetFirstLink();
                   pLn != pEmissList->GetNULLLink();
                   pLn  = pEmissList->GetNextLink() ) {
         if ( ((cMineLinkEmiss*)pLn)->GetHorzRange() < erange ) {
            pEmLink = (cMineLinkEmiss*)pLn;
            erange = pEmLink->GetHorzRange();
         }
      }
      
      if (pLink || pEmLink)
      {
	  if (range <= erange)  CalcControl(pLink,  pWaitTime);
	  else CalcControl(pEmLink,  pWaitTime);
      }

      else {      // there is no tgt link to check
         *pWaitTime = fpMine->GetUpdateRate();
         if ( state != emisOn )
            fpMine->StateChange(emisOn);
      }

  
   }
   
   if ( gfInteract )
      fpMine->UpdateInteractions();
}


void cMineControl::CalcControl(cLinkVehGeom* pLink, TTimeSim* pWaitTime)
{
   TAttackGeom   attGeom;
   EMineInternalState state = fpMine->GetInternalState();
         // have tgt selection, look at geometry
         CalcGeom( pLink, &attGeom);

         if ( attGeom.fbAttackNow ) {
            fpMine->SetDetonationResults(pLink);   // includes setting state
            *pWaitTime = fpMine->GetUpdateRate();
            new cMineDetonationMsg(fpMine->GetDetonationData() );
	    //    gCmsMgr.GetNextEventId(fpMine.fDetonationData.fEventId);
         }
         else if ( attGeom.fbLikelyTgt ) {
            TTimeSim approachTime = attGeom.fApproachTime * kSecToSimTime;
            if ( approachTime > fpMine->GetUpdateRate() ) {
               *pWaitTime = fpMine->GetUpdateRate();
               if ( state != emisOn )
                  fpMine->StateChange(emisOn);
            }
            else if (approachTime > fpMine->GetFastUpdateRate() ) {
               *pWaitTime = fpMine->GetFastUpdateRate();
               if ( state != emisCloseTracking )
                  fpMine->StateChange(emisCloseTracking);
            }
            else if (approachTime > 0.0 ) {
               *pWaitTime = 1.1 * approachTime;
               if ( *pWaitTime < 30 ) *pWaitTime = 30;
               if ( state != emisCloseTracking )
                  fpMine->StateChange(emisCloseTracking);
            }
            else {
               *pWaitTime = fpMine->GetUpdateRate();
               if ( state != emisOn )
                  fpMine->StateChange(emisOn);
            }
         }
         
         else {
               // fast update for very close vehicles, even if not approaching
            if ( pLink->GetRange() < 5.0 ) {
               *pWaitTime = fpMine->GetFastUpdateRate();
               if ( state != emisOn )
                  fpMine->StateChange(emisCloseTracking);
            }
            else {
               *pWaitTime = fpMine->GetUpdateRate();
               if ( state != emisOn )
                  fpMine->StateChange(emisOn);
            }
         }

}


void cMineControl::CalcControl(cMineLinkEmiss* pEmLink, TTimeSim* pWaitTime)
{
   TAttackGeom   attGeom;
   EMineInternalState state = fpMine->GetInternalState();
         // have tgt selection, look at geometry
         CalcGeom( pEmLink, &attGeom);

         if ( attGeom.fbAttackNow ) {
		
               *pWaitTime = fpMine->GetUpdateRate();
		fpMine->GetMechVuln()->ProcessMagCm(pEmLink, pWaitTime);
//            	fpMine->SetDetonationResults(pEmLink);   // includes setting state
//            	new cMineDetonationMsg(fpMine->GetDetonationData() );
         }
         else if ( attGeom.fbLikelyTgt ) {
            TTimeSim approachTime = attGeom.fApproachTime * kSecToSimTime;
            if ( approachTime > fpMine->GetUpdateRate() ) {
               *pWaitTime = fpMine->GetUpdateRate();
               if ( state != emisOn )
                  fpMine->StateChange(emisOn);
            }
            else if (approachTime > fpMine->GetFastUpdateRate() ) {
               *pWaitTime = fpMine->GetFastUpdateRate();
               if ( state != emisCloseTracking )
                  fpMine->StateChange(emisCloseTracking);
            }
            else if (approachTime > 0.0 ) {
               *pWaitTime = 1.1 * approachTime;
               if ( *pWaitTime < 30 ) *pWaitTime = 30;
               if ( state != emisCloseTracking )
                  fpMine->StateChange(emisCloseTracking);
            }
            else {
               *pWaitTime = fpMine->GetUpdateRate();
               if ( state != emisOn )
                  fpMine->StateChange(emisOn);
            }
         }
         
         else {
               // fast update for very close vehicles, even if not approaching
            if ( pEmLink->GetRange() < 5.0 ) {
               *pWaitTime = fpMine->GetFastUpdateRate();
               if ( state != emisOn )
                  fpMine->StateChange(emisCloseTracking);
            }
            else {
               *pWaitTime = fpMine->GetUpdateRate();
               if ( state != emisOn )
                  fpMine->StateChange(emisOn);
            }
         }

}


void  cMineControl::CalcGeom(const cLinkVehGeom* pLink, TAttackGeom* pGeom)
      // default is for collocation, veh going over mine
      // TgtOffset is distance to corner of vehicle, zero over vehicle
{
   const  TVehDimensions& vehDim = pLink->GetVehicle()->GetDimensions();
   const  TEntCoord&      vehLoc = pLink->GetLocation();
          TVelocity       vehVel(pLink->GetVelocity());

   float delta;
   if (vehLoc.x > 0)
      pGeom->fTgtOffset.x = ( (delta = vehLoc.x - vehDim.length/2.0 - fFireOffset.x) < 0.0 ) ? 0.0 : delta ;
   else
      pGeom->fTgtOffset.x = ( (delta = vehLoc.x + vehDim.length/2.0) + fFireOffset.x > 0.0 ) ? 0.0 : delta ;
   
      // slow movers get special treatment, they might accelerate
   if ( (vehVel.x < 1.0) && (vehVel.x > -0.1) )
      vehVel.x = 1.0;

   pGeom->fApproachTime = - pGeom->fTgtOffset.x / vehVel.x;
      
   if ( pGeom->fApproachTime >= 0.0 )
      pGeom->fbApproaching = true;
   else
      pGeom->fbApproaching = false;
   
   if (vehLoc.y > 0)
      pGeom->fTgtOffset.y = ( (delta = vehLoc.y - vehDim.width/2.0 - fFireOffset.y) < 0.0 ) ? 0.0 : delta ;
   else
      pGeom->fTgtOffset.y = ( (delta = vehLoc.y + vehDim.width/2.0 + fFireOffset.y) > 0.0 ) ? 0.0 : delta ;


   if ( fabs(pGeom->fTgtOffset.y) <= 1.0 ) {
      pGeom->fbLikelyTgt = true;
      if ( FireGeometry(pLink, pGeom) )
         pGeom->fbAttackNow = true;
      else
         pGeom->fbAttackNow = false;
   }
   else {
      pGeom->fbLikelyTgt = false;
      pGeom->fbAttackNow = false;
   }
}

void  cMineControl::CalcGeom(const cMineLinkEmiss* pEmLink, TAttackGeom* pGeom)
      // default is for collocation, veh going over mine
      // TgtOffset is distance to corner of vehicle, zero over vehicle
{
   const  TVehDimensions& emissDim = pEmLink->GetEmission()->GetEmissDim();
//   float		  radius = pEmLink->GetEmission()->GetRadius();
   const  TEntCoord&      emissLoc = pEmLink->GetLocation();
          TVelocity       emissVel(pEmLink->GetVelocity());

   float delta;
   if (emissLoc.x > 0)
      pGeom->fTgtOffset.x = ( (delta = emissLoc.x - emissDim.length/2.0 - fFireOffset.x) < 0.0 ) ? 0.0 : delta ;
   else
      pGeom->fTgtOffset.x = ( (delta = emissLoc.x + emissDim.length/2.0) + fFireOffset.x > 0.0 ) ? 0.0 : delta ;
   
      // slow movers get special treatment, they might accelerate
   if ( (emissVel.x < 1.0) && (emissVel.x > -0.1) )
      emissVel.x = 1.0;

   pGeom->fApproachTime = - pGeom->fTgtOffset.x / emissVel.x;
      
   if ( pGeom->fApproachTime >= 0.0 )
      pGeom->fbApproaching = true;
   else
      pGeom->fbApproaching = false;
   
   if (emissLoc.y > 0)
      pGeom->fTgtOffset.y = ( (delta = emissLoc.y - emissDim.width/2.0 - fFireOffset.y) < 0.0 ) ? 0.0 : delta ;
   else
      pGeom->fTgtOffset.y = ( (delta = emissLoc.y + emissDim.width/2.0 + fFireOffset.y) > 0.0 ) ? 0.0 : delta ;


   if ( fabs(pGeom->fTgtOffset.y) <= 1.0 ) {
      pGeom->fbLikelyTgt = true;
      if ( FireGeometry(pEmLink, pGeom) )
         pGeom->fbAttackNow = true;
      else
         pGeom->fbAttackNow = false;
   }
   else {
      pGeom->fbLikelyTgt = false;
      pGeom->fbAttackNow = false;
   }
}

EBoolean  cMineControl::FireGeometry(const cLinkVehGeom* /* pLink */, TAttackGeom* pGeom)
   // default fires on proximity/ offset check only
{
   if ( (pGeom->fTgtOffset.x == 0.0) && 
        (pGeom->fTgtOffset.y == 0.0)   )
      return true;
   else
      return false;
}

EBoolean  cMineControl::FireGeometry(const cMineLinkEmiss* /* pEmLink */, TAttackGeom* pGeom)
   // default fires on proximity/ offset check only
{
   if ( (pGeom->fTgtOffset.x == 0.0) && 
        (pGeom->fTgtOffset.y == 0.0)   )
      return true;
   else
      return false;
}

EBoolean   cMineControl::NeedsPrUpdate( EMineInternalState minestate)
{ 
   return minestate >= emisCloseTracking ? true : false;
}


EBoolean   cMineControl::NeedsUpdate( EMineInternalState minestate)
{ 
   return minestate >= emisLowestUpdate ? true : false;
}

cMineControl::cMineControl(cSimMine* pMine, TFlatEntCoord offset, const TFuzeOpt& fuzeOpt )
{
   fpMine      = pMine;
   fFireOffset = offset;
   fTgtCount   = fuzeOpt.fTgtCount;
}

cMineControl::~cMineControl()
{ }

float  cDetonVuln::GetDetVulnRange(int detType, float depth)
{
   return (fpVulnDetList->GetMaxRange(detType, depth) + fExtraRange);
}

void   cDetonVuln::AssessDeton(cDetonation* pDet, float range)
      // called for all detonations in the general vicinity
{   
   float rng = range;
   EVulnResult result = evrNone;
   TDetVulnTable* pVdTable = fpVulnDetList->GetVulnDetTable( pDet->GetDetonType() );
   
         // special for ESMB and MICLIC, we need to know geometry
   if ( pDet->IsAreaType() ) {
      TEntCoord relLoc = 
            pDet->GetTccRot() * ( fpMine->GetTccLoc() - pDet->GetTccLoc() );
      if ( fabs(relLoc.x) <= pVdTable->GetLinearLength() )
         rng = fabs(relLoc.y);
      else
         return;
   }
   
   if (pVdTable != NULL) {
      //cout << endl << "Using Det Vuln Table for fuze " << ((int)fpMine->GetFuze());
      //cout << endl << " Det Type: " << pDet->GetDetonTypeName() << endl;
      //fpMine->WriteEntSumm((ofstream*) &cout);
      //cout << endl;
      //pDet->WriteDetInfo((ofstream*) &cout);
      //cout << endl << endl;
      result = pVdTable->GetRandomResult(fpMine->GetDepth(), rng);
   }
   else {
      cout << endl << "Cannot find Det Vuln Table! ";
      cout << "Det Type: " << pDet->GetDetonType() << endl;
      pDet->WriteDetInfo((ofstream*) &cout);
      cout << endl;
      fpMine->WriteEntSumm((ofstream*) &cout);
      cout << endl; endl;
   }

   switch (result) {
      case evrDet:
            fpMine->SetDetonResult(edetGroundImpact);
            fpMine->FireMine(emisDetonatedMissed, true);
            fpMine->SetDetonLoc( fpMine->GetGeoLoc() );
            new cMineDetonationMsg(fpMine->GetDetonationData());
            fpMine->DoMineChange();
            if ( gfInteract ) {
               WriteDetonResult(gpInteract, pDet, range, evrDet);
               fpMine->UpdateInteractions();
            }
         break;
   
      case evrNeut:
            fpMine->StateChange(emisFailed);
            if ( gfInteract ) {
               WriteDetonResult(gpInteract, pDet, range, evrNeut);
               fpMine->UpdateInteractions();
            }
         break;
         
      case evrNone:
            if ( gfInteract ) {
               WriteDetonResult(gpInteract, pDet, range, evrNone);
            }
         break;
   
      default:
         break;
   }
}

cDetonVuln::cDetonVuln(cDetVulnList* pVulnDetList, cSimMine* pMine, float extraRange)
   // extra range is for component's virtual mine, never used for actual mine
{
   fpVulnDetList = pVulnDetList;
   fpMine = pMine;
	fExtraRange = extraRange;
}

cDetonVuln::~cDetonVuln()
{ }

// ************************************
//   minefield objects
// ************************************


void   cMfieldObj::SetMfLoc(float xLoc, float yLoc)
{
   if ( fpMinefield->HasMfCoords() ) {
      TFlatEntCoord locFlat( xLoc, yLoc );
      fpMinefield->MfToMapLoc(locFlat, &fTccLocation);
      SetCoordTccRef(fTccLocation, fTccOrientation.psi, fTccOrientation.theta, fTccOrientation.phi);
   }
   else {
      fMfLocation.x = xLoc;
      fMfLocation.y = yLoc;
      fMfLocation.z = - FLT_MAX;
      fRefSet = eMfRef;
   }
}

void   cMfieldObj::SetCoordGeoRef(TLocation geoLoc, float psi, float theta, float phi)
{
   cEntity::SetCoordGeoRef( geoLoc, psi, theta, phi );
   fRefSet = eTccRef;

   SetMfFromTcc();

   if ( fpDispObj)
      fpDispObj->DrawObj();
}

void   cMfieldObj::SetCoordGeoRef(TLocation geoLoc, TOrient orient)
{
   cEntity::SetCoordGeoRef( geoLoc, orient );
   fRefSet = eTccRef;

   SetMfFromTcc();

   if ( fpDispObj)
      fpDispObj->DrawObj();
}

void   cMfieldObj::SetCoordTccRef(TLocation tccLoc, float psi, float theta, float phi)
{
   cEntity::SetCoordTccRef( tccLoc, psi, theta, phi );
   fRefSet = eTccRef;

   SetMfFromTcc();

   if ( fpDispObj) {
      fpDispObj->DrawObj();
   }
}

void   cMfieldObj::SetTccOrient(float psi, float theta, float phi)
{
   cEntity::SetTccOrient( psi, theta, phi );
   SetMfFromTcc();
   if ( fpDispObj)
     fpDispObj->RedrawSelected();
}

void   cMfieldObj::SetMfFromTcc()
{
   if ( fpMinefield && fpMinefield->HasMfCoords() ) {
      fpMinefield->MapToMfLoc(fTccLocation, &fMfLocation);
      fRefSet = eRefComplete;
   }
}

void   cMfieldObj::CompleteVisuals()
{ 
   if ( fpDispObj )
      fpDispObj->DrawObj();
   else
      CreateDispObj();
}

void   cMfieldObj::CreateDispObj()
{ }

EBoolean      cMfieldObj::CompleteMfObj()
{
   switch (fRefSet) {
      case eMfRef:
            SetMfLoc(fMfLocation.x, fMfLocation.y);
         break;
         
      case eMfRef3d: {
            float delZ = fMfLocation.z;
            SetMfLoc(fMfLocation.x, fMfLocation.y);
            fMfLocation.z += delZ;
            fTccLocation.z += delZ;
         }
         break;
         
      case eTccRef:
            SetMfFromTcc();
         break;

      case eRefComplete:
          break;
         
      default:
          break;
   
   }

   if (gbGui)
      CompleteVisuals();
      
   return EBoolean (fRefSet == eRefComplete);
}

void     cMfieldObj::SelectObj()
{
   if (! fbSelected ) {
      fbSelected = true;
      if ( fpDispObj)
	 fpDispObj->RedrawSelected ();
   }
}

void     cMfieldObj::DeSelectObj()
{
  fbSelected = false;
  if ( fpDispObj)
    fpDispObj->RedrawSelected ();
}

void     cMfieldObj::ShowObj (EBoolean show)
{
  if ( fpDispObj)
     fpDispObj->SetVisible (show);
}

void   cMfieldObj::CopyMfObjParams(cMfieldObj* pOriginal)
{
   fRefSet          = pOriginal->fRefSet;
//   fpDispObj not copied, caller decides what to do

   fpMfComponent    = pOriginal->fpMfComponent;
   fpMinefield      = pOriginal->fpMinefield;
   fMfLocation      = pOriginal->fMfLocation;
   fDepth           = pOriginal->fDepth;
   fHoursInPlace    = pOriginal->fHoursInPlace;
   fbSelected       = pOriginal->fbSelected;
}

cMfieldObj::cMfieldObj(cMineComp* pParent, cMfieldObj* pOriginal):
   cEntity(pOriginal)
   // used when duplicating, backing up, or restoring
{
   InitMfObj(pParent);
   CopyMfObjParams(pOriginal);
   fpDispObj = NULL;
   
   fpMfComponent    = pParent;
   if (pParent ) 
      fpMinefield = pParent->GetMinefield();
   else
      fpMinefield = NULL;
}

void   cMfieldObj::InitMfObj(cMfComponent* pParent)
{
   fpMfComponent = pParent;
   if (pParent )
      fpMinefield   = pParent->GetMinefield();
   else
      fpMinefield = NULL;
   
   fRefSet       = eNullRef;
   fpDispObj     = NULL;

   if (pParent) {
      fDepth        = ((cMineComp*)pParent)->GetCompMineDepth();
      fHoursInPlace = ((cMineComp*)pParent)->GetCompHoursInPlace();
      fpMfComponent = pParent;
      fpMinefield = pParent->GetMinefield();
   }
   else {
      fpMinefield = NULL;
      fpMfComponent = NULL;
      fDepth        = 0.0;
      fHoursInPlace = 0;
   }

   fbSelected    = false;
}

cMfieldObj::cMfieldObj(cMfieldObj* pOriginal) :
   cEntity(pOriginal)
{
   InitMfObj(NULL);
   if (pOriginal)
      CopyMfObjParams(pOriginal);
}

cMfieldObj::cMfieldObj(cMfComponent* pParent)
{
   InitMfObj(pParent);
}

cMfieldObj::cMfieldObj(cMfComponent* pParent, TLocation& tccPt)
{
   InitMfObj(pParent);
   
   if (tccPt.z == 0.0)
      tccPt.z = gpTerrainMgr->GetMapElev(tccPt.x, tccPt.y);
      
   SetCoordTccRef(tccPt, fTccOrientation.psi, fTccOrientation.theta, fTccOrientation.phi);
}

cMfieldObj::~cMfieldObj()
{
   if ( fbSelected && gbGui)
      gpGuiWin->DeleteSelection(fpMinefield, fpMfComponent, this);
      
   if (fpDispObj) {
      delete fpDispObj;
      fpDispObj = NULL;
   }
}

TMineParam*    cMine::GetMineParams()
{
   if ( fpDbMine )
      return fpDbMine->GetMineParam( fOptSet.fMineOpt );
   else
      return NULL;
}

TFuzeParam*    cMine::GetFuzeParams()
{
   if ( fpDbMine )
      return fpDbMine->GetFuzeParam( fOptSet.fFuzeOpt );
   else
      return NULL;
}

char*   cMine::GetEntName()
{
   if ( fpDbMine )
      return fpDbMine->GetEntryEntityName();
   else
      return NULL;
}

const TEntityType&   cMine::GetEntType()
{
   if ( fpDbMine )
      return fpDbMine->GetEntryEntityType();
   else
      return TEntityType(0);
}

EBoolean    cMine::IsDirectional(TFlatEntCoord* pMinMax)
{
   if ( fpDbMine )
      return fpDbMine->IsDirectional(fOptSet, pMinMax);
   else
      return false;
}

void    cMine::UserSetDirection(float psi, float theta, float phi)
{
   SetTccOrient(psi, theta, phi);
   
   if ( fpDbMine )
      ((fpDbMine->GetMineParam(fOptSet.fMineOpt))->fTccOrient).SetOrient(psi, theta, phi);
}

EBoolean    cMine::IsWideArea(float* pRange)
{
   if ( fpDbMine )
      return fpDbMine->IsWideArea(fOptSet, pRange);
   else
      return false;
}

EBoolean    cMine::IsCmdDet()
{
   if ( fpDbMine )
      return fpDbMine->IsCmdDet(fOptSet);
   else
      return false;
}

EBoolean    cMine::IsClickFire()
{
   if ( fpDbMine )
      //return fpDbMine->IsClickFire(fOptSet);
      return fpDbMine->IsCmdDet(fOptSet);
   else
      return false;
}

void    cMine::CmdDet()
{
}

void    cMine::CmdDet(TLocation /* tccPt */)
{
}

void    cMine::CmdFire(EMfCmdMode /* eMineCmdMode */)
{
}

EBoolean    cMine::GetMineToggleState()
{
   if ( IsCmdDet() )
      return ( (feIntState > emisFailed) && (fRoundsLeft > 0)
             ) ? true : false;
   else
      return fbEditOn;
}

EWarhead    cMine::GetWarhead() 
{ 
   if ( fpDbMine )
      return fpDbMine->GetMineParam( fOptSet.fMineOpt )->fWarhead;
   else
      return ewhMine;
}

EFuze       cMine::GetFuze()    
{ 
   if ( fpDbMine )
      return fpDbMine->GetFuzeParam( fOptSet.fFuzeOpt )->fFuze;
   else
      return efzOther;
}

//Below func. added by KS
int	cMine::GetFuzeNameIndex()
{
   if (fpDbMine)
      return fpDbMine->GetFuzeParam( fOptSet.fFuzeOpt )->GetType();
   else
      return TFuzeParam::efuzetypeOther;
}

EYesNoOpt cMine::GetAntiHandling()
{
   if (fpDbMine)
   	return fpDbMine->GetFuzeParam( fOptSet.fFuzeOpt )->GetOptSelector()->GetAntihandlingOpt();
   else
   	return eNo;
}


short cMine::GetDomain()
{
	return fpDbMine->GetEntryEntityType().domain;
}

	
unsigned long   cMine::GetIconType()
   // The default is for cSimMine mines. cPlanMine overrides
{
   unsigned long icon = cMine::simObjType[esymAt];

   if ( fpDbMine ) {
      if ( fpDbMine->IsDirectional(fOptSet) ){
 	 if ( GetFuzeNameIndex() == TFuzeParam::esenstypeCommandCamDir ||
	      GetFuzeNameIndex() == TFuzeParam::esenstypeAutoCmdCamDir)
	    icon = cMine::simObjType[esymCam];
         else
            icon = cMine::simObjType[esymDir];
      }
      else if ((GetFuzeNameIndex() >= TFuzeParam::esenstypePerDet)&&
               (GetFuzeNameIndex() <= TFuzeParam::esenstypeDirTrack))
	icon = cMine::simObjType[esymSens];
      else if (fpDbMine->GetEntryEntityType().domain == emundomAntipersonnel)
         icon = cMine::simObjType[esymAp];
      else if (fpDbMine->GetEntryEntityType().domain == efunnydomainFalseAlarm)
         icon = cMine::simObjType[esymFalseDet];
   }

   return icon;
}



EMineInternalState    cMine::GetDisplayState()
{
   if ( gfMineStateDisp )
      return GetInternalState();
   else
      return emisOn;
}

EMineExternalState       cMine::GetExternalState()    
{ 
   switch (feIntState) {
      case emisFailed:
         return emsOther;
         // break;
         
      case emisDetonated:
      case emisDetonatedHit:
      case emisDetonatedMissed:
         return emsFired;
         // break;
         
      case emisNone:         // this means not yet simulated
      case emisMoving:
      case emisOff:
      case emisInhibit:
      case emisOn:
      case emisTracking:
      case emisActivating:
      case emisCloseTracking:
         return emsAlive;
         // break;
         
      default:
         break;
   }
   return emsOther;
}

void   cMine::WriteEntSumm(ofstream* pOut)
   // writes mine location summary to output file
{
   *pOut << GetEntName();
   *pOut << " id: "
         << GetEntityID().site        << " "
         << GetEntityID().application << " "
         << GetEntityID().entityNum;
   *pOut << " state: "
         << GetInternalStateText(feIntState);
   *pOut << " mapLocation: "
         << fTccLocation.x << " "
         << fTccLocation.y << " "
         << fTccLocation.z;
   int   utmZone = 0;
   double utmNorth = 0.0, utmEast = 0.0, utmZ = 0.0;
   
   if ( ! gpTerrainMgr->GeoToUtmLoc(fGeoLocation, 
               &utmZone, &utmNorth, &utmEast, &utmZ) ) {
      *pOut << " utmLocation: "
            << utmZone  << " "
            << utmNorth << " "
            << utmEast  << " "
            << utmZ;
   }
   else {
      *pOut << " utm coords not available";
   }
   
   if ( (fpDbMine->GetMineParam(fOptSet.fMineOpt))->fNumRounds > 1)
      *pOut << " rounds fired/left: "
            << (fpDbMine->GetMineParam(fOptSet.fMineOpt))->fNumRounds - fRoundsLeft
            << " " << fRoundsLeft;
}

EBoolean cMine::MoveMine (TLocation tccPt) 
   // this is called from the GUI
{
  if (GetMinefield()->GetPerimeter()->PointInside (tccPt)) {
    SetCoordTccRef( tccPt, fTccOrientation.psi, fTccOrientation.theta, fTccOrientation.phi );
      // mine displays gets moved when component completes it coord system
//    ((cMineDisp*)fpDispObj)->MoveMine (tccPt);
    fpMfComponent->CompleteComp();
    ((cMineComp*)fpMfComponent)->RedrawComp();
    
    if (gpGuiWin) {
      cCoordList*    pMineCoord = 
               gpGuiWin->GetCurEditor()->GetMineCoordWidget();
      if (pMineCoord)
         pMineCoord->ReplaceEntry (fpMfComponent->GetObjIndex((cMfieldObj*)this),
                  tccPt);
    }
    return true;
  }
  else {
    if (gbGui) gpGuiWin->DialogMessage (cGuiWindow::eDialogError, NULL,
            "Invalid point.  Mine must be emplaced\ninside minefield perimeter.");
    return false;
  }
}

EBoolean   cMine::MoveMineWithComp (TEntCoord& centerPt, T2dMove& move)
   //  This is the call when a component moves.  Each mine moves within the
   // minefield, and then the component re-sets its coordinates based
   // on the new mine locations.
   // rotates mine around component center and offsets its mf location
   //  Does not update other coords, higher level will complete the coord systems
{
   fMfLocation = (move.fRotMatrix * (fMfLocation - centerPt)) + centerPt;
   fMfLocation.x += move.fDelX;
   fMfLocation.y += move.fDelY;

   TRotation rot;
   move.fRotMatrix.MultTrans(fTccRotation, &rot);
   rot.SetOrientation(&fTccOrientation);
      // fTccRotation will get reset
   
   fRefSet = eMfRef;
      // mine displays gets moved when component completes it coord system
   
   return true;
}

EBoolean   cMine::MoveMineWithMf (T2dMove& move)
   //  Entire minefield moves.  In mf coords, we do not offset
   // rotates mine around mf center
   //  Does not update other coords, higher level will complete the coord systems
{
   if ( fRefSet != eRefComplete )
      return false;
      
   fMfLocation = move.fRotMatrix * fMfLocation;
   TRotation rot;
   move.fRotMatrix.MultTrans(fTccRotation, &rot);
   rot.SetOrientation(&fTccOrientation);
      // fTccRotation will get reset
   fRefSet = eMfRef;
      // mine displays gets moved when component completes it coord system
   
   return true;
}

void  cMine::SetMineSim (EBoolean sim)
      // this is a function called by the gui
{
   fbEditSim = sim;

   if ( feIntState > emisNone )      // we're already simulating
      new cSimulateMineMsg(this, sim);
}

void  cMine::SetMineOn (EBoolean on)
      // this is a function called by the gui
{
   fbEditOn = on;

   if ( feIntState > emisNone )      // we're already simulating
      new cOnOffMineMsg(this, on);
}

void    cMine::SetMinePvdSelect( EBoolean on )
{
  if (fpDispObj)
    ((cMineDisp*)fpDispObj)->SetMineSelectSens (on);
}


void    cMine::SetCompPvdSelect( EBoolean on )
{
  if (fpDispObj) {
    ((cMineDisp*)fpDispObj)->SetCompSelectSens (on);
  }
}

void   cMine::CreateDispObj()
{ 
   if ( gbGui && ( !fpDispObj) && 
       ( (fRefSet == eRefComplete) || (fRefSet == eTccRef) ) )
      fpDispObj = new cMineDisp (this, fTccLocation, ((cMineComp*)fpMfComponent)->GetShowMines() );
}

void   cMine::InitMine(cMineComp* pParent)
{
//   InitTccOrient();  overrides InitMfObj() version to get mine orientation

   fRoundsLeft = 1;
   if (pParent) {
      fpDbMine      = pParent->GetDbEntity();
      fOptSet       = pParent->GetDbOpt();
      //fDepth        = pParent->GetCompMineDepth();
      //fHoursInPlace = pParent->GetCompHoursInPlace();
      
      pParent->IncrementLive();
      //fpMinefield = pParent->GetMinefield();
      
      fpPrevEnt = pParent->fpMineListTail;
      if (fpPrevEnt)  ((cMine*)fpPrevEnt)->fpNextEnt = this;
      pParent->fpMineListTail = this;
      if ( !pParent->fpMineListHead) pParent->fpMineListHead = this;
   }
   else {
      fpDbMine      = &fsDbMine;
      //fpMinefield = NULL;
      //fpMfComponent = NULL;
      //fDepth        = 0.0;
      //fHoursInPlace = 0;
   }
   
         // orientation set to component option default, may
         // get overridden 
   //if ( fpDbMine )
   // fTccOrientation = fpDbMine->GetMineParam(fOptSet.fMineOpt)->fTccOrient;
   
//   fTccOrientation.SetOrient( pDbMine->GetTccOrient().psi, 
//            pDbMine->GetTccOrient().theta, pDbMine->GetTccOrient().phi );

   feIntState    = emisNone;         // gets set when starting to simulate
   fbEditOn      = true;
   fbEditSim     = true;
}

void       cMine::CopyMineParams(cMine* pOriginal)
{
   fpDbMine        = pOriginal->fpDbMine;
   fOptSet         = pOriginal->fOptSet;
   feIntState      = pOriginal->feIntState;
   fbEditOn        = pOriginal->fbEditOn;
   fbEditSim       = pOriginal->fbEditSim;
}

cMine::cMine(cPlanMine* pPlan) :
   cMfieldObj(pPlan)
{
   InitMine();
   if (pPlan )
      CopyMineParams(pPlan);
}

cMine::cMine( cMineComp* pParent, cMine* pOriginal, EBoolean ) : 
             cMfieldObj(pParent, pOriginal)
{
   InitMine(pParent);
   CopyMineParams( pOriginal );

   if (fpMinefield != NULL && fpMinefield->GetSimStart() != esimstSimulating)
      feIntState = emisNone;   // Cannot simulate mine without simulating minefield
}

cMine::cMine(cMineComp* pParent) : 
             cMfieldObj(pParent)
{
   InitMine(pParent);
}



cMine::cMine(cMineComp* pParent, TLocation& tccPt) 
     : cMfieldObj(pParent, tccPt)
{
   InitMine(pParent);
   
//   SetCoordTccRef(fTccLocation, fTccOrientation.psi, fTccOrientation.theta, fTccOrientation.phi);

//   CreateDispObj();
}

cMine::~cMine()
{
   cMineComp* pMineComp = (cMineComp*)fpMfComponent;
   
   if (pMineComp) {
         // first decrement the count, so that gui can get new count
      pMineComp->DecrementMine( GetExternalState() );
      
         // delete entry, while index and links are still valid
      if (gpGuiWin ) {
         int index = pMineComp->GetObjIndex(this);
         gpGuiWin->GetCurEditor()->DeleteObjEntry(fpMfComponent, index);
      }

         // fix indices
      if (pMineComp->fpMineListHead == this) 
         pMineComp->fpMineListHead = (cMine*)fpNextEnt;
      if (pMineComp->fpMineListTail == this) 
         pMineComp->fpMineListTail = (cMine*)fpPrevEnt;
   }
   
      // write info to mine state file
   if ( fbSimulating && gfMineStateSumm ) {
      *gpMineStateSumm << "  { MineSimDelete time:"
                       << GetCurSimTime() * kSimTimeToSec
                       << " ";
      WriteEntSumm(gpMineStateSumm);
      *gpMineStateSumm << "}"
                       << endl;
   }
}

TDetonationData&  cSimMine::GetDetonationData()
{
   gCmsMgr.GetNextEventId(&fDetonationData.fEventId);
   return fDetonationData; 
}

void   cSimMine::SetMineSetList(T2linkMineSetList* fpList)
{
   fpMineSetList = fpList;
   fpList->AddMine(this);
}

void   cSimMine::DoMineChange()
{
   fChangeSequence++;
   if ( fpMineSetList ) {
      if ( feIntState <= emisDetonated ) {
         fpMineSetList->RemoveMine(this);
         fpMineSetList->MineChange(NULL);
         fpMineSetList = NULL;
      }
      else
         fpMineSetList->MineChange(this);
   }
   fbChangeIndicator = false;
}

cInteraction*   cSimMine::CreateNewInteraction(cLinkVehGeom* pLinkVeh)
{
   return new cInteraction(this, pLinkVeh);
}

void   cSimMine::UpdateInteractions()
{
         // for output, update each link
   if ( gfInteract ) {
      cInteraction* pInter;
      for (cLinkVehGeom* pLn  = (cLinkVehGeom*)(fTrackVeh.GetFirstLink());
                         pLn != (cLinkVehGeom*)(fTrackVeh.GetNULLLink());
                         pLn  = (cLinkVehGeom*)(fTrackVeh.GetNextLink()) ) {
         pInter = pLn->GetInteraction();
         if ( pInter ) {      // there is an interaction record
            pInter->UpdateInteraction(pLn);
            if ( feIntState < emisLowestUpdate) {
                  // detonated, set result if not already done
               if ( pInter->GetResult() == eTracking) {
                  pInter->SetResult(eMineDetonated);
                  if ( pLn->GetVehicle() == fpTarget ) {
                     if (feIntState == emisDetonatedHit)
                        pInter->SetResult(eHitTarget);
                     else if (feIntState == emisDetonatedMissed)
                        pInter->SetResult(eMissedTarget);
                     else if (feIntState == emisDetonated)
                        pInter->SetResult(eAttackedTarget);
                  }
               }
            }
            else {      // not detonated - keep tracking or drop
               if ( ! pLn->IsApproaching() ) {
                  if ( pInter->GetResult() == eTracking) {
                     if ( feIntState == emisFailed )
                        pInter->SetResult(eMineNeutralized);
                     else
                        pInter->SetResult(eNoAttack);
                  }
                  pLn->DeleteInteraction();
               }
            }
         }
         else {            // no interaction record for this link, may need one
            if ( pLn->GetVehicle() == fpTarget ) {
               pInter = CreateNewInteraction(pLn);
               pLn->SetInteraction( pInter );
               pInter->UpdateInteraction(pLn);
               if (feIntState == emisDetonatedHit)
                  pInter->SetResult(eHitTarget);
               else if (feIntState == emisDetonatedMissed)
                  pInter->SetResult(eMissedTarget);
               else
                  pInter->SetResult(eAttackedTarget);
            }
            else {      // no detonation, create interaction record for approaching veh
               if ( feIntState >= emisLowestUpdate) {
                  if ( pLn->IsApproaching() ) {
                     pInter = CreateNewInteraction(pLn);
                     pLn->SetInteraction( pInter );
                     pInter->UpdateInteraction(pLn);
                     pInter->SetResult(eTracking);
                  }
               }
            }
         }
      }
   }
}

void   cSimMine::UpdateDetChar()
{
   TTimeSim curTime = GetCurSimTime();
   if ( (curTime >= fNextThermalChange) &&
        (gpNetMgr->IncludeThermal()) ) {
      fDetectChar.fThermalContrast += 1.0;
      DoMineChange();
      fNextThermalChange = (UniformRand() + 0.5) * kSecToSimTime * 60.0
                      * GetMineParams()->fMeanTimeThermal + curTime;
   }
}

/*
void   cSimMine::UpdateMine()
{
        TTimeSim      waitTime = 0;
        fpUpdateMsg = NULL;

        if ( feIntState >= emisLowestUpdate )
        {
                if ( feIntState >= emisLowestTracker )
                {
                        // update sensor
                        //TLocation loc = GetGeoLoc();
                        //TEntCoord tloc(loc.x,loc.y,loc.z);
                        //if(fpSensor->UpdateSensor(tloc) == true)
                        if(fpSensor->UpdateSensor() == true)
                        {
                                SetDetonationResults();
                                new cMineDetonationMsg(this,5.0,333.0);
                        }
                        else
                                fpTracker->UpdateTracker( ((cMineComp*)fpMfComponent)->GetVehList(),
                                   &fTrackVeh, fMfLocation);
                }

                if(feIntState >= emisLowestControl)
			fpMechanVuln->UpdateMechVuln(&fTrackVeh, &waitTime);
                if ( feIntState >= emisLowestControl )
                        fpControl->UpdateControl(&fTrackVeh, &waitTime);

                UpdateDetChar();
                if ( fbChangeIndicator )
                        DoMineChange();

                if ( feIntState == emisCloseTracking ) {
                        fpUpdateMsg = new cUpdateMinePrMsg(waitTime, this);
                }
                else if ( feIntState >= emisLowestUpdate) {
                        //NPAC fpUpdateMsg = new cUpdateMineMsg(this);
                 }
                else
                {
                        fTrackVeh.DeleteList();
                        delete fpTracker;
                        fpTracker = NULL;
                        delete fpControl;
                        fpControl = NULL;
                        delete fpDetonVuln;
                        fpDetonVuln = NULL;
                        delete fpMechanVuln;
                        fpMechanVuln = NULL;
                        //       fTrackEmissions.DeleteList();
                        delete fpSensor;
                        fpSensor = NULL;
                        //      delete fpEmissionVuln;
                        //      fpEmissionVuln = NULL;
                }
        }
}
*/

/*void   cSimMine::UpdateMine()
{
	TTimeSim      waitTime = 0;
	fpUpdateMsg = NULL;

	if ( feIntState >= emisLowestUpdate )
	{
		if ( feIntState >= emisLowestTracker )
		{
			// update sensor
			//TLocation loc = GetGeoLoc();
			//TEntCoord tloc(loc.x,loc.y,loc.z);
			//if(fpSensor->UpdateSensor(tloc) == true)
			if(fpSensor->UpdateSensor() == true)
			{
				SetDetonationResults();
				new cMineDetonationMsg(this);
			}
			else 
				fpTracker->UpdateTracker( ((cMineComp*)fpMfComponent)->GetVehList(), 
                               	   &fTrackVeh, fMfLocation);
		}

		//if( feIntState >= emisLowestUpdate)
			fpMechanVuln->UpdateMechVuln(&fTrackVeh, &waitTime);
		
		if ( feIntState >= emisLowestControl ) 
			fpControl->UpdateControl(&fTrackVeh, &waitTime);
     
		UpdateDetChar();
		if ( fbChangeIndicator )
			DoMineChange();
      
		if ( feIntState == emisCloseTracking ) {
			fpUpdateMsg = new cUpdateMinePrMsg(waitTime, this);
                }
		else if ( feIntState >= emisLowestUpdate)
			//NPAC fpUpdateMsg = new cUpdateMineMsg(this);
		else 
		{
			fTrackVeh.DeleteList();
//			fProxEmiss.DeleteList();
			fProxEmiss.ResetList();
			delete fpTracker;
			fpTracker = NULL;
			delete fpControl;
			fpControl = NULL;
			delete fpDetonVuln;
			fpDetonVuln = NULL;
			delete fpMechanVuln;
			fpMechanVuln = NULL;
			if(fpSensor) 
			{
				delete fpSensor;
				fpSensor = NULL;
			}
		}
	}
}
*/

void   cSimMine::UpdateMine()
{
        TTimeSim      waitTime = 0;
        fpUpdateMsg = NULL;

        if ( feIntState >= emisLowestUpdate )
        {
                if ( feIntState >= emisLowestTracker )
                {
		   fpTracker->UpdateTracker( ((cMineComp*)fpMfComponent)->GetVehList(),
					     &fTrackVeh, fMfLocation);

		   if ( fpSensor != NULL) {
		      fpSensor->UpdateSensor(((cMineComp*)fpMfComponent)->GetEmissList(),
                                   &fProxEmiss, GetTccLoc());
		      //fpEmissVuln->UpdateEmissVuln(&fProxEmiss, this, &waitTime);
		   }

		   fpMechanVuln->UpdateMechVuln(&fTrackVeh, &waitTime);
		}
		

                if ( feIntState >= emisLowestControl )
                        fpControl->UpdateControl(&fTrackVeh, &fProxEmiss,  &waitTime);
 
                if ( GetC2Interface() && feIntState >= emisLowestControl )
		        GetC2Interface()->UpdateInterface();

                UpdateDetChar();
                if ( fbChangeIndicator )
                        DoMineChange();
 
                if ( fpControl->NeedsPrUpdate(feIntState) ) {
                        fpUpdateMsg = new cUpdateMinePrMsg(waitTime, this);
                }
                else if ( fpControl->NeedsUpdate(feIntState) ) {
                        //fpUpdateMsg = new cUpdateMineMsg(this);
                   }
                else
                {
                        fTrackVeh.DeleteList();
			fProxEmiss.DeleteList();
//			fProxEmiss.ResetList();
                        delete fpTracker;
                        fpTracker = NULL;
                        delete fpControl;
                        fpControl = NULL;
                        delete fpDetonVuln;
                        fpDetonVuln = NULL;
                        delete fpMechanVuln;
                        fpMechanVuln = NULL;
                        if(fpSensor)
                        {
                                delete fpSensor;
                                fpSensor = NULL;
                        }
                        if(fpC2Interface)
                        {
                                delete fpC2Interface;
                                fpC2Interface = NULL;
                        }
                        if(fpRadio)
                        {
                                delete fpRadio;
                                fpRadio = NULL;
                        }
                }
        }
}


void    cSimMine::CheckVehDamage(cVehicle* pVeh)
{
   if ( pVeh ) {
      if ( ! pVeh->IsMobile() ) {
         fKilledTgts++;
         ((cMineComp*)fpMfComponent)->IncrementVehKill();
      }
   }
}

void   cSimMine::SimulateMine()
   // we simulate and update duds, they may get detected
{
      // constructor has set desired initial state, we call StateChange
      // to  get to it to set summaries correctly
   EMineInternalState startState = feIntState;
   feIntState = emisNone;
   fOptSet = ((cMineComp*)fpMfComponent)->GetDbOpt();
   fRoundsLeft = (fpDbMine->GetMineParam(fOptSet.fMineOpt))->fNumRounds;
   fNextThermalChange = (UniformRand() + 0.5) * kSecToSimTime * 60.0
                      * GetMineParams()->fMeanTimeThermal;
   
   if ( fbEditSim ) {
      if ( startState == emisFailed ||
           (UniformRand() <= (GetFuzeParams()->fProbDud) ))
         StateChange (emisFailed);   //make call in order to update display, etc.
      else {
         if ( fbEditOn ) {
            StateChange( emisOn );
	 }
         else
            StateChange( emisOff );
      }
      gCmsMgr.GetNextEntityId( this, &fId );
      //NPAC fpUpdateMsg = new cUpdateMineMsg(this);
      fbSimulating = true;
   
         // write info to mine state file
      if ( gfMineStateSumm ) {
         *gpMineStateSumm << "  { MineSimStart time:"
                          << GetCurSimTime() * kSimTimeToSec
                          << " ";
         WriteEntSumm(gpMineStateSumm);
         *gpMineStateSumm << "}"
                          << endl;
      }
   }
}

void   cSimMine::OnOffMine( EBoolean on)
   // called from msg, when already simulating
{
   fbEditOn = on;
   
   if ( on ) {      // turning on, OK if we're now off or inhibited
      if ( (feIntState == emisOff) || (feIntState == emisInhibit) )
         StateChange( emisOn);
   }
   
   else             // turning off, OK if we are in an operating state
      if ( feIntState >= emisOn )
         StateChange( emisOff);
}

void   cSimMine::StateChange(EMineInternalState state)
{
   EMineExternalState oldExtState = GetExternalState();
   feIntState = state;
   EMineExternalState newExtState = GetExternalState();
   
   if ( fpDispObj ) fpDispObj->DrawObj();
   
   if(state == emisMoving)
      fpMinefield->IncrementSeq();  
   
   if ( oldExtState != newExtState ) {
      switch ( newExtState ) {
/*     FireMine() now takes care of fired case
         case emsFired:
               ((cMineComp*)fpMfComponent)->IncrementFired();
               if ( (fDetonationData.feDetResult == edetEntityImpact) ||
                    (fDetonationData.feDetResult == edetEntityProximate)   ) {
                  ((cMineComp*)fpMfComponent)->IncrementVehHit();
               } 
            break;
*/            
         case emsOther:
               ((cMineComp*)fpMfComponent)->IncrementOtherDead();
            break;
     }
     fpMinefield->IncrementSeq(); 
  }
      
}

void   cSimMine::FireMine(EMineInternalState state, EBoolean all)
{
   if ( ( state == emisDetonatedMissed ) ||
        ( state == emisDetonatedHit ) ||
        ( state == emisDetonated ) ) {
   
      if ( all )
         fRoundsLeft = 0;
      else
         --fRoundsLeft;
        
        
      ((cMineComp*)fpMfComponent)->IncrementFired( (fRoundsLeft <= 0) ? true : false );
      if (state == emisDetonatedHit) 
         ((cMineComp*)fpMfComponent)->IncrementVehHit();
   }
   
   if ( (fRoundsLeft <= 0) &&
        (feIntState != state) )
      StateChange(state);
}

EBoolean   cSimMine::InMineRange(cVehicle* veh, double range)
{
   if (!fpTracker) return false;
   
   return fpTracker->IsInRange(veh->GetEntType(), range);
}

EBoolean   cSimMine::InMineRange(cEmission* pEm, double range)
{
   if (!fpSensor) return false;
   
   return fpSensor->IsInRange(pEm, range);
}

float     cSimMine::GetDetVulnRange(int detType)
{
   return fpDetonVuln->GetDetVulnRange(detType, fDepth);
}

/*
void    cSimMine::SetDetonationResults()
{
   fDetonLoc =  fGeoLocation;

   feDetonResult = edetDetonation;
   StateChange(emisDetonated);
   //pLink->SetInteractResult(eMineDetonated);

   SetChangeIndicator();
}
*/

void    cSimMine::SetDetonationResults(cLinkVehGeom* pLink, TVehPart* pPart, EBoolean all)
{
   fDetonationData.fFiringEnt = fFireData.fFiringEnt = fId;
   fDetonationData.fDetLocation =  fFireData.fLocation =  fGeoLocation;
   fDetonationData.fFireTccLocation =  fFireData.fFireTccLocation =  fTccLocation;
   fDetonationData.fDetonationType =  fFireData.fDetonationType = GetDetonationType();
   fDetonationData.fWarhead =  fFireData.fWarhead = GetWarhead();
   fDetonationData.fFuze =  fFireData.fFuze = GetFuze();
   

   if ( pLink ) {
      fpTarget = pLink->GetVehicle();
      fTargetType = fpTarget->GetEntType();
      fDetonationData.fTargetEnt = fFireData.fTargetEnt = fpTarget->GetEntityID();
//            fpTarget->GeoToLocalLoc(fGeoLocation, &fLocTargetRef);
      fFireData.fFireRange = pLink->GetHorzRange();
      ((cLinkVehGeom*)pLink)->SnapZ();
      pLink->GetLocTgtRef( & fDetonationData.fLocTargetRef );
         // parts that a mine hits are plows, etc.,
         // so we don't hit the target entity if we hit a part
      if ( pPart ) {
         fDetonationData.fTgtPart = *pPart;
         fDetonationData.feDetResult = edetEntityProximate;
         FireMine(emisDetonated, all);
         pLink->SetInteractResult(eMineDetonated);
      }
      else {
         fDetonationData.feDetResult = GetFuzeParams()->fDetonResult;
         FireMine(emisDetonatedHit, all);
         pLink->SetInteractResult(eHitTarget);
      }
      new cCheckVehDamageMsg(this, fsDamageCheckDelay, fpTarget);
   }
   else {
      fpTarget = NULL;
      fDetonationData.feDetResult = edetDetonation;
      FireMine(emisDetonated, all);
   }
   
   SetChangeIndicator();
}

void    cSimMine::SetDetonationResults(cMineLinkEmiss* pEmLink, EBoolean all)
{
   fDetonationData.fFiringEnt = fFireData.fFiringEnt = fId;
   fDetonationData.fDetLocation =  fFireData.fLocation =  fGeoLocation;
   fDetonationData.fFireTccLocation =  fFireData.fFireTccLocation =  fTccLocation;
   fDetonationData.fDetonationType =  fFireData.fDetonationType = GetDetonationType();
   fDetonationData.fWarhead =  fFireData.fWarhead = GetWarhead();
   fDetonationData.fFuze =  fFireData.fFuze = GetFuze();
      
   fpTarget = pEmLink->GetEmission()->GetVehicle();
   fTargetType = fpTarget->GetEntType();
   fDetonationData.fTargetEnt = fFireData.fTargetEnt = fpTarget->GetEntityID();

   fFireData.fFireRange = pEmLink->GetHorzRange();
   //((cLinkVehGeom*)pLink)->SnapZ();
   pEmLink->GetLocTgtRef( & fDetonationData.fLocTargetRef );
      
//   pVeh->GeoToLocalLoc(fGeoLocation, &fLocTargetRef);
//   fLocTargetRef.y = ftmpLoc.x;
//   fLocTargetRef.x = ftmpLoc.y;
//   fLocTargetRef.z = ftmpLoc.z;
   
   fDetonationData.feDetResult = edetEntityProximate;
   fDetonationData.fTgtPart = new TVehPart();
   fDetonationData.fTgtPart.SetPartType(ePrtMagCm);
   //   fDetonationData.fpTgtPart.fValueType = 0xFFFFFFE0;
   fDetonationData.fTgtPart.fValueType = 0x1F23;
   
   FireMine(emisDetonated, all);
   
   SetChangeIndicator();
}

void   cSimMine::InDetMine(cDetonation* pDet)
{
   if ( feIntState >= emisLowestUpdate )  {
      fpDetonVuln->AssessDeton(pDet, fTccLocation.HorzDistance(pDet->GetTccLoc()));
   }
}

void   cSimMine::InDetTargeted(cDetonation* pDet)
{
   if ( feIntState >= emisLowestUpdate )  {
      TEntCoord origin;      // initialized to zeros

      if ( gfInteract ) {
         *gpInteract << "{ Detonation targeted on mine" << endl;
         *gpInteract << "time: " << GetCurSimTime() * kSimTimeToSec << endl;
         pDet->WriteDetInfo(gpInteract);
      }

      fpDetonVuln->AssessDeton(pDet, origin.HorzDistance(pDet->GetEntityLoc()));

      if ( gfInteract ) {
         *gpInteract << "}\n" << endl;
      }
   }
}

void   cSimMine::WriteEntSumm(ofstream* pOut)
   // writes mine location summary to output file
{
   cMine::WriteEntSumm(pOut);
   
   if (fpTarget) {
      *pOut << endl
            << "Attacked target: ";
      fpTarget->WriteEntSumm(pOut);
      *pOut << " target killed: "
            << (fbKilledTgt == true ? "true" : "false");
   }
}

unsigned long   cPlanMine::GetIconType()
{
   unsigned long icon = cMine::simObjType[esymPlanAt];
   
   if ( fpDbMine ) {
      if ( fpDbMine->IsDirectional(fOptSet) ){
         if ( GetFuzeNameIndex() == TFuzeParam::esenstypeCommandCamDir ||
	      GetFuzeNameIndex() == TFuzeParam::esenstypeAutoCmdCamDir)
	    icon = cMine::simObjType[esymPlanCam];
         else
            icon = cMine::simObjType[esymPlanDir];
      }
      else if ((GetFuzeNameIndex() >= TFuzeParam::esenstypePerDet)&&
               (GetFuzeNameIndex() <= TFuzeParam::esenstypeDirTrack))
	icon = cMine::simObjType[esymPlanSens];
      else if (fpDbMine->GetEntryEntityType().domain == emundomAntipersonnel)
         icon = cMine::simObjType[esymPlanAp];
      else if (fpDbMine->GetEntryEntityType().domain == efunnydomainFalseAlarm)
         icon = cMine::simObjType[esymFalseDet];
   }

   return icon;
}

void cPlanMine::SetMineType (cDbMine* pDbMine)
{
   fpDbMine = pDbMine;
   fOptSet.fMineOpt = fOptSet.fFuzeOpt = fOptSet.fVulnDetOpt = fOptSet.fVulnMechOpt = 0; //CMS2.0B6
   //fTccOrientation = fpDbMine->GetMineParam(fOptSet.fMineOpt)->fTccOrient;
   if (fpDispObj)
      fpDispObj->DrawObj();
}

cPlanMine::cPlanMine(cMineComp* pParent, cMine* pOriginal, EBoolean isBackup):
   cMine( pParent, pOriginal, isBackup)
{
   if ( ! isBackup )
      CreateDispObj();
}

cPlanMine::cPlanMine(cMineComp* pParent, TLocation& tccPt):
   cMine( pParent, tccPt)
{
         // orientation set to component option default, may
         // get overridden 
   if ( fpDbMine )
      fTccOrientation = fpDbMine->GetMineParam(fOptSet.fMineOpt)->fTccOrient;
}

cPlanMine::cPlanMine(cMineComp* pParent, TEntCoord* pMfPt):
   cMine( pParent )
{
   SetMfLoc(pMfPt->x, pMfPt->y);   // sets all coord systems, if it can

   if ( fRefSet == eRefComplete ) {
      fMfLocation.z  += pMfPt->z;
      fTccLocation.z += pMfPt->z;
   }
   else {
      fMfLocation.z = pMfPt->z;
      fRefSet       = eMfRef3d;
   }

   SetCoordTccRef(fTccLocation, fTccOrientation.psi, fTccOrientation.theta, fTccOrientation.phi);
   CreateDispObj();
}

cPlanMine::cPlanMine(cMineComp* pParent, TFlatEntCoord* pMfPt):
   cMine( pParent )
{
   SetMfLoc(pMfPt->x, pMfPt->y);   // sets all coord systems, if it can

   SetCoordTccRef(fTccLocation, fTccOrientation.psi, fTccOrientation.theta, fTccOrientation.phi);
   CreateDispObj();
}

cPlanMine::~cPlanMine()
{
}

void    cSimMine::InitSimMine()
   // basically zeroing out
   //  Constructors call this first, overwrite as needed
{
   fpUpdateMsg   = NULL;
//   fbHitEmiss	 = false;

      // these fields will get overwritten after construction
   fpTracker     = NULL;
   fpSensor      = NULL;
   fpMechanVuln  = NULL;
   fpControl     = NULL;
   fpDetonVuln   = NULL;

   fpController = NULL;

   fpTarget      = NULL;
   fbKilledTgt   = false;
   fKilledTgts   = 0;
    
   fChangeSequence   = 1;
   fbChangeIndicator = false;
   fpMineSetList     = NULL;
   fNextThermalChange = 0;
}

void    cSimMine::SaveMineState()
{
      // write info to mine state file
   if ( fbSimulating && gfMineStateSumm ) {
      *gpMineStateSumm << "  { save state cmd time: "
                       << GetCurSimTime() * kSimTimeToSec
                       << " ";
      WriteEntSumm(gpMineStateSumm);
      *gpMineStateSumm << "}"
                       << endl;
   }
}

cSimMine::cSimMine(cMineComp* , float ) :
      cMine(), fDetonationData(this), fFireData(this)
{
}

cSimMine::cSimMine(cPlanMine* pPlan) :
      cMine(pPlan), fDetonationData(this), fFireData(this)
{
   InitSimMine();
}



cSimMine::~cSimMine()
{

   if (fpUpdateMsg) (fpUpdateMsg->GetMsgList())->DeleteMsg(fpUpdateMsg);
   
   if (fpTracker) delete fpTracker;
   if (fpSensor) delete fpSensor;
   if (fpMechanVuln) delete fpMechanVuln;
   if (fpControl) delete fpControl;
   if (fpDetonVuln) delete fpDetonVuln;
}

void   cFixObj::SimulateFixObj()
   // If fixed objects need updating, structure is here
{
   // new cUpdateFixObjMsg(this);
}

cFixObj::~cFixObj()
{
}

TLinkMine::~TLinkMine()
{}

T2linkMineList::T2linkMineList(TEntityType type, T2link* prev) : 
      T2link(prev)
{
   fType = type;
   fNumMines = 0;
}
      
T2linkMineList::~T2linkMineList()
{ 
}

void    T2linkMineList::AddMine( cMine* pM )
{
   new TLinkMine(pM, fMineList.GetLastLink());
   ++fNumMines;
}

void    T2linkMineList::RemoveMine( cMine* pM )
{
   for ( TLinkMine* pLM = (TLinkMine*) (fMineList.GetFirstLink());
                    pLM != (TLinkMine*) (fMineList.GetNULLLink());
                    pLM = (TLinkMine*) (fMineList.GetNextLink()) ) {
      if ( pLM->GetMine() == pM ) {
         delete pLM;
         --fNumMines;
         break;
      }
   }
}

cMine*   T2linkMineList::GetFirstMine() 
{
   TLinkMine* pLink = (TLinkMine*)(fMineList.GetFirstLink());
   if ( pLink == fMineList.GetNULLLink())
      return NULL;
   else
      return pLink->GetMine();
}

cMine*    T2linkMineList::GetNextMine() 
{
   TLinkMine* pLink = (TLinkMine*)(fMineList.GetNextLink());
   if ( pLink == fMineList.GetNULLLink())
      return NULL;
   else
      return pLink->GetMine();
}

void     T2linkMineSetList::MineChange( cMine* )
{
   fChangeNum++;
   
   if ( fpCpMinesMsg ) {   // already a msg in queue
      if ( fpCpMinesMsg->GetSendTime() > GetCurSimTime() ) {
                  // its a future msg, reschedule for now
         fpCpMinesMsg->GetMsgList()->DeleteMsg( fpCpMinesMsg );
         fpCpMinesMsg = new cSendCpMinesMsg( this, 0 );
      }
   }
   
   else
      fpCpMinesMsg = new cSendCpMinesMsg( this, 0 );
}

T2linkMineSetList::T2linkMineSetList(TEntityType type, cMineComp* pComp, T2link* prev) : 
      T2linkMineList(type, prev)
{
   fpComp = pComp;
   fChangeNum = 0;
   fpCpMinesMsg = NULL;
   gCmsMgr.GetNextEntityId(pComp, &fMineSetId );
}
      
T2linkMineSetList::~T2linkMineSetList()
{ 
   if (fMineSetId.entityNum)
      gCmsMgr.DeleteEntityIdById(fMineSetId.entityNum);
   if (fpCpMinesMsg)
      fpCpMinesMsg->GetMsgList()->DeleteMsg(fpCpMinesMsg);
}

float TMineDetectChar::GetDetectCoeff(TEntityType /*detSensorType*/)
{
    return 1.0;
}

TMineDetectChar::TMineDetectChar()
{   
   fSnowDepth = fWaterDepth = fThermalContrast = 
   fDielectricContrast = fMineAge = 0.0; 
   
   for (int i = 0; i < eNumdetsens; i++ )
      fDetectCoeff[i] = 1.0;
}

/*
void    cEmissVuln::UpdateEmissVuln(cEmissListHead* pEmissList, cSimMine* fpMine, TTimeSim* pWaitTime)
{
   for ( cLinkEmiss*   pEmiss = (cLinkEmiss*) (pEmissList->GetFirstLink());
                       pEmiss != (cLinkEmiss*) (pEmissList->GetNULLLink());
                       pEmiss = (cLinkEmiss*) (pEmissList->GetNextLink()) ) {
         ProcessMagCm(pEmiss, fpMine,  pWaitTime);
   }
}   
	

void    cEmissVuln::ProcessMagCm(cLinkEmiss* pEmLink, cSimMine* fpMine,  TTimeSim*  pWaitTime )
{
   cEmission* pEm = pEmLink->GetEmission();
   EBoolean eResult;

   if ( pEm->GetEmitterName() == DIS203_EMITTER_SYSTEM_MMCM || pEm->GetEmitterName() == 0) {
	eResult = pEm->ProcessEmission(((cMineLinkEmiss*)pEmLink)->GetHorzRange());
   
        if (eResult) {
                     if ( fpMine->GetInternalState() >= emisOn ) {
                        fpMine->SetDetonationResults(); //sets state and interact result
                        new cMineDetonationMsg(fpMine);
                     }
	}
    }
	
}
*/

