/*
$RCSfile: MineEditorCB.cc,v $
$Revision: 1.2 $
$Author: ksnively $
$Date: 1999/05/18 19:33:21 $
$Log: MineEditorCB.cc,v $
Revision 1.2  1999/05/18 19:33:21  ksnively
Ported CMS to compile under IRIX 6.5
Altered make files to allow cms to be compiled under various OS simulataneously
Removed the Startup GUI

Revision 1.1.1.1  1999/02/16 14:54:39  jchappel
Comprehensive Mine Simulator

// Revision 2.0  1998/01/26  21:01:35  ksnively
// Baseline CMS before additions for AP mine replacements.
//
// Revision 2.0  1998/01/26  21:01:35  ksnively
// Baseline CMS before additions for AP mine replacements.
//
// Revision 1.2  1997/12/17  14:38:03  ksnively
// Debugged Minefield duplication routine.
// Added input file "netparams" for reading PDU type enumerations.
// Got rid of warning messages during compilation.
//
// Revision 1.1  1997/12/16  13:59:57  ksnively
// Initial revision
//
// Revision 1.3  1997/10/02  17:53:37  austin
// first working port to modsaf3.0
//
// Revision 1.2  1997/10/02  17:50:22  austin
// first working port to modsaf3.0
//
// Revision 1.2  1997/10/02  17:50:22  austin
// first working port to modsaf3.0
//
// Revision 1.1  1996/10/23  13:54:40  nsipes
// Initial revision
//
// Revision 1.1  1996/10/23  13:54:40  nsipes
// Initial revision
//
// Revision 1.9  1996/07/13  19:04:20  rcarp
// version 1.5b13, fixes bug dragging with two buttons and displays damamged vehicles
//
// Revision 1.8  1996/06/22  13:04:11  rcarp
// deton vuln bug fixes for 1.5b4
//
// Revision 1.7  1996/05/14  16:15:08  rcarp
// refinements and bug fixes for 1.5 delivery
//
// Revision 1.6  1996/05/11  21:35:41  mkappel
// Add mine age.
//
// Revision 1.5  1996/05/08  00:48:49  rcarp
// changes for 1.5, incl user mines, mine params, param i/o, selection
//
// Revision 1.4  1996/04/04  22:16:03  mkappel
// Label minefield on PVD.
//
// Revision 1.3  1996/03/23  14:23:28  rcarp
// improvements to test mode and selection
//
$State: Exp $
*/
 
/*******************************************

   file: MineEditorCB.cc
   
      Copyright 1995 by the Institute for Defense Analyses
      
         Institute for Defense Analyses
         1801 N. Beauregard Street
         Alexandria, Virginia 22311-1772
         703-845-2000
         
      This software was developed by IDA under U. S. Government
      contract.  For distribution information contact:
      
         U. S. Army Night Vision Directorate
         AMSEL RD NV OD CD
         10221 Burbeck Road, suite 430
         Ft. Belvoir VA 22060-5806
      
*********************************************/

/*******************************************

   MineEditorCB.cc
   
      The display interface implementation.
      
      
   
   Created by Michael Kappel
   Modification history:
      created   
      
*********************************************/

#include "Display.h"
#include "Message.h"
#include "Minefield.h"
#include <Xm/List.h>
#include <Xm/RowColumn.h>
#include <Xm/Text.h>
#include <Xm/ToggleB.h>

void cMinefieldEditorWindow::CbScroll (Widget sbar, XtPointer /*wForm*/, 
				       XmScrollBarCallbackStruct *cbs)
{
  cMfComponent*  pComp = (cMfComponent*)gpGuiWin->GetCurMinefield()->GetPerimeter();
  int            count = 0;
  Widget         wMainWin, wPrev;

  if (pComp == NULL) return;

  while (pComp != NULL) {
    wMainWin = pComp->GetCompEntry()->GetMainWin();
    if (count < cbs->value)
      XtUnmanageChild (wMainWin);
    else {
      XtManageChild (wMainWin);
      if (count == cbs->value)
	XtVaSetValues (wMainWin,
		       XmNtopAttachment, XmATTACH_FORM,
		       NULL);
      else
	XtVaSetValues (wMainWin,
		       XmNtopAttachment, XmATTACH_WIDGET,
		       XmNtopWidget, wPrev,
		       NULL);
      wPrev = wMainWin;
    }
    
    count++;
    pComp = pComp->GetNext();
  }

  XtVaSetValues (sbar, XmNmaximum, (count > 1) ? count : 2, NULL);
}

void cMinefieldEditorWindow::CbCreate (Widget /*w*/, XtPointer pObj, 
				  XmAnyCallbackStruct */*cbs*/)
{
  cMinefield* pCurMinefield = gpGuiWin->GetCurMinefield();
//  cCompListArea*  pCompArea = pCurMinefield->GetCompList();
//  pCurMinefield->SetMfName ((char *)XmTextGetString(pCompArea->fwMinefieldName));
  new cCreateCompMsg(pCurMinefield, (ECompType)((int)pObj), true);
}

void cMinefieldEditorWindow::CbEditComp (Widget /*w*/, XtPointer /*pObj*/, 
					 XmAnyCallbackStruct */*cbs*/)
{
   cMinefield*   pCurMinefield = gpGuiWin->GetCurMinefield();
   cMfComponent* pCurMComponent = gpGuiWin->GetCurComponent();
   
   if (pCurMComponent) {
//     cCompListArea*  pCompArea = pCurMinefield->GetCompList();
//     pCurMinefield->SetMfName ((char *)XmTextGetString(pCompArea->fwMinefieldName));
     new cEditCompMsg(pCurMComponent);
     pCurMComponent->StartEditingComp();
   }
}

void cMinefieldEditorWindow::CbDuplicateComp (Widget /*w*/, XtPointer /*pObj*/, 
					      XmAnyCallbackStruct */*cbs*/)
{
   float    daz = 0.0;
   double   dx = 100.0;
   double   dy = 100.0;
   
   gMfieldMgr.DuplicateComponents(CompSelectionCount(), MakeCompSelectionList(),
               dx, dy, daz);
      // deselect the comps
//   gpGuiWin->SetSelection( false, gpGuiWin->GetCurMinefield() );
}

void cMinefieldEditorWindow::CbDeleteComp (Widget /*w*/, XtPointer /*pObj*/, 
					   XmAnyCallbackStruct */*cbs*/)
{
  gpGuiWin->DialogMessage (cGuiWindow::eDialogWarning, 
			   (XtCallbackProc)CbDeleteOK,
			   "Are you sure that you want to\ndelete the selected component?");
}

void cMinefieldEditorWindow::CbDeleteOK (Widget fs, XtPointer /*client_data*/, 
					 XmAnyCallbackStruct */*cbs*/)
{
   gMfieldMgr.DeleteComponents(CompSelectionCount(), MakeCompSelectionList());
      // deselect the comps
   gpGuiWin->SetSelection( false, gpGuiWin->GetCurMinefield() );

   XtDestroyWidget (fs);
}

void cMinefieldEditorWindow::CbMoveMf (Widget /*w*/, XtPointer /*pObj*/, 
				       XmAnyCallbackStruct */*cbs*/)
{
  cPerimeter*  pPerim = (cPerimeter*)(gpGuiWin->GetCurMinefield()->GetPerimeter());
  gpGuiWin->SetSelection(false, gpGuiWin->GetCurMinefield(), pPerim);
  new cEditCompMsg(pPerim);
  gpGuiWin->DialogMessage (cGuiWindow::eDialogInfo, NULL, 
			   "Move minefield to new location by clicking\nand dragging (left mouse button) an edge\nof the minefield perimeter.  All minefield\nobjects will be moved along with it.");
  pPerim->StartEditingComp();
}

void cMinefieldEditorWindow::CbDone (Widget /*w*/, XtPointer /*pObj*/, 
				XmPushButtonCallbackStruct */*cbs*/)
{
   //cMinefieldEditorWindow*   pWin = (cMinefieldEditorWindow*)pObj;
   char           *str;
   XmString        xmstr;
   Widget          widget;
   cMinefield*     pCurMinefield = gpGuiWin->GetCurMinefield();
   cCompListArea*  pCompArea = pCurMinefield->GetCompList();

//   pCurMinefield->SetMfName ((char *)XmTextGetString(pCompArea->fwMinefieldName));

   XtVaGetValues (pCompArea->fwForceMenu,
		  XmNmenuHistory, &widget,
		  NULL);
   XtVaGetValues (widget, 
		  XmNlabelString, &xmstr,
		  NULL);
   XmStringGetLtoR (xmstr, XmSTRING_DEFAULT_CHARSET, &str);
   if (strcmp (str, "Friendly") == 0)
     pCurMinefield->SetMfForce (eFriendly);
   else if (strcmp (str, "Enemy") == 0)
     pCurMinefield->SetMfForce (eEnemy);
   else
     pCurMinefield->SetMfForce (eNeutral);

   pCurMinefield->GetMfSumm()->ShowInfo();
   pCurMinefield->StopEditingMf();

/*
   if (pWin->fpMfCopy) {
     cMinefield* ppMfList[1];
     ppMfList[0] =  pWin->fpMfCopy;
     gMfieldMgr.DeleteMinefields (1, ppMfList);
     pWin->fpMfCopy = NULL;
   }
*/
   gpGuiWin->ShowEditor(cGuiWindow::eEditMfStatus);
}

void cMinefieldEditorWindow::CbCancel (Widget /*w*/, XtPointer /*pObj*/, 
				  XmPushButtonCallbackStruct */*cbs*/)
{
   cMinefield*    pCurMinefield = gpGuiWin->GetCurMinefield();
   Assert( pCurMinefield != NULL, kerrValidityCheck, "cMinefieldEditorWindow::CbCancel");

   if ( pCurMinefield->HasMfBackup() ) {
      gpGuiWin->SetSelection( false, pCurMinefield);   // removes selection of components
      pCurMinefield->RestoreMfBackup();
      pCurMinefield->GetMfSumm()->ShowInfo();
      pCurMinefield->StopEditingMf();
   }
      
   else {
     gpGuiWin->SetSelection ( false, (cMinefield*)NULL);
     cMinefield** ppMfList = new cMinefield* [1];
     ppMfList[0] =  pCurMinefield;
     gMfieldMgr.DeleteMinefields (1, ppMfList);
   }
   gpGuiWin->ShowEditor(cGuiWindow::eEditMfStatus);
}

int               cMinefieldEditorWindow::CompSelectionCount()
{
   int count = 0;
   
   for ( cMfComponent* pC = gpGuiWin->GetCurMinefield()->GetFirstComp(); pC; pC = pC->GetNext() )
      if ( pC->IsSelected() )
         count++;
   return count;
}

cMfComponent**    cMinefieldEditorWindow::MakeCompSelectionList()
{
   cMfComponent **ppCompList, *pC;
   int          count = CompSelectionCount();

   ppCompList = new cMfComponent* [count];
   count = 0;
   for ( pC = gpGuiWin->GetCurMinefield()->GetFirstComp(); pC; pC = pC->GetNext()) {
      if ( pC->IsSelected() )
         ppCompList[count++] = pC;
   }
   
   return ppCompList;
}

void cMinefieldEditorWindow::ShowEdWindow()
{
  cMinefield*    pMinefield = gpGuiWin->GetCurMinefield();
  cMfComponent*  pComp = (cMfComponent*)pMinefield->GetPerimeter();
  
  pMinefield->GetCompList()->ShowInfo();

  if (((cPerimeter*)pComp)->GetNumPoints() < 3)
    gpGuiWin->SetSelection( false, gpGuiWin->GetCurMinefield(), pComp );

  while (pComp != NULL) {
    pComp->GetCompEntry()->ShowInfo();
    pComp = pComp->GetNext();
  }

  SetButtonState ();
  XtManageChild (fwMainWin);
}

void cMinefieldEditorWindow::SetButtonState()
{
   cMinefield*   pCurMinefield = gpGuiWin->GetCurMinefield();
   if (pCurMinefield == NULL) return;

   if (pCurMinefield->GetPerimeter()->GetNumPoints() >= 3) {
     XtSetSensitive (fwDoneButton, TRUE);
     XtSetSensitive (fwMoveMf, TRUE);
     XtSetSensitive (fwCreateIndiv, TRUE);
     XtSetSensitive (fwCreateGrid, TRUE);
     XtSetSensitive (fwCreateRow, TRUE);
   }
   else {
     XtSetSensitive (fwDoneButton, FALSE);
     XtSetSensitive (fwMoveMf, FALSE);
     XtSetSensitive (fwCreateIndiv, FALSE);
     XtSetSensitive (fwCreateGrid, FALSE);
     XtSetSensitive (fwCreateRow, FALSE);
   }

   int count = CompSelectionCount();

   if ( count == 0 ) {
      XtSetSensitive (fwEditComp, FALSE);
      XtSetSensitive (fwDeleteComp, FALSE);
      XtSetSensitive (fwDuplicateComp, FALSE);
   }
   
   else if (count == 1 ) {
      XtSetSensitive (fwEditComp, TRUE);
      if (gpGuiWin->GetCurComponent()->GetCompType() == eCompPerim) {
         XtSetSensitive (fwDeleteComp, FALSE);
         XtSetSensitive (fwDuplicateComp, FALSE);
      }
      else {
         XtSetSensitive (fwDeleteComp, TRUE);
         XtSetSensitive (fwDuplicateComp, TRUE);
      }
   }
   
   else {   // multiple selections
      XtSetSensitive (fwEditComp, FALSE);
      XtSetSensitive (fwDeleteComp, TRUE);
      XtSetSensitive (fwDuplicateComp, TRUE);
   }
}

void  cCompSummLine::CbSelect(Widget /*w*/, XtPointer pObj, 
                               XmPushButtonCallbackStruct *cbs)
{
   cMfComponent*  pComp = ((cCompSummLine*)pObj)->fpComp;
   EBoolean       multiSelect = false;

   if (cbs->event->xbutton.state & ShiftMask)  //shift key for multi-select
      multiSelect = true;
      
   gpGuiWin->SetSelection( multiSelect, pComp->GetMinefield(),  pComp);
}

void cCompSummLine::CbSimToggle (Widget w, XtPointer pObj, 
				  XmToggleButtonCallbackStruct *cbs)
{
  cMineComp*     pComp = (cMineComp*) (((cCompSummLine*)pObj)->fpComp);
  EBoolean       multiSelect = false;

  if (cbs->event->xbutton.state & ShiftMask)  //shift key for multi-select
     multiSelect = true;

  pComp->SetSimState 
    ((EBoolean)XmToggleButtonGetState (w));

  gpGuiWin->SetSelection( multiSelect, pComp->GetMinefield(),  pComp );
}

void cCompSummLine::CbOnToggle (Widget w, XtPointer pObj, 
				 XmToggleButtonCallbackStruct *cbs)
{
  cMineComp*     pComp = (cMineComp*) (((cCompSummLine*)pObj)->fpComp);
  EBoolean       multiSelect = false;

  if (cbs->event->xbutton.state & ShiftMask)  //shift key for multi-select
     multiSelect = true;

  pComp->SetOnState 
    ((EBoolean)XmToggleButtonGetState (w));

  gpGuiWin->SetSelection( multiSelect, pComp->GetMinefield(),  pComp );
}

void cCompSummLine::ShowInfo ()
{
}

void cMineCompSummLine::ShowInfo ()
{
  char        str[20];
  XmString    xmstr;
  cMineComp*  pComp = (cMineComp*)fpComp;

  XtVaSetValues (fwSimToggle,
		 XmNset, pComp->GetSimState(),
		 NULL);

  XtVaSetValues (fwOnToggle,
		 XmNset, pComp->GetOnState(),
		 NULL);

  sprintf (str, "%d", pComp->GetNumMines());
  xmstr = XmStringCreateSimple (str);
  XtVaSetValues (fwNumMines,
		 XmNlabelString, xmstr,
		 NULL);
  XmStringFree (xmstr);

  sprintf (str, "%.2f", pComp->GetCompMineDepth() * kMeterToInch);
  xmstr = XmStringCreateSimple (str);
  XtVaSetValues (fwMineDepth,
		 XmNlabelString, xmstr,
		 NULL);
  XmStringFree (xmstr);

  sprintf (str, "%.2f", pComp->GetCompHoursInPlace());
  xmstr = XmStringCreateSimple (str);
  XtVaSetValues (fwMineAge,
		 XmNlabelString, xmstr,
		 NULL);
  XmStringFree (xmstr);

  if (fpComp->GetCompType() == eCompGrid || 
      fpComp->GetCompType() == eCompRow) {
    if (fpComp->GetCompType() == eCompGrid)
      sprintf (str, "%.2f", ((cGridComp*)fpComp)->GetSpacing());
    else
      sprintf (str, "%.2f", ((cRowComp*)fpComp)->GetSpacing());
    xmstr = XmStringCreateSimple (str);
    XtVaSetValues (fwMineSpacing,
		   XmNlabelString, xmstr,
		   NULL);
    XmStringFree (xmstr);
  }

  if (pComp->GetDbEntity())
     xmstr = XmStringCreateSimple ((char*)pComp->GetEntType().GetMunitionDomainText());
  else
    xmstr = XmStringCreateSimple ("Domain not set");
  XtVaSetValues (fwDomain,
		 XmNlabelString, xmstr,
		 NULL);
  XmStringFree (xmstr);
  
  if (pComp->GetDbEntity())
    xmstr = XmStringCreateSimple ((char*)pComp->GetDbEntity()->GetEntryEntityName());
  else
    xmstr = XmStringCreateSimple ("Type not set");
  XtVaSetValues (fwMineType,
		 XmNlabelString, xmstr,
		 NULL);
  XmStringFree (xmstr);
}

void cPerimSummLine::ShowInfo ()
{
  char        str[20];
  XmString    xmstr;

  sprintf (str, "%d", ((cPerimeter*)fpComp)->GetNumPoints());
  xmstr = XmStringCreateSimple (str);
  XtVaSetValues (fwNumMines,
		 XmNlabelString, xmstr,
		 NULL);
}

void cCompListArea::ShowInfo ()
{
   Widget  widget;

   cMinefield* pCurMinefield = gpGuiWin->GetCurMinefield();

   if (pCurMinefield) {
      XtVaSetValues (fwMinefieldName,
   		  XmNvalue, pCurMinefield->GetMfName(),
   		  NULL);
   
      switch (pCurMinefield->GetMfType()) {
   
      case cMinefield::eDeliberate:
        widget = fwDeliberateOption;
        break;
      case cMinefield::eHasty:
        widget = fwHastyOption;
        break;
   /*
      case cMinefield::eTactical:
        widget = fwTacticalOption;
        break;
   */
      }
   
      XtVaSetValues (fwTypeMenu,
   		  XmNmenuHistory, widget,
   		  NULL);
   
      switch (pCurMinefield->GetForce()) {
   
      case eFriendly:
        widget = fwFriendlyOption;
        break;
      case eEnemy:
        widget = fwEnemyOption;
        break;
      default:
        widget = fwOtherOption;
        break;
      }
   
      XtVaSetValues (fwForceMenu,
   		  XmNmenuHistory, widget,
   		  NULL);
   
      XtManageChild (fwMainWin);
   }
}

void cCompListArea::CbNameChange (Widget w, XtPointer /*pObj*/,
				  XmTextVerifyCallbackStruct* /*cbs*/)
{
  cMinefield* pCurMinefield = gpGuiWin->GetCurMinefield();
  pCurMinefield->SetMfName ((char *)XmTextGetString(w));
}
