/*
$RCSfile: MineType.cc,v $
$Revision: 1.2 $
$Author: ksnively $
$Date: 1999/04/22 22:20:04 $
$Log: MineType.cc,v $
Revision 1.2  1999/04/22 22:20:04  ksnively
Sreamlined radio communication routines.  Allowed to send to unlimited number of receivers.

Revision 1.1.1.1  1999/02/16 14:54:40  jchappel
Comprehensive Mine Simulator

// Revision 2.0  1998/01/26  21:01:35  ksnively
// Baseline CMS before additions for AP mine replacements.
//
// Revision 2.0  1998/01/26  21:01:35  ksnively
// Baseline CMS before additions for AP mine replacements.
//
// Revision 1.2  1997/12/17  14:38:03  ksnively
// Debugged Minefield duplication routine.
// Added input file "netparams" for reading PDU type enumerations.
// Got rid of warning messages during compilation.
//
// Revision 1.1  1997/12/16  13:59:57  ksnively
// Initial revision
//
// Revision 1.3  1997/10/02  17:53:37  austin
// first working port to modsaf3.0
//
// Revision 1.2  1997/10/02  17:50:22  austin
// first working port to modsaf3.0
//
// Revision 1.2  1997/10/02  17:50:22  austin
// first working port to modsaf3.0
//
// Revision 1.1  1996/10/23  13:54:40  nsipes
// Initial revision
//
// Revision 1.1  1996/10/23  13:54:40  nsipes
// Initial revision
//
// Revision 1.12  1996/06/19  19:05:45  rcarp
// revisions for mine vulnerability, version 1.5b2
//
// Revision 1.11  1996/05/23  18:42:07  mkappel
// Use DbMine list accessors.
//
// Revision 1.10  1996/05/15  15:01:14  mkappel
// Set fuze option menus.
//
// Revision 1.9  1996/05/14  20:23:49  rcarp
// restores 1.7 changes
//
// Revision 1.8  1996/05/14  16:15:08  rcarp
// refinements and bug fixes for 1.5 delivery
//
// Revision 1.7  1996/05/11  22:32:35  mkappel
// Use user data.
//
// Revision 1.6  1996/05/11  18:44:46  mkappel
// Set list size constant.
//
// Revision 1.5  1996/05/11  16:49:17  mkappel
// New mine type selector and fuze options.
//
// Revision 1.4  1996/05/08  00:45:10  rcarp
// changes for 1.5, incl user mines, mine params, param i/o, selection
//
// Revision 1.3  1996/03/23  14:25:40  rcarp
// improvements to test mode and selection
//
// Revision 1.2  1996/03/13  00:12:33  mkappel
// Create scrolling set of toggles for mines.
//
// Revision 1.1  1996/01/23  16:52:30  rcarp
// Initial revision
//
$State: Exp $
*/
 
/*******************************************

   file: MineType.cc
   
      Copyright 1995 by the Institute for Defense Analyses
      
         Institute for Defense Analyses
         1801 N. Beauregard Street
         Alexandria, Virginia 22311-1772
         703-845-2000
         
      This software was developed by IDA under U. S. Government
      contract.  For distribution information contact:
      
         U. S. Army Night Vision Directorate
         AMSEL RD NV OD CD
         10221 Burbeck Road, suite 430
         Ft. Belvoir VA 22060-5806
      
*********************************************/

/*******************************************

   MineType.cc
   
      The display interface implementation.
      
      
   
   Created by Michael Kappel
   Modification history:
      created   
      
*********************************************/

#include "Display.h"
#include "MineType.h"
#include "EntityDB.h"

#include <Xm/Form.h>
#include <Xm/Frame.h>
#include <Xm/Label.h>
#include <Xm/LabelG.h>
#include <Xm/List.h>
#include <Xm/MenuShell.h>
#include <Xm/PushBG.h>
#include <Xm/RowColumn.h>
#include <Xm/TextF.h>


cMineTypeSelector::cMineTypeSelector (Widget wParent)
{
   Widget        wForm, wLabel, wRowCol, wRowCol2, wMenu, wItem;
   XmString      xmstr;
   Arg           args[3];
   int           i, count, index;
   cDbMine     **retbuf, *root = (cDbMine*)gMineDbMgr.GetRoot();

   fwTypeForm = 
     XtVaCreateManagedWidget ("frame", 
			      xmFrameWidgetClass, wParent,
			      XmNshadowThickness, 4, 
			      NULL);
   wForm = 
     XtVaCreateManagedWidget ("mine_type_form", 
			      xmFormWidgetClass, fwTypeForm, 
			      NULL);

   wLabel = 
     XtVaCreateManagedWidget ("Mine Type", 
			      xmLabelGadgetClass, wForm,
			      XmNtopAttachment, XmATTACH_FORM,
			      XmNleftAttachment, XmATTACH_FORM,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      NULL);
   wRowCol = 
     XtVaCreateManagedWidget ("rowcol", 
			      xmRowColumnWidgetClass, wForm, 
			      XmNorientation, XmVERTICAL,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, wLabel,
			      XmNleftAttachment, XmATTACH_FORM,
			      NULL);

   wMenu = XmCreatePulldownMenu (wRowCol, "_pulldown", NULL, 0);
   xmstr = XmStringCreateSimple ("Unit");
   XtSetArg (args[0], XmNsubMenuId, wMenu);
   XtSetArg (args[1], XmNlabelString, xmstr);
   fwUnitMenu = 
     XmCreateOptionMenu (wRowCol, "menu", args, 2);

// kludge until unit enum specified
   wItem =
     XtVaCreateManagedWidget ("Mine", 
			      xmPushButtonGadgetClass, wMenu, 
			      NULL);
   wItem =
     XtVaCreateManagedWidget ("Cluster", 
			      xmPushButtonGadgetClass, wMenu, 
			      XmNsensitive, FALSE,
			      NULL);
   XtAddCallback (wItem, XmNactivateCallback,
		  (XtCallbackProc)CbUnit, 
		  (XtPointer)root);
// end kludge

   XtManageChild (fwUnitMenu);
   XmStringFree (xmstr);

   wMenu = XmCreatePulldownMenu (wRowCol, "_pulldown", NULL, 0);
   xmstr = XmStringCreateSimple ("Domain");
   XtSetArg (args[0], XmNsubMenuId, wMenu);
   XtSetArg (args[1], XmNlabelString, xmstr);
   fwDomainMenu = 
     XmCreateOptionMenu (wRowCol, "menu", args, 2);

   wItem =
     XtVaCreateManagedWidget ("All",
			      xmPushButtonGadgetClass, wMenu, 
			      NULL);
   XtAddCallback (wItem, XmNactivateCallback,
		  (XtCallbackProc)CbDomain, 
		  (XtPointer)root);

   root->GetDomainList (&retbuf, &count, &index);
   for (i = 0; i < count; i++) {
     wItem =
       XtVaCreateManagedWidget (retbuf[i]->GetEntryEntityName(),
				xmPushButtonGadgetClass, wMenu, 
				NULL);
     XtAddCallback (wItem, XmNactivateCallback,
		    (XtCallbackProc)CbDomain, 
		    (XtPointer)retbuf[i]);
   }
   XtManageChild (fwDomainMenu);
   XmStringFree (xmstr);

   wMenu = XmCreatePulldownMenu (wRowCol, "_pulldown", NULL, 0);
   xmstr = XmStringCreateSimple ("Category");
   XtSetArg (args[0], XmNsubMenuId, wMenu);
   XtSetArg (args[1], XmNlabelString, xmstr);
   fwCategoryMenu = 
     XmCreateOptionMenu (wRowCol, "menu", args, 2);

   wItem = 
     XtVaCreateManagedWidget ("All",
			      xmPushButtonGadgetClass, wMenu, 
			      NULL);
   XtAddCallback (wItem, XmNactivateCallback,
		  (XtCallbackProc)CbCategory, 
		  (XtPointer)0);
   XtManageChild (fwCategoryMenu);
   XmStringFree (xmstr);

   wMenu = XmCreatePulldownMenu (wRowCol, "_pulldown", NULL, 0);
   xmstr = XmStringCreateSimple ("Country");
   XtSetArg (args[0], XmNsubMenuId, wMenu);
   XtSetArg (args[1], XmNlabelString, xmstr);
   fwCountryMenu = 
     XmCreateOptionMenu (wRowCol, "menu", args, 2);

   wItem =
     XtVaCreateManagedWidget ("All",
			      xmPushButtonGadgetClass, wMenu, 
			      NULL);
   XtAddCallback (wItem, XmNactivateCallback,
		  (XtCallbackProc)CbCountry, 
		  (XtPointer)kMatchAllShort);
   XtManageChild (fwCountryMenu);
   XmStringFree (xmstr);

   XtSetArg (args[0], XmNselectionPolicy, XmBROWSE_SELECT);
   XtSetArg (args[1], XmNwidth, 150);
   XtSetArg (args[2], XmNlistSizePolicy, XmCONSTANT);

   fwMineTypeList = 
     XmCreateScrolledList (wForm, "list", args, 3);
   XtVaSetValues (XtParent(fwMineTypeList),
		  XmNtopAttachment, XmATTACH_FORM,
		  XmNtopOffset, 5,
		  XmNleftAttachment, XmATTACH_WIDGET,
		  XmNleftWidget, wRowCol,
		  XmNbottomAttachment, XmATTACH_FORM,
		  XmNbottomOffset, 5,
		  NULL);
   XtAddCallback (fwMineTypeList, XmNbrowseSelectionCallback,
		  (XtCallbackProc)CbMineType, this);
   XtManageChild (fwMineTypeList);

   wRowCol = 
     XtVaCreateManagedWidget ("rowcol", 
			      xmRowColumnWidgetClass, wForm, 
			      XmNorientation, XmVERTICAL,
			      XmNtopAttachment, XmATTACH_FORM,
			      XmNleftAttachment, XmATTACH_WIDGET,
			      XmNleftWidget, XtParent(fwMineTypeList),
			      XmNrightAttachment, XmATTACH_FORM,
			      NULL);

   wMenu = XmCreatePulldownMenu (wRowCol, "_pulldown", NULL, 0);
   xmstr = XmStringCreateSimple ("Fuze");
   XtSetArg (args[0], XmNsubMenuId, wMenu);
   XtSetArg (args[1], XmNlabelString, xmstr);
   fwFuzeMenu =
     XmCreateOptionMenu (wRowCol, "menu", args, 2);
   wItem =
     XtVaCreateManagedWidget ("N/A",
			      xmPushButtonGadgetClass, wMenu, 
			      XmNuserData, 0,
			      NULL);
   XtManageChild (fwFuzeMenu);
   XmStringFree (xmstr);

   wMenu = XmCreatePulldownMenu (wRowCol, "_pulldown", NULL, 0);
   xmstr = XmStringCreateSimple ("Anti-Handling");
   XtSetArg (args[0], XmNsubMenuId, wMenu);
   XtSetArg (args[1], XmNlabelString, xmstr);
   fwAntiHandlingMenu =
     XmCreateOptionMenu (wRowCol, "menu", args, 2);
   XtVaCreateManagedWidget ("No",
			    xmPushButtonGadgetClass, wMenu, 
			    XmNuserData, eNo,
			    NULL);
   XtVaCreateManagedWidget ("Yes",
			    xmPushButtonGadgetClass, wMenu, 
			    XmNuserData, eYes,
			    NULL);
   XtManageChild (fwAntiHandlingMenu);
   XmStringFree (xmstr);

   wMenu = XmCreatePulldownMenu (wRowCol, "_pulldown", NULL, 0);
   xmstr = XmStringCreateSimple ("Blast Hardened");
   XtSetArg (args[0], XmNsubMenuId, wMenu);
   XtSetArg (args[1], XmNlabelString, xmstr);
   fwBlastHardenedMenu =
     XmCreateOptionMenu (wRowCol, "menu", args, 2);
   XtVaCreateManagedWidget ("No",
			    xmPushButtonGadgetClass, wMenu, 
			    XmNuserData, eNo,
			    NULL);
   XtVaCreateManagedWidget ("Yes",
			    xmPushButtonGadgetClass, wMenu, 
			    XmNuserData, eYes,
			    NULL);
   XtManageChild (fwBlastHardenedMenu);
   XmStringFree (xmstr);

   wMenu = XmCreatePulldownMenu (wRowCol, "_pulldown", NULL, 0);
   xmstr = XmStringCreateSimple ("Self Destruct (hrs.)");
   XtSetArg (args[0], XmNsubMenuId, wMenu);
   XtSetArg (args[1], XmNlabelString, xmstr);
   fwSelfDestructMenu =
     XmCreateOptionMenu (wRowCol, "menu", args, 2);
   wItem =
     XtVaCreateManagedWidget ("N/A",
			      xmPushButtonGadgetClass, wMenu, 
			      NULL);
   XtManageChild (fwSelfDestructMenu);
   XmStringFree (xmstr);

   wRowCol2 = 
     XtVaCreateManagedWidget ("rowcol", 
			      xmRowColumnWidgetClass, wRowCol, 
			      XmNorientation, XmHORIZONTAL,
			      NULL);
   wLabel = 
     XtVaCreateManagedWidget ("Target Count",
			      xmLabelGadgetClass, wRowCol2,
			      NULL);
   fwTargetCountText =
     XtVaCreateManagedWidget ("textbox",
			      xmTextFieldWidgetClass, wRowCol2,
			      XmNcolumns, 7,
			      NULL);

   fpDbMine = root;
   fCountry = kMatchAllShort;
}

cMineTypeSelector::~cMineTypeSelector ()
{
}

void cMineTypeSelector::CbUnit (Widget /*w*/, XtPointer /*pObj*/,
				XmPushButtonCallbackStruct */*cbs*/)
{
/*
  cMineComp*             pMineComp = (cMineComp*)(gpGuiWin->GetCurComponent());
  cMineCompEditorWindow* pCompEditor = 
                           (cMineCompEditorWindow*)gpGuiWin->GetCurEditor();
  cMineTypeSelector*     pMineType = pCompEditor->GetMineTypeSelector();

  pMineType->fpDbMine = (cDbMine*)pObj;
  pMineType->ResetDomain();
*/
}

void cMineTypeSelector::CbDomain (Widget /*w*/, XtPointer pObj,
				  XmPushButtonCallbackStruct */*cbs*/)
{
  cMineComp*             pMineComp = (cMineComp*)(gpGuiWin->GetCurComponent());
  cMineCompEditorWindow* pCompEditor = 
                           (cMineCompEditorWindow*)gpGuiWin->GetCurEditor();
  cMineTypeSelector*     pMineType = pCompEditor->GetMineTypeSelector();
  cDbMine*               pDbMine = (cDbMine*)pObj;

  pMineType->fpDbMine = pDbMine;
  pMineType->ResetCategory();
}

void cMineTypeSelector::CbCategory (Widget /*w*/, XtPointer pObj,
				    XmPushButtonCallbackStruct */*cbs*/)
{
  cMineComp*             pMineComp = (cMineComp*)(gpGuiWin->GetCurComponent());
  cMineCompEditorWindow* pCompEditor = 
                           (cMineCompEditorWindow*)gpGuiWin->GetCurEditor();
  cMineTypeSelector*     pMineType = pCompEditor->GetMineTypeSelector();
  cDbMine               *pDbMine = (cDbMine*)pObj, **retbuf;
  int                    count, index;

  if (pDbMine)
    pMineType->fpDbMine = pDbMine;
  else {
    /* set to domain's DbMine */
    pMineType->fpDbMine->GetDomainList (&retbuf, &count, &index);
    pMineType->fpDbMine = retbuf[index];
  
    delete[] retbuf;
  }
		     
  pMineType->ResetCountry();
}

void cMineTypeSelector::CbCountry (Widget /*w*/, XtPointer pObj,
				   XmPushButtonCallbackStruct */*cbs*/)
{
  cMineComp*             pMineComp = (cMineComp*)(gpGuiWin->GetCurComponent());
  cMineCompEditorWindow* pCompEditor = 
                           (cMineCompEditorWindow*)gpGuiWin->GetCurEditor();
  cMineTypeSelector*     pMineType = pCompEditor->GetMineTypeSelector();

  pMineType->fCountry = (uint)pObj;
  pMineType->ShowMineType();
}

void cMineTypeSelector::CbFuze (Widget /*w*/, XtPointer pObj,
				XmPushButtonCallbackStruct */*cbs*/)
{
  cMineComp*             pMineComp = (cMineComp*) (gpGuiWin->GetCurComponent());
  cMineCompEditorWindow* pCompEditor = 
                           (cMineCompEditorWindow*)gpGuiWin->GetCurEditor();
  cMineTypeSelector*     pMineType = pCompEditor->GetMineTypeSelector();

  pMineType->ResetFuzeOpt (((TFuzeParam*)pObj)->GetOptSelector());

  //Set the widget sensitivity
  pCompEditor->SetWidgetState();
}

void cMineTypeSelector::ResetFuzeOpt (TFuzeOptionSelector* pFuzeOptSel)
{
  Widget                 wMenu, wItem, *widget_list;
  int                    count, i;
  float                 *time_list;
  char                   buf[20], *str;
  XmString               xmstr;

  if (pFuzeOptSel == NULL) {
    XtSetSensitive (fwAntiHandlingMenu,  FALSE);
    XtSetSensitive (fwBlastHardenedMenu, FALSE);
    XtSetSensitive (fwSelfDestructMenu,  FALSE);
    XtSetSensitive (fwTargetCountText,   FALSE);
    return;
  }

  XtVaGetValues (fwAntiHandlingMenu, 
		 XmNsubMenuId, &wMenu,
		 NULL);
  XtVaGetValues (wMenu, 
		 XmNnumChildren, &count,
		 XmNchildren, &widget_list,
		 NULL);

  EYesNoOpt anti_handling = pFuzeOptSel->GetAntihandlingOpt();
  if (anti_handling == eBoth) 
    XtVaSetValues (fwAntiHandlingMenu,
		   XmNmenuHistory, widget_list[0],
		   NULL);
  else
    XtVaSetValues (fwAntiHandlingMenu,
		   XmNmenuHistory, widget_list[(int)anti_handling],
		   NULL);
  XtSetSensitive (fwAntiHandlingMenu, (anti_handling == eBoth));

  EYesNoOpt blast_hardened = pFuzeOptSel->GetBlasthardOpt();
  if (blast_hardened == eBoth) 
    XtVaSetValues (fwBlastHardenedMenu,
		   XmNmenuHistory, widget_list[0],
		   NULL);
  else
    XtVaSetValues (fwBlastHardenedMenu,
		   XmNmenuHistory, widget_list[(int)blast_hardened],
		   NULL);
  XtSetSensitive (fwBlastHardenedMenu, (blast_hardened == eBoth));

  /* clear self destruct menu except first entry */
  XtVaGetValues (fwSelfDestructMenu, 
		 XmNsubMenuId, &wMenu,
		 NULL);
  XtVaGetValues (wMenu, 
		 XmNnumChildren, &count,
		 XmNchildren, &widget_list,
		 NULL);
  for (i = count - 1; i > 0; i--)
    XtDestroyWidget (widget_list[i]);

  pFuzeOptSel->GetDestTimeOpt (&count, &time_list);
  if (count > 0) {
    for (i = 0; i < count; i++) {
      sprintf (buf, "%.1f", time_list[i]);
      if (i == 0) {
	xmstr = XmStringCreateSimple (buf);
	XtVaSetValues (widget_list[0],
		       XmNlabelString, xmstr,
		       NULL);
	XmStringFree (xmstr);
      }
      else
	wItem =
	  XtVaCreateManagedWidget (buf,
				   xmPushButtonGadgetClass, wMenu, 
				   NULL);
    }
  }
  else {
    xmstr = XmStringCreateSimple ("N/A");
    XtVaSetValues (widget_list[0],
		   XmNlabelString, xmstr,
		   NULL);
    XmStringFree (xmstr);
  }
  XtSetSensitive (fwSelfDestructMenu, (count > 0));

  if (pFuzeOptSel->GetTgtCountOpt()) {
    XtSetSensitive (fwTargetCountText, TRUE);
    XtVaGetValues (fwTargetCountText,
		   XmNvalue, &str,
		   NULL);
    if (strcmp (str, "N/A") == 0 || strcmp (str, "") == 0)
      XtVaSetValues (fwTargetCountText,
		     XmNvalue, "0",
		     NULL);
  }
  else
    XtVaSetValues (fwTargetCountText,
		   XmNsensitive, FALSE,
		   XmNvalue, "N/A",
		   NULL);
}

cDbMine* cMineTypeSelector::ResetCategory ()
{
  int                    i, count, index = -1;
  cDbMine              **retbuf, *retDbMine = NULL, *root = (cDbMine*)gMineDbMgr.GetRoot();
  Widget                *widget_list, wItem, wMenu;

  /* clear category menu except first option ('All') */
  XtVaGetValues (fwCategoryMenu, 
		 XmNsubMenuId, &wMenu,
		 NULL);
  XtVaGetValues (wMenu, 
		 XmNnumChildren, &count,
		 XmNchildren, &widget_list,
		 NULL);
  for (i = count - 1; i > 0; i--)
    XtDestroyWidget (widget_list[i]);

  if (fpDbMine != root) { /* not 'All' */
    fpDbMine->GetSubcatList (&retbuf, &count, &index);
    for (i = 0; i < count; i++) {
      wItem =
	XtVaCreateManagedWidget (retbuf[i]->GetEntryEntityName(),
				 xmPushButtonGadgetClass, wMenu, 
				 NULL);
      XtAddCallback (wItem, XmNactivateCallback,
		     (XtCallbackProc)CbCategory, 
		     (XtPointer)retbuf[i]);
      if (i == index)
	XtVaSetValues (fwCategoryMenu,
		       XmNmenuHistory, wItem,
		       NULL);
    }
    if ( count > 0 )
      XtSetSensitive (fwCategoryMenu, TRUE);
    else
      XtSetSensitive (fwCategoryMenu, FALSE);
      
    if (index >= 0)
       retDbMine = retbuf[index];
    delete[] retbuf;
  }
  else
    XtSetSensitive (fwCategoryMenu, FALSE);

  ResetCountry();

  if (index == -1)
    return root;
  else
    return retDbMine;
}

void cMineTypeSelector::ResetCountry ()
{
  int                    i, count, *retbuf, index;
  Widget                *widget_list, wItem, wMenu;

  /* clear country menu except first option ('All') */
  XtVaGetValues (fwCountryMenu, 
		 XmNsubMenuId, &wMenu,
		 NULL);
  XtVaGetValues (wMenu, 
		 XmNnumChildren, &count,
		 XmNchildren, &widget_list,
		 NULL);
  for (i = count - 1; i > 0; i--)
    XtDestroyWidget (widget_list[i]);

  fpDbMine->GetCountryList (&retbuf, &count, &index);
  for (i = 0; i < count; i++) {
    wItem =
      XtVaCreateManagedWidget ( TEntityType::GetCountryText(retbuf[i]),
			       xmPushButtonGadgetClass, wMenu, 
			       NULL);
    XtAddCallback (wItem, XmNactivateCallback,
		   (XtCallbackProc)CbCountry, 
		   (XtPointer)retbuf[i]);
    if (i == index)
      XtVaSetValues (fwCountryMenu,
		     XmNmenuHistory, wItem,
		     NULL);
  }

  if (index > -1)
    fCountry = (uint)retbuf[index];
  else
    fCountry = kMatchAllShort;

  ShowMineType();
  
  delete[] retbuf;
}

void cMineTypeSelector::ResetFuze (cDbMine *pDbMine)
{
  int                    i, count;
  Widget                *widget_list, wItem, wMenu;
  XmString               xmstr;

  XtVaGetValues (fwFuzeMenu, 
		 XmNsubMenuId, &wMenu,
		 NULL);
  XtVaGetValues (wMenu, 
		 XmNnumChildren, &count,
		 XmNchildren, &widget_list,
		 NULL);
  /* clear fuze menu except first entry */
  for (i = count - 1; i > 0; i--)
    XtDestroyWidget (widget_list[i]);

  if (pDbMine) {
    count = pDbMine->GetNumFuzeParam();
    for (i = 0; i < count; i++) {
      TFuzeParam* pFuzeParam = pDbMine->GetFuzeParam(i);
      if (i == 0) {
	wItem = widget_list[0];
	xmstr = XmStringCreateSimple ((char*)pFuzeParam->GetFuzeName());
	XtVaSetValues (wItem,
		       XmNlabelString, xmstr,
		       NULL);
	XmStringFree (xmstr);
	ResetFuzeOpt (pFuzeParam->GetOptSelector());
      }
      else
	wItem =
	  XtVaCreateManagedWidget (pFuzeParam->GetFuzeName(),
				   xmPushButtonGadgetClass, wMenu, 
				   XmNuserData, i,
				   NULL);
      XtAddCallback (wItem, XmNactivateCallback,
		     (XtCallbackProc)CbFuze, 
		     (XtPointer)pFuzeParam);
    }
  }
  else {
    xmstr = XmStringCreateSimple ("N/A");
    XtVaSetValues (widget_list[0],
		   XmNlabelString, xmstr,
		   NULL);
    XmStringFree (xmstr);
    ResetFuzeOpt (NULL);
  }

  XtSetSensitive (fwFuzeMenu, (pDbMine != NULL));
}

void cMineTypeSelector::SetFuzeMenu (TFuzeParam* pFuzeParam, int fuze_opt)
{
  Widget        *widget_list, wMenu;

  XtVaGetValues (fwFuzeMenu, 
		 XmNsubMenuId, &wMenu,
		 NULL);
  XtVaGetValues (wMenu, 
		 XmNchildren, &widget_list,
		 NULL);
  XtVaSetValues (fwFuzeMenu,
		 XmNmenuHistory, widget_list[fuze_opt],
		 NULL);

  ResetFuzeOpt (pFuzeParam->GetOptSelector());
}

void cMineTypeSelector::SetFuzeOptMenus (TFuzeOpt FuzeOpt)
{
  Widget        *widget_list, wMenu;
  int            count, i;
  char          *str;
  XmString       xmstr;

  if (XtIsSensitive (fwAntiHandlingMenu)) {
    XtVaGetValues (fwAntiHandlingMenu, 
		   XmNsubMenuId, &wMenu,
		   NULL);
    XtVaGetValues (wMenu, 
		   XmNchildren, &widget_list,
		   NULL);
    XtVaSetValues (fwAntiHandlingMenu,
		   XmNmenuHistory, widget_list[(int)FuzeOpt.fbAntihandling],
		   NULL);
  }

  if (XtIsSensitive (fwBlastHardenedMenu)) {
    XtVaGetValues (fwBlastHardenedMenu, 
		   XmNsubMenuId, &wMenu,
		   NULL);
    XtVaGetValues (wMenu, 
		   XmNchildren, &widget_list,
		   NULL);
    XtVaSetValues (fwBlastHardenedMenu,
		   XmNmenuHistory, widget_list[(int)FuzeOpt.fbBlastHard],
		   NULL);
  }

  if (XtIsSensitive (fwSelfDestructMenu)) {
    XtVaGetValues (fwSelfDestructMenu, 
		   XmNsubMenuId, &wMenu,
		   NULL);
    XtVaGetValues (wMenu, 
		   XmNnumChildren, &count,
		   XmNchildren, &widget_list,
		   NULL);
    for (i = 0; i < count; i++) {
      XtVaGetValues (widget_list[i],
		     XmNlabelString, &xmstr,
		     NULL);
      XmStringGetLtoR (xmstr, XmSTRING_DEFAULT_CHARSET, &str);
      if (FuzeOpt.fSelfDestTimeHrs == atof (str)) 
	XtVaSetValues (fwSelfDestructMenu,
		       XmNmenuHistory, widget_list[i],
		       NULL);
    }
  }

  if (XtIsSensitive (fwTargetCountText)) {
    sprintf (str, "%d", FuzeOpt.fTgtCount);
    XtVaSetValues (fwTargetCountText,
		   XmNvalue, str,
		   NULL);
  }
}

void cMineTypeSelector::ShowMineType ()
{
  int                    i, count, index;
  cDbMine              **retbuf;
  cMineCompEditorWindow* pCompEditor = 
                           (cMineCompEditorWindow*)gpGuiWin->GetCurEditor();

  // clear old mine type list
  XmListDeleteAllItems(fwMineTypeList);

  fpDbMine->GetSpecificList (&retbuf, &count, fCountry, &index);
  if (count > 0) {
    // build list of strings and add to list
    XmString *names = new XmString[count];

    for( i = 0; i < count; i++ )
      names[i] = XmStringCreateSimple((char *)retbuf[i]->GetEntryEntityName());
    XmListAddItemsUnselected( fwMineTypeList, names, count, 0 );

    // for now, just clean everything up
    for( i = 0; i < count; i++ )
      XmStringFree( names[i] );
    delete[] names;

    if (index > -1)
      XmListSelectPos (fwMineTypeList, index + 1, TRUE);
    else
      XmListSelectPos (fwMineTypeList, 1, TRUE);
  }
  else
    ResetFuze (NULL);

  pCompEditor->SetButtonState();
  
  delete[] retbuf;
}

void cMineTypeSelector::SetMineTypeMenus (cMineComp *pMineComp)
{
  Widget       *widget_list, wMenu;
  int           count, index, fuze_opt = 0, *pos_list;
  cDbMine     **retbuf;
  TFuzeOpt      fuze_options;

  /* existing component already has mine type */
  if (pMineComp->GetDbEntity()) {
    fpDbMine = pMineComp->GetDbEntity();
    fuze_opt = pMineComp->GetDbOpt().fFuzeOpt;
    fuze_options = pMineComp->GetFuzeOpt();
  }
  /* new component doesn't have mine type */
  else {
    if (XmListGetSelectedPos (fwMineTypeList, &pos_list, &count)) {
      if (count == 1) {
	/* hold on to fuze options */
	fuze_opt = GetFuze();
	fuze_options = GetFuzeOptions();
	/* use mine type of previous component */
	XmListSelectPos (fwMineTypeList, pos_list[0], TRUE);
	fpDbMine = pMineComp->GetDbEntity();
      }
    }
  }

  /* show specific domain */
  XtVaGetValues (fwDomainMenu, 
		 XmNsubMenuId, &wMenu,
		 NULL);
  XtVaGetValues (wMenu, 
		 XmNchildren, &widget_list,
		 NULL);

  fpDbMine->GetDomainList (&retbuf, &count, &index);
  XtVaSetValues (fwDomainMenu,
		 XmNmenuHistory, widget_list[index+1],
		 NULL);
  fpDbMine = ResetCategory();
  delete[] retbuf;

  if (fuze_opt) {
    SetFuzeMenu (pMineComp->GetDbEntity()->GetFuzeParam(fuze_opt),
		 fuze_opt);
    SetFuzeOptMenus (fuze_options);
  }
}

int cMineTypeSelector::GetNumEntries ()
{
   int ntypes;

   XtVaGetValues (fwMineTypeList,
		  XmNitemCount, &ntypes,
		  NULL);
   return ntypes;
}

void cMineTypeSelector::CbMineType (Widget /*w*/, XtPointer pObj,
				    XmListCallbackStruct *cbs)
{
  cMineComp*             pMineComp = (cMineComp*) (gpGuiWin->GetCurComponent());
  cEditorWindow*         pCompEditor = gpGuiWin->GetCurEditor();
  cMineTypeSelector*     pMineType = (cMineTypeSelector*)pObj;
  int                    count, index;
  cDbMine              **retbuf, *pDbMine;

  pMineType->fpDbMine->GetSpecificList (&retbuf, &count, 
					 pMineType->fCountry, &index);
  pDbMine = retbuf[cbs->item_position - 1];
  pMineComp->SetCompMineType (pDbMine);
  pMineType->ResetFuze (pDbMine);

  pCompEditor->SetWidgetState();
  
  delete[] retbuf;
}

int cMineTypeSelector::GetFuze ()
{
  Widget      widget;
  int         ifuze;

  XtVaGetValues (fwFuzeMenu,
		 XmNmenuHistory, &widget,
		 NULL);
  XtVaGetValues (widget,
		 XmNuserData, &ifuze,
		 NULL);

  return ifuze;
}

TFuzeOpt cMineTypeSelector::GetFuzeOptions ()
{
  TFuzeOpt    FuzeOpt;
  Widget      widget;
  XmString    xmstr;
  char       *str;
  Boolean     sens;

  XtVaGetValues (fwAntiHandlingMenu,
		 XmNmenuHistory, &widget,
		 NULL);
  XtVaGetValues (widget,
		 XmNuserData, &FuzeOpt.fbAntihandling,
		 NULL);

  XtVaGetValues (fwBlastHardenedMenu,
		 XmNmenuHistory, &widget,
		 NULL);
  XtVaGetValues (widget,
		 XmNuserData, &FuzeOpt.fbBlastHard,
		 NULL);

  XtVaGetValues (fwSelfDestructMenu,
		 XmNmenuHistory, &widget,
		 XmNsensitive, &sens,
		 NULL);
  if (sens) {
    XtVaGetValues (widget,
		   XmNlabelString, &xmstr,
		   NULL);
    XmStringGetLtoR (xmstr, XmSTRING_DEFAULT_CHARSET, &str);
    FuzeOpt.fSelfDestTimeHrs = atof (str);
  }

  XtVaGetValues (fwTargetCountText,
		 XmNsensitive, &sens,
		 XmNvalue, &str,
		 NULL);
  if (sens)
    FuzeOpt.fTgtCount = atoi (str);

  return FuzeOpt;
}

