/*
$RCSfile: MinefieldStatusCB.cc,v $
$Revision: 1.2 $
$Author: ksnively $
$Date: 1999/04/29 19:34:21 $
$Log: MinefieldStatusCB.cc,v $
Revision 1.2  1999/04/29 19:34:21  ksnively
Incorporated ARDEC addtions:  Tripwire AP mines and a Control Window.

Revision 1.1.1.1  1999/02/16 14:54:41  jchappel
Comprehensive Mine Simulator

// Revision 2.2  1998/10/27  19:34:43  jchappel
// modifications for versioning
//
// Revision 2.2  1998/10/27  19:34:43  jchappel
// modifications for versioning
//
// Revision 2.1  1998/02/18  17:16:10  ksnively
// Incorporated AP mine replacement code.
//
// Revision 2.0  1998/01/26  21:01:35  ksnively
// Baseline CMS before additions for AP mine replacements.
//
// Revision 1.1  1997/12/16  13:59:57  ksnively
// Initial revision
//
// Revision 1.5  1997/10/02  17:51:30  austin
// first working port to modsaf3.0
//
// Revision 1.4  1997/10/02  17:48:55  austin
// first working port to modsaf3.0
//
// Revision 1.4  1997/10/02  17:48:55  austin
// first working port to modsaf3.0
//
// Revision 1.3  1997/05/20  15:35:11  ksnively
// Redraw screen when turning on or off minefield
//
// Revision 1.2  1997/03/20  19:14:41  ksnively
// added emission tracking, updated to CMS2.0B6
//
// Revision 1.2  1997/03/20  19:14:41  ksnively
// added emission tracking, updated to CMS2.0B6
//
// Revision 1.1  1996/10/23  13:54:40  nsipes
// Initial revision
//
// Revision 1.11  1996/05/21  22:14:37  rcarp
// text and lists from mine db, and activating mine state save cmd
//
// Revision 1.10  1996/05/15  17:17:31  rcarp
// refinements and fixes for 1.5 delivery
//
// Revision 1.9  1996/05/14  16:15:08  rcarp
// refinements and bug fixes for 1.5 delivery
//
// Revision 1.7  1996/03/28  22:34:41  mkappel
// Add Mine Display toggle to component editors.
//
// Revision 1.7  1996/03/28  22:34:41  mkappel
// Add Mine Display toggle to component editors.
//
// Revision 1.6  1996/03/23  14:25:01  rcarp
// improvements to test mode and selection
//
// Revision 1.5  1996/03/15  16:03:02  mkappel
// Allow repositioning of minefield when loading (standard minefields).
//
// Revision 1.4  1996/03/07  21:36:34  mkappel
// Use PopupMessage when error saving minefield.
//
// Revision 1.3  1996/03/06  19:45:05  mkappel
// New Mine Status Window
//
// Revision 1.2  1996/02/23  18:36:44  mkappel
// Add Site/Application to Start Up Screen.
//
// Revision 1.1  1996/01/23  16:52:30  rcarp
// Initial revision
//
$State: Exp $
*/
 
/*******************************************

   file: MinefieldStatusCB.cc
   
      Copyright 1995 by the Institute for Defense Analyses
      
         Institute for Defense Analyses
         1801 N. Beauregard Street
         Alexandria, Virginia 22311-1772
         703-845-2000
         
      This software was developed by IDA under U. S. Government
      contract.  For distribution information contact:
      
         U. S. Army Night Vision Directorate
         AMSEL RD NV OD CD
         10221 Burbeck Road, suite 430
         Ft. Belvoir VA 22060-5806
      
*********************************************/

/*******************************************

   MinefieldStatusCB.cc
   
      The display interface implementation.
      
      
   
   Created by Michael Kappel
   Modification history:
      created   
      
*********************************************/

#include "CmsControl.h"
#include "Display.h"
#include "Message.h"
#include "Minefield.h"
#include <Xm/FileSB.h>
#include <Xm/ToggleB.h>
#include <sys/types.h>
#include <sys/stat.h>

int     cMinefieldStatusWindow::SelectionCount()
{
   cMinefield   *pMf;
   int          count = 0;
   for ( pMf = gMfieldMgr.GetField(1); pMf; pMf = pMf->GetNextMf()) {
      if ( pMf->IsSelected() )
         count++;
   }
   return count;
}

cMinefield**  cMinefieldStatusWindow::MakeSelectionList()
{
   cMinefield **ppMfList, *pMf;
   int          count = SelectionCount();

   ppMfList = new cMinefield* [count];
   count = 0;
   for ( pMf = gMfieldMgr.GetField(1); pMf; pMf = pMf->GetNextMf()) {
      if ( pMf->IsSelected() )
         ppMfList[count++] = pMf;
   }
   
   return ppMfList;
}

void cMinefieldStatusWindow::CbScroll (Widget sbar, XtPointer /*wForm*/, 
				       XmScrollBarCallbackStruct *cbs)
{
  cMinefield* pMf = gMfieldMgr.GetField(1);
  int         count = 0;
  Widget      wMainWin, wPrev;

  if (pMf == NULL) return;

  while (pMf != NULL) {
    wMainWin = pMf->GetMfSumm()->GetMainWin();
    if (count < cbs->value)
      XtUnmanageChild (wMainWin);
    else {
      XtManageChild (wMainWin);
      if (count == cbs->value)
	XtVaSetValues (wMainWin,
		       XmNtopAttachment, XmATTACH_FORM,
		       NULL);
      else
	XtVaSetValues (wMainWin,
		       XmNtopAttachment, XmATTACH_WIDGET,
		       XmNtopWidget, wPrev,
		       NULL);
      wPrev = wMainWin;
    }
    
    count++;
    pMf = pMf->GetNextMf();
  }

  XtVaSetValues (sbar, XmNmaximum, (count > 1) ? count : 2, NULL);
}

void    cMinefieldStatusWindow::CbCreate (Widget /*w*/, XtPointer  /*pObj*/,
					  XmPushButtonCallbackStruct */*cbs*/)
{
   new cCreateMinefieldMsg ();
}

void    cMinefieldStatusWindow::CbEdit (Widget /*w*/, XtPointer  /*pObj*/,
					XmPushButtonCallbackStruct */*cbs*/)
{
   cMinefield* pCurMinefield = gpGuiWin->GetCurMinefield();
   if (pCurMinefield) {
     if (pCurMinefield->GetSimStart() == esimstSimulating)
       new cComponentStatusMsg (pCurMinefield);
     else {
       new cEditMinefieldMsg ();
       pCurMinefield->StartEditingMf();
     }
   }
}

void    cMinefieldStatusWindow::CbDuplicate (Widget /*w*/, XtPointer  /*pObj*/,
					XmPushButtonCallbackStruct */*cbs*/)
{
   float    daz = 0.0;
   double   dx = 100.0;
   double   dy = 100.0;
   
   gMfieldMgr.DuplicateMinefields(SelectionCount(), MakeSelectionList(), 
                                  dx, dy, daz);
   gpGuiWin->SetSelection( false, (cMinefield*)NULL);
}

void    cMinefieldStatusWindow::CbDelete (Widget /*w*/, XtPointer  /*pObj*/,
					XmPushButtonCallbackStruct */*cbs*/)
{
  gpGuiWin->DialogMessage (cGuiWindow::eDialogWarning, 
			   (XtCallbackProc)CbDeleteOK,
			   "Are you sure that you want to\ndelete the selected minefield(s)?");
}

void cMinefieldStatusWindow::CbDeleteOK (Widget w, XtPointer /*client_data*/, 
					 XmAnyCallbackStruct */*cbs*/)
{
   gMfieldMgr.DeleteMinefields(SelectionCount(), MakeSelectionList());
   gpGuiWin->SetSelection( false, (cMinefield*)NULL);
   XtDestroyWidget (w);
}

void    cMinefieldStatusWindow::CbZoom (Widget /*w*/, XtPointer  /*pObj*/,
					XmPushButtonCallbackStruct */*cbs*/)
{
/*added cell parameter to match modsaf3.0 libtactmap.h AUSTIN 7 Aug 97*/
   if (gpGuiWin->GetCurMinefield() ) {
     TLocation loc = gpGuiWin->GetCurMinefield()->GetTccLoc();
     gpGuiWin->SetMapCenter ((int32)loc.x, (int32)loc.y, (int32)0);
   }
}

void    cMinefieldStatusWindow::CbSendCmd (Widget /*w*/, XtPointer  /*pObj*/,
					XmPushButtonCallbackStruct */*cbs*/)
{
   cMinefield* pCurMinefield = gpGuiWin->GetCurMinefield();
   if (pCurMinefield) {
     if (pCurMinefield->GetSimState() == esimSimulated)
       new cFieldControlMsg (pCurMinefield);
}
}

void    cMinefieldStatusWindow::CbSaveMfs (Widget /*w*/, XtPointer  pObj,
					   XmPushButtonCallbackStruct */*cbs*/)
{
   Widget          file_sb;
   Arg             args[1];
   XmString        dir;

   dir = XmStringCreateSimple (gCmsMgr.GetDirMfOutput());
   XtSetArg (args[0], XmNdirectory, dir);
   file_sb = XmCreateFileSelectionDialog (fwTopLevelShell,
					  "file_sb", args, 1);
   XtVaSetValues (file_sb, 
		  XmNdialogStyle, XmDIALOG_FULL_APPLICATION_MODAL, 
		  NULL);
   XtVaSetValues (XtParent (file_sb),
		  XmNtitle, "Save Minefield(s)",
		  NULL);
   XtAddCallback (file_sb, XmNcancelCallback, 
		  (XtCallbackProc)CbCancel, NULL);
   XtAddCallback (file_sb, XmNokCallback, 
		  (XtCallbackProc)CbSaveMfsOK, pObj);
   XtManageChild (file_sb);
   XmStringFree (dir);
}

void cMinefieldStatusWindow::CbSaveMfsOK (Widget fs, XtPointer client_data, 
					  XmFileSelectionBoxCallbackStruct *cbs)
{
  char	       overwriteMsg[200];
/*
  EBoolean     bResult;
  cMinefield **ppMfList, *pMf;
  int          count;

  count = 0;
  pMf = gMfieldMgr.GetField(1);

  while (pMf != NULL) {
    if ( pMf->IsSelected() )
      count++;
    pMf = pMf->GetNextMf();
  }
  ppMfList = new cMinefield* [count];
  count = 0;
  pMf = gMfieldMgr.GetField(1);

  while (pMf != NULL) {
    if ( pMf->IsSelected() )
      ppMfList[count++] = pMf;
    pMf = pMf->GetNextMf();
  }

*/

  ((cMinefieldStatusWindow*)client_data)->fwfs = fs;
  XmStringGetLtoR (cbs->value, XmSTRING_DEFAULT_CHARSET, &(((cMinefieldStatusWindow*)client_data)->filename));

  struct stat tmpbuf;
  if (stat(((cMinefieldStatusWindow*)client_data)->filename, &tmpbuf) != -1)  {
     sprintf(overwriteMsg, "File %s\nalready exists.  Overwrite?", ((cMinefieldStatusWindow*)client_data)->filename);
     gpGuiWin->PopupMessage (fs, cGuiWindow::eDialogQuestion, "Yes", "No", 
			    (XtCallbackProc) CbSaveMfsOKYes, NULL, client_data, overwriteMsg);

  }
  else CbSaveMfsOKYes (fs , client_data, cbs);

/*
  bResult = gMfieldMgr.SaveMinefile(filename, count, ppMfList, &resultMsg);

  if ( !bResult ) {
    gpGuiWin->PopupMessage (fs, cGuiWindow::eDialogError, "", "", 
			    NULL, NULL, NULL, resultMsg);
    delete[] resultMsg;
    return;
  }

  XtDestroyWidget (fs);
*/
}

void cMinefieldStatusWindow::CbSaveMfsOKYes (Widget fs, XtPointer client_data, 
					  XmFileSelectionBoxCallbackStruct */*cbs*/)
{
  char* resultMsg;
  EBoolean     bResult;
  cMinefield **ppMfList, *pMf;
  int          count;

  count = 0;
  pMf = gMfieldMgr.GetField(1);

  while (pMf != NULL) {
    if ( pMf->IsSelected() )
      count++;
    pMf = pMf->GetNextMf();
  }
  ppMfList = new cMinefield* [count];
  count = 0;
  pMf = gMfieldMgr.GetField(1);

  while (pMf != NULL) {
    if ( pMf->IsSelected() )
      ppMfList[count++] = pMf;
    pMf = pMf->GetNextMf();
  }

  bResult = gMfieldMgr.SaveMinefile(((cMinefieldStatusWindow*) client_data)->filename, count, ppMfList, &resultMsg);

  if ( !bResult ) {
    gpGuiWin->PopupMessage (fs, cGuiWindow::eDialogError, "", "", 
			    NULL, NULL, NULL, resultMsg);
    delete[] resultMsg;
    return;
  }

  XtDestroyWidget (((cMinefieldStatusWindow*) client_data)->fwfs);

}

void    cMinefieldStatusWindow::CbLoadMfs (Widget /*w*/, XtPointer  /*pObj*/,
					XmPushButtonCallbackStruct */*cbs*/)
{
   Widget          file_sb;
   Arg             args[1];
   XmString        dir;

   dir = XmStringCreateSimple (gCmsMgr.GetDirMfInput());
   XtSetArg (args[0], XmNdirectory, dir);
   file_sb = XmCreateFileSelectionDialog (fwTopLevelShell,
					  "file_sb", args, 1);
   XtVaSetValues (file_sb, 
		  XmNdialogStyle, XmDIALOG_FULL_APPLICATION_MODAL, 
		  NULL);
   XtVaSetValues (XtParent (file_sb),
		  XmNtitle, "Load Minefield(s)",
		  NULL);
   XtAddCallback (file_sb, XmNcancelCallback, 
		  (XtCallbackProc)CbCancel, NULL);
   XtAddCallback (file_sb, XmNokCallback, 
		  (XtCallbackProc)CbLoadMfsOK, NULL);
   XtManageChild (file_sb);
   XmStringFree (dir);
}

void cMinefieldStatusWindow::CbLoadMfsOK (Widget fs, XtPointer /*client_data*/, 
					  XmFileSelectionBoxCallbackStruct *cbs)
{
  char*        filename, msg[199];
  //  Widget       dialog;
  //  XmString     str1;
  cInFileObj*  pMineFile;

  XmStringGetLtoR (cbs->value, XmSTRING_DEFAULT_CHARSET, &filename);
  
  pMineFile = new cInFileObj;
  if ( !pMineFile->Open(filename, gftypeMinefields) ) {
    sprintf (msg, "Cannot open %s for input", filename);
    gpGuiWin->PopupMessage (fs, cGuiWindow::eDialogError, "", "", 
			    NULL, NULL, NULL, msg);
    return;
  }

  new cReadMineFileMsg (pMineFile);
  XtDestroyWidget (fs);
  
  gpGuiWin->SetSelection(false, NULL);
}

void    cMinefieldStatusWindow::CbSaveTbl (Widget /*w*/, XtPointer  /*pObj*/,
					XmPushButtonCallbackStruct */*cbs*/)
{
   gMfieldMgr.SaveMfState(SelectionCount(), MakeSelectionList());
}

void    cMinefieldStatusWindow::CbPrintTbl (Widget /*w*/, XtPointer  /*pObj*/,
					XmPushButtonCallbackStruct */*cbs*/)
{
}

void    cMinefieldStatusWindow::MapClick (TLocation& /*tccPt*/)
{
}

void    cMinefieldStatusWindow::ShowEdWindow()
{
   for ( cMinefield* pMf = gMfieldMgr.GetField(1);
	 pMf;
	 pMf = pMf->GetNextMf() ) {
      pMf->GetMfSumm()->ShowInfo();
      pMf->SetPvdSelect( true );
      // here we set the sensitivity of the CD mines (NOT!)
      //   cComponentStatusWindow::SetCmdCompSens( pMf, true );
   }

   SetButtonState ();
   XtManageChild(fwMainWin);
}

void    cMinefieldStatusWindow::ClearEdWindow()
{
   cEditorWindow::ClearEdWindow();
   
   for ( cMinefield* pMf = gMfieldMgr.GetField(1);
                     pMf;
                     pMf = pMf->GetNextMf() )  {
      pMf->SetPvdSelect( false );
      // here we set the sensitivity of the CD mines (NOT!)
      //cComponentStatusWindow::SetCmdCompSens( pMf, false );
   }
   if (gbGui) tactmap_refresh_non_terrain (gpTactmap);
}

void    cMinefieldStatusWindow::SetButtonState ()
{
  cMinefield* pMf = gMfieldMgr.GetField(1);
  int         count = SelectionCount();
  XmString    str1;

  if (count == 1) {
    XtSetSensitive (fwEditButton, TRUE);
    XtSetSensitive (fwDuplicateButton, TRUE);
    XtSetSensitive (fwZoomButton, TRUE);
//    XtSetSensitive (fwSendCmdButton, TRUE);
    XtSetSensitive (fwSaveTblButton, TRUE);

    cMinefield* pMf = gpGuiWin->GetCurMinefield();
    if ( (pMf->AcceptsCommands()) &&
         (pMf->GetSimState() == esimSimulated) )
       XtSetSensitive (fwSendCmdButton, TRUE);
    else
       XtSetSensitive (fwSendCmdButton, FALSE);

    if (gpGuiWin->GetCurMinefield()->GetSimState() == esimSimulated)
      str1 = XmStringCreateSimple ("Status");
    else
      str1 = XmStringCreateSimple ("Edit");

    XtVaSetValues (fwEditButton,
		   XmNlabelString, str1,
		   NULL);
    XmStringFree (str1);
  }
  else {
//    gpCurMinefield = NULL;

    XtSetSensitive (fwEditButton, FALSE);
    XtSetSensitive (fwZoomButton, FALSE);
    XtSetSensitive (fwSendCmdButton, FALSE);
  }

  if (count == 0) {
    XtSetSensitive (fwSaveMfsButton, FALSE);
    XtSetSensitive (fwDuplicateButton, FALSE);
    XtSetSensitive (fwDeleteButton, FALSE);
    XtSetSensitive (fwSaveTblButton, FALSE);
  }
  else {
    XtSetSensitive (fwSaveMfsButton, TRUE);
    XtSetSensitive (fwDuplicateButton, TRUE);
    XtSetSensitive (fwDeleteButton, TRUE);
    XtSetSensitive (fwSaveTblButton, TRUE);
  }
}

void cMinefieldStatusWindow::CbCancel (Widget w, XtPointer /*client_data*/, 
				       XmFileSelectionBoxCallbackStruct */*cbs*/)
{
   XtDestroyWidget (w);
}

void  cDispMfSummary::CbSelect(Widget /*w*/, XtPointer pObj, 
                               XmPushButtonCallbackStruct *cbs)
{
  cMinefield* pMf = ((cDispMfSummary*) pObj)->fpMinefield;
  EBoolean multi = ( ((cbs->event->xbutton.state & ShiftMask) == 0) ? false: true);
  gpGuiWin->SetSelection( multi, pMf, NULL, NULL );
}

void cDispMfSummary::CbSimToggle (Widget w, XtPointer pObj, 
				  XmToggleButtonCallbackStruct *cbs)
{
  cDispMfSummary* pDisp = (cDispMfSummary*) pObj;
  cMfComponent*  pComp = (cMfComponent*)pDisp->fpMinefield->GetPerimeter(); 
  // newly added to make mines sensitive after simulation

  if (XmToggleButtonGetState (w)) {
    pDisp->fpMinefield->SetSimStart( esimstSimulating );
     
    // more new stuff
    if (pComp) {
       pComp = pComp->GetNext(); /* skip perimeter */
   
       while (pComp != NULL) {
          pComp->SetCompPvdSelect( true ); // not sure about this one
          pComp = pComp->GetNext();
       }
    }
    // end new   
  
    XtSetSensitive (w, FALSE);  /* once simulating, always simulating */
  }
  
  EBoolean multi = ( ((cbs->event->xbutton.state & ShiftMask) == 0) ? false: true);
  gpGuiWin->SetSelection( multi, pDisp->fpMinefield );
}

/*
void cDispMfSummary::CbOnToggle (Widget w, XtPointer pObj, 
				 XmToggleButtonCallbackStruct *cbs)
{
  cDispMfSummary* pDisp = (cDispMfSummary*) pObj;

  pDisp->fpMinefield->SetMfOnState
    ((EBoolean)XmToggleButtonGetState (w));
    
  EBoolean multi = ( ((cbs->event->xbutton.state & ShiftMask) == 0) ? false: true);
  gpGuiWin->SetSelection( multi, pDisp->fpMinefield );
}
*/

void cDispMfSummary::CbOnToggle (Widget w, XtPointer pObj, 
				 XmToggleButtonCallbackStruct *cbs)
{
  cDispMfSummary* pDisp = (cDispMfSummary*) pObj;
  cMinefield* pMf = pDisp->fpMinefield;

  EBoolean show = pMf->GetShowMines();
  
  pMf->ShowMines(false);
  pMf->SetMfOnState((EBoolean)XmToggleButtonGetState (w));
  pMf->ShowMines(show);

  EBoolean multi = ( ((cbs->event->xbutton.state & ShiftMask) == 0) ? false: true);
  gpGuiWin->SetSelection( multi, pDisp->fpMinefield );
}

void cDispMfSummary::CbPerimToggle (Widget w, XtPointer pObj, 
				    XmToggleButtonCallbackStruct *cbs)
{
  cDispMfSummary* pDisp   = (cDispMfSummary*) pObj;
  cPerimeter*     pPerim  = pDisp->fpMinefield->GetPerimeter();

  if (XmToggleButtonGetState (w))
    pPerim->ShowPerim (true);
  else
    pPerim->ShowPerim (false);

  EBoolean multi = ( ((cbs->event->xbutton.state & ShiftMask) == 0) ? false: true);
  gpGuiWin->SetSelection( multi, pDisp->fpMinefield );
}

void cDispMfSummary::CbLabelToggle (Widget w, XtPointer pObj, 
				    XmToggleButtonCallbackStruct */*cbs*/)
{
  cDispMfSummary* pDisp   = (cDispMfSummary*) pObj;
  cPerimDisp* pPerimDisp  = pDisp->fpMinefield->GetPerimeter()->GetPerimDisp();
  EBoolean is_vis = pPerimDisp->IsVisible();
  
  if (XmToggleButtonGetState (w))
     pDisp->fpMinefield->SetShowLabel(true);
  else
     pDisp->fpMinefield->SetShowLabel(false);     

  if (pDisp->fpMinefield->GetShowLabel())
    pPerimDisp->UpdateLabelName(pDisp->fpMinefield->GetMfName());
  else  {
    char*	null_name = "";
    pDisp->fpMinefield->GetPerimeter()->ShowPerim (false);
    pPerimDisp-> UpdateLabelName(null_name);
    pDisp->fpMinefield->GetPerimeter()->ShowPerim (is_vis);
  }
  
  //pPerimDisp->RedrawSelected();
  //EBoolean multi = ( ((cbs->event->xbutton.state & ShiftMask) == 0) ? false: true);
  //gpGuiWin->SetSelection( multi, pDisp->fpMinefield );
}

void cDispMfSummary::CbMineToggle (Widget w, XtPointer pObj, 
				   XmToggleButtonCallbackStruct *cbs)
{
  cDispMfSummary* pDisp   = (cDispMfSummary*) pObj;
  EBoolean        show = (EBoolean)XmToggleButtonGetState (w);
  cMinefield*     pMf = pDisp->fpMinefield;

  pMf->ShowMines (show);
  
  EBoolean multi = ( ((cbs->event->xbutton.state & ShiftMask) == 0) ? false: true);
  gpGuiWin->SetSelection( multi, pMf );
}

void cDispMfSummary::CbFixtToggle (Widget w, XtPointer /*pObj*/, 
				   XmToggleButtonCallbackStruct */*cbs*/)
{
   //  cDispMfSummary* pDisp   = (cDispMfSummary*) pObj;

  if (XmToggleButtonGetState (w))
    ;
  else
    ;

//  EBoolean multi = ( ((cbs->event->xbutton.state & ShiftMask) == 0) ? false: true);
//  gpGuiWin->SetSelection( multi, pDisp->fpMinefield );
}

void cDispMfSummary::ShowInfo()
{
   XmString       xmsText;
   char           buf[100];
   const TMineSumm&   mineSumm = fpMinefield->GetMineSumm();
   
   xmsText = XmStringCreateSimple (fpMinefield->GetMfName());
   XtVaSetValues (fwMfName,
		  XmNlabelString, xmsText,
		  NULL);
   XmStringFree(xmsText);

   XtVaSetValues (fwSimToggle,
		  XmNset, (fpMinefield->GetSimStart() == esimstSimulating),
		  XmNsensitive, !(fpMinefield->GetSimStart() == esimstSimulating) &&
		                mineSumm.fTotalMines > 0,
		  NULL);

   XtVaSetValues (fwOnToggle,
		  XmNset, fpMinefield->GetOnState(),
		  NULL);

   XtVaSetValues (fwMineToggle,
		  XmNset, fpMinefield->GetShowMines(),
		  NULL);
		  
   XtVaSetValues (fwLabelToggle, XmNset, fpMinefield->GetShowLabel(), NULL);

   sprintf (buf, "%d", mineSumm.fTotalMines);
   xmsText = XmStringCreateSimple (buf);
   XtVaSetValues (fwTotalMines,
		  XmNlabelString, xmsText,
		  NULL);
   XmStringFree(xmsText);

   sprintf (buf, "%d", mineSumm.fLiveMines);
   xmsText = XmStringCreateSimple (buf);
   XtVaSetValues (fwLiveMines,
		  XmNlabelString, xmsText,
		  NULL);
   XmStringFree(xmsText);

   sprintf (buf, "%d", mineSumm.fFiredMines);
   xmsText = XmStringCreateSimple (buf);
   XtVaSetValues (fwFiredMines,
		  XmNlabelString, xmsText,
		  NULL);
   XmStringFree(xmsText);

   sprintf (buf, "%d", mineSumm.fOtherDeadMines);
   xmsText = XmStringCreateSimple (buf);
   XtVaSetValues (fwOtherMines,
		  XmNlabelString, xmsText,
		  NULL);
   XmStringFree(xmsText);

   sprintf (buf, "%d", mineSumm.fVehiclesHit);
   xmsText = XmStringCreateSimple (buf);
   XtVaSetValues (fwVehHits,
		  XmNlabelString, xmsText,
		  NULL);
   XmStringFree(xmsText);

   sprintf (buf, "%d", mineSumm.fVehiclesKilled);
   xmsText = XmStringCreateSimple (buf);
   XtVaSetValues (fwVehKills,
		  XmNlabelString, xmsText,
		  NULL);
   XmStringFree(xmsText);
}
