/*
$RCSfile: NetMgr.cc,v $
$Revision: 1.2 $
$Author: ksnively $
$Date: 1999/06/03 19:45:00 $
$Log: NetMgr.cc,v $
Revision 1.2  1999/06/03 19:45:00  ksnively
Updated CMS Makefile to compile CMS and create DEPENDS file for multiple platforms allowing a DEPENDS file to exist for each type of platform CMS is compiled on concurrently.

Updated supporting make-cms file to support platform dependent DEPENDS file.

Small corrections to NetMgr files.

Revision 1.1.1.1  1999/02/16 14:54:41  jchappel
Comprehensive Mine Simulator

// Revision 2.1  1998/10/27  19:32:18  jchappel
// modifications for versioning
//
// Revision 2.1  1998/10/27  19:32:18  jchappel
// modifications for versioning
//
// Revision 2.0  1998/01/26  21:01:35  ksnively
// Baseline CMS before additions for AP mine replacements.
//
// Revision 1.3  1998/01/09  18:21:47  ksnively
// Integrated latest SAIC release cms3.0b2.
//
// Revision 1.2  1997/12/17  14:38:03  ksnively
// Debugged Minefield duplication routine.
// Added input file "netparams" for reading PDU type enumerations.
// Got rid of warning messages during compilation.
//
// Revision 1.1  1997/12/16  13:59:57  ksnively
// Initial revision
//
// Revision 1.5  1997/10/27  17:04:43  trang
// ci *.cc
// Build1
//
Revision 1.4  1997/10/02 17:53:37  austin
first working port to modsaf3.0

// Revision 1.3  1997/10/02  17:50:22  austin
// first working port to modsaf3.0
//
// Revision 1.3  1997/10/02  17:50:22  austin
// first working port to modsaf3.0
//
// Revision 1.2  1996/11/06  15:13:32  nsipes
// *** empty log message ***
//
// Revision 1.2  1996/11/06  15:13:32  nsipes
// *** empty log message ***
//
// Revision 1.1  1996/10/23  13:54:40  nsipes
// Initial revision
//
// Revision 1.8  1996/09/06  18:57:57  rcarp
// CP bug fixes
//
// Revision 1.7  1996/08/21  21:58:20  rcarp
// CP and QRP file output, other updates
//
// Revision 1.6  1996/08/08  18:10:09  rcarp
// gui updates and more CP changes
//
// Revision 1.5  1996/08/07  20:31:59  mkappel
// Startup screen header file.
//
// Revision 1.4  1996/08/07  14:19:30  rcarp
// initial revisions for CP protocol
//
// Revision 1.3  1996/07/03  22:55:15  rcarp
// enhancements and bug fixes for version 1.5b9
//
// Revision 1.2  1996/02/05  14:31:34  rcarp
// Updates and bug fixes of release version 1.1b5
//
// Revision 1.2  1996/02/05  14:31:34  rcarp
// Updates and bug fixes of release version 1.1b5
//
$State: Exp $
*/
 
/*******************************************

   file: NetMgr.cc
   
      Copyright 1995 by the Institute for Defense Analyses
      
         Institute for Defense Analyses
         1801 N. Beauregard Street
         Alexandria, Virginia 22311-1772
         703-845-2000
         
      This software was developed by IDA under U. S. Government
      contract.  For distribution information contact:
      
         U. S. Army Night Vision Directorate
         AMSEL RD NV OD CD
         10221 Burbeck Road, suite 430
         Ft. Belvoir VA 22060-5806
      
*********************************************/

/*******************************************

   NetMgr.cc
   
      The network manager implementation
         
   Created by Richard Carpenter
   Modification history:
      created   
      
*********************************************/

#define MULTIADDR 224.002.140.183

#include "NetMgr.h"
#include "DisPdu203.h"
#include "CmsPdu.h"
#include "CmsControl.h"

#include <net/raw.h>
#include <netinet/if_ether.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <netinet/udp.h>
#include <unistd.h>
#include <arpa/inet.h>

#include <errno.h>
#include <fcntl.h>
#include <iostream.h>
#include <stdlib.h>

//unsigned short    cNetMgr::fSite = 16;
//unsigned short    cNetMgr::fApplication = 233;


int      gPduLen  = 0;

cPort::cPort() {}
cPort::~cPort() {}

ENetReturn      cNonetPort::GetPdu(void */*buffer*/, int /*buflen*/)
{
   return enetNoData;
}

int             cNonetPort::PutPdu(void */*buffer*/, int buflen)
{
   return buflen;
}

cNonetPort::cNonetPort()
{
}

cNonetPort::~cNonetPort()
{
}

int    cUdpPort::OpenPort(int udpPort, int ttl, char* pMultireq)
{
   int on = 1;
   u_char off = (u_char) 0;
   int cc;

   sport = rport = udpPort;
   hostid = gethostid();
   
      // SET UP THE RECEIVING SOCKET
   cc = 1024 * ebufSize;
   r  = socket(AF_INET, SOCK_DGRAM, 0);
   
   setsockopt(r, SOL_SOCKET, SO_REUSEADDR, (const char*)&on, sizeof(on));
   setsockopt(r, SOL_SOCKET, SO_REUSEPORT, (const char*)&on, sizeof(on));
   Assert ( !setsockopt(r, SOL_SOCKET, SO_BROADCAST, &on, sizeof (on)), kerrNoRecvBcast, "OpenPort");
   Assert ( !setsockopt(r, SOL_SOCKET, SO_RCVBUF, &cc, sizeof(cc)), kerrNoBuff, "OpenPort");
 
   rin.sin_family      = AF_INET;
   rin.sin_addr.s_addr = htonl(INADDR_ANY);
   rin.sin_port        = htons(udpPort);
 
   //Bind the recieving socket
   Assert ( !bind(r, (sockaddr *)&rin, sizeof(sockaddr_in)), kerrBindSocket, "OpenPort", errno);
 
   Assert ( !ioctl(r, FIONBIO, &on), kerrNoBlock, "OpenPort", errno);
   
   //Create the sending socket
   Assert ( (s = socket(AF_INET, SOCK_DGRAM, 0)) != -1, kerrCreateSendSocket, "OpenPort", errno);

   //Set the socket for broadcasting
   Assert ( !setsockopt(s, SOL_SOCKET, SO_BROADCAST, &on, sizeof(on)), kerrNoSendBcast, "OpenPort", errno);

   //  --- no need to bind sending socket ---
 

   //Check if the user specified multicast
   if (pMultireq != NULL)
   {
      fprintf(stdout, "Using multicast address %s\n", pMultireq);

      //Check we have a valid multicast address
      Assert(IN_MULTICAST(inet_addr (pMultireq)), kerrInvalidMcast, "OpenPort", errno);
      //Get the TTL from command line input
      sMttl = (u_char)ttl;
      fprintf(stdout, "Multicast TTL = %d\n", sMttl);

      //Now set multicast parameters for RECIEVING SOCKET
      //Set the multicast address.
      sMreq.imr_multiaddr.s_addr = inet_addr (pMultireq);
      sMreq.imr_interface.s_addr = INADDR_ANY;
      
      //Now join the multicast group.  We don't need to worry about TTL for receiving.
      Assert(!setsockopt(r, IPPROTO_IP, IP_ADD_MEMBERSHIP,(char*)&sMreq, sizeof(sMreq)), 
	     kerrNoSubscribeMcast, "OpenPort (recv socket)", errno);
   
      // Disable Loopback
      Assert(!setsockopt(r, IPPROTO_IP, IP_MULTICAST_LOOP, (char *) &off, sizeof (off)), 
	     kerrNoDisableLoop, "OpenPort (recv socket)", errno);


      //Now set up Multicast parameters for SENDING SOCKET
      //Set the multicast destination address
      sin.sin_family      = AF_INET;
      sin.sin_addr.s_addr = inet_addr (pMultireq);
      sin.sin_port        = htons(udpPort);

      //Set the TTL.  This is where it matters 
      Assert(!setsockopt(s, IPPROTO_IP, IP_MULTICAST_TTL, (char *) &sMttl, sizeof(sMttl)),
	     kerrNoTtlMcast, "OpenPort (send socket)", errno);

      //This setsockopt doesn't work.
      //if (setsockopt(s, IPPROTO_IP, IP_MULTICAST_IF,(char *)sMreq.imr_interface.s_addr, sizeof(struct in_addr)) == -1)
      // perror("Error setting  IP_MULTICAST_IF in OpenPort for sending socket");

      //Assert(!setsockopt(s, IPPROTO_IP, IP_ADD_MEMBERSHIP, (char*)&sMreq, sizeof(sMreq)),
      //     kerrNoDisableLoop, "OpenPort (send socket)", errno);
	     

   }
   else  // if (fMulticastAddr != NULL)
   {
      // Set the broadcast destination address
      sin.sin_family      = AF_INET;
      sin.sin_addr.s_addr = htonl(INADDR_BROADCAST);
      sin.sin_port        = htons(udpPort);
   }
 
   return 0;

}

int    cUdpPort::ClosePort()
{
   close(s);
   close(r);
   return 0;
}

ENetReturn    cUdpPort::GetPdu(void *buffer, int buflen)
      // buflen is max size we can receive
{
   rlen = 0;
   rinlen = sizeof(sockaddr_in);
   errno = 0;
   errcode = enetSelfMsg;
   
      // discard msgs from this host ip, read until none
   while ( errcode == enetSelfMsg ) {
      rlen = recvfrom(r, buffer, buflen, 0, (sockaddr *)&rin, &rinlen);
//      if (errno != EWOULDBLOCK) cout<<"recvfrom returns errno = "<<errno<<" rlen "<<rlen;
      switch (errno) {
         
         case 0:      // no error
               if (hostid == rin.sin_addr.s_addr) {
                  errcode = enetSelfMsg;
//                  cout<<" from self"<<endl;
               }
               else {
                  errcode = enetMsgRecv;   //success, msg read
//                  cout<<" from elsewhere"<<endl;
               }
            break;
   
         case EWOULDBLOCK:   // nothing to read
               errcode = enetNoData;
            break;
            
         default:
               errcode = enetErr;
              if ( gfNetif )
                 cout << "port err num" << errno << endl;
            break;
      }
   };
   
   if ( (errcode != enetNoData) && (rlen < 0) ) errcode = enetErr;
   
   Assert( errcode != enetErr, kerrRecvError, "cUdpPort::GetPdu", errno);

   return errcode;
}

int    cUdpPort::PutPdu(void *buffer, int buflen)
{
   errno = errcode = enetMsgRecv;
 
   slen = sendto(s, buffer , buflen, 0, (sockaddr *)&sin, sizeof(sockaddr_in));
   
   Assert ( slen > 0, kerrNoPduSend, "cUdpPort::PutPdu");
 
   return slen;
}

cUdpPort::cUdpPort(int udpPort, int ttl, char* pMultireq)
{
   OpenPort(udpPort, ttl, pMultireq);
   
   if ( gfNetif )
      cout << "udp port " << udpPort << " opened" << endl;
}

cUdpPort::~cUdpPort()
{
   ClosePort();
}

cPduTranslator::cPduTranslator( int bufSize )
{
   fpOutBuf = new long[ bufSize/sizeof(long) + 1 ];
   fLength = 0;
   fProtocolFamily = 0;
}


EBoolean         cNetMgr::RecvPdu()
{
         // check against last quit time, to warn about delays
   
   ENetReturn   getResultCode;      
   EBoolean     recv = false;
   
   TTimeSim   start = GetCurSimTime();
   EBoolean bBreak;
   
   if ( gfNetif )
      cout << "receiving pdus" << endl;
   do  {
      bBreak = false;
         // this logic checks the sim port every cycle, 
         //   checks the cms port only when nothing is on the sim port,
         //   and exits when each port comes up empty
      if ( gfNetif )
         cout << "get next pdu " << endl;
      getResultCode = fpSimPort->GetPdu(fpBuffer, ePduBufSize);
         // we can check avg transmission delay for this site, and add time delta here
      if (getResultCode == enetMsgRecv) {
         fpPduTranslator->ReceivePdu(fpBuffer);
         recv = true;
      }
      else if ( fpCmsPort && (getResultCode == enetNoData) ) {
               // port only checks port number
         getResultCode = fpCmsPort->GetPdu(fpBuffer, ePduBufSize);
         if (getResultCode == enetMsgRecv) {
               // translator must check exercise, address, etc
            fpCmsTranslator->ReceivePdu(fpBuffer);
            recv = true;
         }
      }
     
      if ( GetCurSimTime() - start >= 50 ) {
//         cout << "breaking net to check sim" << endl;
         bBreak = true;
      }
   } while ( (getResultCode == enetMsgRecv) && (bBreak == false) );
   
   if ( gfNetif )
      cout << "port empty " << endl;
   
   return recv;
}

void    cNetMgr::SendPdu(void * pBuf, int length)
{
   int retLength;
   retLength = fpSimPort->PutPdu(pBuf, length);
}

int    cNetMgr::GetExerciseId()
{ 
   return fExerciseId;
}

EBoolean     cNetMgr::UsesCp() 
{
   return fpPduTranslator->UsesCp();
}

EBoolean     cNetMgr::IncludeThermal()  
{ 
   return fpPduTranslator->IncludeThermal(); 
}

EBoolean     cNetMgr::IncludeBurial()  
{ 
   return fpPduTranslator->IncludeBurial(); 
}

EBoolean     cNetMgr::IncludeOrient()  
{ 
   return fpPduTranslator->IncludeOrient();
}

EBoolean    cNetMgr::UsesQrp()
{
   return fpPduTranslator->UsesQrp();
}

void    cNetMgr::NetShutdown()
{
   if ( fpPduTranslator )
      fpPduTranslator->TranslatorShutdown();
}

cNetMgr::cNetMgr( TStartupParam & startup )
{
   //unsigned int   CpBitFlags;      // determines optional fields used
// CpBitFlags = startup.fbOrientation << ? +   
//              startup.fbBurialDepth << ? + 
//              startup.fbTemperature << ?;

   fExerciseId = startup.fExerciseId;
   
   cout<<"starting with exercise id = "<<startup.fExerciseId<<endl;
   
   fpBuffer = new long[ ePduBufSize/sizeof(long) + 1 ];
   
   switch (startup.feProtocol) {
   
      case eDis203:
	//    case eDis204:
            fpPduTranslator = new cDisPduTranslator(startup.feQrpProtocol, 
                                                    startup.feCpProtocol,
                                                    startup.fbOrientation,
                                                    startup.fbBurialDepth,
                                                    startup.fbTemperature );
            fpSimPort = new cUdpPort(startup.fDisPort, startup.fTtl, startup.fMulticastAddr);
            cout<<"opening udp port # "<< startup.fDisPort<<endl;
         break;
   
      case eDis204:
	/* read before  fpPduTranslator = new cDisPdu204(startup.feQrpProtocol */
            fpPduTranslator = new cDisPduTranslator(startup.feQrpProtocol, 
                                                    startup.feCpProtocol,
                                                    startup.fbOrientation,
                                                    startup.fbBurialDepth,
                                                    startup.fbTemperature );
            fpSimPort = new cUdpPort(startup.fDisPort, startup.fTtl, startup.fMulticastAddr);
            cout<<"opening udp port # "<< startup.fDisPort<<endl;
         break;

      case eNonet:
	    if (startup.feProtocol == eDis203)
               fpPduTranslator = new cDisPduTranslator(startup.feQrpProtocol, 
                                                    startup.feCpProtocol,
                                                    startup.fbOrientation,
                                                    startup.fbBurialDepth,
                                                    startup.fbTemperature );
	    else
	/* read before  fpPduTranslator = new cDisPdu204(startup.feQrpProtocol */
               fpPduTranslator = new cDisPduTranslator(startup.feQrpProtocol, 
                                                    startup.feCpProtocol,
                                                    startup.fbOrientation,
                                                    startup.fbBurialDepth,
                                                    startup.fbTemperature );

            fpSimPort = new cNonetPort();
            cout<<"not opening port, nonet operation"<<endl;
         break;
   
      default:
            cerr << "unknown simulation protocol"<<endl;
            Assert ( 0, kerrProtocolFamily, "cNetMgr contructor");
         break;
   }
   
      // if this is half duplex, need CMS port
   if ( ! (startup.fbGui && startup.fbHost) ) {
      fpCmsPort = new cUdpPort(startup.fCmsPort, startup.fTtl, startup.fMulticastAddr);
      fpCmsTranslator = new cCmsTranslator();
   }
   else {
      fpCmsPort = NULL;
      fpCmsTranslator = NULL;
   }
   
}


cNetMgr::~cNetMgr()
{
   if (fpSimPort) delete fpSimPort;
   if (fpCmsPort) delete fpCmsPort;
   if (fpPduTranslator) delete fpPduTranslator;
   if (fpCmsTranslator) delete fpCmsTranslator;
}

cUdpclient::cUdpclient(char *addr, int udpPort)
{
   if(addr==NULL) exit(0);
   if((sockfd = socket(AF_INET, SOCK_DGRAM,0)) < 0 )
   { cout <<"check the PORT!!!!!"<<endl;
     exit(0);
   }
   bzero(&servaddr, sizeof(servaddr));
   servaddr.sin_family = AF_INET ;
   servaddr.sin_addr.s_addr = inet_addr(addr);
   servaddr.sin_port = htons(udpPort);
}
/*void cUdpclient::toByte(float val, char* ret, unsigned* length)*/
void cUdpclient::toByte(float fval, unsigned short usval,
                        char* ret, unsigned* length)

{
   unsigned char *lp ;
   int i;
   /*
   *length = 4;

   if(!do_swap) *((float*)ret) = val;
   else
   {
      lp = (unsigned char *) &val;
      for(i=0;i<4;i++) ret[4-1-i]=lp[i];
   }

  */
  *length = 6;

     if(!do_swap)
        { lp = (unsigned char *) &fval;
          for(i=0;i<4;i++) ret[i]=lp[i];
             lp = (unsigned char *) &usval;
             for(i=0;i<2;i++) ret[4+i]=lp[i];
         }
         else
         { lp = (unsigned char *) &fval;
           for(i=0;i<4;i++) ret[3-i]=lp[i];
           lp = (unsigned char *) &usval;
           for(i=0;i<2;i++) ret[5-i]=lp[i];
        }
}
int cUdpclient::sendTo(float fdata, unsigned short usdata)
{
     unsigned len,err;
     char strLine[20];
      toByte(fdata,usdata,strLine,&len);
     err=sendto(sockfd,strLine,len,0, (struct sockaddr *)&servaddr, sizeof(struct sockaddr_in));
     return err;
}

cUdpclient::~cUdpclient()
{ close(sockfd);
}
