/*
$RCSfile: PerimEditorCB.cc,v $
$Revision: 1.1.1.1 $
$Author: jchappel $
$Date: 1999/02/16 14:54:42 $
$Log: PerimEditorCB.cc,v $
Revision 1.1.1.1  1999/02/16 14:54:42  jchappel
Comprehensive Mine Simulator

// Revision 2.1  1998/02/18  17:16:10  ksnively
// Incorporated AP mine replacement code.
//
// Revision 2.0  1998/01/26  21:01:35  ksnively
// Baseline CMS before additions for AP mine replacements.
//
// Revision 1.2  1997/12/17  14:38:03  ksnively
// Debugged Minefield duplication routine.
// Added input file "netparams" for reading PDU type enumerations.
// Got rid of warning messages during compilation.
//
// Revision 1.1  1997/12/16  13:59:57  ksnively
// Initial revision
//
// Revision 1.4  1997/10/02  17:51:30  austin
// first working port to modsaf3.0
//
// Revision 1.3  1997/10/02  17:48:55  austin
// first working port to modsaf3.0
//
// Revision 1.3  1997/10/02  17:48:55  austin
// first working port to modsaf3.0
//
// Revision 1.2  1997/05/07  12:32:33  ksnively
// *** empty log message ***
//
// Revision 1.1  1996/10/23  13:54:40  nsipes
// Initial revision
//
// Revision 1.9  1996/08/15  19:15:44  mkappel
// Change perimeter color when minefield state changes.
//
// Revision 1.8  1996/07/13  19:04:20  rcarp
// version 1.5b13, fixes bug dragging with two buttons and displays damamged vehicles
//
// Revision 1.7  1996/07/03  22:55:15  rcarp
// enhancements and bug fixes for version 1.5b9
//
// Revision 1.6  1996/05/08  00:50:23  rcarp
// changes for 1.5, incl user mines, mine params, param i/o, selection
//
// Revision 1.6  1996/05/08  00:50:23  rcarp
// changes for 1.5, incl user mines, mine params, param i/o, selection
//
// Revision 1.5  1996/04/04  22:16:03  mkappel
// Label minefield on PVD.
//
// Revision 1.4  1996/03/23  14:23:28  rcarp
// improvements to test mode and selection
//
// Revision 1.3  1996/02/21  19:45:02  rcarp
// revisions for map scroll, mine ranges
//
// Revision 1.2  1996/01/26  21:33:07  rcarp
// Revisions and bug fixes of CMS version 1.1b1
//
$State: Exp $
*/
 
/*******************************************

   file: PerimEditorCB.cc
   
      Copyright 1995 by the Institute for Defense Analyses
      
         Institute for Defense Analyses
         1801 N. Beauregard Street
         Alexandria, Virginia 22311-1772
         703-845-2000
         
      This software was developed by IDA under U. S. Government
      contract.  For distribution information contact:
      
         U. S. Army Night Vision Directorate
         AMSEL RD NV OD CD
         10221 Burbeck Road, suite 430
         Ft. Belvoir VA 22060-5806
      
*********************************************/

/*******************************************

   PerimEditorCB.cc
   
      The display interface implementation.
      
      
   
   Created by Michael Kappel
   Modification history:
      created   
      
*********************************************/

#include "Display.h"
#include "Minefield.h"
#include "MapGeometry.h"

#include <Xm/List.h>
#include <Xm/Text.h>
#include <Xm/TextF.h>
#include <bstring.h>
#include <math.h>
#include <stdext.h>

#define MAX_GCS  4

XFontStruct*        cPerimDisp::fFontInfo;
SNSTVE_CLASS        cPerimDisp::fSensNull;
SNSTVE_CLASS        cPerimDisp::fSensSelNull;
SNSTVE_CLASS        cPerimDisp::fSensPerim;
SNSTVE_CLASS        cPerimDisp::fSensPerimSelect;
GC                  cPerimDisp::fPerimGC [MAX_GCS];
int                 cPerimDisp::fSensPerimInstanceCounter;

SNSTVE_CLASS        cSegmentDisp::fSensNull;
GC                  cSegmentDisp::fSegmentGC[1];

void cPerimEditorWindow::CbDone (Widget /*w*/, XtPointer /*pObj*/, 
				 XmPushButtonCallbackStruct */*cbs*/)
{
   //cPerimEditorWindow*  pWin   = (cPerimEditorWindow*)pObj;
   cPerimeter*          pPerim = (cPerimeter*)(gpGuiWin->GetCurComponent());
   TPerimPoint*         pPt    = pPerim->GetFirstPoint();
   TLocation            tccPt  = pPt->GetTccPoint();

   // is last point valid ?
   if (! pPerim->ValidPerim (tccPt))
     return;

   pPerim->StopEditingComp();

/*
   if (pWin->fpMfCopy) {
     cMinefield* ppMfList[1];
     ppMfList[0] =  pWin->fpMfCopy;
     gMfieldMgr.DeleteMinefields (1, ppMfList);
     pWin->fpMfCopy = NULL;
   }
*/
   gpGuiWin->ShowEditor(cGuiWindow::eEditMinefield);
}

void cPerimEditorWindow::CbCancel (Widget /*w*/, XtPointer /*pObj*/, 
				   XmPushButtonCallbackStruct */*cbs*/)
{
   cMfComponent*   pCurComp = gpGuiWin->GetCurComponent();
   
   gpGuiWin->SetSelection( false, pCurComp->GetMinefield(), pCurComp);
   pCurComp->RestoreBackup();

   pCurComp->StopEditingComp();
/*
   cPerimEditorWindow*   pWin = (cPerimEditorWindow*)pObj;

   pWin->fpMfCopy->ReplaceInList (gpCurMinefield);
   pWin->fpMfCopy->RecreateVisuals();
   gpGuiWin->SetSelection (pWin->fpMfCopy->GetPerimeter());

   pWin->fpMfCopy->GetCompList()->ShowInfo();
*/
   gpGuiWin->ShowEditor(cGuiWindow::eEditMinefield);
}

void cPerimEditorWindow::MapClick (TLocation& loc)
{
  if (((cPerimeter*)(gpGuiWin->GetCurComponent()))->AddTccPoint (loc))
    fpVertexCoord->AppendCoordEntry (loc);
}

cCoordList*    cPerimEditorWindow::GetPerimVertexCoordWidget ()
{
   return fpVertexCoord;
}

void cPerimEditorWindow::ShowEdWindow()
{
   cPerimeter*  pPerim = (cPerimeter*)gpGuiWin->GetCurComponent();
   Assert( pPerim != NULL, kerrValidityCheck, "cPerimEditorWindow::ShowEdWindow");
   int          nvert = pPerim->GetNumPoints();

//   pPerim->StartEditingComp();
   pPerim->GetPerimDisp()->SetSensitive (true);
   pPerim->GetPerimDisp()->EditPerim ();

   XtVaSetValues (fwMinefieldName,
		  XmNvalue, gpGuiWin->GetCurMinefield()->GetMfName(),		  
		  NULL);

   fpVertexCoord->DeleteEntries();
   fpVertexCoord->AppendCoordEntry ();

   for (TPerimPoint* pPt = pPerim->GetFirstPoint();
	pPt; pPt = (TPerimPoint*)pPerim->GetNextPoint())

     fpVertexCoord->AppendCoordEntry (pPt->GetTccPoint());

   fpVertexCoord->UpdateNumEntries();
   SetButtonState ();
   XtManageChild (fwMainWin);

   // make a copy in case cancel
/*
   fpMfCopy = new cMinefield (gpCurMinefield, false);
*/
}


void cPerimEditorWindow::SetButtonState ()
{
   XtSetSensitive (fwDoneButton, 
		   ((cPerimeter*)(gpGuiWin->GetCurComponent()))->GetNumPoints() >= 3);
}

void cPerimDisp::SetStateColor (EBoolean on)
{
  fDfn.linear.gc = fPerimGC [on ? epsOn : epsOff];
  tactmap_update_object (gpTactmap, fpObj, &fDfn);
}

void cPerimDisp::SetVisible (EBoolean show)
{
  cDispObj::SetVisible (show);
  RedrawSelected ();
}

void cPerimDisp::RedrawSelected ()
{
  if (fpObjSelected) {
    if (!fpPerim->GetMinefield()->IsSelected()) {
      if (fbSelVisible) {
         tactmap_remove_object (gpTactmap, fpObjSelected);
         fbSelVisible = false;
      }
    }
    else if (! fbSelVisible) {
      tactmap_add_transient_object (gpTactmap, fpObjSelected);
      fbSelVisible = true;
    }
    else
      tactmap_update_object (gpTactmap, fpObjSelected, &fDfnSelected);
  }
}

void cPerimDisp::CbDrawSelected (Widget /*widget*/, Pixmap /*pixmap*/,
				 ADDRESS draw_arg, XRectangle *boundary)
{
  cPerimDisp*  pDisp = (cPerimDisp*)draw_arg; 
  int          nvert =  (int)pDisp->fDfn.linear.n_vertices;
//  XPoint      *xpts = (XPoint*)malloc (nvert * sizeof (XPoint));
  XPoint      *xpts = new XPoint [ nvert ];
  int32        x, y, xmin = 99999999, xmax = 0, ymin = 99999999, ymax = 0;

  if (pDisp->fpPerim->GetMinefield()->IsSelected() && nvert > 2) {
    for (int i = 0; i < nvert; i++) {
/*modified parameters to match modsaf3.0 libtactmap.h AUSTIN 4 Aug 97*/
      tactmap_map_to_screen (gpTactmap,
				(float64)pDisp->fDfn.linear.vertices[i*2],
				(float64)pDisp->fDfn.linear.vertices[i*2+1],
				(int32)0, &x, &y);
      if (x < xmin) xmin = x;
      if (x > xmax) xmax = x;
      if (y < ymin) ymin = y;
      if (y > ymax) ymax = y;
      xpts[i].x = x;
      xpts[i].y = y;
    }

    XFillPolygon (gpDisplay, gMapWindow, fPerimGC [MAX_GCS-1], xpts, 
		  nvert, Nonconvex, CoordModeOrigin);
    boundary->x      = xmin;
    boundary->y      = ymin;
    boundary->width  = xmax - xmin;
    boundary->height = ymax - ymin;
  }
  else
    bzero(boundary, sizeof(XRectangle));
    
  delete[] xpts;
}

void cPerimDisp::EditPerim ()
{
   int        nvert = fpPerim->GetNumPoints();
   TLocation  pt1, pt2;

   if (nvert >= 2) {
     fDfn.linear.n_vertices--;
     tactmap_update_object (gpTactmap, fpObj, &fDfn);
   
     if (nvert >= 3) {
       pt1.x = fDfn.linear.vertices[0];
       pt1.y = fDfn.linear.vertices[1];
       pt2.x = fDfn.linear.vertices[(nvert-1)*2];
       pt2.y = fDfn.linear.vertices[(nvert-1)*2+1];
       fpDashed = new cSegmentDisp (pt1, pt2);

       tactmap_update_object (gpTactmap, fpObjSelected, &fDfnSelected);
     }
   }
}

void cPerimDisp::CbMove (SNSTVE_WINDOW_PTR /*sensitive*/, 
			 SNSTVE_ACTION action,
			 SNSTVE_CALL_DATA *call_data, 
			 char */*name*/)
{
  float64         dx, dy, xmap, ymap, arccos, a2, b2, c2,off_vec[XYC];
  static float64  xorig, yorig;
  int32           v, cmap, corig;
  TLocation       tccPt;
  T2dMove         move;
  cPerimDisp*     pPerimDisp = (cPerimDisp*)call_data->user_data; 
  cPerimeter*     pPerim = pPerimDisp->fpPerim;
  
  Assert ( pPerim == gpGuiWin->GetCurComponent(), kerrValidityCheck, "cPerimDisp::CbMove" );

  if (call_data->button == 2) {
    /* since libsensitive is not returning correct offset for Motion */
    if (action == SNSTVE_PRESS)
/*added parameter to match modsaf3.0 libtactmap.h AUSTIN 4 Aug 97*/
      tactmap_screen_to_map (gpTactmap,
			     call_data->screen_x,
			     call_data->screen_y,
			     &xorig, &yorig, &corig);

    else if (action == SNSTVE_MOTION || action == SNSTVE_RELEASE) {
      TLocation    tccCenter = pPerim->GetMinefield()->GetTccLoc();

/*added parameter to match modsaf3.0 libtactmap.h AUSTIN 4 Aug 97*/
      tactmap_screen_to_map (gpTactmap,
			     call_data->screen_x,
			     call_data->screen_y,
			     &xmap, &ymap, &cmap);

      a2 = (xmap - tccCenter.x) * (xmap - tccCenter.x) +
	   (ymap - tccCenter.y) * (ymap - tccCenter.y);
      b2 = (xorig - tccCenter.x) * (xorig - tccCenter.x) +
	   (yorig - tccCenter.y) * (yorig - tccCenter.y);
      c2 = (xorig - xmap) * (xorig - xmap) +
	   (yorig - ymap) * (yorig - ymap);

      arccos = acos(-.5 * (c2 - a2 - b2) / (sqrt(a2) * sqrt(b2)));

      /* point right of line implies counterclockwise rotation */
      if (xmap * (tccCenter.y - yorig) + ymap * (xorig - tccCenter.x) +
	  (tccCenter.x * yorig - tccCenter.y * xorig) < 0)
	arccos = -arccos;

      move.SetMove (0., 0., (float)arccos);
      
      if (action == SNSTVE_MOTION)
	pPerimDisp->RotateObj (move);
      else /* RELEASE */
         pPerim->GetMinefield()->MoveMinefield (move);
    }
  }

  else if (action == SNSTVE_RELEASE) {

    /* move */

    if (call_data->button == 1) {
/*replaced tactmap_pixel_offset with tactmap_pix_to_offvec to match modsaf3.0 libtactmap.h AUSTIN 4 Aug 97*/

	tactmap_pix_to_offvec (gpTactmap,
			    call_data->xoff,
			    call_data->yoff,
			    off_vec);
	
	dx=off_vec[0];
	dy=off_vec[1];			
/*
      tactmap_pixel_offset (gpTactmap,
			    call_data->xoff,
			    call_data->yoff,
			    &dx, &dy);
*/
      /* vertex - just move vertex */
      if (TACTMAP_IS_VERTEX (call_data->instance)) {
	v = TACTMAP_INDEX (call_data->instance);
	tccPt.x = pPerimDisp->fDfn.linear.vertices[v*2] + dx;
	tccPt.y = pPerimDisp->fDfn.linear.vertices[v*2+1] + dy;
	pPerim->MovePoint ((int)v + 1, tccPt);
      }

      /* edge - move whole minefield */
      else {
         move.SetMove(dx, dy, 0.0);
         pPerim->GetMinefield()->MoveMinefield (move);
      }
    }

    /* delete */

    else if (call_data->button == 3) {
      if (TACTMAP_IS_VERTEX (call_data->instance)) {
	v = TACTMAP_INDEX (call_data->instance);
	pPerim->DeletePoint ((int)v + 1);
      }
    }
  }
}

void cPerimDisp::CbClickSelect (SNSTVE_WINDOW_PTR /*sensitive*/, 
			 SNSTVE_ACTION /*action*/,
			 SNSTVE_CALL_DATA *call_data, 
			 char */*name*/)
{
  cPerimDisp*     pPerimDisp = (cPerimDisp*)call_data->user_data; 
  cPerimeter*     pPerim = pPerimDisp->fpPerim;
  cMinefield*     pMf = pPerim->GetMinefield();
  
  gpGuiWin->SetSelection(false, pMf);
  
}

void cPerimDisp::RotateObj (T2dMove move)
{
  TLocation       tccPt, tccCenter = fpPerim->GetMinefield()->GetTccLoc();
  int             iPt = 0;

  for (TPerimPoint* pPt = fpPerim->GetFirstPoint();
       pPt; pPt = (TPerimPoint*)fpPerim->GetNextPoint()) {

    move.fRotMatrix.Mult (pPt->GetTccPoint() - tccCenter, &tccPt);
    fDfn.linear.vertices[iPt*2]   = tccPt.x + tccCenter.x;
    fDfn.linear.vertices[iPt*2+1] = tccPt.y + tccCenter.y;
    iPt++;
  }
  /*added AUSTIN 14 Aug 97*/
  fDfn.linear.cell = (int32)0;
  tactmap_update_object (gpTactmap, fpObj, &fDfn);
//  tactmap_update_object (gpTactmap, fpObjSelected, &fDfnSelected);

  if (fpDashed) {
    TLocation    pt1, pt2;
    pt1.x = fDfn.linear.vertices[0];
    pt1.y = fDfn.linear.vertices[1];
    pt2.x = fDfn.linear.vertices[(iPt-1)*2];
    pt2.y = fDfn.linear.vertices[(iPt-1)*2+1];
    fpDashed->MoveSegment (pt1, pt2);
  }			    
  UpdateLabelPos ();
}

void cPerimDisp::MoveVertex (int iPt, TLocation tccPt)
{
   int32        nvert = fDfn.linear.n_vertices;
   TLocation    pt1, pt2;
   cCoordList*  pVertexCoord = 
     gpGuiWin->GetCurEditor()->GetPerimVertexCoordWidget();

   if (!fpDashed && nvert >= 3 && iPt == nvert - 1) iPt = 0;

   if (pVertexCoord)
     pVertexCoord->ReplaceEntry (iPt + 1, tccPt);

   fDfn.linear.vertices[iPt*2] = tccPt.x;
   fDfn.linear.vertices[iPt*2+1] = tccPt.y;

   if (!fpDashed && nvert >= 3 && iPt == 0) {
     fDfn.linear.vertices[(nvert-1)*2] = fDfn.linear.vertices[0];
     fDfn.linear.vertices[(nvert-1)*2+1] = fDfn.linear.vertices[1];
   }

    /*added AUSTIN 14 Aug 97*/
    fDfn.linear.cell = (int32)0;
   tactmap_update_object (gpTactmap, fpObj, &fDfn);
//   tactmap_update_object (gpTactmap, fpObjSelected, &fDfnSelected);

   if (fpDashed) {
     pt1.x = fDfn.linear.vertices[0];
     pt1.y = fDfn.linear.vertices[1];
     pt2.x = fDfn.linear.vertices[(nvert-1)*2];
     pt2.y = fDfn.linear.vertices[(nvert-1)*2+1];
     fpDashed->MoveSegment (pt1, pt2);
   }			    
   UpdateLabelPos ();
}


cPerimDisp::cPerimDisp (cPerimeter *pPerim)
{
   fpPerim = pPerim;
   fpDashed = NULL;
   fpLabelObj = NULL;   // gets created when first point is added
   ++fSensPerimInstanceCounter;

   fDfn.sensitive.sensClass = &fSensNull;
   fDfn.sensitive.instance = fSensPerimInstanceCounter;
   fDfn.sensitive.user_data = (char*)this;

   fDfn.linear.style = LSplain;
   fDfn.linear.dashed = 0;
   fDfn.linear.width = 0;
   fDfn.linear.thickness = 2;
   fDfn.linear.gc = fPerimGC[epsNotSim];
   fDfn.linear.n_vertices = 0;
//   fDfn.linear.vertices = (float64 *) malloc (20 * sizeof (float64));
   fDfn.linear.vertices = new float64 [ 20 ];

    /*added AUSTIN 14 Aug 97*/
   fDfn.linear.cell = (int32)0;
   fpObj = tactmap_create_object (gpTactmap, TACTMAP_LINEAR, &fDfn);
   tactmap_add_object (gpTactmap, fpObj);/*transient_*/

   /* also create Selected Area dfn*/
   bzero(&fDfnSelected, sizeof(TACTMAP_OBJECT_DFN));
   fDfnSelected.sensitive.sensClass = &fSensSelNull;
   fDfnSelected.sensitive.instance = fSensPerimInstanceCounter;
   fDfnSelected.sensitive.user_data = (char*)this;
   fDfnSelected.drawn.draw = (TACTMAP_DRAW_CALLBACK)cPerimDisp::CbDrawSelected;
   fDfnSelected.drawn.draw_arg = (ADDRESS)this;
   fpObjSelected = tactmap_create_object (gpTactmap, TACTMAP_DRAWN, &fDfnSelected);
   tactmap_add_transient_object (gpTactmap, fpObjSelected);

   bzero(&fLabelDfn, sizeof(TACTMAP_OBJECT_DFN));
   fLabelDfn.sensitive.sensClass = &fSensSelNull;
   fDfnSelected.sensitive.instance = fSensPerimInstanceCounter;
   fLabelDfn.sensitive.user_data = (char*)this;
   fLabelDfn.text.gc = fPerimGC[epsNotSim];
   fLabelDfn.text.font_struct = fFontInfo;
   fLabelDfn.text.string = cppstrdup (pPerim->GetMinefield()->GetMfName());
}

void cPerimDisp::UpdateLabelName (char *name)
{
  if ( (fpLabelObj) && (strcmp (name, fLabelDfn.text.string) != 0) ) {
    delete[] fLabelDfn.text.string;
    fLabelDfn.text.string = cppstrdup (name);
    tactmap_update_object (gpTactmap, fpLabelObj, &fLabelDfn);
  }
}

void cPerimDisp::UpdateLabelPos ()
{
   int          imax, ascent, descent, dir;
   int32        xscreen, yscreen;
   float64      ymax; //, width, height;
   XCharStruct  overall;

   /* find vertex with maximum y */
   ymax = -9999999.;
   for (int i = 0; i < fDfn.linear.n_vertices; i++) {
     if (fDfn.linear.vertices[i*2+1] > ymax) {
       imax = i;
       ymax = fDfn.linear.vertices[i*2+1];
     }
   }

   /* center text above that vertex */
   XTextExtents (fFontInfo, fLabelDfn.text.string, strlen(fLabelDfn.text.string), 
		 &dir, &ascent, &descent, &overall);
/*modified parameters to match modsaf3.0 libtactmap.h AUSTIN 4 Aug 97*/
   tactmap_map_to_screen (gpTactmap, 
			  fDfn.linear.vertices[imax*2],
			  fDfn.linear.vertices[imax*2+1], 
			  (int32)0,&xscreen, &yscreen);
/*modified parameters to match modsaf3.0 libtactmap.h AUSTIN 4 Aug 97*/
   tactmap_screen_to_map (gpTactmap,
			  (int32)(xscreen - overall.width / 2), 
			  (int32)(yscreen - ascent - descent),
			  &fLabelDfn.text.x, &fLabelDfn.text.y,
			  &fLabelDfn.text.cell);
   tactmap_update_object (gpTactmap, fpLabelObj, &fLabelDfn);
}

void cPerimDisp::AddVertex (int nvert, TLocation tccPt)
{
   TLocation  pt1;

   if (nvert % 10 == 0)
     fDfn.linear.vertices = 
       (float64 *) realloc (fDfn.linear.vertices,
			    2 * (nvert + 10) * sizeof (float64));

   fDfn.linear.vertices[(nvert-1)*2] = tccPt.x;
   fDfn.linear.vertices[(nvert-1)*2+1] = tccPt.y;
   fDfn.linear.n_vertices = nvert;
   /*added AUSTIN 14 Aug 97*/
   fDfn.linear.cell = (int32)0;
   tactmap_update_object (gpTactmap, fpObj, &fDfn);
//   tactmap_update_object (gpTactmap, fpObjSelected, &fDfnSelected);

   if (nvert >= 3) {
     pt1.x = fDfn.linear.vertices[0];
     pt1.y = fDfn.linear.vertices[1];
     if (fpDashed == NULL) {
       fpDashed = new cSegmentDisp (pt1, tccPt);
       tactmap_update_object (gpTactmap, fpObjSelected, &fDfnSelected);
     }
     else
       fpDashed->MoveSegment (pt1, tccPt);
   }


   if (nvert == 1) {
     fpLabelObj = tactmap_create_object (gpTactmap, TACTMAP_TEXT, &fLabelDfn);
     tactmap_add_object (gpTactmap, fpLabelObj);
   }
   UpdateLabelPos ();
}

void cPerimDisp::DeleteVertex (int iPt)
{
   int           v, nvert = (int)fDfn.linear.n_vertices;
   TLocation     pt1, pt2;
   cCoordList*   pVertexCoord = 
     gpGuiWin->GetCurEditor()->GetPerimVertexCoordWidget();

   if (pVertexCoord)
     pVertexCoord->DeleteEntry (iPt + 1);

   for (v = iPt; v < nvert; v++) {
     fDfn.linear.vertices[v*2] = fDfn.linear.vertices[(v+1)*2];
     fDfn.linear.vertices[v*2+1] = fDfn.linear.vertices[(v+1)*2+1];
   }
   nvert = (int)--fDfn.linear.n_vertices;

   if (fpDashed) {
     if (nvert < 3) {
       delete fpDashed;
       fpDashed = NULL;
     }
     else if (iPt == 0 || iPt == nvert) {
       pt1.x = fDfn.linear.vertices[0];
       pt1.y = fDfn.linear.vertices[1];
       pt2.x = fDfn.linear.vertices[(nvert-1)*2];
       pt2.y = fDfn.linear.vertices[(nvert-1)*2+1];
       fpDashed->MoveSegment (pt1, pt2);
     }
   }

   tactmap_update_object (gpTactmap, fpObj, &fDfn);
//   tactmap_update_object (gpTactmap, fpObjSelected, &fDfnSelected);
   if (nvert == 0) {
     tactmap_destroy_object (gpTactmap, fpLabelObj);
     fpLabelObj = NULL;
   }
   else
     UpdateLabelPos ();

   gpGuiWin->SetEditorButtonState ();
}

void cPerimDisp::CloseLoop (int nvert)
{
   if (fpDashed) {
     delete fpDashed;
     fpDashed = NULL;
   }

   if (nvert > 2) {
     fDfn.linear.vertices[(nvert-1)*2] = fDfn.linear.vertices[0];
     fDfn.linear.vertices[(nvert-1)*2+1] = fDfn.linear.vertices[1];
     fDfn.linear.n_vertices = nvert;
     /*added AUSTIN 14 Aug 97*/
     fDfn.linear.cell = (int32)0;
     tactmap_update_object (gpTactmap, fpObj, &fDfn);
   }
}

void cPerimDisp::SetSensitive (EBoolean sens)
{
  if (sens) {
    fDfn.sensitive.sensClass = &fSensPerim;
    tactmap_update_object (gpTactmap, fpObj, &fDfn);
  }
  else if (fDfn.sensitive.sensClass == &fSensPerim) {
    fDfn.sensitive.sensClass = &fSensNull;
    tactmap_update_object (gpTactmap, fpObj, &fDfn);
  }
}

void cPerimDisp::SetSelectSens (EBoolean sens)
{
  if (sens) {
    fDfn.sensitive.sensClass = &fSensPerimSelect;
    tactmap_update_object (gpTactmap, fpObj, &fDfn);
  }
  else if (fDfn.sensitive.sensClass == &fSensPerimSelect) {
    fDfn.sensitive.sensClass = &fSensNull;
    tactmap_update_object (gpTactmap, fpObj, &fDfn);
  }
}

cPerimDisp::~cPerimDisp ()
{
  if (fpDashed) {
    delete fpDashed;
    fpDashed = NULL;
  }

  if (fpLabelObj) {
    tactmap_destroy_object (gpTactmap, fpLabelObj);
    fpLabelObj = NULL;
  }
}

void cPerimDisp::InitGCs (Widget wShell)
{
   Window            root;
   XGCValues         gcv;
   Pixmap            stipple;
   static char       stipple_bits[] = {0x01, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0};


   struct perim_disp_resources
     {
       Pixel not_sim;
       Pixel off;
       Pixel on;
       Pixel selected;
       Font  designations;
     } resources;

   static XtResource res_list[] = {
     { "not_sim" , "Not_Sim" , XmRPixel , sizeof(Pixel) ,
       XtOffset(struct perim_disp_resources *, not_sim) ,
       XmRString , "Gray50" } ,
     { "off" , "Off" , XmRPixel , sizeof(Pixel) ,
       XtOffset(struct perim_disp_resources *, off) ,
       XmRString , "Yellow" } ,
     { "on" , "On" , XmRPixel , sizeof(Pixel) ,
       XtOffset(struct perim_disp_resources *, on) ,
       XmRString , "Red" } ,
     { "selected" , "Selected" , XmRPixel , sizeof(Pixel) ,
       XtOffset(struct perim_disp_resources *, selected) ,
       XmRString , "Blue" } ,
     { "designations" , "Designations" , XmRFont , sizeof(Font) ,
       XtOffset(struct perim_disp_resources *, designations) ,
       XmRString , "Fixed" } ,
   };

   root = RootWindowOfScreen(XtScreen(wShell));

   /* Get the colors, and various other resources used */
   XtGetSubresources (wShell, &resources, "perim", "PERIM",
		      res_list, XtNumber(res_list), NULL, 0);

   gcv.font = resources.designations;
   fFontInfo = XQueryFont (gpDisplay, gcv.font);
   gcv.background = 
     tactmap_get_color(gpTactmap,(TACTMAP_OBJECT_CLASS)-1);

   gcv.foreground = resources.not_sim;
   fPerimGC [epsNotSim] = 
     XCreateGC(gpDisplay,root,GCForeground|GCBackground|GCFont,&gcv);
   gcv.foreground = resources.off;
   fPerimGC [epsOff] = 
     XCreateGC(gpDisplay,root,GCForeground|GCBackground|GCFont,&gcv);
   gcv.foreground = resources.on;
   fPerimGC [epsOn] = 
     XCreateGC(gpDisplay,root,GCForeground|GCBackground|GCFont,&gcv);
   gcv.foreground = resources.selected;
   fPerimGC [MAX_GCS-1] =
     XCreateGC(gpDisplay,root,GCForeground|GCBackground|GCFont,&gcv);
   /* stipple for selected */
   stipple = XCreateBitmapFromData (gpDisplay, root, stipple_bits, 8, 8);
   XSetFillStyle (gpDisplay, fPerimGC [MAX_GCS-1], FillStippled);
   XSetStipple (gpDisplay, fPerimGC [MAX_GCS-1], stipple);

   SNSTVE_INIT_CLASS(fSensNull);
   SNSTVE_INIT_CLASS(fSensSelNull);
   SNSTVE_INIT_CLASS(fSensPerim);
   callback_register_handler(fSensPerim.gesture, 
			     (CALLBACK_HANDLER)CbMove,
			     "perim");
   fSensPerim.buttons = 0x7; /* binary 111, Buttons 1, 2 and 3 */
   fSensPerim.sensitive = fSensPerim.hot = fSensPerim.dragable = 1;
   SNSTVE_INIT_CLASS(fSensPerimSelect);
   callback_register_handler(fSensPerimSelect.gesture, 
			     (CALLBACK_HANDLER)CbClickSelect,
			     "perimSel");
   fSensPerimSelect.buttons = 0x2; /* 1 << 1, Button 1 */
   fSensPerimSelect.sensitive = fSensPerimSelect.hot = 1;
   fSensPerimInstanceCounter = 0;
}

cSegmentDisp::cSegmentDisp (TLocation tccPt1, TLocation tccPt2)
{
  static float64             verts[4];

  verts[0] = tccPt1.x;
  verts[1] = tccPt1.y;
  verts[2] = tccPt2.x;
  verts[3] = tccPt2.y;

  fDfn.linear.style = LSplain;
  fDfn.linear.dashed = 1;
  fDfn.linear.width = 0;
  fDfn.linear.thickness = 2;
  fDfn.linear.gc = fSegmentGC [0];
  fDfn.linear.n_vertices = 2;
  fDfn.linear.vertices = verts;
  /*added AUSTIN 14 Aug 97*/
  fDfn.linear.cell = (int32)0;
  fDfn.sensitive.sensClass = &fSensNull;

  fpObj = tactmap_create_object (gpTactmap, TACTMAP_LINEAR, &fDfn);
  tactmap_add_object (gpTactmap, fpObj);
}

void cSegmentDisp::MoveSegment (TLocation tccPt1, TLocation tccPt2)
{
  fDfn.linear.vertices[0] = tccPt1.x;
  fDfn.linear.vertices[1] = tccPt1.y;
  fDfn.linear.vertices[2] = tccPt2.x;
  fDfn.linear.vertices[3] = tccPt2.y;

  tactmap_update_object (gpTactmap, fpObj, &fDfn);
//  tactmap_update_object (gpTactmap, fpObjSelected, &fDfnSelected);
}

cSegmentDisp::~cSegmentDisp ()
{
}

void cSegmentDisp::InitGCs (Widget wShell)
{
   Window            root;
   XGCValues         gcv;

   struct segm_disp_resources
     {
       Pixel dashed;
       Font  designations;
     } resources;

   static XtResource res_list[] = {
     { "dashed" , "Dashed" , XmRPixel , sizeof(Pixel) ,
       XtOffset(struct segm_disp_resources *, dashed) ,
       XmRString , "Orange" } ,
     { "designations" , "Designations" , XmRFont , sizeof(Font) ,
       XtOffset(struct segm_disp_resources *, designations) ,
       XmRString , "Fixed" } ,
   };

   root = RootWindowOfScreen(XtScreen(wShell));

   /* Get the colors, and various other resources used */
   XtGetSubresources (wShell, &resources, "dash", "DASH",
		      res_list, XtNumber(res_list), NULL, 0);

   gcv.font = resources.designations;
   gcv.background = 
     tactmap_get_color(gpTactmap,(TACTMAP_OBJECT_CLASS)-1);

   gcv.foreground = resources.dashed;
   fSegmentGC [0] = 
     XCreateGC(gpDisplay,root,GCForeground|GCBackground|GCFont,&gcv);

   SNSTVE_INIT_CLASS(fSensNull);
}
