/*
$RCSfile: PerimEditorCreate.cc,v $
$Revision: 1.1.1.1 $
$Author: jchappel $
$Date: 1999/02/16 14:54:42 $
$Log: PerimEditorCreate.cc,v $
Revision 1.1.1.1  1999/02/16 14:54:42  jchappel
Comprehensive Mine Simulator

// Revision 2.0  1998/01/26  21:01:35  ksnively
// Baseline CMS before additions for AP mine replacements.
//
// Revision 2.0  1998/01/26  21:01:35  ksnively
// Baseline CMS before additions for AP mine replacements.
//
// Revision 1.1  1997/12/16  13:59:57  ksnively
// Initial revision
//
// Revision 1.3  1997/10/02  17:53:37  austin
// first working port to modsaf3.0
//
// Revision 1.2  1997/10/02  17:50:22  austin
// first working port to modsaf3.0
//
// Revision 1.2  1997/10/02  17:50:22  austin
// first working port to modsaf3.0
//
// Revision 1.1  1996/10/23  13:54:40  nsipes
// Initial revision
//
// Revision 1.1  1996/10/23  13:54:40  nsipes
// Initial revision
//
// Revision 1.4  1996/07/03  22:55:15  rcarp
// enhancements and bug fixes for version 1.5b9
//
// Revision 1.3  1996/05/14  16:15:08  rcarp
// refinements and bug fixes for 1.5 delivery
//
// Revision 1.2  1996/03/13  00:12:33  mkappel
// Create scrolling set of toggles for mines.
//
// Revision 1.2  1996/03/13  00:12:33  mkappel
// Create scrolling set of toggles for mines.
//
// Revision 1.1  1996/01/23  16:52:30  rcarp
// Initial revision
//
$State: Exp $
*/
 
/*******************************************

   file: PerimEditorCreate.cc
   
      Copyright 1995 by the Institute for Defense Analyses
      
         Institute for Defense Analyses
         1801 N. Beauregard Street
         Alexandria, Virginia 22311-1772
         703-845-2000
         
      This software was developed by IDA under U. S. Government
      contract.  For distribution information contact:
      
         U. S. Army Night Vision Directorate
         AMSEL RD NV OD CD
         10221 Burbeck Road, suite 430
         Ft. Belvoir VA 22060-5806
      
*********************************************/

/*******************************************

   PerimEditorCreate.cc
   
      The display interface implementation.
      
      
   
   Created by Michael Kappel
   Modification history:
      created   
      
*********************************************/

#include "Display.h"
#include <Xm/Form.h>
#include <Xm/Frame.h>
#include <Xm/Label.h>
#include <Xm/LabelG.h>
#include <Xm/List.h>
#include <Xm/MenuShell.h>
#include <Xm/PanedW.h>
#include <Xm/PushB.h>
#include <Xm/ScrolledW.h>
#include <Xm/ScrollBar.h>
#include <Xm/Text.h>
#include <Xm/TextF.h>
#include <Xm/ToggleB.h>
#include <stdio.h>

cPerimEditorWindow::cPerimEditorWindow (Widget wParent)
   : cCompEditorWindow (wParent)
{
   Widget            wLabel, wCoordForm;
   cHelpTextWidget*  pHelp;
   char             *help_text;

   wLabel = 
     XtVaCreateManagedWidget ("Minefield Perimeter Editor", 
			      xmLabelGadgetClass, fwMainWin,
			      XmNtopAttachment, XmATTACH_FORM,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 0,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 20,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      NULL);

   fpVertexCoord = new cCoordList (fwMainWin, ecltPerimVertex);
   wCoordForm = fpVertexCoord->GetCoordForm();
   XtVaSetValues (wCoordForm,
		  XmNtopAttachment, XmATTACH_FORM,
		  XmNtopOffset, 5,
		  XmNbottomAttachment, XmATTACH_WIDGET,
		  XmNbottomWidget, fwActionArea,
		  XmNbottomOffset, 10,
		  XmNrightAttachment, XmATTACH_FORM,
		  NULL);

   help_text = cppstrdup ("Add Vertex: left click on map or select first blank entry at right.\nDelete Vertex: right click on map or use Delete button in entry pop-up.\nMove Vertex: left click-and-drag or use entry pop-up.\nMove Whole Minefield: left click-and-drag a perimeter edge.\nRotate Whole Minefield: middle click-and-drag."); 

   pHelp = new cHelpTextWidget (fwMainWin, help_text);
   XtVaSetValues (pHelp->GetHelpForm(),
		  XmNtopAttachment, XmATTACH_WIDGET,
		  XmNtopWidget, fwMinefieldName,
		  XmNtopOffset, 10,
		  XmNleftAttachment, XmATTACH_WIDGET,
		  XmNleftWidget, wLabel,
		  XmNrightAttachment, XmATTACH_WIDGET,
		  XmNrightWidget, wCoordForm,
		  XmNrightOffset, 5,
		  NULL);
   delete[] help_text;

   XtAddCallback( fwDoneButton, XmNactivateCallback, 
		 (XtCallbackProc)CbDone, this);
   XtAddCallback( fwCancelButton, XmNactivateCallback, 
		 (XtCallbackProc)CbCancel, this);
}

cPerimEditorWindow::~cPerimEditorWindow ()
{
}
