/*
$RCSfile: Vehicle.cc,v $
$Revision: 1.2 $
$Author: jchappel $
$Date: 1999/03/25 19:07:55 $
$Log: Vehicle.cc,v $
Revision 1.2  1999/03/25 19:07:55  jchappel
changes made to cms some time ago, should be okay

Revision 1.1.1.1  1999/02/16 14:54:44  jchappel
Comprehensive Mine Simulator

// Revision 2.5  1998/12/02  16:38:47  jchappel
// added gui detonator
//
// Revision 2.4  1998/10/27  19:34:43  jchappel
// modifications for versioning
//
// Revision 2.3  1998/04/20  15:10:36  ksnively
// *** empty log message ***
//
// Revision 2.2  1998/02/26  21:24:37  ksnively
// Created Mf Camera object to control MAK Stealth view.
// Created vulnerability tables specific to command detonated mines
// and the camera object.
//
// Revision 2.1  1998/02/18  17:16:10  ksnively
// Incorporated AP mine replacement code.
//
// Revision 2.0  1998/01/26  21:01:35  ksnively
// Baseline CMS before additions for AP mine replacements.
//
// Revision 1.1  1997/12/16  13:59:57  ksnively
// Initial revision
//
// Revision 1.4  1997/10/02  17:53:37  austin
// first working port to modsaf3.0
//
// Revision 1.3  1997/10/02  17:50:22  austin
// first working port to modsaf3.0
//
// Revision 1.3  1997/10/02  17:50:22  austin
// first working port to modsaf3.0
//
// Revision 1.2  1997/05/07  12:32:33  ksnively
// *** empty log message ***
//
// Revision 1.2  1997/05/07  12:32:33  ksnively
// *** empty log message ***
//
// Revision 1.1  1996/10/23  13:54:40  nsipes
// Initial revision
//
// Revision 1.14  1996/07/13  19:04:20  rcarp
// version 1.5b13, fixes bug dragging with two buttons and displays damamged vehicles
//
// Revision 1.12  1996/07/03  22:55:15  rcarp
// enhancements and bug fixes for version 1.5b9
//
// Revision 1.11  1996/06/22  13:04:11  rcarp
// deton vuln bug fixes for 1.5b4
//
// Revision 1.10  1996/06/21  17:04:20  rcarp
// upgrades for release 1.5b3, mostly mine vuln
//
// Revision 1.9  1996/06/19  19:08:07  rcarp
// revisions for mine vulnerability, version 1.5b2
//
// Revision 1.8  1996/05/14  16:15:08  rcarp
// refinements and bug fixes for 1.5 delivery
//
// Revision 1.7  1996/05/11  15:15:24  rcarp
// test mode and mine selector work
//
// Revision 1.7  1996/05/11  15:15:24  rcarp
// test mode and mine selector work
//
// Revision 1.4  1996/02/16  19:33:39  rcarp
// revisions for 1.1b7 version
//
// Revision 1.3  1996/02/05  14:31:34  rcarp
// Updates and bug fixes of release version 1.1b5
//
$State: Exp $
*/
 
/*******************************************

   file: Vehicle.cc
   
      Copyright 1995 by the Institute for Defense Analyses
      
         Institute for Defense Analyses
         1801 N. Beauregard Street
         Alexandria, Virginia 22311-1772
         703-845-2000
         
      This software was developed by IDA under U. S. Government
      contract.  For distribution information contact:
      
         U. S. Army Night Vision Directorate
         AMSEL RD NV OD CD
         10221 Burbeck Road, suite 430
         Ft. Belvoir VA 22060-5806
      
*********************************************/

/*******************************************

   Vehicle.cc
   
      The vehicle implementation.
      
      
   
   Created by Richard Carpenter
   Modification history:
      created   
      
*********************************************/

#include "Vehicle.h"
#include "NetMgr.h"
#include "Display.h"
#include "Minefield.h"
#include "EntityDB.h"
#include "CmsControl.h"
#include "MapGeometry.h"
#include "DisPdu203.h"
#include "AnalData.h"
#include "TestMode.h"
#include "MapControls.h"

#include <iostream.h>
#include <stdlib.h>
#include <math.h>

TTimeSim   cVehicle::fTimeoutDelay = 10000;

const TKeywordEntry cVehicleMgr::fVehMgrTable[evehmgrSizeTable] = {
	"testVehicleType", ekeyLev1Struct
};

// ************************************
//   vehicle lists
// ************************************

cLinkVeh::cLinkVeh(cVehicle* pVeh, cLinkVeh* pPrev) :
   T2link(pPrev)
{   
   fpVehicle = pVeh;
}

cLinkVeh::~cLinkVeh()
{
}

cVehListHead::cVehListHead(cVehListHead* pOldHead) : T2linkHead(pOldHead)
   // this list head takes over the list from the old head
{
/*
   if (newOwner) {
      for ( cLinkVehLoc* pLink  = (cLinkVehLoc*)GetFirstLink(); 
                         pLink != (cLinkVehLoc*)GetNULLLink(); 
                         pLink  = (cLinkVehLoc*)GetNextLink())
         pLink->SetRefOwner(newOwner);
   }
*/
}

cVehListHead::cVehListHead() : T2linkHead()
{
}

/*
void   cVehListHead::DeleteList()
{
   while (fpNext != this)
      delete fpNext;
}
*/

cVehicle*   cVehListHead::GetFirstVeh()
{ 
   fpCurrent = fpNext;
   if (fpCurrent == this)
      return NULL;
   else
      return ((cLinkVeh*)fpCurrent)->fpVehicle; 
}

cVehicle*   cVehListHead::GetNextVeh()
{ 
   fpCurrent = fpCurrent->fpNext; 
   
   if (fpCurrent == this)
      return NULL;

   return ((cLinkVeh*)fpCurrent)->fpVehicle; 
}

EBoolean    cVehListHead::IsInList(const cVehicle* pVeh, cLinkVeh** ppVehNode)
{
   for (cLinkVeh* pVN = (cLinkVeh*)fpNext; (T2link*)pVN != this; pVN = (cLinkVeh*)(pVN->fpNext)) {
      if ( pVN->fpVehicle == pVeh ) {
         *ppVehNode = pVN;
         return true;
      }
   }
   *ppVehNode = NULL;
   return false;
}

cVehListHead::~cVehListHead()
{
   while (fpNext != this)
      delete fpNext;
}

void     cLinkVehLoc::SetLocation()
{
   if ( (fpRefEnt != NULL) && (fpVehicle != NULL) ) {
      fTime  = GetCurSimTime();
      
      if ( fbTgtVelRef ) {
         TRotation mapRot, vehTccRot;
         gpTerrainMgr->GetMapRotationGeoPt( &mapRot, fpRefEnt->GetDrGeoLoc(fTime) );
         TVelocity mapVel = mapRot * fpVehicle->GetVehicleGeoVel();
				 
            // if veh is stopped, use its orientation, otherwise its velocity for direction
         if ( (mapVel.x > 0.1) || (mapVel.y > 0.1) ) {
            fAzRot = atan2(mapVel.y, mapVel.x);
            vehTccRot.SetRotation( fAzRot, 0.0, kPi );   // z points down in veh coords
         }
         else {
            fAzRot = fpVehicle->GetTccOrient().psi;
            vehTccRot = fpVehicle->GetTccRot();
         }
         fVelocity = vehTccRot * mapVel;
         fLocation = vehTccRot * (fpVehicle->GetDrTccLoc(fTime) - fpRefEnt->GetDrTccLoc(fTime));

         if ( IsVerySmall(fVelocity.x) ) fbApproaching = false;
         else {
            if ( (fLocation.x / fVelocity.x) < 0.0 ) fbApproaching = true;
            else                                     fbApproaching = false;
         }
      }
      
      else {
         fpRefEnt->GeoToLocalLoc(fpVehicle->GetDrGeoLoc(fTime), &fLocation);
         fpRefEnt->GeoToLocalVel(fpVehicle->GetVehicleGeoVel(), &fVelocity);
         fAzRot = 0.0;
         
         if ( IsVerySmall(fVelocity.y) ) fbApproaching = false;
         else {
            if ( (fLocation.y / fVelocity.y) < 0.0 ) fbApproaching = true;
            else                                     fbApproaching = false;
      
         }
      }
   }
}

void     cLinkVehLoc::SnapZ()
         // fixes elevation for detonation
         //  for ground encounters, -fLocation.z should be half vehicle height
{
   if ( (fLocation.z < -2.0) || (fLocation.z > 0.0) )
//      cout << "snapping z, calc value is " << fLocation.z << endl;
   fLocation.z =  - fpVehicle->GetDimensions().height / 2.0;
   fLocation.z -=  ((cMine*)fpRefEnt)->GetMineDepth() * kInchToMeter;
/*
   if ( (fLocation.z > 2.0) || (fLocation.z < 0.0) )
      cout << "snapping z, calc value is " << fLocation.z << endl;
   fLocation.z =   fpVehicle->GetDimensions().height / 2.0;
   fLocation.z +=  ((cMine*)fpRefEnt)->GetMineDepth() * kInchToMeter;
*/
}

void    cLinkVehLoc::GetLocTgtRef(TEntCoord* pLocTgtRef) const
{
   if ( fbTgtVelRef ) {
      (* pLocTgtRef).x = -fLocation.x;
      (* pLocTgtRef).y = -fLocation.y;
      (* pLocTgtRef).z = -fLocation.z;
   }
   else {
         // rotate to global and then to tgt but without translation
      TEntCoord geoRef;
      fpRefEnt->GetGeoRot().MultTrans( ((T3Dsingle)fLocation) * float(-1.0), &geoRef);
      fpVehicle->GetGeoRot().Mult(geoRef, pLocTgtRef);
   }
}

cLinkVehLoc::cLinkVehLoc(cLinkVehLoc* pPrVeh, cLinkVeh* pPrev, cEntity* pRefEnt,
      EBoolean refTgtVel) : cLinkVeh(pPrVeh->fpVehicle, pPrev)
     //copies data from another link
     //  if pRefEnt is given, new data are computed for new ref system.
     //   if pRefEnt is null, complete copy from old ref system is made.
{
   if (pRefEnt) {
      fpRefEnt       = pRefEnt;
      fbTgtVelRef    = refTgtVel;
      SetLocation();
   }
   else {
      fpRefEnt      = pPrVeh->fpRefEnt;
      fbTgtVelRef   = pPrVeh->fbTgtVelRef;
      fAzRot        = pPrVeh->fAzRot;
      fLocation     = pPrVeh->fLocation;
      fVelocity     = pPrVeh->fVelocity;
      fTime         = pPrVeh->fTime;
   }
}

cLinkVehLoc::cLinkVehLoc(cVehicle* pVeh, cLinkVeh* pPrev, cEntity* pRefEnt,
      EBoolean refTgtVel) : cLinkVeh(pVeh, pPrev)
         // gets data from the original master vehicle link
{
   fpRefEnt       = pRefEnt;
   fbTgtVelRef    = refTgtVel;
   SetLocation();
}

cLinkVehLoc::~cLinkVehLoc()
{
}

EPartResult cLinkVehGeom::GetPartResult(EPartParam type)
{
   switch (type) {
   		case ePrtFullPlow:
   				return fFwmPResult;
//   			break;
   
   		case ePrtTrackPlow:
   				return fTwmPResult;
//   			break;
   
   		case ePrtFullRake:
   				return fFwmRResult;
//   			break;
   
   		case ePrtTrackRoller:
   				return fTwmRResult;
//   			break;
   
   		case ePrtDogbone:
   				return fDbResult;
//   			break;
   
   		case ePrtMagCm:
   				return fMagCmResult;
//   			break;
   }
   return eprNotEngaged;
}



void    cLinkVehGeom::SetInteraction(cInteraction* pInter)
{
	if (fpInteract)
		delete fpInteract;
   fpInteract = pInter;
}

void    cLinkVehGeom::DeleteInteraction()
{ 
	if (fpInteract) {
      if ( gfInteract )
         fpInteract->WriteInteraction(gpInteract);
		delete fpInteract;
   }
   fpInteract = NULL;
}

void    cLinkVehGeom::SetInteractResult(int eResult) const
{
   if (fpInteract)
      fpInteract->SetResult( (EInteractionResult) eResult); 
}

int    cLinkVehGeom::GetInteractResult() const
{
   if (fpInteract)
      return (int) (fpInteract->GetResult());
   else
      return 0;
}

void   cLinkVehGeom::UpdateTrkRec()
{
   SetLocation();    // get up to date vehicle info
   
   double dHSq = fLocation.x*fLocation.x + fLocation.y*fLocation.y;
   double dSq = dHSq + fLocation.z*fLocation.z;
   
   fHorzRange = sqrt(dHSq);
   fRange     = sqrt(dSq);
   fAzimuth   = atan2(fLocation.y, fLocation.x);
   fElevation = atan2(fLocation.z, fHorzRange);
}

cLinkVehGeom::cLinkVehGeom(cVehicle* pVeh, cLinkVeh* pPrev, cEntity* pRefEnt, EBoolean refInvert) :
      cLinkVehLoc(pVeh, pPrev, pRefEnt, refInvert)
{   
   fbApproaching   = false;
   fFwmPResult      = eprNotEngaged;
   fTwmPResult      = eprNotEngaged;
   fFwmRResult      = eprNotEngaged;
   fTwmRResult      = eprNotEngaged;
   fDbResult        = eprNotEngaged;
   fMagCmResult     = eprNotEngaged;
   fDetectResult    = edrNotEngaged;

      // these are all set in UpdateTrRec
   fRange     = 0.0;
   fHorzRange = 0.0;
   fAzimuth   = 0.0;
   fElevation = 0.0;
   
   fpInteract = NULL;
   fTime = 0;      // to ensure getting new data, for new coord system
}

cLinkVehGeom::cLinkVehGeom(cLinkVehGeom* pTrkVeh, cLinkVeh* pPrev) :
      cLinkVehLoc( (cLinkVehLoc*)pTrkVeh, pPrev)
{
      // time, loc, vel copied in cLinkVehLoc
   fbApproaching = pTrkVeh->fbApproaching;
   fRange        = pTrkVeh->fRange;
   fHorzRange    = pTrkVeh->fHorzRange;
   fAzimuth      = pTrkVeh->fAzimuth;
   fElevation    = pTrkVeh->fElevation;

   fFwmPResult      = pTrkVeh->fFwmPResult;
   fTwmPResult      = pTrkVeh->fTwmPResult;
   fFwmRResult      = pTrkVeh->fFwmRResult;
   fTwmRResult      = pTrkVeh->fTwmRResult;
   fDbResult        = pTrkVeh->fDbResult;
   fMagCmResult     = pTrkVeh->fMagCmResult;
   fDetectResult    = pTrkVeh->fDetectResult;

   fpInteract    = pTrkVeh->fpInteract;
   pTrkVeh->fpInteract = NULL;
}

cLinkVehGeom::cLinkVehGeom(cLinkVehLoc* pProxVeh, cLinkVeh* pPrev, cEntity* pRefEnt, EBoolean refInvert) :
      cLinkVehLoc(pProxVeh, pPrev, pRefEnt, refInvert)
{   
   fbApproaching   = false;
   fFwmPResult      = eprNotEngaged;
   fTwmPResult      = eprNotEngaged;
   fFwmRResult      = eprNotEngaged;
   fTwmRResult      = eprNotEngaged;
   fDbResult        = eprNotEngaged;
   fMagCmResult     = eprNotEngaged;
   fDetectResult    = edrNotEngaged;

      // these are all set in UpdateTrRec
   fRange     = 0.0;
   fHorzRange = 0.0;
   fAzimuth   = 0.0;
   fElevation = 0.0;
   
   fTime = 0;
   fpInteract = NULL;
}

cLinkVehGeom::~cLinkVehGeom()
{
   if ( fpInteract )
      DeleteInteraction();
}

EBoolean   TVehPart::IsCmPart()
{ 
   switch (fParamType) {
      case ePrtFullPlow:
      case ePrtTrackPlow:
      case ePrtFullRake:
      case ePrtTrackRoller:
      case ePrtDogbone:
      case ePrtMagCm:
            return true;
//         break;
   }
   return false;
}

EBoolean   TVehPart::IsTurret()
{ 
   switch (fParamType) {
      case ePrtTurret:
            return true;
//         break;
   }
   return false;
}

TVehPart::TVehPart(TVehPart* pOldPart)
{ 
   *this = *pOldPart;
}

TVehPart::TVehPart()
{
   fChange      = 0;
   fChange204   = 0;
   fAttachPoint = 0;
   fValueType   = 0;
   fValue       = 0.0;
   fAttached    = false;
   
   fParamType   = ePrtOther;
   fDepth       = 0.0;
}

void   cSendViewControlMsg::SendMsg()
{
   (gpNetMgr->GetPduTrans())->SendViewControl(fpView, fToID);
}

cSendViewControlMsg::~cSendViewControlMsg()
{ }

void   cVehStateMsg::SendMsg()
{
   gVehMgr.ForwardVehStateMsg(fpVeh);
      
   if ( fInternal ) {
      (gpNetMgr->GetPduTrans())->SendVehState(fpVeh);
   }
}

cVehStateMsg::cVehStateMsg( cVehicle* pVeh, EBoolean internal)
{
   fpVeh     = pVeh;
   fInternal = internal;
}

cVehStateMsg::~cVehStateMsg()
{ }

void   cSendVehStateMsg::SendMsg()
{
   (gpNetMgr->GetPduTrans())->SendVehState(fpVeh);
}

cSendVehStateMsg::~cSendVehStateMsg()
{ }

void   cPriorityVehStateMsg::SendMsg()
{
   gVehMgr.ForwardVehStateMsg(fpVeh);
      
   if ( fInternal ) {
      (gpNetMgr->GetPduTrans())->SendVehState(fpVeh);
   }
}

cPriorityVehStateMsg::cPriorityVehStateMsg( cVehicle* pVeh, EBoolean internal)
{
   fpVeh     = pVeh;
   fInternal = internal;
}

cPriorityVehStateMsg::~cPriorityVehStateMsg()
{
}

void    cUpdateVehicleMsg::SendMsg()
{
   fpVehicle->UpdateVehicle();
}

cUpdateVehicleMsg::~cUpdateVehicleMsg()
{
}

EBoolean    cVehicleMgr::IsPriorityVeh(const TEntityID & vID)
{
   if ( FindVehicle(vID, &fPriorityList) )
      return true;
   else
      return false;
}

TLocation     cVehicle::GetDrGeoLoc(TTimeSim time)
   //** fill in correctly with Dead Reckoning algorithms
{
   return fGeoLocation + ( fGeoVelocity * (kSimTimeToSec * (time - fTime)));
}

TLocation     cVehicle::GetDrTccLoc(TTimeSim time)
{
   return fTccLocation + ( (fTccRotation | fEntVelocity) * (kSimTimeToSec * (time - fTime)));
}

void       cVehicle::GeoToLocalVel(const T3Dsingle& geoVel, T3Dsingle* pLocVel)
{
   fGeoRotation.Mult( geoVel, pLocVel);
   *pLocVel -= fEntVelocity;
}

void       cVehicle::LocalToGeoVel(const T3Dsingle& locVel, T3Dsingle* pGeoVel)
{
   
   T3Dsingle vel = fEntVelocity + locVel;
   fGeoRotation.MultTrans(vel, pGeoVel);
}

char*   cVehicle::GetEntName()
{
   if ( fpDbVeh )
      return fpDbVeh->GetEntryEntityName();
   else
      return NULL;
}

const  TVehDimensions&  cVehicle::GetDimensions()  const 
{
   if ( fpDbVeh )
      return fpDbVeh->GetVehDim();
   else
      return TVehDimensions(0.0);
}

TVehPart*   cVehicle::GetPartByType(EPartParam type)
{
   for ( int i = 0; i < fNumParts; i++ ) {
      if (fpVehPartList[i].fParamType == type)
         return &fpVehPartList[i];
   }
   return NULL;
}

float   cVehicle::GetPartExtension(EPartParam type)
{
   for ( int i = 0; i < fNumParts; i++ ) {
      if (fpVehPartList[i].fParamType == type)
	if ((fpVehPartList[i].fValueType & eprtmskValType) == ePartTypeExtension)
	   return  fpVehPartList[i].fValue;
   }
   return 0.000;
}

void        cVehicle::ProcVehStateMsg( cVehicle* pVeh)
{
   fTime        = pVeh->fTime;
   fId          = pVeh->fId;
   fForce       = pVeh->fForce;
   fCmsType     = pVeh->fCmsType;
   fAltType     = pVeh->fAltType;
   fTurretAzimuth     = pVeh->fTurretAzimuth;
   
   SetCoordGeoRef( pVeh->fGeoLocation, pVeh->fGeoOrient);
   if ( fpDisplay && ! IsDisplayable() ) {
      delete fpDisplay;
      fpDisplay = NULL;
   }

   fVelocity    = pVeh->fVelocity;
   if ( fDrAlg < eDrLowestBody ) {
      fGeoVelocity = pVeh->fVelocity;
      fEntVelocity = fGeoRotation * fGeoVelocity;
   }
   else {
      fEntVelocity = pVeh->fVelocity;
      fGeoRotation.MultTrans(fEntVelocity, &fGeoVelocity);
   }
   
   fAppearance  = pVeh->fAppearance;
   fDrAlg       = pVeh->fDrAlg;
   fDrAccel     = pVeh->fDrAccel;
   fDrAngVel    = pVeh->fDrAngVel;
   
   fTimeout     = fTime + fTimeoutDelay;

   fNumParts       = pVeh->fNumParts;
   delete[] fpVehPartList;
   fpVehPartList   = pVeh->fpVehPartList;
   fbHasCmPart     = pVeh->fbHasCmPart;

   if ( gbGui && IsDisplayable() && (!fpDisplay) )
      fpDisplay = new cVehDisp(this, cMapControlsWindow::IsVehDisplayed(fForce));
}

void        cVehicle::SimulateVehicle()
{
   
   if ( (fCmsType.kind == ekindPlatform) ||
        (fCmsType.kind == ekindLifeform) ) {
      if ( ! fpDbVeh )
         fpDbVeh = (cDbVeh*)(gVehDbMgr.MatchClosestOne(fCmsType));
   }
      
   if ( gbGui && IsDisplayable() )
      fpDisplay = new cVehDisp(this, cMapControlsWindow::IsVehDisplayed(fForce));
   else
      fpDisplay = NULL;
   
   fbSimulating = true;
   fpUpdateVehMsg = new cUpdateVehicleMsg(this);
}

void        cVehicle::UpdateVehicle()
   // we perform dead reckoning update, regardless of how long ago
   // we received a pdu.
   //** look into dead reckoning algorithms
{
   TTimeSim   now = GetCurSimTime();
   
   if ( now < fTimeout ) {
      float  timeSec = kSimTimeToSec * (now - fTime);
      fGeoLocation += fGeoVelocity * timeSec;
      fTime = now;
      SetTccCoordFromGeo();
      
      if ( fpDisplay)
         fpDisplay->UpdateVehicleDisp();
      fpUpdateVehMsg = new cUpdateVehicleMsg(this);
   }
   
   else {
      gVehMgr.VehTimedOut(this);
      if ( fpDisplay) {
         delete fpDisplay;
         fpDisplay = NULL;
      }
   }
}

void cVehicle::ShowVehicle (EBoolean show)
{
  if ( fpDisplay ) {
     if ( cMapControlsWindow::IsVehDisplayed(fForce) )
        fpDisplay->SetVisible (show);
     else
        fpDisplay->SetVisible (false);
  }
}

EBoolean    cVehicle::IsDisplayable ()
{
   if ( (fCmsType.kind != ekindPlatform) &&
        (fCmsType.kind != ekindMunition) &&
        (fCmsType.kind != ekindLifeform) )
      return false;

   if ( ! gpTerrainMgr->InTccArea(fTccLocation) )
      return false;
   return true;
}

void   cVehicle::WriteEntSumm(ofstream* pOut)
{
   *pOut << "vehicle id: "
         << GetEntityID().site        << " "
         << GetEntityID().application << " "
         << GetEntityID().entityNum;
   *pOut << " force: "
         << (int)fForce;
   *pOut << " vehicle type: "
         << GetEntName();
   *pOut << " entity type enum: ";
   fCmsType.WriteEntityType(pOut);
}

cVehicle::cVehicle()
{
   fpDbVeh      = NULL;
   fTime        = GetCurSimTime ();
   fForce       = eOther;
   fAppearance  = eAprStandard;
   fDrAlg       = eDrStatic;
   fpDisplay    = NULL;
   fpUpdateVehMsg = NULL;
//   fVehTypeName   = NULL;
   fNumParts     = 0;
   fpVehPartList = NULL;
   fbHasCmPart   = false;
   fTurretAzimuth = 0.0;
   
   fTimeout     = fTime + fTimeoutDelay;
}

cVehicle::~cVehicle()
{
}

void   cSimVehicle::UpdateLocation()
{
}

cSimVehicle::cSimVehicle()
{
   gCmsMgr.GetNextEntityId(this, &fId);
}

cSimVehicle::~cSimVehicle()
{

}

cController::cController()
{
}

cVehicle*   cVehicleMgr::FindVehicle(const TEntityID & vID, cVehListHead* pListHead)
{
   cVehicle* pVeh;
   
   cVehListHead* pHead = pListHead;
   if ( pHead == NULL ) pHead = &fVehList;
   
   for ( pVeh = pHead->GetFirstVeh(); 
         pVeh; 
         pVeh = pHead->GetNextVeh() )
      if (pVeh->GetEntityID() == vID)
         return pVeh;

   return NULL;
}

void    cVehicleMgr::VehTimedOut( cVehicle* pVeh )
      // move to TO list, veh itself does display
{
   cLinkVeh* pVehLink;
   for ( pVehLink  = (cLinkVeh*) (fVehList.GetFirstLink()); 
         pVehLink != (cLinkVeh*) (fVehList.GetNULLLink()); 
         pVehLink  = (cLinkVeh*) (fVehList.GetNextLink()) )
      if (pVehLink->GetVehicle() == pVeh) {
         delete pVehLink;
         break;
      }
   for ( pVehLink  = (cLinkVeh*) (fPriorityList.GetFirstLink()); 
         pVehLink != (cLinkVeh*) (fPriorityList.GetNULLLink()); 
         pVehLink  = (cLinkVeh*) (fPriorityList.GetNextLink()) )
      if (pVehLink->GetVehicle() == pVeh) {
         delete pVehLink;
         break;
      }
   new cLinkVeh(pVeh, (cLinkVeh*)(fTimedOutList.GetLastLink()));   // adds at end
}

void        cVehicleMgr::ForwardVehStateMsg(cVehicle* pVeh)
{
   cVehicle*   pExistingVeh = FindVehicle(pVeh->fId, &fVehList);
   
   if ( pExistingVeh == NULL ) {
//      cout<<" veh manager adding vehicle"<<endl;
      new cLinkVeh(pVeh, (cLinkVeh*)(fVehList.GetLastLink()));   // adds at end
      pVeh->SimulateVehicle();
   }
   else
      pExistingVeh->ProcVehStateMsg(pVeh);
}

void   cVehicleMgr::ReadTestFile(char* pFileName)
{
   cInFileObj infile(pFileName, gftypeTestFile);
   
   if ( infile.GetErrorCode() == eFileNoErr ) {

		EFileReturn  returnCode;
		int          returnIndex;
		char*        vehTypeName = NULL;
		EBoolean     done = false;

		while( !done )
		{
			returnCode = infile.ReadItem( fVehMgrTable, evehmgrSizeTable,
				&returnIndex, (void **)&vehTypeName );

			switch (returnCode)
			{
				case eNextLevel:
					switch( returnIndex )
					{
						case evehmgrkwVehType:
							   ReadTestVeh( infile, vehTypeName );
							break;

						default:
							break;
					}
					break;

				case eEOF:
					   done = true;
					break;

				default:  // error return
					   Assert(false, kerrReadParamfile, "cVehicleMgr::ReadTestFile");
					break;
			}
//         if (vehTypeName)
//            delete[] vehTypeName;
		}
   
      infile.Close();
   }
   else
      cout<<"Error opening file for test mode input, file " << pFileName << endl;
}
   
EBoolean    cVehicleMgr::ReadTestVeh(cInFileObj& infile, char* vehTypeName)
{
	cDbVeh* pDbVeh = (cDbVeh*) (gVehDbMgr.FindByName(vehTypeName));
   EBoolean success = true;
   
   if ( pDbVeh ) {
      cTestVehicle* newVeh = new cTestVehicle(pDbVeh);
      if ( ! newVeh->ReadTestVehParams(infile) ) {
         delete newVeh;
         success = false;
      }
   }
   else {
      cout << "Warning: could not find vehicle type, test vehicle not created"<<endl;
      success = false;
   }
   return success;
}

void   cVehicleMgr::VehShutdown()
{
   fVehList.DeleteList();
   fPriorityList.DeleteList();
   fTimedOutList.DeleteList();
}

cVehicleMgr::cVehicleMgr() :
      fVehList(), fPriorityList()
{
}

cVehicleMgr::~cVehicleMgr()
{
   // should delete every vehicle
}
