/*
$RCSfile: Vehicle.h,v $
$Revision: 1.4 $
$Author: ksnively $
$Date: 1999/04/29 19:34:22 $
$Log: Vehicle.h,v $
Revision 1.4  1999/04/29 19:34:22  ksnively
Incorporated ARDEC addtions:  Tripwire AP mines and a Control Window.

Revision 1.3  1999/04/22 22:20:06  ksnively
Sreamlined radio communication routines.  Allowed to send to unlimited number of receivers.

Revision 1.2  1999/03/25 19:07:56  jchappel
changes made to cms some time ago, should be okay

Revision 1.1.1.1  1999/02/16 14:54:53  jchappel
Comprehensive Mine Simulator

 * Revision 2.5  1998/12/02  16:38:28  jchappel
 * added gui detonator
 *
 * Revision 2.4  1998/10/27  19:34:43  jchappel
 * modifications for versioning
 *
 * Revision 2.3  1998/04/20  15:10:36  ksnively
 * *** empty log message ***
 *
 * Revision 2.2  1998/02/26  21:26:56  ksnively
 * Created Mf Camera object to control MAK Stealth view.
 * Created vulnerability tables specific to command detonated mines
 * and the camera object.
 *
 * Revision 2.1  1998/02/18  17:17:24  ksnively
 * Incorporated AP mine replacement code
 *
 * Revision 2.0  1998/01/26  21:04:20  ksnively
 * Baseline CMS before additions for AP mine replacements.
 *
 * Revision 1.1  1997/12/16  13:59:57  ksnively
 * Initial revision
 *
 * Revision 1.4  1997/10/27  17:07:30  trang
 * BUILD1
 *
 * Revision 1.3  1997/10/02  17:47:47  austin
 * first working port to modsaf3.0
 *
Revision 1.3  1997/10/02 17:47:47  austin
first working port to modsaf3.0

 * Revision 1.2  1997/05/07  12:33:45  ksnively
 * *** empty log message ***
 *
 * Revision 1.1  1996/10/23  13:54:40  nsipes
 * Initial revision
 *
 * Revision 1.12  1996/08/07  14:19:30  rcarp
 * initial revisions for CP protocol
 *
 * Revision 1.11  1996/07/13  19:04:20  rcarp
 * version 1.5b13, fixes bug dragging with two buttons and displays damamged vehicles
 *
 * Revision 1.10  1996/07/03  22:55:15  rcarp
 * enhancements and bug fixes for version 1.5b9
 *
 * Revision 1.9  1996/06/22  13:04:11  rcarp
 * deton vuln bug fixes for 1.5b4
 *
 * Revision 1.8  1996/06/21  17:05:32  rcarp
 * upgrades for release 1.5b3, mostly mine vuln
 *
 * Revision 1.7  1996/06/19  19:08:07  rcarp
 * revisions for mine vulnerability, version 1.5b2
 *
 * Revision 1.6  1996/05/14  16:15:08  rcarp
 * refinements and bug fixes for 1.5 delivery
 *
 * Revision 1.3  1996/02/16  19:32:41  rcarp
 * revisions for 1.1b7 version
 *
 * Revision 1.2  1996/02/05  14:31:34  rcarp
 * Updates and bug fixes of release version 1.1b5
 *
$State: Exp $
*/
 
/*******************************************

   file: Vehicle.h
   
      Copyright 1995 by the Institute for Defense Analyses
      
         Institute for Defense Analyses
         1801 N. Beauregard Street
         Alexandria, Virginia 22311-1772
         703-845-2000
         
      This software was developed by IDA under U. S. Government
      contract.  For distribution information contact:
      
         U. S. Army Night Vision Directorate
         AMSEL RD NV OD CD
         10221 Burbeck Road, suite 430
         Ft. Belvoir VA 22060-5806
      
*********************************************/

/*******************************************

   Vehicle.h
   
      The vehicle header file defines the top level vehicle classes.
      
      
   
   Created by Richard Carpenter
   Modification history:
      created   
      
*********************************************/

#ifndef _UVehicle_
#define _UVehicle_
#include "Globals.h"
#include "EntityDB.h"

// ************************************
//   basic types
// ************************************

enum   EAppearance     { eAprStandard = 0, 
                         eAprImmobile,
                         eAprNoFire,
                         eAprImmobNoFire,
                         eAprDestroyed, 
                         eAprDeact };
enum   EDeadReckonAlg  { eDrOther = 0, eDrStatic, eDrFpw, eDrRpw, eDrRvw, eDrFvw, 
                                       eDrFpb, eDrRpb, eDrRvb, eDrFvb, eDrLowestBody = eDrFpb };
enum   EPartParam      { ePrtOther = 0, 
                         ePrtFullPlow, 
                         ePrtTrackPlow, 
                         ePrtFullRake, 
                         ePrtTrackRoller, 
                         ePrtDogbone, 
                         ePrtMagCm,
                         ePrtTurret,
                         ePrtORSMC };
enum   EPartValueType  { ePrtValPosition = 1,
                         ePrtValPositionRate,
                         ePrtValExtension,
                         ePrtValExtensionRate,
                         ePrtValX,
                         ePrtValXRate,
                         ePrtValY,
                         ePrtValYRate,
                         ePrtValZ,
                         ePrtValZRate,
                         ePrtValAzimuth,
                         ePrtValAzimuthRate,
                         ePrtValElevation,
                         ePrtValElevationRate,
                         ePrtValRotation,
                         ePrtValRotationRate     };


struct TVehDimensions : public cDbStruct {
   float      length;
   float      width;
   float      height;
   float      trackYmin;
   float      trackYmax;

	enum {
		evehkwLength,
		evehkwWidth,
		evehkwHeight,
		evehkwTrackMin,
		evehkwTrackMax,
      
		eSizeVehSizeParamTable
	};
   
	static const TKeywordEntry fKeyVehSizeParamTable[eSizeVehSizeParamTable];

   virtual EBoolean     ParseDbStructItem(cInFileObj& infile);
   void                 WriteDimensions(ofstream* file);
   
   TVehDimensions(float len = 0.0, float wid = 0.0, float ht = 0.0, 
                  float trkMn = 0.0, float trkMx = 0.0) :
                  length(len), width(wid), height(ht), trackYmin(trkMn), trackYmax(trkMx) {}
   virtual ~TVehDimensions() {}
};

class cDbVeh : public cDbEntry {
 protected:
 
	enum { evehkwSize,
          evehSizeTable };
   static const TKeywordEntry fKeyVehTable[evehSizeTable];
   
   TVehDimensions      fVehDim;
   
 public:

   virtual  EBoolean   ParseDbEntry(cInFileObj& infile);
   virtual  int        GetDbLevel();
   void                WriteVehicleParam(ofstream* file);
   virtual  EBoolean   ValidType(TEntityType& type);
  
   const    TVehDimensions&     GetVehDim()   { return fVehDim; }

             cDbVeh*  CloneDbVeh();      // returns unlinked copy
   
            cDbVeh();
            cDbVeh(TEntityType& type, int level, 
                   char* pName = NULL, TVehDimensions* pVehDim = NULL);
   virtual ~cDbVeh();
};

struct TVehPart : public cDbStruct {
   EPartParam       fParamType;   // this is the CMS type, cm parts only
   float            fDepth;       // cms depth, for plows
   
   unsigned short   fChange;
   unsigned char    fChange204;
   unsigned short   fAttachPoint;
   EBoolean         fAttached;   // false if articulated
   unsigned int     fValueType;
   float            fValue;      // for articulated parts
   TEntityType      fEntType;    // for attached parts
   

   void             SetPartType(EPartParam type) { fParamType = type; }
   void             SetDepth(float depth)        { fDepth = depth; }

   EPartParam       GetPartType()      { return fParamType; }
   EBoolean         IsCmPart();            // countermine type
   EBoolean         IsTurret();            // for display purposes
   float            GetDepth()         { return fDepth; }
   unsigned short   GetPartChange()    { return fChange; }
   unsigned char    GetPartChange204() { return fChange204; }
   unsigned short   GetPartAttachPt()  { return fAttachPoint; }
   EBoolean         IsAttached()       { return fAttached; }
   unsigned int     GetPartValueType() { return fValueType; }
   float            GetPartValue()     { return fValue; }
   TEntityType&     GetEntType()     { return fEntType; }

      // for test mode input
   enum {      evpkwPartType,
               evpkwDepth,
               evpkwAttachPt,
               evpkwAttached,
               evpkwValueType,
               evpkwValue,
               evpkwEntityTypeList,
               
               evpkwSizeTable };
	static    const TKeywordEntry fKeyVehPartTable[evpkwSizeTable];
   virtual   EBoolean   ParseDbStructItem(cInFileObj& infile);
   
   TVehPart(TVehPart* pOldPart);
   
   TVehPart();
   virtual ~TVehPart() {}
};

enum EPartResult {
   eprNotEngaged,
   eprNoEffect,
   eprDetonated,
   eprNeutralized,
   eprDisplaced,
   eprRollback,
   eprNumResultTypes
};

enum EDetectResult {

   edrNotEngaged,
   edrInFootprint,
   edrNumResultTypes
};

// ************************************
//   vehicle types
// ************************************

class cVehDisp;
class cUpdateVehicleMsg;
class cVehicle : public cEntity {
   // base class for all vehicles, including those simulated elsewhere
   // and those such as sublets simulated in the CMS.
   friend class cVehicleMgr;
   friend class cDisPduTranslator;
   friend class cDispVehicle;
   
 private: 
   const TVelocity&     GetVehicleVel()     const  {return fVelocity;}

 public:
   
   static   TTimeSim   fTimeoutDelay;   // time from last update to timing out
//   char*               fVehTypeName;

protected:
   cDbVeh*         fpDbVeh;
   
   TTimeSim        fTime;         // time at state definition
//   TEntityID   fVehicleID inherited as fId
   EForce          fForce;
   TEntityType     fCmsType;      // needed, as particular type may not be in database
   TEntityType     fAltType;
   TVelocity       fVelocity;      // as it appears in ESPDU
   TVelocity       fGeoVelocity;
   TVelocity       fEntVelocity;
         // location and orientation inherited from cEntity
   EAppearance     fAppearance;
   EDeadReckonAlg  fDrAlg;
   TAccel          fDrAccel;
   TAngVel         fDrAngVel;
   int             fNumParts;
   TVehPart*       fpVehPartList;   // array of parts
   EBoolean        fbHasCmPart;
   float           fTurretAzimuth;
   
//   TVehDimensions   fDimensions;

   cMessage*            fpUpdateVehMsg;
   cVehDisp*            fpDisplay;
   TTimeSim             fTimeout;
 
  
public:
   TTimeSim             GetVehicleTime()    const  {return fTime;}
   EForce               GetVehicleForce()   const  {return fForce;}
   const TEntityType&   GetVehicleAltType() const  {return fAltType;}
   const TVelocity&     GetVehicleGeoVel()  const  {return fGeoVelocity;}
   const TVelocity&     GetVehicleEntVel()  const  {return fEntVelocity;}
   EAppearance          GetVehicleAppear()  const  {return fAppearance;}
   EDeadReckonAlg       GetVehicleDrAlg()   const  {return fDrAlg;}
   const TAccel&        GetVehicleAccel()   const  {return fDrAccel;}
   const TAngVel&       GetVehicleAngVel()  const  {return fDrAngVel;}

   virtual TLocation    GetDrGeoLoc(TTimeSim time);
   virtual TLocation    GetDrTccLoc(TTimeSim time);
   virtual   void       GeoToLocalVel(const T3Dsingle& geoVel, T3Dsingle* pLocVel);
   virtual   void       LocalToGeoVel(const T3Dsingle& locVel, T3Dsingle* pGeoVel);

   const  TVehDimensions&  GetDimensions()  const;
   virtual   char*         GetEntName();
   virtual  const TEntityType&   GetEntType()   { return fCmsType; }
            // may want to display internal vehicles with type the pvd recognizes
   virtual const TEntityType&   GetDispVehicleType()    const  {return fCmsType;}
   TVehPart*            GetPartList() { return fpVehPartList; }
   EBoolean             HasCmPart()   { return fbHasCmPart; }
   float                GetTurretAz() { return fTurretAzimuth; }
   TVehPart*            GetPartByType(EPartParam type);
   float                GetPartExtension(EPartParam type);
   
   EBoolean             IsMobile() { if ( (fAppearance == eAprImmobile) ||
                                          (fAppearance == eAprDestroyed) ||
                                          (fAppearance == eAprImmobNoFire) ||
                                          (fAppearance == eAprDeact) ) return false; 
                                     else return true; }
   EBoolean             IsAlive()  { if (fAppearance == eAprDestroyed) return false; 
                                     else return true; }
      
             void        ProcVehStateMsg( cVehicle* pVeh);
   
   virtual   void        SimulateVehicle();
   virtual   void        UpdateVehicle();
             void        ShowVehicle (EBoolean show);
   EBoolean              IsDisplayable ();

   virtual   void        WriteEntSumm(ofstream*);

               cVehicle();
//               cVehicle(const char* name);
//               cVehicle(TEntityType type, const char* name, TVehDimensions size);
   virtual    ~cVehicle();
};

class cSimVehicle : public cVehicle {
      // vehicles that are simulated by the CMS, 
      // e.g., projectiles fired by mines.

 public:
   virtual     void   UpdateLocation();
 
               cSimVehicle();
   virtual    ~cSimVehicle();
};


class cController : public cSimVehicle {

 public:

 protected:

      static TEntityType  fsContEntityType;
      static char*        fsContName;
      
 private:  
      cController();
   virtual ~cController() {}
};


// ************************************
//   vehicle lists
//      there are lists kept by the vehicle manager, minefields, and mines
//      Because of multiple listings, none may actually delete a vehicle.
// ************************************

class cLinkVeh : public T2link {

      // USAGE: The vehicle manager uses this class.
      //        Local lists for components and mines use descendent classes
      //            with additional info such as location in local coords

   friend class cVehicleMgr;
   friend class cVehListHead;

protected:
   cVehicle*         fpVehicle;

public:
   cVehicle*             GetVehicle() const   { return fpVehicle; }
   const TEntityType&    GetEntityType() const {return fpVehicle->GetEntType();}
      
                 cLinkVeh(cVehicle* pVeh, cLinkVeh* pPrev);
      virtual   ~cLinkVeh();
};

class cLinkVehGeom;
class cVehListHead : public  T2linkHead{

   friend class cVehicleMgr;
  
protected:

public:
      
      cVehicle*   GetFirstVeh();
        cVehicle*   GetNextVeh();
            
      EBoolean        IsInList(const cVehicle* pVeh, cLinkVeh** ppVehNode); //matches veh and returns node ptr
//      cLinkVehGeom*  GetClosestRange();      // returns NULL if none found
      
                 cVehListHead(cVehListHead* pOldHead);  // takes over old list
                 cVehListHead();
      virtual   ~cVehListHead();
};

class cMinefield;
class cLinkVehLoc : public cLinkVeh {
      // a vehicle list with local entity coords,
      // not updated to current time
      
      // USAGE: a component uses this class, with the minefield ref
      //        mine trackers use descendent classes with other info such as range,
      //            and use either target vehicle or self ref systems.

protected:
   cEntity*       fpRefEnt;      // entity providing ref coord system
   EBoolean       fbTgtVelRef; // use vehicle vel to get az rot angle
   float          fAzRot;       // from map to veh system, only if fbTgtVelRef
   TEntCoord      fLocation;
   TVelocity      fVelocity;
   TTimeSim       fTime;         // time of setting geometry

   EBoolean      fbApproaching;

public:
   const TEntCoord&      GetLocation() const   {return fLocation;}
         void            GetLocTgtRef(TEntCoord* pLocTgtRef) const;
   const TVelocity&      GetVelocity() const   {return fVelocity;}
         float           GetAzRot() const      {return fAzRot;}
         
         void     SnapZ();      // fixes elevation for detonation
   
   void          SetLocation();
   
                 cLinkVehLoc(cLinkVehLoc* pPrVeh, cLinkVeh* pPrev, cEntity* pRefEnt = NULL,
                             EBoolean refTgtVel = false);   // copy of other node pPrVeh
                 cLinkVehLoc(cVehicle* pVeh, cLinkVeh* pPrev, cEntity* pRefEnt,
                             EBoolean refTgtVel = false);
   virtual      ~cLinkVehLoc();
};

class cInteraction;

class cLinkVehGeom : public cLinkVehLoc
      //  Adds range, az, el local geometry
      //  Used by mines for errorless tracking with collocation sensors
      //  For most mines, the coord ref system is that of the tracked vehicle,
      // so that x is distance in travel direction and y is offset from
      // vehicle centerline.
{

protected:
         // these are updated estimates.  Descendents apply errors
   float         fRange;
   float         fHorzRange;
   float         fAzimuth;
   float         fElevation;
   
   EPartResult   fFwmPResult;
   EPartResult   fTwmPResult;
   EPartResult   fFwmRResult;
   EPartResult   fTwmRResult;
   EPartResult   fDbResult;
   EPartResult   fMagCmResult;
 
   EDetectResult fDetectResult;
   
   cInteraction*   fpInteract;   // for analysis output, record of interaction
   
public:
   virtual void  UpdateTrkRec();
   float         GetRange()  const      { return fRange; }
   float         GetHorzRange()  const  { return fHorzRange; } 
   float         GetAzimuth()  const    { return fAzimuth; } 
   float         GetElevation()  const  { return fElevation; }
   T2Dpolar      GetLocPolar()          { T2Dpolar pLoc(fRange, fAzimuth); return pLoc; }
   EBoolean      IsApproaching() const  { return fbApproaching; }
   EBoolean      HasCmPart() const      { return fpVehicle->HasCmPart(); }
   EPartResult   GetPartResult(EPartParam type);
   EPartResult   GetFullPlowResult()   { return fFwmPResult; }
   EPartResult   GetTrackPlowResult()   { return fTwmPResult; }
   EPartResult   GetFullRakeResult()   { return fFwmRResult; }
   EPartResult   GetTrackRollerResult()   { return fTwmRResult; }
   EPartResult   GetDbResult()   { return fDbResult; }
   EPartResult   GetMagCmResult()   { return fMagCmResult; }
   EDetectResult GetDetectionResult() { return fDetectResult; }
   
   void          SetApproaching( EBoolean bApp )   { fbApproaching = bApp; }
   void          SetFullPlowResult(EPartResult res)   { fFwmPResult = res; }
   void          SetTrackPlowResult(EPartResult res)   { fTwmPResult = res; }
   void          SetFullRakeResult(EPartResult res)   { fFwmRResult = res; }
   void          SetTrackRollerResult(EPartResult res)   { fTwmRResult = res; }
   void          SetDbResult(EPartResult res)   { fDbResult = res; }
   void          SetMagCmResult(EPartResult res)   { fMagCmResult = res; }
   void          SetDetectionResult(EDetectResult res ) {fDetectResult = res; }
   
   
   cInteraction*   GetInteraction()     { return fpInteract; }
   void            SetInteraction(cInteraction* pInter);
   void            DeleteInteraction();
   void            SetInteractResult(int eResult) const;
   int             GetInteractResult() const;

                 cLinkVehGeom(cVehicle* pVeh, cLinkVeh* pPrev, cEntity* pRefEnt, EBoolean refInvert = true);
                 cLinkVehGeom(cLinkVehGeom* pTrkVeh, cLinkVeh* pPrev);
                 cLinkVehGeom(cLinkVehLoc* pProxVeh, cLinkVeh* pPrev, cEntity* pRefEnt, EBoolean refInvert = true);
      virtual   ~cLinkVehGeom();
};

class cVehicleMgr {
      // cVehicleMgr manages the vehicle lists, finds vehicles to
      // update from PDUs, etc.
      // **It has one instantiated object, no virtual functions
 
 protected:
	enum { evehmgrkwVehType, evehmgrSizeTable };
   static const TKeywordEntry fVehMgrTable[evehmgrSizeTable];
   
   cVehListHead    fVehList;         // fpNext is the head, fpPrev the tail
   cVehListHead    fPriorityList;
   cVehListHead    fTimedOutList;
   
public:
   
   EBoolean    IsPriorityVeh(const TEntityID & vID);
   cVehicle*   FindVehicle(const TEntityID & vID, cVehListHead* pListHead);
   void        VehTimedOut( cVehicle* veh );      // move to TO list, veh itself does display
   
   void        ForwardVehStateMsg(cVehicle* pVeh);         //normal priority msg sent to mgr
   
   cVehListHead&   GetVehList()   {return fVehList;}
   
   void        ReadTestFile(char* pFileName);
   
   EBoolean    ReadTestVeh(cInFileObj& infile, char* vehTypeName);

   void        VehShutdown();
   
               cVehicleMgr();
              ~cVehicleMgr();
};

// ************************************
//   messages
// ************************************
class cVehStateMsg : public cMsgEvent {
   cVehicle*      fpVeh;
   
   EBoolean       fInternal;
   
public:
   void        SendMsg();

               cVehStateMsg( cVehicle* pVeh, EBoolean internal = false);
   virtual    ~cVehStateMsg();
};

class cSendViewControlMsg : public cMsgEvent {
   cVehicle*      fpView;
   TEntityID      fToID;
   
public:
   void        SendMsg();

               cSendViewControlMsg( cVehicle* pView, TEntityID toID = TEntityID(0,0,0)) 
                   { fpView = pView; fToID = toID; }
   virtual    ~cSendViewControlMsg();
};

class cSendVehStateMsg : public cMsgEvent {
   cVehicle*      fpVeh;
   
public:
   void        SendMsg();

               cSendVehStateMsg( cVehicle* pVeh) { fpVeh = pVeh; }
   virtual    ~cSendVehStateMsg();
};

class cPriorityVehStateMsg : public cMsgPrEvent {
     //   There is a temptation to send priority msg directly to the vehicle, but
     //   in some permutations the vehicle may have been deleted.  Make the
     //   vehicle manager find it again.
   cVehicle*      fpVeh;
   
   EBoolean       fInternal;
   
public:
      void        SendMsg();

               cPriorityVehStateMsg( cVehicle* pVeh, EBoolean internal = false);
   virtual    ~cPriorityVehStateMsg();
};

class cUpdateVehicleMsg : public cMsgUpdt {

protected:
   cVehicle*     fpVehicle;
   
public:
      void        SendMsg();

               cUpdateVehicleMsg(cVehicle* pVehicle) { fpVehicle = pVehicle; }
   virtual    ~cUpdateVehicleMsg(); 
};

#endif
