#include <math.h>
#include "Area.h"
#include <iostream.h>
#include <stdio.h>

cEllipse::cEllipse(T3Dsingle* pCtr, TOrient* pOrient, float a, float b)
{
	a2 = a*a;
	b2 = b*b;
	a2b2 = a2*b2;
	Xoffset = pCtr->x;
	Yoffset = pCtr->y;
	Zoffset = pCtr->z;

	SIN_PSI = fsin(-pOrient->psi);
	COS_PSI = fcos(-pOrient->psi);
}

cEllipse::cEllipse(T3Ddouble* pCtr, TOrient* pOrient, float a, float b)
{
        a2 = a*a;
        b2 = b*b;
        a2b2 = a2*b2;
        Xoffset = pCtr->x;
        Yoffset = pCtr->y;
        Zoffset = pCtr->z;

        SIN_PSI = fsin(-pOrient->psi);
        COS_PSI = fcos(-pOrient->psi);
}

int cEllipse::IsPtInArea(T3Dsingle* pt)
{
        T3Dsingle tpt(pt->x - Xoffset, pt->y - Yoffset, 0);
        T3Dsingle rpt(tpt.x*COS_PSI - tpt.y*SIN_PSI, tpt.x*SIN_PSI + tpt.y*COS_PSI,0);

        float num1 = rpt.x*rpt.x;
        float num2 = rpt.y*rpt.y;

        if( (num1*a2) + (num2*b2) <= a2b2)
                return true;
        else
                return false;
}

int cEllipse::IsPtInArea(T3Ddouble* pt)
{
	T3Dsingle spt(pt->x,pt->y,pt->z);
	return IsPtInArea(&spt);	
}


cRectangle::cRectangle(T3Dsingle* pCtr, TOrient* pOrient, float fWidth, float fLength)
{
	spCtr.x = pCtr->x;
	spCtr.y = pCtr->y;
	spCtr.z = pCtr->z;

	half_width = fWidth/2.0;
	half_length = fLength/2.0;
	//fprintf(stderr, "orient = %.8f,", pOrient->psi);
        COS_PSI = fcos( -pOrient->psi);
        SIN_PSI = fsin( -pOrient->psi);
	//fprintf(stderr, " sin = %.10lf, cos = %.10lf\n", SIN_PSI, COS_PSI);

        T3Dsingle directional_offset(half_length * COS_PSI, half_length * SIN_PSI,0);
        T3Dsingle pos_a = *pCtr - directional_offset;
        T3Dsingle pos_b = *pCtr + directional_offset;

        T3Dsingle direction = pos_b - pos_a;
        T3Dsingle udirection = direction.unit();
        T3Dsingle perp_direction(-udirection.y, udirection.x,0);
        T3Dsingle offset = perp_direction * half_width;

        fArea[0] = pos_a + offset;
        fArea[1] = pos_a - offset;
        fArea[2] = pos_b - offset;
        fArea[3] = pos_b + offset;

	//fprintf(stderr,  "(%.8f, %.8f, %.8f)" , fArea[0].x, fArea[0].y ,fArea[0].z);
	//fprintf(stderr,  "(%.8f, %.8f, %.8f)" , fArea[1].x, fArea[1].y ,fArea[1].z);
	//fprintf(stderr,  "(%.8f, %.8f, %.8f)" , fArea[2].x, fArea[2].y ,fArea[2].z);
	//fprintf(stderr,  "(%.8f, %.8f, %.8f)\n" , fArea[3].x, fArea[3].y ,fArea[3].z);
	//fprintf(stderr, "center = (%.8f, %.8f, %.8f)\n", spCtr.x, spCtr.y, spCtr.z);
	
}

cRectangle::cRectangle(T3Ddouble* pCtr, TOrient* pOrient, float fWidth, float fLength)
{
	spCtr.x = pCtr->x;
	spCtr.y = pCtr->y;
	spCtr.z = pCtr->z;

	half_width = fWidth/2.0;
	half_length = fLength/2.0;
        COS_PSI = fcos( -pOrient->psi);
        SIN_PSI = fsin( -pOrient->psi);


        T3Dsingle directional_offset(half_length * COS_PSI, half_length * SIN_PSI,0);
        T3Dsingle pos_a = spCtr - directional_offset;
        T3Dsingle pos_b = spCtr + directional_offset;

        T3Dsingle direction = pos_b - pos_a;
        T3Dsingle udirection = direction.unit();
        T3Dsingle perp_direction(-udirection.y, udirection.x,0);
        T3Dsingle offset = perp_direction * half_width;

        fArea[0] = pos_a + offset;
        fArea[1] = pos_a - offset;
        fArea[2] = pos_b - offset;
        fArea[3] = pos_b + offset;
}


int cRectangle::IsPtInArea(T3Dsingle* pt)
{
//       T3Dsingle poly[4];
//        if(PtInPolygon(*pt, 4, fArea))
//                return true;
//        else
//                return false;
	T3Dsingle tpt(pt->x - spCtr.x, pt->y - spCtr.y, 0);
        T3Dsingle rpt(tpt.x*COS_PSI - tpt.y*SIN_PSI, tpt.x*SIN_PSI + tpt.y*COS_PSI,0);

	if (fabs(rpt.x) <= half_length && fabs(rpt.y) <= half_width)
	{
		return true;
	}	
	else 
	{
		return false;
	}
		
}

int cRectangle::IsPtInArea(T3Ddouble* pt)
{	
//       T3Dsingle poly[4];
//        if(PtInPolygon(*pt, 4, fArea))
//                return true;
//        else
//                return false;
	T3Dsingle tpt(pt->x - spCtr.x, pt->y - spCtr.y, 0);
        T3Dsingle rpt(tpt.x*COS_PSI - tpt.y*SIN_PSI, tpt.x*SIN_PSI + tpt.y*COS_PSI,0);

	if (fabs(rpt.x) <= half_length && fabs(rpt.y) <= half_width)
		return true;
	else 
		return false;
		
}


/*cCircle::cCircle(T3Ddouble* pCtr, float radius)
{
        r2 = radius*radius;
        Xoffset = pCtr->x;
        Yoffset = pCtr->y;
        Zoffset = pCtr->z;

        SIN_PSI = fsin(pOrient->psi);
        COS_PSI = fcos(pOrient->psi);
}

cCircle::cCircle(T3Dsingle* pCtr, float radius)
{
        r2 = radius*radius;
        Xoffset = pCtr->x;
        Yoffset = pCtr->y;
        Zoffset = pCtr->z;

        SIN_PSI = fsin(-pOrient->psi);
        COS_PSI = fcos(-pOrient->psi);
}

cCircle::IsPtInArea(T3Ddouble* pt)
{
	T3Dsingle spt(pt->x,pt->y,pt->z);
	return IsPtInArea(&spt);
}

cCircle::IsPtInArea(T3Dsingle* pt)
{
	T3Dsingle tpt(pt->x - Xoffset, pt->y - Yoffset, 0);
        T3Dsingle rpt(tpt.x*COS_PSI - tpt.y*SIN_PSI, tpt.x*SIN_PSI + tpt.y*COS_PSI,0);

        if( (rpt.x*rpt.x) + (rpt.y*rpt.y) <= r2)
                return true;
        else
                return false;

}
*/
