/*
$RCSfile: CmsPdu.cc,v $
$Revision: 1.2 $
$Author: ksnively $
$Date: 1999/04/29 19:34:04 $
$Log: CmsPdu.cc,v $
Revision 1.2  1999/04/29 19:34:04  ksnively
Incorporated ARDEC addtions:  Tripwire AP mines and a Control Window.

Revision 1.1.1.1  1999/02/16 14:54:29  jchappel
Comprehensive Mine Simulator

// Revision 2.3  1998/12/05  22:56:59  jchappel
// *** empty log message ***
//
// Revision 2.2  1998/10/27  19:34:43  jchappel
// modifications for versioning
//
// Revision 2.1  1998/02/18  17:16:10  ksnively
// Incorporated AP mine replacement code.
//
// Revision 2.0  1998/01/26  21:01:35  ksnively
// Baseline CMS before additions for AP mine replacements.
//
// Revision 1.2  1997/12/17  14:38:03  ksnively
// Debugged Minefield duplication routine.
// Added input file "netparams" for reading PDU type enumerations.
// Got rid of warning messages during compilation.
//
// Revision 1.1  1997/12/16  13:59:57  ksnively
// Initial revision
//
// Revision 1.8  1997/10/02  17:51:30  austin
// first working port to modsaf3.0
//
// Revision 1.7  1997/10/02  17:48:55  austin
// first working port to modsaf3.0
//
// Revision 1.7  1997/10/02  17:48:55  austin
// first working port to modsaf3.0
//
// Revision 1.6  1997/05/07  12:32:33  ksnively
// *** empty log message ***
//
// Revision 1.5  1997/03/20  19:14:41  ksnively
// added emission tracking, updated to CMS2.0B6
//
// Revision 1.4  1997/01/21  15:08:14  nsipes
// *** empty log message ***
//
// Revision 1.3  1997/01/02  19:48:54  nsipes
// *** empty log message ***
//
// Revision 1.2  1996/11/06  15:13:32  nsipes
// *** empty log message ***
//
// Revision 1.1  1996/10/23  13:54:40  nsipes
// Initial revision
//
// Revision 1.7  1996/09/06  18:57:57  rcarp
// CP bug fixes
//
// Revision 1.6  1996/08/22  17:37:34  rcarp
// fixed bug when shutting down with no CP messages sent
//
// Revision 1.5  1996/08/21  21:58:20  rcarp
// CP and QRP file output, other updates
//
// Revision 1.4  1996/08/07  14:19:30  rcarp
// initial revisions for CP protocol
//
// Revision 1.3  1996/06/21  17:04:20  rcarp
// upgrades for release 1.5b3, mostly mine vuln
//
// Revision 1.2  1996/05/14  16:15:08  rcarp
// refinements and bug fixes for 1.5 delivery
//
$State: Exp $
*/
 
/*******************************************

   file: CmsPdu.cc
   
      Copyright 1995 by the Institute for Defense Analyses
      
         Institute for Defense Analyses
         1801 N. Beauregard Street
         Alexandria, Virginia 22311-1772
         703-845-2000
         
      This software was developed by IDA under U. S. Government
      contract.  For distribution information contact:
      
         U. S. Army Night Vision Directorate
         AMSEL RD NV OD CD
         10221 Burbeck Road, suite 430
         Ft. Belvoir VA 22060-5806
      
*********************************************/

/*******************************************

   CmsPdu.cc
   
      The Cms Pdu translator interfaces the CMS gui and host.
         
   Created by Richard Carpenter
   Modification history:
      created   
      
*********************************************/

#include <strings.h>
#include <bstring.h>
#include "CmsPdu.h"
#include "McmPdu.h"
//#include "DisPdu.h"
#include "DisPdu203.h"
#include "Minefield.h"
#include "CmsControl.h"

const    TEntityType    kEntTypeESMB(ekindMunition,9,ecntryUnited_States,emuncatFixed,2,0,0);
const    TEntityType    kEntTypeMICLIC(ekindMunition,9,ecntryUnited_States,1,79,1,0);
const    TEntityType    kEntTypeORSMC (ekindPlatform, 
                                        eplatdomLand,
                                        ecntryUnited_States,
                                        eplatlandSmWheelUtil, 
                                        1,          // HMMWV
//** special for testing                                        kMatchAllChar,    
//                                        18,         // 18th variation
					1,
                                        kMatchAllChar);

unsigned int  cQrpManager::fsMinesPerPdu = 42;
unsigned int  cCpManager::fsMinesPerPdu = 0;
TMineDataFlag cCpManager::fsBitFlags = { 0, 0, 0, 0};
TMineDataFlag cQrpManager::fsBitFlags = { 0, 0, 0, 0};

TDetonationData::TDetonationData()
{
   fWarhead = ewhOther;
   fFuze = efzOther;
   feDetResult = edetOther;
}

TDetonationData::TDetonationData(cSimMine* pMine)
{
   fFiringEnt = pMine->GetEntityID();
   fTargetEnt = pMine->GetTargetID();
   fFireTccLocation = pMine->GetTccLoc();
   fDetLocation = pMine->GetGeoLoc();
   fDetonationType = pMine->GetDetonationType();
   fWarhead = pMine->GetWarhead();
   fFuze = pMine->GetFuze();
   feDetResult = edetOther;
}

TFireData::TFireData()
{
   fWarhead = ewhOther;
   fFuze = efzOther;
   fFireRange = 0.0;
}

TFireData::TFireData(cSimMine* pMine)
{
   fFireRange = 0.0;

   fFiringEnt = pMine->GetEntityID();
   fLocation = pMine->GetGeoLoc();
   fFireTccLocation = pMine->GetTccLoc();
   fWarhead = pMine->GetWarhead();
   fFuze = pMine->GetFuze();
   fDetonationType = pMine->GetDetonationType();
}

void cMinefieldRequestMsg::SendMsg()
{
	/*if(fcp==eQrp1)
		fpMinefield->ProcessMfRequest(fRequestor, fRequestNum,
                    fFilter, fMineType, fNumPts, fpPerim);
	else //if(fcp==eQrp3)*/
		fpMinefield->ProcessMfRequest(fRequestor, fRequestNum,
                    fFilter, fMineType, fNumPts, fpPerim,fNumReqSensors,fpReqSensorTypes);
}

cMinefieldRequestMsg::cMinefieldRequestMsg( cMinefield* pMf, TEntityID requestorId,
         int reqNum, int numPts, unsigned int filter, TEntityType type, TEntCoord* pPerim,
		short numReqSensors, TEntityType* pReqSensorTypes)
{
   fpMinefield = pMf;
   fRequestor  = requestorId;
   fRequestNum = reqNum;
   fNumPts     = numPts;
   fFilter     = filter;
   fMineType   = type;
   fpPerim     = pPerim;
   fNumReqSensors = numReqSensors;

   if(fNumReqSensors == 0)
	fpReqSensorTypes = NULL;
   else
   {
      fpReqSensorTypes = new TEntityType[fNumReqSensors];
      memcpy(fpReqSensorTypes, pReqSensorTypes, sizeof(TEntityType) * fNumReqSensors);
   }
}
 
cMinefieldRequestMsg::cMinefieldRequestMsg( cMinefield* pMf, TEntityID requestorId,
         int reqNum, int numPts, unsigned short filter, TEntityType type, TEntCoord* pPerim)
{
   fpMinefield = pMf;
   fRequestor  = requestorId;
   fRequestNum = reqNum;
   fNumPts     = numPts;
   fFilter     = filter;
   fMineType   = type;
   fpPerim     = pPerim;
   fpReqSensorTypes = NULL;
}

cMinefieldRequestMsg::~cMinefieldRequestMsg()
{ 
	if(fpReqSensorTypes) delete [] fpReqSensorTypes;
}



void    cMinefieldResponseMsg::SendMsg()
{
   gpNetMgr->GetPduTrans()->ProcessMineResponse(fpMinefield, fpTypesList, fRequestorId, fRequestNum,
					fNumReqSensors, fpReqSensorTypes);
}


cMinefieldResponseMsg::~cMinefieldResponseMsg()
{ }

void    cSendResponsePduMsg::SendMsg()
{
   gpNetMgr->GetPduTrans()->SendMineResponse(fpMinefield, fpMineList, fRequestorId,
            fRequestNum, fType, fNumMines, fThisPduIndex, fTotalResponsePdus,fNumReqSensors, fpReqSensType);
}

cSendResponsePduMsg::cSendResponsePduMsg(cMinefield* pMf, T2linkHead* pMineList, TEntityID reqId, 
                  int reqNum, const TEntityType& type, int numMines, int msgNum, int msgsTot,
			short numReqSens, TEntityType* pReqSensType)
{
   fpMinefield = pMf;
   fpMineList = pMineList;
   fRequestorId = reqId;
   fRequestNum = reqNum;
   fType = type;
   fNumMines = numMines;
   fThisPduIndex = msgNum;
   fTotalResponsePdus = msgsTot;
   fNumReqSensors = numReqSens;
   fpReqSensType = pReqSensType;
}

cSendResponsePduMsg::~cSendResponsePduMsg()
{ }

void    cSendCpMinesMsg::SendMsg()
{
   fpMineSet->fpCpMinesMsg = NULL;
   gpNetMgr->GetPduTrans()->SendCpMines(fpMineSet);
}
      
cSendCpMinesMsg::cSendCpMinesMsg( T2linkMineSetList* pMineSet,
                  TTimeSim wait ) :
   cMsgLowRateUpdt(wait)
{
   fpMineSet = pMineSet;
}

cSendCpMinesMsg::~cSendCpMinesMsg()
{ }

void    cSendCpMfMsg::SendMsg()
{
   fpMinefield->SetCpMfMsg( NULL );
   gpNetMgr->GetPduTrans()->SendCpMinefield(fpMinefield);
}
      
cSendCpMfMsg::cSendCpMfMsg( cMinefield* pMinefield, TTimeSim wait ) :
   cMsgLowRateUpdt(wait)
{
   fpMinefield = pMinefield;
}

cSendCpMfMsg::~cSendCpMfMsg()
{ }


int   cpduMinefieldState_REV::GetStructSize()

  /*  make if change to DIS204 in here */
{  
  // if( gCmsMgr.fStartupParam.feProtocol == /*EProtocol:: */eDis203 ){

      return sizeof(DIS203_PDU_HEADER_RECORD) +
             sizeof(DIS203_ENTITY_ID_RECORD) +
	     sizeof(unsigned short) + 
             sizeof(DIS203_FORCE_ID_TYPE) +
             sizeof(unsigned char) +
             sizeof(DIS203_ENTITY_TYPE_RECORD) +
             sizeof(unsigned short) +
             sizeof(DIS203_WORLD_COORDINATES_RECORD) +
             sizeof(DIS203_EULER_ANGLES_RECORD) +
	     sizeof(EMfAppearance_REV) +
	     sizeof(unsigned short);
      /* }
   else {

      return sizeof(DIS204_PDU_HEADER_RECORD) +
             sizeof(DIS204_ENTITY_ID_RECORD) +
	     sizeof(unsigned short) + 
             sizeof(DIS204_FORCE_ID_TYPE) +
             sizeof(unsigned char) +
             sizeof(DIS204_ENTITY_TYPE_RECORD) +
             sizeof(unsigned short) +
             sizeof(DIS204_WORLD_COORDINATES_RECORD) +
             sizeof(DIS204_EULER_ANGLES_RECORD) +
	     sizeof(EMfAppearance_REV) +
	     sizeof(unsigned short);
   }*/

}


int   cpduMinefieldState::GetStructSize()

  /*  make if change to DIS204 in here */
{
  // if( gCmsMgr.fStartupParam.feProtocol == /*EProtocol:: */eDis203 ){

      return sizeof(DIS203_PDU_HEADER_RECORD) +
             sizeof(DIS203_ENTITY_ID_RECORD) +
             sizeof(DIS203_FORCE_ID_TYPE) +
             sizeof(unsigned char) +
             sizeof(DIS203_ENTITY_TYPE_RECORD) +
             sizeof(DIS203_ENTITY_TYPE_RECORD) +
             sizeof(unsigned short) +
             sizeof(unsigned short) +
             sizeof(DIS203_WORLD_COORDINATES_RECORD) +
             sizeof(DIS203_EULER_ANGLES_RECORD);

      /*  }
   else { 

      return sizeof(DIS204_PDU_HEADER_RECORD) + 
             sizeof(DIS204_ENTITY_ID_RECORD) + 
             sizeof(DIS204_FORCE_ID_TYPE) + 
             sizeof(unsigned char) + 
             sizeof(DIS204_ENTITY_TYPE_RECORD) + 
             sizeof(DIS204_ENTITY_TYPE_RECORD) + 
             sizeof(unsigned short) + 
             sizeof(unsigned short) + 
             sizeof(DIS204_WORLD_COORDINATES_RECORD) + 
             sizeof(DIS204_EULER_ANGLES_RECORD); 

   }*/

}

void     cQrpManager::RecvMfReqPdu(void * buf, TTimeSim)
{
	if(fcp == eQrp1)
		RecvMfReqPduQRP1(buf);
	else // if(fcp == eQrp3)
		RecvMfReqPduQRP3(buf);  /*error*/
}



void     cQrpManager::RecvMfReqPduQRP3(void * buf, TTimeSim)
{
   cpduMinefieldRequest_REV* pPdu = (cpduMinefieldRequest_REV*) buf;
   cout << "processing request pdu"<<endl;
      // check address.  Do nothing if not for us
   if ( (pPdu->fMinefieldId.simulation_address.site_id == gCmsMgr.GetSite()) &&
        (pPdu->fMinefieldId.simulation_address.application_id == gCmsMgr.GetApplication()) ) {
      TEntityID fieldId(pPdu->fMinefieldId.simulation_address.site_id,
                        pPdu->fMinefieldId.simulation_address.application_id,
                        pPdu->fMinefieldId.entity_id);
      cMinefield* pMinefield = gMfieldMgr.GetFieldByEntId(fieldId);
      if ( pMinefield ) {
         TEntCoord* pPerim = new TEntCoord[pPdu->fNumPerimeterPts];
         for ( int i = 0; i < pPdu->fNumPerimeterPts; i++)
            pPerim[i] = pPdu->fpPerimeter[i];

         DIS203_ENTITY_TYPE_RECORD* tmpSensorType = (DIS203_ENTITY_TYPE_RECORD*)pPdu;
	 //  DIS204_ENTITY_TYPE_RECORD* tmpSensorType204 = (DIS204_ENTITY_TYPE_RECORD*)pPdu;

	 //   if( gCmsMgr.fStartupParam.feProtocol == /*EProtocol:: */eDis203 )
            tmpSensorType += (pPdu->GetStructSize() + (pPdu->fNumPerimeterPts *
            sizeof(TEntCoord)));
	    /*  else
            tmpSensorType204 += (pPdu->GetStructSize() + (pPdu->fNumPerimeterPts *  
            sizeof(TEntCoord)));*/

	 TEntityType* pReqSensType = new TEntityType[pPdu->fNumReqSensors];	

    	 DIS203_ENTITY_TYPE_RECORD SensorType;
	 //  DIS204_ENTITY_TYPE_RECORD SensorType204;

	 //   if( gCmsMgr.fStartupParam.feProtocol == /*EProtocol:: */eDis203 ) {

	    for(int j=0;j<pPdu->fNumReqSensors;j++)
	    {
		memcpy(&SensorType,tmpSensorType,sizeof(DIS203_ENTITY_TYPE_RECORD));
		pReqSensType[j] = cDisPdu::CmsEntType(SensorType);
		tmpSensorType += sizeof(TEntCoord);
	    }

	    /*   }
         else { 
	    for(int j=0;j<pPdu->fNumReqSensors;j++) 
	    { 
		memcpy(&SensorType204,tmpSensorType204,sizeof(DIS204_ENTITY_TYPE_RECORD)); 
		pReqSensType[j] = cDisPdu::CmsEntType(SensorType204);
		tmpSensorType204 += sizeof(TEntCoord); 
	    } 

         }*/


         cout<< "request pdu is for us, scheduling request msg"<<endl;
         new cMinefieldRequestMsg(pMinefield, cDisPdu::CmsEntID(pPdu->fRequesterId), 
                                  pPdu->fRequestId,pPdu->fNumPerimeterPts, pPdu->fFilter, 
                                  cDisPdu::CmsEntType(pPdu->fObjType), pPerim, 
                                  pPdu->fNumReqSensors, pReqSensType);
      }
   }
}


void     cQrpManager::RecvMfReqPduQRP1(void * buf, TTimeSim)
{
   cpduMinefieldRequest* pPdu = (cpduMinefieldRequest*) buf;
   cout << "processing request pdu"<<endl;
      // check address.  Do nothing if not for us
   if ( (pPdu->fMinefieldId.simulation_address.site_id == gCmsMgr.GetSite()) && 
        (pPdu->fMinefieldId.simulation_address.application_id == gCmsMgr.GetApplication()) ) {
      TEntityID fieldId(pPdu->fMinefieldId.simulation_address.site_id,
                        pPdu->fMinefieldId.simulation_address.application_id,
                        pPdu->fMinefieldId.entity_id);
      cMinefield* pMinefield = gMfieldMgr.GetFieldByEntId(fieldId);
      if ( pMinefield ) {
         TEntCoord* pPerim = new TEntCoord[pPdu->fNumPerimeterPts];
         for ( int i = 0; i < pPdu->fNumPerimeterPts; i++) 
            pPerim[i] = pPdu->fPerimeter[i];
         
         cout<< "request pdu is for us, scheduling request msg"<<endl;
         new cMinefieldRequestMsg(pMinefield, cDisPdu::CmsEntID(pPdu->fRequesterId), pPdu->fRequestId, 
                     pPdu->fNumPerimeterPts, pPdu->fFilter, cDisPdu::CmsEntType(pPdu->fObjType), pPerim);
      }
   }
}

void     cQrpManager::RecvMfNACKPdu(void * buf, TTimeSim)
{
	if(fcp == eQrp1)
	   cout << "error: Recieved Nack pdu but eQrp1=true" << endl;
	else // if(fcp == eQrp3)
		RecvMfNACKPduQRP3(buf);  /*error*/
}

void     cQrpManager::RecvMfNACKPduQRP3(void * buf, TTimeSim)
{
   cpduMinefieldNACK* pPdu = (cpduMinefieldNACK*) buf;
   cout << "processing NACK pdu"<<endl;
      // check address.  Do nothing if not for us
   if ( (pPdu->fMinefieldId.simulation_address.site_id == gCmsMgr.GetSite()) &&
        (pPdu->fMinefieldId.simulation_address.application_id == gCmsMgr.GetApplication()) ) {
      TEntityID fieldId(pPdu->fMinefieldId.simulation_address.site_id,
                        pPdu->fMinefieldId.simulation_address.application_id,
                        pPdu->fMinefieldId.entity_id);
      cMinefield* pMinefield = gMfieldMgr.GetFieldByEntId(fieldId);
      if ( pMinefield ) {

	unsigned char* pMissingPackets = new unsigned char[pPdu->fNumMissingPackets];
	for ( int i=0; i < pPdu->fNumMissingPackets; i++ ) 
	   pMissingPackets[i] = pPdu->fpMissingPacketNum[i];


         cout<< "NACK pdu is for us, scheduling request msg"<<endl;
/*         new cMinefieldRequestMsg(pMinefield,
                     cDisPdu::CmsEntID(pPdu->fRequesterId),
                     pPdu->fRequestId, pPdu->fNumPerimeterPts,
                     pPdu->fFilter,
                     cDisPdu::CmsEntType(pPdu->fObjType), pPerim,
                     pPdu->fNumReqSensors, pReqSensType);
*/
      }
   }
}

// original constructor

cQrpManager::cQrpManager(EQrpProtocol qrp, cDisPduTranslator* pDisTrans) 
{ 
   fcp = qrp;
   fpDisTrans = pDisTrans;
   
   fNumMfMsgs = 0;
   fNumResponseMsgs = 0;
   fNumResponsePdus = 0;
   fLengthMfMsgs = 0;
   fLengthResponseMsgs = 0;

}
/*
cQrpManager::cQrpManager(EQrpProtocol qrp, cDisPdu204* pDisTrans) 
{ 
   fcp = qrp;
   fpDisTrans = pDisTrans;
   
   fNumMfMsgs = 0;
   fNumResponseMsgs = 0;
   fNumResponsePdus = 0;
   fLengthMfMsgs = 0;
   fLengthResponseMsgs = 0;

}*/




cQrpManager::cQrpManager(EQrpProtocol qrp, cDisPduTranslator* pDisTrans,
				EBoolean bOrient, EBoolean bBurial, EBoolean bTemp)
{
   fcp = qrp;
   fpDisTrans = pDisTrans;

   fNumMfMsgs = 0;
   fNumResponseMsgs = 0;
   fNumResponsePdus = 0;
   fLengthMfMsgs = 0;
   fLengthResponseMsgs = 0;
   cout << "in cQrpManager constructor.  Who called me?" << endl;

if(qrp == eQrp3)
{
   fsBitFlags.orientation_flag = (unsigned int) bOrient;
   fsBitFlags.burial_depth_flag = (unsigned int) bBurial;
   fsBitFlags.temperature_flag = (unsigned int) bTemp;
   fsBitFlags._unused_ = 0;

   ////////////////////////////////////
   // calculate maximum number of mines to include in each
   // mines pdu.
   // Note: 1452 must be maximum pdu size
   ////////////////////////////////////
   int partSize = 1452 -  sizeof(cpduCpMine);

   // these are "sizeof" statements
   int varSize = sizeof(DIS203_VECTOR_RECORD);
                 // at this time, DIS203 and DIS204 Vector Records are the same. 
                 // so there is no need to add the if/else dis version here.
   if ( fsBitFlags.orientation_flag )
      varSize += sizeof(DIS203_EULER_ANGLES_RECORD);
                 // at this time, DIS203 and DIS204 Euler Angles Records are the same. 
                 // so there is no need to add the if/else dis version here.

   if ( fsBitFlags.burial_depth_flag )
      varSize += sizeof(float);
   if ( fsBitFlags.temperature_flag )
      varSize += sizeof(float);
   fsMinesPerPdu = partSize / varSize;
}


} 


EBoolean     cCpManager::UsesQe()
{
   if ( (fcp == eCp1) || (fcp == eCp1Mcast) ||
        (fcp == eCp2) || (fcp == eCp2Mcast) )
      return true;
   else
      return false;
}

void    cCpManager::RecvCpMfPdu(void * buf, TTimeSim )
{
   cpduCpMinefield* pPdu = (cpduCpMinefield*) buf;
   
   cout << "minefield pdu, num vertices = "<< (int)(pPdu->num_vertices) << endl;
}

void    cCpManager::RecvCpMinesPdu(void * buf, TTimeSim )
{
   cpduCpMine* pPdu = (cpduCpMine*) buf;
   cout << "mines pdu, num mines = "<< pPdu->num_mines << endl;
}
   
void   cCpManager::SendCpMines(T2linkMineSetList* pMineSet, void* buf)
{
   int i;
   cMine* pMine;

   cpduCpMine* pPdu = (cpduCpMine*)buf;
   int length = sizeof(cpduCpMine) - sizeof(DIS203_VECTOR_RECORD);
                 // at this time, DIS203 and DIS204 Vector Records are the same. 
                 // so there is no need to add the if/else dis version here.
 
   const TLocation& refloc = pMineSet->fpComp->GetGeoLoc();

   //  if( gCmsMgr.fStartupParam.feProtocol == /*EProtocol:: */eDis203 ){
   
      pPdu->mine_set_id = fpDisTrans->DisEntID( pMineSet->GetSetId() );
      pPdu->q_sequence.quiescent = UsesQe() ? 1 : 0; 
      pPdu->q_sequence.sequence = pMineSet->GetChangeNum(); 
      pPdu->munition = fpDisTrans->DisEntType( pMineSet->fpComp->GetDetectEntType() ); 
      pPdu->fuze = pMineSet->fpComp->GetCompFuzeParams()->fFuze;
      /*const TLocation& refloc = pMineSet->fpComp->GetGeoLoc(); */
      pPdu->ref_location  = fpDisTrans->DisVehLoc( refloc );
      /*  }
   else{
       pPdu->mine_set_id = fpDisTrans->DisEntID204( pMineSet->GetSetId() );    
       pPdu->q_sequence.quiescent = UsesQe() ? 1 : 0; 
       pPdu->q_sequence.sequence = pMineSet->GetChangeNum(); 
       pPdu->munition = fpDisTrans->DisEntType204( pMineSet->fpComp->GetDetectEntType() ); 
       pPdu->fuze = pMineSet->fpComp->GetCompFuzeParams()->fFuze; 
       pPdu->ref_location  = fpDisTrans->DisVehLoc204( refloc ); 
    } */
   pPdu->data_flags  = fsBitFlags;
   
   pPdu->num_mines = pMineSet->GetNumMines();
   
   for ( i = 0, pMine = pMineSet->GetFirstMine(); 
      i < pPdu->num_mines; 
      pMine = pMineSet->GetNextMine(), i++ ) {

     // if( gCmsMgr.fStartupParam.feProtocol == /*EProtocol:: */eDis203 )
         pPdu->locations[i] = fpDisTrans->DisEntLoc( pMine->GetGeoLoc() - refloc );
	 /*  else
         pPdu->locations[i] = fpDisTrans->DisEntLoc204( pMine->GetGeoLoc() - refloc );
	 */
      length += sizeof(DIS203_VECTOR_RECORD);
                 // at this time, DIS203 and DIS204 Vector Records are the same. 
                 // so there is no need to add the if/else dis version here.
   }
   
   if ( IncludeOrient() ) {
       for ( i = 0, pMine = pMineSet->GetFirstMine(); 
            i < pPdu->num_mines; 
            pMine = pMineSet->GetNextMine(), i++ ) {
       
	 // if( gCmsMgr.fStartupParam.feProtocol == /*EProtocol:: */eDis203 )
               * ( (DIS203_EULER_ANGLES_RECORD*) ((char*)pPdu + length)) = 
               fpDisTrans->DisVehOrient( pMine->GetGeoOrient() );
	       /*  else
               * ( (DIS203_EULER_ANGLES_RECORD*) ((char*)pPdu + length)) =  
               fpDisTrans->DisVehOrient204( pMine->GetGeoOrient() );*/

         length += sizeof(DIS203_EULER_ANGLES_RECORD);
                 // at this time, DIS203 and DIS204 Euler Angles Records are the same. 
                 // so there is no need to add the if/else dis version here.
      }
   }
   
   if ( IncludeBurial() ) {
       for ( i = 0, pMine = pMineSet->GetFirstMine(); 
            i < pPdu->num_mines; 
            pMine = pMineSet->GetNextMine(), i++ ) {
         * ( (float*) ((char*)pPdu + length)) = pMine->GetDepth();
         length += sizeof(float);
      }
   }
   
   if ( IncludeThermal() ) {
       for ( i = 0, pMine = pMineSet->GetFirstMine(); 
            i < pPdu->num_mines; 
            pMine = pMineSet->GetNextMine(), i++ ) {
         * ( (float*) ((char*)pPdu + length)) = ((cSimMine*)pMine)->GetThermalContrast();
         length += sizeof(float);
      }
   }

   fpDisTrans->SetLength( length );
   fpDisTrans->FillHdr( gPduType.pdu[epduTypeCpMines], gPduType.family[epduFamilyEntityInteraction] );
   gpNetMgr->SendPdu(pPdu, pPdu->fHeader.length);
   
   if ( gfPduData ) {
      fNumMinesetMsgs++;
      fLengthMinesetMsgs += pPdu->fHeader.length;
      if ( (UsesQe()) && (pPdu->q_sequence.sequence == 1) ) {
         *gpPduData << GetCurSimTime() 
                   << " initial CP PDU sent for set of "
                   << pMineSet->GetNumMines()
                   << " mines of type: "
                   << pMineSet->fpComp->GetEntName()
                   << " in minefield: "
                   << pMineSet->fpComp->GetMinefield()->GetEntName()
                   << endl;
      }
   }

   if ( ! UsesQe() )  
      pMineSet->fpCpMinesMsg = new cSendCpMinesMsg( pMineSet, fsHeartbeat);
}

void   cCpManager::SendCpMinefield(cMinefield* pMf, void* buf)
{
   int i;
   TPerimPoint* pPt;
   
   cpduCpMinefield* pPdu = (cpduCpMinefield*)buf;
   cPerimeter* pPerim = pMf->GetPerimeter();
   
   int length = sizeof(cpduCpMinefield) - sizeof(DIS203_WORLD_COORDINATES_RECORD);
                 // at this time, DIS203 and DIS204 World Coordinates Records are the same. 
                 // so there is no need to add the if/else dis version here.

   //  if( gCmsMgr.fStartupParam.feProtocol == /*EProtocol:: */eDis203 )
      pPdu->minefield_id = fpDisTrans->DisEntID( pMf->GetEntityID() );
      /*  else 
      pPdu->minefield_id = fpDisTrans->DisEntID204( pMf->GetEntityID() );*/

   pPdu->q_sequence.quiescent = UsesQe() ? 1 : 0;
   pPdu->q_sequence.sequence = pMf->GetChangeNum();
   pPdu->appearance   = (unsigned short) ( pMf->GetMfAppearance() );
   pPdu->num_vertices = pPerim->GetNumPoints();
   fpDisTrans->DisForce( &pPdu->force_id, pMf->GetForce() );
   
   for ( i = 0, pPt = pPerim->GetFirstPoint(); 
         i < pPdu->num_vertices; 
         pPt = pPerim->GetNextPoint(), i++ ) {
      pPdu->vertices[i] = fpDisTrans->DisVehLoc( pPt->GetGeoPoint() );
      length += sizeof(DIS203_WORLD_COORDINATES_RECORD);
                 // at this time, DIS203 and DIS204 World Coordinates Records are the same. 
                 // so there is no need to add the if/else dis version here.
   }

   fpDisTrans->SetLength( length );
   fpDisTrans->FillHdr( gPduType.pdu[epduTypeCpMinefield], gPduType.family[epduFamilyEntityInteraction] );
   gpNetMgr->SendPdu(pPdu, pPdu->fHeader.length);
   
   if ( gfPduData ) {
      fNumMfMsgs++;
      fLengthMfMsgs += pPdu->fHeader.length;
      if ( (UsesQe()) && (pPdu->q_sequence.sequence == 1) ) {
         *gpPduData << GetCurSimTime() 
                   << " initial CP minefield PDU sent for: "
                   << pMf->GetEntName() << endl;
      }
   }

   if ( ! UsesQe() )  {
      cSendCpMfMsg* pCpMfMsg = new cSendCpMfMsg( pMf, fsHeartbeat);
      pMf->SetCpMfMsg( pCpMfMsg );
   }
}

void     cCpManager::CpShutdown()
{
   if ( gfPduData ) {
      *gpPduData << "CP shutdown"
                 << endl;
                 
      float avg = (fNumMfMsgs == 0) ? 0.0 : ( fLengthMfMsgs / fNumMfMsgs);
      *gpPduData << "Total minefield msgs: "
                 << fNumMfMsgs
                 << " total length: "
                 << fLengthMfMsgs
                 << " avg length: "
                 << avg
                 << endl;
                 
      avg = (fNumMinesetMsgs == 0) ? 0.0 : ( fLengthMinesetMsgs / fNumMinesetMsgs);
      *gpPduData << "Total mine set msgs: "
                 << fNumMinesetMsgs
                 << " total length: "
                 << fLengthMinesetMsgs
                 << " avg length: "
                 << avg
                 << endl;
   }
}

cCpManager::cCpManager(ECpProtocol cp, cDisPduTranslator* pDisTrans, EBoolean bOrient,
                       EBoolean bBurial, EBoolean bTemp) 
{ 
   fcp = cp;
   fsBitFlags.orientation_flag = (unsigned int) bOrient;
   fsBitFlags.burial_depth_flag = (unsigned int) bBurial;
   fsBitFlags.temperature_flag = (unsigned int) bTemp;
   fsBitFlags._unused_ = 0;
   fpDisTrans = pDisTrans;
   
   int partSize = 1452 -  sizeof(cpduCpMine);
   int varSize = sizeof(DIS203_VECTOR_RECORD);
                 // at this time, DIS203 and DIS204 Vector Records are the same. 
                 // so there is no need to add the if/else dis version here.
   if ( fsBitFlags.orientation_flag )
      varSize += sizeof(DIS203_EULER_ANGLES_RECORD);
                 // at this time, DIS203 and DIS204 Euler Angles Records are the same. 
                 // so there is no need to add the if/else dis version here.
   if ( fsBitFlags.burial_depth_flag )
      varSize += sizeof(float);
   if ( fsBitFlags.temperature_flag )
      varSize += sizeof(float);
      
   fsMinesPerPdu = partSize / varSize;
   
   fNumMfMsgs = 0;
   fNumMinesetMsgs = 0;
   fLengthMfMsgs = 0;
   fLengthMinesetMsgs = 0;
}
/*
cCpManager::cCpManager(ECpProtocol cp, cDisPdu204* pDisTrans, EBoolean bOrient,
                       EBoolean bBurial, EBoolean bTemp) 
{ 
   fcp = cp;
   fsBitFlags.orientation_flag = (unsigned int) bOrient;
   fsBitFlags.burial_depth_flag = (unsigned int) bBurial;
   fsBitFlags.temperature_flag = (unsigned int) bTemp;
   fsBitFlags._unused_ = 0;
   fpDisTrans = pDisTrans;
   
   int partSize = 1452 -  sizeof(cpduCpMine);
   int varSize = sizeof(DIS203_VECTOR_RECORD);
                 // at this time, DIS203 and DIS204 Vector Records are the same. 
                 // so there is no need to add the if/else dis version here.
   if ( fsBitFlags.orientation_flag )
      varSize += sizeof(DIS203_EULER_ANGLES_RECORD);
                 // at this time, DIS203 and DIS204 Euler Angles Records are the same. 
                 // so there is no need to add the if/else dis version here.
   if ( fsBitFlags.burial_depth_flag )
      varSize += sizeof(float);
   if ( fsBitFlags.temperature_flag )
      varSize += sizeof(float);
      
   fsMinesPerPdu = partSize / varSize;
   
   fNumMfMsgs = 0;
   fNumMinesetMsgs = 0;
   fLengthMfMsgs = 0;
   fLengthMinesetMsgs = 0;
}
*/
int cpduMinefieldRequest_REV::GetStructSize()
{  
  // if( gCmsMgr.fStartupParam.feProtocol == /*EProtocol:: */eDis203 ){

	return 	sizeof(DIS203_PDU_HEADER_RECORD) +
		sizeof(DIS203_ENTITY_ID_RECORD) + 
		sizeof(DIS203_ENTITY_ID_RECORD) +
		sizeof(unsigned char) +
		sizeof(unsigned char) +
		sizeof(unsigned char) +
		sizeof(unsigned char) +
		sizeof(TMinefieldObjectFilter_REV) +
		sizeof(DIS203_ENTITY_TYPE_RECORD);
	/*  }
   else {

	return 	sizeof(DIS204_PDU_HEADER_RECORD) +
		sizeof(DIS204_ENTITY_ID_RECORD) + 
		sizeof(DIS204_ENTITY_ID_RECORD) +
		sizeof(unsigned char) +
		sizeof(unsigned char) +
		sizeof(unsigned char) +
		sizeof(unsigned char) +
		sizeof(TMinefieldObjectFilter_REV) +
		sizeof(DIS204_ENTITY_TYPE_RECORD);
   }*/
 
   
}
			
int   cpduMinefieldResponse::GetStructSize()
{
  //  if( gCmsMgr.fStartupParam.feProtocol == /*EProtocol:: */eDis203 ){

      return sizeof(DIS203_PDU_HEADER_RECORD) +
          sizeof(DIS203_ENTITY_ID_RECORD) +
          sizeof(DIS203_ENTITY_ID_RECORD) +
          sizeof(unsigned char) +
          sizeof(unsigned char) +
          sizeof(unsigned char) +
          sizeof(unsigned char) +
          sizeof(DIS203_ENTITY_TYPE_RECORD);
      /* }
   else {

      return sizeof(DIS204_PDU_HEADER_RECORD) +
          sizeof(DIS204_ENTITY_ID_RECORD) +
          sizeof(DIS204_ENTITY_ID_RECORD) +
          sizeof(unsigned char) +
          sizeof(unsigned char) +
          sizeof(unsigned char) +
          sizeof(unsigned char) +
          sizeof(DIS204_ENTITY_TYPE_RECORD);
   }*/
 
}

int   cpduMinefieldResponse_REV::GetStructSize()
{
  //if( gCmsMgr.fStartupParam.feProtocol == /*EProtocol:: */eDis203 ){

      return sizeof(DIS203_PDU_HEADER_RECORD) +
          sizeof(DIS203_ENTITY_ID_RECORD) +
          sizeof(DIS203_ENTITY_ID_RECORD) +
	  sizeof(unsigned short) +
          sizeof(unsigned char) +
          sizeof(unsigned char) +
          sizeof(unsigned char) +
          sizeof(unsigned char) +
	  sizeof(unsigned char) +
	  sizeof(unsigned char) +
	  sizeof(unsigned int) +
          sizeof(DIS203_ENTITY_TYPE_RECORD);
      /* }
   else {

      return sizeof(DIS204_PDU_HEADER_RECORD) +
          sizeof(DIS204_ENTITY_ID_RECORD) +
          sizeof(DIS204_ENTITY_ID_RECORD) +
	  sizeof(unsigned short) +
          sizeof(unsigned char) +
          sizeof(unsigned char) +
          sizeof(unsigned char) +
          sizeof(unsigned char) +
	  sizeof(unsigned char) +
	  sizeof(unsigned char) +
	  sizeof(unsigned int) +
          sizeof(DIS204_ENTITY_TYPE_RECORD);
   }*/

}

void   cpduMinefieldResponse::WriteMfResponsePdu()
{
   cout << " packet length " << fHeader.length << endl;
   cout << " minefield entity id "<<(int)fMinefieldId.simulation_address.site_id << " "
                            <<(int)fMinefieldId.simulation_address.application_id << " "
                            <<(int)fMinefieldId.entity_id << endl;
   cout << " requestor entity id "  <<(int)fRequesterId.simulation_address.site_id << " "
                            <<(int)fRequesterId.simulation_address.application_id << " "
                            <<(int)fRequesterId.entity_id << endl;

   cout << " request id " << (int)fRequestId << endl;
   cout << " packet number " << (int)fPacketNumber << endl;
   cout << " total packets " << (int)fTotalPackets << endl;
   cout << " number of objects " << (int)fNumberOfObjects << endl;
   
   cout<< "object type " 
       << (int)fObjType.kind << " "
       << (int)fObjType.domain << " "
       << (int)fObjType.country << " "
       << (int)fObjType.category << " "
     /*       << (int)fObjType.category204 << " " */
       << (int)fObjType.subcategory << " "
 /*       << (int)fObjType.subcategory204 << " "*/
       << (int)fObjType.specific << " "
 /*       << (int)fObjType.specific204 << " "*/
       << (int)fObjType.extra
 /*       << (int)fObjType.extra204*/
       << endl;
       
   cout<< " locations " << endl;
   for ( int i = 0; i < fNumberOfObjects; i++ )
      cout<< fObjOrientedLoc[i].fLocation.x << " "
          << fObjOrientedLoc[i].fLocation.y << " "
          << fObjOrientedLoc[i].fLocation.z << endl;
}

void   cpduMinefieldResponse_REV::WriteMfResponsePdu(VARPTRS* pVariableRec)
{
   cout << " packet length " << fHeader.length << endl;
   cout << " minefield entity id "<<(int)fMinefieldId.simulation_address.site_id << " "
                            <<(int)fMinefieldId.simulation_address.application_id << " "
                            <<(int)fMinefieldId.entity_id << endl;
   cout << " requestor entity id "  <<(int)fRequesterId.simulation_address.site_id << " "
                            <<(int)fRequesterId.simulation_address.application_id << " "
                            <<(int)fRequesterId.entity_id << endl;

   cout << " request id " << (int)fRequestId << endl;
   cout << " packet number " << (int)fPacketNumber << endl;
   cout << " total packets " << (int)fTotalPackets << endl;
   cout << " number of objects " << (int)fNumberOfObjects << endl;
   
   cout<< "object type " 
       << (int)fObjType.kind << " "
       << (int)fObjType.domain << " "
       << (int)fObjType.country << " "
       << (int)fObjType.category << " "
     /*    << (int)fObjType.category204 << " "*/
       << (int)fObjType.subcategory << " "
     /*   << (int)fObjType.subcategory204 << " "*/
       << (int)fObjType.specific << " "
     /*   << (int)fObjType.specific204 << " "*/
       << (int)fObjType.extra
     /*   << (int)fObjType.extra204*/
       << endl;
       
   //   if( gCmsMgr.fStartupParam.feProtocol == /*EProtocol:: */eDis203 ){

   cout<< " locations " << endl;
   for ( int i = 0; i < fNumberOfObjects; i++ )
      cout<< pVariableRec->pMineLoc[i].x << " "
          << pVariableRec->pMineLoc[i].y << " "
          << pVariableRec->pMineLoc[i].z << endl;

   /*   }
   else {

   cout<< " locations " << endl;
   for ( int i = 0; i < fNumberOfObjects; i++ )
      cout<< pVariableRec->pMineLoc_204[i].x << " "
          << pVariableRec->pMineLoc_204[i].y << " "
          << pVariableRec->pMineLoc_204[i].z << endl;

   }*/
	  
   cout << " Filter flags " << endl;
   TMinefieldRequestFilter filter = *((TMinefieldRequestFilter*) (&fFilter));
   	if (filter.GroundBurialDepth)
	    cout << "GroundBurialDepth, ";
	    
	if (filter.WaterBurialDepth)
	    cout << "WaterBurialDepth, ";

	if (filter.SnowBurialDepth)
	    cout << "Snow Burial Depth, ";

	if (filter.MineOrientation)
	    cout << "MineOrientation, ";

	if (filter.ThermalContrast)
	    cout << "ThermalContrast, ";

	if (filter.DielectricConstant)
	    cout << "DielectricConstant, ";

	if (filter.MineEmplacementAge)
	    cout << "MineEmplacementAge, ";

	if (filter.TripDetWireLoc)
	    cout << "TripDetWireLoc, ";
	
	if (filter.Fusing)
	    cout << "Fusing, ";

	if (filter.ScalerDetCoeff)
	    cout << "ScalerDetCoeff, ";
	    
	if (filter.PaintScheme)
	    cout << "PaintScheme, ";
  cout << endl;

}

void     cCmsTranslator::ReceivePdu(void * , TTimeSim )
{
}


void    cQrpManager::FillPerimeter(cMinefield* pMf, void* buf, int* pLength)
   // fLength set to already filled PDU length,
   //  we add on end and increment fLength
{
   TEntCoord*  pOutPt = (TEntCoord*) ((char*)buf + *pLength);
   cPerimeter* pPerim = pMf->GetPerimeter();
   
   for ( TPerimPoint* pPt = pPerim->GetFirstPoint(); 
                      pPt; 
                      pPt = pPerim->GetNextPoint() ) {
      *pOutPt++ = pPt->GetMfPoint();
      *pLength += sizeof(TEntCoord);
//  cout<<" perim pt added, length so far "<<fLength<<endl;
   }
}


void    cQrpManager::FillMineTypes(cMinefield* pMf, void* buf, int* pLength)
   // fLength set to already filled PDU length,
   //  we add on end and increment fLength
{
   TEntityType* pOutType = (TEntityType*) ((char*)buf + *pLength);
   cObjTypeListHead*   pTypeList =  pMf->GetMineTypeList();
   
   for ( TMfObjTypeDesc* pLink  = (TMfObjTypeDesc*) (pTypeList->GetFirstLink()); 
                         pLink != (TMfObjTypeDesc*) (pTypeList->GetNULLLink()); 
                         pLink  = (TMfObjTypeDesc*) (pTypeList->GetNextLink()) ) {
      *pOutType++ = pLink->GetEntityType();
      *pLength += sizeof(TEntityType);
//  cout<<" mine type added, length so far "<<fLength<<endl;
   }
}

	 
	

void cQrpManager::SendMinefieldState(cMinefield* pMf, void* buf)
{
	if(fcp == eQrp1)
		SendMinefieldStateQRP1(pMf, buf);
	else // if fcp==eQrp3
		SendMinefieldStateQRP3(pMf, buf);
}


void   cQrpManager::SendMinefieldStateQRP3(cMinefield* pMf, void* buf)
{
	// need fSeqNum....Got it I think (KS)
//   int i;
   //TPerimPoint* pPt;
   cPerimeter* pPerim = pMf->GetPerimeter();
   cpduMinefieldState_REV* pPdu = (cpduMinefieldState_REV*)buf;

   // Don't know why I had it like this.. Check on this.
   //int length = sizeof(cpduMinefield_REV) - sizeof(DIS203_WORLD_COORDINATES_RECORD);
   int length = pPdu->GetStructSize();

   pPdu->fMinefieldId = fpDisTrans->DisEntID( pMf->GetEntityID() );
   //why didn't I (Picot) put in the if statement here?  Well, this is temporary...
   pPdu->fSeqNum = pMf->GetCurSeq().u;
   pMf->UpdateLastSeq();
   fpDisTrans->DisForce( &pPdu->fForceId, pMf->GetForce() );
   pPdu->fNumPerimeterPts = pPerim->GetNumPoints();

   // Don't know why I had it like this.. Check on this.
   /*for ( i = 0, pPt = pPerim->GetFirstPoint();
         i < pPdu->num_vertices;
         pPt = pPerim->GetNextPoint(), i++ ) {
      pPdu->vertices[i] = fpDisTrans->DisVehLoc( pPt->GetGeoPoint() );
      length += sizeof(DIS203_WORLD_COORDINATES_RECORD);
   }*/
   FillPerimeter(pMf, buf, &length);      //uses length, adjusts it
  
   // this wasn't in when I did this earlier.  Why?  Did I just forget to do it?
   pPdu->fType        = fpDisTrans->DisEntType(pMf->GetEntType());
   pPdu->fNumMineTypes       = pMf->GetNumMineTypes();
   FillMineTypes(pMf, buf, &length);      //uses length, adjusts it

   bzero((&pPdu->fAppearance),sizeof(pPdu->fAppearance));
   pPdu->fAppearance.MinefieldType = pMf->GetMinefieldType(); 
   fpDisTrans->SetLength( length );
   fpDisTrans->FillHdr( gPduType.pdu[epduTypeMinefieldState], gPduType.family[epduFamilyEntityInteraction] );
   fpDisTrans->SetProtocolFamily(130);  // experimental pdu

   pPdu->fLocation           = fpDisTrans->DisVehLoc(pMf->GetGeoLoc());
   pPdu->fOrientation        = fpDisTrans->DisVehOrient(pMf->GetGeoOrient());


//////////////////////////////////////////////////////
//////////////////////////////////////////////////////

   /*pPdu->q_sequence.quiescent = UsesQe() ? 1 : 0;
   pPdu->q_sequence.sequence = pMf->GetChangeNum();
   pPdu->appearance   = (unsigned short) ( pMf->GetMfAppearance() );

   for ( i = 0, pPt = pPerim->GetFirstPoint();
         i < pPdu->num_vertices;
         pPt = pPerim->GetNextPoint(), i++ ) {
      pPdu->vertices[i] = fpDisTrans->DisVehLoc( pPt->GetGeoPoint() );
      length += sizeof(DIS203_WORLD_COORDINATES_RECORD);
   }

   gpNetMgr->SendPdu(pPdu, pPdu->fHeader.length);

   if ( gfPduData ) {
      fNumMfMsgs++;
      fLengthMfMsgs += pPdu->fHeader.length;
      if ( (UsesQe()) && (pPdu->q_sequence.sequence == 1) ) {
         *gpPduData << GetCurSimTime()
                   << " initial CP minefield PDU sent for: "
                   << pMf->GetEntName() << endl;
      }
   }

   if ( ! UsesQe() )  {
      cSendCpMfMsg* pCpMfMsg = new cSendCpMfMsg( pMf, fsHeartbeat);
      pMf->SetCpMfMsg( pCpMfMsg );
   }

*/

}



void    cQrpManager::SendMinefieldStateQRP1(cMinefield* pMf, void* buf)
{
//  cout<<"sending minefield state PDU"<<endl;
  
   cpduMinefieldState* pPdu = (cpduMinefieldState*)buf;

   int length = pPdu->GetStructSize();
//   fLength = sizeof(cpduMinefieldState);
//  cout<<" length so far "<<fLength<<endl;

   pPdu->fMinefieldId        = fpDisTrans->DisEntID(pMf->GetEntityID());
   fpDisTrans->DisForce( &(pPdu->fForce), pMf->GetForce() );
   pPdu->fNumPerimeterPts    = pMf->GetPerimeter()->GetNumPoints();
   pPdu->fType               = fpDisTrans->DisEntType(pMf->GetEntType());
   pPdu->fAltType            = fpDisTrans->DisEntType(pMf->GetEntType());

   pPdu->fNumMineTypes       = pMf->GetNumMineTypes();
   pPdu->fNumFixObjTypes     = pMf->GetNumFixobjTypes();
   pPdu->fLocation           = fpDisTrans->DisVehLoc(pMf->GetGeoLoc());
   pPdu->fOrientation        = fpDisTrans->DisVehOrient(pMf->GetGeoOrient());

   FillPerimeter(pMf, buf, &length);      //uses length, adjusts it
   FillMineTypes(pMf, buf, &length);      //uses length, adjusts it
//   pPdu->fpPerimeter         = ;
//   pPdu->fpMineTypes         = ;
//   pPdu->fpFixedObjectTypes  = ;
   
   fpDisTrans->SetLength(length);
   fpDisTrans->FillHdr(gPduType.pdu[epduTypeMinefieldState], gPduType.family[epduFamilyEntityInteraction] );
   
   if ( gfPduData ) {
      fNumMfMsgs++;
      fLengthMfMsgs += pPdu->fHeader.length;
   }

   gpNetMgr->SendPdu(buf, pPdu->fHeader.length);
}

void    cQrpManager::ProcessMineResponse(cMinefield* pMf, T2linkHead* pTypeList,
               TEntityID reqId, int reqNum, short numReqSensors, TEntityType* pReqSensType)
   // breaks the entire minefield response into PDUs to send
{
// cout<<" processing response, breaking into packets if necessary"<<endl;
   int numPdus  = 0;
   int numMines = 0;
   int thisMsg  = 0;
   
      // loop to find the number of PDUs to send
   for ( T2linkMineList*   pMineList  = (T2linkMineList*)(pTypeList->GetFirstLink());
                           pMineList != pTypeList->GetNULLLink();
                           pMineList  = (T2linkMineList*)(pTypeList->GetNextLink()) ) {
      numPdus += ( pMineList->GetNumMines() + fsMinesPerPdu - 1 ) / fsMinesPerPdu;
      numMines += pMineList->GetNumMines();
// cout << "mine list with "<<pMineList->GetNumMines()<<" mines, cum num Pdus = "<< numPdus<<endl;
   }
   
   if ( numPdus > 0 ) {
      for ( T2linkMineList*   pMineList  = (T2linkMineList*)(pTypeList->GetFirstLink());
                              pMineList != pTypeList->GetNULLLink();
                              pMineList  = (T2linkMineList*)(pTypeList->GetNextLink()) ) {
         if  (pMineList->GetNumMines() <= 0 ) continue;
         
         if  (pMineList->GetNumMines() <= fsMinesPerPdu ) {
            T2linkHead* pNewList = new T2linkHead(&(pMineList->fMineList));
            new cSendResponsePduMsg(pMf, pNewList, reqId, reqNum, pMineList->GetType(), 
                        pMineList->GetNumMines(), ++thisMsg, numPdus,numReqSensors,pReqSensType);
            if (gfDetectProt) {
               for (TLinkMine* pLink  = (TLinkMine*)(pNewList->GetFirstLink());
                               pLink != (TLinkMine*)(pNewList->GetNULLLink());
                               pLink  = (TLinkMine*)(pNewList->GetNextLink())     ) {
                  pLink->GetMine()->ShowObj(true);
               }
            }
         }
         else {      // break into multiple pdus
            int iStart = 0;
            int iNextStart   = fsMinesPerPdu;
            int numMsgs = ( pMineList->GetNumMines() + fsMinesPerPdu - 1 ) / fsMinesPerPdu;
            cMine*   pMine = pMineList->GetFirstMine();
            for (int i = 1; i <= numMsgs; i++ ) {
               T2linkHead* pPartMineList = new T2linkHead();
               for (int j = iStart; j < iNextStart; j++) {
                  new TLinkMine(pMine, pPartMineList->GetLastLink());
                  if (gfDetectProt)   pMine->ShowObj(true);
                  pMine = pMineList->GetNextMine();
               }
               new cSendResponsePduMsg(pMf, pPartMineList, reqId, reqNum, pMineList->GetType(),
                                    iNextStart - iStart, ++thisMsg, numPdus,numReqSensors,pReqSensType);
               iStart = iNextStart;
               iNextStart = ( (i == (numMsgs - 1) ) ? pMineList->GetNumMines() : iNextStart + fsMinesPerPdu );
            }
               // delete link from old list, new ones have been created
            pMineList->fMineList.DeleteList();
         }
      }
   }
   
   else {   // construct empty response pdu
      TEntityType nullType;
      new cSendResponsePduMsg(pMf, NULL, reqId, reqNum, nullType, 0, 1, 1,0,NULL);
   }
   
   pTypeList->DeleteList();   // deletes the pMineList links
   delete pTypeList;
}

////////////////
// original
/*void    cQrpManager::SendMineResponse(cMinefield* pMf, T2linkHead* pMineList,
                     TEntityID reqId, int reqNum, TEntityType& type, int numMines,
                     int msgNum, int msgsTot, void* buf)
{
   cMine* pMine;
   cpduMinefieldResponse* pPdu = (cpduMinefieldResponse*)buf;

   int length = pPdu->GetStructSize() + numMines * sizeof(TFixedObjectOrientedLoc);

//  cout<<"sending minefield response PDU for "<<numMines<<" mines"<<endl;
//  cout<<" sizes, tot, basic, each mine rec "<< fLength <<" "<< pPdu->GetStructSize() <<" "<<
sizeof(TFixedObjectOrientedLoc);

   pPdu->fMinefieldId        = fpDisTrans->DisEntID(pMf->GetEntityID());
   pPdu->fRequesterId        = fpDisTrans->DisEntID(reqId);
   pPdu->fRequestId          = reqNum;
   pPdu->fPacketNumber       = msgNum;
   pPdu->fTotalPackets       = msgsTot;
   pPdu->fNumberOfObjects    = numMines;
   pPdu->fObjType            = fpDisTrans->DisEntType(type);

   if ( pMineList ) {
      pMine = ((TLinkMine*)(pMineList->GetFirstLink()))->GetMine();
      for ( int i = 0; i < numMines; i++ ) {
         pPdu->fObjOrientedLoc[i].fLocation     = fpDisTrans->DisEntLoc( pMine->GetMfLoc() );
         pPdu->fObjOrientedLoc[i].fOrientation  = fpDisTrans->DisVehOrient( pMine->GetTccOrient() );
         pPdu->fObjOrientedLoc[i].fBurialDepth  = pMine->GetDepth();
         pPdu->fObjOrientedLoc[i].fId           = (pMine->GetEntityID()).entityNum;
         pPdu->fObjOrientedLoc[i].padding       = 0;
         pMine =  ((TLinkMine*)(pMineList->GetNextLink()))->GetMine();
      }
   }
  
   fpDisTrans->SetLength(length);
   fpDisTrans->FillHdr(gPduType.pdu[epduTypeMinefieldResponse]);
  
   if ( gfPduData ) {
      fNumResponsePdus++;
      if ( pPdu->fPacketNumber == 1 )
         fNumResponseMsgs++;
      fLengthResponseMsgs += pPdu->fHeader.length;
   }
   gpNetMgr->SendPdu(buf, pPdu->fHeader.length);
  
   if (pPdu->fHeader.exercise_id == 50) pPdu->WriteMfResponsePdu();
}
*/


void cQrpManager::SendMineResponse1(cMinefield* pMf, T2linkHead* pMineList,
                     TEntityID reqId, int reqNum, TEntityType& type, int numMines,
                     int msgNum, int msgsTot, void* buf)
{
	cMine* pMine;
   	int length, varLength;
	cpduMinefieldResponse* pPdu = (cpduMinefieldResponse*)buf;
        length = pPdu->GetStructSize();
        varLength = numMines * sizeof(TFixedObjectOrientedLoc);

       //  cout<<"sending minefield response PDU for "<<numMines<<" mines"<<endl;
        //  cout<<" sizes, tot, basic, each mine rec "<< fLength <<" "<< pPdu->GetStructSize() <<" "<< sizeof(TFixedObjectOrientedLoc);

        pPdu->fMinefieldId        = fpDisTrans->DisEntID(pMf->GetEntityID());
        pPdu->fRequesterId        = fpDisTrans->DisEntID(reqId);
        pPdu->fRequestId          = reqNum;
        pPdu->fPacketNumber       = msgNum;
        pPdu->fTotalPackets       = msgsTot;
        pPdu->fNumberOfObjects    = numMines;
        pPdu->fObjType            = fpDisTrans->DisEntType(type);

	if ( pMineList )
        {
                pMine = ((TLinkMine*)(pMineList->GetFirstLink()))->GetMine();
                for ( int i = 0; i < numMines; i++ )
                {
                        pPdu->fObjOrientedLoc[i].fLocation     = fpDisTrans->DisEntLoc( pMine->GetMfLoc() );
                        pPdu->fObjOrientedLoc[i].fOrientation  = fpDisTrans->DisVehOrient( pMine->GetTccOrient() );
                        pPdu->fObjOrientedLoc[i].fBurialDepth  = pMine->GetDepth();
                        pPdu->fObjOrientedLoc[i].fId           = (pMine->GetEntityID()).entityNum;
                        pPdu->fObjOrientedLoc[i].padding       = 0;
                        pMine =  ((TLinkMine*)(pMineList->GetNextLink()))->GetMine();
                }
        }


	length += varLength;
	fpDisTrans->SetLength(length);
	fpDisTrans->FillHdr(gPduType.pdu[epduTypeMinefieldResponse], gPduType.family[epduFamilyEntityInteraction] );
  
	if ( gfPduData ) 
	{
      		fNumResponsePdus++;
      		if ( pPdu->fPacketNumber == 1 )
         		fNumResponseMsgs++;
      		fLengthResponseMsgs += pPdu->fHeader.length;
   	}
   	gpNetMgr->SendPdu(buf, pPdu->fHeader.length);
  
   	if (pPdu->fHeader.exercise_id == 50) pPdu->WriteMfResponsePdu();
}

void cQrpManager::GetVarRec(VARPTRS* varRec, short* pLength,TMinefieldRequestFilter filter,short numReqSens,
                                short numMines)
{

        varRec = new VARPTRS;
        *pLength = 0;
        //int sz;

        varRec->pReqSensType = new TEntityType[numReqSens];
        *pLength += sizeof(TEntityType) * numReqSens;

        varRec->pPadding_1 = new char[2*(numReqSens%2)];
        bzero(varRec->pPadding_1,2*(numReqSens%2));
        *pLength +=  2*(numReqSens%2);

/* this is a temp thing */

	//        if( gCmsMgr.fStartupParam.feProtocol == /*EProtocol:: */eDis203 ){

        varRec->pMineLoc = new DIS203_ENTITY_COORDINATE_VECTOR_RECORD[numMines];
        *pLength += numMines*sizeof(TEntCoord);
	/*	}

	else{ 

        varRec->pMineLoc_204 = new DIS203_ENTITY_COORDINATE_VECTOR_RECORD[numMines]; 
        *pLength += numMines*sizeof(TEntCoord); 
	}*/


        varRec->pGroundDepth = new float[(filter.GroundBurialDepth || filter.WaterBurialDepth || filter.SnowBurialDepth) * numMines];
        *pLength += (filter.GroundBurialDepth || filter.WaterBurialDepth || filter.SnowBurialDepth) * numMines * sizeof(float);

        varRec->pWaterDepth = new float[filter.WaterBurialDepth * numMines];
        *pLength += filter.WaterBurialDepth * numMines * sizeof(float);

        varRec->pSnowDepth = new float[filter.SnowBurialDepth * numMines];
        *pLength += filter.SnowBurialDepth * numMines * sizeof(float);

        // these are really both the same size, I just make the switch because it 
	// is a more complicated statement than the "sizeof" ones that I left alone

//   if( gCmsMgr.fStartupParam.feProtocol == /*EProtocol:: */eDis203 )
           varRec->pMineOrient = new DIS203_EULER_ANGLES_RECORD[(filter.MineOrientation || 
                                     filter.GroundBurialDepth || filter.WaterBurialDepth ||
                                     filter.SnowBurialDepth) * numMines];
        
	/* takeout? */
/*        else
           varRec->pMineOrient_204 = new DIS203_EULER_ANGLES_RECORD[(filter.MineOrientation
                                     || filter.GroundBurialDepth || filter.WaterBurialDepth
                                     || filter.SnowBurialDepth) * numMines];*/


        *pLength += (filter.MineOrientation || filter.GroundBurialDepth || 
                     filter.WaterBurialDepth || filter.SnowBurialDepth) * 
                     numMines * sizeof(DIS203_EULER_ANGLES_RECORD);
	             // at this time, Dis 203 and 204 Euler Angles records are the same
	             // so we don't need to make the if/else dis version switch here. 
	

        varRec->pThermalContrast = new float[filter.ThermalContrast * numMines];
        *pLength += filter.ThermalContrast * numMines * sizeof(float);

        varRec->pDielectricConstant = new float[filter.DielectricConstant * numMines];
        *pLength += filter.DielectricConstant * numMines * sizeof(float);

        varRec->pMineEmplacementAge = new double[filter.MineEmplacementAge * numMines];
        *pLength += filter.MineEmplacementAge * numMines * sizeof(double);

        varRec->pMineEntityId = new TEntityID[numMines];
        *pLength += numMines * sizeof(TEntityID);

        varRec->pFusing = new short[filter.Fusing * numMines];
        *pLength += filter.Fusing * numMines * sizeof(short);

        varRec->pScalerDetCoeff = new uint8[filter.ScalerDetCoeff * numMines * numReqSens];
        *pLength += filter.ScalerDetCoeff * numMines * numReqSens;

        varRec->pPaintScheme = new unsigned char[filter.PaintScheme * numMines];
        *pLength += filter.PaintScheme * numMines * sizeof(unsigned char);

        varRec->pPadding_2 = new char[(4-numMines*(2*filter.Fusing + numReqSens*filter.ScalerDetCoeff + filter.PaintScheme + 2)) % 4];
        bzero(varRec->pPadding_2,(4-numMines*(2*filter.Fusing + numReqSens*filter.ScalerDetCoeff + filter.PaintScheme + 2)) % 4);
        *pLength += (4-numMines*(2*filter.Fusing + numReqSens*filter.ScalerDetCoeff + filter.PaintScheme + 2)) % 4;

        varRec->pNumTripWires = new char[filter.TripDetWireLoc * numMines];
        *pLength += filter.TripDetWireLoc * numMines;

        varRec->pPadding_3 = new char[filter.TripDetWireLoc * ((4-numMines)%4)];
        bzero(varRec->pPadding_3,filter.TripDetWireLoc * ((4-numMines)%4));
        *pLength += filter.TripDetWireLoc * ((4-numMines)%4);


//        return varRec;  mental error?
}


void cQrpManager::SendMineResponse3(cMinefield* pMf, T2linkHead* pMineList,
                     TEntityID reqId, int reqNum, TEntityType& type, int numMines,
                     int msgNum, int msgsTot, void* buf,short numReqSens, TEntityType* pReqSensEntType)
{
	cMine* pMine;
        cpduMinefieldResponse_REV* pPdu = (cpduMinefieldResponse_REV*)buf;
        int length = pPdu->GetStructSize();

	TMinefieldRequestFilter filter = *((TMinefieldRequestFilter*) (&(pPdu->fFilter)));

	VARPTRS* pVarRec=NULL;

//	int varLength;
	short varLength;
	GetVarRec(pVarRec, &varLength, filter, numReqSens,numMines);

	  cout<<"sending minefield response PDU for "<<numMines<<" mines"<<endl;
	//  cout<<" sizes, tot, basic, each mine rec "<< fLength <<" "<< pPdu->GetStructSize() <<" "<< sizeof(TFixedObjectOrientedLoc);
	  //	if( gCmsMgr.fStartupParam.feProtocol == /*EProtocol:: */eDis203 ){
           pPdu->fMinefieldId        = fpDisTrans->DisEntID(pMf->GetEntityID());
   	   pPdu->fRequesterId        = fpDisTrans->DisEntID(reqId);
   	   pPdu->fObjType            = fpDisTrans->DisEntType(type);
	   /*	}
	else{
   	   pPdu->fMinefieldId        = fpDisTrans->DisEntID204(pMf->GetEntityID());  
   	   pPdu->fRequesterId        = fpDisTrans->DisEntID204(reqId); 
   	   pPdu->fObjType            = fpDisTrans->DisEntType204(type);  
	}*/

   	pPdu->fRequestId          = reqNum;
   	pPdu->fPacketNumber       = msgNum;
   	pPdu->fTotalPackets       = msgsTot;
   	pPdu->fNumberOfObjects    = numMines;
   	pPdu->fObjType            = fpDisTrans->DisEntType(type);
	pPdu->fMfSeqNum           = pMf->GetCurSeq().u;
	pPdu->fNumReqSensors      = numReqSens;

	
	for(int j=0; j<numReqSens; j++) {
	        pVarRec->pReqSensType[j]     = pReqSensEntType[j];
	}


        if ( pMineList )
        {
                pMine = ((TLinkMine*)(pMineList->GetFirstLink()))->GetMine();
                for ( int i = 0; i < numMines; i++ )
                {
 /*                
                  pPdu->fObjOrientedLoc[i].fLocation     = fpDisTrans->DisEntLoc( 
                                                           pMine->GetMfLoc() );
                  pPdu->fObjOrientedLoc[i].fOrientation  = fpDisTrans->DisVehOrient( 
                                                           pMine->GetTccOrient() );
                  pPdu->fObjOrientedLoc[i].fBurialDepth  = pMine->GetDepth();
                  pPdu->fObjOrientedLoc[i].fId           = (pMine->GetEntityID()).entityNum;
                  pPdu->fObjOrientedLoc[i].padding       = 0;
*/
		  //	  if( gCmsMgr.fStartupParam.feProtocol == /*EProtocol:: */eDis203 )
                     pVarRec->pMineLoc[i] = fpDisTrans->DisEntLoc(pMine->GetGeoLoc() - 
                                             pMf->GetGeoLoc());

		     /*	  else
		     pVarRec->pMineLoc[i] = fpDisTrans->DisEntLoc204(
                                                  pMine->GetGeoLoc()  - pMf->GetGeoLoc());*/

                        /////////////////////
                        // new stuff
                   if(filter.GroundBurialDepth || filter.WaterBurialDepth || 
                      filter.SnowBurialDepth)

		      pVarRec->pGroundDepth[i] = pMine->GetDepth();
			
		   if(filter.WaterBurialDepth)
		      pVarRec->pWaterDepth[i] = ((cSimMine*)pMine)->GetWaterDepth();

		   if(filter.SnowBurialDepth)
                      pVarRec->pSnowDepth[i] = ((cSimMine*)pMine)->GetSnowDepth();
			
		   if(filter.MineOrientation || filter.GroundBurialDepth || 
                      filter.WaterBurialDepth || filter.SnowBurialDepth)

		      pVarRec->pMineOrient[i] = fpDisTrans->DisVehOrient( 
                                                pMine->GetTccOrient() );

		   if(filter.ThermalContrast)		
		      pVarRec->pThermalContrast[i] = ((cSimMine*)pMine)->
                                                     GetThermalContrast();

		   if(filter.DielectricConstant)
		      pVarRec->pDielectricConstant[i] = ((cSimMine*)pMine)->
                                                        GetDielectricContrast();	   

		   if(filter.MineEmplacementAge)
		      pVarRec->pMineEmplacementAge[i] = ((cSimMine*)pMine)->GetMineAge();
		
		   pVarRec->pMineEntityId[i] = (pMine->GetEntityID()).entityNum;

                   if(filter.Fusing);
		      pVarRec->pFusing[i] = fpDisTrans->DisFusing(pMine);

                   /*if(filter.ScalerDetCoeff)
		      pVarRec->pScalerDetCoeff[i](pMine->GetEntityID()).entityNum; */
		
		   if(filter.TripDetWireLoc)
		      {
		      // No trip wires in Cms, Enter 0 here.
		         pVarRec->pNumTripWires[i] = 0x00;
		      }

		   if(filter.ScalerDetCoeff)
		      {
		       	 for (j=0; i<numReqSens; j++)
			    pVarRec->pScalerDetCoeff[i+j] = 255*((uint8)((cSimMine*)pMine)->
						   GetScalerDetCoeff(pReqSensEntType[j])); 
		      }

		   if(filter.PaintScheme)
		      {
			 pVarRec->pPaintScheme[i] = ((cSimMine*)pMine)->GetPaintScheme();
		      }


                   pMine =  ((TLinkMine*)(pMineList->GetNextLink()))->GetMine();
                }
        }

        // for new pdus, need to add the following:
        //      Minefield Sequence Number
        //      Number of Trip/Detonation Wires
        //      Number of Vertices
        //      Vertex

//	length += varLength;
	length += (int) varLength;
  	fpDisTrans->SetLength(length);
   	fpDisTrans->FillHdr(gPduType.pdu[epduTypeMinefieldResponse], gPduType.family[epduFamilyEntityInteraction] );
  
   	if ( gfPduData ) 
	{
      		fNumResponsePdus++;
      		if ( pPdu->fPacketNumber == 1 )
         		fNumResponseMsgs++;
      		fLengthResponseMsgs += pPdu->fHeader.length;
   	}
   	gpNetMgr->SendPdu(buf, pPdu->fHeader.length);
  
   	if (pPdu->fHeader.exercise_id == 50) pPdu->WriteMfResponsePdu(pVarRec);
}


void    cQrpManager::SendMineResponse(cMinefield* pMf, T2linkHead* pMineList, 
                     TEntityID reqId, int reqNum, TEntityType& type, int numMines, 
                     int msgNum, int msgsTot, void* buf, short numReqSens, TEntityType* pReqSensType)
{
	if(fcp==eQrp1)
		SendMineResponse1(pMf,pMineList,reqId,reqNum,type,numMines,msgNum,msgsTot,buf);
	else // if(fcp==cQrp3)
		SendMineResponse3(pMf,pMineList,reqId,reqNum,type,numMines,msgNum,msgsTot,buf, numReqSens,pReqSensType);
}

//This appears not to be used, so I commented it out.  Caused compile error
/*
void    cQrpManager_REV::SendMineResponse(cMinefield* pMf, T2linkHead* pMineList,
                     TEntityID reqId, int reqNum, TEntityType& type, int numMines,
                     int msgNum, int msgsTot, void* buf)
{
   cMine* pMine;
 
   cpduMinefieldResponse_REV* pPdu = (cpduMinefieldResponse_REV*)buf;

   // compute variable size part of pdu
   int varLength =	(numMines*sizeof(TFixedObjectOrientedLoc) +
   int length = pPdu->GetStructSize() + numMines * sizeof(TFixedObjectOrientedLoc);
	

//  cout<<"sending minefield response PDU for "<<numMines<<" mines"<<endl;
//  cout<<" sizes, tot, basic, each mine rec "<< fLength <<" "<< pPdu->GetStructSize() <<" "<< sizeof(TFixedObjectOrientedLoc);

   pPdu->fMinefieldId        = fpDisTrans->DisEntID(pMf->GetEntityID());
   pPdu->fRequesterId        = fpDisTrans->DisEntID(reqId);
   pPdu->fRequestId          = reqNum;
   pPdu->fPacketNumber       = msgNum;
   pPdu->fTotalPackets       = msgsTot;
   pPdu->fNumberOfObjects    = numMines;
   pPdu->fObjType            = fpDisTrans->DisEntType(type);

   if ( pMineList ) {
      pMine = ((TLinkMine*)(pMineList->GetFirstLink()))->GetMine();
      for ( int i = 0; i < numMines; i++ ) {
         pPdu->fObjOrientedLoc[i].fLocation     = fpDisTrans->DisEntLoc( pMine->GetMfLoc() );
         pPdu->fObjOrientedLoc[i].fOrientation  = fpDisTrans->DisVehOrient( pMine->GetTccOrient() );
         pPdu->fObjOrientedLoc[i].fBurialDepth  = pMine->GetDepth();
         pPdu->fObjOrientedLoc[i].fId           = (pMine->GetEntityID()).entityNum;
         pPdu->fObjOrientedLoc[i].padding       = 0;
         pMine =  ((TLinkMine*)(pMineList->GetNextLink()))->GetMine();
      }
   }

   fpDisTrans->SetLength(length);
   fpDisTrans->FillHdr(gPduType.pdu[epduTypeMinefieldResponse]);
  
   if ( gfPduData ) {
      fNumResponsePdus++;
      if ( pPdu->fPacketNumber == 1 )
         fNumResponseMsgs++;
      fLengthResponseMsgs += pPdu->fHeader.length;
   }
   gpNetMgr->SendPdu(buf, pPdu->fHeader.length);
  
   if (pPdu->fHeader.exercise_id == 50) pPdu->WriteMfResponsePdu();
}
*/

void     cQrpManager::QrpShutdown()
{
   if ( gfPduData ) {
      *gpPduData << "QRP shutdown"
                 << endl;
                 
      float avg = (fNumMfMsgs == 0) ? 0.0 : ( fLengthMfMsgs / fNumMfMsgs);
      *gpPduData << "Total minefield state msgs: "
                 << fNumMfMsgs
                 << " total length: "
                 << fLengthMfMsgs
                 << " avg length: "
                 << avg
                 << endl;
                 
      avg = (fNumResponsePdus == 0) ? 0.0 : ( fLengthResponseMsgs / fNumResponsePdus);
      *gpPduData << "Total response msgs: "
                 << fNumResponseMsgs
                 << " num PDUs: "
                 << fNumResponsePdus
                 << " total length: "
                 << fLengthResponseMsgs
                 << " avg pdu length: "
                 << avg
                 << endl;
   }
}

/*void     cQrpManager::QrpShutdown()
{
   if ( gfPduData ) {
      *gpPduData << "QRP shutdown"
                 << endl;

      float avg = (fNumMfMsgs == 0) ? 0.0 : ( fLengthMfMsgs / fNumMfMsgs);
      *gpPduData << "Total minefield msgs: "
                 << fNumMfMsgs
                 << " total length: "
                 << fLengthMfMsgs
                 << " avg length: "
                 << avg
                 << endl;

      avg = (fNumResponsePdus == 0) ? 0.0 : ( fLengthResponseMsgs / fNumResponsePdus);
      *gpPduData << "Total response msgs: "
                 << fNumResponseMsgs
                 << " num PDUs: "
                 << fNumResponsePdus
                 << " total length: "
                 << fLengthResponseMsgs
                 << " avg pdu length: "
                 << avg
                 << endl;
   }
}
*/
