/*
$RCSfile: CmsPdu.h,v $
$Revision: 1.1.1.1 $
$Author: jchappel $
$Date: 1999/02/16 14:54:47 $
$Log: CmsPdu.h,v $
Revision 1.1.1.1  1999/02/16 14:54:47  jchappel
Comprehensive Mine Simulator

 * Revision 2.1  1998/02/18  17:17:24  ksnively
 * Incorporated AP mine replacement code
 *
 * Revision 2.0  1998/01/26  21:04:20  ksnively
 * Baseline CMS before additions for AP mine replacements.
 *
 * Revision 1.1  1997/12/16  13:59:57  ksnively
 * Initial revision
 *
 * Revision 1.3  1997/10/27  17:07:30  trang
 * BUILD1
 *
 * Revision 1.2  1997/10/02  17:47:47  austin
 * first working port to modsaf3.0
 *
Revision 1.2  1997/10/02 17:47:47  austin
first working port to modsaf3.0

 * Revision 1.1  1996/10/23  13:54:40  nsipes
 * Initial revision
 *
 * Revision 1.1  1996/10/23  13:54:40  nsipes
 * Initial revision
 *
 * Revision 1.2  1996/06/21  17:04:20  rcarp
 * upgrades for release 1.5b3, mostly mine vuln
 *
 * Revision 1.1  1996/01/23  16:48:05  rcarp
 * Initial revision
 *
 * Revision 1.1  1996/01/23  16:48:05  rcarp
 * Initial revision
 *
$State: Exp $
*/
 
/*******************************************

   file: CmsPdu.h
   
      Copyright 1995 by the Institute for Defense Analyses
      
         Institute for Defense Analyses
         1801 N. Beauregard Street
         Alexandria, Virginia 22311-1772
         703-845-2000
         
      This software was developed by IDA under U. S. Government
      contract.  For distribution information contact:
      
         U. S. Army Night Vision Directorate
         AMSEL RD NV OD CD
         10221 Burbeck Road, suite 430
         Ft. Belvoir VA 22060-5806
      
*********************************************/

/*******************************************

   CmsPdu.h
   
      The header file defining the cCmsTranslator class, 
      which interfaces the CMS gui and host, and other
      cms protocol definitions
         
   Created by Richard Carpenter
   Modification history:
      created   
      
*********************************************/

#ifndef _UCmsPdu_
#define _UCmsPdu_

#include "Globals.h"
#include "NetMgr.h"
#include "Vehicle.h"



   // Special special entity types
extern const TEntityType   kEntTypeORSMC;
extern const TEntityType   kEntTypeESMB;
extern const TEntityType   kEntTypeMICLIC;

enum    {   k204AppearanceDeactivated = 0x800000 };

class cCmsTranslator : public cPduTranslator {

public:
   virtual   void            ReceivePdu(void * buf, TTimeSim timeDelta = 0);
   
};

struct TDetonationData {
   TEntityID      fFiringEnt;
   TEntityID      fTargetEnt;
   TEntityID      fMunitionEnt;
   TEntityID      fEventId;
   TVelocity      fVelocity;
   TLocation      fFireTccLocation;
   TLocation      fDetLocation;
   TEntityType    fDetonationType;
   EWarhead       fWarhead;
   EFuze          fFuze;
   TEntCoord      fLocTargetRef;
   EDetonResult   feDetResult;
   TVehPart       fTgtPart;
//   float          fFireRange;
//   TEntityID      fProjID;
//   TVelocity      fGeoLaunchVel;
   
   TDetonationData();
   TDetonationData( cSimMine* pMine );
};

      // used to pass firing data from mine or projectile
      // to the protocol translator
struct TFireData {
   TEntityID      fFiringEnt;
   TEntityID      fTargetEnt;
   TEntityID      fMunitionEnt;   // projectile ID
   TEntityID      fEventId;
   TVelocity      fGeoLaunchVel;
   TLocation      fLocation;
   TLocation      fFireTccLocation;
   TEntityType    fDetonationType;
   EWarhead       fWarhead;
   EFuze          fFuze;
   float          fFireRange;
//   TEntityID      fProjID;
//   TVelocity      fGeoLaunchVel;
   
   TFireData();
   TFireData( cSimMine* pMine );
};

#endif
