/*
$RCSfile: CompStatusCreate.cc,v $
$Revision: 1.2 $
$Author: ksnively $
$Date: 1999/05/10 20:18:22 $
$Log: CompStatusCreate.cc,v $
Revision 1.2  1999/05/10 20:18:22  ksnively
Added a command line option for enabling Communication Capability.

Revision 1.1.1.1  1999/02/16 14:54:29  jchappel
Comprehensive Mine Simulator

// Revision 2.1  1998/02/18  17:16:10  ksnively
// Incorporated AP mine replacement code.
//
// Revision 2.0  1998/01/26  21:01:35  ksnively
// Baseline CMS before additions for AP mine replacements.
//
// Revision 1.2  1997/12/17  18:41:50  ksnively
// eliminated warning messages during compilation.
//
// Revision 1.1  1997/12/16  13:59:57  ksnively
// Initial revision
//
// Revision 1.3  1997/10/02  17:53:37  austin
// first working port to modsaf3.0
//
// Revision 1.2  1997/10/02  17:50:22  austin
// first working port to modsaf3.0
//
// Revision 1.2  1997/10/02  17:50:22  austin
// first working port to modsaf3.0
//
// Revision 1.1  1996/10/23  13:54:40  nsipes
// Initial revision
//
// Revision 1.1  1996/10/23  13:54:40  nsipes
// Initial revision
//
// Revision 1.5  1996/07/03  22:55:15  rcarp
// enhancements and bug fixes for version 1.5b9
//
// Revision 1.4  1996/05/14  16:15:08  rcarp
// refinements and bug fixes for 1.5 delivery
//
// Revision 1.3  1996/03/13  01:09:55  mkappel
// Move CompStatus button.
//
// Revision 1.3  1996/03/13  01:09:55  mkappel
// Move CompStatus button.
//
// Revision 1.2  1996/03/06  19:45:05  mkappel
// New Mine Status Window
//
// Revision 1.1  1996/01/23  16:52:30  rcarp
// Initial revision
//
$State: Exp $
*/
 
/*******************************************

   file: CompStatusCreate.cc
   
      Copyright 1995 by the Institute for Defense Analyses
      
         Institute for Defense Analyses
         1801 N. Beauregard Street
         Alexandria, Virginia 22311-1772
         703-845-2000
         
      This software was developed by IDA under U. S. Government
      contract.  For distribution information contact:
      
         U. S. Army Night Vision Directorate
         AMSEL RD NV OD CD
         10221 Burbeck Road, suite 430
         Ft. Belvoir VA 22060-5806
      
*********************************************/

/*******************************************

   CompStatusCreate.cc
   
      The display interface implementation.
      
      
   
   Created by Michael Kappel
   Modification history:
      created   
      
*********************************************/

#include "Display.h"
#include <Xm/ArrowBG.h>
#include <Xm/CascadeBG.h>
#include <Xm/Form.h>
#include <Xm/Frame.h>
#include <Xm/Label.h>
#include <Xm/LabelG.h>
#include <Xm/List.h>
#include <Xm/MainW.h>
#include <Xm/MenuShell.h>
#include <Xm/PanedW.h>
#include <Xm/PushB.h>
#include <Xm/PushBG.h>
#include <Xm/RowColumn.h>
#include <Xm/ScrollBar.h>
#include <Xm/ScrolledW.h>
#include <Xm/Text.h>
#include <Xm/TextF.h>
#include <Xm/ToggleB.h>
#include <stdio.h>

Widget  cComponentStatusWindow::fwCompScrollArea;
Widget  cComponentStatusWindow::fwCompScrollBar;
Widget  cComponentStatusWindow::fwDoneButton;
Widget  cComponentStatusWindow::fwStatusButton;
cMinefield*   cComponentStatusWindow::fpMinefield = NULL;

cCompStatusLine::cCompStatusLine (cMfComponent* pComp, Widget wParent)
{
   XmString   xmsText;
   Dimension  height;
   
   fpComp = pComp;
   
   fwMainWin = 
     XtVaCreateWidget ("compSumm", 
		       xmFormWidgetClass, wParent, 
		       XmNfractionBase, 80,
		       XmNleftAttachment, XmATTACH_POSITION,
		       XmNleftPosition, 20,
		       XmNrightAttachment, XmATTACH_POSITION,
		       XmNrightPosition, 100,
		       XmNalignment, XmALIGNMENT_BEGINNING,
		       NULL);

   if (pComp->GetPrevComp() && pComp->GetPrevComp()->GetCompStatus())
     XtVaSetValues (fwMainWin,
		    XmNtopAttachment, XmATTACH_WIDGET,
		    XmNtopWidget, pComp->GetPrevComp()->GetCompStatus()->GetMainWin(),
		    NULL);
   else
     XtVaSetValues (fwMainWin,
		    XmNtopAttachment, XmATTACH_FORM,
 		    NULL);

   if (pComp->GetNext())
     XtVaSetValues (pComp->GetNext()->GetCompStatus()->GetMainWin(),
		    XmNtopAttachment, XmATTACH_WIDGET,
		    XmNtopWidget, fwMainWin,
		    NULL);

   switch (pComp->GetCompType()) {
      case eCompIndiv:
            xmsText = XmStringCreate("individual", XmFONTLIST_DEFAULT_TAG);
         break;

      case eCompGrid:
            xmsText = XmStringCreate("grid", XmFONTLIST_DEFAULT_TAG);
         break;

      case eCompRow:
            xmsText = XmStringCreate("row", XmFONTLIST_DEFAULT_TAG);
         break;
   }
   fwTypeText = 
     XtVaCreateManagedWidget ("compTypeName", 
			      xmPushButtonWidgetClass, fwMainWin, 
			      XmNlabelString, xmsText,
			      XmNshadowThickness, 0,
			      XmNborderWidth, 0,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 1,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 10,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      NULL);
   XmStringFree(xmsText);
   XtAddCallback( fwTypeText, XmNactivateCallback, 
       (XtCallbackProc)CbSelect, (XtPointer)this);
   
   fwSimToggle =
     XtVaCreateManagedWidget ("",
			      xmToggleButtonWidgetClass, fwMainWin,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 11,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 14,
			      XmNset, TRUE,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      NULL);
   XtAddCallback( fwSimToggle, XmNvalueChangedCallback, 
       (XtCallbackProc)CbSimToggle, (XtPointer)this);

   fwOnToggle =
     XtVaCreateManagedWidget ("",
			      xmToggleButtonWidgetClass, fwMainWin,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 15,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 18,
			      XmNset, TRUE,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      NULL);
   XtAddCallback( fwOnToggle, XmNvalueChangedCallback, 
       (XtCallbackProc)CbOnToggle, (XtPointer)this);

      // minefield values
   xmsText = XmStringCreateSimple("0");
   fwTotalMines = 
     XtVaCreateManagedWidget ("totMines", 
			      xmLabelWidgetClass, fwMainWin, 
			      XmNlabelString, xmsText,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 20,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 25,
			      XmNalignment, XmALIGNMENT_END,
			      NULL);
   XmStringFree(xmsText);
   
   xmsText = XmStringCreateSimple("0");
   fwLiveMines = 
     XtVaCreateManagedWidget ("liveMines", 
			      xmLabelWidgetClass, fwMainWin, 
			      XmNlabelString, xmsText,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 26,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 31,
			      XmNalignment, XmALIGNMENT_END,
			      NULL);
   XmStringFree(xmsText);
   
   xmsText = XmStringCreateSimple("0");
   fwFiredMines = 
     XtVaCreateManagedWidget ("firedMines", 
			      xmLabelWidgetClass, fwMainWin, 
			      XmNlabelString, xmsText,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 32,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 37,
			      XmNalignment, XmALIGNMENT_END,
			      NULL);
   XmStringFree(xmsText);
   
   xmsText = XmStringCreateSimple("0");
   fwOtherMines = 
     XtVaCreateManagedWidget ("otherMines", 
			      xmLabelWidgetClass, fwMainWin, 
			      XmNlabelString, xmsText,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 38,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 43,
			      XmNalignment, XmALIGNMENT_END,	
			      NULL);
   XmStringFree(xmsText);
   
   xmsText = XmStringCreateSimple("0");
   fwVehHits =
     XtVaCreateManagedWidget ("vehHit", 
			      xmLabelWidgetClass, fwMainWin, 
			      XmNlabelString, xmsText,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 45,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 50,
			      XmNalignment, XmALIGNMENT_END,
			      NULL);
   XmStringFree(xmsText);
   
   xmsText = XmStringCreateSimple("0");
   fwVehKills =
     XtVaCreateManagedWidget ("vehKilled", 
			      xmLabelWidgetClass, fwMainWin, 
			      XmNlabelString, xmsText,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 51,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 56,
			      XmNalignment, XmALIGNMENT_END,
			      NULL);
   XmStringFree(xmsText);

   xmsText = XmStringCreateSimple("AP");
   fwDomain = 
     XtVaCreateManagedWidget ("label", 
			      xmLabelWidgetClass, fwMainWin, 
			      XmNlabelString, xmsText,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 58,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 63,
			      XmNalignment, XmALIGNMENT_CENTER,
			      NULL);
   XmStringFree(xmsText);
   
   xmsText = XmStringCreateSimple("US M75");
   fwMineType = 
     XtVaCreateManagedWidget ("label", 
			      xmLabelWidgetClass, fwMainWin, 
			      XmNlabelString, xmsText,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 64,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 80,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      NULL);
   XmStringFree(xmsText);

   XtVaGetValues (fwTypeText,
		  XmNheight, &height,
		  NULL);
   XtVaSetValues (fwMainWin,
		  XmNheight, height,
		  NULL);

   XtManageChild(fwMainWin);
}

cCompStatusLine::~cCompStatusLine ()
{
  if (fpComp->GetNext()) {
    if ( ( fpComp->GetPrevComp() ) &&
         ( fpComp->GetPrevComp()->GetCompStatus() ) ) // perimeter does not have a Status line
      XtVaSetValues (fpComp->GetNext()->GetCompStatus()->GetMainWin(),
		     XmNtopAttachment, XmATTACH_WIDGET,
		     XmNtopWidget, fpComp->GetPrevComp()->GetCompStatus()->GetMainWin(),
		     NULL);
    else
      XtVaSetValues (fpComp->GetNext()->GetCompStatus()->GetMainWin(),
		     XmNtopAttachment, XmATTACH_FORM,
		     NULL);
  }

  XtDestroyWidget (fwMainWin);
}

Widget        cComponentStatusWindow::CreateHeadings (Widget wParent)
{
   Widget     wHeadings, wLabel1, wLabel2;
   XmString   xmsText;
   Dimension  height, h;
   
   wHeadings = 
     XtVaCreateWidget ("headings", 
		       xmFormWidgetClass, wParent,
		       XmNfractionBase, 100,
		       NULL);

   xmsText = XmStringCreateSimple("- Control -");
   wLabel1 = 
     XtVaCreateManagedWidget ("simButtonHd", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNalignment, XmALIGNMENT_CENTER,
			      XmNtopAttachment, XmATTACH_FORM,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 31,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 38,
			      NULL);
   XmStringFree(xmsText);

   xmsText = XmStringCreateSimple("Sim");
   wLabel2 = 
     XtVaCreateManagedWidget ("simButtonHd", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, wLabel1,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 31,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 34,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      NULL);
   XmStringFree(xmsText);

   xmsText = XmStringCreateSimple("On");
   wLabel2 = 
     XtVaCreateManagedWidget ("simButtonHd", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, wLabel1,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 35,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 38,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      NULL);
   XmStringFree(xmsText);

   xmsText = XmStringCreateSimple("Component");
   wLabel2 = 
     XtVaCreateManagedWidget ("label", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, wLabel1,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 21,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 30,
			      NULL);
   XmStringFree(xmsText);

   fwStatusButton = 
     XtVaCreateManagedWidget ("Status", 
			      xmPushButtonWidgetClass, wHeadings,
			      XmNbottomAttachment, XmATTACH_FORM,
//			      XmNleftAttachment, XmATTACH_FORM,
			      XmNrightAttachment, XmATTACH_WIDGET,
			      XmNrightWidget, wLabel2,
			      XmNrightOffset, 10,
//			      XmNheight, 20,
			      NULL);
   XtAddCallback( fwStatusButton, XmNactivateCallback, 
		 (XtCallbackProc)CbStatus, (XtPointer) this);

      // mines
   xmsText = XmStringCreateSimple("----------- Mines ------------");
   wLabel1 = 
     XtVaCreateManagedWidget ("totMinesHd", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNalignment, XmALIGNMENT_CENTER,
			      XmNtopAttachment, XmATTACH_FORM,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 40,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 63,
			      NULL);
   XmStringFree(xmsText);
   
   xmsText = XmStringCreateSimple("Total");
   wLabel2 = 
     XtVaCreateManagedWidget ("totMinesHd", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNalignment, XmALIGNMENT_END,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, wLabel1,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 40,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 45,
			      NULL);
   XmStringFree(xmsText);
   
   xmsText = XmStringCreateSimple("Live");
   wLabel2 = 
     XtVaCreateManagedWidget ("totMinesHd", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNalignment, XmALIGNMENT_END,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, wLabel1,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 46,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 51,
			      NULL);
   XmStringFree(xmsText);
   
   xmsText = XmStringCreateSimple("Fired");
   wLabel2 = 
     XtVaCreateManagedWidget ("totMinesHd", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNalignment, XmALIGNMENT_END,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, wLabel1,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 52,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 57,
			      NULL);
   XmStringFree(xmsText);
   
   xmsText = XmStringCreateSimple("Other");
   wLabel2 = 
     XtVaCreateManagedWidget ("totMinesHd", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNalignment, XmALIGNMENT_END,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, wLabel1,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 58,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 63,
			      NULL);
   XmStringFree(xmsText);
   
      // vehicles
   xmsText = XmStringCreateSimple("--- Vehicles ---");
   wLabel1 = 
     XtVaCreateManagedWidget ("vehHitHd", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNalignment, XmALIGNMENT_CENTER,
			      XmNtopAttachment, XmATTACH_FORM,
			      XmNleftPosition, 65,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 76,
			      NULL);
   XmStringFree(xmsText);
   
   xmsText = XmStringCreateSimple("Hit");
   wLabel2 = 
     XtVaCreateManagedWidget ("vehHitHd", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNalignment, XmALIGNMENT_END,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, wLabel1,
			      XmNleftPosition, 65,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 70,
			      NULL);
   XmStringFree(xmsText);
   
   xmsText = XmStringCreateSimple("Killed");
   wLabel2 = 
     XtVaCreateManagedWidget ("vehHitHd", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNalignment, XmALIGNMENT_END,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, wLabel1,
			      XmNleftPosition, 71,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 76,
			      NULL);
   XmStringFree(xmsText);

   xmsText = XmStringCreateSimple("Domain");
   wLabel2 = 
     XtVaCreateManagedWidget ("label", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, wLabel1,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 78,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 83,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      NULL);
   XmStringFree(xmsText);

   xmsText = XmStringCreateSimple("Type");
   wLabel2 = 
     XtVaCreateManagedWidget ("label", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmsText,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, wLabel1,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 84,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 100,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      NULL);
   XmStringFree(xmsText);

   XtVaGetValues (wHeadings, XmNmarginHeight, &h, NULL);
   XtVaGetValues (wLabel1, XmNheight, &height, NULL);
   height = 2 * height + 3 * h ;
   XtVaSetValues (wHeadings,
		  XmNpaneMinimum, height,
		  XmNpaneMaximum, height,
		  NULL);

   XtManageChild (wHeadings);
   return wHeadings;
}

Widget    cComponentStatusWindow::CreateSummaryArea (Widget wParent)
{
   int           width = WidthOfScreen(XtScreen(fwTopLevelShell)) - 100;

   fwCompScrollArea = 
     XtVaCreateManagedWidget ("scrollwin", 
			      xmScrolledWindowWidgetClass, wParent,
			      XmNscrollingPolicy, XmAPPLICATION_DEFINED,
			      XmNwidth, width,
			      XmNheight, 200,
			      NULL);

   fwCompScrollBar = 
     XtVaCreateManagedWidget ("scrollbar",
			      xmScrollBarWidgetClass, fwCompScrollArea,
			      XmNorientation, XmVERTICAL,
			      XmNmaximum, 2,
			      NULL);

   return fwCompScrollArea;
}

cCompStatusArea*    cComponentStatusWindow::CreateCompStatusArea ()
{
   cCompStatusArea* pCompArea = new cCompStatusArea (fwCompScrollArea);
   Widget           wMainWin = pCompArea->GetMainWin();

   XmScrolledWindowSetAreas (fwCompScrollArea, NULL, 
			     fwCompScrollBar, wMainWin);
   XtAddCallback (fwCompScrollBar, XmNvalueChangedCallback, 
		  (XtCallbackProc)CbScroll, wMainWin);

   return pCompArea;
}

cCompStatusArea::cCompStatusArea (Widget wParent)
{
   Widget        wLabel;   
   int           width = WidthOfScreen(XtScreen(fwTopLevelShell)) - 100;
   //Arg           args[2];

   fwMainWin = 
     XtVaCreateWidget ("form", 
		       xmFormWidgetClass, wParent, 
		       XmNwidth, width,
		       XmNheight, 200,
		       NULL);

   wLabel = 
     XtVaCreateManagedWidget ("Minefield Name", 
			      xmLabelGadgetClass, fwMainWin,
			      XmNtopAttachment, XmATTACH_FORM,
			      XmNleftAttachment, XmATTACH_FORM,
			      NULL);
   fwMinefieldName = 
     XtVaCreateManagedWidget ("textbox", 
			      xmTextFieldWidgetClass, fwMainWin,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, wLabel,
			      XmNleftAttachment, XmATTACH_FORM,
			      XmNcolumns, 20,
			      XmNeditable, FALSE,
			      NULL);

   wLabel = 
     XtVaCreateManagedWidget ("Type: ", 
			      xmLabelGadgetClass, fwMainWin,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, fwMinefieldName,
			      XmNtopOffset, 5,
			      XmNleftAttachment, XmATTACH_FORM,
			      NULL);
   fwTypeLabel = 
     XtVaCreateManagedWidget ("Type", 
			      xmLabelGadgetClass, fwMainWin,
			      XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET,
			      XmNtopWidget, wLabel,
			      XmNleftAttachment, XmATTACH_WIDGET,
			      XmNleftWidget, wLabel,
			      NULL);

   wLabel = 
     XtVaCreateManagedWidget ("Force: ", 
			      xmLabelGadgetClass, fwMainWin,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, wLabel,
			      XmNtopOffset, 5,
			      XmNleftAttachment, XmATTACH_FORM,
			      NULL);
   fwForceLabel = 
     XtVaCreateManagedWidget ("Force", 
			      xmLabelGadgetClass, fwMainWin,
			      XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET,
			      XmNtopWidget, wLabel,
			      XmNleftAttachment, XmATTACH_WIDGET,
			      XmNleftWidget, wLabel,
			      NULL);

   wLabel =  
     XtVaCreateManagedWidget ("State: ", 
			      xmLabelGadgetClass, fwMainWin,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, wLabel,
			      XmNtopOffset, 5,
			      XmNleftAttachment, XmATTACH_FORM,
			      NULL);
   fwStateLabel = 
     XtVaCreateManagedWidget ("State", 
			      xmLabelGadgetClass, fwMainWin,
			      XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET,
			      XmNtopWidget, wLabel,
			      XmNleftAttachment, XmATTACH_WIDGET,
			      XmNleftWidget, wLabel,
			      NULL);

//   XtManageChild( fwMainWin );
}

cCompStatusArea::~cCompStatusArea ()
{
}

Widget cComponentStatusWindow::CreateActionArea (Widget wParent)
{
   Widget     wActionArea, wButton;
   Dimension  height, h;

   wActionArea = 
     XtVaCreateWidget ("action_area", 
		       xmFormWidgetClass, wParent,
		       XmNfractionBase, 100,
		       XmNleftAttachment, XmATTACH_FORM,
		       XmNrightAttachment, XmATTACH_FORM,
		       XmNbottomAttachment, XmATTACH_FORM,
		       NULL);
   fwDoneButton = 
     XtVaCreateManagedWidget ("Done", 
			      xmPushButtonWidgetClass, wActionArea,
			      XmNtopAttachment, XmATTACH_FORM,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 25,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 40,
			      NULL);
   XtAddCallback( fwDoneButton, XmNactivateCallback, 
		 (XtCallbackProc)CbDone, (XtPointer) this);
   wButton = 
     XtVaCreateManagedWidget ("Cancel", 
			      xmPushButtonWidgetClass, wActionArea,
			      XmNtopAttachment, XmATTACH_FORM,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 60,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 75,
			      XmNsensitive, FALSE,
			      NULL);
   XtAddCallback( wButton, XmNactivateCallback, 
		 (XtCallbackProc)CbCancel, (XtPointer) this);

   XtVaGetValues (wActionArea, XmNmarginHeight, &h, NULL);
   XtVaGetValues (wButton, XmNheight, &height, NULL);
   height =  height + 2 * h ;
   XtVaSetValues (wActionArea,
		  XmNpaneMinimum, height,
		  XmNpaneMaximum, height,
		  NULL);

   XtManageChild( wActionArea );
   return wActionArea;
}

cComponentStatusWindow::cComponentStatusWindow (Widget wParent)
   // the constructor creates the window and its widgets,
   // initializing with input values
   //** should we take the menu bar out of the scrolled window?
{
   //   Widget        wHeadings, wSummary, wActionArea; 

   fwMainWin =
     XtVaCreateWidget ("pane",
             xmPanedWindowWidgetClass, wParent,
             XmNtopAttachment, XmATTACH_FORM,
             XmNbottomAttachment, XmATTACH_FORM,
             NULL);
             
   /*wHeadings = */ CreateHeadings (fwMainWin);
   /* wSummary = */ CreateSummaryArea (fwMainWin);
   /*wActionArea = */ CreateActionArea (fwMainWin);
}

cComponentStatusWindow::~cComponentStatusWindow()
{
}

