/*
$RCSfile: CoordEntry.h,v $
$Revision: 1.1.1.1 $
$Author: jchappel $
$Date: 1999/02/16 14:54:47 $
$Log: CoordEntry.h,v $
Revision 1.1.1.1  1999/02/16 14:54:47  jchappel
Comprehensive Mine Simulator

 * Revision 2.0  1998/01/26  21:04:20  ksnively
 * Baseline CMS before additions for AP mine replacements.
 *
 * Revision 2.0  1998/01/26  21:04:20  ksnively
 * Baseline CMS before additions for AP mine replacements.
 *
 * Revision 1.1  1997/12/16  13:59:57  ksnively
 * Initial revision
 *
 * Revision 1.3  1997/10/27  17:07:30  trang
 * BUILD1
 *
 * Revision 1.2  1997/10/02  17:47:47  austin
 * first working port to modsaf3.0
 *
Revision 1.2  1997/10/02 17:47:47  austin
first working port to modsaf3.0

 * Revision 1.1  1996/10/23  13:54:40  nsipes
 * Initial revision
 *
 * Revision 1.1  1996/10/23  13:54:40  nsipes
 * Initial revision
 *
 * Revision 1.3  1996/05/14  16:15:08  rcarp
 * refinements and bug fixes for 1.5 delivery
 *
 * Revision 1.2  1996/03/13  00:25:53  mkappel
 * Elim toggles in popup.
 *
 * Revision 1.2  1996/03/13  00:25:53  mkappel
 * Elim toggles in popup.
 *
 * Revision 1.1  1996/01/23  16:48:05  rcarp
 * Initial revision
 *
$State: Exp $
*/
 
/*******************************************

   file: CoordEntry.h
   
      Copyright 1995 by the Institute for Defense Analyses
      
         Institute for Defense Analyses
         1801 N. Beauregard Street
         Alexandria, Virginia 22311-1772
         703-845-2000
         
      This software was developed by IDA under U. S. Government
      contract.  For distribution information contact:
      
         U. S. Army Night Vision Directorate
         AMSEL RD NV OD CD
         10221 Burbeck Road, suite 430
         Ft. Belvoir VA 22060-5806
      
*********************************************/

/*******************************************

   CoordEntry.h
   
      The header file defines the map controls interface classes.
      
      
   
   Created by Michael Kappel
   Modification history:
      created   
      
*********************************************/

#ifndef _CoordEntry_
#define _CoordEntry_

#include "Display.h"

class cCoordEntryWindow : public cShellWindow {

friend cGuiWindow;

private:
   ECoordListType  fType;
   cMine*          fpMine;
   cPerimeter*     fpPerim;
   cRowComp*       fpRowComp;
   int             fVertex;

   Widget          fwXBox;
   Widget          fwYBox;
   Widget          fwOrientBox;

   Widget     CreateMainWin (Widget wParent);
   Widget     CreateWorkArea (Widget wParent);
   Widget     CreateActionArea (Widget wParent);

   static void  CbOK     (Widget, XtPointer, XmPushButtonCallbackStruct*);
   static void  CbDelete (Widget, XtPointer, XmPushButtonCallbackStruct*);
   static void  CbCancel (Widget, XtPointer, XmPushButtonCallbackStruct*);

public:
                cCoordEntryWindow (Widget parent, cMine* pMine);
                cCoordEntryWindow (Widget parent, cPerimeter* pPerim,
				   int ivert);
                cCoordEntryWindow (Widget parent, cRowComp* pRowComp,
				   int ivert);
   virtual     ~cCoordEntryWindow ();
};

#endif
