/*
$RCSfile: EntityEnums.cc,v $
$Revision: 1.1.1.1 $
$Author: jchappel $
$Date: 1999/02/16 14:54:34 $
$Log: EntityEnums.cc,v $
Revision 1.1.1.1  1999/02/16 14:54:34  jchappel
Comprehensive Mine Simulator

// Revision 2.1  1998/02/18  17:16:10  ksnively
// Incorporated AP mine replacement code.
//
// Revision 2.0  1998/01/26  21:01:35  ksnively
// Baseline CMS before additions for AP mine replacements.
//
// Revision 1.1  1997/12/16  13:59:57  ksnively
// Initial revision
//
// Revision 1.4  1997/10/02  17:53:37  austin
// first working port to modsaf3.0
//
// Revision 1.3  1997/10/02  17:50:22  austin
// first working port to modsaf3.0
//
// Revision 1.3  1997/10/02  17:50:22  austin
// first working port to modsaf3.0
//
// Revision 1.2  1997/03/20  19:14:41  ksnively
// added emission tracking, updated to CMS2.0B6
//
// Revision 1.2  1997/03/20  19:14:41  ksnively
// added emission tracking, updated to CMS2.0B6
//
// Revision 1.1  1996/10/23  13:54:40  nsipes
// Initial revision
//
// Revision 1.4  1996/07/03  22:55:15  rcarp
// enhancements and bug fixes for version 1.5b9
//
// Revision 1.3  1996/05/21  22:12:12  rcarp
// text and lists from mine db, and activating mine state save cmd
//
// Revision 1.2  1996/05/15  17:18:44  rcarp
// refinements and fixes for 1.5 delivery
//
// Revision 1.1  1996/05/14  16:15:08  rcarp
// Initial revision
//
$State: Exp $
*/
/*******************************************

   
   EntityEnums.cc
   
      Enumerations to support DIS
   
      Copyright 1995-96 by the Institute for Defense Analyses
      
         Institute for Defense Analyses
         1801 N. Beauregard Street
         Alexandria, Virginia 22311-1772
         703-845-2000
         
      This software was developed by IDA under U. S. Government
      contract.  For distribution information contact:
      
         U. S. Army Night Vision Directorate
         AMSEL RD NV OD CD
         10221 Burbeck Road, suite 430
         Ft. Belvoir VA 22060-5806
      
*********************************************/

#include   "Globals.h"

const char* TEntityType::fsKindText[enumKind] = {
	"Other",
	"Platform",
	"Munition",
	"Lifeform",
	"Environmental",
	"Cultural",
	"Supply",
	"Radio"
};

   // This array uses short domain names, for tables
const char* TEntityType::fsMunDomText[enumMunDom] = {
	"Other",
   "AAir",
	"AT",
   "AGuid",
   "ARad",
   "ASat",
   "AShip",
   "ASub",
   "AP",
   "BatSup",
   "Strg",
   "Tact",
   "FA",
   "SaSens",
   "SaContrl"
};

const char* TEntityType::fsMunCategoryText[enumMunCat] = {
	"Other",
	"Guided",
	"Ballistic",
	"Fixed"
};

const TKeyValuePair TEntityType::fsMineSubcatText[enumMineSubcatPairs] = {
	"Other", 0,
	"AT_Conventional", eatscatConv,
	"AT_Scatterable", eatscatScatter,
	"AT_Off-route", eatscatOffroute,
	"AT_Wide_Area", eatscatWidearea,
	"AP_Conventional", eapscatConv,
	"AP_Scatterable", eapscatScatter,
	"AP_Conv_Bounding", eapscatConvBounding,
	"AP_Scat_Bounding", eapscatScatBounding
};

/*
const TKeyValuePair TEntityType::fsCountryText[eNumCountryPairs] = {
	"All", kMatchAllShort,
   "Other", ecntryOther,
	"China", ecntryChina,
	"France", ecntryFrance,
	"Germany", ecntryGermany,
	"Italy", ecntryItaly,
	"Russia", ecntryUssr,
	"U.K.", ecntryUk,
	"U.S.", ecntryUs
};
*/

const char*   TEntityType::fsCountryText[enumCountry] = {
   "Other",
   "Afghanistan",
   "Albania",
   "Algeria",
   "AmericanSamoa",
   "Andorra",
   "Angola",
   "Anguilla",
   "Antarctica",
   "AntiguaAndBarbuda",
   "Argentina",
   "Aruba",
   "AshmoreAndCartierIslands",
   "Australia",
   "Austria",
   "Bahamas",
   "Bahrain",
   "BakerIsland",
   "Bangladesh",
   "Barbados",
   "BassasDaIndia",
   "Belgium",
   "Belize",
   "Benin",
   "Bermuda",
   "Bhutan",
   "Bolivia",
   "Botswana",
   "BouvetIsland",
   "Brazil",
   "BritishIndianOceanTerritory",
   "BritishVirginIslands",
   "Brunei",
   "Bulgaria",
   "BurkinaFaso",
   "Burma",
   "Burundi",
   "Cambodia",
   "Cameroon",
   "Canada",
   "CapeVerde",
   "CaymanIslands",
   "CentralAfricanRepublic",
   "Chad",
   "Chile",
   "China",
   "ChristmasIsland",
   "CocosIslands",
   "Colombia",
   "Comoros",
   "Congo",
   "CookIslands",
   "CoralSeaIslands",
   "CostaRica",
   "Cuba",
   "Cyprus",
   "Czechoslovakia",
   "Denmark",
   "Djibouti",
   "Dominica",
   "DominicanRepublic",
   "Ecuador",
   "Egypt",
   "ElSalvador",
   "EquatorialGuinea",
   "Ethiopia",
   "EuropaIslands",
   "FalklandIslands",
   "FaroeIsland",
   "Fiji",
   "Finland",
   "France",
   "FrenchGuiana",
   "FrenchPolynesia",
   "FrenchSouthernAndAntarcticIslands",
   "Gabon",
   "Gambia",
   "GazaStrip",
   "Germany",
   "Ghana",
   "Gibraltar",
   "GloriosoIsland",
   "Greece",
   "Greenland",
   "Grenada",
   "Guadaloupe",
   "Guam",
   "Guatemala",
   "Guernsey",
   "Guinea",
   "GuineaBissua",
   "Guyana",
   "Haiti",
   "HeardIslandAndMcdonaldIslands",
   "Honduras",
   "HongKong",
   "HowlandIsland",
   "Hungary",
   "Iceland",
   "India",
   "Indonesia",
   "Iran",
   "Iraq",
   "IraqSaudiArabiaNeutralZone",
   "Ireland",
   "Israel",
   "Italy",
   "IvoryCoast",
   "Jamaica",
   "JanMayen",
   "Japan",
   "JarvisIsland",
   "Jersey",
   "JohnstonAtoll",
   "Jordan",
   "JuanDeNovaIsland",
   "Kenya",
   "KingmanReef",
   "Kiribati",
   "Korea",
   "RepublicOfKorea",
   "Kuwait",
   "Laos",
   "Lebanon",
   "Lesotho",
   "Liberia",
   "Libya",
   "Liechtenstein",
   "Luxembourg",
   "Macao",
   "Madagascar",
   "Malawi",
   "Malaysia",
   "Maldives",
   "Mali",
   "Malta",
   "ManIsleOf",
   "MarshallIslands",
   "Martinique",
   "Mauritania",
   "Mauritius",
   "Mayotte",
   "Mexico",
   "Micronesia",
   "Monaco",
   "Mongolia",
   "Montserrat",
   "Morocco",
   "Mosambique",
   "Namibia",
   "Nauru",
   "NavassaIsland",
   "Nepal",
   "Netherlands",
   "NetherlandsAntilles",
   "NewCaledonia",
   "NewZealand",
   "Nicaragua",
   "Niger",
   "Nigeria",
   "Niue",
   "NorfolkIsland",
   "NorthernMarianaIslands",
   "Norway",
   "Oman",
   "Pakistan",
   "PalmyraAtoll",
   "Palau",
   "Panama",
   "PapuaNewGuinea",
   "ParacelIslands",
   "Paraguay",
   "Peru",
   "Philippines",
   "PitcaimIslands",
   "Poland",
   "Portugal",
   "PuertoRico",
   "Qatar",
   "Reunion",
   "Romania",
   "Rwanda",
   "StKittsAndNevis",
   "StHelena",
   "StLucia",
   "StPierreAndMiguelon",
   "StVincentAndTheGrenadines",
   "SanMarino",
   "SaoTomeAndPrincipe",
   "SaudiArabia",
   "Senegal",
   "Seychelles",
   "SierraLeone",
   "Singapore",
   "SolomonIslands",
   "Somalia",
   "SouthGeorgiaAndSouthSandwichIslands",
   "SouthAfrica",
   "Spain",
   "SpratlyIslands",
   "SriLanka",
   "Sudan",
   "Suriname",
   "Svalbard",
   "Swaziland",
   "Sweden",
   "Switzerland",
   "Syria",
   "Taiwan",
   "Tanzania",
   "Thailand",
   "Togo",
   "Tokelau",
   "Tonga",
   "TrinidadAndTobago",
   "TromelinIsland",
   "TrustTerritoryOfThePacificIslands",
   "Tunisia",
   "Turkey",
   "TurksAndCaicosIsland",
   "Tuvalu",
   "Uganda",
   "USSR",
   "UnitedArabEmirates",
   "United_Kingdom",
   "United_States",
   "Uruguay",
   "Vanuatu",
   "VaticanCity",
   "Venezuela",
   "Vietnam",
   "VirginIslands",
   "WakeIsland",
   "WallisAndFutuna",
   "WesternSahara",
   "WestBanks",
   "WesternSamoa",
   "Yemen",
   "YemenAden",
   "YemenSanaa",
   "Yugoslavia",
   "Zaire",
   "Zambia",
   "Zimbabwe"
};

const char*   TEntityType::GetKindText(int knd)
{
   return fsKindText[knd];
}

const char*   TEntityType::GetMunitionDomainText(int dom)
{
   return fsMunDomText[dom];
}

const char*   TEntityType::GetCountryText(int cntry)
{
   if ( (cntry >= 0) && (cntry < enumCountry) )
      return fsCountryText[cntry];
   else
      return NULL;
}

const char*   TEntityType::GetKindText() const
{
   return fsKindText[kind];
}

const char*   TEntityType::GetMunitionDomainText() const
{
   Assert ( kind == ekindMunition, kerrValidityCheck, "TEntityType::GetMunitionDomainText" );
   return fsMunDomText[domain];
}

const char*   TEntityType::GetCountryText() const
{
   if ( country < enumCountry )
      return fsCountryText[country];
   else
      return NULL;
}
