/*
$RCSfile: EntityEnums.h,v $
$Revision: 1.2 $
$Author: ksnively $
$Date: 1999/04/29 19:34:10 $
$Log: EntityEnums.h,v $
Revision 1.2  1999/04/29 19:34:10  ksnively
Incorporated ARDEC addtions:  Tripwire AP mines and a Control Window.

Revision 1.1.1.1  1999/02/16 14:54:49  jchappel
Comprehensive Mine Simulator

 * Revision 2.6  1998/12/02  16:42:42  jchappel
 * added gui detonator
 *
 * Revision 2.5  1998/10/27  19:30:47  jchappel
 * modifications for versioning
 *
 * Revision 2.4  1998/07/27  17:51:27  ksnively
 * Added single detection trip wire sensor
 *
 * Revision 2.3  1998/04/20  15:10:36  ksnively
 * *** empty log message ***
 *
 * Revision 2.2  1998/02/26  21:26:56  ksnively
 * Created Mf Camera object to control MAK Stealth view.
 * Created vulnerability tables specific to command detonated mines
 * and the camera object.
 *
 * Revision 2.1  1998/02/18  17:17:24  ksnively
 * Incorporated AP mine replacement code
 *
 * Revision 2.0  1998/01/26  21:04:20  ksnively
 * Baseline CMS before additions for AP mine replacements.
 *
 * Revision 1.1  1997/12/16  13:59:57  ksnively
 * Initial revision
 *
 * Revision 1.4  1997/10/27  17:07:30  trang
 * BUILD1
 *
 * Revision 1.3  1997/05/20  15:37:57  ksnively
 * *** empty log message ***
 *
Revision 1.3  1997/05/20 15:37:57  ksnively
*** empty log message ***

 * Revision 1.2  1997/05/07  12:33:45  ksnively
 * *** empty log message ***
 *
 * Revision 1.1  1996/10/23  13:54:40  nsipes
 * Initial revision
 *
 * Revision 1.1  1996/05/14  16:15:08  rcarp
 * Initial revision
 *
$State: Exp $
*/
/*******************************************

   
   EntityEnums.h
   
      Enumerations to support DIS
   
      Copyright 1995-96 by the Institute for Defense Analyses
      
         Institute for Defense Analyses
         1801 N. Beauregard Street
         Alexandria, Virginia 22311-1772
         703-845-2000
         
      This software was developed by IDA under U. S. Government
      contract.  For distribution information contact:
      
         U. S. Army Night Vision Directorate
         AMSEL RD NV OD CD
         10221 Burbeck Road, suite 430
         Ft. Belvoir VA 22060-5806
      
*********************************************/


#ifndef _UEnumTypes_
#define _UEnumTypes_


enum EEntKind        { ekindOther        = 0,
                       ekindPlatform,
                       ekindMunition,
                       ekindLifeform,
                       ekindEnvironmental,
                       ekindCultural,
                       ekindSupply,
                       ekindRadio,
                       
                       enumKind };

enum EPlatformEntDomain   { eplatdomOther      = 0, 
                            eplatdomLand,
                            eplatdomAir, 
                            eplatdomSurface, 
                            eplatdomSubsurface, 
                            eplatdomSpace,
                            
                            enumPlatDomain};

enum EPlatformLandCat   { eplatlandOther      = 0, 
                          eplatlandTank,
                          eplatlandArmorFightVeh,
                          eplatlandArmorUtilVeh,
                          eplatlandSelfPropArty,
                          eplatlandTowedArty,
                          eplatlandSmWheelUtil,
                          eplatlandLgWheelUtil,
                          eplatlandSmTrkUtil,
                          eplatlandLgTrkUtil,
                          eplatlandMortar,
                          
                          enumPlatLandCat};

enum EPlatformAirCat   { eplatairUAVRecon = 50,  // used to be 54 for 2.0.3
                          eplatairOther      = 0, 
                          eplatairFighterAD,
                          eplatairAttack,
                          eplatairBomber,
                          eplatairCargo,
                          eplatairASWObs,
                          eplatairEW,
                          eplatairRecon,
                          eplatairSurvC2,
                          eplatairAttackHel,
                          eplatairUtilHel,
                          eplatairASWPatrol,
                          eplatairCargoHel,
                          eplatairObsHel,
                          eplatairSpecOps,
                          eplatairTrainer,
                          eplatairUnmanned,
													
			  enumPlatAirCat};
                          

enum EMunDomain   { emundomOther         = 0, 
                       emundomAntiair       = 1, 
                       emundomAntitank      = 2, 
                       emundomAntiguided    = 3, 
                       emundomAntiradar     = 4, 
                       emundomAntisatellite = 5, 
                       emundomAntiship      = 6, 
                       emundomAntisub       = 7, 
                       emundomAntipersonnel = 8, 
                       emundomBattleSup     = 9, 
                       emundomStrategic     = 10,
                       emundomTactical      = 11,
                       efunnydomainFalseAlarm = 12,
                       efunnydomainSaSensor   = 13,
                       efunnydomainSaController = 14,
                       efunnydomainMfCamera = 15,
											 
                       enumMunDom};   // never sent externally

enum ELifeformLandCat   { elifelandOther      = 0, 
                          elifelandDI,
                          
                          enumLifeLandCat};

/*
enum ECountry        { ecntryOther           = 0,
                       ecntryBelgium         = 21,
                       ecntryChina           = 45,
                       ecntryCzech           = 56,
                       ecntryEgypt           = 62,
                       ecntryFrance          = 71,
                       ecntryGermany         = 78,
                       ecntryItaly           = 106,
                       ecntryPakistan        = 165,
                       ecntrySingapore       = 193,
                       ecntrySweden          = 205,
                       ecntryUssr            = 222,
                       ecntryUk              = 224,
                       ecntryUs              = 225,
                       ecntryYugo            = 240
                     };
*/
enum ECountry  { 
      ecntryOther,
			
      ecntryAfghanistan,
      ecntryAlbania,
      ecntryAlgeria,
      ecntryAmerican_Samoa,
      ecntryAndorra,
      ecntryAngola,
      ecntryAnguilla,
      ecntryAntarctica,
      ecntryAntigua_And_Barbuda,
      ecntryArgentina = 10,
			
      ecntryAruba,
      ecntryAshmore_And_Cartier_Islands,
      ecntryAustralia,
      ecntryAustria,
      ecntryBahamas,
      ecntryBahrain,
      ecntryBaker_Island,
      ecntryBangladesh,
      ecntryBarbados,
      ecntryBassas_Da_India,
			
      ecntryBelgium,
      ecntryBelize,
      ecntryBenin,
      ecntryBermuda,
      ecntryBhutan,
      ecntryBolivia,
      ecntryBotswana,
      ecntryBouvet_Island,
      ecntryBrazil,
      ecntryBritish_Indian_Ocean_Territory,
			
      ecntryBritish_Virgin_Islands,			
      ecntryBrunei,
      ecntryBulgaria,
      ecntryBurkina_Faso,
      ecntryBurma,
      ecntryBurundi,
      ecntryCambodia,
      ecntryCameroon,
      ecntryCanada,
      ecntryCape_Verde,
			
      ecntryCayman_Islands,
      ecntryCentral_African_Republic,
      ecntryChad,
      ecntryChile,
      ecntryChina,
      ecntryChristmas_Island,
      ecntryCocos_Islands,
      ecntryColombia,
      ecntryComoros,
      ecntryCongo,
			
      ecntryCook_Islands,
      ecntryCoral_Sea_Islands,
      ecntryCosta_Rica,
      ecntryCuba,
      ecntryCyprus,
      ecntryCzechoslovakia,
      ecntryDenmark,
      ecntryDjibouti,
      ecntryDominica,
      ecntryDominican_Republic,
			
      ecntryEcuador,
      ecntryEgypt,
      ecntryEl_Salvador,
      ecntryEquatorial_Guinea,
      ecntryEthiopia,
      ecntryEuropa_Islands,
      ecntryFalkland_Islands,
      ecntryFaroe_Island,
      ecntryFiji,
      ecntryFinland,
			
      ecntryFrance,
      ecntryFrench_Guiana,
      ecntryFrench_Polynesia,
      ecntryFrench_Southern_And_Antarctic_Islands,
      ecntryGabon,
      ecntryGambia,
      ecntryGaza_Strip,
      ecntryGermany,
      ecntryGhana,
      ecntryGibraltar,
			
      ecntryGlorioso_Island,
      ecntryGreece,
      ecntryGreenland,
      ecntryGrenada,
      ecntryGuadaloupe,
      ecntryGuam,
      ecntryGuatemala,
      ecntryGuernsey,
      ecntryGuinea,
      ecntryGuinea_Bissua,
			
      ecntryGuyana,
      ecntryHaiti,
      ecntryHeard_Island_And_Mcdonald_Islands,
      ecntryHonduras,
      ecntryHong_Kong,
      ecntryHowland_Island,
      ecntryHungary,
      ecntryIceland,
      ecntryIndia,
      ecntryIndonesia,
			
      ecntryIran,
      ecntryIraq,
      ecntryIraq_Saudi_Arabia_Neutral_Zone,
      ecntryIreland,
      ecntryIsrael,
      ecntryItaly,
      ecntryIvory_Coast,
      ecntryJamaica,
      ecntryJan_Mayen,
      ecntryJapan,
			
      ecntryJarvis_Island,
      ecntryJersey,
      ecntryJohnston_Atoll,
      ecntryJordan,
      ecntryJuan_De_Nova_Island,
      ecntryKenya,
      ecntryKingman_Reef,
      ecntryKiribati,
      ecntryKorea,
      ecntryRepublic_Of_Korea,
			
      ecntryKuwait,			
      ecntryLaos,
      ecntryLebanon,
      ecntryLesotho,
      ecntryLiberia,
      ecntryLibya,
      ecntryLiechtenstein,
      ecntryLuxembourg,
      ecntryMacao,
      ecntryMadagascar,
			
      ecntryMalawi,
      ecntryMalaysia,
      ecntryMaldives,
      ecntryMali,
      ecntryMalta,
      ecntryMan_Isle_Of,
      ecntryMarshall_Islands,
      ecntryMartinique,
      ecntryMauritania,
      ecntryMauritius,
			
      ecntryMayotte,
      ecntryMexico,
      ecntryMicronesia,
      ecntryMonaco,
      ecntryMongolia,
      ecntryMontserrat,
      ecntryMorocco,
      ecntryMosambique,
      ecntryNamibia,
      ecntryNauru,
			
      ecntryNavassa_Island,
      ecntryNepal,
      ecntryNetherlands,
      ecntryNetherlands_Antilles,
      ecntryNew_Caledonia,
      ecntryNew_Zealand,
      ecntryNicaragua,
      ecntryNiger,
      ecntryNigeria,
      ecntryNiue,
			
      ecntryNorfolk_Island,			
      ecntryNorthern_Mariana_Islands,
      ecntryNorway,
      ecntryOman,
      ecntryPakistan,
      ecntryPalmyra_Atoll,
      ecntryPalau,
      ecntryPanama,
      ecntryPapua_New_Guinea,
      ecntryParacel_Islands,
			
      ecntryParaguay,
      ecntryPeru,
      ecntryPhilippines,
      ecntryPitcaim_Islands,
      ecntryPoland,
      ecntryPortugal,
      ecntryPuerto_Rico,
      ecntryQatar,
      ecntryReunion,
      ecntryRomania,
			
      ecntryRwanda,
      ecntrySt_Kitts_And_Nevis,
      ecntrySt_Helena,
      ecntrySt_Lucia,
      ecntrySt_Pierre_And_Miguelon,
      ecntrySt_Vincent_And_The_Grenadines,
      ecntrySan_Marino,
      ecntrySao_Tome_And_Principe,
      ecntrySaudi_Arabia,
      ecntrySenegal,
			
      ecntrySeychelles,
      ecntrySierra_Leone,
      ecntrySingapore,
      ecntrySolomon_Islands,
      ecntrySomalia,
      ecntrySouth_Georgia_And_South_Sandwich_Islands,
      ecntrySouth_Africa,
      ecntrySpain,
      ecntrySpratly_Islands,
      ecntrySri_Lanka,
			
      ecntrySudan,
      ecntrySuriname,
      ecntrySvalbard,
      ecntrySwaziland,
      ecntrySweden,
      ecntrySwitzerland,
      ecntrySyria,
      ecntryTaiwan,
      ecntryTanzania,
      ecntryThailand,
			
      ecntryTogo,
      ecntryTokelau,
      ecntryTonga,
      ecntryTrinidad_And_Tobago,
      ecntryTromelin_Island,
      ecntryTrust_Territory_Of_The_Pacific_Islands,
      ecntryTunisia,
      ecntryTurkey,
      ecntryTurks_And_Caicos_Island,
      ecntryTuvalu,
			
      ecntryUganda,
      ecntryUnion_Of_Soviet_Socialist_Republics,
      ecntryUnited_Arab_Emirates,
      ecntryUnited_Kingdom,
      ecntryUnited_States,
      ecntryUruguay,
      ecntryVanuatu,
      ecntryVatican_City,
      ecntryVenezuela,
      ecntryVietnam,
			
      ecntryVirgin_Islands,
      ecntryWake_Island,
      ecntryWallis_And_Futuna,
      ecntryWestern_Sahara,
      ecntryWest_Banks,
      ecntryWestern_Samoa,
      ecntryYemen,
      ecntryYemen_Aden,
      ecntryYemen_Sanaa,
      ecntryYugoslavia,
			
      ecntryZaire,
      ecntryZambia,
      ecntryZimbabwe,
			
      enumCountry
};


enum EMunEntCategory { emuncatOther         = 0,
                       emuncatGuided,
                       emuncatBallistic,
                       emuncatFixed,
											 
											 enumMunCat};

enum EAtSubcategory  { eatscatOther         = 0, 
                       eatscatConv, 
                       eatscatScatter, 
                       eatscatOffroute, 
                       eatscatWidearea,
											 
											 enumAtMineSubcat};

enum EAtUsGuidedSubcategory  { eatusguidscatOther         = 0, 
                               eatusguidTow, 
                               eatusguidDragon, 
                               eatusguidHellfire, 
                               eatusguidMaverick, 
                               eatusguidCopperhead, 
                               eatusguidAawsm, 
                               eatusguidHvm,
															 
															 enumAtGuidedUsSubcat};

enum EAtUsBalSubcategory  { eatusbalscatOther         = 0, 
                          eatusbalscat12_7mm, 
                          eatusbalscat20mm, 
                          eatusbalscat25mm, 
                          eatusbalscat30mm, 
                          eatusbalscat66mmLAW, 
                          eatusbalscat76mm, 
                          eatusbalscat81mm, 
                          eatusbalscat84mm,
                          eatusbalscat90mm,
                          eatusbalscat105mm,
                          eatusbalscat106mmM40,
                          eatusbalscat107mm,
                          eatusbalscat120mm,
                          eatusbalscat152mm,
                          eatusbalscat155mm,
                          eatusbalscat227mmRocket,
                          eatusbalscatHydra        = 20,
                          eatusbalscatRockeye      = 50,
                          eatusbalscatTmdWaam,
                          eatusbalscatWidearea     = 60 };

enum EAtConvSpec     { 
                       
                       eatItalyconvOther    = 0,
                       
                       eatUssrconvOther     = 0,
							  eatUssrconvTM62P,
							  eatUssrconvTM46,
                       
                       eatUkconvOther       = 0,

                       eatFranceconvOther   = 0,
                       eatFranceconvHPDF2,

                       eatUSconvOther       = 0,
                       eatUSconvM15,
							  eatUSconvM21,
                       
							  eatGermanyconvOther  = 0,

                       eatYugoconvOther   = 0,
                       eatYugoconvTMA3
                       
                      };

enum EAtScatterSpec     { 
                       
                       eatItalyscatOther    = 0,
                       
                       eatUssrscatOther     = 0,
							  eatUssrscatPGMDM,
                       
                       eatUkscatOther       = 0,

                       eatUSscatOther       = 0,
                       eatUSscatM75,
                       
							  eatGermanyscatOther  = 0,
							  eatGermanyscatAT2
                       
                      };

enum EAtOffrouteSpec { 
                       eatOtheroffGeneric  = 1,
                       
                       eatItalyoffOther    = 0,
                       
                       eatUssroffOther     = 0,
                       
                       eatUkoffOther       = 0,

                       eatUSoffOther       = 0,
                       
							  eatGermanyoffOther  = 0
                       
                      };

enum EAtWideareaSpec { 
                       
                       eatOtherwideGeneric  = 1,
                       
                       eatItalywideOther    = 0,
                       
                       eatUssrwideOther     = 0,
                       
                       eatUkwideOther       = 0,

                       eatUSwideOther       = 0,
                       
                       eatGermanywideOther  = 0
                       
                      };

enum EApSubcategory  { eapscatOther         = 0, 
                       eapscatConv, 
                       eapscatScatter, 
                       eapscatConvBounding,
                       eapscatScatBounding,

                       eapscatScatCmdDet,
                       eapscatScatTripCmdDet
                     };

enum EApConvBdingSpec { 
                       
                       eapItalycvbdOther    = 0,
                       eapItalycvbdValmara  = 1,
                       
                       eapGermanycvbdOther  = 0,
                       
                       eapUssrcvbdOther     = 0,
                       
                       eapUscvbdOther       = 0,

                       eapUkcvbdOther       = 0,
                       
							  eapYugocvbdOther     = 0
                       
                      };

/*
enum EApScatBdingSpec { 
                       
                       eapOtherscbdOther    = 0,
                       eapOtherscbdVMMD     = 1,
                       eapOtherscbdASTA     = 2,
                       eapOtherscbdCIMMD    = 3,
                       eapOtherscbdPSS12    = 4,
                      
                       eapItalyscbdOther    = 0,
                       
                       eapGermanycscbdOther  = 0,
                       
                       eapUssrscbdOther     = 0,
                       
                       eapUsscbdOther       = 0,

                       eapUkscbdOther       = 0,
                       
							  eapYugoscbdOther     = 0
                       
                      };
		      */

enum EApScatWAMSpec {
                        eapWamOther       = 0,

                        eapUSWam          = 1
                       };

enum EApScatOrSpec {
                        eapOrOther          = 0,

                        eapUSClay           = 1,
                        eapUSCmdClay        = 2,
                        eapUSCmdMultiClay   = 3
                       };

enum ESensSubcategory {
                        esensscatOther     = 0,
                        esensscatDetecting = 1,
                        esensscatTracking  = 2,
                        
                        enumsensscat

                      };

enum EWarhead        { ewhOther              = 0,

                       ewhHE                 = 1000,
                          ewhHEPlastic          = 1100,
                          ewhHEIncendiary       = 1200,
                          ewhHEFrag             = 1300,
                          ewhHEAntitank         = 1400,
                          
                          ewhHEAntipersonnel    = 1685,


                       ewhMine               = 6000,
                       ewhMineAt               = 6100,
                          ewhMineAtBlast           = 6110,
                             ewhMineAtBlastSmall        = 6111,
                             ewhMineAtBlastLarge        = 6112,
                          ewhMineAtFrag            = 6120,
                          ewhMineAtPlate           = 6130,
                          ewhMineAtEfp             = 6140,
                          ewhMineAtShapedCharge    = 6150,

                       ewhMineAp               = 6200,
                          ewhMineApBlast           = 6210,
                             ewhMineApBlastSmall        = 6211,
                             ewhMineApBlastLarge        = 6212,
                          ewhMineApFrag            = 6220,
                          ewhMineAtDirectionalFrag = 6230

                       };

enum EFuze           { efzOther              = 0,
                       efzContact            = 1000,
		       efzTiltrod	     = 1100, 
                       efzProximity          = 3000,
                          efzProxMag            = 3200,
                       efzCommand            = 4000,
                          efzCommandFire        = 4200,
                          efzCommandLoc         = 4300,
                          efzCommandFireDir     = 4400,
                          efzCommandTripFire    = 4500,
		          esensCommandCamDir      = 4800,
		          esensAutoCmdCamDir      = 4900,
                       efzAcoustic           = 7000,
                       efzPressure           = 8000,
                          efzPresDelay          = 8010
                       
                       };

enum ESens           { esensOther            = 0,
                       esensPeoDet           = 1000,
                       esensVehDet           = 1010,
                       esensPeoVehDet        = 1020,
		       esensTripWire         = 1030,
		       esensDirDet           = 1040,
                       esensPeoTrk           = 2000,
                       esensVehTrk           = 2010,
                       esensPeoVehTrk        = 2020,
		       esensDirPVTrk         = 2030,
                       esensDirSmart         = 3000
                       
                       };

enum EControl       { econOther            = 0,
                       econAuto             = 1000,
                       econRelay            = 2000
                       
                       };

enum EDetonResult    { edetOther             = 0,
                       edetEntityImpact,
                       edetEntityProximate,
                       edetGroundImpact,
                       edetGroundProximate,
                       edetDetonation,
                       edetNone  };
 

#endif
