/*
$RCSfile: MapCreate.cc,v $
$Revision: 1.4 $
$Author: ksnively $
$Date: 1999/05/10 20:18:25 $
$Log: MapCreate.cc,v $
Revision 1.4  1999/05/10 20:18:25  ksnively
Added a command line option for enabling Communication Capability.

Revision 1.3  1999/04/29 19:34:14  ksnively
Incorporated ARDEC addtions:  Tripwire AP mines and a Control Window.

Revision 1.2  1999/04/22 22:20:02  ksnively
Sreamlined radio communication routines.  Allowed to send to unlimited number of receivers.

Revision 1.1.1.1  1999/02/16 14:54:37  jchappel
Comprehensive Mine Simulator

// Revision 2.2  1998/10/27  19:31:39  jchappel
// modifications for versioning
//
// Revision 2.1  1998/06/03  17:18:04  jchappel
// ..
//
// Revision 2.0  1998/01/26  21:01:35  ksnively
// Baseline CMS before additions for AP mine replacements.
//
// Revision 1.1  1997/12/16  13:59:57  ksnively
// Initial revision
//
// Revision 1.5  1997/10/27  17:04:43  trang
// ci *.cc
// Build1
//
Revision 1.4  1997/10/02 17:53:37  austin
first working port to modsaf3.0

// Revision 1.3  1997/10/02  17:50:22  austin
// first working port to modsaf3.0
//
// Revision 1.3  1997/10/02  17:50:22  austin
// first working port to modsaf3.0
//
// Revision 1.2  1997/09/16  22:56:30  austin
// last attempt with old style ctdb_read--no libworld use
//
// Revision 1.2  1997/09/16  22:56:30  austin
// last attempt with old style ctdb_read--no libworld use
//
// Revision 1.1  1996/10/23  13:54:40  nsipes
// Initial revision
//
// Revision 1.14  1996/08/20  13:44:41  mkappel
// Add Detonation Display.
//
// Revision 1.13  1996/08/08  14:18:00  mkappel
// Enhance title of map.
//
// Revision 1.12  1996/05/14  16:15:08  rcarp
// refinements and bug fixes for 1.5 delivery
//
// Revision 1.9  1996/03/30  19:35:34  mkappel
// Add Distance tool.
//
// Revision 1.8  1996/03/23  18:09:52  mkappel
// Fix repositioning on load of minefield.
//
// Revision 1.7  1996/03/23  14:24:14  rcarp
// improvements to test mode and selection
//
// Revision 1.6  1996/03/16  18:36:36  mkappel
// Interface for Test Mode files.
//
// Revision 1.5  1996/03/07  14:22:46  mkappel
// Add Output Statistics to main menu.
//
// Revision 1.4  1996/03/06  19:45:05  mkappel
// New Mine Status Window
//
// Revision 1.3  1996/02/23  18:36:44  mkappel
// Add Site/Application to Start Up Screen.
//
// Revision 1.1  1996/01/23  16:52:30  rcarp
// Initial revision
//
$State: Exp $
*/
 
/*******************************************

   file: MapCreate.cc
   
      Copyright 1995 by the Institute for Defense Analyses
      
         Institute for Defense Analyses
         1801 N. Beauregard Street
         Alexandria, Virginia 22311-1772
         703-845-2000
         
      This software was developed by IDA under U. S. Government
      contract.  For distribution information contact:
      
         U. S. Army Night Vision Directorate
         AMSEL RD NV OD CD
         10221 Burbeck Road, suite 430
         Ft. Belvoir VA 22060-5806
      
*********************************************/


#include "CmsControl.h"
#include "Distance.h"
#include "MapControls.h"
#include "MapGeometry.h"
#include "Message.h"
#include "TestMode.h"
#include "NetMgr.h"

#include <libprotocol.h>
#include <libdisconst.h>
#include <libotmatch.h>
#include <libphysdb.h>
/*added AUSTIN 29 Jul 97*/

#include <libconstants.h>
/*
#include <librdrconst.h>
*/
#include <Xm/CascadeB.h>
#include <Xm/DrawingA.h>
#include <Xm/Form.h>
#include <Xm/LabelG.h>
#include <Xm/List.h>
#include <Xm/MainW.h>
#include <Xm/MenuShell.h>
#include <Xm/RowColumn.h>
#include <Xm/PanedW.h>
#include <Xm/PushB.h>
#include <Xm/ScrollBar.h>
#include <Xm/ScrolledW.h>
#include <Xm/ToggleB.h>

#include <X11/cursorfont.h>
#include <unistd.h>
#include <ctype.h>

Display            *gpDisplay     = NULL;
Window              gMapWindow    = NULL;
TACTMAP_PTR         gpTactmap     = NULL;

cMinefieldStatusWindow*  cGuiWindow::fpMinefieldStatusWin = NULL;
cMinefieldEditorWindow*  cGuiWindow::fpMfieldEditorWin    = NULL;
cPerimEditorWindow*      cGuiWindow::fpPerimEditorWin     = NULL;
cIndivEditorWindow*      cGuiWindow::fpIndivEditorWin     = NULL;
cGridEditorWindow*       cGuiWindow::fpGridEditorWin      = NULL;
cRowEditorWindow*        cGuiWindow::fpRowEditorWin       = NULL;
cComponentStatusWindow*  cGuiWindow::fpCompStatusWin      = NULL;
cMineStatusWindow*       cGuiWindow::fpMineStatusWin      = NULL;
cFieldControlWindow*     cGuiWindow::fpFieldControlWin    = NULL;
cMapControlsWindow*      cGuiWindow::fpMapControlsWin     = NULL;
cTestModeWindow*         cGuiWindow::fpTestModeWin        = NULL;

cEditorWindow*           cGuiWindow::fpCurrentEditor      = NULL;
EBoolean                 cGuiWindow::fsUserEnabled        = true;

Widget                   cGuiWindow::fwOutputButton;
Widget                   cGuiWindow::fwMineDispButton;
Widget                   cGuiWindow::fwCommEffectsButton;

Widget        cWindow::fwTopLevelShell = NULL;
XtAppContext  cWindow::fApp = NULL;


cWindow::~cWindow() 
{
  XtDestroyWidget (fwMainWin);
}

cShellWindow::~cShellWindow() 
{}

void       cGuiWindow::ShowEditor(EEditor eEditType)
      // this routine just switches editor windows.  Current selections
      // should already have been set/changed as needed
{
   cEditorWindow* pNewEditor;
   
   switch ( eEditType ) {
      case eEditMfStatus :
            pNewEditor = fpMinefieldStatusWin;
         break;
   
      case eEditMinefield :
            if (gMfieldMgr.ResumeReadMinefile ())
	       pNewEditor = fpMinefieldStatusWin;
	    else
	       pNewEditor = fpMfieldEditorWin;
/*
            if (fpCurrentEditor == fpMinefieldStatusWin) {
               gpCurMinefield->GetCompList()->ShowInfo();
               gpCurMinefield->MakeMfBackup();
            }
            else
               snstve_clear (fpSensWin);
*/
         break;
   
      case eEditPerim :
            pNewEditor = fpPerimEditorWin;
         break;
   
      case eEditIndiv :
            pNewEditor = fpIndivEditorWin;
         break;
   
      case eEditGrid :
            pNewEditor = fpGridEditorWin;
         break;
   
      case eEditRow :
            pNewEditor = fpRowEditorWin;
         break;
   
      case eEditCompStatus :
            pNewEditor = fpCompStatusWin;
//            gpCurMinefield->GetCompStatus()->ShowInfo();
         break;
   
      case eEditMineStatus :
            pNewEditor = fpMineStatusWin;
//            gpCurMinefield->GetCompStatus()->ShowInfo();
         break;
   
      case eEditMfCommand :
            pNewEditor = fpFieldControlWin;
         break;
   
      default :
            pNewEditor = NULL;
         break;
   
   }
   
   if (fpCurrentEditor != pNewEditor) {
      pNewEditor->ShowEdWindow();
      if ( fpCurrentEditor )
         fpCurrentEditor->ClearEdWindow();
   }
   
   fpCurrentEditor = pNewEditor;
}

Widget        cGuiWindow::CreateMenuBar(Widget wParent)
{
   Widget     wMenuBar, wFileMenu, wFileCascade, wButton;
	
   wMenuBar = 
     XmCreateMenuBar(wParent, "menu_bar", NULL, 0);
   
         // File menu
   wFileMenu = 
     XmCreatePulldownMenu( wMenuBar, "file_menu", NULL, 0 );
   wFileCascade = 
     XtVaCreateManagedWidget( "Controls", 
			     xmCascadeButtonWidgetClass, wMenuBar,
			     XmNsubMenuId, wFileMenu, 
			     NULL);
   wButton = 
     XtCreateManagedWidget( "Map...", 
			   xmPushButtonWidgetClass, wFileMenu,
			   NULL, 0);
   XtAddCallback( wButton, XmNactivateCallback, 
		 (XtCallbackProc)CbMap, (XtPointer)this);
       
   if ( gfInteract )
	  fwOutputButton = 
		XtCreateManagedWidget( "Stop Saving Interactions", 
			   xmPushButtonWidgetClass, wFileMenu,
			   NULL, 0);
   else 
	  fwOutputButton = 
		XtCreateManagedWidget( "Start Saving Interactions", 
			   xmPushButtonWidgetClass, wFileMenu,
			   NULL, 0);
            
   XtAddCallback( fwOutputButton, XmNactivateCallback, 
		 (XtCallbackProc)CbOutput, (XtPointer)this);

   if ( gfMineStateDisp )
	  fwMineDispButton = 
		XtCreateManagedWidget( "Hide Mine State Display",
			   xmPushButtonWidgetClass, wFileMenu,
			   NULL, 0);
   else 
	  fwMineDispButton = 
		XtCreateManagedWidget( "Show Mine State Display", 
			   xmPushButtonWidgetClass, wFileMenu,
			   NULL, 0);

   XtAddCallback( fwMineDispButton, XmNactivateCallback, 
		 (XtCallbackProc)CbMineStateDisp, (XtPointer)this);

   if (gCmsMgr.fStartupParam.fbController) {
      //Communication effects button
      fwCommEffectsButton = 
	 XtCreateManagedWidget( "Use Communication Effects",
				xmPushButtonWidgetClass, wFileMenu,
				NULL, 0);
      
      XtAddCallback( fwCommEffectsButton, XmNactivateCallback, 
		     (XtCallbackProc)CbCommEffects, (XtPointer)this);
   }
      
   wButton = 
      XtCreateManagedWidget( "Start Test Mode Input...", 
			     xmPushButtonWidgetClass, wFileMenu,
			     NULL, 0);
   XtSetSensitive (wButton, ( !gCmsMgr.GetOperatorPriv() )  && 
   							( gCmsMgr.GetProtocol() == eNonet ) );
   XtAddCallback( wButton, XmNactivateCallback, 
		 (XtCallbackProc)CbTestMode, (XtPointer)this);
   wButton = 
     XtCreateManagedWidget( "Quit", 
			   xmPushButtonWidgetClass, wFileMenu,
			   NULL, 0);
   XtAddCallback( wButton, XmNactivateCallback, 
		 (XtCallbackProc)CbQuit, (XtPointer)this);

   XtManageChild( wMenuBar );
   return wMenuBar;
}

Widget        cGuiWindow::CreateWorkArea(Widget wParent)
{
   Widget        wMapArea, wScrollWin;

   wScrollWin = 
     XtVaCreateManagedWidget("mapScrolled",
			     xmScrolledWindowWidgetClass, wParent, 
			     XmNscrollingPolicy, XmAPPLICATION_DEFINED,
			     NULL);
   wHScrollbar = 
     XtVaCreateManagedWidget("mapHScroll",
			     xmScrollBarWidgetClass, wScrollWin, 
			     XmNorientation, XmHORIZONTAL,
			     NULL);
   wVScrollbar = 
     XtVaCreateManagedWidget("mapVScroll",
			     xmScrollBarWidgetClass, wScrollWin, 
			     XmNorientation, XmVERTICAL,
			     XmNprocessingDirection, XmMAX_ON_TOP,
			     NULL);

   wMapArea = 
     XtVaCreateManagedWidget ("map_area", 
			      xmDrawingAreaWidgetClass, wScrollWin,
			      XmNheight, HeightOfScreen(XtScreen(wParent)) - 400,
			      NULL);
/*
   String translations = 
     "<Btn3Motion>: DrawingAreaInput() ManagerGadgetButtonMotion()";
   XtOverrideTranslations (wMapArea, XtParseTranslationTable (translations));
   XtAddCallback (wMapArea, XmNinputCallback, (XtCallbackProc)CbMapClick, NULL);
*/   
   XmScrolledWindowSetAreas(wScrollWin, wHScrollbar, wVScrollbar, wMapArea);
   InitScrollbar (wHScrollbar);
   InitScrollbar (wVScrollbar);

   return wMapArea;
}

void     cGuiWindow::DisableUser()
{
  static Cursor   hourglass;
  static int      first = TRUE;

  if (first) {
    first = FALSE;
    hourglass = XCreateFontCursor (gpDisplay, XC_watch);
  }

  if (fsUserEnabled) {
     XtSetSensitive (fwShell, FALSE);
     XDefineCursor (gpDisplay, XtWindow (fwShell), hourglass);
     XFlush (gpDisplay);
     fsUserEnabled = false;
  }
}

void     cGuiWindow::EnableUser()
{

  if ( ! fsUserEnabled) {
     XtSetSensitive (fwShell, TRUE);
     XUndefineCursor (gpDisplay, XtWindow (fwShell));
     XFlush (gpDisplay);
     fsUserEnabled = true;
  }
}

char *main_get_hostname()
{
#define HOST_STRING_SIZE 128
    static char hostname[HOST_STRING_SIZE];
    int32 i;

    /* Get the hostname, remove stuff after ".", and upcase it */
    gethostname(hostname, HOST_STRING_SIZE);
    strtok(hostname, ".");

    for (i = 0; hostname[i] != '\0'; i++)
      if (islower(hostname[i]))
	hostname[i] = toupper(hostname[i]);
    
    return hostname;
}

cGuiWindow::cGuiWindow()
{
   Widget            wPane, wMenuBar, wWorkArea;
   XGCValues         gcv;
   CTDB  *           pCtdb;
   Window            root;
   Dimension         height;
   char              geom_buf[40], title[100];
   int               i;
   int32             vers;

   fpCurrentEditor = NULL;
   fsUserEnabled = true;
   
       // window setup
   height = HeightOfScreen(XtScreen(fwTopLevelShell)) - 50;
   sprintf(geom_buf,"%dx%d+0+0",
	   WidthOfScreen(XtScreen(fwTopLevelShell)) - 50, height);
   // title
   sprintf (title, "CMS %s @ %s      Exercise: %d     Terrain: %s",
	    kpCmsVersion, main_get_hostname(), gpNetMgr->GetExerciseId(), 
	    gpTerrainMgr->GetCtdbAddr()->name);
      
   fwShell = 
     XtVaCreatePopupShell( "CMS PVD", 
			  topLevelShellWidgetClass, fwTopLevelShell,
			  XmNtitle, title,
			  XmNgeometry, geom_buf,
			  NULL);
   fwMainWin = 
     XtCreateManagedWidget( "main_pvd_window", 
			   xmMainWindowWidgetClass, fwShell, 
			   NULL, 0);
   wPane = 
     XtVaCreateWidget ("pane", 
		       xmPanedWindowWidgetClass, fwMainWin,
		       NULL);

   wMenuBar = CreateMenuBar (fwMainWin);
   wWorkArea = CreateWorkArea (wPane);

   fpMinefieldStatusWin = new cMinefieldStatusWindow (wPane);
   fpMfieldEditorWin    = new cMinefieldEditorWindow (wPane);
   fpPerimEditorWin     = new cPerimEditorWindow     (wPane);
   fpIndivEditorWin     = new cIndivEditorWindow     (wPane, gCmsMgr.fStartupParam.fbController);
   fpGridEditorWin      = new cGridEditorWindow      (wPane, gCmsMgr.fStartupParam.fbController);
   fpRowEditorWin       = new cRowEditorWindow       (wPane, gCmsMgr.fStartupParam.fbController);
   fpCompStatusWin      = new cComponentStatusWindow (wPane);
   fpMineStatusWin      = new cMineStatusWindow      (wPane);
   fpFieldControlWin    = new cFieldControlWindow    (wPane);

   fpMapControlsWin     = new cMapControlsWindow     (fwMainWin);
   fpTestModeWin        = new cTestModeWindow        (fwMainWin);

   ShowEditor(eEditMfStatus);
   XtManageChild( wPane );
   XtPopup( fwShell, XtGrabNone );    
   
   root = RootWindowOfScreen(XtScreen(fwMainWin));
   gpDisplay = XtDisplay(fwMainWin);

      // reader has been inited along with the terrain
      //  sensitive stuff
   gcv.foreground = WhitePixelOfScreen(XtScreen(fwTopLevelShell));
   gcv.line_width = 1;
   fgcSensDraw = XCreateGC(gpDisplay, root, 
			   GCForeground | GCLineWidth, &gcv);
   fgcSensErase = XCreateGC(gpDisplay, root, GCLineWidth, &gcv);

   snstve_init();

   fpSensWin = snstve_create(wWorkArea, fgcSensDraw, fgcSensErase);
   callback_register_handler(snstve_miss_callback(fpSensWin), 
			     (CALLBACK_HANDLER)CbClick, NULL);

   /* reader */
   reader_init(0);

   //changed to read constants from ./ to ../../data from AUSTIN 20 Oct 97
   //const_init("../../data/constants");
   const_init(DatapathConst);

   /* otm */
   //changed to read otm from ./data to ../../data from AUSTIN 20 Oct 97
   otm_init(Datapath,0);

   //changed to read env from ../constants to ../../data from AUSTIN 20 Oct 97
   env_init(Datapath,0);

   // tactical map
   tactmap_init();

   pCtdb = gpTerrainMgr->GetCtdbAddr();
   /*removed last 2 parameters to upgrade to modsaf3.0 libtactmap AUSTIN 4 Aug 97*/   
   gpTactmap = tactmap_create(wWorkArea, fpSensWin, fgcSensErase, NULL);
   /*,			      gpTerrainMgr->GetTcc(), pCtdb */

   printf("Processing %d features\n,",NUM_FEATURES);

   for (i = 0; i < NUM_FEATURES; i++) {
     cMapControlsWindow::fFeature[i].pMapDisp = 
       new cMapDisp (cMapControlsWindow::fFeature[i].tmap_class);
     if (i == 1 || i == 3)
       cMapControlsWindow::fFeature[i].pMapDisp->SetVisible (false);
   }
   cMapControlsWindow::SetDefaultFeatures();

   SetMapScale (250000.);
   SetMapCenter ((int32)(pCtdb->min_x+pCtdb->max_x)/2, 
		 (int32)(pCtdb->min_y+pCtdb->max_y)/2,(int32)0);
   gMapWindow = XtWindow (wWorkArea);

   /*reader_init used to be here. moved per libtactmap.h instructions AUSTIN*/
   protocol_init();

   /* rdrconst */
   /*replaced rdc init with const_init AUSTIN 29 Jul 97*/
   /*const_init used to be here. moved per libtactmap.h instructions AUSTIN */


   /*otm_init used to be called from here. moved per libtactmap.h instructions*/
   /* physdb */
   //changed to read physdb from ./data to ../../data from AUSTIN 20 Oct 97
   if (physdb_init(Datapath, 0/*READER_OVERRIDE*/))
      printf("Error initializing libphysdb\n"), exit(0);

   /* Initialize libdisconst */
   //changed to read disconst from ./data to ../../data from AUSTIN 20 Oct 97
 
   if( gCmsMgr.fStartupParam.feProtocol == /*EProtocol:: */eDis203 )
      vers = 3;
   else 
      vers = 4;

   int32 tempi = (disconst_init(Datapath, (uint32)0, vers, (int32)0/*get dis version, 2.0.3,etc.*/));
   if (tempi!=0)
   {
	printf("Error initializing libdisconst - returned %d\n",tempi);
      exit(0);
   }
   cPerimDisp::InitGCs (fwShell);
   cSegmentDisp::InitGCs (fwShell);
   cRowDisp::InitGCs (fwShell);
   cMineDisp::InitGCs (fwShell);
   cMineExplosion::InitGCs (fwShell);
   cDetonationDisp::InitGCs (fwShell);
   cVehDisp::InitGCs (fwShell);
   cVehDisp::InitPictures ();
   cDistanceDisp::InitGCs (fwShell);

   tactmap_tick(gpTactmap, 60000);
   new cUpdateTactmapMsg(this);
}

cGuiWindow::~cGuiWindow()
{
}
