/*
$RCSfile: Message.cc,v $
$Revision: 1.3 $
$Author: ksnively $
$Date: 1999/04/29 19:34:15 $
$Log: Message.cc,v $
Revision 1.3  1999/04/29 19:34:15  ksnively
Incorporated ARDEC addtions:  Tripwire AP mines and a Control Window.

Revision 1.2  1999/03/26 21:17:39  ksnively

Added radio communication capability for Command Detonated Mines.  Included sending
and receiving transmitter and signal PDUs.  All signals have the option of being
processed by the Communication Effects Federate.

Revision 1.1.1.1  1999/02/16 14:54:38  jchappel
Comprehensive Mine Simulator

// Revision 2.1  1998/11/25  18:37:51  ksnively
// Update for APLA Exercise
//
// Revision 2.0  1998/01/26  21:01:35  ksnively
// Baseline CMS before additions for AP mine replacements.
//
// Revision 1.1  1997/12/16  13:59:57  ksnively
// Initial revision
//
// Revision 1.4  1997/10/02  17:53:37  austin
// first working port to modsaf3.0
//
// Revision 1.3  1997/10/02  17:50:22  austin
// first working port to modsaf3.0
//
// Revision 1.3  1997/10/02  17:50:22  austin
// first working port to modsaf3.0
//
// Revision 1.2  1997/03/20  19:14:41  ksnively
// added emission tracking, updated to CMS2.0B6
//
// Revision 1.2  1997/03/20  19:14:41  ksnively
// added emission tracking, updated to CMS2.0B6
//
// Revision 1.1  1996/10/23  13:54:40  nsipes
// Initial revision
//
// Revision 1.6  1996/08/20  13:44:41  mkappel
// Add Detonation Display.
//
// Revision 1.5  1996/07/03  22:55:15  rcarp
// enhancements and bug fixes for version 1.5b9
//
// Revision 1.4  1996/05/21  22:12:12  rcarp
// text and lists from mine db, and activating mine state save cmd
//
// Revision 1.3  1996/05/08  00:45:10  rcarp
// changes for 1.5, incl user mines, mine params, param i/o, selection
//
// Revision 1.3  1996/05/08  00:45:10  rcarp
// changes for 1.5, incl user mines, mine params, param i/o, selection
//
// Revision 1.2  1996/03/23  14:22:31  rcarp
// improvements to test mode and selection
//
$State: Exp $
*/
 
/*******************************************

   file: Message.cc
   
      Copyright 1995 by the Institute for Defense Analyses
      
         Institute for Defense Analyses
         1801 N. Beauregard Street
         Alexandria, Virginia 22311-1772
         703-845-2000
         
      This software was developed by IDA under U. S. Government
      contract.  For distribution information contact:
      
         U. S. Army Night Vision Directorate
         AMSEL RD NV OD CD
         10221 Burbeck Road, suite 430
         Ft. Belvoir VA 22060-5806
      
*********************************************/

#include "Display.h"
#include "GlobalTypes.h"
#include "Message.h"
#include "Minefield.h"
#include "Communication.h"

void   cUpdateTactmapMsg::SendMsg()
{
   fpGuiWin->UpdateTactmap();
   
   new cUpdateTactmapMsg(fpGuiWin);
}

cUpdateTactmapMsg::cUpdateTactmapMsg(cGuiWindow* pWin)
{
   fpGuiWin = pWin;
}

cUpdateTactmapMsg::~cUpdateTactmapMsg()
{
}

void   cUpdateMfCompStatusMsg::SendMsg()
{
   fpMineComp->UpdateStatusInfo(true);
   
}

cUpdateMfCompStatusMsg::cUpdateMfCompStatusMsg(cMineComp* pComp)
{
   fpMineComp = pComp;
}

cUpdateMfCompStatusMsg::~cUpdateMfCompStatusMsg()
{
}

void   cSetMineSummMsg::SendMsg()
{
   fpMinefield->SetMineSumm();
   
}

cSetMineSummMsg::cSetMineSummMsg(cMinefield* pMfield)
{
   fpMinefield = pMfield;
   //fpMinefield->GetMineTypeList().DeleteList();
   //fpMinefield->GetMsgMineSumm().Clear();
   
}

cSetMineSummMsg::~cSetMineSummMsg()
{
}

void   cEditMinefieldMsg::SendMsg()
{
   gpGuiWin->ShowEditor(cGuiWindow::eEditMinefield);
}

cEditMinefieldMsg::~cEditMinefieldMsg()
{
}

void   cComponentStatusMsg::SendMsg()
{
   gpGuiWin->ComponentStatus(fpField);
}

cComponentStatusMsg::~cComponentStatusMsg()
{
}

void   cFieldControlMsg::SendMsg()
{
   gpGuiWin->FieldControl(fpField);
}

cFieldControlMsg::~cFieldControlMsg()
{
}

void   cEditCompMsg::SendMsg()
{
   gpGuiWin->EditComponent(fpComp);
}

cEditCompMsg::~cEditCompMsg()
{
}

void   cSimulateComponentMsg::SendMsg()
{
   fpComp->SimulateComponent (fSim);
}

cSimulateComponentMsg::~cSimulateComponentMsg()
{
}

void   cOnOffComponentMsg::SendMsg()
{
   fpComp->OnOffComponent (fOn);
}

cOnOffComponentMsg::~cOnOffComponentMsg()
{
}

void   cDuplicateComponentMsg::SendMsg()
{
   gMfieldMgr.DuplicateNextComponent ();
}

cDuplicateComponentMsg::~cDuplicateComponentMsg()
{
}

void   cDeleteComponentMsg::SendMsg()
{
   gMfieldMgr.DeleteNextComponent ();
}

cDeleteComponentMsg::~cDeleteComponentMsg()
{
}

void   cMoveMinefieldMsg::SendMsg()
{
   gMfieldMgr.MoveNextMinefield ();
}

cMoveMinefieldMsg::~cMoveMinefieldMsg()
{
}

void   cOnOffMineMsg::SendMsg()
{
	((cSimMine*)fpMine)->OnOffMine (fOn); //CMS2.0B6
//  if (gpCurObject)
//    gpCurObject->OnOffMine (fOn);
}

cOnOffMineMsg::~cOnOffMineMsg()
{
}

void   cSimulateMineMsg::SendMsg()
{

}

cSimulateMineMsg::~cSimulateMineMsg()
{
}

void   cDeleteMineMsg::SendMsg()
{
  gMfieldMgr.DeleteNextMine ();
}

cDeleteMineMsg::~cDeleteMineMsg()
{
}

void   cSetMineTypeMsg::SendMsg()
{
  fpMineComp->SetCompMineType (fpDbMine);
}

cSetMineTypeMsg::~cSetMineTypeMsg()
{
}

void   cSetMineDepthMsg::SendMsg()
{
  fpMineComp->SetCompMineDepth (fDepth);
}

cSetMineDepthMsg::~cSetMineDepthMsg()
{
}

void   cSetMineSpacingMsg::SendMsg()
{
//  gMfieldMgr.SetMineSpacing (fpMineComp, fSpacing);
}

cSetMineSpacingMsg::~cSetMineSpacingMsg()
{
}

void   cSaveMinefieldMsg::SendMsg()
{
   gMfieldMgr.SaveNextMinefield ();
}

cSaveMinefieldMsg::~cSaveMinefieldMsg()
{
}

void   cLoadMinefieldsMsg::SendMsg()
{
   //gMfieldMgr.LoadMinefields (fFilename);
}

cLoadMinefieldsMsg::~cLoadMinefieldsMsg()
{
}

void   cDuplicateMinefieldMsg::SendMsg()
{
   gMfieldMgr.DuplicateNextMinefield ();
}

cDuplicateMinefieldMsg::~cDuplicateMinefieldMsg()
{
}

void   cDeleteMinefieldMsg::SendMsg()
{
   gMfieldMgr.DeleteNextMinefield ();
}

cDeleteMinefieldMsg::~cDeleteMinefieldMsg()
{
}

void   cSaveMfStateMsg::SendMsg()
{
   gMfieldMgr.SaveNextMfState ();
}

cSaveMfStateMsg::~cSaveMfStateMsg()
{
}

void    cRemoveExplosionMsg::SendMsg()
{
   delete fpExplosion;
   fpExplosion = NULL;
}

cRemoveExplosionMsg::cRemoveExplosionMsg(cMineExplosion* pExplosion,
					 TTimeSim wait) :   
         cMsgLowRateUpdt(wait)
{
   fpExplosion = pExplosion;
}

cRemoveExplosionMsg::~cRemoveExplosionMsg()
{} 

void    cRemoveDetonationMsg::SendMsg()
{
   delete fpDisplay;
   fpDisplay = NULL;
}

cRemoveDetonationMsg::cRemoveDetonationMsg(cDetonationDisp* pDisplay,
					 TTimeSim wait) :   
         cMsgLowRateUpdt(wait)
{
   fpDisplay = pDisplay;
}

cRemoveDetonationMsg::~cRemoveDetonationMsg()
{} 

void   cFireButtonActivateMsg::SendMsg()
{
   fpMinefield->ProcessFireButMsg(fbOn);
}

cFireButtonActivateMsg::~cFireButtonActivateMsg()
{
}

void   cFireMunitionMsg::SendMsg()
{
   fpMinefield->CmdFire();
}

cFireMunitionMsg::~cFireMunitionMsg()
{
}
