/*
$RCSfile: MineStatusCreate.cc,v $
$Revision: 1.1.1.1 $
$Author: jchappel $
$Date: 1999/02/16 14:54:40 $
$Log: MineStatusCreate.cc,v $
Revision 1.1.1.1  1999/02/16 14:54:40  jchappel
Comprehensive Mine Simulator

// Revision 2.1  1998/02/18  17:16:10  ksnively
// Incorporated AP mine replacement code.
//
// Revision 2.0  1998/01/26  21:01:35  ksnively
// Baseline CMS before additions for AP mine replacements.
//
// Revision 1.1  1997/12/16  13:59:57  ksnively
// Initial revision
//
// Revision 1.4  1997/10/02  17:53:37  austin
// first working port to modsaf3.0
//
// Revision 1.3  1997/10/02  17:50:22  austin
// first working port to modsaf3.0
//
// Revision 1.3  1997/10/02  17:50:22  austin
// first working port to modsaf3.0
//
// Revision 1.2  1997/05/07  12:32:33  ksnively
// ..
//
// Revision 1.2  1997/05/07  12:32:33  ksnively
// ..
//
// Revision 1.1  1996/10/23  13:54:40  nsipes
// Initial revision
//
// Revision 1.4  1996/07/03  22:55:15  rcarp
// enhancements and bug fixes for version 1.5b9
//
// Revision 1.3  1996/05/11  21:36:32  mkappel
// Add mine age.
//
// Revision 1.3  1996/05/11  21:36:32  mkappel
// Add mine age.
//
// Revision 1.2  1996/03/07  21:29:06  mkappel
// Use IsTargetKilled.
//
// Revision 1.1  1996/03/06  19:45:05  mkappel
// New Mine Status Window
//
// Initial revision
//
$State: Exp $
*/
 
/*******************************************

   file: MineStatusCreate.cc
   
      Copyright 1995 by the Institute for Defense Analyses
      
         Institute for Defense Analyses
         1801 N. Beauregard Street
         Alexandria, Virginia 22311-1772
         703-845-2000
         
      This software was developed by IDA under U. S. Government
      contract.  For distribution information contact:
      
         U. S. Army Night Vision Directorate
         AMSEL RD NV OD CD
         10221 Burbeck Road, suite 430
         Ft. Belvoir VA 22060-5806
      
*********************************************/

/*******************************************

   MineStatusCreate.cc
   
      The display interface implementation.
      
      
   
   Created by Michael Kappel
   Modification history:
      created   
      
*********************************************/

#include "Display.h"
#include <Xm/ArrowBG.h>
#include <Xm/CascadeBG.h>
#include <Xm/Form.h>
#include <Xm/Frame.h>
#include <Xm/Label.h>
#include <Xm/LabelG.h>
#include <Xm/List.h>
#include <Xm/MainW.h>
#include <Xm/MenuShell.h>
#include <Xm/PanedW.h>
#include <Xm/PushB.h>
#include <Xm/PushBG.h>
#include <Xm/RowColumn.h>
#include <Xm/ScrollBar.h>
#include <Xm/ScrolledW.h>
#include <Xm/Text.h>
#include <Xm/TextF.h>
#include <stdio.h>

int     cMineStatusWindow::fMaxToggles = 0;
int     cMineStatusWindow::fListLineSize = 16;

Widget  cMineStatusWindow::fwStatusArea;
Widget  cMineStatusWindow::fwMinefieldName;
Widget  cMineStatusWindow::fwCompType;
Widget  cMineStatusWindow::fwDomain;
Widget  cMineStatusWindow::fwMineType;
Widget  cMineStatusWindow::fwMineDepth;
Widget  cMineStatusWindow::fwMineAge;
Widget  cMineStatusWindow::fwMineList;
Widget  cMineStatusWindow::fwScrollbar;
Widget  cMineStatusWindow::fwToggle[50];
Widget  cMineStatusWindow::fwDoneButton;

cMineComp *  cMineStatusWindow::fpMineComp = NULL;

Widget        cMineStatusWindow::CreateHeadings (Widget wParent)
{
   Widget     wHeadings, wLabel1, wLabel2;
   XmString   xmstr;
   Dimension  height, h;
   
   wHeadings = 
     XtVaCreateWidget ("headings", 
		       xmFormWidgetClass, wParent,
		       XmNfractionBase, 100,
		       NULL);

   xmstr = XmStringCreateSimple("-------------- Target ---------------");
   wLabel1 = 
     XtVaCreateManagedWidget ("totMinesHd", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmstr,
			      XmNalignment, XmALIGNMENT_CENTER,
			      XmNtopAttachment, XmATTACH_FORM,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 45,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 72,
			      NULL);
   XmStringFree(xmstr);
   
   xmstr = XmStringCreateSimple("On");
   wLabel2 = 
     XtVaCreateManagedWidget ("simButtonHd", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmstr,
			      XmNalignment, XmALIGNMENT_CENTER,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, wLabel1,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 19,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 21,
			      NULL);
   XmStringFree(xmstr);

   xmstr = XmStringCreateSimple("X");
   wLabel2 = 
     XtVaCreateManagedWidget ("simButtonHd", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmstr,
			      XmNalignment, XmALIGNMENT_CENTER,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, wLabel1,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 21,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 28,
			      NULL);
   XmStringFree(xmstr);

   xmstr = XmStringCreateSimple("Y");
   wLabel2 = 
     XtVaCreateManagedWidget ("simButtonHd", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmstr,
			      XmNalignment, XmALIGNMENT_CENTER,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, wLabel1,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 29,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 36,
			      NULL);
   XmStringFree(xmstr);

   xmstr = XmStringCreateSimple("State");
   wLabel2 = 
     XtVaCreateManagedWidget ("label", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmstr,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, wLabel1,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 37,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 44,
			      NULL);
   XmStringFree(xmstr);

   xmstr = XmStringCreateSimple("ID");
   wLabel2 = 
     XtVaCreateManagedWidget ("totMinesHd", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmstr,
			      XmNalignment, XmALIGNMENT_CENTER,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, wLabel1,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 45,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 56,
			      NULL);
   XmStringFree(xmstr);
   
   xmstr = XmStringCreateSimple("Type");
   wLabel2 = 
     XtVaCreateManagedWidget ("totMinesHd", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmstr,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, wLabel1,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 57,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 64,
			      NULL);
   XmStringFree(xmstr);
   
   xmstr = XmStringCreateSimple("Killed");
   wLabel2 = 
     XtVaCreateManagedWidget ("totMinesHd", 
			      xmLabelWidgetClass, wHeadings, 
			      XmNlabelString, xmstr,
			      XmNalignment, XmALIGNMENT_BEGINNING,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, wLabel1,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 65,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 72,
			      NULL);
   XmStringFree(xmstr);

   XtVaGetValues (wHeadings, XmNmarginHeight, &h, NULL);
   XtVaGetValues (wLabel1, XmNheight, &height, NULL);
   height = 2 * height + 3 * h ;
   XtVaSetValues (wHeadings,
		  XmNpaneMinimum, height,
		  XmNpaneMaximum, height,
		  NULL);

   XtManageChild (wHeadings);
   return wHeadings;
}

Widget    cMineStatusWindow::CreateStatusArea (Widget wParent)
{
   Widget        wStatusArea, wLabel;   
   int           width = WidthOfScreen(XtScreen(fwTopLevelShell)) - 100;
//   Arg           args[2];
   Dimension     height1, height2;

   wStatusArea = 
     XtVaCreateWidget ("form", 
		       xmFormWidgetClass, wParent, 
		       XmNfractionBase, 100,
		       XmNwidth, width,
		       XmNheight, 200,
		       NULL);

   wLabel = 
     XtVaCreateManagedWidget ("Minefield Name", 
			      xmLabelGadgetClass, wStatusArea,
			      XmNtopAttachment, XmATTACH_FORM,
			      XmNleftAttachment, XmATTACH_FORM,
			      NULL);
   fwMinefieldName = 
     XtVaCreateManagedWidget ("textbox", 
			      xmTextFieldWidgetClass, wStatusArea,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, wLabel,
			      XmNleftAttachment, XmATTACH_FORM,
			      XmNcolumns, 20,
			      XmNeditable, FALSE,
			      NULL);

   wLabel = 
     XtVaCreateManagedWidget ("Comp Type: ", 
			      xmLabelGadgetClass, wStatusArea,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, fwMinefieldName,
			      XmNtopOffset, 2,
			      XmNleftAttachment, XmATTACH_FORM,
			      NULL);
   fwCompType = 
     XtVaCreateManagedWidget ("label", 
			      xmLabelGadgetClass, wStatusArea,
			      XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET,
			      XmNtopWidget, wLabel,
			      XmNleftAttachment, XmATTACH_WIDGET,
			      XmNleftWidget, wLabel,
			      NULL);

   wLabel = 
     XtVaCreateManagedWidget ("Domain: ", 
			      xmLabelGadgetClass, wStatusArea,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, fwCompType,
			      XmNtopOffset, 2,
			      XmNleftAttachment, XmATTACH_FORM,
			      NULL);
   fwDomain = 
     XtVaCreateManagedWidget ("label", 
			      xmLabelGadgetClass, wStatusArea,
			      XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET,
			      XmNtopWidget, wLabel,
			      XmNleftAttachment, XmATTACH_WIDGET,
			      XmNleftWidget, wLabel,
			      NULL);

   wLabel = 
     XtVaCreateManagedWidget ("Mine Type: ", 
			      xmLabelGadgetClass, wStatusArea,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, fwDomain,
			      XmNtopOffset, 2,
			      XmNleftAttachment, XmATTACH_FORM,
			      NULL);
   fwMineType = 
     XtVaCreateManagedWidget ("label", 
			      xmLabelGadgetClass, wStatusArea,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, wLabel,
			      XmNleftAttachment, XmATTACH_FORM,
			      XmNleftOffset, 20,
			      NULL);

   wLabel = 
     XtVaCreateManagedWidget ("Depth (in.): ", 
			      xmLabelGadgetClass, wStatusArea,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, fwMineType,
			      XmNtopOffset, 2,
			      XmNleftAttachment, XmATTACH_FORM,
			      NULL);
   fwMineDepth = 
     XtVaCreateManagedWidget ("label", 
			      xmLabelGadgetClass, wStatusArea,
			      XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET,
			      XmNtopWidget, wLabel,
			      XmNleftAttachment, XmATTACH_WIDGET,
			      XmNleftWidget, wLabel,
			      NULL);

   wLabel = 
     XtVaCreateManagedWidget ("Age (hrs.): ", 
			      xmLabelGadgetClass, wStatusArea,
			      XmNtopAttachment, XmATTACH_WIDGET,
			      XmNtopWidget, fwMineDepth,
			      XmNtopOffset, 2,
			      XmNleftAttachment, XmATTACH_FORM,
			      NULL);
   fwMineAge = 
     XtVaCreateManagedWidget ("label", 
			      xmLabelGadgetClass, wStatusArea,
			      XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET,
			      XmNtopWidget, wLabel,
			      XmNleftAttachment, XmATTACH_WIDGET,
			      XmNleftWidget, wLabel,
			      NULL);

   fwMineList = 
     XmCreateScrolledList (wStatusArea, "list", NULL, 0);
   XtVaSetValues (fwMineList, 
		  XmNselectionPolicy, XmBROWSE_SELECT,
		  XmNvisibleItemCount, 3,
		  NULL);
   XtVaSetValues (XtParent(fwMineList),
		  XmNtopAttachment, XmATTACH_FORM,
		  XmNleftAttachment, XmATTACH_WIDGET,
		  XmNleftAttachment, XmATTACH_POSITION,
		  XmNleftPosition, 21,
		  XmNrightAttachment, XmATTACH_FORM,
		  NULL);
   XtAddCallback (fwMineList, XmNbrowseSelectionCallback,
		  (XtCallbackProc)CbMineItem, this);
   XtManageChild (fwMineList);

   XtVaGetValues (fwMineList, XmNheight, &height1, NULL);
   XtVaSetValues (fwMineList, XmNvisibleItemCount, 4, NULL);
   XtManageChild (fwMineList);
   XtVaGetValues (fwMineList, XmNheight, &height2, NULL);
   fListLineSize = height2 - height1;
   XtVaSetValues (XtParent(fwMineList), XmNbottomAttachment, XmATTACH_FORM, NULL);
   XtManageChild (fwMineList);

   XtVaGetValues (XtParent(fwMineList), XmNverticalScrollBar, &fwScrollbar, NULL);
   XtAddCallback(fwScrollbar, XmNdecrementCallback    , (XtCallbackProc)CbScroll, this);
   XtAddCallback(fwScrollbar, XmNdragCallback         , (XtCallbackProc)CbScroll, this);
   XtAddCallback(fwScrollbar, XmNincrementCallback    , (XtCallbackProc)CbScroll, this);
   XtAddCallback(fwScrollbar, XmNpageDecrementCallback, (XtCallbackProc)CbScroll, this);
   XtAddCallback(fwScrollbar, XmNpageIncrementCallback, (XtCallbackProc)CbScroll, this);
   XtAddCallback(fwScrollbar, XmNtoBottomCallback     , (XtCallbackProc)CbScroll, this);
   XtAddCallback(fwScrollbar, XmNtoTopCallback        , (XtCallbackProc)CbScroll, this);
   XtAddCallback(fwScrollbar, XmNvalueChangedCallback , (XtCallbackProc)CbScroll, this);

   XtManageChild( wStatusArea );
   XtAddEventHandler(wStatusArea, StructureNotifyMask, FALSE,
		     (XtEventHandler)CbResize, (XtPointer)this);
   return wStatusArea;
}

Widget cMineStatusWindow::CreateActionArea (Widget wParent)
{
   Widget     wActionArea, wButton;
   Dimension  height, h;

   wActionArea = 
     XtVaCreateWidget ("action_area", 
		       xmFormWidgetClass, wParent,
		       XmNfractionBase, 100,
		       XmNleftAttachment, XmATTACH_FORM,
		       XmNrightAttachment, XmATTACH_FORM,
		       XmNbottomAttachment, XmATTACH_FORM,
		       NULL);
   fwDoneButton = 
     XtVaCreateManagedWidget ("Done", 
			      xmPushButtonWidgetClass, wActionArea,
			      XmNtopAttachment, XmATTACH_FORM,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 25,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 40,
			      NULL);
   XtAddCallback( fwDoneButton, XmNactivateCallback, 
		 (XtCallbackProc)CbDone, (XtPointer) this);
   wButton = 
     XtVaCreateManagedWidget ("Cancel", 
			      xmPushButtonWidgetClass, wActionArea,
			      XmNtopAttachment, XmATTACH_FORM,
			      XmNleftAttachment, XmATTACH_POSITION,
			      XmNleftPosition, 60,
			      XmNrightAttachment, XmATTACH_POSITION,
			      XmNrightPosition, 75,
			      XmNsensitive, FALSE,
			      NULL);
   XtAddCallback( wButton, XmNactivateCallback, 
		 (XtCallbackProc)CbCancel, (XtPointer) this);

   XtVaGetValues (wActionArea, XmNmarginHeight, &h, NULL);
   XtVaGetValues (wButton, XmNheight, &height, NULL);
   height =  height + 2 * h ;
   XtVaSetValues (wActionArea,
		  XmNpaneMinimum, height,
		  XmNpaneMaximum, height,
		  NULL);

   XtManageChild( wActionArea );
   return wActionArea;
}

cMineStatusWindow::cMineStatusWindow (Widget wParent)
   // the constructor creates the window and its widgets,
   // initializing with input values
{
   Widget        wHeadings, wActionArea;

   fwMainWin =
     XtVaCreateWidget ("pane",
             xmPanedWindowWidgetClass, wParent,
             XmNtopAttachment, XmATTACH_FORM,
             XmNbottomAttachment, XmATTACH_FORM,
             NULL);
             
   wHeadings = CreateHeadings (fwMainWin);
   fwStatusArea = CreateStatusArea (fwMainWin);
   wActionArea = CreateActionArea (fwMainWin);
}

cMineStatusWindow::~cMineStatusWindow()
{
}
