/*
$RCSfile: TestMode.h,v $
$Revision: 1.1.1.1 $
$Author: jchappel $
$Date: 1999/02/16 14:54:53 $
$Log: TestMode.h,v $
Revision 1.1.1.1  1999/02/16 14:54:53  jchappel
Comprehensive Mine Simulator

 * Revision 2.0  1998/01/26  21:04:20  ksnively
 * Baseline CMS before additions for AP mine replacements.
 *
 * Revision 2.0  1998/01/26  21:04:20  ksnively
 * Baseline CMS before additions for AP mine replacements.
 *
 * Revision 1.1  1997/12/16  13:59:57  ksnively
 * Initial revision
 *
 * Revision 1.3  1997/10/27  17:07:30  trang
 * BUILD1
 *
 * Revision 1.2  1997/10/02  17:47:47  austin
 * first working port to modsaf3.0
 *
Revision 1.2  1997/10/02 17:47:47  austin
first working port to modsaf3.0

 * Revision 1.1  1996/10/23  13:54:40  nsipes
 * Initial revision
 *
 * Revision 1.1  1996/10/23  13:54:40  nsipes
 * Initial revision
 *
 * Revision 1.5  1996/06/19  19:05:45  rcarp
 * revisions for mine vulnerability, version 1.5b2
 *
 * Revision 1.4  1996/05/14  16:15:08  rcarp
 * refinements and bug fixes for 1.5 delivery
 *
 * Revision 1.1  1996/03/16  18:36:36  mkappel
 * Interface for Test Mode files.
 *
 * Revision 1.1  1996/03/16  18:36:36  mkappel
 * Interface for Test Mode files.
 *
 * Initial revision
 *
$State: Exp $
*/
 
/*******************************************

   file: TestMode.h
   
      Copyright 1995 by the Institute for Defense Analyses
      
         Institute for Defense Analyses
         1801 N. Beauregard Street
         Alexandria, Virginia 22311-1772
         703-845-2000
         
      This software was developed by IDA under U. S. Government
      contract.  For distribution information contact:
      
         U. S. Army Night Vision Directorate
         AMSEL RD NV OD CD
         10221 Burbeck Road, suite 430
         Ft. Belvoir VA 22060-5806
      
*********************************************/

/*******************************************

   TestMode.h
   
      The header file defines the test mode interface classes.
      
      
   
   Created by Michael Kappel
   Modification history:
      created   
      
*********************************************/

#ifndef _TestMode_
#define _TestMode_

#include "Globals.h"
#include "Display.h"
#include "Vehicle.h"

class cTestModeWindow : public cShellWindow {

private:
   Widget     fwList;
   Widget     fwStartButton;

   Widget     CreateWorkArea (Widget wParent);
   Widget     CreateActionArea (Widget wParent);

   static void  CbSelect  (Widget, XtPointer, XmListCallbackStruct*);
   static void  CbStart   (Widget, XtPointer, XmPushButtonCallbackStruct*);
   static void  CbNewFile (Widget, XtPointer, XmPushButtonCallbackStruct*);
   static void  CbCancel  (Widget, XtPointer, XmPushButtonCallbackStruct*);
   static void  CbFileOK  (Widget, XtPointer, XmFileSelectionBoxCallbackStruct*);

public:
                cTestModeWindow (Widget parent);
   virtual     ~cTestModeWindow ();
};

struct TTurnParam : public cDbStruct {
 
	enum { eturnkwTime, eturnkwVelocity, eturnSizeTable };
   static const TKeywordEntry fTurnParamTable[eturnSizeTable];

   TTimeSim      fTurnTime;
   TVelocity     fNewVelocity;   // tcc coord system
   
   virtual   EBoolean      ParseDbStructItem(cInFileObj& infile);
   
             TTurnParam(TTimeSim turnTime = 0);
   virtual  ~TTurnParam();
};

class cTestVehicle : public cSimVehicle {
 
 protected:
	enum { etestvehkwStartTime, etestvehkwEndTime,  etestvehkwStartLoc,
          etestvehkwStartVel,
          etestvehkwProbKill, etestvehkwTurnParam, 
          etestvehkwPartParam,  etestvehSizeTable };
   static const TKeywordEntry fTestVehTable[etestvehSizeTable];
   
   int           fNextTurnParam;

   cDbVeh*       fpDbVeh;
   TParamList    fTurnParam;   // list of turn param records
   TTimeSim      fStartTime;
   TTimeSim      fEndTime;
   float         fProbKill;

   TTimeSim      fBaseTime;      // time file read

 public:
               EBoolean  ParseTestVehEntry(cInFileObj& infile);
               EBoolean  ReadTestVehParams(cInFileObj& infile);
               
               void      NextTurn();
   virtual     void      UpdateVehicle();
 
               cTestVehicle( cDbVeh* pDbVeh);
   virtual    ~cTestVehicle();
};

class cTestVehTurnMsg : public cMsgLowRateUpdt {

   cTestVehicle*   fpTestVeh;
   
   public:
      virtual   void           SendMsg();
   
                cTestVehTurnMsg(cTestVehicle* pTestVeh, 
                               TTimeSim time = 0, EBoolean bAbsTime = false);
      virtual  ~cTestVehTurnMsg();
};

#endif
