/**
* @date   September 15, 1998 ( Last Updated September 21, 1998 )
*/

import java.util.Hashtable;
import java.io.*;


/**
*
* It is a textual user interface to control HBD object.
*
* @author H. Timucin Ozdemir
* @date   September 15, 1998 ( Last Updated September 21, 1998 )
*/
public class 
HBDaemonTxtGUI extends RunnerObject implements HBDaemonCommands 
{

  /** */
  HeartBeat._ReportAdminImplBase daemon;

  /** */
  boolean  daemonState = false;

  /** */
  Hashtable  cmds;

  /**
  */
  public HBDaemonTxtGUI( HeartBeat._ReportAdminImplBase _daemon )
  {
     daemon = _daemon;
     cmds   = new Hashtable();
     cmds.put( HBDaemonCommands.startCmd, new startDaemon(this) );
     cmds.put( HBDaemonCommands.stopCmd,  new stopDaemon(this) );
     cmds.put( HBDaemonCommands.exitCmd,  new exitDaemon(this) );

  }// end of CONSTRUCTOR

  /**
  */
  public void
  run( )
  {
     String command = "";
     Command cmd;

     boolean started = false;

     try
     {
        while( true )
        {
           yield();
           command = displayMenu();
           yield();
           cmd = (Command) cmds.get(command);
           if( cmd!=null ) 
             cmd.execute();
           else 
             System.out.println(" ERROR: Unrecognized command! ");
           //yield();

        }// end of while

     } catch(java.io.IOException ioe)
       { if( isDaemonRunning() ) stopDaemon(); }

  }// end of run() 

  /**
  */
  String displayMenu() throws java.io.IOException
  {
     String line = null;
    
     while(line==null)
     {
        System.out.print(  " start : starts the daemon\n"
                          +" stop  : stops the daemon \n"
                          +" read  : starts reporting \n"
                          +" close : stops reporting  \n"
                          +" exit  : ?                \n"
                          +" command : ");
          DataInput d = new DataInputStream(System.in);
          line = d.readLine();

      }// end of while

      return line;

  }// end of displayMenu()

  /**
  */
  public boolean isDaemonRunning()  { return daemonState; }

  /**
  */
  public void startDaemon()  { daemon.start(); daemonState=true; }

  /**
  */
  public void stopDaemon()  
  { 
     System.out.println(" in HBDaemonTxtGUI::stopDaemon() ");
     daemon.stop(); daemonState=false; 
  }

}// end of HBDaemonTxtGUI


