/**
* @date   September 14, 1998 ( Last Updated September 15, 1995)
*
*/

import java.util.Enumeration;
import java.util.Hashtable;
import org.omg.CORBA.*;

/**
*
* broadcasts a register message.
*
* @author H. Timucin Ozdemir
* @date   September 14, 1998 ( Last Updated September 21, 1998)
*
*/
public class 
RegisterBroadcaster extends RunnerObject
{
    /** */
    HeartBeatServant   central;

    /** */
    HeartBeat.HeartBeatListener  newComerHBL;

    /** */
    String             newComerName;

    /** */
    Hashtable          maps;

    /** */
    Hashtable          simaps;

    /** */
    int                id;

    /**
    */
    public RegisterBroadcaster()
    {
    }// end of CONSTUCTOR

    /**
    */
    public void 
    broadcast( HeartBeatServant _central, HeartBeat.HeartBeatListener _newComerHBL, 
               String _newComerName, int _id, Hashtable _maps, Hashtable _simaps)
    {
       if( _maps.size()>0 )
       {
               central = _central;
           newComerHBL = _newComerHBL;
          newComerName = _newComerName;
                  maps = _maps;
                simaps = _simaps;
                    id = _id;
          start();

       }// end of if

    }// end of broadcast()

    /**
    *
    * Sends <b>register()</b> message to the interested parties.
    *
    */
    public final void run()
    {
       HeartBeat.HeartBeatListener hb;
       Enumeration e = maps.keys();
       String srvKey;

       // Broadcast all others this registration
       while( e.hasMoreElements() )
       {
          srvKey = (String) e.nextElement();

          if( srvKey!=null && !srvKey.equals(newComerName) )
          {
             hb = (HeartBeat.HeartBeatListener) maps.get(srvKey);
             if( hb!=null )
               try
               {  hb.register(newComerName,id,newComerHBL);
               } catch(  org.omg.CORBA.SystemException se)
                 {  // delete(srvKey);
                 }

          }// end of if

       }// end of while

       e = maps.keys();

       // Broadcast all others to the new comer
       // try
       // {
       while( e.hasMoreElements() )
       {
          srvKey = (String) e.nextElement();

          if( srvKey!=null && !srvKey.equals(newComerName) )
          {
             hb = (HeartBeat.HeartBeatListener) maps.get(srvKey);
             if( hb!=null )
             {
               ServerInfo sv = (ServerInfo) simaps.get(srvKey);

               if( sv!=null )
                 try
                 {  newComerHBL.register(srvKey,sv.getId(),hb);
                 } catch(  org.omg.CORBA.SystemException se)
                   {  // delete(hName); 
                   }

             }// end of if

          }// end of if

       }// end of while

       // } catch(  org.omg.CORNBA.SystemException se)
       //   {  // delete(hName); }

    }// end of run

}// end of RegisterBroadcaster()

