/**
* @date   September 14, 1998 ( Last Updated September 15, 1998)
*/

import java.util.Enumeration;
import java.util.Hashtable;
import org.omg.CORBA.*;

import HeartBeat.*;
import HeartBeat.ReportListenerPackage.*;


/**
*
* publishes a report to the ReportListener objects. If it finds that
* they are not accessible, tells its master to remove it.
*
* @author H. Timucin Ozdemir
* @date   September 14, 1998 ( Last Updated September 21, 1998)
*
*/
public class 
ReportBroadcaster extends RunnerObject
{
    /** */
    Enumeration        e;

    /** */
    HeartBeat.ReportListenerPackage.ServerItem r[];

    /** */
    HeartBeat.ReportAdmin   master = null;

    /**
    */
    public ReportBroadcaster()
    {
        this(null);

    }// end of CONSTUCTOR

    /**
    */
    public ReportBroadcaster(HeartBeat.ReportAdmin _master)
    {
        setPriority(Thread.MAX_PRIORITY);
        master = _master;

    }// end of CONSTUCTOR

    /**
    */
    public void 
    broadcast( Enumeration _e, HeartBeat.ReportListenerPackage.ServerItem[] _r)
    {
       e = _e;
       r = _r;
       if( r.length>0 && e.hasMoreElements() ) start();

    }// end of broadcast()

    /**
    *
    * Sends <b>report()</b> message to the interested parties.
    *
    */
    public final void run()
    {
       System.out.println(" in ReportBroadcaster::run() ");
       HeartBeat.ReportListener rl;

       // Broadcast report to all listeners 
       while( e.hasMoreElements() )
       {
          rl = (HeartBeat.ReportListener) e.nextElement();
          if( rl!=null )
            try
            {  rl.report(r);
            } catch( org.omg.CORBA.SystemException se) 
              { if(master!=null) master.remove(rl); }
              catch( java.lang.Exception ne) 
              { if(master!=null) master.remove(rl); }

       }// end of while

    }// end of run

}// end of ReportBroadcaster()

