/**
* @date   September 14, 1998 ( Last Updated September 21, 1998)
*
*/

import java.util.Enumeration;
import org.omg.CORBA.*;

/**
*
* Timer. Sleeps for the interval.
* Then sends alive message to each group member.
* sends <b>ticked</b> message to its HBL object.
*
* @author H. Timucin Ozdemir
* @date   September 14, 1998 ( Last Updated September 21, 1998)
*
*/
public class 
Ticker extends RunnerObject implements HBLDebug
{
    /** */
    HeartBeatServant  heart;

    /** */
    int               sleepInterval;

    /** */
    String            name;

    /** */
    boolean           stay = true;

    /**
    */
    public Ticker(HeartBeatServant _heart, int _sleepInterval) 
    {
       heart = _heart ;
       sleepInterval = _sleepInterval;
       name = heart.getName();
       setPriority(Thread.MAX_PRIORITY); 

    }// end of CONSTUCTOR

    /**
    *
    * Sends <b>alive()</b> message to the interested parties.
    *
    */
    public final void run()
    {
       Enumeration e;
       HeartBeat.HeartBeatListener budy;

       debug(" in Ticker::run() ");

       while(stay)
       {
          try 
          {  // fiesta time
             runner.sleep(sleepInterval);
          } catch(InterruptedException  ie)
            { debug(" ***Interrupted!** "); stay=false; }// what do you want?

          // Party Time, Let's talk my budies
          e = heart.getBudies(); 

          while( e.hasMoreElements() )
          {
             budy = (HeartBeat.HeartBeatListener) e.nextElement();

             if( budy!=null )
             {
                try
                {  // It is good to be alive
                   budy.alive(name);
                } catch(org.omg.CORBA.SystemException se) {}
                  catch(Exception se) {}

             }// end of if

          }// end of while

          heart.ticked();

       }// end of while()

    }// end of run

    /**
    */
    public void
    destroy()
    {
       stay = false;
       stop();

    }// end of destroy()

    /**
    */
    public void
    debug(String mess)
    {
       if(TCK_DEBUG) System.out.println(mess);

    }// end of debug

}// end of Ticker()
