#!/usr/local/bin/perl
#
# Non-parsed headers CGI 1.1 error script in Perl to handle error requests
# from NCSA HTTPd 1.4 via ErrorDocument.  This should handle all errors in 
# almost the same fashion as NCSA HTTPd 1.4 would internally.
#
# This script is in the Public Domain.  NCSA and the author offer no
# guaruntee's nor claim any responsibility for it.  That's as pseudo-legalise
# as I get.
#
# This script doesn't do any encryption or authentication, nor does it
# contain hooks to do so.
#
# This was written for Perl 4.016.  I've heard rumours about it working with
# other versions, but I'm no Perl hacker, so how would I know?
#
# Brandon Long / NCSA HTTPd Development Team / Software Development Group 
# National Center for Supercomputing Applications / University of Illinios
#
# For more information:
# NCSA HTTPd    : http://hoohoo.ncsa.uiuc.edu/docs/
# CGI 1.1       : http://hoohoo.nsca.uiuc.edu/cgi/
# ErrorDocument : http://hoohoo.ncsa.uiuc.edu/docs/setup/srm/ErrorDocument.html
# Example CGI   : http://hoohoo.ncsa.uiuc.edu/cgi/ErrorCGI.html
#

$error = $ENV{'QUERY_STRING'};
$redirect_request = $ENV{'REDIRECT_REQUEST'};
($redirect_method,$request_url,$redirect_protocal) = split(' ',$redirect_request);
$redirect_status = $ENV{'REDIRECT_STATUS'};
if (!defined($redirect_status)) {
  $redirect_status = "200 Ok";
}
($redirect_number,$redirect_message) = split(' ',$redirect_status);
$error =~ s/error=//;

$title = "<HEAD><TITLE>".$redirect_status."</TITLE></HEAD>";

if ($redirect_method eq "HEAD") {
	$head_only = 1;
} else {
	$head_only = 0;
}

printf("Content-type: text/plain\r\n");

printf("<html>\r\n");
printf("<body>\r\n");

printf("%s %s\r\n",$ENV{'SERVER_PROTOCOL'},$redirect_status);
printf("Server: %s <br>\r\n",$ENV{'SERVER_SOFTWARE'});

printf("\r\n <b>CGI/1.1 test script report</b> <br>\r\n");
 

printf("\r\n <hr> \r\n");

printf("<table border=2> \r\n");

printf("<tr> <td>\r\n");
printf("AUTH_TYPE </td><td> %s \r\n",$ENV{'AUTH_TYPE'});
printf("</td> </tr>\r\n");

printf("<tr> <td>\r\n");
printf("CONTENT_LENGTH </td><td> %s \r\n",$ENV{'CONTENT_LENGTH'});
printf("</td> </tr>\r\n");

printf("<tr> <td>\r\n");
printf("CONTENT_TYPE </td><td> %s \r\n",$ENV{'CONTENT_TYPE'});
printf("</td> </tr>\r\n");

printf("<tr> <td>\r\n");
printf("GATEWAY_INTERFACE </td><td> %s \r\n",$ENV{'GATEWAY_INTERFACE'});
printf("</td> </tr>\r\n");

printf("<tr> <td>\r\n");
printf("HTTP_ACCEPT </td><td> %s \r\n",$ENV{'HTTP_ACCEPT'});
printf("</td> </tr>\r\n");

printf("<tr> <td>\r\n");
printf("HTTP_USER_AGENT </td><td> %s \r\n",$ENV{'HTTP_USER_AGENT'});
printf("</td> </tr>\r\n");

printf("<tr> <td>\r\n");
printf("PATH_INFO </td><td> %s \r\n",$ENV{'PATH_INFO'});
printf("</td> </tr>\r\n");

printf("<tr> <td>\r\n");
printf("PATH_TRANSLATED </td><td> %s \r\n",$ENV{'PATH_TRANSLATED'});
printf("</td> </tr>\r\n");

printf("<tr> <td>\r\n");
printf("QUERY_STRING </td><td> %s \r\n",$ENV{'QUERY_STRING'});
printf("</td> </tr>\r\n");

printf("<tr> <td>\r\n");
printf("REMOTE_ADDR </td><td> %s \r\n",$ENV{'REMOTE_ADDR'});
printf("</td> </tr>\r\n");

printf("<tr> <td>\r\n");
printf("REMOTE_HOST </td><td> %s \r\n",$ENV{'REMOTE_HOST'});
printf("</td> </tr>\r\n");

printf("<tr> <td>\r\n");
printf("REMOTE_IDENT </td><td> %s \r\n",$ENV{'REMOTE_IDENT'});
printf("</td> </tr>\r\n");

printf("<tr> <td>\r\n");
printf("REMOTE_USER </td><td> %s \r\n",$ENV{'REMOTE_USER'});
printf("</td> </tr>\r\n");

printf("<tr> <td>\r\n");
printf("REQUEST_METHOD </td><td> %s \r\n",$ENV{'REQUEST_METHOD'});
printf("</td> </tr>\r\n");

printf("<tr> <td>\r\n");
printf("SCRIPT_NAME </td><td> %s \r\n",$ENV{'SCRIPT_NAME'});
printf("</td> </tr>\r\n");

printf("<tr> <td>\r\n");
printf("SERVER_NAME </td><td> %s \r\n",$ENV{'SERVER_NAME'});
printf("</td> </tr>\r\n");

printf("<tr> <td>\r\n");
printf("SERVER_PORT </td><td> %s \r\n",$ENV{'SERVER_PORT'});
printf("</td> </tr>\r\n");

printf("<tr> <td>\r\n");
printf("SERVER_PROTOCOL </td><td> %s \r\n",$ENV{'SERVER_PROTOCOL'});
printf("</td> </tr>\r\n");

printf("<tr> <td>\r\n");
printf("SERVER_SOFTWARE </td><td> %s \r\n",$ENV{'SERVER_SOFTWARE'});
printf("</td> </tr>\r\n");

printf("</table> \r\n");

printf("\r\n <hr> \r\n");
printf("</body></html>\r\n");
