/**
* Test for servlets which try to access the same server for document.
*
* Q: What happens if it tries to access a another servlet?
*    If it is already loaded, then OK.
*    If it is not but it can be loaded without circular dependency, then
*    again it is OK.
*    If there is a circular dependency between these servlets, then
*    there is nothing I can do right NOW!
*
*/

import java.io.*;
import java.util.Enumeration;
import java.net.*;

import javax.servlet.*;
import javax.servlet.http.*;

/**
* PropertiesTest. This servlet simply list the initial parameters. 
*
*/
public
class AutoEcho extends HttpServlet {
    
    Enumeration  params;
    ServletConfig myCnf;
    String moduleUrl;
    

    public void
    readFileFromURL(PrintStream out)
    {
       if(moduleUrl!=null)
       { 
          URL address = null;
          DataInputStream file = null;

          System.out.println(" I am in parse() of "+moduleUrl);

          try
          {
             /*****************/
             /** create a URL */
             /*****************/
             address = new URL(moduleUrl);

           } catch( MalformedURLException e)
             {
 
                System.out.println(" Can't create URL from the given path ");
                e.printStackTrace();
                return ;
              }

           System.out.println(" I got the address () ");
      try
      {

         if( address != null )
         {
            /****************************************/
            /** opens a Module Name Repository file */
            /****************************************/
            file = new DataInputStream( address.openStream() );

            System.out.println(" I opened the file () ");

         } else   System.out.println(" I opened the file () ");

      } catch(IOException e)
        {
           System.out.println(" Can't open given file ");
           e.printStackTrace();
           return ;
        }

     if( file != null )
      {
         /*********************************/
         /** It looks like file is exist. */
         /*********************************/

         try
         {
            System.out.println(" File is not empty ");
            String  module = null;

            /*************************************/
            /** As long as we can read something */
            /*************************************/

            while( ( module = file.readLine() ) != null )
            {
 
               out.println(module+"<br>");
               
            }// end of while
            out.println(module+"<br>");
 
            file.close(); 

         } catch(IOException e)
           {
              System.out.println(" Read error");
              e.printStackTrace();
              return ;
           }
      }

       }// end of if

    }// end of printProperties()

    public void
    printProperties(PrintStream out)
    {
       String str;
       Enumeration  e=params;

       for(;e.hasMoreElements() ;) 
       {
          str = (String) e.nextElement();
          out.println(str+"<br>");
       }

    }// end of printProperties()

    public void
    printProperties(ServletOutputStream out) throws  IOException
    {
       String str;
       String val;
       Enumeration  e=params;

       if(!e.hasMoreElements()) System.out.println(" *** NO ELEMENT ** ");
       for(;e.hasMoreElements() ;) 
       {
          str = (String) e.nextElement();
          val =  myCnf.getInitParameter(str);
          out.println(str+" = "+val+" <br>");
          System.out.println(str+" = "+val+" <br>");

       }// end of for

    }// end of printProperties()

    public void 
    init(ServletConfig myConfig)
    {
       System.out.println(" ****** In init() of class PropertiesTest");
       params = myConfig.getInitParameterNames();
       myCnf  = myConfig;
       printProperties(System.out);
       moduleUrl = myConfig.getInitParameter("ModuleFileURL");
       System.out.println(" moduleUrl : "+moduleUrl);
       readFileFromURL(System.out);
       
    }

    public void doGet (HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException
    {
       System.out.println(" ****** In doGet of class PropertiesTest");
       String str; 
	   res.setContentType("text/html");

	   ServletOutputStream out = res.getOutputStream();
	   out.println("<html>");
	   out.println("<head><title>PropertiesTest</title></head>");
	   out.println("<body>");
	   out.println("<h1>PropertiesTest</h1><br>");

       params = myCnf.getInitParameterNames();
       printProperties(out);
       readFileFromURL(new PrintStream(out));

	   out.println("</body></html>");
    }

    public String 
    getServletInfo() 
    {
	   return "Create a page that says <i>PropertiesTest</i> and send it back";
    }
}
