
import java.io.*;
import java.util.*;

import javax.servlet.*;
import javax.servlet.http.*;

/**
 */

public
class Naming extends GenericServlet 
{

    String NamingFile  = null;
    Hashtable interfaces = null;

    public void init(ServletConfig initialParameters) throws ServletException
    {
       //super.init(initialParameters);

       NamingFile = initialParameters.getInitParameter("NAMESERVICE");

       //System.out.println(" NamingFile : "+NamingFile);
  
       if(NamingFile!=null) 
       { 
         loadInterfaces();
         listInterfaces(new PrintWriter(System.out));
       }

    }// end of init()

   /**
   */
   void
   parseline(String line)
   {
      String strline = line.trim().replace('=',' ');
      StringTokenizer sT = new StringTokenizer(strline);

      int numberOfTokens = sT.countTokens();
      String[] tokens = new String[numberOfTokens];
      for(int i=0;i<numberOfTokens;i++) tokens[i] = sT.nextToken();

      //System.out.println("I am gonna parse :"+line);
      //System.out.println("I am gonna parse :"+strline);

      if( numberOfTokens>3 && tokens[0].equals("IDL") && 
          tokens[2].equals("IOR") && tokens[1]!=null && tokens[3]!=null)
      {
         if(interfaces.contains(tokens[1])) interfaces.remove(tokens[1]);

         interfaces.put(tokens[1],tokens[3]);

      }// end of if

   }// end of parseline()


    /**
    * Reads the file 
    */
    void loadInterfaces()
    {
       File nameFile = new File(NamingFile);
       interfaces = new Hashtable();

       if(nameFile.exists() && nameFile.canRead())
       {

         try
         {
            BufferedReader bufReader =
                           new BufferedReader(new FileReader(nameFile) );

            //System.out.println(" Naming Definition File is  exist! ");
            String line;

            while( (line = bufReader.readLine()) != null )
            {
                line = line.trim();

                if(line.length()>0 && !line.startsWith("#") )
                         parseline(line);

             }// end of while

             bufReader.close();

         } catch(FileNotFoundException fnde) { }
           catch(IOException ioe) { }

       }// end of if
     
    }// end of loadInterfaces()

    /**
    */
    void listInterfaces(PrintWriter out)
    {
      
        Enumeration keys = interfaces.keys();

        for (; keys.hasMoreElements() ;)
        {
           String key = (String) keys.nextElement();
           if(key!=null)
           {
              String ior = (String)interfaces.get(key);
              if(ior!=null) out.println("IDL:"+key+" IOR:"+ior);

           } // end of if 

        }// end of for

    }// end of listInterfaces()

    /**
    * Reads the file 
    */
    public void
    service(ServletRequest req, ServletResponse res) 
            throws ServletException,IOException
    {
       String command = req.getParameter("cmd");

       loadInterfaces();
       //System.out.println(" command : "+command);
       //if(interfaces!=null) System.out.println(" interface : not NULL" );
       //else System.out.println(" interface : is NULLLL ");

       if(command!=null && command.equals("getIOR") && interfaces!=null ) 
            service_getIOR(req,res);
       if(command!=null && command.equals("list") && interfaces!=null ) 
            service_list(req,res);
       else service_unknown(res,command);
       
       //System.out.println(command+" is being served by ME !! ");

    }// end of init() 

    /**
    */
    void service_getIOR(ServletRequest req, ServletResponse res)
    {
       //System.out.println("I am in service_getIOR ");
       res.setContentType("text/html");

       try
       {
         OutputStream os = res.getOutputStream();
         PrintStream out = new PrintStream(os);
         
         String idl = req.getParameter("IDL");
         if( idl!= null)
         {
            String ior = (String) interfaces.get(idl); 
            
            if(ior!=null) out.println(ior);  
            //else System.out.println("Interface does not exist!");
         }
         //else  System.out.println("IDL is NULL");

         out.flush();

       } catch(java.io.IOException e)
         {  //System.out.println("IOException in service_refresh() : "+e);
            e.printStackTrace();
         }

    }// end of getIOR()

    void service_list(ServletRequest req, ServletResponse res)
    {
       //System.out.println("I am in service_getIOR ");
       res.setContentType("text/html");

       try
       {
         OutputStream os = res.getOutputStream();
         PrintWriter out = new PrintWriter(os);
         listInterfaces(out);
         
         out.flush();

       } catch(java.io.IOException e)
         {  //System.out.println("IOException in service_refresh() : "+e);
            e.printStackTrace();
         }

    }// end of service_list() 

    /**
    * Unknown command received on URL. Return a message with "unknown command"
    * in it.
    * @param res: a ServletResponse, an object that contains the response of the
    *             servlet.
    * @param command: String containing the command with which the servlet was
    *                 invoked
    */
    void service_unknown(ServletResponse res, String command)
    {
       res.setContentType("text/html");
       try
       {
          OutputStream os = res.getOutputStream();
          PrintStream out = new PrintStream(os);
          out.println("Unknown command: " + command);
          out.flush();

       }catch(java.io.IOException e){System.out.println(e);}

    }// end of service_unknown()



    public void 
    doGet (HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException
    {
	res.setContentType("text/html");

	ServletOutputStream out = res.getOutputStream();
	out.println("<html>");
	out.println("<head><title>Hello World</title></head>");
	out.println("<body>");
	out.println("<h1>Hello World</h1>");
	out.println("</body></html>");
    }

    public String getServletInfo() {
	return "Naming servlet" ;
    }
}
