/**
* @author H. Timucin OZDEMIR
*/

import java.applet.*;
import java.awt.*;

public class 
Bench extends Applet implements Runnable
{
    Grapher panel;
    TestInputPanel inputPanel;
    Thread runner;
    int type = 0;
    int size = 100;
    int step = 10;
    Benchmarker sampler;
    Benchmark   benchInstance;

    public void 
    init() 
    {
        setLayout(new BorderLayout());

        panel = new Grapher(100);
        add("Center", panel);

        inputPanel = new TestInputPanel(this);
        add("West", inputPanel);

        sampler = new Benchmarker();
        getServer(); 

    }// end of init()

    /**
    */
    String getIOR()
    {

       String retIOR=null;


       try
       {
          URL address = getCodeBase();
          String host = address.getHost();
          int port = address.getPort();

          String query = new String("http://"+host+":"+port+"/servlet/naming?");
          query += "cmd=getIOR&";
          query += "IDL=IDL:Benchmark:1.0";
          System.out.println(" query :"+query);

          URL namingURL = new URL(query);

          DataInputStream dis = new DataInputStream( namingURL.openStream());
          retIOR = dis.readLine();

       } catch(MalformedURLException mfue) {}
         catch(IOException ioe) {}

       return retIOR;

    }// end of getIOR()


    /**
    */
    void getServer()
    {
       String ior = getIOR();

       if(ior!=null)
       {
          ORB orb = ORB.init(null,null);
          org.omg.CORBA.Object objRef = orb.string_to_object(ior);
          benchInstance = BenchmarkHelper.narrow(objRef);

       }// end of if

    }// end of getServer() 

    /**
    */
    public void 
    startThread() 
    {
      if(runner==null)
      {
         runner=new Thread(this);
         runner.setPriority(Thread.MIN_PRIORITY);
         runner.start();
      }

    }

    /**
    */
    double 
    f(double x)
    {
       return (Math.cos(x/5) + Math.sin(x/7) + 2) * size().height / 4;
    }


    /**
    */
    public void 
    run() 
    {
        //panel.start();

        int x= 0;
        while(x<100)
        {

           panel.addPoint((float)f((x%4)*3f));
           x = (x+1) % 100; 
           System.out.println("x "+x);
        } 
    }

    /**
    */
    public void 
    stop() 
    {
        //panel.stop();
        runner.stop();
        runner = null;
    }

    /**
    */
    public boolean 
    action(Event evt, Object arg) 
    {
        return false;
    }

    /**
    */
    public String 
    getAppletInfo() 
    {
      return "Title: Benchmarker \nAuthor: H. Timucin Ozdemir";
    }
    
    /**
    *
    * 1. Stop the current benchmark
    * 2. Update the array size
    * 3. Resume the benchmark.
    *
    * Note: Do not allow to start a benchmark before completing the
    *       necessary settings.
    */
    public void
    setArraySize(int arrSize)
    {

      if(arrSize>0) size = arrSize;
     
    }// end of setArraySize()

    public void
    setTestType(int _type)
    {
       if(_type>=0 && _type<4) type = _type;
    }

    public void
    setTestSize(int _size)
    {
       if(_size>0) size = _size;
    }

}// end of Class Bench
