/**
* @date   September 14, 1998 ( Last Updated September 15, 1998)
*/

import java.util.Enumeration;
import java.util.Hashtable;
import org.omg.CORBA.*;

import HeartBeat.*;
import HeartBeat.ReportListenerPackage.*;


/**
*
* publishes a report to the ReportListener objects. If it finds that
* they are not accessible, tells its master to remove it.
*
* @author H. Timucin Ozdemir
* @date   September 14, 1998 ( Last Updated September 21, 1998)
*
*/
public class 
ReportBroadcaster extends RunnerObject
{
    /** */
    Hashtable        e;

    /** */
    HeartBeat.ReportListenerPackage.ServerItem r[];

    /** */
    HeartBeat.ReportAdmin   master = null;

    /**
    */
    public ReportBroadcaster()
    {
        this(null);

    }// end of CONSTUCTOR

    /**
    */
    public ReportBroadcaster(HeartBeat.ReportAdmin _master)
    {
        setPriority(Thread.MAX_PRIORITY);
        master = _master;

    }// end of CONSTUCTOR

    /**
    */
    public void 
    broadcast( Hashtable _e, HeartBeat.ReportListenerPackage.ServerItem[] _r)
    {
       e = _e;
       r = _r;
       if( r.length>0 && e.size()>0 ) start();

    }// end of broadcast()

    /**
    *
    * Sends <b>report()</b> message to the interested parties.
    *
    */
    public final void run()
    {
       System.out.println(" in ReportBroadcaster::run() ");
       HeartBeat.ReportListener rl;
       Enumeration keys = e.keys();

       // Broadcast report to all listeners 
       while( keys.hasMoreElements() )
       {
          //Integer ky = (Integer) keys.nextElement();
          //if( ky!=null ) 
          //{
            //rl = (HeartBeat.ReportListener) e.get(ky);
            rl = (HeartBeat.ReportListener) keys.nextElement();
            if( rl!=null )
            try
            {  rl.report(r);
            } catch( org.omg.CORBA.SystemException se) 
              { if(master!=null) master.remove(rl); /* ky.intValue()); */ }
              catch( java.lang.Exception ne) 
              { if(master!=null) master.remove(rl); /*ky.intValue());*/ }

          //}// end of if

       }// end of while

    }// end of run

}// end of ReportBroadcaster()

