/**
* @date   September 14, 1998 ( Last Updated September 21, 1998)
*
*/

import java.util.Enumeration;
import java.util.Hashtable;
import org.omg.CORBA.*;

import HeartBeat.*;
import HeartBeat.ReportListenerPackage.*;

/**
*
* Checks the stike out information of each record. If a server should be
* removed, first checks the server with <b>areYouAlive()</b> message. If it
* does not reply, then it will remove the record about this server.
*
* @author H. Timucin Ozdemir
* @date   September 14, 1998 ( Last Updated September 21, 1998)
*
*/
public class 
StrikeOutUpdater extends RunnerObject
{
    /** */
    Enumeration        e;

    /** */
    HeartBeatServant   master = null;

    /** */
    long timeLimit = 3000;

    long time=0;

    /** */
    int  strikeOutLimit = 3;

    /**
    */
    public StrikeOutUpdater()
    {
        this(null);

    }// end of CONSTUCTOR

    /**
    */
    public StrikeOutUpdater(HeartBeatServant _master)
    {
        setPriority(Thread.MAX_PRIORITY);
        master = _master;

    }// end of CONSTUCTOR

    /**
    */
    public void 
    update( Enumeration _e, int _strikeOutLimit, long _timeLimit)
    {
                    e = _e;
       strikeOutLimit = _strikeOutLimit;
            timeLimit = _timeLimit;

       if( e.hasMoreElements() ) start();

    }// end of broadcast()

    /**
    *
    */
    public final void run()
    {
       System.out.println(" in StrikeOutUpdater::run() ");
       HeartBeat.HeartBeatListener rl = null;
       ServerInfo sv = null;
       boolean    removeIt = false;

       time = System.currentTimeMillis();
       while( e.hasMoreElements() )
       {
          sv = (ServerInfo) e.nextElement();
          if( sv!=null && ( time - sv.getTime() ) > timeLimit )
          {
             sv.incrementMiss();
             if( sv.getStrikeOut() > strikeOutLimit )
             {
               rl = (HeartBeat.HeartBeatListener) master.getHBL( sv.getName() );
               removeIt = true;

               if( rl != null )
                 try
                 { removeIt = !rl.areYouAlive();
                   if(!removeIt) sv.reset();
                 } catch(Exception e) {}

               if(removeIt) master.delete(sv.getName());
 
             }// end of if

          }// end of if

       }// end of while

    }// end of run

}// end of StrikeOutUpdater()

