/**
* @date  September 16, 1998 ( Last Upadted on September 21, 1998 )
*
*/

import org.omg.CosNaming.*;  
import org.omg.CORBA.*;     

import java.net.*;
import java.io.*;
import java.util.*;

import HeartBeat.*;
import HeartBeat.HeartBeatListenerPackage.*;
import HeartBeat.ReportListenerPackage.*;


/**
*
* It starts a txtReporter object to produce textual report about the state
* of each server in the cluster.
*
* <ol>
*  <p><li> obtains the address of HeartBeat.ReportAdmin from file
*  <p><li> defines txtReport object
*  <p><li> registers txtReporter object to the HeartBeat.ReportAdmin
*  <p><li> produces reports for a while.
*  <p><li> removes txtReporter object from the HeartBeat.ReportAdmin
* </ol>
*
* @author H. Timucin Ozdemir
* @date  September 16, 1998 ( Last Upadted on September 21, 1998 )
*
*/
public class 
monitorCluster
{

    /**
    */
    public static void 
    main(String args[]) 
    {
      try 
      {
         int i;
         String fileName = new String("IOR");
         if(args.length>0) fileName = args[0];
         String strIOR = IORProvider.getIORFromFile(fileName); 

         if( strIOR!=null && strIOR.startsWith("IOR:") )
         {
 
            Properties prop = new Properties();
            prop.put("org.omg.CORBA.ORBClass","worb.protocols.iiop.ORBImpl");
            prop.put("org.omg.CORBA.ORBSingletonClass","worb.protocols.iiop.ORBImpl");
            System.out.println(" I read IOR --> "+strIOR);

            // Create and initialize the ORB
            org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args, prop);

            System.out.println(" IOR --> "+strIOR);
            org.omg.CORBA.Object objRef = orb.string_to_object(strIOR);
      
            HeartBeat.ReportAdmin deamon = HeartBeat.ReportAdminHelper.narrow(objRef);
            txtReporter gui = new txtReporter();
            org.omg.CORBA.ORB.init().connect(gui);
            deamon.register(gui);
            gui.collect();
            deamon.remove(gui);
 
            System.exit(0);

         }
         else 
          {
             System.err.println(fileName+" does not have poper IOR address ");
             System.exit(1);
          }

        } catch (Exception e) 
          {
             System.out.println("### Exception !!! ### \n");
             e.printStackTrace();
          }

    }// end of main()

}// end of Class monitorCluster 
