/**
* @date   September 15, 1998 ( Last Updated September 21, 1998 )
*/

// the naming service.
import org.omg.CosNaming.*;

// The package containing special exceptions thrown by the name service.
import org.omg.CosNaming.NamingContextPackage.*;

// All CORBA applications need these classes.
import org.omg.CORBA.*;

import java.util.*;
import java.io.*;

/**
*
* A java application to control HBD object
*
* <ol>
*  <p><li> defines a HBD object.
*  <p><li> If there is no published valid HBD object, then it publishes its
*          address.
*  <p><li> starts HBDaemonTxtGUI.
* </ol>
*
* @author H. Timucin Ozdemir
* @date   September 15, 1998 ( Last Updated September 21, 1998 )
*
*/
public class 
startHBDaemon 
{

  /**
  */
  public static void 
  printMyIOR(String fileName, String IOR)
  {
     try
     {
        PrintWriter pw = new PrintWriter( new FileWriter(new File(fileName)));
        pw.println(IOR);
        pw.close();

     } catch( java.io.IOException io) {}

  }// end of printMyIOR()

  /**
  */
  public static void 
  main(String args[])
  {
    try{
    
      Properties prop = new Properties();
      
      // to force our IIOP implementation.
      prop.put("org.omg.CORBA.ORBClass","worb.protocols.iiop.ORBImpl");
      prop.put("org.omg.CORBA.ORBSingletonClass","worb.protocols.iiop.ORBImpl");

      // Create and initialize the ORB
      ORB orb = org.omg.CORBA.ORB.init(args, prop);
      
      // Create the servant and register it with the ORB
      HeartBeat._ReportAdminImplBase daemon = new HeartBeatDaemon();
      orb.connect(daemon);
      
      // Get the root naming context
      //org.omg.CORBA.Object objRef = orb.resolve_initial_references("NameService");
      /*
      NamingContext ncRef = NamingContextHelper.narrow(objRef);
      
      // Bind the object reference in naming
      NameComponent nc = new NameComponent("HeartBeat.ReportAdmin", " ");
      NameComponent path[] = {nc};
      ncRef.rebind(path, deamon);
      */ 
      
      String IOR = orb.object_to_string(daemon);
      System.out.println("IOR "+IOR);

      boolean publish = true;
      try
      { String tIOR = IORProvider.getIORFromFile("IOR");
        if( tIOR!=null )
        {
           HeartBeat.ReportAdmin tdaemon = HeartBeat.ReportAdminHelper.narrow(org.omg.CORBA.ORB.init().string_to_object(tIOR));
           publish = false;
        }
      } catch(Exception e) { }

      if(publish) startHBDaemon.printMyIOR("./IOR",IOR);
      HBDaemonTxtGUI gui = new HBDaemonTxtGUI(daemon);
      gui.start();

      /**
      // Wait for invocations from clients
      java.lang.Object sync = new java.lang.Object();
      synchronized(sync){
        sync.wait();
      }
      */
      
    } catch(Exception e) {
        System.err.println("ERROR: " + e);
        e.printStackTrace(System.out);
      }  

  }// end of main

}// end of startHBDaemon


