/**
* A simple test for remote invocations.
*
* <p>
* It reads IOR of the test object from file IOR in the current directory 
* unless user provides another file name for this.
*
* <p>
* Usage : java test1Client [<IOR_file_name>]
*
* @author H. Timucin Ozdemir
* @date  July 6, 1998
*
*/

import org.omg.CosNaming.*;  
import org.omg.CORBA.*;     

import java.net.*;
import java.io.*;
import java.util.*;

public class 
anyClient
{

   public static void writeAny(org.omg.CORBA.Any b) {
       System.out.println(" (AnyClient) received type: "+TCtoStr.IDLtypeName(b.type()));
       TCKind bKind =  b.type().kind();
       if( bKind == TCKind.tk_string )
           System.out.println(" (AnyClient) received: "+b.extract_string());
       else if( bKind == TCKind.tk_string )
           System.out.println(" (AnyClient) received: "+b.extract_string());
       else if( bKind == TCKind.tk_ulong )
           System.out.println(" (AnyClient) received: "+b.extract_ulong());
       else if( bKind == TCKind.tk_ushort )
           System.out.println(" (AnyClient) received: "+b.extract_ushort());
       else if( bKind == TCKind.tk_long )
           System.out.println(" (AnyClient) received: "+b.extract_long());
       else if( bKind == TCKind.tk_short )
           System.out.println(" (AnyClient) received: "+b.extract_short());
       else if( bKind == TCKind.tk_boolean )
           System.out.println(" (AnyClient) received: "+b.extract_boolean());
       else if( bKind == TCKind.tk_octet )
           System.out.println(" (AnyClient) received: "+b.extract_octet());
       else if( bKind == TCKind.tk_char )
           System.out.println(" (AnyClient) received: "+b.extract_char());
       else if( bKind == TCKind.tk_wchar )
           System.out.println(" (AnyClient) received: "+b.extract_wchar());
       else if( bKind == TCKind.tk_longlong )
           System.out.println(" (AnyClient) received: "+b.extract_longlong());
       else if( bKind == TCKind.tk_ulonglong )
           System.out.println(" (AnyClient) received: "+b.extract_ulonglong());
       else if( bKind == TCKind.tk_float )
           System.out.println(" (AnyClient) received: "+b.extract_float());
       else if( bKind == TCKind.tk_double )
           System.out.println(" (AnyClient) received: "+b.extract_double());

    }

    /**
    */
    public static void 
    main(String args[]) 
    {
        try 
        {
           int i;
           String fileName = new String("IOR");
           if(args.length>0) fileName = args[0];
           BufferedReader input = new BufferedReader(new FileReader(fileName));
           String strIOR = input.readLine();  // get IOR address of RTIKernelInt erface
           if( strIOR!=null && strIOR.startsWith("IOR:") )
           {
 
              Properties prop = new Properties();
              prop.put("org.omg.CORBA.ORBClass","worb.protocols.iiop.ORBImpl");
              prop.put("org.omg.CORBA.ORBSingletonClass","worb.protocols.iiop.ORBImpl");
              System.out.println(" I read IOR --> "+strIOR);

              // Create and initialize the ORB
              ORB orb = ORB.init(args, prop);

              System.out.println(" IOR --> "+strIOR);
              org.omg.CORBA.Object objRef = orb.string_to_object(strIOR);
      
              anyExample anyRef = anyExampleHelper.narrow(objRef);

              Any a = orb.create_any();
              
              a.insert_short((short)2133);
              Any b = anyRef.testOp(a);
              anyClient.writeAny(b);

              a.insert_long((int)123);
              b = anyRef.testOp(a);
              anyClient.writeAny(b);

              /*a.insert_longlong((int)123);
              b = anyRef.testOp(a);
              anyClient.writeAny(b);
              */
              a.insert_ushort((short)2133);
              b = anyRef.testOp(a);
              anyClient.writeAny(b);
              
              a.insert_ulong((int)22233);
              b = anyRef.testOp(a);
              anyClient.writeAny(b);

              /*a.insert_ulonglong((long)123);
              b = anyRef.testOp(a);
              anyClient.writeAny(b);
              */
              a.insert_float((float)2133.11);
              b = anyRef.testOp(a);
              anyClient.writeAny(b);
  
              a.insert_double((double)22133.11);
              b = anyRef.testOp(a);
              anyClient.writeAny(b);

              a.insert_boolean(true);
              b = anyRef.testOp(a);
              anyClient.writeAny(b);

              char H = 'H';
              a.insert_char(H);
              b = anyRef.testOp(a);
              anyClient.writeAny(b);
              
              /*H = 'W';
              a.insert_wchar(H);
              b = anyRef.testOp(a);
              anyClient.writeAny(b);
              */
              byte B= 111;
              a.insert_octet(B);
              b = anyRef.testOp(a);
              anyClient.writeAny(b);

              a.insert_string("Hello");
              b = anyRef.testOp(a);
              anyClient.writeAny(b);

              a.insert_wstring("Hello");
              b = anyRef.testOp(a);
              anyClient.writeAny(b);

              a.insert_long((int)123);
              b = anyRef.testOp(a);
              anyClient.writeAny(b);

              a.insert_short((short)2133);
              b = anyRef.testOp(a);
              anyClient.writeAny(b);

              H = 'W';
              a.insert_wchar(H);
              b = anyRef.testOp(a);
              anyClient.writeAny(b);

              a.insert_longlong((int)123);
              b = anyRef.testOp(a);
              anyClient.writeAny(b);

              a.insert_ulonglong((long)1234);
              b = anyRef.testOp(a);
              anyClient.writeAny(b);
              
              System.out.println();
              System.out.println("***************Test is OVER************");

           }
           else 
            {
               System.err.println(fileName+" does not have poper IOR address ");
               System.exit(1);
            }

        } catch (Exception e) 
          {
             System.out.println("### Exception !!! ### \n");
             e.printStackTrace();
          }

    }// end of main()

}// end of Class test1Client 
