/**
* A simple benchmark for remote invocations.
* It takes the system clock right before and after 
* method invocations.
* This class is changed by H. Timucin Ozdemir.
* Original version can be found with JacORBv0.8d. 
*/

import org.omg.CosNaming.*;  
import org.omg.CORBA.*;     

import java.net.*;
import java.io.*;

import BenchmarkPackage.*;

public class 
benchClient3 
{

    public static String
    readIORfromFile(String fileName)
    {
       String ret = null;

       try
       {
          BufferedReader input = new BufferedReader(new FileReader(fileName));
          ret = input.readLine();  // get IOR address of Benchmark erface
       } //catch(java.io.FileNotFound fnf) {}
         catch(java.io.IOException fnf) {}

       return ret;

    }// end of readIORfromFile()

    /**
    */
    public static void 
    main(String args[]) 
    {
        try 
        {
           String fileName = new String("IOR");
           if(args.length>0) fileName = args[0];
           String objIOR = benchClient3.readIORfromFile(fileName);

           //if(args.length > 0 && args[args.length-1].startsWith("IOR:") )
           if(objIOR!=null && objIOR.startsWith("IOR:") )
           {
 
              // Create and initialize the ORB
              ORB orb = ORB.init(args, null);
               

              System.out.println(" IOR --> "+objIOR);
              org.omg.CORBA.Object objRef = orb.string_to_object(objIOR);
      
              Benchmark benchRef = BenchmarkHelper.narrow(objRef);
              Benchmarker client = new Benchmarker();

              client.doBenchmarking(benchRef);
           }
           else 
            {
               System.err.println("usage: java benchClient3 <IOR_file_name>");
               System.exit(1);
            }

        } catch (Exception e) 
          {
             System.out.println("### Exception !!! ### \n");
             e.printStackTrace();
          }

    }// end of main()

}// end of Class benchClient 
