/**
* A simple benchmark for remote invocations.
* It takes the system clock right before and after 
* method invocations.
* This class is changed by H. Timucin Ozdemir.
* Original version can be found with JacORBv0.8d. 
*/

import org.omg.CosNaming.*;  
import org.omg.CORBA.*;     

import java.net.*;
import java.io.*;

import BenchmarkPackage.*;

public class 
benchClientIOR 
{

    /**
    */
    public static void 
    main(String args[]) 
    {
        try 
        {
           String fileName = new String("IOR");
           if(args.length>0) fileName = args[0];
           BufferedReader input = new BufferedReader(new FileReader(fileName));
           String strIOR = input.readLine();  // get IOR address of RTIKernelInt erface
  
           if( strIOR!=null && strIOR.startsWith("IOR:") )
           {
 
              System.out.println(" I read IOR --> "+strIOR);
              // Create and initialize the ORB
              ORB orb = ORB.init(args, null);
               

              System.out.println(" IOR --> "+strIOR);
              org.omg.CORBA.Object objRef = orb.string_to_object(strIOR);
      
              Benchmark benchRef = BenchmarkHelper.narrow(objRef);
              //Benchmarker client = new Benchmarker();
              int val = 11;
              System.out.println(" I said "+val);
              System.out.println(" I received "+benchRef.echoLong(val));

              callbackServant myCallback = new callbackServant();
              org.omg.CORBA.ORB.init().connect(myCallback);
              System.out.println(" myCallBack is connected ............. ");

              benchRef.registerCallback(myCallback);
              System.out.println(" After myCallBack is registered ............. ");
 
              benchRef.broadcast("Hello");
              System.out.println(" I broadcasted ............. ");
		      benchRef.ping(); 
              System.out.println(" I received ping............. ");

              echo1 myEcho = benchRef.getEchoObject();
            
              String mess = new String(" Garbage Can ");
              System.out.println(" I said "+mess);
              System.out.println(" I received "+myEcho.echo(mess));

              //client.doBenchmarking(benchRef);
           }
           else 
            {
               System.err.println("usage: java benchClient <IOR>");
               System.exit(1);
            }

        } catch (Exception e) 
          {
             System.out.println("### Exception !!! ### \n");
             e.printStackTrace();
          }

    }// end of main()

}// end of Class benchClient 
