/**
* A simple benchmark for remote invocations.
* It takes the system clock right before and after 
* method invocations.
* This class is changed by H. Timucin Ozdemir.
* Original version can be found with JacORBv0.8d. 
*/

import org.omg.CosNaming.*;  
import org.omg.CORBA.*;     

import java.net.*;
import java.io.*;

import BenchmarkPackage.*;

public class 
benchClient2 
{

    public static final String
    getIOR(String args[])
    {

       String retIOR=null;

       //if(args.length > 1 && args[args.length-1].startsWith("IOR:") )
       if(args.length > 1) 
       {
 
          try
          {
             String host = args[0];
             int port = Integer.parseInt(args[1]);
             String query = new String("http://"+host+":"+port+"/servlet/naming?");
             query += "cmd=getIOR&";
             query += "IDL=IDL:Benchmark:1.0";
             System.out.println(" query :"+query);
             URL namingURL = new URL(query);

             DataInputStream dis = new DataInputStream( namingURL.openStream());
             retIOR = dis.readLine();
          
          } catch(NumberFormatException nfe) {}
            catch(MalformedURLException mfue) {}
            catch(IOException ioe) {}
       }
       else 
        {
            System.err.println("usage: java benchClient hostname port");
            System.exit(1);
        }
      
       return retIOR;

    }// end of getIOR()

    /**
    */
    public static void 
    main(String args[]) 
    {
        try 
        {

           String ior = getIOR(args);
           if(ior!=null)
           {
 
              // Create and initialize the ORB
              ORB orb = ORB.init(args, null);

              System.out.println(" IOR --> "+ior);
              org.omg.CORBA.Object objRef = orb.string_to_object(ior);
      
              Benchmark benchRef = BenchmarkHelper.narrow(objRef);
              Benchmarker client = new Benchmarker();

              client.doBenchmarking(benchRef);
           }

        } catch (Exception e) 
          {
             System.out.println("### Exception !!! ### \n");
             e.printStackTrace();
          }

    }// end of main()

}// end of Class benchClient 
