/**
*
* This is a basic test program for JWORB. 
*
* org.omg.* classes come with Java 1.2 beta2.
*
* @author H. Timucin Ozdemir
* @date   July 6, 1998
*/

// the naming service.
import org.omg.CosNaming.*;

// The package containing special exceptions thrown by the name service.
import org.omg.CosNaming.NamingContextPackage.*;

// All CORBA applications need these classes.
import org.omg.CORBA.*;

import java.util.*;
import java.io.*;

public class 
test1Server 
{

  /**
  */
  public static void 
  printMyIOR(String fileName, String IOR)
  {
     try
     {
        PrintWriter pw = new PrintWriter( new FileWriter(new File(fileName)));
        pw.println(IOR);
        pw.close();

     } catch( java.io.IOException io) {}

  }// end of printMyIOR()

  /**
  */
  public static void 
  main(String args[])
  {
    try{
    
      Properties prop = new Properties();
      
      // to force our IIOP implementation.
      prop.put("org.omg.CORBA.ORBClass","worb.protocols.iiop.ORBImpl");
      prop.put("org.omg.CORBA.ORBSingletonClass","worb.protocols.iiop.ORBImpl");

      // Create and initialize the ORB
      ORB orb = ORB.init(args, prop);
      
      // Create the servant and register it with the ORB
      jworbTest1Servant tst1Ref = new jworbTest1Servant();
      orb.connect(tst1Ref);
      
      // Get the root naming context
      //org.omg.CORBA.Object objRef = orb.resolve_initial_references("NameService");
      /*
      NamingContext ncRef = NamingContextHelper.narrow(objRef);
      
      // Bind the object reference in naming
      NameComponent nc = new NameComponent("jworbTest1", " ");
      NameComponent path[] = {nc};
      ncRef.rebind(path, tst1Ref);
      */ 
      
      String IOR = orb.object_to_string(tst1Ref);
      System.out.println("IOR "+IOR);
      test1Server.printMyIOR("/project/speedes/users/timucin/omniORB_2.5.0/src/examples/test1/IOR",IOR);
      test1Server.printMyIOR("./IOR",IOR);

      // Wait for invocations from clients
      java.lang.Object sync = new java.lang.Object();
      synchronized(sync){
        sync.wait();
      }
      
    } catch(Exception e) {
        System.err.println("ERROR: " + e);
        e.printStackTrace(System.out);
      }  

  }// end of main

}// end of test1Server


