/**
* A simple test for remote invocations for JWORB.
*
* <p>
* Usage : java test2Client [<name_of_IOR_file>]
*
* <p>
* It reads the IOR of the object from IOR file in current directory if
* user does not provide from the command line.
*
* @author H. Timucin Ozdemir
* @date  July 6, 1998
*
*/

import org.omg.CosNaming.*;  
import org.omg.CORBA.*;     

import java.net.*;
import java.io.*;
import java.util.*;

import jworbTest2Package.*;

public class 
test2Client 
{

    /**
    */
    public static void 
    main(String args[]) 
    {
        try 
        {
           String fileName = new String("IOR");
           if(args.length>0) fileName = args[0];
           BufferedReader input = new BufferedReader(new FileReader(fileName));
           String strIOR = input.readLine();  // get IOR address of RTIKernelInt erface
  
           if( strIOR!=null && strIOR.startsWith("IOR:") )
           {
 
              Properties prop = new Properties();
              prop.put("org.omg.CORBA.ORBClass","worb.protocols.iiop.ORBImpl");
              prop.put("org.omg.CORBA.ORBSingletonClass","worb.protocols.iiop.ORBImpl");
              System.out.println(" I read IOR --> "+strIOR);
              // Create and initialize the ORB
              ORB orb = ORB.init(args, prop);
               

              System.out.println(" IOR --> "+strIOR);
              org.omg.CORBA.Object objRef = orb.string_to_object(strIOR);
      
              jworbTest2 tst2Ref = jworbTest2Helper.narrow(objRef);

              echo1 myEcho = tst2Ref.getEchoObject();
            
              String mess = new String(" Garbage Can ");
              System.out.println(" I said "+mess);
              System.out.println(" I received "+myEcho.echo(mess));

              callbackServant myCallback = new callbackServant();
              //org.omg.CORBA.ORB.init().connect(myCallback);
              orb.connect(myCallback);
              System.out.println(" myCallBack is connected ............. ");

              tst2Ref.registerCallback(myCallback);
              System.out.println(" After myCallBack is registered ............. ");
 
              String line = "Hello";

              do
              {
                if(line!=null)
                { 
                   tst2Ref.broadcast(line);
                   System.out.println(" I broadcasted ............. ");

                }// end of if

                System.out.print(" Mess ");
                DataInput d = new DataInputStream(System.in);
                line = d.readLine();
 
              } while(line==null || ( line!=null && !line.equals("exit")) );

              tst2Ref.unregisterCallback(myCallback);

              //org.omg.CORBA.ORB.init().disconnect(myCallback);
              orb.disconnect(myCallback);
              System.out.print(" after orb.disconnect() ");

           }
           else 
            {
               System.err.println("Usage: java test2Client [<name_of_IOR_file>]");
               System.exit(1);
            }

        } catch (Exception e) 
          {
             System.out.println("### Exception !!! ### \n");
             e.printStackTrace();
          }

    }// end of main()

}// end of Class test2Client 
