/**
*
* This is a basic test program for JWORB. 
*
* <p>
* This server tests: 
*
* <ol>
* <li> Exception, 
* <li> Accessing another object in the server side by getting 
*      its reference through interface, and
* <li> registering callback objects.
* </ol>
*
* org.omg.* classes come with Java 1.2 beta2.
*
* <p>
* Usage : java test2Server  [<name_file_to_write_IOR>]
*
* <p>
* It writes the IOR of the object into the following files
*
* <ol>
* <li> ./IOR  in current directory
* <li> name_file_to_write_IOR if provided
* </ol>
*
* @author H. Timucin Ozdemir
* @date   July 6, 1998
*
*/

// the naming service.
import org.omg.CosNaming.*;

// The package containing special exceptions thrown by the name service.
import org.omg.CosNaming.NamingContextPackage.*;

// All CORBA applications need these classes.
import org.omg.CORBA.*;

import java.util.*;
import java.io.*;

public class 
test2Server 
{

  /**
  */
  public static void 
  printMyIOR(String fileName, String IOR)
  {
     try
     {
        PrintWriter pw = new PrintWriter( new FileWriter(new File(fileName)));
        pw.println(IOR);
        pw.close();

     } catch( java.io.IOException io) {}

  }// end of printMyIOR()

  /**
  */
  public static void 
  main(String args[])
  {
    try{
    
      Properties prop = new Properties();
      prop.put("org.omg.CORBA.ORBClass","worb.protocols.iiop.ORBImpl");
      prop.put("org.omg.CORBA.ORBSingletonClass","worb.protocols.iiop.ORBImpl");
      // Create and initialize the ORB
      ORB orb = ORB.init(args, prop);
      
      // Create the servant and register it with the ORB
      //BenchmarkServant echoRef = new BenchmarkServant();
      jworbTest2Servant tst2Ref = new jworbTest2Servant();
      orb.connect(tst2Ref);
      
      // Get the root naming context
      //org.omg.CORBA.Object objRef = orb.resolve_initial_references("NameService");
      /*
      NamingContext ncRef = NamingContextHelper.narrow(objRef);
      
      // Bind the object reference in naming
      NameComponent nc = new NameComponent("Benckmark", " ");
      NameComponent path[] = {nc};
      ncRef.rebind(path, benchmarkRef);
      */ 
      
      String IOR = orb.object_to_string(tst2Ref);
      System.out.println("IOR "+IOR);
      test2Server.printMyIOR("/project/speedes/users/timucin/omniORB_2.5.0/src/examples/test2/IOR",IOR);
      test2Server.printMyIOR("./IOR",IOR);
      if(args.length>0) test2Server.printMyIOR(args[0],IOR);

      // Wait for invocations from clients
      java.lang.Object sync = new java.lang.Object();
      synchronized(sync){
        sync.wait();
      }
      
    } catch(Exception e) {
        System.err.println("ERROR: " + e);
        e.printStackTrace(System.out);
      }  
  }
}


