
import org.omg.CosNaming.*;  // HelloClient will use the naming service.
import org.omg.CORBA.*;      // All CORBA applications need these classes.

import AnyTest.*;
import java.io.*;

public class AnyClient
{
  ORB orb ;
  aTest anyRef ;

  void sendString(String msg) throws Exception
  {
      Any a = orb.create_any();
      a.insert_string(msg);
      Any b = anyRef.pingString(a);
      System.out.println(" received: "+b.extract_string());      

  }// end of sendString()

  void sendInt(int msg) throws Exception
  {
      Any a = orb.create_any();
      a.insert_long(msg);
      Any b = anyRef.pingInteger(a);
      System.out.println(" received: "+b.extract_long());      

  }// end of sendInt()

  void sendMessage(String towhom, String msg) throws Exception
  {
      Any a = orb.create_any();
      AnyTest.messageHelper.insert(a,new message(towhom,msg));
      Any b = anyRef.pingMessage(a);

      message c = AnyTest.messageHelper.extract(a);
        
      System.out.println(" received: ");      
      System.out.println("   origin : "+c.origin);      
      System.out.println("      msg : "+c.msg);      

  }// end of sendMessage()

  public void conductExperiments() throws Exception
  {

     // Call the Hello server object and print results
     System.out.println(" received: "+anyRef.pingString2("Hello"));

     sendInt(123);
     sendString("Hello");
     sendMessage("aa","Hello");

  }// end of conductExperiments() 

  public AnyClient( aTest _anyRef )
  {
      String[] args = null;
      // Create and initialize the ORB
      orb = ORB.init(args, null);
      anyRef = _anyRef;
  }
 
  public static void main(String args[])
  {
    try{

      String fName = new String("IOR");
      if(args.length>0) fName = args[0];
      BufferedReader input = new BufferedReader(new FileReader("IOR"));
      String strIOR = input.readLine();  // get IOR address of Benchmark

      if( strIOR != null )
      {

      System.out.println(" IOR --> "+strIOR);

      // Create and initialize the ORB
      ORB orb = ORB.init(args, null);
      
      // Get the root naming context
      /*org.omg.CORBA.Object objRef = orb.resolve_initial_references("NameService");
      NamingContext ncRef = NamingContextHelper.narrow(objRef);
      
      // Resolve the object reference in naming
      NameComponent nc = new NameComponent("Hello", " ");
      NameComponent path[] = {nc};
      */

      System.out.println(" IOR --> "+strIOR);
      org.omg.CORBA.Object objRef = orb.string_to_object(strIOR);
      
      //Hello helloRef = HelloHelper.narrow(ncRef.resolve(path));
      aTest anyRef = aTestHelper.narrow(objRef);

      AnyClient exp = new AnyClient(anyRef);
     
      exp.conductExperiments();

      }
          
    } catch(Exception e) {
        System.out.println("ERROR : " + e);
        e.printStackTrace(System.out);
      }  
  }
}


