
// The package containing our stubs.
import AnyTest.*;

// HelloServer will use the naming service.
import org.omg.CosNaming.*;

// The package containing special exceptions thrown by the name service.
import org.omg.CosNaming.NamingContextPackage.*;

// All CORBA applications need these classes.
import org.omg.CORBA.*;

import java.util.*;
import java.io.*;

public class AnyServer 
{

  public static void
  writeIOR(String fileName, String IOR)
  {
      try
      {
         File f = new File(fileName);

         PrintWriter out = new PrintWriter(new FileWriter(f));
         out.print(IOR);
         out.close();

      } catch(IOException ioe) {}

  }// end of writeIOR()


  public static void main(String args[])
  {
    try{
    
      Properties prop = new Properties();
      //prop.put("org.omg.CORBA.ORBClass","worb.protocols.iiop.ORBImpl");
      // Create and initialize the ORB
      ORB orb = ORB.init(args, prop);
      
      // Create the servant and register it with the ORB
      AnyServant anyRef = new AnyServant();
      orb.connect(anyRef);

      System.out.println(orb.object_to_string(anyRef));

      String fName = new String("IOR");
      System.out.println("at "+fName);
      AnyServer.writeIOR(fName,orb.object_to_string(anyRef));

      /*
      // Get the root naming context
      org.omg.CORBA.Object objRef = orb.resolve_initial_references("NameService");
      NamingContext ncRef = NamingContextHelper.narrow(objRef);
      
      // Bind the object reference in naming
      NameComponent nc = new NameComponent("Hello", " ");
      NameComponent path[] = {nc};
      ncRef.rebind(path, helloRef);
      */ 

      // Wait for invocations from clients
      java.lang.Object sync = new java.lang.Object();
      synchronized(sync){
        sync.wait();
      }

    } catch(Exception e) 
      { System.err.println("ERROR: " + e); e.printStackTrace(System.out); }  

  }// end of main()

}// end of AnyServer

