/**
 * This software is (c) Copyright IONA Technologies Limited 1995-1997.
 * All Rights Reserved
 */

package WebChat;

import java.awt.*;
import java.util.*;

import org.omg.CORBA.*;
import org.omg.CosNaming.*;
import org.omg.CosEventComm.*;
import org.omg.CosEventChannelAdmin.*;

import worb.protocols.iiop.util.*;
import worb.protocols.iiop.es.EvtUtils.*;

/**
 * The WebChat client class.
 * This client can be run as an applet (using the ClientStart applet) or an
 * application using the mainline below.
 */

public class WebChatGUI extends Frame {

  public WebChatGUI(String host, String name, String IOR_NameServer) {

    super("WebChatGUI window");
    // Generated code ...

    //{{INIT_CONTROLS
    setLayout(null);
    addNotify();
    resize(insets().left + insets().right + 463, insets().top + insets().bottom + 361);
    QuitButton=new Button("Quit");
    add(QuitButton);
    QuitButton.reshape(insets().left + 354,insets().top + 310,89,23);
    SendButton=new Button("Send");
    add(SendButton);
    SendButton.reshape(insets().left + 352,insets().top + 268,87,25);
    ClearButton=new Button("Clear");
    add(ClearButton);
    ClearButton.reshape(insets().left + 250,insets().top + 310,88,23);
    SendEdit=new TextField(38);
    add(SendEdit);
    SendEdit.reshape(insets().left + 19,insets().top + 267,319,26);
    ChatEdit=new TextArea(11,50);
    add(ChatEdit);
    ChatEdit.reshape(insets().left + 18,insets().top + 59,420,185);
    GroupChoice= new Choice();
    add(GroupChoice);
    GroupChoice.reshape(insets().left + 79,insets().top + 23,140,65);
    GroupChoice.addItem("General");
    GroupChoice.addItem("Engineering");
    GroupChoice.addItem("Prof Services");
    GroupChoice.addItem("Sales");
    GroupChoice.addItem("Marcom");
    GroupChoice.addItem("BusDev");
    CurrentGroupLabel=new Label("Current Chat Group :");
    add(CurrentGroupLabel);
    CurrentGroupLabel.reshape(insets().left + 235,insets().top + 24,120,13);
    GroupLabel=new Label("General");
    add(GroupLabel);
    GroupLabel.reshape(insets().left + 361,insets().top + 24,70,13);
    GroupsLabel=new Label("Groups :");
    add(GroupsLabel);
    GroupsLabel.reshape(insets().left + 21,insets().top + 24,54,13);
    //}}

    //{{INIT_MENUS
    //}}

    NamingContext rootContext = null;
    

    Host = new String(host);
    Name = new String(name);

    // Create the OrbixWeb callback object
    try {
      CallObj = new local_implementation(this);
    }
    catch (SystemException ex) {
      displayMsg("Exception creating local implementation \n"+ ex.toString());
      System.exit(1);
    }

    // Find Naming Server

    /*
    try
    {
      org.omg.CORBA.Object initNCRef = ORB.init().string_to_object(IOR_NameServer);

      rootContext = NamingContextHelper.narrow(initNCRef);

    } catch(SystemException se)
      {
         displayMsg("Exception during Bind to NameService\n" + se.toString());
         return;
      }

    System.out.println(" I GOT the NameServer ");

    try
    {
        NameComponent[] nameC = null;
        org.omg.CORBA.Object objRef = null;

        nameC = new NameComponent[2];
        nameC[0] = new NameComponent("EventService","EventChannelFactory");
        nameC[1] = new NameComponent("EventFactory","EvtChannelProducer");
        
        objRef = rootContext.resolve(nameC);
        System.out.println(" I GOT the Server ");

        EvtFactory   = EventChannelFactoryHelper.narrow(objRef);

    } 

      catch(org.omg.CosNaming.NamingContextPackage.NotFound ie)
      {
         displayMsg("Exception during Bind to NameService\n" + ie.toString());
         return;
      }

      catch(org.omg.CosNaming.NamingContextPackage.InvalidName ie)
      {
         displayMsg("Exception during Bind to NameService\n" + ie.toString());
         return;
      }

      catch(org.omg.CosNaming.NamingContextPackage.CannotProceed  ie)
      {
         displayMsg("Exception during Bind to NameService\n" + ie.toString());
         return;
      }

      
      //catch(CannotProceed cp)
      //{
      //   displayMsg("Exception during Bind to NameService\n" + cp.toString());
      //   return;
      //}
      //catch(NotFound nf)
      //{
      //   displayMsg("Exception during Bind to NameService\n" + nf.toString());
      //   return;
      //}
      catch(SystemException se)
      {
         displayMsg("Exception during Bind to NameService\n" + se.toString());
         return;
      }*/
    
    int i, j;
    
    try
    {  
    String strIOR = IORProvider.getIOR("kernels.srv","IDL:worb.protocols.iiop.es/EvtUtils/EventChannelFactory:1.0");

    if( strIOR!=null )
    {
    System.out.println(" I GOT the TALK ");

    
    // Get the channel
    try
    {
       Properties prop = new Properties();
       prop.put("org.omg.CORBA.ORBClass","worb.protocols.iiop.ORBImpl");
       prop.put("org.omg.CORBA.ORBSingletonClass","worb.protocols.iiop.ORBImpl");
       System.out.println(" I read IOR --> "+strIOR);
        String[] args = null;

       // Create and initialize the ORB
       ORB orb = ORB.init(args, prop);
       System.out.println(" IOR --> "+strIOR);
       org.omg.CORBA.Object objRef = orb.string_to_object(strIOR);
       EventChannelFactory      eFac = EventChannelFactoryHelper.narrow(objRef);
       EventChannel        EvtChannel = eFac.defineChannel("Channel3");

       consumerAdmin = EvtChannel.for_consumers();
       supplierAdmin = EvtChannel.for_suppliers();

       myPush = consumerAdmin.obtain_push_supplier();
       mySrvPush = supplierAdmin.obtain_push_consumer();

       EvtPushSupplier   pSup = new EvtPushSupplier();
            
       mySrvPush.connect_push_supplier(pSup);

       myPush.connect_push_consumer(CallObj);
       
    } 

      //catch(CosEventChannelFactory.EventChannelAlreadyExist  ie)
      //{
      //   displayMsg("Exception during Bind to NameService\n" + ie.toString());
      //   return;
      //}

      /*catch(org.omg.CosEventChannelAdmin.TypeError te)
      {
         displayMsg("Exception during Bind to NameService\n" + te.toString());
         return;
      }

      catch(org.omg.CosEventChannelAdmin.AlreadyConnected ae)
      {
         displayMsg("Exception during Bind to NameService\n" + ae.toString());
         return;
      }*/

      catch(SystemException se)
      {  displayMsg("Exception during Bind to NameService\n" + se.toString());
         return;
      }

    /*
    // Register the Client with the General group server object
    try {
      TALK.RegisterClient(CallObj,Name);
      TALK.SendMessage("-----> " +Name+" : has joined group " + GroupLabel.getText());
    }
    catch (SystemException ex) {
      displayMsg("FAIL\tException during Register, SendMessage \n"+ex.toString());
      System.exit(1);
    }

    // Enter the OrbixWeb event loop and wait for callbacks.
    Process_Events EventLoop = new Process_Events();
    EventLoop.start();
    */
    show();
    }
    } catch (Exception ex) {
      displayMsg("FAIL\tException during Register, SendMessage \n"+ex.toString());
      System.exit(1);
    }


  }

  /**
   * WebChat client mainline used when running the client as an application.
   */
  public static void main(String args[]) { 
    //ORB.init(args,null); 

    String hostname, username, IOR_NameServer;

    if (args.length<1) {
      hostname = "";//_CORBA.Orbix.myHost();
      username = "nobody";
    }
    else if (args.length==2) {
      hostname = args[0];
      username = args[1];
    }
    else {
      hostname = args[0];
      username = "nobody";
    }
    // set the OrbixWeb user name
    //_CORBA.Orbix.set_principal(username);

    IOR_NameServer = new String(); //args[1]);
    //System.out.println(" IOR of NameServer : "+IOR_NameServer);
    new WebChatGUI(hostname, username,IOR_NameServer);
  }

  public synchronized void show() {
    move(50, 50);
    super.show();
  }

  /**
   * WebChat Event handler.
   */
  public boolean handleEvent(Event event) {
    if (event.id == Event.ACTION_EVENT && event.target == GroupChoice) {
      selectedGroupChoice();
      return true;
    }
    else if (event.id == Event.ACTION_EVENT && event.target == QuitButton) {
      clickedQuitButton();
      return true;
    }
    else if (event.id == Event.ACTION_EVENT && event.target == ClearButton) {
      clickedClearButton();
      return true;
    }
    else if (event.id == Event.ACTION_EVENT && event.target == SendButton) {
      clickedSendButton();
      return true;
    }
    else if (event.id == Event.WINDOW_DESTROY) {
      hide();
      return true;
    }
    else if (event.id == Event.KEY_RELEASE && event.target == SendEdit) {
      if(event.key =='\n')
        clickedSendButton();
        return false;
      }
      return super.handleEvent(event);
  }

  /**
  */
  public void pushMessage(String buff)
  {

    try 
    {
       org.omg.CORBA.Any an = org.omg.CORBA.ORB.init().create_any();
       an.type(org.omg.CORBA.ORB.init().get_primitive_tc(TCKind.tk_string));
       an.insert_string(buff);
       mySrvPush.push(an);

    } catch(org.omg.CosEventComm.Disconnected de)
      {
         displayMsg("Exception during SendMessage \n "+de.toString());
         System.exit(1);
      }
      catch(SystemException se)
      {
         displayMsg("Exception during SendMessage \n "+se.toString());
         System.exit(1);
      }

  }// end of pushMessage()

  /**
   * Send new message to the server object.
   */
  public void clickedSendButton() {
    String buff;
    buff = Name + " : " +  SendEdit.getText();
    pushMessage(buff);

    /*
    try {

      //synchronized(TALK) {
      //  TALK.SendMessage(buff);
      //}
      mySrvPush.push(buff);

    } 

      catch(CosEventComm.Disconnected de)
      {
         displayMsg("Exception during SendMessage \n "+de.toString());
         System.exit(1);
      }

      catch(SystemException se)
      {
         displayMsg("Exception during SendMessage \n "+se.toString());
         System.exit(1);
      }
     */

    SendEdit.setText("");
  }

  public void clickedClearButton() {
    SendEdit.setText("");
    ChatEdit.setText("");
  }


  /**
   * Change group by _binding to a new server group object
   */
  public void selectedGroupChoice() {

    String NewGroup = null;

    try{
      //TALK.SendMessage("-----> " +Name+" : has left group " + GroupLabel.getText());
      pushMessage("-----> " +Name+" : has left group " + GroupLabel.getText());
      NewGroup = new String(GroupChoice.getSelectedItem());
      GroupLabel.setText(NewGroup);
      /*TALK.RemoveClient(CallObj,Name);
      TALK = ChatHelper.bind(NewGroup+":WebChat",Host);
      TALK.RegisterClient(CallObj,Name);
      TALK.SendMessage("-----> " +Name+" : has joined group " + NewGroup);
      */
    }
    catch(SystemException se) {
      displayMsg("Exception during SendMessage /n" + se.toString());
      System.exit(1);
    }
  }


  public void addMessage(String NewMess) {
    ChatEdit.appendText(NewMess + "\n");
  }

  public void clickedQuitButton() {

    /*
    if (TALK!=null) {
      synchronized(TALK){
         try{
           TALK.SendMessage("-----> " +Name+" : has left WebChat");
           //TALK.RemoveClient(CallObj,Name);
         }
         catch(SystemException se){
           this.hide();
           this.dispose();
           System.exit(1);
        }
        TALK=null;
      }
    }
    */

    if (mySrvPush!=null) 
    {
       pushMessage("-----> " +Name+" : has left WebChat");

       try
       {
         mySrvPush.disconnect_push_consumer();
 
       } catch(SystemException se)
         {
           this.hide();
           this.dispose();
           System.exit(1);
        }
        mySrvPush=null;
    }

    this.hide();
    this.dispose();
    System.exit(1);
  }

  void displayMsg (String msg) {
    System.out.println(msg);             // print to console also
    MsgDialog msgDlog = new MsgDialog("WebChat Error Message", msg);
    msgDlog.resize (380, 200);
    msgDlog.show ();
  }

  //{{DECLARE_CONTROLS
  Button QuitButton;
  Button SendButton;
  Button ClearButton;
  TextField SendEdit;
  TextArea ChatEdit;
  Choice GroupChoice;
  Label CurrentGroupLabel;
  Label GroupLabel;
  Label GroupsLabel;
  //}}

  private String Host , Name = null;
  //private Chat TALK = null;
  //private CallBack CallObj = null;

  private _PushConsumerImplBase CallObj = null;
  private EventChannelFactory EvtFactory = null;
  private EventChannel EvtChannel = null;
  private ConsumerAdmin consumerAdmin = null;
  private SupplierAdmin supplierAdmin = null;
  private ProxyPushConsumer mySrvPush = null;
  private ProxyPushSupplier myPush = null;

}


/**
 * OrbixWeb event handler thread.
 */
class Process_Events extends Thread {
    public Process_Events(){}

    public void run() {
         /* 
         try {
         _CORBA.Orbix.processEvents(_CORBA.IT_INFINITE_TIMEOUT);  // one second timeout
         }
        catch (SystemException ex) {
            System.out.println("FAIL\tException during processEvents() \n"
                 +ex.toString());
            return;
         }
        */
    }
}

