/**
 * This software is (c) Copyright IONA Technologies Limited 1995-1997.
 * All Rights Reserved
 */

package WebChat;

import java.awt.*;
import org.omg.CORBA.*;
import org.omg.CosNaming.*;

import org.omg.CosEventComm.*;
import org.omg.CosEventChannelAdmin.*;

/** 
 * WebChat client callback object implementation class
 */
public class 
local_implementation extends _PushConsumerImplBase 
{
  /** */
  WebChatGUI bkChat;

  /**
   * Callback objects hold a WebChatGUI object. 
   */
  public local_implementation(WebChatGUI bkChat)
  {
    super();
    this.bkChat = bkChat;
  }

  /**
   * Called by the server when a new message has been sent to the current group.
   */
  public void push(Any a)
  {
     String s = new String("");
     while( a.type().kind() == TCKind.tk_any ) a = a.extract_any();

     if( a.type().kind() == TCKind.tk_string )
      {    
        s = a.extract_string();
        System.out.println(" RECEIVED: "+s);
      }

     System.out.println("Executing local_implementation::NewMessage("+s+")\n");
     try{
         bkChat.ChatEdit.appendText(s+"\n");
     }
     catch(Exception se){
         System.out.println("Exception in NewMessage " + se.toString());
         System.exit(1);
     }
  }

  /**
  */
  public void disconnect_push_consumer()
  {
     System.out.println(" Push Supplier has been disconnected! ");
  }

}// end of local_implementation
