/**
*
* This is a basic benchmark program for ORB. 
*
* org.omg.* classes come with Java 1.2 beta2.
*
* @author H. Timucin Ozdemir
* @date   Feb, 1998
*/

// the naming service.
import org.omg.CosNaming.*;

// The package containing special exceptions thrown by the name service.
import org.omg.CosNaming.NamingContextPackage.*;

// All CORBA applications need these classes.
import org.omg.CORBA.*;

import java.util.*;
import java.io.*;

public class BenchmarkServer 
{

   public static void
   writeIOR(String fileName, String IOR)
   {
      try
      {
         File f = new File(fileName);

         PrintWriter out = new PrintWriter(new FileWriter(f));
         out.print(IOR);
         out.close();

      } catch(IOException ioe) {}

   }// end of writeIOR()

   public static void main(String args[])
   {
     try{
    
      Properties prop = new Properties();
      //prop.put("org.omg.CORBA.ORBClass","worb.protocols.iiop.ORBImpl");
      //prop.put("org.omg.CORBA.ORBSingletonClass","worb.protocols.iiop.ORBImpl");
      // Create and initialize the ORB
      ORB orb = ORB.init(args, prop);
      
      // Create the servant and register it with the ORB
      BenchmarkServant echoRef = new BenchmarkServant();
      orb.connect(echoRef);
      
      // Get the root naming context
      //org.omg.CORBA.Object objRef = orb.resolve_initial_references("NameService");
      /*
      NamingContext ncRef = NamingContextHelper.narrow(objRef);
      
      // Bind the object reference in naming
      NameComponent nc = new NameComponent("Benckmark", " ");
      NameComponent path[] = {nc};
      ncRef.rebind(path, benchmarkRef);
      */ 
      
      System.out.println("IOR "+orb.object_to_string(echoRef));

      String fName = new String("IOR");
      System.out.println("at "+fName);
      BenchmarkServer.writeIOR(fName,orb.object_to_string(echoRef));

      // Wait for invocations from clients
      java.lang.Object sync = new java.lang.Object();
      synchronized(sync){
        sync.wait();
      }
      
    } catch(Exception e) {
        System.err.println("ERROR: " + e);
        e.printStackTrace(System.out);
      }  
  }

}// end of BenchmarkServer


