/**
* A simple benchmark for remote invocations.
* It takes the system clock right before and after 
* method invocations.
* This class is changed by H. Timucin Ozdemir.
* Original version can be found with JacORBv0.8d. 
*/

import org.omg.CosNaming.*;  
import org.omg.CORBA.*;     

import java.net.*;
import java.io.*;

import BenchmarkPackage.*;

public class 
benchClient 
{

    /**
    */
    public static void 
    main(String args[]) 
    {
        try 
        {
           String fName = new String("IOR");
           if(args.length>0) fName = args[0];
           BufferedReader input = new BufferedReader(new FileReader("IOR"));
           String strIOR = input.readLine();  // get IOR address of Benchmark

           if( strIOR != null )
           {

              // Create and initialize the ORB
              ORB orb = ORB.init(args, null);

              System.out.println(" IOR --> "+strIOR);
              org.omg.CORBA.Object objRef = orb.string_to_object(strIOR);
      
              Benchmark benchRef = BenchmarkHelper.narrow(objRef);
              Benchmarker client = new Benchmarker();

              client.doBenchmarking(benchRef);
           }
           else 
            {
               System.err.println("usage: java benchClient [<IOR_file_name>]");
               System.exit(1);
            }

        } catch (Exception e) 
          {
             System.out.println("### Exception !!! ### \n");
             e.printStackTrace();
          }

    }// end of main()

}// end of Class benchClient 
