
import java.util.Properties;
import org.omg.CORBA.*;
import org.omg.CosNaming.*;
import org.omg.CosEventComm.*;
import org.omg.CosEventChannelAdmin.*;

import java.lang.*;

import worb.protocols.iiop.util.*;
import worb.protocols.iiop.es.EvtUtils.*;

/**
*/
public class EventClient
{
   public static void main(String args[])
   {
      try 
      { 

         int i, j;
         String strIOR = IORProvider.getIOR("kernels.srv","IDL:worb.protocols.iiop.es/EvtUtils/EventChannelFactory:1.0");

	     if(strIOR!=null && strIOR.startsWith("IOR:") )
         { 
 
            Properties prop = new Properties();
            prop.put("org.omg.CORBA.ORBClass","worb.protocols.iiop.ORBImpl");
            prop.put("org.omg.CORBA.ORBSingletonClass","worb.protocols.iiop.ORBImpl");
            System.out.println(" I read IOR --> "+strIOR);

            // Create and initialize the ORB
            ORB orb = ORB.init(args, prop);

            System.out.println(" IOR --> "+strIOR);
            org.omg.CORBA.Object objRef = orb.string_to_object(strIOR);

            EventChannelFactory eFac = EventChannelFactoryHelper.narrow(objRef);

            EventChannel      eChannel1 = eFac.defineChannel("first");
            SupplierAdmin     sAdmin    = eChannel1.for_suppliers();
            ConsumerAdmin     cAdmin    = eChannel1.for_consumers();
            ProxyPushSupplier pushSupp  = cAdmin.obtain_push_supplier();
            //ProxyPullConsumer   pullCon = sAdmin.obtain_pull_consumer();
            ProxyPushConsumer pushCon   = sAdmin.obtain_push_consumer();

            EvtPushSupplier   pSup = new EvtPushSupplier();
            EvtPushConsumer   rec  = new EvtPushConsumer();  
            try
            {
               pushSupp.connect_push_consumer(rec);
               pushCon.connect_push_supplier(pSup);

               org.omg.CORBA.Any an = org.omg.CORBA.ORB.init().create_any();
               an.type(org.omg.CORBA.ORB.init().get_primitive_tc(TCKind.tk_string));

               String hello = "hello";
               for(i=0;i<2;i++)
               {
                  an.insert_string(hello+i);
                  pushCon.push(an);
                  for(j=0;j<100000;j++) { double x = Math.sin(i*i)+Math.cos(j*j); }
                 
               }// end of for

            } catch(org.omg.CosEventChannelAdmin.AlreadyConnected ac) {}

            pushCon.disconnect_push_consumer();
            pushSupp.disconnect_push_supplier();
            eFac.destroyChannel("first");
            

         }// end of if

    } catch (Exception e) { e.printStackTrace(System.err); }

  } // end of main() 

}// end NameClient

