
import java.util.Properties;
import org.omg.CORBA.*;
import org.omg.CosNaming.*;
import org.omg.CosEventComm.*;
import org.omg.CosEventChannelAdmin.*;

import java.lang.*;

import worb.protocols.iiop.util.*;
import worb.protocols.iiop.es.EvtUtils.*;

/**
* Publishes events in Pull Style.
*/
public class EventPullPublisher implements Disconnect
{

   /** */
   boolean isConnected = false;

   /**
   */
   public EventPullPublisher()
   {  isConnected = false; }

   /**
   */
   public void disconnect() { isConnected=false; }

   /** 
   */
   public void conductExperiment(String args[])
   {
      try 
      { 

         int i, j;
         String strIOR = IORProvider.getIOR("kernels.srv","IDL:worb.protocols.iiop.es/EvtUtils/EventChannelFactory:1.0");

	     if(strIOR!=null && strIOR.startsWith("IOR:") )
         { 
 
            Properties prop = new Properties();
            prop.put("org.omg.CORBA.ORBClass","worb.protocols.iiop.ORBImpl");
            prop.put("org.omg.CORBA.ORBSingletonClass","worb.protocols.iiop.ORBImpl");
            System.out.println(" I read IOR --> "+strIOR);

            // Create and initialize the ORB
            ORB orb = ORB.init(args, prop);

            System.out.println(" IOR --> "+strIOR);
            org.omg.CORBA.Object objRef = orb.string_to_object(strIOR);

            EventChannelFactory eFac = EventChannelFactoryHelper.narrow(objRef);

            EventChannel      eChannel1 = eFac.defineChannel("first");
            SupplierAdmin        sAdmin = eChannel1.for_suppliers();
            ProxyPullConsumer   pullCon = sAdmin.obtain_pull_consumer();
            
            EvtPullSupplier   rec  = new EvtPullSupplier(this);
            isConnected = true;  
            
            try
            {
               pullCon.connect_pull_supplier(rec);
               
            } catch(org.omg.CosEventChannelAdmin.AlreadyConnected ac) {}

            while(isConnected) {};

            pullCon.disconnect_pull_consumer();
            
         }// end of if

    } catch (Exception e) { e.printStackTrace(System.err); }

  } // end of conductExperiment() 

  /**
  */
  public static void main(String args[])
  {
     EventPullPublisher pub = new EventPullPublisher();
     pub.conductExperiment(args);

  } // end of main() 

}// end EventPullPublisher

