
import java.util.Properties;
import org.omg.CORBA.*;
import org.omg.CosNaming.*;
import org.omg.CosEventComm.*;
import org.omg.CosEventChannelAdmin.*;

import java.lang.*;

import worb.protocols.iiop.util.*;
import worb.protocols.iiop.es.EvtUtils.*;

/**
*
*  Receives events in Pull style.
*
* @author Zeynep Odcikin-Ozdemir
* @date   Dec 22, 1998
* 
*/
public class EventPullSubscriber implements Disconnect
{
   /** */
   boolean isConnected = false;
   
   /** */
   public EventPullSubscriber()
   {  isConnected = false; }

   /** 
   */
   public void 
   disconnect()
   { isConnected = false;
   }// end of disconnect()

   public void 
   conductExperiment(String[] args)
   { 
      try 
      { 
         int i, j;
         String strIOR = IORProvider.getIOR("kernels.srv","IDL:worb.protocols.iiop.es/EvtUtils/EventChannelFactory:1.0");

	   if(strIOR!=null && strIOR.startsWith("IOR:") )
         { 
 
            Properties prop = new Properties();
            prop.put("org.omg.CORBA.ORBClass","worb.protocols.iiop.ORBImpl");
            prop.put("org.omg.CORBA.ORBSingletonClass","worb.protocols.iiop.ORBImpl");
            System.out.println(" I read IOR --> "+strIOR);

            // Create and initialize the ORB
            ORB orb = ORB.init(args, prop);

            System.out.println(" IOR --> "+strIOR);
            org.omg.CORBA.Object objRef = orb.string_to_object(strIOR);

            EventChannelFactory eFac = EventChannelFactoryHelper.narrow(objRef);

            EventChannel      eChannel1 = eFac.defineChannel("first");
            ConsumerAdmin     cAdmin    = eChannel1.for_consumers();
            ProxyPullSupplier pullSupp  = cAdmin.obtain_pull_supplier();
            EvtPullConsumer   rec  = new EvtPullConsumer(this,pullSupp);  
            isConnected = true;
            
            try
            {
               pullSupp.connect_pull_consumer(rec);
               
            } catch(org.omg.CosEventChannelAdmin.AlreadyConnected ac) {}

            while(isConnected) {};
            pullSupp.disconnect_pull_supplier();
         
         }// end of if

      } catch (Exception e) { e.printStackTrace(System.err); }
  
  }// end of conductExperiment()

  /**
  */ 
  public static void main(String args[])
  {
     EventPullSubscriber listener = new EventPullSubscriber();
     listener.conductExperiment(args);

  } // end of main() 

}// end EventPullSubscriber

