
import java.util.Properties;
import org.omg.CORBA.*;
import org.omg.CosNaming.*;
import org.omg.CosEventComm.*;
import org.omg.CosEventChannelAdmin.*;

import java.lang.*;

import worb.protocols.iiop.util.*;
import worb.protocols.iiop.es.EvtUtils.*;

/**
* Publishes events in Push Style.
*/
public class EventPushSubscriber implements Disconnect
{
   /** */
   boolean isConnected = false;

   /** */
   public EventPushSubscriber()
   { isConnected = false; }

   /** */
   public void disconnect() { isConnected=false; }

   /** */
   public void conductExperiment(String args[])
   {
      try 
      { 

         int i, j;
         String strIOR = IORProvider.getIOR("kernels.srv","IDL:worb.protocols.iiop.es/EvtUtils/EventChannelFactory:1.0");

	   if(strIOR!=null && strIOR.startsWith("IOR:") )
         { 
 
            Properties prop = new Properties();
            prop.put("org.omg.CORBA.ORBClass","worb.protocols.iiop.ORBImpl");
            prop.put("org.omg.CORBA.ORBSingletonClass","worb.protocols.iiop.ORBImpl");
            System.out.println(" I read IOR --> "+strIOR);

            // Create and initialize the ORB
            ORB orb = ORB.init(args, prop);

            System.out.println(" IOR --> "+strIOR);
            org.omg.CORBA.Object objRef = orb.string_to_object(strIOR);

            EventChannelFactory      eFac = EventChannelFactoryHelper.narrow(objRef);
            EventChannel        eChannel1 = eFac.defineChannel("first");
            ConsumerAdmin          cAdmin = eChannel1.for_consumers();
            ProxyPushSupplier    pushSupp = cAdmin.obtain_push_supplier();
            
            EvtPushConsumer   rec  = new EvtPushConsumer(this);  
            
            try
            {
               pushSupp.connect_push_consumer(rec);
               isConnected = true;

            } catch(org.omg.CosEventChannelAdmin.AlreadyConnected ac) {}

            while(isConnected) {};

            pushSupp.disconnect_push_supplier();
            
         }// end of if

    } catch (Exception e) { e.printStackTrace(System.err); }

  }// end of conductExperiment() 
 
  /** */
  public static void main(String args[])
  {
     EventPushSubscriber listener = new EventPushSubscriber();
     listener.conductExperiment(args);
 
  } // end of main() 

}// end EventPushSubscriber

