
import org.omg.CosEventComm.*;
import org.omg.CosEventChannelAdmin.*;
import org.omg.CORBA.*;

/**
*
* Produces a message which can be pulled by the
* event channel.
*
* @author Zeynep Odcikin-Ozdemir
* @date   Dec 22, 1998
*
*/
public class 
EvtPullSupplier extends _PullSupplierImplBase 
{
   /** Disconnected */
   Disconnect d =null;

   /** counter */
   int count = 0;

   /** connected */
   boolean connected = true;

   /**
   */
   public EvtPullSupplier(Disconnect _d)
   { d = _d;
   }// end of CONSTRUCTOR

   /**
   */
   public void disconnect_pull_supplier()
   { connected = false;
     org.omg.CORBA.ORB.init().disconnect(this);
     if(d!=null) d.disconnect();
   }// end of disconnect_pull_supplier()

   /**
   */
   public Any pull() throws org.omg.CosEventComm.Disconnected 
   { 
      if(!connected) throw new org.omg.CosEventComm.Disconnected();

      org.omg.CORBA.Any an = org.omg.CORBA.ORB.init().create_any();
      an.type(org.omg.CORBA.ORB.init().get_primitive_tc(TCKind.tk_string));
      an.insert_string("hello"+count);
      count++;
      return an;        
   }// end of pull()

   /**
   */
   public Any 
   try_pull(org.omg.CORBA.BooleanHolder has_event)
          throws org.omg.CosEventComm.Disconnected 
   { 
      if(!connected) throw new org.omg.CosEventComm.Disconnected();
     
      org.omg.CORBA.Any ret = null;

      if(count%4==0)
      {  
         ret = org.omg.CORBA.ORB.init().create_any();
         ret.type(org.omg.CORBA.ORB.init().get_primitive_tc(TCKind.tk_string));
         ret.insert_string("hello"+count);
         count++;

      } else has_event.value=false;

      return ret;  
     
   }// end of try_pull()

}// end of EvtPullSupplier

