
import java.util.Properties;
import org.omg.CORBA.*;
import org.omg.CosNaming.*;

import worb.protocols.iiop.util.*;


/**
stolen from http://java.sun.com/products/jdk/1.2/docs/guide/idl/jidlNaming.html
*/
public class NameClient
{
   public static void main(String args[])
   {
      try 
      { 

         int k,i;
         String strIOR = IORProvider.getIOR("kernels.srv","IDL:omg.org/CosNaming/NamingContext:1.0");

	   if(strIOR!=null && strIOR.startsWith("IOR:") )
         { 
           
 
            Properties prop = new Properties();
            prop.put("org.omg.CORBA.ORBClass","worb.protocols.iiop.ORBImpl");
            prop.put("org.omg.CORBA.ORBSingletonClass","worb.protocols.iiop.ORBImpl");
            System.out.println(" I read IOR --> "+strIOR);

            // Create and initialize the ORB
            ORB orb = ORB.init(args, prop);

            System.out.println(" IOR --> "+strIOR);
            org.omg.CORBA.Object objRef = orb.string_to_object(strIOR);

            if( objRef == null ) System.out.println(" objRef is NULL! ");
      
         //Properties props = new Properties();
         //props.put("org.omg.CORBA.ORBInitialPort", "1050");
         //org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args, props);

            NamingContext ctx = NamingContextHelper.narrow(objRef);
            //NamingContext objref = ctx;

            if( ctx == null ) System.out.println(" ctx is NULL! ");
            NamingContext objref = ctx.new_context();
 
            for(k=0;k<15;k++)
            {
              NameComponent nc1 = new NameComponent("plans"+k, "text");
              NameComponent[] name1 = {nc1};
              ctx.rebind(name1, objref);
              System.out.println("******plans"+k+" rebind sucessful!");
            }// end of for

            NameComponent nc2 = new NameComponent("Personal", "directory");
            NameComponent[] name2 = {nc2};
            NamingContext ctx2 = ctx.bind_new_context(name2);
            System.out.println("*****new naming context added..");

            if( ctx2==null ) System.out.println("new naming context is NULL!!!");

            NameComponent nc3 = new NameComponent("schedule", "text");
            NameComponent[] name3 = {nc3};
            System.out.println(" Before ctx.rebind() --> ");
            ctx2.rebind(name3, objref);
            System.out.println("schedule rebind sucessful!");

            NameComponent nc4 = new NameComponent("calender", "text");
            NameComponent[] name4 = {nc4};
            ctx2.rebind(name4, objref);
            System.out.println("calender rebind sucessful!");

            NameComponent nc5 = new NameComponent("tim1", "directory");
            NameComponent[] name5 = {nc5};
            NamingContext ctx3 = ctx2.bind_new_context(name5);
            System.out.println("*****new naming context added..");

            for(k=0;k<5;k++)
            {
              NameComponent nc11 = new NameComponent("evren"+k, "text");
              NameComponent[] name11 = {nc11};
              ctx3.rebind(name11, objref);
              System.out.println("******evren"+k+" rebind sucessful!");

            }// end of for

         }// end of if

    } catch (Exception e) { e.printStackTrace(System.err); }

  } // end of main() 

}// end NameClient

