
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Properties;
import org.omg.CORBA.*;
import org.omg.CosNaming.*;

import worb.protocols.iiop.util.*;



/**
* taken from http://java.sun.com/products/jdk/1.2/docs/guide/idl/jidlNaming.html
* and changed a little bit.
*
* @author Zeynep Odcikin-Ozdemir
* @date   Dec 18, 1998
*
*/
public class NameClientList
{
   /** */
   public NameClientList()
   { }

   /** */
   public void listContext(NamingContext nc, String pream, Hashtable tre)
   {
       try
       {  int i; 
          BindingListHolder bl       = new BindingListHolder();
          BindingIteratorHolder blIt = new BindingIteratorHolder();

          // Get at most 10 elements into BindingList.
          // The rest will be sitting in the BindingIterator object.
          nc.list(10, bl, blIt);

          Binding bindings[] = bl.value;
          if (bindings.length == 0) return;

          // Process the binding list
          for (i=0; i < bindings.length; i++) 
               processABinding(nc,pream,tre,bindings[i]);
   
          org.omg.CosNaming.BindingListHolder bLstHolder = new org.omg.CosNaming.BindingListHolder();
         
          // If there are some in BindingIterator, ask first 2 
          if( blIt.value!=null && blIt.value.next_n(2,bLstHolder) )
          {
            // Consume the received info 
            if( bLstHolder.value!=null)
                for(i=0;i<bLstHolder.value.length;i++) processABinding(nc,pream,tre,bLstHolder.value[i]);
           
            org.omg.CosNaming.BindingHolder bHolder = new org.omg.CosNaming.BindingHolder();
         
            // Consume the rest, one by one
            while( blIt.value.next_one(bHolder) ) processABinding(nc,pream,tre,bHolder.value);

            // Destroy the BindingIterator
            blIt.value.destroy();

          }// end of if

          
       } catch (Exception e) { e.printStackTrace(System.err); } 
   
   }// end of listContext()

   final void 
   processABinding(NamingContext nc, String pream, Hashtable tre, Binding b )
          throws org.omg.CosNaming.NamingContextPackage.NotFound, 
                 org.omg.CosNaming.NamingContextPackage.CannotProceed, 
                 org.omg.CosNaming.NamingContextPackage.InvalidName
   {
      // get the object reference for each binding
      org.omg.CORBA.Object obj = nc.resolve(b.binding_name);

      System.out.println(" after resolve! ");

      //String objStr = org.omg.CORBA.ORB.init().object_to_string(obj);
      int lastIx = b.binding_name.length-1;

      // check to see if this is a naming context
      if (b.binding_type == BindingType.ncontext) 
      {
          System.out.println( pream+" Context: " + b.binding_name[lastIx].id);
          Hashtable tre1 = new Hashtable();
          listContext((NamingContext)obj,pream+"**",tre1);
          tre.put( b.binding_name[lastIx].id,tre1); 
      } else {
          System.out.println(pream+" Object: " + b.binding_name[lastIx].id);
          tre.put( b.binding_name[lastIx].id,new Hashtable()); 
      }   

   }// end of processABinding()

   public void listObjects(String args[])
   {

      try 
      { 
         int i;
         String strIOR = IORProvider.getIORFromFile("IOR");//kernels.srv","IDL:omg.org/CosNaming/NamingContext:1.0");

         if(strIOR!=null && strIOR.startsWith("IOR:") )
         {


            Properties prop = new Properties();
            prop.put("org.omg.CORBA.ORBClass","worb.protocols.iiop.ORBImpl");
            prop.put("org.omg.CORBA.ORBSingletonClass","worb.protocols.iiop.ORBImpl");
            System.out.println(" I read IOR --> "+strIOR);

            // Create and initialize the ORB
            ORB orb = ORB.init(args, prop);

            System.out.println(" IOR --> "+strIOR);
            org.omg.CORBA.Object objRef = orb.string_to_object(strIOR);

            if( objRef == null ) System.out.println(" objRef is NULL! ");


        //Properties props = new Properties();
        //props.put("org.omg.CORBA.ORBInitialPort", "1050");
        //ORB orb = ORB.init(args, props);
        //ORB orb = org.omg.CORBA.ORB.init();

            //NamingContext nc = NamingContextHelper.narrow(orb.resolve_initial_references("NameService"));
            NamingContext nc = NamingContextHelper.narrow(objRef);
            Hashtable nTree = new Hashtable();
            listContext(nc,"**",nTree);

            printTree(nTree,".");
 
         }// end of if

       } catch (Exception e) { e.printStackTrace(System.err); } 

   }// end of listObjects()
 
   public void printTree(Hashtable nTree, String pream)
   {
      if(nTree!=null)
      {
        Enumeration e = nTree.keys();
        while( e.hasMoreElements() )
        {
          String ky = (String) e.nextElement();
          if( ky!=null )
          {
             Hashtable a = (Hashtable)nTree.get(ky);
             System.out.println(pream+ky);
             if( a!=null && a.size()>0 ) printTree(a,pream+ky+".");
          }// end of if

        }// end of while 

      }// end of if

   }// end of printTree()

   public static void main(String args[])
   {
      NameClientList nLister = new NameClientList();
      nLister.listObjects(args);
   }// end of main()

}// end of NameClientList
