// test1_impl.cc : Tests the ORB with several basic data types.
//                 This is the object implementation.
//
// Usage: test1_impl <name_of_IOR_file>
//
//        On startup, the object reference is printed to cerr as a
//        stringified IOR and the file provided from the command line. 
//        This string can be used as the argument to test1_clt.
//
// author H. Timucin Ozdemir
// date   July 6, 1998
//
#include <fstream.h>
#include <iostream.h>
#include "omnithread.h"
#include "anyidl.hh"
#include "aTest_i.h"

int
main(int argc, char **argv)
{
  CORBA::ORB_ptr orb = CORBA::ORB_init(argc,argv,"omniORB2");
  CORBA::BOA_ptr boa = orb->BOA_init(argc,argv,"omniORB2_BOA");

  if( argc > 0 )
  {
   
  
      aTest_i *myobj = new aTest_i();
      myobj->_obj_is_ready(boa);

      jworbTest1_var myobjRef = myobj->_this();
      CORBA::String_var p = orb->object_to_string(myobjRef);
      cerr << "'" << (char*)p << "'" << endl;

      ofstream fout(argv[1]);
      fout << (char*)p;
      fout.close();

      ofstream fout2("IOR");
      fout2 << (char*)p;
      fout2.close();

      // Tell the BOA we are ready. The BOA's default behaviour is to block
      // on this call indefinitely.
      boa->impl_is_ready();

  } else  cout << " argc is " << argc << endl;

  return 0;

}// end of main
