#
# Usage:
#   nmake /f dir.mk [<build option>]
#
#  <build option>:
#      all       - build all executables
#      clean     - delete all executables and obj files
#      veryclean - clean plus delete all stub files generated by omniidl2
#        
#
# Pre-requisite:
#
# Make sure that you have environment variable LIB and INCLUDE setup for
# using Developer studio from the command line. Usually, this is accomplished
# by source the vcvars32.bat file.
#

# Where is the top of this distribution. All executable, library and include
# directories are relative to this variable.
#
TOP = ..\..\..


##########################################################################
# Essential flags to use omniORB2
#
DIR_CPPFLAGS   = -I. -I$(TOP)\include
#
#
CORBA_CPPFLAGS = -D__WIN32__ -D__x86__ -D__NT__ -D__OSVERSION__=4
CORBA_LIB      = omniORB25_rt.lib omnithread2_rt.lib wsock32.lib advapi32.lib \
		 -libpath:$(TOP)\lib\x86_win32
CXXFLAGS       = -O2 -MD -GX $(CORBA_CPPFLAGS) $(DIR_CPPFLAGS)
CXXLINKOPTIONS =

.SUFFIXES: .cc
.cc.obj:
  cl /nologo /c $(CXXFLAGS) /Tp$<

########################################################################
# To build debug executables
# Replace the above with the following:
#
#CORBA_CPPFLAGS = -D__WIN32__ -D__x86__ -D__NT__ -D__OSVERSION__=4
#CORBA_LIB      = omniORB25_rtd.lib omnithread2_rtd.lib wsock32.lib \
#                 advapi32.lib -libpath:$(TOP)\lib\x86_win32
#CXXFLAGS       = -MDd -GX -Z7 -Od  $(CORBA_CPPFLAGS) $(DIR_CPPFLAGS)
#CXXLINKOPTIONS = -debug -PDB:NONE      

all:: test2_clt.exe test2_impl.exe 

test2_clt.exe: callbackSK.obj echo1SK.obj jworbTest2SK.obj test2_clt.obj
  link -nologo $(CXXLINKOPTIONS) -out:$@ $** $(CORBA_LIB) 

test2_impl.exe: callbackSK.obj echo1SK.obj jworbTest2SK.obj test2_impl.obj
  link -nologo $(CXXLINKOPTIONS) -out:$@ $** $(CORBA_LIB)

clean::
  -del *.obj
  -del *.exe


veryclean::
  -del *.obj
  -del callbackSK.* echo1SK.* callback.hh echo1.hh jworbTest2SK.* jworbTest2.hh
  -del *.exe

callback.hh callbackSK.cc: callback.idl
	$(TOP)\bin\x86_win32\omniidl2 -h .hh -s SK.cc callback.idl

echo1.hh echo1SK.cc: echo1.idl
	$(TOP)\bin\x86_win32\omniidl2 -h .hh -s SK.cc echo1.idl

jworbTest2.hh jworbTest2SK.cc: jworbTest2.idl
	$(TOP)\bin\x86_win32\omniidl2 -h .hh -s SK.cc jworbTest2.idl
