#
# Usage:
#   nmake /f dir.mk [<build option>]
#
#  <build option>:
#      all       - build all executables
#      clean     - delete all executables and obj files
#      veryclean - clean plus delete all stub files generated by omniidl2
#        
#
# Pre-requisite:
#
# Make sure that you have environment variable LIB and INCLUDE setup for
# using Developer studio from the command line. Usually, this is accomplished
# by source the vcvars32.bat file.
#
WIN32 = 
# Where is the top of this distribution. All executable, library and include
# directories are relative to this variable.
#
include ..\..\..\mk\config.win
TOP = $(PARALLEL_CMS)\omniORB_2.7.1

RTI_CPP_HOME = $(PARALLEL_CMS)\owrti\C++Lib\RtiCapLib
PUBLIC_INCL = -I$(RTI_CPP_HOME)\include
RTI_LIB     = RtiCap.lib

##########################################################################
# Essential flags to use omniORB2
#
DIR_CPPFLAGS   = -I. -I$(TOP)\include -Ic:\progra~1\devstudio\vc\include
#
#
CORBA_CPPFLAGS = -D__WIN32__ -D__x86__ -D__NT__ -D__OSVERSION__=4
CORBA_LIB      = omniORB271_rt.lib omnithread2_rt.lib wsock32.lib \
		 advapi32.lib RtiCap.lib \
		 -libpath:$(TOP)\lib\x86_win32 -libpath:$(RTI_CPP_HOME) -libpath:c:\progra~1\devstudio\vc\lib
CXXFLAGS       = -O2 -MD -GX $(CORBA_CPPFLAGS) $(DIR_CPPFLAGS) $(PUBLIC_INCL) 
CXXLINKOPTIONS =

.SUFFIXES: .cc .cpp
.cc.obj:
  cl /nologo /c $(CXXFLAGS) /Tp$<

.cpp.obj:
  cl /nologo /c $(CXXFLAGS) /Tp$<


########################################################################
# To build debug executables
# Replace the above with the following:
#
#CORBA_CPPFLAGS = -D__WIN32__ -D__x86__ -D__NT__ -D__OSVERSION__=4
#CORBA_LIB      = omniORB25_rtd.lib omnithread2_rtd.lib wsock32.lib \
#                 advapi32.lib -libpath:$(TOP)\lib\x86_win32
#CXXFLAGS       = -MDd -GX -Z7 -Od  $(CORBA_CPPFLAGS) $(DIR_CPPFLAGS)
#CXXLINKOPTIONS = -debug -PDB:NONE      

HW_OBJS = helloWorld.obj Country.obj HwFederateAmbassador.obj

all:: helloworld.exe

helloworld.exe: $(HW_OBJS)
	link -nologo $(CXXLINKOPTIONS) -out:$@ $** $(CORBA_LIB)

clean::
  -del *.obj
  -del *.exe

runHello::
	helloWorld au 10 10

runHello1::
	helloWorld us 100 50

runHello2::
	helloWorld fr 200 50
