#include "DemoMgr.h"
#include "NetMgr.h"

unsigned short  cDemoMgr::fsSite = 16;
unsigned short  cDemoMgr::fsApplication = 232;

TStartupParam::TStartupParam()
{ 
   feProtocol        = eDis203;
   feQrpProtocol     = eQrp1;
   feCpProtocol      = eCp1;
   fbOrientation     = false;
   fbBurialDepth     = false;
   fbTemperature     = false;
   fTerrainName      = NULL;
   fDisPort          = 3000;
   fCmsPort          = 3010;
   fMulticastAddr    = NULL;
   fTtl              = 32;
   fSite             = 1;      
   fApplication      = 1;     
   fExerciseId       = 1;
}

void  cDemoMgr::SetStartupParams( int* pArgc, char* argv[])
{
   int arg = 1;

   if ( ( *pArgc > 1 ) &&  ( strcmp ( argv[1], "-f" ) != 0 ) ){

      fStartupParam.fTerrainName = NULL;
      fStartupParam.feProtocol        = eDis203;
      fStartupParam.feQrpProtocol     = eQrpNo;
      fStartupParam.feCpProtocol      = eCp1HeartBeat;
      fStartupParam.fbOrientation     = false;
      fStartupParam.fbBurialDepth     = false;
      fStartupParam.fbTemperature     = false;
      fStartupParam.fTerrainName      = cppstrdup( "knox-0311" );
      fStartupParam.fDisPort          = 3000;
      fStartupParam.fCmsPort          = 3010;
      fStartupParam.fSite             = 1;
      fStartupParam.fApplication      = 1;

      while ( arg < *pArgc ){
       if ( strcmp ( argv[arg], "-network" ) == 0)       
            fStartupParam.feProtocol = eDis203;
          // REGION 5. ZEYNEP - UPDATE (HLA)!
         else if ( strcmp ( argv[arg], "-hla" ) == 0)       // network protocol
            fStartupParam.feProtocol = eHLA;
         //END OF REGION 5.

        else if ( strcmp ( argv[arg], "-disport" ) == 0) {
          if ( ( ( arg + 1 ) < *pArgc ) && ( argv[arg+1][0] != '-' ) ){
               fStartupParam.fDisPort = atoi ( argv[arg+1] );
             arg++;
          }
          else                                           
             fStartupParam.fDisPort = 3000;
        }  
        else if ( strcmp ( argv[arg], "-ttl" ) == 0) {
          if ( ( ( arg + 1 ) < *pArgc ) && ( argv[arg+1][0] != '-' ) ){
               fStartupParam.fTtl = atoi ( argv[arg+1] );
             arg++;
          }
          else                                           
             fStartupParam.fTtl = 32;
        } 
        else if ( strcmp ( argv[arg], "-unicast" ) == 0) {
          if  ( ( ( arg + 1 ) < *pArgc ) && ( argv[arg+1][0] != '-' ) ){
           fStartupParam.fMulticastAddr = cppstrdup ( argv [ arg + 1 ] );
           arg++;
          }
          else                                     
           fStartupParam.fMulticastAddr = NULL;
         }
         else if ( strcmp ( argv[arg], "-minesorient" ) == 0)
            fStartupParam.fbOrientation = true;           
         else if ( strcmp ( argv[arg], "-nominesorient" ) == 0)
            fStartupParam.fbOrientation = false;          
         else if ( strcmp ( argv[arg], "-minesdepth" ) == 0)
            fStartupParam.fbBurialDepth = true;           
         else if ( strcmp ( argv[arg], "-nominesdepth" ) == 0)
            fStartupParam.fbBurialDepth = false;         
         else if ( strcmp ( argv[arg], "-minestemp" ) == 0)
            fStartupParam.fbTemperature = true;           
         else if ( strcmp ( argv[arg], "-nominestemp" ) == 0)
            fStartupParam.fbTemperature = false;          
         else if ( strcmp ( argv[arg], "-qrp" ) == 0)
            fStartupParam.feQrpProtocol = eQrp1;          
         else if ( strcmp ( argv[arg], "-noqrp" ) == 0)
            fStartupParam.feQrpProtocol = eQrpNo;         
         else if ( strcmp ( argv[arg], "-cp" ) == 0){     
                fStartupParam.feCpProtocol = eCp1HeartBeat;
         }  
         else if ( strcmp ( argv[arg], "-nocp" ) == 0)
            fStartupParam.feCpProtocol = eCpNo;            
         else if ( strcmp ( argv[arg], "-terrain" ) == 0) {
            if  ( ( ( arg + 1 ) < *pArgc ) && ( argv[arg+1][0] != '-' ) ){
              delete [] fStartupParam.fTerrainName;
              fStartupParam.fTerrainName = cppstrdup( argv[arg+1] );
              arg++;
            }
            else                                         
           		fStartupParam.fTerrainName = cppstrdup ( "knox-0311" );
         }  
         arg++;
      } 

   } 
   fStartupParam.fSite = fsSite;
   fStartupParam.fApplication = fsApplication;
}

void cDemoMgr::Initialize( int* pArgc, char* argv[] )
{  SetStartupParams (pArgc, argv);
   gpNetMgr = new cNetMgr(fStartupParam);
}

void cDemoMgr::Shutdown(void)
{ if ( gpNetMgr )
   {
      gpNetMgr->NetShutdown();
      //REGION 9. ZEYNEP - UPDATE (HLA) !
      delete gpNetMgr;
      //END OF REGION 9.
   }

}

void cDemoMgr::Run(void)
{ 
  while(true)
   gpNetMgr->RecvPdu();      // loops internally until all PDUs received
}

cDemoMgr::cDemoMgr(void)
{
}

cDemoMgr::~cDemoMgr(void)
{
}

