#ifndef _DisPdu203_
#define _DisPdu203_


#include "Globals.h"
#include "NetMgr.h"
//#include "Vehicle.h"
#include "dis203_types.h" 

enum EPduType { epduTypeNone = 0,
                epduTypeEntityState,
                epduTypeFire,
                epduTypeDetonation,
                epduTypeCollision,
                epduTypeServiceRequest     = 5,
                epduTypeResupplyOffer,
                epduTypeResupplyReceived,
                epduTypeResupplyCancel,
                epduTypeRepairComplete,
                epduTypeRepairResponse     = 10,
                epduTypeCreateEntity,
                epduTypeRemoveEntity,
                epduTypeStartResume,
                epduTypeStopFreeze,
                epduTypeAcknowledge        = 15,
                epduTypeActionRequest,
                epduTypeActionResponse,
                epduTypeDataQuery,
                epduTypeSetData,
                epduTypeData               = 20,
                epduTypeEventReport,
                epduTypeMessage,
                epduTypeEmission,
                epduTypeLaser,
                epduTypeTransmitter        = 25,
                epduTypeSignal,
                epduTypeReceiver           = 27,

        epduTypeExpEnvironment     = 154, 
                epduTypeCpMinefield        = 160, 
                epduTypeCpMines            = 161, 

                epduTypeMinefieldRequest   = 188,
                epduTypeMinefieldResponse  = 189,
                epduTypeMinefieldState     = 190 ,
                };

/*
class cDisPdu {
 
 public:
 
   static const  float     fsDefaultPlowDepth;
   
         //   data type translators, DIS to CMS
   static TEntityID        CmsEntID(const DIS203_ENTITY_ID_RECORD & id);
   static EForce           CmsForce( void* pForce);
   static TEntityType      CmsEntType(const DIS203_ENTITY_TYPE_RECORD & type);
   static EAppearance      CmsVehAppear(const DIS203_ENTITY_APPEARANCE_TYPE & appear);
   static EDeadReckonAlg   CmsVehDr(const DIS203_DEAD_RECKONING_ALGORITHM_TYPE & alg);
   static TLocation        CmsVehLoc(const DIS203_WORLD_COORDINATES_RECORD & loc);
   static TEntCoord        CmsEntLoc(const DIS203_ENTITY_COORDINATE_VECTOR_RECORD & loc);
   static TVelocity        CmsVehVel(const DIS203_LINEAR_VELOCITY_VECTOR_RECORD & vel);
   static TOrient          CmsVehOrient(const DIS203_EULER_ANGLES_RECORD & orient);
   static TAccel           CmsVehAccel(const DIS203_LINEAR_ACCELERATION_VECTOR_RECORD & accel);
   static TAngVel          CmsVehAngVel(const DIS203_ANGULAR_VELOCITY_VECTOR_RECORD & angVel);

   static EWarhead         CmsWarhead(const DIS203_WARHEAD_TYPE warhead);
   static EFuze            CmsFuze(const DIS203_FUZE_TYPE fuze);
   static EDetonResult     CmsDetResult(const void* pDisResult);
   static void             SetArticPartParams(const DIS203_ARTICULATION_PARAMETER_RECORD& partRec,
                                    TVehPart* pPart);
   static EPartParam       CmsAttachPartType(const DIS203_PARAMETER_TYPE_TYPE type);
};

*/
/*
 * DIS PDU translator, translates from CMS to DIS
 */
class cDisPduTranslator : public cPduTranslator {
 protected:
   
   /*cQrpManager*         fpQrpMgr;
   cCpManager*          fpCpMgr;


   enum {DisFusingNoFuze = 0,
   	 DisFusingOther,
	 DisFusingPressure,
	 DisFusingMagnetic,
	 DisFusingTiltrod,
	 DisFusingCommand,
	 DisFusingTripwire };
*/ 

 public:
         //   data type translators, CMS to DIS
 /*  DIS203_ENTITY_ID_RECORD                     DisEntID(const TEntityID & id);
   DIS203_ENTITY_ID_RECORD                     DisEntID(unsigned short idNum);   // fills in site and application
   void            DisForce(void* pDisForce, EForce force);
   DIS203_ENTITY_TYPE_RECORD                   DisEntType(const TEntityType & type);
   DIS203_ENTITY_APPEARANCE_TYPE               DisVehAppear(EAppearance appear);
   DIS203_DEAD_RECKONING_ALGORITHM_TYPE        DisVehDr(EDeadReckonAlg alg);
   DIS203_PARAMETER_TYPE_TYPE                  DisVehPartParam(EPartParam paramType, const EPartValueType & valType);
   DIS203_WORLD_COORDINATES_RECORD             DisVehLoc(const TLocation & loc);
   DIS203_LINEAR_VELOCITY_VECTOR_RECORD        DisVehVel(const TVelocity & vel);
   DIS203_EULER_ANGLES_RECORD                  DisVehOrient(const TOrient & orient);
   DIS203_LINEAR_ACCELERATION_VECTOR_RECORD    DisVehAccel(const TAccel & accel);
   DIS203_ANGULAR_VELOCITY_VECTOR_RECORD       DisVehAngVel(const TAngVel & angVel);

   DIS203_EVENT_ID_RECORD                      DisEventID(const TEntityID & id);   // fills in site and application
   DIS203_EVENT_ID_RECORD                      DisEventID(unsigned short idNum);   // fills in site and application
   DIS203_BURST_DESCRIPTOR_RECORD              DisBurstDesc( const TEntityType &, EWarhead, EFuze);
   DIS203_DETONATION_RESULT_TYPE               DisDetonResult( EDetonResult );
   DIS203_ENTITY_COORDINATE_VECTOR_RECORD      DisEntLoc(const TEntCoord & loc);
   DIS203_ENTITY_COORDINATE_VECTOR_RECORD      DisEntLoc(const T3Ddouble & loc);
   DIS203_RANGE_TYPE                           DisRange(float range)   { return range; }
   short					  DisFusing(cMine* pMine);

             void         RecvESPdu(void * buf, TTimeSim timeDelta = 0);
             int          ProcessableEsPdu(void * buf);
             void         WriteEsPdu(void * buf);
	     void         RecvEmissionPdu(void* buf, TTimeSim timeDelta = 0);
             void         RecvDetonPdu(void * buf, TTimeSim timeDelta = 0);
             void         RecvEnvironmentPdu(void * buf, TTimeSim timeDelta = 0);
             EBoolean     IsAreaDetonation(void * buf);
             void         WriteDetonPdu(void * buf);
*/
   virtual   void         ReceivePdu(void * buf, TTimeSim timeDelta = 0);
   virtual   EBoolean     VerifyPdu( void* buf);
   virtual   int          GetPduType( void* buf);
/*
             void         FillHdr(DIS203_PDU_TYPE_TYPE type);
             
   virtual   void        SendVehState(cVehicle* pVeh);
   virtual   void        SendMineDetonation(TDetonationData& detData );
   virtual   void        SendMineFire(TFireData& fireData);
   virtual   void        SendProjFire(cProjectile* pProjectile);
   virtual   void        SendProjDeton(cProjectile* pProjectile);
   virtual   void        SendViewControl(cVehicle* pView, TEntityID toID);

   virtual void    ProcessMineResponse(cMinefield* pMf, T2linkHead* pTypeList,
               TEntityID reqId, int reqNum,short fNumReqSensors, TEntityType* pReqSensorTypes);
   virtual void    SendMineResponse(cMinefield* pMf, T2linkHead* pMineList, TEntityID reqId,
                     int reqNum, TEntityType& type, int numMines, int msgNum, int msgsTot, short numReqSens,
                                TEntityType* pReqSensType);
                     
   virtual   void        SendMinefieldState(cMinefield* pMf);
   
             void   SendCpMines(T2linkMineSetList* pMineSet);
             void   SendCpMinefield(cMinefield* pMf);
   
   EBoolean         UsesCp() { return  fpCpMgr ? true : false; }
   EBoolean         UsesCpwQe();
   EBoolean         IncludeThermal()  { return fpCpMgr ? fpCpMgr->IncludeThermal() : false; }
   EBoolean         IncludeBurial()  { return fpCpMgr ? fpCpMgr->IncludeBurial() : false; }
   EBoolean         IncludeOrient()  { return fpCpMgr ? fpCpMgr->IncludeOrient() : false; }
   EBoolean         UsesQrp() { return  fpQrpMgr ? true : false; }
   
   void             TranslatorShutdown();
   
*/
   cDisPduTranslator( EQrpProtocol qrp, ECpProtocol cp, EBoolean bOrient,
                                      EBoolean bBurial, EBoolean bTemp);
  
};
 
#endif
