
#ifndef _UGlobals_
#define _UGlobals_

/*
#include <limits.h>
#include <float.h>

#include "EntityEnums.h"
*/

#include "GlobalTypes.h"

#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>
#include <stdio.h>
/*
#include <libtactmap.h>

// global constants
extern char Datapath[256]; 
extern char DatapathConst[256];
extern char Const[256];
extern char Setupdir[256];
*/
      //+++++++++error numbers
enum EerrorNumber   {
   kerrNone = 0,
   kerrDebug,
   kerrNoBuff,
   kerrNoPduSend,
   kerrRecvError,
   kerrReadTerrain,
   kerrReadMinefield,
	kerrReadParamfile,
   
         //errors after this lead to shutdown
   kerrLowestFatal = 500,
   kerrMemory = kerrLowestFatal,
   kerrValidityCheck,
   kerrNoRecvBcast,
   kerrBindSocket,
   kerrNoBlock,
   kerrCreateSendSocket,
   kerrNoSendBcast,
   kerrInvalidMcast,
   kerrNoSubscribeMcast,
   kerrNoTtlMcast,
   kerrNoDisableLoop,
   kerrCoordRead,
   kerrProtocolFamily,
   kerrList,
   kerrTypeMatch
   
};

extern   const double kSimTimeToDis;

//   Global constants, declared extern here.  Most defined in main.cc
/*
extern   const char*  kpCmsVersion;
extern   const double kSimTimeToSec;
extern   const double kSecToSimTime;
extern   const double kSimTimeToDis;
extern   const double kDisToSimTime;
extern   const double kSimTimeToUsec;
extern   const double kUsecToSimTime;
extern   int   kMaxMinesInField;

extern   const double kPi;
extern   const double kHalfPi;
extern   const double kDegToRad;
extern   const double kRadToDeg;
extern   const double kHalfGravAccel;
extern   const double kInchToMeter;
extern   const double kMeterToInch;

//   Global variables, declared extern here.  Most defined in main.cc

//   message lists
extern   cPrEventList     gPrEventList;
extern   cPrUpdtList      gPrUpdtList;
extern   cEventList       gEventList;
extern   cUpdtList        gUpdtList;
extern   cDispUpdtList    gDispUpdtList;
extern   cLowPrEventList  gLowPrEventList;
extern   cLowRateUpdtList gLowRateUpdtList;

   // file types, defined in FileObj
extern   char*   gftypeUndefined;
extern   char*   gftypeMinefields;
extern   char*   gftypeParam;
extern   char*   gftypeNetParam;
extern   char*   gfmechVulnParam;
extern   char*   gfdetVulnParam;
extern   char*   gftypeInteract;
extern   char*   gftypeMineState;
extern   char*   gftypeMineInputs;
extern   char*   gftypeVehicleInputs;
extern   char*   gftypeTestFile;
extern   char*   gftypePduData;

extern   const int kYesNoPairs;
extern   const TKeyValuePair gpYesNoText[];

//   miscellaneous
class cMinefield;
class cMfComponent;
class cMfieldObj;
class cPerimeter;

extern   EBoolean         gbGui;
extern   EBoolean         gbHost;
extern   TACTMAP_PTR      gpTactmap;
extern   Display*         gpDisplay;
extern   Window           gMapWindow;
extern   long             gSimStartTime;      // in seconds, not TTimeSim
*/

#ifdef sgi
typedef  unsigned int     iotimer_t;
extern   unsigned int     gSimStartCycle;        // in cycles
extern   long             gStartTimeMilli;
extern volatile iotimer_t       *gpTimerAddr;
extern   double           gCycleVal;
extern   unsigned int     max_diff;
#define  MAXNUMCYCLES     4294967295.0           // 2^32 - 1
#endif

/*
//   managers etc.
class   cEntityDBMgr;
class   cMineDBMgr;
class   cVehDBMgr;
class   cProjDBMgr;
class   cMechThreatList;
class   cDetThreatList;
class   cMsgMgr;
*/
class   cNetMgr;
class   cDemoMgr;
/*
class   cVehicleMgr;
class   cEmissionMgr;
class   cMfieldMgr;
class   cTerrain;
class   cGuiWindow;
*/

class   cDisPduType;

/*
extern   cMineDBMgr       gMineDbMgr;
extern   cVehDBMgr        gVehDbMgr;
extern   cProjDBMgr       gProjDbMgr;
extern   cMechThreatList  gMechThreatList;
extern   cDetThreatList   gDetThreatList;
extern   cMsgMgr          gMsgMgr;
*/
extern   cNetMgr*         gpNetMgr;

extern   cDemoMgr          gDemoMgr;

/*
extern   cEmissionMgr     gEmissionMgr;
extern   cVehicleMgr      gVehMgr;
extern   cMfieldMgr       gMfieldMgr;
extern   cTerrain*        gpTerrainMgr;
extern   cGuiWindow *     gpGuiWin;
*/
extern   cDisPduType      gPduType;
/*
      // output control flags, file object pointers, and file names
extern int         gFileProt;      // protection mode for created output files
extern int         gfInteract;
extern ofstream*   gpInteract;
extern char*       gpInteractFileName;

extern int         gfMineStateDisp;
extern int         gfMineStateSumm;
extern ofstream*   gpMineStateSumm;
extern char*       gpMineStateFileName;

extern int         gfMineInputParams;
extern ofstream*   gpMineInputParams;
extern char*       gpMineInputFileName;

extern int         gfVehicleInputParams;
extern ofstream*   gpVehicleInputParams;
extern char*       gpVehicleInputFileName;

extern int         gfPduData;
extern ofstream*   gpPduData;
extern char*       gpPduDataFileName;

extern int      gfTestRun;
extern int      gfVehicle;
extern int      gfMinefield;
extern int      gfMine;
extern int      gfFixObj;
extern int      gfSensor;
extern int      gfDamage;
extern int      gfControl;
extern int      gfAttack;
*/
extern int      gfNetif;
/*
extern int      gfDetectProt;

extern char*    gpRunName;

//   Global functions.  Most defined in main.cc

extern   float            UniformRand();         // uniform on (0,1)
extern   void             SetRand(unsigned int seed);
*/
extern   TTimeSim         GetCurSimTime();
extern   void             SetSimStartTime();
extern   char*            cppstrdup( const char* pStr);

/*
extern   void   NewFailureHandler();         //called if new cannot get memory it needs
*/
extern   void   Assert(int, EerrorNumber, char* fnName = 0, int sysErr = 0);    //condition to test, err num on failure
/*
extern   void   Shutdown(EerrorNumber);       // global, can be called regardless of CMS state

extern "C" int yywrap();

extern   TLocation     EntToSimLoc( const TEntCoord& entLoc, const TLocation& entOrigin, const TOrient& entOrient );
extern   TEntCoord     SimToEntLoc( const TLocation& simLoc, const TLocation& entOrigin, const TOrient& entOrient );
extern   EBoolean      IsVerySmall( const double x );

   // geometry helpers
extern   int   CntrClk(double pt0x, double pt0y, double pt1x, double pt1y, double pt2x, double pt2y);
extern   int   CntrClk(const T3Dsingle& pt0, const T3Dsingle& pt1, const T3Dsingle& pt2);

extern   EBoolean   SegIntersect(const T3Dsingle& seg1pt1, const T3Dsingle& seg1pt2, const T3Dsingle& seg2pt1, const T3Dsingle& seg2pt2);
extern   EBoolean   SegIntersect(const T3Ddouble& seg1pt1, const T3Ddouble& seg1pt2, const T3Ddouble& seg2pt1, const T3Ddouble& seg2pt2);
extern   EBoolean   PtInPolygon(const T3Dsingle& pt, int numPolyPts, const T3Dsingle* pPolyPts);
extern   EBoolean   PtInPolygon(const T3Ddouble& pt, int numPolyPts, const T3Ddouble* pPolyPts);

*/
#endif
