/*
 * $RCSfile$ $Revision$ $State$
 */
/****************************************************************************
*   File: stdbcopy.h		                                            *
*                                                                           *
*       Copyright 1996 by Loral Advanced Distributed Simulation, Inc.       *
*                                                                           *
*               Loral Advanced Distributed Simulation, Inc.                 *
*               50 Moulton Street                                           *
*               Cambridge, MA 02138                                         *
*               617-441-2000                                                *
*                                                                           *
*       This software was developed by Loral under U. S. Government contracts *
*       and may be reproduced by or for the U. S. Government pursuant to    *
*       the copyright license under the clause at DFARS 252.227-7013        *
*       (OCT 1988).                                                         *
*                                                                           *
*       Contents: Declarations of bcopy, with macros for machines without
*       Created: Thu Feb 29 11:46:11 EST 1996
*       Author: bhelf
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/
 
#ifndef _STDBCOPY_H_INCLUDED
#define _STDBCOPY_H_INCLUDED
 

/* Make sure bcopy, bzero, and friends are defined */

#if defined(sgi)
#include <bstring.h>

#elif defined(sun5)
#include <string.h>
#define bzero(string, length) (memset((string), 0, (length)))
#define bcopy(from, to, length) (memmove((to), (from), (length)))
#define bcmp(s1, s2, length) (memcmp((s1), (s2), (length)))

#elif defined(sun4) || defined(mips)
extern void     bcopy(const void *, void *, int);
extern int      bcmp(const void *, const void *, int);
extern void     bzero(void *, int);

#else
#include <stdstring.h>

#endif



#endif /*_STDBCOPY_H_INCLUDED*/
