/*
 * $RCSfile$ $Revision$ $State$
 */
/****************************************************************************
*   File: stdcoord.h                                                        *
*                                                                           *
*       Copyright 1995 by SAIC & TASC                                       *
*                                                                           *
*       SAIC                          TASC                                  *
*       20 Burlington Mall Road       55 Walkers Brook Drive                *
*       Suite 130                     Reading, MA 01867                     *
*       Burlington, MA 01803          617-942-2000                          *
*       617-221-7600                                                        *
*                                                                           *
*	This software was developed by TASC/SAIC under U. S. Government     *
*       contracts, and may be reproduced by or for the U. S. Government     *
*       pursuant to the copyright license under the clause                  *
*       at DFARS 252.227-7013                                               *
*	(OCT 1988).                                                         *
*                                                                           *
*       Contents: Common coordinates system constants and macros            *
*       Created: January 1996                                               *
*       Author: cbuettner                                                   *
*       Remarks:                                                            *
*                                                                           *
****************************************************************************/
#ifndef _STDCOORD_H_INCLUDE
#define _STDCOORD_H_INCLUDE

#define DATUM_UNKNOWN         -1
#define DATUM_ED50             0
#define DATUM_ED79             1
#define DATUM_WGS72            2
#define DATUM_WGS84            3
#define DATUM_CONUSNAD27       4
#define DATUM_NASBNAD27        5
#define DATUM_NASANAD27        6
#define DATUM_NAD83            7
#define DATUM_ADINDAN          8
#define DATUM_ARC50            9
#define DATUM_AUSTRALIAN       10
#define DATUM_BUKITRIMPAH      11
#define DATUM_CAMPAREAASTRO    12
#define DATUM_DJAKARTA         13
#define DATUM_GEOD49           14
#define DATUM_GUAM63           15
#define DATUM_GUNUNGSEGARA     16
#define DATUM_HERATNORTH       17
#define DATUM_HJORSEY55        18
#define DATUM_INDIAN           19
#define DATUM_IRELAND65        20
#define DATUM_KERTAU48         21
#define DATUM_LIBERIA64        22
#define DATUM_LUZON            23
#define DATUM_MERCHICH         24
#define DATUM_NIGERIA          25
#define DATUM_ALASKACANADA27   26
#define DATUM_MAUI             27
#define DATUM_OAHU             28
#define DATUM_KAUAI            29
#define DATUM_GREATBRITAIN36   30
#define DATUM_QORNOQ           31
#define DATUM_SACAMPOINCHAUSPE 32
#define DATUM_SACHUAASTRO      33
#define DATUM_SACORREGOALEGRE  34
#define DATUM_SAPROVISIONAL56  35
#define DATUM_SAYACARE         36
#define DATUM_TAMANARIVEOBSV25 37
#define DATUM_TIMBOLAI48       38
#define DATUM_TOKYO            39
#define DATUM_MAXIMUM_COUNT    40

#define WGS84_MINOR_AXIS     6356752.3142
#define WGS84_MAJOR_AXIS     6378137.0
#define WGS84_DEFORMATION    1/298.257223563
#define WGS84_MAJOR_SQUARE   4.068063159e13
#define WGS84_MINOR_SQUARE   4.040829998e13
#define WGS84_MAJOR_QUAD     1.654913787e27
#define WGS84_MAJOR_SQ_X_MINOR_SQ 1.643835165e27
#define EARTH_RADIUS_EQUATOR WGS84_MAJOR_AXIS
#define EARTH_RADIUS_POLAR   WGS84_MINOR_AXIS

/* Current bounds of valid semi major and minor axis */
#define MAX_SEMI_MAJOR 6380000.0
#define MAX_SEMI_MINOR 6360000.0
#define MIN_SEMI_MAJOR 6370000.0
#define MIN_SEMI_MINOR 6350000.0

#endif /*_STDCOORD_H_INCLUDES*/
