import java.util.*;
import java.io.*;

import RTIcap.*;             // The package containing our stubs.
import npacrti.*;            // The package containing our stubs.
import org.omg.CosNaming.*;  // 
import org.omg.CORBA.*;      // All CORBA applications need these classes.
import owrti.util.*;

/**
*  This demo is prepared to demostrate how you can use OWRTI package.
*  This is a Chat example.
*
* @date May 11, 1998 ( Updated May 11, 1998 )
* @author H. Timucin Ozdemir
*
*/
public class mainChat {

   /** */
   public static void main(String args[]) {
     try
     {  // Create and initialize the ORB
        ORB orb = ORB.init(args, null);
      
        /*  ----- This Part is required if we are using Naming Service ---
        // Get the root naming context
        org.omg.CORBA.Object objRef = orb.resolve_initial_references("NameService");
        NamingContext ncRef = NamingContextHelper.narrow(objRef);
      
        // Resolve the object reference in naming
        NameComponent nc = new NameComponent("RTIKernel", " ");
        NameComponent path[] = {nc};
        RTIKernelInterface rtiKernel = RTIKernelInterfaceHelper.narrow(ncRef.resolve(path));
        */
        String InterfaceName="IDL:npacrti/RTIKernelInterface:1.0";
        String JWORB_HOST_NAME=null;
        int JWORB_PORT_NUMBER=-1;
        for(int i=0;i<args.length;i++) {
          if(args[i].equals("-jworbhn")&&i+1<args.length) 
              JWORB_HOST_NAME=args[i+1];
          if(args[i].equals("-jworbpn")&&i+1<args.length) 
            try
            { int aa=Integer.parseInt(args[i+1]); JWORB_PORT_NUMBER=aa; } 
            catch(NumberFormatException nfe) {} 
        }// end of for

        try 
        {  String strIOR =null;
           if(JWORB_HOST_NAME!=null&&JWORB_PORT_NUMBER>0) 
               strIOR = owrti.util.KernelLocator.askIOR(JWORB_HOST_NAME,JWORB_PORT_NUMBER,InterfaceName);
           if( strIOR == null ) 
               strIOR = owrti.util.KernelLocator.getRTIKernelIOR();
           if( strIOR != null ) {
              RTIKernelInterface rtiKernel = RTIKernelInterfaceHelper.narrow(orb.string_to_object(strIOR));

              // Get the Version of the Kernel
              String version = rtiKernel.getVersion();
              System.out.println(" Version is : "+version);      

              RTIambassador rtiAmb = rtiKernel.createRTIAmbassador();

              ChatGUI chatWin = new ChatGUI(rtiAmb,orb);

              chatWin.setTitle("ChatGUI/0.1");
              chatWin.setSize(550, 260);
              chatWin.setVisible(true);

           } else System.out.println(" IOR file is empty| \n "+
                        "I can not find the address of RTIKernelInterface ");

        } catch(java.io.FileNotFoundException fnf) 
          { System.out.println("File Not Found"); }
          
     } catch(Exception e) 
       { System.out.println("ERROR : " + e); e.printStackTrace(System.out); }  

   }// end of main()
 
}// end of mainChat()
