/* The daemon file
Initialises the feddisplay which displays the frame
asking user to specify federate name.
Provides functions for joinig and leaving federations*/


import java.util.*;
import java.io.*;

import RTIcap.*;             // The package containing our stubs.
import npacrti.*;            // The package containing our stubs.
import org.omg.CosNaming.*;  // 
import org.omg.CORBA.*;      // All CORBA applications need these classes.
import owrti.util.*;

import javax.swing.*;
import java.awt.*;
import java.awt.Container;
import java.awt.event.*;
import javax.swing.event.*;


public class 
Daemon 
{

Server thisServer;
		
	Daemon()
	{
			FedDisplay dsp = new FedDisplay(this); 
			  JFrame frame = new JFrame("Federate Info");

			  Container contentPane = frame.getContentPane();
		      contentPane.add(dsp.getPane());
				frame.setSize(400,300);
				frame.pack();
				frame.setVisible(true);
				frame.addWindowListener(new WindowAdapter() {
				public void windowClosing(WindowEvent e) {leave();}
					});


	}



	public void join(String fedName)
	{
		try{
		ORB orb = ORB.init();
		try 
        {
           String strIOR = owrti.util.KernelLocator.getRTIKernelIOR();

           if( strIOR != null )
           {
      
              RTIKernelInterface rtiKernel = RTIKernelInterfaceHelper.narrow(orb.string_to_object(strIOR));

              // Get the Version of the Kernel
              String version = rtiKernel.getVersion();
              System.out.println(" Version is : "+version);   
			  
			  RTIambassador rtiAmb = rtiKernel.createRTIAmbassador();
              thisServer = new Server(rtiAmb,fedName,20,orb);
              thisServer.start();

            } else System.out.println(" IOR file is empty| \n "+
                        "I can not find the address of RTIKernelInterface ");

        } catch(java.io.FileNotFoundException fnf) 
          { System.out.println("File Not Found"); }
          
     } catch(Exception e) 
       {
         System.out.println("ERROR : " + e);
         e.printStackTrace(System.out);
       }  

	}

	public void leave()
	{
		thisServer.leaveFederationExecution();
	}


   public static void 
   main(String args[])
   {
		Daemon m = new Daemon();          
       		 
    
   }// end of main()
 
}
