/*
*/
import org.omg.CORBA.*;

import RTIcap.*;
import owrti.util.CDRCoderEncoder;
import javax.swing.*;

import java.awt.*;
import java.awt.Container;
import java.awt.event.*;
import javax.swing.event.*;

/**
*
* This is callback object to receive RTI messages.
* We used the following callback messages for this demo program:
*
* <p>
* <ol>
* <p> <li> discoverObjectInstance
* <p> <li> removeObjectInstance[With Time]
* <p> <li> reflectAttributeValues[WithTime]
* <p> <li> provideAttributeValueUpdate
* <p> <li> turnUpdatesOnForObjectInstance
* <p> <li> turnUpdatesOffForObjectInstance
* <p> <li> timeAdvanceGrant
* <p> <li> timeRegulationEnabled
* <p> <li> timeConstrainedEnabled
* </ol>
*
* <p>

*/
public class 
HwFederateAmbassador extends RTIcap._FederateAmbassadorImplBase 
{
    Server  boss;
	Server disp;
	FederateManager fedManager;
	boolean monitor=false;
	
	Display win;
	 int counter=0;
	public 
    HwFederateAmbassador(FederateManager _fmg, Server father,boolean _monitor) 
    {  
        fedManager = _fmg;
		boss = father; 
        monitor=_monitor;
		if(monitor)
		{
			disp=father; 
	  System.out.println("Initialising the Demo Window");
	//Initialising the Demo Window
	
		JFrame frame = new JFrame("Cluster Monitor");

        win = new Display(this);
        Container contentPane = frame.getContentPane();
		contentPane.setLayout(new BorderLayout());
		
        contentPane.add(win.gettabbedPane(), BorderLayout.CENTER);
		contentPane.add(win.getPanel(), BorderLayout.SOUTH);
        frame.pack();
		frame.setVisible(true);
        frame.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {exit();}
        });
		
   

		}
	



    }// end of HwFederateAmbassador()


	public void exit()
	{
		disp.leaveFederationExecution();
		System.exit(0);
	}

    public void 
    synchronizationPointRegistrationSucceeded(String theLabel)
        throws RTIcap.FederateInternalError
    { }

    public void 
    synchronizationPointRegistrationFailed(String theLabel)
        throws RTIcap.FederateInternalError
    { }

    public void 
    announceSynchronizationPoint(String theLabel, String theTag)
        throws RTIcap.FederateInternalError
    { }

    public void 
    federationSynchronized(String theLabel) throws RTIcap.FederateInternalError
    { }

    public void 
    initiateFederateSave(String theLabel)
        throws RTIcap.UnableToPerformSave, RTIcap.FederateInternalError
    { }

    public void 
    federationSaved() throws RTIcap.FederateInternalError
    { }

    public void 
    federationNotSaved() throws RTIcap.FederateInternalError
    { }

    public void 
    requestFederationRestoreSucceeded(String theLabel)
        throws RTIcap.FederateInternalError
    { }

    public void 
    requestFederationRestoreFailed(String theLabel)
        throws RTIcap.FederateInternalError
    { }

    public void 
    federationRestoreBegun() throws RTIcap.FederateInternalError
    { }

    public void 
    initiateFederateRestore(String theLabel, short handle)
        throws RTIcap.SpecifiedLabelDoesNotExist, RTIcap.CouldNotRestore, 
               RTIcap.FederateInternalError
    { }

    public void 
    federationRestored() throws RTIcap.FederateInternalError
    { }

    public void 
    federationNotRestored() throws RTIcap.FederateInternalError
    { }

    public void 
    startRegistrationForObjectClass(short theClass)
        throws RTIcap.ObjectClassNotPublished, RTIcap.AttributeNotPublished, 
               RTIcap.FederateInternalError
    { }

    public void 
    stopRegistrationForObjectClass(short theClass)
        throws RTIcap.ObjectClassNotPublished, RTIcap.AttributeNotPublished, 
               RTIcap.FederateInternalError
    { }

    public void 
    turnInteractionsOn(short theHandle)
        throws RTIcap.InteractionClassNotPublished, RTIcap.FederateInternalError
    { }

    public void 
    turnInteractionsOff(short theHandle)
       throws RTIcap.InteractionClassNotPublished, RTIcap.FederateInternalError
    { }

    public void 
    startUpdates(short theClass, short[] theAttributes)
        throws RTIcap.ObjectClassNotPublished, RTIcap.AttributeNotPublished, 
               RTIcap.FederateInternalError
    { }

    public void 
    stopUpdates(short theClass, short[] theAttributes)
        throws RTIcap.ObjectClassNotPublished, RTIcap.AttributeNotPublished, 
               RTIcap.FederateInternalError
    { }

    /**
    * Add this new discovered object to the FederateManager.
    */
    public void 
    discoverObjectInstance(int theObject, short theObjectClass)
        throws RTIcap.CouldNotDiscover, RTIcap.ObjectClassNotKnown, 
               RTIcap.InvalidFederationTime, RTIcap.FederateInternalError
    { 
    	Node c1 = fedManager.getFederate(theObject);
		if(c1==null) fedManager.add(theObject, new Node(theObject));
			System.out.println("GOT NEW OBJECT Added to fed manager" +theObject);
	
    }// end of discoverObjectInstance()

    /**
    * Update attributes.
    */
    public void 
    reflectAttributeValuesWithTime(int theObject, 
               RTIcap.AttributeHandleValuePair[] theAttributes, double theTime, 
               String theTag, RTIcap.EventRetractionHandle theHandle)
        throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotKnown, 
               RTIcap.FederateOwnsAttributes, RTIcap.InvalidFederationTime, 
               RTIcap.FederateInternalError
    { 
        reflectAttributeValues(theObject,theAttributes,theTag); 
    }// end of reflectAttributeValuesWithTime()

    /**
    *
    * Find the objects in the FederateManager and updates their received
    * attributes. Note that, CDR provided us the necessary decode/encode
    * mechanism for various data types.
    *
    */
    public void 
    reflectAttributeValues(int theObject, 
               RTIcap.AttributeHandleValuePair[] theAttributes, String theTag)
        throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotKnown, 
               RTIcap.FederateOwnsAttributes, RTIcap.FederateInternalError
    { 
		Node c1 = fedManager.getFederate(theObject);
	if(boss!=null)
	{
        if( c1 != null ) 
        {
		if(c1.getName()==null||c1.getId()==-1)
		{
			System.out.println("c1 name is null" +theAttributes.length);
			for(int i=0;i<theAttributes.length;i++)
           {
              if( theAttributes[i].handle == boss.getNameAttributeId() )
			  {  
				  c1.setName(new String(theAttributes[i].value));	
			  }

              else if( theAttributes[i].handle == boss.getPopuAttributeId() )
              {
				c1.setId(CDRCoderEncoder.extractDouble(theAttributes[i].value));
		     	System.out.println("Setting ID "+c1.getId());
			  }
			// I am assuming initially that ids of federates will be the same as given
				//by RTi So central has ID=1.Now when central dies9
			//Each federate mantains the vector in Fedmanager which has all ids.
			//so i can write algo which deteramines the min id and that federate takes 
			//over as central.
		
			}// end of for
		}//end of if c1.getName()==null||c1.getId()==-1
		else{
		
		 System.out.println("AlIVE  message recieved from "+c1.getName());
		 c1.setState(true);//Should be done only for central(do it later)
			fedManager.add(theObject,c1);
			if(monitor)
			win.addFederate(c1);
		 }
        } else System.out.println(theObject+" is not known ");
	 
		 
	}


    }// end of reflectAttributeValues()

    public void 
    receiveInteractionWithTime(short theInteraction, 
               RTIcap.ParameterHandleValuePair[] theParameters, double theTime, 
               String theTag, RTIcap.EventRetractionHandle theHandle)
        throws RTIcap.InteractionClassNotKnown, 
               RTIcap.InteractionParameterNotKnown, 
               RTIcap.InvalidFederationTime, RTIcap.FederateInternalError
    { 
	receiveInteraction(theInteraction,theParameters,theTag);
	}

    public void 
    receiveInteraction(short theInteraction, 
               RTIcap.ParameterHandleValuePair[] theParameters, String theTag)
        throws RTIcap.InteractionClassNotKnown, 
               RTIcap.InteractionParameterNotKnown, RTIcap.FederateInternalError
    { 
	
//this is the case when alive interaction recieved from central
// set checker false to true
if(boss!=null)
{
	if(theInteraction==boss.getCentralTypeId())
	{
		double centralID=-1.0;
		for(int i=0;i<theParameters.length;i++)
           {
              if( theParameters[i].handle == boss.getCentralMsgTypeId())
			  		  centralID = (CDRCoderEncoder.extractDouble(theParameters[i].value)) ;
		System.out.println("Interaction from central " );  
		}
	boss.centralAlive(CDRCoderEncoder.extractDouble(theParameters[0].value));
	}

	else if(theInteraction==boss.getCommTypeId())
	{
		double deadID=-1;
			for(int i=0;i<theParameters.length;i++)
           {
              if( theParameters[i].handle == boss.getCommMsgTypeId())
			  		  deadID = (CDRCoderEncoder.extractDouble(theParameters[i].value)) ;;
		   }
		
		boss.deadFederate(deadID);
		System.out.println("\nGot dead Interaction Dead"+deadID);
		if(monitor)
			win.deadFederate(deadID);

	}
}


	}
    
    public void 
    removeObjectInstanceWithTime(int theObject, double theTime, String theTag, 
               RTIcap.EventRetractionHandle theHandle)
        throws RTIcap.ObjectNotKnown, RTIcap.InvalidFederationTime, 
               RTIcap.FederateInternalError
    { 
    }// end of removeObjectInstanceWithTime()

   
    public void 
    removeObjectInstance(int theObject, String theTag)
        throws RTIcap.ObjectNotKnown, RTIcap.FederateInternalError
    { 

    }// end of removeObjectInstanceWithTime()

    public void 
    attributesInScope(int theObject, short[] theAttributes)
        throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotKnown, 
               RTIcap.FederateInternalError
    { }

    public void 
    attributesOutOfScope(int theObject, short[] theAttributes)
        throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotKnown, 
               RTIcap.FederateInternalError
    { }

    /**
    * Ask the corresponding SimNode object to update its attribute.
    */
    public void 
    provideAttributeValueUpdate(int theObject, short[] theAttributes)
        throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotKnown, 
               RTIcap.AttributeNotOwned, RTIcap.FederateInternalError
    { 
        Node c = fedManager.getFederate(theObject);

        if(c!=null && c instanceof SimNode )
        {
           for(int i=0;i<theAttributes.length;i++)
            if( theAttributes[i] == boss.getNameAttributeId() )
                ((SimNode)c).setNameChanged();
            else if( theAttributes[i] == boss.getPopuAttributeId() )
                ((SimNode)c).setPopuChanged();

        }// end of if
       System.out.println(" Out of provideAttributeValueUpdate() ");

    }// end of provideAttributeValueUpdate()

   
    public void 
    turnUpdatesOnForObjectInstance(int theObject, short[] theAttributes)
        throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotOwned, 
               RTIcap.FederateInternalError
    { 
       
    }// end of turnUpdatesOnForObjectInstance()

    /**
    * Tell simulated object *NOT* to send its updates to RTI.
    */
    public void 
    turnUpdatesOffForObjectInstance(int theObject, short[] theAttributes)
        throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotOwned, 
               RTIcap.FederateInternalError
    { 
        Node c = fedManager.getFederate(theObject);
        if( c != null && c instanceof SimNode ) 
            ((SimNode)c).UpdateControls(false,theAttributes); 
    }// end of turnUpdatesOffForObjectInstance()

    public void 
    requestAttributeOwnershipAssumption(int theObject, 
               short[] offeredAttributes, String theTag)
        throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotKnown, 
               RTIcap.AttributeAlreadyOwned, RTIcap.AttributeNotPublished, 
               RTIcap.FederateInternalError
    { }

    public void 
    attributeOwnershipDivestitureNotification(int theObject, 
               short[] releasedAttributes)
        throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotKnown, 
               RTIcap.AttributeNotOwned, 
               RTIcap.AttributeDivestitureWasNotRequested, 
               RTIcap.FederateInternalError
    { }

    public void 
    attributeOwnershipAcquisitionNotification(int theObject, 
               short[] securedAttributes)
        throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotKnown, 
               RTIcap.AttributeAcquisitionWasNotRequested, 
               RTIcap.AttributeAlreadyOwned, RTIcap.AttributeNotPublished, 
               RTIcap.FederateInternalError
    { }

    public void 
     attributeOwnershipUnavailable(int theObject, short[] theAttributes)
        throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotKnown, 
               RTIcap.AttributeAlreadyOwned, 
               RTIcap.AttributeAcquisitionWasNotRequested, 
               RTIcap.FederateInternalError
    { }

    public void 
    requestAttributeOwnershipRelease(int theObject, 
               short[] candidateAttributes, String theTag)
        throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotKnown, 
               RTIcap.AttributeNotOwned, RTIcap.FederateInternalError
    { }

    public void 
    confirmAttributeOwnershipAcquisitionCancellation(int theObject, 
               short[] theAttributes)
        throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotKnown, 
               RTIcap.AttributeAlreadyOwned, 
               RTIcap.AttributeAcquisitionWasNotCancelled, 
               RTIcap.FederateInternalError
    { }

    public void 
    informAttributeOwnership(int theObject, short theAttribute, short theOwner)
        throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotKnown, 
               RTIcap.FederateInternalError
    { }

    public void 
    attributeIsNotOwned(int theObject, short theAttribute)
        throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotKnown, 
               RTIcap.FederateInternalError
    { }

    public void 
    attributeIsOwnedByRTI(int theObject, short theAttribute)
        throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotKnown, 
               RTIcap.FederateInternalError
    { }

    /**
    * Change the Server federation's time. And inform that time is
    * advanced.
    */
    public void 
    timeAdvanceGrant(double theTime)
        throws RTIcap.InvalidFederationTime, 
               RTIcap.TimeAdvanceWasNotInProgress, 
               RTIcap.FederateInternalError
    { 
        if(boss!=null)
		{
		boss.setCurrentTime( theTime );
        boss.setTimeAdvanceGranted();
		}

    }// end of timeAdvanceGrant()

    /**
    * Change the Server federate's time. And inform that time is
    * advanced.
    */
    public void 
    timeRegulationEnabled(double theTime)
        throws RTIcap.InvalidFederationTime, 
               RTIcap.EnableTimeRegulationWasNotPending, 
               RTIcap.FederateInternalError
    { 
        if(boss !=null){
		boss.setCurrentTime( theTime );
        boss.setTimeAdvanceGranted();
		}


    }// end of timeRegulationEnabled()

    /**
    * Change the Server federate's time. And inform that time is
    * advanced.
    */
    public void 
    timeConstrainedEnabled(double theTime)
        throws RTIcap.InvalidFederationTime, 
               RTIcap.EnableTimeConstrainedWasNotPending, 
               RTIcap.FederateInternalError
    { 
        if(boss !=null){
		boss.setCurrentTime( theTime );
        boss.setTimeAdvanceGranted();
		}


    }// end of timeConstrainedEnabled()

    public void 
    requestRetraction(RTIcap.EventRetractionHandle theHandle)
        throws RTIcap.EventNotKnown, RTIcap.FederateInternalError
    { }

    public void 
    changeThresholds(RTIcap.Region theRegion, 
                     RTIcap.ThresholdSetHolder theThresholds)
        throws RTIcap.RegionNotKnown, RTIcap.FederateInternalError
    { }

}// end of HwFederateAmbassador
