import java.util.*;
import java.io.*;

import RTIcap.*;             // The package containing our stubs.
import npacrti.*; 
import owrti.util.CDRCoderEncoder;
           // The package containing our stubs.
import org.omg.CosNaming.*;  // 
import org.omg.CORBA.*;      // All CORBA applications need these classes.

public class 
Server implements Runnable
{
   String  myNodeName = "zzz";
   double  myID  = 100.0;
   double centralId = -1;
   Thread  runner;
   short   federateId;
   ORB     orb;

   boolean monitor=false;

   String nodeTypeStr = new String("Node");
   String nodeNameTypeStr = new String("Name");
   String nodePopuTypeStr = new String("Id");
   short nodeTypeId = -1;
   int nodeNameTypeId = -1, nodePopuTypeId = -1;

   String nodeCommTypeStr = new String("Communication");
   String nodeCommMsgTypeStr = new String("Message");

   String centralAliveStr= new String("Central");
   String centralIDStr = new String("ID");

   short  nodeCommTypeId = -1;
   int    nodeCommMsgTypeId = -1;

   short centralCommTypeId = -1;
   int    centralCommMsgTypeId = -1;

   java.lang.Object guard = new java.lang.Object();

   /** RTI Mappers */

   Hashtable className       = new Hashtable();
   Hashtable attributeName   = new Hashtable();
   Hashtable interactionName = new Hashtable();
   Hashtable parameterName   = new Hashtable();

   RTIcap.RTIambassador rtiAmb;

   SimNode    myNode;
   FederateManager FederateMng = new FederateManager();

   boolean       advanceGranted = false;
   double        currentTime = 0.0; 
   double        timeStep = 5.0; 
   double        requestTime ; 

   /**
   my defns
   */
  
	public static final int SLAVE     = 0;
    public static final int CENTRAL   = SLAVE+1;

	int   role = SLAVE;

	boolean centralState;

	centralChecker cCheck;

   public 
   Server( RTIcap.RTIambassador _rtiAmb, String nodeName, 
               double initialId, ORB _orb )
   {
       rtiAmb = _rtiAmb;
       myNodeName = nodeName;
       myID = initialId;
       orb = _orb;
		if(nodeName=="Monitor")
			monitor=true;
    

   }// end of CONSTRUCTOR

   /**
   */
   public void
   start()
   {
      if(runner==null) 
      {
         runner = new Thread(this);
         runner.start();

      } else   runner.start();

   }// end of start()

   /**
   */
   public void
   stop()
   {
      if(runner!=null) 
      {
         runner.stop();
         runner = null;

      }// end of if

   }// end of stop()

  
   /**
   *
   * Gets the RTTI (Meta-Object Protocol MOP) handles.
   *
   * Ask RTI about the class indentifier of each object, attribute, 
   * interaction and parameter. So that we can define, subscribe, publish,
   * and interpret these attributes/objects.
   *
   */
   boolean getRtiIds()
   {
      boolean ret = false;

      if( rtiAmb != null )
      {
           try
           {
           nodeTypeId = rtiAmb.getObjectClassHandle(nodeTypeStr);
           } catch( RTIcap.FederateNotExecutionMember icnd ) {}
             catch( RTIcap.NameNotFound icnd ) {}
             catch( RTIcap.RTIinternalError icnd ) {}


           try
           {
           nodeNameTypeId = 
                  rtiAmb.getAttributeHandle(nodeNameTypeStr,nodeTypeId );
           } catch( RTIcap.ObjectClassNotDefined icnd ) {}
             catch( RTIcap.NameNotFound icnd ) {}
             catch( RTIcap.FederateNotExecutionMember icnd ) {}
             catch( RTIcap.RTIinternalError icnd ) {}

           try
           { 
           nodePopuTypeId = 
                  rtiAmb.getAttributeHandle(nodePopuTypeStr, nodeTypeId );
           } catch( RTIcap.ObjectClassNotDefined icnd ) {}
             catch( RTIcap.NameNotFound icnd ) {}
             catch( RTIcap.FederateNotExecutionMember icnd ) {}
             catch( RTIcap.RTIinternalError icnd ) {}

        
           try
           { 
           nodeCommTypeId = 
                  rtiAmb.getInteractionClassHandle(nodeCommTypeStr);
           } catch( RTIcap.NameNotFound icnd ) {}
             catch( RTIcap.FederateNotExecutionMember icnd ) {}
             catch( RTIcap.RTIinternalError icnd ) {}

           try
           { 
           nodeCommMsgTypeId = 
                  rtiAmb.getParameterHandle(nodeCommMsgTypeStr,nodeCommTypeId);
             ret = true;
           } catch( RTIcap.InteractionClassNotDefined icnd ) {}
             catch( RTIcap.NameNotFound icnd ) {}
             catch( RTIcap.FederateNotExecutionMember icnd ) {}
             catch( RTIcap.RTIinternalError icnd ) {}
		
		try
           { 
           centralCommTypeId = 
                  rtiAmb.getInteractionClassHandle("Central");
           } catch( RTIcap.NameNotFound icnd ) {System.out.println(icnd);}
             catch( RTIcap.FederateNotExecutionMember icnd ) {System.out.println(icnd); }
             catch( RTIcap.RTIinternalError icnd ) {System.out.println(icnd);}

		try
           { 
           centralCommMsgTypeId = 
                  rtiAmb.getParameterHandle("ID",centralCommTypeId);
           } catch( RTIcap.InteractionClassNotDefined icnd ) {System.out.println(icnd);}
             catch( RTIcap.NameNotFound icnd ) {System.out.println(icnd);}
             catch( RTIcap.FederateNotExecutionMember icnd ) {System.out.println(icnd);}
             catch( RTIcap.RTIinternalError icnd ) {System.out.println(icnd);}

			 System.out.println("YAhoo got ids " +centralCommTypeId +"	"+centralCommMsgTypeId);




           /** Place them into a hashtable */

      }// end of if
  
      return ret;

   }// end of getRtiIds()

   /**
   *
   * Describe our interest for publishing objects and attributes.
   * Describe our interest for receiving objects and attributes.
   * Describe our interest for publishing interations and parameters.
   * Describe our interest for receiving interations and parameters.
   *
   */
   boolean publishSubscribe()
   {

      boolean ret = false;

      if( rtiAmb != null )
      {
           short[] myAttributes = new short[2];  
           myAttributes[0] = (short) nodeNameTypeId;
           myAttributes[1] = (short) nodePopuTypeId;

		   short[] objectAttributes= new short[0];


		   // subscribe only if u r central and recieve updates
		 
           try 
           {
		  if(role==CENTRAL||monitor==true)
		          rtiAmb.subscribeObjectClassAttributes( nodeTypeId, myAttributes , RTIcap._Boolean.RTI_TRUE);
          else
				rtiAmb.subscribeObjectClassAttributes( nodeTypeId, objectAttributes , RTIcap._Boolean.RTI_TRUE);	
		   
		   } catch( RTIcap.ObjectClassNotDefined  flsc) 
             { 
               System.out.println(" exception ObjectClassNotDefined! ");
               System.exit(1);
             }
             catch( RTIcap.AttributeNotDefined  fnem) 
             { 
               System.out.println(" exception AttributeNotDefined! ");
               System.exit(1);
             }
             catch( RTIcap.FederateNotExecutionMember  fnem) 
             { 
               System.out.println(" exception FederateNotExecutionMember! ");
               System.exit(1);
             }
             catch( RTIcap.RTIinternalError  ie) 
             { 
               System.out.println(" exception RTIinternalError! ");
               System.exit(1);
             }
             catch( RTIcap.RestoreInProgress  rip) 
             { 
               System.out.println(" exception RestoreInProgress! ");
               System.exit(1);
             }
             catch( RTIcap.SaveInProgress  sip) 
             { 
               System.out.println(" exception SaveInProgress! ");
               System.exit(1);
             }
		  

           try 
           {
             rtiAmb.publishObjectClass( nodeTypeId, myAttributes );
           } catch( RTIcap.ObjectClassNotDefined  flsc) 
             { 
               System.out.println(" exception ObjectClassNotDefined! ");
               System.exit(1);
             }
             catch( RTIcap.AttributeNotDefined  fnem) 
             { 
               System.out.println(" exception AttributeNotDefined! ");
               System.exit(1);
             }
             catch( RTIcap.FederateNotExecutionMember  fnem) 
             { 
               System.out.println(" exception FederateNotExecutionMember! ");
               System.exit(1);
             }
             catch( RTIcap.RTIinternalError  ie) 
             { 
               System.out.println(" exception RTIinternalError! ");
               System.exit(1);
             }
             catch( RTIcap.RestoreInProgress  rip) 
             { 
               System.out.println(" exception RestoreInProgress! ");
               System.exit(1);
             }
             catch( RTIcap.SaveInProgress  sip) 
             { 
               System.out.println(" exception SaveInProgress! ");
               System.exit(1);
             }

           try
           {
             rtiAmb.subscribeInteractionClass( nodeCommTypeId, RTIcap._Boolean.RTI_TRUE);
           } catch( RTIcap.FederateLoggingServiceCalls  flsc) {}
             catch( RTIcap.FederateNotExecutionMember  fnem) {}
             catch( RTIcap.RTIinternalError  ie) {}
             catch( RTIcap.RestoreInProgress  rip) {}
             catch( RTIcap.InteractionClassNotDefined  icnd) {}
             catch( RTIcap.SaveInProgress  sip) {}

           try
           {
             rtiAmb.publishInteractionClass( nodeCommTypeId );
             ret = true;
           } catch( RTIcap.FederateNotExecutionMember fnem) {}
             catch( RTIcap.RestoreInProgress rip) {}
             catch( RTIcap.InteractionClassNotDefined icnd) {}
             catch( RTIcap.SaveInProgress sip) {}
             catch( RTIcap.RTIinternalError ie) {}

	
			  try
			   {
				 rtiAmb.publishInteractionClass( centralCommTypeId );
			} catch( RTIcap.FederateNotExecutionMember fnem) {}
				 catch( RTIcap.RestoreInProgress rip) {}
				 catch( RTIcap.InteractionClassNotDefined icnd) {}
				 catch( RTIcap.SaveInProgress sip) {}
				 catch( RTIcap.RTIinternalError ie) {}
		

		if(role==SLAVE)	
		{
			try
			   {
				 rtiAmb.subscribeInteractionClass( centralCommTypeId, RTIcap._Boolean.RTI_TRUE);
			   } catch( RTIcap.FederateLoggingServiceCalls  flsc) {}
				 catch( RTIcap.FederateNotExecutionMember  fnem) {}
				 catch( RTIcap.RTIinternalError  ie) {}
				 catch( RTIcap.RestoreInProgress  rip) {}
				 catch( RTIcap.InteractionClassNotDefined  icnd) {}
				 catch( RTIcap.SaveInProgress  sip) {}
			}


      }// end of if

      return ret;

   }// end of publishSubscribe()

   /**
   * 
   * We want to join the Federation but we do not know its ID and
   * whether it is on. Therefore, we first try to create this Federation.
   * If this federation is  already exists, we will receive the exception.
   * If not, it will be created for us.
   * Then we need to join this execution and get ourself a federate id.
   * 
   */
   boolean joinFederationExecution(RTIcap.FederateAmbassador fedAmb)
   {

      boolean ret = false;
	  boolean flag = false;

      if( rtiAmb != null )
      {

         try {
           rtiAmb.createFederationExecution("ClusterFederation","ClusterManager.fed");
         } catch( RTIcap.FederationExecutionAlreadyExists icnd) {
		 // implies central sever exists
			System.out.println("EXCEPTION" +icnd);
			 flag =true;
		 }
           catch( RTIcap.RTIinternalError ie) {}

	

         try {
           federateId = rtiAmb.joinFederationExecution(myNodeName,"ClusterFederation",fedAmb);
             ret = true;
			 if(federateId !=1)                                 
				 flag=true;
         } catch( RTIcap.FederateAlreadyExecutionMember fnem) {}
           catch( RTIcap.FederationExecutionDoesNotExist icnd) {}
           catch( RTIcap.CouldNotOpenFED fnem) {}
           catch( RTIcap.ErrorReadingFED fnem) {}
           catch( RTIcap.SaveInProgress sip) {}
           catch( RTIcap.RestoreInProgress rip) {}
           catch( RTIcap.RTIinternalError ie) {}

      }// end of if
	if(!flag)
		{
			System.out.println("i am the central server");
			role = CENTRAL;
		}
	else
	{
		System.out.println("i am the SLAVE");
	}

      return ret;

   }// end of joinFederationExecution() 

   /**
   *
   * Before we leave the Federation
   *  1. Delete all the object that we are suppose(promised) to simulate.
   *  2. resign from the federation.
   *  3. Try to destroy the federation execution. Note that if there 
   *     are still federates in the Federation, the federation execution
   *     won't be stopped. Only, we resign it. 
   *
   */
   public void leaveFederationExecution()
   {

      if( rtiAmb != null )
      {

         try 
         {
           rtiAmb.deleteObjectInstance(myNode.getObjectID(),"destroy");
         } catch( RTIcap.DeletePrivilegeNotHeld ie) {}
           catch( RTIcap.ObjectNotKnown ie) {}
           catch( RTIcap.FederateNotExecutionMember ie) {}
           catch( RTIcap.SaveInProgress ie) {}
           catch( RTIcap.RestoreInProgress ie) {}
           catch( RTIcap.RTIinternalError ie) {}

         try 
         {
           rtiAmb.resignFederationExecution(RTIcap.ResignAction.DELETE_OBJECTS_AND_RELEASE_ATTRIBUTES);
         } catch( RTIcap.InvalidResignAction ie) {}
           catch( RTIcap.FederateOwnsAttributes ie) {}
           catch( RTIcap.FederateNotExecutionMember ie) {}
           catch( RTIcap.RTIinternalError ie) {}


	
		try 
         {
           rtiAmb.destroyFederationExecution("ClusterFederation");
         } catch( RTIcap.FederationExecutionDoesNotExist icnd) {}
           catch( RTIcap.FederatesCurrentlyJoined ie) {}
           catch( RTIcap.RTIinternalError ie) {}
    
	  }// end of if
	  System.exit(0);

   }// end of leaveFederationExecution() 

   /**
   *
   * To register a new object to the RTI
   *   1. Get an ObjectId for the Node object type. This will define
   *      a new instane for us.
   *   2. Define our simulation object(myNode) with return information 
   *      so that SimNode object knows what its ObjectID in this 
   *      federation.
   *
   */
   boolean registerMyNode()
   {
      boolean ret = false;
      int     objInstanceId;

      if( rtiAmb != null )
      {

         try 
         {
             objInstanceId = rtiAmb.registerObjectInstance(nodeTypeId);
             myID = federateId ;
			 System.out.println("My Id "+myID);
				 myNode = new SimNode(rtiAmb,this,myNodeName,myID,objInstanceId,centralCommTypeId,role);
             ret = true;

         } catch( RTIcap.ObjectClassNotDefined sip) {}
           catch( RTIcap.ObjectClassNotPublished sip) {}
           catch( RTIcap.SaveInProgress sip) {}
           catch( RTIcap.RestoreInProgress rip) {}
           catch( RTIcap.FederateNotExecutionMember icnd) {}
           catch( RTIcap.RTIinternalError ie) {}

      }// end of if

      return ret;

   }// end of joinFederationExecution() 
   
   /**
   */
   public void 
   run()
   {
      int count = 0;

       /*******************************************************************/
      /** Define FederateAmbassador for Federate. This objects serves  */
      /** as a callback mechanism so that RTI can bring us the necessary */ 
      /** events.                                                        */
      /*******************************************************************/
      HwFederateAmbassador fedAmb = new HwFederateAmbassador(FederateMng,this,monitor);
      //orb.connect(fedAmb);
      org.omg.CORBA.ORB.init().connect(fedAmb);

        
      /************************************************************/
      /** Create FederationExecution, get RTI id of the objects,  */
      /** attributes, interactions, and parameters.               */
      /** Define interest for Subscription/Publishing.            */
      /** Define my simulated object.                             */
      /************************************************************/
      
	  if( joinFederationExecution(fedAmb) && getRtiIds() && 
          publishSubscribe() && registerMyNode() )
      {
      try
	  {
        /*********************************************************************/
        /** TimeConstrained : we want to receive timestamped events in order */
        /*********************************************************************/
        resetTimeAdvanceGranted();

        try
        { 
          rtiAmb.enableTimeConstrained( );
        } catch( RTIcap.TimeAdvanceAlreadyInProgress aa ) {}
          catch( RTIcap.EnableTimeConstrainedPending aa ) {}
          catch( RTIcap.TimeConstrainedAlreadyEnabled aa ) {}
          catch( RTIcap.FederateNotExecutionMember aa ) {}
          catch( RTIcap.SaveInProgress aa ) {}
          catch( RTIcap.RestoreInProgress aa ) {}
          catch( RTIcap.RTIinternalError aa ) {}

        /***************************************************/
        /** Tick RTI to get timeConstrainedEnabled message */
        /***************************************************/
        tickRTI(2);

        /**********************************************************/
        /** TimeRegulating : We want to vote for time advancement */
        /**********************************************************/
        resetTimeAdvanceGranted();

        try
        { 
          rtiAmb.enableTimeRegulation( currentTime, 5.0 );
        } catch( RTIcap.TimeAdvanceAlreadyInProgress aa ) {}
          catch( RTIcap.EnableTimeRegulationPending aa ) {}
          catch( RTIcap.ConcurrentAccessAttempted aa ) {}
          catch( RTIcap.TimeRegulationAlreadyEnabled aa ) {}
          catch( RTIcap.InvalidLookahead aa ) {}
          catch( RTIcap.InvalidFederationTime aa ) {}
          catch( RTIcap.FederateNotExecutionMember aa ) {}
          catch( RTIcap.SaveInProgress aa ) {}
          catch( RTIcap.RestoreInProgress aa ) {}
          catch( RTIcap.RTIinternalError aa ) {}

        /**************************************************/
        /** Tick RTI to get timeRegulationEnabled message */
        /**************************************************/
        tickRTI(2);

        try
        { 
           rtiAmb.enableAsynchronousDelivery( );
        } 
          catch( RTIcap.FederateNotExecutionMember aa ) {}
          catch( RTIcap.AsynchronousDeliveryAlreadyEnabled aa ) {}
          catch( RTIcap.ConcurrentAccessAttempted aa ) {}
          catch( RTIcap.SaveInProgress aa ) {}
          catch( RTIcap.RestoreInProgress aa ) {}
          catch( RTIcap.RTIinternalError aa ) {}

        /**************************************************/
        /** Add my node to the FederateManager */
        /**************************************************/
		FederateMng.add( myNode.getObjectID(), myNode );

		if(role==CENTRAL)
		{
			new checker(this,FederateMng,3000).start();
		}

        /***************/
        /** Event Loop */
        /***************/
		while(true )
        {
           /***************************************************/
           /** Send Alive Messages							  */
           /***************************************************/
			myNode.UpdateTime(currentTime);

           
			/***************************************************************/
           /** Print state of all the simulated objects in the Simulation */
           /***************************************************************/
      //     printSimObjects();
       
           /*****************/
           /** Advance time */
           /*****************/
           resetTimeAdvanceGranted();
           requestTime = currentTime + timeStep;

           /************************************/
           /** Try to advance the current time */
           /************************************/
           do
           {

              try
              { 
                rtiAmb.timeAdvanceRequest( requestTime );
              } catch( RTIcap.TimeAdvanceAlreadyInProgress aa ) {}
                catch( RTIcap.EnableTimeConstrainedPending aa ) {}
                catch( RTIcap.EnableTimeRegulationPending aa ) {}
                catch( RTIcap.InvalidFederationTime aa ) {}
                catch( RTIcap.FederationTimeAlreadyPassed aa ) {}
                catch( RTIcap.FederateNotExecutionMember aa ) {}
                catch( RTIcap.SaveInProgress aa ) {}
                catch( RTIcap.RestoreInProgress aa ) {}
                catch( RTIcap.RTIinternalError aa ) {}

             mySleep(3000);

           } while( !isTimeAdvanceGranted() );
           
        }// end of while()

        /************************************/
        /** Leave the Federation Execution  */
        /************************************/
     // Dont leave it
		  // leaveFederationExecution();
	}finally
	  {
		System.out.println("In Finally");  
		leaveFederationExecution();
	  }
      }// end of if 
	  

   }// end of run()



   /**
   */
   public void
   resetTimeAdvanceGranted()
   { synchronized(guard) { advanceGranted = false; } 
   }// end of resetTimeAdvanceGranted()

   /**
   * This method will be invoked by HwFededarateAmbassador object whenever
   *
   *   timeAdvanceGrant 
   *   timeConstrainedEnabled
   *   timeRegulationEnabled
   *
   * messages received.
   *
   */
   public void
   setTimeAdvanceGranted()
   { synchronized(guard) { advanceGranted = true; } 
   }// end of setTimeAdvanceGranted()

   /**
   */
   public boolean
   isTimeAdvanceGranted()
   { return advanceGranted ; 
   }// end of isTimeAdvanceGranted()

   /**
   */
   public void
   setCurrentTime( double _newTime)
   { 
     if( _newTime >= currentTime ) currentTime = _newTime;

   }// end of setCurrentTime()

   
   public short
   getPopuAttributeId()
   {  return (short)nodePopuTypeId; }

   /**
   */
   public short
   getNameAttributeId()
   {  return (short)nodeNameTypeId; }

   public short
	   getCommMsgTypeId()
   { return (short)nodeCommMsgTypeId;
   }

    public short
	   getCommTypeId()
   { return (short)nodeCommTypeId;
   }
    public short
	   getCentralMsgTypeId()
   { return (short)centralCommMsgTypeId;
   }

 public short
	   getCentralTypeId()
   { return (short)centralCommTypeId;
   }
   /**
   */
   public final void
   mySleep(long aa)
   {  
      try
      { if(runner != null ) runner.sleep(aa);
      } catch( java.lang.InterruptedException ie) {}

   }// end of mySleep()

   /**
   *
   * Ticks the RTIambassador. This will cause the delivery of waiting 
   * events in the Receive Order Queue.
   *
   */
   public void
   tickRTI( long sleepTime )
   {
      while( !isTimeAdvanceGranted() )
      {
         try { rtiAmb.tick( ); } 
         catch( RTIcap.RTIinternalError aa ) {}

         mySleep(2);

      }// end of while() 

   }// end of tickRTI()

   public void
	   deadServer(Node c)
   {
System.out.println("Trying to get attribute updates");
	   System.out.println("sending ARE YOU ALive message to "+c.getName()+c.getObjectID() );
	//send provide attribute
	// if dont get response 
	// remove from hashtable and declare dead server.
/*	 short[] myAttributes = new short[2];  
     myAttributes[0] = (short) nodeNameTypeId;
     myAttributes[1] = (short) nodePopuTypeId;
	
	try{
		rtiAmb.requestObjectAttributeValueUpdate(c.getObjectID(),myAttributes) ;
	}catch(RTIcap.AttributeNotDefined a){}
	catch( RTIcap.ObjectNotKnown b ){}
	catch(RTIcap.FederateNotExecutionMember fne){}
	catch(RTIcap.SaveInProgress d){}
	catch(RTIcap.RestoreInProgress e){}
	catch(RTIcap.RTIinternalError f) {}
*/
	
if(c.getObjectID()!=-1)
 sendDeadInteraction( c.getObjectID());
System.out.println("\n"+c.getName() + "is DEAD " +"\n");

}// end of Federate()

void sendDeadInteraction(double id)
{

	
		RTIcap.ParameterHandleValuePair[] eles1 = new RTIcap.ParameterHandleValuePair[1];
         
		byte[] values = CDRCoderEncoder.toByte(id);      
              
        eles1[0] = new RTIcap.ParameterHandleValuePair(getCommMsgTypeId(), values);//serverName.getBytes()); 

		
		try{
			rtiAmb.sendInteraction((short) nodeCommTypeId ,eles1,"Dead");
			}catch(RTIcap.InteractionClassNotDefined onk){}
			catch(RTIcap.InteractionClassNotPublished onk){}
			catch(RTIcap.InteractionParameterNotDefined onk){}
			catch(RTIcap.FederateNotExecutionMember onk){}
			catch (RTIcap.SaveInProgress onk) {}
            catch (RTIcap.RestoreInProgress onk) {}
            catch (RTIcap.RTIinternalError onk) {} 

	System.out.println("Removing from list " +id);
	FederateMng.remove((int)id);
}

public void setCentralId(double _ID)
{
centralId= _ID;
}

public void foundCentral(double _ID)
{
	System.out.println("Central server Found"+_ID+" Starting Checker");
  	setCentralId(_ID);
	cCheck=new centralChecker(this,3000);	
	cCheck.start();

}

public boolean getCentralState()
{
	return centralState;
}

public double getmyID()
{
	return myID;

}
public void setCentralState(boolean state)
{
	centralState = state;
}



//This method called whenever fed Amb recieves the central Alive interaction

public void centralAlive(double Id)
{
	if(centralId==-1)
		foundCentral(Id);
	centralState =true;
}

public void deadCentral()
{
	System.out.println("\n\nCentral Server is dead \n\n");
	System.out.println("I have the following IDs");
	
	// Remove central server from RTI
	try 
         {
           rtiAmb.deleteObjectInstance((int)centralId,"destroy");
         } catch( RTIcap.DeletePrivilegeNotHeld ie) {}
           catch( RTIcap.ObjectNotKnown ie) {}
           catch( RTIcap.FederateNotExecutionMember ie) {}
           catch( RTIcap.SaveInProgress ie) {}
           catch( RTIcap.RestoreInProgress ie) {}
           catch( RTIcap.RTIinternalError ie) {}
	
	
	
	
	
	FederateMng.remove((int)centralId);
	Enumeration list_of_federates;
	list_of_federates= FederateMng.getAllFederates();
	double min = myID;
	double newID ;
	
	while(list_of_federates.hasMoreElements())
		{
			Node c = (Node)list_of_federates.nextElement();
			newID = c.getObjectID();
			System.out.println(newID);
			if(newID < min)
				min = newID;
	}
	System.out.println("MInimum ID is "+min );
	if(min==myID)
	{
		sendDeadInteraction((int)centralId);
		System.out.println("\nI am the Central Server \n" );
		becomeCentral();
	}
	else
		System.out.println("\n The central server is " +min);
	centralId=-1;
	cCheck.stop();

	

}


void becomeCentral()
{
	System.out.println("\nBecoming the Central Server \n" );
	myNode.setRole(CENTRAL);

	short[] myAttributes = new short[2];  
    myAttributes[0] = (short) nodeNameTypeId;
    myAttributes[1] = (short) nodePopuTypeId;
		 
           try 
           {
			   rtiAmb.subscribeObjectClassAttributes( nodeTypeId, myAttributes , RTIcap._Boolean.RTI_TRUE);
		    } catch( RTIcap.ObjectClassNotDefined  flsc) 
             { 
               System.out.println(" exception ObjectClassNotDefined! ");
               System.exit(1);
             }
             catch( RTIcap.AttributeNotDefined  fnem) 
             { 
               System.out.println(" exception AttributeNotDefined! ");
               System.exit(1);
             }
             catch( RTIcap.FederateNotExecutionMember  fnem) 
             { 
               System.out.println(" exception FederateNotExecutionMember! ");
               System.exit(1);
             }
             catch( RTIcap.RTIinternalError  ie) 
             { 
               System.out.println(" exception RTIinternalError! ");
               System.exit(1);
             }
             catch( RTIcap.RestoreInProgress  rip) 
             { 
               System.out.println(" exception RestoreInProgress! ");
               System.exit(1);
             }
             catch( RTIcap.SaveInProgress  sip) 
             { 
               System.out.println(" exception SaveInProgress! ");
               System.exit(1);
             }
		  
     
	new checker(this,FederateMng,3000).start();


}


public void deadFederate(double ID)
{
	System.out.println("Removing from list " +ID);
	FederateMng.remove((int)ID);

}
}
